/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Global Instruction Selector for the PPC target                             *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GLOBALISEL_PREDICATE_BITSET
const unsigned MAX_SUBTARGET_PREDICATES = 41;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GLOBALISEL_PREDICATE_BITSET

#ifdef GET_GLOBALISEL_TEMPORARIES_DECL
  mutable MatcherState State;
  typedef ComplexRendererFns(PPCInstructionSelector::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(PPCInstructionSelector::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static PPCInstructionSelector::ComplexMatcherMemFn ComplexPredicateFns[];
  static PPCInstructionSelector::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  bool runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_DECL

#ifdef GET_GLOBALISEL_TEMPORARIES_INIT
, State(0),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_INIT

#ifdef GET_GLOBALISEL_IMPL
// LLT Objects.
enum {
  GILLT_s1,
  GILLT_s32,
  GILLT_s64,
  GILLT_s128,
  GILLT_v2s64,
  GILLT_v4s32,
  GILLT_v8s16,
  GILLT_v16s8,
  GILLT_v256s1,
  GILLT_v512s1,
  GILLT_v1024s1,
};
const static size_t NumTypeObjects = 11;
const static LLT TypeObjects[] = {
  LLT::scalar(1),
  LLT::scalar(32),
  LLT::scalar(64),
  LLT::scalar(128),
  LLT::vector(ElementCount::getFixed(2), 64),
  LLT::vector(ElementCount::getFixed(4), 32),
  LLT::vector(ElementCount::getFixed(8), 16),
  LLT::vector(ElementCount::getFixed(16), 8),
  LLT::vector(ElementCount::getFixed(256), 1),
  LLT::vector(ElementCount::getFixed(512), 1),
  LLT::vector(ElementCount::getFixed(1024), 1),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
  Feature_In32BitModeBit = 1,
  Feature_In64BitModeBit = 9,
  Feature_HasOnlyMSYNCBit = 23,
  Feature_HasSYNCBit = 22,
  Feature_HasSPEBit = 8,
  Feature_HasICBTBit = 21,
  Feature_HasBPERMDBit = 10,
  Feature_HasExtDivBit = 3,
  Feature_IsISA2_06Bit = 11,
  Feature_IsISA2_07Bit = 40,
  Feature_IsISA3_0Bit = 2,
  Feature_HasFPUBit = 0,
  Feature_PCRelativeMemopsBit = 37,
  Feature_IsNotISA3_1Bit = 39,
  Feature_IsAIXBit = 24,
  Feature_NotAIXBit = 25,
  Feature_IsISAFutureBit = 18,
  Feature_IsNotISAFutureBit = 19,
  Feature_HasAltivecBit = 4,
  Feature_HasP8AltivecBit = 5,
  Feature_HasP8CryptoBit = 6,
  Feature_HasP9AltivecBit = 7,
  Feature_HasVSXBit = 12,
  Feature_IsLittleEndianBit = 26,
  Feature_IsBigEndianBit = 27,
  Feature_IsPPC64Bit = 31,
  Feature_HasOnlySwappingMemOpsBit = 29,
  Feature_NoP8VectorBit = 30,
  Feature_HasP8VectorBit = 13,
  Feature_HasDirectMoveBit = 14,
  Feature_NoP9VectorBit = 28,
  Feature_HasP9VectorBit = 15,
  Feature_NoP9AltivecBit = 32,
  Feature_NoP10VectorBit = 33,
  Feature_HasP10VectorBit = 36,
  Feature_HasHTMBit = 34,
  Feature_IsPPC32Bit = 38,
  Feature_PrefixInstrsBit = 16,
  Feature_IsISA3_1Bit = 17,
  Feature_PairedVectorMemopsBit = 35,
  Feature_MMABit = 20,
};

PredicateBitset PPCInstructionSelector::
computeAvailableModuleFeatures(const PPCSubtarget *Subtarget) const {
  PredicateBitset Features{};
  if (!Subtarget->isPPC64())
    Features.set(Feature_In32BitModeBit);
  if (Subtarget->isPPC64())
    Features.set(Feature_In64BitModeBit);
  if (Subtarget->hasOnlyMSYNC())
    Features.set(Feature_HasOnlyMSYNCBit);
  if (!Subtarget->hasOnlyMSYNC())
    Features.set(Feature_HasSYNCBit);
  if (Subtarget->hasSPE())
    Features.set(Feature_HasSPEBit);
  if (Subtarget->hasICBT())
    Features.set(Feature_HasICBTBit);
  if (Subtarget->hasBPERMD())
    Features.set(Feature_HasBPERMDBit);
  if (Subtarget->hasExtDiv())
    Features.set(Feature_HasExtDivBit);
  if (Subtarget->isISA2_06())
    Features.set(Feature_IsISA2_06Bit);
  if (Subtarget->isISA2_07())
    Features.set(Feature_IsISA2_07Bit);
  if (Subtarget->isISA3_0())
    Features.set(Feature_IsISA3_0Bit);
  if (Subtarget->hasFPU())
    Features.set(Feature_HasFPUBit);
  if (Subtarget->hasPCRelativeMemops())
    Features.set(Feature_PCRelativeMemopsBit);
  if (!Subtarget->isISA3_1())
    Features.set(Feature_IsNotISA3_1Bit);
  if (Subtarget->isAIXABI())
    Features.set(Feature_IsAIXBit);
  if (!Subtarget->isAIXABI())
    Features.set(Feature_NotAIXBit);
  if (Subtarget->isISAFuture())
    Features.set(Feature_IsISAFutureBit);
  if (!Subtarget->isISAFuture())
    Features.set(Feature_IsNotISAFutureBit);
  if (Subtarget->hasAltivec())
    Features.set(Feature_HasAltivecBit);
  if (Subtarget->hasP8Altivec())
    Features.set(Feature_HasP8AltivecBit);
  if (Subtarget->hasP8Crypto())
    Features.set(Feature_HasP8CryptoBit);
  if (Subtarget->hasP9Altivec())
    Features.set(Feature_HasP9AltivecBit);
  if (Subtarget->hasVSX())
    Features.set(Feature_HasVSXBit);
  if (Subtarget->isLittleEndian())
    Features.set(Feature_IsLittleEndianBit);
  if (!Subtarget->isLittleEndian())
    Features.set(Feature_IsBigEndianBit);
  if (Subtarget->isPPC64())
    Features.set(Feature_IsPPC64Bit);
  if (!Subtarget->hasP9Vector())
    Features.set(Feature_HasOnlySwappingMemOpsBit);
  if (!Subtarget->hasP8Vector())
    Features.set(Feature_NoP8VectorBit);
  if (Subtarget->hasP8Vector())
    Features.set(Feature_HasP8VectorBit);
  if (Subtarget->hasDirectMove())
    Features.set(Feature_HasDirectMoveBit);
  if (!Subtarget->hasP9Vector())
    Features.set(Feature_NoP9VectorBit);
  if (Subtarget->hasP9Vector())
    Features.set(Feature_HasP9VectorBit);
  if (!Subtarget->hasP9Altivec())
    Features.set(Feature_NoP9AltivecBit);
  if (!Subtarget->hasP10Vector())
    Features.set(Feature_NoP10VectorBit);
  if (Subtarget->hasP10Vector())
    Features.set(Feature_HasP10VectorBit);
  if (Subtarget->hasHTM())
    Features.set(Feature_HasHTMBit);
  if (!Subtarget->isPPC64())
    Features.set(Feature_IsPPC32Bit);
  if (Subtarget->hasPrefixInstrs())
    Features.set(Feature_PrefixInstrsBit);
  if (Subtarget->isISA3_1())
    Features.set(Feature_IsISA3_1Bit);
  if (Subtarget->pairedVectorMemops())
    Features.set(Feature_PairedVectorMemopsBit);
  if (Subtarget->hasMMA())
    Features.set(Feature_MMABit);
  return Features;
}

void PPCInstructionSelector::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const PPCSubtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset PPCInstructionSelector::
computeAvailableFunctionFeatures(const PPCSubtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features{};
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
  GIFBS_HasAltivec,
  GIFBS_HasBPERMD,
  GIFBS_HasExtDiv,
  GIFBS_HasFPU,
  GIFBS_HasHTM,
  GIFBS_HasOnlyMSYNC,
  GIFBS_HasP8Altivec,
  GIFBS_HasP8Crypto,
  GIFBS_HasP9Altivec,
  GIFBS_HasSPE,
  GIFBS_HasSYNC,
  GIFBS_HasVSX,
  GIFBS_In32BitMode,
  GIFBS_In64BitMode,
  GIFBS_IsAIX,
  GIFBS_IsISA3_0,
  GIFBS_IsISA3_1,
  GIFBS_IsISAFuture,
  GIFBS_IsNotISA3_1,
  GIFBS_NotAIX,
  GIFBS_HasDirectMove_HasVSX,
  GIFBS_HasFPU_IsISA3_1,
  GIFBS_HasP10Vector_PrefixInstrs,
  GIFBS_HasP8Altivec_HasVSX,
  GIFBS_HasP8Vector_HasVSX,
  GIFBS_HasP9Vector_HasVSX,
  GIFBS_HasVSX_IsISA3_1,
  GIFBS_In64BitMode_IsISA3_0,
  GIFBS_IsISAFuture_MMA,
  GIFBS_IsNotISAFuture_MMA,
  GIFBS_HasP8Altivec_HasVSX_IsBigEndian,
  GIFBS_HasP8Altivec_HasVSX_IsLittleEndian,
  GIFBS_IsISAFuture_MMA_PrefixInstrs,
  GIFBS_IsNotISAFuture_MMA_PrefixInstrs,
  GIFBS_HasDirectMove_HasVSX_IsISA3_0_IsLittleEndian,
  GIFBS_HasDirectMove_HasVSX_IsLittleEndian_NoP9Vector,
  GIFBS_HasVSX_IsBigEndian_IsISA3_1_IsPPC32,
  GIFBS_HasDirectMove_HasVSX_IsBigEndian_IsISA3_0_IsPPC64,
  GIFBS_HasDirectMove_HasVSX_IsBigEndian_IsPPC64_NoP9Vector,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
  {Feature_HasAltivecBit, },
  {Feature_HasBPERMDBit, },
  {Feature_HasExtDivBit, },
  {Feature_HasFPUBit, },
  {Feature_HasHTMBit, },
  {Feature_HasOnlyMSYNCBit, },
  {Feature_HasP8AltivecBit, },
  {Feature_HasP8CryptoBit, },
  {Feature_HasP9AltivecBit, },
  {Feature_HasSPEBit, },
  {Feature_HasSYNCBit, },
  {Feature_HasVSXBit, },
  {Feature_In32BitModeBit, },
  {Feature_In64BitModeBit, },
  {Feature_IsAIXBit, },
  {Feature_IsISA3_0Bit, },
  {Feature_IsISA3_1Bit, },
  {Feature_IsISAFutureBit, },
  {Feature_IsNotISA3_1Bit, },
  {Feature_NotAIXBit, },
  {Feature_HasDirectMoveBit, Feature_HasVSXBit, },
  {Feature_HasFPUBit, Feature_IsISA3_1Bit, },
  {Feature_HasP10VectorBit, Feature_PrefixInstrsBit, },
  {Feature_HasP8AltivecBit, Feature_HasVSXBit, },
  {Feature_HasP8VectorBit, Feature_HasVSXBit, },
  {Feature_HasP9VectorBit, Feature_HasVSXBit, },
  {Feature_HasVSXBit, Feature_IsISA3_1Bit, },
  {Feature_In64BitModeBit, Feature_IsISA3_0Bit, },
  {Feature_IsISAFutureBit, Feature_MMABit, },
  {Feature_IsNotISAFutureBit, Feature_MMABit, },
  {Feature_HasP8AltivecBit, Feature_HasVSXBit, Feature_IsBigEndianBit, },
  {Feature_HasP8AltivecBit, Feature_HasVSXBit, Feature_IsLittleEndianBit, },
  {Feature_IsISAFutureBit, Feature_MMABit, Feature_PrefixInstrsBit, },
  {Feature_IsNotISAFutureBit, Feature_MMABit, Feature_PrefixInstrsBit, },
  {Feature_HasDirectMoveBit, Feature_HasVSXBit, Feature_IsISA3_0Bit, Feature_IsLittleEndianBit, },
  {Feature_HasDirectMoveBit, Feature_HasVSXBit, Feature_IsLittleEndianBit, Feature_NoP9VectorBit, },
  {Feature_HasVSXBit, Feature_IsBigEndianBit, Feature_IsISA3_1Bit, Feature_IsPPC32Bit, },
  {Feature_HasDirectMoveBit, Feature_HasVSXBit, Feature_IsBigEndianBit, Feature_IsISA3_0Bit, Feature_IsPPC64Bit, },
  {Feature_HasDirectMoveBit, Feature_HasVSXBit, Feature_IsBigEndianBit, Feature_IsPPC64Bit, Feature_NoP9VectorBit, },
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
};
// See constructor for table contents

PPCInstructionSelector::ComplexMatcherMemFn
PPCInstructionSelector::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
};

// PatFrag predicates.
bool PPCInstructionSelector::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  const MachineFunction &MF = *MI.getParent()->getParent();
  const MachineRegisterInfo &MRI = MF.getRegInfo();
  const auto &Operands = State.RecordedOperands;
  (void)Operands;
  (void)MRI;
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_I64_Predicate_Msk2Imm = GICXXPred_Invalid + 1,
  GICXXPred_I64_Predicate_Msk4Imm,
  GICXXPred_I64_Predicate_Msk8Imm,
  GICXXPred_I64_Predicate_i32immNonAllOneNonZero,
  GICXXPred_I64_Predicate_imm32SExt16,
  GICXXPred_I64_Predicate_imm64SExt16,
  GICXXPred_I64_Predicate_imm64ZExt32,
  GICXXPred_I64_Predicate_immNonAllOneAnyExt8,
  GICXXPred_I64_Predicate_immSExt5NonZero,
};
bool PPCInstructionSelector::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  switch (PredicateID) {
  case GICXXPred_I64_Predicate_Msk2Imm: {
     return isUInt<2>(Imm); 
  }
  case GICXXPred_I64_Predicate_Msk4Imm: {
     return isUInt<4>(Imm); 
  }
  case GICXXPred_I64_Predicate_Msk8Imm: {
     return isUInt<8>(Imm); 
  }
  case GICXXPred_I64_Predicate_i32immNonAllOneNonZero: {
     return Imm && (Imm != -1); 
  }
  case GICXXPred_I64_Predicate_imm32SExt16: {
    
      // imm32SExt16 predicate - True if the i32 immediate fits in a 16-bit
      // sign extended field.  Used by instructions like 'addi'.
      return (int32_t)Imm == (short)Imm;
    
    llvm_unreachable("imm32SExt16 should have returned");
  }
  case GICXXPred_I64_Predicate_imm64SExt16: {
    
      // imm64SExt16 predicate - True if the i64 immediate fits in a 16-bit
      // sign extended field.  Used by instructions like 'addi'.
      return (int64_t)Imm == (short)Imm;
    
    llvm_unreachable("imm64SExt16 should have returned");
  }
  case GICXXPred_I64_Predicate_imm64ZExt32: {
    
      // imm64ZExt32 predicate - True if the i64 immediate fits in a 32-bit
      // zero extended field.
      return isUInt<32>(Imm);
    
    llvm_unreachable("imm64ZExt32 should have returned");
  }
  case GICXXPred_I64_Predicate_immNonAllOneAnyExt8: {
    
      return (isInt<8>(Imm) && (Imm != -1)) || (isUInt<8>(Imm) && (Imm != 0xFF));
    
  }
  case GICXXPred_I64_Predicate_immSExt5NonZero: {
     return Imm && isInt<5>(Imm); 
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
bool PPCInstructionSelector::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
bool PPCInstructionSelector::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
bool PPCInstructionSelector::testSimplePredicate(unsigned) const {
    llvm_unreachable("PPCInstructionSelector does not support simple predicates!");
  return false;
}
// Custom renderers.
enum {
  GICR_Invalid,
};
PPCInstructionSelector::CustomRendererFn
PPCInstructionSelector::CustomRenderers[] = {
  nullptr, // GICR_Invalid
};

bool PPCInstructionSelector::selectImpl(MachineInstr &I, CodeGenCoverage &CoverageInfo) const {
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  MachineIRBuilder B(I);
  State.MIs.clear();
  State.MIs.push_back(&I);

  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), TII, MF->getRegInfo(), TRI, RBI, AvailableFeatures, &CoverageInfo)) {
    return true;
  }

  return false;
}

bool PPCInstructionSelector::runCustomAction(unsigned, const MatcherState&, NewMIVector &) const {
    llvm_unreachable("PPCInstructionSelector does not support custom C++ actions!");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *PPCInstructionSelector::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
     /*      0 */ GIM_SwitchOpcode, /*MI*/0, /*[*/GIMT_Encode2(53), GIMT_Encode2(285), /*)*//*default:*//*Label 83*/ GIMT_Encode4(208730),
     /*     10 */ /*TargetOpcode::G_ADD*//*Label 0*/ GIMT_Encode4(938),
     /*     14 */ /*TargetOpcode::G_SUB*//*Label 1*/ GIMT_Encode4(1347),
     /*     18 */ /*TargetOpcode::G_MUL*//*Label 2*/ GIMT_Encode4(1788),
     /*     22 */ /*TargetOpcode::G_SDIV*//*Label 3*/ GIMT_Encode4(2070),
     /*     26 */ /*TargetOpcode::G_UDIV*//*Label 4*/ GIMT_Encode4(2226),
     /*     30 */ /*TargetOpcode::G_SREM*//*Label 5*/ GIMT_Encode4(2382),
     /*     34 */ /*TargetOpcode::G_UREM*//*Label 6*/ GIMT_Encode4(2544), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     46 */ /*TargetOpcode::G_AND*//*Label 7*/ GIMT_Encode4(2706),
     /*     50 */ /*TargetOpcode::G_OR*//*Label 8*/ GIMT_Encode4(5267),
     /*     54 */ /*TargetOpcode::G_XOR*//*Label 9*/ GIMT_Encode4(48409), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    106 */ /*TargetOpcode::G_BUILD_VECTOR*//*Label 10*/ GIMT_Encode4(57516), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    126 */ /*TargetOpcode::G_BITCAST*//*Label 11*/ GIMT_Encode4(58483), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    142 */ /*TargetOpcode::G_INTRINSIC_TRUNC*//*Label 12*/ GIMT_Encode4(60760),
     /*    146 */ /*TargetOpcode::G_INTRINSIC_ROUND*//*Label 13*/ GIMT_Encode4(61035),
     /*    150 */ /*TargetOpcode::G_INTRINSIC_LRINT*//*Label 14*/ GIMT_Encode4(61285),
     /*    154 */ /*TargetOpcode::G_INTRINSIC_LLRINT*//*Label 15*/ GIMT_Encode4(61416), GIMT_Encode4(0),
     /*    162 */ /*TargetOpcode::G_READCYCLECOUNTER*//*Label 16*/ GIMT_Encode4(61547), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    286 */ /*TargetOpcode::G_FENCE*//*Label 17*/ GIMT_Encode4(61567), GIMT_Encode4(0),
     /*    294 */ /*TargetOpcode::G_BRCOND*//*Label 18*/ GIMT_Encode4(61692), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    306 */ /*TargetOpcode::G_INTRINSIC*//*Label 19*/ GIMT_Encode4(61755),
     /*    310 */ /*TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS*//*Label 20*/ GIMT_Encode4(88456), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    322 */ /*TargetOpcode::G_ANYEXT*//*Label 21*/ GIMT_Encode4(91348),
     /*    326 */ /*TargetOpcode::G_TRUNC*//*Label 22*/ GIMT_Encode4(112104),
     /*    330 */ /*TargetOpcode::G_CONSTANT*//*Label 23*/ GIMT_Encode4(112290), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    346 */ /*TargetOpcode::G_SEXT*//*Label 24*/ GIMT_Encode4(112442),
     /*    350 */ /*TargetOpcode::G_SEXT_INREG*//*Label 25*/ GIMT_Encode4(127474),
     /*    354 */ /*TargetOpcode::G_ZEXT*//*Label 26*/ GIMT_Encode4(127827),
     /*    358 */ /*TargetOpcode::G_SHL*//*Label 27*/ GIMT_Encode4(149297),
     /*    362 */ /*TargetOpcode::G_LSHR*//*Label 28*/ GIMT_Encode4(149653),
     /*    366 */ /*TargetOpcode::G_ASHR*//*Label 29*/ GIMT_Encode4(150075), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    382 */ /*TargetOpcode::G_ROTL*//*Label 30*/ GIMT_Encode4(150445),
     /*    386 */ /*TargetOpcode::G_ICMP*//*Label 31*/ GIMT_Encode4(150753),
     /*    390 */ /*TargetOpcode::G_FCMP*//*Label 32*/ GIMT_Encode4(154755), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    402 */ /*TargetOpcode::G_SELECT*//*Label 33*/ GIMT_Encode4(158206), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    446 */ /*TargetOpcode::G_UMULH*//*Label 34*/ GIMT_Encode4(159330),
     /*    450 */ /*TargetOpcode::G_SMULH*//*Label 35*/ GIMT_Encode4(159460),
     /*    454 */ /*TargetOpcode::G_UADDSAT*//*Label 36*/ GIMT_Encode4(159590),
     /*    458 */ /*TargetOpcode::G_SADDSAT*//*Label 37*/ GIMT_Encode4(159692),
     /*    462 */ /*TargetOpcode::G_USUBSAT*//*Label 38*/ GIMT_Encode4(159794),
     /*    466 */ /*TargetOpcode::G_SSUBSAT*//*Label 39*/ GIMT_Encode4(159896), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    510 */ /*TargetOpcode::G_FADD*//*Label 40*/ GIMT_Encode4(159998),
     /*    514 */ /*TargetOpcode::G_FSUB*//*Label 41*/ GIMT_Encode4(160293),
     /*    518 */ /*TargetOpcode::G_FMUL*//*Label 42*/ GIMT_Encode4(160588),
     /*    522 */ /*TargetOpcode::G_FMA*//*Label 43*/ GIMT_Encode4(160938), GIMT_Encode4(0),
     /*    530 */ /*TargetOpcode::G_FDIV*//*Label 44*/ GIMT_Encode4(161519), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    578 */ /*TargetOpcode::G_FNEG*//*Label 45*/ GIMT_Encode4(161789),
     /*    582 */ /*TargetOpcode::G_FPEXT*//*Label 46*/ GIMT_Encode4(164260),
     /*    586 */ /*TargetOpcode::G_FPTRUNC*//*Label 47*/ GIMT_Encode4(164424),
     /*    590 */ /*TargetOpcode::G_FPTOSI*//*Label 48*/ GIMT_Encode4(164581),
     /*    594 */ /*TargetOpcode::G_FPTOUI*//*Label 49*/ GIMT_Encode4(164844),
     /*    598 */ /*TargetOpcode::G_SITOFP*//*Label 50*/ GIMT_Encode4(165107),
     /*    602 */ /*TargetOpcode::G_UITOFP*//*Label 51*/ GIMT_Encode4(165354), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    614 */ /*TargetOpcode::G_FABS*//*Label 52*/ GIMT_Encode4(165601),
     /*    618 */ /*TargetOpcode::G_FCOPYSIGN*//*Label 53*/ GIMT_Encode4(165893), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    630 */ /*TargetOpcode::G_FMINNUM*//*Label 54*/ GIMT_Encode4(166209),
     /*    634 */ /*TargetOpcode::G_FMAXNUM*//*Label 55*/ GIMT_Encode4(166289),
     /*    638 */ /*TargetOpcode::G_FMINNUM_IEEE*//*Label 56*/ GIMT_Encode4(166369),
     /*    642 */ /*TargetOpcode::G_FMAXNUM_IEEE*//*Label 57*/ GIMT_Encode4(166951), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    686 */ /*TargetOpcode::G_SMIN*//*Label 58*/ GIMT_Encode4(167533),
     /*    690 */ /*TargetOpcode::G_SMAX*//*Label 59*/ GIMT_Encode4(167713),
     /*    694 */ /*TargetOpcode::G_UMIN*//*Label 60*/ GIMT_Encode4(167893),
     /*    698 */ /*TargetOpcode::G_UMAX*//*Label 61*/ GIMT_Encode4(168073), GIMT_Encode4(0),
     /*    706 */ /*TargetOpcode::G_LROUND*//*Label 62*/ GIMT_Encode4(168253),
     /*    710 */ /*TargetOpcode::G_LLROUND*//*Label 63*/ GIMT_Encode4(168555),
     /*    714 */ /*TargetOpcode::G_BR*//*Label 64*/ GIMT_Encode4(168720), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    734 */ /*TargetOpcode::G_INSERT_VECTOR_ELT*//*Label 65*/ GIMT_Encode4(168736), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    758 */ /*TargetOpcode::G_CTTZ*//*Label 66*/ GIMT_Encode4(168854), GIMT_Encode4(0),
     /*    766 */ /*TargetOpcode::G_CTLZ*//*Label 67*/ GIMT_Encode4(169032), GIMT_Encode4(0),
     /*    774 */ /*TargetOpcode::G_CTPOP*//*Label 68*/ GIMT_Encode4(169204),
     /*    778 */ /*TargetOpcode::G_BSWAP*//*Label 69*/ GIMT_Encode4(169376),
     /*    782 */ /*TargetOpcode::G_BITREVERSE*//*Label 70*/ GIMT_Encode4(169640),
     /*    786 */ /*TargetOpcode::G_FCEIL*//*Label 71*/ GIMT_Encode4(205646), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    834 */ /*TargetOpcode::G_FSQRT*//*Label 72*/ GIMT_Encode4(205921),
     /*    838 */ /*TargetOpcode::G_FFLOOR*//*Label 73*/ GIMT_Encode4(206138),
     /*    842 */ /*TargetOpcode::G_FRINT*//*Label 74*/ GIMT_Encode4(206413),
     /*    846 */ /*TargetOpcode::G_FNEARBYINT*//*Label 75*/ GIMT_Encode4(206625), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    874 */ /*TargetOpcode::G_STRICT_FADD*//*Label 76*/ GIMT_Encode4(206862),
     /*    878 */ /*TargetOpcode::G_STRICT_FSUB*//*Label 77*/ GIMT_Encode4(207132),
     /*    882 */ /*TargetOpcode::G_STRICT_FMUL*//*Label 78*/ GIMT_Encode4(207402),
     /*    886 */ /*TargetOpcode::G_STRICT_FDIV*//*Label 79*/ GIMT_Encode4(207672), GIMT_Encode4(0),
     /*    894 */ /*TargetOpcode::G_STRICT_FMA*//*Label 80*/ GIMT_Encode4(207942),
     /*    898 */ /*TargetOpcode::G_STRICT_FSQRT*//*Label 81*/ GIMT_Encode4(208500), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    934 */ /*TargetOpcode::G_TRAP*//*Label 82*/ GIMT_Encode4(208717),
     /*    938 */ // Label 0: @938
     /*    938 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(8), /*)*//*default:*//*Label 92*/ GIMT_Encode4(1346),
     /*    949 */ /*GILLT_s1*//*Label 84*/ GIMT_Encode4(981),
     /*    953 */ /*GILLT_s32*//*Label 85*/ GIMT_Encode4(1004),
     /*    957 */ /*GILLT_s64*//*Label 86*/ GIMT_Encode4(1064),
     /*    961 */ /*GILLT_s128*//*Label 87*/ GIMT_Encode4(1124),
     /*    965 */ /*GILLT_v2s64*//*Label 88*/ GIMT_Encode4(1150),
     /*    969 */ /*GILLT_v4s32*//*Label 89*/ GIMT_Encode4(1176),
     /*    973 */ /*GILLT_v8s16*//*Label 90*/ GIMT_Encode4(1202),
     /*    977 */ /*GILLT_v16s8*//*Label 91*/ GIMT_Encode4(1320),
     /*    981 */ // Label 84: @981
     /*    981 */ GIM_Try, /*On fail goto*//*Label 93*/ GIMT_Encode4(1003), // Rule ID 3629 //
     /*    986 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /*    989 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s1,
     /*    992 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*    996 */   // (add:{ *:[i1] } i1:{ *:[i1] }:$a, i1:{ *:[i1] }:$b)  =>  (CRXOR:{ *:[i1] } ?:{ *:[i1] }:$a, ?:{ *:[i1] }:$b)
     /*    996 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::CRXOR),
     /*   1001 */   GIR_RootConstrainSelectedInstOperands,
     /*   1002 */   // GIR_Coverage, 3629,
     /*   1002 */   GIR_Done,
     /*   1003 */ // Label 93: @1003
     /*   1003 */ GIM_Reject,
     /*   1004 */ // Label 85: @1004
     /*   1004 */ GIM_Try, /*On fail goto*//*Label 94*/ GIMT_Encode4(1063),
     /*   1009 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   1012 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   1015 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*   1019 */   GIM_Try, /*On fail goto*//*Label 95*/ GIMT_Encode4(1050), // Rule ID 107 //
     /*   1024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   1032 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /*   1036 */     // MIs[1] Operand 1
     /*   1036 */     // No operand predicates
     /*   1036 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1038 */     // (add:{ *:[i32] } i32:{ *:[i32] }:$RA, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$D)  =>  (ADDI:{ *:[i32] } i32:{ *:[i32] }:$RA, (imm:{ *:[i32] }):$D)
     /*   1038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::ADDI),
     /*   1041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*   1043 */     GIR_RootToRootCopy, /*OpIdx*/1, // RA
     /*   1045 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // D
     /*   1048 */     GIR_RootConstrainSelectedInstOperands,
     /*   1049 */     // GIR_Coverage, 107,
     /*   1049 */     GIR_EraseRootFromParent_Done,
     /*   1050 */   // Label 95: @1050
     /*   1050 */   GIM_Try, /*On fail goto*//*Label 96*/ GIMT_Encode4(1062), // Rule ID 199 //
     /*   1055 */     // (add:{ *:[i32] } i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)  =>  (ADD4:{ *:[i32] } i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)
     /*   1055 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::ADD4),
     /*   1060 */     GIR_RootConstrainSelectedInstOperands,
     /*   1061 */     // GIR_Coverage, 199,
     /*   1061 */     GIR_Done,
     /*   1062 */   // Label 96: @1062
     /*   1062 */   GIM_Reject,
     /*   1063 */ // Label 94: @1063
     /*   1063 */ GIM_Reject,
     /*   1064 */ // Label 86: @1064
     /*   1064 */ GIM_Try, /*On fail goto*//*Label 97*/ GIMT_Encode4(1123),
     /*   1069 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   1072 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   1075 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*   1079 */   GIM_Try, /*On fail goto*//*Label 98*/ GIMT_Encode4(1110), // Rule ID 659 //
     /*   1084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   1092 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /*   1096 */     // MIs[1] Operand 1
     /*   1096 */     // No operand predicates
     /*   1096 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1098 */     // (add:{ *:[i64] } i64:{ *:[i64] }:$RA, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$D)  =>  (ADDI8:{ *:[i64] } i64:{ *:[i64] }:$RA, (imm:{ *:[i64] }):$D)
     /*   1098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::ADDI8),
     /*   1101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*   1103 */     GIR_RootToRootCopy, /*OpIdx*/1, // RA
     /*   1105 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // D
     /*   1108 */     GIR_RootConstrainSelectedInstOperands,
     /*   1109 */     // GIR_Coverage, 659,
     /*   1109 */     GIR_EraseRootFromParent_Done,
     /*   1110 */   // Label 98: @1110
     /*   1110 */   GIM_Try, /*On fail goto*//*Label 99*/ GIMT_Encode4(1122), // Rule ID 655 //
     /*   1115 */     // (add:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)  =>  (ADD8:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)
     /*   1115 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::ADD8),
     /*   1120 */     GIR_RootConstrainSelectedInstOperands,
     /*   1121 */     // GIR_Coverage, 655,
     /*   1121 */     GIR_Done,
     /*   1122 */   // Label 99: @1122
     /*   1122 */   GIM_Reject,
     /*   1123 */ // Label 97: @1123
     /*   1123 */ GIM_Reject,
     /*   1124 */ // Label 87: @1124
     /*   1124 */ GIM_Try, /*On fail goto*//*Label 100*/ GIMT_Encode4(1149), // Rule ID 470 //
     /*   1129 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*   1132 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*   1135 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*   1138 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   1142 */   // (add:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)  =>  (VADDUQM:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)
     /*   1142 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VADDUQM),
     /*   1147 */   GIR_RootConstrainSelectedInstOperands,
     /*   1148 */   // GIR_Coverage, 470,
     /*   1148 */   GIR_Done,
     /*   1149 */ // Label 100: @1149
     /*   1149 */ GIM_Reject,
     /*   1150 */ // Label 88: @1150
     /*   1150 */ GIM_Try, /*On fail goto*//*Label 101*/ GIMT_Encode4(1175), // Rule ID 469 //
     /*   1155 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*   1158 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   1161 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*   1164 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   1168 */   // (add:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VADDUDM:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*   1168 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VADDUDM),
     /*   1173 */   GIR_RootConstrainSelectedInstOperands,
     /*   1174 */   // GIR_Coverage, 469,
     /*   1174 */   GIR_Done,
     /*   1175 */ // Label 101: @1175
     /*   1175 */ GIM_Reject,
     /*   1176 */ // Label 89: @1176
     /*   1176 */ GIM_Try, /*On fail goto*//*Label 102*/ GIMT_Encode4(1201), // Rule ID 303 //
     /*   1181 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*   1184 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   1187 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   1190 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   1194 */   // (add:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VADDUWM:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*   1194 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VADDUWM),
     /*   1199 */   GIR_RootConstrainSelectedInstOperands,
     /*   1200 */   // GIR_Coverage, 303,
     /*   1200 */   GIR_Done,
     /*   1201 */ // Label 102: @1201
     /*   1201 */ GIM_Reject,
     /*   1202 */ // Label 90: @1202
     /*   1202 */ GIM_Try, /*On fail goto*//*Label 103*/ GIMT_Encode4(1319),
     /*   1207 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   1210 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   1213 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   1217 */   GIM_Try, /*On fail goto*//*Label 104*/ GIMT_Encode4(1260), // Rule ID 1290 //
     /*   1222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*   1225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   1233 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   1237 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   1241 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1243 */     // (add:{ *:[v8i16] } (mul:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$vA, v8i16:{ *:[v8i16] }:$vB), v8i16:{ *:[v8i16] }:$vC)  =>  (VMLADDUHM:{ *:[v8i16] } ?:{ *:[v8i16] }:$vA, ?:{ *:[v8i16] }:$vB, ?:{ *:[v8i16] }:$vC)
     /*   1243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMLADDUHM),
     /*   1246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*   1248 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*   1252 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*   1256 */     GIR_RootToRootCopy, /*OpIdx*/2, // vC
     /*   1258 */     GIR_RootConstrainSelectedInstOperands,
     /*   1259 */     // GIR_Coverage, 1290,
     /*   1259 */     GIR_EraseRootFromParent_Done,
     /*   1260 */   // Label 104: @1260
     /*   1260 */   GIM_Try, /*On fail goto*//*Label 105*/ GIMT_Encode4(1303), // Rule ID 4900 //
     /*   1265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*   1268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   1276 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   1280 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   1284 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1286 */     // (add:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$vC, (mul:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$vA, v8i16:{ *:[v8i16] }:$vB))  =>  (VMLADDUHM:{ *:[v8i16] } ?:{ *:[v8i16] }:$vA, ?:{ *:[v8i16] }:$vB, ?:{ *:[v8i16] }:$vC)
     /*   1286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMLADDUHM),
     /*   1289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*   1291 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*   1295 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*   1299 */     GIR_RootToRootCopy, /*OpIdx*/1, // vC
     /*   1301 */     GIR_RootConstrainSelectedInstOperands,
     /*   1302 */     // GIR_Coverage, 4900,
     /*   1302 */     GIR_EraseRootFromParent_Done,
     /*   1303 */   // Label 105: @1303
     /*   1303 */   GIM_Try, /*On fail goto*//*Label 106*/ GIMT_Encode4(1318), // Rule ID 302 //
     /*   1308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*   1311 */     // (add:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VADDUHM:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*   1311 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VADDUHM),
     /*   1316 */     GIR_RootConstrainSelectedInstOperands,
     /*   1317 */     // GIR_Coverage, 302,
     /*   1317 */     GIR_Done,
     /*   1318 */   // Label 106: @1318
     /*   1318 */   GIM_Reject,
     /*   1319 */ // Label 103: @1319
     /*   1319 */ GIM_Reject,
     /*   1320 */ // Label 91: @1320
     /*   1320 */ GIM_Try, /*On fail goto*//*Label 107*/ GIMT_Encode4(1345), // Rule ID 301 //
     /*   1325 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*   1328 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*   1331 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*   1334 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   1338 */   // (add:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VADDUBM:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*   1338 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VADDUBM),
     /*   1343 */   GIR_RootConstrainSelectedInstOperands,
     /*   1344 */   // GIR_Coverage, 301,
     /*   1344 */   GIR_Done,
     /*   1345 */ // Label 107: @1345
     /*   1345 */ GIM_Reject,
     /*   1346 */ // Label 92: @1346
     /*   1346 */ GIM_Reject,
     /*   1347 */ // Label 1: @1347
     /*   1347 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(8), /*)*//*default:*//*Label 116*/ GIMT_Encode4(1787),
     /*   1358 */ /*GILLT_s1*//*Label 108*/ GIMT_Encode4(1390),
     /*   1362 */ /*GILLT_s32*//*Label 109*/ GIMT_Encode4(1413),
     /*   1366 */ /*GILLT_s64*//*Label 110*/ GIMT_Encode4(1498),
     /*   1370 */ /*GILLT_s128*//*Label 111*/ GIMT_Encode4(1583),
     /*   1374 */ /*GILLT_v2s64*//*Label 112*/ GIMT_Encode4(1609),
     /*   1378 */ /*GILLT_v4s32*//*Label 113*/ GIMT_Encode4(1672),
     /*   1382 */ /*GILLT_v8s16*//*Label 114*/ GIMT_Encode4(1735),
     /*   1386 */ /*GILLT_v16s8*//*Label 115*/ GIMT_Encode4(1761),
     /*   1390 */ // Label 108: @1390
     /*   1390 */ GIM_Try, /*On fail goto*//*Label 117*/ GIMT_Encode4(1412), // Rule ID 3630 //
     /*   1395 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /*   1398 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s1,
     /*   1401 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*   1405 */   // (sub:{ *:[i1] } i1:{ *:[i1] }:$a, i1:{ *:[i1] }:$b)  =>  (CRXOR:{ *:[i1] } ?:{ *:[i1] }:$a, ?:{ *:[i1] }:$b)
     /*   1405 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::CRXOR),
     /*   1410 */   GIR_RootConstrainSelectedInstOperands,
     /*   1411 */   // GIR_Coverage, 3630,
     /*   1411 */   GIR_Done,
     /*   1412 */ // Label 117: @1412
     /*   1412 */ GIM_Reject,
     /*   1413 */ // Label 109: @1413
     /*   1413 */ GIM_Try, /*On fail goto*//*Label 118*/ GIMT_Encode4(1497),
     /*   1418 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   1421 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   1424 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*   1428 */   GIM_Try, /*On fail goto*//*Label 119*/ GIMT_Encode4(1446), // Rule ID 211 //
     /*   1433 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   1437 */     // (sub:{ *:[i32] } 0:{ *:[i32] }, i32:{ *:[i32] }:$RA)  =>  (NEG:{ *:[i32] } i32:{ *:[i32] }:$RA)
     /*   1437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::NEG),
     /*   1440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*   1442 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*   1444 */     GIR_RootConstrainSelectedInstOperands,
     /*   1445 */     // GIR_Coverage, 211,
     /*   1445 */     GIR_EraseRootFromParent_Done,
     /*   1446 */   // Label 119: @1446
     /*   1446 */   GIM_Try, /*On fail goto*//*Label 120*/ GIMT_Encode4(1480), // Rule ID 1211 //
     /*   1451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   1459 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /*   1463 */     // MIs[1] Operand 1
     /*   1463 */     // No operand predicates
     /*   1463 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1465 */     // (sub:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, i32:{ *:[i32] }:$in)  =>  (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$in, (imm:{ *:[i32] }):$imm)
     /*   1465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /*   1468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*   1470 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*   1472 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*   1475 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CARRY*/0,
     /*   1478 */     GIR_RootConstrainSelectedInstOperands,
     /*   1479 */     // GIR_Coverage, 1211,
     /*   1479 */     GIR_EraseRootFromParent_Done,
     /*   1480 */   // Label 120: @1480
     /*   1480 */   GIM_Try, /*On fail goto*//*Label 121*/ GIMT_Encode4(1496), // Rule ID 209 //
     /*   1485 */     // (sub:{ *:[i32] } i32:{ *:[i32] }:$RB, i32:{ *:[i32] }:$RA)  =>  (SUBF:{ *:[i32] } i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)
     /*   1485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SUBF),
     /*   1488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*   1490 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*   1492 */     GIR_RootToRootCopy, /*OpIdx*/1, // RB
     /*   1494 */     GIR_RootConstrainSelectedInstOperands,
     /*   1495 */     // GIR_Coverage, 209,
     /*   1495 */     GIR_EraseRootFromParent_Done,
     /*   1496 */   // Label 121: @1496
     /*   1496 */   GIM_Reject,
     /*   1497 */ // Label 118: @1497
     /*   1497 */ GIM_Reject,
     /*   1498 */ // Label 110: @1498
     /*   1498 */ GIM_Try, /*On fail goto*//*Label 122*/ GIMT_Encode4(1582),
     /*   1503 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   1506 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   1509 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*   1513 */   GIM_Try, /*On fail goto*//*Label 123*/ GIMT_Encode4(1531), // Rule ID 665 //
     /*   1518 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   1522 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, i64:{ *:[i64] }:$RA)  =>  (NEG8:{ *:[i64] } i64:{ *:[i64] }:$RA)
     /*   1522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::NEG8),
     /*   1525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*   1527 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*   1529 */     GIR_RootConstrainSelectedInstOperands,
     /*   1530 */     // GIR_Coverage, 665,
     /*   1530 */     GIR_EraseRootFromParent_Done,
     /*   1531 */   // Label 123: @1531
     /*   1531 */   GIM_Try, /*On fail goto*//*Label 124*/ GIMT_Encode4(1565), // Rule ID 1533 //
     /*   1536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   1544 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /*   1548 */     // MIs[1] Operand 1
     /*   1548 */     // No operand predicates
     /*   1548 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1550 */     // (sub:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, i64:{ *:[i64] }:$in)  =>  (SUBFIC8:{ *:[i64] }:{ *:[i32] } ?:{ *:[i64] }:$in, (imm:{ *:[i64] }):$imm)
     /*   1550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SUBFIC8),
     /*   1553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*   1555 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*   1557 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*   1560 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CARRY*/0,
     /*   1563 */     GIR_RootConstrainSelectedInstOperands,
     /*   1564 */     // GIR_Coverage, 1533,
     /*   1564 */     GIR_EraseRootFromParent_Done,
     /*   1565 */   // Label 124: @1565
     /*   1565 */   GIM_Try, /*On fail goto*//*Label 125*/ GIMT_Encode4(1581), // Rule ID 664 //
     /*   1570 */     // (sub:{ *:[i64] } i64:{ *:[i64] }:$RB, i64:{ *:[i64] }:$RA)  =>  (SUBF8:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)
     /*   1570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SUBF8),
     /*   1573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*   1575 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*   1577 */     GIR_RootToRootCopy, /*OpIdx*/1, // RB
     /*   1579 */     GIR_RootConstrainSelectedInstOperands,
     /*   1580 */     // GIR_Coverage, 664,
     /*   1580 */     GIR_EraseRootFromParent_Done,
     /*   1581 */   // Label 125: @1581
     /*   1581 */   GIM_Reject,
     /*   1582 */ // Label 122: @1582
     /*   1582 */ GIM_Reject,
     /*   1583 */ // Label 111: @1583
     /*   1583 */ GIM_Try, /*On fail goto*//*Label 126*/ GIMT_Encode4(1608), // Rule ID 475 //
     /*   1588 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*   1591 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*   1594 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*   1597 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   1601 */   // (sub:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)  =>  (VSUBUQM:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)
     /*   1601 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSUBUQM),
     /*   1606 */   GIR_RootConstrainSelectedInstOperands,
     /*   1607 */   // GIR_Coverage, 475,
     /*   1607 */   GIR_Done,
     /*   1608 */ // Label 126: @1608
     /*   1608 */ GIM_Reject,
     /*   1609 */ // Label 112: @1609
     /*   1609 */ GIM_Try, /*On fail goto*//*Label 127*/ GIMT_Encode4(1671),
     /*   1614 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   1617 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*   1620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   1624 */   GIM_Try, /*On fail goto*//*Label 128*/ GIMT_Encode4(1655), // Rule ID 542 //
     /*   1629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*   1632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1636 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   1642 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*   1644 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1646 */     // (sub:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, v2i64:{ *:[v2i64] }:$VB)  =>  (VNEGD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VB)
     /*   1646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VNEGD),
     /*   1649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*   1651 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*   1653 */     GIR_RootConstrainSelectedInstOperands,
     /*   1654 */     // GIR_Coverage, 542,
     /*   1654 */     GIR_EraseRootFromParent_Done,
     /*   1655 */   // Label 128: @1655
     /*   1655 */   GIM_Try, /*On fail goto*//*Label 129*/ GIMT_Encode4(1670), // Rule ID 474 //
     /*   1660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*   1663 */     // (sub:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VSUBUDM:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*   1663 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSUBUDM),
     /*   1668 */     GIR_RootConstrainSelectedInstOperands,
     /*   1669 */     // GIR_Coverage, 474,
     /*   1669 */     GIR_Done,
     /*   1670 */   // Label 129: @1670
     /*   1670 */   GIM_Reject,
     /*   1671 */ // Label 127: @1671
     /*   1671 */ GIM_Reject,
     /*   1672 */ // Label 113: @1672
     /*   1672 */ GIM_Try, /*On fail goto*//*Label 130*/ GIMT_Encode4(1734),
     /*   1677 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   1680 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   1683 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   1687 */   GIM_Try, /*On fail goto*//*Label 131*/ GIMT_Encode4(1718), // Rule ID 541 //
     /*   1692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*   1695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1699 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   1705 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*   1707 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1709 */     // (sub:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, v4i32:{ *:[v4i32] }:$VB)  =>  (VNEGW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VB)
     /*   1709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VNEGW),
     /*   1712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*   1714 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*   1716 */     GIR_RootConstrainSelectedInstOperands,
     /*   1717 */     // GIR_Coverage, 541,
     /*   1717 */     GIR_EraseRootFromParent_Done,
     /*   1718 */   // Label 131: @1718
     /*   1718 */   GIM_Try, /*On fail goto*//*Label 132*/ GIMT_Encode4(1733), // Rule ID 373 //
     /*   1723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*   1726 */     // (sub:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VSUBUWM:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*   1726 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSUBUWM),
     /*   1731 */     GIR_RootConstrainSelectedInstOperands,
     /*   1732 */     // GIR_Coverage, 373,
     /*   1732 */     GIR_Done,
     /*   1733 */   // Label 132: @1733
     /*   1733 */   GIM_Reject,
     /*   1734 */ // Label 130: @1734
     /*   1734 */ GIM_Reject,
     /*   1735 */ // Label 114: @1735
     /*   1735 */ GIM_Try, /*On fail goto*//*Label 133*/ GIMT_Encode4(1760), // Rule ID 372 //
     /*   1740 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*   1743 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   1746 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   1749 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   1753 */   // (sub:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VSUBUHM:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*   1753 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSUBUHM),
     /*   1758 */   GIR_RootConstrainSelectedInstOperands,
     /*   1759 */   // GIR_Coverage, 372,
     /*   1759 */   GIR_Done,
     /*   1760 */ // Label 133: @1760
     /*   1760 */ GIM_Reject,
     /*   1761 */ // Label 115: @1761
     /*   1761 */ GIM_Try, /*On fail goto*//*Label 134*/ GIMT_Encode4(1786), // Rule ID 371 //
     /*   1766 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*   1769 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*   1772 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*   1775 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   1779 */   // (sub:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VSUBUBM:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*   1779 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSUBUBM),
     /*   1784 */   GIR_RootConstrainSelectedInstOperands,
     /*   1785 */   // GIR_Coverage, 371,
     /*   1785 */   GIR_Done,
     /*   1786 */ // Label 134: @1786
     /*   1786 */ GIM_Reject,
     /*   1787 */ // Label 116: @1787
     /*   1787 */ GIM_Reject,
     /*   1788 */ // Label 2: @1788
     /*   1788 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(7), /*)*//*default:*//*Label 141*/ GIMT_Encode4(2069),
     /*   1799 */ /*GILLT_s1*//*Label 135*/ GIMT_Encode4(1827),
     /*   1803 */ /*GILLT_s32*//*Label 136*/ GIMT_Encode4(1850),
     /*   1807 */ /*GILLT_s64*//*Label 137*/ GIMT_Encode4(1910), GIMT_Encode4(0),
     /*   1815 */ /*GILLT_v2s64*//*Label 138*/ GIMT_Encode4(1970),
     /*   1819 */ /*GILLT_v4s32*//*Label 139*/ GIMT_Encode4(1996),
     /*   1823 */ /*GILLT_v8s16*//*Label 140*/ GIMT_Encode4(2022),
     /*   1827 */ // Label 135: @1827
     /*   1827 */ GIM_Try, /*On fail goto*//*Label 142*/ GIMT_Encode4(1849), // Rule ID 3631 //
     /*   1832 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /*   1835 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s1,
     /*   1838 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*   1842 */   // (mul:{ *:[i1] } i1:{ *:[i1] }:$a, i1:{ *:[i1] }:$b)  =>  (CRAND:{ *:[i1] } ?:{ *:[i1] }:$a, ?:{ *:[i1] }:$b)
     /*   1842 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::CRAND),
     /*   1847 */   GIR_RootConstrainSelectedInstOperands,
     /*   1848 */   // GIR_Coverage, 3631,
     /*   1848 */   GIR_Done,
     /*   1849 */ // Label 142: @1849
     /*   1849 */ GIM_Reject,
     /*   1850 */ // Label 136: @1850
     /*   1850 */ GIM_Try, /*On fail goto*//*Label 143*/ GIMT_Encode4(1909),
     /*   1855 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   1858 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   1861 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*   1865 */   GIM_Try, /*On fail goto*//*Label 144*/ GIMT_Encode4(1896), // Rule ID 111 //
     /*   1870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   1878 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /*   1882 */     // MIs[1] Operand 1
     /*   1882 */     // No operand predicates
     /*   1882 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1884 */     // (mul:{ *:[i32] } i32:{ *:[i32] }:$RA, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$D)  =>  (MULLI:{ *:[i32] } i32:{ *:[i32] }:$RA, (imm:{ *:[i32] }):$D)
     /*   1884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MULLI),
     /*   1887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*   1889 */     GIR_RootToRootCopy, /*OpIdx*/1, // RA
     /*   1891 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // D
     /*   1894 */     GIR_RootConstrainSelectedInstOperands,
     /*   1895 */     // GIR_Coverage, 111,
     /*   1895 */     GIR_EraseRootFromParent_Done,
     /*   1896 */   // Label 144: @1896
     /*   1896 */   GIM_Try, /*On fail goto*//*Label 145*/ GIMT_Encode4(1908), // Rule ID 208 //
     /*   1901 */     // (mul:{ *:[i32] } i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)  =>  (MULLW:{ *:[i32] } i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)
     /*   1901 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::MULLW),
     /*   1906 */     GIR_RootConstrainSelectedInstOperands,
     /*   1907 */     // GIR_Coverage, 208,
     /*   1907 */     GIR_Done,
     /*   1908 */   // Label 145: @1908
     /*   1908 */   GIM_Reject,
     /*   1909 */ // Label 143: @1909
     /*   1909 */ GIM_Reject,
     /*   1910 */ // Label 137: @1910
     /*   1910 */ GIM_Try, /*On fail goto*//*Label 146*/ GIMT_Encode4(1969),
     /*   1915 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   1918 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   1921 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*   1925 */   GIM_Try, /*On fail goto*//*Label 147*/ GIMT_Encode4(1956), // Rule ID 702 //
     /*   1930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   1938 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /*   1942 */     // MIs[1] Operand 1
     /*   1942 */     // No operand predicates
     /*   1942 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1944 */     // (mul:{ *:[i64] } i64:{ *:[i64] }:$RA, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$D)  =>  (MULLI8:{ *:[i64] } i64:{ *:[i64] }:$RA, (imm:{ *:[i64] }):$D)
     /*   1944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MULLI8),
     /*   1947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*   1949 */     GIR_RootToRootCopy, /*OpIdx*/1, // RA
     /*   1951 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // D
     /*   1954 */     GIR_RootConstrainSelectedInstOperands,
     /*   1955 */     // GIR_Coverage, 702,
     /*   1955 */     GIR_EraseRootFromParent_Done,
     /*   1956 */   // Label 147: @1956
     /*   1956 */   GIM_Try, /*On fail goto*//*Label 148*/ GIMT_Encode4(1968), // Rule ID 701 //
     /*   1961 */     // (mul:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)  =>  (MULLD:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)
     /*   1961 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::MULLD),
     /*   1966 */     GIR_RootConstrainSelectedInstOperands,
     /*   1967 */     // GIR_Coverage, 701,
     /*   1967 */     GIR_Done,
     /*   1968 */   // Label 148: @1968
     /*   1968 */   GIM_Reject,
     /*   1969 */ // Label 146: @1969
     /*   1969 */ GIM_Reject,
     /*   1970 */ // Label 138: @1970
     /*   1970 */ GIM_Try, /*On fail goto*//*Label 149*/ GIMT_Encode4(1995), // Rule ID 1120 //
     /*   1975 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*   1978 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   1981 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*   1984 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   1988 */   // (mul:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VMULLD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*   1988 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMULLD),
     /*   1993 */   GIR_RootConstrainSelectedInstOperands,
     /*   1994 */   // GIR_Coverage, 1120,
     /*   1994 */   GIR_Done,
     /*   1995 */ // Label 149: @1995
     /*   1995 */ GIM_Reject,
     /*   1996 */ // Label 139: @1996
     /*   1996 */ GIM_Try, /*On fail goto*//*Label 150*/ GIMT_Encode4(2021), // Rule ID 461 //
     /*   2001 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*   2004 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   2007 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   2010 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   2014 */   // (mul:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VMULUWM:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*   2014 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMULUWM),
     /*   2019 */   GIR_RootConstrainSelectedInstOperands,
     /*   2020 */   // GIR_Coverage, 461,
     /*   2020 */   GIR_Done,
     /*   2021 */ // Label 150: @2021
     /*   2021 */ GIM_Reject,
     /*   2022 */ // Label 140: @2022
     /*   2022 */ GIM_Try, /*On fail goto*//*Label 151*/ GIMT_Encode4(2068), // Rule ID 1289 //
     /*   2027 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*   2030 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   2033 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   2036 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   2040 */   // (mul:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$vA, v8i16:{ *:[v8i16] }:$vB)  =>  (VMLADDUHM:{ *:[v8i16] } ?:{ *:[v8i16] }:$vA, ?:{ *:[v8i16] }:$vB, (V_SET0H:{ *:[v8i16] }))
     /*   2040 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*   2043 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::V_SET0H),
     /*   2047 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   2052 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   2054 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMLADDUHM),
     /*   2057 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*   2059 */   GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*   2061 */   GIR_RootToRootCopy, /*OpIdx*/2, // vB
     /*   2063 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   2066 */   GIR_RootConstrainSelectedInstOperands,
     /*   2067 */   // GIR_Coverage, 1289,
     /*   2067 */   GIR_EraseRootFromParent_Done,
     /*   2068 */ // Label 151: @2068
     /*   2068 */ GIM_Reject,
     /*   2069 */ // Label 141: @2069
     /*   2069 */ GIM_Reject,
     /*   2070 */ // Label 3: @2070
     /*   2070 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 157*/ GIMT_Encode4(2225),
     /*   2081 */ /*GILLT_s32*//*Label 152*/ GIMT_Encode4(2101),
     /*   2085 */ /*GILLT_s64*//*Label 153*/ GIMT_Encode4(2124),
     /*   2089 */ /*GILLT_s128*//*Label 154*/ GIMT_Encode4(2147),
     /*   2093 */ /*GILLT_v2s64*//*Label 155*/ GIMT_Encode4(2173),
     /*   2097 */ /*GILLT_v4s32*//*Label 156*/ GIMT_Encode4(2199),
     /*   2101 */ // Label 152: @2101
     /*   2101 */ GIM_Try, /*On fail goto*//*Label 158*/ GIMT_Encode4(2123), // Rule ID 202 //
     /*   2106 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   2109 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   2112 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*   2116 */   // (sdiv:{ *:[i32] } i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)  =>  (DIVW:{ *:[i32] } i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)
     /*   2116 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::DIVW),
     /*   2121 */   GIR_RootConstrainSelectedInstOperands,
     /*   2122 */   // GIR_Coverage, 202,
     /*   2122 */   GIR_Done,
     /*   2123 */ // Label 158: @2123
     /*   2123 */ GIM_Reject,
     /*   2124 */ // Label 153: @2124
     /*   2124 */ GIM_Try, /*On fail goto*//*Label 159*/ GIMT_Encode4(2146), // Rule ID 693 //
     /*   2129 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   2132 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   2135 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*   2139 */   // (sdiv:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)  =>  (DIVD:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)
     /*   2139 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::DIVD),
     /*   2144 */   GIR_RootConstrainSelectedInstOperands,
     /*   2145 */   // GIR_Coverage, 693,
     /*   2145 */   GIR_Done,
     /*   2146 */ // Label 159: @2146
     /*   2146 */ GIM_Reject,
     /*   2147 */ // Label 154: @2147
     /*   2147 */ GIM_Try, /*On fail goto*//*Label 160*/ GIMT_Encode4(2172), // Rule ID 1144 //
     /*   2152 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*   2155 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*   2158 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*   2161 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   2165 */   // (sdiv:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)  =>  (VDIVSQ:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)
     /*   2165 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VDIVSQ),
     /*   2170 */   GIR_RootConstrainSelectedInstOperands,
     /*   2171 */   // GIR_Coverage, 1144,
     /*   2171 */   GIR_Done,
     /*   2172 */ // Label 160: @2172
     /*   2172 */ GIM_Reject,
     /*   2173 */ // Label 155: @2173
     /*   2173 */ GIM_Try, /*On fail goto*//*Label 161*/ GIMT_Encode4(2198), // Rule ID 1131 //
     /*   2178 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*   2181 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   2184 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*   2187 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   2191 */   // (sdiv:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VDIVSD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*   2191 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VDIVSD),
     /*   2196 */   GIR_RootConstrainSelectedInstOperands,
     /*   2197 */   // GIR_Coverage, 1131,
     /*   2197 */   GIR_Done,
     /*   2198 */ // Label 161: @2198
     /*   2198 */ GIM_Reject,
     /*   2199 */ // Label 156: @2199
     /*   2199 */ GIM_Try, /*On fail goto*//*Label 162*/ GIMT_Encode4(2224), // Rule ID 1129 //
     /*   2204 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*   2207 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   2210 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   2213 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   2217 */   // (sdiv:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VDIVSW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*   2217 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VDIVSW),
     /*   2222 */   GIR_RootConstrainSelectedInstOperands,
     /*   2223 */   // GIR_Coverage, 1129,
     /*   2223 */   GIR_Done,
     /*   2224 */ // Label 162: @2224
     /*   2224 */ GIM_Reject,
     /*   2225 */ // Label 157: @2225
     /*   2225 */ GIM_Reject,
     /*   2226 */ // Label 4: @2226
     /*   2226 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 168*/ GIMT_Encode4(2381),
     /*   2237 */ /*GILLT_s32*//*Label 163*/ GIMT_Encode4(2257),
     /*   2241 */ /*GILLT_s64*//*Label 164*/ GIMT_Encode4(2280),
     /*   2245 */ /*GILLT_s128*//*Label 165*/ GIMT_Encode4(2303),
     /*   2249 */ /*GILLT_v2s64*//*Label 166*/ GIMT_Encode4(2329),
     /*   2253 */ /*GILLT_v4s32*//*Label 167*/ GIMT_Encode4(2355),
     /*   2257 */ // Label 163: @2257
     /*   2257 */ GIM_Try, /*On fail goto*//*Label 169*/ GIMT_Encode4(2279), // Rule ID 203 //
     /*   2262 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   2265 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   2268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*   2272 */   // (udiv:{ *:[i32] } i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)  =>  (DIVWU:{ *:[i32] } i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)
     /*   2272 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::DIVWU),
     /*   2277 */   GIR_RootConstrainSelectedInstOperands,
     /*   2278 */   // GIR_Coverage, 203,
     /*   2278 */   GIR_Done,
     /*   2279 */ // Label 169: @2279
     /*   2279 */ GIM_Reject,
     /*   2280 */ // Label 164: @2280
     /*   2280 */ GIM_Try, /*On fail goto*//*Label 170*/ GIMT_Encode4(2302), // Rule ID 694 //
     /*   2285 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   2288 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   2291 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*   2295 */   // (udiv:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)  =>  (DIVDU:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)
     /*   2295 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::DIVDU),
     /*   2300 */   GIR_RootConstrainSelectedInstOperands,
     /*   2301 */   // GIR_Coverage, 694,
     /*   2301 */   GIR_Done,
     /*   2302 */ // Label 170: @2302
     /*   2302 */ GIM_Reject,
     /*   2303 */ // Label 165: @2303
     /*   2303 */ GIM_Try, /*On fail goto*//*Label 171*/ GIMT_Encode4(2328), // Rule ID 1145 //
     /*   2308 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*   2311 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*   2314 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*   2317 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   2321 */   // (udiv:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)  =>  (VDIVUQ:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)
     /*   2321 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VDIVUQ),
     /*   2326 */   GIR_RootConstrainSelectedInstOperands,
     /*   2327 */   // GIR_Coverage, 1145,
     /*   2327 */   GIR_Done,
     /*   2328 */ // Label 171: @2328
     /*   2328 */ GIM_Reject,
     /*   2329 */ // Label 166: @2329
     /*   2329 */ GIM_Try, /*On fail goto*//*Label 172*/ GIMT_Encode4(2354), // Rule ID 1132 //
     /*   2334 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*   2337 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   2340 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*   2343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   2347 */   // (udiv:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VDIVUD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*   2347 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VDIVUD),
     /*   2352 */   GIR_RootConstrainSelectedInstOperands,
     /*   2353 */   // GIR_Coverage, 1132,
     /*   2353 */   GIR_Done,
     /*   2354 */ // Label 172: @2354
     /*   2354 */ GIM_Reject,
     /*   2355 */ // Label 167: @2355
     /*   2355 */ GIM_Try, /*On fail goto*//*Label 173*/ GIMT_Encode4(2380), // Rule ID 1130 //
     /*   2360 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*   2363 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   2366 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   2369 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   2373 */   // (udiv:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VDIVUW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*   2373 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VDIVUW),
     /*   2378 */   GIR_RootConstrainSelectedInstOperands,
     /*   2379 */   // GIR_Coverage, 1130,
     /*   2379 */   GIR_Done,
     /*   2380 */ // Label 173: @2380
     /*   2380 */ GIM_Reject,
     /*   2381 */ // Label 168: @2381
     /*   2381 */ GIM_Reject,
     /*   2382 */ // Label 5: @2382
     /*   2382 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 179*/ GIMT_Encode4(2543),
     /*   2393 */ /*GILLT_s32*//*Label 174*/ GIMT_Encode4(2413),
     /*   2397 */ /*GILLT_s64*//*Label 175*/ GIMT_Encode4(2439),
     /*   2401 */ /*GILLT_s128*//*Label 176*/ GIMT_Encode4(2465),
     /*   2405 */ /*GILLT_v2s64*//*Label 177*/ GIMT_Encode4(2491),
     /*   2409 */ /*GILLT_v4s32*//*Label 178*/ GIMT_Encode4(2517),
     /*   2413 */ // Label 174: @2413
     /*   2413 */ GIM_Try, /*On fail goto*//*Label 180*/ GIMT_Encode4(2438), // Rule ID 197 //
     /*   2418 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_0),
     /*   2421 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   2424 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   2427 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*   2431 */   // (srem:{ *:[i32] } i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)  =>  (MODSW:{ *:[i32] } i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)
     /*   2431 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::MODSW),
     /*   2436 */   GIR_RootConstrainSelectedInstOperands,
     /*   2437 */   // GIR_Coverage, 197,
     /*   2437 */   GIR_Done,
     /*   2438 */ // Label 180: @2438
     /*   2438 */ GIM_Reject,
     /*   2439 */ // Label 175: @2439
     /*   2439 */ GIM_Try, /*On fail goto*//*Label 181*/ GIMT_Encode4(2464), // Rule ID 698 //
     /*   2444 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_0),
     /*   2447 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   2450 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   2453 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*   2457 */   // (srem:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)  =>  (MODSD:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)
     /*   2457 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::MODSD),
     /*   2462 */   GIR_RootConstrainSelectedInstOperands,
     /*   2463 */   // GIR_Coverage, 698,
     /*   2463 */   GIR_Done,
     /*   2464 */ // Label 181: @2464
     /*   2464 */ GIM_Reject,
     /*   2465 */ // Label 176: @2465
     /*   2465 */ GIM_Try, /*On fail goto*//*Label 182*/ GIMT_Encode4(2490), // Rule ID 1154 //
     /*   2470 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*   2473 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*   2476 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*   2479 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   2483 */   // (srem:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)  =>  (VMODSQ:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)
     /*   2483 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMODSQ),
     /*   2488 */   GIR_RootConstrainSelectedInstOperands,
     /*   2489 */   // GIR_Coverage, 1154,
     /*   2489 */   GIR_Done,
     /*   2490 */ // Label 182: @2490
     /*   2490 */ GIM_Reject,
     /*   2491 */ // Label 177: @2491
     /*   2491 */ GIM_Try, /*On fail goto*//*Label 183*/ GIMT_Encode4(2516), // Rule ID 1127 //
     /*   2496 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*   2499 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   2502 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*   2505 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   2509 */   // (srem:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VMODSD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*   2509 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMODSD),
     /*   2514 */   GIR_RootConstrainSelectedInstOperands,
     /*   2515 */   // GIR_Coverage, 1127,
     /*   2515 */   GIR_Done,
     /*   2516 */ // Label 183: @2516
     /*   2516 */ GIM_Reject,
     /*   2517 */ // Label 178: @2517
     /*   2517 */ GIM_Try, /*On fail goto*//*Label 184*/ GIMT_Encode4(2542), // Rule ID 1125 //
     /*   2522 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*   2525 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   2528 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   2531 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   2535 */   // (srem:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VMODSW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*   2535 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMODSW),
     /*   2540 */   GIR_RootConstrainSelectedInstOperands,
     /*   2541 */   // GIR_Coverage, 1125,
     /*   2541 */   GIR_Done,
     /*   2542 */ // Label 184: @2542
     /*   2542 */ GIM_Reject,
     /*   2543 */ // Label 179: @2543
     /*   2543 */ GIM_Reject,
     /*   2544 */ // Label 6: @2544
     /*   2544 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 190*/ GIMT_Encode4(2705),
     /*   2555 */ /*GILLT_s32*//*Label 185*/ GIMT_Encode4(2575),
     /*   2559 */ /*GILLT_s64*//*Label 186*/ GIMT_Encode4(2601),
     /*   2563 */ /*GILLT_s128*//*Label 187*/ GIMT_Encode4(2627),
     /*   2567 */ /*GILLT_v2s64*//*Label 188*/ GIMT_Encode4(2653),
     /*   2571 */ /*GILLT_v4s32*//*Label 189*/ GIMT_Encode4(2679),
     /*   2575 */ // Label 185: @2575
     /*   2575 */ GIM_Try, /*On fail goto*//*Label 191*/ GIMT_Encode4(2600), // Rule ID 198 //
     /*   2580 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_0),
     /*   2583 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   2586 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   2589 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*   2593 */   // (urem:{ *:[i32] } i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)  =>  (MODUW:{ *:[i32] } i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)
     /*   2593 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::MODUW),
     /*   2598 */   GIR_RootConstrainSelectedInstOperands,
     /*   2599 */   // GIR_Coverage, 198,
     /*   2599 */   GIR_Done,
     /*   2600 */ // Label 191: @2600
     /*   2600 */ GIM_Reject,
     /*   2601 */ // Label 186: @2601
     /*   2601 */ GIM_Try, /*On fail goto*//*Label 192*/ GIMT_Encode4(2626), // Rule ID 699 //
     /*   2606 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_0),
     /*   2609 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   2612 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   2615 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*   2619 */   // (urem:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)  =>  (MODUD:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)
     /*   2619 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::MODUD),
     /*   2624 */   GIR_RootConstrainSelectedInstOperands,
     /*   2625 */   // GIR_Coverage, 699,
     /*   2625 */   GIR_Done,
     /*   2626 */ // Label 192: @2626
     /*   2626 */ GIM_Reject,
     /*   2627 */ // Label 187: @2627
     /*   2627 */ GIM_Try, /*On fail goto*//*Label 193*/ GIMT_Encode4(2652), // Rule ID 1155 //
     /*   2632 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*   2635 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*   2638 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*   2641 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   2645 */   // (urem:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)  =>  (VMODUQ:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)
     /*   2645 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMODUQ),
     /*   2650 */   GIR_RootConstrainSelectedInstOperands,
     /*   2651 */   // GIR_Coverage, 1155,
     /*   2651 */   GIR_Done,
     /*   2652 */ // Label 193: @2652
     /*   2652 */ GIM_Reject,
     /*   2653 */ // Label 188: @2653
     /*   2653 */ GIM_Try, /*On fail goto*//*Label 194*/ GIMT_Encode4(2678), // Rule ID 1128 //
     /*   2658 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*   2661 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   2664 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*   2667 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   2671 */   // (urem:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VMODUD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*   2671 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMODUD),
     /*   2676 */   GIR_RootConstrainSelectedInstOperands,
     /*   2677 */   // GIR_Coverage, 1128,
     /*   2677 */   GIR_Done,
     /*   2678 */ // Label 194: @2678
     /*   2678 */ GIM_Reject,
     /*   2679 */ // Label 189: @2679
     /*   2679 */ GIM_Try, /*On fail goto*//*Label 195*/ GIMT_Encode4(2704), // Rule ID 1126 //
     /*   2684 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*   2687 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   2690 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   2693 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   2697 */   // (urem:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VMODUW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*   2697 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMODUW),
     /*   2702 */   GIR_RootConstrainSelectedInstOperands,
     /*   2703 */   // GIR_Coverage, 1126,
     /*   2703 */   GIR_Done,
     /*   2704 */ // Label 195: @2704
     /*   2704 */ GIM_Reject,
     /*   2705 */ // Label 190: @2705
     /*   2705 */ GIM_Reject,
     /*   2706 */ // Label 7: @2706
     /*   2706 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(6), /*)*//*default:*//*Label 200*/ GIMT_Encode4(5266),
     /*   2717 */ /*GILLT_s1*//*Label 196*/ GIMT_Encode4(2741),
     /*   2721 */ /*GILLT_s32*//*Label 197*/ GIMT_Encode4(2850),
     /*   2725 */ /*GILLT_s64*//*Label 198*/ GIMT_Encode4(2959), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   2737 */ /*GILLT_v4s32*//*Label 199*/ GIMT_Encode4(3068),
     /*   2741 */ // Label 196: @2741
     /*   2741 */ GIM_Try, /*On fail goto*//*Label 201*/ GIMT_Encode4(2849),
     /*   2746 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /*   2749 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s1,
     /*   2752 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*   2756 */   GIM_Try, /*On fail goto*//*Label 202*/ GIMT_Encode4(2796), // Rule ID 4877 //
     /*   2761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   2769 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /*   2773 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /*   2777 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*   2781 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   2783 */     // (and:{ *:[i1] } (xor:{ *:[i1] } i1:{ *:[i1] }:$CRB, -1:{ *:[i1] }), i1:{ *:[i1] }:$CRA)  =>  (CRANDC:{ *:[i1] } i1:{ *:[i1] }:$CRA, i1:{ *:[i1] }:$CRB)
     /*   2783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRANDC),
     /*   2786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /*   2788 */     GIR_RootToRootCopy, /*OpIdx*/2, // CRA
     /*   2790 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // CRB
     /*   2794 */     GIR_RootConstrainSelectedInstOperands,
     /*   2795 */     // GIR_Coverage, 4877,
     /*   2795 */     GIR_EraseRootFromParent_Done,
     /*   2796 */   // Label 202: @2796
     /*   2796 */   GIM_Try, /*On fail goto*//*Label 203*/ GIMT_Encode4(2836), // Rule ID 182 //
     /*   2801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   2805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   2809 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /*   2813 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /*   2817 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*   2821 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   2823 */     // (and:{ *:[i1] } i1:{ *:[i1] }:$CRA, (xor:{ *:[i1] } i1:{ *:[i1] }:$CRB, -1:{ *:[i1] }))  =>  (CRANDC:{ *:[i1] } i1:{ *:[i1] }:$CRA, i1:{ *:[i1] }:$CRB)
     /*   2823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRANDC),
     /*   2826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /*   2828 */     GIR_RootToRootCopy, /*OpIdx*/1, // CRA
     /*   2830 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // CRB
     /*   2834 */     GIR_RootConstrainSelectedInstOperands,
     /*   2835 */     // GIR_Coverage, 182,
     /*   2835 */     GIR_EraseRootFromParent_Done,
     /*   2836 */   // Label 203: @2836
     /*   2836 */   GIM_Try, /*On fail goto*//*Label 204*/ GIMT_Encode4(2848), // Rule ID 175 //
     /*   2841 */     // (and:{ *:[i1] } i1:{ *:[i1] }:$CRA, i1:{ *:[i1] }:$CRB)  =>  (CRAND:{ *:[i1] } i1:{ *:[i1] }:$CRA, i1:{ *:[i1] }:$CRB)
     /*   2841 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::CRAND),
     /*   2846 */     GIR_RootConstrainSelectedInstOperands,
     /*   2847 */     // GIR_Coverage, 175,
     /*   2847 */     GIR_Done,
     /*   2848 */   // Label 204: @2848
     /*   2848 */   GIM_Reject,
     /*   2849 */ // Label 201: @2849
     /*   2849 */ GIM_Reject,
     /*   2850 */ // Label 197: @2850
     /*   2850 */ GIM_Try, /*On fail goto*//*Label 205*/ GIMT_Encode4(2958),
     /*   2855 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   2858 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   2861 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*   2865 */   GIM_Try, /*On fail goto*//*Label 206*/ GIMT_Encode4(2905), // Rule ID 4871 //
     /*   2870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   2878 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2882 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   2886 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*   2890 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   2892 */     // (and:{ *:[i32] } (xor:{ *:[i32] } i32:{ *:[i32] }:$RB, -1:{ *:[i32] }), i32:{ *:[i32] }:$RST)  =>  (ANDC:{ *:[i32] } i32:{ *:[i32] }:$RST, i32:{ *:[i32] }:$RB)
     /*   2892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::ANDC),
     /*   2895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*   2897 */     GIR_RootToRootCopy, /*OpIdx*/2, // RST
     /*   2899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RB
     /*   2903 */     GIR_RootConstrainSelectedInstOperands,
     /*   2904 */     // GIR_Coverage, 4871,
     /*   2904 */     GIR_EraseRootFromParent_Done,
     /*   2905 */   // Label 206: @2905
     /*   2905 */   GIM_Try, /*On fail goto*//*Label 207*/ GIMT_Encode4(2945), // Rule ID 123 //
     /*   2910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   2914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   2918 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2922 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   2926 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*   2930 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   2932 */     // (and:{ *:[i32] } i32:{ *:[i32] }:$RST, (xor:{ *:[i32] } i32:{ *:[i32] }:$RB, -1:{ *:[i32] }))  =>  (ANDC:{ *:[i32] } i32:{ *:[i32] }:$RST, i32:{ *:[i32] }:$RB)
     /*   2932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::ANDC),
     /*   2935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*   2937 */     GIR_RootToRootCopy, /*OpIdx*/1, // RST
     /*   2939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RB
     /*   2943 */     GIR_RootConstrainSelectedInstOperands,
     /*   2944 */     // GIR_Coverage, 123,
     /*   2944 */     GIR_EraseRootFromParent_Done,
     /*   2945 */   // Label 207: @2945
     /*   2945 */   GIM_Try, /*On fail goto*//*Label 208*/ GIMT_Encode4(2957), // Rule ID 122 //
     /*   2950 */     // (and:{ *:[i32] } i32:{ *:[i32] }:$RST, i32:{ *:[i32] }:$RB)  =>  (AND:{ *:[i32] } i32:{ *:[i32] }:$RST, i32:{ *:[i32] }:$RB)
     /*   2950 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::AND),
     /*   2955 */     GIR_RootConstrainSelectedInstOperands,
     /*   2956 */     // GIR_Coverage, 122,
     /*   2956 */     GIR_Done,
     /*   2957 */   // Label 208: @2957
     /*   2957 */   GIM_Reject,
     /*   2958 */ // Label 205: @2958
     /*   2958 */ GIM_Reject,
     /*   2959 */ // Label 198: @2959
     /*   2959 */ GIM_Try, /*On fail goto*//*Label 209*/ GIMT_Encode4(3067),
     /*   2964 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   2967 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   2970 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*   2974 */   GIM_Try, /*On fail goto*//*Label 210*/ GIMT_Encode4(3014), // Rule ID 4884 //
     /*   2979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   2987 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   2991 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   2995 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*   2999 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   3001 */     // (and:{ *:[i64] } (xor:{ *:[i64] } i64:{ *:[i64] }:$RB, -1:{ *:[i64] }), i64:{ *:[i64] }:$RST)  =>  (ANDC8:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)
     /*   3001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::ANDC8),
     /*   3004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*   3006 */     GIR_RootToRootCopy, /*OpIdx*/2, // RST
     /*   3008 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RB
     /*   3012 */     GIR_RootConstrainSelectedInstOperands,
     /*   3013 */     // GIR_Coverage, 4884,
     /*   3013 */     GIR_EraseRootFromParent_Done,
     /*   3014 */   // Label 210: @3014
     /*   3014 */   GIM_Try, /*On fail goto*//*Label 211*/ GIMT_Encode4(3054), // Rule ID 643 //
     /*   3019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   3027 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   3031 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   3035 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*   3039 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   3041 */     // (and:{ *:[i64] } i64:{ *:[i64] }:$RST, (xor:{ *:[i64] } i64:{ *:[i64] }:$RB, -1:{ *:[i64] }))  =>  (ANDC8:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)
     /*   3041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::ANDC8),
     /*   3044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*   3046 */     GIR_RootToRootCopy, /*OpIdx*/1, // RST
     /*   3048 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RB
     /*   3052 */     GIR_RootConstrainSelectedInstOperands,
     /*   3053 */     // GIR_Coverage, 643,
     /*   3053 */     GIR_EraseRootFromParent_Done,
     /*   3054 */   // Label 211: @3054
     /*   3054 */   GIM_Try, /*On fail goto*//*Label 212*/ GIMT_Encode4(3066), // Rule ID 642 //
     /*   3059 */     // (and:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)  =>  (AND8:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)
     /*   3059 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /*   3064 */     GIR_RootConstrainSelectedInstOperands,
     /*   3065 */     // GIR_Coverage, 642,
     /*   3065 */     GIR_Done,
     /*   3066 */   // Label 212: @3066
     /*   3066 */   GIM_Reject,
     /*   3067 */ // Label 209: @3067
     /*   3067 */ GIM_Reject,
     /*   3068 */ // Label 199: @3068
     /*   3068 */ GIM_Try, /*On fail goto*//*Label 213*/ GIMT_Encode4(5265),
     /*   3073 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3076 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3079 */   GIM_Try, /*On fail goto*//*Label 214*/ GIMT_Encode4(3157), // Rule ID 5232 //
     /*   3084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   3087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   3091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   3099 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3103 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3107 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3111 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   3115 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3119 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3123 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*   3127 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   3133 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*   3135 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3137 */     // (and:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 16:{ *:[i32] })
     /*   3137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   3140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   3142 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   3146 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*   3150 */     GIR_RootToRootCopy, /*OpIdx*/2, // vC
     /*   3152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*   3155 */     GIR_RootConstrainSelectedInstOperands,
     /*   3156 */     // GIR_Coverage, 5232,
     /*   3156 */     GIR_EraseRootFromParent_Done,
     /*   3157 */   // Label 214: @3157
     /*   3157 */   GIM_Try, /*On fail goto*//*Label 215*/ GIMT_Encode4(3235), // Rule ID 5233 //
     /*   3162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   3165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   3169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   3177 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3181 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3185 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   3189 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   3193 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3197 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3201 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*   3205 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   3211 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*   3213 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3215 */     // (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] })), v4i32:{ *:[v4i32] }:$vC)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 16:{ *:[i32] })
     /*   3215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   3218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   3220 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   3224 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*   3228 */     GIR_RootToRootCopy, /*OpIdx*/2, // vC
     /*   3230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*   3233 */     GIR_RootConstrainSelectedInstOperands,
     /*   3234 */     // GIR_Coverage, 5233,
     /*   3234 */     GIR_EraseRootFromParent_Done,
     /*   3235 */   // Label 215: @3235
     /*   3235 */   GIM_Try, /*On fail goto*//*Label 216*/ GIMT_Encode4(3315), // Rule ID 5234 //
     /*   3240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   3243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   3247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   3255 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3259 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3263 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   3267 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   3271 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3275 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3279 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*   3283 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   3289 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*   3291 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3293 */     // (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 16:{ *:[i32] })
     /*   3293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   3296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   3298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   3302 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*   3306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   3310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*   3313 */     GIR_RootConstrainSelectedInstOperands,
     /*   3314 */     // GIR_Coverage, 5234,
     /*   3314 */     GIR_EraseRootFromParent_Done,
     /*   3315 */   // Label 216: @3315
     /*   3315 */   GIM_Try, /*On fail goto*//*Label 217*/ GIMT_Encode4(3395), // Rule ID 5237 //
     /*   3320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   3323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   3327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*   3335 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3339 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3343 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   3347 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   3351 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3355 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3359 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*   3363 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   3369 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*   3371 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3373 */     // (and:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 112:{ *:[i32] })
     /*   3373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   3376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   3378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   3382 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*   3386 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   3390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/112,
     /*   3393 */     GIR_RootConstrainSelectedInstOperands,
     /*   3394 */     // GIR_Coverage, 5237,
     /*   3394 */     GIR_EraseRootFromParent_Done,
     /*   3395 */   // Label 217: @3395
     /*   3395 */   GIM_Try, /*On fail goto*//*Label 218*/ GIMT_Encode4(3473), // Rule ID 4921 //
     /*   3400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   3403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   3407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   3415 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3419 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3423 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3427 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   3431 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3435 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3439 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   3443 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   3449 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*   3451 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3453 */     // (and:{ *:[v4i32] } (xor:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$vA)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 14:{ *:[i32] })
     /*   3453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   3456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   3458 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*   3460 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   3464 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*   3468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3471 */     GIR_RootConstrainSelectedInstOperands,
     /*   3472 */     // GIR_Coverage, 4921,
     /*   3472 */     GIR_EraseRootFromParent_Done,
     /*   3473 */   // Label 218: @3473
     /*   3473 */   GIM_Try, /*On fail goto*//*Label 219*/ GIMT_Encode4(3551), // Rule ID 4915 //
     /*   3478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   3481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   3485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   3493 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3497 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3501 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3505 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*   3509 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3513 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3517 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   3521 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   3527 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*   3529 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3531 */     // (and:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$vA)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 8:{ *:[i32] })
     /*   3531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   3534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   3536 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*   3538 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   3542 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*   3546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*   3549 */     GIR_RootConstrainSelectedInstOperands,
     /*   3550 */     // GIR_Coverage, 4915,
     /*   3550 */     GIR_EraseRootFromParent_Done,
     /*   3551 */   // Label 219: @3551
     /*   3551 */   GIM_Try, /*On fail goto*//*Label 220*/ GIMT_Encode4(3629), // Rule ID 4919 //
     /*   3556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   3559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   3563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   3571 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3575 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3579 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3583 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   3587 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3591 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3595 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*   3599 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   3605 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*   3607 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3609 */     // (and:{ *:[v4i32] } (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 9:{ *:[i32] })
     /*   3609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   3612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   3614 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*   3616 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   3620 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   3624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /*   3627 */     GIR_RootConstrainSelectedInstOperands,
     /*   3628 */     // GIR_Coverage, 4919,
     /*   3628 */     GIR_EraseRootFromParent_Done,
     /*   3629 */   // Label 220: @3629
     /*   3629 */   GIM_Try, /*On fail goto*//*Label 221*/ GIMT_Encode4(3707), // Rule ID 4918 //
     /*   3634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   3637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   3641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   3649 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3653 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3657 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3661 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   3665 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3669 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3673 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   3677 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   3683 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*   3685 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3687 */     // (and:{ *:[v4i32] } (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$vA)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 9:{ *:[i32] })
     /*   3687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   3690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   3692 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*   3694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   3698 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*   3702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /*   3705 */     GIR_RootConstrainSelectedInstOperands,
     /*   3706 */     // GIR_Coverage, 4918,
     /*   3706 */     GIR_EraseRootFromParent_Done,
     /*   3707 */   // Label 221: @3707
     /*   3707 */   GIM_Try, /*On fail goto*//*Label 222*/ GIMT_Encode4(3785), // Rule ID 4920 //
     /*   3712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   3715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   3719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   3727 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3731 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3735 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   3739 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   3743 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3747 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3751 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*   3755 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   3761 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*   3763 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3765 */     // (and:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, immAllOnesV:{ *:[v4i32] })), v4i32:{ *:[v4i32] }:$vA)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 9:{ *:[i32] })
     /*   3765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   3768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   3770 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*   3772 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   3776 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*   3780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /*   3783 */     GIR_RootConstrainSelectedInstOperands,
     /*   3784 */     // GIR_Coverage, 4920,
     /*   3784 */     GIR_EraseRootFromParent_Done,
     /*   3785 */   // Label 222: @3785
     /*   3785 */   GIM_Try, /*On fail goto*//*Label 223*/ GIMT_Encode4(3865), // Rule ID 3394 //
     /*   3790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   3793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   3797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   3805 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3809 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3813 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   3817 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   3823 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*   3825 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   3829 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*   3833 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3837 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3841 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3843 */     // (and:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 16:{ *:[i32] })
     /*   3843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   3846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   3848 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*   3852 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*   3856 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*   3860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*   3863 */     GIR_RootConstrainSelectedInstOperands,
     /*   3864 */     // GIR_Coverage, 3394,
     /*   3864 */     GIR_EraseRootFromParent_Done,
     /*   3865 */   // Label 223: @3865
     /*   3865 */   GIM_Try, /*On fail goto*//*Label 224*/ GIMT_Encode4(3945), // Rule ID 3395 //
     /*   3870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   3873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   3877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   3885 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3889 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3893 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   3897 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   3903 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*   3905 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   3909 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*   3913 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3917 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3921 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3923 */     // (and:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }), (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 112:{ *:[i32] })
     /*   3923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   3926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   3928 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*   3932 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*   3936 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*   3940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/112,
     /*   3943 */     GIR_RootConstrainSelectedInstOperands,
     /*   3944 */     // GIR_Coverage, 3395,
     /*   3944 */     GIR_EraseRootFromParent_Done,
     /*   3945 */   // Label 224: @3945
     /*   3945 */   GIM_Try, /*On fail goto*//*Label 225*/ GIMT_Encode4(4025), // Rule ID 3393 //
     /*   3950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   3953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   3957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   3965 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3969 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3973 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   3977 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   3983 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*   3985 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   3989 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   3993 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3997 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4001 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   4003 */     // (and:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }), (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 96:{ *:[i32] })
     /*   4003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   4006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   4008 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*   4012 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*   4016 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*   4020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/96,
     /*   4023 */     GIR_RootConstrainSelectedInstOperands,
     /*   4024 */     // GIR_Coverage, 3393,
     /*   4024 */     GIR_EraseRootFromParent_Done,
     /*   4025 */   // Label 225: @4025
     /*   4025 */   GIM_Try, /*On fail goto*//*Label 226*/ GIMT_Encode4(4105), // Rule ID 5231 //
     /*   4030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   4033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   4037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   4045 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4049 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4053 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   4057 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   4061 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4065 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4069 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*   4073 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   4079 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*   4081 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   4083 */     // (and:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 96:{ *:[i32] })
     /*   4083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   4086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   4088 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   4092 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*   4096 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   4100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/96,
     /*   4103 */     GIR_RootConstrainSelectedInstOperands,
     /*   4104 */     // GIR_Coverage, 5231,
     /*   4104 */     GIR_EraseRootFromParent_Done,
     /*   4105 */   // Label 226: @4105
     /*   4105 */   GIM_Try, /*On fail goto*//*Label 227*/ GIMT_Encode4(4183), // Rule ID 5235 //
     /*   4110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   4113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   4117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   4125 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4129 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4133 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4137 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   4141 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4145 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4149 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*   4153 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   4159 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*   4161 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   4163 */     // (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 16:{ *:[i32] })
     /*   4163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   4166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   4168 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   4172 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*   4176 */     GIR_RootToRootCopy, /*OpIdx*/1, // vC
     /*   4178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*   4181 */     GIR_RootConstrainSelectedInstOperands,
     /*   4182 */     // GIR_Coverage, 5235,
     /*   4182 */     GIR_EraseRootFromParent_Done,
     /*   4183 */   // Label 227: @4183
     /*   4183 */   GIM_Try, /*On fail goto*//*Label 228*/ GIMT_Encode4(4261), // Rule ID 5236 //
     /*   4188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   4191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   4195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   4203 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4207 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4211 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   4215 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   4219 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4223 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4227 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*   4231 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   4237 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*   4239 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   4241 */     // (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] })))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 16:{ *:[i32] })
     /*   4241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   4244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   4246 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   4250 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*   4254 */     GIR_RootToRootCopy, /*OpIdx*/1, // vC
     /*   4256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*   4259 */     GIR_RootConstrainSelectedInstOperands,
     /*   4260 */     // GIR_Coverage, 5236,
     /*   4260 */     GIR_EraseRootFromParent_Done,
     /*   4261 */   // Label 228: @4261
     /*   4261 */   GIM_Try, /*On fail goto*//*Label 229*/ GIMT_Encode4(4339), // Rule ID 3381 //
     /*   4266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   4269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   4273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   4281 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4285 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4289 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4293 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   4297 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4301 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4305 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   4309 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   4315 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*   4317 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   4319 */     // (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (xor:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 14:{ *:[i32] })
     /*   4319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   4322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   4324 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*   4326 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   4330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*   4334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   4337 */     GIR_RootConstrainSelectedInstOperands,
     /*   4338 */     // GIR_Coverage, 3381,
     /*   4338 */     GIR_EraseRootFromParent_Done,
     /*   4339 */   // Label 229: @4339
     /*   4339 */   GIM_Try, /*On fail goto*//*Label 230*/ GIMT_Encode4(4417), // Rule ID 3379 //
     /*   4344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   4347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   4351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   4359 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4363 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4367 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4371 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*   4375 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4379 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4383 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   4387 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   4393 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*   4395 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   4397 */     // (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 8:{ *:[i32] })
     /*   4397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   4400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   4402 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*   4404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   4408 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*   4412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*   4415 */     GIR_RootConstrainSelectedInstOperands,
     /*   4416 */     // GIR_Coverage, 3379,
     /*   4416 */     GIR_EraseRootFromParent_Done,
     /*   4417 */   // Label 230: @4417
     /*   4417 */   GIM_Try, /*On fail goto*//*Label 231*/ GIMT_Encode4(4495), // Rule ID 4916 //
     /*   4422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   4425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   4429 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4433 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   4437 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4441 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4445 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4449 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   4453 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4457 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4461 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*   4465 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   4471 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*   4473 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   4475 */     // (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 9:{ *:[i32] })
     /*   4475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   4478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   4480 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*   4482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   4486 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   4490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /*   4493 */     GIR_RootConstrainSelectedInstOperands,
     /*   4494 */     // GIR_Coverage, 4916,
     /*   4494 */     GIR_EraseRootFromParent_Done,
     /*   4495 */   // Label 231: @4495
     /*   4495 */   GIM_Try, /*On fail goto*//*Label 232*/ GIMT_Encode4(4573), // Rule ID 3380 //
     /*   4500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   4503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   4507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   4515 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4519 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4523 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4527 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   4531 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4535 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4539 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   4543 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   4549 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*   4551 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   4553 */     // (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 9:{ *:[i32] })
     /*   4553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   4556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   4558 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*   4560 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   4564 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*   4568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /*   4571 */     GIR_RootConstrainSelectedInstOperands,
     /*   4572 */     // GIR_Coverage, 3380,
     /*   4572 */     GIR_EraseRootFromParent_Done,
     /*   4573 */   // Label 232: @4573
     /*   4573 */   GIM_Try, /*On fail goto*//*Label 233*/ GIMT_Encode4(4651), // Rule ID 4917 //
     /*   4578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   4581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   4585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   4593 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4597 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4601 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   4605 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   4609 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4613 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4617 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*   4621 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   4627 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*   4629 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   4631 */     // (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, immAllOnesV:{ *:[v4i32] })))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 9:{ *:[i32] })
     /*   4631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   4634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   4636 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*   4638 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   4642 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*   4646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /*   4649 */     GIR_RootConstrainSelectedInstOperands,
     /*   4650 */     // GIR_Coverage, 4917,
     /*   4650 */     GIR_EraseRootFromParent_Done,
     /*   4651 */   // Label 233: @4651
     /*   4651 */   GIM_Try, /*On fail goto*//*Label 234*/ GIMT_Encode4(4706), // Rule ID 4892 //
     /*   4656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*   4659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   4663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   4671 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4675 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4679 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   4683 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   4689 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*   4691 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4693 */     // (and:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XB, immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$XA)  =>  (XXLANDC:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB)
     /*   4693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXLANDC),
     /*   4696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   4698 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*   4700 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XB
     /*   4704 */     GIR_RootConstrainSelectedInstOperands,
     /*   4705 */     // GIR_Coverage, 4892,
     /*   4705 */     GIR_EraseRootFromParent_Done,
     /*   4706 */   // Label 234: @4706
     /*   4706 */   GIM_Try, /*On fail goto*//*Label 235*/ GIMT_Encode4(4761), // Rule ID 929 //
     /*   4711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*   4714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   4718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   4726 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4730 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4734 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   4738 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   4744 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*   4746 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4748 */     // (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XB, immAllOnesV:{ *:[v4i32] }))  =>  (XXLANDC:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB)
     /*   4748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXLANDC),
     /*   4751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   4753 */     GIR_RootToRootCopy, /*OpIdx*/1, // XA
     /*   4755 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XB
     /*   4759 */     GIR_RootConstrainSelectedInstOperands,
     /*   4760 */     // GIR_Coverage, 929,
     /*   4760 */     GIR_EraseRootFromParent_Done,
     /*   4761 */   // Label 235: @4761
     /*   4761 */   GIM_Try, /*On fail goto*//*Label 236*/ GIMT_Encode4(4811), // Rule ID 4912 //
     /*   4766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   4769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   4773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   4781 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4785 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4789 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4791 */     // (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 1:{ *:[i32] })
     /*   4791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   4794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   4796 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*   4800 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*   4804 */     GIR_RootToRootCopy, /*OpIdx*/2, // vC
     /*   4806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   4809 */     GIR_RootConstrainSelectedInstOperands,
     /*   4810 */     // GIR_Coverage, 4912,
     /*   4810 */     GIR_EraseRootFromParent_Done,
     /*   4811 */   // Label 236: @4811
     /*   4811 */   GIM_Try, /*On fail goto*//*Label 237*/ GIMT_Encode4(4861), // Rule ID 4914 //
     /*   4816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   4819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   4823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*   4831 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4835 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4839 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4841 */     // (and:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 7:{ *:[i32] })
     /*   4841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   4844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   4846 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*   4848 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*   4852 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   4856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*   4859 */     GIR_RootConstrainSelectedInstOperands,
     /*   4860 */     // GIR_Coverage, 4914,
     /*   4860 */     GIR_EraseRootFromParent_Done,
     /*   4861 */   // Label 237: @4861
     /*   4861 */   GIM_Try, /*On fail goto*//*Label 238*/ GIMT_Encode4(4911), // Rule ID 4913 //
     /*   4866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   4869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   4873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   4881 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4885 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4889 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4891 */     // (and:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 6:{ *:[i32] })
     /*   4891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   4894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   4896 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*   4898 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*   4902 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   4906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   4909 */     GIR_RootConstrainSelectedInstOperands,
     /*   4910 */     // GIR_Coverage, 4913,
     /*   4910 */     GIR_EraseRootFromParent_Done,
     /*   4911 */   // Label 238: @4911
     /*   4911 */   GIM_Try, /*On fail goto*//*Label 239*/ GIMT_Encode4(4961), // Rule ID 3376 //
     /*   4916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   4919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   4923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   4931 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4935 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4939 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4941 */     // (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 1:{ *:[i32] })
     /*   4941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   4944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   4946 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*   4948 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*   4952 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   4956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   4959 */     GIR_RootConstrainSelectedInstOperands,
     /*   4960 */     // GIR_Coverage, 3376,
     /*   4960 */     GIR_EraseRootFromParent_Done,
     /*   4961 */   // Label 239: @4961
     /*   4961 */   GIM_Try, /*On fail goto*//*Label 240*/ GIMT_Encode4(5011), // Rule ID 3378 //
     /*   4966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   4969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   4973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*   4981 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4985 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4989 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4991 */     // (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 7:{ *:[i32] })
     /*   4991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   4994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   4996 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*   4998 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*   5002 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   5006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*   5009 */     GIR_RootConstrainSelectedInstOperands,
     /*   5010 */     // GIR_Coverage, 3378,
     /*   5010 */     GIR_EraseRootFromParent_Done,
     /*   5011 */   // Label 240: @5011
     /*   5011 */   GIM_Try, /*On fail goto*//*Label 241*/ GIMT_Encode4(5061), // Rule ID 3377 //
     /*   5016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   5019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   5023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   5031 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5035 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   5039 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5041 */     // (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 6:{ *:[i32] })
     /*   5041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   5044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   5046 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*   5048 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*   5052 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   5056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   5059 */     GIR_RootConstrainSelectedInstOperands,
     /*   5060 */     // GIR_Coverage, 3377,
     /*   5060 */     GIR_EraseRootFromParent_Done,
     /*   5061 */   // Label 241: @5061
     /*   5061 */   GIM_Try, /*On fail goto*//*Label 242*/ GIMT_Encode4(5080), // Rule ID 928 //
     /*   5066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*   5069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   5073 */     // (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB)  =>  (XXLAND:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB)
     /*   5073 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XXLAND),
     /*   5078 */     GIR_RootConstrainSelectedInstOperands,
     /*   5079 */     // GIR_Coverage, 928,
     /*   5079 */     GIR_Done,
     /*   5080 */   // Label 242: @5080
     /*   5080 */   GIM_Try, /*On fail goto*//*Label 243*/ GIMT_Encode4(5135), // Rule ID 4880 //
     /*   5085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*   5088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   5092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   5100 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5104 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   5108 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   5112 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   5118 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*   5120 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5122 */     // (and:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VB, immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$VA)  =>  (VANDC:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*   5122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VANDC),
     /*   5125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*   5127 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*   5129 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // VB
     /*   5133 */     GIR_RootConstrainSelectedInstOperands,
     /*   5134 */     // GIR_Coverage, 4880,
     /*   5134 */     GIR_EraseRootFromParent_Done,
     /*   5135 */   // Label 243: @5135
     /*   5135 */   GIM_Try, /*On fail goto*//*Label 244*/ GIMT_Encode4(5190), // Rule ID 312 //
     /*   5140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*   5143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   5147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   5155 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5159 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   5163 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   5167 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   5173 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*   5175 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5177 */     // (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VB, immAllOnesV:{ *:[v4i32] }))  =>  (VANDC:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*   5177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VANDC),
     /*   5180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*   5182 */     GIR_RootToRootCopy, /*OpIdx*/1, // VA
     /*   5184 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // VB
     /*   5188 */     GIR_RootConstrainSelectedInstOperands,
     /*   5189 */     // GIR_Coverage, 312,
     /*   5189 */     GIR_EraseRootFromParent_Done,
     /*   5190 */   // Label 244: @5190
     /*   5190 */   GIM_Try, /*On fail goto*//*Label 245*/ GIMT_Encode4(5245), // Rule ID 1378 //
     /*   5195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*   5198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   5202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   5210 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5214 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   5218 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   5222 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   5228 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*   5230 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5232 */     // (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$A, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$B, immAllOnesV:{ *:[v4i32] }))  =>  (VANDC:{ *:[v4i32] } ?:{ *:[v4i32] }:$A, ?:{ *:[v4i32] }:$B)
     /*   5232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VANDC),
     /*   5235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*   5237 */     GIR_RootToRootCopy, /*OpIdx*/1, // A
     /*   5239 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // B
     /*   5243 */     GIR_RootConstrainSelectedInstOperands,
     /*   5244 */     // GIR_Coverage, 1378,
     /*   5244 */     GIR_EraseRootFromParent_Done,
     /*   5245 */   // Label 245: @5245
     /*   5245 */   GIM_Try, /*On fail goto*//*Label 246*/ GIMT_Encode4(5264), // Rule ID 311 //
     /*   5250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*   5253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   5257 */     // (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VAND:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*   5257 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VAND),
     /*   5262 */     GIR_RootConstrainSelectedInstOperands,
     /*   5263 */     // GIR_Coverage, 311,
     /*   5263 */     GIR_Done,
     /*   5264 */   // Label 246: @5264
     /*   5264 */   GIM_Reject,
     /*   5265 */ // Label 213: @5265
     /*   5265 */ GIM_Reject,
     /*   5266 */ // Label 200: @5266
     /*   5266 */ GIM_Reject,
     /*   5267 */ // Label 8: @5267
     /*   5267 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(6), /*)*//*default:*//*Label 251*/ GIMT_Encode4(48408),
     /*   5278 */ /*GILLT_s1*//*Label 247*/ GIMT_Encode4(5302),
     /*   5282 */ /*GILLT_s32*//*Label 248*/ GIMT_Encode4(5411),
     /*   5286 */ /*GILLT_s64*//*Label 249*/ GIMT_Encode4(5520), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   5298 */ /*GILLT_v4s32*//*Label 250*/ GIMT_Encode4(5629),
     /*   5302 */ // Label 247: @5302
     /*   5302 */ GIM_Try, /*On fail goto*//*Label 252*/ GIMT_Encode4(5410),
     /*   5307 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /*   5310 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s1,
     /*   5313 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*   5317 */   GIM_Try, /*On fail goto*//*Label 253*/ GIMT_Encode4(5357), // Rule ID 4878 //
     /*   5322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   5330 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /*   5334 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /*   5338 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*   5342 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5344 */     // (or:{ *:[i1] } (xor:{ *:[i1] } i1:{ *:[i1] }:$CRB, -1:{ *:[i1] }), i1:{ *:[i1] }:$CRA)  =>  (CRORC:{ *:[i1] } i1:{ *:[i1] }:$CRA, i1:{ *:[i1] }:$CRB)
     /*   5344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRORC),
     /*   5347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /*   5349 */     GIR_RootToRootCopy, /*OpIdx*/2, // CRA
     /*   5351 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // CRB
     /*   5355 */     GIR_RootConstrainSelectedInstOperands,
     /*   5356 */     // GIR_Coverage, 4878,
     /*   5356 */     GIR_EraseRootFromParent_Done,
     /*   5357 */   // Label 253: @5357
     /*   5357 */   GIM_Try, /*On fail goto*//*Label 254*/ GIMT_Encode4(5397), // Rule ID 183 //
     /*   5362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   5370 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /*   5374 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /*   5378 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*   5382 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5384 */     // (or:{ *:[i1] } i1:{ *:[i1] }:$CRA, (xor:{ *:[i1] } i1:{ *:[i1] }:$CRB, -1:{ *:[i1] }))  =>  (CRORC:{ *:[i1] } i1:{ *:[i1] }:$CRA, i1:{ *:[i1] }:$CRB)
     /*   5384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRORC),
     /*   5387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /*   5389 */     GIR_RootToRootCopy, /*OpIdx*/1, // CRA
     /*   5391 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // CRB
     /*   5395 */     GIR_RootConstrainSelectedInstOperands,
     /*   5396 */     // GIR_Coverage, 183,
     /*   5396 */     GIR_EraseRootFromParent_Done,
     /*   5397 */   // Label 254: @5397
     /*   5397 */   GIM_Try, /*On fail goto*//*Label 255*/ GIMT_Encode4(5409), // Rule ID 177 //
     /*   5402 */     // (or:{ *:[i1] } i1:{ *:[i1] }:$CRA, i1:{ *:[i1] }:$CRB)  =>  (CROR:{ *:[i1] } i1:{ *:[i1] }:$CRA, i1:{ *:[i1] }:$CRB)
     /*   5402 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::CROR),
     /*   5407 */     GIR_RootConstrainSelectedInstOperands,
     /*   5408 */     // GIR_Coverage, 177,
     /*   5408 */     GIR_Done,
     /*   5409 */   // Label 255: @5409
     /*   5409 */   GIM_Reject,
     /*   5410 */ // Label 252: @5410
     /*   5410 */ GIM_Reject,
     /*   5411 */ // Label 248: @5411
     /*   5411 */ GIM_Try, /*On fail goto*//*Label 256*/ GIMT_Encode4(5519),
     /*   5416 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   5419 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   5422 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*   5426 */   GIM_Try, /*On fail goto*//*Label 257*/ GIMT_Encode4(5466), // Rule ID 4872 //
     /*   5431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   5439 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5443 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   5447 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*   5451 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5453 */     // (or:{ *:[i32] } (xor:{ *:[i32] } i32:{ *:[i32] }:$RB, -1:{ *:[i32] }), i32:{ *:[i32] }:$RST)  =>  (ORC:{ *:[i32] } i32:{ *:[i32] }:$RST, i32:{ *:[i32] }:$RB)
     /*   5453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::ORC),
     /*   5456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*   5458 */     GIR_RootToRootCopy, /*OpIdx*/2, // RST
     /*   5460 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RB
     /*   5464 */     GIR_RootConstrainSelectedInstOperands,
     /*   5465 */     // GIR_Coverage, 4872,
     /*   5465 */     GIR_EraseRootFromParent_Done,
     /*   5466 */   // Label 257: @5466
     /*   5466 */   GIM_Try, /*On fail goto*//*Label 258*/ GIMT_Encode4(5506), // Rule ID 126 //
     /*   5471 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5475 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   5479 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5483 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   5487 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*   5491 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5493 */     // (or:{ *:[i32] } i32:{ *:[i32] }:$RST, (xor:{ *:[i32] } i32:{ *:[i32] }:$RB, -1:{ *:[i32] }))  =>  (ORC:{ *:[i32] } i32:{ *:[i32] }:$RST, i32:{ *:[i32] }:$RB)
     /*   5493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::ORC),
     /*   5496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*   5498 */     GIR_RootToRootCopy, /*OpIdx*/1, // RST
     /*   5500 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RB
     /*   5504 */     GIR_RootConstrainSelectedInstOperands,
     /*   5505 */     // GIR_Coverage, 126,
     /*   5505 */     GIR_EraseRootFromParent_Done,
     /*   5506 */   // Label 258: @5506
     /*   5506 */   GIM_Try, /*On fail goto*//*Label 259*/ GIMT_Encode4(5518), // Rule ID 124 //
     /*   5511 */     // (or:{ *:[i32] } i32:{ *:[i32] }:$RST, i32:{ *:[i32] }:$RB)  =>  (OR:{ *:[i32] } i32:{ *:[i32] }:$RST, i32:{ *:[i32] }:$RB)
     /*   5511 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::OR),
     /*   5516 */     GIR_RootConstrainSelectedInstOperands,
     /*   5517 */     // GIR_Coverage, 124,
     /*   5517 */     GIR_Done,
     /*   5518 */   // Label 259: @5518
     /*   5518 */   GIM_Reject,
     /*   5519 */ // Label 256: @5519
     /*   5519 */ GIM_Reject,
     /*   5520 */ // Label 249: @5520
     /*   5520 */ GIM_Try, /*On fail goto*//*Label 260*/ GIMT_Encode4(5628),
     /*   5525 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   5528 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   5531 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*   5535 */   GIM_Try, /*On fail goto*//*Label 261*/ GIMT_Encode4(5575), // Rule ID 4885 //
     /*   5540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   5548 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5552 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   5556 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*   5560 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5562 */     // (or:{ *:[i64] } (xor:{ *:[i64] } i64:{ *:[i64] }:$RB, -1:{ *:[i64] }), i64:{ *:[i64] }:$RST)  =>  (ORC8:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)
     /*   5562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::ORC8),
     /*   5565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*   5567 */     GIR_RootToRootCopy, /*OpIdx*/2, // RST
     /*   5569 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RB
     /*   5573 */     GIR_RootConstrainSelectedInstOperands,
     /*   5574 */     // GIR_Coverage, 4885,
     /*   5574 */     GIR_EraseRootFromParent_Done,
     /*   5575 */   // Label 261: @5575
     /*   5575 */   GIM_Try, /*On fail goto*//*Label 262*/ GIMT_Encode4(5615), // Rule ID 646 //
     /*   5580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   5588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5592 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   5596 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*   5600 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5602 */     // (or:{ *:[i64] } i64:{ *:[i64] }:$RST, (xor:{ *:[i64] } i64:{ *:[i64] }:$RB, -1:{ *:[i64] }))  =>  (ORC8:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)
     /*   5602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::ORC8),
     /*   5605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*   5607 */     GIR_RootToRootCopy, /*OpIdx*/1, // RST
     /*   5609 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RB
     /*   5613 */     GIR_RootConstrainSelectedInstOperands,
     /*   5614 */     // GIR_Coverage, 646,
     /*   5614 */     GIR_EraseRootFromParent_Done,
     /*   5615 */   // Label 262: @5615
     /*   5615 */   GIM_Try, /*On fail goto*//*Label 263*/ GIMT_Encode4(5627), // Rule ID 644 //
     /*   5620 */     // (or:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)  =>  (OR8:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)
     /*   5620 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /*   5625 */     GIR_RootConstrainSelectedInstOperands,
     /*   5626 */     // GIR_Coverage, 644,
     /*   5626 */     GIR_Done,
     /*   5627 */   // Label 263: @5627
     /*   5627 */   GIM_Reject,
     /*   5628 */ // Label 260: @5628
     /*   5628 */ GIM_Reject,
     /*   5629 */ // Label 250: @5629
     /*   5629 */ GIM_Try, /*On fail goto*//*Label 264*/ GIMT_Encode4(48407),
     /*   5634 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5637 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   5640 */   GIM_Try, /*On fail goto*//*Label 265*/ GIMT_Encode4(5778), // Rule ID 4932 //
     /*   5645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   5648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   5652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   5660 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5664 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   5668 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5672 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   5676 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5680 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   5684 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   5688 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   5692 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5696 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   5700 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   5704 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   5708 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5712 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   5716 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   5720 */     // MIs[5] vA
     /*   5720 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   5725 */     // MIs[5] vB
     /*   5725 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5730 */     // MIs[4] vC
     /*   5730 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   5735 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   5739 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   5745 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   5747 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   5749 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   5749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   5752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   5754 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   5758 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*   5762 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   5766 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   5776 */     GIR_RootConstrainSelectedInstOperands,
     /*   5777 */     // GIR_Coverage, 4932,
     /*   5777 */     GIR_EraseRootFromParent_Done,
     /*   5778 */   // Label 265: @5778
     /*   5778 */   GIM_Try, /*On fail goto*//*Label 266*/ GIMT_Encode4(5916), // Rule ID 4933 //
     /*   5783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   5786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   5790 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5794 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   5798 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5802 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   5806 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5810 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   5814 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5818 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   5822 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   5826 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   5830 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5834 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   5838 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   5842 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   5846 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5850 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   5854 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   5858 */     // MIs[5] vB
     /*   5858 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5863 */     // MIs[5] vA
     /*   5863 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   5868 */     // MIs[4] vC
     /*   5868 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   5873 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   5877 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   5883 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   5885 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   5887 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   5887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   5890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   5892 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   5896 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*   5900 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   5904 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   5914 */     GIR_RootConstrainSelectedInstOperands,
     /*   5915 */     // GIR_Coverage, 4933,
     /*   5915 */     GIR_EraseRootFromParent_Done,
     /*   5916 */   // Label 266: @5916
     /*   5916 */   GIM_Try, /*On fail goto*//*Label 267*/ GIMT_Encode4(6054), // Rule ID 4934 //
     /*   5921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   5924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   5928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   5936 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5940 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   5944 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5948 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   5952 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5956 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   5960 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   5964 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   5968 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5972 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   5976 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   5980 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   5984 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5988 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   5992 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   5996 */     // MIs[5] vA
     /*   5996 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   6001 */     // MIs[5] vC
     /*   6001 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   6006 */     // MIs[4] vB
     /*   6006 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   6011 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   6015 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   6021 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   6023 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   6025 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   6025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   6028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   6030 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   6034 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*   6038 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   6042 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   6052 */     GIR_RootConstrainSelectedInstOperands,
     /*   6053 */     // GIR_Coverage, 4934,
     /*   6053 */     GIR_EraseRootFromParent_Done,
     /*   6054 */   // Label 267: @6054
     /*   6054 */   GIM_Try, /*On fail goto*//*Label 268*/ GIMT_Encode4(6192), // Rule ID 4935 //
     /*   6059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   6062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   6066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   6074 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6078 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6082 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6086 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   6090 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6094 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6098 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6102 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   6106 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6110 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6114 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6118 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   6122 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6126 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   6130 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   6134 */     // MIs[5] vC
     /*   6134 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   6139 */     // MIs[5] vA
     /*   6139 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   6144 */     // MIs[4] vB
     /*   6144 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   6149 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   6153 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   6159 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   6161 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   6163 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   6163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   6166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   6168 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   6172 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*   6176 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   6180 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   6190 */     GIR_RootConstrainSelectedInstOperands,
     /*   6191 */     // GIR_Coverage, 4935,
     /*   6191 */     GIR_EraseRootFromParent_Done,
     /*   6192 */   // Label 268: @6192
     /*   6192 */   GIM_Try, /*On fail goto*//*Label 269*/ GIMT_Encode4(6330), // Rule ID 4936 //
     /*   6197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   6200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   6204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   6212 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6216 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6220 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6224 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   6228 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6232 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6236 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6240 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   6244 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6248 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6252 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6256 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   6260 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6264 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   6268 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   6272 */     // MIs[5] vB
     /*   6272 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   6277 */     // MIs[5] vC
     /*   6277 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   6282 */     // MIs[4] vA
     /*   6282 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   6287 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   6291 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   6297 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   6299 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   6301 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   6301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   6304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   6306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   6310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*   6314 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   6318 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   6328 */     GIR_RootConstrainSelectedInstOperands,
     /*   6329 */     // GIR_Coverage, 4936,
     /*   6329 */     GIR_EraseRootFromParent_Done,
     /*   6330 */   // Label 269: @6330
     /*   6330 */   GIM_Try, /*On fail goto*//*Label 270*/ GIMT_Encode4(6468), // Rule ID 4937 //
     /*   6335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   6338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   6342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   6350 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6354 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6358 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6362 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   6366 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6370 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6374 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6378 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   6382 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6386 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6390 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6394 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   6398 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6402 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   6406 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   6410 */     // MIs[5] vC
     /*   6410 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   6415 */     // MIs[5] vB
     /*   6415 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   6420 */     // MIs[4] vA
     /*   6420 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   6425 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   6429 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   6435 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   6437 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   6439 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   6439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   6442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   6444 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   6448 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*   6452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   6456 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   6466 */     GIR_RootConstrainSelectedInstOperands,
     /*   6467 */     // GIR_Coverage, 4937,
     /*   6467 */     GIR_EraseRootFromParent_Done,
     /*   6468 */   // Label 270: @6468
     /*   6468 */   GIM_Try, /*On fail goto*//*Label 271*/ GIMT_Encode4(6606), // Rule ID 4944 //
     /*   6473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   6476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   6480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   6488 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6492 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6496 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6500 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   6504 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6508 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6512 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6516 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   6520 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6524 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6528 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6532 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   6536 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6540 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   6544 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   6548 */     // MIs[5] vA
     /*   6548 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   6553 */     // MIs[5] vB
     /*   6553 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   6558 */     // MIs[4] vC
     /*   6558 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   6563 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   6567 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   6573 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   6575 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   6577 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   6577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   6580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   6582 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*   6586 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   6590 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   6594 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   6604 */     GIR_RootConstrainSelectedInstOperands,
     /*   6605 */     // GIR_Coverage, 4944,
     /*   6605 */     GIR_EraseRootFromParent_Done,
     /*   6606 */   // Label 271: @6606
     /*   6606 */   GIM_Try, /*On fail goto*//*Label 272*/ GIMT_Encode4(6744), // Rule ID 4945 //
     /*   6611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   6614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   6618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   6626 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6630 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6634 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6638 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   6642 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6646 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6650 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6654 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   6658 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6662 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6666 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6670 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   6674 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6678 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   6682 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   6686 */     // MIs[5] vB
     /*   6686 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   6691 */     // MIs[5] vA
     /*   6691 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   6696 */     // MIs[4] vC
     /*   6696 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   6701 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   6705 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   6711 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   6713 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   6715 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   6715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   6718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   6720 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*   6724 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   6728 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   6732 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   6742 */     GIR_RootConstrainSelectedInstOperands,
     /*   6743 */     // GIR_Coverage, 4945,
     /*   6743 */     GIR_EraseRootFromParent_Done,
     /*   6744 */   // Label 272: @6744
     /*   6744 */   GIM_Try, /*On fail goto*//*Label 273*/ GIMT_Encode4(6882), // Rule ID 4946 //
     /*   6749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   6752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   6756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   6764 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6768 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6772 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6776 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   6780 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6784 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6788 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6792 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   6796 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6800 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6804 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6808 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   6812 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6816 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   6820 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   6824 */     // MIs[5] vA
     /*   6824 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   6829 */     // MIs[5] vC
     /*   6829 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   6834 */     // MIs[4] vB
     /*   6834 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   6839 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   6843 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   6849 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   6851 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   6853 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   6853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   6856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   6858 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*   6862 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   6866 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   6870 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   6880 */     GIR_RootConstrainSelectedInstOperands,
     /*   6881 */     // GIR_Coverage, 4946,
     /*   6881 */     GIR_EraseRootFromParent_Done,
     /*   6882 */   // Label 273: @6882
     /*   6882 */   GIM_Try, /*On fail goto*//*Label 274*/ GIMT_Encode4(7020), // Rule ID 4947 //
     /*   6887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   6890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   6894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   6902 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6906 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6910 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6914 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   6918 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6922 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6926 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6930 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   6934 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6938 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6942 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6946 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   6950 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6954 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   6958 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   6962 */     // MIs[5] vC
     /*   6962 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   6967 */     // MIs[5] vA
     /*   6967 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   6972 */     // MIs[4] vB
     /*   6972 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   6977 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   6981 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   6987 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   6989 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   6991 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   6991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   6994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   6996 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*   7000 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   7004 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   7008 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   7018 */     GIR_RootConstrainSelectedInstOperands,
     /*   7019 */     // GIR_Coverage, 4947,
     /*   7019 */     GIR_EraseRootFromParent_Done,
     /*   7020 */   // Label 274: @7020
     /*   7020 */   GIM_Try, /*On fail goto*//*Label 275*/ GIMT_Encode4(7158), // Rule ID 4948 //
     /*   7025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   7028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   7032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   7040 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7044 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7048 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7052 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   7056 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7060 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7064 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   7068 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   7072 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7076 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7080 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   7084 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   7088 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7092 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   7096 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   7100 */     // MIs[5] vB
     /*   7100 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   7105 */     // MIs[5] vC
     /*   7105 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   7110 */     // MIs[4] vA
     /*   7110 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   7115 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   7119 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   7125 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   7127 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   7129 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   7129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   7132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   7134 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*   7138 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   7142 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   7146 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   7156 */     GIR_RootConstrainSelectedInstOperands,
     /*   7157 */     // GIR_Coverage, 4948,
     /*   7157 */     GIR_EraseRootFromParent_Done,
     /*   7158 */   // Label 275: @7158
     /*   7158 */   GIM_Try, /*On fail goto*//*Label 276*/ GIMT_Encode4(7296), // Rule ID 4949 //
     /*   7163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   7166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   7170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   7178 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7182 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7186 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7190 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   7194 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7198 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7202 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   7206 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   7210 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7214 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7218 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   7222 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   7226 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7230 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   7234 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   7238 */     // MIs[5] vC
     /*   7238 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   7243 */     // MIs[5] vB
     /*   7243 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   7248 */     // MIs[4] vA
     /*   7248 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   7253 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   7257 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   7263 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   7265 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   7267 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   7267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   7270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   7272 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*   7276 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   7280 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   7284 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   7294 */     GIR_RootConstrainSelectedInstOperands,
     /*   7295 */     // GIR_Coverage, 4949,
     /*   7295 */     GIR_EraseRootFromParent_Done,
     /*   7296 */   // Label 276: @7296
     /*   7296 */   GIM_Try, /*On fail goto*//*Label 277*/ GIMT_Encode4(7434), // Rule ID 4956 //
     /*   7301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   7304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   7308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   7316 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7320 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7324 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7328 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   7332 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7336 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7340 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   7344 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   7348 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7352 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7356 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   7360 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   7364 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7368 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   7372 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   7376 */     // MIs[5] vA
     /*   7376 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   7381 */     // MIs[5] vB
     /*   7381 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   7386 */     // MIs[4] vC
     /*   7386 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   7391 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   7395 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   7401 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   7403 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   7405 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   7405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   7408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   7410 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   7414 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*   7418 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*   7422 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   7432 */     GIR_RootConstrainSelectedInstOperands,
     /*   7433 */     // GIR_Coverage, 4956,
     /*   7433 */     GIR_EraseRootFromParent_Done,
     /*   7434 */   // Label 277: @7434
     /*   7434 */   GIM_Try, /*On fail goto*//*Label 278*/ GIMT_Encode4(7572), // Rule ID 4957 //
     /*   7439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   7442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   7446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   7454 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7458 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7462 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7466 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   7470 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7474 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7478 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   7482 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   7486 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7490 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7494 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   7498 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   7502 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7506 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   7510 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   7514 */     // MIs[5] vB
     /*   7514 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   7519 */     // MIs[5] vA
     /*   7519 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   7524 */     // MIs[4] vC
     /*   7524 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   7529 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   7533 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   7539 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   7541 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   7543 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   7543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   7546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   7548 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   7552 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*   7556 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*   7560 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   7570 */     GIR_RootConstrainSelectedInstOperands,
     /*   7571 */     // GIR_Coverage, 4957,
     /*   7571 */     GIR_EraseRootFromParent_Done,
     /*   7572 */   // Label 278: @7572
     /*   7572 */   GIM_Try, /*On fail goto*//*Label 279*/ GIMT_Encode4(7710), // Rule ID 4958 //
     /*   7577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   7580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   7584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   7592 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7596 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7600 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7604 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   7608 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7612 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7616 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   7620 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   7624 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7628 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7632 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   7636 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   7640 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7644 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   7648 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   7652 */     // MIs[5] vA
     /*   7652 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   7657 */     // MIs[5] vC
     /*   7657 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   7662 */     // MIs[4] vB
     /*   7662 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   7667 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   7671 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   7677 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   7679 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   7681 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   7681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   7684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   7686 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   7690 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*   7694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*   7698 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   7708 */     GIR_RootConstrainSelectedInstOperands,
     /*   7709 */     // GIR_Coverage, 4958,
     /*   7709 */     GIR_EraseRootFromParent_Done,
     /*   7710 */   // Label 279: @7710
     /*   7710 */   GIM_Try, /*On fail goto*//*Label 280*/ GIMT_Encode4(7848), // Rule ID 4959 //
     /*   7715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   7718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   7722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   7730 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7734 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7738 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7742 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   7746 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7750 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7754 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   7758 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   7762 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7766 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7770 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   7774 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   7778 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7782 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   7786 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   7790 */     // MIs[5] vC
     /*   7790 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   7795 */     // MIs[5] vA
     /*   7795 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   7800 */     // MIs[4] vB
     /*   7800 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   7805 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   7809 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   7815 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   7817 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   7819 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   7819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   7822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   7824 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   7828 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*   7832 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*   7836 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   7846 */     GIR_RootConstrainSelectedInstOperands,
     /*   7847 */     // GIR_Coverage, 4959,
     /*   7847 */     GIR_EraseRootFromParent_Done,
     /*   7848 */   // Label 280: @7848
     /*   7848 */   GIM_Try, /*On fail goto*//*Label 281*/ GIMT_Encode4(7986), // Rule ID 4960 //
     /*   7853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   7856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   7860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   7868 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7872 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7876 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7880 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   7884 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7888 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7892 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   7896 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   7900 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7904 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7908 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   7912 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   7916 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7920 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   7924 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   7928 */     // MIs[5] vB
     /*   7928 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   7933 */     // MIs[5] vC
     /*   7933 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   7938 */     // MIs[4] vA
     /*   7938 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   7943 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   7947 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   7953 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   7955 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   7957 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   7957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   7960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   7962 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   7966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*   7970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*   7974 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   7984 */     GIR_RootConstrainSelectedInstOperands,
     /*   7985 */     // GIR_Coverage, 4960,
     /*   7985 */     GIR_EraseRootFromParent_Done,
     /*   7986 */   // Label 281: @7986
     /*   7986 */   GIM_Try, /*On fail goto*//*Label 282*/ GIMT_Encode4(8124), // Rule ID 4961 //
     /*   7991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   7994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   7998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   8006 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8010 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8014 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8018 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   8022 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8026 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8030 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   8034 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   8038 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8042 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8046 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   8050 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   8054 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8058 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   8062 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   8066 */     // MIs[5] vC
     /*   8066 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   8071 */     // MIs[5] vB
     /*   8071 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   8076 */     // MIs[4] vA
     /*   8076 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   8081 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   8085 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   8091 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   8093 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   8095 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   8095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   8098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   8100 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   8104 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*   8108 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*   8112 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   8122 */     GIR_RootConstrainSelectedInstOperands,
     /*   8123 */     // GIR_Coverage, 4961,
     /*   8123 */     GIR_EraseRootFromParent_Done,
     /*   8124 */   // Label 282: @8124
     /*   8124 */   GIM_Try, /*On fail goto*//*Label 283*/ GIMT_Encode4(8262), // Rule ID 4968 //
     /*   8129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   8132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   8136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   8144 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8148 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8152 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8156 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   8160 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8164 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8168 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   8172 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   8176 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8180 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8184 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   8188 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   8192 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8196 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   8200 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   8204 */     // MIs[5] vA
     /*   8204 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   8209 */     // MIs[5] vB
     /*   8209 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   8214 */     // MIs[4] vC
     /*   8214 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   8219 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   8223 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   8229 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   8231 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   8233 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   8233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   8236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   8238 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*   8242 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*   8246 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*   8250 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   8260 */     GIR_RootConstrainSelectedInstOperands,
     /*   8261 */     // GIR_Coverage, 4968,
     /*   8261 */     GIR_EraseRootFromParent_Done,
     /*   8262 */   // Label 283: @8262
     /*   8262 */   GIM_Try, /*On fail goto*//*Label 284*/ GIMT_Encode4(8400), // Rule ID 4969 //
     /*   8267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   8270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   8274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   8282 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8286 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8290 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8294 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   8298 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8302 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8306 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   8310 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   8314 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8318 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8322 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   8326 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   8330 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8334 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   8338 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   8342 */     // MIs[5] vB
     /*   8342 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   8347 */     // MIs[5] vA
     /*   8347 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   8352 */     // MIs[4] vC
     /*   8352 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   8357 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   8361 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   8367 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   8369 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   8371 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   8371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   8374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   8376 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*   8380 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*   8384 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*   8388 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   8398 */     GIR_RootConstrainSelectedInstOperands,
     /*   8399 */     // GIR_Coverage, 4969,
     /*   8399 */     GIR_EraseRootFromParent_Done,
     /*   8400 */   // Label 284: @8400
     /*   8400 */   GIM_Try, /*On fail goto*//*Label 285*/ GIMT_Encode4(8538), // Rule ID 4970 //
     /*   8405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   8408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   8412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   8420 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8424 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8428 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8432 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   8436 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8440 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8444 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   8448 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   8452 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8456 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8460 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   8464 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   8468 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8472 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   8476 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   8480 */     // MIs[5] vA
     /*   8480 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   8485 */     // MIs[5] vC
     /*   8485 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   8490 */     // MIs[4] vB
     /*   8490 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   8495 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   8499 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   8505 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   8507 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   8509 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   8509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   8512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   8514 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*   8518 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*   8522 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*   8526 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   8536 */     GIR_RootConstrainSelectedInstOperands,
     /*   8537 */     // GIR_Coverage, 4970,
     /*   8537 */     GIR_EraseRootFromParent_Done,
     /*   8538 */   // Label 285: @8538
     /*   8538 */   GIM_Try, /*On fail goto*//*Label 286*/ GIMT_Encode4(8676), // Rule ID 4971 //
     /*   8543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   8546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   8550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   8558 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8562 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8566 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8570 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   8574 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8578 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8582 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   8586 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   8590 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8594 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8598 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   8602 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   8606 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8610 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   8614 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   8618 */     // MIs[5] vC
     /*   8618 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   8623 */     // MIs[5] vA
     /*   8623 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   8628 */     // MIs[4] vB
     /*   8628 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   8633 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   8637 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   8643 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   8645 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   8647 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   8647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   8650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   8652 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*   8656 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*   8660 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*   8664 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   8674 */     GIR_RootConstrainSelectedInstOperands,
     /*   8675 */     // GIR_Coverage, 4971,
     /*   8675 */     GIR_EraseRootFromParent_Done,
     /*   8676 */   // Label 286: @8676
     /*   8676 */   GIM_Try, /*On fail goto*//*Label 287*/ GIMT_Encode4(8814), // Rule ID 4972 //
     /*   8681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   8684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   8688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   8696 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8700 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8704 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8708 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   8712 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8716 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8720 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   8724 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   8728 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8732 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8736 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   8740 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   8744 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8748 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   8752 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   8756 */     // MIs[5] vB
     /*   8756 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   8761 */     // MIs[5] vC
     /*   8761 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   8766 */     // MIs[4] vA
     /*   8766 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   8771 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   8775 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   8781 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   8783 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   8785 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   8785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   8788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   8790 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*   8794 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*   8798 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*   8802 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   8812 */     GIR_RootConstrainSelectedInstOperands,
     /*   8813 */     // GIR_Coverage, 4972,
     /*   8813 */     GIR_EraseRootFromParent_Done,
     /*   8814 */   // Label 287: @8814
     /*   8814 */   GIM_Try, /*On fail goto*//*Label 288*/ GIMT_Encode4(8952), // Rule ID 4973 //
     /*   8819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   8822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   8826 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8830 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   8834 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8838 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8842 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8846 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   8850 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8854 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8858 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   8862 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   8866 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8870 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8874 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   8878 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   8882 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8886 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   8890 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   8894 */     // MIs[5] vC
     /*   8894 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   8899 */     // MIs[5] vB
     /*   8899 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   8904 */     // MIs[4] vA
     /*   8904 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   8909 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   8913 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   8919 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   8921 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   8923 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   8923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   8926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   8928 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*   8932 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*   8936 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*   8940 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   8950 */     GIR_RootConstrainSelectedInstOperands,
     /*   8951 */     // GIR_Coverage, 4973,
     /*   8951 */     GIR_EraseRootFromParent_Done,
     /*   8952 */   // Label 288: @8952
     /*   8952 */   GIM_Try, /*On fail goto*//*Label 289*/ GIMT_Encode4(9090), // Rule ID 4980 //
     /*   8957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   8960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   8964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   8972 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8976 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8980 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8984 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   8988 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8992 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8996 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   9000 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   9004 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9008 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9012 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   9016 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   9020 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9024 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   9028 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   9032 */     // MIs[5] vA
     /*   9032 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   9037 */     // MIs[5] vB
     /*   9037 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   9042 */     // MIs[4] vC
     /*   9042 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   9047 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   9051 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   9057 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   9059 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   9061 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   9061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   9064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   9066 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*   9070 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   9074 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*   9078 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   9088 */     GIR_RootConstrainSelectedInstOperands,
     /*   9089 */     // GIR_Coverage, 4980,
     /*   9089 */     GIR_EraseRootFromParent_Done,
     /*   9090 */   // Label 289: @9090
     /*   9090 */   GIM_Try, /*On fail goto*//*Label 290*/ GIMT_Encode4(9228), // Rule ID 4981 //
     /*   9095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   9098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   9102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   9110 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9114 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9118 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9122 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   9126 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9130 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9134 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   9138 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   9142 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9146 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9150 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   9154 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   9158 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9162 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   9166 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   9170 */     // MIs[5] vB
     /*   9170 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   9175 */     // MIs[5] vA
     /*   9175 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   9180 */     // MIs[4] vC
     /*   9180 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   9185 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   9189 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   9195 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   9197 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   9199 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   9199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   9202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   9204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*   9208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   9212 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*   9216 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   9226 */     GIR_RootConstrainSelectedInstOperands,
     /*   9227 */     // GIR_Coverage, 4981,
     /*   9227 */     GIR_EraseRootFromParent_Done,
     /*   9228 */   // Label 290: @9228
     /*   9228 */   GIM_Try, /*On fail goto*//*Label 291*/ GIMT_Encode4(9366), // Rule ID 4982 //
     /*   9233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   9236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   9240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   9248 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9252 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9256 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9260 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   9264 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9268 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9272 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   9276 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   9280 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9284 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9288 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   9292 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   9296 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9300 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   9304 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   9308 */     // MIs[5] vA
     /*   9308 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   9313 */     // MIs[5] vC
     /*   9313 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   9318 */     // MIs[4] vB
     /*   9318 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   9323 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   9327 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   9333 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   9335 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   9337 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   9337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   9340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   9342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*   9346 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   9350 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*   9354 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   9364 */     GIR_RootConstrainSelectedInstOperands,
     /*   9365 */     // GIR_Coverage, 4982,
     /*   9365 */     GIR_EraseRootFromParent_Done,
     /*   9366 */   // Label 291: @9366
     /*   9366 */   GIM_Try, /*On fail goto*//*Label 292*/ GIMT_Encode4(9504), // Rule ID 4983 //
     /*   9371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   9374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   9378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   9386 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9390 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9394 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9398 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   9402 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9406 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9410 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   9414 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   9418 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9422 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9426 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   9430 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   9434 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9438 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   9442 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   9446 */     // MIs[5] vC
     /*   9446 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   9451 */     // MIs[5] vA
     /*   9451 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   9456 */     // MIs[4] vB
     /*   9456 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   9461 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   9465 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   9471 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   9473 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   9475 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   9475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   9478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   9480 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*   9484 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   9488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*   9492 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   9502 */     GIR_RootConstrainSelectedInstOperands,
     /*   9503 */     // GIR_Coverage, 4983,
     /*   9503 */     GIR_EraseRootFromParent_Done,
     /*   9504 */   // Label 292: @9504
     /*   9504 */   GIM_Try, /*On fail goto*//*Label 293*/ GIMT_Encode4(9642), // Rule ID 4984 //
     /*   9509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   9512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   9516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   9524 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9528 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9532 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9536 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   9540 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9544 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9548 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   9552 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   9556 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9560 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9564 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   9568 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   9572 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9576 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   9580 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   9584 */     // MIs[5] vB
     /*   9584 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   9589 */     // MIs[5] vC
     /*   9589 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   9594 */     // MIs[4] vA
     /*   9594 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   9599 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   9603 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   9609 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   9611 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   9613 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   9613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   9616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   9618 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*   9622 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   9626 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*   9630 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   9640 */     GIR_RootConstrainSelectedInstOperands,
     /*   9641 */     // GIR_Coverage, 4984,
     /*   9641 */     GIR_EraseRootFromParent_Done,
     /*   9642 */   // Label 293: @9642
     /*   9642 */   GIM_Try, /*On fail goto*//*Label 294*/ GIMT_Encode4(9780), // Rule ID 4985 //
     /*   9647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   9650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   9654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   9662 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9666 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9670 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9674 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   9678 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9682 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9686 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   9690 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   9694 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9698 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9702 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   9706 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   9710 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9714 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   9718 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   9722 */     // MIs[5] vC
     /*   9722 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   9727 */     // MIs[5] vB
     /*   9727 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   9732 */     // MIs[4] vA
     /*   9732 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   9737 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   9741 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   9747 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   9749 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   9751 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   9751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   9754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   9756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*   9760 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   9764 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*   9768 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   9778 */     GIR_RootConstrainSelectedInstOperands,
     /*   9779 */     // GIR_Coverage, 4985,
     /*   9779 */     GIR_EraseRootFromParent_Done,
     /*   9780 */   // Label 294: @9780
     /*   9780 */   GIM_Try, /*On fail goto*//*Label 295*/ GIMT_Encode4(9918), // Rule ID 4992 //
     /*   9785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   9788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   9792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   9800 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9804 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9808 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9812 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   9816 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9820 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9824 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   9828 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   9832 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9836 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9840 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   9844 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   9848 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9852 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   9856 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   9860 */     // MIs[5] vA
     /*   9860 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   9865 */     // MIs[5] vB
     /*   9865 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   9870 */     // MIs[4] vC
     /*   9870 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   9875 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   9879 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   9885 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   9887 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   9889 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   9889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   9892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   9894 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*   9898 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*   9902 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*   9906 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   9916 */     GIR_RootConstrainSelectedInstOperands,
     /*   9917 */     // GIR_Coverage, 4992,
     /*   9917 */     GIR_EraseRootFromParent_Done,
     /*   9918 */   // Label 295: @9918
     /*   9918 */   GIM_Try, /*On fail goto*//*Label 296*/ GIMT_Encode4(10056), // Rule ID 4993 //
     /*   9923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   9926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   9930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   9938 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9942 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9946 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9950 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   9954 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9958 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9962 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   9966 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   9970 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9974 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9978 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   9982 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   9986 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9990 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   9994 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   9998 */     // MIs[5] vB
     /*   9998 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  10003 */     // MIs[5] vA
     /*  10003 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10008 */     // MIs[4] vC
     /*  10008 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  10013 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  10017 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  10023 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  10025 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  10027 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  10027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  10030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  10032 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  10036 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  10040 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  10044 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  10054 */     GIR_RootConstrainSelectedInstOperands,
     /*  10055 */     // GIR_Coverage, 4993,
     /*  10055 */     GIR_EraseRootFromParent_Done,
     /*  10056 */   // Label 296: @10056
     /*  10056 */   GIM_Try, /*On fail goto*//*Label 297*/ GIMT_Encode4(10194), // Rule ID 4994 //
     /*  10061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  10064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  10068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  10076 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10080 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10084 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  10088 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  10092 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10096 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10100 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  10104 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  10108 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10112 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10116 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  10120 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  10124 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10128 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  10132 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  10136 */     // MIs[5] vA
     /*  10136 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10141 */     // MIs[5] vC
     /*  10141 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  10146 */     // MIs[4] vB
     /*  10146 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  10151 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  10155 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  10161 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  10163 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  10165 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  10165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  10168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  10170 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  10174 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  10178 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  10182 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  10192 */     GIR_RootConstrainSelectedInstOperands,
     /*  10193 */     // GIR_Coverage, 4994,
     /*  10193 */     GIR_EraseRootFromParent_Done,
     /*  10194 */   // Label 297: @10194
     /*  10194 */   GIM_Try, /*On fail goto*//*Label 298*/ GIMT_Encode4(10332), // Rule ID 4995 //
     /*  10199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  10202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  10206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  10214 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10218 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10222 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  10226 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  10230 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10234 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10238 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  10242 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  10246 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10250 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10254 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  10258 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  10262 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10266 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  10270 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  10274 */     // MIs[5] vC
     /*  10274 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  10279 */     // MIs[5] vA
     /*  10279 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10284 */     // MIs[4] vB
     /*  10284 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  10289 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  10293 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  10299 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  10301 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  10303 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  10303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  10306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  10308 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  10312 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  10316 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  10320 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  10330 */     GIR_RootConstrainSelectedInstOperands,
     /*  10331 */     // GIR_Coverage, 4995,
     /*  10331 */     GIR_EraseRootFromParent_Done,
     /*  10332 */   // Label 298: @10332
     /*  10332 */   GIM_Try, /*On fail goto*//*Label 299*/ GIMT_Encode4(10470), // Rule ID 4996 //
     /*  10337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  10340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  10344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  10352 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10356 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10360 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  10364 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  10368 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10372 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10376 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  10380 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  10384 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10388 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10392 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  10396 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  10400 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10404 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  10408 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  10412 */     // MIs[5] vB
     /*  10412 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  10417 */     // MIs[5] vC
     /*  10417 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  10422 */     // MIs[4] vA
     /*  10422 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10427 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  10431 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  10437 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  10439 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  10441 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  10441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  10444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  10446 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  10450 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  10454 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  10458 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  10468 */     GIR_RootConstrainSelectedInstOperands,
     /*  10469 */     // GIR_Coverage, 4996,
     /*  10469 */     GIR_EraseRootFromParent_Done,
     /*  10470 */   // Label 299: @10470
     /*  10470 */   GIM_Try, /*On fail goto*//*Label 300*/ GIMT_Encode4(10608), // Rule ID 4997 //
     /*  10475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  10478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  10482 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10486 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  10490 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10494 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10498 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  10502 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  10506 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10510 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10514 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  10518 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  10522 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10526 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10530 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  10534 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  10538 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10542 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  10546 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  10550 */     // MIs[5] vC
     /*  10550 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  10555 */     // MIs[5] vB
     /*  10555 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  10560 */     // MIs[4] vA
     /*  10560 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10565 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  10569 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  10575 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  10577 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  10579 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  10579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  10582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  10584 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  10588 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  10592 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  10596 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  10606 */     GIR_RootConstrainSelectedInstOperands,
     /*  10607 */     // GIR_Coverage, 4997,
     /*  10607 */     GIR_EraseRootFromParent_Done,
     /*  10608 */   // Label 300: @10608
     /*  10608 */   GIM_Try, /*On fail goto*//*Label 301*/ GIMT_Encode4(10746), // Rule ID 4938 //
     /*  10613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  10616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  10620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  10628 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10632 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10636 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  10640 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  10644 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10648 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10652 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  10656 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  10660 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10664 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10668 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  10672 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  10676 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10680 */     // MIs[4] vC
     /*  10680 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10685 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  10689 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  10693 */     // MIs[5] vA
     /*  10693 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  10698 */     // MIs[5] vB
     /*  10698 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  10703 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  10707 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  10713 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  10715 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  10717 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  10717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  10720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  10722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  10726 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  10730 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  10734 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  10744 */     GIR_RootConstrainSelectedInstOperands,
     /*  10745 */     // GIR_Coverage, 4938,
     /*  10745 */     GIR_EraseRootFromParent_Done,
     /*  10746 */   // Label 301: @10746
     /*  10746 */   GIM_Try, /*On fail goto*//*Label 302*/ GIMT_Encode4(10884), // Rule ID 4939 //
     /*  10751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  10754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  10758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  10766 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10770 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10774 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  10778 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  10782 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10786 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10790 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  10794 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  10798 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10802 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10806 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  10810 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  10814 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10818 */     // MIs[4] vC
     /*  10818 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10823 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  10827 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  10831 */     // MIs[5] vB
     /*  10831 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  10836 */     // MIs[5] vA
     /*  10836 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  10841 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  10845 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  10851 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  10853 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  10855 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  10855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  10858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  10860 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  10864 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  10868 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  10872 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  10882 */     GIR_RootConstrainSelectedInstOperands,
     /*  10883 */     // GIR_Coverage, 4939,
     /*  10883 */     GIR_EraseRootFromParent_Done,
     /*  10884 */   // Label 302: @10884
     /*  10884 */   GIM_Try, /*On fail goto*//*Label 303*/ GIMT_Encode4(11022), // Rule ID 4940 //
     /*  10889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  10892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  10896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  10904 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10908 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10912 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  10916 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  10920 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10924 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10928 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  10932 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  10936 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10940 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10944 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  10948 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  10952 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10956 */     // MIs[4] vB
     /*  10956 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  10961 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  10965 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  10969 */     // MIs[5] vA
     /*  10969 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  10974 */     // MIs[5] vC
     /*  10974 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10979 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  10983 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  10989 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  10991 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  10993 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  10993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  10996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  10998 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  11002 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  11006 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  11010 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  11020 */     GIR_RootConstrainSelectedInstOperands,
     /*  11021 */     // GIR_Coverage, 4940,
     /*  11021 */     GIR_EraseRootFromParent_Done,
     /*  11022 */   // Label 303: @11022
     /*  11022 */   GIM_Try, /*On fail goto*//*Label 304*/ GIMT_Encode4(11160), // Rule ID 4941 //
     /*  11027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  11030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  11034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  11042 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11046 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11050 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  11054 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  11058 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11062 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11066 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  11070 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  11074 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11078 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11082 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  11086 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  11090 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11094 */     // MIs[4] vB
     /*  11094 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  11099 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  11103 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  11107 */     // MIs[5] vC
     /*  11107 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  11112 */     // MIs[5] vA
     /*  11112 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11117 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  11121 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  11127 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  11129 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  11131 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  11131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  11134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  11136 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  11140 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  11144 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  11148 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  11158 */     GIR_RootConstrainSelectedInstOperands,
     /*  11159 */     // GIR_Coverage, 4941,
     /*  11159 */     GIR_EraseRootFromParent_Done,
     /*  11160 */   // Label 304: @11160
     /*  11160 */   GIM_Try, /*On fail goto*//*Label 305*/ GIMT_Encode4(11298), // Rule ID 4942 //
     /*  11165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  11168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  11172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  11180 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11184 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11188 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  11192 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  11196 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11200 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11204 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  11208 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  11212 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11216 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11220 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  11224 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  11228 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11232 */     // MIs[4] vA
     /*  11232 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11237 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  11241 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  11245 */     // MIs[5] vB
     /*  11245 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  11250 */     // MIs[5] vC
     /*  11250 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  11255 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  11259 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  11265 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  11267 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  11269 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  11269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  11272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  11274 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  11278 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  11282 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  11286 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  11296 */     GIR_RootConstrainSelectedInstOperands,
     /*  11297 */     // GIR_Coverage, 4942,
     /*  11297 */     GIR_EraseRootFromParent_Done,
     /*  11298 */   // Label 305: @11298
     /*  11298 */   GIM_Try, /*On fail goto*//*Label 306*/ GIMT_Encode4(11436), // Rule ID 4943 //
     /*  11303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  11306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  11310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  11318 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11322 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11326 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  11330 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  11334 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11338 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11342 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  11346 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  11350 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11354 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11358 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  11362 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  11366 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11370 */     // MIs[4] vA
     /*  11370 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11375 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  11379 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  11383 */     // MIs[5] vC
     /*  11383 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  11388 */     // MIs[5] vB
     /*  11388 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  11393 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  11397 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  11403 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  11405 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  11407 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  11407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  11410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  11412 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  11416 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  11420 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  11424 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  11434 */     GIR_RootConstrainSelectedInstOperands,
     /*  11435 */     // GIR_Coverage, 4943,
     /*  11435 */     GIR_EraseRootFromParent_Done,
     /*  11436 */   // Label 306: @11436
     /*  11436 */   GIM_Try, /*On fail goto*//*Label 307*/ GIMT_Encode4(11574), // Rule ID 4950 //
     /*  11441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  11444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  11448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  11456 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11460 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11464 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  11468 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  11472 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11476 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11480 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  11484 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  11488 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11492 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11496 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  11500 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  11504 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11508 */     // MIs[4] vC
     /*  11508 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  11513 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  11517 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  11521 */     // MIs[5] vA
     /*  11521 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  11526 */     // MIs[5] vB
     /*  11526 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11531 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  11535 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  11541 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  11543 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  11545 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  11545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  11548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  11550 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  11554 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  11558 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  11562 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  11572 */     GIR_RootConstrainSelectedInstOperands,
     /*  11573 */     // GIR_Coverage, 4950,
     /*  11573 */     GIR_EraseRootFromParent_Done,
     /*  11574 */   // Label 307: @11574
     /*  11574 */   GIM_Try, /*On fail goto*//*Label 308*/ GIMT_Encode4(11712), // Rule ID 4951 //
     /*  11579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  11582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  11586 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11590 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  11594 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11598 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11602 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  11606 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  11610 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11614 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11618 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  11622 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  11626 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11630 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11634 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  11638 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  11642 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11646 */     // MIs[4] vC
     /*  11646 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  11651 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  11655 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  11659 */     // MIs[5] vB
     /*  11659 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11664 */     // MIs[5] vA
     /*  11664 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  11669 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  11673 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  11679 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  11681 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  11683 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  11683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  11686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  11688 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  11692 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  11696 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  11700 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  11710 */     GIR_RootConstrainSelectedInstOperands,
     /*  11711 */     // GIR_Coverage, 4951,
     /*  11711 */     GIR_EraseRootFromParent_Done,
     /*  11712 */   // Label 308: @11712
     /*  11712 */   GIM_Try, /*On fail goto*//*Label 309*/ GIMT_Encode4(11850), // Rule ID 4952 //
     /*  11717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  11720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  11724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  11732 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11736 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11740 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  11744 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  11748 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11752 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11756 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  11760 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  11764 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11768 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11772 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  11776 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  11780 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11784 */     // MIs[4] vB
     /*  11784 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11789 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  11793 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  11797 */     // MIs[5] vA
     /*  11797 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  11802 */     // MIs[5] vC
     /*  11802 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  11807 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  11811 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  11817 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  11819 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  11821 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  11821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  11824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  11826 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  11830 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  11834 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  11838 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  11848 */     GIR_RootConstrainSelectedInstOperands,
     /*  11849 */     // GIR_Coverage, 4952,
     /*  11849 */     GIR_EraseRootFromParent_Done,
     /*  11850 */   // Label 309: @11850
     /*  11850 */   GIM_Try, /*On fail goto*//*Label 310*/ GIMT_Encode4(11988), // Rule ID 4953 //
     /*  11855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  11858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  11862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  11870 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11874 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11878 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  11882 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  11886 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11890 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11894 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  11898 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  11902 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11906 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11910 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  11914 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  11918 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11922 */     // MIs[4] vB
     /*  11922 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11927 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  11931 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  11935 */     // MIs[5] vC
     /*  11935 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  11940 */     // MIs[5] vA
     /*  11940 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  11945 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  11949 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  11955 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  11957 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  11959 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  11959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  11962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  11964 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  11968 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  11972 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  11976 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  11986 */     GIR_RootConstrainSelectedInstOperands,
     /*  11987 */     // GIR_Coverage, 4953,
     /*  11987 */     GIR_EraseRootFromParent_Done,
     /*  11988 */   // Label 310: @11988
     /*  11988 */   GIM_Try, /*On fail goto*//*Label 311*/ GIMT_Encode4(12126), // Rule ID 4954 //
     /*  11993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  11996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  12000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  12008 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12012 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12016 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12020 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  12024 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12028 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12032 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12036 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  12040 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12044 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12048 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12052 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  12056 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12060 */     // MIs[4] vA
     /*  12060 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  12065 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  12069 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  12073 */     // MIs[5] vB
     /*  12073 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  12078 */     // MIs[5] vC
     /*  12078 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  12083 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  12087 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  12093 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  12095 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  12097 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  12097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  12100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  12102 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  12106 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  12110 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  12114 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  12124 */     GIR_RootConstrainSelectedInstOperands,
     /*  12125 */     // GIR_Coverage, 4954,
     /*  12125 */     GIR_EraseRootFromParent_Done,
     /*  12126 */   // Label 311: @12126
     /*  12126 */   GIM_Try, /*On fail goto*//*Label 312*/ GIMT_Encode4(12264), // Rule ID 4955 //
     /*  12131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  12134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  12138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  12146 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12150 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12154 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12158 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  12162 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12166 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12170 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12174 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  12178 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12182 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12186 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12190 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  12194 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12198 */     // MIs[4] vA
     /*  12198 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  12203 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  12207 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  12211 */     // MIs[5] vC
     /*  12211 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  12216 */     // MIs[5] vB
     /*  12216 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  12221 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  12225 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  12231 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  12233 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  12235 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  12235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  12238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  12240 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  12244 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  12248 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  12252 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  12262 */     GIR_RootConstrainSelectedInstOperands,
     /*  12263 */     // GIR_Coverage, 4955,
     /*  12263 */     GIR_EraseRootFromParent_Done,
     /*  12264 */   // Label 312: @12264
     /*  12264 */   GIM_Try, /*On fail goto*//*Label 313*/ GIMT_Encode4(12402), // Rule ID 4962 //
     /*  12269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  12272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  12276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  12284 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12288 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12292 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12296 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  12300 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12304 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12308 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12312 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  12316 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12320 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12324 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12328 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  12332 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12336 */     // MIs[4] vC
     /*  12336 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  12341 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  12345 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  12349 */     // MIs[5] vA
     /*  12349 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  12354 */     // MIs[5] vB
     /*  12354 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  12359 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  12363 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  12369 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  12371 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  12373 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  12373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  12376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  12378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  12382 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*  12386 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  12390 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  12400 */     GIR_RootConstrainSelectedInstOperands,
     /*  12401 */     // GIR_Coverage, 4962,
     /*  12401 */     GIR_EraseRootFromParent_Done,
     /*  12402 */   // Label 313: @12402
     /*  12402 */   GIM_Try, /*On fail goto*//*Label 314*/ GIMT_Encode4(12540), // Rule ID 4963 //
     /*  12407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  12410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  12414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  12422 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12426 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12430 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12434 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  12438 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12442 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12446 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12450 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  12454 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12458 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12462 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12466 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  12470 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12474 */     // MIs[4] vC
     /*  12474 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  12479 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  12483 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  12487 */     // MIs[5] vB
     /*  12487 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  12492 */     // MIs[5] vA
     /*  12492 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  12497 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  12501 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  12507 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  12509 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  12511 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  12511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  12514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  12516 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  12520 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*  12524 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  12528 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  12538 */     GIR_RootConstrainSelectedInstOperands,
     /*  12539 */     // GIR_Coverage, 4963,
     /*  12539 */     GIR_EraseRootFromParent_Done,
     /*  12540 */   // Label 314: @12540
     /*  12540 */   GIM_Try, /*On fail goto*//*Label 315*/ GIMT_Encode4(12678), // Rule ID 4964 //
     /*  12545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  12548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  12552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  12560 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12564 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12568 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12572 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  12576 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12580 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12584 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12588 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  12592 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12596 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12600 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12604 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  12608 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12612 */     // MIs[4] vB
     /*  12612 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  12617 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  12621 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  12625 */     // MIs[5] vA
     /*  12625 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  12630 */     // MIs[5] vC
     /*  12630 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  12635 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  12639 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  12645 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  12647 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  12649 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  12649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  12652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  12654 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  12658 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*  12662 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  12666 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  12676 */     GIR_RootConstrainSelectedInstOperands,
     /*  12677 */     // GIR_Coverage, 4964,
     /*  12677 */     GIR_EraseRootFromParent_Done,
     /*  12678 */   // Label 315: @12678
     /*  12678 */   GIM_Try, /*On fail goto*//*Label 316*/ GIMT_Encode4(12816), // Rule ID 4965 //
     /*  12683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  12686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  12690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  12698 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12702 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12706 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12710 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  12714 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12718 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12722 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12726 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  12730 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12734 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12738 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12742 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  12746 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12750 */     // MIs[4] vB
     /*  12750 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  12755 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  12759 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  12763 */     // MIs[5] vC
     /*  12763 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  12768 */     // MIs[5] vA
     /*  12768 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  12773 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  12777 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  12783 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  12785 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  12787 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  12787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  12790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  12792 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  12796 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*  12800 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  12804 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  12814 */     GIR_RootConstrainSelectedInstOperands,
     /*  12815 */     // GIR_Coverage, 4965,
     /*  12815 */     GIR_EraseRootFromParent_Done,
     /*  12816 */   // Label 316: @12816
     /*  12816 */   GIM_Try, /*On fail goto*//*Label 317*/ GIMT_Encode4(12954), // Rule ID 4966 //
     /*  12821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  12824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  12828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  12836 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12840 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12844 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12848 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  12852 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12856 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12860 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12864 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  12868 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12872 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12876 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12880 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  12884 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12888 */     // MIs[4] vA
     /*  12888 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  12893 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  12897 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  12901 */     // MIs[5] vB
     /*  12901 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  12906 */     // MIs[5] vC
     /*  12906 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  12911 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  12915 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  12921 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  12923 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  12925 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  12925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  12928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  12930 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  12934 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*  12938 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  12942 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  12952 */     GIR_RootConstrainSelectedInstOperands,
     /*  12953 */     // GIR_Coverage, 4966,
     /*  12953 */     GIR_EraseRootFromParent_Done,
     /*  12954 */   // Label 317: @12954
     /*  12954 */   GIM_Try, /*On fail goto*//*Label 318*/ GIMT_Encode4(13092), // Rule ID 4967 //
     /*  12959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  12962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  12966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  12974 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12978 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12982 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12986 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  12990 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12994 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12998 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  13002 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  13006 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13010 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13014 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  13018 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  13022 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13026 */     // MIs[4] vA
     /*  13026 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  13031 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  13035 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  13039 */     // MIs[5] vC
     /*  13039 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  13044 */     // MIs[5] vB
     /*  13044 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  13049 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  13053 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  13059 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  13061 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  13063 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  13063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  13066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  13068 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  13072 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*  13076 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  13080 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  13090 */     GIR_RootConstrainSelectedInstOperands,
     /*  13091 */     // GIR_Coverage, 4967,
     /*  13091 */     GIR_EraseRootFromParent_Done,
     /*  13092 */   // Label 318: @13092
     /*  13092 */   GIM_Try, /*On fail goto*//*Label 319*/ GIMT_Encode4(13230), // Rule ID 4974 //
     /*  13097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  13100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  13104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  13112 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13116 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13120 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13124 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  13128 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13132 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13136 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  13140 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  13144 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13148 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13152 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  13156 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  13160 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13164 */     // MIs[4] vC
     /*  13164 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  13169 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  13173 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  13177 */     // MIs[5] vA
     /*  13177 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  13182 */     // MIs[5] vB
     /*  13182 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  13187 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  13191 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  13197 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  13199 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  13201 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  13201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  13204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  13206 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  13210 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*  13214 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  13218 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  13228 */     GIR_RootConstrainSelectedInstOperands,
     /*  13229 */     // GIR_Coverage, 4974,
     /*  13229 */     GIR_EraseRootFromParent_Done,
     /*  13230 */   // Label 319: @13230
     /*  13230 */   GIM_Try, /*On fail goto*//*Label 320*/ GIMT_Encode4(13368), // Rule ID 4975 //
     /*  13235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  13238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  13242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  13250 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13254 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13258 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13262 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  13266 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13270 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13274 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  13278 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  13282 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13286 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13290 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  13294 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  13298 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13302 */     // MIs[4] vC
     /*  13302 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  13307 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  13311 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  13315 */     // MIs[5] vB
     /*  13315 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  13320 */     // MIs[5] vA
     /*  13320 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  13325 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  13329 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  13335 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  13337 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  13339 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  13339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  13342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  13344 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  13348 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*  13352 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  13356 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  13366 */     GIR_RootConstrainSelectedInstOperands,
     /*  13367 */     // GIR_Coverage, 4975,
     /*  13367 */     GIR_EraseRootFromParent_Done,
     /*  13368 */   // Label 320: @13368
     /*  13368 */   GIM_Try, /*On fail goto*//*Label 321*/ GIMT_Encode4(13506), // Rule ID 4976 //
     /*  13373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  13376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  13380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  13388 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13392 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13396 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13400 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  13404 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13408 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13412 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  13416 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  13420 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13424 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13428 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  13432 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  13436 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13440 */     // MIs[4] vB
     /*  13440 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  13445 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  13449 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  13453 */     // MIs[5] vA
     /*  13453 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  13458 */     // MIs[5] vC
     /*  13458 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  13463 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  13467 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  13473 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  13475 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  13477 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  13477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  13480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  13482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  13486 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*  13490 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  13494 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  13504 */     GIR_RootConstrainSelectedInstOperands,
     /*  13505 */     // GIR_Coverage, 4976,
     /*  13505 */     GIR_EraseRootFromParent_Done,
     /*  13506 */   // Label 321: @13506
     /*  13506 */   GIM_Try, /*On fail goto*//*Label 322*/ GIMT_Encode4(13644), // Rule ID 4977 //
     /*  13511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  13514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  13518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  13526 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13530 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13534 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13538 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  13542 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13546 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13550 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  13554 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  13558 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13562 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13566 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  13570 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  13574 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13578 */     // MIs[4] vB
     /*  13578 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  13583 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  13587 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  13591 */     // MIs[5] vC
     /*  13591 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  13596 */     // MIs[5] vA
     /*  13596 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  13601 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  13605 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  13611 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  13613 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  13615 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  13615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  13618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  13620 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  13624 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*  13628 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  13632 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  13642 */     GIR_RootConstrainSelectedInstOperands,
     /*  13643 */     // GIR_Coverage, 4977,
     /*  13643 */     GIR_EraseRootFromParent_Done,
     /*  13644 */   // Label 322: @13644
     /*  13644 */   GIM_Try, /*On fail goto*//*Label 323*/ GIMT_Encode4(13782), // Rule ID 4978 //
     /*  13649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  13652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  13656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  13664 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13668 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13672 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13676 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  13680 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13684 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13688 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  13692 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  13696 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13700 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13704 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  13708 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  13712 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13716 */     // MIs[4] vA
     /*  13716 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  13721 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  13725 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  13729 */     // MIs[5] vB
     /*  13729 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  13734 */     // MIs[5] vC
     /*  13734 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  13739 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  13743 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  13749 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  13751 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  13753 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  13753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  13756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  13758 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  13762 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*  13766 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  13770 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  13780 */     GIR_RootConstrainSelectedInstOperands,
     /*  13781 */     // GIR_Coverage, 4978,
     /*  13781 */     GIR_EraseRootFromParent_Done,
     /*  13782 */   // Label 323: @13782
     /*  13782 */   GIM_Try, /*On fail goto*//*Label 324*/ GIMT_Encode4(13920), // Rule ID 4979 //
     /*  13787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  13790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  13794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  13802 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13806 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13810 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13814 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  13818 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13822 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13826 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  13830 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  13834 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13838 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13842 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  13846 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  13850 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13854 */     // MIs[4] vA
     /*  13854 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  13859 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  13863 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  13867 */     // MIs[5] vC
     /*  13867 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  13872 */     // MIs[5] vB
     /*  13872 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  13877 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  13881 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  13887 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  13889 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  13891 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  13891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  13894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  13896 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  13900 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*  13904 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  13908 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  13918 */     GIR_RootConstrainSelectedInstOperands,
     /*  13919 */     // GIR_Coverage, 4979,
     /*  13919 */     GIR_EraseRootFromParent_Done,
     /*  13920 */   // Label 324: @13920
     /*  13920 */   GIM_Try, /*On fail goto*//*Label 325*/ GIMT_Encode4(14058), // Rule ID 4986 //
     /*  13925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  13928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  13932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  13940 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13944 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13948 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13952 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  13956 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13960 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13964 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  13968 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  13972 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13976 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13980 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  13984 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  13988 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13992 */     // MIs[4] vC
     /*  13992 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  13997 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  14001 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  14005 */     // MIs[5] vA
     /*  14005 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  14010 */     // MIs[5] vB
     /*  14010 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  14015 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  14019 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  14025 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  14027 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  14029 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  14029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  14032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  14034 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  14038 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  14042 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  14046 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  14056 */     GIR_RootConstrainSelectedInstOperands,
     /*  14057 */     // GIR_Coverage, 4986,
     /*  14057 */     GIR_EraseRootFromParent_Done,
     /*  14058 */   // Label 325: @14058
     /*  14058 */   GIM_Try, /*On fail goto*//*Label 326*/ GIMT_Encode4(14196), // Rule ID 4987 //
     /*  14063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  14066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  14070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  14078 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14082 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14086 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14090 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  14094 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14098 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14102 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  14106 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  14110 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14114 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14118 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  14122 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  14126 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14130 */     // MIs[4] vC
     /*  14130 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  14135 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  14139 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  14143 */     // MIs[5] vB
     /*  14143 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  14148 */     // MIs[5] vA
     /*  14148 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  14153 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  14157 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  14163 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  14165 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  14167 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  14167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  14170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  14172 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  14176 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  14180 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  14184 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  14194 */     GIR_RootConstrainSelectedInstOperands,
     /*  14195 */     // GIR_Coverage, 4987,
     /*  14195 */     GIR_EraseRootFromParent_Done,
     /*  14196 */   // Label 326: @14196
     /*  14196 */   GIM_Try, /*On fail goto*//*Label 327*/ GIMT_Encode4(14334), // Rule ID 4988 //
     /*  14201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  14204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  14208 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14212 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  14216 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14220 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14224 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14228 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  14232 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14236 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14240 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  14244 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  14248 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14252 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14256 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  14260 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  14264 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14268 */     // MIs[4] vB
     /*  14268 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  14273 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  14277 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  14281 */     // MIs[5] vA
     /*  14281 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  14286 */     // MIs[5] vC
     /*  14286 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  14291 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  14295 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  14301 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  14303 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  14305 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  14305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  14308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  14310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  14314 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  14318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  14322 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  14332 */     GIR_RootConstrainSelectedInstOperands,
     /*  14333 */     // GIR_Coverage, 4988,
     /*  14333 */     GIR_EraseRootFromParent_Done,
     /*  14334 */   // Label 327: @14334
     /*  14334 */   GIM_Try, /*On fail goto*//*Label 328*/ GIMT_Encode4(14472), // Rule ID 4989 //
     /*  14339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  14342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  14346 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14350 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  14354 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14358 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14362 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14366 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  14370 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14374 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14378 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  14382 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  14386 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14390 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14394 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  14398 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  14402 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14406 */     // MIs[4] vB
     /*  14406 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  14411 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  14415 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  14419 */     // MIs[5] vC
     /*  14419 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  14424 */     // MIs[5] vA
     /*  14424 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  14429 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  14433 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  14439 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  14441 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  14443 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  14443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  14446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  14448 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  14452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  14456 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  14460 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  14470 */     GIR_RootConstrainSelectedInstOperands,
     /*  14471 */     // GIR_Coverage, 4989,
     /*  14471 */     GIR_EraseRootFromParent_Done,
     /*  14472 */   // Label 328: @14472
     /*  14472 */   GIM_Try, /*On fail goto*//*Label 329*/ GIMT_Encode4(14610), // Rule ID 4990 //
     /*  14477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  14480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  14484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  14492 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14496 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14500 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14504 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  14508 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14512 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14516 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  14520 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  14524 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14528 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14532 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  14536 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  14540 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14544 */     // MIs[4] vA
     /*  14544 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  14549 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  14553 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  14557 */     // MIs[5] vB
     /*  14557 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  14562 */     // MIs[5] vC
     /*  14562 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  14567 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  14571 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  14577 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  14579 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  14581 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  14581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  14584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  14586 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  14590 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  14594 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  14598 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  14608 */     GIR_RootConstrainSelectedInstOperands,
     /*  14609 */     // GIR_Coverage, 4990,
     /*  14609 */     GIR_EraseRootFromParent_Done,
     /*  14610 */   // Label 329: @14610
     /*  14610 */   GIM_Try, /*On fail goto*//*Label 330*/ GIMT_Encode4(14748), // Rule ID 4991 //
     /*  14615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  14618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  14622 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14626 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  14630 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14634 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14638 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14642 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  14646 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14650 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14654 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  14658 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  14662 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14666 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14670 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  14674 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  14678 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14682 */     // MIs[4] vA
     /*  14682 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  14687 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  14691 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  14695 */     // MIs[5] vC
     /*  14695 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  14700 */     // MIs[5] vB
     /*  14700 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  14705 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  14709 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  14715 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  14717 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  14719 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  14719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  14722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  14724 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  14728 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  14732 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  14736 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  14746 */     GIR_RootConstrainSelectedInstOperands,
     /*  14747 */     // GIR_Coverage, 4991,
     /*  14747 */     GIR_EraseRootFromParent_Done,
     /*  14748 */   // Label 330: @14748
     /*  14748 */   GIM_Try, /*On fail goto*//*Label 331*/ GIMT_Encode4(14886), // Rule ID 4998 //
     /*  14753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  14756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  14760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  14768 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14772 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14776 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14780 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  14784 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14788 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14792 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  14796 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  14800 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14804 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14808 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  14812 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  14816 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14820 */     // MIs[4] vC
     /*  14820 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  14825 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  14829 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  14833 */     // MIs[5] vA
     /*  14833 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  14838 */     // MIs[5] vB
     /*  14838 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  14843 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  14847 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  14853 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  14855 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  14857 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  14857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  14860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  14862 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  14866 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  14870 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  14874 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  14884 */     GIR_RootConstrainSelectedInstOperands,
     /*  14885 */     // GIR_Coverage, 4998,
     /*  14885 */     GIR_EraseRootFromParent_Done,
     /*  14886 */   // Label 331: @14886
     /*  14886 */   GIM_Try, /*On fail goto*//*Label 332*/ GIMT_Encode4(15024), // Rule ID 4999 //
     /*  14891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  14894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  14898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  14906 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14910 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14914 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14918 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  14922 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14926 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14930 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  14934 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  14938 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14942 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14946 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  14950 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  14954 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14958 */     // MIs[4] vC
     /*  14958 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  14963 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  14967 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  14971 */     // MIs[5] vB
     /*  14971 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  14976 */     // MIs[5] vA
     /*  14976 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  14981 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  14985 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  14991 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  14993 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  14995 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  14995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  14998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  15000 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  15004 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  15008 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  15012 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  15022 */     GIR_RootConstrainSelectedInstOperands,
     /*  15023 */     // GIR_Coverage, 4999,
     /*  15023 */     GIR_EraseRootFromParent_Done,
     /*  15024 */   // Label 332: @15024
     /*  15024 */   GIM_Try, /*On fail goto*//*Label 333*/ GIMT_Encode4(15162), // Rule ID 5000 //
     /*  15029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  15032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  15036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  15044 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15048 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15052 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  15056 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  15060 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15064 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15068 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  15072 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  15076 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15080 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15084 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  15088 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  15092 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15096 */     // MIs[4] vB
     /*  15096 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  15101 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  15105 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  15109 */     // MIs[5] vA
     /*  15109 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  15114 */     // MIs[5] vC
     /*  15114 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  15119 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  15123 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  15129 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  15131 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  15133 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  15133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  15136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  15138 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  15142 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  15146 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  15150 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  15160 */     GIR_RootConstrainSelectedInstOperands,
     /*  15161 */     // GIR_Coverage, 5000,
     /*  15161 */     GIR_EraseRootFromParent_Done,
     /*  15162 */   // Label 333: @15162
     /*  15162 */   GIM_Try, /*On fail goto*//*Label 334*/ GIMT_Encode4(15300), // Rule ID 5001 //
     /*  15167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  15170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  15174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  15182 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15186 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15190 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  15194 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  15198 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15202 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15206 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  15210 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  15214 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15218 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15222 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  15226 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  15230 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15234 */     // MIs[4] vB
     /*  15234 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  15239 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  15243 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  15247 */     // MIs[5] vC
     /*  15247 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  15252 */     // MIs[5] vA
     /*  15252 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  15257 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  15261 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  15267 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  15269 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  15271 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  15271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  15274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  15276 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  15280 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  15284 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  15288 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  15298 */     GIR_RootConstrainSelectedInstOperands,
     /*  15299 */     // GIR_Coverage, 5001,
     /*  15299 */     GIR_EraseRootFromParent_Done,
     /*  15300 */   // Label 334: @15300
     /*  15300 */   GIM_Try, /*On fail goto*//*Label 335*/ GIMT_Encode4(15438), // Rule ID 5002 //
     /*  15305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  15308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  15312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  15320 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15324 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15328 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  15332 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  15336 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15340 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15344 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  15348 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  15352 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15356 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15360 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  15364 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  15368 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15372 */     // MIs[4] vA
     /*  15372 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  15377 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  15381 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  15385 */     // MIs[5] vB
     /*  15385 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  15390 */     // MIs[5] vC
     /*  15390 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  15395 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  15399 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  15405 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  15407 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  15409 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  15409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  15412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  15414 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  15418 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  15422 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  15426 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  15436 */     GIR_RootConstrainSelectedInstOperands,
     /*  15437 */     // GIR_Coverage, 5002,
     /*  15437 */     GIR_EraseRootFromParent_Done,
     /*  15438 */   // Label 335: @15438
     /*  15438 */   GIM_Try, /*On fail goto*//*Label 336*/ GIMT_Encode4(15576), // Rule ID 5003 //
     /*  15443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  15446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  15450 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15454 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  15458 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15462 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15466 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  15470 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  15474 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15478 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15482 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  15486 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  15490 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15494 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15498 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  15502 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  15506 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15510 */     // MIs[4] vA
     /*  15510 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  15515 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  15519 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  15523 */     // MIs[5] vC
     /*  15523 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  15528 */     // MIs[5] vB
     /*  15528 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  15533 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  15537 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  15543 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  15545 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  15547 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  15547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  15550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  15552 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  15556 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  15560 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  15564 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  15574 */     GIR_RootConstrainSelectedInstOperands,
     /*  15575 */     // GIR_Coverage, 5003,
     /*  15575 */     GIR_EraseRootFromParent_Done,
     /*  15576 */   // Label 336: @15576
     /*  15576 */   GIM_Try, /*On fail goto*//*Label 337*/ GIMT_Encode4(15714), // Rule ID 5004 //
     /*  15581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  15584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  15588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  15596 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15600 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15604 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15608 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  15612 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15616 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15620 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  15624 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  15628 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15632 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15636 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  15640 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  15644 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15648 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  15652 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  15656 */     // MIs[5] vA
     /*  15656 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  15661 */     // MIs[5] vB
     /*  15661 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  15666 */     // MIs[4] vC
     /*  15666 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  15671 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  15675 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  15681 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  15683 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  15685 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  15685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  15688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  15690 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  15694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  15698 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  15702 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  15712 */     GIR_RootConstrainSelectedInstOperands,
     /*  15713 */     // GIR_Coverage, 5004,
     /*  15713 */     GIR_EraseRootFromParent_Done,
     /*  15714 */   // Label 337: @15714
     /*  15714 */   GIM_Try, /*On fail goto*//*Label 338*/ GIMT_Encode4(15852), // Rule ID 5005 //
     /*  15719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  15722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  15726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  15734 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15738 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15742 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15746 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  15750 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15754 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15758 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  15762 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  15766 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15770 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15774 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  15778 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  15782 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15786 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  15790 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  15794 */     // MIs[5] vB
     /*  15794 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  15799 */     // MIs[5] vA
     /*  15799 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  15804 */     // MIs[4] vC
     /*  15804 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  15809 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  15813 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  15819 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  15821 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  15823 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  15823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  15826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  15828 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  15832 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  15836 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  15840 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  15850 */     GIR_RootConstrainSelectedInstOperands,
     /*  15851 */     // GIR_Coverage, 5005,
     /*  15851 */     GIR_EraseRootFromParent_Done,
     /*  15852 */   // Label 338: @15852
     /*  15852 */   GIM_Try, /*On fail goto*//*Label 339*/ GIMT_Encode4(15990), // Rule ID 5006 //
     /*  15857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  15860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  15864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15868 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  15872 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15876 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15880 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15884 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  15888 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15892 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15896 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  15900 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  15904 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15908 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15912 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  15916 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  15920 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15924 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  15928 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  15932 */     // MIs[5] vA
     /*  15932 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  15937 */     // MIs[5] vC
     /*  15937 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  15942 */     // MIs[4] vB
     /*  15942 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  15947 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  15951 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  15957 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  15959 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  15961 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  15961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  15964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  15966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  15970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  15974 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  15978 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  15988 */     GIR_RootConstrainSelectedInstOperands,
     /*  15989 */     // GIR_Coverage, 5006,
     /*  15989 */     GIR_EraseRootFromParent_Done,
     /*  15990 */   // Label 339: @15990
     /*  15990 */   GIM_Try, /*On fail goto*//*Label 340*/ GIMT_Encode4(16128), // Rule ID 5007 //
     /*  15995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  15998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  16002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16010 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16014 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16018 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16022 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16026 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16030 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16034 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  16038 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16042 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16046 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16050 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  16054 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  16058 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16062 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  16066 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  16070 */     // MIs[5] vC
     /*  16070 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  16075 */     // MIs[5] vA
     /*  16075 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  16080 */     // MIs[4] vB
     /*  16080 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  16085 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  16089 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  16095 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  16097 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  16099 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  16099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  16102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  16104 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  16108 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  16112 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  16116 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  16126 */     GIR_RootConstrainSelectedInstOperands,
     /*  16127 */     // GIR_Coverage, 5007,
     /*  16127 */     GIR_EraseRootFromParent_Done,
     /*  16128 */   // Label 340: @16128
     /*  16128 */   GIM_Try, /*On fail goto*//*Label 341*/ GIMT_Encode4(16266), // Rule ID 5008 //
     /*  16133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  16136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  16140 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16144 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16148 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16152 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16156 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16160 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16164 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16168 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16172 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  16176 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16180 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16184 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16188 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  16192 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  16196 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16200 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  16204 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  16208 */     // MIs[5] vB
     /*  16208 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  16213 */     // MIs[5] vC
     /*  16213 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  16218 */     // MIs[4] vA
     /*  16218 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  16223 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  16227 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  16233 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  16235 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  16237 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  16237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  16240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  16242 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  16246 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  16250 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  16254 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  16264 */     GIR_RootConstrainSelectedInstOperands,
     /*  16265 */     // GIR_Coverage, 5008,
     /*  16265 */     GIR_EraseRootFromParent_Done,
     /*  16266 */   // Label 341: @16266
     /*  16266 */   GIM_Try, /*On fail goto*//*Label 342*/ GIMT_Encode4(16404), // Rule ID 5009 //
     /*  16271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  16274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  16278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16286 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16290 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16294 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16298 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16302 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16306 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16310 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  16314 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16318 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16322 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16326 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  16330 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  16334 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16338 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  16342 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  16346 */     // MIs[5] vC
     /*  16346 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  16351 */     // MIs[5] vB
     /*  16351 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  16356 */     // MIs[4] vA
     /*  16356 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  16361 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  16365 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  16371 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  16373 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  16375 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  16375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  16378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  16380 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  16384 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  16388 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  16392 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  16402 */     GIR_RootConstrainSelectedInstOperands,
     /*  16403 */     // GIR_Coverage, 5009,
     /*  16403 */     GIR_EraseRootFromParent_Done,
     /*  16404 */   // Label 342: @16404
     /*  16404 */   GIM_Try, /*On fail goto*//*Label 343*/ GIMT_Encode4(16542), // Rule ID 5016 //
     /*  16409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  16412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  16416 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16420 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16424 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16428 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16432 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16436 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16440 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16444 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16448 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  16452 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16456 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16460 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16464 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  16468 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  16472 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16476 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  16480 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  16484 */     // MIs[5] vA
     /*  16484 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  16489 */     // MIs[5] vB
     /*  16489 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  16494 */     // MIs[4] vC
     /*  16494 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  16499 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  16503 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  16509 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  16511 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  16513 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  16513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  16516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  16518 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  16522 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  16526 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  16530 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  16540 */     GIR_RootConstrainSelectedInstOperands,
     /*  16541 */     // GIR_Coverage, 5016,
     /*  16541 */     GIR_EraseRootFromParent_Done,
     /*  16542 */   // Label 343: @16542
     /*  16542 */   GIM_Try, /*On fail goto*//*Label 344*/ GIMT_Encode4(16680), // Rule ID 5017 //
     /*  16547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  16550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  16554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16562 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16566 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16570 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16574 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16578 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16582 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16586 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  16590 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16594 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16598 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16602 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  16606 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  16610 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16614 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  16618 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  16622 */     // MIs[5] vB
     /*  16622 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  16627 */     // MIs[5] vA
     /*  16627 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  16632 */     // MIs[4] vC
     /*  16632 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  16637 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  16641 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  16647 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  16649 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  16651 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  16651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  16654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  16656 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  16660 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  16664 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  16668 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  16678 */     GIR_RootConstrainSelectedInstOperands,
     /*  16679 */     // GIR_Coverage, 5017,
     /*  16679 */     GIR_EraseRootFromParent_Done,
     /*  16680 */   // Label 344: @16680
     /*  16680 */   GIM_Try, /*On fail goto*//*Label 345*/ GIMT_Encode4(16818), // Rule ID 5018 //
     /*  16685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  16688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  16692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16700 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16704 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16708 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16712 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16716 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16720 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16724 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  16728 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16732 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16736 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16740 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  16744 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  16748 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16752 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  16756 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  16760 */     // MIs[5] vA
     /*  16760 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  16765 */     // MIs[5] vC
     /*  16765 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  16770 */     // MIs[4] vB
     /*  16770 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  16775 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  16779 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  16785 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  16787 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  16789 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  16789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  16792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  16794 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  16798 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  16802 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  16806 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  16816 */     GIR_RootConstrainSelectedInstOperands,
     /*  16817 */     // GIR_Coverage, 5018,
     /*  16817 */     GIR_EraseRootFromParent_Done,
     /*  16818 */   // Label 345: @16818
     /*  16818 */   GIM_Try, /*On fail goto*//*Label 346*/ GIMT_Encode4(16956), // Rule ID 5019 //
     /*  16823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  16826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  16830 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16834 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16838 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16842 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16846 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16850 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16854 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16858 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16862 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  16866 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16870 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16874 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16878 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  16882 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  16886 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16890 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  16894 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  16898 */     // MIs[5] vC
     /*  16898 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  16903 */     // MIs[5] vA
     /*  16903 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  16908 */     // MIs[4] vB
     /*  16908 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  16913 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  16917 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  16923 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  16925 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  16927 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  16927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  16930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  16932 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  16936 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  16940 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  16944 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  16954 */     GIR_RootConstrainSelectedInstOperands,
     /*  16955 */     // GIR_Coverage, 5019,
     /*  16955 */     GIR_EraseRootFromParent_Done,
     /*  16956 */   // Label 346: @16956
     /*  16956 */   GIM_Try, /*On fail goto*//*Label 347*/ GIMT_Encode4(17094), // Rule ID 5020 //
     /*  16961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  16964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  16968 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16972 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16976 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16980 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16984 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16988 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16992 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16996 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17000 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  17004 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  17008 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17012 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17016 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  17020 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  17024 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17028 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  17032 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  17036 */     // MIs[5] vB
     /*  17036 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  17041 */     // MIs[5] vC
     /*  17041 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  17046 */     // MIs[4] vA
     /*  17046 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  17051 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  17055 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  17061 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  17063 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  17065 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  17065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  17068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  17070 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  17074 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  17078 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  17082 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  17092 */     GIR_RootConstrainSelectedInstOperands,
     /*  17093 */     // GIR_Coverage, 5020,
     /*  17093 */     GIR_EraseRootFromParent_Done,
     /*  17094 */   // Label 347: @17094
     /*  17094 */   GIM_Try, /*On fail goto*//*Label 348*/ GIMT_Encode4(17232), // Rule ID 5021 //
     /*  17099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  17102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  17106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17110 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17114 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17118 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17122 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17126 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17130 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17134 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17138 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  17142 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  17146 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17150 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17154 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  17158 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  17162 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17166 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  17170 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  17174 */     // MIs[5] vC
     /*  17174 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  17179 */     // MIs[5] vB
     /*  17179 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  17184 */     // MIs[4] vA
     /*  17184 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  17189 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  17193 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  17199 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  17201 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  17203 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  17203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  17206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  17208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  17212 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  17216 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  17220 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  17230 */     GIR_RootConstrainSelectedInstOperands,
     /*  17231 */     // GIR_Coverage, 5021,
     /*  17231 */     GIR_EraseRootFromParent_Done,
     /*  17232 */   // Label 348: @17232
     /*  17232 */   GIM_Try, /*On fail goto*//*Label 349*/ GIMT_Encode4(17370), // Rule ID 5028 //
     /*  17237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  17240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  17244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17252 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17256 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17260 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17264 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17268 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17272 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17276 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  17280 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  17284 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17288 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17292 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  17296 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  17300 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17304 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  17308 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  17312 */     // MIs[5] vA
     /*  17312 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  17317 */     // MIs[5] vB
     /*  17317 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  17322 */     // MIs[4] vC
     /*  17322 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  17327 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  17331 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  17337 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  17339 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  17341 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  17341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  17344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  17346 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  17350 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  17354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  17358 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  17368 */     GIR_RootConstrainSelectedInstOperands,
     /*  17369 */     // GIR_Coverage, 5028,
     /*  17369 */     GIR_EraseRootFromParent_Done,
     /*  17370 */   // Label 349: @17370
     /*  17370 */   GIM_Try, /*On fail goto*//*Label 350*/ GIMT_Encode4(17508), // Rule ID 5029 //
     /*  17375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  17378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  17382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17390 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17394 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17398 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17402 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17406 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17410 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17414 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  17418 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  17422 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17426 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17430 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  17434 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  17438 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17442 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  17446 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  17450 */     // MIs[5] vB
     /*  17450 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  17455 */     // MIs[5] vA
     /*  17455 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  17460 */     // MIs[4] vC
     /*  17460 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  17465 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  17469 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  17475 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  17477 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  17479 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  17479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  17482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  17484 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  17488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  17492 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  17496 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  17506 */     GIR_RootConstrainSelectedInstOperands,
     /*  17507 */     // GIR_Coverage, 5029,
     /*  17507 */     GIR_EraseRootFromParent_Done,
     /*  17508 */   // Label 350: @17508
     /*  17508 */   GIM_Try, /*On fail goto*//*Label 351*/ GIMT_Encode4(17646), // Rule ID 5030 //
     /*  17513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  17516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  17520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17528 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17532 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17536 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17540 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17544 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17548 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17552 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  17556 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  17560 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17564 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17568 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  17572 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  17576 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17580 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  17584 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  17588 */     // MIs[5] vA
     /*  17588 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  17593 */     // MIs[5] vC
     /*  17593 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  17598 */     // MIs[4] vB
     /*  17598 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  17603 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  17607 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  17613 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  17615 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  17617 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  17617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  17620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  17622 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  17626 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  17630 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  17634 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  17644 */     GIR_RootConstrainSelectedInstOperands,
     /*  17645 */     // GIR_Coverage, 5030,
     /*  17645 */     GIR_EraseRootFromParent_Done,
     /*  17646 */   // Label 351: @17646
     /*  17646 */   GIM_Try, /*On fail goto*//*Label 352*/ GIMT_Encode4(17784), // Rule ID 5031 //
     /*  17651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  17654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  17658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17666 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17670 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17674 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17678 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17682 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17686 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17690 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  17694 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  17698 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17702 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17706 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  17710 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  17714 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17718 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  17722 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  17726 */     // MIs[5] vC
     /*  17726 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  17731 */     // MIs[5] vA
     /*  17731 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  17736 */     // MIs[4] vB
     /*  17736 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  17741 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  17745 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  17751 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  17753 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  17755 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  17755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  17758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  17760 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  17764 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  17768 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  17772 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  17782 */     GIR_RootConstrainSelectedInstOperands,
     /*  17783 */     // GIR_Coverage, 5031,
     /*  17783 */     GIR_EraseRootFromParent_Done,
     /*  17784 */   // Label 352: @17784
     /*  17784 */   GIM_Try, /*On fail goto*//*Label 353*/ GIMT_Encode4(17922), // Rule ID 5032 //
     /*  17789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  17792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  17796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17804 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17808 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17812 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17816 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17820 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17824 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17828 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  17832 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  17836 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17840 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17844 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  17848 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  17852 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17856 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  17860 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  17864 */     // MIs[5] vB
     /*  17864 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  17869 */     // MIs[5] vC
     /*  17869 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  17874 */     // MIs[4] vA
     /*  17874 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  17879 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  17883 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  17889 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  17891 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  17893 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  17893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  17896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  17898 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  17902 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  17906 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  17910 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  17920 */     GIR_RootConstrainSelectedInstOperands,
     /*  17921 */     // GIR_Coverage, 5032,
     /*  17921 */     GIR_EraseRootFromParent_Done,
     /*  17922 */   // Label 353: @17922
     /*  17922 */   GIM_Try, /*On fail goto*//*Label 354*/ GIMT_Encode4(18060), // Rule ID 5033 //
     /*  17927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  17930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  17934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17942 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17946 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17950 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17954 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17958 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17962 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17966 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  17970 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  17974 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17978 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17982 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  17986 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  17990 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17994 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  17998 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  18002 */     // MIs[5] vC
     /*  18002 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  18007 */     // MIs[5] vB
     /*  18007 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  18012 */     // MIs[4] vA
     /*  18012 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  18017 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  18021 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  18027 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  18029 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  18031 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  18031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  18034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  18036 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  18040 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  18044 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  18048 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  18058 */     GIR_RootConstrainSelectedInstOperands,
     /*  18059 */     // GIR_Coverage, 5033,
     /*  18059 */     GIR_EraseRootFromParent_Done,
     /*  18060 */   // Label 354: @18060
     /*  18060 */   GIM_Try, /*On fail goto*//*Label 355*/ GIMT_Encode4(18198), // Rule ID 5040 //
     /*  18065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  18068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  18072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18080 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18084 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18088 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  18092 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18096 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18100 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18104 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  18108 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  18112 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18116 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18120 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  18124 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  18128 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18132 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  18136 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  18140 */     // MIs[5] vA
     /*  18140 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  18145 */     // MIs[5] vB
     /*  18145 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  18150 */     // MIs[4] vC
     /*  18150 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  18155 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  18159 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  18165 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  18167 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  18169 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  18169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  18172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  18174 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  18178 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  18182 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  18186 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  18196 */     GIR_RootConstrainSelectedInstOperands,
     /*  18197 */     // GIR_Coverage, 5040,
     /*  18197 */     GIR_EraseRootFromParent_Done,
     /*  18198 */   // Label 355: @18198
     /*  18198 */   GIM_Try, /*On fail goto*//*Label 356*/ GIMT_Encode4(18336), // Rule ID 5041 //
     /*  18203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  18206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  18210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18218 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18222 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18226 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  18230 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18234 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18238 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18242 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  18246 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  18250 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18254 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18258 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  18262 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  18266 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18270 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  18274 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  18278 */     // MIs[5] vB
     /*  18278 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  18283 */     // MIs[5] vA
     /*  18283 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  18288 */     // MIs[4] vC
     /*  18288 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  18293 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  18297 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  18303 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  18305 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  18307 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  18307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  18310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  18312 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  18316 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  18320 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  18324 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  18334 */     GIR_RootConstrainSelectedInstOperands,
     /*  18335 */     // GIR_Coverage, 5041,
     /*  18335 */     GIR_EraseRootFromParent_Done,
     /*  18336 */   // Label 356: @18336
     /*  18336 */   GIM_Try, /*On fail goto*//*Label 357*/ GIMT_Encode4(18474), // Rule ID 5042 //
     /*  18341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  18344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  18348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18356 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18360 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18364 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  18368 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18372 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18376 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18380 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  18384 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  18388 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18392 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18396 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  18400 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  18404 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18408 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  18412 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  18416 */     // MIs[5] vA
     /*  18416 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  18421 */     // MIs[5] vC
     /*  18421 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  18426 */     // MIs[4] vB
     /*  18426 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  18431 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  18435 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  18441 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  18443 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  18445 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  18445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  18448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  18450 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  18454 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  18458 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  18462 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  18472 */     GIR_RootConstrainSelectedInstOperands,
     /*  18473 */     // GIR_Coverage, 5042,
     /*  18473 */     GIR_EraseRootFromParent_Done,
     /*  18474 */   // Label 357: @18474
     /*  18474 */   GIM_Try, /*On fail goto*//*Label 358*/ GIMT_Encode4(18612), // Rule ID 5043 //
     /*  18479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  18482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  18486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18494 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18498 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18502 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  18506 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18510 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18514 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18518 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  18522 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  18526 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18530 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18534 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  18538 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  18542 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18546 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  18550 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  18554 */     // MIs[5] vC
     /*  18554 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  18559 */     // MIs[5] vA
     /*  18559 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  18564 */     // MIs[4] vB
     /*  18564 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  18569 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  18573 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  18579 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  18581 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  18583 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  18583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  18586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  18588 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  18592 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  18596 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  18600 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  18610 */     GIR_RootConstrainSelectedInstOperands,
     /*  18611 */     // GIR_Coverage, 5043,
     /*  18611 */     GIR_EraseRootFromParent_Done,
     /*  18612 */   // Label 358: @18612
     /*  18612 */   GIM_Try, /*On fail goto*//*Label 359*/ GIMT_Encode4(18750), // Rule ID 5044 //
     /*  18617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  18620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  18624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18632 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18636 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18640 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  18644 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18648 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18652 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18656 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  18660 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  18664 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18668 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18672 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  18676 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  18680 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18684 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  18688 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  18692 */     // MIs[5] vB
     /*  18692 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  18697 */     // MIs[5] vC
     /*  18697 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  18702 */     // MIs[4] vA
     /*  18702 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  18707 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  18711 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  18717 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  18719 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  18721 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  18721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  18724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  18726 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  18730 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  18734 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  18738 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  18748 */     GIR_RootConstrainSelectedInstOperands,
     /*  18749 */     // GIR_Coverage, 5044,
     /*  18749 */     GIR_EraseRootFromParent_Done,
     /*  18750 */   // Label 359: @18750
     /*  18750 */   GIM_Try, /*On fail goto*//*Label 360*/ GIMT_Encode4(18888), // Rule ID 5045 //
     /*  18755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  18758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  18762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18770 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18774 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18778 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  18782 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18786 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18790 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18794 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  18798 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  18802 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18806 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18810 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  18814 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  18818 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18822 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  18826 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  18830 */     // MIs[5] vC
     /*  18830 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  18835 */     // MIs[5] vB
     /*  18835 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  18840 */     // MIs[4] vA
     /*  18840 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  18845 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  18849 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  18855 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  18857 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  18859 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  18859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  18862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  18864 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  18868 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  18872 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  18876 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  18886 */     GIR_RootConstrainSelectedInstOperands,
     /*  18887 */     // GIR_Coverage, 5045,
     /*  18887 */     GIR_EraseRootFromParent_Done,
     /*  18888 */   // Label 360: @18888
     /*  18888 */   GIM_Try, /*On fail goto*//*Label 361*/ GIMT_Encode4(19026), // Rule ID 5052 //
     /*  18893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  18896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  18900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18908 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18912 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18916 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  18920 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18924 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18928 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18932 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  18936 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  18940 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18944 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18948 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  18952 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  18956 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18960 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  18964 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  18968 */     // MIs[5] vA
     /*  18968 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  18973 */     // MIs[5] vB
     /*  18973 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  18978 */     // MIs[4] vC
     /*  18978 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  18983 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  18987 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  18993 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  18995 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  18997 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  18997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  19000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  19002 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  19006 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  19010 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  19014 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  19024 */     GIR_RootConstrainSelectedInstOperands,
     /*  19025 */     // GIR_Coverage, 5052,
     /*  19025 */     GIR_EraseRootFromParent_Done,
     /*  19026 */   // Label 361: @19026
     /*  19026 */   GIM_Try, /*On fail goto*//*Label 362*/ GIMT_Encode4(19164), // Rule ID 5053 //
     /*  19031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  19034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  19038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19046 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19050 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19054 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19058 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19062 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19066 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19070 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  19074 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  19078 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19082 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19086 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  19090 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  19094 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19098 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  19102 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  19106 */     // MIs[5] vB
     /*  19106 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  19111 */     // MIs[5] vA
     /*  19111 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  19116 */     // MIs[4] vC
     /*  19116 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  19121 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  19125 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  19131 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  19133 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  19135 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  19135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  19138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  19140 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  19144 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  19148 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  19152 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  19162 */     GIR_RootConstrainSelectedInstOperands,
     /*  19163 */     // GIR_Coverage, 5053,
     /*  19163 */     GIR_EraseRootFromParent_Done,
     /*  19164 */   // Label 362: @19164
     /*  19164 */   GIM_Try, /*On fail goto*//*Label 363*/ GIMT_Encode4(19302), // Rule ID 5054 //
     /*  19169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  19172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  19176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19184 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19188 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19192 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19196 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19200 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19204 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19208 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  19212 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  19216 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19220 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19224 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  19228 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  19232 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19236 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  19240 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  19244 */     // MIs[5] vA
     /*  19244 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  19249 */     // MIs[5] vC
     /*  19249 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  19254 */     // MIs[4] vB
     /*  19254 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  19259 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  19263 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  19269 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  19271 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  19273 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  19273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  19276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  19278 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  19282 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  19286 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  19290 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  19300 */     GIR_RootConstrainSelectedInstOperands,
     /*  19301 */     // GIR_Coverage, 5054,
     /*  19301 */     GIR_EraseRootFromParent_Done,
     /*  19302 */   // Label 363: @19302
     /*  19302 */   GIM_Try, /*On fail goto*//*Label 364*/ GIMT_Encode4(19440), // Rule ID 5055 //
     /*  19307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  19310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  19314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19322 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19326 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19330 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19334 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19338 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19342 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19346 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  19350 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  19354 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19358 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19362 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  19366 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  19370 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19374 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  19378 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  19382 */     // MIs[5] vC
     /*  19382 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  19387 */     // MIs[5] vA
     /*  19387 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  19392 */     // MIs[4] vB
     /*  19392 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  19397 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  19401 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  19407 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  19409 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  19411 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  19411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  19414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  19416 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  19420 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  19424 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  19428 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  19438 */     GIR_RootConstrainSelectedInstOperands,
     /*  19439 */     // GIR_Coverage, 5055,
     /*  19439 */     GIR_EraseRootFromParent_Done,
     /*  19440 */   // Label 364: @19440
     /*  19440 */   GIM_Try, /*On fail goto*//*Label 365*/ GIMT_Encode4(19578), // Rule ID 5056 //
     /*  19445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  19448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  19452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19460 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19464 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19468 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19472 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19476 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19480 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19484 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  19488 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  19492 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19496 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19500 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  19504 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  19508 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19512 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  19516 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  19520 */     // MIs[5] vB
     /*  19520 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  19525 */     // MIs[5] vC
     /*  19525 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  19530 */     // MIs[4] vA
     /*  19530 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  19535 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  19539 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  19545 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  19547 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  19549 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  19549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  19552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  19554 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  19558 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  19562 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  19566 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  19576 */     GIR_RootConstrainSelectedInstOperands,
     /*  19577 */     // GIR_Coverage, 5056,
     /*  19577 */     GIR_EraseRootFromParent_Done,
     /*  19578 */   // Label 365: @19578
     /*  19578 */   GIM_Try, /*On fail goto*//*Label 366*/ GIMT_Encode4(19716), // Rule ID 5057 //
     /*  19583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  19586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  19590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19598 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19602 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19606 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19610 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19614 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19618 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19622 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  19626 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  19630 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19634 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19638 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  19642 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  19646 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19650 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  19654 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  19658 */     // MIs[5] vC
     /*  19658 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  19663 */     // MIs[5] vB
     /*  19663 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  19668 */     // MIs[4] vA
     /*  19668 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  19673 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  19677 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  19683 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  19685 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  19687 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  19687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  19690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  19692 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  19696 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  19700 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  19704 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  19714 */     GIR_RootConstrainSelectedInstOperands,
     /*  19715 */     // GIR_Coverage, 5057,
     /*  19715 */     GIR_EraseRootFromParent_Done,
     /*  19716 */   // Label 366: @19716
     /*  19716 */   GIM_Try, /*On fail goto*//*Label 367*/ GIMT_Encode4(19854), // Rule ID 5063 //
     /*  19721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  19724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  19728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19736 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19740 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19744 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19748 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19752 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19756 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19760 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  19764 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  19768 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19772 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19776 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  19780 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  19784 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19788 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  19792 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  19796 */     // MIs[5] vA
     /*  19796 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  19801 */     // MIs[5] vB
     /*  19801 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  19806 */     // MIs[4] vC
     /*  19806 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  19811 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  19815 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  19821 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  19823 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  19825 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  19825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  19828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  19830 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  19834 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  19838 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  19842 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  19852 */     GIR_RootConstrainSelectedInstOperands,
     /*  19853 */     // GIR_Coverage, 5063,
     /*  19853 */     GIR_EraseRootFromParent_Done,
     /*  19854 */   // Label 367: @19854
     /*  19854 */   GIM_Try, /*On fail goto*//*Label 368*/ GIMT_Encode4(19992), // Rule ID 5064 //
     /*  19859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  19862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  19866 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19870 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19874 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19878 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19882 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19886 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19890 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19894 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19898 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  19902 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  19906 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19910 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19914 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  19918 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  19922 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19926 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  19930 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  19934 */     // MIs[5] vB
     /*  19934 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  19939 */     // MIs[5] vA
     /*  19939 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  19944 */     // MIs[4] vC
     /*  19944 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  19949 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  19953 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  19959 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  19961 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  19963 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  19963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  19966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  19968 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  19972 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  19976 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  19980 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  19990 */     GIR_RootConstrainSelectedInstOperands,
     /*  19991 */     // GIR_Coverage, 5064,
     /*  19991 */     GIR_EraseRootFromParent_Done,
     /*  19992 */   // Label 368: @19992
     /*  19992 */   GIM_Try, /*On fail goto*//*Label 369*/ GIMT_Encode4(20130), // Rule ID 5065 //
     /*  19997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  20000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  20004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20012 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20016 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20020 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  20024 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20028 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20032 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20036 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  20040 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  20044 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20048 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20052 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  20056 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  20060 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20064 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  20068 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  20072 */     // MIs[5] vA
     /*  20072 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  20077 */     // MIs[5] vC
     /*  20077 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  20082 */     // MIs[4] vB
     /*  20082 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  20087 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  20091 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  20097 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  20099 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  20101 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  20101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  20104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  20106 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  20110 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  20114 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  20118 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  20128 */     GIR_RootConstrainSelectedInstOperands,
     /*  20129 */     // GIR_Coverage, 5065,
     /*  20129 */     GIR_EraseRootFromParent_Done,
     /*  20130 */   // Label 369: @20130
     /*  20130 */   GIM_Try, /*On fail goto*//*Label 370*/ GIMT_Encode4(20268), // Rule ID 5066 //
     /*  20135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  20138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  20142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20150 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20154 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20158 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  20162 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20166 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20170 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20174 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  20178 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  20182 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20186 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20190 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  20194 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  20198 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20202 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  20206 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  20210 */     // MIs[5] vC
     /*  20210 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  20215 */     // MIs[5] vA
     /*  20215 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  20220 */     // MIs[4] vB
     /*  20220 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  20225 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  20229 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  20235 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  20237 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  20239 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  20239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  20242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  20244 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  20248 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  20252 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  20256 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  20266 */     GIR_RootConstrainSelectedInstOperands,
     /*  20267 */     // GIR_Coverage, 5066,
     /*  20267 */     GIR_EraseRootFromParent_Done,
     /*  20268 */   // Label 370: @20268
     /*  20268 */   GIM_Try, /*On fail goto*//*Label 371*/ GIMT_Encode4(20406), // Rule ID 5067 //
     /*  20273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  20276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  20280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20288 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20292 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20296 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  20300 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20304 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20308 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20312 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  20316 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  20320 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20324 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20328 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  20332 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  20336 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20340 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  20344 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  20348 */     // MIs[5] vB
     /*  20348 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  20353 */     // MIs[5] vC
     /*  20353 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  20358 */     // MIs[4] vA
     /*  20358 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  20363 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  20367 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  20373 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  20375 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  20377 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  20377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  20380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  20382 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  20386 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  20390 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  20394 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  20404 */     GIR_RootConstrainSelectedInstOperands,
     /*  20405 */     // GIR_Coverage, 5067,
     /*  20405 */     GIR_EraseRootFromParent_Done,
     /*  20406 */   // Label 371: @20406
     /*  20406 */   GIM_Try, /*On fail goto*//*Label 372*/ GIMT_Encode4(20544), // Rule ID 5068 //
     /*  20411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  20414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  20418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20426 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20430 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20434 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  20438 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20442 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20446 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20450 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  20454 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  20458 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20462 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20466 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  20470 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  20474 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20478 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  20482 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  20486 */     // MIs[5] vC
     /*  20486 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  20491 */     // MIs[5] vB
     /*  20491 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  20496 */     // MIs[4] vA
     /*  20496 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  20501 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  20505 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  20511 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  20513 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  20515 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  20515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  20518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  20520 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  20524 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  20528 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  20532 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  20542 */     GIR_RootConstrainSelectedInstOperands,
     /*  20543 */     // GIR_Coverage, 5068,
     /*  20543 */     GIR_EraseRootFromParent_Done,
     /*  20544 */   // Label 372: @20544
     /*  20544 */   GIM_Try, /*On fail goto*//*Label 373*/ GIMT_Encode4(20682), // Rule ID 3388 //
     /*  20549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  20552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  20556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20564 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20568 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20572 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  20576 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20580 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20584 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20588 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  20592 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  20596 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20600 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20604 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  20608 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  20612 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20616 */     // MIs[4] vA
     /*  20616 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  20621 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  20625 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  20629 */     // MIs[5] vB
     /*  20629 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  20634 */     // MIs[5] vC
     /*  20634 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  20639 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  20643 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  20649 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  20651 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  20653 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  20653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  20656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  20658 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  20662 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  20666 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  20670 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  20680 */     GIR_RootConstrainSelectedInstOperands,
     /*  20681 */     // GIR_Coverage, 3388,
     /*  20681 */     GIR_EraseRootFromParent_Done,
     /*  20682 */   // Label 373: @20682
     /*  20682 */   GIM_Try, /*On fail goto*//*Label 374*/ GIMT_Encode4(20820), // Rule ID 5010 //
     /*  20687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  20690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  20694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20702 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20706 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20710 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  20714 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20718 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20722 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20726 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  20730 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  20734 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20738 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20742 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  20746 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  20750 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20754 */     // MIs[4] vC
     /*  20754 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  20759 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  20763 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  20767 */     // MIs[5] vA
     /*  20767 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  20772 */     // MIs[5] vB
     /*  20772 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  20777 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  20781 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  20787 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  20789 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  20791 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  20791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  20794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  20796 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  20800 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  20804 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  20808 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  20818 */     GIR_RootConstrainSelectedInstOperands,
     /*  20819 */     // GIR_Coverage, 5010,
     /*  20819 */     GIR_EraseRootFromParent_Done,
     /*  20820 */   // Label 374: @20820
     /*  20820 */   GIM_Try, /*On fail goto*//*Label 375*/ GIMT_Encode4(20958), // Rule ID 5011 //
     /*  20825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  20828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  20832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20840 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20844 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20848 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  20852 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20856 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20860 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20864 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  20868 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  20872 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20876 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20880 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  20884 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  20888 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20892 */     // MIs[4] vC
     /*  20892 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  20897 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  20901 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  20905 */     // MIs[5] vB
     /*  20905 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  20910 */     // MIs[5] vA
     /*  20910 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  20915 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  20919 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  20925 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  20927 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  20929 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  20929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  20932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  20934 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  20938 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  20942 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  20946 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  20956 */     GIR_RootConstrainSelectedInstOperands,
     /*  20957 */     // GIR_Coverage, 5011,
     /*  20957 */     GIR_EraseRootFromParent_Done,
     /*  20958 */   // Label 375: @20958
     /*  20958 */   GIM_Try, /*On fail goto*//*Label 376*/ GIMT_Encode4(21096), // Rule ID 5012 //
     /*  20963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  20966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  20970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20978 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20982 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20986 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  20990 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20994 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20998 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21002 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21006 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  21010 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21014 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21018 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21022 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  21026 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21030 */     // MIs[4] vB
     /*  21030 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  21035 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  21039 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  21043 */     // MIs[5] vA
     /*  21043 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  21048 */     // MIs[5] vC
     /*  21048 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  21053 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  21057 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  21063 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  21065 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  21067 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  21067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  21070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  21072 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  21076 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  21080 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  21084 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  21094 */     GIR_RootConstrainSelectedInstOperands,
     /*  21095 */     // GIR_Coverage, 5012,
     /*  21095 */     GIR_EraseRootFromParent_Done,
     /*  21096 */   // Label 376: @21096
     /*  21096 */   GIM_Try, /*On fail goto*//*Label 377*/ GIMT_Encode4(21234), // Rule ID 5013 //
     /*  21101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  21104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  21108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21116 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21120 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21124 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  21128 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21132 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21136 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21140 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21144 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  21148 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21152 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21156 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21160 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  21164 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21168 */     // MIs[4] vB
     /*  21168 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  21173 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  21177 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  21181 */     // MIs[5] vC
     /*  21181 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  21186 */     // MIs[5] vA
     /*  21186 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  21191 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  21195 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  21201 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  21203 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  21205 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  21205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  21208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  21210 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  21214 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  21218 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  21222 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  21232 */     GIR_RootConstrainSelectedInstOperands,
     /*  21233 */     // GIR_Coverage, 5013,
     /*  21233 */     GIR_EraseRootFromParent_Done,
     /*  21234 */   // Label 377: @21234
     /*  21234 */   GIM_Try, /*On fail goto*//*Label 378*/ GIMT_Encode4(21372), // Rule ID 5014 //
     /*  21239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  21242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  21246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21254 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21258 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21262 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  21266 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21270 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21274 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21278 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21282 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  21286 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21290 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21294 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21298 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  21302 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21306 */     // MIs[4] vA
     /*  21306 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  21311 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  21315 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  21319 */     // MIs[5] vB
     /*  21319 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  21324 */     // MIs[5] vC
     /*  21324 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  21329 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  21333 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  21339 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  21341 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  21343 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  21343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  21346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  21348 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  21352 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  21356 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  21360 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  21370 */     GIR_RootConstrainSelectedInstOperands,
     /*  21371 */     // GIR_Coverage, 5014,
     /*  21371 */     GIR_EraseRootFromParent_Done,
     /*  21372 */   // Label 378: @21372
     /*  21372 */   GIM_Try, /*On fail goto*//*Label 379*/ GIMT_Encode4(21510), // Rule ID 5015 //
     /*  21377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  21380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  21384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21392 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21396 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21400 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  21404 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21408 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21412 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21416 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21420 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  21424 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21428 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21432 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21436 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  21440 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21444 */     // MIs[4] vA
     /*  21444 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  21449 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  21453 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  21457 */     // MIs[5] vC
     /*  21457 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  21462 */     // MIs[5] vB
     /*  21462 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  21467 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  21471 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  21477 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  21479 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  21481 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  21481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  21484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  21486 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  21490 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  21494 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  21498 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  21508 */     GIR_RootConstrainSelectedInstOperands,
     /*  21509 */     // GIR_Coverage, 5015,
     /*  21509 */     GIR_EraseRootFromParent_Done,
     /*  21510 */   // Label 379: @21510
     /*  21510 */   GIM_Try, /*On fail goto*//*Label 380*/ GIMT_Encode4(21648), // Rule ID 5022 //
     /*  21515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  21518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  21522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21530 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21534 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21538 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  21542 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21546 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21550 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21554 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21558 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  21562 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21566 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21570 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21574 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  21578 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21582 */     // MIs[4] vC
     /*  21582 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  21587 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  21591 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  21595 */     // MIs[5] vA
     /*  21595 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  21600 */     // MIs[5] vB
     /*  21600 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  21605 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  21609 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  21615 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  21617 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  21619 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  21619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  21622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  21624 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  21628 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  21632 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  21636 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  21646 */     GIR_RootConstrainSelectedInstOperands,
     /*  21647 */     // GIR_Coverage, 5022,
     /*  21647 */     GIR_EraseRootFromParent_Done,
     /*  21648 */   // Label 380: @21648
     /*  21648 */   GIM_Try, /*On fail goto*//*Label 381*/ GIMT_Encode4(21786), // Rule ID 5023 //
     /*  21653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  21656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  21660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21668 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21672 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21676 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  21680 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21684 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21688 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21692 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21696 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  21700 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21704 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21708 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21712 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  21716 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21720 */     // MIs[4] vC
     /*  21720 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  21725 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  21729 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  21733 */     // MIs[5] vB
     /*  21733 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  21738 */     // MIs[5] vA
     /*  21738 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  21743 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  21747 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  21753 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  21755 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  21757 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  21757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  21760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  21762 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  21766 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  21770 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  21774 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  21784 */     GIR_RootConstrainSelectedInstOperands,
     /*  21785 */     // GIR_Coverage, 5023,
     /*  21785 */     GIR_EraseRootFromParent_Done,
     /*  21786 */   // Label 381: @21786
     /*  21786 */   GIM_Try, /*On fail goto*//*Label 382*/ GIMT_Encode4(21924), // Rule ID 5024 //
     /*  21791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  21794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  21798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21806 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21810 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21814 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  21818 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21822 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21826 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21830 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21834 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  21838 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21842 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21846 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21850 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  21854 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21858 */     // MIs[4] vB
     /*  21858 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  21863 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  21867 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  21871 */     // MIs[5] vA
     /*  21871 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  21876 */     // MIs[5] vC
     /*  21876 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  21881 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  21885 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  21891 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  21893 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  21895 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  21895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  21898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  21900 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  21904 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  21908 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  21912 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  21922 */     GIR_RootConstrainSelectedInstOperands,
     /*  21923 */     // GIR_Coverage, 5024,
     /*  21923 */     GIR_EraseRootFromParent_Done,
     /*  21924 */   // Label 382: @21924
     /*  21924 */   GIM_Try, /*On fail goto*//*Label 383*/ GIMT_Encode4(22062), // Rule ID 5025 //
     /*  21929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  21932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  21936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21944 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21948 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21952 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  21956 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21960 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21964 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21968 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21972 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  21976 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21980 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21984 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21988 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  21992 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21996 */     // MIs[4] vB
     /*  21996 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  22001 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  22005 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  22009 */     // MIs[5] vC
     /*  22009 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  22014 */     // MIs[5] vA
     /*  22014 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  22019 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  22023 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  22029 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  22031 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  22033 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  22033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  22036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  22038 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  22042 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  22046 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  22050 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  22060 */     GIR_RootConstrainSelectedInstOperands,
     /*  22061 */     // GIR_Coverage, 5025,
     /*  22061 */     GIR_EraseRootFromParent_Done,
     /*  22062 */   // Label 383: @22062
     /*  22062 */   GIM_Try, /*On fail goto*//*Label 384*/ GIMT_Encode4(22200), // Rule ID 5026 //
     /*  22067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  22070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  22074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22082 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22086 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22090 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22094 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22098 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22102 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22106 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22110 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22114 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22118 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22122 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  22126 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  22130 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22134 */     // MIs[4] vA
     /*  22134 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  22139 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  22143 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  22147 */     // MIs[5] vB
     /*  22147 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  22152 */     // MIs[5] vC
     /*  22152 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  22157 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  22161 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  22167 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  22169 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  22171 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  22171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  22174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  22176 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  22180 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  22184 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  22188 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  22198 */     GIR_RootConstrainSelectedInstOperands,
     /*  22199 */     // GIR_Coverage, 5026,
     /*  22199 */     GIR_EraseRootFromParent_Done,
     /*  22200 */   // Label 384: @22200
     /*  22200 */   GIM_Try, /*On fail goto*//*Label 385*/ GIMT_Encode4(22338), // Rule ID 5027 //
     /*  22205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  22208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  22212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22220 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22224 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22228 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22232 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22236 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22240 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22244 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22248 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22252 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22256 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22260 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  22264 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  22268 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22272 */     // MIs[4] vA
     /*  22272 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  22277 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  22281 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  22285 */     // MIs[5] vC
     /*  22285 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  22290 */     // MIs[5] vB
     /*  22290 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  22295 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  22299 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  22305 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  22307 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  22309 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  22309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  22312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  22314 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  22318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  22322 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  22326 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  22336 */     GIR_RootConstrainSelectedInstOperands,
     /*  22337 */     // GIR_Coverage, 5027,
     /*  22337 */     GIR_EraseRootFromParent_Done,
     /*  22338 */   // Label 385: @22338
     /*  22338 */   GIM_Try, /*On fail goto*//*Label 386*/ GIMT_Encode4(22476), // Rule ID 5034 //
     /*  22343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  22346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  22350 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22354 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22358 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22362 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22366 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22370 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22374 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22378 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22382 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22386 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22390 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22394 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22398 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  22402 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  22406 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22410 */     // MIs[4] vC
     /*  22410 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  22415 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  22419 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  22423 */     // MIs[5] vA
     /*  22423 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  22428 */     // MIs[5] vB
     /*  22428 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  22433 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  22437 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  22443 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  22445 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  22447 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  22447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  22450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  22452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  22456 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  22460 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  22464 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  22474 */     GIR_RootConstrainSelectedInstOperands,
     /*  22475 */     // GIR_Coverage, 5034,
     /*  22475 */     GIR_EraseRootFromParent_Done,
     /*  22476 */   // Label 386: @22476
     /*  22476 */   GIM_Try, /*On fail goto*//*Label 387*/ GIMT_Encode4(22614), // Rule ID 5035 //
     /*  22481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  22484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  22488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22496 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22500 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22504 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22508 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22512 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22516 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22520 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22524 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22528 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22532 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22536 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  22540 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  22544 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22548 */     // MIs[4] vC
     /*  22548 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  22553 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  22557 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  22561 */     // MIs[5] vB
     /*  22561 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  22566 */     // MIs[5] vA
     /*  22566 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  22571 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  22575 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  22581 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  22583 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  22585 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  22585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  22588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  22590 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  22594 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  22598 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  22602 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  22612 */     GIR_RootConstrainSelectedInstOperands,
     /*  22613 */     // GIR_Coverage, 5035,
     /*  22613 */     GIR_EraseRootFromParent_Done,
     /*  22614 */   // Label 387: @22614
     /*  22614 */   GIM_Try, /*On fail goto*//*Label 388*/ GIMT_Encode4(22752), // Rule ID 5036 //
     /*  22619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  22622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  22626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22634 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22638 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22642 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22646 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22650 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22654 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22658 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22662 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22666 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22670 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22674 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  22678 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  22682 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22686 */     // MIs[4] vB
     /*  22686 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  22691 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  22695 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  22699 */     // MIs[5] vA
     /*  22699 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  22704 */     // MIs[5] vC
     /*  22704 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  22709 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  22713 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  22719 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  22721 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  22723 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  22723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  22726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  22728 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  22732 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  22736 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  22740 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  22750 */     GIR_RootConstrainSelectedInstOperands,
     /*  22751 */     // GIR_Coverage, 5036,
     /*  22751 */     GIR_EraseRootFromParent_Done,
     /*  22752 */   // Label 388: @22752
     /*  22752 */   GIM_Try, /*On fail goto*//*Label 389*/ GIMT_Encode4(22890), // Rule ID 5037 //
     /*  22757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  22760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  22764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22772 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22776 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22780 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22784 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22788 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22792 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22796 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22800 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22804 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22808 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22812 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  22816 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  22820 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22824 */     // MIs[4] vB
     /*  22824 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  22829 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  22833 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  22837 */     // MIs[5] vC
     /*  22837 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  22842 */     // MIs[5] vA
     /*  22842 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  22847 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  22851 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  22857 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  22859 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  22861 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  22861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  22864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  22866 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  22870 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  22874 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  22878 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  22888 */     GIR_RootConstrainSelectedInstOperands,
     /*  22889 */     // GIR_Coverage, 5037,
     /*  22889 */     GIR_EraseRootFromParent_Done,
     /*  22890 */   // Label 389: @22890
     /*  22890 */   GIM_Try, /*On fail goto*//*Label 390*/ GIMT_Encode4(23028), // Rule ID 5038 //
     /*  22895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  22898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  22902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22910 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22914 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22918 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22922 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22926 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22930 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22934 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22938 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22942 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22946 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22950 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  22954 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  22958 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22962 */     // MIs[4] vA
     /*  22962 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  22967 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  22971 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  22975 */     // MIs[5] vB
     /*  22975 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  22980 */     // MIs[5] vC
     /*  22980 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  22985 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  22989 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  22995 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  22997 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  22999 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  22999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  23002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  23004 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  23008 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  23012 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  23016 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  23026 */     GIR_RootConstrainSelectedInstOperands,
     /*  23027 */     // GIR_Coverage, 5038,
     /*  23027 */     GIR_EraseRootFromParent_Done,
     /*  23028 */   // Label 390: @23028
     /*  23028 */   GIM_Try, /*On fail goto*//*Label 391*/ GIMT_Encode4(23166), // Rule ID 5039 //
     /*  23033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  23036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  23040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23048 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23052 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23056 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  23060 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23064 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23068 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23072 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  23076 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  23080 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23084 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23088 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  23092 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  23096 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23100 */     // MIs[4] vA
     /*  23100 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  23105 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  23109 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  23113 */     // MIs[5] vC
     /*  23113 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  23118 */     // MIs[5] vB
     /*  23118 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  23123 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  23127 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  23133 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  23135 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  23137 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  23137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  23140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  23142 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  23146 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  23150 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  23154 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  23164 */     GIR_RootConstrainSelectedInstOperands,
     /*  23165 */     // GIR_Coverage, 5039,
     /*  23165 */     GIR_EraseRootFromParent_Done,
     /*  23166 */   // Label 391: @23166
     /*  23166 */   GIM_Try, /*On fail goto*//*Label 392*/ GIMT_Encode4(23304), // Rule ID 5046 //
     /*  23171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  23174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  23178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23186 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23190 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23194 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  23198 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23202 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23206 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23210 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  23214 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  23218 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23222 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23226 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  23230 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  23234 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23238 */     // MIs[4] vC
     /*  23238 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  23243 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  23247 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  23251 */     // MIs[5] vA
     /*  23251 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  23256 */     // MIs[5] vB
     /*  23256 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  23261 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  23265 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  23271 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  23273 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  23275 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  23275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  23278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  23280 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  23284 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  23288 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  23292 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  23302 */     GIR_RootConstrainSelectedInstOperands,
     /*  23303 */     // GIR_Coverage, 5046,
     /*  23303 */     GIR_EraseRootFromParent_Done,
     /*  23304 */   // Label 392: @23304
     /*  23304 */   GIM_Try, /*On fail goto*//*Label 393*/ GIMT_Encode4(23442), // Rule ID 5047 //
     /*  23309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  23312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  23316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23324 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23328 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23332 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  23336 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23340 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23344 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23348 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  23352 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  23356 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23360 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23364 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  23368 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  23372 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23376 */     // MIs[4] vC
     /*  23376 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  23381 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  23385 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  23389 */     // MIs[5] vB
     /*  23389 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  23394 */     // MIs[5] vA
     /*  23394 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  23399 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  23403 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  23409 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  23411 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  23413 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  23413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  23416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  23418 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  23422 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  23426 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  23430 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  23440 */     GIR_RootConstrainSelectedInstOperands,
     /*  23441 */     // GIR_Coverage, 5047,
     /*  23441 */     GIR_EraseRootFromParent_Done,
     /*  23442 */   // Label 393: @23442
     /*  23442 */   GIM_Try, /*On fail goto*//*Label 394*/ GIMT_Encode4(23580), // Rule ID 5048 //
     /*  23447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  23450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  23454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23462 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23466 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23470 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  23474 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23478 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23482 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23486 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  23490 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  23494 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23498 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23502 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  23506 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  23510 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23514 */     // MIs[4] vB
     /*  23514 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  23519 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  23523 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  23527 */     // MIs[5] vA
     /*  23527 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  23532 */     // MIs[5] vC
     /*  23532 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  23537 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  23541 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  23547 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  23549 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  23551 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  23551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  23554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  23556 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  23560 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  23564 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  23568 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  23578 */     GIR_RootConstrainSelectedInstOperands,
     /*  23579 */     // GIR_Coverage, 5048,
     /*  23579 */     GIR_EraseRootFromParent_Done,
     /*  23580 */   // Label 394: @23580
     /*  23580 */   GIM_Try, /*On fail goto*//*Label 395*/ GIMT_Encode4(23718), // Rule ID 5049 //
     /*  23585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  23588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  23592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23600 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23604 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23608 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  23612 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23616 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23620 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23624 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  23628 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  23632 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23636 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23640 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  23644 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  23648 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23652 */     // MIs[4] vB
     /*  23652 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  23657 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  23661 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  23665 */     // MIs[5] vC
     /*  23665 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  23670 */     // MIs[5] vA
     /*  23670 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  23675 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  23679 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  23685 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  23687 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  23689 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  23689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  23692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  23694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  23698 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  23702 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  23706 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  23716 */     GIR_RootConstrainSelectedInstOperands,
     /*  23717 */     // GIR_Coverage, 5049,
     /*  23717 */     GIR_EraseRootFromParent_Done,
     /*  23718 */   // Label 395: @23718
     /*  23718 */   GIM_Try, /*On fail goto*//*Label 396*/ GIMT_Encode4(23856), // Rule ID 5050 //
     /*  23723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  23726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  23730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23738 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23742 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23746 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  23750 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23754 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23758 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23762 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  23766 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  23770 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23774 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23778 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  23782 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  23786 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23790 */     // MIs[4] vA
     /*  23790 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  23795 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  23799 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  23803 */     // MIs[5] vB
     /*  23803 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  23808 */     // MIs[5] vC
     /*  23808 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  23813 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  23817 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  23823 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  23825 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  23827 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  23827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  23830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  23832 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  23836 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  23840 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  23844 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  23854 */     GIR_RootConstrainSelectedInstOperands,
     /*  23855 */     // GIR_Coverage, 5050,
     /*  23855 */     GIR_EraseRootFromParent_Done,
     /*  23856 */   // Label 396: @23856
     /*  23856 */   GIM_Try, /*On fail goto*//*Label 397*/ GIMT_Encode4(23994), // Rule ID 5051 //
     /*  23861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  23864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  23868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23876 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23880 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23884 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  23888 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23892 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23896 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23900 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  23904 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  23908 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23912 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23916 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  23920 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  23924 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23928 */     // MIs[4] vA
     /*  23928 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  23933 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  23937 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  23941 */     // MIs[5] vC
     /*  23941 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  23946 */     // MIs[5] vB
     /*  23946 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  23951 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  23955 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  23961 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  23963 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  23965 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  23965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  23968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  23970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  23974 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  23978 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  23982 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  23992 */     GIR_RootConstrainSelectedInstOperands,
     /*  23993 */     // GIR_Coverage, 5051,
     /*  23993 */     GIR_EraseRootFromParent_Done,
     /*  23994 */   // Label 397: @23994
     /*  23994 */   GIM_Try, /*On fail goto*//*Label 398*/ GIMT_Encode4(24132), // Rule ID 5058 //
     /*  23999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  24002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  24006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  24014 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24018 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24022 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24026 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  24030 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24034 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24038 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  24042 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  24046 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24050 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24054 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  24058 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  24062 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24066 */     // MIs[4] vC
     /*  24066 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  24071 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  24075 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  24079 */     // MIs[5] vA
     /*  24079 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  24084 */     // MIs[5] vB
     /*  24084 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  24089 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  24093 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  24099 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  24101 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  24103 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  24103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  24106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  24108 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  24112 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  24116 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  24120 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  24130 */     GIR_RootConstrainSelectedInstOperands,
     /*  24131 */     // GIR_Coverage, 5058,
     /*  24131 */     GIR_EraseRootFromParent_Done,
     /*  24132 */   // Label 398: @24132
     /*  24132 */   GIM_Try, /*On fail goto*//*Label 399*/ GIMT_Encode4(24270), // Rule ID 5059 //
     /*  24137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  24140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  24144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  24152 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24156 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24160 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24164 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  24168 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24172 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24176 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  24180 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  24184 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24188 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24192 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  24196 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  24200 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24204 */     // MIs[4] vC
     /*  24204 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  24209 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  24213 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  24217 */     // MIs[5] vB
     /*  24217 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  24222 */     // MIs[5] vA
     /*  24222 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  24227 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  24231 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  24237 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  24239 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  24241 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  24241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  24244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  24246 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  24250 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  24254 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  24258 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  24268 */     GIR_RootConstrainSelectedInstOperands,
     /*  24269 */     // GIR_Coverage, 5059,
     /*  24269 */     GIR_EraseRootFromParent_Done,
     /*  24270 */   // Label 399: @24270
     /*  24270 */   GIM_Try, /*On fail goto*//*Label 400*/ GIMT_Encode4(24408), // Rule ID 5060 //
     /*  24275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  24278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  24282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24286 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  24290 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24294 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24298 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24302 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  24306 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24310 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24314 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  24318 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  24322 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24326 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24330 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  24334 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  24338 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24342 */     // MIs[4] vB
     /*  24342 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  24347 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  24351 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  24355 */     // MIs[5] vA
     /*  24355 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  24360 */     // MIs[5] vC
     /*  24360 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  24365 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  24369 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  24375 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  24377 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  24379 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  24379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  24382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  24384 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  24388 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  24392 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  24396 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  24406 */     GIR_RootConstrainSelectedInstOperands,
     /*  24407 */     // GIR_Coverage, 5060,
     /*  24407 */     GIR_EraseRootFromParent_Done,
     /*  24408 */   // Label 400: @24408
     /*  24408 */   GIM_Try, /*On fail goto*//*Label 401*/ GIMT_Encode4(24546), // Rule ID 5061 //
     /*  24413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  24416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  24420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  24428 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24432 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24436 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24440 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  24444 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24448 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24452 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  24456 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  24460 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24464 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24468 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  24472 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  24476 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24480 */     // MIs[4] vB
     /*  24480 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  24485 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  24489 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  24493 */     // MIs[5] vC
     /*  24493 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  24498 */     // MIs[5] vA
     /*  24498 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  24503 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  24507 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  24513 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  24515 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  24517 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  24517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  24520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  24522 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  24526 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  24530 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  24534 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  24544 */     GIR_RootConstrainSelectedInstOperands,
     /*  24545 */     // GIR_Coverage, 5061,
     /*  24545 */     GIR_EraseRootFromParent_Done,
     /*  24546 */   // Label 401: @24546
     /*  24546 */   GIM_Try, /*On fail goto*//*Label 402*/ GIMT_Encode4(24684), // Rule ID 5062 //
     /*  24551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  24554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  24558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24562 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  24566 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24570 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24574 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24578 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  24582 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24586 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24590 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  24594 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  24598 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24602 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24606 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  24610 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  24614 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24618 */     // MIs[4] vA
     /*  24618 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  24623 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  24627 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  24631 */     // MIs[5] vC
     /*  24631 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  24636 */     // MIs[5] vB
     /*  24636 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  24641 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  24645 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  24651 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  24653 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  24655 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  24655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  24658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  24660 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  24664 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  24668 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  24672 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  24682 */     GIR_RootConstrainSelectedInstOperands,
     /*  24683 */     // GIR_Coverage, 5062,
     /*  24683 */     GIR_EraseRootFromParent_Done,
     /*  24684 */   // Label 402: @24684
     /*  24684 */   GIM_Try, /*On fail goto*//*Label 403*/ GIMT_Encode4(24822), // Rule ID 5069 //
     /*  24689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  24692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  24696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  24704 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24708 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24712 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24716 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  24720 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24724 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24728 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  24732 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  24736 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24740 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24744 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  24748 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  24752 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24756 */     // MIs[4] vC
     /*  24756 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  24761 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  24765 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  24769 */     // MIs[5] vA
     /*  24769 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  24774 */     // MIs[5] vB
     /*  24774 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  24779 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  24783 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  24789 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  24791 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  24793 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  24793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  24796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  24798 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  24802 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  24806 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  24810 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  24820 */     GIR_RootConstrainSelectedInstOperands,
     /*  24821 */     // GIR_Coverage, 5069,
     /*  24821 */     GIR_EraseRootFromParent_Done,
     /*  24822 */   // Label 403: @24822
     /*  24822 */   GIM_Try, /*On fail goto*//*Label 404*/ GIMT_Encode4(24960), // Rule ID 5070 //
     /*  24827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  24830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  24834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  24842 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24846 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24850 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24854 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  24858 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24862 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24866 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  24870 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  24874 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24878 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24882 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  24886 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  24890 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24894 */     // MIs[4] vC
     /*  24894 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  24899 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  24903 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  24907 */     // MIs[5] vB
     /*  24907 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  24912 */     // MIs[5] vA
     /*  24912 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  24917 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  24921 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  24927 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  24929 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  24931 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  24931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  24934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  24936 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  24940 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  24944 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  24948 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  24958 */     GIR_RootConstrainSelectedInstOperands,
     /*  24959 */     // GIR_Coverage, 5070,
     /*  24959 */     GIR_EraseRootFromParent_Done,
     /*  24960 */   // Label 404: @24960
     /*  24960 */   GIM_Try, /*On fail goto*//*Label 405*/ GIMT_Encode4(25098), // Rule ID 5071 //
     /*  24965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  24968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  24972 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24976 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  24980 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24984 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24988 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24992 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  24996 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25000 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25004 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  25008 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  25012 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25016 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25020 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  25024 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  25028 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25032 */     // MIs[4] vB
     /*  25032 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  25037 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  25041 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  25045 */     // MIs[5] vA
     /*  25045 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  25050 */     // MIs[5] vC
     /*  25050 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  25055 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  25059 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  25065 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  25067 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  25069 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  25069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  25072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  25074 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  25078 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  25082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  25086 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  25096 */     GIR_RootConstrainSelectedInstOperands,
     /*  25097 */     // GIR_Coverage, 5071,
     /*  25097 */     GIR_EraseRootFromParent_Done,
     /*  25098 */   // Label 405: @25098
     /*  25098 */   GIM_Try, /*On fail goto*//*Label 406*/ GIMT_Encode4(25236), // Rule ID 5072 //
     /*  25103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  25106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  25110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  25118 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25122 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25126 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  25130 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  25134 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25138 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25142 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  25146 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  25150 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25154 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25158 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  25162 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  25166 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25170 */     // MIs[4] vB
     /*  25170 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  25175 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  25179 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  25183 */     // MIs[5] vC
     /*  25183 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  25188 */     // MIs[5] vA
     /*  25188 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  25193 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  25197 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  25203 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  25205 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  25207 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  25207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  25210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  25212 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  25216 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  25220 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  25224 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  25234 */     GIR_RootConstrainSelectedInstOperands,
     /*  25235 */     // GIR_Coverage, 5072,
     /*  25235 */     GIR_EraseRootFromParent_Done,
     /*  25236 */   // Label 406: @25236
     /*  25236 */   GIM_Try, /*On fail goto*//*Label 407*/ GIMT_Encode4(25374), // Rule ID 5073 //
     /*  25241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  25244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  25248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  25256 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25260 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25264 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  25268 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  25272 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25276 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25280 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  25284 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  25288 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25292 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25296 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  25300 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  25304 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25308 */     // MIs[4] vA
     /*  25308 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  25313 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  25317 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  25321 */     // MIs[5] vB
     /*  25321 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  25326 */     // MIs[5] vC
     /*  25326 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  25331 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  25335 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  25341 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  25343 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  25345 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  25345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  25348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  25350 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  25354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  25358 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  25362 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  25372 */     GIR_RootConstrainSelectedInstOperands,
     /*  25373 */     // GIR_Coverage, 5073,
     /*  25373 */     GIR_EraseRootFromParent_Done,
     /*  25374 */   // Label 407: @25374
     /*  25374 */   GIM_Try, /*On fail goto*//*Label 408*/ GIMT_Encode4(25512), // Rule ID 5074 //
     /*  25379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  25382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  25386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25390 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  25394 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25398 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25402 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  25406 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  25410 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25414 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25418 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  25422 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  25426 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25430 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25434 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  25438 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  25442 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25446 */     // MIs[4] vA
     /*  25446 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  25451 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  25455 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  25459 */     // MIs[5] vC
     /*  25459 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  25464 */     // MIs[5] vB
     /*  25464 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  25469 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  25473 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  25479 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  25481 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  25483 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  25483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  25486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  25488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  25492 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  25496 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  25500 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  25510 */     GIR_RootConstrainSelectedInstOperands,
     /*  25511 */     // GIR_Coverage, 5074,
     /*  25511 */     GIR_EraseRootFromParent_Done,
     /*  25512 */   // Label 408: @25512
     /*  25512 */   GIM_Try, /*On fail goto*//*Label 409*/ GIMT_Encode4(25650), // Rule ID 5075 //
     /*  25517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  25520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  25524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  25532 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25536 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25540 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25544 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  25548 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25552 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25556 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25560 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  25564 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25568 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25572 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  25576 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  25582 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  25584 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  25588 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  25592 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25596 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  25600 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  25604 */     // MIs[6] vA
     /*  25604 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  25609 */     // MIs[6] vB
     /*  25609 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  25614 */     // MIs[5] vC
     /*  25614 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  25619 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  25621 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  25621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  25624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  25626 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  25630 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  25634 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  25638 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  25648 */     GIR_RootConstrainSelectedInstOperands,
     /*  25649 */     // GIR_Coverage, 5075,
     /*  25649 */     GIR_EraseRootFromParent_Done,
     /*  25650 */   // Label 409: @25650
     /*  25650 */   GIM_Try, /*On fail goto*//*Label 410*/ GIMT_Encode4(25788), // Rule ID 5076 //
     /*  25655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  25658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  25662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  25670 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25674 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25678 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25682 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  25686 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25690 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25694 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25698 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  25702 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25706 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25710 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  25714 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  25720 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  25722 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  25726 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  25730 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25734 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  25738 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  25742 */     // MIs[6] vB
     /*  25742 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  25747 */     // MIs[6] vA
     /*  25747 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  25752 */     // MIs[5] vC
     /*  25752 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  25757 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  25759 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  25759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  25762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  25764 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  25768 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  25772 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  25776 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  25786 */     GIR_RootConstrainSelectedInstOperands,
     /*  25787 */     // GIR_Coverage, 5076,
     /*  25787 */     GIR_EraseRootFromParent_Done,
     /*  25788 */   // Label 410: @25788
     /*  25788 */   GIM_Try, /*On fail goto*//*Label 411*/ GIMT_Encode4(25926), // Rule ID 5077 //
     /*  25793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  25796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  25800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  25808 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25812 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25816 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25820 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  25824 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25828 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25832 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25836 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  25840 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25844 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25848 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  25852 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  25858 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  25860 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  25864 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  25868 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25872 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  25876 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  25880 */     // MIs[6] vA
     /*  25880 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  25885 */     // MIs[6] vC
     /*  25885 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  25890 */     // MIs[5] vB
     /*  25890 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  25895 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  25897 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  25897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  25900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  25902 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  25906 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  25910 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  25914 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  25924 */     GIR_RootConstrainSelectedInstOperands,
     /*  25925 */     // GIR_Coverage, 5077,
     /*  25925 */     GIR_EraseRootFromParent_Done,
     /*  25926 */   // Label 411: @25926
     /*  25926 */   GIM_Try, /*On fail goto*//*Label 412*/ GIMT_Encode4(26064), // Rule ID 5078 //
     /*  25931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  25934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  25938 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25942 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  25946 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25950 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25954 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25958 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  25962 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25966 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25970 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25974 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  25978 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25982 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25986 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  25990 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  25996 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  25998 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  26002 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  26006 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26010 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  26014 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  26018 */     // MIs[6] vC
     /*  26018 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  26023 */     // MIs[6] vA
     /*  26023 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  26028 */     // MIs[5] vB
     /*  26028 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  26033 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  26035 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  26035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  26038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  26040 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  26044 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  26048 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  26052 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  26062 */     GIR_RootConstrainSelectedInstOperands,
     /*  26063 */     // GIR_Coverage, 5078,
     /*  26063 */     GIR_EraseRootFromParent_Done,
     /*  26064 */   // Label 412: @26064
     /*  26064 */   GIM_Try, /*On fail goto*//*Label 413*/ GIMT_Encode4(26202), // Rule ID 5079 //
     /*  26069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  26072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  26076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  26084 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26088 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26092 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26096 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  26100 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26104 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26108 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26112 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  26116 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26120 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26124 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  26128 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  26134 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  26136 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  26140 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  26144 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26148 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  26152 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  26156 */     // MIs[6] vB
     /*  26156 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  26161 */     // MIs[6] vC
     /*  26161 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  26166 */     // MIs[5] vA
     /*  26166 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  26171 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  26173 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  26173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  26176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  26178 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  26182 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  26186 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  26190 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  26200 */     GIR_RootConstrainSelectedInstOperands,
     /*  26201 */     // GIR_Coverage, 5079,
     /*  26201 */     GIR_EraseRootFromParent_Done,
     /*  26202 */   // Label 413: @26202
     /*  26202 */   GIM_Try, /*On fail goto*//*Label 414*/ GIMT_Encode4(26340), // Rule ID 5080 //
     /*  26207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  26210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  26214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  26222 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26226 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26230 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26234 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  26238 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26242 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26246 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26250 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  26254 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26258 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26262 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  26266 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  26272 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  26274 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  26278 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  26282 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26286 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  26290 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  26294 */     // MIs[6] vC
     /*  26294 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  26299 */     // MIs[6] vB
     /*  26299 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  26304 */     // MIs[5] vA
     /*  26304 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  26309 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  26311 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  26311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  26314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  26316 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  26320 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  26324 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  26328 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  26338 */     GIR_RootConstrainSelectedInstOperands,
     /*  26339 */     // GIR_Coverage, 5080,
     /*  26339 */     GIR_EraseRootFromParent_Done,
     /*  26340 */   // Label 414: @26340
     /*  26340 */   GIM_Try, /*On fail goto*//*Label 415*/ GIMT_Encode4(26478), // Rule ID 5087 //
     /*  26345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  26348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  26352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  26360 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26364 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26368 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26372 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  26376 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26380 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26384 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26388 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  26392 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26396 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26400 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  26404 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  26410 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  26412 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  26416 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  26420 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26424 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  26428 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  26432 */     // MIs[6] vA
     /*  26432 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  26437 */     // MIs[6] vB
     /*  26437 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  26442 */     // MIs[5] vC
     /*  26442 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  26447 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  26449 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  26449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  26452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  26454 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  26458 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  26462 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  26466 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  26476 */     GIR_RootConstrainSelectedInstOperands,
     /*  26477 */     // GIR_Coverage, 5087,
     /*  26477 */     GIR_EraseRootFromParent_Done,
     /*  26478 */   // Label 415: @26478
     /*  26478 */   GIM_Try, /*On fail goto*//*Label 416*/ GIMT_Encode4(26616), // Rule ID 5088 //
     /*  26483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  26486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  26490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  26498 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26502 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26506 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26510 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  26514 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26518 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26522 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26526 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  26530 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26534 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26538 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  26542 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  26548 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  26550 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  26554 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  26558 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26562 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  26566 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  26570 */     // MIs[6] vB
     /*  26570 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  26575 */     // MIs[6] vA
     /*  26575 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  26580 */     // MIs[5] vC
     /*  26580 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  26585 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  26587 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  26587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  26590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  26592 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  26596 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  26600 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  26604 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  26614 */     GIR_RootConstrainSelectedInstOperands,
     /*  26615 */     // GIR_Coverage, 5088,
     /*  26615 */     GIR_EraseRootFromParent_Done,
     /*  26616 */   // Label 416: @26616
     /*  26616 */   GIM_Try, /*On fail goto*//*Label 417*/ GIMT_Encode4(26754), // Rule ID 5089 //
     /*  26621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  26624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  26628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  26636 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26640 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26644 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26648 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  26652 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26656 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26660 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26664 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  26668 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26672 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26676 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  26680 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  26686 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  26688 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  26692 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  26696 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26700 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  26704 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  26708 */     // MIs[6] vA
     /*  26708 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  26713 */     // MIs[6] vC
     /*  26713 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  26718 */     // MIs[5] vB
     /*  26718 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  26723 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  26725 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  26725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  26728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  26730 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  26734 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  26738 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  26742 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  26752 */     GIR_RootConstrainSelectedInstOperands,
     /*  26753 */     // GIR_Coverage, 5089,
     /*  26753 */     GIR_EraseRootFromParent_Done,
     /*  26754 */   // Label 417: @26754
     /*  26754 */   GIM_Try, /*On fail goto*//*Label 418*/ GIMT_Encode4(26892), // Rule ID 5090 //
     /*  26759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  26762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  26766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  26774 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26778 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26782 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26786 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  26790 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26794 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26798 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26802 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  26806 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26810 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26814 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  26818 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  26824 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  26826 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  26830 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  26834 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26838 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  26842 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  26846 */     // MIs[6] vC
     /*  26846 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  26851 */     // MIs[6] vA
     /*  26851 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  26856 */     // MIs[5] vB
     /*  26856 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  26861 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  26863 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  26863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  26866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  26868 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  26872 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  26876 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  26880 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  26890 */     GIR_RootConstrainSelectedInstOperands,
     /*  26891 */     // GIR_Coverage, 5090,
     /*  26891 */     GIR_EraseRootFromParent_Done,
     /*  26892 */   // Label 418: @26892
     /*  26892 */   GIM_Try, /*On fail goto*//*Label 419*/ GIMT_Encode4(27030), // Rule ID 5091 //
     /*  26897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  26900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  26904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  26912 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26916 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26920 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26924 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  26928 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26932 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26936 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26940 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  26944 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26948 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26952 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  26956 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  26962 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  26964 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  26968 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  26972 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26976 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  26980 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  26984 */     // MIs[6] vB
     /*  26984 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  26989 */     // MIs[6] vC
     /*  26989 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  26994 */     // MIs[5] vA
     /*  26994 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  26999 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  27001 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  27001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  27004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  27006 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  27010 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  27014 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  27018 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  27028 */     GIR_RootConstrainSelectedInstOperands,
     /*  27029 */     // GIR_Coverage, 5091,
     /*  27029 */     GIR_EraseRootFromParent_Done,
     /*  27030 */   // Label 419: @27030
     /*  27030 */   GIM_Try, /*On fail goto*//*Label 420*/ GIMT_Encode4(27168), // Rule ID 5092 //
     /*  27035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  27038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  27042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27046 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  27050 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27054 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27058 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27062 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  27066 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27070 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27074 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  27078 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  27082 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27086 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27090 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  27094 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  27100 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  27102 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  27106 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  27110 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27114 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  27118 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  27122 */     // MIs[6] vC
     /*  27122 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  27127 */     // MIs[6] vB
     /*  27127 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  27132 */     // MIs[5] vA
     /*  27132 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  27137 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  27139 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  27139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  27142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  27144 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  27148 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  27152 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  27156 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  27166 */     GIR_RootConstrainSelectedInstOperands,
     /*  27167 */     // GIR_Coverage, 5092,
     /*  27167 */     GIR_EraseRootFromParent_Done,
     /*  27168 */   // Label 420: @27168
     /*  27168 */   GIM_Try, /*On fail goto*//*Label 421*/ GIMT_Encode4(27306), // Rule ID 5099 //
     /*  27173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  27176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  27180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  27188 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27192 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27196 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27200 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  27204 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27208 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27212 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  27216 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  27220 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27224 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27228 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  27232 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  27238 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  27240 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  27244 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  27248 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27252 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  27256 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  27260 */     // MIs[6] vA
     /*  27260 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  27265 */     // MIs[6] vB
     /*  27265 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  27270 */     // MIs[5] vC
     /*  27270 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  27275 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  27277 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  27277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  27280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  27282 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  27286 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  27290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  27294 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  27304 */     GIR_RootConstrainSelectedInstOperands,
     /*  27305 */     // GIR_Coverage, 5099,
     /*  27305 */     GIR_EraseRootFromParent_Done,
     /*  27306 */   // Label 421: @27306
     /*  27306 */   GIM_Try, /*On fail goto*//*Label 422*/ GIMT_Encode4(27444), // Rule ID 5100 //
     /*  27311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  27314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  27318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  27326 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27330 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27334 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27338 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  27342 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27346 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27350 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  27354 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  27358 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27362 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27366 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  27370 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  27376 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  27378 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  27382 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  27386 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27390 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  27394 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  27398 */     // MIs[6] vB
     /*  27398 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  27403 */     // MIs[6] vA
     /*  27403 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  27408 */     // MIs[5] vC
     /*  27408 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  27413 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  27415 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  27415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  27418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  27420 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  27424 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  27428 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  27432 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  27442 */     GIR_RootConstrainSelectedInstOperands,
     /*  27443 */     // GIR_Coverage, 5100,
     /*  27443 */     GIR_EraseRootFromParent_Done,
     /*  27444 */   // Label 422: @27444
     /*  27444 */   GIM_Try, /*On fail goto*//*Label 423*/ GIMT_Encode4(27582), // Rule ID 5101 //
     /*  27449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  27452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  27456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  27464 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27468 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27472 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27476 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  27480 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27484 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27488 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  27492 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  27496 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27500 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27504 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  27508 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  27514 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  27516 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  27520 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  27524 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27528 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  27532 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  27536 */     // MIs[6] vA
     /*  27536 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  27541 */     // MIs[6] vC
     /*  27541 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  27546 */     // MIs[5] vB
     /*  27546 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  27551 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  27553 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  27553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  27556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  27558 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  27562 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  27566 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  27570 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  27580 */     GIR_RootConstrainSelectedInstOperands,
     /*  27581 */     // GIR_Coverage, 5101,
     /*  27581 */     GIR_EraseRootFromParent_Done,
     /*  27582 */   // Label 423: @27582
     /*  27582 */   GIM_Try, /*On fail goto*//*Label 424*/ GIMT_Encode4(27720), // Rule ID 5102 //
     /*  27587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  27590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  27594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  27602 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27606 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27610 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27614 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  27618 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27622 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27626 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  27630 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  27634 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27638 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27642 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  27646 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  27652 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  27654 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  27658 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  27662 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27666 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  27670 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  27674 */     // MIs[6] vC
     /*  27674 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  27679 */     // MIs[6] vA
     /*  27679 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  27684 */     // MIs[5] vB
     /*  27684 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  27689 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  27691 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  27691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  27694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  27696 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  27700 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  27704 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  27708 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  27718 */     GIR_RootConstrainSelectedInstOperands,
     /*  27719 */     // GIR_Coverage, 5102,
     /*  27719 */     GIR_EraseRootFromParent_Done,
     /*  27720 */   // Label 424: @27720
     /*  27720 */   GIM_Try, /*On fail goto*//*Label 425*/ GIMT_Encode4(27858), // Rule ID 5103 //
     /*  27725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  27728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  27732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  27740 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27744 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27748 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27752 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  27756 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27760 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27764 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  27768 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  27772 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27776 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27780 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  27784 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  27790 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  27792 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  27796 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  27800 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27804 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  27808 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  27812 */     // MIs[6] vB
     /*  27812 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  27817 */     // MIs[6] vC
     /*  27817 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  27822 */     // MIs[5] vA
     /*  27822 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  27827 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  27829 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  27829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  27832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  27834 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  27838 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  27842 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  27846 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  27856 */     GIR_RootConstrainSelectedInstOperands,
     /*  27857 */     // GIR_Coverage, 5103,
     /*  27857 */     GIR_EraseRootFromParent_Done,
     /*  27858 */   // Label 425: @27858
     /*  27858 */   GIM_Try, /*On fail goto*//*Label 426*/ GIMT_Encode4(27996), // Rule ID 5104 //
     /*  27863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  27866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  27870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  27878 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27882 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27886 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27890 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  27894 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27898 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27902 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  27906 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  27910 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27914 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27918 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  27922 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  27928 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  27930 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  27934 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  27938 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27942 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  27946 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  27950 */     // MIs[6] vC
     /*  27950 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  27955 */     // MIs[6] vB
     /*  27955 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  27960 */     // MIs[5] vA
     /*  27960 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  27965 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  27967 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  27967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  27970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  27972 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  27976 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  27980 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  27984 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  27994 */     GIR_RootConstrainSelectedInstOperands,
     /*  27995 */     // GIR_Coverage, 5104,
     /*  27995 */     GIR_EraseRootFromParent_Done,
     /*  27996 */   // Label 426: @27996
     /*  27996 */   GIM_Try, /*On fail goto*//*Label 427*/ GIMT_Encode4(28134), // Rule ID 5111 //
     /*  28001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  28004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  28008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  28016 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28020 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28024 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28028 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  28032 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28036 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28040 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  28044 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  28048 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28052 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28056 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  28060 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  28066 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  28068 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  28072 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  28076 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28080 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  28084 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  28088 */     // MIs[6] vA
     /*  28088 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  28093 */     // MIs[6] vB
     /*  28093 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  28098 */     // MIs[5] vC
     /*  28098 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  28103 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  28105 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  28105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  28108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  28110 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  28114 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  28118 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  28122 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  28132 */     GIR_RootConstrainSelectedInstOperands,
     /*  28133 */     // GIR_Coverage, 5111,
     /*  28133 */     GIR_EraseRootFromParent_Done,
     /*  28134 */   // Label 427: @28134
     /*  28134 */   GIM_Try, /*On fail goto*//*Label 428*/ GIMT_Encode4(28272), // Rule ID 5112 //
     /*  28139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  28142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  28146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  28154 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28158 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28162 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28166 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  28170 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28174 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28178 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  28182 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  28186 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28190 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28194 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  28198 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  28204 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  28206 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  28210 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  28214 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28218 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  28222 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  28226 */     // MIs[6] vB
     /*  28226 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  28231 */     // MIs[6] vA
     /*  28231 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  28236 */     // MIs[5] vC
     /*  28236 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  28241 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  28243 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  28243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  28246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  28248 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  28252 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  28256 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  28260 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  28270 */     GIR_RootConstrainSelectedInstOperands,
     /*  28271 */     // GIR_Coverage, 5112,
     /*  28271 */     GIR_EraseRootFromParent_Done,
     /*  28272 */   // Label 428: @28272
     /*  28272 */   GIM_Try, /*On fail goto*//*Label 429*/ GIMT_Encode4(28410), // Rule ID 5113 //
     /*  28277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  28280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  28284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  28292 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28296 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28300 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28304 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  28308 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28312 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28316 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  28320 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  28324 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28328 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28332 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  28336 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  28342 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  28344 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  28348 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  28352 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28356 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  28360 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  28364 */     // MIs[6] vA
     /*  28364 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  28369 */     // MIs[6] vC
     /*  28369 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  28374 */     // MIs[5] vB
     /*  28374 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  28379 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  28381 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  28381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  28384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  28386 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  28390 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  28394 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  28398 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  28408 */     GIR_RootConstrainSelectedInstOperands,
     /*  28409 */     // GIR_Coverage, 5113,
     /*  28409 */     GIR_EraseRootFromParent_Done,
     /*  28410 */   // Label 429: @28410
     /*  28410 */   GIM_Try, /*On fail goto*//*Label 430*/ GIMT_Encode4(28548), // Rule ID 5114 //
     /*  28415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  28418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  28422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  28430 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28434 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28438 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28442 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  28446 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28450 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28454 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  28458 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  28462 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28466 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28470 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  28474 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  28480 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  28482 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  28486 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  28490 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28494 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  28498 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  28502 */     // MIs[6] vC
     /*  28502 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  28507 */     // MIs[6] vA
     /*  28507 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  28512 */     // MIs[5] vB
     /*  28512 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  28517 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  28519 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  28519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  28522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  28524 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  28528 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  28532 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  28536 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  28546 */     GIR_RootConstrainSelectedInstOperands,
     /*  28547 */     // GIR_Coverage, 5114,
     /*  28547 */     GIR_EraseRootFromParent_Done,
     /*  28548 */   // Label 430: @28548
     /*  28548 */   GIM_Try, /*On fail goto*//*Label 431*/ GIMT_Encode4(28686), // Rule ID 5115 //
     /*  28553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  28556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  28560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  28568 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28572 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28576 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28580 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  28584 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28588 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28592 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  28596 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  28600 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28604 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28608 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  28612 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  28618 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  28620 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  28624 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  28628 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28632 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  28636 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  28640 */     // MIs[6] vB
     /*  28640 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  28645 */     // MIs[6] vC
     /*  28645 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  28650 */     // MIs[5] vA
     /*  28650 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  28655 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  28657 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  28657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  28660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  28662 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  28666 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  28670 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  28674 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  28684 */     GIR_RootConstrainSelectedInstOperands,
     /*  28685 */     // GIR_Coverage, 5115,
     /*  28685 */     GIR_EraseRootFromParent_Done,
     /*  28686 */   // Label 431: @28686
     /*  28686 */   GIM_Try, /*On fail goto*//*Label 432*/ GIMT_Encode4(28824), // Rule ID 5116 //
     /*  28691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  28694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  28698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  28706 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28710 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28714 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28718 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  28722 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28726 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28730 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  28734 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  28738 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28742 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28746 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  28750 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  28756 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  28758 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  28762 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  28766 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28770 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  28774 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  28778 */     // MIs[6] vC
     /*  28778 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  28783 */     // MIs[6] vB
     /*  28783 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  28788 */     // MIs[5] vA
     /*  28788 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  28793 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  28795 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  28795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  28798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  28800 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  28804 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  28808 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  28812 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  28822 */     GIR_RootConstrainSelectedInstOperands,
     /*  28823 */     // GIR_Coverage, 5116,
     /*  28823 */     GIR_EraseRootFromParent_Done,
     /*  28824 */   // Label 432: @28824
     /*  28824 */   GIM_Try, /*On fail goto*//*Label 433*/ GIMT_Encode4(28962), // Rule ID 5123 //
     /*  28829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  28832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  28836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28840 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  28844 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28848 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28852 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28856 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  28860 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28864 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28868 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  28872 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  28876 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28880 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28884 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  28888 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  28894 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  28896 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  28900 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  28904 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28908 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  28912 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  28916 */     // MIs[6] vA
     /*  28916 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  28921 */     // MIs[6] vB
     /*  28921 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  28926 */     // MIs[5] vC
     /*  28926 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  28931 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  28933 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  28933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  28936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  28938 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  28942 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  28946 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  28950 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  28960 */     GIR_RootConstrainSelectedInstOperands,
     /*  28961 */     // GIR_Coverage, 5123,
     /*  28961 */     GIR_EraseRootFromParent_Done,
     /*  28962 */   // Label 433: @28962
     /*  28962 */   GIM_Try, /*On fail goto*//*Label 434*/ GIMT_Encode4(29100), // Rule ID 5124 //
     /*  28967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  28970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  28974 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28978 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  28982 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28986 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28990 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28994 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  28998 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29002 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29006 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  29010 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  29014 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29018 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29022 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  29026 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  29032 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  29034 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  29038 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  29042 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29046 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  29050 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  29054 */     // MIs[6] vB
     /*  29054 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  29059 */     // MIs[6] vA
     /*  29059 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  29064 */     // MIs[5] vC
     /*  29064 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  29069 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  29071 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  29071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  29074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  29076 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  29080 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  29084 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  29088 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  29098 */     GIR_RootConstrainSelectedInstOperands,
     /*  29099 */     // GIR_Coverage, 5124,
     /*  29099 */     GIR_EraseRootFromParent_Done,
     /*  29100 */   // Label 434: @29100
     /*  29100 */   GIM_Try, /*On fail goto*//*Label 435*/ GIMT_Encode4(29238), // Rule ID 5125 //
     /*  29105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  29108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  29112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  29120 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29124 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29128 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  29132 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  29136 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29140 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29144 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  29148 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  29152 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29156 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29160 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  29164 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  29170 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  29172 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  29176 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  29180 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29184 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  29188 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  29192 */     // MIs[6] vA
     /*  29192 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  29197 */     // MIs[6] vC
     /*  29197 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  29202 */     // MIs[5] vB
     /*  29202 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  29207 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  29209 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  29209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  29212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  29214 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  29218 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  29222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  29226 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  29236 */     GIR_RootConstrainSelectedInstOperands,
     /*  29237 */     // GIR_Coverage, 5125,
     /*  29237 */     GIR_EraseRootFromParent_Done,
     /*  29238 */   // Label 435: @29238
     /*  29238 */   GIM_Try, /*On fail goto*//*Label 436*/ GIMT_Encode4(29376), // Rule ID 5126 //
     /*  29243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  29246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  29250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  29258 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29262 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29266 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  29270 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  29274 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29278 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29282 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  29286 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  29290 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29294 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29298 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  29302 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  29308 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  29310 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  29314 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  29318 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29322 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  29326 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  29330 */     // MIs[6] vC
     /*  29330 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  29335 */     // MIs[6] vA
     /*  29335 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  29340 */     // MIs[5] vB
     /*  29340 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  29345 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  29347 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  29347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  29350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  29352 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  29356 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  29360 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  29364 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  29374 */     GIR_RootConstrainSelectedInstOperands,
     /*  29375 */     // GIR_Coverage, 5126,
     /*  29375 */     GIR_EraseRootFromParent_Done,
     /*  29376 */   // Label 436: @29376
     /*  29376 */   GIM_Try, /*On fail goto*//*Label 437*/ GIMT_Encode4(29514), // Rule ID 5127 //
     /*  29381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  29384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  29388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  29396 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29400 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29404 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  29408 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  29412 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29416 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29420 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  29424 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  29428 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29432 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29436 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  29440 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  29446 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  29448 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  29452 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  29456 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29460 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  29464 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  29468 */     // MIs[6] vB
     /*  29468 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  29473 */     // MIs[6] vC
     /*  29473 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  29478 */     // MIs[5] vA
     /*  29478 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  29483 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  29485 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  29485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  29488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  29490 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  29494 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  29498 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  29502 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  29512 */     GIR_RootConstrainSelectedInstOperands,
     /*  29513 */     // GIR_Coverage, 5127,
     /*  29513 */     GIR_EraseRootFromParent_Done,
     /*  29514 */   // Label 437: @29514
     /*  29514 */   GIM_Try, /*On fail goto*//*Label 438*/ GIMT_Encode4(29652), // Rule ID 5128 //
     /*  29519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  29522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  29526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  29534 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29538 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29542 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  29546 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  29550 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29554 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29558 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  29562 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  29566 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29570 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29574 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  29578 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  29584 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  29586 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  29590 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  29594 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29598 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  29602 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  29606 */     // MIs[6] vC
     /*  29606 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  29611 */     // MIs[6] vB
     /*  29611 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  29616 */     // MIs[5] vA
     /*  29616 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  29621 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  29623 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  29623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  29626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  29628 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  29632 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  29636 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  29640 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  29650 */     GIR_RootConstrainSelectedInstOperands,
     /*  29651 */     // GIR_Coverage, 5128,
     /*  29651 */     GIR_EraseRootFromParent_Done,
     /*  29652 */   // Label 438: @29652
     /*  29652 */   GIM_Try, /*On fail goto*//*Label 439*/ GIMT_Encode4(29790), // Rule ID 5135 //
     /*  29657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  29660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  29664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  29672 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29676 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29680 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  29684 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  29688 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29692 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29696 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  29700 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  29704 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29708 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29712 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  29716 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  29722 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  29724 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  29728 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  29732 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29736 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  29740 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  29744 */     // MIs[6] vA
     /*  29744 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  29749 */     // MIs[6] vB
     /*  29749 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  29754 */     // MIs[5] vC
     /*  29754 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  29759 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  29761 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  29761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  29764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  29766 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  29770 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  29774 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  29778 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  29788 */     GIR_RootConstrainSelectedInstOperands,
     /*  29789 */     // GIR_Coverage, 5135,
     /*  29789 */     GIR_EraseRootFromParent_Done,
     /*  29790 */   // Label 439: @29790
     /*  29790 */   GIM_Try, /*On fail goto*//*Label 440*/ GIMT_Encode4(29928), // Rule ID 5136 //
     /*  29795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  29798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  29802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  29810 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29814 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29818 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  29822 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  29826 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29830 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29834 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  29838 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  29842 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29846 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29850 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  29854 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  29860 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  29862 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  29866 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  29870 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29874 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  29878 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  29882 */     // MIs[6] vB
     /*  29882 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  29887 */     // MIs[6] vA
     /*  29887 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  29892 */     // MIs[5] vC
     /*  29892 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  29897 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  29899 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  29899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  29902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  29904 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  29908 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  29912 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  29916 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  29926 */     GIR_RootConstrainSelectedInstOperands,
     /*  29927 */     // GIR_Coverage, 5136,
     /*  29927 */     GIR_EraseRootFromParent_Done,
     /*  29928 */   // Label 440: @29928
     /*  29928 */   GIM_Try, /*On fail goto*//*Label 441*/ GIMT_Encode4(30066), // Rule ID 5137 //
     /*  29933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  29936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  29940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  29948 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29952 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29956 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  29960 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  29964 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29968 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29972 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  29976 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  29980 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29984 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29988 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  29992 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  29998 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  30000 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  30004 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  30008 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30012 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  30016 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  30020 */     // MIs[6] vA
     /*  30020 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  30025 */     // MIs[6] vC
     /*  30025 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  30030 */     // MIs[5] vB
     /*  30030 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  30035 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  30037 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  30037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  30040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  30042 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  30046 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  30050 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  30054 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  30064 */     GIR_RootConstrainSelectedInstOperands,
     /*  30065 */     // GIR_Coverage, 5137,
     /*  30065 */     GIR_EraseRootFromParent_Done,
     /*  30066 */   // Label 441: @30066
     /*  30066 */   GIM_Try, /*On fail goto*//*Label 442*/ GIMT_Encode4(30204), // Rule ID 5138 //
     /*  30071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  30074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  30078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30082 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  30086 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30090 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30094 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  30098 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  30102 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30106 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30110 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  30114 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  30118 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30122 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30126 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  30130 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  30136 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  30138 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  30142 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  30146 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30150 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  30154 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  30158 */     // MIs[6] vC
     /*  30158 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  30163 */     // MIs[6] vA
     /*  30163 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  30168 */     // MIs[5] vB
     /*  30168 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  30173 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  30175 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  30175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  30178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  30180 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  30184 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  30188 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  30192 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  30202 */     GIR_RootConstrainSelectedInstOperands,
     /*  30203 */     // GIR_Coverage, 5138,
     /*  30203 */     GIR_EraseRootFromParent_Done,
     /*  30204 */   // Label 442: @30204
     /*  30204 */   GIM_Try, /*On fail goto*//*Label 443*/ GIMT_Encode4(30342), // Rule ID 5139 //
     /*  30209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  30212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  30216 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30220 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  30224 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30228 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30232 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  30236 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  30240 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30244 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30248 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  30252 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  30256 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30260 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30264 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  30268 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  30274 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  30276 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  30280 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  30284 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30288 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  30292 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  30296 */     // MIs[6] vB
     /*  30296 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  30301 */     // MIs[6] vC
     /*  30301 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  30306 */     // MIs[5] vA
     /*  30306 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  30311 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  30313 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  30313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  30316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  30318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  30322 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  30326 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  30330 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  30340 */     GIR_RootConstrainSelectedInstOperands,
     /*  30341 */     // GIR_Coverage, 5139,
     /*  30341 */     GIR_EraseRootFromParent_Done,
     /*  30342 */   // Label 443: @30342
     /*  30342 */   GIM_Try, /*On fail goto*//*Label 444*/ GIMT_Encode4(30480), // Rule ID 5140 //
     /*  30347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  30350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  30354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  30362 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30366 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30370 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  30374 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  30378 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30382 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30386 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  30390 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  30394 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30398 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30402 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  30406 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  30412 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  30414 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  30418 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  30422 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30426 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  30430 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  30434 */     // MIs[6] vC
     /*  30434 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  30439 */     // MIs[6] vB
     /*  30439 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  30444 */     // MIs[5] vA
     /*  30444 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  30449 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  30451 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  30451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  30454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  30456 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  30460 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  30464 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  30468 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  30478 */     GIR_RootConstrainSelectedInstOperands,
     /*  30479 */     // GIR_Coverage, 5140,
     /*  30479 */     GIR_EraseRootFromParent_Done,
     /*  30480 */   // Label 444: @30480
     /*  30480 */   GIM_Try, /*On fail goto*//*Label 445*/ GIMT_Encode4(30618), // Rule ID 5081 //
     /*  30485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  30488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  30492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  30500 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30504 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30508 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  30512 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  30516 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30520 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30524 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  30528 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  30532 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30536 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30540 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  30544 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  30550 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  30552 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  30556 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  30560 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30564 */     // MIs[5] vC
     /*  30564 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  30569 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  30573 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  30577 */     // MIs[6] vA
     /*  30577 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  30582 */     // MIs[6] vB
     /*  30582 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  30587 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  30589 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  30589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  30592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  30594 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  30598 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  30602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  30606 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  30616 */     GIR_RootConstrainSelectedInstOperands,
     /*  30617 */     // GIR_Coverage, 5081,
     /*  30617 */     GIR_EraseRootFromParent_Done,
     /*  30618 */   // Label 445: @30618
     /*  30618 */   GIM_Try, /*On fail goto*//*Label 446*/ GIMT_Encode4(30756), // Rule ID 5082 //
     /*  30623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  30626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  30630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  30638 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30642 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30646 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  30650 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  30654 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30658 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30662 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  30666 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  30670 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30674 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30678 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  30682 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  30688 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  30690 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  30694 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  30698 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30702 */     // MIs[5] vC
     /*  30702 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  30707 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  30711 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  30715 */     // MIs[6] vB
     /*  30715 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  30720 */     // MIs[6] vA
     /*  30720 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  30725 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  30727 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  30727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  30730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  30732 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  30736 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  30740 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  30744 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  30754 */     GIR_RootConstrainSelectedInstOperands,
     /*  30755 */     // GIR_Coverage, 5082,
     /*  30755 */     GIR_EraseRootFromParent_Done,
     /*  30756 */   // Label 446: @30756
     /*  30756 */   GIM_Try, /*On fail goto*//*Label 447*/ GIMT_Encode4(30894), // Rule ID 5083 //
     /*  30761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  30764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  30768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  30776 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30780 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30784 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  30788 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  30792 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30796 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30800 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  30804 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  30808 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30812 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30816 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  30820 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  30826 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  30828 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  30832 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  30836 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30840 */     // MIs[5] vB
     /*  30840 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  30845 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  30849 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  30853 */     // MIs[6] vA
     /*  30853 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  30858 */     // MIs[6] vC
     /*  30858 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  30863 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  30865 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  30865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  30868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  30870 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  30874 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  30878 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  30882 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  30892 */     GIR_RootConstrainSelectedInstOperands,
     /*  30893 */     // GIR_Coverage, 5083,
     /*  30893 */     GIR_EraseRootFromParent_Done,
     /*  30894 */   // Label 447: @30894
     /*  30894 */   GIM_Try, /*On fail goto*//*Label 448*/ GIMT_Encode4(31032), // Rule ID 5084 //
     /*  30899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  30902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  30906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  30914 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30918 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30922 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  30926 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  30930 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30934 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30938 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  30942 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  30946 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30950 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30954 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  30958 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  30964 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  30966 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  30970 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  30974 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30978 */     // MIs[5] vB
     /*  30978 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  30983 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  30987 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  30991 */     // MIs[6] vC
     /*  30991 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  30996 */     // MIs[6] vA
     /*  30996 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  31001 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  31003 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  31003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  31006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  31008 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  31012 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  31016 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  31020 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  31030 */     GIR_RootConstrainSelectedInstOperands,
     /*  31031 */     // GIR_Coverage, 5084,
     /*  31031 */     GIR_EraseRootFromParent_Done,
     /*  31032 */   // Label 448: @31032
     /*  31032 */   GIM_Try, /*On fail goto*//*Label 449*/ GIMT_Encode4(31170), // Rule ID 5085 //
     /*  31037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  31040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  31044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  31052 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31056 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31060 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31064 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  31068 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31072 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31076 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  31080 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  31084 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31088 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31092 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  31096 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  31102 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  31104 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  31108 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  31112 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31116 */     // MIs[5] vA
     /*  31116 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  31121 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  31125 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  31129 */     // MIs[6] vB
     /*  31129 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  31134 */     // MIs[6] vC
     /*  31134 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  31139 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  31141 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  31141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  31144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  31146 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  31150 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  31154 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  31158 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  31168 */     GIR_RootConstrainSelectedInstOperands,
     /*  31169 */     // GIR_Coverage, 5085,
     /*  31169 */     GIR_EraseRootFromParent_Done,
     /*  31170 */   // Label 449: @31170
     /*  31170 */   GIM_Try, /*On fail goto*//*Label 450*/ GIMT_Encode4(31308), // Rule ID 5086 //
     /*  31175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  31178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  31182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  31190 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31194 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31198 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31202 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  31206 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31210 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31214 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  31218 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  31222 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31226 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31230 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  31234 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  31240 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  31242 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  31246 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  31250 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31254 */     // MIs[5] vA
     /*  31254 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  31259 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  31263 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  31267 */     // MIs[6] vC
     /*  31267 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  31272 */     // MIs[6] vB
     /*  31272 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  31277 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  31279 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  31279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  31282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  31284 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  31288 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  31292 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  31296 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  31306 */     GIR_RootConstrainSelectedInstOperands,
     /*  31307 */     // GIR_Coverage, 5086,
     /*  31307 */     GIR_EraseRootFromParent_Done,
     /*  31308 */   // Label 450: @31308
     /*  31308 */   GIM_Try, /*On fail goto*//*Label 451*/ GIMT_Encode4(31446), // Rule ID 5093 //
     /*  31313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  31316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  31320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  31328 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31332 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31336 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31340 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  31344 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31348 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31352 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  31356 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  31360 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31364 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31368 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  31372 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  31378 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  31380 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  31384 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  31388 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31392 */     // MIs[5] vC
     /*  31392 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  31397 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  31401 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  31405 */     // MIs[6] vA
     /*  31405 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  31410 */     // MIs[6] vB
     /*  31410 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  31415 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  31417 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  31417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  31420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  31422 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  31426 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  31430 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  31434 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  31444 */     GIR_RootConstrainSelectedInstOperands,
     /*  31445 */     // GIR_Coverage, 5093,
     /*  31445 */     GIR_EraseRootFromParent_Done,
     /*  31446 */   // Label 451: @31446
     /*  31446 */   GIM_Try, /*On fail goto*//*Label 452*/ GIMT_Encode4(31584), // Rule ID 5094 //
     /*  31451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  31454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  31458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  31466 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31470 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31474 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31478 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  31482 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31486 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31490 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  31494 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  31498 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31502 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31506 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  31510 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  31516 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  31518 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  31522 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  31526 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31530 */     // MIs[5] vC
     /*  31530 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  31535 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  31539 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  31543 */     // MIs[6] vB
     /*  31543 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  31548 */     // MIs[6] vA
     /*  31548 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  31553 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  31555 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  31555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  31558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  31560 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  31564 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  31568 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  31572 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  31582 */     GIR_RootConstrainSelectedInstOperands,
     /*  31583 */     // GIR_Coverage, 5094,
     /*  31583 */     GIR_EraseRootFromParent_Done,
     /*  31584 */   // Label 452: @31584
     /*  31584 */   GIM_Try, /*On fail goto*//*Label 453*/ GIMT_Encode4(31722), // Rule ID 5095 //
     /*  31589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  31592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  31596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  31604 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31608 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31612 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31616 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  31620 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31624 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31628 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  31632 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  31636 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31640 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31644 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  31648 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  31654 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  31656 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  31660 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  31664 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31668 */     // MIs[5] vB
     /*  31668 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  31673 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  31677 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  31681 */     // MIs[6] vA
     /*  31681 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  31686 */     // MIs[6] vC
     /*  31686 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  31691 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  31693 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  31693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  31696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  31698 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  31702 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  31706 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  31710 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  31720 */     GIR_RootConstrainSelectedInstOperands,
     /*  31721 */     // GIR_Coverage, 5095,
     /*  31721 */     GIR_EraseRootFromParent_Done,
     /*  31722 */   // Label 453: @31722
     /*  31722 */   GIM_Try, /*On fail goto*//*Label 454*/ GIMT_Encode4(31860), // Rule ID 5096 //
     /*  31727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  31730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  31734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  31742 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31746 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31750 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31754 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  31758 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31762 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31766 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  31770 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  31774 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31778 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31782 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  31786 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  31792 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  31794 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  31798 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  31802 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31806 */     // MIs[5] vB
     /*  31806 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  31811 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  31815 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  31819 */     // MIs[6] vC
     /*  31819 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  31824 */     // MIs[6] vA
     /*  31824 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  31829 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  31831 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  31831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  31834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  31836 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  31840 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  31844 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  31848 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  31858 */     GIR_RootConstrainSelectedInstOperands,
     /*  31859 */     // GIR_Coverage, 5096,
     /*  31859 */     GIR_EraseRootFromParent_Done,
     /*  31860 */   // Label 454: @31860
     /*  31860 */   GIM_Try, /*On fail goto*//*Label 455*/ GIMT_Encode4(31998), // Rule ID 5097 //
     /*  31865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  31868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  31872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  31880 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31884 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31888 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31892 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  31896 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31900 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31904 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  31908 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  31912 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31916 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31920 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  31924 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  31930 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  31932 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  31936 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  31940 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31944 */     // MIs[5] vA
     /*  31944 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  31949 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  31953 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  31957 */     // MIs[6] vB
     /*  31957 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  31962 */     // MIs[6] vC
     /*  31962 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  31967 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  31969 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  31969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  31972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  31974 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  31978 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  31982 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  31986 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  31996 */     GIR_RootConstrainSelectedInstOperands,
     /*  31997 */     // GIR_Coverage, 5097,
     /*  31997 */     GIR_EraseRootFromParent_Done,
     /*  31998 */   // Label 455: @31998
     /*  31998 */   GIM_Try, /*On fail goto*//*Label 456*/ GIMT_Encode4(32136), // Rule ID 5098 //
     /*  32003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  32006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  32010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  32018 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32022 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32026 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32030 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  32034 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32038 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32042 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  32046 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  32050 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32054 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32058 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  32062 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  32068 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  32070 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  32074 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  32078 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32082 */     // MIs[5] vA
     /*  32082 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  32087 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  32091 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  32095 */     // MIs[6] vC
     /*  32095 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  32100 */     // MIs[6] vB
     /*  32100 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  32105 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  32107 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  32107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  32110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  32112 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  32116 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  32120 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  32124 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  32134 */     GIR_RootConstrainSelectedInstOperands,
     /*  32135 */     // GIR_Coverage, 5098,
     /*  32135 */     GIR_EraseRootFromParent_Done,
     /*  32136 */   // Label 456: @32136
     /*  32136 */   GIM_Try, /*On fail goto*//*Label 457*/ GIMT_Encode4(32274), // Rule ID 5105 //
     /*  32141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  32144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  32148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  32156 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32160 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32164 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32168 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  32172 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32176 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32180 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  32184 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  32188 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32192 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32196 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  32200 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  32206 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  32208 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  32212 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  32216 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32220 */     // MIs[5] vC
     /*  32220 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  32225 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  32229 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  32233 */     // MIs[6] vA
     /*  32233 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  32238 */     // MIs[6] vB
     /*  32238 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  32243 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  32245 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  32245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  32248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  32250 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  32254 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  32258 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  32262 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  32272 */     GIR_RootConstrainSelectedInstOperands,
     /*  32273 */     // GIR_Coverage, 5105,
     /*  32273 */     GIR_EraseRootFromParent_Done,
     /*  32274 */   // Label 457: @32274
     /*  32274 */   GIM_Try, /*On fail goto*//*Label 458*/ GIMT_Encode4(32412), // Rule ID 5106 //
     /*  32279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  32282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  32286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  32294 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32298 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32302 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32306 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  32310 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32314 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32318 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  32322 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  32326 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32330 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32334 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  32338 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  32344 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  32346 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  32350 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  32354 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32358 */     // MIs[5] vC
     /*  32358 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  32363 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  32367 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  32371 */     // MIs[6] vB
     /*  32371 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  32376 */     // MIs[6] vA
     /*  32376 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  32381 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  32383 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  32383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  32386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  32388 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  32392 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  32396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  32400 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  32410 */     GIR_RootConstrainSelectedInstOperands,
     /*  32411 */     // GIR_Coverage, 5106,
     /*  32411 */     GIR_EraseRootFromParent_Done,
     /*  32412 */   // Label 458: @32412
     /*  32412 */   GIM_Try, /*On fail goto*//*Label 459*/ GIMT_Encode4(32550), // Rule ID 5107 //
     /*  32417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  32420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  32424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  32432 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32436 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32440 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32444 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  32448 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32452 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32456 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  32460 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  32464 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32468 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32472 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  32476 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  32482 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  32484 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  32488 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  32492 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32496 */     // MIs[5] vB
     /*  32496 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  32501 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  32505 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  32509 */     // MIs[6] vA
     /*  32509 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  32514 */     // MIs[6] vC
     /*  32514 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  32519 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  32521 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  32521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  32524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  32526 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  32530 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  32534 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  32538 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  32548 */     GIR_RootConstrainSelectedInstOperands,
     /*  32549 */     // GIR_Coverage, 5107,
     /*  32549 */     GIR_EraseRootFromParent_Done,
     /*  32550 */   // Label 459: @32550
     /*  32550 */   GIM_Try, /*On fail goto*//*Label 460*/ GIMT_Encode4(32688), // Rule ID 5108 //
     /*  32555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  32558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  32562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  32570 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32574 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32578 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32582 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  32586 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32590 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32594 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  32598 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  32602 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32606 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32610 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  32614 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  32620 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  32622 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  32626 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  32630 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32634 */     // MIs[5] vB
     /*  32634 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  32639 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  32643 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  32647 */     // MIs[6] vC
     /*  32647 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  32652 */     // MIs[6] vA
     /*  32652 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  32657 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  32659 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  32659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  32662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  32664 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  32668 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  32672 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  32676 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  32686 */     GIR_RootConstrainSelectedInstOperands,
     /*  32687 */     // GIR_Coverage, 5108,
     /*  32687 */     GIR_EraseRootFromParent_Done,
     /*  32688 */   // Label 460: @32688
     /*  32688 */   GIM_Try, /*On fail goto*//*Label 461*/ GIMT_Encode4(32826), // Rule ID 5109 //
     /*  32693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  32696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  32700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  32708 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32712 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32716 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32720 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  32724 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32728 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32732 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  32736 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  32740 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32744 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32748 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  32752 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  32758 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  32760 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  32764 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  32768 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32772 */     // MIs[5] vA
     /*  32772 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  32777 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  32781 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  32785 */     // MIs[6] vB
     /*  32785 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  32790 */     // MIs[6] vC
     /*  32790 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  32795 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  32797 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  32797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  32800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  32802 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  32806 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  32810 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  32814 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  32824 */     GIR_RootConstrainSelectedInstOperands,
     /*  32825 */     // GIR_Coverage, 5109,
     /*  32825 */     GIR_EraseRootFromParent_Done,
     /*  32826 */   // Label 461: @32826
     /*  32826 */   GIM_Try, /*On fail goto*//*Label 462*/ GIMT_Encode4(32964), // Rule ID 5110 //
     /*  32831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  32834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  32838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  32846 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32850 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32854 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32858 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  32862 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32866 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32870 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  32874 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  32878 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32882 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32886 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  32890 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  32896 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  32898 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  32902 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  32906 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32910 */     // MIs[5] vA
     /*  32910 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  32915 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  32919 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  32923 */     // MIs[6] vC
     /*  32923 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  32928 */     // MIs[6] vB
     /*  32928 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  32933 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  32935 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  32935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  32938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  32940 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  32944 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  32948 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  32952 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  32962 */     GIR_RootConstrainSelectedInstOperands,
     /*  32963 */     // GIR_Coverage, 5110,
     /*  32963 */     GIR_EraseRootFromParent_Done,
     /*  32964 */   // Label 462: @32964
     /*  32964 */   GIM_Try, /*On fail goto*//*Label 463*/ GIMT_Encode4(33102), // Rule ID 5117 //
     /*  32969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  32972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  32976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  32984 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32988 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32992 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32996 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  33000 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33004 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33008 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  33012 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  33016 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33020 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33024 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  33028 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  33034 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  33036 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  33040 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  33044 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33048 */     // MIs[5] vC
     /*  33048 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  33053 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  33057 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  33061 */     // MIs[6] vA
     /*  33061 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  33066 */     // MIs[6] vB
     /*  33066 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  33071 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  33073 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  33073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  33076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  33078 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  33082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  33086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  33090 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  33100 */     GIR_RootConstrainSelectedInstOperands,
     /*  33101 */     // GIR_Coverage, 5117,
     /*  33101 */     GIR_EraseRootFromParent_Done,
     /*  33102 */   // Label 463: @33102
     /*  33102 */   GIM_Try, /*On fail goto*//*Label 464*/ GIMT_Encode4(33240), // Rule ID 5118 //
     /*  33107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  33110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  33114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  33122 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33126 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33130 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  33134 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  33138 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33142 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33146 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  33150 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  33154 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33158 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33162 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  33166 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  33172 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  33174 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  33178 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  33182 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33186 */     // MIs[5] vC
     /*  33186 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  33191 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  33195 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  33199 */     // MIs[6] vB
     /*  33199 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  33204 */     // MIs[6] vA
     /*  33204 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  33209 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  33211 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  33211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  33214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  33216 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  33220 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  33224 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  33228 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  33238 */     GIR_RootConstrainSelectedInstOperands,
     /*  33239 */     // GIR_Coverage, 5118,
     /*  33239 */     GIR_EraseRootFromParent_Done,
     /*  33240 */   // Label 464: @33240
     /*  33240 */   GIM_Try, /*On fail goto*//*Label 465*/ GIMT_Encode4(33378), // Rule ID 5119 //
     /*  33245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  33248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  33252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  33260 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33264 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33268 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  33272 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  33276 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33280 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33284 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  33288 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  33292 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33296 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33300 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  33304 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  33310 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  33312 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  33316 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  33320 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33324 */     // MIs[5] vB
     /*  33324 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  33329 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  33333 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  33337 */     // MIs[6] vA
     /*  33337 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  33342 */     // MIs[6] vC
     /*  33342 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  33347 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  33349 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  33349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  33352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  33354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  33358 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  33362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  33366 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  33376 */     GIR_RootConstrainSelectedInstOperands,
     /*  33377 */     // GIR_Coverage, 5119,
     /*  33377 */     GIR_EraseRootFromParent_Done,
     /*  33378 */   // Label 465: @33378
     /*  33378 */   GIM_Try, /*On fail goto*//*Label 466*/ GIMT_Encode4(33516), // Rule ID 5120 //
     /*  33383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  33386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  33390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33394 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  33398 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33402 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33406 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  33410 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  33414 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33418 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33422 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  33426 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  33430 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33434 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33438 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  33442 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  33448 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  33450 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  33454 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  33458 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33462 */     // MIs[5] vB
     /*  33462 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  33467 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  33471 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  33475 */     // MIs[6] vC
     /*  33475 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  33480 */     // MIs[6] vA
     /*  33480 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  33485 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  33487 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  33487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  33490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  33492 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  33496 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  33500 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  33504 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  33514 */     GIR_RootConstrainSelectedInstOperands,
     /*  33515 */     // GIR_Coverage, 5120,
     /*  33515 */     GIR_EraseRootFromParent_Done,
     /*  33516 */   // Label 466: @33516
     /*  33516 */   GIM_Try, /*On fail goto*//*Label 467*/ GIMT_Encode4(33654), // Rule ID 5121 //
     /*  33521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  33524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  33528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  33536 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33540 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33544 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  33548 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  33552 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33556 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33560 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  33564 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  33568 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33572 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33576 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  33580 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  33586 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  33588 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  33592 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  33596 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33600 */     // MIs[5] vA
     /*  33600 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  33605 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  33609 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  33613 */     // MIs[6] vB
     /*  33613 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  33618 */     // MIs[6] vC
     /*  33618 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  33623 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  33625 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  33625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  33628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  33630 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  33634 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  33638 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  33642 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  33652 */     GIR_RootConstrainSelectedInstOperands,
     /*  33653 */     // GIR_Coverage, 5121,
     /*  33653 */     GIR_EraseRootFromParent_Done,
     /*  33654 */   // Label 467: @33654
     /*  33654 */   GIM_Try, /*On fail goto*//*Label 468*/ GIMT_Encode4(33792), // Rule ID 5122 //
     /*  33659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  33662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  33666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  33674 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33678 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33682 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  33686 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  33690 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33694 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33698 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  33702 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  33706 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33710 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33714 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  33718 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  33724 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  33726 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  33730 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  33734 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33738 */     // MIs[5] vA
     /*  33738 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  33743 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  33747 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  33751 */     // MIs[6] vC
     /*  33751 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  33756 */     // MIs[6] vB
     /*  33756 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  33761 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  33763 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  33763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  33766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  33768 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  33772 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  33776 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  33780 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  33790 */     GIR_RootConstrainSelectedInstOperands,
     /*  33791 */     // GIR_Coverage, 5122,
     /*  33791 */     GIR_EraseRootFromParent_Done,
     /*  33792 */   // Label 468: @33792
     /*  33792 */   GIM_Try, /*On fail goto*//*Label 469*/ GIMT_Encode4(33930), // Rule ID 5129 //
     /*  33797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  33800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  33804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  33812 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33816 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33820 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  33824 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  33828 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33832 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33836 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  33840 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  33844 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33848 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33852 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  33856 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  33862 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  33864 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  33868 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  33872 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33876 */     // MIs[5] vC
     /*  33876 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  33881 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  33885 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  33889 */     // MIs[6] vA
     /*  33889 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  33894 */     // MIs[6] vB
     /*  33894 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  33899 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  33901 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  33901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  33904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  33906 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  33910 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  33914 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  33918 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  33928 */     GIR_RootConstrainSelectedInstOperands,
     /*  33929 */     // GIR_Coverage, 5129,
     /*  33929 */     GIR_EraseRootFromParent_Done,
     /*  33930 */   // Label 469: @33930
     /*  33930 */   GIM_Try, /*On fail goto*//*Label 470*/ GIMT_Encode4(34068), // Rule ID 5130 //
     /*  33935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  33938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  33942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  33950 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33954 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33958 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  33962 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  33966 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33970 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33974 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  33978 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  33982 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33986 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33990 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  33994 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  34000 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  34002 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  34006 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  34010 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34014 */     // MIs[5] vC
     /*  34014 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  34019 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  34023 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  34027 */     // MIs[6] vB
     /*  34027 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  34032 */     // MIs[6] vA
     /*  34032 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  34037 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  34039 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  34039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  34042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  34044 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  34048 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  34052 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  34056 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  34066 */     GIR_RootConstrainSelectedInstOperands,
     /*  34067 */     // GIR_Coverage, 5130,
     /*  34067 */     GIR_EraseRootFromParent_Done,
     /*  34068 */   // Label 470: @34068
     /*  34068 */   GIM_Try, /*On fail goto*//*Label 471*/ GIMT_Encode4(34206), // Rule ID 5131 //
     /*  34073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  34076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  34080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  34088 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34092 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34096 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  34100 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  34104 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34108 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34112 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  34116 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  34120 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34124 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34128 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  34132 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  34138 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  34140 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  34144 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  34148 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34152 */     // MIs[5] vB
     /*  34152 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  34157 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  34161 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  34165 */     // MIs[6] vA
     /*  34165 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  34170 */     // MIs[6] vC
     /*  34170 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  34175 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  34177 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  34177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  34180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  34182 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  34186 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  34190 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  34194 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  34204 */     GIR_RootConstrainSelectedInstOperands,
     /*  34205 */     // GIR_Coverage, 5131,
     /*  34205 */     GIR_EraseRootFromParent_Done,
     /*  34206 */   // Label 471: @34206
     /*  34206 */   GIM_Try, /*On fail goto*//*Label 472*/ GIMT_Encode4(34344), // Rule ID 5132 //
     /*  34211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  34214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  34218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  34226 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34230 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34234 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  34238 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  34242 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34246 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34250 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  34254 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  34258 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34262 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34266 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  34270 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  34276 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  34278 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  34282 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  34286 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34290 */     // MIs[5] vB
     /*  34290 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  34295 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  34299 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  34303 */     // MIs[6] vC
     /*  34303 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  34308 */     // MIs[6] vA
     /*  34308 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  34313 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  34315 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  34315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  34318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  34320 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  34324 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  34328 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  34332 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  34342 */     GIR_RootConstrainSelectedInstOperands,
     /*  34343 */     // GIR_Coverage, 5132,
     /*  34343 */     GIR_EraseRootFromParent_Done,
     /*  34344 */   // Label 472: @34344
     /*  34344 */   GIM_Try, /*On fail goto*//*Label 473*/ GIMT_Encode4(34482), // Rule ID 5133 //
     /*  34349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  34352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  34356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  34364 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34368 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34372 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  34376 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  34380 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34384 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34388 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  34392 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  34396 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34400 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34404 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  34408 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  34414 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  34416 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  34420 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  34424 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34428 */     // MIs[5] vA
     /*  34428 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  34433 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  34437 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  34441 */     // MIs[6] vB
     /*  34441 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  34446 */     // MIs[6] vC
     /*  34446 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  34451 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  34453 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  34453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  34456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  34458 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  34462 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  34466 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  34470 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  34480 */     GIR_RootConstrainSelectedInstOperands,
     /*  34481 */     // GIR_Coverage, 5133,
     /*  34481 */     GIR_EraseRootFromParent_Done,
     /*  34482 */   // Label 473: @34482
     /*  34482 */   GIM_Try, /*On fail goto*//*Label 474*/ GIMT_Encode4(34620), // Rule ID 5134 //
     /*  34487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  34490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  34494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  34502 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34506 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34510 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  34514 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  34518 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34522 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34526 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  34530 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  34534 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34538 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34542 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  34546 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  34552 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  34554 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  34558 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  34562 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34566 */     // MIs[5] vA
     /*  34566 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  34571 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  34575 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  34579 */     // MIs[6] vC
     /*  34579 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  34584 */     // MIs[6] vB
     /*  34584 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  34589 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  34591 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  34591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  34594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  34596 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  34600 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  34604 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  34608 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  34618 */     GIR_RootConstrainSelectedInstOperands,
     /*  34619 */     // GIR_Coverage, 5134,
     /*  34619 */     GIR_EraseRootFromParent_Done,
     /*  34620 */   // Label 474: @34620
     /*  34620 */   GIM_Try, /*On fail goto*//*Label 475*/ GIMT_Encode4(34758), // Rule ID 5141 //
     /*  34625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  34628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  34632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  34640 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34644 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34648 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  34652 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  34656 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34660 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34664 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  34668 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  34672 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34676 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34680 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  34684 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  34690 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  34692 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  34696 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  34700 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34704 */     // MIs[5] vC
     /*  34704 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  34709 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  34713 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  34717 */     // MIs[6] vA
     /*  34717 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  34722 */     // MIs[6] vB
     /*  34722 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  34727 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  34729 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  34729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  34732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  34734 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  34738 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  34742 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  34746 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  34756 */     GIR_RootConstrainSelectedInstOperands,
     /*  34757 */     // GIR_Coverage, 5141,
     /*  34757 */     GIR_EraseRootFromParent_Done,
     /*  34758 */   // Label 475: @34758
     /*  34758 */   GIM_Try, /*On fail goto*//*Label 476*/ GIMT_Encode4(34896), // Rule ID 5142 //
     /*  34763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  34766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  34770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  34778 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34782 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34786 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  34790 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  34794 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34798 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34802 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  34806 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  34810 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34814 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34818 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  34822 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  34828 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  34830 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  34834 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  34838 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34842 */     // MIs[5] vC
     /*  34842 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  34847 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  34851 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  34855 */     // MIs[6] vB
     /*  34855 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  34860 */     // MIs[6] vA
     /*  34860 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  34865 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  34867 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  34867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  34870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  34872 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  34876 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  34880 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  34884 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  34894 */     GIR_RootConstrainSelectedInstOperands,
     /*  34895 */     // GIR_Coverage, 5142,
     /*  34895 */     GIR_EraseRootFromParent_Done,
     /*  34896 */   // Label 476: @34896
     /*  34896 */   GIM_Try, /*On fail goto*//*Label 477*/ GIMT_Encode4(35034), // Rule ID 5143 //
     /*  34901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  34904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  34908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  34916 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34920 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34924 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  34928 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  34932 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34936 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34940 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  34944 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  34948 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34952 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34956 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  34960 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  34966 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  34968 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  34972 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  34976 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34980 */     // MIs[5] vB
     /*  34980 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  34985 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  34989 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  34993 */     // MIs[6] vA
     /*  34993 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  34998 */     // MIs[6] vC
     /*  34998 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  35003 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  35005 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  35005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  35008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  35010 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  35014 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  35018 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  35022 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  35032 */     GIR_RootConstrainSelectedInstOperands,
     /*  35033 */     // GIR_Coverage, 5143,
     /*  35033 */     GIR_EraseRootFromParent_Done,
     /*  35034 */   // Label 477: @35034
     /*  35034 */   GIM_Try, /*On fail goto*//*Label 478*/ GIMT_Encode4(35172), // Rule ID 5144 //
     /*  35039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  35042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  35046 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35050 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  35054 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35058 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35062 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  35066 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  35070 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35074 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35078 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  35082 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  35086 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35090 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35094 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  35098 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  35104 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  35106 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  35110 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  35114 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35118 */     // MIs[5] vB
     /*  35118 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  35123 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  35127 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  35131 */     // MIs[6] vC
     /*  35131 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  35136 */     // MIs[6] vA
     /*  35136 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  35141 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  35143 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  35143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  35146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  35148 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  35152 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  35156 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  35160 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  35170 */     GIR_RootConstrainSelectedInstOperands,
     /*  35171 */     // GIR_Coverage, 5144,
     /*  35171 */     GIR_EraseRootFromParent_Done,
     /*  35172 */   // Label 478: @35172
     /*  35172 */   GIM_Try, /*On fail goto*//*Label 479*/ GIMT_Encode4(35310), // Rule ID 5145 //
     /*  35177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  35180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  35184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  35192 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35196 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35200 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  35204 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  35208 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35212 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35216 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  35220 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  35224 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35228 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35232 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  35236 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  35242 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  35244 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  35248 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  35252 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35256 */     // MIs[5] vA
     /*  35256 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  35261 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  35265 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  35269 */     // MIs[6] vB
     /*  35269 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  35274 */     // MIs[6] vC
     /*  35274 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  35279 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  35281 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  35281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  35284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  35286 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  35290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  35294 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  35298 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  35308 */     GIR_RootConstrainSelectedInstOperands,
     /*  35309 */     // GIR_Coverage, 5145,
     /*  35309 */     GIR_EraseRootFromParent_Done,
     /*  35310 */   // Label 479: @35310
     /*  35310 */   GIM_Try, /*On fail goto*//*Label 480*/ GIMT_Encode4(35448), // Rule ID 5146 //
     /*  35315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  35318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  35322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  35330 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35334 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35338 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  35342 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  35346 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35350 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35354 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  35358 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  35362 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35366 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35370 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  35374 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  35380 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  35382 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  35386 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  35390 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35394 */     // MIs[5] vA
     /*  35394 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  35399 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  35403 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  35407 */     // MIs[6] vC
     /*  35407 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  35412 */     // MIs[6] vB
     /*  35412 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  35417 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  35419 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  35419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  35422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  35424 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  35428 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  35432 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  35436 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  35446 */     GIR_RootConstrainSelectedInstOperands,
     /*  35447 */     // GIR_Coverage, 5146,
     /*  35447 */     GIR_EraseRootFromParent_Done,
     /*  35448 */   // Label 480: @35448
     /*  35448 */   GIM_Try, /*On fail goto*//*Label 481*/ GIMT_Encode4(35586), // Rule ID 5147 //
     /*  35453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  35456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  35460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  35468 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35472 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35476 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  35480 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  35484 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35488 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35492 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  35496 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  35500 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35504 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35508 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  35512 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  35518 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  35520 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  35524 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  35528 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35532 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  35536 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  35540 */     // MIs[6] vA
     /*  35540 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  35545 */     // MIs[6] vB
     /*  35545 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  35550 */     // MIs[5] vC
     /*  35550 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  35555 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  35557 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  35557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  35560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  35562 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  35566 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  35570 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  35574 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  35584 */     GIR_RootConstrainSelectedInstOperands,
     /*  35585 */     // GIR_Coverage, 5147,
     /*  35585 */     GIR_EraseRootFromParent_Done,
     /*  35586 */   // Label 481: @35586
     /*  35586 */   GIM_Try, /*On fail goto*//*Label 482*/ GIMT_Encode4(35724), // Rule ID 5148 //
     /*  35591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  35594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  35598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  35606 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35610 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35614 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  35618 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  35622 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35626 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35630 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  35634 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  35638 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35642 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35646 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  35650 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  35656 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  35658 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  35662 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  35666 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35670 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  35674 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  35678 */     // MIs[6] vB
     /*  35678 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  35683 */     // MIs[6] vA
     /*  35683 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  35688 */     // MIs[5] vC
     /*  35688 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  35693 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  35695 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  35695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  35698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  35700 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  35704 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  35708 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  35712 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  35722 */     GIR_RootConstrainSelectedInstOperands,
     /*  35723 */     // GIR_Coverage, 5148,
     /*  35723 */     GIR_EraseRootFromParent_Done,
     /*  35724 */   // Label 482: @35724
     /*  35724 */   GIM_Try, /*On fail goto*//*Label 483*/ GIMT_Encode4(35862), // Rule ID 5149 //
     /*  35729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  35732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  35736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  35744 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35748 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35752 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  35756 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  35760 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35764 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35768 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  35772 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  35776 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35780 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35784 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  35788 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  35794 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  35796 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  35800 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  35804 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35808 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  35812 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  35816 */     // MIs[6] vA
     /*  35816 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  35821 */     // MIs[6] vC
     /*  35821 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  35826 */     // MIs[5] vB
     /*  35826 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  35831 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  35833 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  35833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  35836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  35838 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  35842 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  35846 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  35850 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  35860 */     GIR_RootConstrainSelectedInstOperands,
     /*  35861 */     // GIR_Coverage, 5149,
     /*  35861 */     GIR_EraseRootFromParent_Done,
     /*  35862 */   // Label 483: @35862
     /*  35862 */   GIM_Try, /*On fail goto*//*Label 484*/ GIMT_Encode4(36000), // Rule ID 5150 //
     /*  35867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  35870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  35874 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35878 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  35882 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35886 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35890 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  35894 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  35898 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35902 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35906 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  35910 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  35914 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35918 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35922 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  35926 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  35932 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  35934 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  35938 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  35942 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35946 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  35950 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  35954 */     // MIs[6] vC
     /*  35954 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  35959 */     // MIs[6] vA
     /*  35959 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  35964 */     // MIs[5] vB
     /*  35964 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  35969 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  35971 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  35971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  35974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  35976 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  35980 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  35984 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  35988 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  35998 */     GIR_RootConstrainSelectedInstOperands,
     /*  35999 */     // GIR_Coverage, 5150,
     /*  35999 */     GIR_EraseRootFromParent_Done,
     /*  36000 */   // Label 484: @36000
     /*  36000 */   GIM_Try, /*On fail goto*//*Label 485*/ GIMT_Encode4(36138), // Rule ID 5151 //
     /*  36005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  36008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  36012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  36020 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36024 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36028 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36032 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  36036 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36040 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36044 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  36048 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  36052 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36056 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36060 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  36064 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  36070 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  36072 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  36076 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36080 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36084 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  36088 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36092 */     // MIs[6] vB
     /*  36092 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  36097 */     // MIs[6] vC
     /*  36097 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  36102 */     // MIs[5] vA
     /*  36102 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  36107 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  36109 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  36109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  36112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  36114 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  36118 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  36122 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  36126 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  36136 */     GIR_RootConstrainSelectedInstOperands,
     /*  36137 */     // GIR_Coverage, 5151,
     /*  36137 */     GIR_EraseRootFromParent_Done,
     /*  36138 */   // Label 485: @36138
     /*  36138 */   GIM_Try, /*On fail goto*//*Label 486*/ GIMT_Encode4(36276), // Rule ID 5152 //
     /*  36143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  36146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  36150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  36158 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36162 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36166 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36170 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  36174 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36178 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36182 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  36186 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  36190 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36194 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36198 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  36202 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  36208 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  36210 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  36214 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36218 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36222 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  36226 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36230 */     // MIs[6] vC
     /*  36230 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  36235 */     // MIs[6] vB
     /*  36235 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  36240 */     // MIs[5] vA
     /*  36240 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  36245 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  36247 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  36247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  36250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  36252 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  36256 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  36260 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  36264 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  36274 */     GIR_RootConstrainSelectedInstOperands,
     /*  36275 */     // GIR_Coverage, 5152,
     /*  36275 */     GIR_EraseRootFromParent_Done,
     /*  36276 */   // Label 486: @36276
     /*  36276 */   GIM_Try, /*On fail goto*//*Label 487*/ GIMT_Encode4(36414), // Rule ID 5159 //
     /*  36281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  36284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  36288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  36296 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36300 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36304 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36308 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  36312 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36316 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36320 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  36324 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  36328 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36332 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36336 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  36340 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  36346 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  36348 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  36352 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36356 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36360 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  36364 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36368 */     // MIs[6] vA
     /*  36368 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  36373 */     // MIs[6] vB
     /*  36373 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  36378 */     // MIs[5] vC
     /*  36378 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  36383 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  36385 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  36385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  36388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  36390 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  36394 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  36398 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  36402 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  36412 */     GIR_RootConstrainSelectedInstOperands,
     /*  36413 */     // GIR_Coverage, 5159,
     /*  36413 */     GIR_EraseRootFromParent_Done,
     /*  36414 */   // Label 487: @36414
     /*  36414 */   GIM_Try, /*On fail goto*//*Label 488*/ GIMT_Encode4(36552), // Rule ID 5160 //
     /*  36419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  36422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  36426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  36434 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36438 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36442 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36446 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  36450 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36454 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36458 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  36462 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  36466 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36470 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36474 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  36478 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  36484 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  36486 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  36490 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36494 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36498 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  36502 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36506 */     // MIs[6] vB
     /*  36506 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  36511 */     // MIs[6] vA
     /*  36511 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  36516 */     // MIs[5] vC
     /*  36516 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  36521 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  36523 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  36523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  36526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  36528 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  36532 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  36536 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  36540 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  36550 */     GIR_RootConstrainSelectedInstOperands,
     /*  36551 */     // GIR_Coverage, 5160,
     /*  36551 */     GIR_EraseRootFromParent_Done,
     /*  36552 */   // Label 488: @36552
     /*  36552 */   GIM_Try, /*On fail goto*//*Label 489*/ GIMT_Encode4(36690), // Rule ID 5161 //
     /*  36557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  36560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  36564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  36572 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36576 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36580 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36584 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  36588 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36592 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36596 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  36600 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  36604 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36608 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36612 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  36616 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  36622 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  36624 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  36628 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36632 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36636 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  36640 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36644 */     // MIs[6] vA
     /*  36644 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  36649 */     // MIs[6] vC
     /*  36649 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  36654 */     // MIs[5] vB
     /*  36654 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  36659 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  36661 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  36661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  36664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  36666 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  36670 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  36674 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  36678 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  36688 */     GIR_RootConstrainSelectedInstOperands,
     /*  36689 */     // GIR_Coverage, 5161,
     /*  36689 */     GIR_EraseRootFromParent_Done,
     /*  36690 */   // Label 489: @36690
     /*  36690 */   GIM_Try, /*On fail goto*//*Label 490*/ GIMT_Encode4(36828), // Rule ID 5162 //
     /*  36695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  36698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  36702 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36706 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  36710 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36714 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36718 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36722 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  36726 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36730 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36734 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  36738 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  36742 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36746 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36750 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  36754 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  36760 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  36762 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  36766 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36770 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36774 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  36778 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36782 */     // MIs[6] vC
     /*  36782 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  36787 */     // MIs[6] vA
     /*  36787 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  36792 */     // MIs[5] vB
     /*  36792 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  36797 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  36799 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  36799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  36802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  36804 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  36808 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  36812 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  36816 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  36826 */     GIR_RootConstrainSelectedInstOperands,
     /*  36827 */     // GIR_Coverage, 5162,
     /*  36827 */     GIR_EraseRootFromParent_Done,
     /*  36828 */   // Label 490: @36828
     /*  36828 */   GIM_Try, /*On fail goto*//*Label 491*/ GIMT_Encode4(36966), // Rule ID 5163 //
     /*  36833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  36836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  36840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  36848 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36852 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36856 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36860 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  36864 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36868 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36872 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  36876 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  36880 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36884 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36888 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  36892 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  36898 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  36900 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  36904 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36908 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36912 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  36916 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36920 */     // MIs[6] vB
     /*  36920 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  36925 */     // MIs[6] vC
     /*  36925 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  36930 */     // MIs[5] vA
     /*  36930 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  36935 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  36937 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  36937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  36940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  36942 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  36946 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  36950 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  36954 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  36964 */     GIR_RootConstrainSelectedInstOperands,
     /*  36965 */     // GIR_Coverage, 5163,
     /*  36965 */     GIR_EraseRootFromParent_Done,
     /*  36966 */   // Label 491: @36966
     /*  36966 */   GIM_Try, /*On fail goto*//*Label 492*/ GIMT_Encode4(37104), // Rule ID 5164 //
     /*  36971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  36974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  36978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  36986 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36990 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36994 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36998 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  37002 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37006 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37010 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  37014 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  37018 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37022 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37026 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  37030 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  37036 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  37038 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  37042 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  37046 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37050 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  37054 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  37058 */     // MIs[6] vC
     /*  37058 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  37063 */     // MIs[6] vB
     /*  37063 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  37068 */     // MIs[5] vA
     /*  37068 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  37073 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  37075 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  37075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  37078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  37080 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  37084 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  37088 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  37092 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  37102 */     GIR_RootConstrainSelectedInstOperands,
     /*  37103 */     // GIR_Coverage, 5164,
     /*  37103 */     GIR_EraseRootFromParent_Done,
     /*  37104 */   // Label 492: @37104
     /*  37104 */   GIM_Try, /*On fail goto*//*Label 493*/ GIMT_Encode4(37242), // Rule ID 5171 //
     /*  37109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  37112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  37116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  37120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  37124 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37128 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37132 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37136 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  37140 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37144 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37148 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  37152 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  37156 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37160 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37164 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  37168 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  37174 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  37176 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  37180 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  37184 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37188 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  37192 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  37196 */     // MIs[6] vA
     /*  37196 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  37201 */     // MIs[6] vB
     /*  37201 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  37206 */     // MIs[5] vC
     /*  37206 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  37211 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  37213 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  37213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  37216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  37218 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  37222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  37226 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  37230 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  37240 */     GIR_RootConstrainSelectedInstOperands,
     /*  37241 */     // GIR_Coverage, 5171,
     /*  37241 */     GIR_EraseRootFromParent_Done,
     /*  37242 */   // Label 493: @37242
     /*  37242 */   GIM_Try, /*On fail goto*//*Label 494*/ GIMT_Encode4(37380), // Rule ID 5172 //
     /*  37247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  37250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  37254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  37258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  37262 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37266 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37270 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37274 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  37278 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37282 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37286 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  37290 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  37294 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37298 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37302 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  37306 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  37312 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  37314 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  37318 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  37322 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37326 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  37330 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  37334 */     // MIs[6] vB
     /*  37334 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  37339 */     // MIs[6] vA
     /*  37339 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  37344 */     // MIs[5] vC
     /*  37344 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  37349 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  37351 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  37351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  37354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  37356 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  37360 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  37364 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  37368 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  37378 */     GIR_RootConstrainSelectedInstOperands,
     /*  37379 */     // GIR_Coverage, 5172,
     /*  37379 */     GIR_EraseRootFromParent_Done,
     /*  37380 */   // Label 494: @37380
     /*  37380 */   GIM_Try, /*On fail goto*//*Label 495*/ GIMT_Encode4(37518), // Rule ID 5173 //
     /*  37385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  37388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  37392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  37396 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  37400 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37404 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37408 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37412 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  37416 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37420 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37424 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  37428 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  37432 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37436 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37440 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  37444 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  37450 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  37452 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  37456 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  37460 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37464 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  37468 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  37472 */     // MIs[6] vA
     /*  37472 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  37477 */     // MIs[6] vC
     /*  37477 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  37482 */     // MIs[5] vB
     /*  37482 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  37487 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  37489 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  37489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  37492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  37494 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  37498 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  37502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  37506 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  37516 */     GIR_RootConstrainSelectedInstOperands,
     /*  37517 */     // GIR_Coverage, 5173,
     /*  37517 */     GIR_EraseRootFromParent_Done,
     /*  37518 */   // Label 495: @37518
     /*  37518 */   GIM_Try, /*On fail goto*//*Label 496*/ GIMT_Encode4(37656), // Rule ID 5174 //
     /*  37523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  37526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  37530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  37534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  37538 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37542 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37546 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37550 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  37554 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37558 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37562 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  37566 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  37570 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37574 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37578 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  37582 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  37588 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  37590 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  37594 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  37598 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37602 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  37606 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  37610 */     // MIs[6] vC
     /*  37610 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  37615 */     // MIs[6] vA
     /*  37615 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  37620 */     // MIs[5] vB
     /*  37620 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  37625 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  37627 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  37627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  37630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  37632 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  37636 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  37640 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  37644 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  37654 */     GIR_RootConstrainSelectedInstOperands,
     /*  37655 */     // GIR_Coverage, 5174,
     /*  37655 */     GIR_EraseRootFromParent_Done,
     /*  37656 */   // Label 496: @37656
     /*  37656 */   GIM_Try, /*On fail goto*//*Label 497*/ GIMT_Encode4(37794), // Rule ID 5175 //
     /*  37661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  37664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  37668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  37672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  37676 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37680 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37684 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37688 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  37692 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37696 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37700 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  37704 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  37708 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37712 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37716 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  37720 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  37726 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  37728 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  37732 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  37736 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37740 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  37744 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  37748 */     // MIs[6] vB
     /*  37748 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  37753 */     // MIs[6] vC
     /*  37753 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  37758 */     // MIs[5] vA
     /*  37758 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  37763 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  37765 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  37765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  37768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  37770 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  37774 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  37778 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  37782 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  37792 */     GIR_RootConstrainSelectedInstOperands,
     /*  37793 */     // GIR_Coverage, 5175,
     /*  37793 */     GIR_EraseRootFromParent_Done,
     /*  37794 */   // Label 497: @37794
     /*  37794 */   GIM_Try, /*On fail goto*//*Label 498*/ GIMT_Encode4(37932), // Rule ID 5176 //
     /*  37799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  37802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  37806 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  37810 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  37814 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37818 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37822 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37826 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  37830 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37834 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37838 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  37842 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  37846 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37850 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37854 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  37858 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  37864 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  37866 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  37870 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  37874 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37878 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  37882 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  37886 */     // MIs[6] vC
     /*  37886 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  37891 */     // MIs[6] vB
     /*  37891 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  37896 */     // MIs[5] vA
     /*  37896 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  37901 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  37903 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  37903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  37906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  37908 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  37912 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  37916 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  37920 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  37930 */     GIR_RootConstrainSelectedInstOperands,
     /*  37931 */     // GIR_Coverage, 5176,
     /*  37931 */     GIR_EraseRootFromParent_Done,
     /*  37932 */   // Label 498: @37932
     /*  37932 */   GIM_Try, /*On fail goto*//*Label 499*/ GIMT_Encode4(38070), // Rule ID 5183 //
     /*  37937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  37940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  37944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  37948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  37952 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37956 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37960 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37964 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  37968 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37972 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37976 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  37980 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  37984 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37988 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37992 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  37996 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  38002 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  38004 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  38008 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  38012 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38016 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  38020 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  38024 */     // MIs[6] vA
     /*  38024 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  38029 */     // MIs[6] vB
     /*  38029 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  38034 */     // MIs[5] vC
     /*  38034 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  38039 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  38041 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  38041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  38044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  38046 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  38050 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  38054 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  38058 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  38068 */     GIR_RootConstrainSelectedInstOperands,
     /*  38069 */     // GIR_Coverage, 5183,
     /*  38069 */     GIR_EraseRootFromParent_Done,
     /*  38070 */   // Label 499: @38070
     /*  38070 */   GIM_Try, /*On fail goto*//*Label 500*/ GIMT_Encode4(38208), // Rule ID 5184 //
     /*  38075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  38078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  38082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  38090 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38094 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38098 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38102 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  38106 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38110 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38114 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  38118 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  38122 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38126 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38130 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  38134 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  38140 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  38142 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  38146 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  38150 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38154 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  38158 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  38162 */     // MIs[6] vB
     /*  38162 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  38167 */     // MIs[6] vA
     /*  38167 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  38172 */     // MIs[5] vC
     /*  38172 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  38177 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  38179 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  38179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  38182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  38184 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  38188 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  38192 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  38196 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  38206 */     GIR_RootConstrainSelectedInstOperands,
     /*  38207 */     // GIR_Coverage, 5184,
     /*  38207 */     GIR_EraseRootFromParent_Done,
     /*  38208 */   // Label 500: @38208
     /*  38208 */   GIM_Try, /*On fail goto*//*Label 501*/ GIMT_Encode4(38346), // Rule ID 5185 //
     /*  38213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  38216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  38220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  38228 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38232 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38236 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38240 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  38244 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38248 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38252 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  38256 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  38260 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38264 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38268 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  38272 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  38278 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  38280 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  38284 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  38288 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38292 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  38296 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  38300 */     // MIs[6] vA
     /*  38300 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  38305 */     // MIs[6] vC
     /*  38305 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  38310 */     // MIs[5] vB
     /*  38310 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  38315 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  38317 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  38317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  38320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  38322 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  38326 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  38330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  38334 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  38344 */     GIR_RootConstrainSelectedInstOperands,
     /*  38345 */     // GIR_Coverage, 5185,
     /*  38345 */     GIR_EraseRootFromParent_Done,
     /*  38346 */   // Label 501: @38346
     /*  38346 */   GIM_Try, /*On fail goto*//*Label 502*/ GIMT_Encode4(38484), // Rule ID 5186 //
     /*  38351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  38354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  38358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  38366 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38370 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38374 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38378 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  38382 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38386 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38390 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  38394 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  38398 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38402 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38406 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  38410 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  38416 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  38418 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  38422 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  38426 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38430 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  38434 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  38438 */     // MIs[6] vC
     /*  38438 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  38443 */     // MIs[6] vA
     /*  38443 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  38448 */     // MIs[5] vB
     /*  38448 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  38453 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  38455 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  38455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  38458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  38460 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  38464 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  38468 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  38472 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  38482 */     GIR_RootConstrainSelectedInstOperands,
     /*  38483 */     // GIR_Coverage, 5186,
     /*  38483 */     GIR_EraseRootFromParent_Done,
     /*  38484 */   // Label 502: @38484
     /*  38484 */   GIM_Try, /*On fail goto*//*Label 503*/ GIMT_Encode4(38622), // Rule ID 5187 //
     /*  38489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  38492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  38496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  38504 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38508 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38512 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38516 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  38520 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38524 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38528 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  38532 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  38536 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38540 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38544 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  38548 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  38554 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  38556 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  38560 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  38564 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38568 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  38572 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  38576 */     // MIs[6] vB
     /*  38576 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  38581 */     // MIs[6] vC
     /*  38581 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  38586 */     // MIs[5] vA
     /*  38586 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  38591 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  38593 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  38593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  38596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  38598 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  38602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  38606 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  38610 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  38620 */     GIR_RootConstrainSelectedInstOperands,
     /*  38621 */     // GIR_Coverage, 5187,
     /*  38621 */     GIR_EraseRootFromParent_Done,
     /*  38622 */   // Label 503: @38622
     /*  38622 */   GIM_Try, /*On fail goto*//*Label 504*/ GIMT_Encode4(38760), // Rule ID 5188 //
     /*  38627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  38630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  38634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  38642 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38646 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38650 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38654 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  38658 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38662 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38666 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  38670 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  38674 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38678 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38682 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  38686 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  38692 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  38694 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  38698 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  38702 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38706 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  38710 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  38714 */     // MIs[6] vC
     /*  38714 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  38719 */     // MIs[6] vB
     /*  38719 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  38724 */     // MIs[5] vA
     /*  38724 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  38729 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  38731 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  38731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  38734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  38736 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  38740 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  38744 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  38748 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  38758 */     GIR_RootConstrainSelectedInstOperands,
     /*  38759 */     // GIR_Coverage, 5188,
     /*  38759 */     GIR_EraseRootFromParent_Done,
     /*  38760 */   // Label 504: @38760
     /*  38760 */   GIM_Try, /*On fail goto*//*Label 505*/ GIMT_Encode4(38898), // Rule ID 5195 //
     /*  38765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  38768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  38772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  38780 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38784 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38788 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38792 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  38796 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38800 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38804 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  38808 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  38812 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38816 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38820 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  38824 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  38830 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  38832 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  38836 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  38840 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38844 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  38848 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  38852 */     // MIs[6] vA
     /*  38852 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  38857 */     // MIs[6] vB
     /*  38857 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  38862 */     // MIs[5] vC
     /*  38862 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  38867 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  38869 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  38869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  38872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  38874 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  38878 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  38882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  38886 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  38896 */     GIR_RootConstrainSelectedInstOperands,
     /*  38897 */     // GIR_Coverage, 5195,
     /*  38897 */     GIR_EraseRootFromParent_Done,
     /*  38898 */   // Label 505: @38898
     /*  38898 */   GIM_Try, /*On fail goto*//*Label 506*/ GIMT_Encode4(39036), // Rule ID 5196 //
     /*  38903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  38906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  38910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  38918 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38922 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38926 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38930 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  38934 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38938 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38942 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  38946 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  38950 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38954 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38958 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  38962 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  38968 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  38970 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  38974 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  38978 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38982 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  38986 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  38990 */     // MIs[6] vB
     /*  38990 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  38995 */     // MIs[6] vA
     /*  38995 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  39000 */     // MIs[5] vC
     /*  39000 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  39005 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  39007 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  39007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  39010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  39012 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  39016 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  39020 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  39024 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  39034 */     GIR_RootConstrainSelectedInstOperands,
     /*  39035 */     // GIR_Coverage, 5196,
     /*  39035 */     GIR_EraseRootFromParent_Done,
     /*  39036 */   // Label 506: @39036
     /*  39036 */   GIM_Try, /*On fail goto*//*Label 507*/ GIMT_Encode4(39174), // Rule ID 5197 //
     /*  39041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  39044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  39048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  39056 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39060 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39064 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39068 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  39072 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39076 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39080 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  39084 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  39088 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39092 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39096 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  39100 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  39106 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  39108 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  39112 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  39116 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39120 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  39124 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  39128 */     // MIs[6] vA
     /*  39128 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  39133 */     // MIs[6] vC
     /*  39133 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  39138 */     // MIs[5] vB
     /*  39138 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  39143 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  39145 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  39145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  39148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  39150 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  39154 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  39158 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  39162 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  39172 */     GIR_RootConstrainSelectedInstOperands,
     /*  39173 */     // GIR_Coverage, 5197,
     /*  39173 */     GIR_EraseRootFromParent_Done,
     /*  39174 */   // Label 507: @39174
     /*  39174 */   GIM_Try, /*On fail goto*//*Label 508*/ GIMT_Encode4(39312), // Rule ID 5198 //
     /*  39179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  39182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  39186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  39194 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39198 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39202 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39206 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  39210 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39214 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39218 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  39222 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  39226 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39230 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39234 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  39238 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  39244 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  39246 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  39250 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  39254 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39258 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  39262 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  39266 */     // MIs[6] vC
     /*  39266 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  39271 */     // MIs[6] vA
     /*  39271 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  39276 */     // MIs[5] vB
     /*  39276 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  39281 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  39283 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  39283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  39286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  39288 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  39292 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  39296 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  39300 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  39310 */     GIR_RootConstrainSelectedInstOperands,
     /*  39311 */     // GIR_Coverage, 5198,
     /*  39311 */     GIR_EraseRootFromParent_Done,
     /*  39312 */   // Label 508: @39312
     /*  39312 */   GIM_Try, /*On fail goto*//*Label 509*/ GIMT_Encode4(39450), // Rule ID 5199 //
     /*  39317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  39320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  39324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  39332 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39336 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39340 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39344 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  39348 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39352 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39356 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  39360 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  39364 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39368 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39372 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  39376 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  39382 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  39384 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  39388 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  39392 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39396 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  39400 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  39404 */     // MIs[6] vB
     /*  39404 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  39409 */     // MIs[6] vC
     /*  39409 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  39414 */     // MIs[5] vA
     /*  39414 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  39419 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  39421 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  39421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  39424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  39426 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  39430 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  39434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  39438 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  39448 */     GIR_RootConstrainSelectedInstOperands,
     /*  39449 */     // GIR_Coverage, 5199,
     /*  39449 */     GIR_EraseRootFromParent_Done,
     /*  39450 */   // Label 509: @39450
     /*  39450 */   GIM_Try, /*On fail goto*//*Label 510*/ GIMT_Encode4(39588), // Rule ID 5200 //
     /*  39455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  39458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  39462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  39470 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39474 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39478 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39482 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  39486 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39490 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39494 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  39498 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  39502 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39506 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39510 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  39514 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  39520 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  39522 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  39526 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  39530 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39534 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  39538 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  39542 */     // MIs[6] vC
     /*  39542 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  39547 */     // MIs[6] vB
     /*  39547 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  39552 */     // MIs[5] vA
     /*  39552 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  39557 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  39559 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  39559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  39562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  39564 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  39568 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  39572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  39576 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  39586 */     GIR_RootConstrainSelectedInstOperands,
     /*  39587 */     // GIR_Coverage, 5200,
     /*  39587 */     GIR_EraseRootFromParent_Done,
     /*  39588 */   // Label 510: @39588
     /*  39588 */   GIM_Try, /*On fail goto*//*Label 511*/ GIMT_Encode4(39726), // Rule ID 5207 //
     /*  39593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  39596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  39600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  39608 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39612 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39616 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39620 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  39624 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39628 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39632 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  39636 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  39640 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39644 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39648 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  39652 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  39658 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  39660 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  39664 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  39668 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39672 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  39676 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  39680 */     // MIs[6] vA
     /*  39680 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  39685 */     // MIs[6] vB
     /*  39685 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  39690 */     // MIs[5] vC
     /*  39690 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  39695 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  39697 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  39697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  39700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  39702 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  39706 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  39710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  39714 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  39724 */     GIR_RootConstrainSelectedInstOperands,
     /*  39725 */     // GIR_Coverage, 5207,
     /*  39725 */     GIR_EraseRootFromParent_Done,
     /*  39726 */   // Label 511: @39726
     /*  39726 */   GIM_Try, /*On fail goto*//*Label 512*/ GIMT_Encode4(39864), // Rule ID 5208 //
     /*  39731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  39734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  39738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39742 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  39746 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39750 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39754 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39758 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  39762 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39766 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39770 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  39774 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  39778 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39782 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39786 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  39790 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  39796 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  39798 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  39802 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  39806 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39810 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  39814 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  39818 */     // MIs[6] vB
     /*  39818 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  39823 */     // MIs[6] vA
     /*  39823 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  39828 */     // MIs[5] vC
     /*  39828 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  39833 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  39835 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  39835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  39838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  39840 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  39844 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  39848 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  39852 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  39862 */     GIR_RootConstrainSelectedInstOperands,
     /*  39863 */     // GIR_Coverage, 5208,
     /*  39863 */     GIR_EraseRootFromParent_Done,
     /*  39864 */   // Label 512: @39864
     /*  39864 */   GIM_Try, /*On fail goto*//*Label 513*/ GIMT_Encode4(40002), // Rule ID 5209 //
     /*  39869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  39872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  39876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  39884 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39888 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39892 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39896 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  39900 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39904 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39908 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  39912 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  39916 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39920 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39924 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  39928 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  39934 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  39936 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  39940 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  39944 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39948 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  39952 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  39956 */     // MIs[6] vA
     /*  39956 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  39961 */     // MIs[6] vC
     /*  39961 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  39966 */     // MIs[5] vB
     /*  39966 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  39971 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  39973 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  39973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  39976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  39978 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  39982 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  39986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  39990 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  40000 */     GIR_RootConstrainSelectedInstOperands,
     /*  40001 */     // GIR_Coverage, 5209,
     /*  40001 */     GIR_EraseRootFromParent_Done,
     /*  40002 */   // Label 513: @40002
     /*  40002 */   GIM_Try, /*On fail goto*//*Label 514*/ GIMT_Encode4(40140), // Rule ID 5210 //
     /*  40007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  40010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  40014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  40022 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40026 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40030 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40034 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  40038 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40042 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40046 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  40050 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  40054 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40058 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40062 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  40066 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40072 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  40074 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  40078 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  40082 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40086 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  40090 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  40094 */     // MIs[6] vC
     /*  40094 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  40099 */     // MIs[6] vA
     /*  40099 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  40104 */     // MIs[5] vB
     /*  40104 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  40109 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  40111 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  40111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  40114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  40116 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  40120 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  40124 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  40128 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  40138 */     GIR_RootConstrainSelectedInstOperands,
     /*  40139 */     // GIR_Coverage, 5210,
     /*  40139 */     GIR_EraseRootFromParent_Done,
     /*  40140 */   // Label 514: @40140
     /*  40140 */   GIM_Try, /*On fail goto*//*Label 515*/ GIMT_Encode4(40278), // Rule ID 5211 //
     /*  40145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  40148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  40152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  40160 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40164 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40168 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40172 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  40176 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40180 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40184 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  40188 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  40192 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40196 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40200 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  40204 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40210 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  40212 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  40216 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  40220 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40224 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  40228 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  40232 */     // MIs[6] vB
     /*  40232 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  40237 */     // MIs[6] vC
     /*  40237 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  40242 */     // MIs[5] vA
     /*  40242 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  40247 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  40249 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  40249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  40252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  40254 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  40258 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  40262 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  40266 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  40276 */     GIR_RootConstrainSelectedInstOperands,
     /*  40277 */     // GIR_Coverage, 5211,
     /*  40277 */     GIR_EraseRootFromParent_Done,
     /*  40278 */   // Label 515: @40278
     /*  40278 */   GIM_Try, /*On fail goto*//*Label 516*/ GIMT_Encode4(40416), // Rule ID 5212 //
     /*  40283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  40286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  40290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  40298 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40302 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40306 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40310 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  40314 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40318 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40322 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  40326 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  40330 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40334 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40338 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  40342 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40348 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  40350 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  40354 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  40358 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40362 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  40366 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  40370 */     // MIs[6] vC
     /*  40370 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  40375 */     // MIs[6] vB
     /*  40375 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  40380 */     // MIs[5] vA
     /*  40380 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  40385 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  40387 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  40387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  40390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  40392 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  40396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  40400 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  40404 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  40414 */     GIR_RootConstrainSelectedInstOperands,
     /*  40415 */     // GIR_Coverage, 5212,
     /*  40415 */     GIR_EraseRootFromParent_Done,
     /*  40416 */   // Label 516: @40416
     /*  40416 */   GIM_Try, /*On fail goto*//*Label 517*/ GIMT_Encode4(40554), // Rule ID 5153 //
     /*  40421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  40424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  40428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  40436 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40440 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40444 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40448 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  40452 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40456 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40460 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  40464 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  40468 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40472 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40476 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  40480 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40486 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  40488 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  40492 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  40496 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40500 */     // MIs[5] vC
     /*  40500 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  40505 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  40509 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  40513 */     // MIs[6] vA
     /*  40513 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  40518 */     // MIs[6] vB
     /*  40518 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  40523 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  40525 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  40525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  40528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  40530 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  40534 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  40538 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  40542 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  40552 */     GIR_RootConstrainSelectedInstOperands,
     /*  40553 */     // GIR_Coverage, 5153,
     /*  40553 */     GIR_EraseRootFromParent_Done,
     /*  40554 */   // Label 517: @40554
     /*  40554 */   GIM_Try, /*On fail goto*//*Label 518*/ GIMT_Encode4(40692), // Rule ID 5154 //
     /*  40559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  40562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  40566 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40570 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  40574 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40578 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40582 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40586 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  40590 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40594 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40598 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  40602 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  40606 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40610 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40614 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  40618 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40624 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  40626 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  40630 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  40634 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40638 */     // MIs[5] vC
     /*  40638 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  40643 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  40647 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  40651 */     // MIs[6] vB
     /*  40651 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  40656 */     // MIs[6] vA
     /*  40656 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  40661 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  40663 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  40663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  40666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  40668 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  40672 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  40676 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  40680 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  40690 */     GIR_RootConstrainSelectedInstOperands,
     /*  40691 */     // GIR_Coverage, 5154,
     /*  40691 */     GIR_EraseRootFromParent_Done,
     /*  40692 */   // Label 518: @40692
     /*  40692 */   GIM_Try, /*On fail goto*//*Label 519*/ GIMT_Encode4(40830), // Rule ID 5155 //
     /*  40697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  40700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  40704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  40712 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40716 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40720 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40724 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  40728 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40732 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40736 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  40740 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  40744 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40748 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40752 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  40756 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40762 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  40764 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  40768 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  40772 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40776 */     // MIs[5] vB
     /*  40776 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  40781 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  40785 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  40789 */     // MIs[6] vA
     /*  40789 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  40794 */     // MIs[6] vC
     /*  40794 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  40799 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  40801 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  40801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  40804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  40806 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  40810 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  40814 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  40818 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  40828 */     GIR_RootConstrainSelectedInstOperands,
     /*  40829 */     // GIR_Coverage, 5155,
     /*  40829 */     GIR_EraseRootFromParent_Done,
     /*  40830 */   // Label 519: @40830
     /*  40830 */   GIM_Try, /*On fail goto*//*Label 520*/ GIMT_Encode4(40968), // Rule ID 5156 //
     /*  40835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  40838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  40842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  40850 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40854 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40858 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40862 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  40866 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40870 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40874 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  40878 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  40882 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40886 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40890 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  40894 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40900 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  40902 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  40906 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  40910 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40914 */     // MIs[5] vB
     /*  40914 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  40919 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  40923 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  40927 */     // MIs[6] vC
     /*  40927 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  40932 */     // MIs[6] vA
     /*  40932 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  40937 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  40939 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  40939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  40942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  40944 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  40948 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  40952 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  40956 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  40966 */     GIR_RootConstrainSelectedInstOperands,
     /*  40967 */     // GIR_Coverage, 5156,
     /*  40967 */     GIR_EraseRootFromParent_Done,
     /*  40968 */   // Label 520: @40968
     /*  40968 */   GIM_Try, /*On fail goto*//*Label 521*/ GIMT_Encode4(41106), // Rule ID 5157 //
     /*  40973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  40976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  40980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  40988 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40992 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40996 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41000 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  41004 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41008 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41012 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  41016 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  41020 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41024 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41028 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  41032 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  41038 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  41040 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  41044 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41048 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41052 */     // MIs[5] vA
     /*  41052 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  41057 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  41061 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41065 */     // MIs[6] vB
     /*  41065 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  41070 */     // MIs[6] vC
     /*  41070 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  41075 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  41077 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  41077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  41080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  41082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  41086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  41090 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  41094 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  41104 */     GIR_RootConstrainSelectedInstOperands,
     /*  41105 */     // GIR_Coverage, 5157,
     /*  41105 */     GIR_EraseRootFromParent_Done,
     /*  41106 */   // Label 521: @41106
     /*  41106 */   GIM_Try, /*On fail goto*//*Label 522*/ GIMT_Encode4(41244), // Rule ID 5158 //
     /*  41111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  41114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  41118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  41126 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41130 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41134 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41138 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  41142 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41146 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41150 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  41154 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  41158 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41162 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41166 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  41170 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  41176 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  41178 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  41182 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41186 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41190 */     // MIs[5] vA
     /*  41190 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  41195 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  41199 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41203 */     // MIs[6] vC
     /*  41203 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  41208 */     // MIs[6] vB
     /*  41208 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  41213 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  41215 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  41215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  41218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  41220 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  41224 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  41228 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  41232 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  41242 */     GIR_RootConstrainSelectedInstOperands,
     /*  41243 */     // GIR_Coverage, 5158,
     /*  41243 */     GIR_EraseRootFromParent_Done,
     /*  41244 */   // Label 522: @41244
     /*  41244 */   GIM_Try, /*On fail goto*//*Label 523*/ GIMT_Encode4(41382), // Rule ID 5165 //
     /*  41249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  41252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  41256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  41264 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41268 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41272 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41276 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  41280 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41284 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41288 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  41292 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  41296 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41300 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41304 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  41308 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  41314 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  41316 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  41320 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41324 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41328 */     // MIs[5] vC
     /*  41328 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  41333 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  41337 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41341 */     // MIs[6] vA
     /*  41341 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  41346 */     // MIs[6] vB
     /*  41346 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  41351 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  41353 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  41353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  41356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  41358 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  41362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  41366 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  41370 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  41380 */     GIR_RootConstrainSelectedInstOperands,
     /*  41381 */     // GIR_Coverage, 5165,
     /*  41381 */     GIR_EraseRootFromParent_Done,
     /*  41382 */   // Label 523: @41382
     /*  41382 */   GIM_Try, /*On fail goto*//*Label 524*/ GIMT_Encode4(41520), // Rule ID 5166 //
     /*  41387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  41390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  41394 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41398 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  41402 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41406 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41410 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41414 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  41418 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41422 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41426 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  41430 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  41434 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41438 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41442 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  41446 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  41452 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  41454 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  41458 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41462 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41466 */     // MIs[5] vC
     /*  41466 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  41471 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  41475 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41479 */     // MIs[6] vB
     /*  41479 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  41484 */     // MIs[6] vA
     /*  41484 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  41489 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  41491 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  41491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  41494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  41496 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  41500 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  41504 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  41508 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  41518 */     GIR_RootConstrainSelectedInstOperands,
     /*  41519 */     // GIR_Coverage, 5166,
     /*  41519 */     GIR_EraseRootFromParent_Done,
     /*  41520 */   // Label 524: @41520
     /*  41520 */   GIM_Try, /*On fail goto*//*Label 525*/ GIMT_Encode4(41658), // Rule ID 5167 //
     /*  41525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  41528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  41532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  41540 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41544 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41548 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41552 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  41556 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41560 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41564 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  41568 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  41572 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41576 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41580 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  41584 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  41590 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  41592 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  41596 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41600 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41604 */     // MIs[5] vB
     /*  41604 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  41609 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  41613 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41617 */     // MIs[6] vA
     /*  41617 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  41622 */     // MIs[6] vC
     /*  41622 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  41627 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  41629 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  41629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  41632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  41634 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  41638 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  41642 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  41646 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  41656 */     GIR_RootConstrainSelectedInstOperands,
     /*  41657 */     // GIR_Coverage, 5167,
     /*  41657 */     GIR_EraseRootFromParent_Done,
     /*  41658 */   // Label 525: @41658
     /*  41658 */   GIM_Try, /*On fail goto*//*Label 526*/ GIMT_Encode4(41796), // Rule ID 5168 //
     /*  41663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  41666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  41670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  41678 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41682 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41686 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41690 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  41694 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41698 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41702 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  41706 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  41710 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41714 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41718 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  41722 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  41728 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  41730 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  41734 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41738 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41742 */     // MIs[5] vB
     /*  41742 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  41747 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  41751 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41755 */     // MIs[6] vC
     /*  41755 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  41760 */     // MIs[6] vA
     /*  41760 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  41765 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  41767 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  41767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  41770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  41772 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  41776 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  41780 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  41784 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  41794 */     GIR_RootConstrainSelectedInstOperands,
     /*  41795 */     // GIR_Coverage, 5168,
     /*  41795 */     GIR_EraseRootFromParent_Done,
     /*  41796 */   // Label 526: @41796
     /*  41796 */   GIM_Try, /*On fail goto*//*Label 527*/ GIMT_Encode4(41934), // Rule ID 5169 //
     /*  41801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  41804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  41808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  41816 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41820 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41824 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41828 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  41832 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41836 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41840 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  41844 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  41848 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41852 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41856 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  41860 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  41866 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  41868 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  41872 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41876 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41880 */     // MIs[5] vA
     /*  41880 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  41885 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  41889 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41893 */     // MIs[6] vB
     /*  41893 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  41898 */     // MIs[6] vC
     /*  41898 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  41903 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  41905 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  41905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  41908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  41910 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  41914 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  41918 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  41922 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  41932 */     GIR_RootConstrainSelectedInstOperands,
     /*  41933 */     // GIR_Coverage, 5169,
     /*  41933 */     GIR_EraseRootFromParent_Done,
     /*  41934 */   // Label 527: @41934
     /*  41934 */   GIM_Try, /*On fail goto*//*Label 528*/ GIMT_Encode4(42072), // Rule ID 5170 //
     /*  41939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  41942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  41946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  41954 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41958 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41962 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41966 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  41970 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41974 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41978 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  41982 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  41986 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41990 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41994 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  41998 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42004 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  42006 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  42010 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42014 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42018 */     // MIs[5] vA
     /*  42018 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  42023 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  42027 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42031 */     // MIs[6] vC
     /*  42031 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  42036 */     // MIs[6] vB
     /*  42036 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  42041 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  42043 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  42043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  42046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  42048 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  42052 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  42056 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  42060 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  42070 */     GIR_RootConstrainSelectedInstOperands,
     /*  42071 */     // GIR_Coverage, 5170,
     /*  42071 */     GIR_EraseRootFromParent_Done,
     /*  42072 */   // Label 528: @42072
     /*  42072 */   GIM_Try, /*On fail goto*//*Label 529*/ GIMT_Encode4(42210), // Rule ID 5177 //
     /*  42077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  42080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  42084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  42092 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42096 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42100 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42104 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  42108 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42112 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42116 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  42120 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  42124 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42128 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42132 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  42136 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42142 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  42144 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  42148 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42152 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42156 */     // MIs[5] vC
     /*  42156 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  42161 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  42165 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42169 */     // MIs[6] vA
     /*  42169 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  42174 */     // MIs[6] vB
     /*  42174 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  42179 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  42181 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  42181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  42184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  42186 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  42190 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  42194 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  42198 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  42208 */     GIR_RootConstrainSelectedInstOperands,
     /*  42209 */     // GIR_Coverage, 5177,
     /*  42209 */     GIR_EraseRootFromParent_Done,
     /*  42210 */   // Label 529: @42210
     /*  42210 */   GIM_Try, /*On fail goto*//*Label 530*/ GIMT_Encode4(42348), // Rule ID 5178 //
     /*  42215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  42218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  42222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  42230 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42234 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42238 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42242 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  42246 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42250 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42254 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  42258 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  42262 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42266 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42270 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  42274 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42280 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  42282 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  42286 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42290 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42294 */     // MIs[5] vC
     /*  42294 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  42299 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  42303 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42307 */     // MIs[6] vB
     /*  42307 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  42312 */     // MIs[6] vA
     /*  42312 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  42317 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  42319 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  42319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  42322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  42324 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  42328 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  42332 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  42336 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  42346 */     GIR_RootConstrainSelectedInstOperands,
     /*  42347 */     // GIR_Coverage, 5178,
     /*  42347 */     GIR_EraseRootFromParent_Done,
     /*  42348 */   // Label 530: @42348
     /*  42348 */   GIM_Try, /*On fail goto*//*Label 531*/ GIMT_Encode4(42486), // Rule ID 5179 //
     /*  42353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  42356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  42360 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42364 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  42368 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42372 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42376 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42380 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  42384 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42388 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42392 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  42396 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  42400 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42404 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42408 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  42412 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42418 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  42420 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  42424 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42428 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42432 */     // MIs[5] vB
     /*  42432 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  42437 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  42441 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42445 */     // MIs[6] vA
     /*  42445 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  42450 */     // MIs[6] vC
     /*  42450 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  42455 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  42457 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  42457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  42460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  42462 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  42466 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  42470 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  42474 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  42484 */     GIR_RootConstrainSelectedInstOperands,
     /*  42485 */     // GIR_Coverage, 5179,
     /*  42485 */     GIR_EraseRootFromParent_Done,
     /*  42486 */   // Label 531: @42486
     /*  42486 */   GIM_Try, /*On fail goto*//*Label 532*/ GIMT_Encode4(42624), // Rule ID 5180 //
     /*  42491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  42494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  42498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  42506 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42510 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42514 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42518 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  42522 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42526 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42530 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  42534 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  42538 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42542 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42546 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  42550 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42556 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  42558 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  42562 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42566 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42570 */     // MIs[5] vB
     /*  42570 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  42575 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  42579 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42583 */     // MIs[6] vC
     /*  42583 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  42588 */     // MIs[6] vA
     /*  42588 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  42593 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  42595 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  42595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  42598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  42600 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  42604 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  42608 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  42612 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  42622 */     GIR_RootConstrainSelectedInstOperands,
     /*  42623 */     // GIR_Coverage, 5180,
     /*  42623 */     GIR_EraseRootFromParent_Done,
     /*  42624 */   // Label 532: @42624
     /*  42624 */   GIM_Try, /*On fail goto*//*Label 533*/ GIMT_Encode4(42762), // Rule ID 5181 //
     /*  42629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  42632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  42636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  42644 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42648 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42652 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42656 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  42660 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42664 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42668 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  42672 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  42676 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42680 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42684 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  42688 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42694 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  42696 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  42700 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42704 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42708 */     // MIs[5] vA
     /*  42708 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  42713 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  42717 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42721 */     // MIs[6] vB
     /*  42721 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  42726 */     // MIs[6] vC
     /*  42726 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  42731 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  42733 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  42733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  42736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  42738 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  42742 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  42746 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  42750 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  42760 */     GIR_RootConstrainSelectedInstOperands,
     /*  42761 */     // GIR_Coverage, 5181,
     /*  42761 */     GIR_EraseRootFromParent_Done,
     /*  42762 */   // Label 533: @42762
     /*  42762 */   GIM_Try, /*On fail goto*//*Label 534*/ GIMT_Encode4(42900), // Rule ID 5182 //
     /*  42767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  42770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  42774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  42782 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42786 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42790 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42794 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  42798 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42802 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42806 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  42810 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  42814 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42818 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42822 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  42826 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42832 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  42834 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  42838 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42842 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42846 */     // MIs[5] vA
     /*  42846 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  42851 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  42855 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42859 */     // MIs[6] vC
     /*  42859 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  42864 */     // MIs[6] vB
     /*  42864 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  42869 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  42871 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  42871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  42874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  42876 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  42880 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  42884 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  42888 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  42898 */     GIR_RootConstrainSelectedInstOperands,
     /*  42899 */     // GIR_Coverage, 5182,
     /*  42899 */     GIR_EraseRootFromParent_Done,
     /*  42900 */   // Label 534: @42900
     /*  42900 */   GIM_Try, /*On fail goto*//*Label 535*/ GIMT_Encode4(43038), // Rule ID 5189 //
     /*  42905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  42908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  42912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  42920 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42924 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42928 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42932 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  42936 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42940 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42944 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  42948 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  42952 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42956 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42960 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  42964 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42970 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  42972 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  42976 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42980 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42984 */     // MIs[5] vC
     /*  42984 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  42989 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  42993 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42997 */     // MIs[6] vA
     /*  42997 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  43002 */     // MIs[6] vB
     /*  43002 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  43007 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  43009 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  43009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  43012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  43014 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  43018 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  43022 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  43026 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  43036 */     GIR_RootConstrainSelectedInstOperands,
     /*  43037 */     // GIR_Coverage, 5189,
     /*  43037 */     GIR_EraseRootFromParent_Done,
     /*  43038 */   // Label 535: @43038
     /*  43038 */   GIM_Try, /*On fail goto*//*Label 536*/ GIMT_Encode4(43176), // Rule ID 5190 //
     /*  43043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  43046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  43050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  43058 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43062 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43066 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43070 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  43074 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43078 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43082 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  43086 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  43090 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43094 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43098 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  43102 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  43108 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  43110 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  43114 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43118 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43122 */     // MIs[5] vC
     /*  43122 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  43127 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  43131 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43135 */     // MIs[6] vB
     /*  43135 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  43140 */     // MIs[6] vA
     /*  43140 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  43145 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  43147 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  43147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  43150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  43152 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  43156 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  43160 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  43164 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  43174 */     GIR_RootConstrainSelectedInstOperands,
     /*  43175 */     // GIR_Coverage, 5190,
     /*  43175 */     GIR_EraseRootFromParent_Done,
     /*  43176 */   // Label 536: @43176
     /*  43176 */   GIM_Try, /*On fail goto*//*Label 537*/ GIMT_Encode4(43314), // Rule ID 5191 //
     /*  43181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  43184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  43188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  43196 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43200 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43204 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43208 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  43212 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43216 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43220 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  43224 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  43228 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43232 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43236 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  43240 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  43246 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  43248 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  43252 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43256 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43260 */     // MIs[5] vB
     /*  43260 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  43265 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  43269 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43273 */     // MIs[6] vA
     /*  43273 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  43278 */     // MIs[6] vC
     /*  43278 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  43283 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  43285 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  43285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  43288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  43290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  43294 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  43298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  43302 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  43312 */     GIR_RootConstrainSelectedInstOperands,
     /*  43313 */     // GIR_Coverage, 5191,
     /*  43313 */     GIR_EraseRootFromParent_Done,
     /*  43314 */   // Label 537: @43314
     /*  43314 */   GIM_Try, /*On fail goto*//*Label 538*/ GIMT_Encode4(43452), // Rule ID 5192 //
     /*  43319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  43322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  43326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  43334 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43338 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43342 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43346 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  43350 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43354 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43358 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  43362 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  43366 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43370 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43374 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  43378 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  43384 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  43386 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  43390 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43394 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43398 */     // MIs[5] vB
     /*  43398 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  43403 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  43407 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43411 */     // MIs[6] vC
     /*  43411 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  43416 */     // MIs[6] vA
     /*  43416 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  43421 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  43423 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  43423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  43426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  43428 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  43432 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  43436 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  43440 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  43450 */     GIR_RootConstrainSelectedInstOperands,
     /*  43451 */     // GIR_Coverage, 5192,
     /*  43451 */     GIR_EraseRootFromParent_Done,
     /*  43452 */   // Label 538: @43452
     /*  43452 */   GIM_Try, /*On fail goto*//*Label 539*/ GIMT_Encode4(43590), // Rule ID 5193 //
     /*  43457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  43460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  43464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  43472 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43476 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43480 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43484 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  43488 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43492 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43496 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  43500 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  43504 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43508 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43512 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  43516 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  43522 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  43524 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  43528 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43532 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43536 */     // MIs[5] vA
     /*  43536 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  43541 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  43545 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43549 */     // MIs[6] vB
     /*  43549 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  43554 */     // MIs[6] vC
     /*  43554 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  43559 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  43561 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  43561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  43564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  43566 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  43570 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  43574 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  43578 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  43588 */     GIR_RootConstrainSelectedInstOperands,
     /*  43589 */     // GIR_Coverage, 5193,
     /*  43589 */     GIR_EraseRootFromParent_Done,
     /*  43590 */   // Label 539: @43590
     /*  43590 */   GIM_Try, /*On fail goto*//*Label 540*/ GIMT_Encode4(43728), // Rule ID 5194 //
     /*  43595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  43598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  43602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  43610 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43614 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43618 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43622 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  43626 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43630 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43634 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  43638 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  43642 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43646 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43650 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  43654 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  43660 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  43662 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  43666 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43670 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43674 */     // MIs[5] vA
     /*  43674 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  43679 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  43683 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43687 */     // MIs[6] vC
     /*  43687 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  43692 */     // MIs[6] vB
     /*  43692 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  43697 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  43699 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  43699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  43702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  43704 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  43708 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  43712 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  43716 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  43726 */     GIR_RootConstrainSelectedInstOperands,
     /*  43727 */     // GIR_Coverage, 5194,
     /*  43727 */     GIR_EraseRootFromParent_Done,
     /*  43728 */   // Label 540: @43728
     /*  43728 */   GIM_Try, /*On fail goto*//*Label 541*/ GIMT_Encode4(43866), // Rule ID 5201 //
     /*  43733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  43736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  43740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  43748 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43752 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43756 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43760 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  43764 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43768 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43772 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  43776 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  43780 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43784 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43788 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  43792 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  43798 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  43800 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  43804 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43808 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43812 */     // MIs[5] vC
     /*  43812 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  43817 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  43821 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43825 */     // MIs[6] vA
     /*  43825 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  43830 */     // MIs[6] vB
     /*  43830 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  43835 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  43837 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  43837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  43840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  43842 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  43846 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  43850 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  43854 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  43864 */     GIR_RootConstrainSelectedInstOperands,
     /*  43865 */     // GIR_Coverage, 5201,
     /*  43865 */     GIR_EraseRootFromParent_Done,
     /*  43866 */   // Label 541: @43866
     /*  43866 */   GIM_Try, /*On fail goto*//*Label 542*/ GIMT_Encode4(44004), // Rule ID 5202 //
     /*  43871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  43874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  43878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  43886 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43890 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43894 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43898 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  43902 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43906 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43910 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  43914 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  43918 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43922 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43926 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  43930 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  43936 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  43938 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  43942 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43946 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43950 */     // MIs[5] vC
     /*  43950 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  43955 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  43959 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43963 */     // MIs[6] vB
     /*  43963 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  43968 */     // MIs[6] vA
     /*  43968 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  43973 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  43975 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  43975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  43978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  43980 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  43984 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  43988 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  43992 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  44002 */     GIR_RootConstrainSelectedInstOperands,
     /*  44003 */     // GIR_Coverage, 5202,
     /*  44003 */     GIR_EraseRootFromParent_Done,
     /*  44004 */   // Label 542: @44004
     /*  44004 */   GIM_Try, /*On fail goto*//*Label 543*/ GIMT_Encode4(44142), // Rule ID 5203 //
     /*  44009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  44012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  44016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  44024 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44028 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44032 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  44036 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  44040 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44044 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44048 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  44052 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  44056 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44060 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44064 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  44068 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  44074 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  44076 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  44080 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44084 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44088 */     // MIs[5] vB
     /*  44088 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  44093 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  44097 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44101 */     // MIs[6] vA
     /*  44101 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  44106 */     // MIs[6] vC
     /*  44106 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  44111 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  44113 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  44113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  44116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  44118 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  44122 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  44126 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  44130 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  44140 */     GIR_RootConstrainSelectedInstOperands,
     /*  44141 */     // GIR_Coverage, 5203,
     /*  44141 */     GIR_EraseRootFromParent_Done,
     /*  44142 */   // Label 543: @44142
     /*  44142 */   GIM_Try, /*On fail goto*//*Label 544*/ GIMT_Encode4(44280), // Rule ID 5204 //
     /*  44147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  44150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  44154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  44162 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44166 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44170 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  44174 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  44178 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44182 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44186 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  44190 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  44194 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44198 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44202 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  44206 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  44212 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  44214 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  44218 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44222 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44226 */     // MIs[5] vB
     /*  44226 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  44231 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  44235 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44239 */     // MIs[6] vC
     /*  44239 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  44244 */     // MIs[6] vA
     /*  44244 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  44249 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  44251 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  44251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  44254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  44256 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  44260 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  44264 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  44268 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  44278 */     GIR_RootConstrainSelectedInstOperands,
     /*  44279 */     // GIR_Coverage, 5204,
     /*  44279 */     GIR_EraseRootFromParent_Done,
     /*  44280 */   // Label 544: @44280
     /*  44280 */   GIM_Try, /*On fail goto*//*Label 545*/ GIMT_Encode4(44418), // Rule ID 5205 //
     /*  44285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  44288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  44292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  44300 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44304 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44308 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  44312 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  44316 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44320 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44324 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  44328 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  44332 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44336 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44340 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  44344 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  44350 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  44352 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  44356 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44360 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44364 */     // MIs[5] vA
     /*  44364 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  44369 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  44373 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44377 */     // MIs[6] vB
     /*  44377 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  44382 */     // MIs[6] vC
     /*  44382 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  44387 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  44389 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  44389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  44392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  44394 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  44398 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  44402 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  44406 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  44416 */     GIR_RootConstrainSelectedInstOperands,
     /*  44417 */     // GIR_Coverage, 5205,
     /*  44417 */     GIR_EraseRootFromParent_Done,
     /*  44418 */   // Label 545: @44418
     /*  44418 */   GIM_Try, /*On fail goto*//*Label 546*/ GIMT_Encode4(44556), // Rule ID 5206 //
     /*  44423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  44426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  44430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  44438 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44442 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44446 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  44450 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  44454 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44458 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44462 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  44466 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  44470 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44474 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44478 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  44482 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  44488 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  44490 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  44494 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44498 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44502 */     // MIs[5] vA
     /*  44502 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  44507 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  44511 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44515 */     // MIs[6] vC
     /*  44515 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  44520 */     // MIs[6] vB
     /*  44520 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  44525 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  44527 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  44527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  44530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  44532 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  44536 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  44540 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  44544 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  44554 */     GIR_RootConstrainSelectedInstOperands,
     /*  44555 */     // GIR_Coverage, 5206,
     /*  44555 */     GIR_EraseRootFromParent_Done,
     /*  44556 */   // Label 546: @44556
     /*  44556 */   GIM_Try, /*On fail goto*//*Label 547*/ GIMT_Encode4(44694), // Rule ID 5213 //
     /*  44561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  44564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  44568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  44576 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44580 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44584 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  44588 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  44592 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44596 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44600 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  44604 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  44608 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44612 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44616 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  44620 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  44626 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  44628 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  44632 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44636 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44640 */     // MIs[5] vC
     /*  44640 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  44645 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  44649 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44653 */     // MIs[6] vA
     /*  44653 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  44658 */     // MIs[6] vB
     /*  44658 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  44663 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  44665 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  44665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  44668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  44670 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  44674 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  44678 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  44682 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  44692 */     GIR_RootConstrainSelectedInstOperands,
     /*  44693 */     // GIR_Coverage, 5213,
     /*  44693 */     GIR_EraseRootFromParent_Done,
     /*  44694 */   // Label 547: @44694
     /*  44694 */   GIM_Try, /*On fail goto*//*Label 548*/ GIMT_Encode4(44832), // Rule ID 5214 //
     /*  44699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  44702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  44706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  44714 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44718 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44722 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  44726 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  44730 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44734 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44738 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  44742 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  44746 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44750 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44754 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  44758 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  44764 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  44766 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  44770 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44774 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44778 */     // MIs[5] vC
     /*  44778 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  44783 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  44787 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44791 */     // MIs[6] vB
     /*  44791 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  44796 */     // MIs[6] vA
     /*  44796 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  44801 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  44803 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  44803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  44806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  44808 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  44812 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  44816 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  44820 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  44830 */     GIR_RootConstrainSelectedInstOperands,
     /*  44831 */     // GIR_Coverage, 5214,
     /*  44831 */     GIR_EraseRootFromParent_Done,
     /*  44832 */   // Label 548: @44832
     /*  44832 */   GIM_Try, /*On fail goto*//*Label 549*/ GIMT_Encode4(44970), // Rule ID 5215 //
     /*  44837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  44840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  44844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  44852 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44856 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44860 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  44864 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  44868 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44872 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44876 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  44880 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  44884 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44888 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44892 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  44896 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  44902 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  44904 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  44908 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44912 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44916 */     // MIs[5] vB
     /*  44916 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  44921 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  44925 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44929 */     // MIs[6] vA
     /*  44929 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  44934 */     // MIs[6] vC
     /*  44934 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  44939 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  44941 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  44941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  44944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  44946 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  44950 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  44954 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  44958 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  44968 */     GIR_RootConstrainSelectedInstOperands,
     /*  44969 */     // GIR_Coverage, 5215,
     /*  44969 */     GIR_EraseRootFromParent_Done,
     /*  44970 */   // Label 549: @44970
     /*  44970 */   GIM_Try, /*On fail goto*//*Label 550*/ GIMT_Encode4(45108), // Rule ID 5216 //
     /*  44975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  44978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  44982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  44990 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44994 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44998 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45002 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  45006 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45010 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45014 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  45018 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  45022 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45026 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45030 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  45034 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  45040 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  45042 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  45046 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45050 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45054 */     // MIs[5] vB
     /*  45054 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  45059 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  45063 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45067 */     // MIs[6] vC
     /*  45067 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  45072 */     // MIs[6] vA
     /*  45072 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  45077 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  45079 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  45079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  45082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  45084 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  45088 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  45092 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  45096 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  45106 */     GIR_RootConstrainSelectedInstOperands,
     /*  45107 */     // GIR_Coverage, 5216,
     /*  45107 */     GIR_EraseRootFromParent_Done,
     /*  45108 */   // Label 550: @45108
     /*  45108 */   GIM_Try, /*On fail goto*//*Label 551*/ GIMT_Encode4(45246), // Rule ID 5217 //
     /*  45113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  45116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  45120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  45128 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45132 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45136 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45140 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  45144 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45148 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45152 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  45156 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  45160 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45164 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45168 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  45172 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  45178 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  45180 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  45184 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45188 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45192 */     // MIs[5] vA
     /*  45192 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  45197 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  45201 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45205 */     // MIs[6] vB
     /*  45205 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  45210 */     // MIs[6] vC
     /*  45210 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  45215 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  45217 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  45217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  45220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  45222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  45226 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  45230 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  45234 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  45244 */     GIR_RootConstrainSelectedInstOperands,
     /*  45245 */     // GIR_Coverage, 5217,
     /*  45245 */     GIR_EraseRootFromParent_Done,
     /*  45246 */   // Label 551: @45246
     /*  45246 */   GIM_Try, /*On fail goto*//*Label 552*/ GIMT_Encode4(45384), // Rule ID 5218 //
     /*  45251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  45254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  45258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  45266 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45270 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45274 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45278 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  45282 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45286 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45290 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  45294 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  45298 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45302 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45306 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  45310 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  45316 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  45318 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  45322 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45326 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45330 */     // MIs[5] vA
     /*  45330 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  45335 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  45339 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45343 */     // MIs[6] vC
     /*  45343 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  45348 */     // MIs[6] vB
     /*  45348 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  45353 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  45355 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  45355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  45358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  45360 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  45364 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  45368 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  45372 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  45382 */     GIR_RootConstrainSelectedInstOperands,
     /*  45383 */     // GIR_Coverage, 5218,
     /*  45383 */     GIR_EraseRootFromParent_Done,
     /*  45384 */   // Label 552: @45384
     /*  45384 */   GIM_Try, /*On fail goto*//*Label 553*/ GIMT_Encode4(45478), // Rule ID 4905 //
     /*  45389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  45392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  45396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45404 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45408 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45412 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45416 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  45420 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45424 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45428 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  45432 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  45438 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  45440 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  45444 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45448 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45452 */     // MIs[4] C
     /*  45452 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  45457 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45459 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$C, immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$A), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$C, v4i32:{ *:[v4i32] }:$B))  =>  (XXSEL:{ *:[v4i32] } ?:{ *:[v4i32] }:$A, ?:{ *:[v4i32] }:$B, ?:{ *:[v4i32] }:$C)
     /*  45459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSEL),
     /*  45462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  45464 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // A
     /*  45468 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // B
     /*  45472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // C
     /*  45476 */     GIR_RootConstrainSelectedInstOperands,
     /*  45477 */     // GIR_Coverage, 4905,
     /*  45477 */     GIR_EraseRootFromParent_Done,
     /*  45478 */   // Label 553: @45478
     /*  45478 */   GIM_Try, /*On fail goto*//*Label 554*/ GIMT_Encode4(45572), // Rule ID 1581 //
     /*  45483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  45486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  45490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45498 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45502 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45506 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45510 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  45514 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45518 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45522 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  45526 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  45532 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  45534 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  45538 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45542 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45546 */     // MIs[4] C
     /*  45546 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  45551 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45553 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$C, immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$A), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$B, v4i32:{ *:[v4i32] }:$C))  =>  (XXSEL:{ *:[v4i32] } ?:{ *:[v4i32] }:$A, ?:{ *:[v4i32] }:$B, ?:{ *:[v4i32] }:$C)
     /*  45553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSEL),
     /*  45556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  45558 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // A
     /*  45562 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // B
     /*  45566 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // C
     /*  45570 */     GIR_RootConstrainSelectedInstOperands,
     /*  45571 */     // GIR_Coverage, 1581,
     /*  45571 */     GIR_EraseRootFromParent_Done,
     /*  45572 */   // Label 554: @45572
     /*  45572 */   GIM_Try, /*On fail goto*//*Label 555*/ GIMT_Encode4(45666), // Rule ID 4907 //
     /*  45577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  45580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  45584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45592 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45596 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45600 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  45604 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  45608 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45612 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45616 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  45620 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  45626 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  45628 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  45632 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45636 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45640 */     // MIs[4] C
     /*  45640 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  45645 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45647 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$A, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$C, immAllOnesV:{ *:[v4i32] })), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$C, v4i32:{ *:[v4i32] }:$B))  =>  (XXSEL:{ *:[v4i32] } ?:{ *:[v4i32] }:$A, ?:{ *:[v4i32] }:$B, ?:{ *:[v4i32] }:$C)
     /*  45647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSEL),
     /*  45650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  45652 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // A
     /*  45656 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // B
     /*  45660 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // C
     /*  45664 */     GIR_RootConstrainSelectedInstOperands,
     /*  45665 */     // GIR_Coverage, 4907,
     /*  45665 */     GIR_EraseRootFromParent_Done,
     /*  45666 */   // Label 555: @45666
     /*  45666 */   GIM_Try, /*On fail goto*//*Label 556*/ GIMT_Encode4(45760), // Rule ID 4906 //
     /*  45671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  45674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  45678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45686 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45690 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45694 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  45698 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  45702 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45706 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45710 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  45714 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  45720 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  45722 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  45726 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45730 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45734 */     // MIs[4] C
     /*  45734 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  45739 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45741 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$A, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$C, immAllOnesV:{ *:[v4i32] })), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$B, v4i32:{ *:[v4i32] }:$C))  =>  (XXSEL:{ *:[v4i32] } ?:{ *:[v4i32] }:$A, ?:{ *:[v4i32] }:$B, ?:{ *:[v4i32] }:$C)
     /*  45741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSEL),
     /*  45744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  45746 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // A
     /*  45750 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // B
     /*  45754 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // C
     /*  45758 */     GIR_RootConstrainSelectedInstOperands,
     /*  45759 */     // GIR_Coverage, 4906,
     /*  45759 */     GIR_EraseRootFromParent_Done,
     /*  45760 */   // Label 556: @45760
     /*  45760 */   GIM_Try, /*On fail goto*//*Label 557*/ GIMT_Encode4(45854), // Rule ID 4908 //
     /*  45765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  45768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  45772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45780 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45784 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45788 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  45792 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45796 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45800 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45804 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  45808 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  45812 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45816 */     // MIs[3] C
     /*  45816 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  45821 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  45825 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  45831 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  45833 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45835 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$B, v4i32:{ *:[v4i32] }:$C), (and:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$C, immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$A))  =>  (XXSEL:{ *:[v4i32] } ?:{ *:[v4i32] }:$A, ?:{ *:[v4i32] }:$B, ?:{ *:[v4i32] }:$C)
     /*  45835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSEL),
     /*  45838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  45840 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // A
     /*  45844 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // B
     /*  45848 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // C
     /*  45852 */     GIR_RootConstrainSelectedInstOperands,
     /*  45853 */     // GIR_Coverage, 4908,
     /*  45853 */     GIR_EraseRootFromParent_Done,
     /*  45854 */   // Label 557: @45854
     /*  45854 */   GIM_Try, /*On fail goto*//*Label 558*/ GIMT_Encode4(45948), // Rule ID 4910 //
     /*  45859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  45862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  45866 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45870 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45874 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45878 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45882 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  45886 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45890 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45894 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45898 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  45902 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  45906 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45910 */     // MIs[3] C
     /*  45910 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  45915 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  45919 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  45925 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  45927 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45929 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$C, v4i32:{ *:[v4i32] }:$B), (and:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$C, immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$A))  =>  (XXSEL:{ *:[v4i32] } ?:{ *:[v4i32] }:$A, ?:{ *:[v4i32] }:$B, ?:{ *:[v4i32] }:$C)
     /*  45929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSEL),
     /*  45932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  45934 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // A
     /*  45938 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // B
     /*  45942 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // C
     /*  45946 */     GIR_RootConstrainSelectedInstOperands,
     /*  45947 */     // GIR_Coverage, 4910,
     /*  45947 */     GIR_EraseRootFromParent_Done,
     /*  45948 */   // Label 558: @45948
     /*  45948 */   GIM_Try, /*On fail goto*//*Label 559*/ GIMT_Encode4(46042), // Rule ID 4909 //
     /*  45953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  45956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  45960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45968 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45972 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45976 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  45980 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45984 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45988 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45992 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  45996 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  46000 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46004 */     // MIs[3] C
     /*  46004 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  46009 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  46013 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46019 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  46021 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  46023 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$B, v4i32:{ *:[v4i32] }:$C), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$A, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$C, immAllOnesV:{ *:[v4i32] })))  =>  (XXSEL:{ *:[v4i32] } ?:{ *:[v4i32] }:$A, ?:{ *:[v4i32] }:$B, ?:{ *:[v4i32] }:$C)
     /*  46023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSEL),
     /*  46026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  46028 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // A
     /*  46032 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // B
     /*  46036 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // C
     /*  46040 */     GIR_RootConstrainSelectedInstOperands,
     /*  46041 */     // GIR_Coverage, 4909,
     /*  46041 */     GIR_EraseRootFromParent_Done,
     /*  46042 */   // Label 559: @46042
     /*  46042 */   GIM_Try, /*On fail goto*//*Label 560*/ GIMT_Encode4(46136), // Rule ID 4911 //
     /*  46047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  46050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  46054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  46062 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46066 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46070 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  46074 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  46078 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46082 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46086 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  46090 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  46094 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46098 */     // MIs[3] C
     /*  46098 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  46103 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  46107 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46113 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  46115 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  46117 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$C, v4i32:{ *:[v4i32] }:$B), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$A, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$C, immAllOnesV:{ *:[v4i32] })))  =>  (XXSEL:{ *:[v4i32] } ?:{ *:[v4i32] }:$A, ?:{ *:[v4i32] }:$B, ?:{ *:[v4i32] }:$C)
     /*  46117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSEL),
     /*  46120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  46122 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // A
     /*  46126 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // B
     /*  46130 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // C
     /*  46134 */     GIR_RootConstrainSelectedInstOperands,
     /*  46135 */     // GIR_Coverage, 4911,
     /*  46135 */     GIR_EraseRootFromParent_Done,
     /*  46136 */   // Label 560: @46136
     /*  46136 */   GIM_Try, /*On fail goto*//*Label 561*/ GIMT_Encode4(46223), // Rule ID 4931 //
     /*  46141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  46144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  46148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  46156 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46160 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46164 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  46168 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  46172 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46176 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46180 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  46184 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46190 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  46192 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  46194 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 241:{ *:[i32] })
     /*  46194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  46197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  46199 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  46203 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  46207 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  46211 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(241),
     /*  46221 */     GIR_RootConstrainSelectedInstOperands,
     /*  46222 */     // GIR_Coverage, 4931,
     /*  46222 */     GIR_EraseRootFromParent_Done,
     /*  46223 */   // Label 561: @46223
     /*  46223 */   GIM_Try, /*On fail goto*//*Label 562*/ GIMT_Encode4(46308), // Rule ID 4925 //
     /*  46228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  46231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  46235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  46243 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46247 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46251 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46255 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  46259 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46263 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46267 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  46271 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46277 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  46279 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  46281 */     // (or:{ *:[v4i32] } (or:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 247:{ *:[i32] })
     /*  46281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  46284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  46286 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  46290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*  46294 */     GIR_RootToRootCopy, /*OpIdx*/2, // vC
     /*  46296 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(247),
     /*  46306 */     GIR_RootConstrainSelectedInstOperands,
     /*  46307 */     // GIR_Coverage, 4925,
     /*  46307 */     GIR_EraseRootFromParent_Done,
     /*  46308 */   // Label 562: @46308
     /*  46308 */   GIM_Try, /*On fail goto*//*Label 563*/ GIMT_Encode4(46393), // Rule ID 4926 //
     /*  46313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  46316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  46320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  46328 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46332 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46336 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  46340 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  46344 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46348 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46352 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  46356 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46362 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  46364 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  46366 */     // (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] })), v4i32:{ *:[v4i32] }:$vC)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 247:{ *:[i32] })
     /*  46366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  46369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  46371 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  46375 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  46379 */     GIR_RootToRootCopy, /*OpIdx*/2, // vC
     /*  46381 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(247),
     /*  46391 */     GIR_RootConstrainSelectedInstOperands,
     /*  46392 */     // GIR_Coverage, 4926,
     /*  46392 */     GIR_EraseRootFromParent_Done,
     /*  46393 */   // Label 563: @46393
     /*  46393 */   GIM_Try, /*On fail goto*//*Label 564*/ GIMT_Encode4(46480), // Rule ID 4927 //
     /*  46398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  46401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  46405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  46413 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46417 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46421 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  46425 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  46429 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46433 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46437 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  46441 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46447 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  46449 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  46451 */     // (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 247:{ *:[i32] })
     /*  46451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  46454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  46456 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  46460 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  46464 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  46468 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(247),
     /*  46478 */     GIR_RootConstrainSelectedInstOperands,
     /*  46479 */     // GIR_Coverage, 4927,
     /*  46479 */     GIR_EraseRootFromParent_Done,
     /*  46480 */   // Label 564: @46480
     /*  46480 */   GIM_Try, /*On fail goto*//*Label 565*/ GIMT_Encode4(46565), // Rule ID 5246 //
     /*  46485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  46488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  46492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  46500 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46504 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46508 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46512 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  46516 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46520 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46524 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  46528 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46534 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  46536 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  46538 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$vA)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 239:{ *:[i32] })
     /*  46538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  46541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  46543 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*  46545 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  46549 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  46553 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(239),
     /*  46563 */     GIR_RootConstrainSelectedInstOperands,
     /*  46564 */     // GIR_Coverage, 5246,
     /*  46564 */     GIR_EraseRootFromParent_Done,
     /*  46565 */   // Label 565: @46565
     /*  46565 */   GIM_Try, /*On fail goto*//*Label 566*/ GIMT_Encode4(46650), // Rule ID 5247 //
     /*  46570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  46573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  46577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  46585 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46589 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46593 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46597 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  46601 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46605 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46609 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  46613 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46619 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  46621 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  46623 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$vA)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 143:{ *:[i32] })
     /*  46623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  46626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  46628 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*  46630 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  46634 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  46638 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(143),
     /*  46648 */     GIR_RootConstrainSelectedInstOperands,
     /*  46649 */     // GIR_Coverage, 5247,
     /*  46649 */     GIR_EraseRootFromParent_Done,
     /*  46650 */   // Label 566: @46650
     /*  46650 */   GIM_Try, /*On fail goto*//*Label 567*/ GIMT_Encode4(46735), // Rule ID 5244 //
     /*  46655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  46658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  46662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  46670 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46674 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46678 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46682 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  46686 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46690 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46694 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  46698 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46704 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  46706 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  46708 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 159:{ *:[i32] })
     /*  46708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  46711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  46713 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*  46715 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  46719 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  46723 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(159),
     /*  46733 */     GIR_RootConstrainSelectedInstOperands,
     /*  46734 */     // GIR_Coverage, 5244,
     /*  46734 */     GIR_EraseRootFromParent_Done,
     /*  46735 */   // Label 567: @46735
     /*  46735 */   GIM_Try, /*On fail goto*//*Label 568*/ GIMT_Encode4(46820), // Rule ID 5243 //
     /*  46740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  46743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  46747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  46755 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46759 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46763 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46767 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  46771 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46775 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46779 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  46783 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46789 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  46791 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  46793 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$vA)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 159:{ *:[i32] })
     /*  46793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  46796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  46798 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*  46800 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  46804 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  46808 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(159),
     /*  46818 */     GIR_RootConstrainSelectedInstOperands,
     /*  46819 */     // GIR_Coverage, 5243,
     /*  46819 */     GIR_EraseRootFromParent_Done,
     /*  46820 */   // Label 568: @46820
     /*  46820 */   GIM_Try, /*On fail goto*//*Label 569*/ GIMT_Encode4(46905), // Rule ID 5245 //
     /*  46825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  46828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  46832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  46840 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46844 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46848 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  46852 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  46856 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46860 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46864 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  46868 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46874 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  46876 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  46878 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, immAllOnesV:{ *:[v4i32] })), v4i32:{ *:[v4i32] }:$vA)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 159:{ *:[i32] })
     /*  46878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  46881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  46883 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*  46885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  46889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  46893 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(159),
     /*  46903 */     GIR_RootConstrainSelectedInstOperands,
     /*  46904 */     // GIR_Coverage, 5245,
     /*  46904 */     GIR_EraseRootFromParent_Done,
     /*  46905 */   // Label 569: @46905
     /*  46905 */   GIM_Try, /*On fail goto*//*Label 570*/ GIMT_Encode4(46992), // Rule ID 3387 //
     /*  46910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  46913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  46917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  46925 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46929 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46933 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  46937 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46943 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  46945 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  46949 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  46953 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46957 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46961 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  46963 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 241:{ *:[i32] })
     /*  46963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  46966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  46968 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  46972 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  46976 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  46980 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(241),
     /*  46990 */     GIR_RootConstrainSelectedInstOperands,
     /*  46991 */     // GIR_Coverage, 3387,
     /*  46991 */     GIR_EraseRootFromParent_Done,
     /*  46992 */   // Label 570: @46992
     /*  46992 */   GIM_Try, /*On fail goto*//*Label 571*/ GIMT_Encode4(47079), // Rule ID 3385 //
     /*  46997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  47000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  47004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47012 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47016 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47020 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  47024 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  47030 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  47032 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  47036 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  47040 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47044 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47048 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  47050 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }), (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 247:{ *:[i32] })
     /*  47050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  47053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  47055 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  47059 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  47063 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  47067 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(247),
     /*  47077 */     GIR_RootConstrainSelectedInstOperands,
     /*  47078 */     // GIR_Coverage, 3385,
     /*  47078 */     GIR_EraseRootFromParent_Done,
     /*  47079 */   // Label 571: @47079
     /*  47079 */   GIM_Try, /*On fail goto*//*Label 572*/ GIMT_Encode4(47166), // Rule ID 3386 //
     /*  47084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  47087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  47091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47099 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47103 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47107 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  47111 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  47117 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  47119 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  47123 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47127 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47131 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47135 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  47137 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }), (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 246:{ *:[i32] })
     /*  47137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  47140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  47142 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  47146 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  47150 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  47154 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(246),
     /*  47164 */     GIR_RootConstrainSelectedInstOperands,
     /*  47165 */     // GIR_Coverage, 3386,
     /*  47165 */     GIR_EraseRootFromParent_Done,
     /*  47166 */   // Label 572: @47166
     /*  47166 */   GIM_Try, /*On fail goto*//*Label 573*/ GIMT_Encode4(47253), // Rule ID 4930 //
     /*  47171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  47174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  47178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47186 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47190 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47194 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  47198 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47202 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47206 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47210 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  47214 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  47220 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  47222 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  47224 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 246:{ *:[i32] })
     /*  47224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  47227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  47229 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  47233 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  47237 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  47241 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(246),
     /*  47251 */     GIR_RootConstrainSelectedInstOperands,
     /*  47252 */     // GIR_Coverage, 4930,
     /*  47252 */     GIR_EraseRootFromParent_Done,
     /*  47253 */   // Label 573: @47253
     /*  47253 */   GIM_Try, /*On fail goto*//*Label 574*/ GIMT_Encode4(47338), // Rule ID 4928 //
     /*  47258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  47261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  47265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  47273 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47277 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47281 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  47285 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47289 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47293 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47297 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  47301 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  47307 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  47309 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  47311 */     // (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 247:{ *:[i32] })
     /*  47311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  47314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  47316 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  47320 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*  47324 */     GIR_RootToRootCopy, /*OpIdx*/1, // vC
     /*  47326 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(247),
     /*  47336 */     GIR_RootConstrainSelectedInstOperands,
     /*  47337 */     // GIR_Coverage, 4928,
     /*  47337 */     GIR_EraseRootFromParent_Done,
     /*  47338 */   // Label 574: @47338
     /*  47338 */   GIM_Try, /*On fail goto*//*Label 575*/ GIMT_Encode4(47423), // Rule ID 4929 //
     /*  47343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  47346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  47350 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47354 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  47358 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47362 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47366 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  47370 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47374 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47378 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47382 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  47386 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  47392 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  47394 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  47396 */     // (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] })))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 247:{ *:[i32] })
     /*  47396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  47399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  47401 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  47405 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  47409 */     GIR_RootToRootCopy, /*OpIdx*/1, // vC
     /*  47411 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(247),
     /*  47421 */     GIR_RootConstrainSelectedInstOperands,
     /*  47422 */     // GIR_Coverage, 4929,
     /*  47422 */     GIR_EraseRootFromParent_Done,
     /*  47423 */   // Label 575: @47423
     /*  47423 */   GIM_Try, /*On fail goto*//*Label 576*/ GIMT_Encode4(47508), // Rule ID 3400 //
     /*  47428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  47431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  47435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47443 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47447 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47451 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  47455 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  47459 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47463 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47467 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  47471 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  47477 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  47479 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  47481 */     // (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (xor:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 239:{ *:[i32] })
     /*  47481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  47484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  47486 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*  47488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  47492 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  47496 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(239),
     /*  47506 */     GIR_RootConstrainSelectedInstOperands,
     /*  47507 */     // GIR_Coverage, 3400,
     /*  47507 */     GIR_EraseRootFromParent_Done,
     /*  47508 */   // Label 576: @47508
     /*  47508 */   GIM_Try, /*On fail goto*//*Label 577*/ GIMT_Encode4(47593), // Rule ID 3401 //
     /*  47513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  47516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  47520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47528 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47532 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47536 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  47540 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  47544 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47548 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47552 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  47556 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  47562 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  47564 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  47566 */     // (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 143:{ *:[i32] })
     /*  47566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  47569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  47571 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*  47573 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  47577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  47581 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(143),
     /*  47591 */     GIR_RootConstrainSelectedInstOperands,
     /*  47592 */     // GIR_Coverage, 3401,
     /*  47592 */     GIR_EraseRootFromParent_Done,
     /*  47593 */   // Label 577: @47593
     /*  47593 */   GIM_Try, /*On fail goto*//*Label 578*/ GIMT_Encode4(47678), // Rule ID 5241 //
     /*  47598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  47601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  47605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47613 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47617 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47621 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  47625 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47629 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47633 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47637 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  47641 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  47647 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  47649 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  47651 */     // (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 159:{ *:[i32] })
     /*  47651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  47654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  47656 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*  47658 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  47662 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  47666 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(159),
     /*  47676 */     GIR_RootConstrainSelectedInstOperands,
     /*  47677 */     // GIR_Coverage, 5241,
     /*  47677 */     GIR_EraseRootFromParent_Done,
     /*  47678 */   // Label 578: @47678
     /*  47678 */   GIM_Try, /*On fail goto*//*Label 579*/ GIMT_Encode4(47763), // Rule ID 3399 //
     /*  47683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  47686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  47690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47698 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47702 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47706 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  47710 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47714 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47718 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47722 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  47726 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  47732 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  47734 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  47736 */     // (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 159:{ *:[i32] })
     /*  47736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  47739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  47741 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*  47743 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  47747 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  47751 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(159),
     /*  47761 */     GIR_RootConstrainSelectedInstOperands,
     /*  47762 */     // GIR_Coverage, 3399,
     /*  47762 */     GIR_EraseRootFromParent_Done,
     /*  47763 */   // Label 579: @47763
     /*  47763 */   GIM_Try, /*On fail goto*//*Label 580*/ GIMT_Encode4(47848), // Rule ID 5242 //
     /*  47768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  47771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  47775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47783 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47787 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47791 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  47795 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47799 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47803 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47807 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  47811 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  47817 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  47819 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  47821 */     // (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, immAllOnesV:{ *:[v4i32] })))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 159:{ *:[i32] })
     /*  47821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  47824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  47826 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*  47828 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  47832 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  47836 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(159),
     /*  47846 */     GIR_RootConstrainSelectedInstOperands,
     /*  47847 */     // GIR_Coverage, 5242,
     /*  47847 */     GIR_EraseRootFromParent_Done,
     /*  47848 */   // Label 580: @47848
     /*  47848 */   GIM_Try, /*On fail goto*//*Label 581*/ GIMT_Encode4(47903), // Rule ID 4895 //
     /*  47853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /*  47856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  47860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47868 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47872 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47876 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  47880 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  47886 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  47888 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47890 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XB, immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$XA)  =>  (XXLORC:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB)
     /*  47890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXLORC),
     /*  47893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  47895 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  47897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XB
     /*  47901 */     GIR_RootConstrainSelectedInstOperands,
     /*  47902 */     // GIR_Coverage, 4895,
     /*  47902 */     GIR_EraseRootFromParent_Done,
     /*  47903 */   // Label 581: @47903
     /*  47903 */   GIM_Try, /*On fail goto*//*Label 582*/ GIMT_Encode4(47958), // Rule ID 942 //
     /*  47908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /*  47911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  47915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47923 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47927 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47931 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  47935 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  47941 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  47943 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47945 */     // (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XB, immAllOnesV:{ *:[v4i32] }))  =>  (XXLORC:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB)
     /*  47945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXLORC),
     /*  47948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  47950 */     GIR_RootToRootCopy, /*OpIdx*/1, // XA
     /*  47952 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XB
     /*  47956 */     GIR_RootConstrainSelectedInstOperands,
     /*  47957 */     // GIR_Coverage, 942,
     /*  47957 */     GIR_EraseRootFromParent_Done,
     /*  47958 */   // Label 582: @47958
     /*  47958 */   GIM_Try, /*On fail goto*//*Label 583*/ GIMT_Encode4(48008), // Rule ID 5240 //
     /*  47963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  47966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  47970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  47978 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47982 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47986 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  47988 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 31:{ *:[i32] })
     /*  47988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  47991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  47993 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*  47995 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  47999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  48003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  48006 */     GIR_RootConstrainSelectedInstOperands,
     /*  48007 */     // GIR_Coverage, 5240,
     /*  48007 */     GIR_EraseRootFromParent_Done,
     /*  48008 */   // Label 583: @48008
     /*  48008 */   GIM_Try, /*On fail goto*//*Label 584*/ GIMT_Encode4(48058), // Rule ID 5239 //
     /*  48013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  48016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  48020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  48028 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  48032 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  48036 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48038 */     // (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 127:{ *:[i32] })
     /*  48038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  48041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  48043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  48047 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*  48051 */     GIR_RootToRootCopy, /*OpIdx*/2, // vC
     /*  48053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/127,
     /*  48056 */     GIR_RootConstrainSelectedInstOperands,
     /*  48057 */     // GIR_Coverage, 5239,
     /*  48057 */     GIR_EraseRootFromParent_Done,
     /*  48058 */   // Label 584: @48058
     /*  48058 */   GIM_Try, /*On fail goto*//*Label 585*/ GIMT_Encode4(48108), // Rule ID 5248 //
     /*  48063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  48066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  48070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  48078 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  48082 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  48086 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48088 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 111:{ *:[i32] })
     /*  48088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  48091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  48093 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*  48095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  48099 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  48103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/111,
     /*  48106 */     GIR_RootConstrainSelectedInstOperands,
     /*  48107 */     // GIR_Coverage, 5248,
     /*  48107 */     GIR_EraseRootFromParent_Done,
     /*  48108 */   // Label 585: @48108
     /*  48108 */   GIM_Try, /*On fail goto*//*Label 586*/ GIMT_Encode4(48158), // Rule ID 3398 //
     /*  48113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  48116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  48120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  48128 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  48132 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  48136 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48138 */     // (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 31:{ *:[i32] })
     /*  48138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  48141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  48143 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*  48145 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  48149 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  48153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  48156 */     GIR_RootConstrainSelectedInstOperands,
     /*  48157 */     // GIR_Coverage, 3398,
     /*  48157 */     GIR_EraseRootFromParent_Done,
     /*  48158 */   // Label 586: @48158
     /*  48158 */   GIM_Try, /*On fail goto*//*Label 587*/ GIMT_Encode4(48208), // Rule ID 3397 //
     /*  48163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  48166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  48170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  48178 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  48182 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  48186 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48188 */     // (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 127:{ *:[i32] })
     /*  48188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  48191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  48193 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*  48195 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  48199 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  48203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/127,
     /*  48206 */     GIR_RootConstrainSelectedInstOperands,
     /*  48207 */     // GIR_Coverage, 3397,
     /*  48207 */     GIR_EraseRootFromParent_Done,
     /*  48208 */   // Label 587: @48208
     /*  48208 */   GIM_Try, /*On fail goto*//*Label 588*/ GIMT_Encode4(48258), // Rule ID 3402 //
     /*  48213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  48216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  48220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  48228 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  48232 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  48236 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48238 */     // (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 111:{ *:[i32] })
     /*  48238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  48241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  48243 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*  48245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  48249 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  48253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/111,
     /*  48256 */     GIR_RootConstrainSelectedInstOperands,
     /*  48257 */     // GIR_Coverage, 3402,
     /*  48257 */     GIR_EraseRootFromParent_Done,
     /*  48258 */   // Label 588: @48258
     /*  48258 */   GIM_Try, /*On fail goto*//*Label 589*/ GIMT_Encode4(48277), // Rule ID 931 //
     /*  48263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  48266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  48270 */     // (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB)  =>  (XXLOR:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB)
     /*  48270 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XXLOR),
     /*  48275 */     GIR_RootConstrainSelectedInstOperands,
     /*  48276 */     // GIR_Coverage, 931,
     /*  48276 */     GIR_Done,
     /*  48277 */   // Label 589: @48277
     /*  48277 */   GIM_Try, /*On fail goto*//*Label 590*/ GIMT_Encode4(48332), // Rule ID 4883 //
     /*  48282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  48285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  48289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  48297 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  48301 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  48305 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  48309 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  48315 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  48317 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48319 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VB, immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$VA)  =>  (VORC:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  48319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VORC),
     /*  48322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  48324 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  48326 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // VB
     /*  48330 */     GIR_RootConstrainSelectedInstOperands,
     /*  48331 */     // GIR_Coverage, 4883,
     /*  48331 */     GIR_EraseRootFromParent_Done,
     /*  48332 */   // Label 590: @48332
     /*  48332 */   GIM_Try, /*On fail goto*//*Label 591*/ GIMT_Encode4(48387), // Rule ID 489 //
     /*  48337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  48340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  48344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  48352 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  48356 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  48360 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  48364 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  48370 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  48372 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48374 */     // (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VB, immAllOnesV:{ *:[v4i32] }))  =>  (VORC:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  48374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VORC),
     /*  48377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  48379 */     GIR_RootToRootCopy, /*OpIdx*/1, // VA
     /*  48381 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // VB
     /*  48385 */     GIR_RootConstrainSelectedInstOperands,
     /*  48386 */     // GIR_Coverage, 489,
     /*  48386 */     GIR_EraseRootFromParent_Done,
     /*  48387 */   // Label 591: @48387
     /*  48387 */   GIM_Try, /*On fail goto*//*Label 592*/ GIMT_Encode4(48406), // Rule ID 386 //
     /*  48392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  48395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  48399 */     // (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VOR:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  48399 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VOR),
     /*  48404 */     GIR_RootConstrainSelectedInstOperands,
     /*  48405 */     // GIR_Coverage, 386,
     /*  48405 */     GIR_Done,
     /*  48406 */   // Label 592: @48406
     /*  48406 */   GIM_Reject,
     /*  48407 */ // Label 264: @48407
     /*  48407 */ GIM_Reject,
     /*  48408 */ // Label 251: @48408
     /*  48408 */ GIM_Reject,
     /*  48409 */ // Label 9: @48409
     /*  48409 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(6), /*)*//*default:*//*Label 597*/ GIMT_Encode4(57515),
     /*  48420 */ /*GILLT_s1*//*Label 593*/ GIMT_Encode4(48444),
     /*  48424 */ /*GILLT_s32*//*Label 594*/ GIMT_Encode4(53881),
     /*  48428 */ /*GILLT_s64*//*Label 595*/ GIMT_Encode4(54136), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  48440 */ /*GILLT_v4s32*//*Label 596*/ GIMT_Encode4(54391),
     /*  48444 */ // Label 593: @48444
     /*  48444 */ GIM_Try, /*On fail goto*//*Label 598*/ GIMT_Encode4(53880),
     /*  48449 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /*  48452 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s1,
     /*  48455 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  48459 */   GIM_Try, /*On fail goto*//*Label 599*/ GIMT_Encode4(48550), // Rule ID 3024 //
     /*  48464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  48467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  48475 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  48479 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  48483 */     // MIs[1] Operand 1
     /*  48483 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /*  48488 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  48492 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48496 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /*  48500 */     // MIs[2] Operand 1
     /*  48500 */     // No operand predicates
     /*  48500 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  48504 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48506 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_lt:{ *:[i32] })
     /*  48506 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  48509 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /*  48513 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48518 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  48522 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /*  48525 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  48527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48532 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  48539 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  48544 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  48549 */     // GIR_Coverage, 3024,
     /*  48549 */     GIR_EraseRootFromParent_Done,
     /*  48550 */   // Label 599: @48550
     /*  48550 */   GIM_Try, /*On fail goto*//*Label 600*/ GIMT_Encode4(48641), // Rule ID 3040 //
     /*  48555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  48558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48562 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  48566 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  48570 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  48574 */     // MIs[1] Operand 1
     /*  48574 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /*  48579 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  48583 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48587 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /*  48591 */     // MIs[2] Operand 1
     /*  48591 */     // No operand predicates
     /*  48591 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  48595 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48597 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETLE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_gt:{ *:[i32] })
     /*  48597 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  48600 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /*  48604 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48609 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  48613 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /*  48616 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  48618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48623 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  48630 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  48635 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  48640 */     // GIR_Coverage, 3040,
     /*  48640 */     GIR_EraseRootFromParent_Done,
     /*  48641 */   // Label 600: @48641
     /*  48641 */   GIM_Try, /*On fail goto*//*Label 601*/ GIMT_Encode4(48732), // Rule ID 3048 //
     /*  48646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  48649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  48657 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  48661 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  48665 */     // MIs[1] Operand 1
     /*  48665 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /*  48670 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  48674 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48678 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /*  48682 */     // MIs[2] Operand 1
     /*  48682 */     // No operand predicates
     /*  48682 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  48686 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48688 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETNE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_eq:{ *:[i32] })
     /*  48688 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  48691 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /*  48695 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48700 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  48704 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /*  48707 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  48709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48714 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  48721 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  48726 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  48731 */     // GIR_Coverage, 3048,
     /*  48731 */     GIR_EraseRootFromParent_Done,
     /*  48732 */   // Label 601: @48732
     /*  48732 */   GIM_Try, /*On fail goto*//*Label 602*/ GIMT_Encode4(48823), // Rule ID 3120 //
     /*  48737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  48740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  48748 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  48752 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  48756 */     // MIs[1] Operand 1
     /*  48756 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /*  48761 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  48765 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48769 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /*  48773 */     // MIs[2] Operand 1
     /*  48773 */     // No operand predicates
     /*  48773 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  48777 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48779 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_lt:{ *:[i32] })
     /*  48779 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  48782 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /*  48786 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48791 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  48795 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /*  48798 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  48800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48805 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  48812 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  48817 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  48822 */     // GIR_Coverage, 3120,
     /*  48822 */     GIR_EraseRootFromParent_Done,
     /*  48823 */   // Label 602: @48823
     /*  48823 */   GIM_Try, /*On fail goto*//*Label 603*/ GIMT_Encode4(48914), // Rule ID 3136 //
     /*  48828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  48831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  48839 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  48843 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  48847 */     // MIs[1] Operand 1
     /*  48847 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /*  48852 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  48856 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48860 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /*  48864 */     // MIs[2] Operand 1
     /*  48864 */     // No operand predicates
     /*  48864 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  48868 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48870 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETLE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_gt:{ *:[i32] })
     /*  48870 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  48873 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /*  48877 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48882 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  48886 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /*  48889 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  48891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48896 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  48903 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  48908 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  48913 */     // GIR_Coverage, 3136,
     /*  48913 */     GIR_EraseRootFromParent_Done,
     /*  48914 */   // Label 603: @48914
     /*  48914 */   GIM_Try, /*On fail goto*//*Label 604*/ GIMT_Encode4(49005), // Rule ID 3144 //
     /*  48919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  48922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  48930 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  48934 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  48938 */     // MIs[1] Operand 1
     /*  48938 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /*  48943 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  48947 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48951 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /*  48955 */     // MIs[2] Operand 1
     /*  48955 */     // No operand predicates
     /*  48955 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  48959 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48961 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETNE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_eq:{ *:[i32] })
     /*  48961 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  48964 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /*  48968 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48973 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  48977 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /*  48980 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  48982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48987 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  48994 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  48999 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  49004 */     // GIR_Coverage, 3144,
     /*  49004 */     GIR_EraseRootFromParent_Done,
     /*  49005 */   // Label 604: @49005
     /*  49005 */   GIM_Try, /*On fail goto*//*Label 605*/ GIMT_Encode4(49096), // Rule ID 3778 //
     /*  49010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  49013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  49021 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  49025 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  49029 */     // MIs[1] Operand 1
     /*  49029 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /*  49034 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  49038 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  49042 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /*  49046 */     // MIs[2] Operand 1
     /*  49046 */     // No operand predicates
     /*  49046 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  49050 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49052 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_lt:{ *:[i32] })
     /*  49052 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  49055 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /*  49059 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49064 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  49068 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /*  49071 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  49073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49078 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  49085 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  49090 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  49095 */     // GIR_Coverage, 3778,
     /*  49095 */     GIR_EraseRootFromParent_Done,
     /*  49096 */   // Label 605: @49096
     /*  49096 */   GIM_Try, /*On fail goto*//*Label 606*/ GIMT_Encode4(49187), // Rule ID 3794 //
     /*  49101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  49104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  49112 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  49116 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  49120 */     // MIs[1] Operand 1
     /*  49120 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /*  49125 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  49129 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  49133 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /*  49137 */     // MIs[2] Operand 1
     /*  49137 */     // No operand predicates
     /*  49137 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  49141 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49143 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETLE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_gt:{ *:[i32] })
     /*  49143 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  49146 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /*  49150 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49155 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  49159 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /*  49162 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  49164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49169 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  49176 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  49181 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  49186 */     // GIR_Coverage, 3794,
     /*  49186 */     GIR_EraseRootFromParent_Done,
     /*  49187 */   // Label 606: @49187
     /*  49187 */   GIM_Try, /*On fail goto*//*Label 607*/ GIMT_Encode4(49278), // Rule ID 3802 //
     /*  49192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  49195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  49203 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  49207 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  49211 */     // MIs[1] Operand 1
     /*  49211 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /*  49216 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  49220 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  49224 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /*  49228 */     // MIs[2] Operand 1
     /*  49228 */     // No operand predicates
     /*  49228 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  49232 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49234 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETNE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_eq:{ *:[i32] })
     /*  49234 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  49237 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /*  49241 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49246 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  49250 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /*  49253 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  49255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49260 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  49267 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  49272 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  49277 */     // GIR_Coverage, 3802,
     /*  49277 */     GIR_EraseRootFromParent_Done,
     /*  49278 */   // Label 607: @49278
     /*  49278 */   GIM_Try, /*On fail goto*//*Label 608*/ GIMT_Encode4(49369), // Rule ID 3874 //
     /*  49283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  49286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  49294 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  49298 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  49302 */     // MIs[1] Operand 1
     /*  49302 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /*  49307 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  49311 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  49315 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /*  49319 */     // MIs[2] Operand 1
     /*  49319 */     // No operand predicates
     /*  49319 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  49323 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49325 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_lt:{ *:[i32] })
     /*  49325 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  49328 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /*  49332 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49337 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  49341 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /*  49344 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  49346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49351 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  49358 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  49363 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  49368 */     // GIR_Coverage, 3874,
     /*  49368 */     GIR_EraseRootFromParent_Done,
     /*  49369 */   // Label 608: @49369
     /*  49369 */   GIM_Try, /*On fail goto*//*Label 609*/ GIMT_Encode4(49460), // Rule ID 3890 //
     /*  49374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  49377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  49385 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  49389 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  49393 */     // MIs[1] Operand 1
     /*  49393 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /*  49398 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  49402 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  49406 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /*  49410 */     // MIs[2] Operand 1
     /*  49410 */     // No operand predicates
     /*  49410 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  49414 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49416 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETLE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_gt:{ *:[i32] })
     /*  49416 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  49419 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /*  49423 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49428 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  49432 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /*  49435 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  49437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49442 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  49449 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  49454 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  49459 */     // GIR_Coverage, 3890,
     /*  49459 */     GIR_EraseRootFromParent_Done,
     /*  49460 */   // Label 609: @49460
     /*  49460 */   GIM_Try, /*On fail goto*//*Label 610*/ GIMT_Encode4(49551), // Rule ID 3898 //
     /*  49465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  49468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  49476 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  49480 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  49484 */     // MIs[1] Operand 1
     /*  49484 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /*  49489 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  49493 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  49497 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /*  49501 */     // MIs[2] Operand 1
     /*  49501 */     // No operand predicates
     /*  49501 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  49505 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49507 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETNE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_eq:{ *:[i32] })
     /*  49507 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  49510 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /*  49514 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49519 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  49523 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /*  49526 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  49528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49533 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  49540 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  49545 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  49550 */     // GIR_Coverage, 3898,
     /*  49550 */     GIR_EraseRootFromParent_Done,
     /*  49551 */   // Label 610: @49551
     /*  49551 */   GIM_Try, /*On fail goto*//*Label 611*/ GIMT_Encode4(49631), // Rule ID 3168 //
     /*  49556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  49559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  49567 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  49571 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  49575 */     // MIs[1] Operand 1
     /*  49575 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /*  49580 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  49584 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49586 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_lt:{ *:[i32] })
     /*  49586 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  49589 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /*  49593 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49598 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  49602 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  49606 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  49608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49613 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  49620 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  49625 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  49630 */     // GIR_Coverage, 3168,
     /*  49630 */     GIR_EraseRootFromParent_Done,
     /*  49631 */   // Label 611: @49631
     /*  49631 */   GIM_Try, /*On fail goto*//*Label 612*/ GIMT_Encode4(49711), // Rule ID 3184 //
     /*  49636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  49639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  49647 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  49651 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  49655 */     // MIs[1] Operand 1
     /*  49655 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /*  49660 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  49664 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49666 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] })
     /*  49666 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  49669 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /*  49673 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49678 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  49682 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  49686 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  49688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49693 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  49700 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  49705 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  49710 */     // GIR_Coverage, 3184,
     /*  49710 */     GIR_EraseRootFromParent_Done,
     /*  49711 */   // Label 612: @49711
     /*  49711 */   GIM_Try, /*On fail goto*//*Label 613*/ GIMT_Encode4(49791), // Rule ID 3200 //
     /*  49716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  49719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  49727 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  49731 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  49735 */     // MIs[1] Operand 1
     /*  49735 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /*  49740 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  49744 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49746 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_eq:{ *:[i32] })
     /*  49746 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  49749 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /*  49753 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49758 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  49762 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  49766 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  49768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49773 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  49780 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  49785 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  49790 */     // GIR_Coverage, 3200,
     /*  49790 */     GIR_EraseRootFromParent_Done,
     /*  49791 */   // Label 613: @49791
     /*  49791 */   GIM_Try, /*On fail goto*//*Label 614*/ GIMT_Encode4(49871), // Rule ID 3216 //
     /*  49796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  49799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  49807 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  49811 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  49815 */     // MIs[1] Operand 1
     /*  49815 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /*  49820 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  49824 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49826 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETO:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_un:{ *:[i32] })
     /*  49826 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  49829 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /*  49833 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49838 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  49842 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  49846 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  49848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49853 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /*  49860 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  49865 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  49870 */     // GIR_Coverage, 3216,
     /*  49870 */     GIR_EraseRootFromParent_Done,
     /*  49871 */   // Label 614: @49871
     /*  49871 */   GIM_Try, /*On fail goto*//*Label 615*/ GIMT_Encode4(49951), // Rule ID 3224 //
     /*  49876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  49879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  49887 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  49891 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  49895 */     // MIs[1] Operand 1
     /*  49895 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /*  49900 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  49904 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49906 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_lt:{ *:[i32] })
     /*  49906 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  49909 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /*  49913 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49918 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  49922 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  49926 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  49928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49933 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  49940 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  49945 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  49950 */     // GIR_Coverage, 3224,
     /*  49950 */     GIR_EraseRootFromParent_Done,
     /*  49951 */   // Label 615: @49951
     /*  49951 */   GIM_Try, /*On fail goto*//*Label 616*/ GIMT_Encode4(50031), // Rule ID 3240 //
     /*  49956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  49959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  49967 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  49971 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  49975 */     // MIs[1] Operand 1
     /*  49975 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /*  49980 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  49984 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49986 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] })
     /*  49986 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  49989 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /*  49993 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49998 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  50002 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  50006 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  50008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50013 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  50020 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  50025 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  50030 */     // GIR_Coverage, 3240,
     /*  50030 */     GIR_EraseRootFromParent_Done,
     /*  50031 */   // Label 616: @50031
     /*  50031 */   GIM_Try, /*On fail goto*//*Label 617*/ GIMT_Encode4(50111), // Rule ID 3256 //
     /*  50036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  50039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  50047 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  50051 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  50055 */     // MIs[1] Operand 1
     /*  50055 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /*  50060 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  50064 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50066 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_eq:{ *:[i32] })
     /*  50066 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  50069 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /*  50073 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50078 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  50082 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  50086 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  50088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50093 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  50100 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  50105 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  50110 */     // GIR_Coverage, 3256,
     /*  50110 */     GIR_EraseRootFromParent_Done,
     /*  50111 */   // Label 617: @50111
     /*  50111 */   GIM_Try, /*On fail goto*//*Label 618*/ GIMT_Encode4(50191), // Rule ID 3272 //
     /*  50116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  50119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  50127 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  50131 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  50135 */     // MIs[1] Operand 1
     /*  50135 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /*  50140 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  50144 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50146 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETO:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_un:{ *:[i32] })
     /*  50146 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  50149 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /*  50153 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50158 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  50162 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  50166 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  50168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50173 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /*  50180 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  50185 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  50190 */     // GIR_Coverage, 3272,
     /*  50190 */     GIR_EraseRootFromParent_Done,
     /*  50191 */   // Label 618: @50191
     /*  50191 */   GIM_Try, /*On fail goto*//*Label 619*/ GIMT_Encode4(50271), // Rule ID 3280 //
     /*  50196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  50199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  50207 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /*  50211 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /*  50215 */     // MIs[1] Operand 1
     /*  50215 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /*  50220 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  50224 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50226 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_lt:{ *:[i32] })
     /*  50226 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  50229 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /*  50233 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50238 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  50242 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  50246 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  50248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50253 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  50260 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  50265 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  50270 */     // GIR_Coverage, 3280,
     /*  50270 */     GIR_EraseRootFromParent_Done,
     /*  50271 */   // Label 619: @50271
     /*  50271 */   GIM_Try, /*On fail goto*//*Label 620*/ GIMT_Encode4(50351), // Rule ID 3296 //
     /*  50276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  50279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  50287 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /*  50291 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /*  50295 */     // MIs[1] Operand 1
     /*  50295 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /*  50300 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  50304 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50306 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETULE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_gt:{ *:[i32] })
     /*  50306 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  50309 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /*  50313 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50318 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  50322 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  50326 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  50328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50333 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  50340 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  50345 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  50350 */     // GIR_Coverage, 3296,
     /*  50350 */     GIR_EraseRootFromParent_Done,
     /*  50351 */   // Label 620: @50351
     /*  50351 */   GIM_Try, /*On fail goto*//*Label 621*/ GIMT_Encode4(50431), // Rule ID 3312 //
     /*  50356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  50359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  50367 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /*  50371 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /*  50375 */     // MIs[1] Operand 1
     /*  50375 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /*  50380 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  50384 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50386 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUNE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_eq:{ *:[i32] })
     /*  50386 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  50389 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /*  50393 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50398 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  50402 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  50406 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  50408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50413 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  50420 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  50425 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  50430 */     // GIR_Coverage, 3312,
     /*  50430 */     GIR_EraseRootFromParent_Done,
     /*  50431 */   // Label 621: @50431
     /*  50431 */   GIM_Try, /*On fail goto*//*Label 622*/ GIMT_Encode4(50511), // Rule ID 3328 //
     /*  50436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  50439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  50447 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /*  50451 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /*  50455 */     // MIs[1] Operand 1
     /*  50455 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /*  50460 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  50464 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50466 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETO:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_un:{ *:[i32] })
     /*  50466 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  50469 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /*  50473 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50478 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  50482 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  50486 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  50488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50493 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /*  50500 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  50505 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  50510 */     // GIR_Coverage, 3328,
     /*  50510 */     GIR_EraseRootFromParent_Done,
     /*  50511 */   // Label 622: @50511
     /*  50511 */   GIM_Try, /*On fail goto*//*Label 623*/ GIMT_Encode4(50591), // Rule ID 3978 //
     /*  50516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  50519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  50527 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  50531 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  50535 */     // MIs[1] Operand 1
     /*  50535 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /*  50540 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  50544 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50546 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_lt:{ *:[i32] })
     /*  50546 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  50549 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /*  50553 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50558 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  50562 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  50566 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  50568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50573 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  50580 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  50585 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  50590 */     // GIR_Coverage, 3978,
     /*  50590 */     GIR_EraseRootFromParent_Done,
     /*  50591 */   // Label 623: @50591
     /*  50591 */   GIM_Try, /*On fail goto*//*Label 624*/ GIMT_Encode4(50671), // Rule ID 4010 //
     /*  50596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  50599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  50607 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  50611 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  50615 */     // MIs[1] Operand 1
     /*  50615 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /*  50620 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  50624 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50626 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] })
     /*  50626 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  50629 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /*  50633 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50638 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  50642 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  50646 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  50648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50653 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  50660 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  50665 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  50670 */     // GIR_Coverage, 4010,
     /*  50670 */     GIR_EraseRootFromParent_Done,
     /*  50671 */   // Label 624: @50671
     /*  50671 */   GIM_Try, /*On fail goto*//*Label 625*/ GIMT_Encode4(50751), // Rule ID 4042 //
     /*  50676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  50679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  50687 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  50691 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  50695 */     // MIs[1] Operand 1
     /*  50695 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /*  50700 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  50704 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50706 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_eq:{ *:[i32] })
     /*  50706 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  50709 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /*  50713 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50718 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  50722 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  50726 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  50728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50733 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  50740 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  50745 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  50750 */     // GIR_Coverage, 4042,
     /*  50750 */     GIR_EraseRootFromParent_Done,
     /*  50751 */   // Label 625: @50751
     /*  50751 */   GIM_Try, /*On fail goto*//*Label 626*/ GIMT_Encode4(50831), // Rule ID 4074 //
     /*  50756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  50759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  50767 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  50771 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  50775 */     // MIs[1] Operand 1
     /*  50775 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /*  50780 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  50784 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50786 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETO:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_un:{ *:[i32] })
     /*  50786 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  50789 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /*  50793 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50798 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  50802 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  50806 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  50808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50813 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /*  50820 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  50825 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  50830 */     // GIR_Coverage, 4074,
     /*  50830 */     GIR_EraseRootFromParent_Done,
     /*  50831 */   // Label 626: @50831
     /*  50831 */   GIM_Try, /*On fail goto*//*Label 627*/ GIMT_Encode4(50911), // Rule ID 4090 //
     /*  50836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  50839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  50847 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  50851 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  50855 */     // MIs[1] Operand 1
     /*  50855 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /*  50860 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  50864 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50866 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_lt:{ *:[i32] })
     /*  50866 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  50869 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /*  50873 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50878 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  50882 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  50886 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  50888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50893 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  50900 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  50905 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  50910 */     // GIR_Coverage, 4090,
     /*  50910 */     GIR_EraseRootFromParent_Done,
     /*  50911 */   // Label 627: @50911
     /*  50911 */   GIM_Try, /*On fail goto*//*Label 628*/ GIMT_Encode4(50991), // Rule ID 4122 //
     /*  50916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  50919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  50927 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  50931 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  50935 */     // MIs[1] Operand 1
     /*  50935 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /*  50940 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  50944 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50946 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] })
     /*  50946 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  50949 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /*  50953 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50958 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  50962 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  50966 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  50968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50973 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  50980 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  50985 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  50990 */     // GIR_Coverage, 4122,
     /*  50990 */     GIR_EraseRootFromParent_Done,
     /*  50991 */   // Label 628: @50991
     /*  50991 */   GIM_Try, /*On fail goto*//*Label 629*/ GIMT_Encode4(51071), // Rule ID 4154 //
     /*  50996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  50999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  51007 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  51011 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  51015 */     // MIs[1] Operand 1
     /*  51015 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /*  51020 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  51024 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51026 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_eq:{ *:[i32] })
     /*  51026 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51029 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /*  51033 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51038 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  51042 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  51046 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51053 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  51060 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  51065 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  51070 */     // GIR_Coverage, 4154,
     /*  51070 */     GIR_EraseRootFromParent_Done,
     /*  51071 */   // Label 629: @51071
     /*  51071 */   GIM_Try, /*On fail goto*//*Label 630*/ GIMT_Encode4(51151), // Rule ID 4186 //
     /*  51076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  51079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  51087 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  51091 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  51095 */     // MIs[1] Operand 1
     /*  51095 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /*  51100 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  51104 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51106 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETO:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_un:{ *:[i32] })
     /*  51106 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51109 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /*  51113 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51118 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  51122 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  51126 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51133 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /*  51140 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  51145 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  51150 */     // GIR_Coverage, 4186,
     /*  51150 */     GIR_EraseRootFromParent_Done,
     /*  51151 */   // Label 630: @51151
     /*  51151 */   GIM_Try, /*On fail goto*//*Label 631*/ GIMT_Encode4(51231), // Rule ID 4216 //
     /*  51156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  51159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  51167 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /*  51171 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /*  51175 */     // MIs[1] Operand 1
     /*  51175 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /*  51180 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  51184 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51186 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_lt:{ *:[i32] })
     /*  51186 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51189 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /*  51193 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51198 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  51202 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  51206 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51213 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  51220 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  51225 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  51230 */     // GIR_Coverage, 4216,
     /*  51230 */     GIR_EraseRootFromParent_Done,
     /*  51231 */   // Label 631: @51231
     /*  51231 */   GIM_Try, /*On fail goto*//*Label 632*/ GIMT_Encode4(51311), // Rule ID 4248 //
     /*  51236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  51239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  51247 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /*  51251 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /*  51255 */     // MIs[1] Operand 1
     /*  51255 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /*  51260 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  51264 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51266 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETULE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_gt:{ *:[i32] })
     /*  51266 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51269 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /*  51273 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51278 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  51282 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  51286 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51293 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  51300 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  51305 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  51310 */     // GIR_Coverage, 4248,
     /*  51310 */     GIR_EraseRootFromParent_Done,
     /*  51311 */   // Label 632: @51311
     /*  51311 */   GIM_Try, /*On fail goto*//*Label 633*/ GIMT_Encode4(51391), // Rule ID 4280 //
     /*  51316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  51319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  51327 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /*  51331 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /*  51335 */     // MIs[1] Operand 1
     /*  51335 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /*  51340 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  51344 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51346 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUNE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_eq:{ *:[i32] })
     /*  51346 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51349 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /*  51353 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51358 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  51362 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  51366 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51373 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  51380 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  51385 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  51390 */     // GIR_Coverage, 4280,
     /*  51390 */     GIR_EraseRootFromParent_Done,
     /*  51391 */   // Label 633: @51391
     /*  51391 */   GIM_Try, /*On fail goto*//*Label 634*/ GIMT_Encode4(51471), // Rule ID 4312 //
     /*  51396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  51399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  51407 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /*  51411 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /*  51415 */     // MIs[1] Operand 1
     /*  51415 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /*  51420 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  51424 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51426 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETO:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_un:{ *:[i32] })
     /*  51426 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51429 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /*  51433 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51438 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  51442 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  51446 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51453 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /*  51460 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  51465 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  51470 */     // GIR_Coverage, 4312,
     /*  51470 */     GIR_EraseRootFromParent_Done,
     /*  51471 */   // Label 634: @51471
     /*  51471 */   GIM_Try, /*On fail goto*//*Label 635*/ GIMT_Encode4(51551), // Rule ID 4543 //
     /*  51476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /*  51479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  51487 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  51491 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  51495 */     // MIs[1] Operand 1
     /*  51495 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /*  51500 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  51504 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51506 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPLT:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] })
     /*  51506 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51509 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::EFSCMPLT),
     /*  51513 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51518 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  51522 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  51526 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51533 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  51540 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  51545 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  51550 */     // GIR_Coverage, 4543,
     /*  51550 */     GIR_EraseRootFromParent_Done,
     /*  51551 */   // Label 635: @51551
     /*  51551 */   GIM_Try, /*On fail goto*//*Label 636*/ GIMT_Encode4(51631), // Rule ID 4575 //
     /*  51556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /*  51559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  51567 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  51571 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  51575 */     // MIs[1] Operand 1
     /*  51575 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /*  51580 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  51584 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51586 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPGT:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] })
     /*  51586 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51589 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::EFSCMPGT),
     /*  51593 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51598 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  51602 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  51606 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51613 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  51620 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  51625 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  51630 */     // GIR_Coverage, 4575,
     /*  51630 */     GIR_EraseRootFromParent_Done,
     /*  51631 */   // Label 636: @51631
     /*  51631 */   GIM_Try, /*On fail goto*//*Label 637*/ GIMT_Encode4(51711), // Rule ID 4607 //
     /*  51636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /*  51639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  51647 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  51651 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  51655 */     // MIs[1] Operand 1
     /*  51655 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /*  51660 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  51664 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51666 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPEQ:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] })
     /*  51666 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51669 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::EFSCMPEQ),
     /*  51673 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51678 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  51682 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  51686 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51693 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  51700 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  51705 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  51710 */     // GIR_Coverage, 4607,
     /*  51710 */     GIR_EraseRootFromParent_Done,
     /*  51711 */   // Label 637: @51711
     /*  51711 */   GIM_Try, /*On fail goto*//*Label 638*/ GIMT_Encode4(51791), // Rule ID 4651 //
     /*  51716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /*  51719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  51727 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  51731 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  51735 */     // MIs[1] Operand 1
     /*  51735 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /*  51740 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  51744 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51746 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPLT:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] })
     /*  51746 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51749 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::EFDCMPLT),
     /*  51753 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51758 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  51762 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  51766 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51773 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  51780 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  51785 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  51790 */     // GIR_Coverage, 4651,
     /*  51790 */     GIR_EraseRootFromParent_Done,
     /*  51791 */   // Label 638: @51791
     /*  51791 */   GIM_Try, /*On fail goto*//*Label 639*/ GIMT_Encode4(51871), // Rule ID 4683 //
     /*  51796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /*  51799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  51807 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  51811 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  51815 */     // MIs[1] Operand 1
     /*  51815 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /*  51820 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  51824 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51826 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPGT:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] })
     /*  51826 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51829 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::EFDCMPGT),
     /*  51833 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51838 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  51842 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  51846 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51853 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  51860 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  51865 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  51870 */     // GIR_Coverage, 4683,
     /*  51870 */     GIR_EraseRootFromParent_Done,
     /*  51871 */   // Label 639: @51871
     /*  51871 */   GIM_Try, /*On fail goto*//*Label 640*/ GIMT_Encode4(51951), // Rule ID 4715 //
     /*  51876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /*  51879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  51887 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  51891 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  51895 */     // MIs[1] Operand 1
     /*  51895 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /*  51900 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  51904 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51906 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPEQ:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] })
     /*  51906 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51909 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::EFDCMPEQ),
     /*  51913 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51918 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  51922 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  51926 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51933 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  51940 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  51945 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  51950 */     // GIR_Coverage, 4715,
     /*  51950 */     GIR_EraseRootFromParent_Done,
     /*  51951 */   // Label 640: @51951
     /*  51951 */   GIM_Try, /*On fail goto*//*Label 641*/ GIMT_Encode4(52031), // Rule ID 2970 //
     /*  51956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  51959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  51967 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  51971 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  51975 */     // MIs[1] Operand 1
     /*  51975 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /*  51980 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  51984 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51986 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETUGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] })
     /*  51986 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51989 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /*  51993 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51998 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  52002 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  52006 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  52008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52013 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  52020 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  52025 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  52030 */     // GIR_Coverage, 2970,
     /*  52030 */     GIR_EraseRootFromParent_Done,
     /*  52031 */   // Label 641: @52031
     /*  52031 */   GIM_Try, /*On fail goto*//*Label 642*/ GIMT_Encode4(52111), // Rule ID 2984 //
     /*  52036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  52039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  52047 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  52051 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  52055 */     // MIs[1] Operand 1
     /*  52055 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /*  52060 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  52064 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52066 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] })
     /*  52066 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  52069 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /*  52073 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52078 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  52082 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  52086 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  52088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52093 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  52100 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  52105 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  52110 */     // GIR_Coverage, 2984,
     /*  52110 */     GIR_EraseRootFromParent_Done,
     /*  52111 */   // Label 642: @52111
     /*  52111 */   GIM_Try, /*On fail goto*//*Label 643*/ GIMT_Encode4(52191), // Rule ID 2992 //
     /*  52116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  52119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  52127 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  52131 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  52135 */     // MIs[1] Operand 1
     /*  52135 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /*  52140 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  52144 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52146 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETULE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] })
     /*  52146 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  52149 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /*  52153 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52158 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  52162 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  52166 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  52168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52173 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  52180 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  52185 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  52190 */     // GIR_Coverage, 2992,
     /*  52190 */     GIR_EraseRootFromParent_Done,
     /*  52191 */   // Label 643: @52191
     /*  52191 */   GIM_Try, /*On fail goto*//*Label 644*/ GIMT_Encode4(52271), // Rule ID 3000 //
     /*  52196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  52199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  52207 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  52211 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  52215 */     // MIs[1] Operand 1
     /*  52215 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /*  52220 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  52224 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52226 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETLE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] })
     /*  52226 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  52229 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /*  52233 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52238 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  52242 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  52246 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  52248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52253 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  52260 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  52265 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  52270 */     // GIR_Coverage, 3000,
     /*  52270 */     GIR_EraseRootFromParent_Done,
     /*  52271 */   // Label 644: @52271
     /*  52271 */   GIM_Try, /*On fail goto*//*Label 645*/ GIMT_Encode4(52351), // Rule ID 3008 //
     /*  52276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  52279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  52287 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  52291 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  52295 */     // MIs[1] Operand 1
     /*  52295 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /*  52300 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  52304 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52306 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETNE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_eq:{ *:[i32] })
     /*  52306 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  52309 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /*  52313 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52318 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  52322 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  52326 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  52328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52333 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  52340 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  52345 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  52350 */     // GIR_Coverage, 3008,
     /*  52350 */     GIR_EraseRootFromParent_Done,
     /*  52351 */   // Label 645: @52351
     /*  52351 */   GIM_Try, /*On fail goto*//*Label 646*/ GIMT_Encode4(52431), // Rule ID 3072 //
     /*  52356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  52359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  52367 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52371 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  52375 */     // MIs[1] Operand 1
     /*  52375 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /*  52380 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  52384 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52386 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETUGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] })
     /*  52386 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  52389 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /*  52393 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52398 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  52402 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  52406 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  52408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52413 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  52420 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  52425 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  52430 */     // GIR_Coverage, 3072,
     /*  52430 */     GIR_EraseRootFromParent_Done,
     /*  52431 */   // Label 646: @52431
     /*  52431 */   GIM_Try, /*On fail goto*//*Label 647*/ GIMT_Encode4(52511), // Rule ID 3080 //
     /*  52436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  52439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  52447 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52451 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  52455 */     // MIs[1] Operand 1
     /*  52455 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /*  52460 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  52464 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52466 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] })
     /*  52466 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  52469 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /*  52473 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52478 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  52482 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  52486 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  52488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52493 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  52500 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  52505 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  52510 */     // GIR_Coverage, 3080,
     /*  52510 */     GIR_EraseRootFromParent_Done,
     /*  52511 */   // Label 647: @52511
     /*  52511 */   GIM_Try, /*On fail goto*//*Label 648*/ GIMT_Encode4(52591), // Rule ID 3088 //
     /*  52516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  52519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  52527 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52531 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  52535 */     // MIs[1] Operand 1
     /*  52535 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /*  52540 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  52544 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52546 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETULE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] })
     /*  52546 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  52549 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /*  52553 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52558 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  52562 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  52566 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  52568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52573 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  52580 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  52585 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  52590 */     // GIR_Coverage, 3088,
     /*  52590 */     GIR_EraseRootFromParent_Done,
     /*  52591 */   // Label 648: @52591
     /*  52591 */   GIM_Try, /*On fail goto*//*Label 649*/ GIMT_Encode4(52671), // Rule ID 3096 //
     /*  52596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  52599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  52607 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52611 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  52615 */     // MIs[1] Operand 1
     /*  52615 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /*  52620 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  52624 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52626 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETLE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] })
     /*  52626 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  52629 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /*  52633 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52638 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  52642 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  52646 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  52648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52653 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  52660 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  52665 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  52670 */     // GIR_Coverage, 3096,
     /*  52670 */     GIR_EraseRootFromParent_Done,
     /*  52671 */   // Label 649: @52671
     /*  52671 */   GIM_Try, /*On fail goto*//*Label 650*/ GIMT_Encode4(52751), // Rule ID 3104 //
     /*  52676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  52679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  52687 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52691 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  52695 */     // MIs[1] Operand 1
     /*  52695 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /*  52700 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  52704 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52706 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETNE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_eq:{ *:[i32] })
     /*  52706 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  52709 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /*  52713 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52718 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  52722 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  52726 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  52728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52733 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  52740 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  52745 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  52750 */     // GIR_Coverage, 3104,
     /*  52750 */     GIR_EraseRootFromParent_Done,
     /*  52751 */   // Label 650: @52751
     /*  52751 */   GIM_Try, /*On fail goto*//*Label 651*/ GIMT_Encode4(52831), // Rule ID 3826 //
     /*  52756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  52759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  52767 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  52771 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  52775 */     // MIs[1] Operand 1
     /*  52775 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /*  52780 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  52784 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52786 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETUGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] })
     /*  52786 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  52789 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /*  52793 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52798 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  52802 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  52806 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  52808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52813 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  52820 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  52825 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  52830 */     // GIR_Coverage, 3826,
     /*  52830 */     GIR_EraseRootFromParent_Done,
     /*  52831 */   // Label 651: @52831
     /*  52831 */   GIM_Try, /*On fail goto*//*Label 652*/ GIMT_Encode4(52911), // Rule ID 3834 //
     /*  52836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  52839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  52847 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  52851 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  52855 */     // MIs[1] Operand 1
     /*  52855 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /*  52860 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  52864 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52866 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] })
     /*  52866 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  52869 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /*  52873 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52878 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  52882 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  52886 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  52888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52893 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  52900 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  52905 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  52910 */     // GIR_Coverage, 3834,
     /*  52910 */     GIR_EraseRootFromParent_Done,
     /*  52911 */   // Label 652: @52911
     /*  52911 */   GIM_Try, /*On fail goto*//*Label 653*/ GIMT_Encode4(52991), // Rule ID 3842 //
     /*  52916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  52919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  52927 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  52931 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  52935 */     // MIs[1] Operand 1
     /*  52935 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /*  52940 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  52944 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52946 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETULE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] })
     /*  52946 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  52949 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /*  52953 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52958 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  52962 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  52966 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  52968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52973 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  52980 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  52985 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  52990 */     // GIR_Coverage, 3842,
     /*  52990 */     GIR_EraseRootFromParent_Done,
     /*  52991 */   // Label 653: @52991
     /*  52991 */   GIM_Try, /*On fail goto*//*Label 654*/ GIMT_Encode4(53071), // Rule ID 3850 //
     /*  52996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  52999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  53007 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  53011 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  53015 */     // MIs[1] Operand 1
     /*  53015 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /*  53020 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  53024 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53026 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETLE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] })
     /*  53026 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53029 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /*  53033 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53038 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  53042 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  53046 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53053 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  53060 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  53065 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  53070 */     // GIR_Coverage, 3850,
     /*  53070 */     GIR_EraseRootFromParent_Done,
     /*  53071 */   // Label 654: @53071
     /*  53071 */   GIM_Try, /*On fail goto*//*Label 655*/ GIMT_Encode4(53151), // Rule ID 3858 //
     /*  53076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  53079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  53087 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  53091 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  53095 */     // MIs[1] Operand 1
     /*  53095 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /*  53100 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  53104 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53106 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETNE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_eq:{ *:[i32] })
     /*  53106 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53109 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /*  53113 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53118 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  53122 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  53126 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53133 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  53140 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  53145 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  53150 */     // GIR_Coverage, 3858,
     /*  53150 */     GIR_EraseRootFromParent_Done,
     /*  53151 */   // Label 655: @53151
     /*  53151 */   GIM_Try, /*On fail goto*//*Label 656*/ GIMT_Encode4(53231), // Rule ID 3922 //
     /*  53156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  53159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  53167 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  53171 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  53175 */     // MIs[1] Operand 1
     /*  53175 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /*  53180 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  53184 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53186 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETUGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] })
     /*  53186 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53189 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /*  53193 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53198 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  53202 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  53206 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53213 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  53220 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  53225 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  53230 */     // GIR_Coverage, 3922,
     /*  53230 */     GIR_EraseRootFromParent_Done,
     /*  53231 */   // Label 656: @53231
     /*  53231 */   GIM_Try, /*On fail goto*//*Label 657*/ GIMT_Encode4(53311), // Rule ID 3930 //
     /*  53236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  53239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  53247 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  53251 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  53255 */     // MIs[1] Operand 1
     /*  53255 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /*  53260 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  53264 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53266 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] })
     /*  53266 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53269 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /*  53273 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53278 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  53282 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  53286 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53293 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  53300 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  53305 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  53310 */     // GIR_Coverage, 3930,
     /*  53310 */     GIR_EraseRootFromParent_Done,
     /*  53311 */   // Label 657: @53311
     /*  53311 */   GIM_Try, /*On fail goto*//*Label 658*/ GIMT_Encode4(53391), // Rule ID 3938 //
     /*  53316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  53319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  53327 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  53331 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  53335 */     // MIs[1] Operand 1
     /*  53335 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /*  53340 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  53344 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53346 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETULE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] })
     /*  53346 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53349 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /*  53353 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53358 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  53362 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  53366 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53373 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  53380 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  53385 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  53390 */     // GIR_Coverage, 3938,
     /*  53390 */     GIR_EraseRootFromParent_Done,
     /*  53391 */   // Label 658: @53391
     /*  53391 */   GIM_Try, /*On fail goto*//*Label 659*/ GIMT_Encode4(53471), // Rule ID 3946 //
     /*  53396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  53399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  53407 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  53411 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  53415 */     // MIs[1] Operand 1
     /*  53415 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /*  53420 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  53424 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53426 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETLE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] })
     /*  53426 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53429 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /*  53433 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53438 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  53442 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  53446 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53453 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  53460 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  53465 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  53470 */     // GIR_Coverage, 3946,
     /*  53470 */     GIR_EraseRootFromParent_Done,
     /*  53471 */   // Label 659: @53471
     /*  53471 */   GIM_Try, /*On fail goto*//*Label 660*/ GIMT_Encode4(53551), // Rule ID 3954 //
     /*  53476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  53479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  53487 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  53491 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  53495 */     // MIs[1] Operand 1
     /*  53495 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /*  53500 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  53504 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53506 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETNE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_eq:{ *:[i32] })
     /*  53506 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53509 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /*  53513 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53518 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  53522 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  53526 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53533 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  53540 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  53545 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  53550 */     // GIR_Coverage, 3954,
     /*  53550 */     GIR_EraseRootFromParent_Done,
     /*  53551 */   // Label 660: @53551
     /*  53551 */   GIM_Try, /*On fail goto*//*Label 661*/ GIMT_Encode4(53593), // Rule ID 176 //
     /*  53556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  53564 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /*  53568 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /*  53572 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  53576 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53578 */     // (xor:{ *:[i1] } (and:{ *:[i1] } i1:{ *:[i1] }:$CRA, i1:{ *:[i1] }:$CRB), -1:{ *:[i1] })  =>  (CRNAND:{ *:[i1] } i1:{ *:[i1] }:$CRA, i1:{ *:[i1] }:$CRB)
     /*  53578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNAND),
     /*  53581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /*  53583 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // CRA
     /*  53587 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // CRB
     /*  53591 */     GIR_RootConstrainSelectedInstOperands,
     /*  53592 */     // GIR_Coverage, 176,
     /*  53592 */     GIR_EraseRootFromParent_Done,
     /*  53593 */   // Label 661: @53593
     /*  53593 */   GIM_Try, /*On fail goto*//*Label 662*/ GIMT_Encode4(53635), // Rule ID 179 //
     /*  53598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  53606 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /*  53610 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /*  53614 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  53618 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53620 */     // (xor:{ *:[i1] } (or:{ *:[i1] } i1:{ *:[i1] }:$CRA, i1:{ *:[i1] }:$CRB), -1:{ *:[i1] })  =>  (CRNOR:{ *:[i1] } i1:{ *:[i1] }:$CRA, i1:{ *:[i1] }:$CRB)
     /*  53620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOR),
     /*  53623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /*  53625 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // CRA
     /*  53629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // CRB
     /*  53633 */     GIR_RootConstrainSelectedInstOperands,
     /*  53634 */     // GIR_Coverage, 179,
     /*  53634 */     GIR_EraseRootFromParent_Done,
     /*  53635 */   // Label 662: @53635
     /*  53635 */   GIM_Try, /*On fail goto*//*Label 663*/ GIMT_Encode4(53675), // Rule ID 4875 //
     /*  53640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53644 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53648 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /*  53652 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /*  53656 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  53660 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53662 */     // (xor:{ *:[i1] } (xor:{ *:[i1] } i1:{ *:[i1] }:$CRA, -1:{ *:[i1] }), i1:{ *:[i1] }:$CRB)  =>  (CREQV:{ *:[i1] } i1:{ *:[i1] }:$CRA, i1:{ *:[i1] }:$CRB)
     /*  53662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CREQV),
     /*  53665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /*  53667 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // CRA
     /*  53671 */     GIR_RootToRootCopy, /*OpIdx*/2, // CRB
     /*  53673 */     GIR_RootConstrainSelectedInstOperands,
     /*  53674 */     // GIR_Coverage, 4875,
     /*  53674 */     GIR_EraseRootFromParent_Done,
     /*  53675 */   // Label 663: @53675
     /*  53675 */   GIM_Try, /*On fail goto*//*Label 664*/ GIMT_Encode4(53717), // Rule ID 180 //
     /*  53680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53688 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /*  53692 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /*  53696 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  53700 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53702 */     // (xor:{ *:[i1] } (xor:{ *:[i1] } i1:{ *:[i1] }:$CRA, i1:{ *:[i1] }:$CRB), -1:{ *:[i1] })  =>  (CREQV:{ *:[i1] } i1:{ *:[i1] }:$CRA, i1:{ *:[i1] }:$CRB)
     /*  53702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CREQV),
     /*  53705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /*  53707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // CRA
     /*  53711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // CRB
     /*  53715 */     GIR_RootConstrainSelectedInstOperands,
     /*  53716 */     // GIR_Coverage, 180,
     /*  53716 */     GIR_EraseRootFromParent_Done,
     /*  53717 */   // Label 664: @53717
     /*  53717 */   GIM_Try, /*On fail goto*//*Label 665*/ GIMT_Encode4(53754), // Rule ID 4815 //
     /*  53722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  53730 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  53734 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  53738 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53740 */     // (xor:{ *:[i1] } (trunc:{ *:[i1] } i32:{ *:[i32] }:$in), -1:{ *:[i1] })  =>  (ANDI_rec_1_EQ_BIT:{ *:[i1] }:{ *:[i32] } ?:{ *:[i32] }:$in)
     /*  53740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::ANDI_rec_1_EQ_BIT),
     /*  53743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53745 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // in
     /*  53749 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CR0*/0,
     /*  53752 */     GIR_RootConstrainSelectedInstOperands,
     /*  53753 */     // GIR_Coverage, 4815,
     /*  53753 */     GIR_EraseRootFromParent_Done,
     /*  53754 */   // Label 665: @53754
     /*  53754 */   GIM_Try, /*On fail goto*//*Label 666*/ GIMT_Encode4(53791), // Rule ID 4816 //
     /*  53759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  53767 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  53771 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  53775 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53777 */     // (xor:{ *:[i1] } (trunc:{ *:[i1] } i64:{ *:[i64] }:$in), -1:{ *:[i1] })  =>  (ANDI_rec_1_EQ_BIT8:{ *:[i1] }:{ *:[i32] } ?:{ *:[i64] }:$in)
     /*  53777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::ANDI_rec_1_EQ_BIT8),
     /*  53780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53782 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // in
     /*  53786 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CR0*/0,
     /*  53789 */     GIR_RootConstrainSelectedInstOperands,
     /*  53790 */     // GIR_Coverage, 4816,
     /*  53790 */     GIR_EraseRootFromParent_Done,
     /*  53791 */   // Label 666: @53791
     /*  53791 */   GIM_Try, /*On fail goto*//*Label 667*/ GIMT_Encode4(53831), // Rule ID 4876 //
     /*  53796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53804 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /*  53808 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /*  53812 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  53816 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53818 */     // (xor:{ *:[i1] } i1:{ *:[i1] }:$CRB, (xor:{ *:[i1] } i1:{ *:[i1] }:$CRA, -1:{ *:[i1] }))  =>  (CREQV:{ *:[i1] } i1:{ *:[i1] }:$CRA, i1:{ *:[i1] }:$CRB)
     /*  53818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CREQV),
     /*  53821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /*  53823 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // CRA
     /*  53827 */     GIR_RootToRootCopy, /*OpIdx*/1, // CRB
     /*  53829 */     GIR_RootConstrainSelectedInstOperands,
     /*  53830 */     // GIR_Coverage, 4876,
     /*  53830 */     GIR_EraseRootFromParent_Done,
     /*  53831 */   // Label 667: @53831
     /*  53831 */   GIM_Try, /*On fail goto*//*Label 668*/ GIMT_Encode4(53849), // Rule ID 181 //
     /*  53836 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  53840 */     // (xor:{ *:[i1] } i1:{ *:[i1] }:$CRA, -1:{ *:[i1] })  =>  (CRNOT:{ *:[i1] } i1:{ *:[i1] }:$CRA)
     /*  53840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /*  53843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /*  53845 */     GIR_RootToRootCopy, /*OpIdx*/1, // CRA
     /*  53847 */     GIR_RootConstrainSelectedInstOperands,
     /*  53848 */     // GIR_Coverage, 181,
     /*  53848 */     GIR_EraseRootFromParent_Done,
     /*  53849 */   // Label 668: @53849
     /*  53849 */   GIM_Try, /*On fail goto*//*Label 669*/ GIMT_Encode4(53867), // Rule ID 2900 //
     /*  53854 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  53858 */     // (xor:{ *:[i1] } i1:{ *:[i1] }:$in, -1:{ *:[i1] })  =>  (CRNOT:{ *:[i1] } ?:{ *:[i1] }:$in)
     /*  53858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /*  53861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /*  53863 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /*  53865 */     GIR_RootConstrainSelectedInstOperands,
     /*  53866 */     // GIR_Coverage, 2900,
     /*  53866 */     GIR_EraseRootFromParent_Done,
     /*  53867 */   // Label 669: @53867
     /*  53867 */   GIM_Try, /*On fail goto*//*Label 670*/ GIMT_Encode4(53879), // Rule ID 178 //
     /*  53872 */     // (xor:{ *:[i1] } i1:{ *:[i1] }:$CRA, i1:{ *:[i1] }:$CRB)  =>  (CRXOR:{ *:[i1] } i1:{ *:[i1] }:$CRA, i1:{ *:[i1] }:$CRB)
     /*  53872 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::CRXOR),
     /*  53877 */     GIR_RootConstrainSelectedInstOperands,
     /*  53878 */     // GIR_Coverage, 178,
     /*  53878 */     GIR_Done,
     /*  53879 */   // Label 670: @53879
     /*  53879 */   GIM_Reject,
     /*  53880 */ // Label 598: @53880
     /*  53880 */ GIM_Reject,
     /*  53881 */ // Label 594: @53881
     /*  53881 */ GIM_Try, /*On fail goto*//*Label 671*/ GIMT_Encode4(54135),
     /*  53886 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  53889 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  53892 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  53896 */   GIM_Try, /*On fail goto*//*Label 672*/ GIMT_Encode4(53938), // Rule ID 121 //
     /*  53901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  53909 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  53913 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  53917 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  53921 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53923 */     // (xor:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$RST, i32:{ *:[i32] }:$RB), -1:{ *:[i32] })  =>  (NAND:{ *:[i32] } i32:{ *:[i32] }:$RST, i32:{ *:[i32] }:$RB)
     /*  53923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::NAND),
     /*  53926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  53928 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RST
     /*  53932 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RB
     /*  53936 */     GIR_RootConstrainSelectedInstOperands,
     /*  53937 */     // GIR_Coverage, 121,
     /*  53937 */     GIR_EraseRootFromParent_Done,
     /*  53938 */   // Label 672: @53938
     /*  53938 */   GIM_Try, /*On fail goto*//*Label 673*/ GIMT_Encode4(53980), // Rule ID 125 //
     /*  53943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  53951 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  53955 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  53959 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  53963 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53965 */     // (xor:{ *:[i32] } (or:{ *:[i32] } i32:{ *:[i32] }:$RST, i32:{ *:[i32] }:$RB), -1:{ *:[i32] })  =>  (NOR:{ *:[i32] } i32:{ *:[i32] }:$RST, i32:{ *:[i32] }:$RB)
     /*  53965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /*  53968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  53970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RST
     /*  53974 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RB
     /*  53978 */     GIR_RootConstrainSelectedInstOperands,
     /*  53979 */     // GIR_Coverage, 125,
     /*  53979 */     GIR_EraseRootFromParent_Done,
     /*  53980 */   // Label 673: @53980
     /*  53980 */   GIM_Try, /*On fail goto*//*Label 674*/ GIMT_Encode4(54020), // Rule ID 4873 //
     /*  53985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53993 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  53997 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  54001 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  54005 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54007 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } i32:{ *:[i32] }:$RST, -1:{ *:[i32] }), i32:{ *:[i32] }:$RB)  =>  (EQV:{ *:[i32] } i32:{ *:[i32] }:$RST, i32:{ *:[i32] }:$RB)
     /*  54007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::EQV),
     /*  54010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  54012 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RST
     /*  54016 */     GIR_RootToRootCopy, /*OpIdx*/2, // RB
     /*  54018 */     GIR_RootConstrainSelectedInstOperands,
     /*  54019 */     // GIR_Coverage, 4873,
     /*  54019 */     GIR_EraseRootFromParent_Done,
     /*  54020 */   // Label 674: @54020
     /*  54020 */   GIM_Try, /*On fail goto*//*Label 675*/ GIMT_Encode4(54062), // Rule ID 127 //
     /*  54025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  54037 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  54041 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  54045 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54047 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } i32:{ *:[i32] }:$RST, i32:{ *:[i32] }:$RB), -1:{ *:[i32] })  =>  (EQV:{ *:[i32] } i32:{ *:[i32] }:$RST, i32:{ *:[i32] }:$RB)
     /*  54047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::EQV),
     /*  54050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  54052 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RST
     /*  54056 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RB
     /*  54060 */     GIR_RootConstrainSelectedInstOperands,
     /*  54061 */     // GIR_Coverage, 127,
     /*  54061 */     GIR_EraseRootFromParent_Done,
     /*  54062 */   // Label 675: @54062
     /*  54062 */   GIM_Try, /*On fail goto*//*Label 676*/ GIMT_Encode4(54102), // Rule ID 4874 //
     /*  54067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  54071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54075 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  54079 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  54083 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  54087 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54089 */     // (xor:{ *:[i32] } i32:{ *:[i32] }:$RB, (xor:{ *:[i32] } i32:{ *:[i32] }:$RST, -1:{ *:[i32] }))  =>  (EQV:{ *:[i32] } i32:{ *:[i32] }:$RST, i32:{ *:[i32] }:$RB)
     /*  54089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::EQV),
     /*  54092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  54094 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RST
     /*  54098 */     GIR_RootToRootCopy, /*OpIdx*/1, // RB
     /*  54100 */     GIR_RootConstrainSelectedInstOperands,
     /*  54101 */     // GIR_Coverage, 4874,
     /*  54101 */     GIR_EraseRootFromParent_Done,
     /*  54102 */   // Label 676: @54102
     /*  54102 */   GIM_Try, /*On fail goto*//*Label 677*/ GIMT_Encode4(54122), // Rule ID 1207 //
     /*  54107 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  54111 */     // (xor:{ *:[i32] } i32:{ *:[i32] }:$in, -1:{ *:[i32] })  =>  (NOR:{ *:[i32] } ?:{ *:[i32] }:$in, ?:{ *:[i32] }:$in)
     /*  54111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /*  54114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  54116 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /*  54118 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /*  54120 */     GIR_RootConstrainSelectedInstOperands,
     /*  54121 */     // GIR_Coverage, 1207,
     /*  54121 */     GIR_EraseRootFromParent_Done,
     /*  54122 */   // Label 677: @54122
     /*  54122 */   GIM_Try, /*On fail goto*//*Label 678*/ GIMT_Encode4(54134), // Rule ID 128 //
     /*  54127 */     // (xor:{ *:[i32] } i32:{ *:[i32] }:$RST, i32:{ *:[i32] }:$RB)  =>  (XOR:{ *:[i32] } i32:{ *:[i32] }:$RST, i32:{ *:[i32] }:$RB)
     /*  54127 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XOR),
     /*  54132 */     GIR_RootConstrainSelectedInstOperands,
     /*  54133 */     // GIR_Coverage, 128,
     /*  54133 */     GIR_Done,
     /*  54134 */   // Label 678: @54134
     /*  54134 */   GIM_Reject,
     /*  54135 */ // Label 671: @54135
     /*  54135 */ GIM_Reject,
     /*  54136 */ // Label 595: @54136
     /*  54136 */ GIM_Try, /*On fail goto*//*Label 679*/ GIMT_Encode4(54390),
     /*  54141 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  54144 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  54147 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  54151 */   GIM_Try, /*On fail goto*//*Label 680*/ GIMT_Encode4(54193), // Rule ID 641 //
     /*  54156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54160 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  54164 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  54168 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54172 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  54176 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54178 */     // (xor:{ *:[i64] } (and:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB), -1:{ *:[i64] })  =>  (NAND8:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)
     /*  54178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::NAND8),
     /*  54181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  54183 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RST
     /*  54187 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RB
     /*  54191 */     GIR_RootConstrainSelectedInstOperands,
     /*  54192 */     // GIR_Coverage, 641,
     /*  54192 */     GIR_EraseRootFromParent_Done,
     /*  54193 */   // Label 680: @54193
     /*  54193 */   GIM_Try, /*On fail goto*//*Label 681*/ GIMT_Encode4(54235), // Rule ID 645 //
     /*  54198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  54206 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  54210 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54214 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  54218 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54220 */     // (xor:{ *:[i64] } (or:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB), -1:{ *:[i64] })  =>  (NOR8:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)
     /*  54220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /*  54223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  54225 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RST
     /*  54229 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RB
     /*  54233 */     GIR_RootConstrainSelectedInstOperands,
     /*  54234 */     // GIR_Coverage, 645,
     /*  54234 */     GIR_EraseRootFromParent_Done,
     /*  54235 */   // Label 681: @54235
     /*  54235 */   GIM_Try, /*On fail goto*//*Label 682*/ GIMT_Encode4(54275), // Rule ID 4886 //
     /*  54240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54248 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  54252 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54256 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  54260 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54262 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } i64:{ *:[i64] }:$RST, -1:{ *:[i64] }), i64:{ *:[i64] }:$RB)  =>  (EQV8:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)
     /*  54262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::EQV8),
     /*  54265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  54267 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RST
     /*  54271 */     GIR_RootToRootCopy, /*OpIdx*/2, // RB
     /*  54273 */     GIR_RootConstrainSelectedInstOperands,
     /*  54274 */     // GIR_Coverage, 4886,
     /*  54274 */     GIR_EraseRootFromParent_Done,
     /*  54275 */   // Label 682: @54275
     /*  54275 */   GIM_Try, /*On fail goto*//*Label 683*/ GIMT_Encode4(54317), // Rule ID 647 //
     /*  54280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54288 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  54292 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54296 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  54300 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54302 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB), -1:{ *:[i64] })  =>  (EQV8:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)
     /*  54302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::EQV8),
     /*  54305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  54307 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RST
     /*  54311 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RB
     /*  54315 */     GIR_RootConstrainSelectedInstOperands,
     /*  54316 */     // GIR_Coverage, 647,
     /*  54316 */     GIR_EraseRootFromParent_Done,
     /*  54317 */   // Label 683: @54317
     /*  54317 */   GIM_Try, /*On fail goto*//*Label 684*/ GIMT_Encode4(54357), // Rule ID 4887 //
     /*  54322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  54326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54330 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  54334 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54338 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  54342 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54344 */     // (xor:{ *:[i64] } i64:{ *:[i64] }:$RB, (xor:{ *:[i64] } i64:{ *:[i64] }:$RST, -1:{ *:[i64] }))  =>  (EQV8:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)
     /*  54344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::EQV8),
     /*  54347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  54349 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RST
     /*  54353 */     GIR_RootToRootCopy, /*OpIdx*/1, // RB
     /*  54355 */     GIR_RootConstrainSelectedInstOperands,
     /*  54356 */     // GIR_Coverage, 4887,
     /*  54356 */     GIR_EraseRootFromParent_Done,
     /*  54357 */   // Label 684: @54357
     /*  54357 */   GIM_Try, /*On fail goto*//*Label 685*/ GIMT_Encode4(54377), // Rule ID 1519 //
     /*  54362 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  54366 */     // (xor:{ *:[i64] } i64:{ *:[i64] }:$in, -1:{ *:[i64] })  =>  (NOR8:{ *:[i64] } ?:{ *:[i64] }:$in, ?:{ *:[i64] }:$in)
     /*  54366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /*  54369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  54371 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /*  54373 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /*  54375 */     GIR_RootConstrainSelectedInstOperands,
     /*  54376 */     // GIR_Coverage, 1519,
     /*  54376 */     GIR_EraseRootFromParent_Done,
     /*  54377 */   // Label 685: @54377
     /*  54377 */   GIM_Try, /*On fail goto*//*Label 686*/ GIMT_Encode4(54389), // Rule ID 648 //
     /*  54382 */     // (xor:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)  =>  (XOR8:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)
     /*  54382 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XOR8),
     /*  54387 */     GIR_RootConstrainSelectedInstOperands,
     /*  54388 */     // GIR_Coverage, 648,
     /*  54388 */     GIR_Done,
     /*  54389 */   // Label 686: @54389
     /*  54389 */   GIM_Reject,
     /*  54390 */ // Label 679: @54390
     /*  54390 */ GIM_Reject,
     /*  54391 */ // Label 596: @54391
     /*  54391 */ GIM_Try, /*On fail goto*//*Label 687*/ GIMT_Encode4(57514),
     /*  54396 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  54399 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  54402 */   GIM_Try, /*On fail goto*//*Label 688*/ GIMT_Encode4(54489), // Rule ID 4922 //
     /*  54407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  54410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  54414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  54422 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  54426 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  54430 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  54434 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  54438 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  54442 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  54446 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  54450 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  54456 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  54458 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  54460 */     // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] })  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 254:{ *:[i32] })
     /*  54460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  54463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  54465 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  54469 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  54473 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  54477 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(254),
     /*  54487 */     GIR_RootConstrainSelectedInstOperands,
     /*  54488 */     // GIR_Coverage, 4922,
     /*  54488 */     GIR_EraseRootFromParent_Done,
     /*  54489 */   // Label 688: @54489
     /*  54489 */   GIM_Try, /*On fail goto*//*Label 689*/ GIMT_Encode4(54576), // Rule ID 4924 //
     /*  54494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  54497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  54501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  54509 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  54513 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  54517 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  54521 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  54525 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  54529 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  54533 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  54537 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  54543 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  54545 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  54547 */     // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] })  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 248:{ *:[i32] })
     /*  54547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  54550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  54552 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  54556 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  54560 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  54564 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(248),
     /*  54574 */     GIR_RootConstrainSelectedInstOperands,
     /*  54575 */     // GIR_Coverage, 4924,
     /*  54575 */     GIR_EraseRootFromParent_Done,
     /*  54576 */   // Label 689: @54576
     /*  54576 */   GIM_Try, /*On fail goto*//*Label 690*/ GIMT_Encode4(54663), // Rule ID 4923 //
     /*  54581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  54584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  54588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  54596 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  54600 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  54604 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  54608 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54612 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  54616 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  54620 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  54624 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  54630 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  54632 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  54634 */     // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] })  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 249:{ *:[i32] })
     /*  54634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  54637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  54639 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  54643 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  54647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  54651 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(249),
     /*  54661 */     GIR_RootConstrainSelectedInstOperands,
     /*  54662 */     // GIR_Coverage, 4923,
     /*  54662 */     GIR_EraseRootFromParent_Done,
     /*  54663 */   // Label 690: @54663
     /*  54663 */   GIM_Try, /*On fail goto*//*Label 691*/ GIMT_Encode4(54750), // Rule ID 3382 //
     /*  54668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  54671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  54675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  54683 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  54687 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  54691 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54695 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  54699 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  54703 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  54707 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  54711 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  54717 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  54719 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  54721 */     // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] })  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 254:{ *:[i32] })
     /*  54721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  54724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  54726 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  54730 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  54734 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  54738 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(254),
     /*  54748 */     GIR_RootConstrainSelectedInstOperands,
     /*  54749 */     // GIR_Coverage, 3382,
     /*  54749 */     GIR_EraseRootFromParent_Done,
     /*  54750 */   // Label 691: @54750
     /*  54750 */   GIM_Try, /*On fail goto*//*Label 692*/ GIMT_Encode4(54837), // Rule ID 3384 //
     /*  54755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  54758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  54762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  54770 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  54774 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  54778 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54782 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  54786 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  54790 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  54794 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  54798 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  54804 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  54806 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  54808 */     // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] })  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 248:{ *:[i32] })
     /*  54808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  54811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  54813 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  54817 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  54821 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  54825 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(248),
     /*  54835 */     GIR_RootConstrainSelectedInstOperands,
     /*  54836 */     // GIR_Coverage, 3384,
     /*  54836 */     GIR_EraseRootFromParent_Done,
     /*  54837 */   // Label 692: @54837
     /*  54837 */   GIM_Try, /*On fail goto*//*Label 693*/ GIMT_Encode4(54924), // Rule ID 3383 //
     /*  54842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  54845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  54849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  54857 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  54861 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  54865 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54869 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54873 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  54877 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  54881 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  54885 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  54891 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  54893 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  54895 */     // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] })  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 249:{ *:[i32] })
     /*  54895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  54898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  54900 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  54904 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  54908 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  54912 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(249),
     /*  54922 */     GIR_RootConstrainSelectedInstOperands,
     /*  54923 */     // GIR_Coverage, 3383,
     /*  54923 */     GIR_EraseRootFromParent_Done,
     /*  54924 */   // Label 693: @54924
     /*  54924 */   GIM_Try, /*On fail goto*//*Label 694*/ GIMT_Encode4(55011), // Rule ID 5222 //
     /*  54929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  54932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  54936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  54944 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  54948 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  54952 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  54956 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54960 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  54964 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  54968 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  54972 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  54978 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  54980 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  54982 */     // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 225:{ *:[i32] })
     /*  54982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  54985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  54987 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  54991 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  54995 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  54999 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(225),
     /*  55009 */     GIR_RootConstrainSelectedInstOperands,
     /*  55010 */     // GIR_Coverage, 5222,
     /*  55010 */     GIR_EraseRootFromParent_Done,
     /*  55011 */   // Label 694: @55011
     /*  55011 */   GIM_Try, /*On fail goto*//*Label 695*/ GIMT_Encode4(55098), // Rule ID 5230 //
     /*  55016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  55019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  55023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  55031 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55035 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55039 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  55043 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  55047 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55051 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55055 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  55059 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55065 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  55067 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  55069 */     // (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] })  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 224:{ *:[i32] })
     /*  55069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  55072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  55074 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  55078 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  55082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  55086 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(224),
     /*  55096 */     GIR_RootConstrainSelectedInstOperands,
     /*  55097 */     // GIR_Coverage, 5230,
     /*  55097 */     GIR_EraseRootFromParent_Done,
     /*  55098 */   // Label 695: @55098
     /*  55098 */   GIM_Try, /*On fail goto*//*Label 696*/ GIMT_Encode4(55185), // Rule ID 5229 //
     /*  55103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  55106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  55110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  55118 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55122 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55126 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  55130 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  55134 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55138 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55142 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  55146 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55152 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  55154 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  55156 */     // (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] })  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 128:{ *:[i32] })
     /*  55156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  55159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  55161 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  55165 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  55169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  55173 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(128),
     /*  55183 */     GIR_RootConstrainSelectedInstOperands,
     /*  55184 */     // GIR_Coverage, 5229,
     /*  55184 */     GIR_EraseRootFromParent_Done,
     /*  55185 */   // Label 696: @55185
     /*  55185 */   GIM_Try, /*On fail goto*//*Label 697*/ GIMT_Encode4(55272), // Rule ID 5238 //
     /*  55190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  55193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  55197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  55205 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55209 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55213 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  55217 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55221 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55225 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55229 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  55233 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55239 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  55241 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  55243 */     // (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] })  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 144:{ *:[i32] })
     /*  55243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  55246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  55248 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  55252 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  55256 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  55260 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(144),
     /*  55270 */     GIR_RootConstrainSelectedInstOperands,
     /*  55271 */     // GIR_Coverage, 5238,
     /*  55271 */     GIR_EraseRootFromParent_Done,
     /*  55272 */   // Label 697: @55272
     /*  55272 */   GIM_Try, /*On fail goto*//*Label 698*/ GIMT_Encode4(55359), // Rule ID 3392 //
     /*  55277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  55280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  55284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  55292 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55296 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55300 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55304 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  55308 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55312 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55316 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  55320 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55326 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  55328 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  55330 */     // (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] })  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 224:{ *:[i32] })
     /*  55330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  55333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  55335 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  55339 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  55343 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  55347 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(224),
     /*  55357 */     GIR_RootConstrainSelectedInstOperands,
     /*  55358 */     // GIR_Coverage, 3392,
     /*  55358 */     GIR_EraseRootFromParent_Done,
     /*  55359 */   // Label 698: @55359
     /*  55359 */   GIM_Try, /*On fail goto*//*Label 699*/ GIMT_Encode4(55446), // Rule ID 3391 //
     /*  55364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  55367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  55371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  55379 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55383 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55387 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55391 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  55395 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55399 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55403 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  55407 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55413 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  55415 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  55417 */     // (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] })  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 128:{ *:[i32] })
     /*  55417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  55420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  55422 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  55426 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  55430 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  55434 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(128),
     /*  55444 */     GIR_RootConstrainSelectedInstOperands,
     /*  55445 */     // GIR_Coverage, 3391,
     /*  55445 */     GIR_EraseRootFromParent_Done,
     /*  55446 */   // Label 699: @55446
     /*  55446 */   GIM_Try, /*On fail goto*//*Label 700*/ GIMT_Encode4(55533), // Rule ID 3396 //
     /*  55451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  55454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  55458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  55466 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55470 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55474 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55478 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55482 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55486 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55490 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  55494 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55500 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  55502 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  55504 */     // (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] })  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 144:{ *:[i32] })
     /*  55504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  55507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  55509 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  55513 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  55517 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  55521 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(144),
     /*  55531 */     GIR_RootConstrainSelectedInstOperands,
     /*  55532 */     // GIR_Coverage, 3396,
     /*  55532 */     GIR_EraseRootFromParent_Done,
     /*  55533 */   // Label 700: @55533
     /*  55533 */   GIM_Try, /*On fail goto*//*Label 701*/ GIMT_Encode4(55620), // Rule ID 5227 //
     /*  55538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  55541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  55545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  55553 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55557 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55561 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  55565 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55569 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55573 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55577 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  55581 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55587 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  55589 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  55591 */     // (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 135:{ *:[i32] })
     /*  55591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  55594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  55596 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  55600 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  55604 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  55608 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(135),
     /*  55618 */     GIR_RootConstrainSelectedInstOperands,
     /*  55619 */     // GIR_Coverage, 5227,
     /*  55619 */     GIR_EraseRootFromParent_Done,
     /*  55620 */   // Label 701: @55620
     /*  55620 */   GIM_Try, /*On fail goto*//*Label 702*/ GIMT_Encode4(55705), // Rule ID 5221 //
     /*  55625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  55628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  55632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55640 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55644 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55648 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  55652 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  55656 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55660 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55664 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  55668 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55674 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  55676 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  55678 */     // (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$vA)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 225:{ *:[i32] })
     /*  55678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  55681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  55683 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*  55685 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  55689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  55693 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(225),
     /*  55703 */     GIR_RootConstrainSelectedInstOperands,
     /*  55704 */     // GIR_Coverage, 5221,
     /*  55704 */     GIR_EraseRootFromParent_Done,
     /*  55705 */   // Label 702: @55705
     /*  55705 */   GIM_Try, /*On fail goto*//*Label 703*/ GIMT_Encode4(55792), // Rule ID 5219 //
     /*  55710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  55713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  55717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55725 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55729 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55733 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  55737 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  55741 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55745 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55749 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  55753 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55759 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  55761 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  55763 */     // (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] })  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 225:{ *:[i32] })
     /*  55763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  55766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  55768 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  55772 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  55776 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  55780 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(225),
     /*  55790 */     GIR_RootConstrainSelectedInstOperands,
     /*  55791 */     // GIR_Coverage, 5219,
     /*  55791 */     GIR_EraseRootFromParent_Done,
     /*  55792 */   // Label 703: @55792
     /*  55792 */   GIM_Try, /*On fail goto*//*Label 704*/ GIMT_Encode4(55877), // Rule ID 5226 //
     /*  55797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  55800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  55804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55812 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55816 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55820 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  55824 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  55828 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55832 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55836 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  55840 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55846 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  55848 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  55850 */     // (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$vA)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 135:{ *:[i32] })
     /*  55850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  55853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  55855 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*  55857 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  55861 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  55865 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(135),
     /*  55875 */     GIR_RootConstrainSelectedInstOperands,
     /*  55876 */     // GIR_Coverage, 5226,
     /*  55876 */     GIR_EraseRootFromParent_Done,
     /*  55877 */   // Label 704: @55877
     /*  55877 */   GIM_Try, /*On fail goto*//*Label 705*/ GIMT_Encode4(55964), // Rule ID 5224 //
     /*  55882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  55885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  55889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55897 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55901 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55905 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  55909 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  55913 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55917 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55921 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  55925 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55931 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  55933 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  55935 */     // (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] })  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 135:{ *:[i32] })
     /*  55935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  55938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  55940 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  55944 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  55948 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  55952 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(135),
     /*  55962 */     GIR_RootConstrainSelectedInstOperands,
     /*  55963 */     // GIR_Coverage, 5224,
     /*  55963 */     GIR_EraseRootFromParent_Done,
     /*  55964 */   // Label 705: @55964
     /*  55964 */   GIM_Try, /*On fail goto*//*Label 706*/ GIMT_Encode4(56051), // Rule ID 3389 //
     /*  55969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  55972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  55976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55984 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55988 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55992 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55996 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  56000 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56004 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56008 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  56012 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56018 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  56020 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  56022 */     // (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] })  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 225:{ *:[i32] })
     /*  56022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  56025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  56027 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  56031 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  56035 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  56039 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(225),
     /*  56049 */     GIR_RootConstrainSelectedInstOperands,
     /*  56050 */     // GIR_Coverage, 3389,
     /*  56050 */     GIR_EraseRootFromParent_Done,
     /*  56051 */   // Label 706: @56051
     /*  56051 */   GIM_Try, /*On fail goto*//*Label 707*/ GIMT_Encode4(56138), // Rule ID 3390 //
     /*  56056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  56059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  56063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56071 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56075 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56079 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56083 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  56087 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56091 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56095 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  56099 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56105 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  56107 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  56109 */     // (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] })  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 135:{ *:[i32] })
     /*  56109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  56112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  56114 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  56118 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  56122 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  56126 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(135),
     /*  56136 */     GIR_RootConstrainSelectedInstOperands,
     /*  56137 */     // GIR_Coverage, 3390,
     /*  56137 */     GIR_EraseRootFromParent_Done,
     /*  56138 */   // Label 707: @56138
     /*  56138 */   GIM_Try, /*On fail goto*//*Label 708*/ GIMT_Encode4(56225), // Rule ID 5220 //
     /*  56143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  56146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  56150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56158 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56162 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56166 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56170 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56176 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56178 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  56182 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  56186 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56190 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56194 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  56196 */     // (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 225:{ *:[i32] })
     /*  56196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  56199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  56201 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  56205 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  56209 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  56213 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(225),
     /*  56223 */     GIR_RootConstrainSelectedInstOperands,
     /*  56224 */     // GIR_Coverage, 5220,
     /*  56224 */     GIR_EraseRootFromParent_Done,
     /*  56225 */   // Label 708: @56225
     /*  56225 */   GIM_Try, /*On fail goto*//*Label 709*/ GIMT_Encode4(56312), // Rule ID 5225 //
     /*  56230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  56233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  56237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56245 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56249 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56253 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56257 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56263 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56265 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  56269 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  56273 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56277 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56281 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  56283 */     // (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }), (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 135:{ *:[i32] })
     /*  56283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  56286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  56288 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  56292 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  56296 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  56300 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(135),
     /*  56310 */     GIR_RootConstrainSelectedInstOperands,
     /*  56311 */     // GIR_Coverage, 5225,
     /*  56311 */     GIR_EraseRootFromParent_Done,
     /*  56312 */   // Label 709: @56312
     /*  56312 */   GIM_Try, /*On fail goto*//*Label 710*/ GIMT_Encode4(56397), // Rule ID 5223 //
     /*  56317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  56320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  56324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56332 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56336 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56340 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56344 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  56348 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56352 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56356 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  56360 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56366 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  56368 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  56370 */     // (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (xor:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 225:{ *:[i32] })
     /*  56370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  56373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  56375 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*  56377 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  56381 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  56385 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(225),
     /*  56395 */     GIR_RootConstrainSelectedInstOperands,
     /*  56396 */     // GIR_Coverage, 5223,
     /*  56396 */     GIR_EraseRootFromParent_Done,
     /*  56397 */   // Label 710: @56397
     /*  56397 */   GIM_Try, /*On fail goto*//*Label 711*/ GIMT_Encode4(56482), // Rule ID 5228 //
     /*  56402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  56405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  56409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56417 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56421 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56425 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56429 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  56433 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56437 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56441 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  56445 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56451 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  56453 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  56455 */     // (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 135:{ *:[i32] })
     /*  56455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  56458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  56460 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*  56462 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  56466 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  56470 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(135),
     /*  56480 */     GIR_RootConstrainSelectedInstOperands,
     /*  56481 */     // GIR_Coverage, 5228,
     /*  56481 */     GIR_EraseRootFromParent_Done,
     /*  56482 */   // Label 711: @56482
     /*  56482 */   GIM_Try, /*On fail goto*//*Label 712*/ GIMT_Encode4(56539), // Rule ID 940 //
     /*  56487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /*  56490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  56494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  56502 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56506 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56510 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  56514 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56520 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56522 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56524 */     // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB), immAllOnesV:{ *:[v4i32] })  =>  (XXLNAND:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB)
     /*  56524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXLNAND),
     /*  56527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  56529 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /*  56533 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // XB
     /*  56537 */     GIR_RootConstrainSelectedInstOperands,
     /*  56538 */     // GIR_Coverage, 940,
     /*  56538 */     GIR_EraseRootFromParent_Done,
     /*  56539 */   // Label 712: @56539
     /*  56539 */   GIM_Try, /*On fail goto*//*Label 713*/ GIMT_Encode4(56596), // Rule ID 930 //
     /*  56544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  56547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  56551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  56559 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56563 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56567 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  56571 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56577 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56579 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56581 */     // (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB), immAllOnesV:{ *:[v4i32] })  =>  (XXLNOR:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB)
     /*  56581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXLNOR),
     /*  56584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  56586 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /*  56590 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // XB
     /*  56594 */     GIR_RootConstrainSelectedInstOperands,
     /*  56595 */     // GIR_Coverage, 930,
     /*  56595 */     GIR_EraseRootFromParent_Done,
     /*  56596 */   // Label 713: @56596
     /*  56596 */   GIM_Try, /*On fail goto*//*Label 714*/ GIMT_Encode4(56651), // Rule ID 4893 //
     /*  56601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /*  56604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  56608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56616 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56620 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56624 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56628 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56634 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56636 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56638 */     // (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$XB)  =>  (XXLEQV:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB)
     /*  56638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXLEQV),
     /*  56641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  56643 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /*  56647 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  56649 */     GIR_RootConstrainSelectedInstOperands,
     /*  56650 */     // GIR_Coverage, 4893,
     /*  56650 */     GIR_EraseRootFromParent_Done,
     /*  56651 */   // Label 714: @56651
     /*  56651 */   GIM_Try, /*On fail goto*//*Label 715*/ GIMT_Encode4(56708), // Rule ID 939 //
     /*  56656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /*  56659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  56663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56671 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56675 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56679 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  56683 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56689 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56691 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56693 */     // (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB), immAllOnesV:{ *:[v4i32] })  =>  (XXLEQV:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB)
     /*  56693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXLEQV),
     /*  56696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  56698 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /*  56702 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // XB
     /*  56706 */     GIR_RootConstrainSelectedInstOperands,
     /*  56707 */     // GIR_Coverage, 939,
     /*  56707 */     GIR_EraseRootFromParent_Done,
     /*  56708 */   // Label 715: @56708
     /*  56708 */   GIM_Try, /*On fail goto*//*Label 716*/ GIMT_Encode4(56763), // Rule ID 4894 //
     /*  56713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /*  56716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  56720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56728 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56732 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56736 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56740 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56746 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56748 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56750 */     // (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XB, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, immAllOnesV:{ *:[v4i32] }))  =>  (XXLEQV:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB)
     /*  56750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXLEQV),
     /*  56753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  56755 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /*  56759 */     GIR_RootToRootCopy, /*OpIdx*/1, // XB
     /*  56761 */     GIR_RootConstrainSelectedInstOperands,
     /*  56762 */     // GIR_Coverage, 4894,
     /*  56762 */     GIR_EraseRootFromParent_Done,
     /*  56763 */   // Label 716: @56763
     /*  56763 */   GIM_Try, /*On fail goto*//*Label 717*/ GIMT_Encode4(56800), // Rule ID 1580 //
     /*  56768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  56771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  56775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56779 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56785 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  56787 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  56789 */     // (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$A, immAllOnesV:{ *:[v4i32] })  =>  (XXLNOR:{ *:[v4i32] } ?:{ *:[v4i32] }:$A, ?:{ *:[v4i32] }:$A)
     /*  56789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXLNOR),
     /*  56792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  56794 */     GIR_RootToRootCopy, /*OpIdx*/1, // A
     /*  56796 */     GIR_RootToRootCopy, /*OpIdx*/1, // A
     /*  56798 */     GIR_RootConstrainSelectedInstOperands,
     /*  56799 */     // GIR_Coverage, 1580,
     /*  56799 */     GIR_EraseRootFromParent_Done,
     /*  56800 */   // Label 717: @56800
     /*  56800 */   GIM_Try, /*On fail goto*//*Label 718*/ GIMT_Encode4(56850), // Rule ID 5250 //
     /*  56805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  56808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  56812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  56820 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56824 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56828 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  56830 */     // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 30:{ *:[i32] })
     /*  56830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  56833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  56835 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*  56837 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  56841 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  56845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/30,
     /*  56848 */     GIR_RootConstrainSelectedInstOperands,
     /*  56849 */     // GIR_Coverage, 5250,
     /*  56849 */     GIR_EraseRootFromParent_Done,
     /*  56850 */   // Label 718: @56850
     /*  56850 */   GIM_Try, /*On fail goto*//*Label 719*/ GIMT_Encode4(56900), // Rule ID 5251 //
     /*  56855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  56858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  56862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  56870 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56874 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56878 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  56880 */     // (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 120:{ *:[i32] })
     /*  56880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  56883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  56885 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*  56887 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  56891 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  56895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/120,
     /*  56898 */     GIR_RootConstrainSelectedInstOperands,
     /*  56899 */     // GIR_Coverage, 5251,
     /*  56899 */     GIR_EraseRootFromParent_Done,
     /*  56900 */   // Label 719: @56900
     /*  56900 */   GIM_Try, /*On fail goto*//*Label 720*/ GIMT_Encode4(56950), // Rule ID 5249 //
     /*  56905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  56908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  56912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56920 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56924 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56928 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  56930 */     // (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 105:{ *:[i32] })
     /*  56930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  56933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  56935 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  56939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*  56943 */     GIR_RootToRootCopy, /*OpIdx*/2, // vC
     /*  56945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/105,
     /*  56948 */     GIR_RootConstrainSelectedInstOperands,
     /*  56949 */     // GIR_Coverage, 5249,
     /*  56949 */     GIR_EraseRootFromParent_Done,
     /*  56950 */   // Label 720: @56950
     /*  56950 */   GIM_Try, /*On fail goto*//*Label 721*/ GIMT_Encode4(57000), // Rule ID 3404 //
     /*  56955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  56958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  56962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  56970 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56974 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56978 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  56980 */     // (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 30:{ *:[i32] })
     /*  56980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  56983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  56985 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*  56987 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  56991 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  56995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/30,
     /*  56998 */     GIR_RootConstrainSelectedInstOperands,
     /*  56999 */     // GIR_Coverage, 3404,
     /*  56999 */     GIR_EraseRootFromParent_Done,
     /*  57000 */   // Label 721: @57000
     /*  57000 */   GIM_Try, /*On fail goto*//*Label 722*/ GIMT_Encode4(57050), // Rule ID 3405 //
     /*  57005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  57008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  57012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  57020 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  57024 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  57028 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  57030 */     // (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 120:{ *:[i32] })
     /*  57030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  57033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  57035 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*  57037 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  57041 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  57045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/120,
     /*  57048 */     GIR_RootConstrainSelectedInstOperands,
     /*  57049 */     // GIR_Coverage, 3405,
     /*  57049 */     GIR_EraseRootFromParent_Done,
     /*  57050 */   // Label 722: @57050
     /*  57050 */   GIM_Try, /*On fail goto*//*Label 723*/ GIMT_Encode4(57100), // Rule ID 3403 //
     /*  57055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  57058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  57062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57070 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  57074 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  57078 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  57080 */     // (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 105:{ *:[i32] })
     /*  57080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  57083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  57085 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*  57087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  57091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  57095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/105,
     /*  57098 */     GIR_RootConstrainSelectedInstOperands,
     /*  57099 */     // GIR_Coverage, 3403,
     /*  57099 */     GIR_EraseRootFromParent_Done,
     /*  57100 */   // Label 723: @57100
     /*  57100 */   GIM_Try, /*On fail goto*//*Label 724*/ GIMT_Encode4(57119), // Rule ID 932 //
     /*  57105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  57108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  57112 */     // (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB)  =>  (XXLXOR:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB)
     /*  57112 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XXLXOR),
     /*  57117 */     GIR_RootConstrainSelectedInstOperands,
     /*  57118 */     // GIR_Coverage, 932,
     /*  57118 */     GIR_Done,
     /*  57119 */   // Label 724: @57119
     /*  57119 */   GIM_Try, /*On fail goto*//*Label 725*/ GIMT_Encode4(57176), // Rule ID 488 //
     /*  57124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  57127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  57131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  57139 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  57143 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  57147 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  57151 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  57157 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  57159 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57161 */     // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB), immAllOnesV:{ *:[v4i32] })  =>  (VNAND:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  57161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VNAND),
     /*  57164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  57166 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // VA
     /*  57170 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // VB
     /*  57174 */     GIR_RootConstrainSelectedInstOperands,
     /*  57175 */     // GIR_Coverage, 488,
     /*  57175 */     GIR_EraseRootFromParent_Done,
     /*  57176 */   // Label 725: @57176
     /*  57176 */   GIM_Try, /*On fail goto*//*Label 726*/ GIMT_Encode4(57233), // Rule ID 385 //
     /*  57181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  57184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  57188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  57196 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  57200 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  57204 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  57208 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  57214 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  57216 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57218 */     // (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB), immAllOnesV:{ *:[v4i32] })  =>  (VNOR:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  57218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VNOR),
     /*  57221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  57223 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // VA
     /*  57227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // VB
     /*  57231 */     GIR_RootConstrainSelectedInstOperands,
     /*  57232 */     // GIR_Coverage, 385,
     /*  57232 */     GIR_EraseRootFromParent_Done,
     /*  57233 */   // Label 726: @57233
     /*  57233 */   GIM_Try, /*On fail goto*//*Label 727*/ GIMT_Encode4(57290), // Rule ID 1377 //
     /*  57238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  57241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  57245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  57253 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  57257 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  57261 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  57265 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  57271 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  57273 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57275 */     // (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$A, v4i32:{ *:[v4i32] }:$B), immAllOnesV:{ *:[v4i32] })  =>  (VNOR:{ *:[v4i32] } ?:{ *:[v4i32] }:$A, ?:{ *:[v4i32] }:$B)
     /*  57275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VNOR),
     /*  57278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  57280 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // A
     /*  57284 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // B
     /*  57288 */     GIR_RootConstrainSelectedInstOperands,
     /*  57289 */     // GIR_Coverage, 1377,
     /*  57289 */     GIR_EraseRootFromParent_Done,
     /*  57290 */   // Label 727: @57290
     /*  57290 */   GIM_Try, /*On fail goto*//*Label 728*/ GIMT_Encode4(57345), // Rule ID 4881 //
     /*  57295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  57298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  57302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57310 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  57314 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  57318 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57322 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  57328 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  57330 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57332 */     // (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$VB)  =>  (VEQV:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  57332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEQV),
     /*  57335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  57337 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // VA
     /*  57341 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  57343 */     GIR_RootConstrainSelectedInstOperands,
     /*  57344 */     // GIR_Coverage, 4881,
     /*  57344 */     GIR_EraseRootFromParent_Done,
     /*  57345 */   // Label 728: @57345
     /*  57345 */   GIM_Try, /*On fail goto*//*Label 729*/ GIMT_Encode4(57402), // Rule ID 487 //
     /*  57350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  57353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  57357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57365 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  57369 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  57373 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  57377 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  57383 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  57385 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57387 */     // (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB), immAllOnesV:{ *:[v4i32] })  =>  (VEQV:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  57387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEQV),
     /*  57390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  57392 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // VA
     /*  57396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // VB
     /*  57400 */     GIR_RootConstrainSelectedInstOperands,
     /*  57401 */     // GIR_Coverage, 487,
     /*  57401 */     GIR_EraseRootFromParent_Done,
     /*  57402 */   // Label 729: @57402
     /*  57402 */   GIM_Try, /*On fail goto*//*Label 730*/ GIMT_Encode4(57457), // Rule ID 4882 //
     /*  57407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  57410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  57414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57422 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  57426 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  57430 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57434 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  57440 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  57442 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57444 */     // (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VB, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, immAllOnesV:{ *:[v4i32] }))  =>  (VEQV:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  57444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEQV),
     /*  57447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  57449 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // VA
     /*  57453 */     GIR_RootToRootCopy, /*OpIdx*/1, // VB
     /*  57455 */     GIR_RootConstrainSelectedInstOperands,
     /*  57456 */     // GIR_Coverage, 4882,
     /*  57456 */     GIR_EraseRootFromParent_Done,
     /*  57457 */   // Label 730: @57457
     /*  57457 */   GIM_Try, /*On fail goto*//*Label 731*/ GIMT_Encode4(57494), // Rule ID 1376 //
     /*  57462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  57465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  57469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57473 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  57479 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  57481 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  57483 */     // (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] })  =>  (VNOR:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vA)
     /*  57483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VNOR),
     /*  57486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  57488 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*  57490 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*  57492 */     GIR_RootConstrainSelectedInstOperands,
     /*  57493 */     // GIR_Coverage, 1376,
     /*  57493 */     GIR_EraseRootFromParent_Done,
     /*  57494 */   // Label 731: @57494
     /*  57494 */   GIM_Try, /*On fail goto*//*Label 732*/ GIMT_Encode4(57513), // Rule ID 387 //
     /*  57499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  57502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  57506 */     // (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VXOR:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  57506 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VXOR),
     /*  57511 */     GIR_RootConstrainSelectedInstOperands,
     /*  57512 */     // GIR_Coverage, 387,
     /*  57512 */     GIR_Done,
     /*  57513 */   // Label 732: @57513
     /*  57513 */   GIM_Reject,
     /*  57514 */ // Label 687: @57514
     /*  57514 */ GIM_Reject,
     /*  57515 */ // Label 597: @57515
     /*  57515 */ GIM_Reject,
     /*  57516 */ // Label 10: @57516
     /*  57516 */ GIM_Try, /*On fail goto*//*Label 733*/ GIMT_Encode4(57816),
     /*  57521 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  57524 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  57527 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  57530 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  57533 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  57537 */   GIM_Try, /*On fail goto*//*Label 734*/ GIMT_Encode4(57659), // Rule ID 2124 //
     /*  57542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX_IsBigEndian_IsPPC64_NoP9Vector),
     /*  57545 */     // (build_vector:{ *:[v2i64] } i64:{ *:[i64] }:$A, i64:{ *:[i64] }:$B)  =>  (XXPERMDI:{ *:[v2i64] } (SUBREG_TO_REG:{ *:[v4i32] } 1:{ *:[i64] }, (MTVSRD:{ *:[f64] } ?:{ *:[i64] }:$A), sub_64:{ *:[i32] }), (SUBREG_TO_REG:{ *:[v4i32] } 1:{ *:[i64] }, (MTVSRD:{ *:[f64] } ?:{ *:[i64] }:$B), sub_64:{ *:[i32] }), 0:{ *:[i32] })
     /*  57545 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /*  57548 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::MTVSRD),
     /*  57552 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  57557 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // B
     /*  57561 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  57563 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  57566 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  57570 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  57575 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /*  57578 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  57581 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  57584 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  57589 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  57594 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  57597 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::MTVSRD),
     /*  57601 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  57606 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // A
     /*  57610 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  57612 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  57615 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  57619 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  57624 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  57627 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  57630 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  57633 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  57638 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  57643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXPERMDI),
     /*  57646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  57648 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  57651 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  57654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  57657 */     GIR_RootConstrainSelectedInstOperands,
     /*  57658 */     // GIR_Coverage, 2124,
     /*  57658 */     GIR_EraseRootFromParent_Done,
     /*  57659 */   // Label 734: @57659
     /*  57659 */   GIM_Try, /*On fail goto*//*Label 735*/ GIMT_Encode4(57781), // Rule ID 2127 //
     /*  57664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX_IsLittleEndian_NoP9Vector),
     /*  57667 */     // (build_vector:{ *:[v2i64] } i64:{ *:[i64] }:$A, i64:{ *:[i64] }:$B)  =>  (XXPERMDI:{ *:[v2i64] } (SUBREG_TO_REG:{ *:[v4i32] } 1:{ *:[i64] }, (MTVSRD:{ *:[f64] } ?:{ *:[i64] }:$B), sub_64:{ *:[i32] }), (SUBREG_TO_REG:{ *:[v4i32] } 1:{ *:[i64] }, (MTVSRD:{ *:[f64] } ?:{ *:[i64] }:$A), sub_64:{ *:[i32] }), 0:{ *:[i32] })
     /*  57667 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /*  57670 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::MTVSRD),
     /*  57674 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  57679 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // A
     /*  57683 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  57685 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  57688 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  57692 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  57697 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /*  57700 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  57703 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  57706 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  57711 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  57716 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  57719 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::MTVSRD),
     /*  57723 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  57728 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // B
     /*  57732 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  57734 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  57737 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  57741 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  57746 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  57749 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  57752 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  57755 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  57760 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  57765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXPERMDI),
     /*  57768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  57770 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  57773 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  57776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  57779 */     GIR_RootConstrainSelectedInstOperands,
     /*  57780 */     // GIR_Coverage, 2127,
     /*  57780 */     GIR_EraseRootFromParent_Done,
     /*  57781 */   // Label 735: @57781
     /*  57781 */   GIM_Try, /*On fail goto*//*Label 736*/ GIMT_Encode4(57796), // Rule ID 2870 //
     /*  57786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX_IsBigEndian_IsISA3_0_IsPPC64),
     /*  57789 */     // (build_vector:{ *:[v2i64] } i64:{ *:[i64] }:$rB, i64:{ *:[i64] }:$rA)  =>  (MTVSRDD:{ *:[v2i64] } ?:{ *:[i64] }:$rB, ?:{ *:[i64] }:$rA)
     /*  57789 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::MTVSRDD),
     /*  57794 */     GIR_RootConstrainSelectedInstOperands,
     /*  57795 */     // GIR_Coverage, 2870,
     /*  57795 */     GIR_Done,
     /*  57796 */   // Label 736: @57796
     /*  57796 */   GIM_Try, /*On fail goto*//*Label 737*/ GIMT_Encode4(57815), // Rule ID 2874 //
     /*  57801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX_IsISA3_0_IsLittleEndian),
     /*  57804 */     // (build_vector:{ *:[v2i64] } i64:{ *:[i64] }:$rA, i64:{ *:[i64] }:$rB)  =>  (MTVSRDD:{ *:[v2i64] } ?:{ *:[i64] }:$rB, ?:{ *:[i64] }:$rA)
     /*  57804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTVSRDD),
     /*  57807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  57809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rB
     /*  57811 */     GIR_RootToRootCopy, /*OpIdx*/1, // rA
     /*  57813 */     GIR_RootConstrainSelectedInstOperands,
     /*  57814 */     // GIR_Coverage, 2874,
     /*  57814 */     GIR_EraseRootFromParent_Done,
     /*  57815 */   // Label 737: @57815
     /*  57815 */   GIM_Reject,
     /*  57816 */ // Label 733: @57816
     /*  57816 */ GIM_Try, /*On fail goto*//*Label 738*/ GIMT_Encode4(58341),
     /*  57821 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /*  57824 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  57827 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  57830 */   GIM_Try, /*On fail goto*//*Label 739*/ GIMT_Encode4(57881), // Rule ID 2038 //
     /*  57835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX),
     /*  57838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  57842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  57850 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immSExt5NonZero),
     /*  57854 */     // MIs[1] Operand 1
     /*  57854 */     // No operand predicates
     /*  57854 */     // MIs[0] A
     /*  57854 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  57859 */     // MIs[0] A
     /*  57859 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  57864 */     // MIs[0] A
     /*  57864 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/4, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  57869 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  57871 */     // (build_vector:{ *:[v4i32] } (imm:{ *:[i32] })<<P:Predicate_immSExt5NonZero>>:$A, (imm:{ *:[i32] })<<P:Predicate_immSExt5NonZero>>:$A, (imm:{ *:[i32] })<<P:Predicate_immSExt5NonZero>>:$A, (imm:{ *:[i32] })<<P:Predicate_immSExt5NonZero>>:$A)  =>  (VSPLTISW:{ *:[v4i32] } (imm:{ *:[i32] }):$A)
     /*  57871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSPLTISW),
     /*  57874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  57876 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // A
     /*  57879 */     GIR_RootConstrainSelectedInstOperands,
     /*  57880 */     // GIR_Coverage, 2038,
     /*  57880 */     GIR_EraseRootFromParent_Done,
     /*  57881 */   // Label 739: @57881
     /*  57881 */   GIM_Try, /*On fail goto*//*Label 740*/ GIMT_Encode4(57932), // Rule ID 3371 //
     /*  57886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  57889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  57893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  57901 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i32immNonAllOneNonZero),
     /*  57905 */     // MIs[1] Operand 1
     /*  57905 */     // No operand predicates
     /*  57905 */     // MIs[0] A
     /*  57905 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  57910 */     // MIs[0] A
     /*  57910 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  57915 */     // MIs[0] A
     /*  57915 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/4, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  57920 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  57922 */     // (build_vector:{ *:[v4i32] } (imm:{ *:[i32] })<<P:Predicate_i32immNonAllOneNonZero>>:$A, (imm:{ *:[i32] })<<P:Predicate_i32immNonAllOneNonZero>>:$A, (imm:{ *:[i32] })<<P:Predicate_i32immNonAllOneNonZero>>:$A, (imm:{ *:[i32] })<<P:Predicate_i32immNonAllOneNonZero>>:$A)  =>  (XXSPLTIW:{ *:[v4i32] } (imm:{ *:[i32] }):$A)
     /*  57922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSPLTIW),
     /*  57925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  57927 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // A
     /*  57930 */     GIR_RootConstrainSelectedInstOperands,
     /*  57931 */     // GIR_Coverage, 3371,
     /*  57931 */     GIR_EraseRootFromParent_Done,
     /*  57932 */   // Label 740: @57932
     /*  57932 */   GIM_Try, /*On fail goto*//*Label 741*/ GIMT_Encode4(58068), // Rule ID 1728 //
     /*  57937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  57940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  57943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  57946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  57949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  57953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  57961 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  57965 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  57969 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  57973 */     // MIs[2] A
     /*  57973 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  57978 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /*  57982 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  57986 */     // MIs[3] A
     /*  57986 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  57991 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/4, // MIs[4]
     /*  57995 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  57999 */     // MIs[4] A
     /*  57999 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  58004 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  58006 */     // (build_vector:{ *:[v4f32] } (fpround:{ *:[f32] } f64:{ *:[f64] }:$A), (fpround:{ *:[f32] } f64:{ *:[f64] }:$A), (fpround:{ *:[f32] } f64:{ *:[f64] }:$A), (fpround:{ *:[f32] } f64:{ *:[f64] }:$A))  =>  (XXSPLTW:{ *:[v4f32] } (SUBREG_TO_REG:{ *:[v4i32] } 1:{ *:[i64] }, (XSCVDPSP:{ *:[f64] } f64:{ *:[f64] }:$A), sub_64:{ *:[i32] }), 0:{ *:[i32] })
     /*  58006 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  58009 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCVDPSP),
     /*  58013 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58018 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // A
     /*  58022 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  58024 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  58027 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  58031 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58036 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  58039 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  58042 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  58045 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  58050 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  58055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSPLTW),
     /*  58058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  58060 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  58063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  58066 */     GIR_RootConstrainSelectedInstOperands,
     /*  58067 */     // GIR_Coverage, 1728,
     /*  58067 */     GIR_EraseRootFromParent_Done,
     /*  58068 */   // Label 741: @58068
     /*  58068 */   GIM_Try, /*On fail goto*//*Label 742*/ GIMT_Encode4(58126), // Rule ID 1729 //
     /*  58073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  58076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  58080 */     // MIs[0] A
     /*  58080 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58085 */     // MIs[0] A
     /*  58085 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58090 */     // MIs[0] A
     /*  58090 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/4, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58095 */     // (build_vector:{ *:[v4f32] } f32:{ *:[f32] }:$A, f32:{ *:[f32] }:$A, f32:{ *:[f32] }:$A, f32:{ *:[f32] }:$A)  =>  (XXSPLTW:{ *:[v4f32] } (XSCVDPSPN:{ *:[v4f32] } ?:{ *:[f32] }:$A), 0:{ *:[i32] })
     /*  58095 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  58098 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSCVDPSPN),
     /*  58102 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58107 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // A
     /*  58111 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  58113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSPLTW),
     /*  58116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  58118 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  58121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  58124 */     GIR_RootConstrainSelectedInstOperands,
     /*  58125 */     // GIR_Coverage, 1729,
     /*  58125 */     GIR_EraseRootFromParent_Done,
     /*  58126 */   // Label 742: @58126
     /*  58126 */   GIM_Try, /*On fail goto*//*Label 743*/ GIMT_Encode4(58215), // Rule ID 2126 //
     /*  58131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX_IsBigEndian_IsPPC64_NoP9Vector),
     /*  58134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  58138 */     // MIs[0] A
     /*  58138 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58143 */     // MIs[0] A
     /*  58143 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58148 */     // MIs[0] A
     /*  58148 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/4, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58153 */     // (build_vector:{ *:[v4i32] } i32:{ *:[i32] }:$A, i32:{ *:[i32] }:$A, i32:{ *:[i32] }:$A, i32:{ *:[i32] }:$A)  =>  (XXSPLTW:{ *:[v4i32] } (SUBREG_TO_REG:{ *:[v4i32] } 1:{ *:[i64] }, (MTVSRWZ:{ *:[f64] } ?:{ *:[i32] }:$A), sub_64:{ *:[i32] }), 1:{ *:[i32] })
     /*  58153 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  58156 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::MTVSRWZ),
     /*  58160 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58165 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // A
     /*  58169 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  58171 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  58174 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  58178 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58183 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  58186 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  58189 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  58192 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  58197 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  58202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSPLTW),
     /*  58205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  58207 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  58210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  58213 */     GIR_RootConstrainSelectedInstOperands,
     /*  58214 */     // GIR_Coverage, 2126,
     /*  58214 */     GIR_EraseRootFromParent_Done,
     /*  58215 */   // Label 743: @58215
     /*  58215 */   GIM_Try, /*On fail goto*//*Label 744*/ GIMT_Encode4(58304), // Rule ID 2129 //
     /*  58220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX_IsLittleEndian_NoP9Vector),
     /*  58223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  58227 */     // MIs[0] A
     /*  58227 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58232 */     // MIs[0] A
     /*  58232 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58237 */     // MIs[0] A
     /*  58237 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/4, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58242 */     // (build_vector:{ *:[v4i32] } i32:{ *:[i32] }:$A, i32:{ *:[i32] }:$A, i32:{ *:[i32] }:$A, i32:{ *:[i32] }:$A)  =>  (XXSPLTW:{ *:[v4i32] } (SUBREG_TO_REG:{ *:[v4i32] } 1:{ *:[i64] }, (MTVSRWZ:{ *:[f64] } ?:{ *:[i32] }:$A), sub_64:{ *:[i32] }), 1:{ *:[i32] })
     /*  58242 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  58245 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::MTVSRWZ),
     /*  58249 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58254 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // A
     /*  58258 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  58260 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  58263 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  58267 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58272 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  58275 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  58278 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  58281 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  58286 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  58291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSPLTW),
     /*  58294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  58296 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  58299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  58302 */     GIR_RootConstrainSelectedInstOperands,
     /*  58303 */     // GIR_Coverage, 2129,
     /*  58303 */     GIR_EraseRootFromParent_Done,
     /*  58304 */   // Label 744: @58304
     /*  58304 */   GIM_Try, /*On fail goto*//*Label 745*/ GIMT_Encode4(58340), // Rule ID 2260 //
     /*  58309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  58312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  58316 */     // MIs[0] A
     /*  58316 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58321 */     // MIs[0] A
     /*  58321 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58326 */     // MIs[0] A
     /*  58326 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/4, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58331 */     // (build_vector:{ *:[v4i32] } i32:{ *:[i32] }:$A, i32:{ *:[i32] }:$A, i32:{ *:[i32] }:$A, i32:{ *:[i32] }:$A)  =>  (MTVSRWS:{ *:[v4i32] } ?:{ *:[i32] }:$A)
     /*  58331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTVSRWS),
     /*  58334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  58336 */     GIR_RootToRootCopy, /*OpIdx*/1, // A
     /*  58338 */     GIR_RootConstrainSelectedInstOperands,
     /*  58339 */     // GIR_Coverage, 2260,
     /*  58339 */     GIR_EraseRootFromParent_Done,
     /*  58340 */   // Label 745: @58340
     /*  58340 */   GIM_Reject,
     /*  58341 */ // Label 738: @58341
     /*  58341 */ GIM_Try, /*On fail goto*//*Label 746*/ GIMT_Encode4(58482), // Rule ID 2261 //
     /*  58346 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  58349 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/17,
     /*  58352 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  58355 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  58358 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  58362 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58366 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  58370 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immNonAllOneAnyExt8),
     /*  58374 */   // MIs[1] Operand 1
     /*  58374 */   // No operand predicates
     /*  58374 */   // MIs[0] A
     /*  58374 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58379 */   // MIs[0] A
     /*  58379 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58384 */   // MIs[0] A
     /*  58384 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/4, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58389 */   // MIs[0] A
     /*  58389 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/5, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58394 */   // MIs[0] A
     /*  58394 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/6, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58399 */   // MIs[0] A
     /*  58399 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/7, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58404 */   // MIs[0] A
     /*  58404 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/8, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58409 */   // MIs[0] A
     /*  58409 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/9, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58414 */   // MIs[0] A
     /*  58414 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/10, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58419 */   // MIs[0] A
     /*  58419 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/11, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58424 */   // MIs[0] A
     /*  58424 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/12, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58429 */   // MIs[0] A
     /*  58429 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/13, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58434 */   // MIs[0] A
     /*  58434 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/14, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58439 */   // MIs[0] A
     /*  58439 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/15, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58444 */   // MIs[0] A
     /*  58444 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/16, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58449 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  58451 */   // (build_vector:{ *:[v16i8] } (imm:{ *:[i32] })<<P:Predicate_immNonAllOneAnyExt8>>:$A, (imm:{ *:[i32] })<<P:Predicate_immNonAllOneAnyExt8>>:$A, (imm:{ *:[i32] })<<P:Predicate_immNonAllOneAnyExt8>>:$A, (imm:{ *:[i32] })<<P:Predicate_immNonAllOneAnyExt8>>:$A, (imm:{ *:[i32] })<<P:Predicate_immNonAllOneAnyExt8>>:$A, (imm:{ *:[i32] })<<P:Predicate_immNonAllOneAnyExt8>>:$A, (imm:{ *:[i32] })<<P:Predicate_immNonAllOneAnyExt8>>:$A, (imm:{ *:[i32] })<<P:Predicate_immNonAllOneAnyExt8>>:$A, (imm:{ *:[i32] })<<P:Predicate_immNonAllOneAnyExt8>>:$A, (imm:{ *:[i32] })<<P:Predicate_immNonAllOneAnyExt8>>:$A, (imm:{ *:[i32] })<<P:Predicate_immNonAllOneAnyExt8>>:$A, (imm:{ *:[i32] })<<P:Predicate_immNonAllOneAnyExt8>>:$A, (imm:{ *:[i32] })<<P:Predicate_immNonAllOneAnyExt8>>:$A, (imm:{ *:[i32] })<<P:Predicate_immNonAllOneAnyExt8>>:$A, (imm:{ *:[i32] })<<P:Predicate_immNonAllOneAnyExt8>>:$A, (imm:{ *:[i32] })<<P:Predicate_immNonAllOneAnyExt8>>:$A)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } (XXSPLTIB:{ *:[v4i32] } (imm:{ *:[i32] }):$A), VSRC:{ *:[i32] })
     /*  58451 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  58454 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXSPLTIB),
     /*  58458 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58463 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // A
     /*  58466 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  58468 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58471 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58473 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  58476 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  58481 */   // GIR_Coverage, 2261,
     /*  58481 */   GIR_EraseRootFromParent_Done,
     /*  58482 */ // Label 746: @58482
     /*  58482 */ GIM_Reject,
     /*  58483 */ // Label 11: @58483
     /*  58483 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(8), /*)*//*default:*//*Label 754*/ GIMT_Encode4(60759),
     /*  58494 */ /*GILLT_s32*//*Label 747*/ GIMT_Encode4(58522),
     /*  58498 */ /*GILLT_s64*//*Label 748*/ GIMT_Encode4(58595),
     /*  58502 */ /*GILLT_s128*//*Label 749*/ GIMT_Encode4(58643),
     /*  58506 */ /*GILLT_v2s64*//*Label 750*/ GIMT_Encode4(59047),
     /*  58510 */ /*GILLT_v4s32*//*Label 751*/ GIMT_Encode4(59609),
     /*  58514 */ /*GILLT_v8s16*//*Label 752*/ GIMT_Encode4(60160),
     /*  58518 */ /*GILLT_v16s8*//*Label 753*/ GIMT_Encode4(60488),
     /*  58522 */ // Label 747: @58522
     /*  58522 */ GIM_Try, /*On fail goto*//*Label 755*/ GIMT_Encode4(58594), // Rule ID 2022 //
     /*  58527 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX),
     /*  58530 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  58533 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  58537 */   // (bitconvert:{ *:[i32] } f32:{ *:[f32] }:$A)  =>  (MFVSRWZ:{ *:[i32] } (EXTRACT_SUBREG:{ *:[f64] } (XSCVDPSPN:{ *:[v4i32] } ?:{ *:[f32] }:$A), sub_64:{ *:[i32] }))
     /*  58537 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  58540 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCVDPSPN),
     /*  58544 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58549 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // A
     /*  58553 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  58555 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  58558 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58562 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58567 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_64),
     /*  58574 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSSRCRegClassID),
     /*  58579 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  58584 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFVSRWZ),
     /*  58587 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  58589 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  58592 */   GIR_RootConstrainSelectedInstOperands,
     /*  58593 */   // GIR_Coverage, 2022,
     /*  58593 */   GIR_EraseRootFromParent_Done,
     /*  58594 */ // Label 755: @58594
     /*  58594 */ GIM_Reject,
     /*  58595 */ // Label 748: @58595
     /*  58595 */ GIM_Try, /*On fail goto*//*Label 756*/ GIMT_Encode4(58642),
     /*  58600 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  58603 */   GIM_Try, /*On fail goto*//*Label 757*/ GIMT_Encode4(58622), // Rule ID 2024 //
     /*  58608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX),
     /*  58611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  58615 */     // (bitconvert:{ *:[i64] } f64:{ *:[f64] }:$A)  =>  (MFVSRD:{ *:[i64] } ?:{ *:[f64] }:$A)
     /*  58615 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::MFVSRD),
     /*  58620 */     GIR_RootConstrainSelectedInstOperands,
     /*  58621 */     // GIR_Coverage, 2024,
     /*  58621 */     GIR_Done,
     /*  58622 */   // Label 757: @58622
     /*  58622 */   GIM_Try, /*On fail goto*//*Label 758*/ GIMT_Encode4(58641), // Rule ID 2025 //
     /*  58627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX),
     /*  58630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  58634 */     // (bitconvert:{ *:[f64] } i64:{ *:[i64] }:$S)  =>  (MTVSRD:{ *:[f64] } ?:{ *:[i64] }:$S)
     /*  58634 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::MTVSRD),
     /*  58639 */     GIR_RootConstrainSelectedInstOperands,
     /*  58640 */     // GIR_Coverage, 2025,
     /*  58640 */     GIR_Done,
     /*  58641 */   // Label 758: @58641
     /*  58641 */   GIM_Reject,
     /*  58642 */ // Label 756: @58642
     /*  58642 */ GIM_Reject,
     /*  58643 */ // Label 749: @58643
     /*  58643 */ GIM_Try, /*On fail goto*//*Label 759*/ GIMT_Encode4(58700), // Rule ID 1928 //
     /*  58648 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /*  58651 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  58654 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  58658 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58662 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  58668 */   GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  58670 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  58672 */   // (bitconvert:{ *:[v1i128] } immAllOnesV:{ *:[v16i8] })  =>  (COPY_TO_REGCLASS:{ *:[v1i128] } (XXLEQVOnes:{ *:[v4i32] }), VSRC:{ *:[i32] })
     /*  58672 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  58675 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXLEQVOnes),
     /*  58679 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58684 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  58686 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58689 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58691 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  58694 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  58699 */   // GIR_Coverage, 1928,
     /*  58699 */   GIR_EraseRootFromParent_Done,
     /*  58700 */ // Label 759: @58700
     /*  58700 */ GIM_Try, /*On fail goto*//*Label 760*/ GIMT_Encode4(58726), // Rule ID 1615 //
     /*  58705 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  58708 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  58711 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58715 */   // (bitconvert:{ *:[v1i128] } v2f64:{ *:[v2f64] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v1i128] } ?:{ *:[v2f64] }:$A, VRRC:{ *:[i32] })
     /*  58715 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58720 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58725 */   // GIR_Coverage, 1615,
     /*  58725 */   GIR_Done,
     /*  58726 */ // Label 760: @58726
     /*  58726 */ GIM_Try, /*On fail goto*//*Label 761*/ GIMT_Encode4(58758), // Rule ID 1330 //
     /*  58731 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  58734 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  58737 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58741 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58745 */   // (bitconvert:{ *:[v1i128] } VRRC:{ *:[v16i8] }:$src)  =>  VRRC:{ *:[v1i128] }:$src
     /*  58745 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58748 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  58750 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  58752 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58757 */   // GIR_Coverage, 1330,
     /*  58757 */   GIR_EraseRootFromParent_Done,
     /*  58758 */ // Label 761: @58758
     /*  58758 */ GIM_Try, /*On fail goto*//*Label 762*/ GIMT_Encode4(58790), // Rule ID 1331 //
     /*  58763 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  58766 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  58769 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58773 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58777 */   // (bitconvert:{ *:[v1i128] } VRRC:{ *:[v8i16] }:$src)  =>  VRRC:{ *:[v1i128] }:$src
     /*  58777 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58780 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  58782 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  58784 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58789 */   // GIR_Coverage, 1331,
     /*  58789 */   GIR_EraseRootFromParent_Done,
     /*  58790 */ // Label 762: @58790
     /*  58790 */ GIM_Try, /*On fail goto*//*Label 763*/ GIMT_Encode4(58822), // Rule ID 1332 //
     /*  58795 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  58798 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  58801 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58805 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58809 */   // (bitconvert:{ *:[v1i128] } VRRC:{ *:[v4i32] }:$src)  =>  VRRC:{ *:[v1i128] }:$src
     /*  58809 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58812 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  58814 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  58816 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58821 */   // GIR_Coverage, 1332,
     /*  58821 */   GIR_EraseRootFromParent_Done,
     /*  58822 */ // Label 763: @58822
     /*  58822 */ GIM_Try, /*On fail goto*//*Label 764*/ GIMT_Encode4(58854), // Rule ID 1333 //
     /*  58827 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  58830 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  58833 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58837 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58841 */   // (bitconvert:{ *:[v1i128] } VRRC:{ *:[v4f32] }:$src)  =>  VRRC:{ *:[v1i128] }:$src
     /*  58841 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58844 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  58846 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  58848 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58853 */   // GIR_Coverage, 1333,
     /*  58853 */   GIR_EraseRootFromParent_Done,
     /*  58854 */ // Label 764: @58854
     /*  58854 */ GIM_Try, /*On fail goto*//*Label 765*/ GIMT_Encode4(58886), // Rule ID 1334 //
     /*  58859 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  58862 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  58865 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58869 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58873 */   // (bitconvert:{ *:[v1i128] } VRRC:{ *:[v2i64] }:$src)  =>  VRRC:{ *:[v1i128] }:$src
     /*  58873 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58876 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  58878 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  58880 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58885 */   // GIR_Coverage, 1334,
     /*  58885 */   GIR_EraseRootFromParent_Done,
     /*  58886 */ // Label 765: @58886
     /*  58886 */ GIM_Try, /*On fail goto*//*Label 766*/ GIMT_Encode4(58918), // Rule ID 1335 //
     /*  58891 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  58894 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  58897 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58901 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58905 */   // (bitconvert:{ *:[f128] } VRRC:{ *:[v16i8] }:$src)  =>  VRRC:{ *:[f128] }:$src
     /*  58905 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58908 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  58910 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  58912 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58917 */   // GIR_Coverage, 1335,
     /*  58917 */   GIR_EraseRootFromParent_Done,
     /*  58918 */ // Label 766: @58918
     /*  58918 */ GIM_Try, /*On fail goto*//*Label 767*/ GIMT_Encode4(58950), // Rule ID 1336 //
     /*  58923 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  58926 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  58929 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58933 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58937 */   // (bitconvert:{ *:[f128] } VRRC:{ *:[v8i16] }:$src)  =>  VRRC:{ *:[f128] }:$src
     /*  58937 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58940 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  58942 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  58944 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58949 */   // GIR_Coverage, 1336,
     /*  58949 */   GIR_EraseRootFromParent_Done,
     /*  58950 */ // Label 767: @58950
     /*  58950 */ GIM_Try, /*On fail goto*//*Label 768*/ GIMT_Encode4(58982), // Rule ID 1337 //
     /*  58955 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  58958 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  58961 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58965 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58969 */   // (bitconvert:{ *:[f128] } VRRC:{ *:[v4i32] }:$src)  =>  VRRC:{ *:[f128] }:$src
     /*  58969 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58972 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  58974 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  58976 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58981 */   // GIR_Coverage, 1337,
     /*  58981 */   GIR_EraseRootFromParent_Done,
     /*  58982 */ // Label 768: @58982
     /*  58982 */ GIM_Try, /*On fail goto*//*Label 769*/ GIMT_Encode4(59014), // Rule ID 1338 //
     /*  58987 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  58990 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  58993 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58997 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59001 */   // (bitconvert:{ *:[f128] } VRRC:{ *:[v4f32] }:$src)  =>  VRRC:{ *:[f128] }:$src
     /*  59001 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59004 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  59006 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  59008 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59013 */   // GIR_Coverage, 1338,
     /*  59013 */   GIR_EraseRootFromParent_Done,
     /*  59014 */ // Label 769: @59014
     /*  59014 */ GIM_Try, /*On fail goto*//*Label 770*/ GIMT_Encode4(59046), // Rule ID 1339 //
     /*  59019 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  59022 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  59025 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59029 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59033 */   // (bitconvert:{ *:[f128] } VRRC:{ *:[v2f64] }:$src)  =>  VRRC:{ *:[f128] }:$src
     /*  59033 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59036 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  59038 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  59040 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59045 */   // GIR_Coverage, 1339,
     /*  59045 */   GIR_EraseRootFromParent_Done,
     /*  59046 */ // Label 770: @59046
     /*  59046 */ GIM_Reject,
     /*  59047 */ // Label 750: @59047
     /*  59047 */ GIM_Try, /*On fail goto*//*Label 771*/ GIMT_Encode4(59104), // Rule ID 1929 //
     /*  59052 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /*  59055 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  59058 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59062 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59066 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  59072 */   GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  59074 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  59076 */   // (bitconvert:{ *:[v2i64] } immAllOnesV:{ *:[v16i8] })  =>  (COPY_TO_REGCLASS:{ *:[v2i64] } (XXLEQVOnes:{ *:[v4i32] }), VSRC:{ *:[i32] })
     /*  59076 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  59079 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXLEQVOnes),
     /*  59083 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59088 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  59090 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59093 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59095 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  59098 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59103 */   // GIR_Coverage, 1929,
     /*  59103 */   GIR_EraseRootFromParent_Done,
     /*  59104 */ // Label 771: @59104
     /*  59104 */ GIM_Try, /*On fail goto*//*Label 772*/ GIMT_Encode4(59130), // Rule ID 1596 //
     /*  59109 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  59112 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  59115 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59119 */   // (bitconvert:{ *:[v2f64] } v4f32:{ *:[v4f32] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v2f64] } ?:{ *:[v4f32] }:$A, VSRC:{ *:[i32] })
     /*  59119 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59124 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59129 */   // GIR_Coverage, 1596,
     /*  59129 */   GIR_Done,
     /*  59130 */ // Label 772: @59130
     /*  59130 */ GIM_Try, /*On fail goto*//*Label 773*/ GIMT_Encode4(59156), // Rule ID 1597 //
     /*  59135 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  59138 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  59141 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59145 */   // (bitconvert:{ *:[v2f64] } v4i32:{ *:[v4i32] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v2f64] } ?:{ *:[v4i32] }:$A, VSRC:{ *:[i32] })
     /*  59145 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59150 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59155 */   // GIR_Coverage, 1597,
     /*  59155 */   GIR_Done,
     /*  59156 */ // Label 773: @59156
     /*  59156 */ GIM_Try, /*On fail goto*//*Label 774*/ GIMT_Encode4(59182), // Rule ID 1598 //
     /*  59161 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  59164 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  59167 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59171 */   // (bitconvert:{ *:[v2f64] } v8i16:{ *:[v8i16] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v2f64] } ?:{ *:[v8i16] }:$A, VSRC:{ *:[i32] })
     /*  59171 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59176 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59181 */   // GIR_Coverage, 1598,
     /*  59181 */   GIR_Done,
     /*  59182 */ // Label 774: @59182
     /*  59182 */ GIM_Try, /*On fail goto*//*Label 775*/ GIMT_Encode4(59208), // Rule ID 1599 //
     /*  59187 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  59190 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  59193 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59197 */   // (bitconvert:{ *:[v2f64] } v16i8:{ *:[v16i8] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v2f64] } ?:{ *:[v16i8] }:$A, VSRC:{ *:[i32] })
     /*  59197 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59202 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59207 */   // GIR_Coverage, 1599,
     /*  59207 */   GIR_Done,
     /*  59208 */ // Label 775: @59208
     /*  59208 */ GIM_Try, /*On fail goto*//*Label 776*/ GIMT_Encode4(59234), // Rule ID 1604 //
     /*  59213 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  59216 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  59219 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59223 */   // (bitconvert:{ *:[v2i64] } v4f32:{ *:[v4f32] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v2i64] } ?:{ *:[v4f32] }:$A, VSRC:{ *:[i32] })
     /*  59223 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59228 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59233 */   // GIR_Coverage, 1604,
     /*  59233 */   GIR_Done,
     /*  59234 */ // Label 776: @59234
     /*  59234 */ GIM_Try, /*On fail goto*//*Label 777*/ GIMT_Encode4(59260), // Rule ID 1605 //
     /*  59239 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  59242 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  59245 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59249 */   // (bitconvert:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v2i64] } ?:{ *:[v4i32] }:$A, VSRC:{ *:[i32] })
     /*  59249 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59254 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59259 */   // GIR_Coverage, 1605,
     /*  59259 */   GIR_Done,
     /*  59260 */ // Label 777: @59260
     /*  59260 */ GIM_Try, /*On fail goto*//*Label 778*/ GIMT_Encode4(59286), // Rule ID 1606 //
     /*  59265 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  59268 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  59271 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59275 */   // (bitconvert:{ *:[v2i64] } v8i16:{ *:[v8i16] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v2i64] } ?:{ *:[v8i16] }:$A, VSRC:{ *:[i32] })
     /*  59275 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59280 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59285 */   // GIR_Coverage, 1606,
     /*  59285 */   GIR_Done,
     /*  59286 */ // Label 778: @59286
     /*  59286 */ GIM_Try, /*On fail goto*//*Label 779*/ GIMT_Encode4(59312), // Rule ID 1607 //
     /*  59291 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  59294 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  59297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59301 */   // (bitconvert:{ *:[v2i64] } v16i8:{ *:[v16i8] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v2i64] } ?:{ *:[v16i8] }:$A, VSRC:{ *:[i32] })
     /*  59301 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59306 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59311 */   // GIR_Coverage, 1607,
     /*  59311 */   GIR_Done,
     /*  59312 */ // Label 779: @59312
     /*  59312 */ GIM_Try, /*On fail goto*//*Label 780*/ GIMT_Encode4(59338), // Rule ID 1612 //
     /*  59317 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  59320 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  59323 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59327 */   // (bitconvert:{ *:[v2f64] } v2i64:{ *:[v2i64] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v2f64] } ?:{ *:[v2i64] }:$A, VRRC:{ *:[i32] })
     /*  59327 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59332 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59337 */   // GIR_Coverage, 1612,
     /*  59337 */   GIR_Done,
     /*  59338 */ // Label 780: @59338
     /*  59338 */ GIM_Try, /*On fail goto*//*Label 781*/ GIMT_Encode4(59364), // Rule ID 1613 //
     /*  59343 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  59346 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  59349 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59353 */   // (bitconvert:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v2i64] } ?:{ *:[v2f64] }:$A, VRRC:{ *:[i32] })
     /*  59353 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59358 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59363 */   // GIR_Coverage, 1613,
     /*  59363 */   GIR_Done,
     /*  59364 */ // Label 781: @59364
     /*  59364 */ GIM_Try, /*On fail goto*//*Label 782*/ GIMT_Encode4(59390), // Rule ID 1614 //
     /*  59369 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  59372 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  59375 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59379 */   // (bitconvert:{ *:[v2f64] } v1i128:{ *:[v1i128] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v2f64] } ?:{ *:[v1i128] }:$A, VRRC:{ *:[i32] })
     /*  59379 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59384 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59389 */   // GIR_Coverage, 1614,
     /*  59389 */   GIR_Done,
     /*  59390 */ // Label 782: @59390
     /*  59390 */ GIM_Try, /*On fail goto*//*Label 783*/ GIMT_Encode4(59416), // Rule ID 1616 //
     /*  59395 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  59398 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  59401 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59405 */   // (bitconvert:{ *:[v2i64] } f128:{ *:[f128] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v2i64] } ?:{ *:[f128] }:$A, VRRC:{ *:[i32] })
     /*  59405 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59410 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59415 */   // GIR_Coverage, 1616,
     /*  59415 */   GIR_Done,
     /*  59416 */ // Label 783: @59416
     /*  59416 */ GIM_Try, /*On fail goto*//*Label 784*/ GIMT_Encode4(59448), // Rule ID 1325 //
     /*  59421 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  59424 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  59427 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59431 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59435 */   // (bitconvert:{ *:[v2i64] } VRRC:{ *:[v16i8] }:$src)  =>  VRRC:{ *:[v2i64] }:$src
     /*  59435 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59438 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  59440 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  59442 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59447 */   // GIR_Coverage, 1325,
     /*  59447 */   GIR_EraseRootFromParent_Done,
     /*  59448 */ // Label 784: @59448
     /*  59448 */ GIM_Try, /*On fail goto*//*Label 785*/ GIMT_Encode4(59480), // Rule ID 1326 //
     /*  59453 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  59456 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  59459 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59463 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59467 */   // (bitconvert:{ *:[v2i64] } VRRC:{ *:[v8i16] }:$src)  =>  VRRC:{ *:[v2i64] }:$src
     /*  59467 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59470 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  59472 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  59474 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59479 */   // GIR_Coverage, 1326,
     /*  59479 */   GIR_EraseRootFromParent_Done,
     /*  59480 */ // Label 785: @59480
     /*  59480 */ GIM_Try, /*On fail goto*//*Label 786*/ GIMT_Encode4(59512), // Rule ID 1327 //
     /*  59485 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  59488 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  59491 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59495 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59499 */   // (bitconvert:{ *:[v2i64] } VRRC:{ *:[v4i32] }:$src)  =>  VRRC:{ *:[v2i64] }:$src
     /*  59499 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59502 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  59504 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  59506 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59511 */   // GIR_Coverage, 1327,
     /*  59511 */   GIR_EraseRootFromParent_Done,
     /*  59512 */ // Label 786: @59512
     /*  59512 */ GIM_Try, /*On fail goto*//*Label 787*/ GIMT_Encode4(59544), // Rule ID 1328 //
     /*  59517 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  59520 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  59523 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59527 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59531 */   // (bitconvert:{ *:[v2i64] } VRRC:{ *:[v4f32] }:$src)  =>  VRRC:{ *:[v2i64] }:$src
     /*  59531 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59534 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  59536 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  59538 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59543 */   // GIR_Coverage, 1328,
     /*  59543 */   GIR_EraseRootFromParent_Done,
     /*  59544 */ // Label 787: @59544
     /*  59544 */ GIM_Try, /*On fail goto*//*Label 788*/ GIMT_Encode4(59576), // Rule ID 1329 //
     /*  59549 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  59552 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  59555 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59559 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59563 */   // (bitconvert:{ *:[v2i64] } VRRC:{ *:[v1i128] }:$src)  =>  VRRC:{ *:[v2i64] }:$src
     /*  59563 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59566 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  59568 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  59570 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59575 */   // GIR_Coverage, 1329,
     /*  59575 */   GIR_EraseRootFromParent_Done,
     /*  59576 */ // Label 788: @59576
     /*  59576 */ GIM_Try, /*On fail goto*//*Label 789*/ GIMT_Encode4(59608), // Rule ID 1344 //
     /*  59581 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  59584 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  59587 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59591 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59595 */   // (bitconvert:{ *:[v2f64] } VRRC:{ *:[f128] }:$src)  =>  VRRC:{ *:[v2f64] }:$src
     /*  59595 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59598 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  59600 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  59602 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59607 */   // GIR_Coverage, 1344,
     /*  59607 */   GIR_EraseRootFromParent_Done,
     /*  59608 */ // Label 789: @59608
     /*  59608 */ GIM_Reject,
     /*  59609 */ // Label 751: @59609
     /*  59609 */ GIM_Try, /*On fail goto*//*Label 790*/ GIMT_Encode4(59645), // Rule ID 941 //
     /*  59614 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /*  59617 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  59620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59624 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59628 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  59634 */   GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  59636 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  59638 */   // (bitconvert:{ *:[v4i32] } immAllOnesV:{ *:[v16i8] })  =>  (XXLEQVOnes:{ *:[v4i32] })
     /*  59638 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXLEQVOnes),
     /*  59641 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  59643 */   GIR_RootConstrainSelectedInstOperands,
     /*  59644 */   // GIR_Coverage, 941,
     /*  59644 */   GIR_EraseRootFromParent_Done,
     /*  59645 */ // Label 790: @59645
     /*  59645 */ GIM_Try, /*On fail goto*//*Label 791*/ GIMT_Encode4(59671), // Rule ID 1600 //
     /*  59650 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  59653 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  59656 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59660 */   // (bitconvert:{ *:[v4f32] } v2f64:{ *:[v2f64] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v4f32] } ?:{ *:[v2f64] }:$A, VRRC:{ *:[i32] })
     /*  59660 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59665 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59670 */   // GIR_Coverage, 1600,
     /*  59670 */   GIR_Done,
     /*  59671 */ // Label 791: @59671
     /*  59671 */ GIM_Try, /*On fail goto*//*Label 792*/ GIMT_Encode4(59697), // Rule ID 1601 //
     /*  59676 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  59679 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  59682 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59686 */   // (bitconvert:{ *:[v4i32] } v2f64:{ *:[v2f64] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v2f64] }:$A, VRRC:{ *:[i32] })
     /*  59686 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59691 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59696 */   // GIR_Coverage, 1601,
     /*  59696 */   GIR_Done,
     /*  59697 */ // Label 792: @59697
     /*  59697 */ GIM_Try, /*On fail goto*//*Label 793*/ GIMT_Encode4(59723), // Rule ID 1608 //
     /*  59702 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  59705 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  59708 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59712 */   // (bitconvert:{ *:[v4f32] } v2i64:{ *:[v2i64] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v4f32] } ?:{ *:[v2i64] }:$A, VRRC:{ *:[i32] })
     /*  59712 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59717 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59722 */   // GIR_Coverage, 1608,
     /*  59722 */   GIR_Done,
     /*  59723 */ // Label 793: @59723
     /*  59723 */ GIM_Try, /*On fail goto*//*Label 794*/ GIMT_Encode4(59749), // Rule ID 1609 //
     /*  59728 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  59731 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  59734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59738 */   // (bitconvert:{ *:[v4i32] } v2i64:{ *:[v2i64] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v2i64] }:$A, VRRC:{ *:[i32] })
     /*  59738 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59743 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59748 */   // GIR_Coverage, 1609,
     /*  59748 */   GIR_Done,
     /*  59749 */ // Label 794: @59749
     /*  59749 */ GIM_Try, /*On fail goto*//*Label 795*/ GIMT_Encode4(59775), // Rule ID 1617 //
     /*  59754 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  59757 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  59760 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59764 */   // (bitconvert:{ *:[v4i32] } f128:{ *:[f128] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[f128] }:$A, VRRC:{ *:[i32] })
     /*  59764 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59769 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59774 */   // GIR_Coverage, 1617,
     /*  59774 */   GIR_Done,
     /*  59775 */ // Label 795: @59775
     /*  59775 */ GIM_Try, /*On fail goto*//*Label 796*/ GIMT_Encode4(59807), // Rule ID 1315 //
     /*  59780 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  59783 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  59786 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59790 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59794 */   // (bitconvert:{ *:[v4i32] } VRRC:{ *:[v16i8] }:$src)  =>  VRRC:{ *:[v4i32] }:$src
     /*  59794 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59797 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  59799 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  59801 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59806 */   // GIR_Coverage, 1315,
     /*  59806 */   GIR_EraseRootFromParent_Done,
     /*  59807 */ // Label 796: @59807
     /*  59807 */ GIM_Try, /*On fail goto*//*Label 797*/ GIMT_Encode4(59839), // Rule ID 1316 //
     /*  59812 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  59815 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  59818 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59822 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59826 */   // (bitconvert:{ *:[v4i32] } VRRC:{ *:[v8i16] }:$src)  =>  VRRC:{ *:[v4i32] }:$src
     /*  59826 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59829 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  59831 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  59833 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59838 */   // GIR_Coverage, 1316,
     /*  59838 */   GIR_EraseRootFromParent_Done,
     /*  59839 */ // Label 797: @59839
     /*  59839 */ GIM_Try, /*On fail goto*//*Label 798*/ GIMT_Encode4(59871), // Rule ID 1317 //
     /*  59844 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  59847 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  59850 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59854 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59858 */   // (bitconvert:{ *:[v4i32] } VRRC:{ *:[v4f32] }:$src)  =>  VRRC:{ *:[v4i32] }:$src
     /*  59858 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59861 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  59863 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  59865 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59870 */   // GIR_Coverage, 1317,
     /*  59870 */   GIR_EraseRootFromParent_Done,
     /*  59871 */ // Label 798: @59871
     /*  59871 */ GIM_Try, /*On fail goto*//*Label 799*/ GIMT_Encode4(59903), // Rule ID 1318 //
     /*  59876 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  59879 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  59882 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59886 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59890 */   // (bitconvert:{ *:[v4i32] } VRRC:{ *:[v2i64] }:$src)  =>  VRRC:{ *:[v4i32] }:$src
     /*  59890 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59893 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  59895 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  59897 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59902 */   // GIR_Coverage, 1318,
     /*  59902 */   GIR_EraseRootFromParent_Done,
     /*  59903 */ // Label 799: @59903
     /*  59903 */ GIM_Try, /*On fail goto*//*Label 800*/ GIMT_Encode4(59935), // Rule ID 1319 //
     /*  59908 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  59911 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  59914 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59918 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59922 */   // (bitconvert:{ *:[v4i32] } VRRC:{ *:[v1i128] }:$src)  =>  VRRC:{ *:[v4i32] }:$src
     /*  59922 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59925 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  59927 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  59929 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59934 */   // GIR_Coverage, 1319,
     /*  59934 */   GIR_EraseRootFromParent_Done,
     /*  59935 */ // Label 800: @59935
     /*  59935 */ GIM_Try, /*On fail goto*//*Label 801*/ GIMT_Encode4(59967), // Rule ID 1320 //
     /*  59940 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  59943 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  59946 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59950 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59954 */   // (bitconvert:{ *:[v4f32] } VRRC:{ *:[v16i8] }:$src)  =>  VRRC:{ *:[v4f32] }:$src
     /*  59954 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59957 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  59959 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  59961 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59966 */   // GIR_Coverage, 1320,
     /*  59966 */   GIR_EraseRootFromParent_Done,
     /*  59967 */ // Label 801: @59967
     /*  59967 */ GIM_Try, /*On fail goto*//*Label 802*/ GIMT_Encode4(59999), // Rule ID 1321 //
     /*  59972 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  59975 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  59978 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59982 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59986 */   // (bitconvert:{ *:[v4f32] } VRRC:{ *:[v8i16] }:$src)  =>  VRRC:{ *:[v4f32] }:$src
     /*  59986 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59989 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  59991 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  59993 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59998 */   // GIR_Coverage, 1321,
     /*  59998 */   GIR_EraseRootFromParent_Done,
     /*  59999 */ // Label 802: @59999
     /*  59999 */ GIM_Try, /*On fail goto*//*Label 803*/ GIMT_Encode4(60031), // Rule ID 1322 //
     /*  60004 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  60007 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  60010 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60014 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60018 */   // (bitconvert:{ *:[v4f32] } VRRC:{ *:[v4i32] }:$src)  =>  VRRC:{ *:[v4f32] }:$src
     /*  60018 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60021 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  60023 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  60025 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60030 */   // GIR_Coverage, 1322,
     /*  60030 */   GIR_EraseRootFromParent_Done,
     /*  60031 */ // Label 803: @60031
     /*  60031 */ GIM_Try, /*On fail goto*//*Label 804*/ GIMT_Encode4(60063), // Rule ID 1323 //
     /*  60036 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  60039 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  60042 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60046 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60050 */   // (bitconvert:{ *:[v4f32] } VRRC:{ *:[v2i64] }:$src)  =>  VRRC:{ *:[v4f32] }:$src
     /*  60050 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60053 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  60055 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  60057 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60062 */   // GIR_Coverage, 1323,
     /*  60062 */   GIR_EraseRootFromParent_Done,
     /*  60063 */ // Label 804: @60063
     /*  60063 */ GIM_Try, /*On fail goto*//*Label 805*/ GIMT_Encode4(60095), // Rule ID 1324 //
     /*  60068 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  60071 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  60074 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60078 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60082 */   // (bitconvert:{ *:[v4f32] } VRRC:{ *:[v1i128] }:$src)  =>  VRRC:{ *:[v4f32] }:$src
     /*  60082 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60085 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  60087 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  60089 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60094 */   // GIR_Coverage, 1324,
     /*  60094 */   GIR_EraseRootFromParent_Done,
     /*  60095 */ // Label 805: @60095
     /*  60095 */ GIM_Try, /*On fail goto*//*Label 806*/ GIMT_Encode4(60127), // Rule ID 1342 //
     /*  60100 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  60103 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  60106 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60110 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60114 */   // (bitconvert:{ *:[v4i32] } VRRC:{ *:[f128] }:$src)  =>  VRRC:{ *:[v4i32] }:$src
     /*  60114 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60117 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  60119 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  60121 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60126 */   // GIR_Coverage, 1342,
     /*  60126 */   GIR_EraseRootFromParent_Done,
     /*  60127 */ // Label 806: @60127
     /*  60127 */ GIM_Try, /*On fail goto*//*Label 807*/ GIMT_Encode4(60159), // Rule ID 1343 //
     /*  60132 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  60135 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  60138 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60142 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60146 */   // (bitconvert:{ *:[v4f32] } VRRC:{ *:[f128] }:$src)  =>  VRRC:{ *:[v4f32] }:$src
     /*  60146 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60149 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  60151 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  60153 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60158 */   // GIR_Coverage, 1343,
     /*  60158 */   GIR_EraseRootFromParent_Done,
     /*  60159 */ // Label 807: @60159
     /*  60159 */ GIM_Reject,
     /*  60160 */ // Label 752: @60160
     /*  60160 */ GIM_Try, /*On fail goto*//*Label 808*/ GIMT_Encode4(60217), // Rule ID 1930 //
     /*  60165 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /*  60168 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  60171 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  60175 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60179 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  60185 */   GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  60187 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  60189 */   // (bitconvert:{ *:[v8i16] } immAllOnesV:{ *:[v16i8] })  =>  (COPY_TO_REGCLASS:{ *:[v8i16] } (XXLEQVOnes:{ *:[v4i32] }), VSRC:{ *:[i32] })
     /*  60189 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  60192 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXLEQVOnes),
     /*  60196 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60201 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60203 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60206 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60208 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60211 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  60216 */   // GIR_Coverage, 1930,
     /*  60216 */   GIR_EraseRootFromParent_Done,
     /*  60217 */ // Label 808: @60217
     /*  60217 */ GIM_Try, /*On fail goto*//*Label 809*/ GIMT_Encode4(60243), // Rule ID 1602 //
     /*  60222 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  60225 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  60228 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60232 */   // (bitconvert:{ *:[v8i16] } v2f64:{ *:[v2f64] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v8i16] } ?:{ *:[v2f64] }:$A, VRRC:{ *:[i32] })
     /*  60232 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60237 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60242 */   // GIR_Coverage, 1602,
     /*  60242 */   GIR_Done,
     /*  60243 */ // Label 809: @60243
     /*  60243 */ GIM_Try, /*On fail goto*//*Label 810*/ GIMT_Encode4(60269), // Rule ID 1610 //
     /*  60248 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  60251 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  60254 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60258 */   // (bitconvert:{ *:[v8i16] } v2i64:{ *:[v2i64] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v8i16] } ?:{ *:[v2i64] }:$A, VRRC:{ *:[i32] })
     /*  60258 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60263 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60268 */   // GIR_Coverage, 1610,
     /*  60268 */   GIR_Done,
     /*  60269 */ // Label 810: @60269
     /*  60269 */ GIM_Try, /*On fail goto*//*Label 811*/ GIMT_Encode4(60295), // Rule ID 1618 //
     /*  60274 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  60277 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  60280 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60284 */   // (bitconvert:{ *:[v8i16] } f128:{ *:[f128] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v8i16] } ?:{ *:[f128] }:$A, VRRC:{ *:[i32] })
     /*  60284 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60289 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60294 */   // GIR_Coverage, 1618,
     /*  60294 */   GIR_Done,
     /*  60295 */ // Label 811: @60295
     /*  60295 */ GIM_Try, /*On fail goto*//*Label 812*/ GIMT_Encode4(60327), // Rule ID 1310 //
     /*  60300 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  60303 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  60306 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60310 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60314 */   // (bitconvert:{ *:[v8i16] } VRRC:{ *:[v16i8] }:$src)  =>  VRRC:{ *:[v8i16] }:$src
     /*  60314 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60317 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  60319 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  60321 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60326 */   // GIR_Coverage, 1310,
     /*  60326 */   GIR_EraseRootFromParent_Done,
     /*  60327 */ // Label 812: @60327
     /*  60327 */ GIM_Try, /*On fail goto*//*Label 813*/ GIMT_Encode4(60359), // Rule ID 1311 //
     /*  60332 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  60335 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  60338 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60342 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60346 */   // (bitconvert:{ *:[v8i16] } VRRC:{ *:[v4i32] }:$src)  =>  VRRC:{ *:[v8i16] }:$src
     /*  60346 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60349 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  60351 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  60353 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60358 */   // GIR_Coverage, 1311,
     /*  60358 */   GIR_EraseRootFromParent_Done,
     /*  60359 */ // Label 813: @60359
     /*  60359 */ GIM_Try, /*On fail goto*//*Label 814*/ GIMT_Encode4(60391), // Rule ID 1312 //
     /*  60364 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  60367 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  60370 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60374 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60378 */   // (bitconvert:{ *:[v8i16] } VRRC:{ *:[v4f32] }:$src)  =>  VRRC:{ *:[v8i16] }:$src
     /*  60378 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60381 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  60383 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  60385 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60390 */   // GIR_Coverage, 1312,
     /*  60390 */   GIR_EraseRootFromParent_Done,
     /*  60391 */ // Label 814: @60391
     /*  60391 */ GIM_Try, /*On fail goto*//*Label 815*/ GIMT_Encode4(60423), // Rule ID 1313 //
     /*  60396 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  60399 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  60402 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60406 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60410 */   // (bitconvert:{ *:[v8i16] } VRRC:{ *:[v2i64] }:$src)  =>  VRRC:{ *:[v8i16] }:$src
     /*  60410 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60413 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  60415 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  60417 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60422 */   // GIR_Coverage, 1313,
     /*  60422 */   GIR_EraseRootFromParent_Done,
     /*  60423 */ // Label 815: @60423
     /*  60423 */ GIM_Try, /*On fail goto*//*Label 816*/ GIMT_Encode4(60455), // Rule ID 1314 //
     /*  60428 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  60431 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  60434 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60438 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60442 */   // (bitconvert:{ *:[v8i16] } VRRC:{ *:[v1i128] }:$src)  =>  VRRC:{ *:[v8i16] }:$src
     /*  60442 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60445 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  60447 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  60449 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60454 */   // GIR_Coverage, 1314,
     /*  60454 */   GIR_EraseRootFromParent_Done,
     /*  60455 */ // Label 816: @60455
     /*  60455 */ GIM_Try, /*On fail goto*//*Label 817*/ GIMT_Encode4(60487), // Rule ID 1341 //
     /*  60460 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  60463 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  60466 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60470 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60474 */   // (bitconvert:{ *:[v8i16] } VRRC:{ *:[f128] }:$src)  =>  VRRC:{ *:[v8i16] }:$src
     /*  60474 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60477 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  60479 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  60481 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60486 */   // GIR_Coverage, 1341,
     /*  60486 */   GIR_EraseRootFromParent_Done,
     /*  60487 */ // Label 817: @60487
     /*  60487 */ GIM_Reject,
     /*  60488 */ // Label 753: @60488
     /*  60488 */ GIM_Try, /*On fail goto*//*Label 818*/ GIMT_Encode4(60514), // Rule ID 1603 //
     /*  60493 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  60496 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  60499 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60503 */   // (bitconvert:{ *:[v16i8] } v2f64:{ *:[v2f64] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } ?:{ *:[v2f64] }:$A, VRRC:{ *:[i32] })
     /*  60503 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60508 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60513 */   // GIR_Coverage, 1603,
     /*  60513 */   GIR_Done,
     /*  60514 */ // Label 818: @60514
     /*  60514 */ GIM_Try, /*On fail goto*//*Label 819*/ GIMT_Encode4(60540), // Rule ID 1611 //
     /*  60519 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  60522 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  60525 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60529 */   // (bitconvert:{ *:[v16i8] } v2i64:{ *:[v2i64] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } ?:{ *:[v2i64] }:$A, VRRC:{ *:[i32] })
     /*  60529 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60534 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60539 */   // GIR_Coverage, 1611,
     /*  60539 */   GIR_Done,
     /*  60540 */ // Label 819: @60540
     /*  60540 */ GIM_Try, /*On fail goto*//*Label 820*/ GIMT_Encode4(60566), // Rule ID 1619 //
     /*  60545 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  60548 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  60551 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60555 */   // (bitconvert:{ *:[v16i8] } f128:{ *:[f128] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } ?:{ *:[f128] }:$A, VRRC:{ *:[i32] })
     /*  60555 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60560 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60565 */   // GIR_Coverage, 1619,
     /*  60565 */   GIR_Done,
     /*  60566 */ // Label 820: @60566
     /*  60566 */ GIM_Try, /*On fail goto*//*Label 821*/ GIMT_Encode4(60598), // Rule ID 1305 //
     /*  60571 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  60574 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  60577 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60581 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60585 */   // (bitconvert:{ *:[v16i8] } VRRC:{ *:[v8i16] }:$src)  =>  VRRC:{ *:[v16i8] }:$src
     /*  60585 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60588 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  60590 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  60592 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60597 */   // GIR_Coverage, 1305,
     /*  60597 */   GIR_EraseRootFromParent_Done,
     /*  60598 */ // Label 821: @60598
     /*  60598 */ GIM_Try, /*On fail goto*//*Label 822*/ GIMT_Encode4(60630), // Rule ID 1306 //
     /*  60603 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  60606 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  60609 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60613 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60617 */   // (bitconvert:{ *:[v16i8] } VRRC:{ *:[v4i32] }:$src)  =>  VRRC:{ *:[v16i8] }:$src
     /*  60617 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60620 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  60622 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  60624 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60629 */   // GIR_Coverage, 1306,
     /*  60629 */   GIR_EraseRootFromParent_Done,
     /*  60630 */ // Label 822: @60630
     /*  60630 */ GIM_Try, /*On fail goto*//*Label 823*/ GIMT_Encode4(60662), // Rule ID 1307 //
     /*  60635 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  60638 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  60641 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60645 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60649 */   // (bitconvert:{ *:[v16i8] } VRRC:{ *:[v4f32] }:$src)  =>  VRRC:{ *:[v16i8] }:$src
     /*  60649 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60652 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  60654 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  60656 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60661 */   // GIR_Coverage, 1307,
     /*  60661 */   GIR_EraseRootFromParent_Done,
     /*  60662 */ // Label 823: @60662
     /*  60662 */ GIM_Try, /*On fail goto*//*Label 824*/ GIMT_Encode4(60694), // Rule ID 1308 //
     /*  60667 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  60670 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  60673 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60677 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60681 */   // (bitconvert:{ *:[v16i8] } VRRC:{ *:[v2i64] }:$src)  =>  VRRC:{ *:[v16i8] }:$src
     /*  60681 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60684 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  60686 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  60688 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60693 */   // GIR_Coverage, 1308,
     /*  60693 */   GIR_EraseRootFromParent_Done,
     /*  60694 */ // Label 824: @60694
     /*  60694 */ GIM_Try, /*On fail goto*//*Label 825*/ GIMT_Encode4(60726), // Rule ID 1309 //
     /*  60699 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  60702 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  60705 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60709 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60713 */   // (bitconvert:{ *:[v16i8] } VRRC:{ *:[v1i128] }:$src)  =>  VRRC:{ *:[v16i8] }:$src
     /*  60713 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60716 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  60718 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  60720 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60725 */   // GIR_Coverage, 1309,
     /*  60725 */   GIR_EraseRootFromParent_Done,
     /*  60726 */ // Label 825: @60726
     /*  60726 */ GIM_Try, /*On fail goto*//*Label 826*/ GIMT_Encode4(60758), // Rule ID 1340 //
     /*  60731 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  60734 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  60737 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60741 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60745 */   // (bitconvert:{ *:[v16i8] } VRRC:{ *:[f128] }:$src)  =>  VRRC:{ *:[v16i8] }:$src
     /*  60745 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60748 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  60750 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  60752 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60757 */   // GIR_Coverage, 1340,
     /*  60757 */   GIR_EraseRootFromParent_Done,
     /*  60758 */ // Label 826: @60758
     /*  60758 */ GIM_Reject,
     /*  60759 */ // Label 754: @60759
     /*  60759 */ GIM_Reject,
     /*  60760 */ // Label 12: @60760
     /*  60760 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 832*/ GIMT_Encode4(61034),
     /*  60771 */ /*GILLT_s32*//*Label 827*/ GIMT_Encode4(60791),
     /*  60775 */ /*GILLT_s64*//*Label 828*/ GIMT_Encode4(60884),
     /*  60779 */ /*GILLT_s128*//*Label 829*/ GIMT_Encode4(60932),
     /*  60783 */ /*GILLT_v2s64*//*Label 830*/ GIMT_Encode4(60963),
     /*  60787 */ /*GILLT_v4s32*//*Label 831*/ GIMT_Encode4(60986),
     /*  60791 */ // Label 827: @60791
     /*  60791 */ GIM_Try, /*On fail goto*//*Label 833*/ GIMT_Encode4(60883),
     /*  60796 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  60799 */   GIM_Try, /*On fail goto*//*Label 834*/ GIMT_Encode4(60863), // Rule ID 1706 //
     /*  60804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  60807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /*  60811 */     // (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$S)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (XSRDPIZ:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$S, VSFRC:{ *:[i32] })), VSSRC:{ *:[i32] })
     /*  60811 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  60814 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60818 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60823 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // S
     /*  60827 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  60832 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  60835 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSRDPIZ),
     /*  60839 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60844 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  60847 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60854 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60857 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSSRCRegClassID),
     /*  60862 */     // GIR_Coverage, 1706,
     /*  60862 */     GIR_EraseRootFromParent_Done,
     /*  60863 */   // Label 834: @60863
     /*  60863 */   GIM_Try, /*On fail goto*//*Label 835*/ GIMT_Encode4(60882), // Rule ID 150 //
     /*  60868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  60871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /*  60875 */     // (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$RB)  =>  (FRIZS:{ *:[f32] } f32:{ *:[f32] }:$RB)
     /*  60875 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FRIZS),
     /*  60880 */     GIR_RootConstrainSelectedInstOperands,
     /*  60881 */     // GIR_Coverage, 150,
     /*  60881 */     GIR_Done,
     /*  60882 */   // Label 835: @60882
     /*  60882 */   GIM_Reject,
     /*  60883 */ // Label 833: @60883
     /*  60883 */ GIM_Reject,
     /*  60884 */ // Label 828: @60884
     /*  60884 */ GIM_Try, /*On fail goto*//*Label 836*/ GIMT_Encode4(60931),
     /*  60889 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  60892 */   GIM_Try, /*On fail goto*//*Label 837*/ GIMT_Encode4(60911), // Rule ID 911 //
     /*  60897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  60900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  60904 */     // (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$XB)  =>  (XSRDPIZ:{ *:[f64] } f64:{ *:[f64] }:$XB)
     /*  60904 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSRDPIZ),
     /*  60909 */     GIR_RootConstrainSelectedInstOperands,
     /*  60910 */     // GIR_Coverage, 911,
     /*  60910 */     GIR_Done,
     /*  60911 */   // Label 837: @60911
     /*  60911 */   GIM_Try, /*On fail goto*//*Label 838*/ GIMT_Encode4(60930), // Rule ID 148 //
     /*  60916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  60919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  60923 */     // (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$RB)  =>  (FRIZD:{ *:[f64] } f64:{ *:[f64] }:$RB)
     /*  60923 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FRIZD),
     /*  60928 */     GIR_RootConstrainSelectedInstOperands,
     /*  60929 */     // GIR_Coverage, 148,
     /*  60929 */     GIR_Done,
     /*  60930 */   // Label 838: @60930
     /*  60930 */   GIM_Reject,
     /*  60931 */ // Label 836: @60931
     /*  60931 */ GIM_Reject,
     /*  60932 */ // Label 829: @60932
     /*  60932 */ GIM_Try, /*On fail goto*//*Label 839*/ GIMT_Encode4(60962), // Rule ID 2157 //
     /*  60937 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  60940 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  60943 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60947 */   // (ftrunc:{ *:[f128] } f128:{ *:[f128] }:$vB)  =>  (XSRQPI:{ *:[f128] } 1:{ *:[i32] }, ?:{ *:[f128] }:$vB, 1:{ *:[i32] })
     /*  60947 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSRQPI),
     /*  60950 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VRT]
     /*  60952 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  60955 */   GIR_RootToRootCopy, /*OpIdx*/1, // vB
     /*  60957 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  60960 */   GIR_RootConstrainSelectedInstOperands,
     /*  60961 */   // GIR_Coverage, 2157,
     /*  60961 */   GIR_EraseRootFromParent_Done,
     /*  60962 */ // Label 839: @60962
     /*  60962 */ GIM_Reject,
     /*  60963 */ // Label 830: @60963
     /*  60963 */ GIM_Try, /*On fail goto*//*Label 840*/ GIMT_Encode4(60985), // Rule ID 919 //
     /*  60968 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  60971 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  60974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  60978 */   // (ftrunc:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB)  =>  (XVRDPIZ:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB)
     /*  60978 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVRDPIZ),
     /*  60983 */   GIR_RootConstrainSelectedInstOperands,
     /*  60984 */   // GIR_Coverage, 919,
     /*  60984 */   GIR_Done,
     /*  60985 */ // Label 840: @60985
     /*  60985 */ GIM_Reject,
     /*  60986 */ // Label 831: @60986
     /*  60986 */ GIM_Try, /*On fail goto*//*Label 841*/ GIMT_Encode4(61033),
     /*  60991 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  60994 */   GIM_Try, /*On fail goto*//*Label 842*/ GIMT_Encode4(61013), // Rule ID 927 //
     /*  60999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  61002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  61006 */     // (ftrunc:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB)  =>  (XVRSPIZ:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB)
     /*  61006 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVRSPIZ),
     /*  61011 */     GIR_RootConstrainSelectedInstOperands,
     /*  61012 */     // GIR_Coverage, 927,
     /*  61012 */     GIR_Done,
     /*  61013 */   // Label 842: @61013
     /*  61013 */   GIM_Try, /*On fail goto*//*Label 843*/ GIMT_Encode4(61032), // Rule ID 1415 //
     /*  61018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  61021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  61025 */     // (ftrunc:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$vA)  =>  (VRFIZ:{ *:[v4f32] } ?:{ *:[v4f32] }:$vA)
     /*  61025 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VRFIZ),
     /*  61030 */     GIR_RootConstrainSelectedInstOperands,
     /*  61031 */     // GIR_Coverage, 1415,
     /*  61031 */     GIR_Done,
     /*  61032 */   // Label 843: @61032
     /*  61032 */   GIM_Reject,
     /*  61033 */ // Label 841: @61033
     /*  61033 */ GIM_Reject,
     /*  61034 */ // Label 832: @61034
     /*  61034 */ GIM_Reject,
     /*  61035 */ // Label 13: @61035
     /*  61035 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 849*/ GIMT_Encode4(61284),
     /*  61046 */ /*GILLT_s32*//*Label 844*/ GIMT_Encode4(61066),
     /*  61050 */ /*GILLT_s64*//*Label 845*/ GIMT_Encode4(61159),
     /*  61054 */ /*GILLT_s128*//*Label 846*/ GIMT_Encode4(61207),
     /*  61058 */ /*GILLT_v2s64*//*Label 847*/ GIMT_Encode4(61238),
     /*  61062 */ /*GILLT_v4s32*//*Label 848*/ GIMT_Encode4(61261),
     /*  61066 */ // Label 844: @61066
     /*  61066 */ GIM_Try, /*On fail goto*//*Label 850*/ GIMT_Encode4(61158),
     /*  61071 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  61074 */   GIM_Try, /*On fail goto*//*Label 851*/ GIMT_Encode4(61138), // Rule ID 1700 //
     /*  61079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  61082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /*  61086 */     // (fround:{ *:[f32] } f32:{ *:[f32] }:$S)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (XSRDPI:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$S, VSFRC:{ *:[i32] })), VSSRC:{ *:[i32] })
     /*  61086 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  61089 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61093 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61098 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // S
     /*  61102 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  61107 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  61110 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSRDPI),
     /*  61114 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61119 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  61122 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  61124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61129 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61132 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSSRCRegClassID),
     /*  61137 */     // GIR_Coverage, 1700,
     /*  61137 */     GIR_EraseRootFromParent_Done,
     /*  61138 */   // Label 851: @61138
     /*  61138 */   GIM_Try, /*On fail goto*//*Label 852*/ GIMT_Encode4(61157), // Rule ID 142 //
     /*  61143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  61146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /*  61150 */     // (fround:{ *:[f32] } f32:{ *:[f32] }:$RB)  =>  (FRINS:{ *:[f32] } f32:{ *:[f32] }:$RB)
     /*  61150 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FRINS),
     /*  61155 */     GIR_RootConstrainSelectedInstOperands,
     /*  61156 */     // GIR_Coverage, 142,
     /*  61156 */     GIR_Done,
     /*  61157 */   // Label 852: @61157
     /*  61157 */   GIM_Reject,
     /*  61158 */ // Label 850: @61158
     /*  61158 */ GIM_Reject,
     /*  61159 */ // Label 845: @61159
     /*  61159 */ GIM_Try, /*On fail goto*//*Label 853*/ GIMT_Encode4(61206),
     /*  61164 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  61167 */   GIM_Try, /*On fail goto*//*Label 854*/ GIMT_Encode4(61186), // Rule ID 905 //
     /*  61172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  61175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  61179 */     // (fround:{ *:[f64] } f64:{ *:[f64] }:$XB)  =>  (XSRDPI:{ *:[f64] } f64:{ *:[f64] }:$XB)
     /*  61179 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSRDPI),
     /*  61184 */     GIR_RootConstrainSelectedInstOperands,
     /*  61185 */     // GIR_Coverage, 905,
     /*  61185 */     GIR_Done,
     /*  61186 */   // Label 854: @61186
     /*  61186 */   GIM_Try, /*On fail goto*//*Label 855*/ GIMT_Encode4(61205), // Rule ID 140 //
     /*  61191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  61194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  61198 */     // (fround:{ *:[f64] } f64:{ *:[f64] }:$RB)  =>  (FRIND:{ *:[f64] } f64:{ *:[f64] }:$RB)
     /*  61198 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FRIND),
     /*  61203 */     GIR_RootConstrainSelectedInstOperands,
     /*  61204 */     // GIR_Coverage, 140,
     /*  61204 */     GIR_Done,
     /*  61205 */   // Label 855: @61205
     /*  61205 */   GIM_Reject,
     /*  61206 */ // Label 853: @61206
     /*  61206 */ GIM_Reject,
     /*  61207 */ // Label 846: @61207
     /*  61207 */ GIM_Try, /*On fail goto*//*Label 856*/ GIMT_Encode4(61237), // Rule ID 2155 //
     /*  61212 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  61215 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  61218 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  61222 */   // (fround:{ *:[f128] } f128:{ *:[f128] }:$vB)  =>  (XSRQPI:{ *:[f128] } 0:{ *:[i32] }, ?:{ *:[f128] }:$vB, 0:{ *:[i32] })
     /*  61222 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSRQPI),
     /*  61225 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VRT]
     /*  61227 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61230 */   GIR_RootToRootCopy, /*OpIdx*/1, // vB
     /*  61232 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61235 */   GIR_RootConstrainSelectedInstOperands,
     /*  61236 */   // GIR_Coverage, 2155,
     /*  61236 */   GIR_EraseRootFromParent_Done,
     /*  61237 */ // Label 856: @61237
     /*  61237 */ GIM_Reject,
     /*  61238 */ // Label 847: @61238
     /*  61238 */ GIM_Try, /*On fail goto*//*Label 857*/ GIMT_Encode4(61260), // Rule ID 913 //
     /*  61243 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  61246 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  61249 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  61253 */   // (fround:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB)  =>  (XVRDPI:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB)
     /*  61253 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVRDPI),
     /*  61258 */   GIR_RootConstrainSelectedInstOperands,
     /*  61259 */   // GIR_Coverage, 913,
     /*  61259 */   GIR_Done,
     /*  61260 */ // Label 857: @61260
     /*  61260 */ GIM_Reject,
     /*  61261 */ // Label 848: @61261
     /*  61261 */ GIM_Try, /*On fail goto*//*Label 858*/ GIMT_Encode4(61283), // Rule ID 921 //
     /*  61266 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  61269 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  61272 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  61276 */   // (fround:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB)  =>  (XVRSPI:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB)
     /*  61276 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVRSPI),
     /*  61281 */   GIR_RootConstrainSelectedInstOperands,
     /*  61282 */   // GIR_Coverage, 921,
     /*  61282 */   GIR_Done,
     /*  61283 */ // Label 858: @61283
     /*  61283 */ GIM_Reject,
     /*  61284 */ // Label 849: @61284
     /*  61284 */ GIM_Reject,
     /*  61285 */ // Label 14: @61285
     /*  61285 */ GIM_Try, /*On fail goto*//*Label 859*/ GIMT_Encode4(61415),
     /*  61290 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  61293 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 862*/ GIMT_Encode4(61414),
     /*  61304 */   /*GILLT_s32*//*Label 860*/ GIMT_Encode4(61312),
     /*  61308 */   /*GILLT_s64*//*Label 861*/ GIMT_Encode4(61373),
     /*  61312 */   // Label 860: @61312
     /*  61312 */   GIM_Try, /*On fail goto*//*Label 863*/ GIMT_Encode4(61372), // Rule ID 2027 //
     /*  61317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX),
     /*  61320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  61324 */     // (lrint:{ *:[i64] } f32:{ *:[f32] }:$S)  =>  (MFVSRD:{ *:[i64] } (FCTID:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$S, F8RC:{ *:[i32] })))
     /*  61324 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  61327 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61331 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61336 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // S
     /*  61340 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::F8RCRegClassID),
     /*  61345 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  61348 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCTID),
     /*  61352 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61357 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  61360 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  61362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFVSRD),
     /*  61365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  61367 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61370 */     GIR_RootConstrainSelectedInstOperands,
     /*  61371 */     // GIR_Coverage, 2027,
     /*  61371 */     GIR_EraseRootFromParent_Done,
     /*  61372 */   // Label 863: @61372
     /*  61372 */   GIM_Reject,
     /*  61373 */   // Label 861: @61373
     /*  61373 */   GIM_Try, /*On fail goto*//*Label 864*/ GIMT_Encode4(61413), // Rule ID 2026 //
     /*  61378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX),
     /*  61381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  61385 */     // (lrint:{ *:[i64] } f64:{ *:[f64] }:$S)  =>  (MFVSRD:{ *:[i64] } (FCTID:{ *:[f64] } ?:{ *:[f64] }:$S))
     /*  61385 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  61388 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCTID),
     /*  61392 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61397 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // S
     /*  61401 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  61403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFVSRD),
     /*  61406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  61408 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61411 */     GIR_RootConstrainSelectedInstOperands,
     /*  61412 */     // GIR_Coverage, 2026,
     /*  61412 */     GIR_EraseRootFromParent_Done,
     /*  61413 */   // Label 864: @61413
     /*  61413 */   GIM_Reject,
     /*  61414 */   // Label 862: @61414
     /*  61414 */   GIM_Reject,
     /*  61415 */ // Label 859: @61415
     /*  61415 */ GIM_Reject,
     /*  61416 */ // Label 15: @61416
     /*  61416 */ GIM_Try, /*On fail goto*//*Label 865*/ GIMT_Encode4(61546),
     /*  61421 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  61424 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 868*/ GIMT_Encode4(61545),
     /*  61435 */   /*GILLT_s32*//*Label 866*/ GIMT_Encode4(61443),
     /*  61439 */   /*GILLT_s64*//*Label 867*/ GIMT_Encode4(61504),
     /*  61443 */   // Label 866: @61443
     /*  61443 */   GIM_Try, /*On fail goto*//*Label 869*/ GIMT_Encode4(61503), // Rule ID 2029 //
     /*  61448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX),
     /*  61451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  61455 */     // (llrint:{ *:[i64] } f32:{ *:[f32] }:$S)  =>  (MFVSRD:{ *:[i64] } (FCTID:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$S, F8RC:{ *:[i32] })))
     /*  61455 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  61458 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61462 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61467 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // S
     /*  61471 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::F8RCRegClassID),
     /*  61476 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  61479 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCTID),
     /*  61483 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61488 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  61491 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  61493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFVSRD),
     /*  61496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  61498 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61501 */     GIR_RootConstrainSelectedInstOperands,
     /*  61502 */     // GIR_Coverage, 2029,
     /*  61502 */     GIR_EraseRootFromParent_Done,
     /*  61503 */   // Label 869: @61503
     /*  61503 */   GIM_Reject,
     /*  61504 */   // Label 867: @61504
     /*  61504 */   GIM_Try, /*On fail goto*//*Label 870*/ GIMT_Encode4(61544), // Rule ID 2028 //
     /*  61509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX),
     /*  61512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  61516 */     // (llrint:{ *:[i64] } f64:{ *:[f64] }:$S)  =>  (MFVSRD:{ *:[i64] } (FCTID:{ *:[f64] } ?:{ *:[f64] }:$S))
     /*  61516 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  61519 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCTID),
     /*  61523 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61528 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // S
     /*  61532 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  61534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFVSRD),
     /*  61537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  61539 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61542 */     GIR_RootConstrainSelectedInstOperands,
     /*  61543 */     // GIR_Coverage, 2028,
     /*  61543 */     GIR_EraseRootFromParent_Done,
     /*  61544 */   // Label 870: @61544
     /*  61544 */   GIM_Reject,
     /*  61545 */   // Label 868: @61545
     /*  61545 */   GIM_Reject,
     /*  61546 */ // Label 865: @61546
     /*  61546 */ GIM_Reject,
     /*  61547 */ // Label 16: @61547
     /*  61547 */ GIM_Try, /*On fail goto*//*Label 871*/ GIMT_Encode4(61566), // Rule ID 635 //
     /*  61552 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  61555 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  61559 */   // (readcyclecounter:{ *:[i64] })  =>  (MFTB8:{ *:[i64] })
     /*  61559 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::MFTB8),
     /*  61564 */   GIR_RootConstrainSelectedInstOperands,
     /*  61565 */   // GIR_Coverage, 635,
     /*  61565 */   GIR_Done,
     /*  61566 */ // Label 871: @61566
     /*  61566 */ GIM_Reject,
     /*  61567 */ // Label 17: @61567
     /*  61567 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 874*/ GIMT_Encode4(61642),
     /*  61578 */ /*GILLT_s32*//*Label 872*/ GIMT_Encode4(61586),
     /*  61582 */ /*GILLT_s64*//*Label 873*/ GIMT_Encode4(61614),
     /*  61586 */ // Label 872: @61586
     /*  61586 */ GIM_Try, /*On fail goto*//*Label 875*/ GIMT_Encode4(61613), // Rule ID 1265 //
     /*  61591 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSYNC),
     /*  61594 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 7,
     /*  61598 */   // MIs[0] Operand 1
     /*  61598 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  61601 */   // (atomic_fence 7:{ *:[i32] }, (timm:{ *:[i32] }))  =>  (SYNC 0:{ *:[i32] })
     /*  61601 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SYNC),
     /*  61604 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61607 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  61611 */   GIR_RootConstrainSelectedInstOperands,
     /*  61612 */   // GIR_Coverage, 1265,
     /*  61612 */   GIR_EraseRootFromParent_Done,
     /*  61613 */ // Label 875: @61613
     /*  61613 */ GIM_Reject,
     /*  61614 */ // Label 873: @61614
     /*  61614 */ GIM_Try, /*On fail goto*//*Label 876*/ GIMT_Encode4(61641), // Rule ID 1264 //
     /*  61619 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSYNC),
     /*  61622 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 7,
     /*  61626 */   // MIs[0] Operand 1
     /*  61626 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  61629 */   // (atomic_fence 7:{ *:[i64] }, (timm:{ *:[i64] }))  =>  (SYNC 0:{ *:[i32] })
     /*  61629 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SYNC),
     /*  61632 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61635 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  61639 */   GIR_RootConstrainSelectedInstOperands,
     /*  61640 */   // GIR_Coverage, 1264,
     /*  61640 */   GIR_EraseRootFromParent_Done,
     /*  61641 */ // Label 876: @61641
     /*  61641 */ GIM_Reject,
     /*  61642 */ // Label 874: @61642
     /*  61642 */ GIM_Try, /*On fail goto*//*Label 877*/ GIMT_Encode4(61691),
     /*  61647 */   GIM_CheckIsImm, /*MI*/0, /*Op*/0,
     /*  61650 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  61653 */   GIM_Try, /*On fail goto*//*Label 878*/ GIMT_Encode4(61673), // Rule ID 1266 //
     /*  61658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSYNC),
     /*  61661 */     // (atomic_fence (timm:{ *:[iPTR] }), (timm:{ *:[iPTR] }))  =>  (SYNC 1:{ *:[i32] })
     /*  61661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SYNC),
     /*  61664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  61667 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  61671 */     GIR_RootConstrainSelectedInstOperands,
     /*  61672 */     // GIR_Coverage, 1266,
     /*  61672 */     GIR_EraseRootFromParent_Done,
     /*  61673 */   // Label 878: @61673
     /*  61673 */   GIM_Try, /*On fail goto*//*Label 879*/ GIMT_Encode4(61690), // Rule ID 1267 //
     /*  61678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasOnlyMSYNC),
     /*  61681 */     // (atomic_fence (timm:{ *:[iPTR] }), (timm:{ *:[iPTR] }))  =>  (MSYNC)
     /*  61681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MSYNC),
     /*  61684 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  61688 */     GIR_RootConstrainSelectedInstOperands,
     /*  61689 */     // GIR_Coverage, 1267,
     /*  61689 */     GIR_EraseRootFromParent_Done,
     /*  61690 */   // Label 879: @61690
     /*  61690 */   GIM_Reject,
     /*  61691 */ // Label 877: @61691
     /*  61691 */ GIM_Reject,
     /*  61692 */ // Label 18: @61692
     /*  61692 */ GIM_Try, /*On fail goto*//*Label 880*/ GIMT_Encode4(61754),
     /*  61697 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
     /*  61700 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /*  61703 */   GIM_Try, /*On fail goto*//*Label 881*/ GIMT_Encode4(61741), // Rule ID 17 //
     /*  61708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  61712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61716 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /*  61720 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /*  61724 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  61728 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  61730 */     // (brcond (xor:{ *:[i1] } i1:{ *:[i1] }:$BI, -1:{ *:[i1] }), (bb:{ *:[Other] }):$BD)  =>  (BCn i1:{ *:[i1] }:$BI, (bb:{ *:[Other] }):$BD)
     /*  61730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::BCn),
     /*  61733 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // BI
     /*  61737 */     GIR_RootToRootCopy, /*OpIdx*/1, // BD
     /*  61739 */     GIR_RootConstrainSelectedInstOperands,
     /*  61740 */     // GIR_Coverage, 17,
     /*  61740 */     GIR_EraseRootFromParent_Done,
     /*  61741 */   // Label 881: @61741
     /*  61741 */   GIM_Try, /*On fail goto*//*Label 882*/ GIMT_Encode4(61753), // Rule ID 16 //
     /*  61746 */     // (brcond i1:{ *:[i1] }:$BI, (bb:{ *:[Other] }):$BD)  =>  (BC i1:{ *:[i1] }:$BI, (bb:{ *:[Other] }):$BD)
     /*  61746 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::BC),
     /*  61751 */     GIR_RootConstrainSelectedInstOperands,
     /*  61752 */     // GIR_Coverage, 16,
     /*  61752 */     GIR_Done,
     /*  61753 */   // Label 882: @61753
     /*  61753 */   GIM_Reject,
     /*  61754 */ // Label 880: @61754
     /*  61754 */ GIM_Reject,
     /*  61755 */ // Label 19: @61755
     /*  61755 */ GIM_Try, /*On fail goto*//*Label 883*/ GIMT_Encode4(61903),
     /*  61760 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/2,
     /*  61763 */   GIM_Try, /*On fail goto*//*Label 884*/ GIMT_Encode4(61790), // Rule ID 1163 //
     /*  61768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture),
     /*  61771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_dmsetdmrz),
     /*  61776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  61779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  61783 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10502:{ *:[iPTR] })  =>  (DMSETDMRZ:{ *:[v1024i1] })
     /*  61783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DMSETDMRZ),
     /*  61786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  61788 */     GIR_RootConstrainSelectedInstOperands,
     /*  61789 */     // GIR_Coverage, 1163,
     /*  61789 */     GIR_EraseRootFromParent_Done,
     /*  61790 */   // Label 884: @61790
     /*  61790 */   GIM_Try, /*On fail goto*//*Label 885*/ GIMT_Encode4(61817), // Rule ID 1166 //
     /*  61795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  61798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xxsetaccz),
     /*  61803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  61806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  61810 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10564:{ *:[iPTR] })  =>  (XXSETACCZ:{ *:[v512i1] })
     /*  61810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSETACCZ),
     /*  61813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  61815 */     GIR_RootConstrainSelectedInstOperands,
     /*  61816 */     // GIR_Coverage, 1166,
     /*  61816 */     GIR_EraseRootFromParent_Done,
     /*  61817 */   // Label 885: @61817
     /*  61817 */   GIM_Try, /*On fail goto*//*Label 886*/ GIMT_Encode4(61844), // Rule ID 1167 //
     /*  61822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  61825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xxsetaccz),
     /*  61830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  61833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  61837 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10564:{ *:[iPTR] })  =>  (XXSETACCZW:{ *:[v512i1] })
     /*  61837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSETACCZW),
     /*  61840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  61842 */     GIR_RootConstrainSelectedInstOperands,
     /*  61843 */     // GIR_Coverage, 1167,
     /*  61843 */     GIR_EraseRootFromParent_Done,
     /*  61844 */   // Label 886: @61844
     /*  61844 */   GIM_Try, /*On fail goto*//*Label 887*/ GIMT_Encode4(61868), // Rule ID 4860 //
     /*  61849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mfmsr),
     /*  61854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  61861 */     // (intrinsic_wo_chain:{ *:[i32] } 10493:{ *:[iPTR] })  =>  (MFMSR:{ *:[i32] })
     /*  61861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFMSR),
     /*  61864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  61866 */     GIR_RootConstrainSelectedInstOperands,
     /*  61867 */     // GIR_Coverage, 4860,
     /*  61867 */     GIR_EraseRootFromParent_Done,
     /*  61868 */   // Label 887: @61868
     /*  61868 */   GIM_Try, /*On fail goto*//*Label 888*/ GIMT_Encode4(61902), // Rule ID 4861 //
     /*  61873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mftbu),
     /*  61878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  61885 */     // (intrinsic_wo_chain:{ *:[i32] } 10495:{ *:[iPTR] })  =>  (MFTB:{ *:[i32] } 269:{ *:[i32] })
     /*  61885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFTB),
     /*  61888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  61890 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(269),
     /*  61900 */     GIR_RootConstrainSelectedInstOperands,
     /*  61901 */     // GIR_Coverage, 4861,
     /*  61901 */     GIR_EraseRootFromParent_Done,
     /*  61902 */   // Label 888: @61902
     /*  61902 */   GIM_Reject,
     /*  61903 */ // Label 883: @61903
     /*  61903 */ GIM_Try, /*On fail goto*//*Label 889*/ GIMT_Encode4(65579),
     /*  61908 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  61911 */   GIM_Try, /*On fail goto*//*Label 890*/ GIMT_Encode4(61947), // Rule ID 1748 //
     /*  61916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  61919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_frsqrte),
     /*  61924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  61927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  61930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  61934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  61938 */     // (intrinsic_wo_chain:{ *:[f64] } 10468:{ *:[iPTR] }, vsfrc:{ *:[f64] }:$XB)  =>  (XSRSQRTEDP:{ *:[f64] } ?:{ *:[f64] }:$XB)
     /*  61938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSRSQRTEDP),
     /*  61941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  61943 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  61945 */     GIR_RootConstrainSelectedInstOperands,
     /*  61946 */     // GIR_Coverage, 1748,
     /*  61946 */     GIR_EraseRootFromParent_Done,
     /*  61947 */   // Label 890: @61947
     /*  61947 */   GIM_Try, /*On fail goto*//*Label 891*/ GIMT_Encode4(61983), // Rule ID 1939 //
     /*  61952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /*  61955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_frsqrtes),
     /*  61960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /*  61970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /*  61974 */     // (intrinsic_wo_chain:{ *:[f32] } 10469:{ *:[iPTR] }, vssrc:{ *:[f32] }:$XB)  =>  (XSRSQRTESP:{ *:[f32] } ?:{ *:[f32] }:$XB)
     /*  61974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSRSQRTESP),
     /*  61977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  61979 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  61981 */     GIR_RootConstrainSelectedInstOperands,
     /*  61982 */     // GIR_Coverage, 1939,
     /*  61982 */     GIR_EraseRootFromParent_Done,
     /*  61983 */   // Label 891: @61983
     /*  61983 */   GIM_Try, /*On fail goto*//*Label 892*/ GIMT_Encode4(62015), // Rule ID 872 //
     /*  61988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  61991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcvdpsp),
     /*  61996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  61999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62006 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10657:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$XB)  =>  (XVCVDPSP:{ *:[v4f32] } v2f64:{ *:[v2f64] }:$XB)
     /*  62006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCVDPSP),
     /*  62009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62011 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  62013 */     GIR_RootConstrainSelectedInstOperands,
     /*  62014 */     // GIR_Coverage, 872,
     /*  62014 */     GIR_EraseRootFromParent_Done,
     /*  62015 */   // Label 892: @62015
     /*  62015 */   GIM_Try, /*On fail goto*//*Label 893*/ GIMT_Encode4(62047), // Rule ID 875 //
     /*  62020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcvdpsxws),
     /*  62028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  62031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62038 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10658:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$XB)  =>  (XVCVDPSXWS:{ *:[v4i32] } v2f64:{ *:[v2f64] }:$XB)
     /*  62038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCVDPSXWS),
     /*  62041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62043 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  62045 */     GIR_RootConstrainSelectedInstOperands,
     /*  62046 */     // GIR_Coverage, 875,
     /*  62046 */     GIR_EraseRootFromParent_Done,
     /*  62047 */   // Label 893: @62047
     /*  62047 */   GIM_Try, /*On fail goto*//*Label 894*/ GIMT_Encode4(62079), // Rule ID 878 //
     /*  62052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcvdpuxws),
     /*  62060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  62063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62070 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10659:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$XB)  =>  (XVCVDPUXWS:{ *:[v4i32] } v2f64:{ *:[v2f64] }:$XB)
     /*  62070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCVDPUXWS),
     /*  62073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62075 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  62077 */     GIR_RootConstrainSelectedInstOperands,
     /*  62078 */     // GIR_Coverage, 878,
     /*  62078 */     GIR_EraseRootFromParent_Done,
     /*  62079 */   // Label 894: @62079
     /*  62079 */   GIM_Try, /*On fail goto*//*Label 895*/ GIMT_Encode4(62111), // Rule ID 879 //
     /*  62084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcvspdp),
     /*  62092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  62095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62102 */     // (intrinsic_wo_chain:{ *:[v2f64] } 10662:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$XB)  =>  (XVCVSPDP:{ *:[v2f64] } v4f32:{ *:[v4f32] }:$XB)
     /*  62102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCVSPDP),
     /*  62105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62107 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  62109 */     GIR_RootConstrainSelectedInstOperands,
     /*  62110 */     // GIR_Coverage, 879,
     /*  62110 */     GIR_EraseRootFromParent_Done,
     /*  62111 */   // Label 895: @62111
     /*  62111 */   GIM_Try, /*On fail goto*//*Label 896*/ GIMT_Encode4(62143), // Rule ID 880 //
     /*  62116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcvspsxds),
     /*  62124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  62127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62134 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10664:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$XB)  =>  (XVCVSPSXDS:{ *:[v2i64] } v4f32:{ *:[v4f32] }:$XB)
     /*  62134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCVSPSXDS),
     /*  62137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62139 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  62141 */     GIR_RootConstrainSelectedInstOperands,
     /*  62142 */     // GIR_Coverage, 880,
     /*  62142 */     GIR_EraseRootFromParent_Done,
     /*  62143 */   // Label 896: @62143
     /*  62143 */   GIM_Try, /*On fail goto*//*Label 897*/ GIMT_Encode4(62175), // Rule ID 883 //
     /*  62148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcvspuxds),
     /*  62156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  62159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62166 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10665:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$XB)  =>  (XVCVSPUXDS:{ *:[v2i64] } v4f32:{ *:[v4f32] }:$XB)
     /*  62166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCVSPUXDS),
     /*  62169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62171 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  62173 */     GIR_RootConstrainSelectedInstOperands,
     /*  62174 */     // GIR_Coverage, 883,
     /*  62174 */     GIR_EraseRootFromParent_Done,
     /*  62175 */   // Label 897: @62175
     /*  62175 */   GIM_Try, /*On fail goto*//*Label 898*/ GIMT_Encode4(62207), // Rule ID 888 //
     /*  62180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcvsxdsp),
     /*  62188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  62191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62198 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10666:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$XB)  =>  (XVCVSXDSP:{ *:[v4f32] } v2i64:{ *:[v2i64] }:$XB)
     /*  62198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCVSXDSP),
     /*  62201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62203 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  62205 */     GIR_RootConstrainSelectedInstOperands,
     /*  62206 */     // GIR_Coverage, 888,
     /*  62206 */     GIR_EraseRootFromParent_Done,
     /*  62207 */   // Label 898: @62207
     /*  62207 */   GIM_Try, /*On fail goto*//*Label 899*/ GIMT_Encode4(62239), // Rule ID 893 //
     /*  62212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcvuxdsp),
     /*  62220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  62223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62230 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10668:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$XB)  =>  (XVCVUXDSP:{ *:[v4f32] } v2i64:{ *:[v2i64] }:$XB)
     /*  62230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCVUXDSP),
     /*  62233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62235 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  62237 */     GIR_RootConstrainSelectedInstOperands,
     /*  62238 */     // GIR_Coverage, 893,
     /*  62238 */     GIR_EraseRootFromParent_Done,
     /*  62239 */   // Label 899: @62239
     /*  62239 */   GIM_Try, /*On fail goto*//*Label 900*/ GIMT_Encode4(62271), // Rule ID 896 //
     /*  62244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcvsxwdp),
     /*  62252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  62255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62262 */     // (intrinsic_wo_chain:{ *:[v2f64] } 10667:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$XB)  =>  (XVCVSXWDP:{ *:[v2f64] } v4i32:{ *:[v4i32] }:$XB)
     /*  62262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCVSXWDP),
     /*  62265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62267 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  62269 */     GIR_RootConstrainSelectedInstOperands,
     /*  62270 */     // GIR_Coverage, 896,
     /*  62270 */     GIR_EraseRootFromParent_Done,
     /*  62271 */   // Label 900: @62271
     /*  62271 */   GIM_Try, /*On fail goto*//*Label 901*/ GIMT_Encode4(62303), // Rule ID 897 //
     /*  62276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcvuxwdp),
     /*  62284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  62287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62294 */     // (intrinsic_wo_chain:{ *:[v2f64] } 10669:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$XB)  =>  (XVCVUXWDP:{ *:[v2f64] } v4i32:{ *:[v4i32] }:$XB)
     /*  62294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCVUXWDP),
     /*  62297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62299 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  62301 */     GIR_RootConstrainSelectedInstOperands,
     /*  62302 */     // GIR_Coverage, 897,
     /*  62302 */     GIR_EraseRootFromParent_Done,
     /*  62303 */   // Label 901: @62303
     /*  62303 */   GIM_Try, /*On fail goto*//*Label 902*/ GIMT_Encode4(62335), // Rule ID 1005 //
     /*  62308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  62311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_sqrtf128_round_to_odd),
     /*  62316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  62319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  62322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  62326 */     // (intrinsic_wo_chain:{ *:[f128] } 10593:{ *:[iPTR] }, f128:{ *:[f128] }:$RB)  =>  (XSSQRTQPO:{ *:[f128] } f128:{ *:[f128] }:$RB)
     /*  62326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSSQRTQPO),
     /*  62329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  62331 */     GIR_RootToRootCopy, /*OpIdx*/2, // RB
     /*  62333 */     GIR_RootConstrainSelectedInstOperands,
     /*  62334 */     // GIR_Coverage, 1005,
     /*  62334 */     GIR_EraseRootFromParent_Done,
     /*  62335 */   // Label 902: @62335
     /*  62335 */   GIM_Try, /*On fail goto*//*Label 903*/ GIMT_Encode4(62367), // Rule ID 1012 //
     /*  62340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  62343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_truncf128_round_to_odd),
     /*  62348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  62351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  62354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VFRCRegClassID),
     /*  62358 */     // (intrinsic_wo_chain:{ *:[f64] } 10620:{ *:[iPTR] }, f128:{ *:[f128] }:$RB)  =>  (XSCVQPDPO:{ *:[f64] } f128:{ *:[f128] }:$RB)
     /*  62358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSCVQPDPO),
     /*  62361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  62363 */     GIR_RootToRootCopy, /*OpIdx*/2, // RB
     /*  62365 */     GIR_RootConstrainSelectedInstOperands,
     /*  62366 */     // GIR_Coverage, 1012,
     /*  62366 */     GIR_EraseRootFromParent_Done,
     /*  62367 */   // Label 903: @62367
     /*  62367 */   GIM_Try, /*On fail goto*//*Label 904*/ GIMT_Encode4(62399), // Rule ID 1021 //
     /*  62372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  62375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcvsphp),
     /*  62380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  62383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62390 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10663:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$XB)  =>  (XVCVSPHP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB)
     /*  62390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCVSPHP),
     /*  62393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62395 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  62397 */     GIR_RootConstrainSelectedInstOperands,
     /*  62398 */     // GIR_Coverage, 1021,
     /*  62398 */     GIR_EraseRootFromParent_Done,
     /*  62399 */   // Label 904: @62399
     /*  62399 */   GIM_Try, /*On fail goto*//*Label 905*/ GIMT_Encode4(62431), // Rule ID 1025 //
     /*  62404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  62407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvxexpdp),
     /*  62412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  62415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62422 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10691:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$XB)  =>  (XVXEXPDP:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$XB)
     /*  62422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVXEXPDP),
     /*  62425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62427 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  62429 */     GIR_RootConstrainSelectedInstOperands,
     /*  62430 */     // GIR_Coverage, 1025,
     /*  62430 */     GIR_EraseRootFromParent_Done,
     /*  62431 */   // Label 905: @62431
     /*  62431 */   GIM_Try, /*On fail goto*//*Label 906*/ GIMT_Encode4(62463), // Rule ID 1026 //
     /*  62436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  62439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvxexpsp),
     /*  62444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  62447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62454 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10692:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$XB)  =>  (XVXEXPSP:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$XB)
     /*  62454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVXEXPSP),
     /*  62457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62459 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  62461 */     GIR_RootConstrainSelectedInstOperands,
     /*  62462 */     // GIR_Coverage, 1026,
     /*  62462 */     GIR_EraseRootFromParent_Done,
     /*  62463 */   // Label 906: @62463
     /*  62463 */   GIM_Try, /*On fail goto*//*Label 907*/ GIMT_Encode4(62495), // Rule ID 1027 //
     /*  62468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  62471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvxsigdp),
     /*  62476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  62479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62486 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10693:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$XB)  =>  (XVXSIGDP:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$XB)
     /*  62486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVXSIGDP),
     /*  62489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62491 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  62493 */     GIR_RootConstrainSelectedInstOperands,
     /*  62494 */     // GIR_Coverage, 1027,
     /*  62494 */     GIR_EraseRootFromParent_Done,
     /*  62495 */   // Label 907: @62495
     /*  62495 */   GIM_Try, /*On fail goto*//*Label 908*/ GIMT_Encode4(62527), // Rule ID 1028 //
     /*  62500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  62503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvxsigsp),
     /*  62508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  62511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62518 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10694:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$XB)  =>  (XVXSIGSP:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$XB)
     /*  62518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVXSIGSP),
     /*  62521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62523 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  62525 */     GIR_RootConstrainSelectedInstOperands,
     /*  62526 */     // GIR_Coverage, 1028,
     /*  62526 */     GIR_EraseRootFromParent_Done,
     /*  62527 */   // Label 908: @62527
     /*  62527 */   GIM_Try, /*On fail goto*//*Label 909*/ GIMT_Encode4(62582), // Rule ID 1656 //
     /*  62532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvtsqrtdp),
     /*  62540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  62543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  62550 */     // (intrinsic_wo_chain:{ *:[i32] } 10687:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (XVTSQRTDP:{ *:[i32] } ?:{ *:[v2f64] }:$A), GPRC:{ *:[i32] })
     /*  62550 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  62553 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XVTSQRTDP),
     /*  62557 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62562 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // A
     /*  62566 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  62568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  62571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62573 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62576 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  62581 */     // GIR_Coverage, 1656,
     /*  62581 */     GIR_EraseRootFromParent_Done,
     /*  62582 */   // Label 909: @62582
     /*  62582 */   GIM_Try, /*On fail goto*//*Label 910*/ GIMT_Encode4(62637), // Rule ID 1657 //
     /*  62587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvtsqrtsp),
     /*  62595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  62598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  62605 */     // (intrinsic_wo_chain:{ *:[i32] } 10688:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (XVTSQRTSP:{ *:[i32] } ?:{ *:[v4f32] }:$A), GPRC:{ *:[i32] })
     /*  62605 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  62608 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XVTSQRTSP),
     /*  62612 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62617 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // A
     /*  62621 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  62623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  62626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62628 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62631 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  62636 */     // GIR_Coverage, 1657,
     /*  62636 */     GIR_EraseRootFromParent_Done,
     /*  62637 */   // Label 910: @62637
     /*  62637 */   GIM_Try, /*On fail goto*//*Label 911*/ GIMT_Encode4(62669), // Rule ID 1658 //
     /*  62642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvresp),
     /*  62650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  62653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62660 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10680:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$A)  =>  (XVRESP:{ *:[v4f32] } ?:{ *:[v4f32] }:$A)
     /*  62660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVRESP),
     /*  62663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62665 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  62667 */     GIR_RootConstrainSelectedInstOperands,
     /*  62668 */     // GIR_Coverage, 1658,
     /*  62668 */     GIR_EraseRootFromParent_Done,
     /*  62669 */   // Label 911: @62669
     /*  62669 */   GIM_Try, /*On fail goto*//*Label 912*/ GIMT_Encode4(62701), // Rule ID 1659 //
     /*  62674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvredp),
     /*  62682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  62685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62692 */     // (intrinsic_wo_chain:{ *:[v2f64] } 10679:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$A)  =>  (XVREDP:{ *:[v2f64] } ?:{ *:[v2f64] }:$A)
     /*  62692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVREDP),
     /*  62695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62697 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  62699 */     GIR_RootConstrainSelectedInstOperands,
     /*  62700 */     // GIR_Coverage, 1659,
     /*  62700 */     GIR_EraseRootFromParent_Done,
     /*  62701 */   // Label 912: @62701
     /*  62701 */   GIM_Try, /*On fail goto*//*Label 913*/ GIMT_Encode4(62733), // Rule ID 1660 //
     /*  62706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvrsqrtesp),
     /*  62714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  62717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62724 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10683:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$A)  =>  (XVRSQRTESP:{ *:[v4f32] } ?:{ *:[v4f32] }:$A)
     /*  62724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVRSQRTESP),
     /*  62727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62729 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  62731 */     GIR_RootConstrainSelectedInstOperands,
     /*  62732 */     // GIR_Coverage, 1660,
     /*  62732 */     GIR_EraseRootFromParent_Done,
     /*  62733 */   // Label 913: @62733
     /*  62733 */   GIM_Try, /*On fail goto*//*Label 914*/ GIMT_Encode4(62765), // Rule ID 1661 //
     /*  62738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvrsqrtedp),
     /*  62746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  62749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62756 */     // (intrinsic_wo_chain:{ *:[v2f64] } 10682:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$A)  =>  (XVRSQRTEDP:{ *:[v2f64] } ?:{ *:[v2f64] }:$A)
     /*  62756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVRSQRTEDP),
     /*  62759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62761 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  62763 */     GIR_RootConstrainSelectedInstOperands,
     /*  62764 */     // GIR_Coverage, 1661,
     /*  62764 */     GIR_EraseRootFromParent_Done,
     /*  62765 */   // Label 914: @62765
     /*  62765 */   GIM_Try, /*On fail goto*//*Label 915*/ GIMT_Encode4(62797), // Rule ID 1747 //
     /*  62770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fre),
     /*  62778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  62781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  62784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  62788 */     // (intrinsic_wo_chain:{ *:[f64] } 10466:{ *:[iPTR] }, f64:{ *:[f64] }:$A)  =>  (XSREDP:{ *:[f64] } ?:{ *:[f64] }:$A)
     /*  62788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSREDP),
     /*  62791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62793 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  62795 */     GIR_RootConstrainSelectedInstOperands,
     /*  62796 */     // GIR_Coverage, 1747,
     /*  62796 */     GIR_EraseRootFromParent_Done,
     /*  62797 */   // Label 915: @62797
     /*  62797 */   GIM_Try, /*On fail goto*//*Label 916*/ GIMT_Encode4(62829), // Rule ID 1749 //
     /*  62802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fnabs),
     /*  62810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  62813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  62816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  62820 */     // (intrinsic_wo_chain:{ *:[f64] } 10461:{ *:[iPTR] }, f64:{ *:[f64] }:$A)  =>  (XSNABSDP:{ *:[f64] } ?:{ *:[f64] }:$A)
     /*  62820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNABSDP),
     /*  62823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62825 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  62827 */     GIR_RootConstrainSelectedInstOperands,
     /*  62828 */     // GIR_Coverage, 1749,
     /*  62828 */     GIR_EraseRootFromParent_Done,
     /*  62829 */   // Label 916: @62829
     /*  62829 */   GIM_Try, /*On fail goto*//*Label 917*/ GIMT_Encode4(62861), // Rule ID 1750 //
     /*  62834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fnabss),
     /*  62842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  62845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  62848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /*  62852 */     // (intrinsic_wo_chain:{ *:[f32] } 10462:{ *:[iPTR] }, f32:{ *:[f32] }:$A)  =>  (XSNABSDPs:{ *:[f32] } ?:{ *:[f32] }:$A)
     /*  62852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNABSDPs),
     /*  62855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62857 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  62859 */     GIR_RootConstrainSelectedInstOperands,
     /*  62860 */     // GIR_Coverage, 1750,
     /*  62860 */     GIR_EraseRootFromParent_Done,
     /*  62861 */   // Label 917: @62861
     /*  62861 */   GIM_Try, /*On fail goto*//*Label 918*/ GIMT_Encode4(62893), // Rule ID 1934 //
     /*  62866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /*  62869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fres),
     /*  62874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  62877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  62880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /*  62884 */     // (intrinsic_wo_chain:{ *:[f32] } 10467:{ *:[iPTR] }, f32:{ *:[f32] }:$A)  =>  (XSRESP:{ *:[f32] } ?:{ *:[f32] }:$A)
     /*  62884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSRESP),
     /*  62887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62889 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  62891 */     GIR_RootConstrainSelectedInstOperands,
     /*  62892 */     // GIR_Coverage, 1934,
     /*  62892 */     GIR_EraseRootFromParent_Done,
     /*  62893 */   // Label 918: @62893
     /*  62893 */   GIM_Try, /*On fail goto*//*Label 919*/ GIMT_Encode4(62977), // Rule ID 1935 //
     /*  62898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /*  62901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_extract_exp),
     /*  62906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  62909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  62912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  62916 */     // (intrinsic_wo_chain:{ *:[i32] } 10446:{ *:[iPTR] }, f64:{ *:[f64] }:$A)  =>  (EXTRACT_SUBREG:{ *:[i32] } (XSXEXPDP:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f64] }:$A, VSFRC:{ *:[i32] })), sub_32:{ *:[i32] })
     /*  62916 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  62919 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  62923 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62928 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // A
     /*  62932 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  62937 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  62940 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSXEXPDP),
     /*  62944 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62949 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  62952 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  62954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  62957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62959 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /*  62966 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  62971 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /*  62976 */     // GIR_Coverage, 1935,
     /*  62976 */     GIR_EraseRootFromParent_Done,
     /*  62977 */   // Label 919: @62977
     /*  62977 */   GIM_Try, /*On fail goto*//*Label 920*/ GIMT_Encode4(63031), // Rule ID 1936 //
     /*  62982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /*  62985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_extract_sig),
     /*  62990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  62993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  62996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  63000 */     // (intrinsic_wo_chain:{ *:[i64] } 10447:{ *:[iPTR] }, f64:{ *:[f64] }:$A)  =>  (XSXSIGDP:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f64] }:$A, VSFRC:{ *:[i32] }))
     /*  63000 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  63003 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  63007 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63012 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // A
     /*  63016 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  63021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSXSIGDP),
     /*  63024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  63026 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63029 */     GIR_RootConstrainSelectedInstOperands,
     /*  63030 */     // GIR_Coverage, 1936,
     /*  63030 */     GIR_EraseRootFromParent_Done,
     /*  63031 */   // Label 920: @63031
     /*  63031 */   GIM_Try, /*On fail goto*//*Label 921*/ GIMT_Encode4(63085), // Rule ID 2151 //
     /*  63036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  63039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcvhpsp),
     /*  63044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  63050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  63054 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10660:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$A)  =>  (XVCVHPSP:{ *:[v4f32] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v8i16] }:$A, VSRC:{ *:[i32] }))
     /*  63054 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63057 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  63061 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63066 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // A
     /*  63070 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  63075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCVHPSP),
     /*  63078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  63080 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63083 */     GIR_RootConstrainSelectedInstOperands,
     /*  63084 */     // GIR_Coverage, 2151,
     /*  63084 */     GIR_EraseRootFromParent_Done,
     /*  63085 */   // Label 921: @63085
     /*  63085 */   GIM_Try, /*On fail goto*//*Label 922*/ GIMT_Encode4(63165), // Rule ID 2165 //
     /*  63090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  63093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_scalar_extract_expq),
     /*  63098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  63101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  63104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  63108 */     // (intrinsic_wo_chain:{ *:[i64] } 10584:{ *:[iPTR] }, f128:{ *:[f128] }:$vA)  =>  (MFVSRD:{ *:[i64] } (EXTRACT_SUBREG:{ *:[f64] } (XSXEXPQP:{ *:[v2i64] } ?:{ *:[f128] }:$vA), sub_64:{ *:[i32] }))
     /*  63108 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  63111 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSXEXPQP),
     /*  63115 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63120 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // vA
     /*  63124 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  63126 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  63129 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  63133 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63138 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_64),
     /*  63145 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VFRCRegClassID),
     /*  63150 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFVSRD),
     /*  63158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  63160 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63163 */     GIR_RootConstrainSelectedInstOperands,
     /*  63164 */     // GIR_Coverage, 2165,
     /*  63164 */     GIR_EraseRootFromParent_Done,
     /*  63165 */   // Label 922: @63165
     /*  63165 */   GIM_Try, /*On fail goto*//*Label 923*/ GIMT_Encode4(63208), // Rule ID 1093 //
     /*  63170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  63173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_mtvsrbm),
     /*  63178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  63181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  63184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  63192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63196 */     // MIs[1] Operand 1
     /*  63196 */     // No operand predicates
     /*  63196 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63198 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10111:{ *:[iPTR] }, (imm:{ *:[i64] }):$D)  =>  (MTVSRBMI:{ *:[v16i8] } (imm:{ *:[i64] }):$D)
     /*  63198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTVSRBMI),
     /*  63201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  63203 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // D
     /*  63206 */     GIR_RootConstrainSelectedInstOperands,
     /*  63207 */     // GIR_Coverage, 1093,
     /*  63207 */     GIR_EraseRootFromParent_Done,
     /*  63208 */   // Label 923: @63208
     /*  63208 */   GIM_Try, /*On fail goto*//*Label 924*/ GIMT_Encode4(63241), // Rule ID 4818 //
     /*  63213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_frsqrte),
     /*  63218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  63221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  63224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  63228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  63232 */     // (intrinsic_wo_chain:{ *:[f64] } 10468:{ *:[iPTR] }, f8rc:{ *:[f64] }:$frB)  =>  (FRSQRTE:{ *:[f64] } ?:{ *:[f64] }:$frB)
     /*  63232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FRSQRTE),
     /*  63235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  63237 */     GIR_RootToRootCopy, /*OpIdx*/2, // frB
     /*  63239 */     GIR_RootConstrainSelectedInstOperands,
     /*  63240 */     // GIR_Coverage, 4818,
     /*  63240 */     GIR_EraseRootFromParent_Done,
     /*  63241 */   // Label 924: @63241
     /*  63241 */   GIM_Try, /*On fail goto*//*Label 925*/ GIMT_Encode4(63274), // Rule ID 4819 //
     /*  63246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_frsqrtes),
     /*  63251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  63254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  63257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /*  63261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /*  63265 */     // (intrinsic_wo_chain:{ *:[f32] } 10469:{ *:[iPTR] }, f4rc:{ *:[f32] }:$frB)  =>  (FRSQRTES:{ *:[f32] } ?:{ *:[f32] }:$frB)
     /*  63265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FRSQRTES),
     /*  63268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  63270 */     GIR_RootToRootCopy, /*OpIdx*/2, // frB
     /*  63272 */     GIR_RootConstrainSelectedInstOperands,
     /*  63273 */     // GIR_Coverage, 4819,
     /*  63273 */     GIR_EraseRootFromParent_Done,
     /*  63274 */   // Label 925: @63274
     /*  63274 */   GIM_Try, /*On fail goto*//*Label 926*/ GIMT_Encode4(63303), // Rule ID 73 //
     /*  63279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_popcntb),
     /*  63284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  63287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  63290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  63294 */     // (intrinsic_wo_chain:{ *:[i32] } 10579:{ *:[iPTR] }, i32:{ *:[i32] }:$RST)  =>  (POPCNTB:{ *:[i32] } i32:{ *:[i32] }:$RST)
     /*  63294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::POPCNTB),
     /*  63297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  63299 */     GIR_RootToRootCopy, /*OpIdx*/2, // RST
     /*  63301 */     GIR_RootConstrainSelectedInstOperands,
     /*  63302 */     // GIR_Coverage, 73,
     /*  63302 */     GIR_EraseRootFromParent_Done,
     /*  63303 */   // Label 926: @63303
     /*  63303 */   GIM_Try, /*On fail goto*//*Label 927*/ GIMT_Encode4(63332), // Rule ID 74 //
     /*  63308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_cdtbcd),
     /*  63313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  63316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  63319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  63323 */     // (intrinsic_wo_chain:{ *:[i32] } 10405:{ *:[iPTR] }, i32:{ *:[i32] }:$RST)  =>  (CDTBCD:{ *:[i32] } i32:{ *:[i32] }:$RST)
     /*  63323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CDTBCD),
     /*  63326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  63328 */     GIR_RootToRootCopy, /*OpIdx*/2, // RST
     /*  63330 */     GIR_RootConstrainSelectedInstOperands,
     /*  63331 */     // GIR_Coverage, 74,
     /*  63331 */     GIR_EraseRootFromParent_Done,
     /*  63332 */   // Label 927: @63332
     /*  63332 */   GIM_Try, /*On fail goto*//*Label 928*/ GIMT_Encode4(63361), // Rule ID 75 //
     /*  63337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_cbcdtd),
     /*  63342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  63345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  63348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  63352 */     // (intrinsic_wo_chain:{ *:[i32] } 10403:{ *:[iPTR] }, i32:{ *:[i32] }:$RST)  =>  (CBCDTD:{ *:[i32] } i32:{ *:[i32] }:$RST)
     /*  63352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CBCDTD),
     /*  63355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  63357 */     GIR_RootToRootCopy, /*OpIdx*/2, // RST
     /*  63359 */     GIR_RootConstrainSelectedInstOperands,
     /*  63360 */     // GIR_Coverage, 75,
     /*  63360 */     GIR_EraseRootFromParent_Done,
     /*  63361 */   // Label 928: @63361
     /*  63361 */   GIM_Try, /*On fail goto*//*Label 929*/ GIMT_Encode4(63393), // Rule ID 321 //
     /*  63366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  63369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vexptefp),
     /*  63374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  63380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63384 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10218:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$VB)  =>  (VEXPTEFP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$VB)
     /*  63384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXPTEFP),
     /*  63387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63389 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  63391 */     GIR_RootConstrainSelectedInstOperands,
     /*  63392 */     // GIR_Coverage, 321,
     /*  63392 */     GIR_EraseRootFromParent_Done,
     /*  63393 */   // Label 929: @63393
     /*  63393 */   GIM_Try, /*On fail goto*//*Label 930*/ GIMT_Encode4(63425), // Rule ID 322 //
     /*  63398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  63401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vlogefp),
     /*  63406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  63412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63416 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10256:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$VB)  =>  (VLOGEFP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$VB)
     /*  63416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VLOGEFP),
     /*  63419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63421 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  63423 */     GIR_RootConstrainSelectedInstOperands,
     /*  63424 */     // GIR_Coverage, 322,
     /*  63424 */     GIR_EraseRootFromParent_Done,
     /*  63425 */   // Label 930: @63425
     /*  63425 */   GIM_Try, /*On fail goto*//*Label 931*/ GIMT_Encode4(63457), // Rule ID 363 //
     /*  63430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  63433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vrefp),
     /*  63438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  63444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63448 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10324:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$VB)  =>  (VREFP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$VB)
     /*  63448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VREFP),
     /*  63451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63453 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  63455 */     GIR_RootConstrainSelectedInstOperands,
     /*  63456 */     // GIR_Coverage, 363,
     /*  63456 */     GIR_EraseRootFromParent_Done,
     /*  63457 */   // Label 931: @63457
     /*  63457 */   GIM_Try, /*On fail goto*//*Label 932*/ GIMT_Encode4(63489), // Rule ID 364 //
     /*  63462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  63465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vrfim),
     /*  63470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  63476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63480 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10325:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$VB)  =>  (VRFIM:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$VB)
     /*  63480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VRFIM),
     /*  63483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63485 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  63487 */     GIR_RootConstrainSelectedInstOperands,
     /*  63488 */     // GIR_Coverage, 364,
     /*  63488 */     GIR_EraseRootFromParent_Done,
     /*  63489 */   // Label 932: @63489
     /*  63489 */   GIM_Try, /*On fail goto*//*Label 933*/ GIMT_Encode4(63521), // Rule ID 365 //
     /*  63494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  63497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vrfin),
     /*  63502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  63508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63512 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10326:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$VB)  =>  (VRFIN:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$VB)
     /*  63512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VRFIN),
     /*  63515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63517 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  63519 */     GIR_RootConstrainSelectedInstOperands,
     /*  63520 */     // GIR_Coverage, 365,
     /*  63520 */     GIR_EraseRootFromParent_Done,
     /*  63521 */   // Label 933: @63521
     /*  63521 */   GIM_Try, /*On fail goto*//*Label 934*/ GIMT_Encode4(63553), // Rule ID 366 //
     /*  63526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  63529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vrfip),
     /*  63534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  63540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63544 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10327:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$VB)  =>  (VRFIP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$VB)
     /*  63544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VRFIP),
     /*  63547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63549 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  63551 */     GIR_RootConstrainSelectedInstOperands,
     /*  63552 */     // GIR_Coverage, 366,
     /*  63552 */     GIR_EraseRootFromParent_Done,
     /*  63553 */   // Label 934: @63553
     /*  63553 */   GIM_Try, /*On fail goto*//*Label 935*/ GIMT_Encode4(63585), // Rule ID 367 //
     /*  63558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  63561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vrfiz),
     /*  63566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  63572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63576 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10328:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$VB)  =>  (VRFIZ:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$VB)
     /*  63576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VRFIZ),
     /*  63579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63581 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  63583 */     GIR_RootConstrainSelectedInstOperands,
     /*  63584 */     // GIR_Coverage, 367,
     /*  63584 */     GIR_EraseRootFromParent_Done,
     /*  63585 */   // Label 935: @63585
     /*  63585 */   GIM_Try, /*On fail goto*//*Label 936*/ GIMT_Encode4(63617), // Rule ID 368 //
     /*  63590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  63593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vrsqrtefp),
     /*  63598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  63604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63608 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10339:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$VB)  =>  (VRSQRTEFP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$VB)
     /*  63608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VRSQRTEFP),
     /*  63611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63613 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  63615 */     GIR_RootConstrainSelectedInstOperands,
     /*  63616 */     // GIR_Coverage, 368,
     /*  63616 */     GIR_EraseRootFromParent_Done,
     /*  63617 */   // Label 936: @63617
     /*  63617 */   GIM_Try, /*On fail goto*//*Label 937*/ GIMT_Encode4(63649), // Rule ID 419 //
     /*  63622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  63625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vupkhpx),
     /*  63630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  63636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63640 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10381:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VB)  =>  (VUPKHPX:{ *:[v4i32] } v8i16:{ *:[v8i16] }:$VB)
     /*  63640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VUPKHPX),
     /*  63643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63645 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  63647 */     GIR_RootConstrainSelectedInstOperands,
     /*  63648 */     // GIR_Coverage, 419,
     /*  63648 */     GIR_EraseRootFromParent_Done,
     /*  63649 */   // Label 937: @63649
     /*  63649 */   GIM_Try, /*On fail goto*//*Label 938*/ GIMT_Encode4(63681), // Rule ID 420 //
     /*  63654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  63657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vupkhsb),
     /*  63662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  63665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  63668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63672 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10382:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VB)  =>  (VUPKHSB:{ *:[v8i16] } v16i8:{ *:[v16i8] }:$VB)
     /*  63672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VUPKHSB),
     /*  63675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63677 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  63679 */     GIR_RootConstrainSelectedInstOperands,
     /*  63680 */     // GIR_Coverage, 420,
     /*  63680 */     GIR_EraseRootFromParent_Done,
     /*  63681 */   // Label 938: @63681
     /*  63681 */   GIM_Try, /*On fail goto*//*Label 939*/ GIMT_Encode4(63713), // Rule ID 421 //
     /*  63686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  63689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vupkhsh),
     /*  63694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  63700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63704 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10383:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VB)  =>  (VUPKHSH:{ *:[v4i32] } v8i16:{ *:[v8i16] }:$VB)
     /*  63704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VUPKHSH),
     /*  63707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63709 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  63711 */     GIR_RootConstrainSelectedInstOperands,
     /*  63712 */     // GIR_Coverage, 421,
     /*  63712 */     GIR_EraseRootFromParent_Done,
     /*  63713 */   // Label 939: @63713
     /*  63713 */   GIM_Try, /*On fail goto*//*Label 940*/ GIMT_Encode4(63745), // Rule ID 422 //
     /*  63718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  63721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vupklpx),
     /*  63726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  63732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63736 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10385:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VB)  =>  (VUPKLPX:{ *:[v4i32] } v8i16:{ *:[v8i16] }:$VB)
     /*  63736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VUPKLPX),
     /*  63739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63741 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  63743 */     GIR_RootConstrainSelectedInstOperands,
     /*  63744 */     // GIR_Coverage, 422,
     /*  63744 */     GIR_EraseRootFromParent_Done,
     /*  63745 */   // Label 940: @63745
     /*  63745 */   GIM_Try, /*On fail goto*//*Label 941*/ GIMT_Encode4(63777), // Rule ID 423 //
     /*  63750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  63753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vupklsb),
     /*  63758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  63761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  63764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63768 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10386:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VB)  =>  (VUPKLSB:{ *:[v8i16] } v16i8:{ *:[v16i8] }:$VB)
     /*  63768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VUPKLSB),
     /*  63771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63773 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  63775 */     GIR_RootConstrainSelectedInstOperands,
     /*  63776 */     // GIR_Coverage, 423,
     /*  63776 */     GIR_EraseRootFromParent_Done,
     /*  63777 */   // Label 941: @63777
     /*  63777 */   GIM_Try, /*On fail goto*//*Label 942*/ GIMT_Encode4(63809), // Rule ID 424 //
     /*  63782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  63785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vupklsh),
     /*  63790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  63796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63800 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10387:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VB)  =>  (VUPKLSH:{ *:[v4i32] } v8i16:{ *:[v8i16] }:$VB)
     /*  63800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VUPKLSH),
     /*  63803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63805 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  63807 */     GIR_RootConstrainSelectedInstOperands,
     /*  63808 */     // GIR_Coverage, 424,
     /*  63808 */     GIR_EraseRootFromParent_Done,
     /*  63809 */   // Label 942: @63809
     /*  63809 */   GIM_Try, /*On fail goto*//*Label 943*/ GIMT_Encode4(63841), // Rule ID 504 //
     /*  63814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  63817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vupkhsw),
     /*  63822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  63825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  63828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63832 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10384:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VB)  =>  (VUPKHSW:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$VB)
     /*  63832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VUPKHSW),
     /*  63835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63837 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  63839 */     GIR_RootConstrainSelectedInstOperands,
     /*  63840 */     // GIR_Coverage, 504,
     /*  63840 */     GIR_EraseRootFromParent_Done,
     /*  63841 */   // Label 943: @63841
     /*  63841 */   GIM_Try, /*On fail goto*//*Label 944*/ GIMT_Encode4(63873), // Rule ID 505 //
     /*  63846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  63849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vupklsw),
     /*  63854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  63857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  63860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63864 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10388:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VB)  =>  (VUPKLSW:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$VB)
     /*  63864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VUPKLSW),
     /*  63867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63869 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  63871 */     GIR_RootConstrainSelectedInstOperands,
     /*  63872 */     // GIR_Coverage, 505,
     /*  63872 */     GIR_EraseRootFromParent_Done,
     /*  63873 */   // Label 944: @63873
     /*  63873 */   GIM_Try, /*On fail goto*//*Label 945*/ GIMT_Encode4(63905), // Rule ID 506 //
     /*  63878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  63881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vgbbd),
     /*  63886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  63889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  63892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63896 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10238:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VB)  =>  (VGBBD:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VB)
     /*  63896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VGBBD),
     /*  63899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63901 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  63903 */     GIR_RootConstrainSelectedInstOperands,
     /*  63904 */     // GIR_Coverage, 506,
     /*  63904 */     GIR_EraseRootFromParent_Done,
     /*  63905 */   // Label 945: @63905
     /*  63905 */   GIM_Try, /*On fail goto*//*Label 946*/ GIMT_Encode4(63937), // Rule ID 514 //
     /*  63910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Crypto),
     /*  63913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_crypto_vsbox),
     /*  63918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  63921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  63924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63928 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10093:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA)  =>  (VSBOX:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA)
     /*  63928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSBOX),
     /*  63931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63933 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  63935 */     GIR_RootConstrainSelectedInstOperands,
     /*  63936 */     // GIR_Coverage, 514,
     /*  63936 */     GIR_EraseRootFromParent_Done,
     /*  63937 */   // Label 946: @63937
     /*  63937 */   GIM_Try, /*On fail goto*//*Label 947*/ GIMT_Encode4(63969), // Rule ID 530 //
     /*  63942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  63945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vclzlsbb),
     /*  63950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  63953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  63956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  63960 */     // (intrinsic_wo_chain:{ *:[i32] } 10148:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VB)  =>  (VCLZLSBB:{ *:[i32] } v16i8:{ *:[v16i8] }:$VB)
     /*  63960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCLZLSBB),
     /*  63963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63965 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  63967 */     GIR_RootConstrainSelectedInstOperands,
     /*  63968 */     // GIR_Coverage, 530,
     /*  63968 */     GIR_EraseRootFromParent_Done,
     /*  63969 */   // Label 947: @63969
     /*  63969 */   GIM_Try, /*On fail goto*//*Label 948*/ GIMT_Encode4(64001), // Rule ID 531 //
     /*  63974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  63977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vctzlsbb),
     /*  63982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  63985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  63988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  63992 */     // (intrinsic_wo_chain:{ *:[i32] } 10206:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VB)  =>  (VCTZLSBB:{ *:[i32] } v16i8:{ *:[v16i8] }:$VB)
     /*  63992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCTZLSBB),
     /*  63995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63997 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  63999 */     GIR_RootConstrainSelectedInstOperands,
     /*  64000 */     // GIR_Coverage, 531,
     /*  64000 */     GIR_EraseRootFromParent_Done,
     /*  64001 */   // Label 948: @64001
     /*  64001 */   GIM_Try, /*On fail goto*//*Label 949*/ GIMT_Encode4(64033), // Rule ID 536 //
     /*  64006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  64009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextsb2w),
     /*  64014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  64017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  64020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64024 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10233:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VB)  =>  (VEXTSB2W:{ *:[v4i32] } v16i8:{ *:[v16i8] }:$VB)
     /*  64024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTSB2W),
     /*  64027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64029 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64031 */     GIR_RootConstrainSelectedInstOperands,
     /*  64032 */     // GIR_Coverage, 536,
     /*  64032 */     GIR_EraseRootFromParent_Done,
     /*  64033 */   // Label 949: @64033
     /*  64033 */   GIM_Try, /*On fail goto*//*Label 950*/ GIMT_Encode4(64065), // Rule ID 537 //
     /*  64038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  64041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextsh2w),
     /*  64046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  64049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  64052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64056 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10236:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VB)  =>  (VEXTSH2W:{ *:[v4i32] } v8i16:{ *:[v8i16] }:$VB)
     /*  64056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTSH2W),
     /*  64059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64061 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64063 */     GIR_RootConstrainSelectedInstOperands,
     /*  64064 */     // GIR_Coverage, 537,
     /*  64064 */     GIR_EraseRootFromParent_Done,
     /*  64065 */   // Label 950: @64065
     /*  64065 */   GIM_Try, /*On fail goto*//*Label 951*/ GIMT_Encode4(64097), // Rule ID 538 //
     /*  64070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  64073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextsb2d),
     /*  64078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  64081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  64084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64088 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10232:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VB)  =>  (VEXTSB2D:{ *:[v2i64] } v16i8:{ *:[v16i8] }:$VB)
     /*  64088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTSB2D),
     /*  64091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64093 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64095 */     GIR_RootConstrainSelectedInstOperands,
     /*  64096 */     // GIR_Coverage, 538,
     /*  64096 */     GIR_EraseRootFromParent_Done,
     /*  64097 */   // Label 951: @64097
     /*  64097 */   GIM_Try, /*On fail goto*//*Label 952*/ GIMT_Encode4(64129), // Rule ID 539 //
     /*  64102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  64105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextsh2d),
     /*  64110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  64113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  64116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64120 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10235:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VB)  =>  (VEXTSH2D:{ *:[v2i64] } v8i16:{ *:[v8i16] }:$VB)
     /*  64120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTSH2D),
     /*  64123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64125 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64127 */     GIR_RootConstrainSelectedInstOperands,
     /*  64128 */     // GIR_Coverage, 539,
     /*  64128 */     GIR_EraseRootFromParent_Done,
     /*  64129 */   // Label 952: @64129
     /*  64129 */   GIM_Try, /*On fail goto*//*Label 953*/ GIMT_Encode4(64161), // Rule ID 540 //
     /*  64134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  64137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextsw2d),
     /*  64142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  64145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64152 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10237:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VB)  =>  (VEXTSW2D:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$VB)
     /*  64152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTSW2D),
     /*  64155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64157 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64159 */     GIR_RootConstrainSelectedInstOperands,
     /*  64160 */     // GIR_Coverage, 540,
     /*  64160 */     GIR_EraseRootFromParent_Done,
     /*  64161 */   // Label 953: @64161
     /*  64161 */   GIM_Try, /*On fail goto*//*Label 954*/ GIMT_Encode4(64193), // Rule ID 543 //
     /*  64166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  64169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vprtybw),
     /*  64174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  64177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64184 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10323:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VB)  =>  (VPRTYBW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VB)
     /*  64184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPRTYBW),
     /*  64187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64189 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64191 */     GIR_RootConstrainSelectedInstOperands,
     /*  64192 */     // GIR_Coverage, 543,
     /*  64192 */     GIR_EraseRootFromParent_Done,
     /*  64193 */   // Label 954: @64193
     /*  64193 */   GIM_Try, /*On fail goto*//*Label 955*/ GIMT_Encode4(64225), // Rule ID 544 //
     /*  64198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  64201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vprtybd),
     /*  64206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  64209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64216 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10321:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VB)  =>  (VPRTYBD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VB)
     /*  64216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPRTYBD),
     /*  64219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64221 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64223 */     GIR_RootConstrainSelectedInstOperands,
     /*  64224 */     // GIR_Coverage, 544,
     /*  64224 */     GIR_EraseRootFromParent_Done,
     /*  64225 */   // Label 955: @64225
     /*  64225 */   GIM_Try, /*On fail goto*//*Label 956*/ GIMT_Encode4(64257), // Rule ID 545 //
     /*  64230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  64233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vprtybq),
     /*  64238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  64241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  64244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64248 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10322:{ *:[iPTR] }, v1i128:{ *:[v1i128] }:$VB)  =>  (VPRTYBQ:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VB)
     /*  64248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPRTYBQ),
     /*  64251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64253 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64255 */     GIR_RootConstrainSelectedInstOperands,
     /*  64256 */     // GIR_Coverage, 545,
     /*  64256 */     GIR_EraseRootFromParent_Done,
     /*  64257 */   // Label 956: @64257
     /*  64257 */   GIM_Try, /*On fail goto*//*Label 957*/ GIMT_Encode4(64286), // Rule ID 689 //
     /*  64262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_popcntb),
     /*  64267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  64270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  64273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  64277 */     // (intrinsic_wo_chain:{ *:[i64] } 10579:{ *:[iPTR] }, i64:{ *:[i64] }:$RST)  =>  (POPCNTB8:{ *:[i64] } i64:{ *:[i64] }:$RST)
     /*  64277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::POPCNTB8),
     /*  64280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  64282 */     GIR_RootToRootCopy, /*OpIdx*/2, // RST
     /*  64284 */     GIR_RootConstrainSelectedInstOperands,
     /*  64285 */     // GIR_Coverage, 689,
     /*  64285 */     GIR_EraseRootFromParent_Done,
     /*  64286 */   // Label 957: @64286
     /*  64286 */   GIM_Try, /*On fail goto*//*Label 958*/ GIMT_Encode4(64315), // Rule ID 690 //
     /*  64291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_cdtbcdd),
     /*  64296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  64299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  64302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  64306 */     // (intrinsic_wo_chain:{ *:[i64] } 10406:{ *:[iPTR] }, i64:{ *:[i64] }:$RST)  =>  (CDTBCD8:{ *:[i64] } i64:{ *:[i64] }:$RST)
     /*  64306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CDTBCD8),
     /*  64309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  64311 */     GIR_RootToRootCopy, /*OpIdx*/2, // RST
     /*  64313 */     GIR_RootConstrainSelectedInstOperands,
     /*  64314 */     // GIR_Coverage, 690,
     /*  64314 */     GIR_EraseRootFromParent_Done,
     /*  64315 */   // Label 958: @64315
     /*  64315 */   GIM_Try, /*On fail goto*//*Label 959*/ GIMT_Encode4(64344), // Rule ID 691 //
     /*  64320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_cbcdtdd),
     /*  64325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  64328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  64331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  64335 */     // (intrinsic_wo_chain:{ *:[i64] } 10404:{ *:[iPTR] }, i64:{ *:[i64] }:$RST)  =>  (CBCDTD8:{ *:[i64] } i64:{ *:[i64] }:$RST)
     /*  64335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CBCDTD8),
     /*  64338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  64340 */     GIR_RootToRootCopy, /*OpIdx*/2, // RST
     /*  64342 */     GIR_RootConstrainSelectedInstOperands,
     /*  64343 */     // GIR_Coverage, 691,
     /*  64343 */     GIR_EraseRootFromParent_Done,
     /*  64344 */   // Label 959: @64344
     /*  64344 */   GIM_Try, /*On fail goto*//*Label 960*/ GIMT_Encode4(64376), // Rule ID 1058 //
     /*  64349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vstribr),
     /*  64357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  64360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  64363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64367 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10360:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VB)  =>  (VSTRIBR:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VB)
     /*  64367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSTRIBR),
     /*  64370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VT]
     /*  64372 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64374 */     GIR_RootConstrainSelectedInstOperands,
     /*  64375 */     // GIR_Coverage, 1058,
     /*  64375 */     GIR_EraseRootFromParent_Done,
     /*  64376 */   // Label 960: @64376
     /*  64376 */   GIM_Try, /*On fail goto*//*Label 961*/ GIMT_Encode4(64408), // Rule ID 1059 //
     /*  64381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vstribl),
     /*  64389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  64392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  64395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64399 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10358:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VB)  =>  (VSTRIBL:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VB)
     /*  64399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSTRIBL),
     /*  64402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VT]
     /*  64404 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64406 */     GIR_RootConstrainSelectedInstOperands,
     /*  64407 */     // GIR_Coverage, 1059,
     /*  64407 */     GIR_EraseRootFromParent_Done,
     /*  64408 */   // Label 961: @64408
     /*  64408 */   GIM_Try, /*On fail goto*//*Label 962*/ GIMT_Encode4(64440), // Rule ID 1060 //
     /*  64413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vstrihr),
     /*  64421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  64424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  64427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64431 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10364:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VB)  =>  (VSTRIHR:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VB)
     /*  64431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSTRIHR),
     /*  64434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VT]
     /*  64436 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64438 */     GIR_RootConstrainSelectedInstOperands,
     /*  64439 */     // GIR_Coverage, 1060,
     /*  64439 */     GIR_EraseRootFromParent_Done,
     /*  64440 */   // Label 962: @64440
     /*  64440 */   GIM_Try, /*On fail goto*//*Label 963*/ GIMT_Encode4(64472), // Rule ID 1061 //
     /*  64445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vstrihl),
     /*  64453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  64456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  64459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64463 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10362:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VB)  =>  (VSTRIHL:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VB)
     /*  64463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSTRIHL),
     /*  64466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VT]
     /*  64468 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64470 */     GIR_RootConstrainSelectedInstOperands,
     /*  64471 */     // GIR_Coverage, 1061,
     /*  64471 */     GIR_EraseRootFromParent_Done,
     /*  64472 */   // Label 963: @64472
     /*  64472 */   GIM_Try, /*On fail goto*//*Label 964*/ GIMT_Encode4(64504), // Rule ID 1078 //
     /*  64477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextractbm),
     /*  64485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  64491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  64495 */     // (intrinsic_wo_chain:{ *:[i32] } 10227:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VB)  =>  (VEXTRACTBM:{ *:[i32] } v16i8:{ *:[v16i8] }:$VB)
     /*  64495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTRACTBM),
     /*  64498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64500 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64502 */     GIR_RootConstrainSelectedInstOperands,
     /*  64503 */     // GIR_Coverage, 1078,
     /*  64503 */     GIR_EraseRootFromParent_Done,
     /*  64504 */   // Label 964: @64504
     /*  64504 */   GIM_Try, /*On fail goto*//*Label 965*/ GIMT_Encode4(64536), // Rule ID 1079 //
     /*  64509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextracthm),
     /*  64517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  64523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  64527 */     // (intrinsic_wo_chain:{ *:[i32] } 10229:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VB)  =>  (VEXTRACTHM:{ *:[i32] } v8i16:{ *:[v8i16] }:$VB)
     /*  64527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTRACTHM),
     /*  64530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64532 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64534 */     GIR_RootConstrainSelectedInstOperands,
     /*  64535 */     // GIR_Coverage, 1079,
     /*  64535 */     GIR_EraseRootFromParent_Done,
     /*  64536 */   // Label 965: @64536
     /*  64536 */   GIM_Try, /*On fail goto*//*Label 966*/ GIMT_Encode4(64568), // Rule ID 1080 //
     /*  64541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextractwm),
     /*  64549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  64559 */     // (intrinsic_wo_chain:{ *:[i32] } 10231:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VB)  =>  (VEXTRACTWM:{ *:[i32] } v4i32:{ *:[v4i32] }:$VB)
     /*  64559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTRACTWM),
     /*  64562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64564 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64566 */     GIR_RootConstrainSelectedInstOperands,
     /*  64567 */     // GIR_Coverage, 1080,
     /*  64567 */     GIR_EraseRootFromParent_Done,
     /*  64568 */   // Label 966: @64568
     /*  64568 */   GIM_Try, /*On fail goto*//*Label 967*/ GIMT_Encode4(64600), // Rule ID 1081 //
     /*  64573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextractdm),
     /*  64581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  64591 */     // (intrinsic_wo_chain:{ *:[i32] } 10228:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VB)  =>  (VEXTRACTDM:{ *:[i32] } v2i64:{ *:[v2i64] }:$VB)
     /*  64591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTRACTDM),
     /*  64594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64596 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64598 */     GIR_RootConstrainSelectedInstOperands,
     /*  64599 */     // GIR_Coverage, 1081,
     /*  64599 */     GIR_EraseRootFromParent_Done,
     /*  64600 */   // Label 967: @64600
     /*  64600 */   GIM_Try, /*On fail goto*//*Label 968*/ GIMT_Encode4(64632), // Rule ID 1082 //
     /*  64605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextractqm),
     /*  64613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  64619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  64623 */     // (intrinsic_wo_chain:{ *:[i32] } 10230:{ *:[iPTR] }, v1i128:{ *:[v1i128] }:$VB)  =>  (VEXTRACTQM:{ *:[i32] } v1i128:{ *:[v1i128] }:$VB)
     /*  64623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTRACTQM),
     /*  64626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64628 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64630 */     GIR_RootConstrainSelectedInstOperands,
     /*  64631 */     // GIR_Coverage, 1082,
     /*  64631 */     GIR_EraseRootFromParent_Done,
     /*  64632 */   // Label 968: @64632
     /*  64632 */   GIM_Try, /*On fail goto*//*Label 969*/ GIMT_Encode4(64664), // Rule ID 1083 //
     /*  64637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vexpandbm),
     /*  64645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  64648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  64651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64655 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10213:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VB)  =>  (VEXPANDBM:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VB)
     /*  64655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXPANDBM),
     /*  64658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64660 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64662 */     GIR_RootConstrainSelectedInstOperands,
     /*  64663 */     // GIR_Coverage, 1083,
     /*  64663 */     GIR_EraseRootFromParent_Done,
     /*  64664 */   // Label 969: @64664
     /*  64664 */   GIM_Try, /*On fail goto*//*Label 970*/ GIMT_Encode4(64696), // Rule ID 1084 //
     /*  64669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vexpandhm),
     /*  64677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  64680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  64683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64687 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10215:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VB)  =>  (VEXPANDHM:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VB)
     /*  64687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXPANDHM),
     /*  64690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64692 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64694 */     GIR_RootConstrainSelectedInstOperands,
     /*  64695 */     // GIR_Coverage, 1084,
     /*  64695 */     GIR_EraseRootFromParent_Done,
     /*  64696 */   // Label 970: @64696
     /*  64696 */   GIM_Try, /*On fail goto*//*Label 971*/ GIMT_Encode4(64728), // Rule ID 1085 //
     /*  64701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vexpandwm),
     /*  64709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  64712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64719 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10217:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VB)  =>  (VEXPANDWM:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VB)
     /*  64719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXPANDWM),
     /*  64722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64724 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64726 */     GIR_RootConstrainSelectedInstOperands,
     /*  64727 */     // GIR_Coverage, 1085,
     /*  64727 */     GIR_EraseRootFromParent_Done,
     /*  64728 */   // Label 971: @64728
     /*  64728 */   GIM_Try, /*On fail goto*//*Label 972*/ GIMT_Encode4(64760), // Rule ID 1086 //
     /*  64733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vexpanddm),
     /*  64741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  64744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64751 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10214:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VB)  =>  (VEXPANDDM:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VB)
     /*  64751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXPANDDM),
     /*  64754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64756 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64758 */     GIR_RootConstrainSelectedInstOperands,
     /*  64759 */     // GIR_Coverage, 1086,
     /*  64759 */     GIR_EraseRootFromParent_Done,
     /*  64760 */   // Label 972: @64760
     /*  64760 */   GIM_Try, /*On fail goto*//*Label 973*/ GIMT_Encode4(64792), // Rule ID 1087 //
     /*  64765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vexpandqm),
     /*  64773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  64776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  64779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64783 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10216:{ *:[iPTR] }, v1i128:{ *:[v1i128] }:$VB)  =>  (VEXPANDQM:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VB)
     /*  64783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXPANDQM),
     /*  64786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64788 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64790 */     GIR_RootConstrainSelectedInstOperands,
     /*  64791 */     // GIR_Coverage, 1087,
     /*  64791 */     GIR_EraseRootFromParent_Done,
     /*  64792 */   // Label 973: @64792
     /*  64792 */   GIM_Try, /*On fail goto*//*Label 974*/ GIMT_Encode4(64824), // Rule ID 1088 //
     /*  64797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_mtvsrbm),
     /*  64805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  64808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  64811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64815 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10111:{ *:[iPTR] }, i64:{ *:[i64] }:$VB)  =>  (MTVSRBM:{ *:[v16i8] } i64:{ *:[i64] }:$VB)
     /*  64815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTVSRBM),
     /*  64818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64820 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64822 */     GIR_RootConstrainSelectedInstOperands,
     /*  64823 */     // GIR_Coverage, 1088,
     /*  64823 */     GIR_EraseRootFromParent_Done,
     /*  64824 */   // Label 974: @64824
     /*  64824 */   GIM_Try, /*On fail goto*//*Label 975*/ GIMT_Encode4(64856), // Rule ID 1089 //
     /*  64829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_mtvsrhm),
     /*  64837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  64840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  64843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64847 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10113:{ *:[iPTR] }, i64:{ *:[i64] }:$VB)  =>  (MTVSRHM:{ *:[v8i16] } i64:{ *:[i64] }:$VB)
     /*  64847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTVSRHM),
     /*  64850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64852 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64854 */     GIR_RootConstrainSelectedInstOperands,
     /*  64855 */     // GIR_Coverage, 1089,
     /*  64855 */     GIR_EraseRootFromParent_Done,
     /*  64856 */   // Label 975: @64856
     /*  64856 */   GIM_Try, /*On fail goto*//*Label 976*/ GIMT_Encode4(64888), // Rule ID 1090 //
     /*  64861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_mtvsrwm),
     /*  64869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  64872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  64875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64879 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10115:{ *:[iPTR] }, i64:{ *:[i64] }:$VB)  =>  (MTVSRWM:{ *:[v4i32] } i64:{ *:[i64] }:$VB)
     /*  64879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTVSRWM),
     /*  64882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64884 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64886 */     GIR_RootConstrainSelectedInstOperands,
     /*  64887 */     // GIR_Coverage, 1090,
     /*  64887 */     GIR_EraseRootFromParent_Done,
     /*  64888 */   // Label 976: @64888
     /*  64888 */   GIM_Try, /*On fail goto*//*Label 977*/ GIMT_Encode4(64920), // Rule ID 1091 //
     /*  64893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_mtvsrdm),
     /*  64901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  64904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  64907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64911 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10112:{ *:[iPTR] }, i64:{ *:[i64] }:$VB)  =>  (MTVSRDM:{ *:[v2i64] } i64:{ *:[i64] }:$VB)
     /*  64911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTVSRDM),
     /*  64914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64916 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64918 */     GIR_RootConstrainSelectedInstOperands,
     /*  64919 */     // GIR_Coverage, 1091,
     /*  64919 */     GIR_EraseRootFromParent_Done,
     /*  64920 */   // Label 977: @64920
     /*  64920 */   GIM_Try, /*On fail goto*//*Label 978*/ GIMT_Encode4(64952), // Rule ID 1092 //
     /*  64925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_mtvsrqm),
     /*  64933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  64936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  64939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64943 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10114:{ *:[iPTR] }, i64:{ *:[i64] }:$VB)  =>  (MTVSRQM:{ *:[v1i128] } i64:{ *:[i64] }:$VB)
     /*  64943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTVSRQM),
     /*  64946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64948 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64950 */     GIR_RootConstrainSelectedInstOperands,
     /*  64951 */     // GIR_Coverage, 1092,
     /*  64951 */     GIR_EraseRootFromParent_Done,
     /*  64952 */   // Label 978: @64952
     /*  64952 */   GIM_Try, /*On fail goto*//*Label 979*/ GIMT_Encode4(64984), // Rule ID 1156 //
     /*  64957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextsd2q),
     /*  64965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  64968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64975 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10234:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VB)  =>  (VEXTSD2Q:{ *:[v1i128] } v2i64:{ *:[v2i64] }:$VB)
     /*  64975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTSD2Q),
     /*  64978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64980 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64982 */     GIR_RootConstrainSelectedInstOperands,
     /*  64983 */     // GIR_Coverage, 1156,
     /*  64983 */     GIR_EraseRootFromParent_Done,
     /*  64984 */   // Label 979: @64984
     /*  64984 */   GIM_Try, /*On fail goto*//*Label 980*/ GIMT_Encode4(65016), // Rule ID 1161 //
     /*  64989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture),
     /*  64992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_dmmr),
     /*  64997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  65000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  65003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  65007 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10501:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$AB)  =>  (DMMR:{ *:[v1024i1] } v1024i1:{ *:[v1024i1] }:$AB)
     /*  65007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DMMR),
     /*  65010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  65012 */     GIR_RootToRootCopy, /*OpIdx*/2, // AB
     /*  65014 */     GIR_RootConstrainSelectedInstOperands,
     /*  65015 */     // GIR_Coverage, 1161,
     /*  65015 */     GIR_EraseRootFromParent_Done,
     /*  65016 */   // Label 980: @65016
     /*  65016 */   GIM_Try, /*On fail goto*//*Label 981*/ GIMT_Encode4(65048), // Rule ID 1164 //
     /*  65021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  65024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xxmfacc),
     /*  65029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  65032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  65035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  65039 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10562:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$AT)  =>  (XXMFACC:{ *:[v512i1] } v512i1:{ *:[v512i1] }:$AT)
     /*  65039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXMFACC),
     /*  65042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[ATo]
     /*  65044 */     GIR_RootToRootCopy, /*OpIdx*/2, // AT
     /*  65046 */     GIR_RootConstrainSelectedInstOperands,
     /*  65047 */     // GIR_Coverage, 1164,
     /*  65047 */     GIR_EraseRootFromParent_Done,
     /*  65048 */   // Label 981: @65048
     /*  65048 */   GIM_Try, /*On fail goto*//*Label 982*/ GIMT_Encode4(65080), // Rule ID 1165 //
     /*  65053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  65056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xxmtacc),
     /*  65061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  65064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  65067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  65071 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10563:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi)  =>  (XXMTACC:{ *:[v512i1] } v512i1:{ *:[v512i1] }:$ATi)
     /*  65071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXMTACC),
     /*  65074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  65076 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  65078 */     GIR_RootConstrainSelectedInstOperands,
     /*  65079 */     // GIR_Coverage, 1165,
     /*  65079 */     GIR_EraseRootFromParent_Done,
     /*  65080 */   // Label 982: @65080
     /*  65080 */   GIM_Try, /*On fail goto*//*Label 983*/ GIMT_Encode4(65109), // Rule ID 1280 //
     /*  65085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fre),
     /*  65090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  65093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  65096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  65100 */     // (intrinsic_wo_chain:{ *:[f64] } 10466:{ *:[iPTR] }, f64:{ *:[f64] }:$A)  =>  (FRE:{ *:[f64] } ?:{ *:[f64] }:$A)
     /*  65100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FRE),
     /*  65103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  65105 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  65107 */     GIR_RootConstrainSelectedInstOperands,
     /*  65108 */     // GIR_Coverage, 1280,
     /*  65108 */     GIR_EraseRootFromParent_Done,
     /*  65109 */   // Label 983: @65109
     /*  65109 */   GIM_Try, /*On fail goto*//*Label 984*/ GIMT_Encode4(65138), // Rule ID 1281 //
     /*  65114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fres),
     /*  65119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  65122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  65125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /*  65129 */     // (intrinsic_wo_chain:{ *:[f32] } 10467:{ *:[iPTR] }, f32:{ *:[f32] }:$A)  =>  (FRES:{ *:[f32] } ?:{ *:[f32] }:$A)
     /*  65129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FRES),
     /*  65132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  65134 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  65136 */     GIR_RootConstrainSelectedInstOperands,
     /*  65137 */     // GIR_Coverage, 1281,
     /*  65137 */     GIR_EraseRootFromParent_Done,
     /*  65138 */   // Label 984: @65138
     /*  65138 */   GIM_Try, /*On fail goto*//*Label 985*/ GIMT_Encode4(65167), // Rule ID 1282 //
     /*  65143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fnabs),
     /*  65148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  65151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  65154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  65158 */     // (intrinsic_wo_chain:{ *:[f64] } 10461:{ *:[iPTR] }, f64:{ *:[f64] }:$A)  =>  (FNABSD:{ *:[f64] } ?:{ *:[f64] }:$A)
     /*  65158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FNABSD),
     /*  65161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  65163 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  65165 */     GIR_RootConstrainSelectedInstOperands,
     /*  65166 */     // GIR_Coverage, 1282,
     /*  65166 */     GIR_EraseRootFromParent_Done,
     /*  65167 */   // Label 985: @65167
     /*  65167 */   GIM_Try, /*On fail goto*//*Label 986*/ GIMT_Encode4(65196), // Rule ID 1283 //
     /*  65172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fnabss),
     /*  65177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  65180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  65183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /*  65187 */     // (intrinsic_wo_chain:{ *:[f32] } 10462:{ *:[iPTR] }, f32:{ *:[f32] }:$A)  =>  (FNABSS:{ *:[f32] } ?:{ *:[f32] }:$A)
     /*  65187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FNABSS),
     /*  65190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  65192 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  65194 */     GIR_RootConstrainSelectedInstOperands,
     /*  65195 */     // GIR_Coverage, 1283,
     /*  65195 */     GIR_EraseRootFromParent_Done,
     /*  65196 */   // Label 986: @65196
     /*  65196 */   GIM_Try, /*On fail goto*//*Label 987*/ GIMT_Encode4(65271), // Rule ID 3353 //
     /*  65201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX_IsISA3_1),
     /*  65204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcvspbf16),
     /*  65209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  65212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  65215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  65219 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10661:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } (XVCVSPBF16:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] })), VRRC:{ *:[i32] })
     /*  65219 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  65222 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  65226 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65231 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  65235 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  65240 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65243 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XVCVSPBF16),
     /*  65247 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65252 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  65255 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  65257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  65260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65262 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65265 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  65270 */     // GIR_Coverage, 3353,
     /*  65270 */     GIR_EraseRootFromParent_Done,
     /*  65271 */   // Label 987: @65271
     /*  65271 */   GIM_Try, /*On fail goto*//*Label 988*/ GIMT_Encode4(65346), // Rule ID 3354 //
     /*  65276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX_IsISA3_1),
     /*  65279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcvbf16spn),
     /*  65284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  65287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  65290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  65294 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10656:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } (XVCVBF16SPN:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] })), VRRC:{ *:[i32] })
     /*  65294 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  65297 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  65301 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65306 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  65310 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  65315 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65318 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XVCVBF16SPN),
     /*  65322 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65327 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  65330 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  65332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  65335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65337 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65340 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  65345 */     // GIR_Coverage, 3354,
     /*  65345 */     GIR_EraseRootFromParent_Done,
     /*  65346 */   // Label 988: @65346
     /*  65346 */   GIM_Try, /*On fail goto*//*Label 989*/ GIMT_Encode4(65375), // Rule ID 4852 //
     /*  65351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fcfid),
     /*  65356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  65359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  65362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  65366 */     // (intrinsic_wo_chain:{ *:[f64] } 10448:{ *:[iPTR] }, f64:{ *:[f64] }:$A)  =>  (XSCVSXDDP:{ *:[f64] } ?:{ *:[f64] }:$A)
     /*  65366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSCVSXDDP),
     /*  65369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  65371 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  65373 */     GIR_RootConstrainSelectedInstOperands,
     /*  65374 */     // GIR_Coverage, 4852,
     /*  65374 */     GIR_EraseRootFromParent_Done,
     /*  65375 */   // Label 989: @65375
     /*  65375 */   GIM_Try, /*On fail goto*//*Label 990*/ GIMT_Encode4(65404), // Rule ID 4853 //
     /*  65380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fcfud),
     /*  65385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  65388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  65391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  65395 */     // (intrinsic_wo_chain:{ *:[f64] } 10449:{ *:[iPTR] }, f64:{ *:[f64] }:$A)  =>  (XSCVUXDDP:{ *:[f64] } ?:{ *:[f64] }:$A)
     /*  65395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSCVUXDDP),
     /*  65398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  65400 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  65402 */     GIR_RootConstrainSelectedInstOperands,
     /*  65403 */     // GIR_Coverage, 4853,
     /*  65403 */     GIR_EraseRootFromParent_Done,
     /*  65404 */   // Label 990: @65404
     /*  65404 */   GIM_Try, /*On fail goto*//*Label 991*/ GIMT_Encode4(65433), // Rule ID 4854 //
     /*  65409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fctid),
     /*  65414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  65417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  65420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  65424 */     // (intrinsic_wo_chain:{ *:[f64] } 10450:{ *:[iPTR] }, f64:{ *:[f64] }:$A)  =>  (FCTID:{ *:[f64] } ?:{ *:[f64] }:$A)
     /*  65424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FCTID),
     /*  65427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  65429 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  65431 */     GIR_RootConstrainSelectedInstOperands,
     /*  65432 */     // GIR_Coverage, 4854,
     /*  65432 */     GIR_EraseRootFromParent_Done,
     /*  65433 */   // Label 991: @65433
     /*  65433 */   GIM_Try, /*On fail goto*//*Label 992*/ GIMT_Encode4(65462), // Rule ID 4855 //
     /*  65438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fctidz),
     /*  65443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  65446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  65449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  65453 */     // (intrinsic_wo_chain:{ *:[f64] } 10451:{ *:[iPTR] }, f64:{ *:[f64] }:$A)  =>  (XSCVDPSXDS:{ *:[f64] } ?:{ *:[f64] }:$A)
     /*  65453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSCVDPSXDS),
     /*  65456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  65458 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  65460 */     GIR_RootConstrainSelectedInstOperands,
     /*  65461 */     // GIR_Coverage, 4855,
     /*  65461 */     GIR_EraseRootFromParent_Done,
     /*  65462 */   // Label 992: @65462
     /*  65462 */   GIM_Try, /*On fail goto*//*Label 993*/ GIMT_Encode4(65491), // Rule ID 4856 //
     /*  65467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fctiw),
     /*  65472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  65475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  65478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  65482 */     // (intrinsic_wo_chain:{ *:[f64] } 10452:{ *:[iPTR] }, f64:{ *:[f64] }:$A)  =>  (FCTIW:{ *:[f64] } ?:{ *:[f64] }:$A)
     /*  65482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FCTIW),
     /*  65485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  65487 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  65489 */     GIR_RootConstrainSelectedInstOperands,
     /*  65490 */     // GIR_Coverage, 4856,
     /*  65490 */     GIR_EraseRootFromParent_Done,
     /*  65491 */   // Label 993: @65491
     /*  65491 */   GIM_Try, /*On fail goto*//*Label 994*/ GIMT_Encode4(65520), // Rule ID 4857 //
     /*  65496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fctiwz),
     /*  65501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  65504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  65507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  65511 */     // (intrinsic_wo_chain:{ *:[f64] } 10453:{ *:[iPTR] }, f64:{ *:[f64] }:$A)  =>  (XSCVDPSXWS:{ *:[f64] } ?:{ *:[f64] }:$A)
     /*  65511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSCVDPSXWS),
     /*  65514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  65516 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  65518 */     GIR_RootConstrainSelectedInstOperands,
     /*  65519 */     // GIR_Coverage, 4857,
     /*  65519 */     GIR_EraseRootFromParent_Done,
     /*  65520 */   // Label 994: @65520
     /*  65520 */   GIM_Try, /*On fail goto*//*Label 995*/ GIMT_Encode4(65549), // Rule ID 4858 //
     /*  65525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fctudz),
     /*  65530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  65533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  65536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  65540 */     // (intrinsic_wo_chain:{ *:[f64] } 10454:{ *:[iPTR] }, f64:{ *:[f64] }:$A)  =>  (XSCVDPUXDS:{ *:[f64] } ?:{ *:[f64] }:$A)
     /*  65540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSCVDPUXDS),
     /*  65543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  65545 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  65547 */     GIR_RootConstrainSelectedInstOperands,
     /*  65548 */     // GIR_Coverage, 4858,
     /*  65548 */     GIR_EraseRootFromParent_Done,
     /*  65549 */   // Label 995: @65549
     /*  65549 */   GIM_Try, /*On fail goto*//*Label 996*/ GIMT_Encode4(65578), // Rule ID 4859 //
     /*  65554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fctuwz),
     /*  65559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  65562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  65565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  65569 */     // (intrinsic_wo_chain:{ *:[f64] } 10455:{ *:[iPTR] }, f64:{ *:[f64] }:$A)  =>  (XSCVDPUXWS:{ *:[f64] } ?:{ *:[f64] }:$A)
     /*  65569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSCVDPUXWS),
     /*  65572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  65574 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  65576 */     GIR_RootConstrainSelectedInstOperands,
     /*  65577 */     // GIR_Coverage, 4859,
     /*  65577 */     GIR_EraseRootFromParent_Done,
     /*  65578 */   // Label 996: @65578
     /*  65578 */   GIM_Reject,
     /*  65579 */ // Label 889: @65579
     /*  65579 */ GIM_Try, /*On fail goto*//*Label 997*/ GIMT_Encode4(73981),
     /*  65584 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /*  65587 */   GIM_Try, /*On fail goto*//*Label 998*/ GIMT_Encode4(65658), // Rule ID 2167 //
     /*  65592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  65595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xxextractuw),
     /*  65600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  65603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  65609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  65613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  65617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  65621 */     // MIs[1] Operand 1
     /*  65621 */     // No operand predicates
     /*  65621 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  65623 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10700:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$A, (imm:{ *:[i32] }):$IMM)  =>  (COPY_TO_REGCLASS:{ *:[v2i64] } (XXEXTRACTUW:{ *:[f64] } ?:{ *:[v2i64] }:$A, (imm:{ *:[i32] }):$IMM), VSRC:{ *:[i32] })
     /*  65623 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  65626 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXEXTRACTUW),
     /*  65630 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65635 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // A
     /*  65639 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // IMM
     /*  65642 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  65644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  65647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65649 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65652 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  65657 */     // GIR_Coverage, 2167,
     /*  65657 */     GIR_EraseRootFromParent_Done,
     /*  65658 */   // Label 998: @65658
     /*  65658 */   GIM_Try, /*On fail goto*//*Label 999*/ GIMT_Encode4(65695), // Rule ID 1029 //
     /*  65663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  65666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvtstdcsp),
     /*  65671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  65674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  65677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  65681 */     // MIs[0] DCMX
     /*  65681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  65684 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10690:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$XB, (timm:{ *:[i32] }):$DCMX)  =>  (XVTSTDCSP:{ *:[v4i32] } (timm:{ *:[i32] }):$DCMX, v4f32:{ *:[v4f32] }:$XB)
     /*  65684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVTSTDCSP),
     /*  65687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  65689 */     GIR_RootToRootCopy, /*OpIdx*/3, // DCMX
     /*  65691 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  65693 */     GIR_RootConstrainSelectedInstOperands,
     /*  65694 */     // GIR_Coverage, 1029,
     /*  65694 */     GIR_EraseRootFromParent_Done,
     /*  65695 */   // Label 999: @65695
     /*  65695 */   GIM_Try, /*On fail goto*//*Label 1000*/ GIMT_Encode4(65732), // Rule ID 1030 //
     /*  65700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  65703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvtstdcdp),
     /*  65708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  65711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  65718 */     // MIs[0] DCMX
     /*  65718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  65721 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10689:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$XB, (timm:{ *:[i32] }):$DCMX)  =>  (XVTSTDCDP:{ *:[v2i64] } (timm:{ *:[i32] }):$DCMX, v2f64:{ *:[v2f64] }:$XB)
     /*  65721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVTSTDCDP),
     /*  65724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  65726 */     GIR_RootToRootCopy, /*OpIdx*/3, // DCMX
     /*  65728 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  65730 */     GIR_RootConstrainSelectedInstOperands,
     /*  65731 */     // GIR_Coverage, 1030,
     /*  65731 */     GIR_EraseRootFromParent_Done,
     /*  65732 */   // Label 1000: @65732
     /*  65732 */   GIM_Try, /*On fail goto*//*Label 1001*/ GIMT_Encode4(65777), // Rule ID 898 //
     /*  65737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  65740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xsmaxdp),
     /*  65745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  65748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  65751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  65754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  65758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  65762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  65766 */     // (intrinsic_wo_chain:{ *:[f64] } 10642:{ *:[iPTR] }, vsfrc:{ *:[f64] }:$XA, vsfrc:{ *:[f64] }:$XB)  =>  (XSMAXDP:{ *:[f64] } vsfrc:{ *:[f64] }:$XA, vsfrc:{ *:[f64] }:$XB)
     /*  65766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMAXDP),
     /*  65769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  65771 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  65773 */     GIR_RootToRootCopy, /*OpIdx*/3, // XB
     /*  65775 */     GIR_RootConstrainSelectedInstOperands,
     /*  65776 */     // GIR_Coverage, 898,
     /*  65776 */     GIR_EraseRootFromParent_Done,
     /*  65777 */   // Label 1001: @65777
     /*  65777 */   GIM_Try, /*On fail goto*//*Label 1002*/ GIMT_Encode4(65822), // Rule ID 899 //
     /*  65782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  65785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xsmindp),
     /*  65790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  65793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  65796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  65799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  65803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  65807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  65811 */     // (intrinsic_wo_chain:{ *:[f64] } 10643:{ *:[iPTR] }, vsfrc:{ *:[f64] }:$XA, vsfrc:{ *:[f64] }:$XB)  =>  (XSMINDP:{ *:[f64] } vsfrc:{ *:[f64] }:$XA, vsfrc:{ *:[f64] }:$XB)
     /*  65811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMINDP),
     /*  65814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  65816 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  65818 */     GIR_RootToRootCopy, /*OpIdx*/3, // XB
     /*  65820 */     GIR_RootConstrainSelectedInstOperands,
     /*  65821 */     // GIR_Coverage, 899,
     /*  65821 */     GIR_EraseRootFromParent_Done,
     /*  65822 */   // Label 1002: @65822
     /*  65822 */   GIM_Try, /*On fail goto*//*Label 1003*/ GIMT_Encode4(65867), // Rule ID 900 //
     /*  65827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  65830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvmaxdp),
     /*  65835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  65838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  65844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  65848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  65852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  65856 */     // (intrinsic_wo_chain:{ *:[v2f64] } 10674:{ *:[iPTR] }, vsrc:{ *:[v2f64] }:$XA, vsrc:{ *:[v2f64] }:$XB)  =>  (XVMAXDP:{ *:[v2f64] } vsrc:{ *:[v2f64] }:$XA, vsrc:{ *:[v2f64] }:$XB)
     /*  65856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVMAXDP),
     /*  65859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  65861 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  65863 */     GIR_RootToRootCopy, /*OpIdx*/3, // XB
     /*  65865 */     GIR_RootConstrainSelectedInstOperands,
     /*  65866 */     // GIR_Coverage, 900,
     /*  65866 */     GIR_EraseRootFromParent_Done,
     /*  65867 */   // Label 1003: @65867
     /*  65867 */   GIM_Try, /*On fail goto*//*Label 1004*/ GIMT_Encode4(65912), // Rule ID 901 //
     /*  65872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  65875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvmindp),
     /*  65880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  65883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  65889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  65893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  65897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  65901 */     // (intrinsic_wo_chain:{ *:[v2f64] } 10676:{ *:[iPTR] }, vsrc:{ *:[v2f64] }:$XA, vsrc:{ *:[v2f64] }:$XB)  =>  (XVMINDP:{ *:[v2f64] } vsrc:{ *:[v2f64] }:$XA, vsrc:{ *:[v2f64] }:$XB)
     /*  65901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVMINDP),
     /*  65904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  65906 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  65908 */     GIR_RootToRootCopy, /*OpIdx*/3, // XB
     /*  65910 */     GIR_RootConstrainSelectedInstOperands,
     /*  65911 */     // GIR_Coverage, 901,
     /*  65911 */     GIR_EraseRootFromParent_Done,
     /*  65912 */   // Label 1004: @65912
     /*  65912 */   GIM_Try, /*On fail goto*//*Label 1005*/ GIMT_Encode4(65957), // Rule ID 902 //
     /*  65917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  65920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvmaxsp),
     /*  65925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  65928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  65931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  65934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  65938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  65942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  65946 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10675:{ *:[iPTR] }, vsrc:{ *:[v4f32] }:$XA, vsrc:{ *:[v4f32] }:$XB)  =>  (XVMAXSP:{ *:[v4f32] } vsrc:{ *:[v4f32] }:$XA, vsrc:{ *:[v4f32] }:$XB)
     /*  65946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVMAXSP),
     /*  65949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  65951 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  65953 */     GIR_RootToRootCopy, /*OpIdx*/3, // XB
     /*  65955 */     GIR_RootConstrainSelectedInstOperands,
     /*  65956 */     // GIR_Coverage, 902,
     /*  65956 */     GIR_EraseRootFromParent_Done,
     /*  65957 */   // Label 1005: @65957
     /*  65957 */   GIM_Try, /*On fail goto*//*Label 1006*/ GIMT_Encode4(66002), // Rule ID 903 //
     /*  65962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  65965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvminsp),
     /*  65970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  65973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  65976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  65979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  65983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  65987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  65991 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10677:{ *:[iPTR] }, vsrc:{ *:[v4f32] }:$XA, vsrc:{ *:[v4f32] }:$XB)  =>  (XVMINSP:{ *:[v4f32] } vsrc:{ *:[v4f32] }:$XA, vsrc:{ *:[v4f32] }:$XB)
     /*  65991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVMINSP),
     /*  65994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  65996 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  65998 */     GIR_RootToRootCopy, /*OpIdx*/3, // XB
     /*  66000 */     GIR_RootConstrainSelectedInstOperands,
     /*  66001 */     // GIR_Coverage, 903,
     /*  66001 */     GIR_EraseRootFromParent_Done,
     /*  66002 */   // Label 1006: @66002
     /*  66002 */   GIM_Try, /*On fail goto*//*Label 1007*/ GIMT_Encode4(66039), // Rule ID 827 //
     /*  66007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  66010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcmpeqdp),
     /*  66015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  66018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  66024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  66028 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10644:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)  =>  (XVCMPEQDP:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /*  66028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCMPEQDP),
     /*  66031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  66033 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  66035 */     GIR_RootToRootCopy, /*OpIdx*/3, // XB
     /*  66037 */     GIR_RootConstrainSelectedInstOperands,
     /*  66038 */     // GIR_Coverage, 827,
     /*  66038 */     GIR_EraseRootFromParent_Done,
     /*  66039 */   // Label 1007: @66039
     /*  66039 */   GIM_Try, /*On fail goto*//*Label 1008*/ GIMT_Encode4(66076), // Rule ID 829 //
     /*  66044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  66047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcmpeqsp),
     /*  66052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  66055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  66061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  66065 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10646:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)  =>  (XVCMPEQSP:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /*  66065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCMPEQSP),
     /*  66068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  66070 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  66072 */     GIR_RootToRootCopy, /*OpIdx*/3, // XB
     /*  66074 */     GIR_RootConstrainSelectedInstOperands,
     /*  66075 */     // GIR_Coverage, 829,
     /*  66075 */     GIR_EraseRootFromParent_Done,
     /*  66076 */   // Label 1008: @66076
     /*  66076 */   GIM_Try, /*On fail goto*//*Label 1009*/ GIMT_Encode4(66113), // Rule ID 831 //
     /*  66081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  66084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcmpgedp),
     /*  66089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  66092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  66098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  66102 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10648:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)  =>  (XVCMPGEDP:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /*  66102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCMPGEDP),
     /*  66105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  66107 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  66109 */     GIR_RootToRootCopy, /*OpIdx*/3, // XB
     /*  66111 */     GIR_RootConstrainSelectedInstOperands,
     /*  66112 */     // GIR_Coverage, 831,
     /*  66112 */     GIR_EraseRootFromParent_Done,
     /*  66113 */   // Label 1009: @66113
     /*  66113 */   GIM_Try, /*On fail goto*//*Label 1010*/ GIMT_Encode4(66150), // Rule ID 833 //
     /*  66118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  66121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcmpgesp),
     /*  66126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  66129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  66135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  66139 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10650:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)  =>  (XVCMPGESP:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /*  66139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCMPGESP),
     /*  66142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  66144 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  66146 */     GIR_RootToRootCopy, /*OpIdx*/3, // XB
     /*  66148 */     GIR_RootConstrainSelectedInstOperands,
     /*  66149 */     // GIR_Coverage, 833,
     /*  66149 */     GIR_EraseRootFromParent_Done,
     /*  66150 */   // Label 1010: @66150
     /*  66150 */   GIM_Try, /*On fail goto*//*Label 1011*/ GIMT_Encode4(66187), // Rule ID 835 //
     /*  66155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  66158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcmpgtdp),
     /*  66163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  66166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  66172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  66176 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10652:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)  =>  (XVCMPGTDP:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /*  66176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCMPGTDP),
     /*  66179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  66181 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  66183 */     GIR_RootToRootCopy, /*OpIdx*/3, // XB
     /*  66185 */     GIR_RootConstrainSelectedInstOperands,
     /*  66186 */     // GIR_Coverage, 835,
     /*  66186 */     GIR_EraseRootFromParent_Done,
     /*  66187 */   // Label 1011: @66187
     /*  66187 */   GIM_Try, /*On fail goto*//*Label 1012*/ GIMT_Encode4(66224), // Rule ID 837 //
     /*  66192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  66195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcmpgtsp),
     /*  66200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  66203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  66209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  66213 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10654:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)  =>  (XVCMPGTSP:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /*  66213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCMPGTSP),
     /*  66216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  66218 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  66220 */     GIR_RootToRootCopy, /*OpIdx*/3, // XB
     /*  66222 */     GIR_RootConstrainSelectedInstOperands,
     /*  66223 */     // GIR_Coverage, 837,
     /*  66223 */     GIR_EraseRootFromParent_Done,
     /*  66224 */   // Label 1012: @66224
     /*  66224 */   GIM_Try, /*On fail goto*//*Label 1013*/ GIMT_Encode4(66261), // Rule ID 1001 //
     /*  66229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  66232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_addf128_round_to_odd),
     /*  66237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  66240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  66243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /*  66246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  66250 */     // (intrinsic_wo_chain:{ *:[f128] } 10080:{ *:[iPTR] }, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)  =>  (XSADDQPO:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /*  66250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSADDQPO),
     /*  66253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  66255 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  66257 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  66259 */     GIR_RootConstrainSelectedInstOperands,
     /*  66260 */     // GIR_Coverage, 1001,
     /*  66260 */     GIR_EraseRootFromParent_Done,
     /*  66261 */   // Label 1013: @66261
     /*  66261 */   GIM_Try, /*On fail goto*//*Label 1014*/ GIMT_Encode4(66298), // Rule ID 1002 //
     /*  66266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  66269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mulf128_round_to_odd),
     /*  66274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  66277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  66280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /*  66283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  66287 */     // (intrinsic_wo_chain:{ *:[f128] } 10571:{ *:[iPTR] }, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)  =>  (XSMULQPO:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /*  66287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMULQPO),
     /*  66290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  66292 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  66294 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  66296 */     GIR_RootConstrainSelectedInstOperands,
     /*  66297 */     // GIR_Coverage, 1002,
     /*  66297 */     GIR_EraseRootFromParent_Done,
     /*  66298 */   // Label 1014: @66298
     /*  66298 */   GIM_Try, /*On fail goto*//*Label 1015*/ GIMT_Encode4(66335), // Rule ID 1003 //
     /*  66303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  66306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_subf128_round_to_odd),
     /*  66311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  66314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  66317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /*  66320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  66324 */     // (intrinsic_wo_chain:{ *:[f128] } 10602:{ *:[iPTR] }, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)  =>  (XSSUBQPO:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /*  66324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSSUBQPO),
     /*  66327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  66329 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  66331 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  66333 */     GIR_RootConstrainSelectedInstOperands,
     /*  66334 */     // GIR_Coverage, 1003,
     /*  66334 */     GIR_EraseRootFromParent_Done,
     /*  66335 */   // Label 1015: @66335
     /*  66335 */   GIM_Try, /*On fail goto*//*Label 1016*/ GIMT_Encode4(66372), // Rule ID 1004 //
     /*  66340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  66343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_divf128_round_to_odd),
     /*  66348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  66351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  66354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /*  66357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  66361 */     // (intrinsic_wo_chain:{ *:[f128] } 10442:{ *:[iPTR] }, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)  =>  (XSDIVQPO:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /*  66361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSDIVQPO),
     /*  66364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  66366 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  66368 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  66370 */     GIR_RootConstrainSelectedInstOperands,
     /*  66371 */     // GIR_Coverage, 1004,
     /*  66371 */     GIR_EraseRootFromParent_Done,
     /*  66372 */   // Label 1016: @66372
     /*  66372 */   GIM_Try, /*On fail goto*//*Label 1017*/ GIMT_Encode4(66409), // Rule ID 1023 //
     /*  66377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  66380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xviexpdp),
     /*  66385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  66388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  66394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  66398 */     // (intrinsic_wo_chain:{ *:[v2f64] } 10672:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$XA, v2i64:{ *:[v2i64] }:$XB)  =>  (XVIEXPDP:{ *:[v2f64] } v2i64:{ *:[v2i64] }:$XA, v2i64:{ *:[v2i64] }:$XB)
     /*  66398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVIEXPDP),
     /*  66401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  66403 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  66405 */     GIR_RootToRootCopy, /*OpIdx*/3, // XB
     /*  66407 */     GIR_RootConstrainSelectedInstOperands,
     /*  66408 */     // GIR_Coverage, 1023,
     /*  66408 */     GIR_EraseRootFromParent_Done,
     /*  66409 */   // Label 1017: @66409
     /*  66409 */   GIM_Try, /*On fail goto*//*Label 1018*/ GIMT_Encode4(66446), // Rule ID 1024 //
     /*  66414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  66417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xviexpsp),
     /*  66422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  66425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  66431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  66435 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10673:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB)  =>  (XVIEXPSP:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB)
     /*  66435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVIEXPSP),
     /*  66438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  66440 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  66442 */     GIR_RootToRootCopy, /*OpIdx*/3, // XB
     /*  66444 */     GIR_RootConstrainSelectedInstOperands,
     /*  66445 */     // GIR_Coverage, 1024,
     /*  66445 */     GIR_EraseRootFromParent_Done,
     /*  66446 */   // Label 1018: @66446
     /*  66446 */   GIM_Try, /*On fail goto*//*Label 1019*/ GIMT_Encode4(66483), // Rule ID 1652 //
     /*  66451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  66454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvdivsp),
     /*  66459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  66462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  66468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  66472 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10671:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$A, v4f32:{ *:[v4f32] }:$B)  =>  (XVDIVSP:{ *:[v4f32] } ?:{ *:[v4f32] }:$A, ?:{ *:[v4f32] }:$B)
     /*  66472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVDIVSP),
     /*  66475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  66477 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  66479 */     GIR_RootToRootCopy, /*OpIdx*/3, // B
     /*  66481 */     GIR_RootConstrainSelectedInstOperands,
     /*  66482 */     // GIR_Coverage, 1652,
     /*  66482 */     GIR_EraseRootFromParent_Done,
     /*  66483 */   // Label 1019: @66483
     /*  66483 */   GIM_Try, /*On fail goto*//*Label 1020*/ GIMT_Encode4(66520), // Rule ID 1653 //
     /*  66488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  66491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvdivdp),
     /*  66496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  66499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  66505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  66509 */     // (intrinsic_wo_chain:{ *:[v2f64] } 10670:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$A, v2f64:{ *:[v2f64] }:$B)  =>  (XVDIVDP:{ *:[v2f64] } ?:{ *:[v2f64] }:$A, ?:{ *:[v2f64] }:$B)
     /*  66509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVDIVDP),
     /*  66512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  66514 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  66516 */     GIR_RootToRootCopy, /*OpIdx*/3, // B
     /*  66518 */     GIR_RootConstrainSelectedInstOperands,
     /*  66519 */     // GIR_Coverage, 1653,
     /*  66519 */     GIR_EraseRootFromParent_Done,
     /*  66520 */   // Label 1020: @66520
     /*  66520 */   GIM_Try, /*On fail goto*//*Label 1021*/ GIMT_Encode4(66582), // Rule ID 1654 //
     /*  66525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  66528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvtdivdp),
     /*  66533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  66536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  66542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  66546 */     // (intrinsic_wo_chain:{ *:[i32] } 10684:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$A, v2f64:{ *:[v2f64] }:$B)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (XVTDIVDP:{ *:[i32] } ?:{ *:[v2f64] }:$A, ?:{ *:[v2f64] }:$B), GPRC:{ *:[i32] })
     /*  66546 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  66549 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XVTDIVDP),
     /*  66553 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66558 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // A
     /*  66562 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // B
     /*  66566 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  66568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66573 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66576 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  66581 */     // GIR_Coverage, 1654,
     /*  66581 */     GIR_EraseRootFromParent_Done,
     /*  66582 */   // Label 1021: @66582
     /*  66582 */   GIM_Try, /*On fail goto*//*Label 1022*/ GIMT_Encode4(66644), // Rule ID 1655 //
     /*  66587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  66590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvtdivsp),
     /*  66595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  66598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  66604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  66608 */     // (intrinsic_wo_chain:{ *:[i32] } 10685:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$A, v4f32:{ *:[v4f32] }:$B)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (XVTDIVSP:{ *:[i32] } ?:{ *:[v4f32] }:$A, ?:{ *:[v4f32] }:$B), GPRC:{ *:[i32] })
     /*  66608 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  66611 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XVTDIVSP),
     /*  66615 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66620 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // A
     /*  66624 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // B
     /*  66628 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  66630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66635 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66638 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  66643 */     // GIR_Coverage, 1655,
     /*  66643 */     GIR_EraseRootFromParent_Done,
     /*  66644 */   // Label 1022: @66644
     /*  66644 */   GIM_Try, /*On fail goto*//*Label 1023*/ GIMT_Encode4(66681), // Rule ID 1899 //
     /*  66649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /*  66652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xxleqv),
     /*  66657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  66660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  66666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  66670 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10706:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$A, v4i32:{ *:[v4i32] }:$B)  =>  (XXLEQV:{ *:[v4i32] } ?:{ *:[v4i32] }:$A, ?:{ *:[v4i32] }:$B)
     /*  66670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXLEQV),
     /*  66673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  66675 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  66677 */     GIR_RootToRootCopy, /*OpIdx*/3, // B
     /*  66679 */     GIR_RootConstrainSelectedInstOperands,
     /*  66680 */     // GIR_Coverage, 1899,
     /*  66680 */     GIR_EraseRootFromParent_Done,
     /*  66681 */   // Label 1023: @66681
     /*  66681 */   GIM_Try, /*On fail goto*//*Label 1024*/ GIMT_Encode4(66763), // Rule ID 1937 //
     /*  66686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /*  66689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_insert_exp),
     /*  66694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  66697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  66700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  66703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  66707 */     // (intrinsic_wo_chain:{ *:[f64] } 10477:{ *:[iPTR] }, f64:{ *:[f64] }:$A, i64:{ *:[i64] }:$B)  =>  (COPY_TO_REGCLASS:{ *:[f64] } (XSIEXPDP:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[i64] } ?:{ *:[f64] }:$A, G8RC:{ *:[i32] }), ?:{ *:[i64] }:$B), F8RC:{ *:[i32] })
     /*  66707 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  66710 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66714 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66719 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // A
     /*  66723 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /*  66728 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66731 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSIEXPDP),
     /*  66735 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66740 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  66743 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // B
     /*  66747 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  66749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66754 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66757 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::F8RCRegClassID),
     /*  66762 */     // GIR_Coverage, 1937,
     /*  66762 */     GIR_EraseRootFromParent_Done,
     /*  66763 */   // Label 1024: @66763
     /*  66763 */   GIM_Try, /*On fail goto*//*Label 1025*/ GIMT_Encode4(66819), // Rule ID 2164 //
     /*  66768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  66771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_scalar_insert_exp_qp),
     /*  66776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  66779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  66782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  66785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  66789 */     // (intrinsic_wo_chain:{ *:[f128] } 10585:{ *:[iPTR] }, f128:{ *:[f128] }:$vA, i64:{ *:[i64] }:$vB)  =>  (XSIEXPQP:{ *:[f128] } ?:{ *:[f128] }:$vA, (MTVSRD:{ *:[f64] } ?:{ *:[i64] }:$vB))
     /*  66789 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  66792 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::MTVSRD),
     /*  66796 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66801 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vB
     /*  66805 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  66807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSIEXPQP),
     /*  66810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /*  66812 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*  66814 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66817 */     GIR_RootConstrainSelectedInstOperands,
     /*  66818 */     // GIR_Coverage, 2164,
     /*  66818 */     GIR_EraseRootFromParent_Done,
     /*  66819 */   // Label 1025: @66819
     /*  66819 */   GIM_Try, /*On fail goto*//*Label 1026*/ GIMT_Encode4(66910), // Rule ID 3343 //
     /*  66824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  66827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvtlsbb),
     /*  66832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  66835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  66838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  66841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  66845 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  66849 */     // (intrinsic_wo_chain:{ *:[i32] } 10686:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XB, 1:{ *:[i32] })  =>  (EXTRACT_SUBREG:{ *:[i32] } (XVTLSBB:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] })), sub_lt:{ *:[i32] })
     /*  66849 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  66852 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66856 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66861 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // XB
     /*  66865 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  66870 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  66873 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XVTLSBB),
     /*  66877 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66882 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  66885 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  66887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66892 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  66899 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  66904 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  66909 */     // GIR_Coverage, 3343,
     /*  66909 */     GIR_EraseRootFromParent_Done,
     /*  66910 */   // Label 1026: @66910
     /*  66910 */   GIM_Try, /*On fail goto*//*Label 1027*/ GIMT_Encode4(67001), // Rule ID 3344 //
     /*  66915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  66918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvtlsbb),
     /*  66923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  66926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  66929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  66932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  66936 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  66940 */     // (intrinsic_wo_chain:{ *:[i32] } 10686:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XB, 0:{ *:[i32] })  =>  (EXTRACT_SUBREG:{ *:[i32] } (XVTLSBB:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] })), sub_eq:{ *:[i32] })
     /*  66940 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  66943 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66947 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66952 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // XB
     /*  66956 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  66961 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  66964 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XVTLSBB),
     /*  66968 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66973 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  66976 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  66978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66983 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  66990 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  66995 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  67000 */     // GIR_Coverage, 3344,
     /*  67000 */     GIR_EraseRootFromParent_Done,
     /*  67001 */   // Label 1027: @67001
     /*  67001 */   GIM_Try, /*On fail goto*//*Label 1028*/ GIMT_Encode4(67044), // Rule ID 317 //
     /*  67006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  67009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vcfsx),
     /*  67014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  67024 */     // MIs[0] Operand 3
     /*  67024 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /*  67035 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10142:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VB, 0:{ *:[i32] })  =>  (VCFSX_0:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$VB)
     /*  67035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCFSX_0),
     /*  67038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  67040 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  67042 */     GIR_RootConstrainSelectedInstOperands,
     /*  67043 */     // GIR_Coverage, 317,
     /*  67043 */     GIR_EraseRootFromParent_Done,
     /*  67044 */   // Label 1028: @67044
     /*  67044 */   GIM_Try, /*On fail goto*//*Label 1029*/ GIMT_Encode4(67087), // Rule ID 318 //
     /*  67049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  67052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vctuxs),
     /*  67057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  67067 */     // MIs[0] Operand 3
     /*  67067 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /*  67078 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10204:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$VB, 0:{ *:[i32] })  =>  (VCTUXS_0:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$VB)
     /*  67078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCTUXS_0),
     /*  67081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  67083 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  67085 */     GIR_RootConstrainSelectedInstOperands,
     /*  67086 */     // GIR_Coverage, 318,
     /*  67086 */     GIR_EraseRootFromParent_Done,
     /*  67087 */   // Label 1029: @67087
     /*  67087 */   GIM_Try, /*On fail goto*//*Label 1030*/ GIMT_Encode4(67130), // Rule ID 319 //
     /*  67092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  67095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vcfux),
     /*  67100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  67110 */     // MIs[0] Operand 3
     /*  67110 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /*  67121 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10144:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VB, 0:{ *:[i32] })  =>  (VCFUX_0:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$VB)
     /*  67121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCFUX_0),
     /*  67124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  67126 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  67128 */     GIR_RootConstrainSelectedInstOperands,
     /*  67129 */     // GIR_Coverage, 319,
     /*  67129 */     GIR_EraseRootFromParent_Done,
     /*  67130 */   // Label 1030: @67130
     /*  67130 */   GIM_Try, /*On fail goto*//*Label 1031*/ GIMT_Encode4(67173), // Rule ID 320 //
     /*  67135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  67138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vctsxs),
     /*  67143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  67153 */     // MIs[0] Operand 3
     /*  67153 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /*  67164 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10203:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$VB, 0:{ *:[i32] })  =>  (VCTSXS_0:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$VB)
     /*  67164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCTSXS_0),
     /*  67167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  67169 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  67171 */     GIR_RootConstrainSelectedInstOperands,
     /*  67172 */     // GIR_Coverage, 320,
     /*  67172 */     GIR_EraseRootFromParent_Done,
     /*  67173 */   // Label 1031: @67173
     /*  67173 */   GIM_Try, /*On fail goto*//*Label 1032*/ GIMT_Encode4(67244), // Rule ID 3339 //
     /*  67178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  67181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xxgenpcvbm),
     /*  67186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  67189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  67192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  67195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  67199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  67203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67207 */     // MIs[1] Operand 1
     /*  67207 */     // No operand predicates
     /*  67207 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  67209 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10701:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VRB, (imm:{ *:[i32] }):$IMM)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } (XXGENPCVBM:{ *:[v4i32] } ?:{ *:[v16i8] }:$VRB, (imm:{ *:[i32] }):$IMM), VRRC:{ *:[i32] })
     /*  67209 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67212 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXGENPCVBM),
     /*  67216 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67221 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // VRB
     /*  67225 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // IMM
     /*  67228 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  67230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67235 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67238 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  67243 */     // GIR_Coverage, 3339,
     /*  67243 */     GIR_EraseRootFromParent_Done,
     /*  67244 */   // Label 1032: @67244
     /*  67244 */   GIM_Try, /*On fail goto*//*Label 1033*/ GIMT_Encode4(67315), // Rule ID 3340 //
     /*  67249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  67252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xxgenpcvhm),
     /*  67257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  67260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  67266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  67270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  67274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67278 */     // MIs[1] Operand 1
     /*  67278 */     // No operand predicates
     /*  67278 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  67280 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10703:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VRB, (imm:{ *:[i32] }):$IMM)  =>  (COPY_TO_REGCLASS:{ *:[v8i16] } (XXGENPCVHM:{ *:[v4i32] } ?:{ *:[v8i16] }:$VRB, (imm:{ *:[i32] }):$IMM), VRRC:{ *:[i32] })
     /*  67280 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67283 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXGENPCVHM),
     /*  67287 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67292 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // VRB
     /*  67296 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // IMM
     /*  67299 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  67301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67306 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67309 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  67314 */     // GIR_Coverage, 3340,
     /*  67314 */     GIR_EraseRootFromParent_Done,
     /*  67315 */   // Label 1033: @67315
     /*  67315 */   GIM_Try, /*On fail goto*//*Label 1034*/ GIMT_Encode4(67386), // Rule ID 3341 //
     /*  67320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  67323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xxgenpcvwm),
     /*  67328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  67337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  67341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  67345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67349 */     // MIs[1] Operand 1
     /*  67349 */     // No operand predicates
     /*  67349 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  67351 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10704:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VRB, (imm:{ *:[i32] }):$IMM)  =>  (COPY_TO_REGCLASS:{ *:[v4i32] } (XXGENPCVWM:{ *:[v4i32] } ?:{ *:[v4i32] }:$VRB, (imm:{ *:[i32] }):$IMM), VRRC:{ *:[i32] })
     /*  67351 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67354 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXGENPCVWM),
     /*  67358 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67363 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // VRB
     /*  67367 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // IMM
     /*  67370 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  67372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67377 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67380 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  67385 */     // GIR_Coverage, 3341,
     /*  67385 */     GIR_EraseRootFromParent_Done,
     /*  67386 */   // Label 1034: @67386
     /*  67386 */   GIM_Try, /*On fail goto*//*Label 1035*/ GIMT_Encode4(67457), // Rule ID 3342 //
     /*  67391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  67394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xxgenpcvdm),
     /*  67399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  67402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  67405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  67408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  67412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  67416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67420 */     // MIs[1] Operand 1
     /*  67420 */     // No operand predicates
     /*  67420 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  67422 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10702:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VRB, (imm:{ *:[i32] }):$IMM)  =>  (COPY_TO_REGCLASS:{ *:[v2i64] } (XXGENPCVDM:{ *:[v4i32] } ?:{ *:[v2i64] }:$VRB, (imm:{ *:[i32] }):$IMM), VRRC:{ *:[i32] })
     /*  67422 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67425 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXGENPCVDM),
     /*  67429 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67434 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // VRB
     /*  67438 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // IMM
     /*  67441 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  67443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67448 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67451 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  67456 */     // GIR_Coverage, 3342,
     /*  67456 */     GIR_EraseRootFromParent_Done,
     /*  67457 */   // Label 1035: @67457
     /*  67457 */   GIM_Try, /*On fail goto*//*Label 1036*/ GIMT_Encode4(67494), // Rule ID 313 //
     /*  67462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  67465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vcfsx),
     /*  67470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  67480 */     // MIs[0] VA
     /*  67480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  67483 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10142:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VB, (timm:{ *:[i32] }):$VA)  =>  (VCFSX:{ *:[v4f32] } (timm:{ *:[i32] }):$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  67483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCFSX),
     /*  67486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  67488 */     GIR_RootToRootCopy, /*OpIdx*/3, // VA
     /*  67490 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  67492 */     GIR_RootConstrainSelectedInstOperands,
     /*  67493 */     // GIR_Coverage, 313,
     /*  67493 */     GIR_EraseRootFromParent_Done,
     /*  67494 */   // Label 1036: @67494
     /*  67494 */   GIM_Try, /*On fail goto*//*Label 1037*/ GIMT_Encode4(67531), // Rule ID 314 //
     /*  67499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  67502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vcfux),
     /*  67507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  67517 */     // MIs[0] VA
     /*  67517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  67520 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10144:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VB, (timm:{ *:[i32] }):$VA)  =>  (VCFUX:{ *:[v4f32] } (timm:{ *:[i32] }):$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  67520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCFUX),
     /*  67523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  67525 */     GIR_RootToRootCopy, /*OpIdx*/3, // VA
     /*  67527 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  67529 */     GIR_RootConstrainSelectedInstOperands,
     /*  67530 */     // GIR_Coverage, 314,
     /*  67530 */     GIR_EraseRootFromParent_Done,
     /*  67531 */   // Label 1037: @67531
     /*  67531 */   GIM_Try, /*On fail goto*//*Label 1038*/ GIMT_Encode4(67568), // Rule ID 315 //
     /*  67536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  67539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vctsxs),
     /*  67544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  67554 */     // MIs[0] VA
     /*  67554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  67557 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10203:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$VB, (timm:{ *:[i32] }):$VA)  =>  (VCTSXS:{ *:[v4i32] } (timm:{ *:[i32] }):$VA, v4f32:{ *:[v4f32] }:$VB)
     /*  67557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCTSXS),
     /*  67560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  67562 */     GIR_RootToRootCopy, /*OpIdx*/3, // VA
     /*  67564 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  67566 */     GIR_RootConstrainSelectedInstOperands,
     /*  67567 */     // GIR_Coverage, 315,
     /*  67567 */     GIR_EraseRootFromParent_Done,
     /*  67568 */   // Label 1038: @67568
     /*  67568 */   GIM_Try, /*On fail goto*//*Label 1039*/ GIMT_Encode4(67605), // Rule ID 316 //
     /*  67573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  67576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vctuxs),
     /*  67581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  67591 */     // MIs[0] VA
     /*  67591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  67594 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10204:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$VB, (timm:{ *:[i32] }):$VA)  =>  (VCTUXS:{ *:[v4i32] } (timm:{ *:[i32] }):$VA, v4f32:{ *:[v4f32] }:$VB)
     /*  67594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCTUXS),
     /*  67597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  67599 */     GIR_RootToRootCopy, /*OpIdx*/3, // VA
     /*  67601 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  67603 */     GIR_RootConstrainSelectedInstOperands,
     /*  67604 */     // GIR_Coverage, 316,
     /*  67604 */     GIR_EraseRootFromParent_Done,
     /*  67605 */   // Label 1039: @67605
     /*  67605 */   GIM_Try, /*On fail goto*//*Label 1040*/ GIMT_Encode4(67642), // Rule ID 1094 //
     /*  67610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  67613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vcntmbb),
     /*  67618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  67621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  67624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  67628 */     // MIs[0] MP
     /*  67628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  67631 */     // (intrinsic_wo_chain:{ *:[i64] } 10199:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VB, (timm:{ *:[i32] }):$MP)  =>  (VCNTMBB:{ *:[i64] } v16i8:{ *:[v16i8] }:$VB, (timm:{ *:[i32] }):$MP)
     /*  67631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCNTMBB),
     /*  67634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RD]
     /*  67636 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  67638 */     GIR_RootToRootCopy, /*OpIdx*/3, // MP
     /*  67640 */     GIR_RootConstrainSelectedInstOperands,
     /*  67641 */     // GIR_Coverage, 1094,
     /*  67641 */     GIR_EraseRootFromParent_Done,
     /*  67642 */   // Label 1040: @67642
     /*  67642 */   GIM_Try, /*On fail goto*//*Label 1041*/ GIMT_Encode4(67679), // Rule ID 1095 //
     /*  67647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  67650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vcntmbh),
     /*  67655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  67658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  67665 */     // MIs[0] MP
     /*  67665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  67668 */     // (intrinsic_wo_chain:{ *:[i64] } 10201:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VB, (timm:{ *:[i32] }):$MP)  =>  (VCNTMBH:{ *:[i64] } v8i16:{ *:[v8i16] }:$VB, (timm:{ *:[i32] }):$MP)
     /*  67668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCNTMBH),
     /*  67671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RD]
     /*  67673 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  67675 */     GIR_RootToRootCopy, /*OpIdx*/3, // MP
     /*  67677 */     GIR_RootConstrainSelectedInstOperands,
     /*  67678 */     // GIR_Coverage, 1095,
     /*  67678 */     GIR_EraseRootFromParent_Done,
     /*  67679 */   // Label 1041: @67679
     /*  67679 */   GIM_Try, /*On fail goto*//*Label 1042*/ GIMT_Encode4(67716), // Rule ID 1096 //
     /*  67684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  67687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vcntmbw),
     /*  67692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  67695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  67702 */     // MIs[0] MP
     /*  67702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  67705 */     // (intrinsic_wo_chain:{ *:[i64] } 10202:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VB, (timm:{ *:[i32] }):$MP)  =>  (VCNTMBW:{ *:[i64] } v4i32:{ *:[v4i32] }:$VB, (timm:{ *:[i32] }):$MP)
     /*  67705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCNTMBW),
     /*  67708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RD]
     /*  67710 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  67712 */     GIR_RootToRootCopy, /*OpIdx*/3, // MP
     /*  67714 */     GIR_RootConstrainSelectedInstOperands,
     /*  67715 */     // GIR_Coverage, 1096,
     /*  67715 */     GIR_EraseRootFromParent_Done,
     /*  67716 */   // Label 1042: @67716
     /*  67716 */   GIM_Try, /*On fail goto*//*Label 1043*/ GIMT_Encode4(67753), // Rule ID 1097 //
     /*  67721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  67724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vcntmbd),
     /*  67729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  67732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  67735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  67739 */     // MIs[0] MP
     /*  67739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  67742 */     // (intrinsic_wo_chain:{ *:[i64] } 10200:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VB, (timm:{ *:[i32] }):$MP)  =>  (VCNTMBD:{ *:[i64] } v2i64:{ *:[v2i64] }:$VB, (timm:{ *:[i32] }):$MP)
     /*  67742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCNTMBD),
     /*  67745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RD]
     /*  67747 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  67749 */     GIR_RootToRootCopy, /*OpIdx*/3, // MP
     /*  67751 */     GIR_RootConstrainSelectedInstOperands,
     /*  67752 */     // GIR_Coverage, 1097,
     /*  67752 */     GIR_EraseRootFromParent_Done,
     /*  67753 */   // Label 1043: @67753
     /*  67753 */   GIM_Try, /*On fail goto*//*Label 1044*/ GIMT_Encode4(67790), // Rule ID 1111 //
     /*  67758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  67761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vgnb),
     /*  67766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  67769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  67772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  67776 */     // MIs[0] N
     /*  67776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  67779 */     // (intrinsic_wo_chain:{ *:[i64] } 10239:{ *:[iPTR] }, v1i128:{ *:[v1i128] }:$VB, (timm:{ *:[i32] }):$N)  =>  (VGNB:{ *:[i64] } v1i128:{ *:[v1i128] }:$VB, (timm:{ *:[i32] }):$N)
     /*  67779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VGNB),
     /*  67782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RD]
     /*  67784 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  67786 */     GIR_RootToRootCopy, /*OpIdx*/3, // N
     /*  67788 */     GIR_RootConstrainSelectedInstOperands,
     /*  67789 */     // GIR_Coverage, 1111,
     /*  67789 */     GIR_EraseRootFromParent_Done,
     /*  67790 */   // Label 1044: @67790
     /*  67790 */   GIM_Try, /*On fail goto*//*Label 1045*/ GIMT_Encode4(67835), // Rule ID 204 //
     /*  67795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasExtDiv),
     /*  67798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_divwe),
     /*  67803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  67806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  67809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  67812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  67816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  67820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  67824 */     // (intrinsic_wo_chain:{ *:[i32] } 10443:{ *:[iPTR] }, gprc:{ *:[i32] }:$RA, gprc:{ *:[i32] }:$RB)  =>  (DIVWE:{ *:[i32] } gprc:{ *:[i32] }:$RA, gprc:{ *:[i32] }:$RB)
     /*  67824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DIVWE),
     /*  67827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  67829 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  67831 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  67833 */     GIR_RootConstrainSelectedInstOperands,
     /*  67834 */     // GIR_Coverage, 204,
     /*  67834 */     GIR_EraseRootFromParent_Done,
     /*  67835 */   // Label 1045: @67835
     /*  67835 */   GIM_Try, /*On fail goto*//*Label 1046*/ GIMT_Encode4(67880), // Rule ID 205 //
     /*  67840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasExtDiv),
     /*  67843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_divweu),
     /*  67848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  67851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  67854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  67857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  67861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  67865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  67869 */     // (intrinsic_wo_chain:{ *:[i32] } 10444:{ *:[iPTR] }, gprc:{ *:[i32] }:$RA, gprc:{ *:[i32] }:$RB)  =>  (DIVWEU:{ *:[i32] } gprc:{ *:[i32] }:$RA, gprc:{ *:[i32] }:$RB)
     /*  67869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DIVWEU),
     /*  67872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  67874 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  67876 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  67878 */     GIR_RootConstrainSelectedInstOperands,
     /*  67879 */     // GIR_Coverage, 205,
     /*  67879 */     GIR_EraseRootFromParent_Done,
     /*  67880 */   // Label 1046: @67880
     /*  67880 */   GIM_Try, /*On fail goto*//*Label 1047*/ GIMT_Encode4(67925), // Rule ID 686 //
     /*  67885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBPERMD),
     /*  67888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_bpermd),
     /*  67893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  67896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  67899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  67902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  67906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  67910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  67914 */     // (intrinsic_wo_chain:{ *:[i64] } 10402:{ *:[iPTR] }, g8rc:{ *:[i64] }:$RST, g8rc:{ *:[i64] }:$RB)  =>  (BPERMD:{ *:[i64] } g8rc:{ *:[i64] }:$RST, g8rc:{ *:[i64] }:$RB)
     /*  67914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::BPERMD),
     /*  67917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  67919 */     GIR_RootToRootCopy, /*OpIdx*/2, // RST
     /*  67921 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  67923 */     GIR_RootConstrainSelectedInstOperands,
     /*  67924 */     // GIR_Coverage, 686,
     /*  67924 */     GIR_EraseRootFromParent_Done,
     /*  67925 */   // Label 1047: @67925
     /*  67925 */   GIM_Try, /*On fail goto*//*Label 1048*/ GIMT_Encode4(67970), // Rule ID 695 //
     /*  67930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasExtDiv),
     /*  67933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_divde),
     /*  67938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  67941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  67944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  67947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  67951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  67955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  67959 */     // (intrinsic_wo_chain:{ *:[i64] } 10440:{ *:[iPTR] }, g8rc:{ *:[i64] }:$RA, g8rc:{ *:[i64] }:$RB)  =>  (DIVDE:{ *:[i64] } g8rc:{ *:[i64] }:$RA, g8rc:{ *:[i64] }:$RB)
     /*  67959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DIVDE),
     /*  67962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  67964 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  67966 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  67968 */     GIR_RootConstrainSelectedInstOperands,
     /*  67969 */     // GIR_Coverage, 695,
     /*  67969 */     GIR_EraseRootFromParent_Done,
     /*  67970 */   // Label 1048: @67970
     /*  67970 */   GIM_Try, /*On fail goto*//*Label 1049*/ GIMT_Encode4(68015), // Rule ID 700 //
     /*  67975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasExtDiv),
     /*  67978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_divdeu),
     /*  67983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  67986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  67989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  67992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  67996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68004 */     // (intrinsic_wo_chain:{ *:[i64] } 10441:{ *:[iPTR] }, g8rc:{ *:[i64] }:$RA, g8rc:{ *:[i64] }:$RB)  =>  (DIVDEU:{ *:[i64] } g8rc:{ *:[i64] }:$RA, g8rc:{ *:[i64] }:$RB)
     /*  68004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DIVDEU),
     /*  68007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  68009 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  68011 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  68013 */     GIR_RootConstrainSelectedInstOperands,
     /*  68014 */     // GIR_Coverage, 700,
     /*  68014 */     GIR_EraseRootFromParent_Done,
     /*  68015 */   // Label 1049: @68015
     /*  68015 */   GIM_Try, /*On fail goto*//*Label 1050*/ GIMT_Encode4(68081), // Rule ID 1558 //
     /*  68020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode_IsISA3_0),
     /*  68023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_cmpeqb),
     /*  68028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  68031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  68034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  68037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68049 */     // (intrinsic_wo_chain:{ *:[i64] } 10410:{ *:[iPTR] }, g8rc:{ *:[i64] }:$a, g8rc:{ *:[i64] }:$b)  =>  (SETB8:{ *:[i64] } (CMPEQB:{ *:[i32] } ?:{ *:[i64] }:$a, ?:{ *:[i64] }:$b))
     /*  68049 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  68052 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPEQB),
     /*  68056 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68061 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // a
     /*  68065 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // b
     /*  68069 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  68071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETB8),
     /*  68074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  68076 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68079 */     GIR_RootConstrainSelectedInstOperands,
     /*  68080 */     // GIR_Coverage, 1558,
     /*  68080 */     GIR_EraseRootFromParent_Done,
     /*  68081 */   // Label 1050: @68081
     /*  68081 */   GIM_Try, /*On fail goto*//*Label 1051*/ GIMT_Encode4(68147), // Rule ID 1559 //
     /*  68086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode_IsISA3_0),
     /*  68089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_setb),
     /*  68094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  68097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  68100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  68103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68115 */     // (intrinsic_wo_chain:{ *:[i64] } 10590:{ *:[iPTR] }, g8rc:{ *:[i64] }:$a, g8rc:{ *:[i64] }:$b)  =>  (SETB8:{ *:[i64] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$a, ?:{ *:[i64] }:$b))
     /*  68115 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  68118 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /*  68122 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68127 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // a
     /*  68131 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // b
     /*  68135 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  68137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETB8),
     /*  68140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  68142 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68145 */     GIR_RootConstrainSelectedInstOperands,
     /*  68146 */     // GIR_Coverage, 1559,
     /*  68146 */     GIR_EraseRootFromParent_Done,
     /*  68147 */   // Label 1051: @68147
     /*  68147 */   GIM_Try, /*On fail goto*//*Label 1052*/ GIMT_Encode4(68192), // Rule ID 1563 //
     /*  68152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  68155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mulhd),
     /*  68160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  68163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  68166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  68169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68181 */     // (intrinsic_wo_chain:{ *:[i64] } 10572:{ *:[iPTR] }, g8rc:{ *:[i64] }:$a, g8rc:{ *:[i64] }:$b)  =>  (MULHD:{ *:[i64] } ?:{ *:[i64] }:$a, ?:{ *:[i64] }:$b)
     /*  68181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MULHD),
     /*  68184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  68186 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  68188 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  68190 */     GIR_RootConstrainSelectedInstOperands,
     /*  68191 */     // GIR_Coverage, 1563,
     /*  68191 */     GIR_EraseRootFromParent_Done,
     /*  68192 */   // Label 1052: @68192
     /*  68192 */   GIM_Try, /*On fail goto*//*Label 1053*/ GIMT_Encode4(68237), // Rule ID 1564 //
     /*  68197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  68200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mulhdu),
     /*  68205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  68208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  68211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  68214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68226 */     // (intrinsic_wo_chain:{ *:[i64] } 10573:{ *:[iPTR] }, g8rc:{ *:[i64] }:$a, g8rc:{ *:[i64] }:$b)  =>  (MULHDU:{ *:[i64] } ?:{ *:[i64] }:$a, ?:{ *:[i64] }:$b)
     /*  68226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MULHDU),
     /*  68229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  68231 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  68233 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  68235 */     GIR_RootConstrainSelectedInstOperands,
     /*  68236 */     // GIR_Coverage, 1564,
     /*  68236 */     GIR_EraseRootFromParent_Done,
     /*  68237 */   // Label 1053: @68237
     /*  68237 */   GIM_Try, /*On fail goto*//*Label 1054*/ GIMT_Encode4(68279), // Rule ID 1567 //
     /*  68242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_cmpb),
     /*  68247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  68250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  68253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  68256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68268 */     // (intrinsic_wo_chain:{ *:[i64] } 10409:{ *:[iPTR] }, g8rc:{ *:[i64] }:$a, g8rc:{ *:[i64] }:$b)  =>  (CMPB8:{ *:[i64] } ?:{ *:[i64] }:$a, ?:{ *:[i64] }:$b)
     /*  68268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CMPB8),
     /*  68271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  68273 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  68275 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  68277 */     GIR_RootConstrainSelectedInstOperands,
     /*  68278 */     // GIR_Coverage, 1567,
     /*  68278 */     GIR_EraseRootFromParent_Done,
     /*  68279 */   // Label 1054: @68279
     /*  68279 */   GIM_Try, /*On fail goto*//*Label 1055*/ GIMT_Encode4(68321), // Rule ID 4838 //
     /*  68284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mulhw),
     /*  68289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  68292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  68295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  68298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  68302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  68306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  68310 */     // (intrinsic_wo_chain:{ *:[i32] } 10574:{ *:[iPTR] }, gprc:{ *:[i32] }:$a, gprc:{ *:[i32] }:$b)  =>  (MULHW:{ *:[i32] } ?:{ *:[i32] }:$a, ?:{ *:[i32] }:$b)
     /*  68310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MULHW),
     /*  68313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  68315 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  68317 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  68319 */     GIR_RootConstrainSelectedInstOperands,
     /*  68320 */     // GIR_Coverage, 4838,
     /*  68320 */     GIR_EraseRootFromParent_Done,
     /*  68321 */   // Label 1055: @68321
     /*  68321 */   GIM_Try, /*On fail goto*//*Label 1056*/ GIMT_Encode4(68363), // Rule ID 4839 //
     /*  68326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mulhwu),
     /*  68331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  68334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  68337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  68340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  68344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  68348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  68352 */     // (intrinsic_wo_chain:{ *:[i32] } 10575:{ *:[iPTR] }, gprc:{ *:[i32] }:$a, gprc:{ *:[i32] }:$b)  =>  (MULHWU:{ *:[i32] } ?:{ *:[i32] }:$a, ?:{ *:[i32] }:$b)
     /*  68352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MULHWU),
     /*  68355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  68357 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  68359 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  68361 */     GIR_RootConstrainSelectedInstOperands,
     /*  68362 */     // GIR_Coverage, 4839,
     /*  68362 */     GIR_EraseRootFromParent_Done,
     /*  68363 */   // Label 1056: @68363
     /*  68363 */   GIM_Try, /*On fail goto*//*Label 1057*/ GIMT_Encode4(68405), // Rule ID 4840 //
     /*  68368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_cmpb),
     /*  68373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  68376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  68379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  68382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  68386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  68390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  68394 */     // (intrinsic_wo_chain:{ *:[i32] } 10409:{ *:[iPTR] }, gprc:{ *:[i32] }:$a, gprc:{ *:[i32] }:$b)  =>  (CMPB:{ *:[i32] } ?:{ *:[i32] }:$a, ?:{ *:[i32] }:$b)
     /*  68394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CMPB),
     /*  68397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  68399 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  68401 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  68403 */     GIR_RootConstrainSelectedInstOperands,
     /*  68404 */     // GIR_Coverage, 4840,
     /*  68404 */     GIR_EraseRootFromParent_Done,
     /*  68405 */   // Label 1057: @68405
     /*  68405 */   GIM_Try, /*On fail goto*//*Label 1058*/ GIMT_Encode4(68439), // Rule ID 76 //
     /*  68410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_addg6s),
     /*  68415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  68418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  68421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  68424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  68428 */     // (intrinsic_wo_chain:{ *:[i32] } 10081:{ *:[iPTR] }, i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)  =>  (ADDG6S:{ *:[i32] } i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)
     /*  68428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::ADDG6S),
     /*  68431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  68433 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  68435 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  68437 */     GIR_RootConstrainSelectedInstOperands,
     /*  68438 */     // GIR_Coverage, 76,
     /*  68438 */     GIR_EraseRootFromParent_Done,
     /*  68439 */   // Label 1058: @68439
     /*  68439 */   GIM_Try, /*On fail goto*//*Label 1059*/ GIMT_Encode4(68476), // Rule ID 304 //
     /*  68444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  68447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vaddcuw),
     /*  68452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  68455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  68461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  68465 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10125:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VADDCUW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  68465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VADDCUW),
     /*  68468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  68470 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  68472 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  68474 */     GIR_RootConstrainSelectedInstOperands,
     /*  68475 */     // GIR_Coverage, 304,
     /*  68475 */     GIR_EraseRootFromParent_Done,
     /*  68476 */   // Label 1059: @68476
     /*  68476 */   GIM_Try, /*On fail goto*//*Label 1060*/ GIMT_Encode4(68513), // Rule ID 305 //
     /*  68481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  68484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vaddsbs),
     /*  68489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  68492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  68498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  68502 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10128:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VADDSBS:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  68502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VADDSBS),
     /*  68505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  68507 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  68509 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  68511 */     GIR_RootConstrainSelectedInstOperands,
     /*  68512 */     // GIR_Coverage, 305,
     /*  68512 */     GIR_EraseRootFromParent_Done,
     /*  68513 */   // Label 1060: @68513
     /*  68513 */   GIM_Try, /*On fail goto*//*Label 1061*/ GIMT_Encode4(68550), // Rule ID 306 //
     /*  68518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  68521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vaddshs),
     /*  68526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  68529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  68535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  68539 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10129:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VADDSHS:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  68539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VADDSHS),
     /*  68542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  68544 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  68546 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  68548 */     GIR_RootConstrainSelectedInstOperands,
     /*  68549 */     // GIR_Coverage, 306,
     /*  68549 */     GIR_EraseRootFromParent_Done,
     /*  68550 */   // Label 1061: @68550
     /*  68550 */   GIM_Try, /*On fail goto*//*Label 1062*/ GIMT_Encode4(68587), // Rule ID 307 //
     /*  68555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  68558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vaddsws),
     /*  68563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  68566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  68572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  68576 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10130:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VADDSWS:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  68576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VADDSWS),
     /*  68579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  68581 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  68583 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  68585 */     GIR_RootConstrainSelectedInstOperands,
     /*  68586 */     // GIR_Coverage, 307,
     /*  68586 */     GIR_EraseRootFromParent_Done,
     /*  68587 */   // Label 1062: @68587
     /*  68587 */   GIM_Try, /*On fail goto*//*Label 1063*/ GIMT_Encode4(68624), // Rule ID 308 //
     /*  68592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  68595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vaddubs),
     /*  68600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  68603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  68609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  68613 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10131:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VADDUBS:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  68613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VADDUBS),
     /*  68616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  68618 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  68620 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  68622 */     GIR_RootConstrainSelectedInstOperands,
     /*  68623 */     // GIR_Coverage, 308,
     /*  68623 */     GIR_EraseRootFromParent_Done,
     /*  68624 */   // Label 1063: @68624
     /*  68624 */   GIM_Try, /*On fail goto*//*Label 1064*/ GIMT_Encode4(68661), // Rule ID 309 //
     /*  68629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  68632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vadduhs),
     /*  68637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  68640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  68646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  68650 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10132:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VADDUHS:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  68650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VADDUHS),
     /*  68653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  68655 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  68657 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  68659 */     GIR_RootConstrainSelectedInstOperands,
     /*  68660 */     // GIR_Coverage, 309,
     /*  68660 */     GIR_EraseRootFromParent_Done,
     /*  68661 */   // Label 1064: @68661
     /*  68661 */   GIM_Try, /*On fail goto*//*Label 1065*/ GIMT_Encode4(68698), // Rule ID 310 //
     /*  68666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  68669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vadduws),
     /*  68674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  68677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  68683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  68687 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10133:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VADDUWS:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  68687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VADDUWS),
     /*  68690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  68692 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  68694 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  68696 */     GIR_RootConstrainSelectedInstOperands,
     /*  68697 */     // GIR_Coverage, 310,
     /*  68697 */     GIR_EraseRootFromParent_Done,
     /*  68698 */   // Label 1065: @68698
     /*  68698 */   GIM_Try, /*On fail goto*//*Label 1066*/ GIMT_Encode4(68735), // Rule ID 323 //
     /*  68703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  68706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vavgsb),
     /*  68711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  68714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  68720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  68724 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10134:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VAVGSB:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  68724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VAVGSB),
     /*  68727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  68729 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  68731 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  68733 */     GIR_RootConstrainSelectedInstOperands,
     /*  68734 */     // GIR_Coverage, 323,
     /*  68734 */     GIR_EraseRootFromParent_Done,
     /*  68735 */   // Label 1066: @68735
     /*  68735 */   GIM_Try, /*On fail goto*//*Label 1067*/ GIMT_Encode4(68772), // Rule ID 324 //
     /*  68740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  68743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vavgsh),
     /*  68748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  68751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  68757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  68761 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10135:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VAVGSH:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  68761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VAVGSH),
     /*  68764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  68766 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  68768 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  68770 */     GIR_RootConstrainSelectedInstOperands,
     /*  68771 */     // GIR_Coverage, 324,
     /*  68771 */     GIR_EraseRootFromParent_Done,
     /*  68772 */   // Label 1067: @68772
     /*  68772 */   GIM_Try, /*On fail goto*//*Label 1068*/ GIMT_Encode4(68809), // Rule ID 325 //
     /*  68777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  68780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vavgsw),
     /*  68785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  68788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  68794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  68798 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10136:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VAVGSW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  68798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VAVGSW),
     /*  68801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  68803 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  68805 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  68807 */     GIR_RootConstrainSelectedInstOperands,
     /*  68808 */     // GIR_Coverage, 325,
     /*  68808 */     GIR_EraseRootFromParent_Done,
     /*  68809 */   // Label 1068: @68809
     /*  68809 */   GIM_Try, /*On fail goto*//*Label 1069*/ GIMT_Encode4(68846), // Rule ID 326 //
     /*  68814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  68817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vavgub),
     /*  68822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  68825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  68831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  68835 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10137:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VAVGUB:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  68835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VAVGUB),
     /*  68838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  68840 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  68842 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  68844 */     GIR_RootConstrainSelectedInstOperands,
     /*  68845 */     // GIR_Coverage, 326,
     /*  68845 */     GIR_EraseRootFromParent_Done,
     /*  68846 */   // Label 1069: @68846
     /*  68846 */   GIM_Try, /*On fail goto*//*Label 1070*/ GIMT_Encode4(68883), // Rule ID 327 //
     /*  68851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  68854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vavguh),
     /*  68859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  68862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  68868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  68872 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10138:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VAVGUH:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  68872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VAVGUH),
     /*  68875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  68877 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  68879 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  68881 */     GIR_RootConstrainSelectedInstOperands,
     /*  68882 */     // GIR_Coverage, 327,
     /*  68882 */     GIR_EraseRootFromParent_Done,
     /*  68883 */   // Label 1070: @68883
     /*  68883 */   GIM_Try, /*On fail goto*//*Label 1071*/ GIMT_Encode4(68920), // Rule ID 328 //
     /*  68888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  68891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vavguw),
     /*  68896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  68899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  68905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  68909 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10139:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VAVGUW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  68909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VAVGUW),
     /*  68912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  68914 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  68916 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  68918 */     GIR_RootConstrainSelectedInstOperands,
     /*  68919 */     // GIR_Coverage, 328,
     /*  68919 */     GIR_EraseRootFromParent_Done,
     /*  68920 */   // Label 1071: @68920
     /*  68920 */   GIM_Try, /*On fail goto*//*Label 1072*/ GIMT_Encode4(68957), // Rule ID 329 //
     /*  68925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  68928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmaxfp),
     /*  68933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  68936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  68942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  68946 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10258:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$VA, v4f32:{ *:[v4f32] }:$VB)  =>  (VMAXFP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$VA, v4f32:{ *:[v4f32] }:$VB)
     /*  68946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMAXFP),
     /*  68949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  68951 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  68953 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  68955 */     GIR_RootConstrainSelectedInstOperands,
     /*  68956 */     // GIR_Coverage, 329,
     /*  68956 */     GIR_EraseRootFromParent_Done,
     /*  68957 */   // Label 1072: @68957
     /*  68957 */   GIM_Try, /*On fail goto*//*Label 1073*/ GIMT_Encode4(68994), // Rule ID 330 //
     /*  68962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  68965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmaxsb),
     /*  68970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  68973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  68979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  68983 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10259:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VMAXSB:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  68983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMAXSB),
     /*  68986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  68988 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  68990 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  68992 */     GIR_RootConstrainSelectedInstOperands,
     /*  68993 */     // GIR_Coverage, 330,
     /*  68993 */     GIR_EraseRootFromParent_Done,
     /*  68994 */   // Label 1073: @68994
     /*  68994 */   GIM_Try, /*On fail goto*//*Label 1074*/ GIMT_Encode4(69031), // Rule ID 331 //
     /*  68999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmaxsh),
     /*  69007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  69010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  69016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69020 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10261:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VMAXSH:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  69020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMAXSH),
     /*  69023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69025 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69027 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69029 */     GIR_RootConstrainSelectedInstOperands,
     /*  69030 */     // GIR_Coverage, 331,
     /*  69030 */     GIR_EraseRootFromParent_Done,
     /*  69031 */   // Label 1074: @69031
     /*  69031 */   GIM_Try, /*On fail goto*//*Label 1075*/ GIMT_Encode4(69068), // Rule ID 332 //
     /*  69036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmaxsw),
     /*  69044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  69053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69057 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10262:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VMAXSW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  69057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMAXSW),
     /*  69060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69062 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69064 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69066 */     GIR_RootConstrainSelectedInstOperands,
     /*  69067 */     // GIR_Coverage, 332,
     /*  69067 */     GIR_EraseRootFromParent_Done,
     /*  69068 */   // Label 1075: @69068
     /*  69068 */   GIM_Try, /*On fail goto*//*Label 1076*/ GIMT_Encode4(69105), // Rule ID 333 //
     /*  69073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmaxub),
     /*  69081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  69084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  69087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  69090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69094 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10263:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VMAXUB:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  69094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMAXUB),
     /*  69097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69099 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69101 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69103 */     GIR_RootConstrainSelectedInstOperands,
     /*  69104 */     // GIR_Coverage, 333,
     /*  69104 */     GIR_EraseRootFromParent_Done,
     /*  69105 */   // Label 1076: @69105
     /*  69105 */   GIM_Try, /*On fail goto*//*Label 1077*/ GIMT_Encode4(69142), // Rule ID 334 //
     /*  69110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmaxuh),
     /*  69118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  69121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  69127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69131 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10265:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VMAXUH:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  69131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMAXUH),
     /*  69134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69136 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69138 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69140 */     GIR_RootConstrainSelectedInstOperands,
     /*  69141 */     // GIR_Coverage, 334,
     /*  69141 */     GIR_EraseRootFromParent_Done,
     /*  69142 */   // Label 1077: @69142
     /*  69142 */   GIM_Try, /*On fail goto*//*Label 1078*/ GIMT_Encode4(69179), // Rule ID 335 //
     /*  69147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmaxuw),
     /*  69155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  69164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69168 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10266:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VMAXUW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  69168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMAXUW),
     /*  69171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69173 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69175 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69177 */     GIR_RootConstrainSelectedInstOperands,
     /*  69178 */     // GIR_Coverage, 335,
     /*  69178 */     GIR_EraseRootFromParent_Done,
     /*  69179 */   // Label 1078: @69179
     /*  69179 */   GIM_Try, /*On fail goto*//*Label 1079*/ GIMT_Encode4(69216), // Rule ID 336 //
     /*  69184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vminfp),
     /*  69192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  69201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69205 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10269:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$VA, v4f32:{ *:[v4f32] }:$VB)  =>  (VMINFP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$VA, v4f32:{ *:[v4f32] }:$VB)
     /*  69205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMINFP),
     /*  69208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69210 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69212 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69214 */     GIR_RootConstrainSelectedInstOperands,
     /*  69215 */     // GIR_Coverage, 336,
     /*  69215 */     GIR_EraseRootFromParent_Done,
     /*  69216 */   // Label 1079: @69216
     /*  69216 */   GIM_Try, /*On fail goto*//*Label 1080*/ GIMT_Encode4(69253), // Rule ID 337 //
     /*  69221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vminsb),
     /*  69229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  69232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  69235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  69238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69242 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10270:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VMINSB:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  69242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMINSB),
     /*  69245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69247 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69249 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69251 */     GIR_RootConstrainSelectedInstOperands,
     /*  69252 */     // GIR_Coverage, 337,
     /*  69252 */     GIR_EraseRootFromParent_Done,
     /*  69253 */   // Label 1080: @69253
     /*  69253 */   GIM_Try, /*On fail goto*//*Label 1081*/ GIMT_Encode4(69290), // Rule ID 338 //
     /*  69258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vminsh),
     /*  69266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  69269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  69275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69279 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10272:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VMINSH:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  69279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMINSH),
     /*  69282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69284 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69286 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69288 */     GIR_RootConstrainSelectedInstOperands,
     /*  69289 */     // GIR_Coverage, 338,
     /*  69289 */     GIR_EraseRootFromParent_Done,
     /*  69290 */   // Label 1081: @69290
     /*  69290 */   GIM_Try, /*On fail goto*//*Label 1082*/ GIMT_Encode4(69327), // Rule ID 339 //
     /*  69295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vminsw),
     /*  69303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  69312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69316 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10273:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VMINSW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  69316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMINSW),
     /*  69319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69321 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69323 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69325 */     GIR_RootConstrainSelectedInstOperands,
     /*  69326 */     // GIR_Coverage, 339,
     /*  69326 */     GIR_EraseRootFromParent_Done,
     /*  69327 */   // Label 1082: @69327
     /*  69327 */   GIM_Try, /*On fail goto*//*Label 1083*/ GIMT_Encode4(69364), // Rule ID 340 //
     /*  69332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vminub),
     /*  69340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  69343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  69346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  69349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69353 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10274:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VMINUB:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  69353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMINUB),
     /*  69356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69358 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69360 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69362 */     GIR_RootConstrainSelectedInstOperands,
     /*  69363 */     // GIR_Coverage, 340,
     /*  69363 */     GIR_EraseRootFromParent_Done,
     /*  69364 */   // Label 1083: @69364
     /*  69364 */   GIM_Try, /*On fail goto*//*Label 1084*/ GIMT_Encode4(69401), // Rule ID 341 //
     /*  69369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vminuh),
     /*  69377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  69380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  69386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69390 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10276:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VMINUH:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  69390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMINUH),
     /*  69393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69395 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69397 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69399 */     GIR_RootConstrainSelectedInstOperands,
     /*  69400 */     // GIR_Coverage, 341,
     /*  69400 */     GIR_EraseRootFromParent_Done,
     /*  69401 */   // Label 1084: @69401
     /*  69401 */   GIM_Try, /*On fail goto*//*Label 1085*/ GIMT_Encode4(69438), // Rule ID 342 //
     /*  69406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vminuw),
     /*  69414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  69423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69427 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10277:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VMINUW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  69427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMINUW),
     /*  69430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69432 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69434 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69436 */     GIR_RootConstrainSelectedInstOperands,
     /*  69437 */     // GIR_Coverage, 342,
     /*  69437 */     GIR_EraseRootFromParent_Done,
     /*  69438 */   // Label 1085: @69438
     /*  69438 */   GIM_Try, /*On fail goto*//*Label 1086*/ GIMT_Encode4(69475), // Rule ID 355 //
     /*  69443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmulesb),
     /*  69451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  69454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  69457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  69460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69464 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10287:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VMULESB:{ *:[v8i16] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  69464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULESB),
     /*  69467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69469 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69471 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69473 */     GIR_RootConstrainSelectedInstOperands,
     /*  69474 */     // GIR_Coverage, 355,
     /*  69474 */     GIR_EraseRootFromParent_Done,
     /*  69475 */   // Label 1086: @69475
     /*  69475 */   GIM_Try, /*On fail goto*//*Label 1087*/ GIMT_Encode4(69512), // Rule ID 356 //
     /*  69480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmulesh),
     /*  69488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  69497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69501 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10289:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VMULESH:{ *:[v4i32] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  69501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULESH),
     /*  69504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69506 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69508 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69510 */     GIR_RootConstrainSelectedInstOperands,
     /*  69511 */     // GIR_Coverage, 356,
     /*  69511 */     GIR_EraseRootFromParent_Done,
     /*  69512 */   // Label 1087: @69512
     /*  69512 */   GIM_Try, /*On fail goto*//*Label 1088*/ GIMT_Encode4(69549), // Rule ID 357 //
     /*  69517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmuleub),
     /*  69525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  69528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  69531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  69534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69538 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10291:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VMULEUB:{ *:[v8i16] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  69538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULEUB),
     /*  69541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69543 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69545 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69547 */     GIR_RootConstrainSelectedInstOperands,
     /*  69548 */     // GIR_Coverage, 357,
     /*  69548 */     GIR_EraseRootFromParent_Done,
     /*  69549 */   // Label 1088: @69549
     /*  69549 */   GIM_Try, /*On fail goto*//*Label 1089*/ GIMT_Encode4(69586), // Rule ID 358 //
     /*  69554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmuleuh),
     /*  69562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  69571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69575 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10293:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VMULEUH:{ *:[v4i32] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  69575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULEUH),
     /*  69578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69580 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69582 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69584 */     GIR_RootConstrainSelectedInstOperands,
     /*  69585 */     // GIR_Coverage, 358,
     /*  69585 */     GIR_EraseRootFromParent_Done,
     /*  69586 */   // Label 1089: @69586
     /*  69586 */   GIM_Try, /*On fail goto*//*Label 1090*/ GIMT_Encode4(69623), // Rule ID 359 //
     /*  69591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmulosb),
     /*  69599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  69602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  69605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  69608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69612 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10299:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VMULOSB:{ *:[v8i16] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  69612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULOSB),
     /*  69615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69617 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69619 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69621 */     GIR_RootConstrainSelectedInstOperands,
     /*  69622 */     // GIR_Coverage, 359,
     /*  69622 */     GIR_EraseRootFromParent_Done,
     /*  69623 */   // Label 1090: @69623
     /*  69623 */   GIM_Try, /*On fail goto*//*Label 1091*/ GIMT_Encode4(69660), // Rule ID 360 //
     /*  69628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmulosh),
     /*  69636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  69645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69649 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10301:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VMULOSH:{ *:[v4i32] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  69649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULOSH),
     /*  69652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69654 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69656 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69658 */     GIR_RootConstrainSelectedInstOperands,
     /*  69659 */     // GIR_Coverage, 360,
     /*  69659 */     GIR_EraseRootFromParent_Done,
     /*  69660 */   // Label 1091: @69660
     /*  69660 */   GIM_Try, /*On fail goto*//*Label 1092*/ GIMT_Encode4(69697), // Rule ID 361 //
     /*  69665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmuloub),
     /*  69673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  69676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  69679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  69682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69686 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10303:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VMULOUB:{ *:[v8i16] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  69686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULOUB),
     /*  69689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69691 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69693 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69695 */     GIR_RootConstrainSelectedInstOperands,
     /*  69696 */     // GIR_Coverage, 361,
     /*  69696 */     GIR_EraseRootFromParent_Done,
     /*  69697 */   // Label 1092: @69697
     /*  69697 */   GIM_Try, /*On fail goto*//*Label 1093*/ GIMT_Encode4(69734), // Rule ID 362 //
     /*  69702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmulouh),
     /*  69710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  69719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69723 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10305:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VMULOUH:{ *:[v4i32] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  69723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULOUH),
     /*  69726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69728 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69730 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69732 */     GIR_RootConstrainSelectedInstOperands,
     /*  69733 */     // GIR_Coverage, 362,
     /*  69733 */     GIR_EraseRootFromParent_Done,
     /*  69734 */   // Label 1093: @69734
     /*  69734 */   GIM_Try, /*On fail goto*//*Label 1094*/ GIMT_Encode4(69771), // Rule ID 369 //
     /*  69739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsubcuw),
     /*  69747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  69756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69760 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10367:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VSUBCUW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  69760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSUBCUW),
     /*  69763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69765 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69767 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69769 */     GIR_RootConstrainSelectedInstOperands,
     /*  69770 */     // GIR_Coverage, 369,
     /*  69770 */     GIR_EraseRootFromParent_Done,
     /*  69771 */   // Label 1094: @69771
     /*  69771 */   GIM_Try, /*On fail goto*//*Label 1095*/ GIMT_Encode4(69808), // Rule ID 374 //
     /*  69776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsubsbs),
     /*  69784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  69787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  69790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  69793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69797 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10370:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VSUBSBS:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  69797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSUBSBS),
     /*  69800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69802 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69804 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69806 */     GIR_RootConstrainSelectedInstOperands,
     /*  69807 */     // GIR_Coverage, 374,
     /*  69807 */     GIR_EraseRootFromParent_Done,
     /*  69808 */   // Label 1095: @69808
     /*  69808 */   GIM_Try, /*On fail goto*//*Label 1096*/ GIMT_Encode4(69845), // Rule ID 375 //
     /*  69813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsubshs),
     /*  69821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  69824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  69830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69834 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10371:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VSUBSHS:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  69834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSUBSHS),
     /*  69837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69839 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69841 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69843 */     GIR_RootConstrainSelectedInstOperands,
     /*  69844 */     // GIR_Coverage, 375,
     /*  69844 */     GIR_EraseRootFromParent_Done,
     /*  69845 */   // Label 1096: @69845
     /*  69845 */   GIM_Try, /*On fail goto*//*Label 1097*/ GIMT_Encode4(69882), // Rule ID 376 //
     /*  69850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsubsws),
     /*  69858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  69867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69871 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10372:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VSUBSWS:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  69871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSUBSWS),
     /*  69874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69876 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69878 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69880 */     GIR_RootConstrainSelectedInstOperands,
     /*  69881 */     // GIR_Coverage, 376,
     /*  69881 */     GIR_EraseRootFromParent_Done,
     /*  69882 */   // Label 1097: @69882
     /*  69882 */   GIM_Try, /*On fail goto*//*Label 1098*/ GIMT_Encode4(69919), // Rule ID 377 //
     /*  69887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsububs),
     /*  69895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  69898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  69901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  69904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69908 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10373:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VSUBUBS:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  69908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSUBUBS),
     /*  69911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69913 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69915 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69917 */     GIR_RootConstrainSelectedInstOperands,
     /*  69918 */     // GIR_Coverage, 377,
     /*  69918 */     GIR_EraseRootFromParent_Done,
     /*  69919 */   // Label 1098: @69919
     /*  69919 */   GIM_Try, /*On fail goto*//*Label 1099*/ GIMT_Encode4(69956), // Rule ID 378 //
     /*  69924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsubuhs),
     /*  69932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  69935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  69941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69945 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10374:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VSUBUHS:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  69945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSUBUHS),
     /*  69948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69950 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69952 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69954 */     GIR_RootConstrainSelectedInstOperands,
     /*  69955 */     // GIR_Coverage, 378,
     /*  69955 */     GIR_EraseRootFromParent_Done,
     /*  69956 */   // Label 1099: @69956
     /*  69956 */   GIM_Try, /*On fail goto*//*Label 1100*/ GIMT_Encode4(69993), // Rule ID 379 //
     /*  69961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsubuws),
     /*  69969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  69978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69982 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10375:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VSUBUWS:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  69982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSUBUWS),
     /*  69985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69987 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69989 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69991 */     GIR_RootConstrainSelectedInstOperands,
     /*  69992 */     // GIR_Coverage, 379,
     /*  69992 */     GIR_EraseRootFromParent_Done,
     /*  69993 */   // Label 1100: @69993
     /*  69993 */   GIM_Try, /*On fail goto*//*Label 1101*/ GIMT_Encode4(70030), // Rule ID 388 //
     /*  69998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vrlb),
     /*  70006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  70009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  70012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  70015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70019 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10329:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VRLB:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  70019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VRLB),
     /*  70022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70024 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70026 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70028 */     GIR_RootConstrainSelectedInstOperands,
     /*  70029 */     // GIR_Coverage, 388,
     /*  70029 */     GIR_EraseRootFromParent_Done,
     /*  70030 */   // Label 1101: @70030
     /*  70030 */   GIM_Try, /*On fail goto*//*Label 1102*/ GIMT_Encode4(70067), // Rule ID 389 //
     /*  70035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vrlh),
     /*  70043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  70046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  70052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70056 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10333:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VRLH:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  70056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VRLH),
     /*  70059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70061 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70063 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70065 */     GIR_RootConstrainSelectedInstOperands,
     /*  70066 */     // GIR_Coverage, 389,
     /*  70066 */     GIR_EraseRootFromParent_Done,
     /*  70067 */   // Label 1102: @70067
     /*  70067 */   GIM_Try, /*On fail goto*//*Label 1103*/ GIMT_Encode4(70104), // Rule ID 390 //
     /*  70072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vrlw),
     /*  70080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70093 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10336:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VRLW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  70093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VRLW),
     /*  70096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70098 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70100 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70102 */     GIR_RootConstrainSelectedInstOperands,
     /*  70103 */     // GIR_Coverage, 390,
     /*  70103 */     GIR_EraseRootFromParent_Done,
     /*  70104 */   // Label 1103: @70104
     /*  70104 */   GIM_Try, /*On fail goto*//*Label 1104*/ GIMT_Encode4(70141), // Rule ID 391 //
     /*  70109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsl),
     /*  70117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70130 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10341:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VSL:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  70130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSL),
     /*  70133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70135 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70137 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70139 */     GIR_RootConstrainSelectedInstOperands,
     /*  70140 */     // GIR_Coverage, 391,
     /*  70140 */     GIR_EraseRootFromParent_Done,
     /*  70141 */   // Label 1104: @70141
     /*  70141 */   GIM_Try, /*On fail goto*//*Label 1105*/ GIMT_Encode4(70178), // Rule ID 392 //
     /*  70146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vslo),
     /*  70154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70167 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10345:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VSLO:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  70167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSLO),
     /*  70170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70172 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70174 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70176 */     GIR_RootConstrainSelectedInstOperands,
     /*  70177 */     // GIR_Coverage, 392,
     /*  70177 */     GIR_EraseRootFromParent_Done,
     /*  70178 */   // Label 1105: @70178
     /*  70178 */   GIM_Try, /*On fail goto*//*Label 1106*/ GIMT_Encode4(70215), // Rule ID 393 //
     /*  70183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vslb),
     /*  70191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  70194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  70197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  70200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70204 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10342:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VSLB:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  70204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSLB),
     /*  70207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70209 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70211 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70213 */     GIR_RootConstrainSelectedInstOperands,
     /*  70214 */     // GIR_Coverage, 393,
     /*  70214 */     GIR_EraseRootFromParent_Done,
     /*  70215 */   // Label 1106: @70215
     /*  70215 */   GIM_Try, /*On fail goto*//*Label 1107*/ GIMT_Encode4(70252), // Rule ID 394 //
     /*  70220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vslh),
     /*  70228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  70231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  70237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70241 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10344:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VSLH:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  70241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSLH),
     /*  70244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70246 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70248 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70250 */     GIR_RootConstrainSelectedInstOperands,
     /*  70251 */     // GIR_Coverage, 394,
     /*  70251 */     GIR_EraseRootFromParent_Done,
     /*  70252 */   // Label 1107: @70252
     /*  70252 */   GIM_Try, /*On fail goto*//*Label 1108*/ GIMT_Encode4(70289), // Rule ID 395 //
     /*  70257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vslw),
     /*  70265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70278 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10347:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VSLW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  70278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSLW),
     /*  70281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70283 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70285 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70287 */     GIR_RootConstrainSelectedInstOperands,
     /*  70288 */     // GIR_Coverage, 395,
     /*  70288 */     GIR_EraseRootFromParent_Done,
     /*  70289 */   // Label 1108: @70289
     /*  70289 */   GIM_Try, /*On fail goto*//*Label 1109*/ GIMT_Encode4(70326), // Rule ID 399 //
     /*  70294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsr),
     /*  70302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70315 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10348:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VSR:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  70315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSR),
     /*  70318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70320 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70322 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70324 */     GIR_RootConstrainSelectedInstOperands,
     /*  70325 */     // GIR_Coverage, 399,
     /*  70325 */     GIR_EraseRootFromParent_Done,
     /*  70326 */   // Label 1109: @70326
     /*  70326 */   GIM_Try, /*On fail goto*//*Label 1110*/ GIMT_Encode4(70363), // Rule ID 400 //
     /*  70331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsro),
     /*  70339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70352 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10355:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VSRO:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  70352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSRO),
     /*  70355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70357 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70359 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70361 */     GIR_RootConstrainSelectedInstOperands,
     /*  70362 */     // GIR_Coverage, 400,
     /*  70362 */     GIR_EraseRootFromParent_Done,
     /*  70363 */   // Label 1110: @70363
     /*  70363 */   GIM_Try, /*On fail goto*//*Label 1111*/ GIMT_Encode4(70400), // Rule ID 401 //
     /*  70368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsrab),
     /*  70376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  70379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  70382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  70385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70389 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10349:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VSRAB:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  70389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSRAB),
     /*  70392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70394 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70396 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70398 */     GIR_RootConstrainSelectedInstOperands,
     /*  70399 */     // GIR_Coverage, 401,
     /*  70399 */     GIR_EraseRootFromParent_Done,
     /*  70400 */   // Label 1111: @70400
     /*  70400 */   GIM_Try, /*On fail goto*//*Label 1112*/ GIMT_Encode4(70437), // Rule ID 402 //
     /*  70405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsrah),
     /*  70413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  70416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  70422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70426 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10350:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VSRAH:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  70426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSRAH),
     /*  70429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70431 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70433 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70435 */     GIR_RootConstrainSelectedInstOperands,
     /*  70436 */     // GIR_Coverage, 402,
     /*  70436 */     GIR_EraseRootFromParent_Done,
     /*  70437 */   // Label 1112: @70437
     /*  70437 */   GIM_Try, /*On fail goto*//*Label 1113*/ GIMT_Encode4(70474), // Rule ID 403 //
     /*  70442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsraw),
     /*  70450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70463 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10351:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VSRAW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  70463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSRAW),
     /*  70466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70468 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70470 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70472 */     GIR_RootConstrainSelectedInstOperands,
     /*  70473 */     // GIR_Coverage, 403,
     /*  70473 */     GIR_EraseRootFromParent_Done,
     /*  70474 */   // Label 1113: @70474
     /*  70474 */   GIM_Try, /*On fail goto*//*Label 1114*/ GIMT_Encode4(70511), // Rule ID 404 //
     /*  70479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsrb),
     /*  70487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  70490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  70493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  70496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70500 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10352:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VSRB:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  70500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSRB),
     /*  70503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70505 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70507 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70509 */     GIR_RootConstrainSelectedInstOperands,
     /*  70510 */     // GIR_Coverage, 404,
     /*  70510 */     GIR_EraseRootFromParent_Done,
     /*  70511 */   // Label 1114: @70511
     /*  70511 */   GIM_Try, /*On fail goto*//*Label 1115*/ GIMT_Encode4(70548), // Rule ID 405 //
     /*  70516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsrh),
     /*  70524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  70527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  70533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70537 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10354:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VSRH:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  70537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSRH),
     /*  70540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70542 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70544 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70546 */     GIR_RootConstrainSelectedInstOperands,
     /*  70547 */     // GIR_Coverage, 405,
     /*  70547 */     GIR_EraseRootFromParent_Done,
     /*  70548 */   // Label 1115: @70548
     /*  70548 */   GIM_Try, /*On fail goto*//*Label 1116*/ GIMT_Encode4(70585), // Rule ID 406 //
     /*  70553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsrw),
     /*  70561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70574 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10357:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VSRW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  70574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSRW),
     /*  70577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70579 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70581 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70583 */     GIR_RootConstrainSelectedInstOperands,
     /*  70584 */     // GIR_Coverage, 406,
     /*  70584 */     GIR_EraseRootFromParent_Done,
     /*  70585 */   // Label 1116: @70585
     /*  70585 */   GIM_Try, /*On fail goto*//*Label 1117*/ GIMT_Encode4(70622), // Rule ID 410 //
     /*  70590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vpkpx),
     /*  70598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  70601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70611 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10311:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VPKPX:{ *:[v8i16] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  70611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPKPX),
     /*  70614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70616 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70618 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70620 */     GIR_RootConstrainSelectedInstOperands,
     /*  70621 */     // GIR_Coverage, 410,
     /*  70621 */     GIR_EraseRootFromParent_Done,
     /*  70622 */   // Label 1117: @70622
     /*  70622 */   GIM_Try, /*On fail goto*//*Label 1118*/ GIMT_Encode4(70659), // Rule ID 457 //
     /*  70627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  70630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmulesw),
     /*  70635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  70638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70648 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10290:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VMULESW:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  70648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULESW),
     /*  70651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70653 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70655 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70657 */     GIR_RootConstrainSelectedInstOperands,
     /*  70658 */     // GIR_Coverage, 457,
     /*  70658 */     GIR_EraseRootFromParent_Done,
     /*  70659 */   // Label 1118: @70659
     /*  70659 */   GIM_Try, /*On fail goto*//*Label 1119*/ GIMT_Encode4(70696), // Rule ID 458 //
     /*  70664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  70667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmuleuw),
     /*  70672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  70675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70685 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10294:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VMULEUW:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  70685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULEUW),
     /*  70688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70690 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70692 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70694 */     GIR_RootConstrainSelectedInstOperands,
     /*  70695 */     // GIR_Coverage, 458,
     /*  70695 */     GIR_EraseRootFromParent_Done,
     /*  70696 */   // Label 1119: @70696
     /*  70696 */   GIM_Try, /*On fail goto*//*Label 1120*/ GIMT_Encode4(70733), // Rule ID 459 //
     /*  70701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  70704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmulosw),
     /*  70709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  70712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70722 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10302:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VMULOSW:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  70722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULOSW),
     /*  70725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70727 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70729 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70731 */     GIR_RootConstrainSelectedInstOperands,
     /*  70732 */     // GIR_Coverage, 459,
     /*  70732 */     GIR_EraseRootFromParent_Done,
     /*  70733 */   // Label 1120: @70733
     /*  70733 */   GIM_Try, /*On fail goto*//*Label 1121*/ GIMT_Encode4(70770), // Rule ID 460 //
     /*  70738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  70741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmulouw),
     /*  70746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  70749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70759 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10306:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VMULOUW:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  70759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULOUW),
     /*  70762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70764 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70766 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70768 */     GIR_RootConstrainSelectedInstOperands,
     /*  70769 */     // GIR_Coverage, 460,
     /*  70769 */     GIR_EraseRootFromParent_Done,
     /*  70770 */   // Label 1121: @70770
     /*  70770 */   GIM_Try, /*On fail goto*//*Label 1122*/ GIMT_Encode4(70807), // Rule ID 462 //
     /*  70775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  70778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmaxsd),
     /*  70783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  70786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  70789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  70792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70796 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10260:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VMAXSD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  70796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMAXSD),
     /*  70799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70801 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70803 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70805 */     GIR_RootConstrainSelectedInstOperands,
     /*  70806 */     // GIR_Coverage, 462,
     /*  70806 */     GIR_EraseRootFromParent_Done,
     /*  70807 */   // Label 1122: @70807
     /*  70807 */   GIM_Try, /*On fail goto*//*Label 1123*/ GIMT_Encode4(70844), // Rule ID 463 //
     /*  70812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  70815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmaxud),
     /*  70820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  70823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  70826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  70829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70833 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10264:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VMAXUD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  70833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMAXUD),
     /*  70836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70838 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70840 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70842 */     GIR_RootConstrainSelectedInstOperands,
     /*  70843 */     // GIR_Coverage, 463,
     /*  70843 */     GIR_EraseRootFromParent_Done,
     /*  70844 */   // Label 1123: @70844
     /*  70844 */   GIM_Try, /*On fail goto*//*Label 1124*/ GIMT_Encode4(70881), // Rule ID 464 //
     /*  70849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  70852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vminsd),
     /*  70857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  70860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  70863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  70866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70870 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10271:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VMINSD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  70870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMINSD),
     /*  70873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70875 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70877 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70879 */     GIR_RootConstrainSelectedInstOperands,
     /*  70880 */     // GIR_Coverage, 464,
     /*  70880 */     GIR_EraseRootFromParent_Done,
     /*  70881 */   // Label 1124: @70881
     /*  70881 */   GIM_Try, /*On fail goto*//*Label 1125*/ GIMT_Encode4(70918), // Rule ID 465 //
     /*  70886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  70889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vminud),
     /*  70894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  70897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  70900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  70903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70907 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10275:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VMINUD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  70907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMINUD),
     /*  70910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70912 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70914 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70916 */     GIR_RootConstrainSelectedInstOperands,
     /*  70917 */     // GIR_Coverage, 465,
     /*  70917 */     GIR_EraseRootFromParent_Done,
     /*  70918 */   // Label 1125: @70918
     /*  70918 */   GIM_Try, /*On fail goto*//*Label 1126*/ GIMT_Encode4(70955), // Rule ID 468 //
     /*  70923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  70926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vrld),
     /*  70931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  70934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  70937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  70940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70944 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10330:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VRLD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  70944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VRLD),
     /*  70947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70949 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70951 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70953 */     GIR_RootConstrainSelectedInstOperands,
     /*  70954 */     // GIR_Coverage, 468,
     /*  70954 */     GIR_EraseRootFromParent_Done,
     /*  70955 */   // Label 1126: @70955
     /*  70955 */   GIM_Try, /*On fail goto*//*Label 1127*/ GIMT_Encode4(70992), // Rule ID 472 //
     /*  70960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  70963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vaddcuq),
     /*  70968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  70971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  70974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /*  70977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70981 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10124:{ *:[iPTR] }, v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)  =>  (VADDCUQ:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)
     /*  70981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VADDCUQ),
     /*  70984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70986 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70988 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70990 */     GIR_RootConstrainSelectedInstOperands,
     /*  70991 */     // GIR_Coverage, 472,
     /*  70991 */     GIR_EraseRootFromParent_Done,
     /*  70992 */   // Label 1127: @70992
     /*  70992 */   GIM_Try, /*On fail goto*//*Label 1128*/ GIMT_Encode4(71029), // Rule ID 477 //
     /*  70997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  71000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsubcuq),
     /*  71005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  71008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  71011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /*  71014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71018 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10366:{ *:[iPTR] }, v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)  =>  (VSUBCUQ:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)
     /*  71018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSUBCUQ),
     /*  71021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71023 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71025 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71027 */     GIR_RootConstrainSelectedInstOperands,
     /*  71028 */     // GIR_Coverage, 477,
     /*  71028 */     GIR_EraseRootFromParent_Done,
     /*  71029 */   // Label 1128: @71029
     /*  71029 */   GIM_Try, /*On fail goto*//*Label 1129*/ GIMT_Encode4(71066), // Rule ID 496 //
     /*  71034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  71037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_crypto_vpmsumb),
     /*  71042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  71045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  71051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71055 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10089:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VPMSUMB:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  71055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPMSUMB),
     /*  71058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71060 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71062 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71064 */     GIR_RootConstrainSelectedInstOperands,
     /*  71065 */     // GIR_Coverage, 496,
     /*  71065 */     GIR_EraseRootFromParent_Done,
     /*  71066 */   // Label 1129: @71066
     /*  71066 */   GIM_Try, /*On fail goto*//*Label 1130*/ GIMT_Encode4(71103), // Rule ID 497 //
     /*  71071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  71074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_crypto_vpmsumh),
     /*  71079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  71082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  71085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  71088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71092 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10091:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VPMSUMH:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  71092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPMSUMH),
     /*  71095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71097 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71099 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71101 */     GIR_RootConstrainSelectedInstOperands,
     /*  71102 */     // GIR_Coverage, 497,
     /*  71102 */     GIR_EraseRootFromParent_Done,
     /*  71103 */   // Label 1130: @71103
     /*  71103 */   GIM_Try, /*On fail goto*//*Label 1131*/ GIMT_Encode4(71140), // Rule ID 498 //
     /*  71108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  71111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_crypto_vpmsumw),
     /*  71116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  71119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  71122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  71125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71129 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10092:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VPMSUMW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  71129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPMSUMW),
     /*  71132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71134 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71136 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71138 */     GIR_RootConstrainSelectedInstOperands,
     /*  71139 */     // GIR_Coverage, 498,
     /*  71139 */     GIR_EraseRootFromParent_Done,
     /*  71140 */   // Label 1131: @71140
     /*  71140 */   GIM_Try, /*On fail goto*//*Label 1132*/ GIMT_Encode4(71177), // Rule ID 499 //
     /*  71145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  71148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_crypto_vpmsumd),
     /*  71153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  71156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  71162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71166 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10090:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VPMSUMD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  71166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPMSUMD),
     /*  71169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71171 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71173 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71175 */     GIR_RootConstrainSelectedInstOperands,
     /*  71176 */     // GIR_Coverage, 499,
     /*  71176 */     GIR_EraseRootFromParent_Done,
     /*  71177 */   // Label 1132: @71177
     /*  71177 */   GIM_Try, /*On fail goto*//*Label 1133*/ GIMT_Encode4(71214), // Rule ID 507 //
     /*  71182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  71185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vbpermq),
     /*  71190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  71193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  71199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71203 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10141:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VBPERMQ:{ *:[v2i64] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  71203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VBPERMQ),
     /*  71206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71208 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71210 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71212 */     GIR_RootConstrainSelectedInstOperands,
     /*  71213 */     // GIR_Coverage, 507,
     /*  71213 */     GIR_EraseRootFromParent_Done,
     /*  71214 */   // Label 1133: @71214
     /*  71214 */   GIM_Try, /*On fail goto*//*Label 1134*/ GIMT_Encode4(71251), // Rule ID 510 //
     /*  71219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Crypto),
     /*  71222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_crypto_vcipher),
     /*  71227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  71230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  71236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71240 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10083:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VCIPHER:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  71240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCIPHER),
     /*  71243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71245 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71247 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71249 */     GIR_RootConstrainSelectedInstOperands,
     /*  71250 */     // GIR_Coverage, 510,
     /*  71250 */     GIR_EraseRootFromParent_Done,
     /*  71251 */   // Label 1134: @71251
     /*  71251 */   GIM_Try, /*On fail goto*//*Label 1135*/ GIMT_Encode4(71288), // Rule ID 511 //
     /*  71256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Crypto),
     /*  71259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_crypto_vcipherlast),
     /*  71264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  71267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  71273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71277 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10084:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VCIPHERLAST:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  71277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCIPHERLAST),
     /*  71280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71282 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71284 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71286 */     GIR_RootConstrainSelectedInstOperands,
     /*  71287 */     // GIR_Coverage, 511,
     /*  71287 */     GIR_EraseRootFromParent_Done,
     /*  71288 */   // Label 1135: @71288
     /*  71288 */   GIM_Try, /*On fail goto*//*Label 1136*/ GIMT_Encode4(71325), // Rule ID 512 //
     /*  71293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Crypto),
     /*  71296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_crypto_vncipher),
     /*  71301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  71304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  71310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71314 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10085:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VNCIPHER:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  71314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VNCIPHER),
     /*  71317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71319 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71321 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71323 */     GIR_RootConstrainSelectedInstOperands,
     /*  71324 */     // GIR_Coverage, 512,
     /*  71324 */     GIR_EraseRootFromParent_Done,
     /*  71325 */   // Label 1136: @71325
     /*  71325 */   GIM_Try, /*On fail goto*//*Label 1137*/ GIMT_Encode4(71362), // Rule ID 513 //
     /*  71330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Crypto),
     /*  71333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_crypto_vncipherlast),
     /*  71338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  71341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  71347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71351 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10086:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VNCIPHERLAST:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  71351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VNCIPHERLAST),
     /*  71354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71356 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71358 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71360 */     GIR_RootConstrainSelectedInstOperands,
     /*  71361 */     // GIR_Coverage, 513,
     /*  71361 */     GIR_EraseRootFromParent_Done,
     /*  71362 */   // Label 1137: @71362
     /*  71362 */   GIM_Try, /*On fail goto*//*Label 1138*/ GIMT_Encode4(71399), // Rule ID 546 //
     /*  71367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  71370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vbpermd),
     /*  71375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  71378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  71384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71388 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10140:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VBPERMD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  71388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VBPERMD),
     /*  71391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71393 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71395 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71397 */     GIR_RootConstrainSelectedInstOperands,
     /*  71398 */     // GIR_Coverage, 546,
     /*  71398 */     GIR_EraseRootFromParent_Done,
     /*  71399 */   // Label 1138: @71399
     /*  71399 */   GIM_Try, /*On fail goto*//*Label 1139*/ GIMT_Encode4(71436), // Rule ID 547 //
     /*  71404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  71407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vrlwnm),
     /*  71412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  71415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  71418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  71421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71425 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10338:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VRLWNM:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  71425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VRLWNM),
     /*  71428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71430 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71432 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71434 */     GIR_RootConstrainSelectedInstOperands,
     /*  71435 */     // GIR_Coverage, 547,
     /*  71435 */     GIR_EraseRootFromParent_Done,
     /*  71436 */   // Label 1139: @71436
     /*  71436 */   GIM_Try, /*On fail goto*//*Label 1140*/ GIMT_Encode4(71473), // Rule ID 549 //
     /*  71441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  71444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vrldnm),
     /*  71449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  71452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  71458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71462 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10332:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VRLDNM:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  71462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VRLDNM),
     /*  71465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71467 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71469 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71471 */     GIR_RootConstrainSelectedInstOperands,
     /*  71472 */     // GIR_Coverage, 549,
     /*  71472 */     GIR_EraseRootFromParent_Done,
     /*  71473 */   // Label 1140: @71473
     /*  71473 */   GIM_Try, /*On fail goto*//*Label 1141*/ GIMT_Encode4(71510), // Rule ID 551 //
     /*  71478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  71481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vslv),
     /*  71486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  71489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  71495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71499 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10346:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VSLV:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  71499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSLV),
     /*  71502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71504 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71506 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71508 */     GIR_RootConstrainSelectedInstOperands,
     /*  71509 */     // GIR_Coverage, 551,
     /*  71509 */     GIR_EraseRootFromParent_Done,
     /*  71510 */   // Label 1141: @71510
     /*  71510 */   GIM_Try, /*On fail goto*//*Label 1142*/ GIMT_Encode4(71547), // Rule ID 552 //
     /*  71515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  71518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsrv),
     /*  71523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  71526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  71532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71536 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10356:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VSRV:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  71536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSRV),
     /*  71539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71541 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71543 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71545 */     GIR_RootConstrainSelectedInstOperands,
     /*  71546 */     // GIR_Coverage, 552,
     /*  71546 */     GIR_EraseRootFromParent_Done,
     /*  71547 */   // Label 1142: @71547
     /*  71547 */   GIM_Try, /*On fail goto*//*Label 1143*/ GIMT_Encode4(71584), // Rule ID 553 //
     /*  71552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  71555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vabsdub),
     /*  71560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  71563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  71569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71573 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10121:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VABSDUB:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  71573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VABSDUB),
     /*  71576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71578 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71580 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71582 */     GIR_RootConstrainSelectedInstOperands,
     /*  71583 */     // GIR_Coverage, 553,
     /*  71583 */     GIR_EraseRootFromParent_Done,
     /*  71584 */   // Label 1143: @71584
     /*  71584 */   GIM_Try, /*On fail goto*//*Label 1144*/ GIMT_Encode4(71621), // Rule ID 554 //
     /*  71589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  71592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vabsduh),
     /*  71597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  71600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  71603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  71606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71610 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10122:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VABSDUH:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  71610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VABSDUH),
     /*  71613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71615 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71617 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71619 */     GIR_RootConstrainSelectedInstOperands,
     /*  71620 */     // GIR_Coverage, 554,
     /*  71620 */     GIR_EraseRootFromParent_Done,
     /*  71621 */   // Label 1144: @71621
     /*  71621 */   GIM_Try, /*On fail goto*//*Label 1145*/ GIMT_Encode4(71658), // Rule ID 555 //
     /*  71626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  71629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vabsduw),
     /*  71634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  71637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  71640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  71643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71647 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10123:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VABSDUW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  71647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VABSDUW),
     /*  71650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71652 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71654 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71656 */     GIR_RootConstrainSelectedInstOperands,
     /*  71657 */     // GIR_Coverage, 555,
     /*  71657 */     GIR_EraseRootFromParent_Done,
     /*  71658 */   // Label 1145: @71658
     /*  71658 */   GIM_Try, /*On fail goto*//*Label 1146*/ GIMT_Encode4(71692), // Rule ID 692 //
     /*  71663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_addg6sd),
     /*  71668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  71671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  71674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  71677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  71681 */     // (intrinsic_wo_chain:{ *:[i64] } 10082:{ *:[iPTR] }, i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)  =>  (ADDG6S8:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)
     /*  71681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::ADDG6S8),
     /*  71684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  71686 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  71688 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  71690 */     GIR_RootConstrainSelectedInstOperands,
     /*  71691 */     // GIR_Coverage, 692,
     /*  71691 */     GIR_EraseRootFromParent_Done,
     /*  71692 */   // Label 1146: @71692
     /*  71692 */   GIM_Try, /*On fail goto*//*Label 1147*/ GIMT_Encode4(71729), // Rule ID 1106 //
     /*  71697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  71700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vpdepd),
     /*  71705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  71708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  71714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71718 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10308:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VPDEPD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  71718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPDEPD),
     /*  71721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71723 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71725 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71727 */     GIR_RootConstrainSelectedInstOperands,
     /*  71728 */     // GIR_Coverage, 1106,
     /*  71728 */     GIR_EraseRootFromParent_Done,
     /*  71729 */   // Label 1147: @71729
     /*  71729 */   GIM_Try, /*On fail goto*//*Label 1148*/ GIMT_Encode4(71766), // Rule ID 1107 //
     /*  71734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  71737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vpextd),
     /*  71742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  71745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  71751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71755 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10310:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VPEXTD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  71755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPEXTD),
     /*  71758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71760 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71762 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71764 */     GIR_RootConstrainSelectedInstOperands,
     /*  71765 */     // GIR_Coverage, 1107,
     /*  71765 */     GIR_EraseRootFromParent_Done,
     /*  71766 */   // Label 1148: @71766
     /*  71766 */   GIM_Try, /*On fail goto*//*Label 1149*/ GIMT_Encode4(71803), // Rule ID 1108 //
     /*  71771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  71774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_pdepd),
     /*  71779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  71782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  71785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  71788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  71792 */     // (intrinsic_wo_chain:{ *:[i64] } 10577:{ *:[iPTR] }, i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)  =>  (PDEPD:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)
     /*  71792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PDEPD),
     /*  71795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  71797 */     GIR_RootToRootCopy, /*OpIdx*/2, // RST
     /*  71799 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  71801 */     GIR_RootConstrainSelectedInstOperands,
     /*  71802 */     // GIR_Coverage, 1108,
     /*  71802 */     GIR_EraseRootFromParent_Done,
     /*  71803 */   // Label 1149: @71803
     /*  71803 */   GIM_Try, /*On fail goto*//*Label 1150*/ GIMT_Encode4(71840), // Rule ID 1109 //
     /*  71808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  71811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_pextd),
     /*  71816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  71819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  71822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  71825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  71829 */     // (intrinsic_wo_chain:{ *:[i64] } 10578:{ *:[iPTR] }, i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)  =>  (PEXTD:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)
     /*  71829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PEXTD),
     /*  71832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  71834 */     GIR_RootToRootCopy, /*OpIdx*/2, // RST
     /*  71836 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  71838 */     GIR_RootConstrainSelectedInstOperands,
     /*  71839 */     // GIR_Coverage, 1109,
     /*  71839 */     GIR_EraseRootFromParent_Done,
     /*  71840 */   // Label 1150: @71840
     /*  71840 */   GIM_Try, /*On fail goto*//*Label 1151*/ GIMT_Encode4(71877), // Rule ID 1110 //
     /*  71845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  71848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vcfuged),
     /*  71853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  71856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  71862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71866 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10143:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VCFUGED:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  71866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCFUGED),
     /*  71869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71871 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71873 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71875 */     GIR_RootConstrainSelectedInstOperands,
     /*  71876 */     // GIR_Coverage, 1110,
     /*  71876 */     GIR_EraseRootFromParent_Done,
     /*  71877 */   // Label 1151: @71877
     /*  71877 */   GIM_Try, /*On fail goto*//*Label 1152*/ GIMT_Encode4(71914), // Rule ID 1112 //
     /*  71882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  71885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_cfuged),
     /*  71890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  71893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  71896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  71899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  71903 */     // (intrinsic_wo_chain:{ *:[i64] } 10408:{ *:[iPTR] }, i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)  =>  (CFUGED:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)
     /*  71903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CFUGED),
     /*  71906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  71908 */     GIR_RootToRootCopy, /*OpIdx*/2, // RST
     /*  71910 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  71912 */     GIR_RootConstrainSelectedInstOperands,
     /*  71913 */     // GIR_Coverage, 1112,
     /*  71913 */     GIR_EraseRootFromParent_Done,
     /*  71914 */   // Label 1152: @71914
     /*  71914 */   GIM_Try, /*On fail goto*//*Label 1153*/ GIMT_Encode4(71951), // Rule ID 1114 //
     /*  71919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  71922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vclzdm),
     /*  71927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  71930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  71936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71940 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10147:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VCLZDM:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  71940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCLZDM),
     /*  71943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71945 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71947 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71949 */     GIR_RootConstrainSelectedInstOperands,
     /*  71950 */     // GIR_Coverage, 1114,
     /*  71950 */     GIR_EraseRootFromParent_Done,
     /*  71951 */   // Label 1153: @71951
     /*  71951 */   GIM_Try, /*On fail goto*//*Label 1154*/ GIMT_Encode4(71988), // Rule ID 1115 //
     /*  71956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  71959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vctzdm),
     /*  71964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  71967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  71973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71977 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10205:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VCTZDM:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  71977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCTZDM),
     /*  71980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71982 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71984 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71986 */     GIR_RootConstrainSelectedInstOperands,
     /*  71987 */     // GIR_Coverage, 1115,
     /*  71987 */     GIR_EraseRootFromParent_Done,
     /*  71988 */   // Label 1154: @71988
     /*  71988 */   GIM_Try, /*On fail goto*//*Label 1155*/ GIMT_Encode4(72025), // Rule ID 1116 //
     /*  71993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  71996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_cntlzdm),
     /*  72001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  72004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  72007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  72010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  72014 */     // (intrinsic_wo_chain:{ *:[i64] } 10413:{ *:[iPTR] }, i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)  =>  (CNTLZDM:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)
     /*  72014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CNTLZDM),
     /*  72017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  72019 */     GIR_RootToRootCopy, /*OpIdx*/2, // RST
     /*  72021 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  72023 */     GIR_RootConstrainSelectedInstOperands,
     /*  72024 */     // GIR_Coverage, 1116,
     /*  72024 */     GIR_EraseRootFromParent_Done,
     /*  72025 */   // Label 1155: @72025
     /*  72025 */   GIM_Try, /*On fail goto*//*Label 1156*/ GIMT_Encode4(72062), // Rule ID 1117 //
     /*  72030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_cnttzdm),
     /*  72038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  72041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  72044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  72047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  72051 */     // (intrinsic_wo_chain:{ *:[i64] } 10414:{ *:[iPTR] }, i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)  =>  (CNTTZDM:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)
     /*  72051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CNTTZDM),
     /*  72054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  72056 */     GIR_RootToRootCopy, /*OpIdx*/2, // RST
     /*  72058 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  72060 */     GIR_RootConstrainSelectedInstOperands,
     /*  72061 */     // GIR_Coverage, 1117,
     /*  72061 */     GIR_EraseRootFromParent_Done,
     /*  72062 */   // Label 1156: @72062
     /*  72062 */   GIM_Try, /*On fail goto*//*Label 1157*/ GIMT_Encode4(72099), // Rule ID 1118 //
     /*  72067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vclrlb),
     /*  72075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  72078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  72084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  72088 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10145:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, i32:{ *:[i32] }:$VB)  =>  (VCLRLB:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, i32:{ *:[i32] }:$VB)
     /*  72088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCLRLB),
     /*  72091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  72093 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  72095 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  72097 */     GIR_RootConstrainSelectedInstOperands,
     /*  72098 */     // GIR_Coverage, 1118,
     /*  72098 */     GIR_EraseRootFromParent_Done,
     /*  72099 */   // Label 1157: @72099
     /*  72099 */   GIM_Try, /*On fail goto*//*Label 1158*/ GIMT_Encode4(72136), // Rule ID 1119 //
     /*  72104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vclrrb),
     /*  72112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  72115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  72121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  72125 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10146:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, i32:{ *:[i32] }:$VB)  =>  (VCLRRB:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, i32:{ *:[i32] }:$VB)
     /*  72125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCLRRB),
     /*  72128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  72130 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  72132 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  72134 */     GIR_RootConstrainSelectedInstOperands,
     /*  72135 */     // GIR_Coverage, 1119,
     /*  72135 */     GIR_EraseRootFromParent_Done,
     /*  72136 */   // Label 1158: @72136
     /*  72136 */   GIM_Try, /*On fail goto*//*Label 1159*/ GIMT_Encode4(72173), // Rule ID 1133 //
     /*  72141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vdivesw),
     /*  72149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  72152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  72158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  72162 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10209:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VDIVESW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  72162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VDIVESW),
     /*  72165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  72167 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  72169 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  72171 */     GIR_RootConstrainSelectedInstOperands,
     /*  72172 */     // GIR_Coverage, 1133,
     /*  72172 */     GIR_EraseRootFromParent_Done,
     /*  72173 */   // Label 1159: @72173
     /*  72173 */   GIM_Try, /*On fail goto*//*Label 1160*/ GIMT_Encode4(72210), // Rule ID 1134 //
     /*  72178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vdiveuw),
     /*  72186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  72189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  72195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  72199 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10212:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VDIVEUW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  72199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VDIVEUW),
     /*  72202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  72204 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  72206 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  72208 */     GIR_RootConstrainSelectedInstOperands,
     /*  72209 */     // GIR_Coverage, 1134,
     /*  72209 */     GIR_EraseRootFromParent_Done,
     /*  72210 */   // Label 1160: @72210
     /*  72210 */   GIM_Try, /*On fail goto*//*Label 1161*/ GIMT_Encode4(72247), // Rule ID 1135 //
     /*  72215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vdivesd),
     /*  72223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  72226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  72229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  72232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  72236 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10207:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VDIVESD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  72236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VDIVESD),
     /*  72239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  72241 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  72243 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  72245 */     GIR_RootConstrainSelectedInstOperands,
     /*  72246 */     // GIR_Coverage, 1135,
     /*  72246 */     GIR_EraseRootFromParent_Done,
     /*  72247 */   // Label 1161: @72247
     /*  72247 */   GIM_Try, /*On fail goto*//*Label 1162*/ GIMT_Encode4(72284), // Rule ID 1136 //
     /*  72252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vdiveud),
     /*  72260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  72263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  72266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  72269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  72273 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10210:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VDIVEUD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  72273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VDIVEUD),
     /*  72276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  72278 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  72280 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  72282 */     GIR_RootConstrainSelectedInstOperands,
     /*  72283 */     // GIR_Coverage, 1136,
     /*  72283 */     GIR_EraseRootFromParent_Done,
     /*  72284 */   // Label 1162: @72284
     /*  72284 */   GIM_Try, /*On fail goto*//*Label 1163*/ GIMT_Encode4(72321), // Rule ID 1139 //
     /*  72289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmulesd),
     /*  72297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  72300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  72303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  72306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  72310 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10288:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VMULESD:{ *:[v1i128] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  72310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULESD),
     /*  72313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  72315 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  72317 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  72319 */     GIR_RootConstrainSelectedInstOperands,
     /*  72320 */     // GIR_Coverage, 1139,
     /*  72320 */     GIR_EraseRootFromParent_Done,
     /*  72321 */   // Label 1163: @72321
     /*  72321 */   GIM_Try, /*On fail goto*//*Label 1164*/ GIMT_Encode4(72358), // Rule ID 1140 //
     /*  72326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmuleud),
     /*  72334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  72337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  72340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  72343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  72347 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10292:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VMULEUD:{ *:[v1i128] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  72347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULEUD),
     /*  72350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  72352 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  72354 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  72356 */     GIR_RootConstrainSelectedInstOperands,
     /*  72357 */     // GIR_Coverage, 1140,
     /*  72357 */     GIR_EraseRootFromParent_Done,
     /*  72358 */   // Label 1164: @72358
     /*  72358 */   GIM_Try, /*On fail goto*//*Label 1165*/ GIMT_Encode4(72395), // Rule ID 1141 //
     /*  72363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmulosd),
     /*  72371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  72374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  72377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  72380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  72384 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10300:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VMULOSD:{ *:[v1i128] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  72384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULOSD),
     /*  72387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  72389 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  72391 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  72393 */     GIR_RootConstrainSelectedInstOperands,
     /*  72394 */     // GIR_Coverage, 1141,
     /*  72394 */     GIR_EraseRootFromParent_Done,
     /*  72395 */   // Label 1165: @72395
     /*  72395 */   GIM_Try, /*On fail goto*//*Label 1166*/ GIMT_Encode4(72432), // Rule ID 1142 //
     /*  72400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmuloud),
     /*  72408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  72411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  72414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  72417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  72421 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10304:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VMULOUD:{ *:[v1i128] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  72421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULOUD),
     /*  72424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  72426 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  72428 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  72430 */     GIR_RootConstrainSelectedInstOperands,
     /*  72431 */     // GIR_Coverage, 1142,
     /*  72431 */     GIR_EraseRootFromParent_Done,
     /*  72432 */   // Label 1166: @72432
     /*  72432 */   GIM_Try, /*On fail goto*//*Label 1167*/ GIMT_Encode4(72469), // Rule ID 1146 //
     /*  72437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vdivesq),
     /*  72445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  72448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  72451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /*  72454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  72458 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10208:{ *:[iPTR] }, v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)  =>  (VDIVESQ:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)
     /*  72458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VDIVESQ),
     /*  72461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  72463 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  72465 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  72467 */     GIR_RootConstrainSelectedInstOperands,
     /*  72468 */     // GIR_Coverage, 1146,
     /*  72468 */     GIR_EraseRootFromParent_Done,
     /*  72469 */   // Label 1167: @72469
     /*  72469 */   GIM_Try, /*On fail goto*//*Label 1168*/ GIMT_Encode4(72506), // Rule ID 1147 //
     /*  72474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vdiveuq),
     /*  72482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  72485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  72488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /*  72491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  72495 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10211:{ *:[iPTR] }, v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)  =>  (VDIVEUQ:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)
     /*  72495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VDIVEUQ),
     /*  72498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  72500 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  72502 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  72504 */     GIR_RootConstrainSelectedInstOperands,
     /*  72505 */     // GIR_Coverage, 1147,
     /*  72505 */     GIR_EraseRootFromParent_Done,
     /*  72506 */   // Label 1168: @72506
     /*  72506 */   GIM_Try, /*On fail goto*//*Label 1169*/ GIMT_Encode4(72543), // Rule ID 1157 //
     /*  72511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vrlqnm),
     /*  72519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  72522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  72525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /*  72528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  72532 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10335:{ *:[iPTR] }, v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)  =>  (VRLQNM:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)
     /*  72532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VRLQNM),
     /*  72535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  72537 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  72539 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  72541 */     GIR_RootConstrainSelectedInstOperands,
     /*  72542 */     // GIR_Coverage, 1157,
     /*  72542 */     GIR_EraseRootFromParent_Done,
     /*  72543 */   // Label 1169: @72543
     /*  72543 */   GIM_Try, /*On fail goto*//*Label 1170*/ GIMT_Encode4(72580), // Rule ID 1162 //
     /*  72548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture),
     /*  72551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_dmxor),
     /*  72556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  72559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  72562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v1024s1,
     /*  72565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  72569 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10503:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$ATi, v1024i1:{ *:[v1024i1] }:$AB)  =>  (DMXOR:{ *:[v1024i1] } v1024i1:{ *:[v1024i1] }:$ATi, v1024i1:{ *:[v1024i1] }:$AB)
     /*  72569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DMXOR),
     /*  72572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  72574 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  72576 */     GIR_RootToRootCopy, /*OpIdx*/3, // AB
     /*  72578 */     GIR_RootConstrainSelectedInstOperands,
     /*  72579 */     // GIR_Coverage, 1162,
     /*  72579 */     GIR_EraseRootFromParent_Done,
     /*  72580 */   // Label 1170: @72580
     /*  72580 */   GIM_Try, /*On fail goto*//*Label 1171*/ GIMT_Encode4(72617), // Rule ID 3335 //
     /*  72585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmulhsw),
     /*  72593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  72596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  72602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  72606 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10296:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)  =>  (VMULHSW:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB)
     /*  72606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULHSW),
     /*  72609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  72611 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*  72613 */     GIR_RootToRootCopy, /*OpIdx*/3, // vB
     /*  72615 */     GIR_RootConstrainSelectedInstOperands,
     /*  72616 */     // GIR_Coverage, 3335,
     /*  72616 */     GIR_EraseRootFromParent_Done,
     /*  72617 */   // Label 1171: @72617
     /*  72617 */   GIM_Try, /*On fail goto*//*Label 1172*/ GIMT_Encode4(72654), // Rule ID 3336 //
     /*  72622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmulhuw),
     /*  72630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  72633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  72639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  72643 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10298:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)  =>  (VMULHUW:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB)
     /*  72643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULHUW),
     /*  72646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  72648 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*  72650 */     GIR_RootToRootCopy, /*OpIdx*/3, // vB
     /*  72652 */     GIR_RootConstrainSelectedInstOperands,
     /*  72653 */     // GIR_Coverage, 3336,
     /*  72653 */     GIR_EraseRootFromParent_Done,
     /*  72654 */   // Label 1172: @72654
     /*  72654 */   GIM_Try, /*On fail goto*//*Label 1173*/ GIMT_Encode4(72691), // Rule ID 3337 //
     /*  72659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmulhsd),
     /*  72667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  72670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  72673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  72676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  72680 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10295:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$vA, v2i64:{ *:[v2i64] }:$vB)  =>  (VMULHSD:{ *:[v2i64] } ?:{ *:[v2i64] }:$vA, ?:{ *:[v2i64] }:$vB)
     /*  72680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULHSD),
     /*  72683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  72685 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*  72687 */     GIR_RootToRootCopy, /*OpIdx*/3, // vB
     /*  72689 */     GIR_RootConstrainSelectedInstOperands,
     /*  72690 */     // GIR_Coverage, 3337,
     /*  72690 */     GIR_EraseRootFromParent_Done,
     /*  72691 */   // Label 1173: @72691
     /*  72691 */   GIM_Try, /*On fail goto*//*Label 1174*/ GIMT_Encode4(72728), // Rule ID 3338 //
     /*  72696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmulhud),
     /*  72704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  72707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  72710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  72713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  72717 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10297:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$vA, v2i64:{ *:[v2i64] }:$vB)  =>  (VMULHUD:{ *:[v2i64] } ?:{ *:[v2i64] }:$vA, ?:{ *:[v2i64] }:$vB)
     /*  72717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULHUD),
     /*  72720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  72722 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*  72724 */     GIR_RootToRootCopy, /*OpIdx*/3, // vB
     /*  72726 */     GIR_RootConstrainSelectedInstOperands,
     /*  72727 */     // GIR_Coverage, 3338,
     /*  72727 */     GIR_EraseRootFromParent_Done,
     /*  72728 */   // Label 1174: @72728
     /*  72728 */   GIM_Try, /*On fail goto*//*Label 1175*/ GIMT_Encode4(72809), // Rule ID 3503 //
     /*  72733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  72736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvi4ger8),
     /*  72741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  72744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  72750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  72754 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10557:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVI4GER8:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  72754 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  72757 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  72761 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  72766 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  72770 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  72775 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  72778 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  72782 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  72787 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  72791 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  72796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVI4GER8),
     /*  72799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  72801 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  72804 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  72807 */     GIR_RootConstrainSelectedInstOperands,
     /*  72808 */     // GIR_Coverage, 3503,
     /*  72808 */     GIR_EraseRootFromParent_Done,
     /*  72809 */   // Label 1175: @72809
     /*  72809 */   GIM_Try, /*On fail goto*//*Label 1176*/ GIMT_Encode4(72890), // Rule ID 3505 //
     /*  72814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  72817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvi8ger4),
     /*  72822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  72825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  72831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  72835 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10559:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVI8GER4:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  72835 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  72838 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  72842 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  72847 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  72851 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  72856 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  72859 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  72863 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  72868 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  72872 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  72877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVI8GER4),
     /*  72880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  72882 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  72885 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  72888 */     GIR_RootConstrainSelectedInstOperands,
     /*  72889 */     // GIR_Coverage, 3505,
     /*  72889 */     GIR_EraseRootFromParent_Done,
     /*  72890 */   // Label 1176: @72890
     /*  72890 */   GIM_Try, /*On fail goto*//*Label 1177*/ GIMT_Encode4(72971), // Rule ID 3507 //
     /*  72895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  72898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvi16ger2s),
     /*  72903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  72906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  72912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  72916 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10555:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVI16GER2S:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  72916 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  72919 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  72923 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  72928 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  72932 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  72937 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  72940 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  72944 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  72949 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  72953 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  72958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVI16GER2S),
     /*  72961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  72963 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  72966 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  72969 */     GIR_RootConstrainSelectedInstOperands,
     /*  72970 */     // GIR_Coverage, 3507,
     /*  72970 */     GIR_EraseRootFromParent_Done,
     /*  72971 */   // Label 1177: @72971
     /*  72971 */   GIM_Try, /*On fail goto*//*Label 1178*/ GIMT_Encode4(73052), // Rule ID 3509 //
     /*  72976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  72979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvi4ger8),
     /*  72984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  72987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  72993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  72997 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10557:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVI4GER8W:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  72997 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  73000 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73004 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73009 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  73013 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73018 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73021 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73025 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73030 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  73034 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVI4GER8W),
     /*  73042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  73044 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73047 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  73050 */     GIR_RootConstrainSelectedInstOperands,
     /*  73051 */     // GIR_Coverage, 3509,
     /*  73051 */     GIR_EraseRootFromParent_Done,
     /*  73052 */   // Label 1178: @73052
     /*  73052 */   GIM_Try, /*On fail goto*//*Label 1179*/ GIMT_Encode4(73133), // Rule ID 3511 //
     /*  73057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  73060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvi8ger4),
     /*  73065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  73068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  73074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  73078 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10559:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVI8GER4W:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  73078 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  73081 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73085 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73090 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  73094 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73099 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73102 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73106 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73111 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  73115 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVI8GER4W),
     /*  73123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  73125 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73128 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  73131 */     GIR_RootConstrainSelectedInstOperands,
     /*  73132 */     // GIR_Coverage, 3511,
     /*  73132 */     GIR_EraseRootFromParent_Done,
     /*  73133 */   // Label 1179: @73133
     /*  73133 */   GIM_Try, /*On fail goto*//*Label 1180*/ GIMT_Encode4(73214), // Rule ID 3513 //
     /*  73138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  73141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvi16ger2s),
     /*  73146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  73149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  73155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  73159 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10555:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVI16GER2SW:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  73159 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  73162 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73166 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73171 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  73175 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73180 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73183 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73187 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73192 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  73196 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVI16GER2SW),
     /*  73204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  73206 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73209 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  73212 */     GIR_RootConstrainSelectedInstOperands,
     /*  73213 */     // GIR_Coverage, 3513,
     /*  73213 */     GIR_EraseRootFromParent_Done,
     /*  73214 */   // Label 1180: @73214
     /*  73214 */   GIM_Try, /*On fail goto*//*Label 1181*/ GIMT_Encode4(73295), // Rule ID 3515 //
     /*  73219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  73222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf16ger2),
     /*  73227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  73230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  73236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  73240 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10538:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF16GER2:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  73240 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  73243 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73247 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73252 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  73256 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73261 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73264 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73268 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73273 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  73277 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF16GER2),
     /*  73285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  73287 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73290 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  73293 */     GIR_RootConstrainSelectedInstOperands,
     /*  73294 */     // GIR_Coverage, 3515,
     /*  73294 */     GIR_EraseRootFromParent_Done,
     /*  73295 */   // Label 1181: @73295
     /*  73295 */   GIM_Try, /*On fail goto*//*Label 1182*/ GIMT_Encode4(73376), // Rule ID 3520 //
     /*  73300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  73303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf16ger2),
     /*  73308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  73311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  73317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  73321 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10538:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF16GER2W:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  73321 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  73324 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73328 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73333 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  73337 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73342 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73345 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73349 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73354 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  73358 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF16GER2W),
     /*  73366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  73368 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73371 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  73374 */     GIR_RootConstrainSelectedInstOperands,
     /*  73375 */     // GIR_Coverage, 3520,
     /*  73375 */     GIR_EraseRootFromParent_Done,
     /*  73376 */   // Label 1182: @73376
     /*  73376 */   GIM_Try, /*On fail goto*//*Label 1183*/ GIMT_Encode4(73457), // Rule ID 3525 //
     /*  73381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  73384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf32ger),
     /*  73389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  73392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  73398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  73402 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10543:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF32GER:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  73402 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  73405 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73409 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73414 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  73418 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73423 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73426 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73430 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73435 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  73439 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF32GER),
     /*  73447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  73449 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73452 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  73455 */     GIR_RootConstrainSelectedInstOperands,
     /*  73456 */     // GIR_Coverage, 3525,
     /*  73456 */     GIR_EraseRootFromParent_Done,
     /*  73457 */   // Label 1183: @73457
     /*  73457 */   GIM_Try, /*On fail goto*//*Label 1184*/ GIMT_Encode4(73516), // Rule ID 3530 //
     /*  73462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  73465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf64ger),
     /*  73470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  73473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v256s1,
     /*  73476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  73479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  73483 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10548:{ *:[iPTR] }, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF64GER:{ *:[v512i1] } ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  73483 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73486 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73490 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73495 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  73499 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF64GER),
     /*  73507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  73509 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  73511 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73514 */     GIR_RootConstrainSelectedInstOperands,
     /*  73515 */     // GIR_Coverage, 3530,
     /*  73515 */     GIR_EraseRootFromParent_Done,
     /*  73516 */   // Label 1184: @73516
     /*  73516 */   GIM_Try, /*On fail goto*//*Label 1185*/ GIMT_Encode4(73597), // Rule ID 3535 //
     /*  73521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  73524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvbf16ger2),
     /*  73529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  73532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  73538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  73542 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10533:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVBF16GER2:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  73542 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  73545 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73549 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73554 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  73558 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73563 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73566 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73570 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73575 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  73579 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVBF16GER2),
     /*  73587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  73589 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73592 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  73595 */     GIR_RootConstrainSelectedInstOperands,
     /*  73596 */     // GIR_Coverage, 3535,
     /*  73596 */     GIR_EraseRootFromParent_Done,
     /*  73597 */   // Label 1185: @73597
     /*  73597 */   GIM_Try, /*On fail goto*//*Label 1186*/ GIMT_Encode4(73678), // Rule ID 3540 //
     /*  73602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  73605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvi16ger2),
     /*  73610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  73613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  73619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  73623 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10553:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVI16GER2:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  73623 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  73626 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73630 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73635 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  73639 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73644 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73647 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73651 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73656 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  73660 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVI16GER2),
     /*  73668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  73670 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73673 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  73676 */     GIR_RootConstrainSelectedInstOperands,
     /*  73677 */     // GIR_Coverage, 3540,
     /*  73677 */     GIR_EraseRootFromParent_Done,
     /*  73678 */   // Label 1186: @73678
     /*  73678 */   GIM_Try, /*On fail goto*//*Label 1187*/ GIMT_Encode4(73759), // Rule ID 3543 //
     /*  73683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  73686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf32ger),
     /*  73691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  73694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  73700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  73704 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10543:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF32GERW:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  73704 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  73707 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73711 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73716 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  73720 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73725 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73728 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73732 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73737 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  73741 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF32GERW),
     /*  73749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  73751 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73754 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  73757 */     GIR_RootConstrainSelectedInstOperands,
     /*  73758 */     // GIR_Coverage, 3543,
     /*  73758 */     GIR_EraseRootFromParent_Done,
     /*  73759 */   // Label 1187: @73759
     /*  73759 */   GIM_Try, /*On fail goto*//*Label 1188*/ GIMT_Encode4(73818), // Rule ID 3548 //
     /*  73764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  73767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf64ger),
     /*  73772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  73775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v256s1,
     /*  73778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  73781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  73785 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10548:{ *:[iPTR] }, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF64GERW:{ *:[v512i1] } ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  73785 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73788 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73792 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73797 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  73801 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF64GERW),
     /*  73809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  73811 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  73813 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73816 */     GIR_RootConstrainSelectedInstOperands,
     /*  73817 */     // GIR_Coverage, 3548,
     /*  73817 */     GIR_EraseRootFromParent_Done,
     /*  73818 */   // Label 1188: @73818
     /*  73818 */   GIM_Try, /*On fail goto*//*Label 1189*/ GIMT_Encode4(73899), // Rule ID 3553 //
     /*  73823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  73826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvbf16ger2),
     /*  73831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  73834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  73840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  73844 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10533:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVBF16GER2W:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  73844 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  73847 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73851 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73856 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  73860 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73865 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73868 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73872 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73877 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  73881 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVBF16GER2W),
     /*  73889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  73891 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73894 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  73897 */     GIR_RootConstrainSelectedInstOperands,
     /*  73898 */     // GIR_Coverage, 3553,
     /*  73898 */     GIR_EraseRootFromParent_Done,
     /*  73899 */   // Label 1189: @73899
     /*  73899 */   GIM_Try, /*On fail goto*//*Label 1190*/ GIMT_Encode4(73980), // Rule ID 3558 //
     /*  73904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  73907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvi16ger2),
     /*  73912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  73915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  73921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  73925 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10553:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVI16GER2W:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  73925 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  73928 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73932 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73937 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  73941 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73946 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73949 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73953 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73958 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  73962 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVI16GER2W),
     /*  73970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  73972 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73975 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  73978 */     GIR_RootConstrainSelectedInstOperands,
     /*  73979 */     // GIR_Coverage, 3558,
     /*  73979 */     GIR_EraseRootFromParent_Done,
     /*  73980 */   // Label 1190: @73980
     /*  73980 */   GIM_Reject,
     /*  73981 */ // Label 997: @73981
     /*  73981 */ GIM_Try, /*On fail goto*//*Label 1191*/ GIMT_Encode4(80669),
     /*  73986 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /*  73989 */   GIM_Try, /*On fail goto*//*Label 1192*/ GIMT_Encode4(74047), // Rule ID 1007 //
     /*  73994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  73997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fmaf128_round_to_odd),
     /*  74002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  74005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  74008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /*  74011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s128,
     /*  74014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  74018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  74022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /*  74026 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s128,
     /*  74030 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  74032 */     // (intrinsic_wo_chain:{ *:[f128] } 10458:{ *:[iPTR] }, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB, (fneg:{ *:[f128] } f128:{ *:[f128] }:$RSTi))  =>  (XSMSUBQPO:{ *:[f128] } f128:{ *:[f128] }:$RSTi, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /*  74032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMSUBQPO),
     /*  74035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  74037 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RSTi
     /*  74041 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  74043 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  74045 */     GIR_RootConstrainSelectedInstOperands,
     /*  74046 */     // GIR_Coverage, 1007,
     /*  74046 */     GIR_EraseRootFromParent_Done,
     /*  74047 */   // Label 1192: @74047
     /*  74047 */   GIM_Try, /*On fail goto*//*Label 1193*/ GIMT_Encode4(74100), // Rule ID 2166 //
     /*  74052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  74055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xxinsertw),
     /*  74060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  74063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  74066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  74069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  74076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  74080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  74084 */     // MIs[1] Operand 1
     /*  74084 */     // No operand predicates
     /*  74084 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  74086 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10705:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$A, v2i64:{ *:[v2i64] }:$B, (imm:{ *:[i32] }):$IMM)  =>  (XXINSERTW:{ *:[v4i32] } ?:{ *:[v4i32] }:$A, ?:{ *:[v2i64] }:$B, (imm:{ *:[i32] }):$IMM)
     /*  74086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXINSERTW),
     /*  74089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  74091 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  74093 */     GIR_RootToRootCopy, /*OpIdx*/3, // B
     /*  74095 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // IMM
     /*  74098 */     GIR_RootConstrainSelectedInstOperands,
     /*  74099 */     // GIR_Coverage, 2166,
     /*  74099 */     GIR_EraseRootFromParent_Done,
     /*  74100 */   // Label 1193: @74100
     /*  74100 */   GIM_Try, /*On fail goto*//*Label 1194*/ GIMT_Encode4(74142), // Rule ID 1006 //
     /*  74105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  74108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fmaf128_round_to_odd),
     /*  74113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  74116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  74119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /*  74122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s128,
     /*  74125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  74129 */     // (intrinsic_wo_chain:{ *:[f128] } 10458:{ *:[iPTR] }, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB, f128:{ *:[f128] }:$RSTi)  =>  (XSMADDQPO:{ *:[f128] } f128:{ *:[f128] }:$RSTi, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /*  74129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMADDQPO),
     /*  74132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  74134 */     GIR_RootToRootCopy, /*OpIdx*/4, // RSTi
     /*  74136 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  74138 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  74140 */     GIR_RootConstrainSelectedInstOperands,
     /*  74141 */     // GIR_Coverage, 1006,
     /*  74141 */     GIR_EraseRootFromParent_Done,
     /*  74142 */   // Label 1194: @74142
     /*  74142 */   GIM_Try, /*On fail goto*//*Label 1195*/ GIMT_Encode4(74184), // Rule ID 1745 //
     /*  74147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  74150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fmsub),
     /*  74155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  74158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  74161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  74164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  74167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  74171 */     // (intrinsic_wo_chain:{ *:[f64] } 10459:{ *:[iPTR] }, f64:{ *:[f64] }:$A, f64:{ *:[f64] }:$B, f64:{ *:[f64] }:$C)  =>  (XSMSUBMDP:{ *:[f64] } ?:{ *:[f64] }:$A, ?:{ *:[f64] }:$B, ?:{ *:[f64] }:$C)
     /*  74171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMSUBMDP),
     /*  74174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  74176 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  74178 */     GIR_RootToRootCopy, /*OpIdx*/3, // B
     /*  74180 */     GIR_RootToRootCopy, /*OpIdx*/4, // C
     /*  74182 */     GIR_RootConstrainSelectedInstOperands,
     /*  74183 */     // GIR_Coverage, 1745,
     /*  74183 */     GIR_EraseRootFromParent_Done,
     /*  74184 */   // Label 1195: @74184
     /*  74184 */   GIM_Try, /*On fail goto*//*Label 1196*/ GIMT_Encode4(74226), // Rule ID 1746 //
     /*  74189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  74192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fnmadd),
     /*  74197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  74200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  74203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  74206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  74209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  74213 */     // (intrinsic_wo_chain:{ *:[f64] } 10463:{ *:[iPTR] }, f64:{ *:[f64] }:$A, f64:{ *:[f64] }:$B, f64:{ *:[f64] }:$C)  =>  (XSNMADDMDP:{ *:[f64] } ?:{ *:[f64] }:$A, ?:{ *:[f64] }:$B, ?:{ *:[f64] }:$C)
     /*  74213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNMADDMDP),
     /*  74216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  74218 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  74220 */     GIR_RootToRootCopy, /*OpIdx*/3, // B
     /*  74222 */     GIR_RootToRootCopy, /*OpIdx*/4, // C
     /*  74224 */     GIR_RootConstrainSelectedInstOperands,
     /*  74225 */     // GIR_Coverage, 1746,
     /*  74225 */     GIR_EraseRootFromParent_Done,
     /*  74226 */   // Label 1196: @74226
     /*  74226 */   GIM_Try, /*On fail goto*//*Label 1197*/ GIMT_Encode4(74268), // Rule ID 1932 //
     /*  74231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /*  74234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fmsubs),
     /*  74239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  74242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  74245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  74248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /*  74255 */     // (intrinsic_wo_chain:{ *:[f32] } 10460:{ *:[iPTR] }, f32:{ *:[f32] }:$A, f32:{ *:[f32] }:$B, f32:{ *:[f32] }:$C)  =>  (XSMSUBMSP:{ *:[f32] } ?:{ *:[f32] }:$A, ?:{ *:[f32] }:$B, ?:{ *:[f32] }:$C)
     /*  74255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMSUBMSP),
     /*  74258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  74260 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  74262 */     GIR_RootToRootCopy, /*OpIdx*/3, // B
     /*  74264 */     GIR_RootToRootCopy, /*OpIdx*/4, // C
     /*  74266 */     GIR_RootConstrainSelectedInstOperands,
     /*  74267 */     // GIR_Coverage, 1932,
     /*  74267 */     GIR_EraseRootFromParent_Done,
     /*  74268 */   // Label 1197: @74268
     /*  74268 */   GIM_Try, /*On fail goto*//*Label 1198*/ GIMT_Encode4(74310), // Rule ID 1933 //
     /*  74273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /*  74276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fnmadds),
     /*  74281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  74284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  74287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  74290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /*  74297 */     // (intrinsic_wo_chain:{ *:[f32] } 10464:{ *:[iPTR] }, f32:{ *:[f32] }:$A, f32:{ *:[f32] }:$B, f32:{ *:[f32] }:$C)  =>  (XSNMADDMSP:{ *:[f32] } ?:{ *:[f32] }:$A, ?:{ *:[f32] }:$B, ?:{ *:[f32] }:$C)
     /*  74297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNMADDMSP),
     /*  74300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  74302 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  74304 */     GIR_RootToRootCopy, /*OpIdx*/3, // B
     /*  74306 */     GIR_RootToRootCopy, /*OpIdx*/4, // C
     /*  74308 */     GIR_RootConstrainSelectedInstOperands,
     /*  74309 */     // GIR_Coverage, 1933,
     /*  74309 */     GIR_EraseRootFromParent_Done,
     /*  74310 */   // Label 1198: @74310
     /*  74310 */   GIM_Try, /*On fail goto*//*Label 1199*/ GIMT_Encode4(74352), // Rule ID 508 //
     /*  74315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Crypto),
     /*  74318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_crypto_vshasigmaw),
     /*  74323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  74326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  74329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  74333 */     // MIs[0] ST
     /*  74333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  74336 */     // MIs[0] SIX
     /*  74336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  74339 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10095:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, (timm:{ *:[i32] }):$ST, (timm:{ *:[i32] }):$SIX)  =>  (VSHASIGMAW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, (timm:{ *:[i32] }):$ST, (timm:{ *:[i32] }):$SIX)
     /*  74339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSHASIGMAW),
     /*  74342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  74344 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  74346 */     GIR_RootToRootCopy, /*OpIdx*/3, // ST
     /*  74348 */     GIR_RootToRootCopy, /*OpIdx*/4, // SIX
     /*  74350 */     GIR_RootConstrainSelectedInstOperands,
     /*  74351 */     // GIR_Coverage, 508,
     /*  74351 */     GIR_EraseRootFromParent_Done,
     /*  74352 */   // Label 1199: @74352
     /*  74352 */   GIM_Try, /*On fail goto*//*Label 1200*/ GIMT_Encode4(74394), // Rule ID 509 //
     /*  74357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Crypto),
     /*  74360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_crypto_vshasigmad),
     /*  74365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  74368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  74375 */     // MIs[0] ST
     /*  74375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  74378 */     // MIs[0] SIX
     /*  74378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  74381 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10094:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, (timm:{ *:[i32] }):$ST, (timm:{ *:[i32] }):$SIX)  =>  (VSHASIGMAD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, (timm:{ *:[i32] }):$ST, (timm:{ *:[i32] }):$SIX)
     /*  74381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSHASIGMAD),
     /*  74384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  74386 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  74388 */     GIR_RootToRootCopy, /*OpIdx*/3, // ST
     /*  74390 */     GIR_RootToRootCopy, /*OpIdx*/4, // SIX
     /*  74392 */     GIR_RootConstrainSelectedInstOperands,
     /*  74393 */     // GIR_Coverage, 509,
     /*  74393 */     GIR_EraseRootFromParent_Done,
     /*  74394 */   // Label 1200: @74394
     /*  74394 */   GIM_Try, /*On fail goto*//*Label 1201*/ GIMT_Encode4(74436), // Rule ID 1056 //
     /*  74399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  74402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsldbi),
     /*  74407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  74410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  74413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  74416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  74420 */     // MIs[0] SD
     /*  74420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  74423 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10343:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VRA, v16i8:{ *:[v16i8] }:$VRB, (timm:{ *:[i32] }):$SD)  =>  (VSLDBI:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VRA, v16i8:{ *:[v16i8] }:$VRB, (timm:{ *:[i32] }):$SD)
     /*  74423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSLDBI),
     /*  74426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VRT]
     /*  74428 */     GIR_RootToRootCopy, /*OpIdx*/2, // VRA
     /*  74430 */     GIR_RootToRootCopy, /*OpIdx*/3, // VRB
     /*  74432 */     GIR_RootToRootCopy, /*OpIdx*/4, // SD
     /*  74434 */     GIR_RootConstrainSelectedInstOperands,
     /*  74435 */     // GIR_Coverage, 1056,
     /*  74435 */     GIR_EraseRootFromParent_Done,
     /*  74436 */   // Label 1201: @74436
     /*  74436 */   GIM_Try, /*On fail goto*//*Label 1202*/ GIMT_Encode4(74478), // Rule ID 1057 //
     /*  74441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  74444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsrdbi),
     /*  74449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  74452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  74455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  74458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  74462 */     // MIs[0] SD
     /*  74462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  74465 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10353:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VRA, v16i8:{ *:[v16i8] }:$VRB, (timm:{ *:[i32] }):$SD)  =>  (VSRDBI:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VRA, v16i8:{ *:[v16i8] }:$VRB, (timm:{ *:[i32] }):$SD)
     /*  74465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSRDBI),
     /*  74468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VRT]
     /*  74470 */     GIR_RootToRootCopy, /*OpIdx*/2, // VRA
     /*  74472 */     GIR_RootToRootCopy, /*OpIdx*/3, // VRB
     /*  74474 */     GIR_RootToRootCopy, /*OpIdx*/4, // SD
     /*  74476 */     GIR_RootConstrainSelectedInstOperands,
     /*  74477 */     // GIR_Coverage, 1057,
     /*  74477 */     GIR_EraseRootFromParent_Done,
     /*  74478 */   // Label 1202: @74478
     /*  74478 */   GIM_Try, /*On fail goto*//*Label 1203*/ GIMT_Encode4(74520), // Rule ID 1062 //
     /*  74483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  74486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vinsw),
     /*  74491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  74494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  74497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  74500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  74504 */     // MIs[0] VA
     /*  74504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  74507 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10251:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VDi, i32:{ *:[i32] }:$VB, (timm:{ *:[i32] }):$VA)  =>  (VINSW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VDi, (timm:{ *:[i32] }):$VA, i32:{ *:[i32] }:$VB)
     /*  74507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VINSW),
     /*  74510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  74512 */     GIR_RootToRootCopy, /*OpIdx*/2, // VDi
     /*  74514 */     GIR_RootToRootCopy, /*OpIdx*/4, // VA
     /*  74516 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  74518 */     GIR_RootConstrainSelectedInstOperands,
     /*  74519 */     // GIR_Coverage, 1062,
     /*  74519 */     GIR_EraseRootFromParent_Done,
     /*  74520 */   // Label 1203: @74520
     /*  74520 */   GIM_Try, /*On fail goto*//*Label 1204*/ GIMT_Encode4(74562), // Rule ID 1063 //
     /*  74525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  74528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vinsd),
     /*  74533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  74536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  74542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  74546 */     // MIs[0] VA
     /*  74546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  74549 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10244:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VDi, i64:{ *:[i64] }:$VB, (timm:{ *:[i32] }):$VA)  =>  (VINSD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VDi, (timm:{ *:[i32] }):$VA, i64:{ *:[i64] }:$VB)
     /*  74549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VINSD),
     /*  74552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  74554 */     GIR_RootToRootCopy, /*OpIdx*/2, // VDi
     /*  74556 */     GIR_RootToRootCopy, /*OpIdx*/4, // VA
     /*  74558 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  74560 */     GIR_RootConstrainSelectedInstOperands,
     /*  74561 */     // GIR_Coverage, 1063,
     /*  74561 */     GIR_EraseRootFromParent_Done,
     /*  74562 */   // Label 1204: @74562
     /*  74562 */   GIM_Try, /*On fail goto*//*Label 1205*/ GIMT_Encode4(74607), // Rule ID 1444 //
     /*  74567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  74570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_bcdadd),
     /*  74575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  74578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  74581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  74584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  74588 */     // MIs[0] PS
     /*  74588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  74591 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10398:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$vA, v16i8:{ *:[v16i8] }:$vB, (timm:{ *:[i32] }):$PS)  =>  (BCDADD_rec:{ *:[v16i8] }:{ *:[i32] } ?:{ *:[v16i8] }:$vA, ?:{ *:[v16i8] }:$vB, ?:{ *:[i32] }:$PS)
     /*  74591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::BCDADD_rec),
     /*  74594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  74596 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*  74598 */     GIR_RootToRootCopy, /*OpIdx*/3, // vB
     /*  74600 */     GIR_RootToRootCopy, /*OpIdx*/4, // PS
     /*  74602 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CR6*/0,
     /*  74605 */     GIR_RootConstrainSelectedInstOperands,
     /*  74606 */     // GIR_Coverage, 1444,
     /*  74606 */     GIR_EraseRootFromParent_Done,
     /*  74607 */   // Label 1205: @74607
     /*  74607 */   GIM_Try, /*On fail goto*//*Label 1206*/ GIMT_Encode4(74652), // Rule ID 1445 //
     /*  74612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  74615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_bcdsub),
     /*  74620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  74623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  74626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  74629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  74633 */     // MIs[0] PS
     /*  74633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  74636 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10400:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$vA, v16i8:{ *:[v16i8] }:$vB, (timm:{ *:[i32] }):$PS)  =>  (BCDSUB_rec:{ *:[v16i8] }:{ *:[i32] } ?:{ *:[v16i8] }:$vA, ?:{ *:[v16i8] }:$vB, ?:{ *:[i32] }:$PS)
     /*  74636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::BCDSUB_rec),
     /*  74639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  74641 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*  74643 */     GIR_RootToRootCopy, /*OpIdx*/3, // vB
     /*  74645 */     GIR_RootToRootCopy, /*OpIdx*/4, // PS
     /*  74647 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CR6*/0,
     /*  74650 */     GIR_RootConstrainSelectedInstOperands,
     /*  74651 */     // GIR_Coverage, 1445,
     /*  74651 */     GIR_EraseRootFromParent_Done,
     /*  74652 */   // Label 1206: @74652
     /*  74652 */   GIM_Try, /*On fail goto*//*Label 1207*/ GIMT_Encode4(74706), // Rule ID 1560 //
     /*  74657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode_IsISA3_0),
     /*  74660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_maddhd),
     /*  74665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  74668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  74671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  74674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  74677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  74681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  74685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  74689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  74693 */     // (intrinsic_wo_chain:{ *:[i64] } 10486:{ *:[iPTR] }, g8rc:{ *:[i64] }:$a, g8rc:{ *:[i64] }:$b, g8rc:{ *:[i64] }:$c)  =>  (MADDHD:{ *:[i64] } ?:{ *:[i64] }:$a, ?:{ *:[i64] }:$b, ?:{ *:[i64] }:$c)
     /*  74693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MADDHD),
     /*  74696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  74698 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  74700 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  74702 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  74704 */     GIR_RootConstrainSelectedInstOperands,
     /*  74705 */     // GIR_Coverage, 1560,
     /*  74705 */     GIR_EraseRootFromParent_Done,
     /*  74706 */   // Label 1207: @74706
     /*  74706 */   GIM_Try, /*On fail goto*//*Label 1208*/ GIMT_Encode4(74760), // Rule ID 1561 //
     /*  74711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode_IsISA3_0),
     /*  74714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_maddhdu),
     /*  74719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  74722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  74725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  74728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  74731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  74735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  74739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  74743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  74747 */     // (intrinsic_wo_chain:{ *:[i64] } 10487:{ *:[iPTR] }, g8rc:{ *:[i64] }:$a, g8rc:{ *:[i64] }:$b, g8rc:{ *:[i64] }:$c)  =>  (MADDHDU:{ *:[i64] } ?:{ *:[i64] }:$a, ?:{ *:[i64] }:$b, ?:{ *:[i64] }:$c)
     /*  74747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MADDHDU),
     /*  74750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  74752 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  74754 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  74756 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  74758 */     GIR_RootConstrainSelectedInstOperands,
     /*  74759 */     // GIR_Coverage, 1561,
     /*  74759 */     GIR_EraseRootFromParent_Done,
     /*  74760 */   // Label 1208: @74760
     /*  74760 */   GIM_Try, /*On fail goto*//*Label 1209*/ GIMT_Encode4(74814), // Rule ID 1562 //
     /*  74765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode_IsISA3_0),
     /*  74768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_maddld),
     /*  74773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  74776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  74779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  74782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  74785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  74789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  74793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  74797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  74801 */     // (intrinsic_wo_chain:{ *:[i64] } 10488:{ *:[iPTR] }, g8rc:{ *:[i64] }:$a, g8rc:{ *:[i64] }:$b, g8rc:{ *:[i64] }:$c)  =>  (MADDLD8:{ *:[i64] } ?:{ *:[i64] }:$a, ?:{ *:[i64] }:$b, ?:{ *:[i64] }:$c)
     /*  74801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MADDLD8),
     /*  74804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  74806 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  74808 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  74810 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  74812 */     GIR_RootConstrainSelectedInstOperands,
     /*  74813 */     // GIR_Coverage, 1562,
     /*  74813 */     GIR_EraseRootFromParent_Done,
     /*  74814 */   // Label 1209: @74814
     /*  74814 */   GIM_Try, /*On fail goto*//*Label 1210*/ GIMT_Encode4(74865), // Rule ID 4817 //
     /*  74819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fsel),
     /*  74824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  74827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  74830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  74833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  74836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  74840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  74844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  74848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  74852 */     // (intrinsic_wo_chain:{ *:[f64] } 10470:{ *:[iPTR] }, f8rc:{ *:[f64] }:$FRA, f8rc:{ *:[f64] }:$FRC, f8rc:{ *:[f64] }:$FRB)  =>  (FSELD:{ *:[f64] } ?:{ *:[f64] }:$FRA, ?:{ *:[f64] }:$FRC, ?:{ *:[f64] }:$FRB)
     /*  74852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FSELD),
     /*  74855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /*  74857 */     GIR_RootToRootCopy, /*OpIdx*/2, // FRA
     /*  74859 */     GIR_RootToRootCopy, /*OpIdx*/3, // FRC
     /*  74861 */     GIR_RootToRootCopy, /*OpIdx*/4, // FRB
     /*  74863 */     GIR_RootConstrainSelectedInstOperands,
     /*  74864 */     // GIR_Coverage, 4817,
     /*  74864 */     GIR_EraseRootFromParent_Done,
     /*  74865 */   // Label 1210: @74865
     /*  74865 */   GIM_Try, /*On fail goto*//*Label 1211*/ GIMT_Encode4(74907), // Rule ID 296 //
     /*  74870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  74873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmladduhm),
     /*  74878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  74881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  74884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  74887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  74890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  74894 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10278:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$RA, v8i16:{ *:[v8i16] }:$RB, v8i16:{ *:[v8i16] }:$RC)  =>  (VMLADDUHM:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$RA, v8i16:{ *:[v8i16] }:$RB, v8i16:{ *:[v8i16] }:$RC)
     /*  74894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMLADDUHM),
     /*  74897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  74899 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  74901 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  74903 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  74905 */     GIR_RootConstrainSelectedInstOperands,
     /*  74906 */     // GIR_Coverage, 296,
     /*  74906 */     GIR_EraseRootFromParent_Done,
     /*  74907 */   // Label 1211: @74907
     /*  74907 */   GIM_Try, /*On fail goto*//*Label 1212*/ GIMT_Encode4(74949), // Rule ID 297 //
     /*  74912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  74915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vperm),
     /*  74920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  74923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  74926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  74929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  74932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  74936 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10309:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$RA, v4i32:{ *:[v4i32] }:$RB, v16i8:{ *:[v16i8] }:$RC)  =>  (VPERM:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$RA, v4i32:{ *:[v4i32] }:$RB, v16i8:{ *:[v16i8] }:$RC)
     /*  74936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPERM),
     /*  74939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  74941 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  74943 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  74945 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  74947 */     GIR_RootConstrainSelectedInstOperands,
     /*  74948 */     // GIR_Coverage, 297,
     /*  74948 */     GIR_EraseRootFromParent_Done,
     /*  74949 */   // Label 1212: @74949
     /*  74949 */   GIM_Try, /*On fail goto*//*Label 1213*/ GIMT_Encode4(74991), // Rule ID 298 //
     /*  74954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  74957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsel),
     /*  74962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  74965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  74968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  74971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  74974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  74978 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10340:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$RA, v4i32:{ *:[v4i32] }:$RB, v4i32:{ *:[v4i32] }:$RC)  =>  (VSEL:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$RA, v4i32:{ *:[v4i32] }:$RB, v4i32:{ *:[v4i32] }:$RC)
     /*  74978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSEL),
     /*  74981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  74983 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  74985 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  74987 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  74989 */     GIR_RootConstrainSelectedInstOperands,
     /*  74990 */     // GIR_Coverage, 298,
     /*  74990 */     GIR_EraseRootFromParent_Done,
     /*  74991 */   // Label 1213: @74991
     /*  74991 */   GIM_Try, /*On fail goto*//*Label 1214*/ GIMT_Encode4(75033), // Rule ID 349 //
     /*  74996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  74999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmsummbm),
     /*  75004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  75007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  75010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  75013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  75016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75020 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10280:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$RA, v16i8:{ *:[v16i8] }:$RB, v4i32:{ *:[v4i32] }:$RC)  =>  (VMSUMMBM:{ *:[v4i32] } v16i8:{ *:[v16i8] }:$RA, v16i8:{ *:[v16i8] }:$RB, v4i32:{ *:[v4i32] }:$RC)
     /*  75020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMSUMMBM),
     /*  75023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  75025 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  75027 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  75029 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  75031 */     GIR_RootConstrainSelectedInstOperands,
     /*  75032 */     // GIR_Coverage, 349,
     /*  75032 */     GIR_EraseRootFromParent_Done,
     /*  75033 */   // Label 1214: @75033
     /*  75033 */   GIM_Try, /*On fail goto*//*Label 1215*/ GIMT_Encode4(75075), // Rule ID 350 //
     /*  75038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  75041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmsumshm),
     /*  75046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  75049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  75052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  75055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  75058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75062 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10281:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$RA, v8i16:{ *:[v8i16] }:$RB, v4i32:{ *:[v4i32] }:$RC)  =>  (VMSUMSHM:{ *:[v4i32] } v8i16:{ *:[v8i16] }:$RA, v8i16:{ *:[v8i16] }:$RB, v4i32:{ *:[v4i32] }:$RC)
     /*  75062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMSUMSHM),
     /*  75065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  75067 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  75069 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  75071 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  75073 */     GIR_RootConstrainSelectedInstOperands,
     /*  75074 */     // GIR_Coverage, 350,
     /*  75074 */     GIR_EraseRootFromParent_Done,
     /*  75075 */   // Label 1215: @75075
     /*  75075 */   GIM_Try, /*On fail goto*//*Label 1216*/ GIMT_Encode4(75117), // Rule ID 351 //
     /*  75080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  75083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmsumubm),
     /*  75088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  75091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  75094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  75097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  75100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75104 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10283:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$RA, v16i8:{ *:[v16i8] }:$RB, v4i32:{ *:[v4i32] }:$RC)  =>  (VMSUMUBM:{ *:[v4i32] } v16i8:{ *:[v16i8] }:$RA, v16i8:{ *:[v16i8] }:$RB, v4i32:{ *:[v4i32] }:$RC)
     /*  75104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMSUMUBM),
     /*  75107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  75109 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  75111 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  75113 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  75115 */     GIR_RootConstrainSelectedInstOperands,
     /*  75116 */     // GIR_Coverage, 351,
     /*  75116 */     GIR_EraseRootFromParent_Done,
     /*  75117 */   // Label 1216: @75117
     /*  75117 */   GIM_Try, /*On fail goto*//*Label 1217*/ GIMT_Encode4(75159), // Rule ID 352 //
     /*  75122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  75125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmsumuhm),
     /*  75130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  75133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  75136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  75139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  75142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75146 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10285:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$RA, v8i16:{ *:[v8i16] }:$RB, v4i32:{ *:[v4i32] }:$RC)  =>  (VMSUMUHM:{ *:[v4i32] } v8i16:{ *:[v8i16] }:$RA, v8i16:{ *:[v8i16] }:$RB, v4i32:{ *:[v4i32] }:$RC)
     /*  75146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMSUMUHM),
     /*  75149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  75151 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  75153 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  75155 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  75157 */     GIR_RootConstrainSelectedInstOperands,
     /*  75158 */     // GIR_Coverage, 352,
     /*  75158 */     GIR_EraseRootFromParent_Done,
     /*  75159 */   // Label 1217: @75159
     /*  75159 */   GIM_Try, /*On fail goto*//*Label 1218*/ GIMT_Encode4(75201), // Rule ID 471 //
     /*  75164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  75167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vaddeuqm),
     /*  75172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  75175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  75178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /*  75181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s128,
     /*  75184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75188 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10127:{ *:[iPTR] }, v1i128:{ *:[v1i128] }:$RA, v1i128:{ *:[v1i128] }:$RB, v1i128:{ *:[v1i128] }:$RC)  =>  (VADDEUQM:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$RA, v1i128:{ *:[v1i128] }:$RB, v1i128:{ *:[v1i128] }:$RC)
     /*  75188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VADDEUQM),
     /*  75191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  75193 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  75195 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  75197 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  75199 */     GIR_RootConstrainSelectedInstOperands,
     /*  75200 */     // GIR_Coverage, 471,
     /*  75200 */     GIR_EraseRootFromParent_Done,
     /*  75201 */   // Label 1218: @75201
     /*  75201 */   GIM_Try, /*On fail goto*//*Label 1219*/ GIMT_Encode4(75243), // Rule ID 473 //
     /*  75206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  75209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vaddecuq),
     /*  75214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  75217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  75220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /*  75223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s128,
     /*  75226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75230 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10126:{ *:[iPTR] }, v1i128:{ *:[v1i128] }:$RA, v1i128:{ *:[v1i128] }:$RB, v1i128:{ *:[v1i128] }:$RC)  =>  (VADDECUQ:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$RA, v1i128:{ *:[v1i128] }:$RB, v1i128:{ *:[v1i128] }:$RC)
     /*  75230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VADDECUQ),
     /*  75233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  75235 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  75237 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  75239 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  75241 */     GIR_RootConstrainSelectedInstOperands,
     /*  75242 */     // GIR_Coverage, 473,
     /*  75242 */     GIR_EraseRootFromParent_Done,
     /*  75243 */   // Label 1219: @75243
     /*  75243 */   GIM_Try, /*On fail goto*//*Label 1220*/ GIMT_Encode4(75285), // Rule ID 476 //
     /*  75248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  75251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsubeuqm),
     /*  75256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  75259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  75262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /*  75265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s128,
     /*  75268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75272 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10369:{ *:[iPTR] }, v1i128:{ *:[v1i128] }:$RA, v1i128:{ *:[v1i128] }:$RB, v1i128:{ *:[v1i128] }:$RC)  =>  (VSUBEUQM:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$RA, v1i128:{ *:[v1i128] }:$RB, v1i128:{ *:[v1i128] }:$RC)
     /*  75272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSUBEUQM),
     /*  75275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  75277 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  75279 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  75281 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  75283 */     GIR_RootConstrainSelectedInstOperands,
     /*  75284 */     // GIR_Coverage, 476,
     /*  75284 */     GIR_EraseRootFromParent_Done,
     /*  75285 */   // Label 1220: @75285
     /*  75285 */   GIM_Try, /*On fail goto*//*Label 1221*/ GIMT_Encode4(75327), // Rule ID 478 //
     /*  75290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  75293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsubecuq),
     /*  75298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  75301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  75304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /*  75307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s128,
     /*  75310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75314 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10368:{ *:[iPTR] }, v1i128:{ *:[v1i128] }:$RA, v1i128:{ *:[v1i128] }:$RB, v1i128:{ *:[v1i128] }:$RC)  =>  (VSUBECUQ:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$RA, v1i128:{ *:[v1i128] }:$RB, v1i128:{ *:[v1i128] }:$RC)
     /*  75314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSUBECUQ),
     /*  75317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  75319 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  75321 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  75323 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  75325 */     GIR_RootConstrainSelectedInstOperands,
     /*  75326 */     // GIR_Coverage, 478,
     /*  75326 */     GIR_EraseRootFromParent_Done,
     /*  75327 */   // Label 1221: @75327
     /*  75327 */   GIM_Try, /*On fail goto*//*Label 1222*/ GIMT_Encode4(75369), // Rule ID 515 //
     /*  75332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  75335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmsumudm),
     /*  75340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  75343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  75346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  75349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s128,
     /*  75352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75356 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10284:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$RA, v2i64:{ *:[v2i64] }:$RB, v1i128:{ *:[v1i128] }:$RC)  =>  (VMSUMUDM:{ *:[v1i128] } v2i64:{ *:[v2i64] }:$RA, v2i64:{ *:[v2i64] }:$RB, v1i128:{ *:[v1i128] }:$RC)
     /*  75356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMSUMUDM),
     /*  75359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  75361 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  75363 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  75365 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  75367 */     GIR_RootConstrainSelectedInstOperands,
     /*  75368 */     // GIR_Coverage, 515,
     /*  75368 */     GIR_EraseRootFromParent_Done,
     /*  75369 */   // Label 1222: @75369
     /*  75369 */   GIM_Try, /*On fail goto*//*Label 1223*/ GIMT_Encode4(75411), // Rule ID 548 //
     /*  75374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  75377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vrlwmi),
     /*  75382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  75385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  75391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  75394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75398 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10337:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB, v4i32:{ *:[v4i32] }:$VDi)  =>  (VRLWMI:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB, v4i32:{ *:[v4i32] }:$VDi)
     /*  75398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VRLWMI),
     /*  75401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  75403 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  75405 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  75407 */     GIR_RootToRootCopy, /*OpIdx*/4, // VDi
     /*  75409 */     GIR_RootConstrainSelectedInstOperands,
     /*  75410 */     // GIR_Coverage, 548,
     /*  75410 */     GIR_EraseRootFromParent_Done,
     /*  75411 */   // Label 1223: @75411
     /*  75411 */   GIM_Try, /*On fail goto*//*Label 1224*/ GIMT_Encode4(75453), // Rule ID 550 //
     /*  75416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  75419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vrldmi),
     /*  75424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  75427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  75430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  75433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  75436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75440 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10331:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB, v2i64:{ *:[v2i64] }:$VDi)  =>  (VRLDMI:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB, v2i64:{ *:[v2i64] }:$VDi)
     /*  75440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VRLDMI),
     /*  75443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  75445 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  75447 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  75449 */     GIR_RootToRootCopy, /*OpIdx*/4, // VDi
     /*  75451 */     GIR_RootConstrainSelectedInstOperands,
     /*  75452 */     // GIR_Coverage, 550,
     /*  75452 */     GIR_EraseRootFromParent_Done,
     /*  75453 */   // Label 1224: @75453
     /*  75453 */   GIM_Try, /*On fail goto*//*Label 1225*/ GIMT_Encode4(75495), // Rule ID 1064 //
     /*  75458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  75461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vinsbvlx),
     /*  75466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  75469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  75472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  75478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75482 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10242:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VDi, i32:{ *:[i32] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VINSBVLX:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VDi, i32:{ *:[i32] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  75482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VINSBVLX),
     /*  75485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  75487 */     GIR_RootToRootCopy, /*OpIdx*/2, // VDi
     /*  75489 */     GIR_RootToRootCopy, /*OpIdx*/3, // VA
     /*  75491 */     GIR_RootToRootCopy, /*OpIdx*/4, // VB
     /*  75493 */     GIR_RootConstrainSelectedInstOperands,
     /*  75494 */     // GIR_Coverage, 1064,
     /*  75494 */     GIR_EraseRootFromParent_Done,
     /*  75495 */   // Label 1225: @75495
     /*  75495 */   GIM_Try, /*On fail goto*//*Label 1226*/ GIMT_Encode4(75537), // Rule ID 1065 //
     /*  75500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  75503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vinsbvrx),
     /*  75508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  75511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  75514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  75520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75524 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10243:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VDi, i32:{ *:[i32] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VINSBVRX:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VDi, i32:{ *:[i32] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  75524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VINSBVRX),
     /*  75527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  75529 */     GIR_RootToRootCopy, /*OpIdx*/2, // VDi
     /*  75531 */     GIR_RootToRootCopy, /*OpIdx*/3, // VA
     /*  75533 */     GIR_RootToRootCopy, /*OpIdx*/4, // VB
     /*  75535 */     GIR_RootConstrainSelectedInstOperands,
     /*  75536 */     // GIR_Coverage, 1065,
     /*  75536 */     GIR_EraseRootFromParent_Done,
     /*  75537 */   // Label 1226: @75537
     /*  75537 */   GIM_Try, /*On fail goto*//*Label 1227*/ GIMT_Encode4(75579), // Rule ID 1066 //
     /*  75542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  75545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vinshvlx),
     /*  75550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  75553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  75556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  75562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75566 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10249:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VDi, i32:{ *:[i32] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VINSHVLX:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VDi, i32:{ *:[i32] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  75566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VINSHVLX),
     /*  75569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  75571 */     GIR_RootToRootCopy, /*OpIdx*/2, // VDi
     /*  75573 */     GIR_RootToRootCopy, /*OpIdx*/3, // VA
     /*  75575 */     GIR_RootToRootCopy, /*OpIdx*/4, // VB
     /*  75577 */     GIR_RootConstrainSelectedInstOperands,
     /*  75578 */     // GIR_Coverage, 1066,
     /*  75578 */     GIR_EraseRootFromParent_Done,
     /*  75579 */   // Label 1227: @75579
     /*  75579 */   GIM_Try, /*On fail goto*//*Label 1228*/ GIMT_Encode4(75621), // Rule ID 1067 //
     /*  75584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  75587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vinshvrx),
     /*  75592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  75595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  75598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  75604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75608 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10250:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VDi, i32:{ *:[i32] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VINSHVRX:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VDi, i32:{ *:[i32] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  75608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VINSHVRX),
     /*  75611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  75613 */     GIR_RootToRootCopy, /*OpIdx*/2, // VDi
     /*  75615 */     GIR_RootToRootCopy, /*OpIdx*/3, // VA
     /*  75617 */     GIR_RootToRootCopy, /*OpIdx*/4, // VB
     /*  75619 */     GIR_RootConstrainSelectedInstOperands,
     /*  75620 */     // GIR_Coverage, 1067,
     /*  75620 */     GIR_EraseRootFromParent_Done,
     /*  75621 */   // Label 1228: @75621
     /*  75621 */   GIM_Try, /*On fail goto*//*Label 1229*/ GIMT_Encode4(75663), // Rule ID 1068 //
     /*  75626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  75629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vinswvlx),
     /*  75634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  75637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  75646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75650 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10254:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VDi, i32:{ *:[i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VINSWVLX:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VDi, i32:{ *:[i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  75650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VINSWVLX),
     /*  75653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  75655 */     GIR_RootToRootCopy, /*OpIdx*/2, // VDi
     /*  75657 */     GIR_RootToRootCopy, /*OpIdx*/3, // VA
     /*  75659 */     GIR_RootToRootCopy, /*OpIdx*/4, // VB
     /*  75661 */     GIR_RootConstrainSelectedInstOperands,
     /*  75662 */     // GIR_Coverage, 1068,
     /*  75662 */     GIR_EraseRootFromParent_Done,
     /*  75663 */   // Label 1229: @75663
     /*  75663 */   GIM_Try, /*On fail goto*//*Label 1230*/ GIMT_Encode4(75705), // Rule ID 1069 //
     /*  75668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  75671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vinswvrx),
     /*  75676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  75679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  75688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75692 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10255:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VDi, i32:{ *:[i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VINSWVRX:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VDi, i32:{ *:[i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  75692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VINSWVRX),
     /*  75695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  75697 */     GIR_RootToRootCopy, /*OpIdx*/2, // VDi
     /*  75699 */     GIR_RootToRootCopy, /*OpIdx*/3, // VA
     /*  75701 */     GIR_RootToRootCopy, /*OpIdx*/4, // VB
     /*  75703 */     GIR_RootConstrainSelectedInstOperands,
     /*  75704 */     // GIR_Coverage, 1069,
     /*  75704 */     GIR_EraseRootFromParent_Done,
     /*  75705 */   // Label 1230: @75705
     /*  75705 */   GIM_Try, /*On fail goto*//*Label 1231*/ GIMT_Encode4(75747), // Rule ID 1070 //
     /*  75710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  75713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vinsblx),
     /*  75718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  75721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  75724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  75730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75734 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10240:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VDi, i32:{ *:[i32] }:$VA, i32:{ *:[i32] }:$VB)  =>  (VINSBLX:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VDi, i32:{ *:[i32] }:$VA, i32:{ *:[i32] }:$VB)
     /*  75734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VINSBLX),
     /*  75737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  75739 */     GIR_RootToRootCopy, /*OpIdx*/2, // VDi
     /*  75741 */     GIR_RootToRootCopy, /*OpIdx*/3, // VA
     /*  75743 */     GIR_RootToRootCopy, /*OpIdx*/4, // VB
     /*  75745 */     GIR_RootConstrainSelectedInstOperands,
     /*  75746 */     // GIR_Coverage, 1070,
     /*  75746 */     GIR_EraseRootFromParent_Done,
     /*  75747 */   // Label 1231: @75747
     /*  75747 */   GIM_Try, /*On fail goto*//*Label 1232*/ GIMT_Encode4(75789), // Rule ID 1071 //
     /*  75752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  75755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vinsbrx),
     /*  75760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  75763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  75766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  75772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75776 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10241:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VDi, i32:{ *:[i32] }:$VA, i32:{ *:[i32] }:$VB)  =>  (VINSBRX:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VDi, i32:{ *:[i32] }:$VA, i32:{ *:[i32] }:$VB)
     /*  75776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VINSBRX),
     /*  75779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  75781 */     GIR_RootToRootCopy, /*OpIdx*/2, // VDi
     /*  75783 */     GIR_RootToRootCopy, /*OpIdx*/3, // VA
     /*  75785 */     GIR_RootToRootCopy, /*OpIdx*/4, // VB
     /*  75787 */     GIR_RootConstrainSelectedInstOperands,
     /*  75788 */     // GIR_Coverage, 1071,
     /*  75788 */     GIR_EraseRootFromParent_Done,
     /*  75789 */   // Label 1232: @75789
     /*  75789 */   GIM_Try, /*On fail goto*//*Label 1233*/ GIMT_Encode4(75831), // Rule ID 1072 //
     /*  75794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  75797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vinshlx),
     /*  75802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  75805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  75808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  75814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75818 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10247:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VDi, i32:{ *:[i32] }:$VA, i32:{ *:[i32] }:$VB)  =>  (VINSHLX:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VDi, i32:{ *:[i32] }:$VA, i32:{ *:[i32] }:$VB)
     /*  75818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VINSHLX),
     /*  75821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  75823 */     GIR_RootToRootCopy, /*OpIdx*/2, // VDi
     /*  75825 */     GIR_RootToRootCopy, /*OpIdx*/3, // VA
     /*  75827 */     GIR_RootToRootCopy, /*OpIdx*/4, // VB
     /*  75829 */     GIR_RootConstrainSelectedInstOperands,
     /*  75830 */     // GIR_Coverage, 1072,
     /*  75830 */     GIR_EraseRootFromParent_Done,
     /*  75831 */   // Label 1233: @75831
     /*  75831 */   GIM_Try, /*On fail goto*//*Label 1234*/ GIMT_Encode4(75873), // Rule ID 1073 //
     /*  75836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  75839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vinshrx),
     /*  75844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  75847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  75850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  75856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75860 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10248:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VDi, i32:{ *:[i32] }:$VA, i32:{ *:[i32] }:$VB)  =>  (VINSHRX:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VDi, i32:{ *:[i32] }:$VA, i32:{ *:[i32] }:$VB)
     /*  75860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VINSHRX),
     /*  75863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  75865 */     GIR_RootToRootCopy, /*OpIdx*/2, // VDi
     /*  75867 */     GIR_RootToRootCopy, /*OpIdx*/3, // VA
     /*  75869 */     GIR_RootToRootCopy, /*OpIdx*/4, // VB
     /*  75871 */     GIR_RootConstrainSelectedInstOperands,
     /*  75872 */     // GIR_Coverage, 1073,
     /*  75872 */     GIR_EraseRootFromParent_Done,
     /*  75873 */   // Label 1234: @75873
     /*  75873 */   GIM_Try, /*On fail goto*//*Label 1235*/ GIMT_Encode4(75915), // Rule ID 1074 //
     /*  75878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  75881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vinswlx),
     /*  75886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  75889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  75898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75902 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10252:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VDi, i32:{ *:[i32] }:$VA, i32:{ *:[i32] }:$VB)  =>  (VINSWLX:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VDi, i32:{ *:[i32] }:$VA, i32:{ *:[i32] }:$VB)
     /*  75902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VINSWLX),
     /*  75905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  75907 */     GIR_RootToRootCopy, /*OpIdx*/2, // VDi
     /*  75909 */     GIR_RootToRootCopy, /*OpIdx*/3, // VA
     /*  75911 */     GIR_RootToRootCopy, /*OpIdx*/4, // VB
     /*  75913 */     GIR_RootConstrainSelectedInstOperands,
     /*  75914 */     // GIR_Coverage, 1074,
     /*  75914 */     GIR_EraseRootFromParent_Done,
     /*  75915 */   // Label 1235: @75915
     /*  75915 */   GIM_Try, /*On fail goto*//*Label 1236*/ GIMT_Encode4(75957), // Rule ID 1075 //
     /*  75920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  75923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vinswrx),
     /*  75928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  75931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  75940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75944 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10253:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VDi, i32:{ *:[i32] }:$VA, i32:{ *:[i32] }:$VB)  =>  (VINSWRX:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VDi, i32:{ *:[i32] }:$VA, i32:{ *:[i32] }:$VB)
     /*  75944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VINSWRX),
     /*  75947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  75949 */     GIR_RootToRootCopy, /*OpIdx*/2, // VDi
     /*  75951 */     GIR_RootToRootCopy, /*OpIdx*/3, // VA
     /*  75953 */     GIR_RootToRootCopy, /*OpIdx*/4, // VB
     /*  75955 */     GIR_RootConstrainSelectedInstOperands,
     /*  75956 */     // GIR_Coverage, 1075,
     /*  75956 */     GIR_EraseRootFromParent_Done,
     /*  75957 */   // Label 1236: @75957
     /*  75957 */   GIM_Try, /*On fail goto*//*Label 1237*/ GIMT_Encode4(75999), // Rule ID 1076 //
     /*  75962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  75965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vinsdlx),
     /*  75970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  75973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  75976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  75979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  75982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75986 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10245:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VDi, i64:{ *:[i64] }:$VA, i64:{ *:[i64] }:$VB)  =>  (VINSDLX:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VDi, i64:{ *:[i64] }:$VA, i64:{ *:[i64] }:$VB)
     /*  75986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VINSDLX),
     /*  75989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  75991 */     GIR_RootToRootCopy, /*OpIdx*/2, // VDi
     /*  75993 */     GIR_RootToRootCopy, /*OpIdx*/3, // VA
     /*  75995 */     GIR_RootToRootCopy, /*OpIdx*/4, // VB
     /*  75997 */     GIR_RootConstrainSelectedInstOperands,
     /*  75998 */     // GIR_Coverage, 1076,
     /*  75998 */     GIR_EraseRootFromParent_Done,
     /*  75999 */   // Label 1237: @75999
     /*  75999 */   GIM_Try, /*On fail goto*//*Label 1238*/ GIMT_Encode4(76041), // Rule ID 1077 //
     /*  76004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  76007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vinsdrx),
     /*  76012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  76015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  76018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  76021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  76024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76028 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10246:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VDi, i64:{ *:[i64] }:$VA, i64:{ *:[i64] }:$VB)  =>  (VINSDRX:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VDi, i64:{ *:[i64] }:$VA, i64:{ *:[i64] }:$VB)
     /*  76028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VINSDRX),
     /*  76031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  76033 */     GIR_RootToRootCopy, /*OpIdx*/2, // VDi
     /*  76035 */     GIR_RootToRootCopy, /*OpIdx*/3, // VA
     /*  76037 */     GIR_RootToRootCopy, /*OpIdx*/4, // VB
     /*  76039 */     GIR_RootConstrainSelectedInstOperands,
     /*  76040 */     // GIR_Coverage, 1077,
     /*  76040 */     GIR_EraseRootFromParent_Done,
     /*  76041 */   // Label 1238: @76041
     /*  76041 */   GIM_Try, /*On fail goto*//*Label 1239*/ GIMT_Encode4(76083), // Rule ID 1098 //
     /*  76046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  76049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextdubvlx),
     /*  76054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  76057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  76060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  76063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  76066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76070 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10221:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$RA, v16i8:{ *:[v16i8] }:$RB, i32:{ *:[i32] }:$RC)  =>  (VEXTDUBVLX:{ *:[v2i64] } v16i8:{ *:[v16i8] }:$RA, v16i8:{ *:[v16i8] }:$RB, i32:{ *:[i32] }:$RC)
     /*  76070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTDUBVLX),
     /*  76073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  76075 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  76077 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  76079 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  76081 */     GIR_RootConstrainSelectedInstOperands,
     /*  76082 */     // GIR_Coverage, 1098,
     /*  76082 */     GIR_EraseRootFromParent_Done,
     /*  76083 */   // Label 1239: @76083
     /*  76083 */   GIM_Try, /*On fail goto*//*Label 1240*/ GIMT_Encode4(76125), // Rule ID 1099 //
     /*  76088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  76091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextdubvrx),
     /*  76096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  76099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  76102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  76105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  76108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76112 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10222:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$RA, v16i8:{ *:[v16i8] }:$RB, i32:{ *:[i32] }:$RC)  =>  (VEXTDUBVRX:{ *:[v2i64] } v16i8:{ *:[v16i8] }:$RA, v16i8:{ *:[v16i8] }:$RB, i32:{ *:[i32] }:$RC)
     /*  76112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTDUBVRX),
     /*  76115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  76117 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  76119 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  76121 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  76123 */     GIR_RootConstrainSelectedInstOperands,
     /*  76124 */     // GIR_Coverage, 1099,
     /*  76124 */     GIR_EraseRootFromParent_Done,
     /*  76125 */   // Label 1240: @76125
     /*  76125 */   GIM_Try, /*On fail goto*//*Label 1241*/ GIMT_Encode4(76167), // Rule ID 1100 //
     /*  76130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  76133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextduhvlx),
     /*  76138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  76141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  76147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  76150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76154 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10223:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$RA, v8i16:{ *:[v8i16] }:$RB, i32:{ *:[i32] }:$RC)  =>  (VEXTDUHVLX:{ *:[v2i64] } v8i16:{ *:[v8i16] }:$RA, v8i16:{ *:[v8i16] }:$RB, i32:{ *:[i32] }:$RC)
     /*  76154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTDUHVLX),
     /*  76157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  76159 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  76161 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  76163 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  76165 */     GIR_RootConstrainSelectedInstOperands,
     /*  76166 */     // GIR_Coverage, 1100,
     /*  76166 */     GIR_EraseRootFromParent_Done,
     /*  76167 */   // Label 1241: @76167
     /*  76167 */   GIM_Try, /*On fail goto*//*Label 1242*/ GIMT_Encode4(76209), // Rule ID 1101 //
     /*  76172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  76175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextduhvrx),
     /*  76180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  76183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  76189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  76192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76196 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10224:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$RA, v8i16:{ *:[v8i16] }:$RB, i32:{ *:[i32] }:$RC)  =>  (VEXTDUHVRX:{ *:[v2i64] } v8i16:{ *:[v8i16] }:$RA, v8i16:{ *:[v8i16] }:$RB, i32:{ *:[i32] }:$RC)
     /*  76196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTDUHVRX),
     /*  76199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  76201 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  76203 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  76205 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  76207 */     GIR_RootConstrainSelectedInstOperands,
     /*  76208 */     // GIR_Coverage, 1101,
     /*  76208 */     GIR_EraseRootFromParent_Done,
     /*  76209 */   // Label 1242: @76209
     /*  76209 */   GIM_Try, /*On fail goto*//*Label 1243*/ GIMT_Encode4(76251), // Rule ID 1102 //
     /*  76214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  76217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextduwvlx),
     /*  76222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  76225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  76228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  76231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  76234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76238 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10225:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$RA, v4i32:{ *:[v4i32] }:$RB, i32:{ *:[i32] }:$RC)  =>  (VEXTDUWVLX:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$RA, v4i32:{ *:[v4i32] }:$RB, i32:{ *:[i32] }:$RC)
     /*  76238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTDUWVLX),
     /*  76241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  76243 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  76245 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  76247 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  76249 */     GIR_RootConstrainSelectedInstOperands,
     /*  76250 */     // GIR_Coverage, 1102,
     /*  76250 */     GIR_EraseRootFromParent_Done,
     /*  76251 */   // Label 1243: @76251
     /*  76251 */   GIM_Try, /*On fail goto*//*Label 1244*/ GIMT_Encode4(76293), // Rule ID 1103 //
     /*  76256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  76259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextduwvrx),
     /*  76264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  76267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  76270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  76273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  76276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76280 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10226:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$RA, v4i32:{ *:[v4i32] }:$RB, i32:{ *:[i32] }:$RC)  =>  (VEXTDUWVRX:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$RA, v4i32:{ *:[v4i32] }:$RB, i32:{ *:[i32] }:$RC)
     /*  76280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTDUWVRX),
     /*  76283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  76285 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  76287 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  76289 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  76291 */     GIR_RootConstrainSelectedInstOperands,
     /*  76292 */     // GIR_Coverage, 1103,
     /*  76292 */     GIR_EraseRootFromParent_Done,
     /*  76293 */   // Label 1244: @76293
     /*  76293 */   GIM_Try, /*On fail goto*//*Label 1245*/ GIMT_Encode4(76335), // Rule ID 1104 //
     /*  76298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  76301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextddvlx),
     /*  76306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  76309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  76312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  76315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  76318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76322 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10219:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$RA, v2i64:{ *:[v2i64] }:$RB, i32:{ *:[i32] }:$RC)  =>  (VEXTDDVLX:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$RA, v2i64:{ *:[v2i64] }:$RB, i32:{ *:[i32] }:$RC)
     /*  76322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTDDVLX),
     /*  76325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  76327 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  76329 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  76331 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  76333 */     GIR_RootConstrainSelectedInstOperands,
     /*  76334 */     // GIR_Coverage, 1104,
     /*  76334 */     GIR_EraseRootFromParent_Done,
     /*  76335 */   // Label 1245: @76335
     /*  76335 */   GIM_Try, /*On fail goto*//*Label 1246*/ GIMT_Encode4(76377), // Rule ID 1105 //
     /*  76340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  76343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextddvrx),
     /*  76348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  76351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  76354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  76357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  76360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76364 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10220:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$RA, v2i64:{ *:[v2i64] }:$RB, i32:{ *:[i32] }:$RC)  =>  (VEXTDDVRX:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$RA, v2i64:{ *:[v2i64] }:$RB, i32:{ *:[i32] }:$RC)
     /*  76364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTDDVRX),
     /*  76367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  76369 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  76371 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  76373 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  76375 */     GIR_RootConstrainSelectedInstOperands,
     /*  76376 */     // GIR_Coverage, 1105,
     /*  76376 */     GIR_EraseRootFromParent_Done,
     /*  76377 */   // Label 1246: @76377
     /*  76377 */   GIM_Try, /*On fail goto*//*Label 1247*/ GIMT_Encode4(76419), // Rule ID 1143 //
     /*  76382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  76385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmsumcud),
     /*  76390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  76393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  76396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  76399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s128,
     /*  76402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76406 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10279:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$RA, v2i64:{ *:[v2i64] }:$RB, v1i128:{ *:[v1i128] }:$RC)  =>  (VMSUMCUD:{ *:[v1i128] } v2i64:{ *:[v2i64] }:$RA, v2i64:{ *:[v2i64] }:$RB, v1i128:{ *:[v1i128] }:$RC)
     /*  76406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMSUMCUD),
     /*  76409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  76411 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  76413 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  76415 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  76417 */     GIR_RootConstrainSelectedInstOperands,
     /*  76418 */     // GIR_Coverage, 1143,
     /*  76418 */     GIR_EraseRootFromParent_Done,
     /*  76419 */   // Label 1247: @76419
     /*  76419 */   GIM_Try, /*On fail goto*//*Label 1248*/ GIMT_Encode4(76461), // Rule ID 1158 //
     /*  76424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  76427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vrlqmi),
     /*  76432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  76435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  76438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /*  76441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s128,
     /*  76444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76448 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10334:{ *:[iPTR] }, v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB, v1i128:{ *:[v1i128] }:$VDi)  =>  (VRLQMI:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB, v1i128:{ *:[v1i128] }:$VDi)
     /*  76448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VRLQMI),
     /*  76451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  76453 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  76455 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  76457 */     GIR_RootToRootCopy, /*OpIdx*/4, // VDi
     /*  76459 */     GIR_RootConstrainSelectedInstOperands,
     /*  76460 */     // GIR_Coverage, 1158,
     /*  76460 */     GIR_EraseRootFromParent_Done,
     /*  76461 */   // Label 1248: @76461
     /*  76461 */   GIM_Try, /*On fail goto*//*Label 1249*/ GIMT_Encode4(76500), // Rule ID 1276 //
     /*  76466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fmsub),
     /*  76471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  76474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  76477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  76480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  76483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  76487 */     // (intrinsic_wo_chain:{ *:[f64] } 10459:{ *:[iPTR] }, f64:{ *:[f64] }:$A, f64:{ *:[f64] }:$B, f64:{ *:[f64] }:$C)  =>  (FMSUB:{ *:[f64] } ?:{ *:[f64] }:$A, ?:{ *:[f64] }:$B, ?:{ *:[f64] }:$C)
     /*  76487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FMSUB),
     /*  76490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /*  76492 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  76494 */     GIR_RootToRootCopy, /*OpIdx*/3, // B
     /*  76496 */     GIR_RootToRootCopy, /*OpIdx*/4, // C
     /*  76498 */     GIR_RootConstrainSelectedInstOperands,
     /*  76499 */     // GIR_Coverage, 1276,
     /*  76499 */     GIR_EraseRootFromParent_Done,
     /*  76500 */   // Label 1249: @76500
     /*  76500 */   GIM_Try, /*On fail goto*//*Label 1250*/ GIMT_Encode4(76539), // Rule ID 1277 //
     /*  76505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fmsubs),
     /*  76510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  76513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  76516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  76522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /*  76526 */     // (intrinsic_wo_chain:{ *:[f32] } 10460:{ *:[iPTR] }, f32:{ *:[f32] }:$A, f32:{ *:[f32] }:$B, f32:{ *:[f32] }:$C)  =>  (FMSUBS:{ *:[f32] } ?:{ *:[f32] }:$A, ?:{ *:[f32] }:$B, ?:{ *:[f32] }:$C)
     /*  76526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FMSUBS),
     /*  76529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /*  76531 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  76533 */     GIR_RootToRootCopy, /*OpIdx*/3, // B
     /*  76535 */     GIR_RootToRootCopy, /*OpIdx*/4, // C
     /*  76537 */     GIR_RootConstrainSelectedInstOperands,
     /*  76538 */     // GIR_Coverage, 1277,
     /*  76538 */     GIR_EraseRootFromParent_Done,
     /*  76539 */   // Label 1250: @76539
     /*  76539 */   GIM_Try, /*On fail goto*//*Label 1251*/ GIMT_Encode4(76578), // Rule ID 1278 //
     /*  76544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fnmadd),
     /*  76549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  76552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  76555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  76558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  76561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  76565 */     // (intrinsic_wo_chain:{ *:[f64] } 10463:{ *:[iPTR] }, f64:{ *:[f64] }:$A, f64:{ *:[f64] }:$B, f64:{ *:[f64] }:$C)  =>  (FNMADD:{ *:[f64] } ?:{ *:[f64] }:$A, ?:{ *:[f64] }:$B, ?:{ *:[f64] }:$C)
     /*  76565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FNMADD),
     /*  76568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /*  76570 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  76572 */     GIR_RootToRootCopy, /*OpIdx*/3, // B
     /*  76574 */     GIR_RootToRootCopy, /*OpIdx*/4, // C
     /*  76576 */     GIR_RootConstrainSelectedInstOperands,
     /*  76577 */     // GIR_Coverage, 1278,
     /*  76577 */     GIR_EraseRootFromParent_Done,
     /*  76578 */   // Label 1251: @76578
     /*  76578 */   GIM_Try, /*On fail goto*//*Label 1252*/ GIMT_Encode4(76617), // Rule ID 1279 //
     /*  76583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fnmadds),
     /*  76588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  76591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  76594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  76600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /*  76604 */     // (intrinsic_wo_chain:{ *:[f32] } 10464:{ *:[iPTR] }, f32:{ *:[f32] }:$A, f32:{ *:[f32] }:$B, f32:{ *:[f32] }:$C)  =>  (FNMADDS:{ *:[f32] } ?:{ *:[f32] }:$A, ?:{ *:[f32] }:$B, ?:{ *:[f32] }:$C)
     /*  76604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FNMADDS),
     /*  76607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /*  76609 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  76611 */     GIR_RootToRootCopy, /*OpIdx*/3, // B
     /*  76613 */     GIR_RootToRootCopy, /*OpIdx*/4, // C
     /*  76615 */     GIR_RootConstrainSelectedInstOperands,
     /*  76616 */     // GIR_Coverage, 1279,
     /*  76616 */     GIR_EraseRootFromParent_Done,
     /*  76617 */   // Label 1252: @76617
     /*  76617 */   GIM_Try, /*On fail goto*//*Label 1253*/ GIMT_Encode4(76659), // Rule ID 1381 //
     /*  76622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  76625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmaddfp),
     /*  76630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  76633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  76636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  76639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  76642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76646 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10257:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$A, v4f32:{ *:[v4f32] }:$B, v4f32:{ *:[v4f32] }:$C)  =>  (VMADDFP:{ *:[v4f32] } ?:{ *:[v4f32] }:$A, ?:{ *:[v4f32] }:$B, ?:{ *:[v4f32] }:$C)
     /*  76646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMADDFP),
     /*  76649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  76651 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  76653 */     GIR_RootToRootCopy, /*OpIdx*/3, // B
     /*  76655 */     GIR_RootToRootCopy, /*OpIdx*/4, // C
     /*  76657 */     GIR_RootConstrainSelectedInstOperands,
     /*  76658 */     // GIR_Coverage, 1381,
     /*  76658 */     GIR_EraseRootFromParent_Done,
     /*  76659 */   // Label 1253: @76659
     /*  76659 */   GIM_Try, /*On fail goto*//*Label 1254*/ GIMT_Encode4(76701), // Rule ID 1382 //
     /*  76664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  76667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vnmsubfp),
     /*  76672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  76675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  76678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  76681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  76684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76688 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10307:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$A, v4f32:{ *:[v4f32] }:$B, v4f32:{ *:[v4f32] }:$C)  =>  (VNMSUBFP:{ *:[v4f32] } ?:{ *:[v4f32] }:$A, ?:{ *:[v4f32] }:$B, ?:{ *:[v4f32] }:$C)
     /*  76688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VNMSUBFP),
     /*  76691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  76693 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  76695 */     GIR_RootToRootCopy, /*OpIdx*/3, // B
     /*  76697 */     GIR_RootToRootCopy, /*OpIdx*/4, // C
     /*  76699 */     GIR_RootConstrainSelectedInstOperands,
     /*  76700 */     // GIR_Coverage, 1382,
     /*  76700 */     GIR_EraseRootFromParent_Done,
     /*  76701 */   // Label 1254: @76701
     /*  76701 */   GIM_Try, /*On fail goto*//*Label 1255*/ GIMT_Encode4(76806), // Rule ID 1577 //
     /*  76706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec_HasVSX_IsLittleEndian),
     /*  76709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_crypto_vpermxor),
     /*  76714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  76717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  76720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  76723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  76726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76730 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10087:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$a, v16i8:{ *:[v16i8] }:$b, v16i8:{ *:[v16i8] }:$c)  =>  (VPERMXOR:{ *:[v16i8] } ?:{ *:[v16i8] }:$a, ?:{ *:[v16i8] }:$b, (XXLNOR:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$c, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$c, VSRC:{ *:[i32] })))
     /*  76730 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  76733 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  76737 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76742 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/4, // c
     /*  76746 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  76751 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  76754 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  76758 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76763 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // c
     /*  76767 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  76772 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  76775 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXLNOR),
     /*  76779 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76784 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  76787 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  76790 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  76792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPERMXOR),
     /*  76795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  76797 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  76799 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  76801 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  76804 */     GIR_RootConstrainSelectedInstOperands,
     /*  76805 */     // GIR_Coverage, 1577,
     /*  76805 */     GIR_EraseRootFromParent_Done,
     /*  76806 */   // Label 1255: @76806
     /*  76806 */   GIM_Try, /*On fail goto*//*Label 1256*/ GIMT_Encode4(76848), // Rule ID 1578 //
     /*  76811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec_HasVSX_IsBigEndian),
     /*  76814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_crypto_vpermxor),
     /*  76819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  76822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  76825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  76828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  76831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76835 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10087:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$a, v16i8:{ *:[v16i8] }:$b, v16i8:{ *:[v16i8] }:$c)  =>  (VPERMXOR:{ *:[v16i8] } ?:{ *:[v16i8] }:$a, ?:{ *:[v16i8] }:$b, ?:{ *:[v16i8] }:$c)
     /*  76835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPERMXOR),
     /*  76838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  76840 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  76842 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  76844 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  76846 */     GIR_RootConstrainSelectedInstOperands,
     /*  76847 */     // GIR_Coverage, 1578,
     /*  76847 */     GIR_EraseRootFromParent_Done,
     /*  76848 */   // Label 1256: @76848
     /*  76848 */   GIM_Try, /*On fail goto*//*Label 1257*/ GIMT_Encode4(76890), // Rule ID 1579 //
     /*  76853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec_HasVSX),
     /*  76856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_crypto_vpermxor_be),
     /*  76861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  76864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  76867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  76870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  76873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76877 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10088:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$a, v16i8:{ *:[v16i8] }:$b, v16i8:{ *:[v16i8] }:$c)  =>  (VPERMXOR:{ *:[v16i8] } ?:{ *:[v16i8] }:$a, ?:{ *:[v16i8] }:$b, ?:{ *:[v16i8] }:$c)
     /*  76877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPERMXOR),
     /*  76880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  76882 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  76884 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  76886 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  76888 */     GIR_RootConstrainSelectedInstOperands,
     /*  76889 */     // GIR_Coverage, 1579,
     /*  76889 */     GIR_EraseRootFromParent_Done,
     /*  76890 */   // Label 1257: @76890
     /*  76890 */   GIM_Try, /*On fail goto*//*Label 1258*/ GIMT_Encode4(77019), // Rule ID 3421 //
     /*  76895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  76898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xxblendvb),
     /*  76903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  76906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  76909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  76912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  76915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  76919 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10695:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$A, v16i8:{ *:[v16i8] }:$B, v16i8:{ *:[v16i8] }:$C)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } (XXBLENDVB:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$A, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$B, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$C, VSRC:{ *:[i32] })), VSRC:{ *:[i32] })
     /*  76919 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /*  76922 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  76926 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76931 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/4, // C
     /*  76935 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  76940 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  76943 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  76947 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76952 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // B
     /*  76956 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  76961 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  76964 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  76968 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76973 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // A
     /*  76977 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  76982 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  76985 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXBLENDVB),
     /*  76989 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76994 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  76997 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  77000 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  77003 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  77005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  77008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  77010 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77013 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77018 */     // GIR_Coverage, 3421,
     /*  77018 */     GIR_EraseRootFromParent_Done,
     /*  77019 */   // Label 1258: @77019
     /*  77019 */   GIM_Try, /*On fail goto*//*Label 1259*/ GIMT_Encode4(77148), // Rule ID 3422 //
     /*  77024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  77027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xxblendvh),
     /*  77032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  77035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  77038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  77041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  77044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77048 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10697:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$A, v8i16:{ *:[v8i16] }:$B, v8i16:{ *:[v8i16] }:$C)  =>  (COPY_TO_REGCLASS:{ *:[v8i16] } (XXBLENDVH:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v8i16] }:$A, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v8i16] }:$B, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v8i16] }:$C, VSRC:{ *:[i32] })), VSRC:{ *:[i32] })
     /*  77048 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /*  77051 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  77055 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77060 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/4, // C
     /*  77064 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77069 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  77072 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  77076 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77081 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // B
     /*  77085 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77090 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  77093 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  77097 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77102 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // A
     /*  77106 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77111 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77114 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXBLENDVH),
     /*  77118 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77123 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  77126 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  77129 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  77132 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  77134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  77137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  77139 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77142 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77147 */     // GIR_Coverage, 3422,
     /*  77147 */     GIR_EraseRootFromParent_Done,
     /*  77148 */   // Label 1259: @77148
     /*  77148 */   GIM_Try, /*On fail goto*//*Label 1260*/ GIMT_Encode4(77190), // Rule ID 3423 //
     /*  77153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  77156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xxblendvw),
     /*  77161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  77164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  77167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  77170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  77173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77177 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10698:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$A, v4i32:{ *:[v4i32] }:$B, v4i32:{ *:[v4i32] }:$C)  =>  (XXBLENDVW:{ *:[v4i32] } ?:{ *:[v4i32] }:$A, ?:{ *:[v4i32] }:$B, ?:{ *:[v4i32] }:$C)
     /*  77177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXBLENDVW),
     /*  77180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  77182 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  77184 */     GIR_RootToRootCopy, /*OpIdx*/3, // B
     /*  77186 */     GIR_RootToRootCopy, /*OpIdx*/4, // C
     /*  77188 */     GIR_RootConstrainSelectedInstOperands,
     /*  77189 */     // GIR_Coverage, 3423,
     /*  77189 */     GIR_EraseRootFromParent_Done,
     /*  77190 */   // Label 1260: @77190
     /*  77190 */   GIM_Try, /*On fail goto*//*Label 1261*/ GIMT_Encode4(77232), // Rule ID 3424 //
     /*  77195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  77198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xxblendvd),
     /*  77203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  77206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  77209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  77212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  77215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77219 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10696:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$A, v2i64:{ *:[v2i64] }:$B, v2i64:{ *:[v2i64] }:$C)  =>  (XXBLENDVD:{ *:[v2i64] } ?:{ *:[v2i64] }:$A, ?:{ *:[v2i64] }:$B, ?:{ *:[v2i64] }:$C)
     /*  77219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXBLENDVD),
     /*  77222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  77224 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  77226 */     GIR_RootToRootCopy, /*OpIdx*/3, // B
     /*  77228 */     GIR_RootToRootCopy, /*OpIdx*/4, // C
     /*  77230 */     GIR_RootConstrainSelectedInstOperands,
     /*  77231 */     // GIR_Coverage, 3424,
     /*  77231 */     GIR_EraseRootFromParent_Done,
     /*  77232 */   // Label 1261: @77232
     /*  77232 */   GIM_Try, /*On fail goto*//*Label 1262*/ GIMT_Encode4(77318), // Rule ID 3504 //
     /*  77237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  77240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvi4ger8pp),
     /*  77245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  77248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  77251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  77254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  77257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  77261 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10558:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVI4GER8PP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  77261 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  77264 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  77268 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77273 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  77277 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77282 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77285 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  77289 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77294 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  77298 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVI4GER8PP),
     /*  77306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  77308 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  77310 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77313 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  77316 */     GIR_RootConstrainSelectedInstOperands,
     /*  77317 */     // GIR_Coverage, 3504,
     /*  77317 */     GIR_EraseRootFromParent_Done,
     /*  77318 */   // Label 1262: @77318
     /*  77318 */   GIM_Try, /*On fail goto*//*Label 1263*/ GIMT_Encode4(77404), // Rule ID 3506 //
     /*  77323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  77326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvi8ger4pp),
     /*  77331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  77334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  77337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  77340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  77343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  77347 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10560:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVI8GER4PP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  77347 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  77350 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  77354 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77359 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  77363 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77368 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77371 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  77375 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77380 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  77384 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVI8GER4PP),
     /*  77392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  77394 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  77396 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77399 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  77402 */     GIR_RootConstrainSelectedInstOperands,
     /*  77403 */     // GIR_Coverage, 3506,
     /*  77403 */     GIR_EraseRootFromParent_Done,
     /*  77404 */   // Label 1263: @77404
     /*  77404 */   GIM_Try, /*On fail goto*//*Label 1264*/ GIMT_Encode4(77490), // Rule ID 3508 //
     /*  77409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  77412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvi16ger2spp),
     /*  77417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  77420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  77423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  77426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  77429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  77433 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10556:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVI16GER2SPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  77433 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  77436 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  77440 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77445 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  77449 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77454 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77457 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  77461 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77466 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  77470 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVI16GER2SPP),
     /*  77478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  77480 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  77482 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77485 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  77488 */     GIR_RootConstrainSelectedInstOperands,
     /*  77489 */     // GIR_Coverage, 3508,
     /*  77489 */     GIR_EraseRootFromParent_Done,
     /*  77490 */   // Label 1264: @77490
     /*  77490 */   GIM_Try, /*On fail goto*//*Label 1265*/ GIMT_Encode4(77576), // Rule ID 3510 //
     /*  77495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  77498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvi4ger8pp),
     /*  77503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  77506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  77509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  77512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  77515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  77519 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10558:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVI4GER8WPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  77519 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  77522 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  77526 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77531 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  77535 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77540 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77543 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  77547 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77552 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  77556 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVI4GER8WPP),
     /*  77564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  77566 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  77568 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77571 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  77574 */     GIR_RootConstrainSelectedInstOperands,
     /*  77575 */     // GIR_Coverage, 3510,
     /*  77575 */     GIR_EraseRootFromParent_Done,
     /*  77576 */   // Label 1265: @77576
     /*  77576 */   GIM_Try, /*On fail goto*//*Label 1266*/ GIMT_Encode4(77662), // Rule ID 3512 //
     /*  77581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  77584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvi8ger4pp),
     /*  77589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  77592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  77595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  77598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  77601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  77605 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10560:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVI8GER4WPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  77605 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  77608 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  77612 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77617 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  77621 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77626 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77629 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  77633 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77638 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  77642 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVI8GER4WPP),
     /*  77650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  77652 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  77654 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77657 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  77660 */     GIR_RootConstrainSelectedInstOperands,
     /*  77661 */     // GIR_Coverage, 3512,
     /*  77661 */     GIR_EraseRootFromParent_Done,
     /*  77662 */   // Label 1266: @77662
     /*  77662 */   GIM_Try, /*On fail goto*//*Label 1267*/ GIMT_Encode4(77748), // Rule ID 3514 //
     /*  77667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  77670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvi16ger2spp),
     /*  77675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  77678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  77681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  77684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  77687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  77691 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10556:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVI16GER2SWPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  77691 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  77694 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  77698 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77703 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  77707 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77712 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77715 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  77719 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77724 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  77728 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVI16GER2SWPP),
     /*  77736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  77738 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  77740 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77743 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  77746 */     GIR_RootConstrainSelectedInstOperands,
     /*  77747 */     // GIR_Coverage, 3514,
     /*  77747 */     GIR_EraseRootFromParent_Done,
     /*  77748 */   // Label 1267: @77748
     /*  77748 */   GIM_Try, /*On fail goto*//*Label 1268*/ GIMT_Encode4(77834), // Rule ID 3516 //
     /*  77753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  77756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf16ger2pp),
     /*  77761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  77764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  77767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  77770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  77773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  77777 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10542:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF16GER2PP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  77777 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  77780 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  77784 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77789 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  77793 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77798 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77801 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  77805 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77810 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  77814 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF16GER2PP),
     /*  77822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  77824 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  77826 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77829 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  77832 */     GIR_RootConstrainSelectedInstOperands,
     /*  77833 */     // GIR_Coverage, 3516,
     /*  77833 */     GIR_EraseRootFromParent_Done,
     /*  77834 */   // Label 1268: @77834
     /*  77834 */   GIM_Try, /*On fail goto*//*Label 1269*/ GIMT_Encode4(77920), // Rule ID 3517 //
     /*  77839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  77842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf16ger2pn),
     /*  77847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  77850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  77853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  77856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  77859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  77863 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10541:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF16GER2PN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  77863 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  77866 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  77870 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77875 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  77879 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77884 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77887 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  77891 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77896 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  77900 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF16GER2PN),
     /*  77908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  77910 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  77912 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77915 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  77918 */     GIR_RootConstrainSelectedInstOperands,
     /*  77919 */     // GIR_Coverage, 3517,
     /*  77919 */     GIR_EraseRootFromParent_Done,
     /*  77920 */   // Label 1269: @77920
     /*  77920 */   GIM_Try, /*On fail goto*//*Label 1270*/ GIMT_Encode4(78006), // Rule ID 3518 //
     /*  77925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  77928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf16ger2np),
     /*  77933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  77936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  77939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  77942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  77945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  77949 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10540:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF16GER2NP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  77949 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  77952 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  77956 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77961 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  77965 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77970 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77973 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  77977 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77982 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  77986 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF16GER2NP),
     /*  77994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  77996 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  77998 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78001 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  78004 */     GIR_RootConstrainSelectedInstOperands,
     /*  78005 */     // GIR_Coverage, 3518,
     /*  78005 */     GIR_EraseRootFromParent_Done,
     /*  78006 */   // Label 1270: @78006
     /*  78006 */   GIM_Try, /*On fail goto*//*Label 1271*/ GIMT_Encode4(78092), // Rule ID 3519 //
     /*  78011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  78014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf16ger2nn),
     /*  78019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  78022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  78025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  78028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  78031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  78035 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10539:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF16GER2NN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  78035 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  78038 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78042 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78047 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  78051 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78056 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78059 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78063 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78068 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  78072 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF16GER2NN),
     /*  78080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  78082 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  78084 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78087 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  78090 */     GIR_RootConstrainSelectedInstOperands,
     /*  78091 */     // GIR_Coverage, 3519,
     /*  78091 */     GIR_EraseRootFromParent_Done,
     /*  78092 */   // Label 1271: @78092
     /*  78092 */   GIM_Try, /*On fail goto*//*Label 1272*/ GIMT_Encode4(78178), // Rule ID 3521 //
     /*  78097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  78100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf16ger2pp),
     /*  78105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  78108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  78111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  78114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  78117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  78121 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10542:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF16GER2WPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  78121 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  78124 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78128 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78133 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  78137 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78142 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78145 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78149 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78154 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  78158 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF16GER2WPP),
     /*  78166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  78168 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  78170 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78173 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  78176 */     GIR_RootConstrainSelectedInstOperands,
     /*  78177 */     // GIR_Coverage, 3521,
     /*  78177 */     GIR_EraseRootFromParent_Done,
     /*  78178 */   // Label 1272: @78178
     /*  78178 */   GIM_Try, /*On fail goto*//*Label 1273*/ GIMT_Encode4(78264), // Rule ID 3522 //
     /*  78183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  78186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf16ger2pn),
     /*  78191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  78194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  78197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  78200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  78203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  78207 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10541:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF16GER2WPN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  78207 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  78210 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78214 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78219 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  78223 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78228 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78231 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78235 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78240 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  78244 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF16GER2WPN),
     /*  78252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  78254 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  78256 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78259 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  78262 */     GIR_RootConstrainSelectedInstOperands,
     /*  78263 */     // GIR_Coverage, 3522,
     /*  78263 */     GIR_EraseRootFromParent_Done,
     /*  78264 */   // Label 1273: @78264
     /*  78264 */   GIM_Try, /*On fail goto*//*Label 1274*/ GIMT_Encode4(78350), // Rule ID 3523 //
     /*  78269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  78272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf16ger2np),
     /*  78277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  78280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  78283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  78286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  78289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  78293 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10540:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF16GER2WNP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  78293 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  78296 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78300 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78305 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  78309 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78314 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78317 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78321 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78326 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  78330 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF16GER2WNP),
     /*  78338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  78340 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  78342 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78345 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  78348 */     GIR_RootConstrainSelectedInstOperands,
     /*  78349 */     // GIR_Coverage, 3523,
     /*  78349 */     GIR_EraseRootFromParent_Done,
     /*  78350 */   // Label 1274: @78350
     /*  78350 */   GIM_Try, /*On fail goto*//*Label 1275*/ GIMT_Encode4(78436), // Rule ID 3524 //
     /*  78355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  78358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf16ger2nn),
     /*  78363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  78366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  78369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  78372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  78375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  78379 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10539:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF16GER2WNN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  78379 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  78382 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78386 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78391 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  78395 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78400 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78403 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78407 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78412 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  78416 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF16GER2WNN),
     /*  78424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  78426 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  78428 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78431 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  78434 */     GIR_RootConstrainSelectedInstOperands,
     /*  78435 */     // GIR_Coverage, 3524,
     /*  78435 */     GIR_EraseRootFromParent_Done,
     /*  78436 */   // Label 1275: @78436
     /*  78436 */   GIM_Try, /*On fail goto*//*Label 1276*/ GIMT_Encode4(78522), // Rule ID 3526 //
     /*  78441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  78444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf32gerpp),
     /*  78449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  78452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  78455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  78458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  78461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  78465 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10547:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF32GERPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  78465 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  78468 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78472 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78477 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  78481 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78486 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78489 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78493 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78498 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  78502 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF32GERPP),
     /*  78510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  78512 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  78514 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78517 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  78520 */     GIR_RootConstrainSelectedInstOperands,
     /*  78521 */     // GIR_Coverage, 3526,
     /*  78521 */     GIR_EraseRootFromParent_Done,
     /*  78522 */   // Label 1276: @78522
     /*  78522 */   GIM_Try, /*On fail goto*//*Label 1277*/ GIMT_Encode4(78608), // Rule ID 3527 //
     /*  78527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  78530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf32gerpn),
     /*  78535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  78538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  78541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  78544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  78547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  78551 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10546:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF32GERPN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  78551 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  78554 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78558 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78563 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  78567 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78572 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78575 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78579 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78584 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  78588 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF32GERPN),
     /*  78596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  78598 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  78600 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78603 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  78606 */     GIR_RootConstrainSelectedInstOperands,
     /*  78607 */     // GIR_Coverage, 3527,
     /*  78607 */     GIR_EraseRootFromParent_Done,
     /*  78608 */   // Label 1277: @78608
     /*  78608 */   GIM_Try, /*On fail goto*//*Label 1278*/ GIMT_Encode4(78694), // Rule ID 3528 //
     /*  78613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  78616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf32gernp),
     /*  78621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  78624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  78627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  78630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  78633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  78637 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10545:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF32GERNP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  78637 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  78640 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78644 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78649 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  78653 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78658 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78661 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78665 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78670 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  78674 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF32GERNP),
     /*  78682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  78684 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  78686 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78689 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  78692 */     GIR_RootConstrainSelectedInstOperands,
     /*  78693 */     // GIR_Coverage, 3528,
     /*  78693 */     GIR_EraseRootFromParent_Done,
     /*  78694 */   // Label 1278: @78694
     /*  78694 */   GIM_Try, /*On fail goto*//*Label 1279*/ GIMT_Encode4(78780), // Rule ID 3529 //
     /*  78699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  78702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf32gernn),
     /*  78707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  78710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  78713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  78716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  78719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  78723 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10544:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF32GERNN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  78723 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  78726 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78730 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78735 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  78739 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78744 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78747 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78751 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78756 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  78760 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF32GERNN),
     /*  78768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  78770 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  78772 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78775 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  78778 */     GIR_RootConstrainSelectedInstOperands,
     /*  78779 */     // GIR_Coverage, 3529,
     /*  78779 */     GIR_EraseRootFromParent_Done,
     /*  78780 */   // Label 1279: @78780
     /*  78780 */   GIM_Try, /*On fail goto*//*Label 1280*/ GIMT_Encode4(78844), // Rule ID 3531 //
     /*  78785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  78788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf64gerpp),
     /*  78793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  78796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  78799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  78802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  78805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  78809 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10552:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF64GERPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  78809 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78812 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78816 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78821 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  78825 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF64GERPP),
     /*  78833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  78835 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  78837 */     GIR_RootToRootCopy, /*OpIdx*/3, // XA
     /*  78839 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78842 */     GIR_RootConstrainSelectedInstOperands,
     /*  78843 */     // GIR_Coverage, 3531,
     /*  78843 */     GIR_EraseRootFromParent_Done,
     /*  78844 */   // Label 1280: @78844
     /*  78844 */   GIM_Try, /*On fail goto*//*Label 1281*/ GIMT_Encode4(78908), // Rule ID 3532 //
     /*  78849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  78852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf64gerpn),
     /*  78857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  78860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  78863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  78866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  78869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  78873 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10551:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF64GERPN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  78873 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78876 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78880 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78885 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  78889 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF64GERPN),
     /*  78897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  78899 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  78901 */     GIR_RootToRootCopy, /*OpIdx*/3, // XA
     /*  78903 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78906 */     GIR_RootConstrainSelectedInstOperands,
     /*  78907 */     // GIR_Coverage, 3532,
     /*  78907 */     GIR_EraseRootFromParent_Done,
     /*  78908 */   // Label 1281: @78908
     /*  78908 */   GIM_Try, /*On fail goto*//*Label 1282*/ GIMT_Encode4(78972), // Rule ID 3533 //
     /*  78913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  78916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf64gernp),
     /*  78921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  78924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  78927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  78930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  78933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  78937 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10550:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF64GERNP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  78937 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78940 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78944 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78949 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  78953 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF64GERNP),
     /*  78961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  78963 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  78965 */     GIR_RootToRootCopy, /*OpIdx*/3, // XA
     /*  78967 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78970 */     GIR_RootConstrainSelectedInstOperands,
     /*  78971 */     // GIR_Coverage, 3533,
     /*  78971 */     GIR_EraseRootFromParent_Done,
     /*  78972 */   // Label 1282: @78972
     /*  78972 */   GIM_Try, /*On fail goto*//*Label 1283*/ GIMT_Encode4(79036), // Rule ID 3534 //
     /*  78977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  78980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf64gernn),
     /*  78985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  78988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  78991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  78994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  78997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  79001 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10549:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF64GERNN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  79001 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  79004 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79008 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79013 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  79017 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF64GERNN),
     /*  79025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  79027 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  79029 */     GIR_RootToRootCopy, /*OpIdx*/3, // XA
     /*  79031 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79034 */     GIR_RootConstrainSelectedInstOperands,
     /*  79035 */     // GIR_Coverage, 3534,
     /*  79035 */     GIR_EraseRootFromParent_Done,
     /*  79036 */   // Label 1283: @79036
     /*  79036 */   GIM_Try, /*On fail goto*//*Label 1284*/ GIMT_Encode4(79122), // Rule ID 3536 //
     /*  79041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  79044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvbf16ger2pp),
     /*  79049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  79052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  79055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  79058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  79061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  79065 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10537:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVBF16GER2PP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  79065 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  79068 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79072 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79077 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  79081 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79086 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  79089 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79093 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79098 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  79102 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVBF16GER2PP),
     /*  79110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  79112 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  79114 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79117 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  79120 */     GIR_RootConstrainSelectedInstOperands,
     /*  79121 */     // GIR_Coverage, 3536,
     /*  79121 */     GIR_EraseRootFromParent_Done,
     /*  79122 */   // Label 1284: @79122
     /*  79122 */   GIM_Try, /*On fail goto*//*Label 1285*/ GIMT_Encode4(79208), // Rule ID 3537 //
     /*  79127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  79130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvbf16ger2pn),
     /*  79135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  79138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  79141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  79144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  79147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  79151 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10536:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVBF16GER2PN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  79151 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  79154 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79158 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79163 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  79167 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79172 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  79175 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79179 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79184 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  79188 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVBF16GER2PN),
     /*  79196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  79198 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  79200 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79203 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  79206 */     GIR_RootConstrainSelectedInstOperands,
     /*  79207 */     // GIR_Coverage, 3537,
     /*  79207 */     GIR_EraseRootFromParent_Done,
     /*  79208 */   // Label 1285: @79208
     /*  79208 */   GIM_Try, /*On fail goto*//*Label 1286*/ GIMT_Encode4(79294), // Rule ID 3538 //
     /*  79213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  79216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvbf16ger2np),
     /*  79221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  79224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  79227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  79230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  79233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  79237 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10535:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVBF16GER2NP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  79237 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  79240 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79244 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79249 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  79253 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79258 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  79261 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79265 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79270 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  79274 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVBF16GER2NP),
     /*  79282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  79284 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  79286 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79289 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  79292 */     GIR_RootConstrainSelectedInstOperands,
     /*  79293 */     // GIR_Coverage, 3538,
     /*  79293 */     GIR_EraseRootFromParent_Done,
     /*  79294 */   // Label 1286: @79294
     /*  79294 */   GIM_Try, /*On fail goto*//*Label 1287*/ GIMT_Encode4(79380), // Rule ID 3539 //
     /*  79299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  79302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvbf16ger2nn),
     /*  79307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  79310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  79313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  79316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  79319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  79323 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10534:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVBF16GER2NN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  79323 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  79326 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79330 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79335 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  79339 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79344 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  79347 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79351 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79356 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  79360 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVBF16GER2NN),
     /*  79368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  79370 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  79372 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79375 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  79378 */     GIR_RootConstrainSelectedInstOperands,
     /*  79379 */     // GIR_Coverage, 3539,
     /*  79379 */     GIR_EraseRootFromParent_Done,
     /*  79380 */   // Label 1287: @79380
     /*  79380 */   GIM_Try, /*On fail goto*//*Label 1288*/ GIMT_Encode4(79466), // Rule ID 3541 //
     /*  79385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  79388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvi16ger2pp),
     /*  79393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  79396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  79399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  79402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  79405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  79409 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10554:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVI16GER2PP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  79409 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  79412 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79416 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79421 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  79425 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79430 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  79433 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79437 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79442 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  79446 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVI16GER2PP),
     /*  79454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  79456 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  79458 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79461 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  79464 */     GIR_RootConstrainSelectedInstOperands,
     /*  79465 */     // GIR_Coverage, 3541,
     /*  79465 */     GIR_EraseRootFromParent_Done,
     /*  79466 */   // Label 1288: @79466
     /*  79466 */   GIM_Try, /*On fail goto*//*Label 1289*/ GIMT_Encode4(79552), // Rule ID 3542 //
     /*  79471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  79474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvi8ger4spp),
     /*  79479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  79482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  79485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  79488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  79491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  79495 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10561:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVI8GER4SPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  79495 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  79498 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79502 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79507 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  79511 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79516 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  79519 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79523 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79528 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  79532 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVI8GER4SPP),
     /*  79540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  79542 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  79544 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79547 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  79550 */     GIR_RootConstrainSelectedInstOperands,
     /*  79551 */     // GIR_Coverage, 3542,
     /*  79551 */     GIR_EraseRootFromParent_Done,
     /*  79552 */   // Label 1289: @79552
     /*  79552 */   GIM_Try, /*On fail goto*//*Label 1290*/ GIMT_Encode4(79638), // Rule ID 3544 //
     /*  79557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  79560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf32gerpp),
     /*  79565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  79568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  79571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  79574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  79577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  79581 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10547:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF32GERWPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  79581 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  79584 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79588 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79593 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  79597 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79602 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  79605 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79609 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79614 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  79618 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF32GERWPP),
     /*  79626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  79628 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  79630 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79633 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  79636 */     GIR_RootConstrainSelectedInstOperands,
     /*  79637 */     // GIR_Coverage, 3544,
     /*  79637 */     GIR_EraseRootFromParent_Done,
     /*  79638 */   // Label 1290: @79638
     /*  79638 */   GIM_Try, /*On fail goto*//*Label 1291*/ GIMT_Encode4(79724), // Rule ID 3545 //
     /*  79643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  79646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf32gerpn),
     /*  79651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  79654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  79657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  79660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  79663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  79667 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10546:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF32GERWPN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  79667 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  79670 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79674 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79679 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  79683 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79688 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  79691 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79695 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79700 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  79704 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF32GERWPN),
     /*  79712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  79714 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  79716 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79719 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  79722 */     GIR_RootConstrainSelectedInstOperands,
     /*  79723 */     // GIR_Coverage, 3545,
     /*  79723 */     GIR_EraseRootFromParent_Done,
     /*  79724 */   // Label 1291: @79724
     /*  79724 */   GIM_Try, /*On fail goto*//*Label 1292*/ GIMT_Encode4(79810), // Rule ID 3546 //
     /*  79729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  79732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf32gernp),
     /*  79737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  79740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  79743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  79746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  79749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  79753 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10545:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF32GERWNP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  79753 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  79756 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79760 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79765 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  79769 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79774 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  79777 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79781 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79786 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  79790 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF32GERWNP),
     /*  79798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  79800 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  79802 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79805 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  79808 */     GIR_RootConstrainSelectedInstOperands,
     /*  79809 */     // GIR_Coverage, 3546,
     /*  79809 */     GIR_EraseRootFromParent_Done,
     /*  79810 */   // Label 1292: @79810
     /*  79810 */   GIM_Try, /*On fail goto*//*Label 1293*/ GIMT_Encode4(79896), // Rule ID 3547 //
     /*  79815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  79818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf32gernn),
     /*  79823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  79826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  79829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  79832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  79835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  79839 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10544:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF32GERWNN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  79839 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  79842 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79846 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79851 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  79855 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79860 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  79863 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79867 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79872 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  79876 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF32GERWNN),
     /*  79884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  79886 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  79888 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79891 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  79894 */     GIR_RootConstrainSelectedInstOperands,
     /*  79895 */     // GIR_Coverage, 3547,
     /*  79895 */     GIR_EraseRootFromParent_Done,
     /*  79896 */   // Label 1293: @79896
     /*  79896 */   GIM_Try, /*On fail goto*//*Label 1294*/ GIMT_Encode4(79960), // Rule ID 3549 //
     /*  79901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  79904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf64gerpp),
     /*  79909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  79912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  79915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  79918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  79921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  79925 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10552:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF64GERWPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  79925 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  79928 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79932 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79937 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  79941 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF64GERWPP),
     /*  79949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  79951 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  79953 */     GIR_RootToRootCopy, /*OpIdx*/3, // XA
     /*  79955 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79958 */     GIR_RootConstrainSelectedInstOperands,
     /*  79959 */     // GIR_Coverage, 3549,
     /*  79959 */     GIR_EraseRootFromParent_Done,
     /*  79960 */   // Label 1294: @79960
     /*  79960 */   GIM_Try, /*On fail goto*//*Label 1295*/ GIMT_Encode4(80024), // Rule ID 3550 //
     /*  79965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  79968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf64gerpn),
     /*  79973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  79976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  79979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  79982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  79985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  79989 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10551:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF64GERWPN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  79989 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  79992 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79996 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80001 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  80005 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF64GERWPN),
     /*  80013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  80015 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  80017 */     GIR_RootToRootCopy, /*OpIdx*/3, // XA
     /*  80019 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80022 */     GIR_RootConstrainSelectedInstOperands,
     /*  80023 */     // GIR_Coverage, 3550,
     /*  80023 */     GIR_EraseRootFromParent_Done,
     /*  80024 */   // Label 1295: @80024
     /*  80024 */   GIM_Try, /*On fail goto*//*Label 1296*/ GIMT_Encode4(80088), // Rule ID 3551 //
     /*  80029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  80032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf64gernp),
     /*  80037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  80040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  80043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  80046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  80049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  80053 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10550:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF64GERNP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  80053 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  80056 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80060 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80065 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  80069 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF64GERNP),
     /*  80077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  80079 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  80081 */     GIR_RootToRootCopy, /*OpIdx*/3, // XA
     /*  80083 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80086 */     GIR_RootConstrainSelectedInstOperands,
     /*  80087 */     // GIR_Coverage, 3551,
     /*  80087 */     GIR_EraseRootFromParent_Done,
     /*  80088 */   // Label 1296: @80088
     /*  80088 */   GIM_Try, /*On fail goto*//*Label 1297*/ GIMT_Encode4(80152), // Rule ID 3552 //
     /*  80093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  80096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf64gernn),
     /*  80101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  80104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  80107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  80110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  80113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  80117 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10549:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF64GERWNN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  80117 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  80120 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80124 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80129 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  80133 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF64GERWNN),
     /*  80141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  80143 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  80145 */     GIR_RootToRootCopy, /*OpIdx*/3, // XA
     /*  80147 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80150 */     GIR_RootConstrainSelectedInstOperands,
     /*  80151 */     // GIR_Coverage, 3552,
     /*  80151 */     GIR_EraseRootFromParent_Done,
     /*  80152 */   // Label 1297: @80152
     /*  80152 */   GIM_Try, /*On fail goto*//*Label 1298*/ GIMT_Encode4(80238), // Rule ID 3554 //
     /*  80157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  80160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvbf16ger2pp),
     /*  80165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  80168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  80171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  80174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  80177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  80181 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10537:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVBF16GER2WPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  80181 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  80184 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80188 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80193 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  80197 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80202 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  80205 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80209 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80214 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  80218 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVBF16GER2WPP),
     /*  80226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  80228 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  80230 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80233 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  80236 */     GIR_RootConstrainSelectedInstOperands,
     /*  80237 */     // GIR_Coverage, 3554,
     /*  80237 */     GIR_EraseRootFromParent_Done,
     /*  80238 */   // Label 1298: @80238
     /*  80238 */   GIM_Try, /*On fail goto*//*Label 1299*/ GIMT_Encode4(80324), // Rule ID 3555 //
     /*  80243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  80246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvbf16ger2pn),
     /*  80251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  80254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  80257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  80260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  80263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  80267 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10536:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVBF16GER2WPN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  80267 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  80270 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80274 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80279 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  80283 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80288 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  80291 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80295 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80300 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  80304 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVBF16GER2WPN),
     /*  80312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  80314 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  80316 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80319 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  80322 */     GIR_RootConstrainSelectedInstOperands,
     /*  80323 */     // GIR_Coverage, 3555,
     /*  80323 */     GIR_EraseRootFromParent_Done,
     /*  80324 */   // Label 1299: @80324
     /*  80324 */   GIM_Try, /*On fail goto*//*Label 1300*/ GIMT_Encode4(80410), // Rule ID 3556 //
     /*  80329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  80332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvbf16ger2np),
     /*  80337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  80340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  80343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  80346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  80349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  80353 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10535:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVBF16GER2WNP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  80353 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  80356 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80360 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80365 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  80369 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80374 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  80377 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80381 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80386 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  80390 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVBF16GER2WNP),
     /*  80398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  80400 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  80402 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80405 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  80408 */     GIR_RootConstrainSelectedInstOperands,
     /*  80409 */     // GIR_Coverage, 3556,
     /*  80409 */     GIR_EraseRootFromParent_Done,
     /*  80410 */   // Label 1300: @80410
     /*  80410 */   GIM_Try, /*On fail goto*//*Label 1301*/ GIMT_Encode4(80496), // Rule ID 3557 //
     /*  80415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  80418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvbf16ger2nn),
     /*  80423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  80426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  80429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  80432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  80435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  80439 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10534:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVBF16GER2WNN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  80439 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  80442 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80446 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80451 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  80455 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80460 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  80463 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80467 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80472 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  80476 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVBF16GER2WNN),
     /*  80484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  80486 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  80488 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80491 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  80494 */     GIR_RootConstrainSelectedInstOperands,
     /*  80495 */     // GIR_Coverage, 3557,
     /*  80495 */     GIR_EraseRootFromParent_Done,
     /*  80496 */   // Label 1301: @80496
     /*  80496 */   GIM_Try, /*On fail goto*//*Label 1302*/ GIMT_Encode4(80582), // Rule ID 3559 //
     /*  80501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  80504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvi16ger2pp),
     /*  80509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  80512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  80515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  80518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  80521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  80525 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10554:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVI16GER2WPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  80525 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  80528 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80532 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80537 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  80541 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80546 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  80549 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80553 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80558 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  80562 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVI16GER2WPP),
     /*  80570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  80572 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  80574 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80577 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  80580 */     GIR_RootConstrainSelectedInstOperands,
     /*  80581 */     // GIR_Coverage, 3559,
     /*  80581 */     GIR_EraseRootFromParent_Done,
     /*  80582 */   // Label 1302: @80582
     /*  80582 */   GIM_Try, /*On fail goto*//*Label 1303*/ GIMT_Encode4(80668), // Rule ID 3560 //
     /*  80587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  80590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvi8ger4spp),
     /*  80595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  80598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  80601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  80604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  80607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  80611 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10561:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVI8GER4WSPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  80611 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  80614 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80618 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80623 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  80627 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80632 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  80635 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80639 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80644 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  80648 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVI8GER4WSPP),
     /*  80656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  80658 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  80660 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80663 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  80666 */     GIR_RootConstrainSelectedInstOperands,
     /*  80667 */     // GIR_Coverage, 3560,
     /*  80667 */     GIR_EraseRootFromParent_Done,
     /*  80668 */   // Label 1303: @80668
     /*  80668 */   GIM_Reject,
     /*  80669 */ // Label 1191: @80669
     /*  80669 */ GIM_Try, /*On fail goto*//*Label 1304*/ GIMT_Encode4(81293),
     /*  80674 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /*  80677 */   GIM_Try, /*On fail goto*//*Label 1305*/ GIMT_Encode4(80796), // Rule ID 3572 //
     /*  80682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  80685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf32ger),
     /*  80690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  80693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  80696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  80699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  80709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  80713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  80717 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  80721 */     // MIs[1] Operand 1
     /*  80721 */     // No operand predicates
     /*  80721 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /*  80725 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  80729 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  80733 */     // MIs[2] Operand 1
     /*  80733 */     // No operand predicates
     /*  80733 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  80735 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10514:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)  =>  (PMXVF32GER:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)
     /*  80735 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  80738 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80742 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80747 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  80751 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80756 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  80759 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80763 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80768 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  80772 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF32GER),
     /*  80780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  80782 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80785 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  80788 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  80791 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  80794 */     GIR_RootConstrainSelectedInstOperands,
     /*  80795 */     // GIR_Coverage, 3572,
     /*  80795 */     GIR_EraseRootFromParent_Done,
     /*  80796 */   // Label 1305: @80796
     /*  80796 */   GIM_Try, /*On fail goto*//*Label 1306*/ GIMT_Encode4(80893), // Rule ID 3577 //
     /*  80801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  80804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf64ger),
     /*  80809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  80812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v256s1,
     /*  80815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  80818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  80828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  80832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  80836 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  80840 */     // MIs[1] Operand 1
     /*  80840 */     // No operand predicates
     /*  80840 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /*  80844 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  80848 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  80852 */     // MIs[2] Operand 1
     /*  80852 */     // No operand predicates
     /*  80852 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  80854 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10519:{ *:[iPTR] }, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)  =>  (PMXVF64GER:{ *:[v512i1] } ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)
     /*  80854 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  80857 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80861 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80866 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  80870 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF64GER),
     /*  80878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  80880 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  80882 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80885 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  80888 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  80891 */     GIR_RootConstrainSelectedInstOperands,
     /*  80892 */     // GIR_Coverage, 3577,
     /*  80892 */     GIR_EraseRootFromParent_Done,
     /*  80893 */   // Label 1306: @80893
     /*  80893 */   GIM_Try, /*On fail goto*//*Label 1307*/ GIMT_Encode4(81012), // Rule ID 3601 //
     /*  80898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  80901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf32ger),
     /*  80906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  80909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  80912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  80915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  80925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  80929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  80933 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  80937 */     // MIs[1] Operand 1
     /*  80937 */     // No operand predicates
     /*  80937 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /*  80941 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  80945 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  80949 */     // MIs[2] Operand 1
     /*  80949 */     // No operand predicates
     /*  80949 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  80951 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10514:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)  =>  (PMXVF32GERW:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)
     /*  80951 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  80954 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80958 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80963 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  80967 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80972 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  80975 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80979 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80984 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  80988 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF32GERW),
     /*  80996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  80998 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81001 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  81004 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  81007 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  81010 */     GIR_RootConstrainSelectedInstOperands,
     /*  81011 */     // GIR_Coverage, 3601,
     /*  81011 */     GIR_EraseRootFromParent_Done,
     /*  81012 */   // Label 1307: @81012
     /*  81012 */   GIM_Try, /*On fail goto*//*Label 1308*/ GIMT_Encode4(81109), // Rule ID 3606 //
     /*  81017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  81020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf64ger),
     /*  81025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  81028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v256s1,
     /*  81031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  81034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81037 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  81044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  81048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  81052 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  81056 */     // MIs[1] Operand 1
     /*  81056 */     // No operand predicates
     /*  81056 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /*  81060 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  81064 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  81068 */     // MIs[2] Operand 1
     /*  81068 */     // No operand predicates
     /*  81068 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  81070 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10519:{ *:[iPTR] }, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)  =>  (PMXVF64GERW:{ *:[v512i1] } ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)
     /*  81070 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  81073 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  81077 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81082 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  81086 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF64GERW),
     /*  81094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  81096 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  81098 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81101 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  81104 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  81107 */     GIR_RootConstrainSelectedInstOperands,
     /*  81108 */     // GIR_Coverage, 3606,
     /*  81108 */     GIR_EraseRootFromParent_Done,
     /*  81109 */   // Label 1308: @81109
     /*  81109 */   GIM_Try, /*On fail goto*//*Label 1309*/ GIMT_Encode4(81156), // Rule ID 1113 //
     /*  81114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  81117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xxeval),
     /*  81122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  81125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  81128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  81131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  81134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81138 */     // MIs[0] IMM
     /*  81138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  81141 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10699:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$XA, v2i64:{ *:[v2i64] }:$XB, v2i64:{ *:[v2i64] }:$XC, (timm:{ *:[i32] }):$IMM)  =>  (XXEVAL:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$XA, v2i64:{ *:[v2i64] }:$XB, v2i64:{ *:[v2i64] }:$XC, (timm:{ *:[i32] }):$IMM)
     /*  81141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  81144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  81146 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  81148 */     GIR_RootToRootCopy, /*OpIdx*/3, // XB
     /*  81150 */     GIR_RootToRootCopy, /*OpIdx*/4, // XC
     /*  81152 */     GIR_RootToRootCopy, /*OpIdx*/5, // IMM
     /*  81154 */     GIR_RootConstrainSelectedInstOperands,
     /*  81155 */     // GIR_Coverage, 1113,
     /*  81155 */     GIR_EraseRootFromParent_Done,
     /*  81156 */   // Label 1309: @81156
     /*  81156 */   GIM_Try, /*On fail goto*//*Label 1310*/ GIMT_Encode4(81292), // Rule ID 3420 //
     /*  81161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  81164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xxpermx),
     /*  81169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  81172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  81175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  81178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  81181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81185 */     // MIs[0] D
     /*  81185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  81188 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10707:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$A, v16i8:{ *:[v16i8] }:$B, v16i8:{ *:[v16i8] }:$C, (timm:{ *:[i32] }):$D)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } (XXPERMX:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$A, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$B, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$C, VSRC:{ *:[i32] }), ?:{ *:[i32] }:$D), VSRC:{ *:[i32] })
     /*  81188 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /*  81191 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  81195 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81200 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/4, // C
     /*  81204 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81209 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  81212 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  81216 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81221 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // B
     /*  81225 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81230 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  81233 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  81237 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81242 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // A
     /*  81246 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81251 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  81254 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXPERMX),
     /*  81258 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81263 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  81266 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  81269 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  81272 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // D
     /*  81276 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  81278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  81281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81283 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81286 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81291 */     // GIR_Coverage, 3420,
     /*  81291 */     GIR_EraseRootFromParent_Done,
     /*  81292 */   // Label 1310: @81292
     /*  81292 */   GIM_Reject,
     /*  81293 */ // Label 1304: @81293
     /*  81293 */ GIM_Try, /*On fail goto*//*Label 1311*/ GIMT_Encode4(84754),
     /*  81298 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/7,
     /*  81301 */   GIM_Try, /*On fail goto*//*Label 1312*/ GIMT_Encode4(81438), // Rule ID 3561 //
     /*  81306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  81309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvi4ger8),
     /*  81314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  81317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  81320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  81323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  81336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  81340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  81344 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  81348 */     // MIs[1] Operand 1
     /*  81348 */     // No operand predicates
     /*  81348 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /*  81352 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  81356 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  81360 */     // MIs[2] Operand 1
     /*  81360 */     // No operand predicates
     /*  81360 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/6, // MIs[3]
     /*  81364 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  81368 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk8Imm),
     /*  81372 */     // MIs[3] Operand 1
     /*  81372 */     // No operand predicates
     /*  81372 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  81374 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10528:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$PMSK)  =>  (PMXVI4GER8:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$PMSK)
     /*  81374 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  81377 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  81381 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81386 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  81390 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81395 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  81398 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  81402 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81407 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  81411 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVI4GER8),
     /*  81419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  81421 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81424 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  81427 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  81430 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  81433 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  81436 */     GIR_RootConstrainSelectedInstOperands,
     /*  81437 */     // GIR_Coverage, 3561,
     /*  81437 */     GIR_EraseRootFromParent_Done,
     /*  81438 */   // Label 1312: @81438
     /*  81438 */   GIM_Try, /*On fail goto*//*Label 1313*/ GIMT_Encode4(81575), // Rule ID 3563 //
     /*  81443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  81446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvi8ger4),
     /*  81451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  81454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  81457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  81460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81466 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  81473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  81477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  81481 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  81485 */     // MIs[1] Operand 1
     /*  81485 */     // No operand predicates
     /*  81485 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /*  81489 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  81493 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  81497 */     // MIs[2] Operand 1
     /*  81497 */     // No operand predicates
     /*  81497 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/6, // MIs[3]
     /*  81501 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  81505 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  81509 */     // MIs[3] Operand 1
     /*  81509 */     // No operand predicates
     /*  81509 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  81511 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10530:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$PMSK)  =>  (PMXVI8GER4:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$PMSK)
     /*  81511 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  81514 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  81518 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81523 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  81527 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81532 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  81535 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  81539 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81544 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  81548 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVI8GER4),
     /*  81556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  81558 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81561 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  81564 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  81567 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  81570 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  81573 */     GIR_RootConstrainSelectedInstOperands,
     /*  81574 */     // GIR_Coverage, 3563,
     /*  81574 */     GIR_EraseRootFromParent_Done,
     /*  81575 */   // Label 1313: @81575
     /*  81575 */   GIM_Try, /*On fail goto*//*Label 1314*/ GIMT_Encode4(81712), // Rule ID 3565 //
     /*  81580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  81583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvi16ger2s),
     /*  81588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  81591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  81594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  81597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  81610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  81614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  81618 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  81622 */     // MIs[1] Operand 1
     /*  81622 */     // No operand predicates
     /*  81622 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /*  81626 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  81630 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  81634 */     // MIs[2] Operand 1
     /*  81634 */     // No operand predicates
     /*  81634 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/6, // MIs[3]
     /*  81638 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  81642 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  81646 */     // MIs[3] Operand 1
     /*  81646 */     // No operand predicates
     /*  81646 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  81648 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10526:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVI16GER2S:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  81648 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  81651 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  81655 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81660 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  81664 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81669 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  81672 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  81676 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81681 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  81685 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVI16GER2S),
     /*  81693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  81695 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81698 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  81701 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  81704 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  81707 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  81710 */     GIR_RootConstrainSelectedInstOperands,
     /*  81711 */     // GIR_Coverage, 3565,
     /*  81711 */     GIR_EraseRootFromParent_Done,
     /*  81712 */   // Label 1314: @81712
     /*  81712 */   GIM_Try, /*On fail goto*//*Label 1315*/ GIMT_Encode4(81849), // Rule ID 3567 //
     /*  81717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  81720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf16ger2),
     /*  81725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  81728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  81731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  81734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81740 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  81747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  81751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  81755 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  81759 */     // MIs[1] Operand 1
     /*  81759 */     // No operand predicates
     /*  81759 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /*  81763 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  81767 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  81771 */     // MIs[2] Operand 1
     /*  81771 */     // No operand predicates
     /*  81771 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/6, // MIs[3]
     /*  81775 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  81779 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  81783 */     // MIs[3] Operand 1
     /*  81783 */     // No operand predicates
     /*  81783 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  81785 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10509:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVF16GER2:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  81785 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  81788 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  81792 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81797 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  81801 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81806 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  81809 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  81813 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81818 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  81822 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF16GER2),
     /*  81830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  81832 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81835 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  81838 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  81841 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  81844 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  81847 */     GIR_RootConstrainSelectedInstOperands,
     /*  81848 */     // GIR_Coverage, 3567,
     /*  81848 */     GIR_EraseRootFromParent_Done,
     /*  81849 */   // Label 1315: @81849
     /*  81849 */   GIM_Try, /*On fail goto*//*Label 1316*/ GIMT_Encode4(81986), // Rule ID 3582 //
     /*  81854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  81857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvbf16ger2),
     /*  81862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  81865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  81868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  81871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  81884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  81888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  81892 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  81896 */     // MIs[1] Operand 1
     /*  81896 */     // No operand predicates
     /*  81896 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /*  81900 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  81904 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  81908 */     // MIs[2] Operand 1
     /*  81908 */     // No operand predicates
     /*  81908 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/6, // MIs[3]
     /*  81912 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  81916 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  81920 */     // MIs[3] Operand 1
     /*  81920 */     // No operand predicates
     /*  81920 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  81922 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10504:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVBF16GER2:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  81922 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  81925 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  81929 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81934 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  81938 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81943 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  81946 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  81950 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81955 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  81959 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVBF16GER2),
     /*  81967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  81969 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81972 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  81975 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  81978 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  81981 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  81984 */     GIR_RootConstrainSelectedInstOperands,
     /*  81985 */     // GIR_Coverage, 3582,
     /*  81985 */     GIR_EraseRootFromParent_Done,
     /*  81986 */   // Label 1316: @81986
     /*  81986 */   GIM_Try, /*On fail goto*//*Label 1317*/ GIMT_Encode4(82123), // Rule ID 3587 //
     /*  81991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  81994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvi16ger2),
     /*  81999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  82002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  82005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  82008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82014 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  82017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  82021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  82025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82029 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  82033 */     // MIs[1] Operand 1
     /*  82033 */     // No operand predicates
     /*  82033 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /*  82037 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82041 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  82045 */     // MIs[2] Operand 1
     /*  82045 */     // No operand predicates
     /*  82045 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/6, // MIs[3]
     /*  82049 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82053 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  82057 */     // MIs[3] Operand 1
     /*  82057 */     // No operand predicates
     /*  82057 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  82059 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10524:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVI16GER2:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  82059 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  82062 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  82066 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82071 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  82075 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  82080 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  82083 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  82087 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82092 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  82096 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  82101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVI16GER2),
     /*  82104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  82106 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82109 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  82112 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  82115 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  82118 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  82121 */     GIR_RootConstrainSelectedInstOperands,
     /*  82122 */     // GIR_Coverage, 3587,
     /*  82122 */     GIR_EraseRootFromParent_Done,
     /*  82123 */   // Label 1317: @82123
     /*  82123 */   GIM_Try, /*On fail goto*//*Label 1318*/ GIMT_Encode4(82260), // Rule ID 3590 //
     /*  82128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  82131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvi4ger8),
     /*  82136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  82139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  82142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  82145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  82154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  82158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  82162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82166 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  82170 */     // MIs[1] Operand 1
     /*  82170 */     // No operand predicates
     /*  82170 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /*  82174 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82178 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  82182 */     // MIs[2] Operand 1
     /*  82182 */     // No operand predicates
     /*  82182 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/6, // MIs[3]
     /*  82186 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82190 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk8Imm),
     /*  82194 */     // MIs[3] Operand 1
     /*  82194 */     // No operand predicates
     /*  82194 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  82196 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10528:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$PMSK)  =>  (PMXVI4GER8W:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$PMSK)
     /*  82196 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  82199 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  82203 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82208 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  82212 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  82217 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  82220 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  82224 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82229 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  82233 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  82238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVI4GER8W),
     /*  82241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  82243 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82246 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  82249 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  82252 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  82255 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  82258 */     GIR_RootConstrainSelectedInstOperands,
     /*  82259 */     // GIR_Coverage, 3590,
     /*  82259 */     GIR_EraseRootFromParent_Done,
     /*  82260 */   // Label 1318: @82260
     /*  82260 */   GIM_Try, /*On fail goto*//*Label 1319*/ GIMT_Encode4(82397), // Rule ID 3592 //
     /*  82265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  82268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvi8ger4),
     /*  82273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  82276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  82279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  82282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82288 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  82291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  82295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  82299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82303 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  82307 */     // MIs[1] Operand 1
     /*  82307 */     // No operand predicates
     /*  82307 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /*  82311 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82315 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  82319 */     // MIs[2] Operand 1
     /*  82319 */     // No operand predicates
     /*  82319 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/6, // MIs[3]
     /*  82323 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82327 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  82331 */     // MIs[3] Operand 1
     /*  82331 */     // No operand predicates
     /*  82331 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  82333 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10530:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$PMSK)  =>  (PMXVI8GER4W:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$PMSK)
     /*  82333 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  82336 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  82340 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82345 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  82349 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  82354 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  82357 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  82361 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82366 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  82370 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  82375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVI8GER4W),
     /*  82378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  82380 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82383 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  82386 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  82389 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  82392 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  82395 */     GIR_RootConstrainSelectedInstOperands,
     /*  82396 */     // GIR_Coverage, 3592,
     /*  82396 */     GIR_EraseRootFromParent_Done,
     /*  82397 */   // Label 1319: @82397
     /*  82397 */   GIM_Try, /*On fail goto*//*Label 1320*/ GIMT_Encode4(82534), // Rule ID 3594 //
     /*  82402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  82405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvi16ger2s),
     /*  82410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  82413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  82416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  82419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  82428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  82432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  82436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82440 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  82444 */     // MIs[1] Operand 1
     /*  82444 */     // No operand predicates
     /*  82444 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /*  82448 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82452 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  82456 */     // MIs[2] Operand 1
     /*  82456 */     // No operand predicates
     /*  82456 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/6, // MIs[3]
     /*  82460 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82464 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  82468 */     // MIs[3] Operand 1
     /*  82468 */     // No operand predicates
     /*  82468 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  82470 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10526:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVI16GER2SW:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  82470 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  82473 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  82477 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82482 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  82486 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  82491 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  82494 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  82498 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82503 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  82507 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  82512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVI16GER2SW),
     /*  82515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  82517 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82520 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  82523 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  82526 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  82529 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  82532 */     GIR_RootConstrainSelectedInstOperands,
     /*  82533 */     // GIR_Coverage, 3594,
     /*  82533 */     GIR_EraseRootFromParent_Done,
     /*  82534 */   // Label 1320: @82534
     /*  82534 */   GIM_Try, /*On fail goto*//*Label 1321*/ GIMT_Encode4(82671), // Rule ID 3596 //
     /*  82539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  82542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf16ger2),
     /*  82547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  82550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  82553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  82556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82562 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  82565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  82569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  82573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82577 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  82581 */     // MIs[1] Operand 1
     /*  82581 */     // No operand predicates
     /*  82581 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /*  82585 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82589 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  82593 */     // MIs[2] Operand 1
     /*  82593 */     // No operand predicates
     /*  82593 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/6, // MIs[3]
     /*  82597 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82601 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  82605 */     // MIs[3] Operand 1
     /*  82605 */     // No operand predicates
     /*  82605 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  82607 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10509:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVF16GER2W:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  82607 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  82610 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  82614 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82619 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  82623 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  82628 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  82631 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  82635 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82640 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  82644 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  82649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF16GER2W),
     /*  82652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  82654 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82657 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  82660 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  82663 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  82666 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  82669 */     GIR_RootConstrainSelectedInstOperands,
     /*  82670 */     // GIR_Coverage, 3596,
     /*  82670 */     GIR_EraseRootFromParent_Done,
     /*  82671 */   // Label 1321: @82671
     /*  82671 */   GIM_Try, /*On fail goto*//*Label 1322*/ GIMT_Encode4(82808), // Rule ID 3611 //
     /*  82676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  82679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvbf16ger2),
     /*  82684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  82687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  82690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  82693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82699 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  82702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  82706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  82710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82714 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  82718 */     // MIs[1] Operand 1
     /*  82718 */     // No operand predicates
     /*  82718 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /*  82722 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82726 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  82730 */     // MIs[2] Operand 1
     /*  82730 */     // No operand predicates
     /*  82730 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/6, // MIs[3]
     /*  82734 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82738 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  82742 */     // MIs[3] Operand 1
     /*  82742 */     // No operand predicates
     /*  82742 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  82744 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10504:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVBF16GER2W:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  82744 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  82747 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  82751 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82756 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  82760 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  82765 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  82768 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  82772 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82777 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  82781 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  82786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVBF16GER2W),
     /*  82789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  82791 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82794 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  82797 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  82800 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  82803 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  82806 */     GIR_RootConstrainSelectedInstOperands,
     /*  82807 */     // GIR_Coverage, 3611,
     /*  82807 */     GIR_EraseRootFromParent_Done,
     /*  82808 */   // Label 1322: @82808
     /*  82808 */   GIM_Try, /*On fail goto*//*Label 1323*/ GIMT_Encode4(82945), // Rule ID 3616 //
     /*  82813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  82816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvi16ger2),
     /*  82821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  82824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  82827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  82830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82836 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  82839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  82843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  82847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82851 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  82855 */     // MIs[1] Operand 1
     /*  82855 */     // No operand predicates
     /*  82855 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /*  82859 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82863 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  82867 */     // MIs[2] Operand 1
     /*  82867 */     // No operand predicates
     /*  82867 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/6, // MIs[3]
     /*  82871 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82875 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  82879 */     // MIs[3] Operand 1
     /*  82879 */     // No operand predicates
     /*  82879 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  82881 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10524:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVI16GER2W:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  82881 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  82884 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  82888 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82893 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  82897 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  82902 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  82905 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  82909 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82914 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  82918 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  82923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVI16GER2W),
     /*  82926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  82928 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82931 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  82934 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  82937 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  82940 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  82943 */     GIR_RootConstrainSelectedInstOperands,
     /*  82944 */     // GIR_Coverage, 3616,
     /*  82944 */     GIR_EraseRootFromParent_Done,
     /*  82945 */   // Label 1323: @82945
     /*  82945 */   GIM_Try, /*On fail goto*//*Label 1324*/ GIMT_Encode4(83069), // Rule ID 3573 //
     /*  82950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  82953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf32gerpp),
     /*  82958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  82961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  82964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  82967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  82970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  82976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  82980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  82984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82988 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  82992 */     // MIs[1] Operand 1
     /*  82992 */     // No operand predicates
     /*  82992 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  82996 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83000 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  83004 */     // MIs[2] Operand 1
     /*  83004 */     // No operand predicates
     /*  83004 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  83006 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10518:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)  =>  (PMXVF32GERPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)
     /*  83006 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  83009 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  83013 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83018 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  83022 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  83027 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  83030 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  83034 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83039 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  83043 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  83048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF32GERPP),
     /*  83051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  83053 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  83055 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83058 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  83061 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  83064 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  83067 */     GIR_RootConstrainSelectedInstOperands,
     /*  83068 */     // GIR_Coverage, 3573,
     /*  83068 */     GIR_EraseRootFromParent_Done,
     /*  83069 */   // Label 1324: @83069
     /*  83069 */   GIM_Try, /*On fail goto*//*Label 1325*/ GIMT_Encode4(83193), // Rule ID 3574 //
     /*  83074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  83077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf32gerpn),
     /*  83082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  83085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  83088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  83091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  83094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  83100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  83104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  83108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83112 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  83116 */     // MIs[1] Operand 1
     /*  83116 */     // No operand predicates
     /*  83116 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  83120 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83124 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  83128 */     // MIs[2] Operand 1
     /*  83128 */     // No operand predicates
     /*  83128 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  83130 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10517:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)  =>  (PMXVF32GERPN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)
     /*  83130 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  83133 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  83137 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83142 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  83146 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  83151 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  83154 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  83158 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83163 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  83167 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  83172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF32GERPN),
     /*  83175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  83177 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  83179 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83182 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  83185 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  83188 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  83191 */     GIR_RootConstrainSelectedInstOperands,
     /*  83192 */     // GIR_Coverage, 3574,
     /*  83192 */     GIR_EraseRootFromParent_Done,
     /*  83193 */   // Label 1325: @83193
     /*  83193 */   GIM_Try, /*On fail goto*//*Label 1326*/ GIMT_Encode4(83317), // Rule ID 3575 //
     /*  83198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  83201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf32gernp),
     /*  83206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  83209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  83212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  83215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  83218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  83224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  83228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  83232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83236 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  83240 */     // MIs[1] Operand 1
     /*  83240 */     // No operand predicates
     /*  83240 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  83244 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83248 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  83252 */     // MIs[2] Operand 1
     /*  83252 */     // No operand predicates
     /*  83252 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  83254 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10516:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)  =>  (PMXVF32GERNP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)
     /*  83254 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  83257 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  83261 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83266 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  83270 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  83275 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  83278 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  83282 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83287 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  83291 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  83296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF32GERNP),
     /*  83299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  83301 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  83303 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83306 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  83309 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  83312 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  83315 */     GIR_RootConstrainSelectedInstOperands,
     /*  83316 */     // GIR_Coverage, 3575,
     /*  83316 */     GIR_EraseRootFromParent_Done,
     /*  83317 */   // Label 1326: @83317
     /*  83317 */   GIM_Try, /*On fail goto*//*Label 1327*/ GIMT_Encode4(83441), // Rule ID 3576 //
     /*  83322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  83325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf32gernn),
     /*  83330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  83333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  83336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  83339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  83342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  83348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  83352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  83356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83360 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  83364 */     // MIs[1] Operand 1
     /*  83364 */     // No operand predicates
     /*  83364 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  83368 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83372 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  83376 */     // MIs[2] Operand 1
     /*  83376 */     // No operand predicates
     /*  83376 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  83378 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10515:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)  =>  (PMXVF32GERNN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)
     /*  83378 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  83381 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  83385 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83390 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  83394 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  83399 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  83402 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  83406 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83411 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  83415 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  83420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF32GERNN),
     /*  83423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  83425 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  83427 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83430 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  83433 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  83436 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  83439 */     GIR_RootConstrainSelectedInstOperands,
     /*  83440 */     // GIR_Coverage, 3576,
     /*  83440 */     GIR_EraseRootFromParent_Done,
     /*  83441 */   // Label 1327: @83441
     /*  83441 */   GIM_Try, /*On fail goto*//*Label 1328*/ GIMT_Encode4(83543), // Rule ID 3578 //
     /*  83446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  83449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf64gerpp),
     /*  83454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  83457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  83460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  83463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  83466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83469 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  83472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  83476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  83480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83484 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  83488 */     // MIs[1] Operand 1
     /*  83488 */     // No operand predicates
     /*  83488 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  83492 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83496 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  83500 */     // MIs[2] Operand 1
     /*  83500 */     // No operand predicates
     /*  83500 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  83502 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10523:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)  =>  (PMXVF64GERPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)
     /*  83502 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  83505 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  83509 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83514 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  83518 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  83523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF64GERPP),
     /*  83526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  83528 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  83530 */     GIR_RootToRootCopy, /*OpIdx*/3, // XA
     /*  83532 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83535 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  83538 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  83541 */     GIR_RootConstrainSelectedInstOperands,
     /*  83542 */     // GIR_Coverage, 3578,
     /*  83542 */     GIR_EraseRootFromParent_Done,
     /*  83543 */   // Label 1328: @83543
     /*  83543 */   GIM_Try, /*On fail goto*//*Label 1329*/ GIMT_Encode4(83645), // Rule ID 3579 //
     /*  83548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  83551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf64gerpn),
     /*  83556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  83559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  83562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  83565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  83568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  83574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  83578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  83582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83586 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  83590 */     // MIs[1] Operand 1
     /*  83590 */     // No operand predicates
     /*  83590 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  83594 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83598 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  83602 */     // MIs[2] Operand 1
     /*  83602 */     // No operand predicates
     /*  83602 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  83604 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10522:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)  =>  (PMXVF64GERPN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)
     /*  83604 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  83607 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  83611 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83616 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  83620 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  83625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF64GERPN),
     /*  83628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  83630 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  83632 */     GIR_RootToRootCopy, /*OpIdx*/3, // XA
     /*  83634 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83637 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  83640 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  83643 */     GIR_RootConstrainSelectedInstOperands,
     /*  83644 */     // GIR_Coverage, 3579,
     /*  83644 */     GIR_EraseRootFromParent_Done,
     /*  83645 */   // Label 1329: @83645
     /*  83645 */   GIM_Try, /*On fail goto*//*Label 1330*/ GIMT_Encode4(83747), // Rule ID 3580 //
     /*  83650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  83653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf64gernp),
     /*  83658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  83661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  83664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  83667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  83670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  83676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  83680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  83684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83688 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  83692 */     // MIs[1] Operand 1
     /*  83692 */     // No operand predicates
     /*  83692 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  83696 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83700 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  83704 */     // MIs[2] Operand 1
     /*  83704 */     // No operand predicates
     /*  83704 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  83706 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10521:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)  =>  (PMXVF64GERNP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)
     /*  83706 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  83709 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  83713 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83718 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  83722 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  83727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF64GERNP),
     /*  83730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  83732 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  83734 */     GIR_RootToRootCopy, /*OpIdx*/3, // XA
     /*  83736 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83739 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  83742 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  83745 */     GIR_RootConstrainSelectedInstOperands,
     /*  83746 */     // GIR_Coverage, 3580,
     /*  83746 */     GIR_EraseRootFromParent_Done,
     /*  83747 */   // Label 1330: @83747
     /*  83747 */   GIM_Try, /*On fail goto*//*Label 1331*/ GIMT_Encode4(83849), // Rule ID 3581 //
     /*  83752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  83755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf64gernn),
     /*  83760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  83763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  83766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  83769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  83772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  83778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  83782 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  83786 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83790 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  83794 */     // MIs[1] Operand 1
     /*  83794 */     // No operand predicates
     /*  83794 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  83798 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83802 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  83806 */     // MIs[2] Operand 1
     /*  83806 */     // No operand predicates
     /*  83806 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  83808 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10520:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)  =>  (PMXVF64GERNN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)
     /*  83808 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  83811 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  83815 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83820 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  83824 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  83829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF64GERNN),
     /*  83832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  83834 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  83836 */     GIR_RootToRootCopy, /*OpIdx*/3, // XA
     /*  83838 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83841 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  83844 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  83847 */     GIR_RootConstrainSelectedInstOperands,
     /*  83848 */     // GIR_Coverage, 3581,
     /*  83848 */     GIR_EraseRootFromParent_Done,
     /*  83849 */   // Label 1331: @83849
     /*  83849 */   GIM_Try, /*On fail goto*//*Label 1332*/ GIMT_Encode4(83973), // Rule ID 3602 //
     /*  83854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  83857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf32gerpp),
     /*  83862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  83865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  83868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  83871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  83874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  83880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  83884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  83888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83892 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  83896 */     // MIs[1] Operand 1
     /*  83896 */     // No operand predicates
     /*  83896 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  83900 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83904 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  83908 */     // MIs[2] Operand 1
     /*  83908 */     // No operand predicates
     /*  83908 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  83910 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10518:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)  =>  (PMXVF32GERWPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)
     /*  83910 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  83913 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  83917 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83922 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  83926 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  83931 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  83934 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  83938 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83943 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  83947 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  83952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF32GERWPP),
     /*  83955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  83957 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  83959 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83962 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  83965 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  83968 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  83971 */     GIR_RootConstrainSelectedInstOperands,
     /*  83972 */     // GIR_Coverage, 3602,
     /*  83972 */     GIR_EraseRootFromParent_Done,
     /*  83973 */   // Label 1332: @83973
     /*  83973 */   GIM_Try, /*On fail goto*//*Label 1333*/ GIMT_Encode4(84097), // Rule ID 3603 //
     /*  83978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  83981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf32gerpn),
     /*  83986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  83989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  83992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  83995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  83998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  84004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  84008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  84012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84016 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  84020 */     // MIs[1] Operand 1
     /*  84020 */     // No operand predicates
     /*  84020 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  84024 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84028 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  84032 */     // MIs[2] Operand 1
     /*  84032 */     // No operand predicates
     /*  84032 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  84034 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10517:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)  =>  (PMXVF32GERWPN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)
     /*  84034 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  84037 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84041 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84046 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  84050 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  84055 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  84058 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84062 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84067 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  84071 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  84076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF32GERWPN),
     /*  84079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  84081 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  84083 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84086 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  84089 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  84092 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  84095 */     GIR_RootConstrainSelectedInstOperands,
     /*  84096 */     // GIR_Coverage, 3603,
     /*  84096 */     GIR_EraseRootFromParent_Done,
     /*  84097 */   // Label 1333: @84097
     /*  84097 */   GIM_Try, /*On fail goto*//*Label 1334*/ GIMT_Encode4(84221), // Rule ID 3604 //
     /*  84102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  84105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf32gernp),
     /*  84110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  84113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  84116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  84119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  84122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  84128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  84132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  84136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84140 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  84144 */     // MIs[1] Operand 1
     /*  84144 */     // No operand predicates
     /*  84144 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  84148 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84152 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  84156 */     // MIs[2] Operand 1
     /*  84156 */     // No operand predicates
     /*  84156 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  84158 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10516:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)  =>  (PMXVF32GERWNP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)
     /*  84158 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  84161 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84165 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84170 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  84174 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  84179 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  84182 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84186 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84191 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  84195 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  84200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF32GERWNP),
     /*  84203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  84205 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  84207 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84210 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  84213 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  84216 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  84219 */     GIR_RootConstrainSelectedInstOperands,
     /*  84220 */     // GIR_Coverage, 3604,
     /*  84220 */     GIR_EraseRootFromParent_Done,
     /*  84221 */   // Label 1334: @84221
     /*  84221 */   GIM_Try, /*On fail goto*//*Label 1335*/ GIMT_Encode4(84345), // Rule ID 3605 //
     /*  84226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  84229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf32gernn),
     /*  84234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  84237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  84240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  84243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  84246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  84252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  84256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  84260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84264 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  84268 */     // MIs[1] Operand 1
     /*  84268 */     // No operand predicates
     /*  84268 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  84272 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84276 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  84280 */     // MIs[2] Operand 1
     /*  84280 */     // No operand predicates
     /*  84280 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  84282 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10515:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)  =>  (PMXVF32GERWNN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)
     /*  84282 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  84285 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84289 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84294 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  84298 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  84303 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  84306 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84310 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84315 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  84319 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  84324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF32GERWNN),
     /*  84327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  84329 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  84331 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84334 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  84337 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  84340 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  84343 */     GIR_RootConstrainSelectedInstOperands,
     /*  84344 */     // GIR_Coverage, 3605,
     /*  84344 */     GIR_EraseRootFromParent_Done,
     /*  84345 */   // Label 1335: @84345
     /*  84345 */   GIM_Try, /*On fail goto*//*Label 1336*/ GIMT_Encode4(84447), // Rule ID 3607 //
     /*  84350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  84353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf64gerpp),
     /*  84358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  84361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  84364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  84367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  84370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  84376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  84380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  84384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84388 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  84392 */     // MIs[1] Operand 1
     /*  84392 */     // No operand predicates
     /*  84392 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  84396 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84400 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  84404 */     // MIs[2] Operand 1
     /*  84404 */     // No operand predicates
     /*  84404 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  84406 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10523:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)  =>  (PMXVF64GERWPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)
     /*  84406 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  84409 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84413 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84418 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  84422 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  84427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF64GERWPP),
     /*  84430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  84432 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  84434 */     GIR_RootToRootCopy, /*OpIdx*/3, // XA
     /*  84436 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84439 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  84442 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  84445 */     GIR_RootConstrainSelectedInstOperands,
     /*  84446 */     // GIR_Coverage, 3607,
     /*  84446 */     GIR_EraseRootFromParent_Done,
     /*  84447 */   // Label 1336: @84447
     /*  84447 */   GIM_Try, /*On fail goto*//*Label 1337*/ GIMT_Encode4(84549), // Rule ID 3608 //
     /*  84452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  84455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf64gerpn),
     /*  84460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  84463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  84466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  84469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  84472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  84478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  84482 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  84486 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84490 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  84494 */     // MIs[1] Operand 1
     /*  84494 */     // No operand predicates
     /*  84494 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  84498 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84502 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  84506 */     // MIs[2] Operand 1
     /*  84506 */     // No operand predicates
     /*  84506 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  84508 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10522:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)  =>  (PMXVF64GERWPN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)
     /*  84508 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  84511 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84515 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84520 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  84524 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  84529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF64GERWPN),
     /*  84532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  84534 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  84536 */     GIR_RootToRootCopy, /*OpIdx*/3, // XA
     /*  84538 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84541 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  84544 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  84547 */     GIR_RootConstrainSelectedInstOperands,
     /*  84548 */     // GIR_Coverage, 3608,
     /*  84548 */     GIR_EraseRootFromParent_Done,
     /*  84549 */   // Label 1337: @84549
     /*  84549 */   GIM_Try, /*On fail goto*//*Label 1338*/ GIMT_Encode4(84651), // Rule ID 3609 //
     /*  84554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  84557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf64gernp),
     /*  84562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  84565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  84568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  84571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  84574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  84580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  84584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  84588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84592 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  84596 */     // MIs[1] Operand 1
     /*  84596 */     // No operand predicates
     /*  84596 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  84600 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84604 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  84608 */     // MIs[2] Operand 1
     /*  84608 */     // No operand predicates
     /*  84608 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  84610 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10521:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)  =>  (PMXVF64GERWNP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)
     /*  84610 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  84613 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84617 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84622 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  84626 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  84631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF64GERWNP),
     /*  84634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  84636 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  84638 */     GIR_RootToRootCopy, /*OpIdx*/3, // XA
     /*  84640 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84643 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  84646 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  84649 */     GIR_RootConstrainSelectedInstOperands,
     /*  84650 */     // GIR_Coverage, 3609,
     /*  84650 */     GIR_EraseRootFromParent_Done,
     /*  84651 */   // Label 1338: @84651
     /*  84651 */   GIM_Try, /*On fail goto*//*Label 1339*/ GIMT_Encode4(84753), // Rule ID 3610 //
     /*  84656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  84659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf64gernn),
     /*  84664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  84667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  84670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  84673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  84676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  84682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  84686 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  84690 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84694 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  84698 */     // MIs[1] Operand 1
     /*  84698 */     // No operand predicates
     /*  84698 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  84702 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84706 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  84710 */     // MIs[2] Operand 1
     /*  84710 */     // No operand predicates
     /*  84710 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  84712 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10520:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)  =>  (PMXVF64GERWNN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)
     /*  84712 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  84715 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84719 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84724 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  84728 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  84733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF64GERWNN),
     /*  84736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  84738 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  84740 */     GIR_RootToRootCopy, /*OpIdx*/3, // XA
     /*  84742 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84745 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  84748 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  84751 */     GIR_RootConstrainSelectedInstOperands,
     /*  84752 */     // GIR_Coverage, 3610,
     /*  84752 */     GIR_EraseRootFromParent_Done,
     /*  84753 */   // Label 1339: @84753
     /*  84753 */   GIM_Reject,
     /*  84754 */ // Label 1311: @84754
     /*  84754 */ GIM_Try, /*On fail goto*//*Label 1340*/ GIMT_Encode4(88455),
     /*  84759 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/8,
     /*  84762 */   GIM_Try, /*On fail goto*//*Label 1341*/ GIMT_Encode4(84904), // Rule ID 3562 //
     /*  84767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  84770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvi4ger8pp),
     /*  84775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  84778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  84781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  84784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  84787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  84793 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  84796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  84800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  84804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84808 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  84812 */     // MIs[1] Operand 1
     /*  84812 */     // No operand predicates
     /*  84812 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  84816 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84820 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  84824 */     // MIs[2] Operand 1
     /*  84824 */     // No operand predicates
     /*  84824 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  84828 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84832 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk8Imm),
     /*  84836 */     // MIs[3] Operand 1
     /*  84836 */     // No operand predicates
     /*  84836 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  84838 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10529:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$PMSK)  =>  (PMXVI4GER8PP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$PMSK)
     /*  84838 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  84841 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84845 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84850 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  84854 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  84859 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  84862 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84866 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84871 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  84875 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  84880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVI4GER8PP),
     /*  84883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  84885 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  84887 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84890 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  84893 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  84896 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  84899 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  84902 */     GIR_RootConstrainSelectedInstOperands,
     /*  84903 */     // GIR_Coverage, 3562,
     /*  84903 */     GIR_EraseRootFromParent_Done,
     /*  84904 */   // Label 1341: @84904
     /*  84904 */   GIM_Try, /*On fail goto*//*Label 1342*/ GIMT_Encode4(85046), // Rule ID 3564 //
     /*  84909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  84912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvi8ger4pp),
     /*  84917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  84920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  84923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  84926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  84929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84932 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  84935 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  84938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  84942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  84946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84950 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  84954 */     // MIs[1] Operand 1
     /*  84954 */     // No operand predicates
     /*  84954 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  84958 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84962 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  84966 */     // MIs[2] Operand 1
     /*  84966 */     // No operand predicates
     /*  84966 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  84970 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84974 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  84978 */     // MIs[3] Operand 1
     /*  84978 */     // No operand predicates
     /*  84978 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  84980 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10531:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$PMSK)  =>  (PMXVI8GER4PP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$PMSK)
     /*  84980 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  84983 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84987 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84992 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  84996 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  85001 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  85004 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85008 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85013 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  85017 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  85022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVI8GER4PP),
     /*  85025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  85027 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  85029 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85032 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  85035 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  85038 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  85041 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  85044 */     GIR_RootConstrainSelectedInstOperands,
     /*  85045 */     // GIR_Coverage, 3564,
     /*  85045 */     GIR_EraseRootFromParent_Done,
     /*  85046 */   // Label 1342: @85046
     /*  85046 */   GIM_Try, /*On fail goto*//*Label 1343*/ GIMT_Encode4(85188), // Rule ID 3566 //
     /*  85051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  85054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvi16ger2spp),
     /*  85059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  85062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  85065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  85068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  85071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85074 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85077 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  85084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  85088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85092 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  85096 */     // MIs[1] Operand 1
     /*  85096 */     // No operand predicates
     /*  85096 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  85100 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85104 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  85108 */     // MIs[2] Operand 1
     /*  85108 */     // No operand predicates
     /*  85108 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  85112 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85116 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  85120 */     // MIs[3] Operand 1
     /*  85120 */     // No operand predicates
     /*  85120 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  85122 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10527:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVI16GER2SPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  85122 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  85125 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85129 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85134 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  85138 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  85143 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  85146 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85150 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85155 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  85159 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  85164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVI16GER2SPP),
     /*  85167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  85169 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  85171 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85174 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  85177 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  85180 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  85183 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  85186 */     GIR_RootConstrainSelectedInstOperands,
     /*  85187 */     // GIR_Coverage, 3566,
     /*  85187 */     GIR_EraseRootFromParent_Done,
     /*  85188 */   // Label 1343: @85188
     /*  85188 */   GIM_Try, /*On fail goto*//*Label 1344*/ GIMT_Encode4(85330), // Rule ID 3568 //
     /*  85193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  85196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf16ger2pp),
     /*  85201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  85204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  85207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  85210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  85213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85216 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85219 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  85226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  85230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85234 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  85238 */     // MIs[1] Operand 1
     /*  85238 */     // No operand predicates
     /*  85238 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  85242 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85246 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  85250 */     // MIs[2] Operand 1
     /*  85250 */     // No operand predicates
     /*  85250 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  85254 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85258 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  85262 */     // MIs[3] Operand 1
     /*  85262 */     // No operand predicates
     /*  85262 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  85264 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10513:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVF16GER2PP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  85264 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  85267 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85271 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85276 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  85280 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  85285 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  85288 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85292 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85297 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  85301 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  85306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF16GER2PP),
     /*  85309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  85311 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  85313 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85316 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  85319 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  85322 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  85325 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  85328 */     GIR_RootConstrainSelectedInstOperands,
     /*  85329 */     // GIR_Coverage, 3568,
     /*  85329 */     GIR_EraseRootFromParent_Done,
     /*  85330 */   // Label 1344: @85330
     /*  85330 */   GIM_Try, /*On fail goto*//*Label 1345*/ GIMT_Encode4(85472), // Rule ID 3569 //
     /*  85335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  85338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf16ger2pn),
     /*  85343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  85346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  85349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  85352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  85355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85358 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85361 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  85368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  85372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85376 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  85380 */     // MIs[1] Operand 1
     /*  85380 */     // No operand predicates
     /*  85380 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  85384 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85388 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  85392 */     // MIs[2] Operand 1
     /*  85392 */     // No operand predicates
     /*  85392 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  85396 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85400 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  85404 */     // MIs[3] Operand 1
     /*  85404 */     // No operand predicates
     /*  85404 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  85406 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10512:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVF16GER2PN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  85406 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  85409 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85413 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85418 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  85422 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  85427 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  85430 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85434 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85439 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  85443 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  85448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF16GER2PN),
     /*  85451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  85453 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  85455 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85458 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  85461 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  85464 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  85467 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  85470 */     GIR_RootConstrainSelectedInstOperands,
     /*  85471 */     // GIR_Coverage, 3569,
     /*  85471 */     GIR_EraseRootFromParent_Done,
     /*  85472 */   // Label 1345: @85472
     /*  85472 */   GIM_Try, /*On fail goto*//*Label 1346*/ GIMT_Encode4(85614), // Rule ID 3570 //
     /*  85477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  85480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf16ger2np),
     /*  85485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  85488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  85491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  85494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  85497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85500 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85503 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  85510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  85514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85518 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  85522 */     // MIs[1] Operand 1
     /*  85522 */     // No operand predicates
     /*  85522 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  85526 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85530 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  85534 */     // MIs[2] Operand 1
     /*  85534 */     // No operand predicates
     /*  85534 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  85538 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85542 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  85546 */     // MIs[3] Operand 1
     /*  85546 */     // No operand predicates
     /*  85546 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  85548 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10511:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVF16GER2NP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  85548 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  85551 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85555 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85560 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  85564 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  85569 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  85572 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85576 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85581 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  85585 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  85590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF16GER2NP),
     /*  85593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  85595 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  85597 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85600 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  85603 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  85606 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  85609 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  85612 */     GIR_RootConstrainSelectedInstOperands,
     /*  85613 */     // GIR_Coverage, 3570,
     /*  85613 */     GIR_EraseRootFromParent_Done,
     /*  85614 */   // Label 1346: @85614
     /*  85614 */   GIM_Try, /*On fail goto*//*Label 1347*/ GIMT_Encode4(85756), // Rule ID 3571 //
     /*  85619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  85622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf16ger2nn),
     /*  85627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  85630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  85633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  85636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  85639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85642 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85645 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  85652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  85656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85660 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  85664 */     // MIs[1] Operand 1
     /*  85664 */     // No operand predicates
     /*  85664 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  85668 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85672 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  85676 */     // MIs[2] Operand 1
     /*  85676 */     // No operand predicates
     /*  85676 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  85680 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85684 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  85688 */     // MIs[3] Operand 1
     /*  85688 */     // No operand predicates
     /*  85688 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  85690 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10510:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVF16GER2NN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  85690 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  85693 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85697 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85702 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  85706 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  85711 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  85714 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85718 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85723 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  85727 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  85732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF16GER2NN),
     /*  85735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  85737 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  85739 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85742 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  85745 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  85748 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  85751 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  85754 */     GIR_RootConstrainSelectedInstOperands,
     /*  85755 */     // GIR_Coverage, 3571,
     /*  85755 */     GIR_EraseRootFromParent_Done,
     /*  85756 */   // Label 1347: @85756
     /*  85756 */   GIM_Try, /*On fail goto*//*Label 1348*/ GIMT_Encode4(85898), // Rule ID 3583 //
     /*  85761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  85764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvbf16ger2pp),
     /*  85769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  85772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  85775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  85778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  85781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85784 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85787 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  85794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  85798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85802 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  85806 */     // MIs[1] Operand 1
     /*  85806 */     // No operand predicates
     /*  85806 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  85810 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85814 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  85818 */     // MIs[2] Operand 1
     /*  85818 */     // No operand predicates
     /*  85818 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  85822 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85826 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  85830 */     // MIs[3] Operand 1
     /*  85830 */     // No operand predicates
     /*  85830 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  85832 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10508:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVBF16GER2PP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  85832 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  85835 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85839 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85844 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  85848 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  85853 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  85856 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85860 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85865 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  85869 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  85874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVBF16GER2PP),
     /*  85877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  85879 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  85881 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85884 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  85887 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  85890 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  85893 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  85896 */     GIR_RootConstrainSelectedInstOperands,
     /*  85897 */     // GIR_Coverage, 3583,
     /*  85897 */     GIR_EraseRootFromParent_Done,
     /*  85898 */   // Label 1348: @85898
     /*  85898 */   GIM_Try, /*On fail goto*//*Label 1349*/ GIMT_Encode4(86040), // Rule ID 3584 //
     /*  85903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  85906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvbf16ger2pn),
     /*  85911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  85914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  85917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  85920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  85923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85929 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  85936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  85940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85944 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  85948 */     // MIs[1] Operand 1
     /*  85948 */     // No operand predicates
     /*  85948 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  85952 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85956 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  85960 */     // MIs[2] Operand 1
     /*  85960 */     // No operand predicates
     /*  85960 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  85964 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85968 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  85972 */     // MIs[3] Operand 1
     /*  85972 */     // No operand predicates
     /*  85972 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  85974 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10507:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVBF16GER2PN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  85974 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  85977 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85981 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85986 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  85990 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  85995 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  85998 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86002 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86007 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  86011 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  86016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVBF16GER2PN),
     /*  86019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  86021 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  86023 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86026 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  86029 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  86032 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  86035 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  86038 */     GIR_RootConstrainSelectedInstOperands,
     /*  86039 */     // GIR_Coverage, 3584,
     /*  86039 */     GIR_EraseRootFromParent_Done,
     /*  86040 */   // Label 1349: @86040
     /*  86040 */   GIM_Try, /*On fail goto*//*Label 1350*/ GIMT_Encode4(86182), // Rule ID 3585 //
     /*  86045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  86048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvbf16ger2np),
     /*  86053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  86056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  86059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  86062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  86065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86068 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86071 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  86078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  86082 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86086 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  86090 */     // MIs[1] Operand 1
     /*  86090 */     // No operand predicates
     /*  86090 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  86094 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86098 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  86102 */     // MIs[2] Operand 1
     /*  86102 */     // No operand predicates
     /*  86102 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  86106 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86110 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  86114 */     // MIs[3] Operand 1
     /*  86114 */     // No operand predicates
     /*  86114 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  86116 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10506:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVBF16GER2NP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  86116 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  86119 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86123 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86128 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  86132 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  86137 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  86140 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86144 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86149 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  86153 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  86158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVBF16GER2NP),
     /*  86161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  86163 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  86165 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86168 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  86171 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  86174 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  86177 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  86180 */     GIR_RootConstrainSelectedInstOperands,
     /*  86181 */     // GIR_Coverage, 3585,
     /*  86181 */     GIR_EraseRootFromParent_Done,
     /*  86182 */   // Label 1350: @86182
     /*  86182 */   GIM_Try, /*On fail goto*//*Label 1351*/ GIMT_Encode4(86324), // Rule ID 3586 //
     /*  86187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  86190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvbf16ger2nn),
     /*  86195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  86198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  86201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  86204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  86207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86210 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86213 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  86220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  86224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86228 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  86232 */     // MIs[1] Operand 1
     /*  86232 */     // No operand predicates
     /*  86232 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  86236 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86240 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  86244 */     // MIs[2] Operand 1
     /*  86244 */     // No operand predicates
     /*  86244 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  86248 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86252 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  86256 */     // MIs[3] Operand 1
     /*  86256 */     // No operand predicates
     /*  86256 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  86258 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10505:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVBF16GER2NN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  86258 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  86261 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86265 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86270 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  86274 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  86279 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  86282 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86286 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86291 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  86295 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  86300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVBF16GER2NN),
     /*  86303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  86305 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  86307 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86310 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  86313 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  86316 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  86319 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  86322 */     GIR_RootConstrainSelectedInstOperands,
     /*  86323 */     // GIR_Coverage, 3586,
     /*  86323 */     GIR_EraseRootFromParent_Done,
     /*  86324 */   // Label 1351: @86324
     /*  86324 */   GIM_Try, /*On fail goto*//*Label 1352*/ GIMT_Encode4(86466), // Rule ID 3588 //
     /*  86329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  86332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvi8ger4spp),
     /*  86337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  86340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  86343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  86346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  86349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86352 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86355 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  86362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  86366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86370 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  86374 */     // MIs[1] Operand 1
     /*  86374 */     // No operand predicates
     /*  86374 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  86378 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86382 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  86386 */     // MIs[2] Operand 1
     /*  86386 */     // No operand predicates
     /*  86386 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  86390 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86394 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  86398 */     // MIs[3] Operand 1
     /*  86398 */     // No operand predicates
     /*  86398 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  86400 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10532:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVI8GER4SPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  86400 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  86403 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86407 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86412 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  86416 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  86421 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  86424 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86428 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86433 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  86437 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  86442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVI8GER4SPP),
     /*  86445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  86447 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  86449 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86452 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  86455 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  86458 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  86461 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  86464 */     GIR_RootConstrainSelectedInstOperands,
     /*  86465 */     // GIR_Coverage, 3588,
     /*  86465 */     GIR_EraseRootFromParent_Done,
     /*  86466 */   // Label 1352: @86466
     /*  86466 */   GIM_Try, /*On fail goto*//*Label 1353*/ GIMT_Encode4(86608), // Rule ID 3589 //
     /*  86471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  86474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvi16ger2pp),
     /*  86479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  86482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  86485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  86488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  86491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86494 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86497 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  86504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  86508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86512 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  86516 */     // MIs[1] Operand 1
     /*  86516 */     // No operand predicates
     /*  86516 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  86520 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86524 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  86528 */     // MIs[2] Operand 1
     /*  86528 */     // No operand predicates
     /*  86528 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  86532 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86536 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  86540 */     // MIs[3] Operand 1
     /*  86540 */     // No operand predicates
     /*  86540 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  86542 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10525:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVI16GER2PP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  86542 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  86545 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86549 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86554 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  86558 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  86563 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  86566 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86570 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86575 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  86579 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  86584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVI16GER2PP),
     /*  86587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  86589 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  86591 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86594 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  86597 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  86600 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  86603 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  86606 */     GIR_RootConstrainSelectedInstOperands,
     /*  86607 */     // GIR_Coverage, 3589,
     /*  86607 */     GIR_EraseRootFromParent_Done,
     /*  86608 */   // Label 1353: @86608
     /*  86608 */   GIM_Try, /*On fail goto*//*Label 1354*/ GIMT_Encode4(86750), // Rule ID 3591 //
     /*  86613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  86616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvi4ger8pp),
     /*  86621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  86624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  86627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  86630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  86633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86636 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86639 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  86646 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  86650 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86654 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  86658 */     // MIs[1] Operand 1
     /*  86658 */     // No operand predicates
     /*  86658 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  86662 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86666 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  86670 */     // MIs[2] Operand 1
     /*  86670 */     // No operand predicates
     /*  86670 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  86674 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86678 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk8Imm),
     /*  86682 */     // MIs[3] Operand 1
     /*  86682 */     // No operand predicates
     /*  86682 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  86684 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10529:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$PMSK)  =>  (PMXVI4GER8WPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$PMSK)
     /*  86684 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  86687 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86691 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86696 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  86700 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  86705 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  86708 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86712 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86717 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  86721 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  86726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVI4GER8WPP),
     /*  86729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  86731 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  86733 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86736 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  86739 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  86742 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  86745 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  86748 */     GIR_RootConstrainSelectedInstOperands,
     /*  86749 */     // GIR_Coverage, 3591,
     /*  86749 */     GIR_EraseRootFromParent_Done,
     /*  86750 */   // Label 1354: @86750
     /*  86750 */   GIM_Try, /*On fail goto*//*Label 1355*/ GIMT_Encode4(86892), // Rule ID 3593 //
     /*  86755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  86758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvi8ger4pp),
     /*  86763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  86766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  86769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  86772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  86775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86778 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86781 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  86788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  86792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86796 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  86800 */     // MIs[1] Operand 1
     /*  86800 */     // No operand predicates
     /*  86800 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  86804 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86808 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  86812 */     // MIs[2] Operand 1
     /*  86812 */     // No operand predicates
     /*  86812 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  86816 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86820 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  86824 */     // MIs[3] Operand 1
     /*  86824 */     // No operand predicates
     /*  86824 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  86826 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10531:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$PMSK)  =>  (PMXVI8GER4WPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$PMSK)
     /*  86826 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  86829 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86833 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86838 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  86842 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  86847 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  86850 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86854 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86859 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  86863 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  86868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVI8GER4WPP),
     /*  86871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  86873 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  86875 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86878 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  86881 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  86884 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  86887 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  86890 */     GIR_RootConstrainSelectedInstOperands,
     /*  86891 */     // GIR_Coverage, 3593,
     /*  86891 */     GIR_EraseRootFromParent_Done,
     /*  86892 */   // Label 1355: @86892
     /*  86892 */   GIM_Try, /*On fail goto*//*Label 1356*/ GIMT_Encode4(87034), // Rule ID 3595 //
     /*  86897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  86900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvi16ger2spp),
     /*  86905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  86908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  86911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  86914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  86917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86920 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86923 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  86930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  86934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86938 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  86942 */     // MIs[1] Operand 1
     /*  86942 */     // No operand predicates
     /*  86942 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  86946 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86950 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  86954 */     // MIs[2] Operand 1
     /*  86954 */     // No operand predicates
     /*  86954 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  86958 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86962 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  86966 */     // MIs[3] Operand 1
     /*  86966 */     // No operand predicates
     /*  86966 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  86968 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10527:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVI16GER2SWPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  86968 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  86971 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86975 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86980 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  86984 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  86989 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  86992 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86996 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87001 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  87005 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  87010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVI16GER2SWPP),
     /*  87013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  87015 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  87017 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  87020 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  87023 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  87026 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  87029 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  87032 */     GIR_RootConstrainSelectedInstOperands,
     /*  87033 */     // GIR_Coverage, 3595,
     /*  87033 */     GIR_EraseRootFromParent_Done,
     /*  87034 */   // Label 1356: @87034
     /*  87034 */   GIM_Try, /*On fail goto*//*Label 1357*/ GIMT_Encode4(87176), // Rule ID 3597 //
     /*  87039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  87042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf16ger2pp),
     /*  87047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  87050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  87053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  87056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  87059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87062 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87065 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  87072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  87076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87080 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  87084 */     // MIs[1] Operand 1
     /*  87084 */     // No operand predicates
     /*  87084 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  87088 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87092 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  87096 */     // MIs[2] Operand 1
     /*  87096 */     // No operand predicates
     /*  87096 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  87100 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87104 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  87108 */     // MIs[3] Operand 1
     /*  87108 */     // No operand predicates
     /*  87108 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  87110 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10513:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVF16GER2WPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  87110 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  87113 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87117 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87122 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  87126 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  87131 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  87134 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87138 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87143 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  87147 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  87152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF16GER2WPP),
     /*  87155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  87157 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  87159 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  87162 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  87165 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  87168 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  87171 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  87174 */     GIR_RootConstrainSelectedInstOperands,
     /*  87175 */     // GIR_Coverage, 3597,
     /*  87175 */     GIR_EraseRootFromParent_Done,
     /*  87176 */   // Label 1357: @87176
     /*  87176 */   GIM_Try, /*On fail goto*//*Label 1358*/ GIMT_Encode4(87318), // Rule ID 3598 //
     /*  87181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  87184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf16ger2pn),
     /*  87189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  87192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  87195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  87198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  87201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87204 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87207 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  87214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  87218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87222 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  87226 */     // MIs[1] Operand 1
     /*  87226 */     // No operand predicates
     /*  87226 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  87230 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87234 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  87238 */     // MIs[2] Operand 1
     /*  87238 */     // No operand predicates
     /*  87238 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  87242 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87246 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  87250 */     // MIs[3] Operand 1
     /*  87250 */     // No operand predicates
     /*  87250 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  87252 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10512:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVF16GER2WPN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  87252 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  87255 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87259 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87264 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  87268 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  87273 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  87276 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87280 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87285 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  87289 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  87294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF16GER2WPN),
     /*  87297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  87299 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  87301 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  87304 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  87307 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  87310 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  87313 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  87316 */     GIR_RootConstrainSelectedInstOperands,
     /*  87317 */     // GIR_Coverage, 3598,
     /*  87317 */     GIR_EraseRootFromParent_Done,
     /*  87318 */   // Label 1358: @87318
     /*  87318 */   GIM_Try, /*On fail goto*//*Label 1359*/ GIMT_Encode4(87460), // Rule ID 3599 //
     /*  87323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  87326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf16ger2np),
     /*  87331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  87334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  87337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  87340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  87343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87346 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87349 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  87356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  87360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87364 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  87368 */     // MIs[1] Operand 1
     /*  87368 */     // No operand predicates
     /*  87368 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  87372 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87376 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  87380 */     // MIs[2] Operand 1
     /*  87380 */     // No operand predicates
     /*  87380 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  87384 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87388 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  87392 */     // MIs[3] Operand 1
     /*  87392 */     // No operand predicates
     /*  87392 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  87394 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10511:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVF16GER2WNP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  87394 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  87397 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87401 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87406 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  87410 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  87415 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  87418 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87422 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87427 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  87431 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  87436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF16GER2WNP),
     /*  87439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  87441 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  87443 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  87446 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  87449 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  87452 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  87455 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  87458 */     GIR_RootConstrainSelectedInstOperands,
     /*  87459 */     // GIR_Coverage, 3599,
     /*  87459 */     GIR_EraseRootFromParent_Done,
     /*  87460 */   // Label 1359: @87460
     /*  87460 */   GIM_Try, /*On fail goto*//*Label 1360*/ GIMT_Encode4(87602), // Rule ID 3600 //
     /*  87465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  87468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf16ger2nn),
     /*  87473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  87476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  87479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  87482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  87485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87488 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87491 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  87498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  87502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87506 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  87510 */     // MIs[1] Operand 1
     /*  87510 */     // No operand predicates
     /*  87510 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  87514 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87518 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  87522 */     // MIs[2] Operand 1
     /*  87522 */     // No operand predicates
     /*  87522 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  87526 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87530 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  87534 */     // MIs[3] Operand 1
     /*  87534 */     // No operand predicates
     /*  87534 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  87536 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10510:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVF16GER2WNN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  87536 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  87539 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87543 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87548 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  87552 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  87557 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  87560 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87564 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87569 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  87573 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  87578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF16GER2WNN),
     /*  87581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  87583 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  87585 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  87588 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  87591 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  87594 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  87597 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  87600 */     GIR_RootConstrainSelectedInstOperands,
     /*  87601 */     // GIR_Coverage, 3600,
     /*  87601 */     GIR_EraseRootFromParent_Done,
     /*  87602 */   // Label 1360: @87602
     /*  87602 */   GIM_Try, /*On fail goto*//*Label 1361*/ GIMT_Encode4(87744), // Rule ID 3612 //
     /*  87607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  87610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvbf16ger2pp),
     /*  87615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  87618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  87621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  87624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  87627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87633 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  87640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  87644 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87648 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  87652 */     // MIs[1] Operand 1
     /*  87652 */     // No operand predicates
     /*  87652 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  87656 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87660 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  87664 */     // MIs[2] Operand 1
     /*  87664 */     // No operand predicates
     /*  87664 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  87668 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87672 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  87676 */     // MIs[3] Operand 1
     /*  87676 */     // No operand predicates
     /*  87676 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  87678 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10508:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVBF16GER2WPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  87678 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  87681 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87685 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87690 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  87694 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  87699 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  87702 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87706 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87711 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  87715 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  87720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVBF16GER2WPP),
     /*  87723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  87725 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  87727 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  87730 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  87733 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  87736 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  87739 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  87742 */     GIR_RootConstrainSelectedInstOperands,
     /*  87743 */     // GIR_Coverage, 3612,
     /*  87743 */     GIR_EraseRootFromParent_Done,
     /*  87744 */   // Label 1361: @87744
     /*  87744 */   GIM_Try, /*On fail goto*//*Label 1362*/ GIMT_Encode4(87886), // Rule ID 3613 //
     /*  87749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  87752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvbf16ger2pn),
     /*  87757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  87760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  87763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  87766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  87769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87772 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87775 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  87782 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  87786 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87790 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  87794 */     // MIs[1] Operand 1
     /*  87794 */     // No operand predicates
     /*  87794 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  87798 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87802 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  87806 */     // MIs[2] Operand 1
     /*  87806 */     // No operand predicates
     /*  87806 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  87810 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87814 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  87818 */     // MIs[3] Operand 1
     /*  87818 */     // No operand predicates
     /*  87818 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  87820 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10507:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVBF16GER2WPN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  87820 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  87823 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87827 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87832 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  87836 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  87841 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  87844 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87848 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87853 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  87857 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  87862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVBF16GER2WPN),
     /*  87865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  87867 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  87869 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  87872 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  87875 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  87878 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  87881 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  87884 */     GIR_RootConstrainSelectedInstOperands,
     /*  87885 */     // GIR_Coverage, 3613,
     /*  87885 */     GIR_EraseRootFromParent_Done,
     /*  87886 */   // Label 1362: @87886
     /*  87886 */   GIM_Try, /*On fail goto*//*Label 1363*/ GIMT_Encode4(88028), // Rule ID 3614 //
     /*  87891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  87894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvbf16ger2np),
     /*  87899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  87902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  87905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  87908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  87911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87914 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87917 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  87924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  87928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87932 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  87936 */     // MIs[1] Operand 1
     /*  87936 */     // No operand predicates
     /*  87936 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  87940 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87944 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  87948 */     // MIs[2] Operand 1
     /*  87948 */     // No operand predicates
     /*  87948 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  87952 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87956 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  87960 */     // MIs[3] Operand 1
     /*  87960 */     // No operand predicates
     /*  87960 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  87962 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10506:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVBF16GER2WNP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  87962 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  87965 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87969 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87974 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  87978 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  87983 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  87986 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87990 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87995 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  87999 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  88004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVBF16GER2WNP),
     /*  88007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  88009 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  88011 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  88014 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  88017 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  88020 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  88023 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  88026 */     GIR_RootConstrainSelectedInstOperands,
     /*  88027 */     // GIR_Coverage, 3614,
     /*  88027 */     GIR_EraseRootFromParent_Done,
     /*  88028 */   // Label 1363: @88028
     /*  88028 */   GIM_Try, /*On fail goto*//*Label 1364*/ GIMT_Encode4(88170), // Rule ID 3615 //
     /*  88033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  88036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvbf16ger2nn),
     /*  88041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  88044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  88047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  88050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  88053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88056 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88059 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  88066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  88070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88074 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  88078 */     // MIs[1] Operand 1
     /*  88078 */     // No operand predicates
     /*  88078 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  88082 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88086 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  88090 */     // MIs[2] Operand 1
     /*  88090 */     // No operand predicates
     /*  88090 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  88094 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88098 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  88102 */     // MIs[3] Operand 1
     /*  88102 */     // No operand predicates
     /*  88102 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  88104 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10505:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVBF16GER2WNN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  88104 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  88107 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88111 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88116 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  88120 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  88125 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  88128 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88132 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88137 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  88141 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  88146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVBF16GER2WNN),
     /*  88149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  88151 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  88153 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  88156 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  88159 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  88162 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  88165 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  88168 */     GIR_RootConstrainSelectedInstOperands,
     /*  88169 */     // GIR_Coverage, 3615,
     /*  88169 */     GIR_EraseRootFromParent_Done,
     /*  88170 */   // Label 1364: @88170
     /*  88170 */   GIM_Try, /*On fail goto*//*Label 1365*/ GIMT_Encode4(88312), // Rule ID 3617 //
     /*  88175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  88178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvi8ger4spp),
     /*  88183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  88186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  88189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  88192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  88195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88198 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88201 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  88208 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  88212 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88216 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  88220 */     // MIs[1] Operand 1
     /*  88220 */     // No operand predicates
     /*  88220 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  88224 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88228 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  88232 */     // MIs[2] Operand 1
     /*  88232 */     // No operand predicates
     /*  88232 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  88236 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88240 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  88244 */     // MIs[3] Operand 1
     /*  88244 */     // No operand predicates
     /*  88244 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  88246 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10532:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVI8GER4WSPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  88246 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  88249 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88253 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88258 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  88262 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  88267 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  88270 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88274 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88279 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  88283 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  88288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVI8GER4WSPP),
     /*  88291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  88293 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  88295 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  88298 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  88301 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  88304 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  88307 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  88310 */     GIR_RootConstrainSelectedInstOperands,
     /*  88311 */     // GIR_Coverage, 3617,
     /*  88311 */     GIR_EraseRootFromParent_Done,
     /*  88312 */   // Label 1365: @88312
     /*  88312 */   GIM_Try, /*On fail goto*//*Label 1366*/ GIMT_Encode4(88454), // Rule ID 3618 //
     /*  88317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  88320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvi16ger2pp),
     /*  88325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  88328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  88331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  88334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  88337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88340 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88343 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  88350 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  88354 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88358 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  88362 */     // MIs[1] Operand 1
     /*  88362 */     // No operand predicates
     /*  88362 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  88366 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88370 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  88374 */     // MIs[2] Operand 1
     /*  88374 */     // No operand predicates
     /*  88374 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  88378 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88382 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  88386 */     // MIs[3] Operand 1
     /*  88386 */     // No operand predicates
     /*  88386 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  88388 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10525:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVI16GER2WPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  88388 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  88391 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88395 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88400 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  88404 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  88409 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  88412 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88416 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88421 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  88425 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  88430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVI16GER2WPP),
     /*  88433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  88435 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  88437 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  88440 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  88443 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  88446 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  88449 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  88452 */     GIR_RootConstrainSelectedInstOperands,
     /*  88453 */     // GIR_Coverage, 3618,
     /*  88453 */     GIR_EraseRootFromParent_Done,
     /*  88454 */   // Label 1366: @88454
     /*  88454 */   GIM_Reject,
     /*  88455 */ // Label 1340: @88455
     /*  88455 */ GIM_Reject,
     /*  88456 */ // Label 20: @88456
     /*  88456 */ GIM_Try, /*On fail goto*//*Label 1367*/ GIMT_Encode4(88795),
     /*  88461 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/1,
     /*  88464 */   GIM_Try, /*On fail goto*//*Label 1368*/ GIMT_Encode4(88483), // Rule ID 106 //
     /*  88469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_eieio),
     /*  88474 */     // (intrinsic_void 10445:{ *:[iPTR] })  =>  (PseudoEIEIO)
     /*  88474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PseudoEIEIO),
     /*  88477 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  88481 */     GIR_RootConstrainSelectedInstOperands,
     /*  88482 */     // GIR_Coverage, 106,
     /*  88482 */     GIR_EraseRootFromParent_Done,
     /*  88483 */   // Label 1368: @88483
     /*  88483 */   GIM_Try, /*On fail goto*//*Label 1369*/ GIMT_Encode4(88508), // Rule ID 1195 //
     /*  88488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSYNC),
     /*  88491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_sync),
     /*  88496 */     // (intrinsic_void 10603:{ *:[iPTR] })  =>  (SYNC 0:{ *:[i32] })
     /*  88496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SYNC),
     /*  88499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88502 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  88506 */     GIR_RootConstrainSelectedInstOperands,
     /*  88507 */     // GIR_Coverage, 1195,
     /*  88507 */     GIR_EraseRootFromParent_Done,
     /*  88508 */   // Label 1369: @88508
     /*  88508 */   GIM_Try, /*On fail goto*//*Label 1370*/ GIMT_Encode4(88533), // Rule ID 1196 //
     /*  88513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSYNC),
     /*  88516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_iospace_sync),
     /*  88521 */     // (intrinsic_void 10480:{ *:[iPTR] })  =>  (SYNC 0:{ *:[i32] })
     /*  88521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SYNC),
     /*  88524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88527 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  88531 */     GIR_RootConstrainSelectedInstOperands,
     /*  88532 */     // GIR_Coverage, 1196,
     /*  88532 */     GIR_EraseRootFromParent_Done,
     /*  88533 */   // Label 1370: @88533
     /*  88533 */   GIM_Try, /*On fail goto*//*Label 1371*/ GIMT_Encode4(88558), // Rule ID 1197 //
     /*  88538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSYNC),
     /*  88541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_lwsync),
     /*  88546 */     // (intrinsic_void 10485:{ *:[iPTR] })  =>  (SYNC 1:{ *:[i32] })
     /*  88546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SYNC),
     /*  88549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  88552 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  88556 */     GIR_RootConstrainSelectedInstOperands,
     /*  88557 */     // GIR_Coverage, 1197,
     /*  88557 */     GIR_EraseRootFromParent_Done,
     /*  88558 */   // Label 1371: @88558
     /*  88558 */   GIM_Try, /*On fail goto*//*Label 1372*/ GIMT_Encode4(88583), // Rule ID 1198 //
     /*  88563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSYNC),
     /*  88566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_iospace_lwsync),
     /*  88571 */     // (intrinsic_void 10479:{ *:[iPTR] })  =>  (SYNC 1:{ *:[i32] })
     /*  88571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SYNC),
     /*  88574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  88577 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  88581 */     GIR_RootConstrainSelectedInstOperands,
     /*  88582 */     // GIR_Coverage, 1198,
     /*  88582 */     GIR_EraseRootFromParent_Done,
     /*  88583 */   // Label 1372: @88583
     /*  88583 */   GIM_Try, /*On fail goto*//*Label 1373*/ GIMT_Encode4(88605), // Rule ID 1199 //
     /*  88588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasOnlyMSYNC),
     /*  88591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_sync),
     /*  88596 */     // (intrinsic_void 10603:{ *:[iPTR] })  =>  (MSYNC)
     /*  88596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MSYNC),
     /*  88599 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  88603 */     GIR_RootConstrainSelectedInstOperands,
     /*  88604 */     // GIR_Coverage, 1199,
     /*  88604 */     GIR_EraseRootFromParent_Done,
     /*  88605 */   // Label 1373: @88605
     /*  88605 */   GIM_Try, /*On fail goto*//*Label 1374*/ GIMT_Encode4(88627), // Rule ID 1200 //
     /*  88610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasOnlyMSYNC),
     /*  88613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_iospace_sync),
     /*  88618 */     // (intrinsic_void 10480:{ *:[iPTR] })  =>  (MSYNC)
     /*  88618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MSYNC),
     /*  88621 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  88625 */     GIR_RootConstrainSelectedInstOperands,
     /*  88626 */     // GIR_Coverage, 1200,
     /*  88626 */     GIR_EraseRootFromParent_Done,
     /*  88627 */   // Label 1374: @88627
     /*  88627 */   GIM_Try, /*On fail goto*//*Label 1375*/ GIMT_Encode4(88649), // Rule ID 1201 //
     /*  88632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasOnlyMSYNC),
     /*  88635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_lwsync),
     /*  88640 */     // (intrinsic_void 10485:{ *:[iPTR] })  =>  (MSYNC)
     /*  88640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MSYNC),
     /*  88643 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  88647 */     GIR_RootConstrainSelectedInstOperands,
     /*  88648 */     // GIR_Coverage, 1201,
     /*  88648 */     GIR_EraseRootFromParent_Done,
     /*  88649 */   // Label 1375: @88649
     /*  88649 */   GIM_Try, /*On fail goto*//*Label 1376*/ GIMT_Encode4(88671), // Rule ID 1202 //
     /*  88654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasOnlyMSYNC),
     /*  88657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_iospace_lwsync),
     /*  88662 */     // (intrinsic_void 10479:{ *:[iPTR] })  =>  (MSYNC)
     /*  88662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MSYNC),
     /*  88665 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  88669 */     GIR_RootConstrainSelectedInstOperands,
     /*  88670 */     // GIR_Coverage, 1202,
     /*  88670 */     GIR_EraseRootFromParent_Done,
     /*  88671 */   // Label 1376: @88671
     /*  88671 */   GIM_Try, /*On fail goto*//*Label 1377*/ GIMT_Encode4(88690), // Rule ID 1203 //
     /*  88676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_eieio),
     /*  88681 */     // (intrinsic_void 10445:{ *:[iPTR] })  =>  (PseudoEIEIO)
     /*  88681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PseudoEIEIO),
     /*  88684 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  88688 */     GIR_RootConstrainSelectedInstOperands,
     /*  88689 */     // GIR_Coverage, 1203,
     /*  88689 */     GIR_EraseRootFromParent_Done,
     /*  88690 */   // Label 1377: @88690
     /*  88690 */   GIM_Try, /*On fail goto*//*Label 1378*/ GIMT_Encode4(88709), // Rule ID 1204 //
     /*  88695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_iospace_eieio),
     /*  88700 */     // (intrinsic_void 10478:{ *:[iPTR] })  =>  (PseudoEIEIO)
     /*  88700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PseudoEIEIO),
     /*  88703 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  88707 */     GIR_RootConstrainSelectedInstOperands,
     /*  88708 */     // GIR_Coverage, 1204,
     /*  88708 */     GIR_EraseRootFromParent_Done,
     /*  88709 */   // Label 1378: @88709
     /*  88709 */   GIM_Try, /*On fail goto*//*Label 1379*/ GIMT_Encode4(88731), // Rule ID 1230 //
     /*  88714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_fence),
     /*  88719 */     // (intrinsic_void 10456:{ *:[iPTR] })  =>  (FENCE)
     /*  88719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FENCE),
     /*  88722 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::RM*/0,
     /*  88725 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  88729 */     GIR_RootConstrainSelectedInstOperands,
     /*  88730 */     // GIR_Coverage, 1230,
     /*  88730 */     GIR_EraseRootFromParent_Done,
     /*  88731 */   // Label 1379: @88731
     /*  88731 */   GIM_Try, /*On fail goto*//*Label 1380*/ GIMT_Encode4(88753), // Rule ID 1284 //
     /*  88736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsAIX),
     /*  88739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_altivec_dssall),
     /*  88744 */     // (intrinsic_void 10097:{ *:[iPTR] })  =>  (NOP)
     /*  88744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::NOP),
     /*  88747 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  88751 */     GIR_RootConstrainSelectedInstOperands,
     /*  88752 */     // GIR_Coverage, 1284,
     /*  88752 */     GIR_EraseRootFromParent_Done,
     /*  88753 */   // Label 1380: @88753
     /*  88753 */   GIM_Try, /*On fail goto*//*Label 1381*/ GIMT_Encode4(88775), // Rule ID 1285 //
     /*  88758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotAIX),
     /*  88761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_altivec_dssall),
     /*  88766 */     // (intrinsic_void 10097:{ *:[iPTR] })  =>  (DSSALL)
     /*  88766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DSSALL),
     /*  88769 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  88773 */     GIR_RootConstrainSelectedInstOperands,
     /*  88774 */     // GIR_Coverage, 1285,
     /*  88774 */     GIR_EraseRootFromParent_Done,
     /*  88775 */   // Label 1381: @88775
     /*  88775 */   GIM_Try, /*On fail goto*//*Label 1382*/ GIMT_Encode4(88794), // Rule ID 4820 //
     /*  88780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_isync),
     /*  88785 */     // (intrinsic_void 10481:{ *:[iPTR] })  =>  (ISYNC)
     /*  88785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::ISYNC),
     /*  88788 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  88792 */     GIR_RootConstrainSelectedInstOperands,
     /*  88793 */     // GIR_Coverage, 4820,
     /*  88793 */     GIR_EraseRootFromParent_Done,
     /*  88794 */   // Label 1382: @88794
     /*  88794 */   GIM_Reject,
     /*  88795 */ // Label 1367: @88795
     /*  88795 */ GIM_Try, /*On fail goto*//*Label 1383*/ GIMT_Encode4(89678),
     /*  88800 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/2,
     /*  88803 */   GIM_Try, /*On fail goto*//*Label 1384*/ GIMT_Encode4(88842), // Rule ID 269 //
     /*  88808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  88811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_altivec_dss),
     /*  88816 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  88819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  88823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88827 */     // MIs[1] Operand 1
     /*  88827 */     // No operand predicates
     /*  88827 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88829 */     // (intrinsic_void 10096:{ *:[iPTR] }, (imm:{ *:[i32] }):$STRM)  =>  (DSS (imm:{ *:[i32] }):$STRM)
     /*  88829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DSS),
     /*  88832 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // STRM
     /*  88835 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  88840 */     GIR_RootConstrainSelectedInstOperands,
     /*  88841 */     // GIR_Coverage, 269,
     /*  88841 */     GIR_EraseRootFromParent_Done,
     /*  88842 */   // Label 1384: @88842
     /*  88842 */   GIM_Try, /*On fail goto*//*Label 1385*/ GIMT_Encode4(88868), // Rule ID 193 //
     /*  88847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  88850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_mtfsb0),
     /*  88855 */     // MIs[0] FM
     /*  88855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  88858 */     // (intrinsic_void 10565:{ *:[iPTR] }, (timm:{ *:[i32] }):$FM)  =>  (MTFSB0 (timm:{ *:[i32] }):$FM)
     /*  88858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTFSB0),
     /*  88861 */     GIR_RootToRootCopy, /*OpIdx*/1, // FM
     /*  88863 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::RM*/0,
     /*  88866 */     GIR_RootConstrainSelectedInstOperands,
     /*  88867 */     // GIR_Coverage, 193,
     /*  88867 */     GIR_EraseRootFromParent_Done,
     /*  88868 */   // Label 1385: @88868
     /*  88868 */   GIM_Try, /*On fail goto*//*Label 1386*/ GIMT_Encode4(88894), // Rule ID 194 //
     /*  88873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  88876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_mtfsb1),
     /*  88881 */     // MIs[0] FM
     /*  88881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  88884 */     // (intrinsic_void 10566:{ *:[iPTR] }, (timm:{ *:[i32] }):$FM)  =>  (MTFSB1 (timm:{ *:[i32] }):$FM)
     /*  88884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTFSB1),
     /*  88887 */     GIR_RootToRootCopy, /*OpIdx*/1, // FM
     /*  88889 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::RM*/0,
     /*  88892 */     GIR_RootConstrainSelectedInstOperands,
     /*  88893 */     // GIR_Coverage, 194,
     /*  88893 */     GIR_EraseRootFromParent_Done,
     /*  88894 */   // Label 1386: @88894
     /*  88894 */   GIM_Try, /*On fail goto*//*Label 1387*/ GIMT_Encode4(88921), // Rule ID 278 //
     /*  88899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  88902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_mfvscr),
     /*  88907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  88910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  88914 */     // (intrinsic_w_chain:{ *:[v8i16] } 10109:{ *:[iPTR] })  =>  (MFVSCR:{ *:[v8i16] })
     /*  88914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFVSCR),
     /*  88917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  88919 */     GIR_RootConstrainSelectedInstOperands,
     /*  88920 */     // GIR_Coverage, 278,
     /*  88920 */     GIR_EraseRootFromParent_Done,
     /*  88921 */   // Label 1387: @88921
     /*  88921 */   GIM_Try, /*On fail goto*//*Label 1388*/ GIMT_Encode4(88945), // Rule ID 1231 //
     /*  88926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_readflm),
     /*  88931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  88934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  88938 */     // (intrinsic_w_chain:{ *:[f64] } 10580:{ *:[iPTR] })  =>  (MFFS:{ *:[f64] })
     /*  88938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFFS),
     /*  88941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  88943 */     GIR_RootConstrainSelectedInstOperands,
     /*  88944 */     // GIR_Coverage, 1231,
     /*  88944 */     GIR_EraseRootFromParent_Done,
     /*  88945 */   // Label 1388: @88945
     /*  88945 */   GIM_Try, /*On fail goto*//*Label 1389*/ GIMT_Encode4(88973), // Rule ID 1232 //
     /*  88950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mffsl),
     /*  88955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  88958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  88962 */     // (intrinsic_w_chain:{ *:[f64] } 10492:{ *:[iPTR] })  =>  (MFFSL:{ *:[f64] })
     /*  88962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFFSL),
     /*  88965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  88967 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  88971 */     GIR_RootConstrainSelectedInstOperands,
     /*  88972 */     // GIR_Coverage, 1232,
     /*  88972 */     GIR_EraseRootFromParent_Done,
     /*  88973 */   // Label 1389: @88973
     /*  88973 */   GIM_Try, /*On fail goto*//*Label 1390*/ GIMT_Encode4(89037), // Rule ID 1568 //
     /*  88978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_0),
     /*  88981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_darn32),
     /*  88986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  88989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  88993 */     // (intrinsic_w_chain:{ *:[i32] } 10422:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[i32] } (DARN:{ *:[i64] } 0:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  88993 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  88996 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::DARN),
     /*  89000 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89005 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  89008 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  89012 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  89014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  89019 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /*  89026 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  89031 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /*  89036 */     // GIR_Coverage, 1568,
     /*  89036 */     GIR_EraseRootFromParent_Done,
     /*  89037 */   // Label 1390: @89037
     /*  89037 */   GIM_Try, /*On fail goto*//*Label 1391*/ GIMT_Encode4(89071), // Rule ID 1569 //
     /*  89042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_0),
     /*  89045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_darn),
     /*  89050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  89053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  89057 */     // (intrinsic_w_chain:{ *:[i64] } 10421:{ *:[iPTR] })  =>  (DARN:{ *:[i64] } 1:{ *:[i32] })
     /*  89057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DARN),
     /*  89060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  89062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  89065 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  89069 */     GIR_RootConstrainSelectedInstOperands,
     /*  89070 */     // GIR_Coverage, 1569,
     /*  89070 */     GIR_EraseRootFromParent_Done,
     /*  89071 */   // Label 1391: @89071
     /*  89071 */   GIM_Try, /*On fail goto*//*Label 1392*/ GIMT_Encode4(89105), // Rule ID 1570 //
     /*  89076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_0),
     /*  89079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_darnraw),
     /*  89084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  89087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  89091 */     // (intrinsic_w_chain:{ *:[i64] } 10423:{ *:[iPTR] })  =>  (DARN:{ *:[i64] } 2:{ *:[i32] })
     /*  89091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DARN),
     /*  89094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  89096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*  89099 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  89103 */     GIR_RootConstrainSelectedInstOperands,
     /*  89104 */     // GIR_Coverage, 1570,
     /*  89104 */     GIR_EraseRootFromParent_Done,
     /*  89105 */   // Label 1392: @89105
     /*  89105 */   GIM_Try, /*On fail goto*//*Label 1393*/ GIMT_Encode4(89136), // Rule ID 2884 //
     /*  89110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasHTM),
     /*  89113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_tcheck),
     /*  89118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  89121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  89125 */     // (intrinsic_w_chain:{ *:[i32] } 10610:{ *:[iPTR] })  =>  (TCHECK_RET:{ *:[i32] })
     /*  89125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::TCHECK_RET),
     /*  89128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /*  89130 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  89134 */     GIR_RootConstrainSelectedInstOperands,
     /*  89135 */     // GIR_Coverage, 2884,
     /*  89135 */     GIR_EraseRootFromParent_Done,
     /*  89136 */   // Label 1393: @89136
     /*  89136 */   GIM_Try, /*On fail goto*//*Label 1394*/ GIMT_Encode4(89177), // Rule ID 2888 //
     /*  89141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasHTM),
     /*  89144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_get_texasr),
     /*  89149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  89152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  89156 */     // (intrinsic_w_chain:{ *:[i64] } 10472:{ *:[iPTR] })  =>  (MFSPR8:{ *:[i64] } 130:{ *:[i32] })
     /*  89156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFSPR8),
     /*  89159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  89161 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(130),
     /*  89171 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  89175 */     GIR_RootConstrainSelectedInstOperands,
     /*  89176 */     // GIR_Coverage, 2888,
     /*  89176 */     GIR_EraseRootFromParent_Done,
     /*  89177 */   // Label 1394: @89177
     /*  89177 */   GIM_Try, /*On fail goto*//*Label 1395*/ GIMT_Encode4(89218), // Rule ID 2889 //
     /*  89182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasHTM),
     /*  89185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_get_texasru),
     /*  89190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  89193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  89197 */     // (intrinsic_w_chain:{ *:[i64] } 10473:{ *:[iPTR] })  =>  (MFSPR8:{ *:[i64] } 131:{ *:[i32] })
     /*  89197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFSPR8),
     /*  89200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  89202 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(131),
     /*  89212 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  89216 */     GIR_RootConstrainSelectedInstOperands,
     /*  89217 */     // GIR_Coverage, 2889,
     /*  89217 */     GIR_EraseRootFromParent_Done,
     /*  89218 */   // Label 1395: @89218
     /*  89218 */   GIM_Try, /*On fail goto*//*Label 1396*/ GIMT_Encode4(89259), // Rule ID 2890 //
     /*  89223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasHTM),
     /*  89226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_get_tfhar),
     /*  89231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  89234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  89238 */     // (intrinsic_w_chain:{ *:[i64] } 10474:{ *:[iPTR] })  =>  (MFSPR8:{ *:[i64] } 128:{ *:[i32] })
     /*  89238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFSPR8),
     /*  89241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  89243 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(128),
     /*  89253 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  89257 */     GIR_RootConstrainSelectedInstOperands,
     /*  89258 */     // GIR_Coverage, 2890,
     /*  89258 */     GIR_EraseRootFromParent_Done,
     /*  89259 */   // Label 1396: @89259
     /*  89259 */   GIM_Try, /*On fail goto*//*Label 1397*/ GIMT_Encode4(89300), // Rule ID 2891 //
     /*  89264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasHTM),
     /*  89267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_get_tfiar),
     /*  89272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  89275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  89279 */     // (intrinsic_w_chain:{ *:[i64] } 10475:{ *:[iPTR] })  =>  (MFSPR8:{ *:[i64] } 129:{ *:[i32] })
     /*  89279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFSPR8),
     /*  89282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  89284 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(129),
     /*  89294 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  89298 */     GIR_RootConstrainSelectedInstOperands,
     /*  89299 */     // GIR_Coverage, 2891,
     /*  89299 */     GIR_EraseRootFromParent_Done,
     /*  89300 */   // Label 1397: @89300
     /*  89300 */   GIM_Try, /*On fail goto*//*Label 1398*/ GIMT_Encode4(89331), // Rule ID 4864 //
     /*  89305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_mtmsr),
     /*  89310 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  89313 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  89317 */     // (intrinsic_void 10569:{ *:[iPTR] }, gprc:{ *:[i32] }:$RS)  =>  (MTMSR ?:{ *:[i32] }:$RS, 0:{ *:[i32] })
     /*  89317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTMSR),
     /*  89320 */     GIR_RootToRootCopy, /*OpIdx*/1, // RS
     /*  89322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89325 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  89329 */     GIR_RootConstrainSelectedInstOperands,
     /*  89330 */     // GIR_Coverage, 4864,
     /*  89330 */     GIR_EraseRootFromParent_Done,
     /*  89331 */   // Label 1398: @89331
     /*  89331 */   GIM_Try, /*On fail goto*//*Label 1399*/ GIMT_Encode4(89358), // Rule ID 189 //
     /*  89336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::set_loop_iterations),
     /*  89341 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  89344 */     // (intrinsic_void 322:{ *:[iPTR] }, i32:{ *:[i32] }:$RST)  =>  (MTCTRloop:{ *:[i32] } i32:{ *:[i32] }:$RST)
     /*  89344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTCTRloop),
     /*  89347 */     GIR_RootToRootCopy, /*OpIdx*/1, // RST
     /*  89349 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CTR*/0,
     /*  89352 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  89356 */     GIR_RootConstrainSelectedInstOperands,
     /*  89357 */     // GIR_Coverage, 189,
     /*  89357 */     GIR_EraseRootFromParent_Done,
     /*  89358 */   // Label 1399: @89358
     /*  89358 */   GIM_Try, /*On fail goto*//*Label 1400*/ GIMT_Encode4(89381), // Rule ID 279 //
     /*  89363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  89366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_altivec_mtvscr),
     /*  89371 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  89374 */     // (intrinsic_void 10110:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VB)  =>  (MTVSCR v4i32:{ *:[v4i32] }:$VB)
     /*  89374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTVSCR),
     /*  89377 */     GIR_RootToRootCopy, /*OpIdx*/1, // VB
     /*  89379 */     GIR_RootConstrainSelectedInstOperands,
     /*  89380 */     // GIR_Coverage, 279,
     /*  89380 */     GIR_EraseRootFromParent_Done,
     /*  89381 */   // Label 1400: @89381
     /*  89381 */   GIM_Try, /*On fail goto*//*Label 1401*/ GIMT_Encode4(89408), // Rule ID 633 //
     /*  89386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::set_loop_iterations),
     /*  89391 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  89394 */     // (intrinsic_void 322:{ *:[iPTR] }, i64:{ *:[i64] }:$RST)  =>  (MTCTR8loop:{ *:[i64] } i64:{ *:[i64] }:$RST)
     /*  89394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTCTR8loop),
     /*  89397 */     GIR_RootToRootCopy, /*OpIdx*/1, // RST
     /*  89399 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CTR8*/0,
     /*  89402 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  89406 */     GIR_RootConstrainSelectedInstOperands,
     /*  89407 */     // GIR_Coverage, 633,
     /*  89407 */     GIR_EraseRootFromParent_Done,
     /*  89408 */   // Label 1401: @89408
     /*  89408 */   GIM_Try, /*On fail goto*//*Label 1402*/ GIMT_Encode4(89445), // Rule ID 2892 //
     /*  89413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasHTM),
     /*  89416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_set_texasr),
     /*  89421 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  89424 */     // (intrinsic_void 10586:{ *:[iPTR] }, i64:{ *:[i64] }:$V)  =>  (MTSPR8 130:{ *:[i32] }, ?:{ *:[i64] }:$V)
     /*  89424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTSPR8),
     /*  89427 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(130),
     /*  89437 */     GIR_RootToRootCopy, /*OpIdx*/1, // V
     /*  89439 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  89443 */     GIR_RootConstrainSelectedInstOperands,
     /*  89444 */     // GIR_Coverage, 2892,
     /*  89444 */     GIR_EraseRootFromParent_Done,
     /*  89445 */   // Label 1402: @89445
     /*  89445 */   GIM_Try, /*On fail goto*//*Label 1403*/ GIMT_Encode4(89482), // Rule ID 2893 //
     /*  89450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasHTM),
     /*  89453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_set_texasru),
     /*  89458 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  89461 */     // (intrinsic_void 10587:{ *:[iPTR] }, i64:{ *:[i64] }:$V)  =>  (MTSPR8 131:{ *:[i32] }, ?:{ *:[i64] }:$V)
     /*  89461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTSPR8),
     /*  89464 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(131),
     /*  89474 */     GIR_RootToRootCopy, /*OpIdx*/1, // V
     /*  89476 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  89480 */     GIR_RootConstrainSelectedInstOperands,
     /*  89481 */     // GIR_Coverage, 2893,
     /*  89481 */     GIR_EraseRootFromParent_Done,
     /*  89482 */   // Label 1403: @89482
     /*  89482 */   GIM_Try, /*On fail goto*//*Label 1404*/ GIMT_Encode4(89519), // Rule ID 2894 //
     /*  89487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasHTM),
     /*  89490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_set_tfhar),
     /*  89495 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  89498 */     // (intrinsic_void 10588:{ *:[iPTR] }, i64:{ *:[i64] }:$V)  =>  (MTSPR8 128:{ *:[i32] }, ?:{ *:[i64] }:$V)
     /*  89498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTSPR8),
     /*  89501 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(128),
     /*  89511 */     GIR_RootToRootCopy, /*OpIdx*/1, // V
     /*  89513 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  89517 */     GIR_RootConstrainSelectedInstOperands,
     /*  89518 */     // GIR_Coverage, 2894,
     /*  89518 */     GIR_EraseRootFromParent_Done,
     /*  89519 */   // Label 1404: @89519
     /*  89519 */   GIM_Try, /*On fail goto*//*Label 1405*/ GIMT_Encode4(89556), // Rule ID 2895 //
     /*  89524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasHTM),
     /*  89527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_set_tfiar),
     /*  89532 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  89535 */     // (intrinsic_void 10589:{ *:[iPTR] }, i64:{ *:[i64] }:$V)  =>  (MTSPR8 129:{ *:[i32] }, ?:{ *:[i64] }:$V)
     /*  89535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTSPR8),
     /*  89538 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(129),
     /*  89548 */     GIR_RootToRootCopy, /*OpIdx*/1, // V
     /*  89550 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  89554 */     GIR_RootConstrainSelectedInstOperands,
     /*  89555 */     // GIR_Coverage, 2895,
     /*  89555 */     GIR_EraseRootFromParent_Done,
     /*  89556 */   // Label 1405: @89556
     /*  89556 */   GIM_Try, /*On fail goto*//*Label 1406*/ GIMT_Encode4(89584), // Rule ID 2886 //
     /*  89561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasHTM),
     /*  89564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_trechkpt),
     /*  89569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  89572 */     // (intrinsic_w_chain:{ *:[i32] } 10617:{ *:[iPTR] })  =>  (TRECHKPT:{ *:[i32] })
     /*  89572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::TRECHKPT),
     /*  89575 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CR0*/0,
     /*  89578 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  89582 */     GIR_RootConstrainSelectedInstOperands,
     /*  89583 */     // GIR_Coverage, 2886,
     /*  89583 */     GIR_EraseRootFromParent_Done,
     /*  89584 */   // Label 1406: @89584
     /*  89584 */   GIM_Try, /*On fail goto*//*Label 1407*/ GIMT_Encode4(89615), // Rule ID 2896 //
     /*  89589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasHTM),
     /*  89592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_tendall),
     /*  89597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  89600 */     // (intrinsic_w_chain:{ *:[i32] } 10613:{ *:[iPTR] })  =>  (TEND:{ *:[i32] } 1:{ *:[i32] })
     /*  89600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::TEND),
     /*  89603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  89606 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CR0*/0,
     /*  89609 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  89613 */     GIR_RootConstrainSelectedInstOperands,
     /*  89614 */     // GIR_Coverage, 2896,
     /*  89614 */     GIR_EraseRootFromParent_Done,
     /*  89615 */   // Label 1407: @89615
     /*  89615 */   GIM_Try, /*On fail goto*//*Label 1408*/ GIMT_Encode4(89646), // Rule ID 2897 //
     /*  89620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasHTM),
     /*  89623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_tresume),
     /*  89628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  89631 */     // (intrinsic_w_chain:{ *:[i32] } 10619:{ *:[iPTR] })  =>  (TSR:{ *:[i32] } 1:{ *:[i32] })
     /*  89631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::TSR),
     /*  89634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  89637 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CR0*/0,
     /*  89640 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  89644 */     GIR_RootConstrainSelectedInstOperands,
     /*  89645 */     // GIR_Coverage, 2897,
     /*  89645 */     GIR_EraseRootFromParent_Done,
     /*  89646 */   // Label 1408: @89646
     /*  89646 */   GIM_Try, /*On fail goto*//*Label 1409*/ GIMT_Encode4(89677), // Rule ID 2898 //
     /*  89651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasHTM),
     /*  89654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_tsuspend),
     /*  89659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  89662 */     // (intrinsic_w_chain:{ *:[i32] } 10622:{ *:[iPTR] })  =>  (TSR:{ *:[i32] } 0:{ *:[i32] })
     /*  89662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::TSR),
     /*  89665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89668 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CR0*/0,
     /*  89671 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  89675 */     GIR_RootConstrainSelectedInstOperands,
     /*  89676 */     // GIR_Coverage, 2898,
     /*  89676 */     GIR_EraseRootFromParent_Done,
     /*  89677 */   // Label 1409: @89677
     /*  89677 */   GIM_Reject,
     /*  89678 */ // Label 1383: @89678
     /*  89678 */ GIM_Try, /*On fail goto*//*Label 1410*/ GIMT_Encode4(90204),
     /*  89683 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  89686 */   GIM_Try, /*On fail goto*//*Label 1411*/ GIMT_Encode4(89717), // Rule ID 1172 //
     /*  89691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  89694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_mtfsfi),
     /*  89699 */     // MIs[0] BF
     /*  89699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  89702 */     // MIs[0] U
     /*  89702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  89705 */     // (intrinsic_void 10568:{ *:[iPTR] }, (timm:{ *:[i32] }):$BF, (timm:{ *:[i32] }):$U)  =>  (MTFSFIb (timm:{ *:[i32] }):$BF, (timm:{ *:[i32] }):$U)
     /*  89705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTFSFIb),
     /*  89708 */     GIR_RootToRootCopy, /*OpIdx*/1, // BF
     /*  89710 */     GIR_RootToRootCopy, /*OpIdx*/2, // U
     /*  89712 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::RM*/0,
     /*  89715 */     GIR_RootConstrainSelectedInstOperands,
     /*  89716 */     // GIR_Coverage, 1172,
     /*  89716 */     GIR_EraseRootFromParent_Done,
     /*  89717 */   // Label 1411: @89717
     /*  89717 */   GIM_Try, /*On fail goto*//*Label 1412*/ GIMT_Encode4(89765), // Rule ID 12 //
     /*  89722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_setrnd),
     /*  89727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  89730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  89733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  89737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  89741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89745 */     // MIs[1] Operand 1
     /*  89745 */     // No operand predicates
     /*  89745 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89747 */     // (intrinsic_w_chain:{ *:[f64] } 10592:{ *:[iPTR] }, (imm:{ *:[i32] }):$RND)  =>  (SETRNDi:{ *:[f64] } (imm:{ *:[i32] }):$RND)
     /*  89747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETRNDi),
     /*  89750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /*  89752 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // RND
     /*  89755 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::RM*/0,
     /*  89758 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  89763 */     GIR_RootConstrainSelectedInstOperands,
     /*  89764 */     // GIR_Coverage, 12,
     /*  89764 */     GIR_EraseRootFromParent_Done,
     /*  89765 */   // Label 1412: @89765
     /*  89765 */   GIM_Try, /*On fail goto*//*Label 1413*/ GIMT_Encode4(89813), // Rule ID 190 //
     /*  89770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::loop_decrement),
     /*  89775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
     /*  89778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  89781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  89785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  89789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89793 */     // MIs[1] Operand 1
     /*  89793 */     // No operand predicates
     /*  89793 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89795 */     // (intrinsic_w_chain:{ *:[i1] } 221:{ *:[iPTR] }, (imm:{ *:[i32] }):$stride)  =>  (DecreaseCTRloop:{ *:[i1] }:{ *:[i32] } (imm:{ *:[i32] }):$stride)
     /*  89795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DecreaseCTRloop),
     /*  89798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rT]
     /*  89800 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // stride
     /*  89803 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CTR*/0,
     /*  89806 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  89811 */     GIR_RootConstrainSelectedInstOperands,
     /*  89812 */     // GIR_Coverage, 190,
     /*  89812 */     GIR_EraseRootFromParent_Done,
     /*  89813 */   // Label 1413: @89813
     /*  89813 */   GIM_Try, /*On fail goto*//*Label 1414*/ GIMT_Encode4(89861), // Rule ID 634 //
     /*  89818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::loop_decrement),
     /*  89823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
     /*  89826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  89829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  89833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  89837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89841 */     // MIs[1] Operand 1
     /*  89841 */     // No operand predicates
     /*  89841 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89843 */     // (intrinsic_w_chain:{ *:[i1] } 221:{ *:[iPTR] }, (imm:{ *:[i64] }):$stride)  =>  (DecreaseCTR8loop:{ *:[i1] }:{ *:[i64] } (imm:{ *:[i64] }):$stride)
     /*  89843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DecreaseCTR8loop),
     /*  89846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rT]
     /*  89848 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // stride
     /*  89851 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CTR8*/0,
     /*  89854 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  89859 */     GIR_RootConstrainSelectedInstOperands,
     /*  89860 */     // GIR_Coverage, 634,
     /*  89860 */     GIR_EraseRootFromParent_Done,
     /*  89861 */   // Label 1414: @89861
     /*  89861 */   GIM_Try, /*On fail goto*//*Label 1415*/ GIMT_Encode4(89894), // Rule ID 1173 //
     /*  89866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fixed_addr_ld),
     /*  89871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  89874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  89878 */     // MIs[0] imm
     /*  89878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  89881 */     // (intrinsic_w_chain:{ *:[i32] } 10457:{ *:[iPTR] }, (timm:{ *:[i32] }):$imm)  =>  (PPCLdFixedAddr:{ *:[i32] } (timm:{ *:[i32] }):$imm)
     /*  89881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PPCLdFixedAddr),
     /*  89884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rT]
     /*  89886 */     GIR_RootToRootCopy, /*OpIdx*/2, // imm
     /*  89888 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  89892 */     GIR_RootConstrainSelectedInstOperands,
     /*  89893 */     // GIR_Coverage, 1173,
     /*  89893 */     GIR_EraseRootFromParent_Done,
     /*  89894 */   // Label 1415: @89894
     /*  89894 */   GIM_Try, /*On fail goto*//*Label 1416*/ GIMT_Encode4(89927), // Rule ID 1573 //
     /*  89899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mfspr),
     /*  89904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  89907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  89911 */     // MIs[0] SPR
     /*  89911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  89914 */     // (intrinsic_w_chain:{ *:[i64] } 10494:{ *:[iPTR] }, (timm:{ *:[i32] }):$SPR)  =>  (MFSPR8:{ *:[i64] } ?:{ *:[i32] }:$SPR)
     /*  89914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFSPR8),
     /*  89917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  89919 */     GIR_RootToRootCopy, /*OpIdx*/2, // SPR
     /*  89921 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  89925 */     GIR_RootConstrainSelectedInstOperands,
     /*  89926 */     // GIR_Coverage, 1573,
     /*  89926 */     GIR_EraseRootFromParent_Done,
     /*  89927 */   // Label 1416: @89927
     /*  89927 */   GIM_Try, /*On fail goto*//*Label 1417*/ GIMT_Encode4(89960), // Rule ID 4862 //
     /*  89932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mfspr),
     /*  89937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  89940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  89944 */     // MIs[0] SPR
     /*  89944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  89947 */     // (intrinsic_w_chain:{ *:[i32] } 10494:{ *:[iPTR] }, (timm:{ *:[i32] }):$SPR)  =>  (MFSPR:{ *:[i32] } ?:{ *:[i32] }:$SPR)
     /*  89947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFSPR),
     /*  89950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  89952 */     GIR_RootToRootCopy, /*OpIdx*/2, // SPR
     /*  89954 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  89958 */     GIR_RootConstrainSelectedInstOperands,
     /*  89959 */     // GIR_Coverage, 4862,
     /*  89959 */     GIR_EraseRootFromParent_Done,
     /*  89960 */   // Label 1417: @89960
     /*  89960 */   GIM_Try, /*On fail goto*//*Label 1418*/ GIMT_Encode4(89993), // Rule ID 1574 //
     /*  89965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_mtspr),
     /*  89970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  89973 */     // MIs[0] SPR
     /*  89973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  89976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  89980 */     // (intrinsic_void 10570:{ *:[iPTR] }, (timm:{ *:[i32] }):$SPR, g8rc:{ *:[i64] }:$RT)  =>  (MTSPR8 ?:{ *:[i32] }:$SPR, ?:{ *:[i64] }:$RT)
     /*  89980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTSPR8),
     /*  89983 */     GIR_RootToRootCopy, /*OpIdx*/1, // SPR
     /*  89985 */     GIR_RootToRootCopy, /*OpIdx*/2, // RT
     /*  89987 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  89991 */     GIR_RootConstrainSelectedInstOperands,
     /*  89992 */     // GIR_Coverage, 1574,
     /*  89992 */     GIR_EraseRootFromParent_Done,
     /*  89993 */   // Label 1418: @89993
     /*  89993 */   GIM_Try, /*On fail goto*//*Label 1419*/ GIMT_Encode4(90026), // Rule ID 4863 //
     /*  89998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_mtspr),
     /*  90003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  90006 */     // MIs[0] SPR
     /*  90006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  90009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  90013 */     // (intrinsic_void 10570:{ *:[iPTR] }, (timm:{ *:[i32] }):$SPR, gprc:{ *:[i32] }:$RT)  =>  (MTSPR ?:{ *:[i32] }:$SPR, ?:{ *:[i32] }:$RT)
     /*  90013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTSPR),
     /*  90016 */     GIR_RootToRootCopy, /*OpIdx*/1, // SPR
     /*  90018 */     GIR_RootToRootCopy, /*OpIdx*/2, // RT
     /*  90020 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  90024 */     GIR_RootConstrainSelectedInstOperands,
     /*  90025 */     // GIR_Coverage, 4863,
     /*  90025 */     GIR_EraseRootFromParent_Done,
     /*  90026 */   // Label 1419: @90026
     /*  90026 */   GIM_Try, /*On fail goto*//*Label 1420*/ GIMT_Encode4(90057), // Rule ID 195 //
     /*  90031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  90034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_mtfsf),
     /*  90039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  90042 */     // MIs[0] FM
     /*  90042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  90045 */     // (intrinsic_void 10567:{ *:[iPTR] }, (timm:{ *:[i32] }):$FM, f64:{ *:[f64] }:$RT)  =>  (MTFSFb (timm:{ *:[i32] }):$FM, f64:{ *:[f64] }:$RT)
     /*  90045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTFSFb),
     /*  90048 */     GIR_RootToRootCopy, /*OpIdx*/1, // FM
     /*  90050 */     GIR_RootToRootCopy, /*OpIdx*/2, // RT
     /*  90052 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::RM*/0,
     /*  90055 */     GIR_RootConstrainSelectedInstOperands,
     /*  90056 */     // GIR_Coverage, 195,
     /*  90056 */     GIR_EraseRootFromParent_Done,
     /*  90057 */   // Label 1420: @90057
     /*  90057 */   GIM_Try, /*On fail goto*//*Label 1421*/ GIMT_Encode4(90097), // Rule ID 13 //
     /*  90062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_setrnd),
     /*  90067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  90070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  90073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  90077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  90081 */     // (intrinsic_w_chain:{ *:[f64] } 10592:{ *:[iPTR] }, gprc:{ *:[i32] }:$in)  =>  (SETRND:{ *:[f64] } gprc:{ *:[i32] }:$in)
     /*  90081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETRND),
     /*  90084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /*  90086 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  90088 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::RM*/0,
     /*  90091 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  90095 */     GIR_RootConstrainSelectedInstOperands,
     /*  90096 */     // GIR_Coverage, 13,
     /*  90096 */     GIR_EraseRootFromParent_Done,
     /*  90097 */   // Label 1421: @90097
     /*  90097 */   GIM_Try, /*On fail goto*//*Label 1422*/ GIMT_Encode4(90137), // Rule ID 14 //
     /*  90102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_setflm),
     /*  90107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  90110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  90113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  90117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  90121 */     // (intrinsic_w_chain:{ *:[f64] } 10591:{ *:[iPTR] }, f8rc:{ *:[f64] }:$FLM)  =>  (SETFLM:{ *:[f64] } f8rc:{ *:[f64] }:$FLM)
     /*  90121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETFLM),
     /*  90124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /*  90126 */     GIR_RootToRootCopy, /*OpIdx*/2, // FLM
     /*  90128 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::RM*/0,
     /*  90131 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  90135 */     GIR_RootConstrainSelectedInstOperands,
     /*  90136 */     // GIR_Coverage, 14,
     /*  90136 */     GIR_EraseRootFromParent_Done,
     /*  90137 */   // Label 1422: @90137
     /*  90137 */   GIM_Try, /*On fail goto*//*Label 1423*/ GIMT_Encode4(90170), // Rule ID 2879 //
     /*  90142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasHTM),
     /*  90145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_tabort),
     /*  90150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  90153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  90156 */     // (intrinsic_w_chain:{ *:[i32] } 10604:{ *:[iPTR] }, i32:{ *:[i32] }:$R)  =>  (TABORT:{ *:[i32] } ?:{ *:[i32] }:$R)
     /*  90156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::TABORT),
     /*  90159 */     GIR_RootToRootCopy, /*OpIdx*/2, // R
     /*  90161 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CR0*/0,
     /*  90164 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  90168 */     GIR_RootConstrainSelectedInstOperands,
     /*  90169 */     // GIR_Coverage, 2879,
     /*  90169 */     GIR_EraseRootFromParent_Done,
     /*  90170 */   // Label 1423: @90170
     /*  90170 */   GIM_Try, /*On fail goto*//*Label 1424*/ GIMT_Encode4(90203), // Rule ID 2885 //
     /*  90175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasHTM),
     /*  90178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_treclaim),
     /*  90183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  90186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  90189 */     // (intrinsic_w_chain:{ *:[i32] } 10618:{ *:[iPTR] }, i32:{ *:[i32] }:$RA)  =>  (TRECLAIM:{ *:[i32] } ?:{ *:[i32] }:$RA)
     /*  90189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::TRECLAIM),
     /*  90192 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  90194 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CR0*/0,
     /*  90197 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  90201 */     GIR_RootConstrainSelectedInstOperands,
     /*  90202 */     // GIR_Coverage, 2885,
     /*  90202 */     GIR_EraseRootFromParent_Done,
     /*  90203 */   // Label 1424: @90203
     /*  90203 */   GIM_Reject,
     /*  90204 */ // Label 1410: @90204
     /*  90204 */ GIM_Try, /*On fail goto*//*Label 1425*/ GIMT_Encode4(91131),
     /*  90209 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /*  90212 */   GIM_Try, /*On fail goto*//*Label 1426*/ GIMT_Encode4(90262), // Rule ID 270 //
     /*  90217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  90220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_altivec_dst),
     /*  90225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  90228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  90231 */     // MIs[0] RA
     /*  90231 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  90235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  90239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90243 */     // MIs[1] Operand 1
     /*  90243 */     // No operand predicates
     /*  90243 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90245 */     // (intrinsic_void 10098:{ *:[iPTR] }, i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB, (imm:{ *:[i32] }):$STRM)  =>  (DST (imm:{ *:[i32] }):$STRM, i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)
     /*  90245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DST),
     /*  90248 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // STRM
     /*  90251 */     GIR_RootToRootCopy, /*OpIdx*/1, // RA
     /*  90253 */     GIR_RootToRootCopy, /*OpIdx*/2, // RB
     /*  90255 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  90260 */     GIR_RootConstrainSelectedInstOperands,
     /*  90261 */     // GIR_Coverage, 270,
     /*  90261 */     GIR_EraseRootFromParent_Done,
     /*  90262 */   // Label 1426: @90262
     /*  90262 */   GIM_Try, /*On fail goto*//*Label 1427*/ GIMT_Encode4(90312), // Rule ID 271 //
     /*  90267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  90270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_altivec_dstt),
     /*  90275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  90278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  90281 */     // MIs[0] RA
     /*  90281 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  90285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  90289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90293 */     // MIs[1] Operand 1
     /*  90293 */     // No operand predicates
     /*  90293 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90295 */     // (intrinsic_void 10101:{ *:[iPTR] }, i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB, (imm:{ *:[i32] }):$STRM)  =>  (DSTT (imm:{ *:[i32] }):$STRM, i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)
     /*  90295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DSTT),
     /*  90298 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // STRM
     /*  90301 */     GIR_RootToRootCopy, /*OpIdx*/1, // RA
     /*  90303 */     GIR_RootToRootCopy, /*OpIdx*/2, // RB
     /*  90305 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  90310 */     GIR_RootConstrainSelectedInstOperands,
     /*  90311 */     // GIR_Coverage, 271,
     /*  90311 */     GIR_EraseRootFromParent_Done,
     /*  90312 */   // Label 1427: @90312
     /*  90312 */   GIM_Try, /*On fail goto*//*Label 1428*/ GIMT_Encode4(90362), // Rule ID 272 //
     /*  90317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  90320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_altivec_dstst),
     /*  90325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  90328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  90331 */     // MIs[0] RA
     /*  90331 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  90335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  90339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90343 */     // MIs[1] Operand 1
     /*  90343 */     // No operand predicates
     /*  90343 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90345 */     // (intrinsic_void 10099:{ *:[iPTR] }, i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB, (imm:{ *:[i32] }):$STRM)  =>  (DSTST (imm:{ *:[i32] }):$STRM, i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)
     /*  90345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DSTST),
     /*  90348 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // STRM
     /*  90351 */     GIR_RootToRootCopy, /*OpIdx*/1, // RA
     /*  90353 */     GIR_RootToRootCopy, /*OpIdx*/2, // RB
     /*  90355 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  90360 */     GIR_RootConstrainSelectedInstOperands,
     /*  90361 */     // GIR_Coverage, 272,
     /*  90361 */     GIR_EraseRootFromParent_Done,
     /*  90362 */   // Label 1428: @90362
     /*  90362 */   GIM_Try, /*On fail goto*//*Label 1429*/ GIMT_Encode4(90412), // Rule ID 273 //
     /*  90367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  90370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_altivec_dststt),
     /*  90375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  90378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  90381 */     // MIs[0] RA
     /*  90381 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  90385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  90389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90393 */     // MIs[1] Operand 1
     /*  90393 */     // No operand predicates
     /*  90393 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90395 */     // (intrinsic_void 10100:{ *:[iPTR] }, i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB, (imm:{ *:[i32] }):$STRM)  =>  (DSTSTT (imm:{ *:[i32] }):$STRM, i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)
     /*  90395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DSTSTT),
     /*  90398 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // STRM
     /*  90401 */     GIR_RootToRootCopy, /*OpIdx*/1, // RA
     /*  90403 */     GIR_RootToRootCopy, /*OpIdx*/2, // RB
     /*  90405 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  90410 */     GIR_RootConstrainSelectedInstOperands,
     /*  90411 */     // GIR_Coverage, 273,
     /*  90411 */     GIR_EraseRootFromParent_Done,
     /*  90412 */   // Label 1429: @90412
     /*  90412 */   GIM_Try, /*On fail goto*//*Label 1430*/ GIMT_Encode4(90462), // Rule ID 274 //
     /*  90417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  90420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_altivec_dst),
     /*  90425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  90428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  90431 */     // MIs[0] RA
     /*  90431 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  90435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  90439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90443 */     // MIs[1] Operand 1
     /*  90443 */     // No operand predicates
     /*  90443 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90445 */     // (intrinsic_void 10098:{ *:[iPTR] }, i64:{ *:[i64] }:$RA, i32:{ *:[i32] }:$RB, (imm:{ *:[i32] }):$STRM)  =>  (DST64 (imm:{ *:[i32] }):$STRM, i64:{ *:[i64] }:$RA, i32:{ *:[i32] }:$RB)
     /*  90445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DST64),
     /*  90448 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // STRM
     /*  90451 */     GIR_RootToRootCopy, /*OpIdx*/1, // RA
     /*  90453 */     GIR_RootToRootCopy, /*OpIdx*/2, // RB
     /*  90455 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  90460 */     GIR_RootConstrainSelectedInstOperands,
     /*  90461 */     // GIR_Coverage, 274,
     /*  90461 */     GIR_EraseRootFromParent_Done,
     /*  90462 */   // Label 1430: @90462
     /*  90462 */   GIM_Try, /*On fail goto*//*Label 1431*/ GIMT_Encode4(90512), // Rule ID 275 //
     /*  90467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  90470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_altivec_dstt),
     /*  90475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  90478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  90481 */     // MIs[0] RA
     /*  90481 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  90485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  90489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90493 */     // MIs[1] Operand 1
     /*  90493 */     // No operand predicates
     /*  90493 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90495 */     // (intrinsic_void 10101:{ *:[iPTR] }, i64:{ *:[i64] }:$RA, i32:{ *:[i32] }:$RB, (imm:{ *:[i32] }):$STRM)  =>  (DSTT64 (imm:{ *:[i32] }):$STRM, i64:{ *:[i64] }:$RA, i32:{ *:[i32] }:$RB)
     /*  90495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DSTT64),
     /*  90498 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // STRM
     /*  90501 */     GIR_RootToRootCopy, /*OpIdx*/1, // RA
     /*  90503 */     GIR_RootToRootCopy, /*OpIdx*/2, // RB
     /*  90505 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  90510 */     GIR_RootConstrainSelectedInstOperands,
     /*  90511 */     // GIR_Coverage, 275,
     /*  90511 */     GIR_EraseRootFromParent_Done,
     /*  90512 */   // Label 1431: @90512
     /*  90512 */   GIM_Try, /*On fail goto*//*Label 1432*/ GIMT_Encode4(90562), // Rule ID 276 //
     /*  90517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  90520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_altivec_dstst),
     /*  90525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  90528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  90531 */     // MIs[0] RA
     /*  90531 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  90535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  90539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90543 */     // MIs[1] Operand 1
     /*  90543 */     // No operand predicates
     /*  90543 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90545 */     // (intrinsic_void 10099:{ *:[iPTR] }, i64:{ *:[i64] }:$RA, i32:{ *:[i32] }:$RB, (imm:{ *:[i32] }):$STRM)  =>  (DSTST64 (imm:{ *:[i32] }):$STRM, i64:{ *:[i64] }:$RA, i32:{ *:[i32] }:$RB)
     /*  90545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DSTST64),
     /*  90548 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // STRM
     /*  90551 */     GIR_RootToRootCopy, /*OpIdx*/1, // RA
     /*  90553 */     GIR_RootToRootCopy, /*OpIdx*/2, // RB
     /*  90555 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  90560 */     GIR_RootConstrainSelectedInstOperands,
     /*  90561 */     // GIR_Coverage, 276,
     /*  90561 */     GIR_EraseRootFromParent_Done,
     /*  90562 */   // Label 1432: @90562
     /*  90562 */   GIM_Try, /*On fail goto*//*Label 1433*/ GIMT_Encode4(90612), // Rule ID 277 //
     /*  90567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  90570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_altivec_dststt),
     /*  90575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  90578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  90581 */     // MIs[0] RA
     /*  90581 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  90585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  90589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90593 */     // MIs[1] Operand 1
     /*  90593 */     // No operand predicates
     /*  90593 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90595 */     // (intrinsic_void 10100:{ *:[iPTR] }, i64:{ *:[i64] }:$RA, i32:{ *:[i32] }:$RB, (imm:{ *:[i32] }):$STRM)  =>  (DSTSTT64 (imm:{ *:[i32] }):$STRM, i64:{ *:[i64] }:$RA, i32:{ *:[i32] }:$RB)
     /*  90595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DSTSTT64),
     /*  90598 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // STRM
     /*  90601 */     GIR_RootToRootCopy, /*OpIdx*/1, // RA
     /*  90603 */     GIR_RootToRootCopy, /*OpIdx*/2, // RB
     /*  90605 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  90610 */     GIR_RootConstrainSelectedInstOperands,
     /*  90611 */     // GIR_Coverage, 277,
     /*  90611 */     GIR_EraseRootFromParent_Done,
     /*  90612 */   // Label 1433: @90612
     /*  90612 */   GIM_Try, /*On fail goto*//*Label 1434*/ GIMT_Encode4(90649), // Rule ID 380 //
     /*  90617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  90620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsumsws),
     /*  90625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  90628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  90631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  90634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  90638 */     // (intrinsic_w_chain:{ *:[v4i32] } 10380:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VSUMSWS:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  90638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSUMSWS),
     /*  90641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  90643 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  90645 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  90647 */     GIR_RootConstrainSelectedInstOperands,
     /*  90648 */     // GIR_Coverage, 380,
     /*  90648 */     GIR_EraseRootFromParent_Done,
     /*  90649 */   // Label 1434: @90649
     /*  90649 */   GIM_Try, /*On fail goto*//*Label 1435*/ GIMT_Encode4(90686), // Rule ID 381 //
     /*  90654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  90657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsum2sws),
     /*  90662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  90665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  90668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  90671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  90675 */     // (intrinsic_w_chain:{ *:[v4i32] } 10376:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VSUM2SWS:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  90675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSUM2SWS),
     /*  90678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  90680 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  90682 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  90684 */     GIR_RootConstrainSelectedInstOperands,
     /*  90685 */     // GIR_Coverage, 381,
     /*  90685 */     GIR_EraseRootFromParent_Done,
     /*  90686 */   // Label 1435: @90686
     /*  90686 */   GIM_Try, /*On fail goto*//*Label 1436*/ GIMT_Encode4(90723), // Rule ID 382 //
     /*  90691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  90694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsum4sbs),
     /*  90699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  90702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  90705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  90708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  90712 */     // (intrinsic_w_chain:{ *:[v4i32] } 10377:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VSUM4SBS:{ *:[v4i32] } v16i8:{ *:[v16i8] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  90712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSUM4SBS),
     /*  90715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  90717 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  90719 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  90721 */     GIR_RootConstrainSelectedInstOperands,
     /*  90722 */     // GIR_Coverage, 382,
     /*  90722 */     GIR_EraseRootFromParent_Done,
     /*  90723 */   // Label 1436: @90723
     /*  90723 */   GIM_Try, /*On fail goto*//*Label 1437*/ GIMT_Encode4(90760), // Rule ID 383 //
     /*  90728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  90731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsum4shs),
     /*  90736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  90739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  90745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  90749 */     // (intrinsic_w_chain:{ *:[v4i32] } 10378:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VSUM4SHS:{ *:[v4i32] } v8i16:{ *:[v8i16] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  90749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSUM4SHS),
     /*  90752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  90754 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  90756 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  90758 */     GIR_RootConstrainSelectedInstOperands,
     /*  90759 */     // GIR_Coverage, 383,
     /*  90759 */     GIR_EraseRootFromParent_Done,
     /*  90760 */   // Label 1437: @90760
     /*  90760 */   GIM_Try, /*On fail goto*//*Label 1438*/ GIMT_Encode4(90797), // Rule ID 384 //
     /*  90765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  90768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsum4ubs),
     /*  90773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  90776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  90779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  90782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  90786 */     // (intrinsic_w_chain:{ *:[v4i32] } 10379:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VSUM4UBS:{ *:[v4i32] } v16i8:{ *:[v16i8] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  90786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSUM4UBS),
     /*  90789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  90791 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  90793 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  90795 */     GIR_RootConstrainSelectedInstOperands,
     /*  90796 */     // GIR_Coverage, 384,
     /*  90796 */     GIR_EraseRootFromParent_Done,
     /*  90797 */   // Label 1438: @90797
     /*  90797 */   GIM_Try, /*On fail goto*//*Label 1439*/ GIMT_Encode4(90834), // Rule ID 411 //
     /*  90802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  90805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vpkshss),
     /*  90810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  90813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  90819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  90823 */     // (intrinsic_w_chain:{ *:[v16i8] } 10314:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VPKSHSS:{ *:[v16i8] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  90823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPKSHSS),
     /*  90826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  90828 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  90830 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  90832 */     GIR_RootConstrainSelectedInstOperands,
     /*  90833 */     // GIR_Coverage, 411,
     /*  90833 */     GIR_EraseRootFromParent_Done,
     /*  90834 */   // Label 1439: @90834
     /*  90834 */   GIM_Try, /*On fail goto*//*Label 1440*/ GIMT_Encode4(90871), // Rule ID 412 //
     /*  90839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  90842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vpkshus),
     /*  90847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  90850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  90856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  90860 */     // (intrinsic_w_chain:{ *:[v16i8] } 10315:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VPKSHUS:{ *:[v16i8] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  90860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPKSHUS),
     /*  90863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  90865 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  90867 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  90869 */     GIR_RootConstrainSelectedInstOperands,
     /*  90870 */     // GIR_Coverage, 412,
     /*  90870 */     GIR_EraseRootFromParent_Done,
     /*  90871 */   // Label 1440: @90871
     /*  90871 */   GIM_Try, /*On fail goto*//*Label 1441*/ GIMT_Encode4(90908), // Rule ID 413 //
     /*  90876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  90879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vpkswss),
     /*  90884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  90887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  90890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  90893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  90897 */     // (intrinsic_w_chain:{ *:[v8i16] } 10316:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VPKSWSS:{ *:[v8i16] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  90897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPKSWSS),
     /*  90900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  90902 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  90904 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  90906 */     GIR_RootConstrainSelectedInstOperands,
     /*  90907 */     // GIR_Coverage, 413,
     /*  90907 */     GIR_EraseRootFromParent_Done,
     /*  90908 */   // Label 1441: @90908
     /*  90908 */   GIM_Try, /*On fail goto*//*Label 1442*/ GIMT_Encode4(90945), // Rule ID 414 //
     /*  90913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  90916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vpkswus),
     /*  90921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  90924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  90927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  90930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  90934 */     // (intrinsic_w_chain:{ *:[v8i16] } 10317:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VPKSWUS:{ *:[v8i16] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  90934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPKSWUS),
     /*  90937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  90939 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  90941 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  90943 */     GIR_RootConstrainSelectedInstOperands,
     /*  90944 */     // GIR_Coverage, 414,
     /*  90944 */     GIR_EraseRootFromParent_Done,
     /*  90945 */   // Label 1442: @90945
     /*  90945 */   GIM_Try, /*On fail goto*//*Label 1443*/ GIMT_Encode4(90982), // Rule ID 415 //
     /*  90950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  90953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vpkuhus),
     /*  90958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  90961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  90967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  90971 */     // (intrinsic_w_chain:{ *:[v16i8] } 10319:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VPKUHUS:{ *:[v16i8] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  90971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPKUHUS),
     /*  90974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  90976 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  90978 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  90980 */     GIR_RootConstrainSelectedInstOperands,
     /*  90981 */     // GIR_Coverage, 415,
     /*  90981 */     GIR_EraseRootFromParent_Done,
     /*  90982 */   // Label 1443: @90982
     /*  90982 */   GIM_Try, /*On fail goto*//*Label 1444*/ GIMT_Encode4(91019), // Rule ID 416 //
     /*  90987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  90990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vpkuwus),
     /*  90995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  90998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  91001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  91004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  91008 */     // (intrinsic_w_chain:{ *:[v8i16] } 10320:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VPKUWUS:{ *:[v8i16] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  91008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPKUWUS),
     /*  91011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  91013 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  91015 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  91017 */     GIR_RootConstrainSelectedInstOperands,
     /*  91018 */     // GIR_Coverage, 416,
     /*  91018 */     GIR_EraseRootFromParent_Done,
     /*  91019 */   // Label 1444: @91019
     /*  91019 */   GIM_Try, /*On fail goto*//*Label 1445*/ GIMT_Encode4(91056), // Rule ID 500 //
     /*  91024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  91027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vpksdss),
     /*  91032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  91035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  91038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  91041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  91045 */     // (intrinsic_w_chain:{ *:[v4i32] } 10312:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VPKSDSS:{ *:[v4i32] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  91045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPKSDSS),
     /*  91048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  91050 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  91052 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  91054 */     GIR_RootConstrainSelectedInstOperands,
     /*  91055 */     // GIR_Coverage, 500,
     /*  91055 */     GIR_EraseRootFromParent_Done,
     /*  91056 */   // Label 1445: @91056
     /*  91056 */   GIM_Try, /*On fail goto*//*Label 1446*/ GIMT_Encode4(91093), // Rule ID 501 //
     /*  91061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  91064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vpksdus),
     /*  91069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  91072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  91075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  91078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  91082 */     // (intrinsic_w_chain:{ *:[v4i32] } 10313:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VPKSDUS:{ *:[v4i32] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  91082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPKSDUS),
     /*  91085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  91087 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  91089 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  91091 */     GIR_RootConstrainSelectedInstOperands,
     /*  91092 */     // GIR_Coverage, 501,
     /*  91092 */     GIR_EraseRootFromParent_Done,
     /*  91093 */   // Label 1446: @91093
     /*  91093 */   GIM_Try, /*On fail goto*//*Label 1447*/ GIMT_Encode4(91130), // Rule ID 502 //
     /*  91098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  91101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vpkudus),
     /*  91106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  91109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  91112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  91115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  91119 */     // (intrinsic_w_chain:{ *:[v4i32] } 10318:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VPKUDUS:{ *:[v4i32] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  91119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPKUDUS),
     /*  91122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  91124 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  91126 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  91128 */     GIR_RootConstrainSelectedInstOperands,
     /*  91129 */     // GIR_Coverage, 502,
     /*  91129 */     GIR_EraseRootFromParent_Done,
     /*  91130 */   // Label 1447: @91130
     /*  91130 */   GIM_Reject,
     /*  91131 */ // Label 1425: @91131
     /*  91131 */ GIM_Try, /*On fail goto*//*Label 1448*/ GIMT_Encode4(91347),
     /*  91136 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /*  91139 */   GIM_Try, /*On fail goto*//*Label 1449*/ GIMT_Encode4(91178), // Rule ID 762 //
     /*  91144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_addex),
     /*  91149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  91152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  91155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  91158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  91162 */     // MIs[0] CY
     /*  91162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  91165 */     // (intrinsic_w_chain:{ *:[i64] } 10079:{ *:[iPTR] }, i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB, (timm:{ *:[i32] }):$CY)  =>  (ADDEX8:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB, (timm:{ *:[i32] }):$CY)
     /*  91165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::ADDEX8),
     /*  91168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  91170 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  91172 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  91174 */     GIR_RootToRootCopy, /*OpIdx*/4, // CY
     /*  91176 */     GIR_RootConstrainSelectedInstOperands,
     /*  91177 */     // GIR_Coverage, 762,
     /*  91177 */     GIR_EraseRootFromParent_Done,
     /*  91178 */   // Label 1449: @91178
     /*  91178 */   GIM_Try, /*On fail goto*//*Label 1450*/ GIMT_Encode4(91220), // Rule ID 294 //
     /*  91183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  91186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmhaddshs),
     /*  91191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  91194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  91197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  91200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  91203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  91207 */     // (intrinsic_w_chain:{ *:[v8i16] } 10267:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$RA, v8i16:{ *:[v8i16] }:$RB, v8i16:{ *:[v8i16] }:$RC)  =>  (VMHADDSHS:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$RA, v8i16:{ *:[v8i16] }:$RB, v8i16:{ *:[v8i16] }:$RC)
     /*  91207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMHADDSHS),
     /*  91210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  91212 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  91214 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  91216 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  91218 */     GIR_RootConstrainSelectedInstOperands,
     /*  91219 */     // GIR_Coverage, 294,
     /*  91219 */     GIR_EraseRootFromParent_Done,
     /*  91220 */   // Label 1450: @91220
     /*  91220 */   GIM_Try, /*On fail goto*//*Label 1451*/ GIMT_Encode4(91262), // Rule ID 295 //
     /*  91225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  91228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmhraddshs),
     /*  91233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  91236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  91239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  91242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  91245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  91249 */     // (intrinsic_w_chain:{ *:[v8i16] } 10268:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$RA, v8i16:{ *:[v8i16] }:$RB, v8i16:{ *:[v8i16] }:$RC)  =>  (VMHRADDSHS:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$RA, v8i16:{ *:[v8i16] }:$RB, v8i16:{ *:[v8i16] }:$RC)
     /*  91249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMHRADDSHS),
     /*  91252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  91254 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  91256 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  91258 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  91260 */     GIR_RootConstrainSelectedInstOperands,
     /*  91261 */     // GIR_Coverage, 295,
     /*  91261 */     GIR_EraseRootFromParent_Done,
     /*  91262 */   // Label 1451: @91262
     /*  91262 */   GIM_Try, /*On fail goto*//*Label 1452*/ GIMT_Encode4(91304), // Rule ID 353 //
     /*  91267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  91270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmsumshs),
     /*  91275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  91278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  91281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  91284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  91287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  91291 */     // (intrinsic_w_chain:{ *:[v4i32] } 10282:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$RA, v8i16:{ *:[v8i16] }:$RB, v4i32:{ *:[v4i32] }:$RC)  =>  (VMSUMSHS:{ *:[v4i32] } v8i16:{ *:[v8i16] }:$RA, v8i16:{ *:[v8i16] }:$RB, v4i32:{ *:[v4i32] }:$RC)
     /*  91291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMSUMSHS),
     /*  91294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  91296 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  91298 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  91300 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  91302 */     GIR_RootConstrainSelectedInstOperands,
     /*  91303 */     // GIR_Coverage, 353,
     /*  91303 */     GIR_EraseRootFromParent_Done,
     /*  91304 */   // Label 1452: @91304
     /*  91304 */   GIM_Try, /*On fail goto*//*Label 1453*/ GIMT_Encode4(91346), // Rule ID 354 //
     /*  91309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  91312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmsumuhs),
     /*  91317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  91320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  91323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  91326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  91329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  91333 */     // (intrinsic_w_chain:{ *:[v4i32] } 10286:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$RA, v8i16:{ *:[v8i16] }:$RB, v4i32:{ *:[v4i32] }:$RC)  =>  (VMSUMUHS:{ *:[v4i32] } v8i16:{ *:[v8i16] }:$RA, v8i16:{ *:[v8i16] }:$RB, v4i32:{ *:[v4i32] }:$RC)
     /*  91333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMSUMUHS),
     /*  91336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  91338 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  91340 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  91342 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  91344 */     GIR_RootConstrainSelectedInstOperands,
     /*  91345 */     // GIR_Coverage, 354,
     /*  91345 */     GIR_EraseRootFromParent_Done,
     /*  91346 */   // Label 1453: @91346
     /*  91346 */   GIM_Reject,
     /*  91347 */ // Label 1448: @91347
     /*  91347 */ GIM_Reject,
     /*  91348 */ // Label 21: @91348
     /*  91348 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1456*/ GIMT_Encode4(112103),
     /*  91359 */ /*GILLT_s32*//*Label 1454*/ GIMT_Encode4(91367),
     /*  91363 */ /*GILLT_s64*//*Label 1455*/ GIMT_Encode4(101588),
     /*  91367 */ // Label 1454: @91367
     /*  91367 */ GIM_Try, /*On fail goto*//*Label 1457*/ GIMT_Encode4(101587),
     /*  91372 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /*  91375 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  91379 */   GIM_Try, /*On fail goto*//*Label 1458*/ GIMT_Encode4(91491), // Rule ID 5256 //
     /*  91384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  91392 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  91396 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  91400 */     // MIs[1] Operand 1
     /*  91400 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /*  91405 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  91409 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  91413 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  91417 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  91421 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  91425 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  91429 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  91433 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  91437 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /*  91441 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  91445 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  91447 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } (and:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$sa), i32:{ *:[i32] }:$s1), 0:{ *:[i32] }, SETNE:{ *:[Other] }))  =>  (RLWNM:{ *:[i32] } ?:{ *:[i32] }:$s1, (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 32:{ *:[i32] }), 31:{ *:[i32] }, 31:{ *:[i32] })
     /*  91447 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  91450 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /*  91454 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  91459 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /*  91463 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/32,
     /*  91466 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for PPC::CARRY*/0,
     /*  91469 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  91471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWNM),
     /*  91474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  91476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /*  91480 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  91483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  91486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  91489 */     GIR_RootConstrainSelectedInstOperands,
     /*  91490 */     // GIR_Coverage, 5256,
     /*  91490 */     GIR_EraseRootFromParent_Done,
     /*  91491 */   // Label 1458: @91491
     /*  91491 */   GIM_Try, /*On fail goto*//*Label 1459*/ GIMT_Encode4(91630), // Rule ID 5259 //
     /*  91496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  91504 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  91508 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  91512 */     // MIs[1] Operand 1
     /*  91512 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /*  91517 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  91521 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  91525 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  91529 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  91533 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  91537 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  91541 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  91545 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  91549 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /*  91553 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  91557 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  91559 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } (and:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, i32:{ *:[i32] }:$sa), i64:{ *:[i64] }:$s1), 0:{ *:[i64] }, SETNE:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDCL:{ *:[i64] } ?:{ *:[i64] }:$s1, (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 64:{ *:[i32] }), 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  91559 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  91562 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /*  91566 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  91571 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /*  91575 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/64,
     /*  91578 */     GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for PPC::CARRY*/0,
     /*  91581 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  91583 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  91586 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDCL),
     /*  91590 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  91595 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /*  91599 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  91602 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /*  91605 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  91607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  91612 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /*  91619 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  91624 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /*  91629 */     // GIR_Coverage, 5259,
     /*  91629 */     GIR_EraseRootFromParent_Done,
     /*  91630 */   // Label 1459: @91630
     /*  91630 */   GIM_Try, /*On fail goto*//*Label 1460*/ GIMT_Encode4(91763), // Rule ID 5264 //
     /*  91635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  91643 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  91647 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  91651 */     // MIs[1] Operand 1
     /*  91651 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  91656 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  91660 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  91664 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  91668 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  91672 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  91676 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  91680 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  91684 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  91688 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /*  91692 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  91696 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  91698 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } (and:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$sa), i32:{ *:[i32] }:$s1), 0:{ *:[i32] }, SETEQ:{ *:[Other] }))  =>  (RLWNM:{ *:[i32] } (NOR:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s1), (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 32:{ *:[i32] }), 31:{ *:[i32] }, 31:{ *:[i32] })
     /*  91698 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  91701 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /*  91705 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  91710 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /*  91714 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/32,
     /*  91717 */     GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for PPC::CARRY*/0,
     /*  91720 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  91722 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  91725 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /*  91729 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  91734 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /*  91738 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /*  91742 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  91744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWNM),
     /*  91747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  91749 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  91752 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  91755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  91758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  91761 */     GIR_RootConstrainSelectedInstOperands,
     /*  91762 */     // GIR_Coverage, 5264,
     /*  91762 */     GIR_EraseRootFromParent_Done,
     /*  91763 */   // Label 1460: @91763
     /*  91763 */   GIM_Try, /*On fail goto*//*Label 1461*/ GIMT_Encode4(91923), // Rule ID 5267 //
     /*  91768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  91776 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  91780 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  91784 */     // MIs[1] Operand 1
     /*  91784 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  91789 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  91793 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  91797 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  91801 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  91805 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  91809 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  91813 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  91817 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  91821 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /*  91825 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  91829 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  91831 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } (and:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, i32:{ *:[i32] }:$sa), i64:{ *:[i64] }:$s1), 0:{ *:[i64] }, SETEQ:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDCL:{ *:[i64] } (NOR8:{ *:[i64] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s1), (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 64:{ *:[i32] }), 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  91831 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  91834 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /*  91838 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  91843 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /*  91847 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/64,
     /*  91850 */     GIR_SetImplicitDefDead, /*InsnID*/3, /*OpIdx for PPC::CARRY*/0,
     /*  91853 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  91855 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  91858 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /*  91862 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  91867 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /*  91871 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /*  91875 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  91877 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  91880 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDCL),
     /*  91884 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  91889 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  91892 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  91895 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /*  91898 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  91900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  91905 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /*  91912 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  91917 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /*  91922 */     // GIR_Coverage, 5267,
     /*  91922 */     GIR_EraseRootFromParent_Done,
     /*  91923 */   // Label 1461: @91923
     /*  91923 */   GIM_Try, /*On fail goto*//*Label 1462*/ GIMT_Encode4(92035), // Rule ID 3741 //
     /*  91928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  91936 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  91940 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  91944 */     // MIs[1] Operand 1
     /*  91944 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /*  91949 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  91953 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  91957 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  91961 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  91965 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  91969 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  91973 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  91977 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  91981 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /*  91985 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  91989 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  91991 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } (and:{ *:[i32] } i32:{ *:[i32] }:$s1, (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$sa)), 0:{ *:[i32] }, SETNE:{ *:[Other] }))  =>  (RLWNM:{ *:[i32] } ?:{ *:[i32] }:$s1, (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 32:{ *:[i32] }), 31:{ *:[i32] }, 31:{ *:[i32] })
     /*  91991 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  91994 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /*  91998 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  92003 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /*  92007 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/32,
     /*  92010 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for PPC::CARRY*/0,
     /*  92013 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  92015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWNM),
     /*  92018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  92020 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /*  92024 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  92027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  92030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  92033 */     GIR_RootConstrainSelectedInstOperands,
     /*  92034 */     // GIR_Coverage, 3741,
     /*  92034 */     GIR_EraseRootFromParent_Done,
     /*  92035 */   // Label 1462: @92035
     /*  92035 */   GIM_Try, /*On fail goto*//*Label 1463*/ GIMT_Encode4(92174), // Rule ID 3744 //
     /*  92040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  92048 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  92052 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  92056 */     // MIs[1] Operand 1
     /*  92056 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /*  92061 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  92065 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  92069 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  92073 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  92077 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  92081 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  92085 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  92089 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  92093 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /*  92097 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  92101 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  92103 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } (and:{ *:[i64] } i64:{ *:[i64] }:$s1, (shl:{ *:[i64] } 1:{ *:[i64] }, i32:{ *:[i32] }:$sa)), 0:{ *:[i64] }, SETNE:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDCL:{ *:[i64] } ?:{ *:[i64] }:$s1, (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 64:{ *:[i32] }), 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  92103 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  92106 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /*  92110 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  92115 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /*  92119 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/64,
     /*  92122 */     GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for PPC::CARRY*/0,
     /*  92125 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  92127 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  92130 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDCL),
     /*  92134 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  92139 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /*  92143 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  92146 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /*  92149 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  92151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92156 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /*  92163 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  92168 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /*  92173 */     // GIR_Coverage, 3744,
     /*  92173 */     GIR_EraseRootFromParent_Done,
     /*  92174 */   // Label 1463: @92174
     /*  92174 */   GIM_Try, /*On fail goto*//*Label 1464*/ GIMT_Encode4(92307), // Rule ID 3749 //
     /*  92179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  92187 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  92191 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  92195 */     // MIs[1] Operand 1
     /*  92195 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  92200 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  92204 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  92208 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  92212 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  92216 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  92220 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  92224 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  92228 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  92232 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /*  92236 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  92240 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  92242 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } (and:{ *:[i32] } i32:{ *:[i32] }:$s1, (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$sa)), 0:{ *:[i32] }, SETEQ:{ *:[Other] }))  =>  (RLWNM:{ *:[i32] } (NOR:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s1), (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 32:{ *:[i32] }), 31:{ *:[i32] }, 31:{ *:[i32] })
     /*  92242 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  92245 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /*  92249 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  92254 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /*  92258 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/32,
     /*  92261 */     GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for PPC::CARRY*/0,
     /*  92264 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  92266 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  92269 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /*  92273 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  92278 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /*  92282 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /*  92286 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  92288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWNM),
     /*  92291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  92293 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  92296 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  92299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  92302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  92305 */     GIR_RootConstrainSelectedInstOperands,
     /*  92306 */     // GIR_Coverage, 3749,
     /*  92306 */     GIR_EraseRootFromParent_Done,
     /*  92307 */   // Label 1464: @92307
     /*  92307 */   GIM_Try, /*On fail goto*//*Label 1465*/ GIMT_Encode4(92467), // Rule ID 3752 //
     /*  92312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  92320 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  92324 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  92328 */     // MIs[1] Operand 1
     /*  92328 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  92333 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  92337 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  92341 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  92345 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  92349 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  92353 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  92357 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  92361 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  92365 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /*  92369 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  92373 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  92375 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } (and:{ *:[i64] } i64:{ *:[i64] }:$s1, (shl:{ *:[i64] } 1:{ *:[i64] }, i32:{ *:[i32] }:$sa)), 0:{ *:[i64] }, SETEQ:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDCL:{ *:[i64] } (NOR8:{ *:[i64] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s1), (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 64:{ *:[i32] }), 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  92375 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  92378 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /*  92382 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  92387 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /*  92391 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/64,
     /*  92394 */     GIR_SetImplicitDefDead, /*InsnID*/3, /*OpIdx for PPC::CARRY*/0,
     /*  92397 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  92399 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  92402 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /*  92406 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  92411 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /*  92415 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /*  92419 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  92421 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  92424 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDCL),
     /*  92428 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  92433 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  92436 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  92439 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /*  92442 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  92444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92449 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /*  92456 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  92461 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /*  92466 */     // GIR_Coverage, 3752,
     /*  92466 */     GIR_EraseRootFromParent_Done,
     /*  92467 */   // Label 1465: @92467
     /*  92467 */   GIM_Try, /*On fail goto*//*Label 1466*/ GIMT_Encode4(92536), // Rule ID 3661 //
     /*  92472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  92480 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  92484 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  92488 */     // MIs[1] Operand 1
     /*  92488 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  92493 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  92497 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92499 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETEQ:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } (CNTLZW:{ *:[i32] } ?:{ *:[i32] }:$s1), 27:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /*  92499 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  92502 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CNTLZW),
     /*  92506 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  92511 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  92515 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  92517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /*  92520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  92522 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  92525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/27,
     /*  92528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  92531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  92534 */     GIR_RootConstrainSelectedInstOperands,
     /*  92535 */     // GIR_Coverage, 3661,
     /*  92535 */     GIR_EraseRootFromParent_Done,
     /*  92536 */   // Label 1466: @92536
     /*  92536 */   GIM_Try, /*On fail goto*//*Label 1467*/ GIMT_Encode4(92632), // Rule ID 3664 //
     /*  92541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  92549 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  92553 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  92557 */     // MIs[1] Operand 1
     /*  92557 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  92562 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  92566 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92568 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETEQ:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (CNTLZD:{ *:[i64] } ?:{ *:[i64] }:$s1), 58:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  92568 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  92571 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CNTLZD),
     /*  92575 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  92580 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  92584 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  92586 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  92589 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /*  92593 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  92598 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  92601 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/58,
     /*  92604 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /*  92607 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  92609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92614 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /*  92621 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  92626 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /*  92631 */     // GIR_Coverage, 3664,
     /*  92631 */     GIR_EraseRootFromParent_Done,
     /*  92632 */   // Label 1467: @92632
     /*  92632 */   GIM_Try, /*On fail goto*//*Label 1468*/ GIMT_Encode4(92739), // Rule ID 3669 //
     /*  92637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  92645 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  92649 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  92653 */     // MIs[1] Operand 1
     /*  92653 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /*  92658 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  92662 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92664 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETNE:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } (NOR:{ *:[i32] } (CNTLZW:{ *:[i32] } ?:{ *:[i32] }:$s1), (CNTLZW:{ *:[i32] } ?:{ *:[i32] }:$s1)), 27:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /*  92664 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  92667 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::CNTLZW),
     /*  92671 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  92676 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  92680 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  92682 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  92685 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CNTLZW),
     /*  92689 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  92694 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  92698 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  92700 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  92703 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /*  92707 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  92712 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  92715 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  92718 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  92720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /*  92723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  92725 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  92728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/27,
     /*  92731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  92734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  92737 */     GIR_RootConstrainSelectedInstOperands,
     /*  92738 */     // GIR_Coverage, 3669,
     /*  92738 */     GIR_EraseRootFromParent_Done,
     /*  92739 */   // Label 1468: @92739
     /*  92739 */   GIM_Try, /*On fail goto*//*Label 1469*/ GIMT_Encode4(92873), // Rule ID 3672 //
     /*  92744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  92752 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  92756 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  92760 */     // MIs[1] Operand 1
     /*  92760 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /*  92765 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  92769 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92771 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETNE:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (NOR8:{ *:[i64] } (CNTLZD:{ *:[i64] } ?:{ *:[i64] }:$s1), (CNTLZD:{ *:[i64] } ?:{ *:[i64] }:$s1)), 58:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  92771 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /*  92774 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::CNTLZD),
     /*  92778 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  92783 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  92787 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  92789 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  92792 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::CNTLZD),
     /*  92796 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  92801 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  92805 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  92807 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  92810 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /*  92814 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  92819 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  92822 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /*  92825 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  92827 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  92830 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /*  92834 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  92839 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  92842 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/58,
     /*  92845 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /*  92848 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  92850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92855 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /*  92862 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  92867 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /*  92872 */     // GIR_Coverage, 3672,
     /*  92872 */     GIR_EraseRootFromParent_Done,
     /*  92873 */   // Label 1469: @92873
     /*  92873 */   GIM_Try, /*On fail goto*//*Label 1470*/ GIMT_Encode4(92925), // Rule ID 3677 //
     /*  92878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  92886 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  92890 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  92894 */     // MIs[1] Operand 1
     /*  92894 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /*  92899 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  92903 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92905 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETLT:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$s1, 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /*  92905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /*  92908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  92910 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  92914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  92917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  92920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  92923 */     GIR_RootConstrainSelectedInstOperands,
     /*  92924 */     // GIR_Coverage, 3677,
     /*  92924 */     GIR_EraseRootFromParent_Done,
     /*  92925 */   // Label 1470: @92925
     /*  92925 */   GIM_Try, /*On fail goto*//*Label 1471*/ GIMT_Encode4(93004), // Rule ID 3680 //
     /*  92930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  92938 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  92942 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  92946 */     // MIs[1] Operand 1
     /*  92946 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /*  92951 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  92955 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92957 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETLT:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$s1, 1:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  92957 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  92960 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /*  92964 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  92969 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  92973 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  92976 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /*  92979 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  92981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92986 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /*  92993 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  92998 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /*  93003 */     // GIR_Coverage, 3680,
     /*  93003 */     GIR_EraseRootFromParent_Done,
     /*  93004 */   // Label 1471: @93004
     /*  93004 */   GIM_Try, /*On fail goto*//*Label 1472*/ GIMT_Encode4(93077), // Rule ID 3685 //
     /*  93009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  93013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  93017 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  93021 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  93025 */     // MIs[1] Operand 1
     /*  93025 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /*  93030 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  93034 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  93036 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETGE:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } (NOR:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s1), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /*  93036 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  93039 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /*  93043 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93048 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  93052 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  93056 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  93058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /*  93061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  93063 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  93066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  93069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  93072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  93075 */     GIR_RootConstrainSelectedInstOperands,
     /*  93076 */     // GIR_Coverage, 3685,
     /*  93076 */     GIR_EraseRootFromParent_Done,
     /*  93077 */   // Label 1472: @93077
     /*  93077 */   GIM_Try, /*On fail goto*//*Label 1473*/ GIMT_Encode4(93177), // Rule ID 3688 //
     /*  93082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  93086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  93090 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  93094 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  93098 */     // MIs[1] Operand 1
     /*  93098 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /*  93103 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  93107 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  93109 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETGE:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (NOR8:{ *:[i64] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s1), 1:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  93109 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  93112 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /*  93116 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93121 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  93125 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  93129 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  93131 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  93134 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /*  93138 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93143 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  93146 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  93149 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /*  93152 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  93154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93159 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /*  93166 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  93171 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /*  93176 */     // GIR_Coverage, 3688,
     /*  93176 */     GIR_EraseRootFromParent_Done,
     /*  93177 */   // Label 1473: @93177
     /*  93177 */   GIM_Try, /*On fail goto*//*Label 1474*/ GIMT_Encode4(93267), // Rule ID 3693 //
     /*  93182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  93186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  93190 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  93194 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  93198 */     // MIs[1] Operand 1
     /*  93198 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /*  93203 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  93207 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  93209 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETGT:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } (ANDC:{ *:[i32] } (NEG:{ *:[i32] } ?:{ *:[i32] }:$s1), ?:{ *:[i32] }:$s1), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /*  93209 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  93212 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NEG),
     /*  93216 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93221 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  93225 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  93227 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  93230 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::ANDC),
     /*  93234 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93239 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  93242 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  93246 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  93248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /*  93251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  93253 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  93256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  93259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  93262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  93265 */     GIR_RootConstrainSelectedInstOperands,
     /*  93266 */     // GIR_Coverage, 3693,
     /*  93266 */     GIR_EraseRootFromParent_Done,
     /*  93267 */   // Label 1474: @93267
     /*  93267 */   GIM_Try, /*On fail goto*//*Label 1475*/ GIMT_Encode4(93384), // Rule ID 3696 //
     /*  93272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  93276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  93280 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  93284 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  93288 */     // MIs[1] Operand 1
     /*  93288 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /*  93293 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  93297 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  93299 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETGT:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (ANDC8:{ *:[i64] } (NEG8:{ *:[i64] } ?:{ *:[i64] }:$s1), ?:{ *:[i64] }:$s1), 1:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  93299 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  93302 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::NEG8),
     /*  93306 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93311 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  93315 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  93317 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  93320 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::ANDC8),
     /*  93324 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93329 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  93332 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  93336 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  93338 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  93341 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /*  93345 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93350 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  93353 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  93356 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /*  93359 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  93361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93366 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /*  93373 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  93378 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /*  93383 */     // GIR_Coverage, 3696,
     /*  93383 */     GIR_EraseRootFromParent_Done,
     /*  93384 */   // Label 1475: @93384
     /*  93384 */   GIM_Try, /*On fail goto*//*Label 1476*/ GIMT_Encode4(93474), // Rule ID 3701 //
     /*  93389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  93393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  93397 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  93401 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  93405 */     // MIs[1] Operand 1
     /*  93405 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /*  93410 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  93414 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  93416 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETLE:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } (ORC:{ *:[i32] } ?:{ *:[i32] }:$s1, (NEG:{ *:[i32] } ?:{ *:[i32] }:$s1)), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /*  93416 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  93419 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NEG),
     /*  93423 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93428 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  93432 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  93434 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  93437 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::ORC),
     /*  93441 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93446 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  93450 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  93453 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  93455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /*  93458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  93460 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  93463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  93466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  93469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  93472 */     GIR_RootConstrainSelectedInstOperands,
     /*  93473 */     // GIR_Coverage, 3701,
     /*  93473 */     GIR_EraseRootFromParent_Done,
     /*  93474 */   // Label 1476: @93474
     /*  93474 */   GIM_Try, /*On fail goto*//*Label 1477*/ GIMT_Encode4(93591), // Rule ID 3704 //
     /*  93479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  93483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  93487 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  93491 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  93495 */     // MIs[1] Operand 1
     /*  93495 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /*  93500 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  93504 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  93506 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETLE:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (ORC8:{ *:[i64] } ?:{ *:[i64] }:$s1, (NEG8:{ *:[i64] } ?:{ *:[i64] }:$s1)), 1:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  93506 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  93509 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::NEG8),
     /*  93513 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93518 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  93522 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  93524 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  93527 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::ORC8),
     /*  93531 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93536 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  93540 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  93543 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  93545 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  93548 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /*  93552 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93557 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  93560 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  93563 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /*  93566 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  93568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93573 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /*  93580 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  93585 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /*  93590 */     // GIR_Coverage, 3704,
     /*  93590 */     GIR_EraseRootFromParent_Done,
     /*  93591 */   // Label 1477: @93591
     /*  93591 */   GIM_Try, /*On fail goto*//*Label 1478*/ GIMT_Encode4(93684), // Rule ID 3709 //
     /*  93596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  93600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  93604 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  93608 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  93612 */     // MIs[1] Operand 1
     /*  93612 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /*  93617 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /*  93621 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  93623 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, -1:{ *:[i32] }, SETLT:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } (AND:{ *:[i32] } ?:{ *:[i32] }:$s1, (ADDI:{ *:[i32] } ?:{ *:[i32] }:$s1, 1:{ *:[i32] })), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /*  93623 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  93626 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::ADDI),
     /*  93630 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93635 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  93639 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /*  93642 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  93644 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  93647 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::AND),
     /*  93651 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93656 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  93660 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  93663 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  93665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /*  93668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  93670 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  93673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  93676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  93679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  93682 */     GIR_RootConstrainSelectedInstOperands,
     /*  93683 */     // GIR_Coverage, 3709,
     /*  93683 */     GIR_EraseRootFromParent_Done,
     /*  93684 */   // Label 1478: @93684
     /*  93684 */   GIM_Try, /*On fail goto*//*Label 1479*/ GIMT_Encode4(93804), // Rule ID 3712 //
     /*  93689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  93693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  93697 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  93701 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  93705 */     // MIs[1] Operand 1
     /*  93705 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /*  93710 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /*  93714 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  93716 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, -1:{ *:[i64] }, SETLT:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (AND8:{ *:[i64] } ?:{ *:[i64] }:$s1, (ADDI8:{ *:[i64] } ?:{ *:[i64] }:$s1, 1:{ *:[i64] })), 1:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  93716 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  93719 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::ADDI8),
     /*  93723 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93728 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  93732 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /*  93735 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  93737 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  93740 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /*  93744 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93749 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  93753 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  93756 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  93758 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  93761 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /*  93765 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93770 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  93773 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  93776 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /*  93779 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  93781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93786 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /*  93793 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  93798 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /*  93803 */     // GIR_Coverage, 3712,
     /*  93803 */     GIR_EraseRootFromParent_Done,
     /*  93804 */   // Label 1479: @93804
     /*  93804 */   GIM_Try, /*On fail goto*//*Label 1480*/ GIMT_Encode4(93897), // Rule ID 3717 //
     /*  93809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  93813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  93817 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  93821 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  93825 */     // MIs[1] Operand 1
     /*  93825 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /*  93830 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /*  93834 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  93836 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, -1:{ *:[i32] }, SETGE:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } (NAND:{ *:[i32] } ?:{ *:[i32] }:$s1, (ADDI:{ *:[i32] } ?:{ *:[i32] }:$s1, 1:{ *:[i32] })), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /*  93836 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  93839 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::ADDI),
     /*  93843 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93848 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  93852 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /*  93855 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  93857 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  93860 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NAND),
     /*  93864 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93869 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  93873 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  93876 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  93878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /*  93881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  93883 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  93886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  93889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  93892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  93895 */     GIR_RootConstrainSelectedInstOperands,
     /*  93896 */     // GIR_Coverage, 3717,
     /*  93896 */     GIR_EraseRootFromParent_Done,
     /*  93897 */   // Label 1480: @93897
     /*  93897 */   GIM_Try, /*On fail goto*//*Label 1481*/ GIMT_Encode4(94017), // Rule ID 3720 //
     /*  93902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  93906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  93910 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  93914 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  93918 */     // MIs[1] Operand 1
     /*  93918 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /*  93923 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /*  93927 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  93929 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, -1:{ *:[i64] }, SETGE:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (NAND8:{ *:[i64] } ?:{ *:[i64] }:$s1, (ADDI8:{ *:[i64] } ?:{ *:[i64] }:$s1, 1:{ *:[i64] })), 1:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  93929 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  93932 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::ADDI8),
     /*  93936 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93941 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  93945 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /*  93948 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  93950 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  93953 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NAND8),
     /*  93957 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93962 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  93966 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  93969 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  93971 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  93974 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /*  93978 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93983 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  93986 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  93989 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /*  93992 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  93994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93999 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /*  94006 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  94011 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /*  94016 */     // GIR_Coverage, 3720,
     /*  94016 */     GIR_EraseRootFromParent_Done,
     /*  94017 */   // Label 1481: @94017
     /*  94017 */   GIM_Try, /*On fail goto*//*Label 1482*/ GIMT_Encode4(94090), // Rule ID 3725 //
     /*  94022 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94026 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  94030 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  94034 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  94038 */     // MIs[1] Operand 1
     /*  94038 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /*  94043 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /*  94047 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  94049 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, -1:{ *:[i32] }, SETGT:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } (NOR:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s1), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /*  94049 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  94052 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /*  94056 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94061 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  94065 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  94069 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  94071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /*  94074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  94076 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  94079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  94082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  94085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  94088 */     GIR_RootConstrainSelectedInstOperands,
     /*  94089 */     // GIR_Coverage, 3725,
     /*  94089 */     GIR_EraseRootFromParent_Done,
     /*  94090 */   // Label 1482: @94090
     /*  94090 */   GIM_Try, /*On fail goto*//*Label 1483*/ GIMT_Encode4(94190), // Rule ID 3728 //
     /*  94095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  94103 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  94107 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  94111 */     // MIs[1] Operand 1
     /*  94111 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /*  94116 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /*  94120 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  94122 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, -1:{ *:[i64] }, SETGT:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (NOR8:{ *:[i64] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s1), 1:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  94122 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  94125 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /*  94129 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94134 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  94138 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  94142 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  94144 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  94147 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /*  94151 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94156 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  94159 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  94162 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /*  94165 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  94167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94172 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /*  94179 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  94184 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /*  94189 */     // GIR_Coverage, 3728,
     /*  94189 */     GIR_EraseRootFromParent_Done,
     /*  94190 */   // Label 1483: @94190
     /*  94190 */   GIM_Try, /*On fail goto*//*Label 1484*/ GIMT_Encode4(94242), // Rule ID 3733 //
     /*  94195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  94203 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  94207 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  94211 */     // MIs[1] Operand 1
     /*  94211 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /*  94216 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /*  94220 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  94222 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, -1:{ *:[i32] }, SETLE:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$s1, 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /*  94222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /*  94225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  94227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  94231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  94234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  94237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  94240 */     GIR_RootConstrainSelectedInstOperands,
     /*  94241 */     // GIR_Coverage, 3733,
     /*  94241 */     GIR_EraseRootFromParent_Done,
     /*  94242 */   // Label 1484: @94242
     /*  94242 */   GIM_Try, /*On fail goto*//*Label 1485*/ GIMT_Encode4(94321), // Rule ID 3736 //
     /*  94247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  94255 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  94259 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  94263 */     // MIs[1] Operand 1
     /*  94263 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /*  94268 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /*  94272 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  94274 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, -1:{ *:[i64] }, SETLE:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$s1, 1:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  94274 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  94277 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /*  94281 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94286 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  94290 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  94293 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /*  94296 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  94298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94303 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /*  94310 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  94315 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /*  94320 */     // GIR_Coverage, 3736,
     /*  94320 */     GIR_EraseRootFromParent_Done,
     /*  94321 */   // Label 1485: @94321
     /*  94321 */   GIM_Try, /*On fail goto*//*Label 1486*/ GIMT_Encode4(94424), // Rule ID 3029 //
     /*  94326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  94329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  94337 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  94341 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  94345 */     // MIs[1] Operand 1
     /*  94345 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /*  94350 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  94354 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  94358 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /*  94362 */     // MIs[2] Operand 1
     /*  94362 */     // No operand predicates
     /*  94362 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  94364 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_lt:{ *:[i32] }))
     /*  94364 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  94367 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /*  94371 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94376 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  94380 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /*  94383 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  94385 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  94388 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94392 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94397 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  94404 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  94409 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  94414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  94417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  94419 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  94422 */     GIR_RootConstrainSelectedInstOperands,
     /*  94423 */     // GIR_Coverage, 3029,
     /*  94423 */     GIR_EraseRootFromParent_Done,
     /*  94424 */   // Label 1486: @94424
     /*  94424 */   GIM_Try, /*On fail goto*//*Label 1487*/ GIMT_Encode4(94527), // Rule ID 3045 //
     /*  94429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  94432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  94440 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  94444 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  94448 */     // MIs[1] Operand 1
     /*  94448 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /*  94453 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  94457 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  94461 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /*  94465 */     // MIs[2] Operand 1
     /*  94465 */     // No operand predicates
     /*  94465 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  94467 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_gt:{ *:[i32] }))
     /*  94467 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  94470 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /*  94474 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94479 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  94483 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /*  94486 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  94488 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  94491 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94495 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94500 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  94507 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  94512 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  94517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  94520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  94522 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  94525 */     GIR_RootConstrainSelectedInstOperands,
     /*  94526 */     // GIR_Coverage, 3045,
     /*  94526 */     GIR_EraseRootFromParent_Done,
     /*  94527 */   // Label 1487: @94527
     /*  94527 */   GIM_Try, /*On fail goto*//*Label 1488*/ GIMT_Encode4(94630), // Rule ID 3053 //
     /*  94532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  94535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  94543 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  94547 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  94551 */     // MIs[1] Operand 1
     /*  94551 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /*  94556 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  94560 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  94564 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /*  94568 */     // MIs[2] Operand 1
     /*  94568 */     // No operand predicates
     /*  94568 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  94570 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_eq:{ *:[i32] }))
     /*  94570 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  94573 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /*  94577 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94582 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  94586 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /*  94589 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  94591 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  94594 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94598 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94603 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  94610 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  94615 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  94620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  94623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  94625 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  94628 */     GIR_RootConstrainSelectedInstOperands,
     /*  94629 */     // GIR_Coverage, 3053,
     /*  94629 */     GIR_EraseRootFromParent_Done,
     /*  94630 */   // Label 1488: @94630
     /*  94630 */   GIM_Try, /*On fail goto*//*Label 1489*/ GIMT_Encode4(94733), // Rule ID 3125 //
     /*  94635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  94638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  94646 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  94650 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  94654 */     // MIs[1] Operand 1
     /*  94654 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /*  94659 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  94663 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  94667 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /*  94671 */     // MIs[2] Operand 1
     /*  94671 */     // No operand predicates
     /*  94671 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  94673 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_lt:{ *:[i32] }))
     /*  94673 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  94676 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /*  94680 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94685 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  94689 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /*  94692 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  94694 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  94697 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94701 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94706 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  94713 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  94718 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  94723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  94726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  94728 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  94731 */     GIR_RootConstrainSelectedInstOperands,
     /*  94732 */     // GIR_Coverage, 3125,
     /*  94732 */     GIR_EraseRootFromParent_Done,
     /*  94733 */   // Label 1489: @94733
     /*  94733 */   GIM_Try, /*On fail goto*//*Label 1490*/ GIMT_Encode4(94836), // Rule ID 3141 //
     /*  94738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  94741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  94749 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  94753 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  94757 */     // MIs[1] Operand 1
     /*  94757 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /*  94762 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  94766 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  94770 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /*  94774 */     // MIs[2] Operand 1
     /*  94774 */     // No operand predicates
     /*  94774 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  94776 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_gt:{ *:[i32] }))
     /*  94776 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  94779 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /*  94783 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94788 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  94792 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /*  94795 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  94797 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  94800 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94804 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94809 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  94816 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  94821 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  94826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  94829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  94831 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  94834 */     GIR_RootConstrainSelectedInstOperands,
     /*  94835 */     // GIR_Coverage, 3141,
     /*  94835 */     GIR_EraseRootFromParent_Done,
     /*  94836 */   // Label 1490: @94836
     /*  94836 */   GIM_Try, /*On fail goto*//*Label 1491*/ GIMT_Encode4(94939), // Rule ID 3149 //
     /*  94841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  94844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  94852 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  94856 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  94860 */     // MIs[1] Operand 1
     /*  94860 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /*  94865 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  94869 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  94873 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /*  94877 */     // MIs[2] Operand 1
     /*  94877 */     // No operand predicates
     /*  94877 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  94879 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_eq:{ *:[i32] }))
     /*  94879 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  94882 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /*  94886 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94891 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  94895 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /*  94898 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  94900 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  94903 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94907 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94912 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  94919 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  94924 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  94929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  94932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  94934 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  94937 */     GIR_RootConstrainSelectedInstOperands,
     /*  94938 */     // GIR_Coverage, 3149,
     /*  94938 */     GIR_EraseRootFromParent_Done,
     /*  94939 */   // Label 1491: @94939
     /*  94939 */   GIM_Try, /*On fail goto*//*Label 1492*/ GIMT_Encode4(95082), // Rule ID 3783 //
     /*  94944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  94947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  94955 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  94959 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  94963 */     // MIs[1] Operand 1
     /*  94963 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /*  94968 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  94972 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  94976 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /*  94980 */     // MIs[2] Operand 1
     /*  94980 */     // No operand predicates
     /*  94980 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  94982 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /*  94982 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  94985 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /*  94989 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94994 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  94998 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /*  95001 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  95003 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  95006 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  95010 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95015 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /*  95018 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  95020 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  95023 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  95027 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95032 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  95035 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  95037 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  95040 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95044 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95049 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  95056 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  95061 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  95066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /*  95069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95071 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  95074 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  95077 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  95080 */     GIR_RootConstrainSelectedInstOperands,
     /*  95081 */     // GIR_Coverage, 3783,
     /*  95081 */     GIR_EraseRootFromParent_Done,
     /*  95082 */   // Label 1492: @95082
     /*  95082 */   GIM_Try, /*On fail goto*//*Label 1493*/ GIMT_Encode4(95225), // Rule ID 3799 //
     /*  95087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  95090 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95094 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  95098 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  95102 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  95106 */     // MIs[1] Operand 1
     /*  95106 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /*  95111 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  95115 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  95119 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /*  95123 */     // MIs[2] Operand 1
     /*  95123 */     // No operand predicates
     /*  95123 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  95125 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /*  95125 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  95128 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /*  95132 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95137 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  95141 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /*  95144 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  95146 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  95149 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  95153 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95158 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /*  95161 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  95163 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  95166 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  95170 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95175 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  95178 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  95180 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  95183 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95187 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95192 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  95199 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  95204 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  95209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /*  95212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95214 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  95217 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  95220 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  95223 */     GIR_RootConstrainSelectedInstOperands,
     /*  95224 */     // GIR_Coverage, 3799,
     /*  95224 */     GIR_EraseRootFromParent_Done,
     /*  95225 */   // Label 1493: @95225
     /*  95225 */   GIM_Try, /*On fail goto*//*Label 1494*/ GIMT_Encode4(95368), // Rule ID 3807 //
     /*  95230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  95233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  95241 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  95245 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  95249 */     // MIs[1] Operand 1
     /*  95249 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /*  95254 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  95258 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  95262 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /*  95266 */     // MIs[2] Operand 1
     /*  95266 */     // No operand predicates
     /*  95266 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  95268 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /*  95268 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  95271 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /*  95275 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95280 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  95284 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /*  95287 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  95289 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  95292 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  95296 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95301 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /*  95304 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  95306 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  95309 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  95313 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95318 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  95321 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  95323 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  95326 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95330 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95335 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  95342 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  95347 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  95352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /*  95355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95357 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  95360 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  95363 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  95366 */     GIR_RootConstrainSelectedInstOperands,
     /*  95367 */     // GIR_Coverage, 3807,
     /*  95367 */     GIR_EraseRootFromParent_Done,
     /*  95368 */   // Label 1494: @95368
     /*  95368 */   GIM_Try, /*On fail goto*//*Label 1495*/ GIMT_Encode4(95511), // Rule ID 3879 //
     /*  95373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  95376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  95384 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  95388 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  95392 */     // MIs[1] Operand 1
     /*  95392 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /*  95397 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  95401 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  95405 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /*  95409 */     // MIs[2] Operand 1
     /*  95409 */     // No operand predicates
     /*  95409 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  95411 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /*  95411 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  95414 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /*  95418 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95423 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  95427 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /*  95430 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  95432 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  95435 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  95439 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95444 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /*  95447 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  95449 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  95452 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  95456 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95461 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  95464 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  95466 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  95469 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95473 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95478 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  95485 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  95490 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  95495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /*  95498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95500 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  95503 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  95506 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  95509 */     GIR_RootConstrainSelectedInstOperands,
     /*  95510 */     // GIR_Coverage, 3879,
     /*  95510 */     GIR_EraseRootFromParent_Done,
     /*  95511 */   // Label 1495: @95511
     /*  95511 */   GIM_Try, /*On fail goto*//*Label 1496*/ GIMT_Encode4(95654), // Rule ID 3895 //
     /*  95516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  95519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  95527 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  95531 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  95535 */     // MIs[1] Operand 1
     /*  95535 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /*  95540 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  95544 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  95548 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /*  95552 */     // MIs[2] Operand 1
     /*  95552 */     // No operand predicates
     /*  95552 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  95554 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /*  95554 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  95557 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /*  95561 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95566 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  95570 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /*  95573 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  95575 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  95578 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  95582 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95587 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /*  95590 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  95592 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  95595 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  95599 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95604 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  95607 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  95609 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  95612 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95616 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95621 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  95628 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  95633 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  95638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /*  95641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95643 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  95646 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  95649 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  95652 */     GIR_RootConstrainSelectedInstOperands,
     /*  95653 */     // GIR_Coverage, 3895,
     /*  95653 */     GIR_EraseRootFromParent_Done,
     /*  95654 */   // Label 1496: @95654
     /*  95654 */   GIM_Try, /*On fail goto*//*Label 1497*/ GIMT_Encode4(95797), // Rule ID 3903 //
     /*  95659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  95662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  95670 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  95674 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  95678 */     // MIs[1] Operand 1
     /*  95678 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /*  95683 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  95687 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  95691 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /*  95695 */     // MIs[2] Operand 1
     /*  95695 */     // No operand predicates
     /*  95695 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  95697 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /*  95697 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  95700 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /*  95704 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95709 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  95713 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /*  95716 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  95718 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  95721 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  95725 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95730 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /*  95733 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  95735 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  95738 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  95742 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95747 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  95750 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  95752 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  95755 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95759 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95764 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  95771 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  95776 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  95781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /*  95784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95786 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  95789 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  95792 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  95795 */     GIR_RootConstrainSelectedInstOperands,
     /*  95796 */     // GIR_Coverage, 3903,
     /*  95796 */     GIR_EraseRootFromParent_Done,
     /*  95797 */   // Label 1497: @95797
     /*  95797 */   GIM_Try, /*On fail goto*//*Label 1498*/ GIMT_Encode4(95889), // Rule ID 3173 //
     /*  95802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  95805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  95813 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  95817 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  95821 */     // MIs[1] Operand 1
     /*  95821 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /*  95826 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  95828 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_lt:{ *:[i32] }))
     /*  95828 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  95831 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /*  95835 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95840 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  95844 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  95848 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  95850 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  95853 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95857 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95862 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  95869 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  95874 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  95879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  95882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  95884 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  95887 */     GIR_RootConstrainSelectedInstOperands,
     /*  95888 */     // GIR_Coverage, 3173,
     /*  95888 */     GIR_EraseRootFromParent_Done,
     /*  95889 */   // Label 1498: @95889
     /*  95889 */   GIM_Try, /*On fail goto*//*Label 1499*/ GIMT_Encode4(95981), // Rule ID 3189 //
     /*  95894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  95897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  95905 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  95909 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  95913 */     // MIs[1] Operand 1
     /*  95913 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /*  95918 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  95920 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }))
     /*  95920 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  95923 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /*  95927 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95932 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  95936 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  95940 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  95942 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  95945 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95949 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95954 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  95961 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  95966 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  95971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  95974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  95976 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  95979 */     GIR_RootConstrainSelectedInstOperands,
     /*  95980 */     // GIR_Coverage, 3189,
     /*  95980 */     GIR_EraseRootFromParent_Done,
     /*  95981 */   // Label 1499: @95981
     /*  95981 */   GIM_Try, /*On fail goto*//*Label 1500*/ GIMT_Encode4(96073), // Rule ID 3205 //
     /*  95986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  95989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  95997 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  96001 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  96005 */     // MIs[1] Operand 1
     /*  96005 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /*  96010 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96012 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_eq:{ *:[i32] }))
     /*  96012 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  96015 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /*  96019 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96024 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  96028 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  96032 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  96034 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  96037 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96041 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96046 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  96053 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  96058 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  96063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  96066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  96068 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  96071 */     GIR_RootConstrainSelectedInstOperands,
     /*  96072 */     // GIR_Coverage, 3205,
     /*  96072 */     GIR_EraseRootFromParent_Done,
     /*  96073 */   // Label 1500: @96073
     /*  96073 */   GIM_Try, /*On fail goto*//*Label 1501*/ GIMT_Encode4(96165), // Rule ID 3221 //
     /*  96078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  96081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  96089 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  96093 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  96097 */     // MIs[1] Operand 1
     /*  96097 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /*  96102 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96104 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETO:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_un:{ *:[i32] }))
     /*  96104 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  96107 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /*  96111 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96116 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  96120 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  96124 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  96126 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  96129 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96133 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96138 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /*  96145 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  96150 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  96155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  96158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  96160 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  96163 */     GIR_RootConstrainSelectedInstOperands,
     /*  96164 */     // GIR_Coverage, 3221,
     /*  96164 */     GIR_EraseRootFromParent_Done,
     /*  96165 */   // Label 1501: @96165
     /*  96165 */   GIM_Try, /*On fail goto*//*Label 1502*/ GIMT_Encode4(96257), // Rule ID 3229 //
     /*  96170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  96173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  96181 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  96185 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  96189 */     // MIs[1] Operand 1
     /*  96189 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /*  96194 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96196 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_lt:{ *:[i32] }))
     /*  96196 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  96199 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /*  96203 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96208 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  96212 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  96216 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  96218 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  96221 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96225 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96230 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  96237 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  96242 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  96247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  96250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  96252 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  96255 */     GIR_RootConstrainSelectedInstOperands,
     /*  96256 */     // GIR_Coverage, 3229,
     /*  96256 */     GIR_EraseRootFromParent_Done,
     /*  96257 */   // Label 1502: @96257
     /*  96257 */   GIM_Try, /*On fail goto*//*Label 1503*/ GIMT_Encode4(96349), // Rule ID 3245 //
     /*  96262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  96265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  96273 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  96277 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  96281 */     // MIs[1] Operand 1
     /*  96281 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /*  96286 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96288 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }))
     /*  96288 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  96291 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /*  96295 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96300 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  96304 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  96308 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  96310 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  96313 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96317 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96322 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  96329 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  96334 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  96339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  96342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  96344 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  96347 */     GIR_RootConstrainSelectedInstOperands,
     /*  96348 */     // GIR_Coverage, 3245,
     /*  96348 */     GIR_EraseRootFromParent_Done,
     /*  96349 */   // Label 1503: @96349
     /*  96349 */   GIM_Try, /*On fail goto*//*Label 1504*/ GIMT_Encode4(96441), // Rule ID 3261 //
     /*  96354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  96357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  96365 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  96369 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  96373 */     // MIs[1] Operand 1
     /*  96373 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /*  96378 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96380 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_eq:{ *:[i32] }))
     /*  96380 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  96383 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /*  96387 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96392 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  96396 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  96400 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  96402 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  96405 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96409 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96414 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  96421 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  96426 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  96431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  96434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  96436 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  96439 */     GIR_RootConstrainSelectedInstOperands,
     /*  96440 */     // GIR_Coverage, 3261,
     /*  96440 */     GIR_EraseRootFromParent_Done,
     /*  96441 */   // Label 1504: @96441
     /*  96441 */   GIM_Try, /*On fail goto*//*Label 1505*/ GIMT_Encode4(96533), // Rule ID 3277 //
     /*  96446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  96449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  96457 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  96461 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  96465 */     // MIs[1] Operand 1
     /*  96465 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /*  96470 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96472 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETO:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_un:{ *:[i32] }))
     /*  96472 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  96475 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /*  96479 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96484 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  96488 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  96492 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  96494 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  96497 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96501 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96506 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /*  96513 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  96518 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  96523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  96526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  96528 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  96531 */     GIR_RootConstrainSelectedInstOperands,
     /*  96532 */     // GIR_Coverage, 3277,
     /*  96532 */     GIR_EraseRootFromParent_Done,
     /*  96533 */   // Label 1505: @96533
     /*  96533 */   GIM_Try, /*On fail goto*//*Label 1506*/ GIMT_Encode4(96625), // Rule ID 3285 //
     /*  96538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  96541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  96549 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /*  96553 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /*  96557 */     // MIs[1] Operand 1
     /*  96557 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /*  96562 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96564 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_lt:{ *:[i32] }))
     /*  96564 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  96567 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /*  96571 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96576 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  96580 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  96584 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  96586 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  96589 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96593 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96598 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  96605 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  96610 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  96615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  96618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  96620 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  96623 */     GIR_RootConstrainSelectedInstOperands,
     /*  96624 */     // GIR_Coverage, 3285,
     /*  96624 */     GIR_EraseRootFromParent_Done,
     /*  96625 */   // Label 1506: @96625
     /*  96625 */   GIM_Try, /*On fail goto*//*Label 1507*/ GIMT_Encode4(96717), // Rule ID 3301 //
     /*  96630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  96633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  96641 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /*  96645 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /*  96649 */     // MIs[1] Operand 1
     /*  96649 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /*  96654 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96656 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_gt:{ *:[i32] }))
     /*  96656 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  96659 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /*  96663 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96668 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  96672 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  96676 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  96678 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  96681 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96685 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96690 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  96697 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  96702 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  96707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  96710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  96712 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  96715 */     GIR_RootConstrainSelectedInstOperands,
     /*  96716 */     // GIR_Coverage, 3301,
     /*  96716 */     GIR_EraseRootFromParent_Done,
     /*  96717 */   // Label 1507: @96717
     /*  96717 */   GIM_Try, /*On fail goto*//*Label 1508*/ GIMT_Encode4(96809), // Rule ID 3317 //
     /*  96722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  96725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  96733 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /*  96737 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /*  96741 */     // MIs[1] Operand 1
     /*  96741 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /*  96746 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96748 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUNE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_eq:{ *:[i32] }))
     /*  96748 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  96751 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /*  96755 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96760 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  96764 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  96768 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  96770 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  96773 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96777 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96782 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  96789 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  96794 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  96799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  96802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  96804 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  96807 */     GIR_RootConstrainSelectedInstOperands,
     /*  96808 */     // GIR_Coverage, 3317,
     /*  96808 */     GIR_EraseRootFromParent_Done,
     /*  96809 */   // Label 1508: @96809
     /*  96809 */   GIM_Try, /*On fail goto*//*Label 1509*/ GIMT_Encode4(96901), // Rule ID 3333 //
     /*  96814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  96817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  96825 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /*  96829 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /*  96833 */     // MIs[1] Operand 1
     /*  96833 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /*  96838 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96840 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETO:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_un:{ *:[i32] }))
     /*  96840 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  96843 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /*  96847 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96852 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  96856 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  96860 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  96862 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  96865 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96869 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96874 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /*  96881 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  96886 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  96891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  96894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  96896 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  96899 */     GIR_RootConstrainSelectedInstOperands,
     /*  96900 */     // GIR_Coverage, 3333,
     /*  96900 */     GIR_EraseRootFromParent_Done,
     /*  96901 */   // Label 1509: @96901
     /*  96901 */   GIM_Try, /*On fail goto*//*Label 1510*/ GIMT_Encode4(97033), // Rule ID 3988 //
     /*  96906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  96909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  96917 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  96921 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  96925 */     // MIs[1] Operand 1
     /*  96925 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /*  96930 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96932 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /*  96932 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  96935 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /*  96939 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96944 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  96948 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  96952 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  96954 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  96957 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  96961 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96966 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /*  96969 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  96971 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  96974 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  96978 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96983 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  96986 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  96988 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  96991 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96995 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97000 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  97007 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  97012 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  97017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /*  97020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97022 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97025 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  97028 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  97031 */     GIR_RootConstrainSelectedInstOperands,
     /*  97032 */     // GIR_Coverage, 3988,
     /*  97032 */     GIR_EraseRootFromParent_Done,
     /*  97033 */   // Label 1510: @97033
     /*  97033 */   GIM_Try, /*On fail goto*//*Label 1511*/ GIMT_Encode4(97165), // Rule ID 4020 //
     /*  97038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  97041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  97045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  97049 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  97053 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  97057 */     // MIs[1] Operand 1
     /*  97057 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /*  97062 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97064 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /*  97064 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  97067 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /*  97071 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97076 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  97080 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  97084 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  97086 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  97089 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  97093 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97098 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /*  97101 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  97103 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  97106 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  97110 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97115 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  97118 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  97120 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  97123 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97127 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97132 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  97139 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  97144 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  97149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /*  97152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97154 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97157 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  97160 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  97163 */     GIR_RootConstrainSelectedInstOperands,
     /*  97164 */     // GIR_Coverage, 4020,
     /*  97164 */     GIR_EraseRootFromParent_Done,
     /*  97165 */   // Label 1511: @97165
     /*  97165 */   GIM_Try, /*On fail goto*//*Label 1512*/ GIMT_Encode4(97297), // Rule ID 4052 //
     /*  97170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  97173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  97177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  97181 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  97185 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  97189 */     // MIs[1] Operand 1
     /*  97189 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /*  97194 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97196 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /*  97196 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  97199 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /*  97203 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97208 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  97212 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  97216 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  97218 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  97221 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  97225 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97230 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /*  97233 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  97235 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  97238 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  97242 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97247 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  97250 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  97252 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  97255 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97259 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97264 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  97271 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  97276 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  97281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /*  97284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97286 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97289 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  97292 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  97295 */     GIR_RootConstrainSelectedInstOperands,
     /*  97296 */     // GIR_Coverage, 4052,
     /*  97296 */     GIR_EraseRootFromParent_Done,
     /*  97297 */   // Label 1512: @97297
     /*  97297 */   GIM_Try, /*On fail goto*//*Label 1513*/ GIMT_Encode4(97429), // Rule ID 4084 //
     /*  97302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  97305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  97309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  97313 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  97317 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  97321 */     // MIs[1] Operand 1
     /*  97321 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /*  97326 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97328 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETO:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_un:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /*  97328 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  97331 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /*  97335 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97340 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  97344 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  97348 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  97350 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  97353 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  97357 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97362 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /*  97365 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  97367 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  97370 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  97374 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97379 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  97382 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  97384 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  97387 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97391 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97396 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /*  97403 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  97408 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  97413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /*  97416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97418 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97421 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  97424 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  97427 */     GIR_RootConstrainSelectedInstOperands,
     /*  97428 */     // GIR_Coverage, 4084,
     /*  97428 */     GIR_EraseRootFromParent_Done,
     /*  97429 */   // Label 1513: @97429
     /*  97429 */   GIM_Try, /*On fail goto*//*Label 1514*/ GIMT_Encode4(97561), // Rule ID 4100 //
     /*  97434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  97437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  97441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  97445 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  97449 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  97453 */     // MIs[1] Operand 1
     /*  97453 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /*  97458 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97460 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /*  97460 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  97463 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /*  97467 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97472 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  97476 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  97480 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  97482 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  97485 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  97489 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97494 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /*  97497 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  97499 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  97502 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  97506 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97511 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  97514 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  97516 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  97519 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97523 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97528 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  97535 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  97540 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  97545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /*  97548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97550 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97553 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  97556 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  97559 */     GIR_RootConstrainSelectedInstOperands,
     /*  97560 */     // GIR_Coverage, 4100,
     /*  97560 */     GIR_EraseRootFromParent_Done,
     /*  97561 */   // Label 1514: @97561
     /*  97561 */   GIM_Try, /*On fail goto*//*Label 1515*/ GIMT_Encode4(97693), // Rule ID 4132 //
     /*  97566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  97569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  97573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  97577 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  97581 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  97585 */     // MIs[1] Operand 1
     /*  97585 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /*  97590 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97592 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /*  97592 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  97595 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /*  97599 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97604 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  97608 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  97612 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  97614 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  97617 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  97621 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97626 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /*  97629 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  97631 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  97634 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  97638 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97643 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  97646 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  97648 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  97651 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97655 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97660 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  97667 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  97672 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  97677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /*  97680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97682 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97685 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  97688 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  97691 */     GIR_RootConstrainSelectedInstOperands,
     /*  97692 */     // GIR_Coverage, 4132,
     /*  97692 */     GIR_EraseRootFromParent_Done,
     /*  97693 */   // Label 1515: @97693
     /*  97693 */   GIM_Try, /*On fail goto*//*Label 1516*/ GIMT_Encode4(97825), // Rule ID 4164 //
     /*  97698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  97701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  97705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  97709 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  97713 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  97717 */     // MIs[1] Operand 1
     /*  97717 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /*  97722 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97724 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /*  97724 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  97727 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /*  97731 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97736 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  97740 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  97744 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  97746 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  97749 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  97753 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97758 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /*  97761 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  97763 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  97766 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  97770 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97775 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  97778 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  97780 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  97783 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97787 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97792 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  97799 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  97804 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  97809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /*  97812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97814 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97817 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  97820 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  97823 */     GIR_RootConstrainSelectedInstOperands,
     /*  97824 */     // GIR_Coverage, 4164,
     /*  97824 */     GIR_EraseRootFromParent_Done,
     /*  97825 */   // Label 1516: @97825
     /*  97825 */   GIM_Try, /*On fail goto*//*Label 1517*/ GIMT_Encode4(97957), // Rule ID 4196 //
     /*  97830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  97833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  97837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  97841 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  97845 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  97849 */     // MIs[1] Operand 1
     /*  97849 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /*  97854 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97856 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETO:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_un:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /*  97856 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  97859 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /*  97863 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97868 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  97872 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  97876 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  97878 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  97881 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  97885 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97890 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /*  97893 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  97895 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  97898 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  97902 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97907 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  97910 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  97912 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  97915 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97919 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97924 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /*  97931 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  97936 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  97941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /*  97944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97946 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97949 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  97952 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  97955 */     GIR_RootConstrainSelectedInstOperands,
     /*  97956 */     // GIR_Coverage, 4196,
     /*  97956 */     GIR_EraseRootFromParent_Done,
     /*  97957 */   // Label 1517: @97957
     /*  97957 */   GIM_Try, /*On fail goto*//*Label 1518*/ GIMT_Encode4(98089), // Rule ID 4226 //
     /*  97962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  97965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  97969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  97973 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /*  97977 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /*  97981 */     // MIs[1] Operand 1
     /*  97981 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /*  97986 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97988 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /*  97988 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  97991 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /*  97995 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98000 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  98004 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  98008 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  98010 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  98013 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  98017 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98022 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /*  98025 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  98027 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  98030 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  98034 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98039 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  98042 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  98044 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  98047 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  98051 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98056 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  98063 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  98068 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  98073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /*  98076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98078 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98081 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  98084 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  98087 */     GIR_RootConstrainSelectedInstOperands,
     /*  98088 */     // GIR_Coverage, 4226,
     /*  98088 */     GIR_EraseRootFromParent_Done,
     /*  98089 */   // Label 1518: @98089
     /*  98089 */   GIM_Try, /*On fail goto*//*Label 1519*/ GIMT_Encode4(98221), // Rule ID 4258 //
     /*  98094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  98097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  98101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  98105 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /*  98109 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /*  98113 */     // MIs[1] Operand 1
     /*  98113 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /*  98118 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98120 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /*  98120 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  98123 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /*  98127 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98132 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  98136 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  98140 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  98142 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  98145 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  98149 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98154 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /*  98157 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  98159 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  98162 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  98166 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98171 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  98174 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  98176 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  98179 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  98183 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98188 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  98195 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  98200 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  98205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /*  98208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98210 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98213 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  98216 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  98219 */     GIR_RootConstrainSelectedInstOperands,
     /*  98220 */     // GIR_Coverage, 4258,
     /*  98220 */     GIR_EraseRootFromParent_Done,
     /*  98221 */   // Label 1519: @98221
     /*  98221 */   GIM_Try, /*On fail goto*//*Label 1520*/ GIMT_Encode4(98353), // Rule ID 4290 //
     /*  98226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  98229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  98233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  98237 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /*  98241 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /*  98245 */     // MIs[1] Operand 1
     /*  98245 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /*  98250 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98252 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /*  98252 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  98255 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /*  98259 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98264 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  98268 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  98272 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  98274 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  98277 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  98281 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98286 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /*  98289 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  98291 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  98294 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  98298 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98303 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  98306 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  98308 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  98311 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  98315 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98320 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  98327 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  98332 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  98337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /*  98340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98342 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98345 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  98348 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  98351 */     GIR_RootConstrainSelectedInstOperands,
     /*  98352 */     // GIR_Coverage, 4290,
     /*  98352 */     GIR_EraseRootFromParent_Done,
     /*  98353 */   // Label 1520: @98353
     /*  98353 */   GIM_Try, /*On fail goto*//*Label 1521*/ GIMT_Encode4(98485), // Rule ID 4322 //
     /*  98358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  98361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  98365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  98369 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /*  98373 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /*  98377 */     // MIs[1] Operand 1
     /*  98377 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /*  98382 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98384 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETO:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_un:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /*  98384 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  98387 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /*  98391 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98396 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  98400 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  98404 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  98406 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  98409 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  98413 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98418 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /*  98421 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  98423 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  98426 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  98430 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98435 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  98438 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  98440 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  98443 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  98447 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98452 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /*  98459 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  98464 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  98469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /*  98472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98474 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98477 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  98480 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  98483 */     GIR_RootConstrainSelectedInstOperands,
     /*  98484 */     // GIR_Coverage, 4322,
     /*  98484 */     GIR_EraseRootFromParent_Done,
     /*  98485 */   // Label 1521: @98485
     /*  98485 */   GIM_Try, /*On fail goto*//*Label 1522*/ GIMT_Encode4(98617), // Rule ID 4553 //
     /*  98490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /*  98493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  98497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  98501 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  98505 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  98509 */     // MIs[1] Operand 1
     /*  98509 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /*  98514 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98516 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPLT:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /*  98516 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  98519 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPLT),
     /*  98523 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98528 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  98532 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  98536 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  98538 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  98541 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  98545 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98550 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /*  98553 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  98555 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  98558 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  98562 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98567 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  98570 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  98572 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  98575 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  98579 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98584 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  98591 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  98596 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  98601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /*  98604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98606 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98609 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  98612 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  98615 */     GIR_RootConstrainSelectedInstOperands,
     /*  98616 */     // GIR_Coverage, 4553,
     /*  98616 */     GIR_EraseRootFromParent_Done,
     /*  98617 */   // Label 1522: @98617
     /*  98617 */   GIM_Try, /*On fail goto*//*Label 1523*/ GIMT_Encode4(98749), // Rule ID 4585 //
     /*  98622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /*  98625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  98629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  98633 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  98637 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  98641 */     // MIs[1] Operand 1
     /*  98641 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /*  98646 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98648 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPGT:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /*  98648 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  98651 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPGT),
     /*  98655 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98660 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  98664 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  98668 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  98670 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  98673 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  98677 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98682 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /*  98685 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  98687 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  98690 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  98694 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98699 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  98702 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  98704 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  98707 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  98711 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98716 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  98723 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  98728 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  98733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /*  98736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98738 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98741 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  98744 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  98747 */     GIR_RootConstrainSelectedInstOperands,
     /*  98748 */     // GIR_Coverage, 4585,
     /*  98748 */     GIR_EraseRootFromParent_Done,
     /*  98749 */   // Label 1523: @98749
     /*  98749 */   GIM_Try, /*On fail goto*//*Label 1524*/ GIMT_Encode4(98881), // Rule ID 4617 //
     /*  98754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /*  98757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  98761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  98765 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  98769 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  98773 */     // MIs[1] Operand 1
     /*  98773 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /*  98778 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98780 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPEQ:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /*  98780 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  98783 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPEQ),
     /*  98787 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98792 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  98796 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  98800 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  98802 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  98805 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  98809 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98814 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /*  98817 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  98819 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  98822 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  98826 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98831 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  98834 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  98836 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  98839 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  98843 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98848 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  98855 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  98860 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  98865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /*  98868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98870 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98873 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  98876 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  98879 */     GIR_RootConstrainSelectedInstOperands,
     /*  98880 */     // GIR_Coverage, 4617,
     /*  98880 */     GIR_EraseRootFromParent_Done,
     /*  98881 */   // Label 1524: @98881
     /*  98881 */   GIM_Try, /*On fail goto*//*Label 1525*/ GIMT_Encode4(99013), // Rule ID 4661 //
     /*  98886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /*  98889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  98893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  98897 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  98901 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  98905 */     // MIs[1] Operand 1
     /*  98905 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /*  98910 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98912 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPLT:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /*  98912 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  98915 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPLT),
     /*  98919 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98924 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  98928 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  98932 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  98934 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  98937 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  98941 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98946 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /*  98949 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  98951 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  98954 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  98958 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98963 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  98966 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  98968 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  98971 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  98975 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98980 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  98987 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  98992 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  98997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /*  99000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99002 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99005 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  99008 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  99011 */     GIR_RootConstrainSelectedInstOperands,
     /*  99012 */     // GIR_Coverage, 4661,
     /*  99012 */     GIR_EraseRootFromParent_Done,
     /*  99013 */   // Label 1525: @99013
     /*  99013 */   GIM_Try, /*On fail goto*//*Label 1526*/ GIMT_Encode4(99145), // Rule ID 4693 //
     /*  99018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /*  99021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  99025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  99029 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  99033 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  99037 */     // MIs[1] Operand 1
     /*  99037 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /*  99042 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  99044 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPGT:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /*  99044 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  99047 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPGT),
     /*  99051 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99056 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  99060 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  99064 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  99066 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  99069 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  99073 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99078 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /*  99081 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  99083 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  99086 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  99090 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99095 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  99098 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  99100 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  99103 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  99107 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99112 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  99119 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  99124 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  99129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /*  99132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99134 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99137 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  99140 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  99143 */     GIR_RootConstrainSelectedInstOperands,
     /*  99144 */     // GIR_Coverage, 4693,
     /*  99144 */     GIR_EraseRootFromParent_Done,
     /*  99145 */   // Label 1526: @99145
     /*  99145 */   GIM_Try, /*On fail goto*//*Label 1527*/ GIMT_Encode4(99277), // Rule ID 4725 //
     /*  99150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /*  99153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  99157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  99161 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  99165 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  99169 */     // MIs[1] Operand 1
     /*  99169 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /*  99174 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  99176 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPEQ:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /*  99176 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  99179 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPEQ),
     /*  99183 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99188 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  99192 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  99196 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  99198 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  99201 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  99205 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99210 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /*  99213 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  99215 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  99218 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  99222 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99227 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  99230 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  99232 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  99235 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  99239 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99244 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  99251 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  99256 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  99261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /*  99264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99266 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99269 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  99272 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  99275 */     GIR_RootConstrainSelectedInstOperands,
     /*  99276 */     // GIR_Coverage, 4725,
     /*  99276 */     GIR_EraseRootFromParent_Done,
     /*  99277 */   // Label 1527: @99277
     /*  99277 */   GIM_Try, /*On fail goto*//*Label 1528*/ GIMT_Encode4(99369), // Rule ID 2975 //
     /*  99282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  99285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  99289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  99293 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  99297 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  99301 */     // MIs[1] Operand 1
     /*  99301 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /*  99306 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  99308 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }))
     /*  99308 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  99311 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /*  99315 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99320 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  99324 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  99328 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  99330 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  99333 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  99337 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99342 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  99349 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  99354 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  99359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  99362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  99364 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99367 */     GIR_RootConstrainSelectedInstOperands,
     /*  99368 */     // GIR_Coverage, 2975,
     /*  99368 */     GIR_EraseRootFromParent_Done,
     /*  99369 */   // Label 1528: @99369
     /*  99369 */   GIM_Try, /*On fail goto*//*Label 1529*/ GIMT_Encode4(99461), // Rule ID 2989 //
     /*  99374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  99377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  99381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  99385 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  99389 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  99393 */     // MIs[1] Operand 1
     /*  99393 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /*  99398 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  99400 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETGE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }))
     /*  99400 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  99403 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /*  99407 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99412 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  99416 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  99420 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  99422 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  99425 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  99429 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99434 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  99441 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  99446 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  99451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  99454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  99456 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99459 */     GIR_RootConstrainSelectedInstOperands,
     /*  99460 */     // GIR_Coverage, 2989,
     /*  99460 */     GIR_EraseRootFromParent_Done,
     /*  99461 */   // Label 1529: @99461
     /*  99461 */   GIM_Try, /*On fail goto*//*Label 1530*/ GIMT_Encode4(99553), // Rule ID 2997 //
     /*  99466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  99469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  99473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  99477 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  99481 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  99485 */     // MIs[1] Operand 1
     /*  99485 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /*  99490 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  99492 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }))
     /*  99492 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  99495 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /*  99499 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99504 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  99508 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  99512 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  99514 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  99517 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  99521 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99526 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  99533 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  99538 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  99543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  99546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  99548 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99551 */     GIR_RootConstrainSelectedInstOperands,
     /*  99552 */     // GIR_Coverage, 2997,
     /*  99552 */     GIR_EraseRootFromParent_Done,
     /*  99553 */   // Label 1530: @99553
     /*  99553 */   GIM_Try, /*On fail goto*//*Label 1531*/ GIMT_Encode4(99645), // Rule ID 3005 //
     /*  99558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  99561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  99565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  99569 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  99573 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  99577 */     // MIs[1] Operand 1
     /*  99577 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /*  99582 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  99584 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETLE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }))
     /*  99584 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  99587 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /*  99591 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99596 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  99600 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  99604 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  99606 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  99609 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  99613 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99618 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  99625 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  99630 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  99635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  99638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  99640 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99643 */     GIR_RootConstrainSelectedInstOperands,
     /*  99644 */     // GIR_Coverage, 3005,
     /*  99644 */     GIR_EraseRootFromParent_Done,
     /*  99645 */   // Label 1531: @99645
     /*  99645 */   GIM_Try, /*On fail goto*//*Label 1532*/ GIMT_Encode4(99737), // Rule ID 3013 //
     /*  99650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  99653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  99657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  99661 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  99665 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  99669 */     // MIs[1] Operand 1
     /*  99669 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /*  99674 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  99676 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETNE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_eq:{ *:[i32] }))
     /*  99676 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  99679 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /*  99683 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99688 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  99692 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  99696 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  99698 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  99701 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  99705 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99710 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  99717 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  99722 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  99727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  99730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  99732 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99735 */     GIR_RootConstrainSelectedInstOperands,
     /*  99736 */     // GIR_Coverage, 3013,
     /*  99736 */     GIR_EraseRootFromParent_Done,
     /*  99737 */   // Label 1532: @99737
     /*  99737 */   GIM_Try, /*On fail goto*//*Label 1533*/ GIMT_Encode4(99829), // Rule ID 3077 //
     /*  99742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  99745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  99749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  99753 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  99757 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  99761 */     // MIs[1] Operand 1
     /*  99761 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /*  99766 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  99768 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }))
     /*  99768 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  99771 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /*  99775 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99780 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  99784 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  99788 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  99790 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  99793 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  99797 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99802 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  99809 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  99814 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  99819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  99822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  99824 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99827 */     GIR_RootConstrainSelectedInstOperands,
     /*  99828 */     // GIR_Coverage, 3077,
     /*  99828 */     GIR_EraseRootFromParent_Done,
     /*  99829 */   // Label 1533: @99829
     /*  99829 */   GIM_Try, /*On fail goto*//*Label 1534*/ GIMT_Encode4(99921), // Rule ID 3085 //
     /*  99834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  99837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  99841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  99845 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  99849 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  99853 */     // MIs[1] Operand 1
     /*  99853 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /*  99858 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  99860 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETGE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }))
     /*  99860 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  99863 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /*  99867 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99872 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  99876 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  99880 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  99882 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  99885 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  99889 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99894 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  99901 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  99906 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  99911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  99914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  99916 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99919 */     GIR_RootConstrainSelectedInstOperands,
     /*  99920 */     // GIR_Coverage, 3085,
     /*  99920 */     GIR_EraseRootFromParent_Done,
     /*  99921 */   // Label 1534: @99921
     /*  99921 */   GIM_Try, /*On fail goto*//*Label 1535*/ GIMT_Encode4(100013), // Rule ID 3093 //
     /*  99926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  99929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  99933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  99937 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  99941 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  99945 */     // MIs[1] Operand 1
     /*  99945 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /*  99950 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  99952 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }))
     /*  99952 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  99955 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /*  99959 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99964 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  99968 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  99972 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  99974 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  99977 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  99981 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99986 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  99993 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  99998 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 100003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 100006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 100008 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100011 */     GIR_RootConstrainSelectedInstOperands,
     /* 100012 */     // GIR_Coverage, 3093,
     /* 100012 */     GIR_EraseRootFromParent_Done,
     /* 100013 */   // Label 1535: @100013
     /* 100013 */   GIM_Try, /*On fail goto*//*Label 1536*/ GIMT_Encode4(100105), // Rule ID 3101 //
     /* 100018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 100021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 100025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 100029 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 100033 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 100037 */     // MIs[1] Operand 1
     /* 100037 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 100042 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100044 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETLE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }))
     /* 100044 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 100047 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 100051 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100056 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 100060 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 100064 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 100066 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 100069 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 100073 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100078 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 100085 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 100090 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 100095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 100098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 100100 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100103 */     GIR_RootConstrainSelectedInstOperands,
     /* 100104 */     // GIR_Coverage, 3101,
     /* 100104 */     GIR_EraseRootFromParent_Done,
     /* 100105 */   // Label 1536: @100105
     /* 100105 */   GIM_Try, /*On fail goto*//*Label 1537*/ GIMT_Encode4(100197), // Rule ID 3109 //
     /* 100110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 100113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 100117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 100121 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 100125 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 100129 */     // MIs[1] Operand 1
     /* 100129 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 100134 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100136 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETNE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_eq:{ *:[i32] }))
     /* 100136 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 100139 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 100143 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100148 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 100152 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 100156 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 100158 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 100161 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 100165 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100170 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 100177 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 100182 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 100187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 100190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 100192 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100195 */     GIR_RootConstrainSelectedInstOperands,
     /* 100196 */     // GIR_Coverage, 3109,
     /* 100196 */     GIR_EraseRootFromParent_Done,
     /* 100197 */   // Label 1537: @100197
     /* 100197 */   GIM_Try, /*On fail goto*//*Label 1538*/ GIMT_Encode4(100329), // Rule ID 3831 //
     /* 100202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 100205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 100209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 100213 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 100217 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 100221 */     // MIs[1] Operand 1
     /* 100221 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 100226 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100228 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 100228 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 100231 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 100235 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100240 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 100244 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 100248 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 100250 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 100253 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 100257 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100262 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 100265 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 100267 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 100270 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 100274 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100279 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 100282 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 100284 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 100287 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 100291 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100296 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 100303 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 100308 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 100313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 100316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100318 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100321 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 100324 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 100327 */     GIR_RootConstrainSelectedInstOperands,
     /* 100328 */     // GIR_Coverage, 3831,
     /* 100328 */     GIR_EraseRootFromParent_Done,
     /* 100329 */   // Label 1538: @100329
     /* 100329 */   GIM_Try, /*On fail goto*//*Label 1539*/ GIMT_Encode4(100461), // Rule ID 3839 //
     /* 100334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 100337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 100341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 100345 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 100349 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 100353 */     // MIs[1] Operand 1
     /* 100353 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 100358 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100360 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 100360 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 100363 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 100367 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100372 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 100376 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 100380 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 100382 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 100385 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 100389 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100394 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 100397 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 100399 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 100402 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 100406 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100411 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 100414 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 100416 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 100419 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 100423 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100428 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 100435 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 100440 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 100445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 100448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100450 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100453 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 100456 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 100459 */     GIR_RootConstrainSelectedInstOperands,
     /* 100460 */     // GIR_Coverage, 3839,
     /* 100460 */     GIR_EraseRootFromParent_Done,
     /* 100461 */   // Label 1539: @100461
     /* 100461 */   GIM_Try, /*On fail goto*//*Label 1540*/ GIMT_Encode4(100593), // Rule ID 3847 //
     /* 100466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 100469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 100473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 100477 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 100481 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 100485 */     // MIs[1] Operand 1
     /* 100485 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 100490 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100492 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 100492 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 100495 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 100499 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100504 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 100508 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 100512 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 100514 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 100517 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 100521 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100526 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 100529 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 100531 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 100534 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 100538 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100543 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 100546 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 100548 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 100551 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 100555 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100560 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 100567 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 100572 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 100577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 100580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100582 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100585 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 100588 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 100591 */     GIR_RootConstrainSelectedInstOperands,
     /* 100592 */     // GIR_Coverage, 3847,
     /* 100592 */     GIR_EraseRootFromParent_Done,
     /* 100593 */   // Label 1540: @100593
     /* 100593 */   GIM_Try, /*On fail goto*//*Label 1541*/ GIMT_Encode4(100725), // Rule ID 3855 //
     /* 100598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 100601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 100605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 100609 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 100613 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 100617 */     // MIs[1] Operand 1
     /* 100617 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 100622 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100624 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETLE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 100624 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 100627 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 100631 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100636 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 100640 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 100644 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 100646 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 100649 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 100653 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100658 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 100661 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 100663 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 100666 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 100670 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100675 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 100678 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 100680 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 100683 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 100687 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100692 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 100699 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 100704 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 100709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 100712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100714 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100717 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 100720 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 100723 */     GIR_RootConstrainSelectedInstOperands,
     /* 100724 */     // GIR_Coverage, 3855,
     /* 100724 */     GIR_EraseRootFromParent_Done,
     /* 100725 */   // Label 1541: @100725
     /* 100725 */   GIM_Try, /*On fail goto*//*Label 1542*/ GIMT_Encode4(100857), // Rule ID 3863 //
     /* 100730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 100733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 100737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 100741 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 100745 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 100749 */     // MIs[1] Operand 1
     /* 100749 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 100754 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100756 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 100756 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 100759 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 100763 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100768 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 100772 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 100776 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 100778 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 100781 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 100785 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100790 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 100793 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 100795 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 100798 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 100802 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100807 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 100810 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 100812 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 100815 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 100819 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100824 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 100831 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 100836 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 100841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 100844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100846 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100849 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 100852 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 100855 */     GIR_RootConstrainSelectedInstOperands,
     /* 100856 */     // GIR_Coverage, 3863,
     /* 100856 */     GIR_EraseRootFromParent_Done,
     /* 100857 */   // Label 1542: @100857
     /* 100857 */   GIM_Try, /*On fail goto*//*Label 1543*/ GIMT_Encode4(100989), // Rule ID 3927 //
     /* 100862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 100865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 100869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 100873 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 100877 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 100881 */     // MIs[1] Operand 1
     /* 100881 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 100886 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100888 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 100888 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 100891 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 100895 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100900 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 100904 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 100908 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 100910 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 100913 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 100917 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100922 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 100925 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 100927 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 100930 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 100934 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100939 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 100942 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 100944 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 100947 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 100951 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100956 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 100963 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 100968 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 100973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 100976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100978 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100981 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 100984 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 100987 */     GIR_RootConstrainSelectedInstOperands,
     /* 100988 */     // GIR_Coverage, 3927,
     /* 100988 */     GIR_EraseRootFromParent_Done,
     /* 100989 */   // Label 1543: @100989
     /* 100989 */   GIM_Try, /*On fail goto*//*Label 1544*/ GIMT_Encode4(101121), // Rule ID 3935 //
     /* 100994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 100997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 101005 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 101009 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 101013 */     // MIs[1] Operand 1
     /* 101013 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 101018 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101020 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 101020 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 101023 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 101027 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101032 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 101036 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 101040 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 101042 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 101045 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 101049 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101054 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 101057 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 101059 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 101062 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 101066 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101071 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 101074 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 101076 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 101079 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 101083 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101088 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 101095 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 101100 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 101105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 101108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101110 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101113 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 101116 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 101119 */     GIR_RootConstrainSelectedInstOperands,
     /* 101120 */     // GIR_Coverage, 3935,
     /* 101120 */     GIR_EraseRootFromParent_Done,
     /* 101121 */   // Label 1544: @101121
     /* 101121 */   GIM_Try, /*On fail goto*//*Label 1545*/ GIMT_Encode4(101253), // Rule ID 3943 //
     /* 101126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 101129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 101137 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 101141 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 101145 */     // MIs[1] Operand 1
     /* 101145 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 101150 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101152 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 101152 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 101155 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 101159 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101164 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 101168 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 101172 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 101174 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 101177 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 101181 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101186 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 101189 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 101191 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 101194 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 101198 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101203 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 101206 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 101208 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 101211 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 101215 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101220 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 101227 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 101232 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 101237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 101240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101242 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101245 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 101248 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 101251 */     GIR_RootConstrainSelectedInstOperands,
     /* 101252 */     // GIR_Coverage, 3943,
     /* 101252 */     GIR_EraseRootFromParent_Done,
     /* 101253 */   // Label 1545: @101253
     /* 101253 */   GIM_Try, /*On fail goto*//*Label 1546*/ GIMT_Encode4(101385), // Rule ID 3951 //
     /* 101258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 101261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 101269 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 101273 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 101277 */     // MIs[1] Operand 1
     /* 101277 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 101282 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101284 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETLE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 101284 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 101287 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 101291 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101296 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 101300 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 101304 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 101306 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 101309 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 101313 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101318 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 101321 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 101323 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 101326 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 101330 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101335 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 101338 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 101340 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 101343 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 101347 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101352 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 101359 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 101364 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 101369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 101372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101374 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101377 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 101380 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 101383 */     GIR_RootConstrainSelectedInstOperands,
     /* 101384 */     // GIR_Coverage, 3951,
     /* 101384 */     GIR_EraseRootFromParent_Done,
     /* 101385 */   // Label 1546: @101385
     /* 101385 */   GIM_Try, /*On fail goto*//*Label 1547*/ GIMT_Encode4(101517), // Rule ID 3959 //
     /* 101390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 101393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 101401 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 101405 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 101409 */     // MIs[1] Operand 1
     /* 101409 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 101414 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101416 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 101416 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 101419 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 101423 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101428 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 101432 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 101436 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 101438 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 101441 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 101445 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101450 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 101453 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 101455 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 101458 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 101462 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101467 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 101470 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 101472 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 101475 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 101479 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101484 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 101491 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 101496 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 101501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 101504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101506 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101509 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 101512 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 101515 */     GIR_RootConstrainSelectedInstOperands,
     /* 101516 */     // GIR_Coverage, 3959,
     /* 101516 */     GIR_EraseRootFromParent_Done,
     /* 101517 */   // Label 1547: @101517
     /* 101517 */   GIM_Try, /*On fail goto*//*Label 1548*/ GIMT_Encode4(101532), // Rule ID 2981 //
     /* 101522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 101525 */     // (anyext:{ *:[i32] } i1:{ *:[i1] }:$in)  =>  (SETBC:{ *:[i32] } ?:{ *:[i1] }:$in)
     /* 101525 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SETBC),
     /* 101530 */     GIR_RootConstrainSelectedInstOperands,
     /* 101531 */     // GIR_Coverage, 2981,
     /* 101531 */     GIR_Done,
     /* 101532 */   // Label 1548: @101532
     /* 101532 */   GIM_Try, /*On fail goto*//*Label 1549*/ GIMT_Encode4(101586), // Rule ID 3637 //
     /* 101537 */     // (anyext:{ *:[i32] } i1:{ *:[i1] }:$in)  =>  (SELECT_I4:{ *:[i32] } ?:{ *:[i1] }:$in, (LI:{ *:[i32] } 1:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }))
     /* 101537 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 101540 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 101544 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101549 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 101552 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 101554 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 101557 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 101561 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101566 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 101569 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 101571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 101574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101576 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /* 101578 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101581 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 101584 */     GIR_RootConstrainSelectedInstOperands,
     /* 101585 */     // GIR_Coverage, 3637,
     /* 101585 */     GIR_EraseRootFromParent_Done,
     /* 101586 */   // Label 1549: @101586
     /* 101586 */   GIM_Reject,
     /* 101587 */ // Label 1457: @101587
     /* 101587 */ GIM_Reject,
     /* 101588 */ // Label 1455: @101588
     /* 101588 */ GIM_Try, /*On fail goto*//*Label 1550*/ GIMT_Encode4(112102),
     /* 101593 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 101596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 101600 */   GIM_Try, /*On fail goto*//*Label 1551*/ GIMT_Encode4(101709), // Rule ID 5257 //
     /* 101605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 101613 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 101617 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 101621 */     // MIs[1] Operand 1
     /* 101621 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 101626 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 101630 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 101634 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 101638 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 101642 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 101646 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 101650 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 101654 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 101658 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 101662 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 101666 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 101668 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } (and:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, i32:{ *:[i32] }:$sa), i64:{ *:[i64] }:$s1), 0:{ *:[i64] }, SETNE:{ *:[Other] }))  =>  (RLDCL:{ *:[i64] } ?:{ *:[i64] }:$s1, (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 64:{ *:[i32] }), 63:{ *:[i32] })
     /* 101668 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 101671 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 101675 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101680 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 101684 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/64,
     /* 101687 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for PPC::CARRY*/0,
     /* 101690 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 101692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDCL),
     /* 101695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 101697 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /* 101701 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 101707 */     GIR_RootConstrainSelectedInstOperands,
     /* 101708 */     // GIR_Coverage, 5257,
     /* 101708 */     GIR_EraseRootFromParent_Done,
     /* 101709 */   // Label 1551: @101709
     /* 101709 */   GIM_Try, /*On fail goto*//*Label 1552*/ GIMT_Encode4(101872), // Rule ID 5258 //
     /* 101714 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101718 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 101722 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 101726 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 101730 */     // MIs[1] Operand 1
     /* 101730 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 101735 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 101739 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 101743 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 101747 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 101751 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 101755 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 101759 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 101763 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 101767 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 101771 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 101775 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 101777 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } (and:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$sa), i32:{ *:[i32] }:$s1), 0:{ *:[i32] }, SETNE:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWNM:{ *:[i32] } ?:{ *:[i32] }:$s1, (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 32:{ *:[i32] }), 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 101777 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 101780 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 101784 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101789 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 101793 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/32,
     /* 101796 */     GIR_SetImplicitDefDead, /*InsnID*/3, /*OpIdx for PPC::CARRY*/0,
     /* 101799 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 101801 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 101804 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWNM),
     /* 101808 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101813 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /* 101817 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 101820 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 101823 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 101826 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 101828 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 101831 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101835 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101840 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 101842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 101845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101847 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101850 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 101853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 101856 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 101861 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 101866 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 101871 */     // GIR_Coverage, 5258,
     /* 101871 */     GIR_EraseRootFromParent_Done,
     /* 101872 */   // Label 1552: @101872
     /* 101872 */   GIM_Try, /*On fail goto*//*Label 1553*/ GIMT_Encode4(102002), // Rule ID 5265 //
     /* 101877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 101885 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 101889 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 101893 */     // MIs[1] Operand 1
     /* 101893 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 101898 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 101902 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 101906 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 101910 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 101914 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 101918 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 101922 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 101926 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 101930 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 101934 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 101938 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 101940 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } (and:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, i32:{ *:[i32] }:$sa), i64:{ *:[i64] }:$s1), 0:{ *:[i64] }, SETEQ:{ *:[Other] }))  =>  (RLDCL:{ *:[i64] } (NOR8:{ *:[i64] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s1), (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 64:{ *:[i32] }), 63:{ *:[i32] })
     /* 101940 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 101943 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 101947 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101952 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 101956 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/64,
     /* 101959 */     GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for PPC::CARRY*/0,
     /* 101962 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 101964 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 101967 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /* 101971 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101976 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /* 101980 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /* 101984 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 101986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDCL),
     /* 101989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 101991 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101994 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 101997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 102000 */     GIR_RootConstrainSelectedInstOperands,
     /* 102001 */     // GIR_Coverage, 5265,
     /* 102001 */     GIR_EraseRootFromParent_Done,
     /* 102002 */   // Label 1553: @102002
     /* 102002 */   GIM_Try, /*On fail goto*//*Label 1554*/ GIMT_Encode4(102186), // Rule ID 5266 //
     /* 102007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 102011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 102015 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 102019 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 102023 */     // MIs[1] Operand 1
     /* 102023 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 102028 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 102032 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 102036 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 102040 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 102044 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 102048 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 102052 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 102056 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 102060 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 102064 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 102068 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 102070 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } (and:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$sa), i32:{ *:[i32] }:$s1), 0:{ *:[i32] }, SETEQ:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWNM:{ *:[i32] } (NOR:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s1), (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 32:{ *:[i32] }), 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 102070 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 102073 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 102077 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102082 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 102086 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/32,
     /* 102089 */     GIR_SetImplicitDefDead, /*InsnID*/4, /*OpIdx for PPC::CARRY*/0,
     /* 102092 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 102094 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 102097 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /* 102101 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102106 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /* 102110 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /* 102114 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 102116 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 102119 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWNM),
     /* 102123 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102128 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 102131 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 102134 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 102137 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 102140 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 102142 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 102145 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102149 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102154 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 102156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 102159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102161 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102164 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 102167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 102170 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 102175 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 102180 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 102185 */     // GIR_Coverage, 5266,
     /* 102185 */     GIR_EraseRootFromParent_Done,
     /* 102186 */   // Label 1554: @102186
     /* 102186 */   GIM_Try, /*On fail goto*//*Label 1555*/ GIMT_Encode4(102295), // Rule ID 3742 //
     /* 102191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 102195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 102199 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 102203 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 102207 */     // MIs[1] Operand 1
     /* 102207 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 102212 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 102216 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 102220 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 102224 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 102228 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 102232 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 102236 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 102240 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 102244 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 102248 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 102252 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 102254 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } (and:{ *:[i64] } i64:{ *:[i64] }:$s1, (shl:{ *:[i64] } 1:{ *:[i64] }, i32:{ *:[i32] }:$sa)), 0:{ *:[i64] }, SETNE:{ *:[Other] }))  =>  (RLDCL:{ *:[i64] } ?:{ *:[i64] }:$s1, (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 64:{ *:[i32] }), 63:{ *:[i32] })
     /* 102254 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 102257 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 102261 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102266 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 102270 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/64,
     /* 102273 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for PPC::CARRY*/0,
     /* 102276 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 102278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDCL),
     /* 102281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 102283 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /* 102287 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 102293 */     GIR_RootConstrainSelectedInstOperands,
     /* 102294 */     // GIR_Coverage, 3742,
     /* 102294 */     GIR_EraseRootFromParent_Done,
     /* 102295 */   // Label 1555: @102295
     /* 102295 */   GIM_Try, /*On fail goto*//*Label 1556*/ GIMT_Encode4(102458), // Rule ID 3743 //
     /* 102300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 102304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 102308 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 102312 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 102316 */     // MIs[1] Operand 1
     /* 102316 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 102321 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 102325 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 102329 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 102333 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 102337 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 102341 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 102345 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 102349 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 102353 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 102357 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 102361 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 102363 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } (and:{ *:[i32] } i32:{ *:[i32] }:$s1, (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$sa)), 0:{ *:[i32] }, SETNE:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWNM:{ *:[i32] } ?:{ *:[i32] }:$s1, (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 32:{ *:[i32] }), 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 102363 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 102366 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 102370 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102375 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 102379 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/32,
     /* 102382 */     GIR_SetImplicitDefDead, /*InsnID*/3, /*OpIdx for PPC::CARRY*/0,
     /* 102385 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 102387 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 102390 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWNM),
     /* 102394 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102399 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /* 102403 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 102406 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 102409 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 102412 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 102414 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 102417 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102421 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102426 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 102428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 102431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102433 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102436 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 102439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 102442 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 102447 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 102452 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 102457 */     // GIR_Coverage, 3743,
     /* 102457 */     GIR_EraseRootFromParent_Done,
     /* 102458 */   // Label 1556: @102458
     /* 102458 */   GIM_Try, /*On fail goto*//*Label 1557*/ GIMT_Encode4(102588), // Rule ID 3750 //
     /* 102463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 102467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 102471 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 102475 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 102479 */     // MIs[1] Operand 1
     /* 102479 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 102484 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 102488 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 102492 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 102496 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 102500 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 102504 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 102508 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 102512 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 102516 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 102520 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 102524 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 102526 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } (and:{ *:[i64] } i64:{ *:[i64] }:$s1, (shl:{ *:[i64] } 1:{ *:[i64] }, i32:{ *:[i32] }:$sa)), 0:{ *:[i64] }, SETEQ:{ *:[Other] }))  =>  (RLDCL:{ *:[i64] } (NOR8:{ *:[i64] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s1), (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 64:{ *:[i32] }), 63:{ *:[i32] })
     /* 102526 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 102529 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 102533 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102538 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 102542 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/64,
     /* 102545 */     GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for PPC::CARRY*/0,
     /* 102548 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 102550 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 102553 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /* 102557 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102562 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /* 102566 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /* 102570 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 102572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDCL),
     /* 102575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 102577 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102580 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 102583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 102586 */     GIR_RootConstrainSelectedInstOperands,
     /* 102587 */     // GIR_Coverage, 3750,
     /* 102587 */     GIR_EraseRootFromParent_Done,
     /* 102588 */   // Label 1557: @102588
     /* 102588 */   GIM_Try, /*On fail goto*//*Label 1558*/ GIMT_Encode4(102772), // Rule ID 3751 //
     /* 102593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 102597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 102601 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 102605 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 102609 */     // MIs[1] Operand 1
     /* 102609 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 102614 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 102618 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 102622 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 102626 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 102630 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 102634 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 102638 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 102642 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 102646 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 102650 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 102654 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 102656 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } (and:{ *:[i32] } i32:{ *:[i32] }:$s1, (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$sa)), 0:{ *:[i32] }, SETEQ:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWNM:{ *:[i32] } (NOR:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s1), (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 32:{ *:[i32] }), 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 102656 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 102659 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 102663 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102668 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 102672 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/32,
     /* 102675 */     GIR_SetImplicitDefDead, /*InsnID*/4, /*OpIdx for PPC::CARRY*/0,
     /* 102678 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 102680 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 102683 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /* 102687 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102692 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /* 102696 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /* 102700 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 102702 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 102705 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWNM),
     /* 102709 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102714 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 102717 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 102720 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 102723 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 102726 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 102728 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 102731 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102735 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102740 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 102742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 102745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102747 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102750 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 102753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 102756 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 102761 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 102766 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 102771 */     // GIR_Coverage, 3751,
     /* 102771 */     GIR_EraseRootFromParent_Done,
     /* 102772 */   // Label 1558: @102772
     /* 102772 */   GIM_Try, /*On fail goto*//*Label 1559*/ GIMT_Encode4(102838), // Rule ID 3662 //
     /* 102777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 102781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 102785 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 102789 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 102793 */     // MIs[1] Operand 1
     /* 102793 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 102798 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 102802 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 102804 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETEQ:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } (CNTLZD:{ *:[i64] } ?:{ *:[i64] }:$s1), 58:{ *:[i32] }, 63:{ *:[i32] })
     /* 102804 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 102807 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CNTLZD),
     /* 102811 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102816 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 102820 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 102822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 102825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 102827 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/58,
     /* 102833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 102836 */     GIR_RootConstrainSelectedInstOperands,
     /* 102837 */     // GIR_Coverage, 3662,
     /* 102837 */     GIR_EraseRootFromParent_Done,
     /* 102838 */   // Label 1559: @102838
     /* 102838 */   GIM_Try, /*On fail goto*//*Label 1560*/ GIMT_Encode4(102958), // Rule ID 3663 //
     /* 102843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 102847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 102851 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 102855 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 102859 */     // MIs[1] Operand 1
     /* 102859 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 102864 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 102868 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 102870 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETEQ:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } (CNTLZW:{ *:[i32] } ?:{ *:[i32] }:$s1), 27:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 102870 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 102873 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::CNTLZW),
     /* 102877 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102882 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 102886 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 102888 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 102891 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 102895 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102900 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 102903 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/27,
     /* 102906 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 102909 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 102912 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 102914 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 102917 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102921 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102926 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 102928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 102931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102933 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102936 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 102939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 102942 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 102947 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 102952 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 102957 */     // GIR_Coverage, 3663,
     /* 102957 */     GIR_EraseRootFromParent_Done,
     /* 102958 */   // Label 1560: @102958
     /* 102958 */   GIM_Try, /*On fail goto*//*Label 1561*/ GIMT_Encode4(103062), // Rule ID 3670 //
     /* 102963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 102967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 102971 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 102975 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 102979 */     // MIs[1] Operand 1
     /* 102979 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 102984 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 102988 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 102990 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETNE:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } (NOR8:{ *:[i64] } (CNTLZD:{ *:[i64] } ?:{ *:[i64] }:$s1), (CNTLZD:{ *:[i64] } ?:{ *:[i64] }:$s1)), 58:{ *:[i32] }, 63:{ *:[i32] })
     /* 102990 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 102993 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::CNTLZD),
     /* 102997 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103002 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 103006 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 103008 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 103011 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CNTLZD),
     /* 103015 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103020 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 103024 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103026 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 103029 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /* 103033 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103038 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 103041 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 103044 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 103049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 103051 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/58,
     /* 103057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 103060 */     GIR_RootConstrainSelectedInstOperands,
     /* 103061 */     // GIR_Coverage, 3670,
     /* 103061 */     GIR_EraseRootFromParent_Done,
     /* 103062 */   // Label 1561: @103062
     /* 103062 */   GIM_Try, /*On fail goto*//*Label 1562*/ GIMT_Encode4(103220), // Rule ID 3671 //
     /* 103067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 103071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 103075 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 103079 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 103083 */     // MIs[1] Operand 1
     /* 103083 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 103088 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 103092 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103094 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETNE:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } (NOR:{ *:[i32] } (CNTLZW:{ *:[i32] } ?:{ *:[i32] }:$s1), (CNTLZW:{ *:[i32] } ?:{ *:[i32] }:$s1)), 27:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 103094 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 103097 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(PPC::CNTLZW),
     /* 103101 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103106 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 103110 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 103112 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 103115 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::CNTLZW),
     /* 103119 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103124 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 103128 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 103130 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 103133 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /* 103137 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103142 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 103145 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 103148 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 103150 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 103153 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 103157 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103162 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 103165 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/27,
     /* 103168 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 103171 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 103174 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103176 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 103179 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 103183 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103188 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 103193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103195 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103198 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 103201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 103204 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 103209 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 103214 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 103219 */     // GIR_Coverage, 3671,
     /* 103219 */     GIR_EraseRootFromParent_Done,
     /* 103220 */   // Label 1562: @103220
     /* 103220 */   GIM_Try, /*On fail goto*//*Label 1563*/ GIMT_Encode4(103269), // Rule ID 3678 //
     /* 103225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 103229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 103233 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 103237 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 103241 */     // MIs[1] Operand 1
     /* 103241 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 103246 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 103250 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103252 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETLT:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$s1, 1:{ *:[i32] }, 63:{ *:[i32] })
     /* 103252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 103255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 103257 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 103261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 103264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 103267 */     GIR_RootConstrainSelectedInstOperands,
     /* 103268 */     // GIR_Coverage, 3678,
     /* 103268 */     GIR_EraseRootFromParent_Done,
     /* 103269 */   // Label 1563: @103269
     /* 103269 */   GIM_Try, /*On fail goto*//*Label 1564*/ GIMT_Encode4(103372), // Rule ID 3679 //
     /* 103274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 103278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 103282 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 103286 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 103290 */     // MIs[1] Operand 1
     /* 103290 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 103295 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 103299 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103301 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETLT:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$s1, 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 103301 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 103304 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 103308 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103313 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 103317 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 103320 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 103323 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 103326 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103328 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 103331 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 103335 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103340 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 103345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103347 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103350 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 103353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 103356 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 103361 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 103366 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 103371 */     // GIR_Coverage, 3679,
     /* 103371 */     GIR_EraseRootFromParent_Done,
     /* 103372 */   // Label 1564: @103372
     /* 103372 */   GIM_Try, /*On fail goto*//*Label 1565*/ GIMT_Encode4(103442), // Rule ID 3686 //
     /* 103377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 103381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 103385 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 103389 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 103393 */     // MIs[1] Operand 1
     /* 103393 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 103398 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 103402 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103404 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETGE:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } (NOR8:{ *:[i64] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s1), 1:{ *:[i32] }, 63:{ *:[i32] })
     /* 103404 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 103407 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /* 103411 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103416 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 103420 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 103424 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 103429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 103431 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 103437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 103440 */     GIR_RootConstrainSelectedInstOperands,
     /* 103441 */     // GIR_Coverage, 3686,
     /* 103441 */     GIR_EraseRootFromParent_Done,
     /* 103442 */   // Label 1565: @103442
     /* 103442 */   GIM_Try, /*On fail goto*//*Label 1566*/ GIMT_Encode4(103566), // Rule ID 3687 //
     /* 103447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 103451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 103455 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 103459 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 103463 */     // MIs[1] Operand 1
     /* 103463 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 103468 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 103472 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103474 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETGE:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } (NOR:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s1), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 103474 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 103477 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /* 103481 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103486 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 103490 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 103494 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 103496 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 103499 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 103503 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103508 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 103511 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 103514 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 103517 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 103520 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103522 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 103525 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 103529 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103534 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 103539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103541 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103544 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 103547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 103550 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 103555 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 103560 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 103565 */     // GIR_Coverage, 3687,
     /* 103565 */     GIR_EraseRootFromParent_Done,
     /* 103566 */   // Label 1566: @103566
     /* 103566 */   GIM_Try, /*On fail goto*//*Label 1567*/ GIMT_Encode4(103653), // Rule ID 3694 //
     /* 103571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 103575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 103579 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 103583 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 103587 */     // MIs[1] Operand 1
     /* 103587 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 103592 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 103596 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103598 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETGT:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } (ANDC8:{ *:[i64] } (NEG8:{ *:[i64] } ?:{ *:[i64] }:$s1), ?:{ *:[i64] }:$s1), 1:{ *:[i32] }, 63:{ *:[i32] })
     /* 103598 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 103601 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NEG8),
     /* 103605 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103610 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 103614 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103616 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 103619 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::ANDC8),
     /* 103623 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103628 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 103631 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 103635 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 103640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 103642 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 103648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 103651 */     GIR_RootConstrainSelectedInstOperands,
     /* 103652 */     // GIR_Coverage, 3694,
     /* 103652 */     GIR_EraseRootFromParent_Done,
     /* 103653 */   // Label 1567: @103653
     /* 103653 */   GIM_Try, /*On fail goto*//*Label 1568*/ GIMT_Encode4(103794), // Rule ID 3695 //
     /* 103658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 103662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 103666 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 103670 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 103674 */     // MIs[1] Operand 1
     /* 103674 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 103679 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 103683 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103685 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETGT:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } (ANDC:{ *:[i32] } (NEG:{ *:[i32] } ?:{ *:[i32] }:$s1), ?:{ *:[i32] }:$s1), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 103685 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 103688 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::NEG),
     /* 103692 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103697 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 103701 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 103703 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 103706 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::ANDC),
     /* 103710 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103715 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 103718 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 103722 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 103724 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 103727 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 103731 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103736 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 103739 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 103742 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 103745 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 103748 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103750 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 103753 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 103757 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103762 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 103767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103769 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103772 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 103775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 103778 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 103783 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 103788 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 103793 */     // GIR_Coverage, 3695,
     /* 103793 */     GIR_EraseRootFromParent_Done,
     /* 103794 */   // Label 1568: @103794
     /* 103794 */   GIM_Try, /*On fail goto*//*Label 1569*/ GIMT_Encode4(103881), // Rule ID 3702 //
     /* 103799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 103803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 103807 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 103811 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 103815 */     // MIs[1] Operand 1
     /* 103815 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 103820 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 103824 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103826 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETLE:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } (ORC8:{ *:[i64] } ?:{ *:[i64] }:$s1, (NEG8:{ *:[i64] } ?:{ *:[i64] }:$s1)), 1:{ *:[i32] }, 63:{ *:[i32] })
     /* 103826 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 103829 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NEG8),
     /* 103833 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103838 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 103842 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103844 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 103847 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::ORC8),
     /* 103851 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103856 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 103860 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 103863 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 103868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 103870 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 103876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 103879 */     GIR_RootConstrainSelectedInstOperands,
     /* 103880 */     // GIR_Coverage, 3702,
     /* 103880 */     GIR_EraseRootFromParent_Done,
     /* 103881 */   // Label 1569: @103881
     /* 103881 */   GIM_Try, /*On fail goto*//*Label 1570*/ GIMT_Encode4(104022), // Rule ID 3703 //
     /* 103886 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 103890 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 103894 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 103898 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 103902 */     // MIs[1] Operand 1
     /* 103902 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 103907 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 103911 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103913 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETLE:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } (ORC:{ *:[i32] } ?:{ *:[i32] }:$s1, (NEG:{ *:[i32] } ?:{ *:[i32] }:$s1)), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 103913 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 103916 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::NEG),
     /* 103920 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103925 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 103929 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 103931 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 103934 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::ORC),
     /* 103938 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103943 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 103947 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 103950 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 103952 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 103955 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 103959 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103964 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 103967 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 103970 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 103973 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 103976 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103978 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 103981 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 103985 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103990 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 103995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103997 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104000 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 104003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 104006 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 104011 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 104016 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 104021 */     // GIR_Coverage, 3703,
     /* 104021 */     GIR_EraseRootFromParent_Done,
     /* 104022 */   // Label 1570: @104022
     /* 104022 */   GIM_Try, /*On fail goto*//*Label 1571*/ GIMT_Encode4(104112), // Rule ID 3710 //
     /* 104027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 104031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 104035 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 104039 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 104043 */     // MIs[1] Operand 1
     /* 104043 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 104048 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 104052 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 104054 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, -1:{ *:[i64] }, SETLT:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } (AND8:{ *:[i64] } ?:{ *:[i64] }:$s1, (ADDI8:{ *:[i64] } ?:{ *:[i64] }:$s1, 1:{ *:[i64] })), 1:{ *:[i32] }, 63:{ *:[i32] })
     /* 104054 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 104057 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::ADDI8),
     /* 104061 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104066 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 104070 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 104073 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 104075 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 104078 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 104082 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104087 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 104091 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 104094 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 104096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 104099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 104101 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 104107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 104110 */     GIR_RootConstrainSelectedInstOperands,
     /* 104111 */     // GIR_Coverage, 3710,
     /* 104111 */     GIR_EraseRootFromParent_Done,
     /* 104112 */   // Label 1571: @104112
     /* 104112 */   GIM_Try, /*On fail goto*//*Label 1572*/ GIMT_Encode4(104256), // Rule ID 3711 //
     /* 104117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 104121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 104125 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 104129 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 104133 */     // MIs[1] Operand 1
     /* 104133 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 104138 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 104142 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 104144 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, -1:{ *:[i32] }, SETLT:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } (AND:{ *:[i32] } ?:{ *:[i32] }:$s1, (ADDI:{ *:[i32] } ?:{ *:[i32] }:$s1, 1:{ *:[i32] })), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 104144 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 104147 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::ADDI),
     /* 104151 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104156 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 104160 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 104163 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 104165 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 104168 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 104172 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104177 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 104181 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 104184 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 104186 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 104189 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 104193 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104198 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 104201 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 104204 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 104207 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 104210 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 104212 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 104215 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104219 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104224 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 104226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 104229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104231 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104234 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 104237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 104240 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 104245 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 104250 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 104255 */     // GIR_Coverage, 3711,
     /* 104255 */     GIR_EraseRootFromParent_Done,
     /* 104256 */   // Label 1572: @104256
     /* 104256 */   GIM_Try, /*On fail goto*//*Label 1573*/ GIMT_Encode4(104346), // Rule ID 3718 //
     /* 104261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 104265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 104269 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 104273 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 104277 */     // MIs[1] Operand 1
     /* 104277 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 104282 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 104286 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 104288 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, -1:{ *:[i64] }, SETGE:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } (NAND8:{ *:[i64] } ?:{ *:[i64] }:$s1, (ADDI8:{ *:[i64] } ?:{ *:[i64] }:$s1, 1:{ *:[i64] })), 1:{ *:[i32] }, 63:{ *:[i32] })
     /* 104288 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 104291 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::ADDI8),
     /* 104295 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104300 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 104304 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 104307 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 104309 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 104312 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NAND8),
     /* 104316 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104321 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 104325 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 104328 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 104330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 104333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 104335 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 104341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 104344 */     GIR_RootConstrainSelectedInstOperands,
     /* 104345 */     // GIR_Coverage, 3718,
     /* 104345 */     GIR_EraseRootFromParent_Done,
     /* 104346 */   // Label 1573: @104346
     /* 104346 */   GIM_Try, /*On fail goto*//*Label 1574*/ GIMT_Encode4(104490), // Rule ID 3719 //
     /* 104351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 104355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 104359 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 104363 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 104367 */     // MIs[1] Operand 1
     /* 104367 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 104372 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 104376 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 104378 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, -1:{ *:[i32] }, SETGE:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } (NAND:{ *:[i32] } ?:{ *:[i32] }:$s1, (ADDI:{ *:[i32] } ?:{ *:[i32] }:$s1, 1:{ *:[i32] })), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 104378 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 104381 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::ADDI),
     /* 104385 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104390 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 104394 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 104397 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 104399 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 104402 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::NAND),
     /* 104406 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104411 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 104415 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 104418 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 104420 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 104423 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 104427 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104432 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 104435 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 104438 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 104441 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 104444 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 104446 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 104449 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104453 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104458 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 104460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 104463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104465 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104468 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 104471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 104474 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 104479 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 104484 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 104489 */     // GIR_Coverage, 3719,
     /* 104489 */     GIR_EraseRootFromParent_Done,
     /* 104490 */   // Label 1574: @104490
     /* 104490 */   GIM_Try, /*On fail goto*//*Label 1575*/ GIMT_Encode4(104560), // Rule ID 3726 //
     /* 104495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 104499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 104503 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 104507 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 104511 */     // MIs[1] Operand 1
     /* 104511 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 104516 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 104520 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 104522 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, -1:{ *:[i64] }, SETGT:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } (NOR8:{ *:[i64] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s1), 1:{ *:[i32] }, 63:{ *:[i32] })
     /* 104522 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 104525 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /* 104529 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104534 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 104538 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 104542 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 104544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 104547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 104549 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 104555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 104558 */     GIR_RootConstrainSelectedInstOperands,
     /* 104559 */     // GIR_Coverage, 3726,
     /* 104559 */     GIR_EraseRootFromParent_Done,
     /* 104560 */   // Label 1575: @104560
     /* 104560 */   GIM_Try, /*On fail goto*//*Label 1576*/ GIMT_Encode4(104684), // Rule ID 3727 //
     /* 104565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 104569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 104573 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 104577 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 104581 */     // MIs[1] Operand 1
     /* 104581 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 104586 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 104590 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 104592 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, -1:{ *:[i32] }, SETGT:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } (NOR:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s1), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 104592 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 104595 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /* 104599 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104604 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 104608 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 104612 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 104614 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 104617 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 104621 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104626 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 104629 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 104632 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 104635 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 104638 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 104640 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 104643 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104647 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104652 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 104654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 104657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104659 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104662 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 104665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 104668 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 104673 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 104678 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 104683 */     // GIR_Coverage, 3727,
     /* 104683 */     GIR_EraseRootFromParent_Done,
     /* 104684 */   // Label 1576: @104684
     /* 104684 */   GIM_Try, /*On fail goto*//*Label 1577*/ GIMT_Encode4(104733), // Rule ID 3734 //
     /* 104689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 104693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 104697 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 104701 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 104705 */     // MIs[1] Operand 1
     /* 104705 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 104710 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 104714 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 104716 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, -1:{ *:[i64] }, SETLE:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$s1, 1:{ *:[i32] }, 63:{ *:[i32] })
     /* 104716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 104719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 104721 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 104725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 104728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 104731 */     GIR_RootConstrainSelectedInstOperands,
     /* 104732 */     // GIR_Coverage, 3734,
     /* 104732 */     GIR_EraseRootFromParent_Done,
     /* 104733 */   // Label 1577: @104733
     /* 104733 */   GIM_Try, /*On fail goto*//*Label 1578*/ GIMT_Encode4(104836), // Rule ID 3735 //
     /* 104738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 104742 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 104746 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 104750 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 104754 */     // MIs[1] Operand 1
     /* 104754 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 104759 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 104763 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 104765 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, -1:{ *:[i32] }, SETLE:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$s1, 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 104765 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 104768 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 104772 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104777 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 104781 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 104784 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 104787 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 104790 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 104792 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 104795 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104799 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104804 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 104806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 104809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104811 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104814 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 104817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 104820 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 104825 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 104830 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 104835 */     // GIR_Coverage, 3735,
     /* 104835 */     GIR_EraseRootFromParent_Done,
     /* 104836 */   // Label 1578: @104836
     /* 104836 */   GIM_Try, /*On fail goto*//*Label 1579*/ GIMT_Encode4(104939), // Rule ID 3030 //
     /* 104841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 104844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 104848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 104852 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 104856 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 104860 */     // MIs[1] Operand 1
     /* 104860 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 104865 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 104869 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 104873 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 104877 */     // MIs[2] Operand 1
     /* 104877 */     // No operand predicates
     /* 104877 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 104879 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_lt:{ *:[i32] }))
     /* 104879 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 104882 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 104886 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104891 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 104895 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 104898 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 104900 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 104903 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 104907 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104912 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 104919 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 104924 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 104929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 104932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 104934 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104937 */     GIR_RootConstrainSelectedInstOperands,
     /* 104938 */     // GIR_Coverage, 3030,
     /* 104938 */     GIR_EraseRootFromParent_Done,
     /* 104939 */   // Label 1579: @104939
     /* 104939 */   GIM_Try, /*On fail goto*//*Label 1580*/ GIMT_Encode4(105042), // Rule ID 3046 //
     /* 104944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 104947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 104951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 104955 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 104959 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 104963 */     // MIs[1] Operand 1
     /* 104963 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 104968 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 104972 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 104976 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 104980 */     // MIs[2] Operand 1
     /* 104980 */     // No operand predicates
     /* 104980 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 104982 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_gt:{ *:[i32] }))
     /* 104982 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 104985 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 104989 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104994 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 104998 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 105001 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 105003 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 105006 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105010 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105015 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 105022 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 105027 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 105032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 105035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 105037 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105040 */     GIR_RootConstrainSelectedInstOperands,
     /* 105041 */     // GIR_Coverage, 3046,
     /* 105041 */     GIR_EraseRootFromParent_Done,
     /* 105042 */   // Label 1580: @105042
     /* 105042 */   GIM_Try, /*On fail goto*//*Label 1581*/ GIMT_Encode4(105145), // Rule ID 3054 //
     /* 105047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 105050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 105054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 105058 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 105062 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 105066 */     // MIs[1] Operand 1
     /* 105066 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 105071 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 105075 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 105079 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 105083 */     // MIs[2] Operand 1
     /* 105083 */     // No operand predicates
     /* 105083 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 105085 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_eq:{ *:[i32] }))
     /* 105085 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 105088 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 105092 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105097 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 105101 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 105104 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 105106 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 105109 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105113 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105118 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 105125 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 105130 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 105135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 105138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 105140 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105143 */     GIR_RootConstrainSelectedInstOperands,
     /* 105144 */     // GIR_Coverage, 3054,
     /* 105144 */     GIR_EraseRootFromParent_Done,
     /* 105145 */   // Label 1581: @105145
     /* 105145 */   GIM_Try, /*On fail goto*//*Label 1582*/ GIMT_Encode4(105248), // Rule ID 3126 //
     /* 105150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 105153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 105157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 105161 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 105165 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 105169 */     // MIs[1] Operand 1
     /* 105169 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 105174 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 105178 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 105182 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 105186 */     // MIs[2] Operand 1
     /* 105186 */     // No operand predicates
     /* 105186 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 105188 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_lt:{ *:[i32] }))
     /* 105188 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 105191 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 105195 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105200 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 105204 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 105207 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 105209 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 105212 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105216 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105221 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 105228 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 105233 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 105238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 105241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 105243 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105246 */     GIR_RootConstrainSelectedInstOperands,
     /* 105247 */     // GIR_Coverage, 3126,
     /* 105247 */     GIR_EraseRootFromParent_Done,
     /* 105248 */   // Label 1582: @105248
     /* 105248 */   GIM_Try, /*On fail goto*//*Label 1583*/ GIMT_Encode4(105351), // Rule ID 3142 //
     /* 105253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 105256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 105260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 105264 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 105268 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 105272 */     // MIs[1] Operand 1
     /* 105272 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 105277 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 105281 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 105285 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 105289 */     // MIs[2] Operand 1
     /* 105289 */     // No operand predicates
     /* 105289 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 105291 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_gt:{ *:[i32] }))
     /* 105291 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 105294 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 105298 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105303 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 105307 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 105310 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 105312 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 105315 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105319 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105324 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 105331 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 105336 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 105341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 105344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 105346 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105349 */     GIR_RootConstrainSelectedInstOperands,
     /* 105350 */     // GIR_Coverage, 3142,
     /* 105350 */     GIR_EraseRootFromParent_Done,
     /* 105351 */   // Label 1583: @105351
     /* 105351 */   GIM_Try, /*On fail goto*//*Label 1584*/ GIMT_Encode4(105454), // Rule ID 3150 //
     /* 105356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 105359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 105363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 105367 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 105371 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 105375 */     // MIs[1] Operand 1
     /* 105375 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 105380 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 105384 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 105388 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 105392 */     // MIs[2] Operand 1
     /* 105392 */     // No operand predicates
     /* 105392 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 105394 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_eq:{ *:[i32] }))
     /* 105394 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 105397 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 105401 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105406 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 105410 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 105413 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 105415 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 105418 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105422 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105427 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 105434 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 105439 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 105444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 105447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 105449 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105452 */     GIR_RootConstrainSelectedInstOperands,
     /* 105453 */     // GIR_Coverage, 3150,
     /* 105453 */     GIR_EraseRootFromParent_Done,
     /* 105454 */   // Label 1584: @105454
     /* 105454 */   GIM_Try, /*On fail goto*//*Label 1585*/ GIMT_Encode4(105597), // Rule ID 3784 //
     /* 105459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 105462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 105466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 105470 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 105474 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 105478 */     // MIs[1] Operand 1
     /* 105478 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 105483 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 105487 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 105491 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 105495 */     // MIs[2] Operand 1
     /* 105495 */     // No operand predicates
     /* 105495 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 105497 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 105497 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 105500 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 105504 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105509 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 105513 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 105516 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 105518 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 105521 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 105525 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105530 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 105533 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 105535 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 105538 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 105542 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105547 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 105550 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 105552 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 105555 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105559 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105564 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 105571 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 105576 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 105581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 105584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105586 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105589 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 105592 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 105595 */     GIR_RootConstrainSelectedInstOperands,
     /* 105596 */     // GIR_Coverage, 3784,
     /* 105596 */     GIR_EraseRootFromParent_Done,
     /* 105597 */   // Label 1585: @105597
     /* 105597 */   GIM_Try, /*On fail goto*//*Label 1586*/ GIMT_Encode4(105740), // Rule ID 3800 //
     /* 105602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 105605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 105609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 105613 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 105617 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 105621 */     // MIs[1] Operand 1
     /* 105621 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 105626 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 105630 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 105634 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 105638 */     // MIs[2] Operand 1
     /* 105638 */     // No operand predicates
     /* 105638 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 105640 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 105640 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 105643 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 105647 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105652 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 105656 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 105659 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 105661 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 105664 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 105668 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105673 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 105676 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 105678 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 105681 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 105685 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105690 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 105693 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 105695 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 105698 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105702 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105707 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 105714 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 105719 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 105724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 105727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105729 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105732 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 105735 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 105738 */     GIR_RootConstrainSelectedInstOperands,
     /* 105739 */     // GIR_Coverage, 3800,
     /* 105739 */     GIR_EraseRootFromParent_Done,
     /* 105740 */   // Label 1586: @105740
     /* 105740 */   GIM_Try, /*On fail goto*//*Label 1587*/ GIMT_Encode4(105883), // Rule ID 3808 //
     /* 105745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 105748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 105752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 105756 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 105760 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 105764 */     // MIs[1] Operand 1
     /* 105764 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 105769 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 105773 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 105777 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 105781 */     // MIs[2] Operand 1
     /* 105781 */     // No operand predicates
     /* 105781 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 105783 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 105783 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 105786 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 105790 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105795 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 105799 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 105802 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 105804 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 105807 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 105811 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105816 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 105819 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 105821 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 105824 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 105828 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105833 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 105836 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 105838 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 105841 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105845 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105850 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 105857 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 105862 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 105867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 105870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105872 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105875 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 105878 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 105881 */     GIR_RootConstrainSelectedInstOperands,
     /* 105882 */     // GIR_Coverage, 3808,
     /* 105882 */     GIR_EraseRootFromParent_Done,
     /* 105883 */   // Label 1587: @105883
     /* 105883 */   GIM_Try, /*On fail goto*//*Label 1588*/ GIMT_Encode4(106026), // Rule ID 3880 //
     /* 105888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 105891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 105895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 105899 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 105903 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 105907 */     // MIs[1] Operand 1
     /* 105907 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 105912 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 105916 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 105920 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 105924 */     // MIs[2] Operand 1
     /* 105924 */     // No operand predicates
     /* 105924 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 105926 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 105926 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 105929 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 105933 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105938 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 105942 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 105945 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 105947 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 105950 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 105954 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105959 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 105962 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 105964 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 105967 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 105971 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105976 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 105979 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 105981 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 105984 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105988 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105993 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 106000 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 106005 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 106010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 106013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106015 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106018 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 106021 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 106024 */     GIR_RootConstrainSelectedInstOperands,
     /* 106025 */     // GIR_Coverage, 3880,
     /* 106025 */     GIR_EraseRootFromParent_Done,
     /* 106026 */   // Label 1588: @106026
     /* 106026 */   GIM_Try, /*On fail goto*//*Label 1589*/ GIMT_Encode4(106169), // Rule ID 3896 //
     /* 106031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 106034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 106042 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 106046 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 106050 */     // MIs[1] Operand 1
     /* 106050 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 106055 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 106059 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 106063 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 106067 */     // MIs[2] Operand 1
     /* 106067 */     // No operand predicates
     /* 106067 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 106069 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 106069 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 106072 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 106076 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106081 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 106085 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 106088 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 106090 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 106093 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 106097 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106102 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 106105 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 106107 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 106110 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 106114 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106119 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 106122 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 106124 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 106127 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106131 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106136 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 106143 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 106148 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 106153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 106156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106158 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106161 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 106164 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 106167 */     GIR_RootConstrainSelectedInstOperands,
     /* 106168 */     // GIR_Coverage, 3896,
     /* 106168 */     GIR_EraseRootFromParent_Done,
     /* 106169 */   // Label 1589: @106169
     /* 106169 */   GIM_Try, /*On fail goto*//*Label 1590*/ GIMT_Encode4(106312), // Rule ID 3904 //
     /* 106174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 106177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106181 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 106185 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 106189 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 106193 */     // MIs[1] Operand 1
     /* 106193 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 106198 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 106202 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 106206 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 106210 */     // MIs[2] Operand 1
     /* 106210 */     // No operand predicates
     /* 106210 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 106212 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 106212 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 106215 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 106219 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106224 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 106228 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 106231 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 106233 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 106236 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 106240 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106245 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 106248 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 106250 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 106253 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 106257 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106262 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 106265 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 106267 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 106270 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106274 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106279 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 106286 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 106291 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 106296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 106299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106301 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106304 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 106307 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 106310 */     GIR_RootConstrainSelectedInstOperands,
     /* 106311 */     // GIR_Coverage, 3904,
     /* 106311 */     GIR_EraseRootFromParent_Done,
     /* 106312 */   // Label 1590: @106312
     /* 106312 */   GIM_Try, /*On fail goto*//*Label 1591*/ GIMT_Encode4(106404), // Rule ID 3174 //
     /* 106317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 106320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 106328 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 106332 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 106336 */     // MIs[1] Operand 1
     /* 106336 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 106341 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106343 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_lt:{ *:[i32] }))
     /* 106343 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 106346 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 106350 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106355 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 106359 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 106363 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 106365 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 106368 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106372 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106377 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 106384 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 106389 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 106394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 106397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 106399 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106402 */     GIR_RootConstrainSelectedInstOperands,
     /* 106403 */     // GIR_Coverage, 3174,
     /* 106403 */     GIR_EraseRootFromParent_Done,
     /* 106404 */   // Label 1591: @106404
     /* 106404 */   GIM_Try, /*On fail goto*//*Label 1592*/ GIMT_Encode4(106496), // Rule ID 3190 //
     /* 106409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 106412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 106420 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 106424 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 106428 */     // MIs[1] Operand 1
     /* 106428 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 106433 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106435 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }))
     /* 106435 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 106438 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 106442 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106447 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 106451 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 106455 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 106457 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 106460 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106464 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106469 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 106476 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 106481 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 106486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 106489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 106491 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106494 */     GIR_RootConstrainSelectedInstOperands,
     /* 106495 */     // GIR_Coverage, 3190,
     /* 106495 */     GIR_EraseRootFromParent_Done,
     /* 106496 */   // Label 1592: @106496
     /* 106496 */   GIM_Try, /*On fail goto*//*Label 1593*/ GIMT_Encode4(106588), // Rule ID 3206 //
     /* 106501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 106504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 106512 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 106516 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 106520 */     // MIs[1] Operand 1
     /* 106520 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 106525 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106527 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_eq:{ *:[i32] }))
     /* 106527 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 106530 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 106534 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106539 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 106543 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 106547 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 106549 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 106552 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106556 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106561 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 106568 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 106573 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 106578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 106581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 106583 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106586 */     GIR_RootConstrainSelectedInstOperands,
     /* 106587 */     // GIR_Coverage, 3206,
     /* 106587 */     GIR_EraseRootFromParent_Done,
     /* 106588 */   // Label 1593: @106588
     /* 106588 */   GIM_Try, /*On fail goto*//*Label 1594*/ GIMT_Encode4(106680), // Rule ID 3222 //
     /* 106593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 106596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 106604 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 106608 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 106612 */     // MIs[1] Operand 1
     /* 106612 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 106617 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106619 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETO:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_un:{ *:[i32] }))
     /* 106619 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 106622 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 106626 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106631 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 106635 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 106639 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 106641 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 106644 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106648 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106653 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 106660 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 106665 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 106670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 106673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 106675 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106678 */     GIR_RootConstrainSelectedInstOperands,
     /* 106679 */     // GIR_Coverage, 3222,
     /* 106679 */     GIR_EraseRootFromParent_Done,
     /* 106680 */   // Label 1594: @106680
     /* 106680 */   GIM_Try, /*On fail goto*//*Label 1595*/ GIMT_Encode4(106772), // Rule ID 3230 //
     /* 106685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 106688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 106696 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 106700 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 106704 */     // MIs[1] Operand 1
     /* 106704 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 106709 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106711 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_lt:{ *:[i32] }))
     /* 106711 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 106714 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 106718 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106723 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 106727 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 106731 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 106733 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 106736 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106740 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106745 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 106752 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 106757 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 106762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 106765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 106767 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106770 */     GIR_RootConstrainSelectedInstOperands,
     /* 106771 */     // GIR_Coverage, 3230,
     /* 106771 */     GIR_EraseRootFromParent_Done,
     /* 106772 */   // Label 1595: @106772
     /* 106772 */   GIM_Try, /*On fail goto*//*Label 1596*/ GIMT_Encode4(106864), // Rule ID 3246 //
     /* 106777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 106780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 106788 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 106792 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 106796 */     // MIs[1] Operand 1
     /* 106796 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 106801 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106803 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }))
     /* 106803 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 106806 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 106810 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106815 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 106819 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 106823 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 106825 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 106828 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106832 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106837 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 106844 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 106849 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 106854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 106857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 106859 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106862 */     GIR_RootConstrainSelectedInstOperands,
     /* 106863 */     // GIR_Coverage, 3246,
     /* 106863 */     GIR_EraseRootFromParent_Done,
     /* 106864 */   // Label 1596: @106864
     /* 106864 */   GIM_Try, /*On fail goto*//*Label 1597*/ GIMT_Encode4(106956), // Rule ID 3262 //
     /* 106869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 106872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 106880 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 106884 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 106888 */     // MIs[1] Operand 1
     /* 106888 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 106893 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106895 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_eq:{ *:[i32] }))
     /* 106895 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 106898 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 106902 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106907 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 106911 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 106915 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 106917 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 106920 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106924 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106929 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 106936 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 106941 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 106946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 106949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 106951 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106954 */     GIR_RootConstrainSelectedInstOperands,
     /* 106955 */     // GIR_Coverage, 3262,
     /* 106955 */     GIR_EraseRootFromParent_Done,
     /* 106956 */   // Label 1597: @106956
     /* 106956 */   GIM_Try, /*On fail goto*//*Label 1598*/ GIMT_Encode4(107048), // Rule ID 3278 //
     /* 106961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 106964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 106972 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 106976 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 106980 */     // MIs[1] Operand 1
     /* 106980 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 106985 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106987 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETO:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_un:{ *:[i32] }))
     /* 106987 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 106990 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 106994 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106999 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 107003 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 107007 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 107009 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 107012 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107016 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107021 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 107028 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 107033 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 107038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 107041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 107043 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107046 */     GIR_RootConstrainSelectedInstOperands,
     /* 107047 */     // GIR_Coverage, 3278,
     /* 107047 */     GIR_EraseRootFromParent_Done,
     /* 107048 */   // Label 1598: @107048
     /* 107048 */   GIM_Try, /*On fail goto*//*Label 1599*/ GIMT_Encode4(107140), // Rule ID 3286 //
     /* 107053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 107056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 107060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 107064 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 107068 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 107072 */     // MIs[1] Operand 1
     /* 107072 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 107077 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 107079 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_lt:{ *:[i32] }))
     /* 107079 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 107082 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 107086 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107091 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 107095 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 107099 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 107101 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 107104 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107108 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107113 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 107120 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 107125 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 107130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 107133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 107135 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107138 */     GIR_RootConstrainSelectedInstOperands,
     /* 107139 */     // GIR_Coverage, 3286,
     /* 107139 */     GIR_EraseRootFromParent_Done,
     /* 107140 */   // Label 1599: @107140
     /* 107140 */   GIM_Try, /*On fail goto*//*Label 1600*/ GIMT_Encode4(107232), // Rule ID 3302 //
     /* 107145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 107148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 107152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 107156 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 107160 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 107164 */     // MIs[1] Operand 1
     /* 107164 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 107169 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 107171 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_gt:{ *:[i32] }))
     /* 107171 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 107174 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 107178 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107183 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 107187 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 107191 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 107193 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 107196 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107200 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107205 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 107212 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 107217 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 107222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 107225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 107227 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107230 */     GIR_RootConstrainSelectedInstOperands,
     /* 107231 */     // GIR_Coverage, 3302,
     /* 107231 */     GIR_EraseRootFromParent_Done,
     /* 107232 */   // Label 1600: @107232
     /* 107232 */   GIM_Try, /*On fail goto*//*Label 1601*/ GIMT_Encode4(107324), // Rule ID 3318 //
     /* 107237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 107240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 107244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 107248 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 107252 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 107256 */     // MIs[1] Operand 1
     /* 107256 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 107261 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 107263 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUNE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_eq:{ *:[i32] }))
     /* 107263 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 107266 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 107270 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107275 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 107279 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 107283 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 107285 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 107288 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107292 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107297 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 107304 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 107309 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 107314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 107317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 107319 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107322 */     GIR_RootConstrainSelectedInstOperands,
     /* 107323 */     // GIR_Coverage, 3318,
     /* 107323 */     GIR_EraseRootFromParent_Done,
     /* 107324 */   // Label 1601: @107324
     /* 107324 */   GIM_Try, /*On fail goto*//*Label 1602*/ GIMT_Encode4(107416), // Rule ID 3334 //
     /* 107329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 107332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 107336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 107340 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 107344 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 107348 */     // MIs[1] Operand 1
     /* 107348 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 107353 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 107355 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETO:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_un:{ *:[i32] }))
     /* 107355 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 107358 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 107362 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107367 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 107371 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 107375 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 107377 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 107380 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107384 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107389 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 107396 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 107401 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 107406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 107409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 107411 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107414 */     GIR_RootConstrainSelectedInstOperands,
     /* 107415 */     // GIR_Coverage, 3334,
     /* 107415 */     GIR_EraseRootFromParent_Done,
     /* 107416 */   // Label 1602: @107416
     /* 107416 */   GIM_Try, /*On fail goto*//*Label 1603*/ GIMT_Encode4(107548), // Rule ID 3990 //
     /* 107421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 107424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 107428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 107432 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 107436 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 107440 */     // MIs[1] Operand 1
     /* 107440 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 107445 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 107447 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 107447 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 107450 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 107454 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107459 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 107463 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 107467 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 107469 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 107472 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 107476 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107481 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 107484 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 107486 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 107489 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 107493 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107498 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 107501 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 107503 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 107506 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107510 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107515 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 107522 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 107527 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 107532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 107535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 107537 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107540 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 107543 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 107546 */     GIR_RootConstrainSelectedInstOperands,
     /* 107547 */     // GIR_Coverage, 3990,
     /* 107547 */     GIR_EraseRootFromParent_Done,
     /* 107548 */   // Label 1603: @107548
     /* 107548 */   GIM_Try, /*On fail goto*//*Label 1604*/ GIMT_Encode4(107680), // Rule ID 4022 //
     /* 107553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 107556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 107560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 107564 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 107568 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 107572 */     // MIs[1] Operand 1
     /* 107572 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 107577 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 107579 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 107579 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 107582 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 107586 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107591 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 107595 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 107599 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 107601 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 107604 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 107608 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107613 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 107616 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 107618 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 107621 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 107625 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107630 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 107633 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 107635 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 107638 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107642 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107647 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 107654 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 107659 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 107664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 107667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 107669 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107672 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 107675 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 107678 */     GIR_RootConstrainSelectedInstOperands,
     /* 107679 */     // GIR_Coverage, 4022,
     /* 107679 */     GIR_EraseRootFromParent_Done,
     /* 107680 */   // Label 1604: @107680
     /* 107680 */   GIM_Try, /*On fail goto*//*Label 1605*/ GIMT_Encode4(107812), // Rule ID 4054 //
     /* 107685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 107688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 107692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 107696 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 107700 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 107704 */     // MIs[1] Operand 1
     /* 107704 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 107709 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 107711 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 107711 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 107714 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 107718 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107723 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 107727 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 107731 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 107733 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 107736 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 107740 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107745 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 107748 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 107750 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 107753 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 107757 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107762 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 107765 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 107767 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 107770 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107774 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107779 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 107786 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 107791 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 107796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 107799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 107801 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107804 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 107807 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 107810 */     GIR_RootConstrainSelectedInstOperands,
     /* 107811 */     // GIR_Coverage, 4054,
     /* 107811 */     GIR_EraseRootFromParent_Done,
     /* 107812 */   // Label 1605: @107812
     /* 107812 */   GIM_Try, /*On fail goto*//*Label 1606*/ GIMT_Encode4(107944), // Rule ID 4086 //
     /* 107817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 107820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 107824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 107828 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 107832 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 107836 */     // MIs[1] Operand 1
     /* 107836 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 107841 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 107843 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETO:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_un:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 107843 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 107846 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 107850 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107855 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 107859 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 107863 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 107865 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 107868 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 107872 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107877 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 107880 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 107882 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 107885 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 107889 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107894 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 107897 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 107899 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 107902 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107906 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107911 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 107918 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 107923 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 107928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 107931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 107933 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107936 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 107939 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 107942 */     GIR_RootConstrainSelectedInstOperands,
     /* 107943 */     // GIR_Coverage, 4086,
     /* 107943 */     GIR_EraseRootFromParent_Done,
     /* 107944 */   // Label 1606: @107944
     /* 107944 */   GIM_Try, /*On fail goto*//*Label 1607*/ GIMT_Encode4(108076), // Rule ID 4102 //
     /* 107949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 107952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 107956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 107960 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 107964 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 107968 */     // MIs[1] Operand 1
     /* 107968 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 107973 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 107975 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 107975 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 107978 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 107982 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107987 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 107991 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 107995 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 107997 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 108000 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 108004 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108009 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 108012 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 108014 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 108017 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 108021 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108026 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 108029 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 108031 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 108034 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108038 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108043 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 108050 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 108055 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 108060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 108063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 108065 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108068 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 108071 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 108074 */     GIR_RootConstrainSelectedInstOperands,
     /* 108075 */     // GIR_Coverage, 4102,
     /* 108075 */     GIR_EraseRootFromParent_Done,
     /* 108076 */   // Label 1607: @108076
     /* 108076 */   GIM_Try, /*On fail goto*//*Label 1608*/ GIMT_Encode4(108208), // Rule ID 4134 //
     /* 108081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 108084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 108088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 108092 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 108096 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 108100 */     // MIs[1] Operand 1
     /* 108100 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 108105 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108107 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 108107 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 108110 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 108114 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108119 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 108123 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 108127 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 108129 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 108132 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 108136 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108141 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 108144 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 108146 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 108149 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 108153 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108158 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 108161 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 108163 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 108166 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108170 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108175 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 108182 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 108187 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 108192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 108195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 108197 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108200 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 108203 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 108206 */     GIR_RootConstrainSelectedInstOperands,
     /* 108207 */     // GIR_Coverage, 4134,
     /* 108207 */     GIR_EraseRootFromParent_Done,
     /* 108208 */   // Label 1608: @108208
     /* 108208 */   GIM_Try, /*On fail goto*//*Label 1609*/ GIMT_Encode4(108340), // Rule ID 4166 //
     /* 108213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 108216 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 108220 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 108224 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 108228 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 108232 */     // MIs[1] Operand 1
     /* 108232 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 108237 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108239 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 108239 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 108242 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 108246 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108251 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 108255 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 108259 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 108261 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 108264 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 108268 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108273 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 108276 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 108278 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 108281 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 108285 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108290 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 108293 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 108295 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 108298 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108302 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108307 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 108314 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 108319 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 108324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 108327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 108329 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108332 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 108335 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 108338 */     GIR_RootConstrainSelectedInstOperands,
     /* 108339 */     // GIR_Coverage, 4166,
     /* 108339 */     GIR_EraseRootFromParent_Done,
     /* 108340 */   // Label 1609: @108340
     /* 108340 */   GIM_Try, /*On fail goto*//*Label 1610*/ GIMT_Encode4(108472), // Rule ID 4198 //
     /* 108345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 108348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 108352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 108356 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 108360 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 108364 */     // MIs[1] Operand 1
     /* 108364 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 108369 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108371 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETO:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_un:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 108371 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 108374 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 108378 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108383 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 108387 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 108391 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 108393 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 108396 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 108400 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108405 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 108408 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 108410 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 108413 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 108417 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108422 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 108425 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 108427 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 108430 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108434 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108439 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 108446 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 108451 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 108456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 108459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 108461 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108464 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 108467 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 108470 */     GIR_RootConstrainSelectedInstOperands,
     /* 108471 */     // GIR_Coverage, 4198,
     /* 108471 */     GIR_EraseRootFromParent_Done,
     /* 108472 */   // Label 1610: @108472
     /* 108472 */   GIM_Try, /*On fail goto*//*Label 1611*/ GIMT_Encode4(108604), // Rule ID 4228 //
     /* 108477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 108480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 108484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 108488 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 108492 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 108496 */     // MIs[1] Operand 1
     /* 108496 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 108501 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108503 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 108503 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 108506 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 108510 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108515 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 108519 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 108523 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 108525 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 108528 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 108532 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108537 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 108540 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 108542 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 108545 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 108549 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108554 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 108557 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 108559 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 108562 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108566 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108571 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 108578 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 108583 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 108588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 108591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 108593 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108596 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 108599 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 108602 */     GIR_RootConstrainSelectedInstOperands,
     /* 108603 */     // GIR_Coverage, 4228,
     /* 108603 */     GIR_EraseRootFromParent_Done,
     /* 108604 */   // Label 1611: @108604
     /* 108604 */   GIM_Try, /*On fail goto*//*Label 1612*/ GIMT_Encode4(108736), // Rule ID 4260 //
     /* 108609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 108612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 108616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 108620 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 108624 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 108628 */     // MIs[1] Operand 1
     /* 108628 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 108633 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108635 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 108635 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 108638 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 108642 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108647 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 108651 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 108655 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 108657 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 108660 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 108664 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108669 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 108672 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 108674 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 108677 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 108681 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108686 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 108689 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 108691 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 108694 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108698 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108703 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 108710 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 108715 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 108720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 108723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 108725 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108728 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 108731 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 108734 */     GIR_RootConstrainSelectedInstOperands,
     /* 108735 */     // GIR_Coverage, 4260,
     /* 108735 */     GIR_EraseRootFromParent_Done,
     /* 108736 */   // Label 1612: @108736
     /* 108736 */   GIM_Try, /*On fail goto*//*Label 1613*/ GIMT_Encode4(108868), // Rule ID 4292 //
     /* 108741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 108744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 108748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 108752 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 108756 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 108760 */     // MIs[1] Operand 1
     /* 108760 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 108765 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108767 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 108767 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 108770 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 108774 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108779 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 108783 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 108787 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 108789 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 108792 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 108796 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108801 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 108804 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 108806 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 108809 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 108813 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108818 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 108821 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 108823 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 108826 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108830 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108835 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 108842 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 108847 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 108852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 108855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 108857 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108860 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 108863 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 108866 */     GIR_RootConstrainSelectedInstOperands,
     /* 108867 */     // GIR_Coverage, 4292,
     /* 108867 */     GIR_EraseRootFromParent_Done,
     /* 108868 */   // Label 1613: @108868
     /* 108868 */   GIM_Try, /*On fail goto*//*Label 1614*/ GIMT_Encode4(109000), // Rule ID 4324 //
     /* 108873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 108876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 108880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 108884 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 108888 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 108892 */     // MIs[1] Operand 1
     /* 108892 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 108897 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108899 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETO:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_un:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 108899 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 108902 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 108906 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108911 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 108915 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 108919 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 108921 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 108924 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 108928 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108933 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 108936 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 108938 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 108941 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 108945 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108950 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 108953 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 108955 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 108958 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108962 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108967 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 108974 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 108979 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 108984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 108987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 108989 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108992 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 108995 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 108998 */     GIR_RootConstrainSelectedInstOperands,
     /* 108999 */     // GIR_Coverage, 4324,
     /* 108999 */     GIR_EraseRootFromParent_Done,
     /* 109000 */   // Label 1614: @109000
     /* 109000 */   GIM_Try, /*On fail goto*//*Label 1615*/ GIMT_Encode4(109132), // Rule ID 4555 //
     /* 109005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 109008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 109012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 109016 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 109020 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 109024 */     // MIs[1] Operand 1
     /* 109024 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 109029 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109031 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPLT:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 109031 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 109034 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPLT),
     /* 109038 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109043 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 109047 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 109051 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 109053 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 109056 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 109060 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109065 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 109068 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 109070 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 109073 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 109077 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109082 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 109085 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 109087 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 109090 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109094 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109099 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 109106 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 109111 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 109116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 109119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 109121 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109124 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 109127 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 109130 */     GIR_RootConstrainSelectedInstOperands,
     /* 109131 */     // GIR_Coverage, 4555,
     /* 109131 */     GIR_EraseRootFromParent_Done,
     /* 109132 */   // Label 1615: @109132
     /* 109132 */   GIM_Try, /*On fail goto*//*Label 1616*/ GIMT_Encode4(109264), // Rule ID 4587 //
     /* 109137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 109140 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 109144 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 109148 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 109152 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 109156 */     // MIs[1] Operand 1
     /* 109156 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 109161 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109163 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPGT:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 109163 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 109166 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPGT),
     /* 109170 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109175 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 109179 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 109183 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 109185 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 109188 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 109192 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109197 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 109200 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 109202 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 109205 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 109209 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109214 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 109217 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 109219 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 109222 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109226 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109231 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 109238 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 109243 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 109248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 109251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 109253 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109256 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 109259 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 109262 */     GIR_RootConstrainSelectedInstOperands,
     /* 109263 */     // GIR_Coverage, 4587,
     /* 109263 */     GIR_EraseRootFromParent_Done,
     /* 109264 */   // Label 1616: @109264
     /* 109264 */   GIM_Try, /*On fail goto*//*Label 1617*/ GIMT_Encode4(109396), // Rule ID 4619 //
     /* 109269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 109272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 109276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 109280 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 109284 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 109288 */     // MIs[1] Operand 1
     /* 109288 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 109293 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109295 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPEQ:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 109295 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 109298 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPEQ),
     /* 109302 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109307 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 109311 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 109315 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 109317 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 109320 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 109324 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109329 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 109332 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 109334 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 109337 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 109341 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109346 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 109349 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 109351 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 109354 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109358 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109363 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 109370 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 109375 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 109380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 109383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 109385 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109388 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 109391 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 109394 */     GIR_RootConstrainSelectedInstOperands,
     /* 109395 */     // GIR_Coverage, 4619,
     /* 109395 */     GIR_EraseRootFromParent_Done,
     /* 109396 */   // Label 1617: @109396
     /* 109396 */   GIM_Try, /*On fail goto*//*Label 1618*/ GIMT_Encode4(109528), // Rule ID 4663 //
     /* 109401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 109404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 109408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 109412 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 109416 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 109420 */     // MIs[1] Operand 1
     /* 109420 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 109425 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109427 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPLT:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 109427 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 109430 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPLT),
     /* 109434 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109439 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 109443 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 109447 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 109449 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 109452 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 109456 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109461 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 109464 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 109466 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 109469 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 109473 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109478 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 109481 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 109483 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 109486 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109490 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109495 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 109502 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 109507 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 109512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 109515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 109517 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109520 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 109523 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 109526 */     GIR_RootConstrainSelectedInstOperands,
     /* 109527 */     // GIR_Coverage, 4663,
     /* 109527 */     GIR_EraseRootFromParent_Done,
     /* 109528 */   // Label 1618: @109528
     /* 109528 */   GIM_Try, /*On fail goto*//*Label 1619*/ GIMT_Encode4(109660), // Rule ID 4695 //
     /* 109533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 109536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 109540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 109544 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 109548 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 109552 */     // MIs[1] Operand 1
     /* 109552 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 109557 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109559 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPGT:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 109559 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 109562 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPGT),
     /* 109566 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109571 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 109575 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 109579 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 109581 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 109584 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 109588 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109593 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 109596 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 109598 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 109601 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 109605 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109610 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 109613 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 109615 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 109618 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109622 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109627 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 109634 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 109639 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 109644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 109647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 109649 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109652 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 109655 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 109658 */     GIR_RootConstrainSelectedInstOperands,
     /* 109659 */     // GIR_Coverage, 4695,
     /* 109659 */     GIR_EraseRootFromParent_Done,
     /* 109660 */   // Label 1619: @109660
     /* 109660 */   GIM_Try, /*On fail goto*//*Label 1620*/ GIMT_Encode4(109792), // Rule ID 4727 //
     /* 109665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 109668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 109672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 109676 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 109680 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 109684 */     // MIs[1] Operand 1
     /* 109684 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 109689 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109691 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPEQ:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 109691 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 109694 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPEQ),
     /* 109698 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109703 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 109707 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 109711 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 109713 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 109716 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 109720 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109725 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 109728 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 109730 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 109733 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 109737 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109742 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 109745 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 109747 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 109750 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109754 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109759 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 109766 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 109771 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 109776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 109779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 109781 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109784 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 109787 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 109790 */     GIR_RootConstrainSelectedInstOperands,
     /* 109791 */     // GIR_Coverage, 4727,
     /* 109791 */     GIR_EraseRootFromParent_Done,
     /* 109792 */   // Label 1620: @109792
     /* 109792 */   GIM_Try, /*On fail goto*//*Label 1621*/ GIMT_Encode4(109884), // Rule ID 2976 //
     /* 109797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 109800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 109804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 109808 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 109812 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 109816 */     // MIs[1] Operand 1
     /* 109816 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 109821 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109823 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }))
     /* 109823 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 109826 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 109830 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109835 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 109839 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 109843 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 109845 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 109848 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109852 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109857 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 109864 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 109869 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 109874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 109877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 109879 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109882 */     GIR_RootConstrainSelectedInstOperands,
     /* 109883 */     // GIR_Coverage, 2976,
     /* 109883 */     GIR_EraseRootFromParent_Done,
     /* 109884 */   // Label 1621: @109884
     /* 109884 */   GIM_Try, /*On fail goto*//*Label 1622*/ GIMT_Encode4(109976), // Rule ID 2990 //
     /* 109889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 109892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 109896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 109900 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 109904 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 109908 */     // MIs[1] Operand 1
     /* 109908 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 109913 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109915 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETGE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }))
     /* 109915 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 109918 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 109922 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109927 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 109931 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 109935 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 109937 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 109940 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109944 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109949 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 109956 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 109961 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 109966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 109969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 109971 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109974 */     GIR_RootConstrainSelectedInstOperands,
     /* 109975 */     // GIR_Coverage, 2990,
     /* 109975 */     GIR_EraseRootFromParent_Done,
     /* 109976 */   // Label 1622: @109976
     /* 109976 */   GIM_Try, /*On fail goto*//*Label 1623*/ GIMT_Encode4(110068), // Rule ID 2998 //
     /* 109981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 109984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 109988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 109992 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 109996 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 110000 */     // MIs[1] Operand 1
     /* 110000 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 110005 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110007 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }))
     /* 110007 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 110010 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 110014 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110019 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 110023 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 110027 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 110029 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 110032 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110036 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110041 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 110048 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 110053 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 110058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 110061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 110063 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110066 */     GIR_RootConstrainSelectedInstOperands,
     /* 110067 */     // GIR_Coverage, 2998,
     /* 110067 */     GIR_EraseRootFromParent_Done,
     /* 110068 */   // Label 1623: @110068
     /* 110068 */   GIM_Try, /*On fail goto*//*Label 1624*/ GIMT_Encode4(110160), // Rule ID 3006 //
     /* 110073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 110076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 110080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 110084 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 110088 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 110092 */     // MIs[1] Operand 1
     /* 110092 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 110097 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110099 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETLE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }))
     /* 110099 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 110102 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 110106 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110111 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 110115 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 110119 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 110121 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 110124 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110128 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110133 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 110140 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 110145 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 110150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 110153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 110155 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110158 */     GIR_RootConstrainSelectedInstOperands,
     /* 110159 */     // GIR_Coverage, 3006,
     /* 110159 */     GIR_EraseRootFromParent_Done,
     /* 110160 */   // Label 1624: @110160
     /* 110160 */   GIM_Try, /*On fail goto*//*Label 1625*/ GIMT_Encode4(110252), // Rule ID 3014 //
     /* 110165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 110168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 110172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 110176 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 110180 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 110184 */     // MIs[1] Operand 1
     /* 110184 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 110189 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110191 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETNE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_eq:{ *:[i32] }))
     /* 110191 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 110194 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 110198 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110203 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 110207 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 110211 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 110213 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 110216 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110220 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110225 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 110232 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 110237 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 110242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 110245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 110247 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110250 */     GIR_RootConstrainSelectedInstOperands,
     /* 110251 */     // GIR_Coverage, 3014,
     /* 110251 */     GIR_EraseRootFromParent_Done,
     /* 110252 */   // Label 1625: @110252
     /* 110252 */   GIM_Try, /*On fail goto*//*Label 1626*/ GIMT_Encode4(110344), // Rule ID 3078 //
     /* 110257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 110260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 110264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 110268 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 110272 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 110276 */     // MIs[1] Operand 1
     /* 110276 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 110281 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110283 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }))
     /* 110283 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 110286 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 110290 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110295 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 110299 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 110303 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 110305 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 110308 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110312 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110317 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 110324 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 110329 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 110334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 110337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 110339 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110342 */     GIR_RootConstrainSelectedInstOperands,
     /* 110343 */     // GIR_Coverage, 3078,
     /* 110343 */     GIR_EraseRootFromParent_Done,
     /* 110344 */   // Label 1626: @110344
     /* 110344 */   GIM_Try, /*On fail goto*//*Label 1627*/ GIMT_Encode4(110436), // Rule ID 3086 //
     /* 110349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 110352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 110356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 110360 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 110364 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 110368 */     // MIs[1] Operand 1
     /* 110368 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 110373 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110375 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETGE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }))
     /* 110375 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 110378 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 110382 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110387 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 110391 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 110395 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 110397 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 110400 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110404 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110409 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 110416 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 110421 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 110426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 110429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 110431 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110434 */     GIR_RootConstrainSelectedInstOperands,
     /* 110435 */     // GIR_Coverage, 3086,
     /* 110435 */     GIR_EraseRootFromParent_Done,
     /* 110436 */   // Label 1627: @110436
     /* 110436 */   GIM_Try, /*On fail goto*//*Label 1628*/ GIMT_Encode4(110528), // Rule ID 3094 //
     /* 110441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 110444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 110448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 110452 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 110456 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 110460 */     // MIs[1] Operand 1
     /* 110460 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 110465 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110467 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }))
     /* 110467 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 110470 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 110474 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110479 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 110483 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 110487 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 110489 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 110492 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110496 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110501 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 110508 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 110513 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 110518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 110521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 110523 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110526 */     GIR_RootConstrainSelectedInstOperands,
     /* 110527 */     // GIR_Coverage, 3094,
     /* 110527 */     GIR_EraseRootFromParent_Done,
     /* 110528 */   // Label 1628: @110528
     /* 110528 */   GIM_Try, /*On fail goto*//*Label 1629*/ GIMT_Encode4(110620), // Rule ID 3102 //
     /* 110533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 110536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 110540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 110544 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 110548 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 110552 */     // MIs[1] Operand 1
     /* 110552 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 110557 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110559 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETLE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }))
     /* 110559 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 110562 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 110566 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110571 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 110575 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 110579 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 110581 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 110584 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110588 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110593 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 110600 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 110605 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 110610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 110613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 110615 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110618 */     GIR_RootConstrainSelectedInstOperands,
     /* 110619 */     // GIR_Coverage, 3102,
     /* 110619 */     GIR_EraseRootFromParent_Done,
     /* 110620 */   // Label 1629: @110620
     /* 110620 */   GIM_Try, /*On fail goto*//*Label 1630*/ GIMT_Encode4(110712), // Rule ID 3110 //
     /* 110625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 110628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 110632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 110636 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 110640 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 110644 */     // MIs[1] Operand 1
     /* 110644 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 110649 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110651 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETNE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_eq:{ *:[i32] }))
     /* 110651 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 110654 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 110658 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110663 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 110667 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 110671 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 110673 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 110676 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110680 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110685 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 110692 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 110697 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 110702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 110705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 110707 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110710 */     GIR_RootConstrainSelectedInstOperands,
     /* 110711 */     // GIR_Coverage, 3110,
     /* 110711 */     GIR_EraseRootFromParent_Done,
     /* 110712 */   // Label 1630: @110712
     /* 110712 */   GIM_Try, /*On fail goto*//*Label 1631*/ GIMT_Encode4(110844), // Rule ID 3832 //
     /* 110717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 110720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 110724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 110728 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 110732 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 110736 */     // MIs[1] Operand 1
     /* 110736 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 110741 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110743 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 110743 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 110746 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 110750 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110755 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 110759 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 110763 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 110765 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 110768 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 110772 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110777 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 110780 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 110782 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 110785 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 110789 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110794 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 110797 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 110799 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 110802 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110806 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110811 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 110818 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 110823 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 110828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 110831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110833 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110836 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 110839 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 110842 */     GIR_RootConstrainSelectedInstOperands,
     /* 110843 */     // GIR_Coverage, 3832,
     /* 110843 */     GIR_EraseRootFromParent_Done,
     /* 110844 */   // Label 1631: @110844
     /* 110844 */   GIM_Try, /*On fail goto*//*Label 1632*/ GIMT_Encode4(110976), // Rule ID 3840 //
     /* 110849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 110852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 110856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 110860 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 110864 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 110868 */     // MIs[1] Operand 1
     /* 110868 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 110873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110875 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 110875 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 110878 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 110882 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110887 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 110891 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 110895 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 110897 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 110900 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 110904 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110909 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 110912 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 110914 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 110917 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 110921 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110926 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 110929 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 110931 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 110934 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110938 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110943 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 110950 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 110955 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 110960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 110963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110965 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110968 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 110971 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 110974 */     GIR_RootConstrainSelectedInstOperands,
     /* 110975 */     // GIR_Coverage, 3840,
     /* 110975 */     GIR_EraseRootFromParent_Done,
     /* 110976 */   // Label 1632: @110976
     /* 110976 */   GIM_Try, /*On fail goto*//*Label 1633*/ GIMT_Encode4(111108), // Rule ID 3848 //
     /* 110981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 110984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 110988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 110992 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 110996 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 111000 */     // MIs[1] Operand 1
     /* 111000 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 111005 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111007 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 111007 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 111010 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 111014 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111019 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 111023 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 111027 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 111029 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 111032 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 111036 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111041 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 111044 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 111046 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 111049 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 111053 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111058 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 111061 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 111063 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 111066 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111070 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111075 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 111082 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 111087 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 111092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 111095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111097 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111100 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 111103 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 111106 */     GIR_RootConstrainSelectedInstOperands,
     /* 111107 */     // GIR_Coverage, 3848,
     /* 111107 */     GIR_EraseRootFromParent_Done,
     /* 111108 */   // Label 1633: @111108
     /* 111108 */   GIM_Try, /*On fail goto*//*Label 1634*/ GIMT_Encode4(111240), // Rule ID 3856 //
     /* 111113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 111116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 111124 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 111128 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 111132 */     // MIs[1] Operand 1
     /* 111132 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 111137 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111139 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETLE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 111139 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 111142 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 111146 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111151 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 111155 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 111159 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 111161 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 111164 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 111168 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111173 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 111176 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 111178 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 111181 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 111185 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111190 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 111193 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 111195 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 111198 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111202 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111207 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 111214 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 111219 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 111224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 111227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111229 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111232 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 111235 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 111238 */     GIR_RootConstrainSelectedInstOperands,
     /* 111239 */     // GIR_Coverage, 3856,
     /* 111239 */     GIR_EraseRootFromParent_Done,
     /* 111240 */   // Label 1634: @111240
     /* 111240 */   GIM_Try, /*On fail goto*//*Label 1635*/ GIMT_Encode4(111372), // Rule ID 3864 //
     /* 111245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 111248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 111256 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 111260 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 111264 */     // MIs[1] Operand 1
     /* 111264 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 111269 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111271 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 111271 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 111274 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 111278 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111283 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 111287 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 111291 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 111293 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 111296 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 111300 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111305 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 111308 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 111310 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 111313 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 111317 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111322 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 111325 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 111327 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 111330 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111334 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111339 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 111346 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 111351 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 111356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 111359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111361 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111364 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 111367 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 111370 */     GIR_RootConstrainSelectedInstOperands,
     /* 111371 */     // GIR_Coverage, 3864,
     /* 111371 */     GIR_EraseRootFromParent_Done,
     /* 111372 */   // Label 1635: @111372
     /* 111372 */   GIM_Try, /*On fail goto*//*Label 1636*/ GIMT_Encode4(111504), // Rule ID 3928 //
     /* 111377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 111380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 111388 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 111392 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 111396 */     // MIs[1] Operand 1
     /* 111396 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 111401 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111403 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 111403 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 111406 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 111410 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111415 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 111419 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 111423 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 111425 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 111428 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 111432 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111437 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 111440 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 111442 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 111445 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 111449 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111454 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 111457 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 111459 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 111462 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111466 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111471 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 111478 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 111483 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 111488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 111491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111493 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111496 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 111499 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 111502 */     GIR_RootConstrainSelectedInstOperands,
     /* 111503 */     // GIR_Coverage, 3928,
     /* 111503 */     GIR_EraseRootFromParent_Done,
     /* 111504 */   // Label 1636: @111504
     /* 111504 */   GIM_Try, /*On fail goto*//*Label 1637*/ GIMT_Encode4(111636), // Rule ID 3936 //
     /* 111509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 111512 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111516 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 111520 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 111524 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 111528 */     // MIs[1] Operand 1
     /* 111528 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 111533 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111535 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 111535 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 111538 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 111542 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111547 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 111551 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 111555 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 111557 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 111560 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 111564 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111569 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 111572 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 111574 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 111577 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 111581 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111586 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 111589 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 111591 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 111594 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111598 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111603 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 111610 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 111615 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 111620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 111623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111625 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111628 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 111631 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 111634 */     GIR_RootConstrainSelectedInstOperands,
     /* 111635 */     // GIR_Coverage, 3936,
     /* 111635 */     GIR_EraseRootFromParent_Done,
     /* 111636 */   // Label 1637: @111636
     /* 111636 */   GIM_Try, /*On fail goto*//*Label 1638*/ GIMT_Encode4(111768), // Rule ID 3944 //
     /* 111641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 111644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 111652 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 111656 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 111660 */     // MIs[1] Operand 1
     /* 111660 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 111665 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111667 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 111667 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 111670 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 111674 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111679 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 111683 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 111687 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 111689 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 111692 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 111696 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111701 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 111704 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 111706 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 111709 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 111713 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111718 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 111721 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 111723 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 111726 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111730 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111735 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 111742 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 111747 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 111752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 111755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111757 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111760 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 111763 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 111766 */     GIR_RootConstrainSelectedInstOperands,
     /* 111767 */     // GIR_Coverage, 3944,
     /* 111767 */     GIR_EraseRootFromParent_Done,
     /* 111768 */   // Label 1638: @111768
     /* 111768 */   GIM_Try, /*On fail goto*//*Label 1639*/ GIMT_Encode4(111900), // Rule ID 3952 //
     /* 111773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 111776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 111784 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 111788 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 111792 */     // MIs[1] Operand 1
     /* 111792 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 111797 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111799 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETLE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 111799 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 111802 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 111806 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111811 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 111815 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 111819 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 111821 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 111824 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 111828 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111833 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 111836 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 111838 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 111841 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 111845 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111850 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 111853 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 111855 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 111858 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111862 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111867 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 111874 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 111879 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 111884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 111887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111889 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111892 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 111895 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 111898 */     GIR_RootConstrainSelectedInstOperands,
     /* 111899 */     // GIR_Coverage, 3952,
     /* 111899 */     GIR_EraseRootFromParent_Done,
     /* 111900 */   // Label 1639: @111900
     /* 111900 */   GIM_Try, /*On fail goto*//*Label 1640*/ GIMT_Encode4(112032), // Rule ID 3960 //
     /* 111905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 111908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 111916 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 111920 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 111924 */     // MIs[1] Operand 1
     /* 111924 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 111929 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111931 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 111931 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 111934 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 111938 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111943 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 111947 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 111951 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 111953 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 111956 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 111960 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111965 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 111968 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 111970 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 111973 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 111977 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111982 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 111985 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 111987 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 111990 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111994 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111999 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 112006 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 112011 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 112016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 112019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112021 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112024 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 112027 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 112030 */     GIR_RootConstrainSelectedInstOperands,
     /* 112031 */     // GIR_Coverage, 3960,
     /* 112031 */     GIR_EraseRootFromParent_Done,
     /* 112032 */   // Label 1640: @112032
     /* 112032 */   GIM_Try, /*On fail goto*//*Label 1641*/ GIMT_Encode4(112047), // Rule ID 2982 //
     /* 112037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 112040 */     // (anyext:{ *:[i64] } i1:{ *:[i1] }:$in)  =>  (SETBC8:{ *:[i64] } ?:{ *:[i1] }:$in)
     /* 112040 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SETBC8),
     /* 112045 */     GIR_RootConstrainSelectedInstOperands,
     /* 112046 */     // GIR_Coverage, 2982,
     /* 112046 */     GIR_Done,
     /* 112047 */   // Label 1641: @112047
     /* 112047 */   GIM_Try, /*On fail goto*//*Label 1642*/ GIMT_Encode4(112101), // Rule ID 3638 //
     /* 112052 */     // (anyext:{ *:[i64] } i1:{ *:[i1] }:$in)  =>  (SELECT_I8:{ *:[i64] } ?:{ *:[i1] }:$in, (LI8:{ *:[i64] } 1:{ *:[i64] }), (LI8:{ *:[i64] } 0:{ *:[i64] }))
     /* 112052 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 112055 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 112059 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112064 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 112067 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 112069 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 112072 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 112076 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112081 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 112084 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 112086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 112089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112091 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /* 112093 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112096 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 112099 */     GIR_RootConstrainSelectedInstOperands,
     /* 112100 */     // GIR_Coverage, 3638,
     /* 112100 */     GIR_EraseRootFromParent_Done,
     /* 112101 */   // Label 1642: @112101
     /* 112101 */   GIM_Reject,
     /* 112102 */ // Label 1550: @112102
     /* 112102 */ GIM_Reject,
     /* 112103 */ // Label 1456: @112103
     /* 112103 */ GIM_Reject,
     /* 112104 */ // Label 22: @112104
     /* 112104 */ GIM_Try, /*On fail goto*//*Label 1643*/ GIMT_Encode4(112289),
     /* 112109 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
     /* 112112 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1646*/ GIMT_Encode4(112223),
     /* 112123 */   /*GILLT_s32*//*Label 1644*/ GIMT_Encode4(112131),
     /* 112127 */   /*GILLT_s64*//*Label 1645*/ GIMT_Encode4(112177),
     /* 112131 */   // Label 1644: @112131
     /* 112131 */   GIM_Try, /*On fail goto*//*Label 1647*/ GIMT_Encode4(112176), // Rule ID 1168 //
     /* 112136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 112140 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112144 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 112148 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 112152 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 112156 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 112160 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112162 */     // (trunc:{ *:[i1] } (xor:{ *:[i32] } i32:{ *:[i32] }:$in, -1:{ *:[i32] }))  =>  (ANDI_rec_1_EQ_BIT:{ *:[i1] }:{ *:[i32] } i32:{ *:[i32] }:$in)
     /* 112162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::ANDI_rec_1_EQ_BIT),
     /* 112165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112167 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // in
     /* 112171 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CR0*/0,
     /* 112174 */     GIR_RootConstrainSelectedInstOperands,
     /* 112175 */     // GIR_Coverage, 1168,
     /* 112175 */     GIR_EraseRootFromParent_Done,
     /* 112176 */   // Label 1647: @112176
     /* 112176 */   GIM_Reject,
     /* 112177 */   // Label 1645: @112177
     /* 112177 */   GIM_Try, /*On fail goto*//*Label 1648*/ GIMT_Encode4(112222), // Rule ID 1170 //
     /* 112182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 112186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 112194 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 112198 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 112202 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 112206 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112208 */     // (trunc:{ *:[i1] } (xor:{ *:[i64] } i64:{ *:[i64] }:$in, -1:{ *:[i64] }))  =>  (ANDI_rec_1_EQ_BIT8:{ *:[i1] }:{ *:[i32] } i64:{ *:[i64] }:$in)
     /* 112208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::ANDI_rec_1_EQ_BIT8),
     /* 112211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112213 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // in
     /* 112217 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CR0*/0,
     /* 112220 */     GIR_RootConstrainSelectedInstOperands,
     /* 112221 */     // GIR_Coverage, 1170,
     /* 112221 */     GIR_EraseRootFromParent_Done,
     /* 112222 */   // Label 1648: @112222
     /* 112222 */   GIM_Reject,
     /* 112223 */   // Label 1646: @112223
     /* 112223 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1651*/ GIMT_Encode4(112288),
     /* 112234 */   /*GILLT_s32*//*Label 1649*/ GIMT_Encode4(112242),
     /* 112238 */   /*GILLT_s64*//*Label 1650*/ GIMT_Encode4(112265),
     /* 112242 */   // Label 1649: @112242
     /* 112242 */   GIM_Try, /*On fail goto*//*Label 1652*/ GIMT_Encode4(112264), // Rule ID 1169 //
     /* 112247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 112251 */     // (trunc:{ *:[i1] } i32:{ *:[i32] }:$in)  =>  (ANDI_rec_1_GT_BIT:{ *:[i1] }:{ *:[i32] } i32:{ *:[i32] }:$in)
     /* 112251 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::ANDI_rec_1_GT_BIT),
     /* 112256 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(PPC::CR0), GIMT_Encode2(RegState::Dead),
     /* 112262 */     GIR_RootConstrainSelectedInstOperands,
     /* 112263 */     // GIR_Coverage, 1169,
     /* 112263 */     GIR_Done,
     /* 112264 */   // Label 1652: @112264
     /* 112264 */   GIM_Reject,
     /* 112265 */   // Label 1650: @112265
     /* 112265 */   GIM_Try, /*On fail goto*//*Label 1653*/ GIMT_Encode4(112287), // Rule ID 1171 //
     /* 112270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 112274 */     // (trunc:{ *:[i1] } i64:{ *:[i64] }:$in)  =>  (ANDI_rec_1_GT_BIT8:{ *:[i1] }:{ *:[i32] } i64:{ *:[i64] }:$in)
     /* 112274 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::ANDI_rec_1_GT_BIT8),
     /* 112279 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(PPC::CR0), GIMT_Encode2(RegState::Dead),
     /* 112285 */     GIR_RootConstrainSelectedInstOperands,
     /* 112286 */     // GIR_Coverage, 1171,
     /* 112286 */     GIR_Done,
     /* 112287 */   // Label 1653: @112287
     /* 112287 */   GIM_Reject,
     /* 112288 */   // Label 1651: @112288
     /* 112288 */   GIM_Reject,
     /* 112289 */ // Label 1643: @112289
     /* 112289 */ GIM_Reject,
     /* 112290 */ // Label 23: @112290
     /* 112290 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 1657*/ GIMT_Encode4(112441),
     /* 112301 */ /*GILLT_s1*//*Label 1654*/ GIMT_Encode4(112313),
     /* 112305 */ /*GILLT_s32*//*Label 1655*/ GIMT_Encode4(112393),
     /* 112309 */ /*GILLT_s64*//*Label 1656*/ GIMT_Encode4(112417),
     /* 112313 */ // Label 1654: @112313
     /* 112313 */ GIM_Try, /*On fail goto*//*Label 1658*/ GIMT_Encode4(112392),
     /* 112318 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 112322 */   GIM_Try, /*On fail goto*//*Label 1659*/ GIMT_Encode4(112345), // Rule ID 184 //
     /* 112327 */     // MIs[0] Operand 1
     /* 112327 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/1, GIMT_Encode8(1),
     /* 112338 */     // 1:{ *:[i1] }  =>  (CRSET:{ *:[i1] })
     /* 112338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRSET),
     /* 112341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 112343 */     GIR_RootConstrainSelectedInstOperands,
     /* 112344 */     // GIR_Coverage, 184,
     /* 112344 */     GIR_EraseRootFromParent_Done,
     /* 112345 */   // Label 1659: @112345
     /* 112345 */   GIM_Try, /*On fail goto*//*Label 1660*/ GIMT_Encode4(112368), // Rule ID 185 //
     /* 112350 */     // MIs[0] Operand 1
     /* 112350 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/1, GIMT_Encode8(0),
     /* 112361 */     // 0:{ *:[i1] }  =>  (CRUNSET:{ *:[i1] })
     /* 112361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRUNSET),
     /* 112364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 112366 */     GIR_RootConstrainSelectedInstOperands,
     /* 112367 */     // GIR_Coverage, 185,
     /* 112367 */     GIR_EraseRootFromParent_Done,
     /* 112368 */   // Label 1660: @112368
     /* 112368 */   GIM_Try, /*On fail goto*//*Label 1661*/ GIMT_Encode4(112391), // Rule ID 3632 //
     /* 112373 */     // MIs[0] Operand 1
     /* 112373 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/1, GIMT_Encode8(-1),
     /* 112384 */     // -1:{ *:[i1] }  =>  (CRSET:{ *:[i1] })
     /* 112384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRSET),
     /* 112387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 112389 */     GIR_RootConstrainSelectedInstOperands,
     /* 112390 */     // GIR_Coverage, 3632,
     /* 112390 */     GIR_EraseRootFromParent_Done,
     /* 112391 */   // Label 1661: @112391
     /* 112391 */   GIM_Reject,
     /* 112392 */ // Label 1658: @112392
     /* 112392 */ GIM_Reject,
     /* 112393 */ // Label 1655: @112393
     /* 112393 */ GIM_Try, /*On fail goto*//*Label 1662*/ GIMT_Encode4(112416), // Rule ID 113 //
     /* 112398 */   GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 112402 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 112406 */   // MIs[0] Operand 1
     /* 112406 */   // No operand predicates
     /* 112406 */   // (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$D  =>  (LI:{ *:[i32] } (imm:{ *:[i32] }):$D)
     /* 112406 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 112409 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 112411 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // D
     /* 112414 */   GIR_RootConstrainSelectedInstOperands,
     /* 112415 */   // GIR_Coverage, 113,
     /* 112415 */   GIR_EraseRootFromParent_Done,
     /* 112416 */ // Label 1662: @112416
     /* 112416 */ GIM_Reject,
     /* 112417 */ // Label 1656: @112417
     /* 112417 */ GIM_Try, /*On fail goto*//*Label 1663*/ GIMT_Encode4(112440), // Rule ID 639 //
     /* 112422 */   GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 112426 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 112430 */   // MIs[0] Operand 1
     /* 112430 */   // No operand predicates
     /* 112430 */   // (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$D  =>  (LI8:{ *:[i64] } (imm:{ *:[i64] }):$D)
     /* 112430 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 112433 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 112435 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // D
     /* 112438 */   GIR_RootConstrainSelectedInstOperands,
     /* 112439 */   // GIR_Coverage, 639,
     /* 112439 */   GIR_EraseRootFromParent_Done,
     /* 112440 */ // Label 1663: @112440
     /* 112440 */ GIM_Reject,
     /* 112441 */ // Label 1657: @112441
     /* 112441 */ GIM_Reject,
     /* 112442 */ // Label 24: @112442
     /* 112442 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1666*/ GIMT_Encode4(127473),
     /* 112453 */ /*GILLT_s32*//*Label 1664*/ GIMT_Encode4(112461),
     /* 112457 */ /*GILLT_s64*//*Label 1665*/ GIMT_Encode4(119740),
     /* 112461 */ // Label 1664: @112461
     /* 112461 */ GIM_Try, /*On fail goto*//*Label 1667*/ GIMT_Encode4(119739),
     /* 112466 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 112469 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 112473 */   GIM_Try, /*On fail goto*//*Label 1668*/ GIMT_Encode4(112576), // Rule ID 3027 //
     /* 112478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 112481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 112489 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 112493 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 112497 */     // MIs[1] Operand 1
     /* 112497 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 112502 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 112506 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 112510 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 112514 */     // MIs[2] Operand 1
     /* 112514 */     // No operand predicates
     /* 112514 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 112516 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_lt:{ *:[i32] }))
     /* 112516 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 112519 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 112523 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112528 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 112532 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 112535 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 112537 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 112540 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112544 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112549 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 112556 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 112561 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 112566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 112569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 112571 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112574 */     GIR_RootConstrainSelectedInstOperands,
     /* 112575 */     // GIR_Coverage, 3027,
     /* 112575 */     GIR_EraseRootFromParent_Done,
     /* 112576 */   // Label 1668: @112576
     /* 112576 */   GIM_Try, /*On fail goto*//*Label 1669*/ GIMT_Encode4(112679), // Rule ID 3043 //
     /* 112581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 112584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 112592 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 112596 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 112600 */     // MIs[1] Operand 1
     /* 112600 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 112605 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 112609 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 112613 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 112617 */     // MIs[2] Operand 1
     /* 112617 */     // No operand predicates
     /* 112617 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 112619 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_gt:{ *:[i32] }))
     /* 112619 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 112622 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 112626 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112631 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 112635 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 112638 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 112640 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 112643 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112647 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112652 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 112659 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 112664 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 112669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 112672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 112674 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112677 */     GIR_RootConstrainSelectedInstOperands,
     /* 112678 */     // GIR_Coverage, 3043,
     /* 112678 */     GIR_EraseRootFromParent_Done,
     /* 112679 */   // Label 1669: @112679
     /* 112679 */   GIM_Try, /*On fail goto*//*Label 1670*/ GIMT_Encode4(112782), // Rule ID 3051 //
     /* 112684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 112687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 112695 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 112699 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 112703 */     // MIs[1] Operand 1
     /* 112703 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 112708 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 112712 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 112716 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 112720 */     // MIs[2] Operand 1
     /* 112720 */     // No operand predicates
     /* 112720 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 112722 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_eq:{ *:[i32] }))
     /* 112722 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 112725 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 112729 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112734 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 112738 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 112741 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 112743 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 112746 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112750 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112755 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 112762 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 112767 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 112772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 112775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 112777 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112780 */     GIR_RootConstrainSelectedInstOperands,
     /* 112781 */     // GIR_Coverage, 3051,
     /* 112781 */     GIR_EraseRootFromParent_Done,
     /* 112782 */   // Label 1670: @112782
     /* 112782 */   GIM_Try, /*On fail goto*//*Label 1671*/ GIMT_Encode4(112885), // Rule ID 3123 //
     /* 112787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 112790 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112794 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 112798 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 112802 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 112806 */     // MIs[1] Operand 1
     /* 112806 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 112811 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 112815 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 112819 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 112823 */     // MIs[2] Operand 1
     /* 112823 */     // No operand predicates
     /* 112823 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 112825 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_lt:{ *:[i32] }))
     /* 112825 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 112828 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 112832 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112837 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 112841 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 112844 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 112846 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 112849 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112853 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112858 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 112865 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 112870 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 112875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 112878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 112880 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112883 */     GIR_RootConstrainSelectedInstOperands,
     /* 112884 */     // GIR_Coverage, 3123,
     /* 112884 */     GIR_EraseRootFromParent_Done,
     /* 112885 */   // Label 1671: @112885
     /* 112885 */   GIM_Try, /*On fail goto*//*Label 1672*/ GIMT_Encode4(112988), // Rule ID 3139 //
     /* 112890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 112893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 112901 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 112905 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 112909 */     // MIs[1] Operand 1
     /* 112909 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 112914 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 112918 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 112922 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 112926 */     // MIs[2] Operand 1
     /* 112926 */     // No operand predicates
     /* 112926 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 112928 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_gt:{ *:[i32] }))
     /* 112928 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 112931 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 112935 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112940 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 112944 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 112947 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 112949 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 112952 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112956 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112961 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 112968 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 112973 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 112978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 112981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 112983 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112986 */     GIR_RootConstrainSelectedInstOperands,
     /* 112987 */     // GIR_Coverage, 3139,
     /* 112987 */     GIR_EraseRootFromParent_Done,
     /* 112988 */   // Label 1672: @112988
     /* 112988 */   GIM_Try, /*On fail goto*//*Label 1673*/ GIMT_Encode4(113091), // Rule ID 3147 //
     /* 112993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 112996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 113004 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113008 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 113012 */     // MIs[1] Operand 1
     /* 113012 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 113017 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 113021 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 113025 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 113029 */     // MIs[2] Operand 1
     /* 113029 */     // No operand predicates
     /* 113029 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 113031 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_eq:{ *:[i32] }))
     /* 113031 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 113034 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 113038 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113043 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 113047 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 113050 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 113052 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 113055 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113059 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113064 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 113071 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 113076 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 113081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 113084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 113086 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113089 */     GIR_RootConstrainSelectedInstOperands,
     /* 113090 */     // GIR_Coverage, 3147,
     /* 113090 */     GIR_EraseRootFromParent_Done,
     /* 113091 */   // Label 1673: @113091
     /* 113091 */   GIM_Try, /*On fail goto*//*Label 1674*/ GIMT_Encode4(113234), // Rule ID 3780 //
     /* 113096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 113099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 113107 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 113111 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 113115 */     // MIs[1] Operand 1
     /* 113115 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 113120 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 113124 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 113128 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 113132 */     // MIs[2] Operand 1
     /* 113132 */     // No operand predicates
     /* 113132 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 113134 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 113134 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 113137 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 113141 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113146 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 113150 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 113153 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 113155 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 113158 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 113162 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113167 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 113170 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 113172 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 113175 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 113179 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113184 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 113187 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 113189 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 113192 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113196 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113201 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 113208 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 113213 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 113218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 113221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 113223 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113226 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 113229 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 113232 */     GIR_RootConstrainSelectedInstOperands,
     /* 113233 */     // GIR_Coverage, 3780,
     /* 113233 */     GIR_EraseRootFromParent_Done,
     /* 113234 */   // Label 1674: @113234
     /* 113234 */   GIM_Try, /*On fail goto*//*Label 1675*/ GIMT_Encode4(113377), // Rule ID 3796 //
     /* 113239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 113242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 113250 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 113254 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 113258 */     // MIs[1] Operand 1
     /* 113258 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 113263 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 113267 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 113271 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 113275 */     // MIs[2] Operand 1
     /* 113275 */     // No operand predicates
     /* 113275 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 113277 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 113277 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 113280 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 113284 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113289 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 113293 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 113296 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 113298 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 113301 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 113305 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113310 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 113313 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 113315 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 113318 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 113322 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113327 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 113330 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 113332 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 113335 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113339 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113344 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 113351 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 113356 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 113361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 113364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 113366 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113369 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 113372 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 113375 */     GIR_RootConstrainSelectedInstOperands,
     /* 113376 */     // GIR_Coverage, 3796,
     /* 113376 */     GIR_EraseRootFromParent_Done,
     /* 113377 */   // Label 1675: @113377
     /* 113377 */   GIM_Try, /*On fail goto*//*Label 1676*/ GIMT_Encode4(113520), // Rule ID 3804 //
     /* 113382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 113385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 113393 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 113397 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 113401 */     // MIs[1] Operand 1
     /* 113401 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 113406 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 113410 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 113414 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 113418 */     // MIs[2] Operand 1
     /* 113418 */     // No operand predicates
     /* 113418 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 113420 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 113420 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 113423 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 113427 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113432 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 113436 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 113439 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 113441 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 113444 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 113448 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113453 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 113456 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 113458 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 113461 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 113465 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113470 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 113473 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 113475 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 113478 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113482 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113487 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 113494 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 113499 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 113504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 113507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 113509 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113512 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 113515 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 113518 */     GIR_RootConstrainSelectedInstOperands,
     /* 113519 */     // GIR_Coverage, 3804,
     /* 113519 */     GIR_EraseRootFromParent_Done,
     /* 113520 */   // Label 1676: @113520
     /* 113520 */   GIM_Try, /*On fail goto*//*Label 1677*/ GIMT_Encode4(113663), // Rule ID 3876 //
     /* 113525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 113528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 113536 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113540 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 113544 */     // MIs[1] Operand 1
     /* 113544 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 113549 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 113553 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 113557 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 113561 */     // MIs[2] Operand 1
     /* 113561 */     // No operand predicates
     /* 113561 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 113563 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 113563 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 113566 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 113570 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113575 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 113579 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 113582 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 113584 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 113587 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 113591 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113596 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 113599 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 113601 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 113604 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 113608 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113613 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 113616 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 113618 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 113621 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113625 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113630 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 113637 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 113642 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 113647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 113650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 113652 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113655 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 113658 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 113661 */     GIR_RootConstrainSelectedInstOperands,
     /* 113662 */     // GIR_Coverage, 3876,
     /* 113662 */     GIR_EraseRootFromParent_Done,
     /* 113663 */   // Label 1677: @113663
     /* 113663 */   GIM_Try, /*On fail goto*//*Label 1678*/ GIMT_Encode4(113806), // Rule ID 3892 //
     /* 113668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 113671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 113679 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113683 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 113687 */     // MIs[1] Operand 1
     /* 113687 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 113692 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 113696 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 113700 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 113704 */     // MIs[2] Operand 1
     /* 113704 */     // No operand predicates
     /* 113704 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 113706 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 113706 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 113709 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 113713 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113718 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 113722 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 113725 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 113727 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 113730 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 113734 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113739 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 113742 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 113744 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 113747 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 113751 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113756 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 113759 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 113761 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 113764 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113768 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113773 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 113780 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 113785 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 113790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 113793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 113795 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113798 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 113801 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 113804 */     GIR_RootConstrainSelectedInstOperands,
     /* 113805 */     // GIR_Coverage, 3892,
     /* 113805 */     GIR_EraseRootFromParent_Done,
     /* 113806 */   // Label 1678: @113806
     /* 113806 */   GIM_Try, /*On fail goto*//*Label 1679*/ GIMT_Encode4(113949), // Rule ID 3900 //
     /* 113811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 113814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 113822 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113826 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 113830 */     // MIs[1] Operand 1
     /* 113830 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 113835 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 113839 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 113843 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 113847 */     // MIs[2] Operand 1
     /* 113847 */     // No operand predicates
     /* 113847 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 113849 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 113849 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 113852 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 113856 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113861 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 113865 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 113868 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 113870 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 113873 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 113877 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113882 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 113885 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 113887 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 113890 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 113894 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113899 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 113902 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 113904 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 113907 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113911 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113916 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 113923 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 113928 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 113933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 113936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 113938 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113941 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 113944 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 113947 */     GIR_RootConstrainSelectedInstOperands,
     /* 113948 */     // GIR_Coverage, 3900,
     /* 113948 */     GIR_EraseRootFromParent_Done,
     /* 113949 */   // Label 1679: @113949
     /* 113949 */   GIM_Try, /*On fail goto*//*Label 1680*/ GIMT_Encode4(114041), // Rule ID 3171 //
     /* 113954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 113957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 113965 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 113969 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 113973 */     // MIs[1] Operand 1
     /* 113973 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 113978 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113980 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_lt:{ *:[i32] }))
     /* 113980 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 113983 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 113987 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113992 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 113996 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 114000 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 114002 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 114005 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114009 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114014 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 114021 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 114026 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 114031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 114034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 114036 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114039 */     GIR_RootConstrainSelectedInstOperands,
     /* 114040 */     // GIR_Coverage, 3171,
     /* 114040 */     GIR_EraseRootFromParent_Done,
     /* 114041 */   // Label 1680: @114041
     /* 114041 */   GIM_Try, /*On fail goto*//*Label 1681*/ GIMT_Encode4(114133), // Rule ID 3187 //
     /* 114046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 114049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 114057 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 114061 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 114065 */     // MIs[1] Operand 1
     /* 114065 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 114070 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114072 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }))
     /* 114072 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 114075 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 114079 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114084 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 114088 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 114092 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 114094 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 114097 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114101 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114106 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 114113 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 114118 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 114123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 114126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 114128 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114131 */     GIR_RootConstrainSelectedInstOperands,
     /* 114132 */     // GIR_Coverage, 3187,
     /* 114132 */     GIR_EraseRootFromParent_Done,
     /* 114133 */   // Label 1681: @114133
     /* 114133 */   GIM_Try, /*On fail goto*//*Label 1682*/ GIMT_Encode4(114225), // Rule ID 3203 //
     /* 114138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 114141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 114149 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 114153 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 114157 */     // MIs[1] Operand 1
     /* 114157 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 114162 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114164 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_eq:{ *:[i32] }))
     /* 114164 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 114167 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 114171 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114176 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 114180 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 114184 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 114186 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 114189 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114193 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114198 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 114205 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 114210 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 114215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 114218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 114220 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114223 */     GIR_RootConstrainSelectedInstOperands,
     /* 114224 */     // GIR_Coverage, 3203,
     /* 114224 */     GIR_EraseRootFromParent_Done,
     /* 114225 */   // Label 1682: @114225
     /* 114225 */   GIM_Try, /*On fail goto*//*Label 1683*/ GIMT_Encode4(114317), // Rule ID 3219 //
     /* 114230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 114233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 114241 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 114245 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 114249 */     // MIs[1] Operand 1
     /* 114249 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 114254 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114256 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETO:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_un:{ *:[i32] }))
     /* 114256 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 114259 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 114263 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114268 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 114272 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 114276 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 114278 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 114281 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114285 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114290 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 114297 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 114302 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 114307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 114310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 114312 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114315 */     GIR_RootConstrainSelectedInstOperands,
     /* 114316 */     // GIR_Coverage, 3219,
     /* 114316 */     GIR_EraseRootFromParent_Done,
     /* 114317 */   // Label 1683: @114317
     /* 114317 */   GIM_Try, /*On fail goto*//*Label 1684*/ GIMT_Encode4(114409), // Rule ID 3227 //
     /* 114322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 114325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 114333 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114337 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 114341 */     // MIs[1] Operand 1
     /* 114341 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 114346 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114348 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_lt:{ *:[i32] }))
     /* 114348 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 114351 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 114355 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114360 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 114364 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 114368 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 114370 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 114373 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114377 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114382 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 114389 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 114394 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 114399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 114402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 114404 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114407 */     GIR_RootConstrainSelectedInstOperands,
     /* 114408 */     // GIR_Coverage, 3227,
     /* 114408 */     GIR_EraseRootFromParent_Done,
     /* 114409 */   // Label 1684: @114409
     /* 114409 */   GIM_Try, /*On fail goto*//*Label 1685*/ GIMT_Encode4(114501), // Rule ID 3243 //
     /* 114414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 114417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 114425 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114429 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 114433 */     // MIs[1] Operand 1
     /* 114433 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 114438 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114440 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }))
     /* 114440 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 114443 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 114447 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114452 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 114456 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 114460 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 114462 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 114465 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114469 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114474 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 114481 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 114486 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 114491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 114494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 114496 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114499 */     GIR_RootConstrainSelectedInstOperands,
     /* 114500 */     // GIR_Coverage, 3243,
     /* 114500 */     GIR_EraseRootFromParent_Done,
     /* 114501 */   // Label 1685: @114501
     /* 114501 */   GIM_Try, /*On fail goto*//*Label 1686*/ GIMT_Encode4(114593), // Rule ID 3259 //
     /* 114506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 114509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 114517 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114521 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 114525 */     // MIs[1] Operand 1
     /* 114525 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 114530 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114532 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_eq:{ *:[i32] }))
     /* 114532 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 114535 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 114539 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114544 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 114548 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 114552 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 114554 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 114557 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114561 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114566 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 114573 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 114578 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 114583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 114586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 114588 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114591 */     GIR_RootConstrainSelectedInstOperands,
     /* 114592 */     // GIR_Coverage, 3259,
     /* 114592 */     GIR_EraseRootFromParent_Done,
     /* 114593 */   // Label 1686: @114593
     /* 114593 */   GIM_Try, /*On fail goto*//*Label 1687*/ GIMT_Encode4(114685), // Rule ID 3275 //
     /* 114598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 114601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 114609 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114613 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 114617 */     // MIs[1] Operand 1
     /* 114617 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 114622 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114624 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETO:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_un:{ *:[i32] }))
     /* 114624 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 114627 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 114631 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114636 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 114640 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 114644 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 114646 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 114649 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114653 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114658 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 114665 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 114670 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 114675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 114678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 114680 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114683 */     GIR_RootConstrainSelectedInstOperands,
     /* 114684 */     // GIR_Coverage, 3275,
     /* 114684 */     GIR_EraseRootFromParent_Done,
     /* 114685 */   // Label 1687: @114685
     /* 114685 */   GIM_Try, /*On fail goto*//*Label 1688*/ GIMT_Encode4(114777), // Rule ID 3283 //
     /* 114690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 114693 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114697 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 114701 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 114705 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 114709 */     // MIs[1] Operand 1
     /* 114709 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 114714 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114716 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_lt:{ *:[i32] }))
     /* 114716 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 114719 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 114723 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114728 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 114732 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 114736 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 114738 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 114741 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114745 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114750 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 114757 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 114762 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 114767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 114770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 114772 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114775 */     GIR_RootConstrainSelectedInstOperands,
     /* 114776 */     // GIR_Coverage, 3283,
     /* 114776 */     GIR_EraseRootFromParent_Done,
     /* 114777 */   // Label 1688: @114777
     /* 114777 */   GIM_Try, /*On fail goto*//*Label 1689*/ GIMT_Encode4(114869), // Rule ID 3299 //
     /* 114782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 114785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 114793 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 114797 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 114801 */     // MIs[1] Operand 1
     /* 114801 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 114806 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114808 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETULE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_gt:{ *:[i32] }))
     /* 114808 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 114811 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 114815 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114820 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 114824 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 114828 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 114830 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 114833 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114837 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114842 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 114849 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 114854 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 114859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 114862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 114864 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114867 */     GIR_RootConstrainSelectedInstOperands,
     /* 114868 */     // GIR_Coverage, 3299,
     /* 114868 */     GIR_EraseRootFromParent_Done,
     /* 114869 */   // Label 1689: @114869
     /* 114869 */   GIM_Try, /*On fail goto*//*Label 1690*/ GIMT_Encode4(114961), // Rule ID 3315 //
     /* 114874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 114877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 114885 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 114889 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 114893 */     // MIs[1] Operand 1
     /* 114893 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 114898 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114900 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUNE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_eq:{ *:[i32] }))
     /* 114900 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 114903 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 114907 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114912 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 114916 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 114920 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 114922 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 114925 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114929 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114934 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 114941 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 114946 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 114951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 114954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 114956 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114959 */     GIR_RootConstrainSelectedInstOperands,
     /* 114960 */     // GIR_Coverage, 3315,
     /* 114960 */     GIR_EraseRootFromParent_Done,
     /* 114961 */   // Label 1690: @114961
     /* 114961 */   GIM_Try, /*On fail goto*//*Label 1691*/ GIMT_Encode4(115053), // Rule ID 3331 //
     /* 114966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 114969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 114977 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 114981 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 114985 */     // MIs[1] Operand 1
     /* 114985 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 114990 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114992 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETO:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_un:{ *:[i32] }))
     /* 114992 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 114995 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 114999 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115004 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 115008 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 115012 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 115014 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 115017 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115021 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115026 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 115033 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 115038 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 115043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 115046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 115048 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115051 */     GIR_RootConstrainSelectedInstOperands,
     /* 115052 */     // GIR_Coverage, 3331,
     /* 115052 */     GIR_EraseRootFromParent_Done,
     /* 115053 */   // Label 1691: @115053
     /* 115053 */   GIM_Try, /*On fail goto*//*Label 1692*/ GIMT_Encode4(115185), // Rule ID 3982 //
     /* 115058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 115061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 115069 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 115073 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 115077 */     // MIs[1] Operand 1
     /* 115077 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 115082 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115084 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 115084 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 115087 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 115091 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115096 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 115100 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 115104 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 115106 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 115109 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 115113 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115118 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 115121 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 115123 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 115126 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 115130 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115135 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 115138 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 115140 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 115143 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115147 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115152 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 115159 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 115164 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 115169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 115172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115174 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115177 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 115180 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 115183 */     GIR_RootConstrainSelectedInstOperands,
     /* 115184 */     // GIR_Coverage, 3982,
     /* 115184 */     GIR_EraseRootFromParent_Done,
     /* 115185 */   // Label 1692: @115185
     /* 115185 */   GIM_Try, /*On fail goto*//*Label 1693*/ GIMT_Encode4(115317), // Rule ID 4014 //
     /* 115190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 115193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 115201 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 115205 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 115209 */     // MIs[1] Operand 1
     /* 115209 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 115214 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115216 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 115216 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 115219 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 115223 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115228 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 115232 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 115236 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 115238 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 115241 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 115245 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115250 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 115253 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 115255 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 115258 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 115262 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115267 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 115270 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 115272 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 115275 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115279 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115284 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 115291 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 115296 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 115301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 115304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115306 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115309 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 115312 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 115315 */     GIR_RootConstrainSelectedInstOperands,
     /* 115316 */     // GIR_Coverage, 4014,
     /* 115316 */     GIR_EraseRootFromParent_Done,
     /* 115317 */   // Label 1693: @115317
     /* 115317 */   GIM_Try, /*On fail goto*//*Label 1694*/ GIMT_Encode4(115449), // Rule ID 4046 //
     /* 115322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 115325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 115333 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 115337 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 115341 */     // MIs[1] Operand 1
     /* 115341 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 115346 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115348 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 115348 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 115351 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 115355 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115360 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 115364 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 115368 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 115370 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 115373 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 115377 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115382 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 115385 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 115387 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 115390 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 115394 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115399 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 115402 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 115404 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 115407 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115411 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115416 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 115423 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 115428 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 115433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 115436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115438 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115441 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 115444 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 115447 */     GIR_RootConstrainSelectedInstOperands,
     /* 115448 */     // GIR_Coverage, 4046,
     /* 115448 */     GIR_EraseRootFromParent_Done,
     /* 115449 */   // Label 1694: @115449
     /* 115449 */   GIM_Try, /*On fail goto*//*Label 1695*/ GIMT_Encode4(115581), // Rule ID 4078 //
     /* 115454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 115457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 115465 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 115469 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 115473 */     // MIs[1] Operand 1
     /* 115473 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 115478 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115480 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETO:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_un:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 115480 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 115483 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 115487 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115492 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 115496 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 115500 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 115502 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 115505 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 115509 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115514 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 115517 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 115519 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 115522 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 115526 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115531 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 115534 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 115536 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 115539 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115543 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115548 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 115555 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 115560 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 115565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 115568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115570 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115573 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 115576 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 115579 */     GIR_RootConstrainSelectedInstOperands,
     /* 115580 */     // GIR_Coverage, 4078,
     /* 115580 */     GIR_EraseRootFromParent_Done,
     /* 115581 */   // Label 1695: @115581
     /* 115581 */   GIM_Try, /*On fail goto*//*Label 1696*/ GIMT_Encode4(115713), // Rule ID 4094 //
     /* 115586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 115589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 115597 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 115601 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 115605 */     // MIs[1] Operand 1
     /* 115605 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 115610 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115612 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 115612 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 115615 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 115619 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115624 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 115628 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 115632 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 115634 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 115637 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 115641 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115646 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 115649 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 115651 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 115654 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 115658 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115663 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 115666 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 115668 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 115671 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115675 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115680 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 115687 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 115692 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 115697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 115700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115702 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115705 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 115708 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 115711 */     GIR_RootConstrainSelectedInstOperands,
     /* 115712 */     // GIR_Coverage, 4094,
     /* 115712 */     GIR_EraseRootFromParent_Done,
     /* 115713 */   // Label 1696: @115713
     /* 115713 */   GIM_Try, /*On fail goto*//*Label 1697*/ GIMT_Encode4(115845), // Rule ID 4126 //
     /* 115718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 115721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 115729 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 115733 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 115737 */     // MIs[1] Operand 1
     /* 115737 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 115742 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115744 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 115744 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 115747 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 115751 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115756 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 115760 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 115764 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 115766 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 115769 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 115773 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115778 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 115781 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 115783 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 115786 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 115790 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115795 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 115798 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 115800 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 115803 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115807 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115812 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 115819 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 115824 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 115829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 115832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115834 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115837 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 115840 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 115843 */     GIR_RootConstrainSelectedInstOperands,
     /* 115844 */     // GIR_Coverage, 4126,
     /* 115844 */     GIR_EraseRootFromParent_Done,
     /* 115845 */   // Label 1697: @115845
     /* 115845 */   GIM_Try, /*On fail goto*//*Label 1698*/ GIMT_Encode4(115977), // Rule ID 4158 //
     /* 115850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 115853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 115861 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 115865 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 115869 */     // MIs[1] Operand 1
     /* 115869 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 115874 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115876 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 115876 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 115879 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 115883 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115888 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 115892 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 115896 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 115898 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 115901 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 115905 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115910 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 115913 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 115915 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 115918 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 115922 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115927 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 115930 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 115932 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 115935 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115939 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115944 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 115951 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 115956 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 115961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 115964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115966 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115969 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 115972 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 115975 */     GIR_RootConstrainSelectedInstOperands,
     /* 115976 */     // GIR_Coverage, 4158,
     /* 115976 */     GIR_EraseRootFromParent_Done,
     /* 115977 */   // Label 1698: @115977
     /* 115977 */   GIM_Try, /*On fail goto*//*Label 1699*/ GIMT_Encode4(116109), // Rule ID 4190 //
     /* 115982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 115985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 115993 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 115997 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 116001 */     // MIs[1] Operand 1
     /* 116001 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 116006 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116008 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETO:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_un:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 116008 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 116011 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 116015 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116020 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 116024 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 116028 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 116030 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 116033 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 116037 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116042 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 116045 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 116047 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 116050 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 116054 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116059 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 116062 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 116064 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 116067 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116071 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116076 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 116083 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 116088 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 116093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 116096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116098 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116101 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 116104 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 116107 */     GIR_RootConstrainSelectedInstOperands,
     /* 116108 */     // GIR_Coverage, 4190,
     /* 116108 */     GIR_EraseRootFromParent_Done,
     /* 116109 */   // Label 1699: @116109
     /* 116109 */   GIM_Try, /*On fail goto*//*Label 1700*/ GIMT_Encode4(116241), // Rule ID 4220 //
     /* 116114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 116117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 116125 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 116129 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 116133 */     // MIs[1] Operand 1
     /* 116133 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 116138 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116140 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 116140 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 116143 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 116147 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116152 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 116156 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 116160 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 116162 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 116165 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 116169 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116174 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 116177 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 116179 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 116182 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 116186 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116191 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 116194 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 116196 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 116199 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116203 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116208 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 116215 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 116220 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 116225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 116228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116230 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116233 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 116236 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 116239 */     GIR_RootConstrainSelectedInstOperands,
     /* 116240 */     // GIR_Coverage, 4220,
     /* 116240 */     GIR_EraseRootFromParent_Done,
     /* 116241 */   // Label 1700: @116241
     /* 116241 */   GIM_Try, /*On fail goto*//*Label 1701*/ GIMT_Encode4(116373), // Rule ID 4252 //
     /* 116246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 116249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 116257 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 116261 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 116265 */     // MIs[1] Operand 1
     /* 116265 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 116270 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116272 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 116272 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 116275 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 116279 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116284 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 116288 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 116292 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 116294 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 116297 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 116301 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116306 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 116309 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 116311 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 116314 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 116318 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116323 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 116326 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 116328 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 116331 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116335 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116340 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 116347 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 116352 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 116357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 116360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116362 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116365 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 116368 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 116371 */     GIR_RootConstrainSelectedInstOperands,
     /* 116372 */     // GIR_Coverage, 4252,
     /* 116372 */     GIR_EraseRootFromParent_Done,
     /* 116373 */   // Label 1701: @116373
     /* 116373 */   GIM_Try, /*On fail goto*//*Label 1702*/ GIMT_Encode4(116505), // Rule ID 4284 //
     /* 116378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 116381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 116389 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 116393 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 116397 */     // MIs[1] Operand 1
     /* 116397 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 116402 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116404 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 116404 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 116407 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 116411 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116416 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 116420 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 116424 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 116426 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 116429 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 116433 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116438 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 116441 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 116443 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 116446 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 116450 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116455 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 116458 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 116460 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 116463 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116467 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116472 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 116479 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 116484 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 116489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 116492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116494 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116497 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 116500 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 116503 */     GIR_RootConstrainSelectedInstOperands,
     /* 116504 */     // GIR_Coverage, 4284,
     /* 116504 */     GIR_EraseRootFromParent_Done,
     /* 116505 */   // Label 1702: @116505
     /* 116505 */   GIM_Try, /*On fail goto*//*Label 1703*/ GIMT_Encode4(116637), // Rule ID 4316 //
     /* 116510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 116513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 116521 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 116525 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 116529 */     // MIs[1] Operand 1
     /* 116529 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 116534 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116536 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETO:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_un:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 116536 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 116539 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 116543 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116548 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 116552 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 116556 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 116558 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 116561 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 116565 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116570 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 116573 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 116575 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 116578 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 116582 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116587 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 116590 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 116592 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 116595 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116599 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116604 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 116611 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 116616 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 116621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 116624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116626 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116629 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 116632 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 116635 */     GIR_RootConstrainSelectedInstOperands,
     /* 116636 */     // GIR_Coverage, 4316,
     /* 116636 */     GIR_EraseRootFromParent_Done,
     /* 116637 */   // Label 1703: @116637
     /* 116637 */   GIM_Try, /*On fail goto*//*Label 1704*/ GIMT_Encode4(116769), // Rule ID 4547 //
     /* 116642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 116645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 116653 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 116657 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 116661 */     // MIs[1] Operand 1
     /* 116661 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 116666 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116668 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPLT:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 116668 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 116671 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPLT),
     /* 116675 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116680 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 116684 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 116688 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 116690 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 116693 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 116697 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116702 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 116705 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 116707 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 116710 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 116714 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116719 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 116722 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 116724 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 116727 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116731 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116736 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 116743 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 116748 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 116753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 116756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116758 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116761 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 116764 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 116767 */     GIR_RootConstrainSelectedInstOperands,
     /* 116768 */     // GIR_Coverage, 4547,
     /* 116768 */     GIR_EraseRootFromParent_Done,
     /* 116769 */   // Label 1704: @116769
     /* 116769 */   GIM_Try, /*On fail goto*//*Label 1705*/ GIMT_Encode4(116901), // Rule ID 4579 //
     /* 116774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 116777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 116785 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 116789 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 116793 */     // MIs[1] Operand 1
     /* 116793 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 116798 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116800 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPGT:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 116800 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 116803 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPGT),
     /* 116807 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116812 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 116816 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 116820 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 116822 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 116825 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 116829 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116834 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 116837 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 116839 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 116842 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 116846 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116851 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 116854 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 116856 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 116859 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116863 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116868 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 116875 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 116880 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 116885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 116888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116890 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116893 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 116896 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 116899 */     GIR_RootConstrainSelectedInstOperands,
     /* 116900 */     // GIR_Coverage, 4579,
     /* 116900 */     GIR_EraseRootFromParent_Done,
     /* 116901 */   // Label 1705: @116901
     /* 116901 */   GIM_Try, /*On fail goto*//*Label 1706*/ GIMT_Encode4(117033), // Rule ID 4611 //
     /* 116906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 116909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 116917 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 116921 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 116925 */     // MIs[1] Operand 1
     /* 116925 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 116930 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116932 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPEQ:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 116932 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 116935 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPEQ),
     /* 116939 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116944 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 116948 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 116952 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 116954 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 116957 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 116961 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116966 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 116969 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 116971 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 116974 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 116978 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116983 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 116986 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 116988 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 116991 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116995 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117000 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 117007 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 117012 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 117017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 117020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117022 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117025 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 117028 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 117031 */     GIR_RootConstrainSelectedInstOperands,
     /* 117032 */     // GIR_Coverage, 4611,
     /* 117032 */     GIR_EraseRootFromParent_Done,
     /* 117033 */   // Label 1706: @117033
     /* 117033 */   GIM_Try, /*On fail goto*//*Label 1707*/ GIMT_Encode4(117165), // Rule ID 4655 //
     /* 117038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 117041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 117049 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 117053 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 117057 */     // MIs[1] Operand 1
     /* 117057 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 117062 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117064 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPLT:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 117064 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 117067 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPLT),
     /* 117071 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117076 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 117080 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 117084 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 117086 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 117089 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 117093 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117098 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 117101 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 117103 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 117106 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 117110 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117115 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 117118 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 117120 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 117123 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117127 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117132 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 117139 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 117144 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 117149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 117152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117154 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117157 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 117160 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 117163 */     GIR_RootConstrainSelectedInstOperands,
     /* 117164 */     // GIR_Coverage, 4655,
     /* 117164 */     GIR_EraseRootFromParent_Done,
     /* 117165 */   // Label 1707: @117165
     /* 117165 */   GIM_Try, /*On fail goto*//*Label 1708*/ GIMT_Encode4(117297), // Rule ID 4687 //
     /* 117170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 117173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 117181 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 117185 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 117189 */     // MIs[1] Operand 1
     /* 117189 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 117194 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117196 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPGT:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 117196 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 117199 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPGT),
     /* 117203 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117208 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 117212 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 117216 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 117218 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 117221 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 117225 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117230 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 117233 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 117235 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 117238 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 117242 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117247 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 117250 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 117252 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 117255 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117259 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117264 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 117271 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 117276 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 117281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 117284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117286 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117289 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 117292 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 117295 */     GIR_RootConstrainSelectedInstOperands,
     /* 117296 */     // GIR_Coverage, 4687,
     /* 117296 */     GIR_EraseRootFromParent_Done,
     /* 117297 */   // Label 1708: @117297
     /* 117297 */   GIM_Try, /*On fail goto*//*Label 1709*/ GIMT_Encode4(117429), // Rule ID 4719 //
     /* 117302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 117305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 117313 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 117317 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 117321 */     // MIs[1] Operand 1
     /* 117321 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 117326 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117328 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPEQ:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 117328 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 117331 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPEQ),
     /* 117335 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117340 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 117344 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 117348 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 117350 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 117353 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 117357 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117362 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 117365 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 117367 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 117370 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 117374 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117379 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 117382 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 117384 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 117387 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117391 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117396 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 117403 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 117408 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 117413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 117416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117418 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117421 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 117424 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 117427 */     GIR_RootConstrainSelectedInstOperands,
     /* 117428 */     // GIR_Coverage, 4719,
     /* 117428 */     GIR_EraseRootFromParent_Done,
     /* 117429 */   // Label 1709: @117429
     /* 117429 */   GIM_Try, /*On fail goto*//*Label 1710*/ GIMT_Encode4(117521), // Rule ID 2973 //
     /* 117434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 117437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 117445 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 117449 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 117453 */     // MIs[1] Operand 1
     /* 117453 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 117458 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117460 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }))
     /* 117460 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 117463 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 117467 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117472 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 117476 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 117480 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 117482 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 117485 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117489 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117494 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 117501 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 117506 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 117511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 117514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 117516 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117519 */     GIR_RootConstrainSelectedInstOperands,
     /* 117520 */     // GIR_Coverage, 2973,
     /* 117520 */     GIR_EraseRootFromParent_Done,
     /* 117521 */   // Label 1710: @117521
     /* 117521 */   GIM_Try, /*On fail goto*//*Label 1711*/ GIMT_Encode4(117613), // Rule ID 2987 //
     /* 117526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 117529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 117537 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 117541 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 117545 */     // MIs[1] Operand 1
     /* 117545 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 117550 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117552 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETGE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }))
     /* 117552 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 117555 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 117559 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117564 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 117568 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 117572 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 117574 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 117577 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117581 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117586 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 117593 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 117598 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 117603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 117606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 117608 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117611 */     GIR_RootConstrainSelectedInstOperands,
     /* 117612 */     // GIR_Coverage, 2987,
     /* 117612 */     GIR_EraseRootFromParent_Done,
     /* 117613 */   // Label 1711: @117613
     /* 117613 */   GIM_Try, /*On fail goto*//*Label 1712*/ GIMT_Encode4(117705), // Rule ID 2995 //
     /* 117618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 117621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 117629 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 117633 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 117637 */     // MIs[1] Operand 1
     /* 117637 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 117642 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117644 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETULE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }))
     /* 117644 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 117647 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 117651 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117656 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 117660 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 117664 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 117666 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 117669 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117673 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117678 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 117685 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 117690 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 117695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 117698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 117700 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117703 */     GIR_RootConstrainSelectedInstOperands,
     /* 117704 */     // GIR_Coverage, 2995,
     /* 117704 */     GIR_EraseRootFromParent_Done,
     /* 117705 */   // Label 1712: @117705
     /* 117705 */   GIM_Try, /*On fail goto*//*Label 1713*/ GIMT_Encode4(117797), // Rule ID 3003 //
     /* 117710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 117713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 117721 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 117725 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 117729 */     // MIs[1] Operand 1
     /* 117729 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 117734 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117736 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETLE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }))
     /* 117736 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 117739 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 117743 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117748 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 117752 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 117756 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 117758 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 117761 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117765 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117770 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 117777 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 117782 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 117787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 117790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 117792 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117795 */     GIR_RootConstrainSelectedInstOperands,
     /* 117796 */     // GIR_Coverage, 3003,
     /* 117796 */     GIR_EraseRootFromParent_Done,
     /* 117797 */   // Label 1713: @117797
     /* 117797 */   GIM_Try, /*On fail goto*//*Label 1714*/ GIMT_Encode4(117889), // Rule ID 3011 //
     /* 117802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 117805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 117813 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 117817 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 117821 */     // MIs[1] Operand 1
     /* 117821 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 117826 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117828 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETNE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_eq:{ *:[i32] }))
     /* 117828 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 117831 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 117835 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117840 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 117844 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 117848 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 117850 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 117853 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117857 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117862 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 117869 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 117874 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 117879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 117882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 117884 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117887 */     GIR_RootConstrainSelectedInstOperands,
     /* 117888 */     // GIR_Coverage, 3011,
     /* 117888 */     GIR_EraseRootFromParent_Done,
     /* 117889 */   // Label 1714: @117889
     /* 117889 */   GIM_Try, /*On fail goto*//*Label 1715*/ GIMT_Encode4(117981), // Rule ID 3075 //
     /* 117894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 117897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 117905 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 117909 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 117913 */     // MIs[1] Operand 1
     /* 117913 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 117918 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117920 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }))
     /* 117920 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 117923 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 117927 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117932 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 117936 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 117940 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 117942 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 117945 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117949 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117954 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 117961 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 117966 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 117971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 117974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 117976 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117979 */     GIR_RootConstrainSelectedInstOperands,
     /* 117980 */     // GIR_Coverage, 3075,
     /* 117980 */     GIR_EraseRootFromParent_Done,
     /* 117981 */   // Label 1715: @117981
     /* 117981 */   GIM_Try, /*On fail goto*//*Label 1716*/ GIMT_Encode4(118073), // Rule ID 3083 //
     /* 117986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 117989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 117997 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 118001 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 118005 */     // MIs[1] Operand 1
     /* 118005 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 118010 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118012 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETGE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }))
     /* 118012 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 118015 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 118019 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118024 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 118028 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 118032 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 118034 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 118037 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118041 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118046 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 118053 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 118058 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 118063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 118066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 118068 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118071 */     GIR_RootConstrainSelectedInstOperands,
     /* 118072 */     // GIR_Coverage, 3083,
     /* 118072 */     GIR_EraseRootFromParent_Done,
     /* 118073 */   // Label 1716: @118073
     /* 118073 */   GIM_Try, /*On fail goto*//*Label 1717*/ GIMT_Encode4(118165), // Rule ID 3091 //
     /* 118078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 118081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 118085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 118089 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 118093 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 118097 */     // MIs[1] Operand 1
     /* 118097 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 118102 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118104 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETULE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }))
     /* 118104 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 118107 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 118111 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118116 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 118120 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 118124 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 118126 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 118129 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118133 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118138 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 118145 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 118150 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 118155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 118158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 118160 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118163 */     GIR_RootConstrainSelectedInstOperands,
     /* 118164 */     // GIR_Coverage, 3091,
     /* 118164 */     GIR_EraseRootFromParent_Done,
     /* 118165 */   // Label 1717: @118165
     /* 118165 */   GIM_Try, /*On fail goto*//*Label 1718*/ GIMT_Encode4(118257), // Rule ID 3099 //
     /* 118170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 118173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 118177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 118181 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 118185 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 118189 */     // MIs[1] Operand 1
     /* 118189 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 118194 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118196 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETLE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }))
     /* 118196 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 118199 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 118203 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118208 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 118212 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 118216 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 118218 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 118221 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118225 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118230 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 118237 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 118242 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 118247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 118250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 118252 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118255 */     GIR_RootConstrainSelectedInstOperands,
     /* 118256 */     // GIR_Coverage, 3099,
     /* 118256 */     GIR_EraseRootFromParent_Done,
     /* 118257 */   // Label 1718: @118257
     /* 118257 */   GIM_Try, /*On fail goto*//*Label 1719*/ GIMT_Encode4(118349), // Rule ID 3107 //
     /* 118262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 118265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 118269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 118273 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 118277 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 118281 */     // MIs[1] Operand 1
     /* 118281 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 118286 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118288 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETNE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_eq:{ *:[i32] }))
     /* 118288 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 118291 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 118295 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118300 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 118304 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 118308 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 118310 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 118313 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118317 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118322 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 118329 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 118334 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 118339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 118342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 118344 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118347 */     GIR_RootConstrainSelectedInstOperands,
     /* 118348 */     // GIR_Coverage, 3107,
     /* 118348 */     GIR_EraseRootFromParent_Done,
     /* 118349 */   // Label 1719: @118349
     /* 118349 */   GIM_Try, /*On fail goto*//*Label 1720*/ GIMT_Encode4(118481), // Rule ID 3828 //
     /* 118354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 118357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 118361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 118365 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 118369 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 118373 */     // MIs[1] Operand 1
     /* 118373 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 118378 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118380 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 118380 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 118383 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 118387 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118392 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 118396 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 118400 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 118402 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 118405 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 118409 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118414 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 118417 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 118419 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 118422 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 118426 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118431 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 118434 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 118436 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 118439 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118443 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118448 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 118455 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 118460 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 118465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 118468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118470 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118473 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 118476 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 118479 */     GIR_RootConstrainSelectedInstOperands,
     /* 118480 */     // GIR_Coverage, 3828,
     /* 118480 */     GIR_EraseRootFromParent_Done,
     /* 118481 */   // Label 1720: @118481
     /* 118481 */   GIM_Try, /*On fail goto*//*Label 1721*/ GIMT_Encode4(118613), // Rule ID 3836 //
     /* 118486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 118489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 118493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 118497 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 118501 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 118505 */     // MIs[1] Operand 1
     /* 118505 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 118510 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118512 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 118512 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 118515 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 118519 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118524 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 118528 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 118532 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 118534 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 118537 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 118541 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118546 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 118549 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 118551 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 118554 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 118558 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118563 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 118566 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 118568 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 118571 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118575 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118580 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 118587 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 118592 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 118597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 118600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118602 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118605 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 118608 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 118611 */     GIR_RootConstrainSelectedInstOperands,
     /* 118612 */     // GIR_Coverage, 3836,
     /* 118612 */     GIR_EraseRootFromParent_Done,
     /* 118613 */   // Label 1721: @118613
     /* 118613 */   GIM_Try, /*On fail goto*//*Label 1722*/ GIMT_Encode4(118745), // Rule ID 3844 //
     /* 118618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 118621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 118625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 118629 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 118633 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 118637 */     // MIs[1] Operand 1
     /* 118637 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 118642 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118644 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 118644 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 118647 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 118651 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118656 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 118660 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 118664 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 118666 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 118669 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 118673 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118678 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 118681 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 118683 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 118686 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 118690 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118695 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 118698 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 118700 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 118703 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118707 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118712 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 118719 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 118724 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 118729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 118732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118734 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118737 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 118740 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 118743 */     GIR_RootConstrainSelectedInstOperands,
     /* 118744 */     // GIR_Coverage, 3844,
     /* 118744 */     GIR_EraseRootFromParent_Done,
     /* 118745 */   // Label 1722: @118745
     /* 118745 */   GIM_Try, /*On fail goto*//*Label 1723*/ GIMT_Encode4(118877), // Rule ID 3852 //
     /* 118750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 118753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 118757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 118761 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 118765 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 118769 */     // MIs[1] Operand 1
     /* 118769 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 118774 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118776 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETLE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 118776 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 118779 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 118783 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118788 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 118792 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 118796 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 118798 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 118801 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 118805 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118810 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 118813 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 118815 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 118818 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 118822 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118827 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 118830 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 118832 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 118835 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118839 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118844 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 118851 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 118856 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 118861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 118864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118866 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118869 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 118872 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 118875 */     GIR_RootConstrainSelectedInstOperands,
     /* 118876 */     // GIR_Coverage, 3852,
     /* 118876 */     GIR_EraseRootFromParent_Done,
     /* 118877 */   // Label 1723: @118877
     /* 118877 */   GIM_Try, /*On fail goto*//*Label 1724*/ GIMT_Encode4(119009), // Rule ID 3860 //
     /* 118882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 118885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 118889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 118893 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 118897 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 118901 */     // MIs[1] Operand 1
     /* 118901 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 118906 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118908 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 118908 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 118911 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 118915 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118920 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 118924 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 118928 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 118930 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 118933 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 118937 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118942 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 118945 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 118947 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 118950 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 118954 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118959 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 118962 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 118964 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 118967 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118971 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118976 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 118983 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 118988 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 118993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 118996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118998 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119001 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 119004 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 119007 */     GIR_RootConstrainSelectedInstOperands,
     /* 119008 */     // GIR_Coverage, 3860,
     /* 119008 */     GIR_EraseRootFromParent_Done,
     /* 119009 */   // Label 1724: @119009
     /* 119009 */   GIM_Try, /*On fail goto*//*Label 1725*/ GIMT_Encode4(119141), // Rule ID 3924 //
     /* 119014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 119017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 119025 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 119029 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 119033 */     // MIs[1] Operand 1
     /* 119033 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 119038 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119040 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 119040 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 119043 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 119047 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119052 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 119056 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 119060 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 119062 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 119065 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 119069 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119074 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 119077 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 119079 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 119082 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 119086 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119091 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 119094 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 119096 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 119099 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119103 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119108 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 119115 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 119120 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 119125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 119128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119130 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119133 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 119136 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 119139 */     GIR_RootConstrainSelectedInstOperands,
     /* 119140 */     // GIR_Coverage, 3924,
     /* 119140 */     GIR_EraseRootFromParent_Done,
     /* 119141 */   // Label 1725: @119141
     /* 119141 */   GIM_Try, /*On fail goto*//*Label 1726*/ GIMT_Encode4(119273), // Rule ID 3932 //
     /* 119146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 119149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 119157 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 119161 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 119165 */     // MIs[1] Operand 1
     /* 119165 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 119170 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119172 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 119172 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 119175 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 119179 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119184 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 119188 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 119192 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 119194 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 119197 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 119201 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119206 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 119209 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 119211 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 119214 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 119218 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119223 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 119226 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 119228 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 119231 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119235 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119240 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 119247 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 119252 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 119257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 119260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119262 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119265 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 119268 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 119271 */     GIR_RootConstrainSelectedInstOperands,
     /* 119272 */     // GIR_Coverage, 3932,
     /* 119272 */     GIR_EraseRootFromParent_Done,
     /* 119273 */   // Label 1726: @119273
     /* 119273 */   GIM_Try, /*On fail goto*//*Label 1727*/ GIMT_Encode4(119405), // Rule ID 3940 //
     /* 119278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 119281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119285 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 119289 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 119293 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 119297 */     // MIs[1] Operand 1
     /* 119297 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 119302 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119304 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 119304 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 119307 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 119311 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119316 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 119320 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 119324 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 119326 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 119329 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 119333 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119338 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 119341 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 119343 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 119346 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 119350 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119355 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 119358 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 119360 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 119363 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119367 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119372 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 119379 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 119384 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 119389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 119392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119394 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119397 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 119400 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 119403 */     GIR_RootConstrainSelectedInstOperands,
     /* 119404 */     // GIR_Coverage, 3940,
     /* 119404 */     GIR_EraseRootFromParent_Done,
     /* 119405 */   // Label 1727: @119405
     /* 119405 */   GIM_Try, /*On fail goto*//*Label 1728*/ GIMT_Encode4(119537), // Rule ID 3948 //
     /* 119410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 119413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 119421 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 119425 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 119429 */     // MIs[1] Operand 1
     /* 119429 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 119434 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119436 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETLE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 119436 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 119439 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 119443 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119448 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 119452 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 119456 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 119458 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 119461 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 119465 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119470 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 119473 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 119475 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 119478 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 119482 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119487 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 119490 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 119492 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 119495 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119499 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119504 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 119511 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 119516 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 119521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 119524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119526 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119529 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 119532 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 119535 */     GIR_RootConstrainSelectedInstOperands,
     /* 119536 */     // GIR_Coverage, 3948,
     /* 119536 */     GIR_EraseRootFromParent_Done,
     /* 119537 */   // Label 1728: @119537
     /* 119537 */   GIM_Try, /*On fail goto*//*Label 1729*/ GIMT_Encode4(119669), // Rule ID 3956 //
     /* 119542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 119545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 119553 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 119557 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 119561 */     // MIs[1] Operand 1
     /* 119561 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 119566 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119568 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 119568 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 119571 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 119575 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119580 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 119584 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 119588 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 119590 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 119593 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 119597 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119602 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 119605 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 119607 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 119610 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 119614 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119619 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 119622 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 119624 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 119627 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119631 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119636 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 119643 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 119648 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 119653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 119656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119658 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119661 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 119664 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 119667 */     GIR_RootConstrainSelectedInstOperands,
     /* 119668 */     // GIR_Coverage, 3956,
     /* 119668 */     GIR_EraseRootFromParent_Done,
     /* 119669 */   // Label 1729: @119669
     /* 119669 */   GIM_Try, /*On fail goto*//*Label 1730*/ GIMT_Encode4(119684), // Rule ID 2979 //
     /* 119674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 119677 */     // (sext:{ *:[i32] } i1:{ *:[i1] }:$in)  =>  (SETNBC:{ *:[i32] } ?:{ *:[i1] }:$in)
     /* 119677 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SETNBC),
     /* 119682 */     GIR_RootConstrainSelectedInstOperands,
     /* 119683 */     // GIR_Coverage, 2979,
     /* 119683 */     GIR_Done,
     /* 119684 */   // Label 1730: @119684
     /* 119684 */   GIM_Try, /*On fail goto*//*Label 1731*/ GIMT_Encode4(119738), // Rule ID 3634 //
     /* 119689 */     // (sext:{ *:[i32] } i1:{ *:[i1] }:$in)  =>  (SELECT_I4:{ *:[i32] } ?:{ *:[i1] }:$in, (LI:{ *:[i32] } -1:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }))
     /* 119689 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 119692 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 119696 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119701 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 119704 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 119706 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 119709 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 119713 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119718 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/uint8_t(-1),
     /* 119721 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 119723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 119726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119728 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /* 119730 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119733 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 119736 */     GIR_RootConstrainSelectedInstOperands,
     /* 119737 */     // GIR_Coverage, 3634,
     /* 119737 */     GIR_EraseRootFromParent_Done,
     /* 119738 */   // Label 1731: @119738
     /* 119738 */   GIM_Reject,
     /* 119739 */ // Label 1667: @119739
     /* 119739 */ GIM_Reject,
     /* 119740 */ // Label 1665: @119740
     /* 119740 */ GIM_Try, /*On fail goto*//*Label 1732*/ GIMT_Encode4(119850), // Rule ID 3028 //
     /* 119745 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 119748 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 119751 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 119755 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119759 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 119763 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 119767 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 119771 */   // MIs[1] Operand 1
     /* 119771 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 119776 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 119780 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 119784 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 119788 */   // MIs[2] Operand 1
     /* 119788 */   // No operand predicates
     /* 119788 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 119790 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_lt:{ *:[i32] }))
     /* 119790 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 119793 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 119797 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119802 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 119806 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 119809 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 119811 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 119814 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119818 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119823 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 119830 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 119835 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 119840 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 119843 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 119845 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119848 */   GIR_RootConstrainSelectedInstOperands,
     /* 119849 */   // GIR_Coverage, 3028,
     /* 119849 */   GIR_EraseRootFromParent_Done,
     /* 119850 */ // Label 1732: @119850
     /* 119850 */ GIM_Try, /*On fail goto*//*Label 1733*/ GIMT_Encode4(119960), // Rule ID 3044 //
     /* 119855 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 119858 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 119861 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 119865 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119869 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 119873 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 119877 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 119881 */   // MIs[1] Operand 1
     /* 119881 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 119886 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 119890 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 119894 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 119898 */   // MIs[2] Operand 1
     /* 119898 */   // No operand predicates
     /* 119898 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 119900 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_gt:{ *:[i32] }))
     /* 119900 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 119903 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 119907 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119912 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 119916 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 119919 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 119921 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 119924 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119928 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119933 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 119940 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 119945 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 119950 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 119953 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 119955 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119958 */   GIR_RootConstrainSelectedInstOperands,
     /* 119959 */   // GIR_Coverage, 3044,
     /* 119959 */   GIR_EraseRootFromParent_Done,
     /* 119960 */ // Label 1733: @119960
     /* 119960 */ GIM_Try, /*On fail goto*//*Label 1734*/ GIMT_Encode4(120070), // Rule ID 3052 //
     /* 119965 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 119968 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 119971 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 119975 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119979 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 119983 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 119987 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 119991 */   // MIs[1] Operand 1
     /* 119991 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 119996 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 120000 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 120004 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 120008 */   // MIs[2] Operand 1
     /* 120008 */   // No operand predicates
     /* 120008 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 120010 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_eq:{ *:[i32] }))
     /* 120010 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 120013 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 120017 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120022 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 120026 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 120029 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 120031 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 120034 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120038 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120043 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 120050 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 120055 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 120060 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 120063 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 120065 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120068 */   GIR_RootConstrainSelectedInstOperands,
     /* 120069 */   // GIR_Coverage, 3052,
     /* 120069 */   GIR_EraseRootFromParent_Done,
     /* 120070 */ // Label 1734: @120070
     /* 120070 */ GIM_Try, /*On fail goto*//*Label 1735*/ GIMT_Encode4(120180), // Rule ID 3124 //
     /* 120075 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 120078 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 120081 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 120085 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120089 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 120093 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 120097 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 120101 */   // MIs[1] Operand 1
     /* 120101 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 120106 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 120110 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 120114 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 120118 */   // MIs[2] Operand 1
     /* 120118 */   // No operand predicates
     /* 120118 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 120120 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_lt:{ *:[i32] }))
     /* 120120 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 120123 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 120127 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120132 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 120136 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 120139 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 120141 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 120144 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120148 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120153 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 120160 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 120165 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 120170 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 120173 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 120175 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120178 */   GIR_RootConstrainSelectedInstOperands,
     /* 120179 */   // GIR_Coverage, 3124,
     /* 120179 */   GIR_EraseRootFromParent_Done,
     /* 120180 */ // Label 1735: @120180
     /* 120180 */ GIM_Try, /*On fail goto*//*Label 1736*/ GIMT_Encode4(120290), // Rule ID 3140 //
     /* 120185 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 120188 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 120191 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 120195 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120199 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 120203 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 120207 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 120211 */   // MIs[1] Operand 1
     /* 120211 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 120216 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 120220 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 120224 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 120228 */   // MIs[2] Operand 1
     /* 120228 */   // No operand predicates
     /* 120228 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 120230 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_gt:{ *:[i32] }))
     /* 120230 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 120233 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 120237 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120242 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 120246 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 120249 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 120251 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 120254 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120258 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120263 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 120270 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 120275 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 120280 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 120283 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 120285 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120288 */   GIR_RootConstrainSelectedInstOperands,
     /* 120289 */   // GIR_Coverage, 3140,
     /* 120289 */   GIR_EraseRootFromParent_Done,
     /* 120290 */ // Label 1736: @120290
     /* 120290 */ GIM_Try, /*On fail goto*//*Label 1737*/ GIMT_Encode4(120400), // Rule ID 3148 //
     /* 120295 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 120298 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 120301 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 120305 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120309 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 120313 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 120317 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 120321 */   // MIs[1] Operand 1
     /* 120321 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 120326 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 120330 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 120334 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 120338 */   // MIs[2] Operand 1
     /* 120338 */   // No operand predicates
     /* 120338 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 120340 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_eq:{ *:[i32] }))
     /* 120340 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 120343 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 120347 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120352 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 120356 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 120359 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 120361 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 120364 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120368 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120373 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 120380 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 120385 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 120390 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 120393 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 120395 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120398 */   GIR_RootConstrainSelectedInstOperands,
     /* 120399 */   // GIR_Coverage, 3148,
     /* 120399 */   GIR_EraseRootFromParent_Done,
     /* 120400 */ // Label 1737: @120400
     /* 120400 */ GIM_Try, /*On fail goto*//*Label 1738*/ GIMT_Encode4(120550), // Rule ID 3782 //
     /* 120405 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 120408 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 120411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 120415 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120419 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 120423 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 120427 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 120431 */   // MIs[1] Operand 1
     /* 120431 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 120436 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 120440 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 120444 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 120448 */   // MIs[2] Operand 1
     /* 120448 */   // No operand predicates
     /* 120448 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 120450 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 120450 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 120453 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 120457 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120462 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 120466 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 120469 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 120471 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 120474 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 120478 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120483 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 120486 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 120488 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 120491 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 120495 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120500 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 120503 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 120505 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 120508 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120512 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120517 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 120524 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 120529 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 120534 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 120537 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120539 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120542 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 120545 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 120548 */   GIR_RootConstrainSelectedInstOperands,
     /* 120549 */   // GIR_Coverage, 3782,
     /* 120549 */   GIR_EraseRootFromParent_Done,
     /* 120550 */ // Label 1738: @120550
     /* 120550 */ GIM_Try, /*On fail goto*//*Label 1739*/ GIMT_Encode4(120700), // Rule ID 3798 //
     /* 120555 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 120558 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 120561 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 120565 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120569 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 120573 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 120577 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 120581 */   // MIs[1] Operand 1
     /* 120581 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 120586 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 120590 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 120594 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 120598 */   // MIs[2] Operand 1
     /* 120598 */   // No operand predicates
     /* 120598 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 120600 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 120600 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 120603 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 120607 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120612 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 120616 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 120619 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 120621 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 120624 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 120628 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120633 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 120636 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 120638 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 120641 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 120645 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120650 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 120653 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 120655 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 120658 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120662 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120667 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 120674 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 120679 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 120684 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 120687 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120689 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120692 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 120695 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 120698 */   GIR_RootConstrainSelectedInstOperands,
     /* 120699 */   // GIR_Coverage, 3798,
     /* 120699 */   GIR_EraseRootFromParent_Done,
     /* 120700 */ // Label 1739: @120700
     /* 120700 */ GIM_Try, /*On fail goto*//*Label 1740*/ GIMT_Encode4(120850), // Rule ID 3806 //
     /* 120705 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 120708 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 120711 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 120715 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120719 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 120723 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 120727 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 120731 */   // MIs[1] Operand 1
     /* 120731 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 120736 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 120740 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 120744 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 120748 */   // MIs[2] Operand 1
     /* 120748 */   // No operand predicates
     /* 120748 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 120750 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 120750 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 120753 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 120757 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120762 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 120766 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 120769 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 120771 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 120774 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 120778 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120783 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 120786 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 120788 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 120791 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 120795 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120800 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 120803 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 120805 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 120808 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120812 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120817 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 120824 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 120829 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 120834 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 120837 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120839 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120842 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 120845 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 120848 */   GIR_RootConstrainSelectedInstOperands,
     /* 120849 */   // GIR_Coverage, 3806,
     /* 120849 */   GIR_EraseRootFromParent_Done,
     /* 120850 */ // Label 1740: @120850
     /* 120850 */ GIM_Try, /*On fail goto*//*Label 1741*/ GIMT_Encode4(121000), // Rule ID 3878 //
     /* 120855 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 120858 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 120861 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 120865 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120869 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 120873 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 120877 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 120881 */   // MIs[1] Operand 1
     /* 120881 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 120886 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 120890 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 120894 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 120898 */   // MIs[2] Operand 1
     /* 120898 */   // No operand predicates
     /* 120898 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 120900 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 120900 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 120903 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 120907 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120912 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 120916 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 120919 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 120921 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 120924 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 120928 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120933 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 120936 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 120938 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 120941 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 120945 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120950 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 120953 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 120955 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 120958 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120962 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120967 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 120974 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 120979 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 120984 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 120987 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120989 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120992 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 120995 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 120998 */   GIR_RootConstrainSelectedInstOperands,
     /* 120999 */   // GIR_Coverage, 3878,
     /* 120999 */   GIR_EraseRootFromParent_Done,
     /* 121000 */ // Label 1741: @121000
     /* 121000 */ GIM_Try, /*On fail goto*//*Label 1742*/ GIMT_Encode4(121150), // Rule ID 3894 //
     /* 121005 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 121008 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 121011 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 121015 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 121019 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 121023 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 121027 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 121031 */   // MIs[1] Operand 1
     /* 121031 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 121036 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 121040 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 121044 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 121048 */   // MIs[2] Operand 1
     /* 121048 */   // No operand predicates
     /* 121048 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 121050 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 121050 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 121053 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 121057 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121062 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 121066 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 121069 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 121071 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 121074 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 121078 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121083 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 121086 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 121088 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 121091 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 121095 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121100 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 121103 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 121105 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 121108 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121112 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121117 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 121124 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 121129 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 121134 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 121137 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121139 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121142 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 121145 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 121148 */   GIR_RootConstrainSelectedInstOperands,
     /* 121149 */   // GIR_Coverage, 3894,
     /* 121149 */   GIR_EraseRootFromParent_Done,
     /* 121150 */ // Label 1742: @121150
     /* 121150 */ GIM_Try, /*On fail goto*//*Label 1743*/ GIMT_Encode4(121300), // Rule ID 3902 //
     /* 121155 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 121158 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 121161 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 121165 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 121169 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 121173 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 121177 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 121181 */   // MIs[1] Operand 1
     /* 121181 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 121186 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 121190 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 121194 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 121198 */   // MIs[2] Operand 1
     /* 121198 */   // No operand predicates
     /* 121198 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 121200 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 121200 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 121203 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 121207 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121212 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 121216 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 121219 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 121221 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 121224 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 121228 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121233 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 121236 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 121238 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 121241 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 121245 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121250 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 121253 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 121255 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 121258 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121262 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121267 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 121274 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 121279 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 121284 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 121287 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121289 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121292 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 121295 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 121298 */   GIR_RootConstrainSelectedInstOperands,
     /* 121299 */   // GIR_Coverage, 3902,
     /* 121299 */   GIR_EraseRootFromParent_Done,
     /* 121300 */ // Label 1743: @121300
     /* 121300 */ GIM_Try, /*On fail goto*//*Label 1744*/ GIMT_Encode4(121399), // Rule ID 3172 //
     /* 121305 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 121308 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 121311 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 121315 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 121319 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 121323 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 121327 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 121331 */   // MIs[1] Operand 1
     /* 121331 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 121336 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121338 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_lt:{ *:[i32] }))
     /* 121338 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 121341 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 121345 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121350 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 121354 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 121358 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 121360 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 121363 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121367 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121372 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 121379 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 121384 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 121389 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 121392 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 121394 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121397 */   GIR_RootConstrainSelectedInstOperands,
     /* 121398 */   // GIR_Coverage, 3172,
     /* 121398 */   GIR_EraseRootFromParent_Done,
     /* 121399 */ // Label 1744: @121399
     /* 121399 */ GIM_Try, /*On fail goto*//*Label 1745*/ GIMT_Encode4(121498), // Rule ID 3188 //
     /* 121404 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 121407 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 121410 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 121414 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 121418 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 121422 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 121426 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 121430 */   // MIs[1] Operand 1
     /* 121430 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 121435 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121437 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }))
     /* 121437 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 121440 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 121444 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121449 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 121453 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 121457 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 121459 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 121462 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121466 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121471 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 121478 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 121483 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 121488 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 121491 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 121493 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121496 */   GIR_RootConstrainSelectedInstOperands,
     /* 121497 */   // GIR_Coverage, 3188,
     /* 121497 */   GIR_EraseRootFromParent_Done,
     /* 121498 */ // Label 1745: @121498
     /* 121498 */ GIM_Try, /*On fail goto*//*Label 1746*/ GIMT_Encode4(121597), // Rule ID 3204 //
     /* 121503 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 121506 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 121509 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 121513 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 121517 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 121521 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 121525 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 121529 */   // MIs[1] Operand 1
     /* 121529 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 121534 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121536 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_eq:{ *:[i32] }))
     /* 121536 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 121539 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 121543 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121548 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 121552 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 121556 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 121558 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 121561 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121565 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121570 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 121577 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 121582 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 121587 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 121590 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 121592 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121595 */   GIR_RootConstrainSelectedInstOperands,
     /* 121596 */   // GIR_Coverage, 3204,
     /* 121596 */   GIR_EraseRootFromParent_Done,
     /* 121597 */ // Label 1746: @121597
     /* 121597 */ GIM_Try, /*On fail goto*//*Label 1747*/ GIMT_Encode4(121696), // Rule ID 3220 //
     /* 121602 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 121605 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 121608 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 121612 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 121616 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 121620 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 121624 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 121628 */   // MIs[1] Operand 1
     /* 121628 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 121633 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121635 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETO:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_un:{ *:[i32] }))
     /* 121635 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 121638 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 121642 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121647 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 121651 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 121655 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 121657 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 121660 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121664 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121669 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 121676 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 121681 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 121686 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 121689 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 121691 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121694 */   GIR_RootConstrainSelectedInstOperands,
     /* 121695 */   // GIR_Coverage, 3220,
     /* 121695 */   GIR_EraseRootFromParent_Done,
     /* 121696 */ // Label 1747: @121696
     /* 121696 */ GIM_Try, /*On fail goto*//*Label 1748*/ GIMT_Encode4(121795), // Rule ID 3228 //
     /* 121701 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 121704 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 121707 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 121711 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 121715 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 121719 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 121723 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 121727 */   // MIs[1] Operand 1
     /* 121727 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 121732 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121734 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_lt:{ *:[i32] }))
     /* 121734 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 121737 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 121741 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121746 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 121750 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 121754 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 121756 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 121759 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121763 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121768 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 121775 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 121780 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 121785 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 121788 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 121790 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121793 */   GIR_RootConstrainSelectedInstOperands,
     /* 121794 */   // GIR_Coverage, 3228,
     /* 121794 */   GIR_EraseRootFromParent_Done,
     /* 121795 */ // Label 1748: @121795
     /* 121795 */ GIM_Try, /*On fail goto*//*Label 1749*/ GIMT_Encode4(121894), // Rule ID 3244 //
     /* 121800 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 121803 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 121806 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 121810 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 121814 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 121818 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 121822 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 121826 */   // MIs[1] Operand 1
     /* 121826 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 121831 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121833 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }))
     /* 121833 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 121836 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 121840 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121845 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 121849 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 121853 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 121855 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 121858 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121862 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121867 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 121874 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 121879 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 121884 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 121887 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 121889 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121892 */   GIR_RootConstrainSelectedInstOperands,
     /* 121893 */   // GIR_Coverage, 3244,
     /* 121893 */   GIR_EraseRootFromParent_Done,
     /* 121894 */ // Label 1749: @121894
     /* 121894 */ GIM_Try, /*On fail goto*//*Label 1750*/ GIMT_Encode4(121993), // Rule ID 3260 //
     /* 121899 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 121902 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 121905 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 121909 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 121913 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 121917 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 121921 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 121925 */   // MIs[1] Operand 1
     /* 121925 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 121930 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121932 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_eq:{ *:[i32] }))
     /* 121932 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 121935 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 121939 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121944 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 121948 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 121952 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 121954 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 121957 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121961 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121966 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 121973 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 121978 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 121983 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 121986 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 121988 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121991 */   GIR_RootConstrainSelectedInstOperands,
     /* 121992 */   // GIR_Coverage, 3260,
     /* 121992 */   GIR_EraseRootFromParent_Done,
     /* 121993 */ // Label 1750: @121993
     /* 121993 */ GIM_Try, /*On fail goto*//*Label 1751*/ GIMT_Encode4(122092), // Rule ID 3276 //
     /* 121998 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 122001 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 122004 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 122008 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 122012 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 122016 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 122020 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 122024 */   // MIs[1] Operand 1
     /* 122024 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 122029 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 122031 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETO:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_un:{ *:[i32] }))
     /* 122031 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 122034 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 122038 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122043 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 122047 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 122051 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 122053 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 122056 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122060 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122065 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 122072 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 122077 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 122082 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 122085 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 122087 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122090 */   GIR_RootConstrainSelectedInstOperands,
     /* 122091 */   // GIR_Coverage, 3276,
     /* 122091 */   GIR_EraseRootFromParent_Done,
     /* 122092 */ // Label 1751: @122092
     /* 122092 */ GIM_Try, /*On fail goto*//*Label 1752*/ GIMT_Encode4(122191), // Rule ID 3284 //
     /* 122097 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 122100 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 122103 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 122107 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 122111 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 122115 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 122119 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 122123 */   // MIs[1] Operand 1
     /* 122123 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 122128 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 122130 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_lt:{ *:[i32] }))
     /* 122130 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 122133 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 122137 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122142 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 122146 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 122150 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 122152 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 122155 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122159 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122164 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 122171 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 122176 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 122181 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 122184 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 122186 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122189 */   GIR_RootConstrainSelectedInstOperands,
     /* 122190 */   // GIR_Coverage, 3284,
     /* 122190 */   GIR_EraseRootFromParent_Done,
     /* 122191 */ // Label 1752: @122191
     /* 122191 */ GIM_Try, /*On fail goto*//*Label 1753*/ GIMT_Encode4(122290), // Rule ID 3300 //
     /* 122196 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 122199 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 122202 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 122206 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 122210 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 122214 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 122218 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 122222 */   // MIs[1] Operand 1
     /* 122222 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 122227 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 122229 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETULE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_gt:{ *:[i32] }))
     /* 122229 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 122232 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 122236 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122241 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 122245 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 122249 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 122251 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 122254 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122258 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122263 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 122270 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 122275 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 122280 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 122283 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 122285 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122288 */   GIR_RootConstrainSelectedInstOperands,
     /* 122289 */   // GIR_Coverage, 3300,
     /* 122289 */   GIR_EraseRootFromParent_Done,
     /* 122290 */ // Label 1753: @122290
     /* 122290 */ GIM_Try, /*On fail goto*//*Label 1754*/ GIMT_Encode4(122389), // Rule ID 3316 //
     /* 122295 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 122298 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 122301 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 122305 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 122309 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 122313 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 122317 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 122321 */   // MIs[1] Operand 1
     /* 122321 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 122326 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 122328 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUNE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_eq:{ *:[i32] }))
     /* 122328 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 122331 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 122335 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122340 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 122344 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 122348 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 122350 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 122353 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122357 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122362 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 122369 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 122374 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 122379 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 122382 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 122384 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122387 */   GIR_RootConstrainSelectedInstOperands,
     /* 122388 */   // GIR_Coverage, 3316,
     /* 122388 */   GIR_EraseRootFromParent_Done,
     /* 122389 */ // Label 1754: @122389
     /* 122389 */ GIM_Try, /*On fail goto*//*Label 1755*/ GIMT_Encode4(122488), // Rule ID 3332 //
     /* 122394 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 122397 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 122400 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 122404 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 122408 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 122412 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 122416 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 122420 */   // MIs[1] Operand 1
     /* 122420 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 122425 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 122427 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETO:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_un:{ *:[i32] }))
     /* 122427 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 122430 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 122434 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122439 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 122443 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 122447 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 122449 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 122452 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122456 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122461 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 122468 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 122473 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 122478 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 122481 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 122483 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122486 */   GIR_RootConstrainSelectedInstOperands,
     /* 122487 */   // GIR_Coverage, 3332,
     /* 122487 */   GIR_EraseRootFromParent_Done,
     /* 122488 */ // Label 1755: @122488
     /* 122488 */ GIM_Try, /*On fail goto*//*Label 1756*/ GIMT_Encode4(122627), // Rule ID 3986 //
     /* 122493 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 122496 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 122499 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 122503 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 122507 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 122511 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 122515 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 122519 */   // MIs[1] Operand 1
     /* 122519 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 122524 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 122526 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 122526 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 122529 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 122533 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122538 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 122542 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 122546 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 122548 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 122551 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 122555 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122560 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 122563 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 122565 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 122568 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 122572 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122577 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 122580 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 122582 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 122585 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122589 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122594 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 122601 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 122606 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 122611 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 122614 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122616 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122619 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 122622 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 122625 */   GIR_RootConstrainSelectedInstOperands,
     /* 122626 */   // GIR_Coverage, 3986,
     /* 122626 */   GIR_EraseRootFromParent_Done,
     /* 122627 */ // Label 1756: @122627
     /* 122627 */ GIM_Try, /*On fail goto*//*Label 1757*/ GIMT_Encode4(122766), // Rule ID 4018 //
     /* 122632 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 122635 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 122638 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 122642 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 122646 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 122650 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 122654 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 122658 */   // MIs[1] Operand 1
     /* 122658 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 122663 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 122665 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 122665 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 122668 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 122672 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122677 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 122681 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 122685 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 122687 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 122690 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 122694 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122699 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 122702 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 122704 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 122707 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 122711 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122716 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 122719 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 122721 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 122724 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122728 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122733 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 122740 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 122745 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 122750 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 122753 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122755 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122758 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 122761 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 122764 */   GIR_RootConstrainSelectedInstOperands,
     /* 122765 */   // GIR_Coverage, 4018,
     /* 122765 */   GIR_EraseRootFromParent_Done,
     /* 122766 */ // Label 1757: @122766
     /* 122766 */ GIM_Try, /*On fail goto*//*Label 1758*/ GIMT_Encode4(122905), // Rule ID 4050 //
     /* 122771 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 122774 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 122777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 122781 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 122785 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 122789 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 122793 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 122797 */   // MIs[1] Operand 1
     /* 122797 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 122802 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 122804 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 122804 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 122807 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 122811 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122816 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 122820 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 122824 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 122826 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 122829 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 122833 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122838 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 122841 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 122843 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 122846 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 122850 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122855 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 122858 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 122860 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 122863 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122867 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122872 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 122879 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 122884 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 122889 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 122892 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122894 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122897 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 122900 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 122903 */   GIR_RootConstrainSelectedInstOperands,
     /* 122904 */   // GIR_Coverage, 4050,
     /* 122904 */   GIR_EraseRootFromParent_Done,
     /* 122905 */ // Label 1758: @122905
     /* 122905 */ GIM_Try, /*On fail goto*//*Label 1759*/ GIMT_Encode4(123044), // Rule ID 4082 //
     /* 122910 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 122913 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 122916 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 122920 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 122924 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 122928 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 122932 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 122936 */   // MIs[1] Operand 1
     /* 122936 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 122941 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 122943 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETO:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_un:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 122943 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 122946 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 122950 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122955 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 122959 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 122963 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 122965 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 122968 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 122972 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122977 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 122980 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 122982 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 122985 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 122989 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122994 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 122997 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 122999 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 123002 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 123006 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123011 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 123018 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 123023 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 123028 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 123031 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123033 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123036 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 123039 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 123042 */   GIR_RootConstrainSelectedInstOperands,
     /* 123043 */   // GIR_Coverage, 4082,
     /* 123043 */   GIR_EraseRootFromParent_Done,
     /* 123044 */ // Label 1759: @123044
     /* 123044 */ GIM_Try, /*On fail goto*//*Label 1760*/ GIMT_Encode4(123183), // Rule ID 4098 //
     /* 123049 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 123052 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 123055 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 123059 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 123063 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 123067 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 123071 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 123075 */   // MIs[1] Operand 1
     /* 123075 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 123080 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 123082 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 123082 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 123085 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 123089 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123094 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 123098 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 123102 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 123104 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 123107 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 123111 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123116 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 123119 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 123121 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 123124 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 123128 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123133 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 123136 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 123138 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 123141 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 123145 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123150 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 123157 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 123162 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 123167 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 123170 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123172 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123175 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 123178 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 123181 */   GIR_RootConstrainSelectedInstOperands,
     /* 123182 */   // GIR_Coverage, 4098,
     /* 123182 */   GIR_EraseRootFromParent_Done,
     /* 123183 */ // Label 1760: @123183
     /* 123183 */ GIM_Try, /*On fail goto*//*Label 1761*/ GIMT_Encode4(123322), // Rule ID 4130 //
     /* 123188 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 123191 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 123194 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 123198 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 123202 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 123206 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 123210 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 123214 */   // MIs[1] Operand 1
     /* 123214 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 123219 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 123221 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 123221 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 123224 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 123228 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123233 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 123237 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 123241 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 123243 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 123246 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 123250 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123255 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 123258 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 123260 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 123263 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 123267 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123272 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 123275 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 123277 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 123280 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 123284 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123289 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 123296 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 123301 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 123306 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 123309 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123311 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123314 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 123317 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 123320 */   GIR_RootConstrainSelectedInstOperands,
     /* 123321 */   // GIR_Coverage, 4130,
     /* 123321 */   GIR_EraseRootFromParent_Done,
     /* 123322 */ // Label 1761: @123322
     /* 123322 */ GIM_Try, /*On fail goto*//*Label 1762*/ GIMT_Encode4(123461), // Rule ID 4162 //
     /* 123327 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 123330 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 123333 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 123337 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 123341 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 123345 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 123349 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 123353 */   // MIs[1] Operand 1
     /* 123353 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 123358 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 123360 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 123360 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 123363 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 123367 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123372 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 123376 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 123380 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 123382 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 123385 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 123389 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123394 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 123397 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 123399 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 123402 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 123406 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123411 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 123414 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 123416 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 123419 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 123423 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123428 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 123435 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 123440 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 123445 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 123448 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123450 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123453 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 123456 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 123459 */   GIR_RootConstrainSelectedInstOperands,
     /* 123460 */   // GIR_Coverage, 4162,
     /* 123460 */   GIR_EraseRootFromParent_Done,
     /* 123461 */ // Label 1762: @123461
     /* 123461 */ GIM_Try, /*On fail goto*//*Label 1763*/ GIMT_Encode4(123600), // Rule ID 4194 //
     /* 123466 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 123469 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 123472 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 123476 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 123480 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 123484 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 123488 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 123492 */   // MIs[1] Operand 1
     /* 123492 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 123497 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 123499 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETO:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_un:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 123499 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 123502 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 123506 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123511 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 123515 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 123519 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 123521 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 123524 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 123528 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123533 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 123536 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 123538 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 123541 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 123545 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123550 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 123553 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 123555 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 123558 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 123562 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123567 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 123574 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 123579 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 123584 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 123587 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123589 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123592 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 123595 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 123598 */   GIR_RootConstrainSelectedInstOperands,
     /* 123599 */   // GIR_Coverage, 4194,
     /* 123599 */   GIR_EraseRootFromParent_Done,
     /* 123600 */ // Label 1763: @123600
     /* 123600 */ GIM_Try, /*On fail goto*//*Label 1764*/ GIMT_Encode4(123739), // Rule ID 4224 //
     /* 123605 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 123608 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 123611 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 123615 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 123619 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 123623 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 123627 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 123631 */   // MIs[1] Operand 1
     /* 123631 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 123636 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 123638 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 123638 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 123641 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 123645 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123650 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 123654 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 123658 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 123660 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 123663 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 123667 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123672 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 123675 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 123677 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 123680 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 123684 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123689 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 123692 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 123694 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 123697 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 123701 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123706 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 123713 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 123718 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 123723 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 123726 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123728 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123731 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 123734 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 123737 */   GIR_RootConstrainSelectedInstOperands,
     /* 123738 */   // GIR_Coverage, 4224,
     /* 123738 */   GIR_EraseRootFromParent_Done,
     /* 123739 */ // Label 1764: @123739
     /* 123739 */ GIM_Try, /*On fail goto*//*Label 1765*/ GIMT_Encode4(123878), // Rule ID 4256 //
     /* 123744 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 123747 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 123750 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 123754 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 123758 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 123762 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 123766 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 123770 */   // MIs[1] Operand 1
     /* 123770 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 123775 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 123777 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 123777 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 123780 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 123784 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123789 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 123793 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 123797 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 123799 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 123802 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 123806 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123811 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 123814 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 123816 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 123819 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 123823 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123828 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 123831 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 123833 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 123836 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 123840 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123845 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 123852 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 123857 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 123862 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 123865 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123867 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123870 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 123873 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 123876 */   GIR_RootConstrainSelectedInstOperands,
     /* 123877 */   // GIR_Coverage, 4256,
     /* 123877 */   GIR_EraseRootFromParent_Done,
     /* 123878 */ // Label 1765: @123878
     /* 123878 */ GIM_Try, /*On fail goto*//*Label 1766*/ GIMT_Encode4(124017), // Rule ID 4288 //
     /* 123883 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 123886 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 123889 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 123893 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 123897 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 123901 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 123905 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 123909 */   // MIs[1] Operand 1
     /* 123909 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 123914 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 123916 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 123916 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 123919 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 123923 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123928 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 123932 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 123936 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 123938 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 123941 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 123945 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123950 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 123953 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 123955 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 123958 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 123962 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123967 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 123970 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 123972 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 123975 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 123979 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123984 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 123991 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 123996 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 124001 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 124004 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124006 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124009 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 124012 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 124015 */   GIR_RootConstrainSelectedInstOperands,
     /* 124016 */   // GIR_Coverage, 4288,
     /* 124016 */   GIR_EraseRootFromParent_Done,
     /* 124017 */ // Label 1766: @124017
     /* 124017 */ GIM_Try, /*On fail goto*//*Label 1767*/ GIMT_Encode4(124156), // Rule ID 4320 //
     /* 124022 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 124025 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 124028 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 124032 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124036 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 124040 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 124044 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 124048 */   // MIs[1] Operand 1
     /* 124048 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 124053 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124055 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETO:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_un:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 124055 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 124058 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 124062 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124067 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 124071 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 124075 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 124077 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 124080 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 124084 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124089 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 124092 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 124094 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 124097 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 124101 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124106 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 124109 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 124111 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 124114 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 124118 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124123 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 124130 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 124135 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 124140 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 124143 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124145 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124148 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 124151 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 124154 */   GIR_RootConstrainSelectedInstOperands,
     /* 124155 */   // GIR_Coverage, 4320,
     /* 124155 */   GIR_EraseRootFromParent_Done,
     /* 124156 */ // Label 1767: @124156
     /* 124156 */ GIM_Try, /*On fail goto*//*Label 1768*/ GIMT_Encode4(124295), // Rule ID 4551 //
     /* 124161 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 124164 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 124167 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 124171 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124175 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 124179 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 124183 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 124187 */   // MIs[1] Operand 1
     /* 124187 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 124192 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124194 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPLT:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 124194 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 124197 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPLT),
     /* 124201 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124206 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 124210 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 124214 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 124216 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 124219 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 124223 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124228 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 124231 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 124233 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 124236 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 124240 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124245 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 124248 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 124250 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 124253 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 124257 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124262 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 124269 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 124274 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 124279 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 124282 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124284 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124287 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 124290 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 124293 */   GIR_RootConstrainSelectedInstOperands,
     /* 124294 */   // GIR_Coverage, 4551,
     /* 124294 */   GIR_EraseRootFromParent_Done,
     /* 124295 */ // Label 1768: @124295
     /* 124295 */ GIM_Try, /*On fail goto*//*Label 1769*/ GIMT_Encode4(124434), // Rule ID 4583 //
     /* 124300 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 124303 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 124306 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 124310 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124314 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 124318 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 124322 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 124326 */   // MIs[1] Operand 1
     /* 124326 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 124331 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124333 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPGT:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 124333 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 124336 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPGT),
     /* 124340 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124345 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 124349 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 124353 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 124355 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 124358 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 124362 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124367 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 124370 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 124372 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 124375 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 124379 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124384 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 124387 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 124389 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 124392 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 124396 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124401 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 124408 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 124413 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 124418 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 124421 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124423 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124426 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 124429 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 124432 */   GIR_RootConstrainSelectedInstOperands,
     /* 124433 */   // GIR_Coverage, 4583,
     /* 124433 */   GIR_EraseRootFromParent_Done,
     /* 124434 */ // Label 1769: @124434
     /* 124434 */ GIM_Try, /*On fail goto*//*Label 1770*/ GIMT_Encode4(124573), // Rule ID 4615 //
     /* 124439 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 124442 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 124445 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 124449 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124453 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 124457 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 124461 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 124465 */   // MIs[1] Operand 1
     /* 124465 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 124470 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124472 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPEQ:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 124472 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 124475 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPEQ),
     /* 124479 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124484 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 124488 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 124492 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 124494 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 124497 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 124501 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124506 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 124509 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 124511 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 124514 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 124518 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124523 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 124526 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 124528 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 124531 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 124535 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124540 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 124547 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 124552 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 124557 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 124560 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124562 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124565 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 124568 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 124571 */   GIR_RootConstrainSelectedInstOperands,
     /* 124572 */   // GIR_Coverage, 4615,
     /* 124572 */   GIR_EraseRootFromParent_Done,
     /* 124573 */ // Label 1770: @124573
     /* 124573 */ GIM_Try, /*On fail goto*//*Label 1771*/ GIMT_Encode4(124712), // Rule ID 4659 //
     /* 124578 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 124581 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 124584 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 124588 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124592 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 124596 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 124600 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 124604 */   // MIs[1] Operand 1
     /* 124604 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 124609 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124611 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPLT:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 124611 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 124614 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPLT),
     /* 124618 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124623 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 124627 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 124631 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 124633 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 124636 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 124640 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124645 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 124648 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 124650 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 124653 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 124657 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124662 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 124665 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 124667 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 124670 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 124674 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124679 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 124686 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 124691 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 124696 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 124699 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124701 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124704 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 124707 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 124710 */   GIR_RootConstrainSelectedInstOperands,
     /* 124711 */   // GIR_Coverage, 4659,
     /* 124711 */   GIR_EraseRootFromParent_Done,
     /* 124712 */ // Label 1771: @124712
     /* 124712 */ GIM_Try, /*On fail goto*//*Label 1772*/ GIMT_Encode4(124851), // Rule ID 4691 //
     /* 124717 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 124720 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 124723 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 124727 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124731 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 124735 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 124739 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 124743 */   // MIs[1] Operand 1
     /* 124743 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 124748 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124750 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPGT:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 124750 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 124753 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPGT),
     /* 124757 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124762 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 124766 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 124770 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 124772 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 124775 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 124779 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124784 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 124787 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 124789 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 124792 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 124796 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124801 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 124804 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 124806 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 124809 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 124813 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124818 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 124825 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 124830 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 124835 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 124838 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124840 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124843 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 124846 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 124849 */   GIR_RootConstrainSelectedInstOperands,
     /* 124850 */   // GIR_Coverage, 4691,
     /* 124850 */   GIR_EraseRootFromParent_Done,
     /* 124851 */ // Label 1772: @124851
     /* 124851 */ GIM_Try, /*On fail goto*//*Label 1773*/ GIMT_Encode4(124990), // Rule ID 4723 //
     /* 124856 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 124859 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 124862 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 124866 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124870 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 124874 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 124878 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 124882 */   // MIs[1] Operand 1
     /* 124882 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 124887 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124889 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPEQ:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 124889 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 124892 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPEQ),
     /* 124896 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124901 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 124905 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 124909 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 124911 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 124914 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 124918 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124923 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 124926 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 124928 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 124931 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 124935 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124940 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 124943 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 124945 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 124948 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 124952 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124957 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 124964 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 124969 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 124974 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 124977 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124979 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124982 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 124985 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 124988 */   GIR_RootConstrainSelectedInstOperands,
     /* 124989 */   // GIR_Coverage, 4723,
     /* 124989 */   GIR_EraseRootFromParent_Done,
     /* 124990 */ // Label 1773: @124990
     /* 124990 */ GIM_Try, /*On fail goto*//*Label 1774*/ GIMT_Encode4(125089), // Rule ID 2974 //
     /* 124995 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 124998 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 125001 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 125005 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125009 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 125013 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 125017 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 125021 */   // MIs[1] Operand 1
     /* 125021 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 125026 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125028 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }))
     /* 125028 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 125031 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 125035 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125040 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 125044 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 125048 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 125050 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 125053 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 125057 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125062 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 125069 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 125074 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 125079 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 125082 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 125084 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125087 */   GIR_RootConstrainSelectedInstOperands,
     /* 125088 */   // GIR_Coverage, 2974,
     /* 125088 */   GIR_EraseRootFromParent_Done,
     /* 125089 */ // Label 1774: @125089
     /* 125089 */ GIM_Try, /*On fail goto*//*Label 1775*/ GIMT_Encode4(125188), // Rule ID 2988 //
     /* 125094 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 125097 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 125100 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 125104 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125108 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 125112 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 125116 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 125120 */   // MIs[1] Operand 1
     /* 125120 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 125125 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125127 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETGE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }))
     /* 125127 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 125130 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 125134 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125139 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 125143 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 125147 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 125149 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 125152 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 125156 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125161 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 125168 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 125173 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 125178 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 125181 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 125183 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125186 */   GIR_RootConstrainSelectedInstOperands,
     /* 125187 */   // GIR_Coverage, 2988,
     /* 125187 */   GIR_EraseRootFromParent_Done,
     /* 125188 */ // Label 1775: @125188
     /* 125188 */ GIM_Try, /*On fail goto*//*Label 1776*/ GIMT_Encode4(125287), // Rule ID 2996 //
     /* 125193 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 125196 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 125199 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 125203 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125207 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 125211 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 125215 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 125219 */   // MIs[1] Operand 1
     /* 125219 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 125224 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125226 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETULE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }))
     /* 125226 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 125229 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 125233 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125238 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 125242 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 125246 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 125248 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 125251 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 125255 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125260 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 125267 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 125272 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 125277 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 125280 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 125282 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125285 */   GIR_RootConstrainSelectedInstOperands,
     /* 125286 */   // GIR_Coverage, 2996,
     /* 125286 */   GIR_EraseRootFromParent_Done,
     /* 125287 */ // Label 1776: @125287
     /* 125287 */ GIM_Try, /*On fail goto*//*Label 1777*/ GIMT_Encode4(125386), // Rule ID 3004 //
     /* 125292 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 125295 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 125298 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 125302 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125306 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 125310 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 125314 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 125318 */   // MIs[1] Operand 1
     /* 125318 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 125323 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125325 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETLE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }))
     /* 125325 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 125328 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 125332 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125337 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 125341 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 125345 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 125347 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 125350 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 125354 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125359 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 125366 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 125371 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 125376 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 125379 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 125381 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125384 */   GIR_RootConstrainSelectedInstOperands,
     /* 125385 */   // GIR_Coverage, 3004,
     /* 125385 */   GIR_EraseRootFromParent_Done,
     /* 125386 */ // Label 1777: @125386
     /* 125386 */ GIM_Try, /*On fail goto*//*Label 1778*/ GIMT_Encode4(125485), // Rule ID 3012 //
     /* 125391 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 125394 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 125397 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 125401 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125405 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 125409 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 125413 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 125417 */   // MIs[1] Operand 1
     /* 125417 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 125422 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125424 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETNE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_eq:{ *:[i32] }))
     /* 125424 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 125427 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 125431 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125436 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 125440 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 125444 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 125446 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 125449 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 125453 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125458 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 125465 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 125470 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 125475 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 125478 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 125480 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125483 */   GIR_RootConstrainSelectedInstOperands,
     /* 125484 */   // GIR_Coverage, 3012,
     /* 125484 */   GIR_EraseRootFromParent_Done,
     /* 125485 */ // Label 1778: @125485
     /* 125485 */ GIM_Try, /*On fail goto*//*Label 1779*/ GIMT_Encode4(125584), // Rule ID 3076 //
     /* 125490 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 125493 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 125496 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 125500 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125504 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 125508 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 125512 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 125516 */   // MIs[1] Operand 1
     /* 125516 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 125521 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125523 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }))
     /* 125523 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 125526 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 125530 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125535 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 125539 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 125543 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 125545 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 125548 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 125552 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125557 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 125564 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 125569 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 125574 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 125577 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 125579 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125582 */   GIR_RootConstrainSelectedInstOperands,
     /* 125583 */   // GIR_Coverage, 3076,
     /* 125583 */   GIR_EraseRootFromParent_Done,
     /* 125584 */ // Label 1779: @125584
     /* 125584 */ GIM_Try, /*On fail goto*//*Label 1780*/ GIMT_Encode4(125683), // Rule ID 3084 //
     /* 125589 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 125592 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 125595 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 125599 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125603 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 125607 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 125611 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 125615 */   // MIs[1] Operand 1
     /* 125615 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 125620 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125622 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETGE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }))
     /* 125622 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 125625 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 125629 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125634 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 125638 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 125642 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 125644 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 125647 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 125651 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125656 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 125663 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 125668 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 125673 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 125676 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 125678 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125681 */   GIR_RootConstrainSelectedInstOperands,
     /* 125682 */   // GIR_Coverage, 3084,
     /* 125682 */   GIR_EraseRootFromParent_Done,
     /* 125683 */ // Label 1780: @125683
     /* 125683 */ GIM_Try, /*On fail goto*//*Label 1781*/ GIMT_Encode4(125782), // Rule ID 3092 //
     /* 125688 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 125691 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 125694 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 125698 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125702 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 125706 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 125710 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 125714 */   // MIs[1] Operand 1
     /* 125714 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 125719 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125721 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETULE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }))
     /* 125721 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 125724 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 125728 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125733 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 125737 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 125741 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 125743 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 125746 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 125750 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125755 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 125762 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 125767 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 125772 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 125775 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 125777 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125780 */   GIR_RootConstrainSelectedInstOperands,
     /* 125781 */   // GIR_Coverage, 3092,
     /* 125781 */   GIR_EraseRootFromParent_Done,
     /* 125782 */ // Label 1781: @125782
     /* 125782 */ GIM_Try, /*On fail goto*//*Label 1782*/ GIMT_Encode4(125881), // Rule ID 3100 //
     /* 125787 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 125790 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 125793 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 125797 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125801 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 125805 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 125809 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 125813 */   // MIs[1] Operand 1
     /* 125813 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 125818 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125820 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETLE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }))
     /* 125820 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 125823 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 125827 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125832 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 125836 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 125840 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 125842 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 125845 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 125849 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125854 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 125861 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 125866 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 125871 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 125874 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 125876 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125879 */   GIR_RootConstrainSelectedInstOperands,
     /* 125880 */   // GIR_Coverage, 3100,
     /* 125880 */   GIR_EraseRootFromParent_Done,
     /* 125881 */ // Label 1782: @125881
     /* 125881 */ GIM_Try, /*On fail goto*//*Label 1783*/ GIMT_Encode4(125980), // Rule ID 3108 //
     /* 125886 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 125889 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 125892 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 125896 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125900 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 125904 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 125908 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 125912 */   // MIs[1] Operand 1
     /* 125912 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 125917 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125919 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETNE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_eq:{ *:[i32] }))
     /* 125919 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 125922 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 125926 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125931 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 125935 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 125939 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 125941 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 125944 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 125948 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125953 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 125960 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 125965 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 125970 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 125973 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 125975 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125978 */   GIR_RootConstrainSelectedInstOperands,
     /* 125979 */   // GIR_Coverage, 3108,
     /* 125979 */   GIR_EraseRootFromParent_Done,
     /* 125980 */ // Label 1783: @125980
     /* 125980 */ GIM_Try, /*On fail goto*//*Label 1784*/ GIMT_Encode4(126119), // Rule ID 3830 //
     /* 125985 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 125988 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 125991 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 125995 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125999 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 126003 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 126007 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 126011 */   // MIs[1] Operand 1
     /* 126011 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 126016 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126018 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 126018 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 126021 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 126025 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126030 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 126034 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 126038 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 126040 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 126043 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 126047 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126052 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 126055 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 126057 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 126060 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 126064 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126069 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 126072 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 126074 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 126077 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 126081 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126086 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 126093 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 126098 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 126103 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 126106 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126108 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126111 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 126114 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 126117 */   GIR_RootConstrainSelectedInstOperands,
     /* 126118 */   // GIR_Coverage, 3830,
     /* 126118 */   GIR_EraseRootFromParent_Done,
     /* 126119 */ // Label 1784: @126119
     /* 126119 */ GIM_Try, /*On fail goto*//*Label 1785*/ GIMT_Encode4(126258), // Rule ID 3838 //
     /* 126124 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 126127 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 126130 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 126134 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 126138 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 126142 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 126146 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 126150 */   // MIs[1] Operand 1
     /* 126150 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 126155 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126157 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 126157 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 126160 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 126164 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126169 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 126173 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 126177 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 126179 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 126182 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 126186 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126191 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 126194 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 126196 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 126199 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 126203 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126208 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 126211 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 126213 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 126216 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 126220 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126225 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 126232 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 126237 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 126242 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 126245 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126247 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126250 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 126253 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 126256 */   GIR_RootConstrainSelectedInstOperands,
     /* 126257 */   // GIR_Coverage, 3838,
     /* 126257 */   GIR_EraseRootFromParent_Done,
     /* 126258 */ // Label 1785: @126258
     /* 126258 */ GIM_Try, /*On fail goto*//*Label 1786*/ GIMT_Encode4(126397), // Rule ID 3846 //
     /* 126263 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 126266 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 126269 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 126273 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 126277 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 126281 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 126285 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 126289 */   // MIs[1] Operand 1
     /* 126289 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 126294 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126296 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 126296 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 126299 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 126303 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126308 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 126312 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 126316 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 126318 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 126321 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 126325 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126330 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 126333 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 126335 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 126338 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 126342 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126347 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 126350 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 126352 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 126355 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 126359 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126364 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 126371 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 126376 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 126381 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 126384 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126386 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126389 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 126392 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 126395 */   GIR_RootConstrainSelectedInstOperands,
     /* 126396 */   // GIR_Coverage, 3846,
     /* 126396 */   GIR_EraseRootFromParent_Done,
     /* 126397 */ // Label 1786: @126397
     /* 126397 */ GIM_Try, /*On fail goto*//*Label 1787*/ GIMT_Encode4(126536), // Rule ID 3854 //
     /* 126402 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 126405 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 126408 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 126412 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 126416 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 126420 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 126424 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 126428 */   // MIs[1] Operand 1
     /* 126428 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 126433 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126435 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETLE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 126435 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 126438 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 126442 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126447 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 126451 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 126455 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 126457 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 126460 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 126464 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126469 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 126472 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 126474 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 126477 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 126481 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126486 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 126489 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 126491 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 126494 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 126498 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126503 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 126510 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 126515 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 126520 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 126523 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126525 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126528 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 126531 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 126534 */   GIR_RootConstrainSelectedInstOperands,
     /* 126535 */   // GIR_Coverage, 3854,
     /* 126535 */   GIR_EraseRootFromParent_Done,
     /* 126536 */ // Label 1787: @126536
     /* 126536 */ GIM_Try, /*On fail goto*//*Label 1788*/ GIMT_Encode4(126675), // Rule ID 3862 //
     /* 126541 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 126544 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 126547 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 126551 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 126555 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 126559 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 126563 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 126567 */   // MIs[1] Operand 1
     /* 126567 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 126572 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126574 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 126574 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 126577 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 126581 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126586 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 126590 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 126594 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 126596 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 126599 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 126603 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126608 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 126611 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 126613 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 126616 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 126620 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126625 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 126628 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 126630 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 126633 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 126637 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126642 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 126649 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 126654 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 126659 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 126662 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126664 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126667 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 126670 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 126673 */   GIR_RootConstrainSelectedInstOperands,
     /* 126674 */   // GIR_Coverage, 3862,
     /* 126674 */   GIR_EraseRootFromParent_Done,
     /* 126675 */ // Label 1788: @126675
     /* 126675 */ GIM_Try, /*On fail goto*//*Label 1789*/ GIMT_Encode4(126814), // Rule ID 3926 //
     /* 126680 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 126683 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 126686 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 126690 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 126694 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 126698 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 126702 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 126706 */   // MIs[1] Operand 1
     /* 126706 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 126711 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126713 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 126713 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 126716 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 126720 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126725 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 126729 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 126733 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 126735 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 126738 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 126742 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126747 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 126750 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 126752 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 126755 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 126759 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126764 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 126767 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 126769 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 126772 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 126776 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126781 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 126788 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 126793 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 126798 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 126801 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126803 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126806 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 126809 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 126812 */   GIR_RootConstrainSelectedInstOperands,
     /* 126813 */   // GIR_Coverage, 3926,
     /* 126813 */   GIR_EraseRootFromParent_Done,
     /* 126814 */ // Label 1789: @126814
     /* 126814 */ GIM_Try, /*On fail goto*//*Label 1790*/ GIMT_Encode4(126953), // Rule ID 3934 //
     /* 126819 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 126822 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 126825 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 126829 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 126833 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 126837 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 126841 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 126845 */   // MIs[1] Operand 1
     /* 126845 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 126850 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126852 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 126852 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 126855 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 126859 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126864 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 126868 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 126872 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 126874 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 126877 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 126881 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126886 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 126889 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 126891 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 126894 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 126898 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126903 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 126906 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 126908 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 126911 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 126915 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126920 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 126927 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 126932 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 126937 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 126940 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126942 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126945 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 126948 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 126951 */   GIR_RootConstrainSelectedInstOperands,
     /* 126952 */   // GIR_Coverage, 3934,
     /* 126952 */   GIR_EraseRootFromParent_Done,
     /* 126953 */ // Label 1790: @126953
     /* 126953 */ GIM_Try, /*On fail goto*//*Label 1791*/ GIMT_Encode4(127092), // Rule ID 3942 //
     /* 126958 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 126961 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 126964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 126968 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 126972 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 126976 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 126980 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 126984 */   // MIs[1] Operand 1
     /* 126984 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 126989 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126991 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 126991 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 126994 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 126998 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127003 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 127007 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 127011 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 127013 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 127016 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 127020 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127025 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 127028 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 127030 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 127033 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 127037 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127042 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 127045 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 127047 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 127050 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 127054 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127059 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 127066 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 127071 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 127076 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 127079 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127081 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127084 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 127087 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 127090 */   GIR_RootConstrainSelectedInstOperands,
     /* 127091 */   // GIR_Coverage, 3942,
     /* 127091 */   GIR_EraseRootFromParent_Done,
     /* 127092 */ // Label 1791: @127092
     /* 127092 */ GIM_Try, /*On fail goto*//*Label 1792*/ GIMT_Encode4(127231), // Rule ID 3950 //
     /* 127097 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 127100 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 127103 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 127107 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 127111 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 127115 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 127119 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 127123 */   // MIs[1] Operand 1
     /* 127123 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 127128 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 127130 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETLE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 127130 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 127133 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 127137 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127142 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 127146 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 127150 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 127152 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 127155 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 127159 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127164 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 127167 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 127169 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 127172 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 127176 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127181 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 127184 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 127186 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 127189 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 127193 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127198 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 127205 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 127210 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 127215 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 127218 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127220 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127223 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 127226 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 127229 */   GIR_RootConstrainSelectedInstOperands,
     /* 127230 */   // GIR_Coverage, 3950,
     /* 127230 */   GIR_EraseRootFromParent_Done,
     /* 127231 */ // Label 1792: @127231
     /* 127231 */ GIM_Try, /*On fail goto*//*Label 1793*/ GIMT_Encode4(127370), // Rule ID 3958 //
     /* 127236 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 127239 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 127242 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 127246 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 127250 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 127254 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 127258 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 127262 */   // MIs[1] Operand 1
     /* 127262 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 127267 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 127269 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 127269 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 127272 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 127276 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127281 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 127285 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 127289 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 127291 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 127294 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 127298 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127303 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 127306 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 127308 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 127311 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 127315 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127320 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 127323 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 127325 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 127328 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 127332 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127337 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 127344 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 127349 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 127354 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 127357 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127359 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127362 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 127365 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 127368 */   GIR_RootConstrainSelectedInstOperands,
     /* 127369 */   // GIR_Coverage, 3958,
     /* 127369 */   GIR_EraseRootFromParent_Done,
     /* 127370 */ // Label 1793: @127370
     /* 127370 */ GIM_Try, /*On fail goto*//*Label 1794*/ GIMT_Encode4(127389), // Rule ID 680 //
     /* 127375 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 127378 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 127382 */   // (sext:{ *:[i64] } i32:{ *:[i32] }:$RST)  =>  (EXTSW_32_64:{ *:[i64] } i32:{ *:[i32] }:$RST)
     /* 127382 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EXTSW_32_64),
     /* 127387 */   GIR_RootConstrainSelectedInstOperands,
     /* 127388 */   // GIR_Coverage, 680,
     /* 127388 */   GIR_Done,
     /* 127389 */ // Label 1794: @127389
     /* 127389 */ GIM_Try, /*On fail goto*//*Label 1795*/ GIMT_Encode4(127411), // Rule ID 2980 //
     /* 127394 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 127397 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 127400 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 127404 */   // (sext:{ *:[i64] } i1:{ *:[i1] }:$in)  =>  (SETNBC8:{ *:[i64] } ?:{ *:[i1] }:$in)
     /* 127404 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SETNBC8),
     /* 127409 */   GIR_RootConstrainSelectedInstOperands,
     /* 127410 */   // GIR_Coverage, 2980,
     /* 127410 */   GIR_Done,
     /* 127411 */ // Label 1795: @127411
     /* 127411 */ GIM_Try, /*On fail goto*//*Label 1796*/ GIMT_Encode4(127472), // Rule ID 3636 //
     /* 127416 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 127419 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 127423 */   // (sext:{ *:[i64] } i1:{ *:[i1] }:$in)  =>  (SELECT_I8:{ *:[i64] } ?:{ *:[i1] }:$in, (LI8:{ *:[i64] } -1:{ *:[i64] }), (LI8:{ *:[i64] } 0:{ *:[i64] }))
     /* 127423 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 127426 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 127430 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127435 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 127438 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 127440 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 127443 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 127447 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127452 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/uint8_t(-1),
     /* 127455 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 127457 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 127460 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127462 */   GIR_RootToRootCopy, /*OpIdx*/1, // in
     /* 127464 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127467 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 127470 */   GIR_RootConstrainSelectedInstOperands,
     /* 127471 */   // GIR_Coverage, 3636,
     /* 127471 */   GIR_EraseRootFromParent_Done,
     /* 127472 */ // Label 1796: @127472
     /* 127472 */ GIM_Reject,
     /* 127473 */ // Label 1666: @127473
     /* 127473 */ GIM_Reject,
     /* 127474 */ // Label 25: @127474
     /* 127474 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 1801*/ GIMT_Encode4(127826),
     /* 127485 */ /*GILLT_s32*//*Label 1797*/ GIMT_Encode4(127505),
     /* 127489 */ /*GILLT_s64*//*Label 1798*/ GIMT_Encode4(127569), GIMT_Encode4(0),
     /* 127497 */ /*GILLT_v2s64*//*Label 1799*/ GIMT_Encode4(127658),
     /* 127501 */ /*GILLT_v4s32*//*Label 1800*/ GIMT_Encode4(127756),
     /* 127505 */ // Label 1797: @127505
     /* 127505 */ GIM_Try, /*On fail goto*//*Label 1802*/ GIMT_Encode4(127568),
     /* 127510 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 127513 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 127517 */   GIM_Try, /*On fail goto*//*Label 1803*/ GIMT_Encode4(127542), // Rule ID 135 //
     /* 127522 */     // MIs[0] Operand 2
     /* 127522 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 127533 */     // (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$RST, i8:{ *:[Other] })  =>  (EXTSB:{ *:[i32] } i32:{ *:[i32] }:$RST)
     /* 127533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::EXTSB),
     /* 127536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 127538 */     GIR_RootToRootCopy, /*OpIdx*/1, // RST
     /* 127540 */     GIR_RootConstrainSelectedInstOperands,
     /* 127541 */     // GIR_Coverage, 135,
     /* 127541 */     GIR_EraseRootFromParent_Done,
     /* 127542 */   // Label 1803: @127542
     /* 127542 */   GIM_Try, /*On fail goto*//*Label 1804*/ GIMT_Encode4(127567), // Rule ID 136 //
     /* 127547 */     // MIs[0] Operand 2
     /* 127547 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 127558 */     // (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$RST, i16:{ *:[Other] })  =>  (EXTSH:{ *:[i32] } i32:{ *:[i32] }:$RST)
     /* 127558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::EXTSH),
     /* 127561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 127563 */     GIR_RootToRootCopy, /*OpIdx*/1, // RST
     /* 127565 */     GIR_RootConstrainSelectedInstOperands,
     /* 127566 */     // GIR_Coverage, 136,
     /* 127566 */     GIR_EraseRootFromParent_Done,
     /* 127567 */   // Label 1804: @127567
     /* 127567 */   GIM_Reject,
     /* 127568 */ // Label 1802: @127568
     /* 127568 */ GIM_Reject,
     /* 127569 */ // Label 1798: @127569
     /* 127569 */ GIM_Try, /*On fail goto*//*Label 1805*/ GIMT_Encode4(127657),
     /* 127574 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 127577 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 127581 */   GIM_Try, /*On fail goto*//*Label 1806*/ GIMT_Encode4(127606), // Rule ID 677 //
     /* 127586 */     // MIs[0] Operand 2
     /* 127586 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 127597 */     // (sext_inreg:{ *:[i64] } i64:{ *:[i64] }:$RST, i8:{ *:[Other] })  =>  (EXTSB8:{ *:[i64] } i64:{ *:[i64] }:$RST)
     /* 127597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::EXTSB8),
     /* 127600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 127602 */     GIR_RootToRootCopy, /*OpIdx*/1, // RST
     /* 127604 */     GIR_RootConstrainSelectedInstOperands,
     /* 127605 */     // GIR_Coverage, 677,
     /* 127605 */     GIR_EraseRootFromParent_Done,
     /* 127606 */   // Label 1806: @127606
     /* 127606 */   GIM_Try, /*On fail goto*//*Label 1807*/ GIMT_Encode4(127631), // Rule ID 678 //
     /* 127611 */     // MIs[0] Operand 2
     /* 127611 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 127622 */     // (sext_inreg:{ *:[i64] } i64:{ *:[i64] }:$RST, i16:{ *:[Other] })  =>  (EXTSH8:{ *:[i64] } i64:{ *:[i64] }:$RST)
     /* 127622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::EXTSH8),
     /* 127625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 127627 */     GIR_RootToRootCopy, /*OpIdx*/1, // RST
     /* 127629 */     GIR_RootConstrainSelectedInstOperands,
     /* 127630 */     // GIR_Coverage, 678,
     /* 127630 */     GIR_EraseRootFromParent_Done,
     /* 127631 */   // Label 1807: @127631
     /* 127631 */   GIM_Try, /*On fail goto*//*Label 1808*/ GIMT_Encode4(127656), // Rule ID 679 //
     /* 127636 */     // MIs[0] Operand 2
     /* 127636 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(32),
     /* 127647 */     // (sext_inreg:{ *:[i64] } i64:{ *:[i64] }:$RST, i32:{ *:[Other] })  =>  (EXTSW:{ *:[i64] } i64:{ *:[i64] }:$RST)
     /* 127647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::EXTSW),
     /* 127650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 127652 */     GIR_RootToRootCopy, /*OpIdx*/1, // RST
     /* 127654 */     GIR_RootConstrainSelectedInstOperands,
     /* 127655 */     // GIR_Coverage, 679,
     /* 127655 */     GIR_EraseRootFromParent_Done,
     /* 127656 */   // Label 1808: @127656
     /* 127656 */   GIM_Reject,
     /* 127657 */ // Label 1805: @127657
     /* 127657 */ GIM_Reject,
     /* 127658 */ // Label 1799: @127658
     /* 127658 */ GIM_Try, /*On fail goto*//*Label 1809*/ GIMT_Encode4(127755),
     /* 127663 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 127666 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 127670 */   GIM_Try, /*On fail goto*//*Label 1810*/ GIMT_Encode4(127698), // Rule ID 1450 //
     /* 127675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /* 127678 */     // MIs[0] Operand 2
     /* 127678 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 127689 */     // (sext_inreg:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VRB, v2i8:{ *:[Other] })  =>  (VEXTSB2D:{ *:[v2i64] } ?:{ *:[v2i64] }:$VRB)
     /* 127689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTSB2D),
     /* 127692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /* 127694 */     GIR_RootToRootCopy, /*OpIdx*/1, // VRB
     /* 127696 */     GIR_RootConstrainSelectedInstOperands,
     /* 127697 */     // GIR_Coverage, 1450,
     /* 127697 */     GIR_EraseRootFromParent_Done,
     /* 127698 */   // Label 1810: @127698
     /* 127698 */   GIM_Try, /*On fail goto*//*Label 1811*/ GIMT_Encode4(127726), // Rule ID 1451 //
     /* 127703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /* 127706 */     // MIs[0] Operand 2
     /* 127706 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 127717 */     // (sext_inreg:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VRB, v2i16:{ *:[Other] })  =>  (VEXTSH2D:{ *:[v2i64] } ?:{ *:[v2i64] }:$VRB)
     /* 127717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTSH2D),
     /* 127720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /* 127722 */     GIR_RootToRootCopy, /*OpIdx*/1, // VRB
     /* 127724 */     GIR_RootConstrainSelectedInstOperands,
     /* 127725 */     // GIR_Coverage, 1451,
     /* 127725 */     GIR_EraseRootFromParent_Done,
     /* 127726 */   // Label 1811: @127726
     /* 127726 */   GIM_Try, /*On fail goto*//*Label 1812*/ GIMT_Encode4(127754), // Rule ID 1452 //
     /* 127731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /* 127734 */     // MIs[0] Operand 2
     /* 127734 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(32),
     /* 127745 */     // (sext_inreg:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VRB, v2i32:{ *:[Other] })  =>  (VEXTSW2D:{ *:[v2i64] } ?:{ *:[v2i64] }:$VRB)
     /* 127745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTSW2D),
     /* 127748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /* 127750 */     GIR_RootToRootCopy, /*OpIdx*/1, // VRB
     /* 127752 */     GIR_RootConstrainSelectedInstOperands,
     /* 127753 */     // GIR_Coverage, 1452,
     /* 127753 */     GIR_EraseRootFromParent_Done,
     /* 127754 */   // Label 1812: @127754
     /* 127754 */   GIM_Reject,
     /* 127755 */ // Label 1809: @127755
     /* 127755 */ GIM_Reject,
     /* 127756 */ // Label 1800: @127756
     /* 127756 */ GIM_Try, /*On fail goto*//*Label 1813*/ GIMT_Encode4(127825),
     /* 127761 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 127764 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 127768 */   GIM_Try, /*On fail goto*//*Label 1814*/ GIMT_Encode4(127796), // Rule ID 1448 //
     /* 127773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /* 127776 */     // MIs[0] Operand 2
     /* 127776 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 127787 */     // (sext_inreg:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VRB, v4i8:{ *:[Other] })  =>  (VEXTSB2W:{ *:[v4i32] } ?:{ *:[v4i32] }:$VRB)
     /* 127787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTSB2W),
     /* 127790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /* 127792 */     GIR_RootToRootCopy, /*OpIdx*/1, // VRB
     /* 127794 */     GIR_RootConstrainSelectedInstOperands,
     /* 127795 */     // GIR_Coverage, 1448,
     /* 127795 */     GIR_EraseRootFromParent_Done,
     /* 127796 */   // Label 1814: @127796
     /* 127796 */   GIM_Try, /*On fail goto*//*Label 1815*/ GIMT_Encode4(127824), // Rule ID 1449 //
     /* 127801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /* 127804 */     // MIs[0] Operand 2
     /* 127804 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 127815 */     // (sext_inreg:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VRB, v4i16:{ *:[Other] })  =>  (VEXTSH2W:{ *:[v4i32] } ?:{ *:[v4i32] }:$VRB)
     /* 127815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTSH2W),
     /* 127818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /* 127820 */     GIR_RootToRootCopy, /*OpIdx*/1, // VRB
     /* 127822 */     GIR_RootConstrainSelectedInstOperands,
     /* 127823 */     // GIR_Coverage, 1449,
     /* 127823 */     GIR_EraseRootFromParent_Done,
     /* 127824 */   // Label 1815: @127824
     /* 127824 */   GIM_Reject,
     /* 127825 */ // Label 1813: @127825
     /* 127825 */ GIM_Reject,
     /* 127826 */ // Label 1801: @127826
     /* 127826 */ GIM_Reject,
     /* 127827 */ // Label 26: @127827
     /* 127827 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1818*/ GIMT_Encode4(149296),
     /* 127838 */ /*GILLT_s32*//*Label 1816*/ GIMT_Encode4(127846),
     /* 127842 */ /*GILLT_s64*//*Label 1817*/ GIMT_Encode4(138067),
     /* 127846 */ // Label 1816: @127846
     /* 127846 */ GIM_Try, /*On fail goto*//*Label 1819*/ GIMT_Encode4(138066),
     /* 127851 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 127854 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 127858 */   GIM_Try, /*On fail goto*//*Label 1820*/ GIMT_Encode4(127970), // Rule ID 5252 //
     /* 127863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 127867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 127871 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 127875 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 127879 */     // MIs[1] Operand 1
     /* 127879 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 127884 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 127888 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 127892 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 127896 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 127900 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 127904 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 127908 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 127912 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 127916 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 127920 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 127924 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 127926 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } (and:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$sa), i32:{ *:[i32] }:$s1), 0:{ *:[i32] }, SETNE:{ *:[Other] }))  =>  (RLWNM:{ *:[i32] } ?:{ *:[i32] }:$s1, (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 32:{ *:[i32] }), 31:{ *:[i32] }, 31:{ *:[i32] })
     /* 127926 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 127929 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 127933 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127938 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 127942 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/32,
     /* 127945 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for PPC::CARRY*/0,
     /* 127948 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 127950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWNM),
     /* 127953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 127955 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /* 127959 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 127965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 127968 */     GIR_RootConstrainSelectedInstOperands,
     /* 127969 */     // GIR_Coverage, 5252,
     /* 127969 */     GIR_EraseRootFromParent_Done,
     /* 127970 */   // Label 1820: @127970
     /* 127970 */   GIM_Try, /*On fail goto*//*Label 1821*/ GIMT_Encode4(128109), // Rule ID 5255 //
     /* 127975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 127979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 127983 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 127987 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 127991 */     // MIs[1] Operand 1
     /* 127991 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 127996 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 128000 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 128004 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 128008 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 128012 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 128016 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 128020 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 128024 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 128028 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 128032 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 128036 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 128038 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } (and:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, i32:{ *:[i32] }:$sa), i64:{ *:[i64] }:$s1), 0:{ *:[i64] }, SETNE:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDCL:{ *:[i64] } ?:{ *:[i64] }:$s1, (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 64:{ *:[i32] }), 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 128038 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 128041 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 128045 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128050 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 128054 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/64,
     /* 128057 */     GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for PPC::CARRY*/0,
     /* 128060 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 128062 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 128065 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDCL),
     /* 128069 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128074 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /* 128078 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 128081 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /* 128084 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 128089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128091 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 128098 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 128103 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 128108 */     // GIR_Coverage, 5255,
     /* 128108 */     GIR_EraseRootFromParent_Done,
     /* 128109 */   // Label 1821: @128109
     /* 128109 */   GIM_Try, /*On fail goto*//*Label 1822*/ GIMT_Encode4(128242), // Rule ID 5260 //
     /* 128114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 128118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 128122 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 128126 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 128130 */     // MIs[1] Operand 1
     /* 128130 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 128135 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 128139 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 128143 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 128147 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 128151 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 128155 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 128159 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 128163 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 128167 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 128171 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 128175 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 128177 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } (and:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$sa), i32:{ *:[i32] }:$s1), 0:{ *:[i32] }, SETEQ:{ *:[Other] }))  =>  (RLWNM:{ *:[i32] } (NOR:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s1), (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 32:{ *:[i32] }), 31:{ *:[i32] }, 31:{ *:[i32] })
     /* 128177 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 128180 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 128184 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128189 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 128193 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/32,
     /* 128196 */     GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for PPC::CARRY*/0,
     /* 128199 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 128201 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 128204 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /* 128208 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128213 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /* 128217 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /* 128221 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWNM),
     /* 128226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 128228 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128231 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 128234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 128237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 128240 */     GIR_RootConstrainSelectedInstOperands,
     /* 128241 */     // GIR_Coverage, 5260,
     /* 128241 */     GIR_EraseRootFromParent_Done,
     /* 128242 */   // Label 1822: @128242
     /* 128242 */   GIM_Try, /*On fail goto*//*Label 1823*/ GIMT_Encode4(128402), // Rule ID 5263 //
     /* 128247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 128251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 128255 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 128259 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 128263 */     // MIs[1] Operand 1
     /* 128263 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 128268 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 128272 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 128276 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 128280 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 128284 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 128288 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 128292 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 128296 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 128300 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 128304 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 128308 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 128310 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } (and:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, i32:{ *:[i32] }:$sa), i64:{ *:[i64] }:$s1), 0:{ *:[i64] }, SETEQ:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDCL:{ *:[i64] } (NOR8:{ *:[i64] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s1), (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 64:{ *:[i32] }), 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 128310 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 128313 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 128317 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128322 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 128326 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/64,
     /* 128329 */     GIR_SetImplicitDefDead, /*InsnID*/3, /*OpIdx for PPC::CARRY*/0,
     /* 128332 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 128334 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 128337 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /* 128341 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128346 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /* 128350 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /* 128354 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 128356 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 128359 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDCL),
     /* 128363 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128368 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 128371 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 128374 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /* 128377 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 128382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128384 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 128391 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 128396 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 128401 */     // GIR_Coverage, 5263,
     /* 128401 */     GIR_EraseRootFromParent_Done,
     /* 128402 */   // Label 1823: @128402
     /* 128402 */   GIM_Try, /*On fail goto*//*Label 1824*/ GIMT_Encode4(128514), // Rule ID 3737 //
     /* 128407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 128411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 128415 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 128419 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 128423 */     // MIs[1] Operand 1
     /* 128423 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 128428 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 128432 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 128436 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 128440 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 128444 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 128448 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 128452 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 128456 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 128460 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 128464 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 128468 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 128470 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } (and:{ *:[i32] } i32:{ *:[i32] }:$s1, (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$sa)), 0:{ *:[i32] }, SETNE:{ *:[Other] }))  =>  (RLWNM:{ *:[i32] } ?:{ *:[i32] }:$s1, (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 32:{ *:[i32] }), 31:{ *:[i32] }, 31:{ *:[i32] })
     /* 128470 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 128473 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 128477 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128482 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 128486 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/32,
     /* 128489 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for PPC::CARRY*/0,
     /* 128492 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWNM),
     /* 128497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 128499 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /* 128503 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 128509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 128512 */     GIR_RootConstrainSelectedInstOperands,
     /* 128513 */     // GIR_Coverage, 3737,
     /* 128513 */     GIR_EraseRootFromParent_Done,
     /* 128514 */   // Label 1824: @128514
     /* 128514 */   GIM_Try, /*On fail goto*//*Label 1825*/ GIMT_Encode4(128653), // Rule ID 3740 //
     /* 128519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 128523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 128527 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 128531 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 128535 */     // MIs[1] Operand 1
     /* 128535 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 128540 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 128544 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 128548 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 128552 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 128556 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 128560 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 128564 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 128568 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 128572 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 128576 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 128580 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 128582 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } (and:{ *:[i64] } i64:{ *:[i64] }:$s1, (shl:{ *:[i64] } 1:{ *:[i64] }, i32:{ *:[i32] }:$sa)), 0:{ *:[i64] }, SETNE:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDCL:{ *:[i64] } ?:{ *:[i64] }:$s1, (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 64:{ *:[i32] }), 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 128582 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 128585 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 128589 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128594 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 128598 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/64,
     /* 128601 */     GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for PPC::CARRY*/0,
     /* 128604 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 128606 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 128609 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDCL),
     /* 128613 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128618 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /* 128622 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 128625 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /* 128628 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 128633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128635 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 128642 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 128647 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 128652 */     // GIR_Coverage, 3740,
     /* 128652 */     GIR_EraseRootFromParent_Done,
     /* 128653 */   // Label 1825: @128653
     /* 128653 */   GIM_Try, /*On fail goto*//*Label 1826*/ GIMT_Encode4(128786), // Rule ID 3745 //
     /* 128658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 128662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 128666 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 128670 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 128674 */     // MIs[1] Operand 1
     /* 128674 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 128679 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 128683 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 128687 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 128691 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 128695 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 128699 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 128703 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 128707 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 128711 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 128715 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 128719 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 128721 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } (and:{ *:[i32] } i32:{ *:[i32] }:$s1, (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$sa)), 0:{ *:[i32] }, SETEQ:{ *:[Other] }))  =>  (RLWNM:{ *:[i32] } (NOR:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s1), (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 32:{ *:[i32] }), 31:{ *:[i32] }, 31:{ *:[i32] })
     /* 128721 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 128724 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 128728 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128733 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 128737 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/32,
     /* 128740 */     GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for PPC::CARRY*/0,
     /* 128743 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 128745 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 128748 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /* 128752 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128757 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /* 128761 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /* 128765 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWNM),
     /* 128770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 128772 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128775 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 128778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 128781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 128784 */     GIR_RootConstrainSelectedInstOperands,
     /* 128785 */     // GIR_Coverage, 3745,
     /* 128785 */     GIR_EraseRootFromParent_Done,
     /* 128786 */   // Label 1826: @128786
     /* 128786 */   GIM_Try, /*On fail goto*//*Label 1827*/ GIMT_Encode4(128946), // Rule ID 3748 //
     /* 128791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 128795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 128799 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 128803 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 128807 */     // MIs[1] Operand 1
     /* 128807 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 128812 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 128816 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 128820 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 128824 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 128828 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 128832 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 128836 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 128840 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 128844 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 128848 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 128852 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 128854 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } (and:{ *:[i64] } i64:{ *:[i64] }:$s1, (shl:{ *:[i64] } 1:{ *:[i64] }, i32:{ *:[i32] }:$sa)), 0:{ *:[i64] }, SETEQ:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDCL:{ *:[i64] } (NOR8:{ *:[i64] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s1), (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 64:{ *:[i32] }), 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 128854 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 128857 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 128861 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128866 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 128870 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/64,
     /* 128873 */     GIR_SetImplicitDefDead, /*InsnID*/3, /*OpIdx for PPC::CARRY*/0,
     /* 128876 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 128878 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 128881 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /* 128885 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128890 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /* 128894 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /* 128898 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 128900 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 128903 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDCL),
     /* 128907 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128912 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 128915 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 128918 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /* 128921 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 128926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128928 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 128935 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 128940 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 128945 */     // GIR_Coverage, 3748,
     /* 128945 */     GIR_EraseRootFromParent_Done,
     /* 128946 */   // Label 1827: @128946
     /* 128946 */   GIM_Try, /*On fail goto*//*Label 1828*/ GIMT_Encode4(129015), // Rule ID 3657 //
     /* 128951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 128955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 128959 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 128963 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 128967 */     // MIs[1] Operand 1
     /* 128967 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 128972 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 128976 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128978 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETEQ:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } (CNTLZW:{ *:[i32] } ?:{ *:[i32] }:$s1), 27:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /* 128978 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 128981 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CNTLZW),
     /* 128985 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128990 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 128994 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 128999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 129001 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/27,
     /* 129007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 129010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 129013 */     GIR_RootConstrainSelectedInstOperands,
     /* 129014 */     // GIR_Coverage, 3657,
     /* 129014 */     GIR_EraseRootFromParent_Done,
     /* 129015 */   // Label 1828: @129015
     /* 129015 */   GIM_Try, /*On fail goto*//*Label 1829*/ GIMT_Encode4(129111), // Rule ID 3660 //
     /* 129020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 129024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 129028 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 129032 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 129036 */     // MIs[1] Operand 1
     /* 129036 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 129041 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 129045 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129047 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETEQ:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (CNTLZD:{ *:[i64] } ?:{ *:[i64] }:$s1), 58:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 129047 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 129050 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CNTLZD),
     /* 129054 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129059 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 129063 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 129065 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 129068 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 129072 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129077 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 129080 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/58,
     /* 129083 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /* 129086 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 129091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129093 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 129100 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 129105 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 129110 */     // GIR_Coverage, 3660,
     /* 129110 */     GIR_EraseRootFromParent_Done,
     /* 129111 */   // Label 1829: @129111
     /* 129111 */   GIM_Try, /*On fail goto*//*Label 1830*/ GIMT_Encode4(129218), // Rule ID 3665 //
     /* 129116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 129120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 129124 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 129128 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 129132 */     // MIs[1] Operand 1
     /* 129132 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 129137 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 129141 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129143 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETNE:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } (NOR:{ *:[i32] } (CNTLZW:{ *:[i32] } ?:{ *:[i32] }:$s1), (CNTLZW:{ *:[i32] } ?:{ *:[i32] }:$s1)), 27:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /* 129143 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 129146 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::CNTLZW),
     /* 129150 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129155 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 129159 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 129161 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 129164 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CNTLZW),
     /* 129168 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129173 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 129177 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 129179 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129182 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /* 129186 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129191 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 129194 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 129197 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 129202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 129204 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/27,
     /* 129210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 129213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 129216 */     GIR_RootConstrainSelectedInstOperands,
     /* 129217 */     // GIR_Coverage, 3665,
     /* 129217 */     GIR_EraseRootFromParent_Done,
     /* 129218 */   // Label 1830: @129218
     /* 129218 */   GIM_Try, /*On fail goto*//*Label 1831*/ GIMT_Encode4(129352), // Rule ID 3668 //
     /* 129223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 129227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 129231 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 129235 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 129239 */     // MIs[1] Operand 1
     /* 129239 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 129244 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 129248 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129250 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETNE:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (NOR8:{ *:[i64] } (CNTLZD:{ *:[i64] } ?:{ *:[i64] }:$s1), (CNTLZD:{ *:[i64] } ?:{ *:[i64] }:$s1)), 58:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 129250 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 129253 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::CNTLZD),
     /* 129257 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129262 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 129266 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 129268 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 129271 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::CNTLZD),
     /* 129275 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129280 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 129284 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 129286 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 129289 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /* 129293 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129298 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 129301 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 129304 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 129306 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 129309 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 129313 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129318 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 129321 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/58,
     /* 129324 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /* 129327 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 129332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129334 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 129341 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 129346 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 129351 */     // GIR_Coverage, 3668,
     /* 129351 */     GIR_EraseRootFromParent_Done,
     /* 129352 */   // Label 1831: @129352
     /* 129352 */   GIM_Try, /*On fail goto*//*Label 1832*/ GIMT_Encode4(129404), // Rule ID 3673 //
     /* 129357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 129361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 129365 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 129369 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 129373 */     // MIs[1] Operand 1
     /* 129373 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 129378 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 129382 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129384 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETLT:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$s1, 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /* 129384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 129387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 129389 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 129393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 129396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 129399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 129402 */     GIR_RootConstrainSelectedInstOperands,
     /* 129403 */     // GIR_Coverage, 3673,
     /* 129403 */     GIR_EraseRootFromParent_Done,
     /* 129404 */   // Label 1832: @129404
     /* 129404 */   GIM_Try, /*On fail goto*//*Label 1833*/ GIMT_Encode4(129483), // Rule ID 3676 //
     /* 129409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 129413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 129417 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 129421 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 129425 */     // MIs[1] Operand 1
     /* 129425 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 129430 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 129434 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129436 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETLT:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$s1, 1:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 129436 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 129439 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 129443 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129448 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 129452 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 129455 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /* 129458 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 129463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129465 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 129472 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 129477 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 129482 */     // GIR_Coverage, 3676,
     /* 129482 */     GIR_EraseRootFromParent_Done,
     /* 129483 */   // Label 1833: @129483
     /* 129483 */   GIM_Try, /*On fail goto*//*Label 1834*/ GIMT_Encode4(129556), // Rule ID 3681 //
     /* 129488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 129492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 129496 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 129500 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 129504 */     // MIs[1] Operand 1
     /* 129504 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 129509 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 129513 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129515 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETGE:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } (NOR:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s1), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /* 129515 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129518 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /* 129522 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129527 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 129531 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 129535 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 129540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 129542 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 129548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 129551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 129554 */     GIR_RootConstrainSelectedInstOperands,
     /* 129555 */     // GIR_Coverage, 3681,
     /* 129555 */     GIR_EraseRootFromParent_Done,
     /* 129556 */   // Label 1834: @129556
     /* 129556 */   GIM_Try, /*On fail goto*//*Label 1835*/ GIMT_Encode4(129656), // Rule ID 3684 //
     /* 129561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 129565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 129569 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 129573 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 129577 */     // MIs[1] Operand 1
     /* 129577 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 129582 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 129586 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129588 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETGE:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (NOR8:{ *:[i64] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s1), 1:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 129588 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 129591 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /* 129595 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129600 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 129604 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 129608 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 129610 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 129613 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 129617 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129622 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 129625 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 129628 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /* 129631 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 129636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129638 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 129645 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 129650 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 129655 */     // GIR_Coverage, 3684,
     /* 129655 */     GIR_EraseRootFromParent_Done,
     /* 129656 */   // Label 1835: @129656
     /* 129656 */   GIM_Try, /*On fail goto*//*Label 1836*/ GIMT_Encode4(129746), // Rule ID 3689 //
     /* 129661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 129665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 129669 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 129673 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 129677 */     // MIs[1] Operand 1
     /* 129677 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 129682 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 129686 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129688 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETGT:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } (ANDC:{ *:[i32] } (NEG:{ *:[i32] } ?:{ *:[i32] }:$s1), ?:{ *:[i32] }:$s1), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /* 129688 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 129691 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NEG),
     /* 129695 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129700 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 129704 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 129706 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129709 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::ANDC),
     /* 129713 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129718 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 129721 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 129725 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 129730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 129732 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 129738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 129741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 129744 */     GIR_RootConstrainSelectedInstOperands,
     /* 129745 */     // GIR_Coverage, 3689,
     /* 129745 */     GIR_EraseRootFromParent_Done,
     /* 129746 */   // Label 1836: @129746
     /* 129746 */   GIM_Try, /*On fail goto*//*Label 1837*/ GIMT_Encode4(129863), // Rule ID 3692 //
     /* 129751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 129755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 129759 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 129763 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 129767 */     // MIs[1] Operand 1
     /* 129767 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 129772 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 129776 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129778 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETGT:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (ANDC8:{ *:[i64] } (NEG8:{ *:[i64] } ?:{ *:[i64] }:$s1), ?:{ *:[i64] }:$s1), 1:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 129778 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 129781 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::NEG8),
     /* 129785 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129790 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 129794 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 129796 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 129799 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::ANDC8),
     /* 129803 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129808 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 129811 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 129815 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 129817 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 129820 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 129824 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129829 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 129832 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 129835 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /* 129838 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 129843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129845 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 129852 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 129857 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 129862 */     // GIR_Coverage, 3692,
     /* 129862 */     GIR_EraseRootFromParent_Done,
     /* 129863 */   // Label 1837: @129863
     /* 129863 */   GIM_Try, /*On fail goto*//*Label 1838*/ GIMT_Encode4(129953), // Rule ID 3697 //
     /* 129868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 129872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 129876 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 129880 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 129884 */     // MIs[1] Operand 1
     /* 129884 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 129889 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 129893 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129895 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETLE:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } (ORC:{ *:[i32] } ?:{ *:[i32] }:$s1, (NEG:{ *:[i32] } ?:{ *:[i32] }:$s1)), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /* 129895 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 129898 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NEG),
     /* 129902 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129907 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 129911 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 129913 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129916 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::ORC),
     /* 129920 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129925 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 129929 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 129932 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 129937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 129939 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 129945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 129948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 129951 */     GIR_RootConstrainSelectedInstOperands,
     /* 129952 */     // GIR_Coverage, 3697,
     /* 129952 */     GIR_EraseRootFromParent_Done,
     /* 129953 */   // Label 1838: @129953
     /* 129953 */   GIM_Try, /*On fail goto*//*Label 1839*/ GIMT_Encode4(130070), // Rule ID 3700 //
     /* 129958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 129962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 129966 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 129970 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 129974 */     // MIs[1] Operand 1
     /* 129974 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 129979 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 129983 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129985 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETLE:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (ORC8:{ *:[i64] } ?:{ *:[i64] }:$s1, (NEG8:{ *:[i64] } ?:{ *:[i64] }:$s1)), 1:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 129985 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 129988 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::NEG8),
     /* 129992 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129997 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 130001 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 130003 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 130006 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::ORC8),
     /* 130010 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130015 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 130019 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 130022 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 130024 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 130027 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 130031 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130036 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 130039 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 130042 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /* 130045 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 130050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130052 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 130059 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 130064 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 130069 */     // GIR_Coverage, 3700,
     /* 130069 */     GIR_EraseRootFromParent_Done,
     /* 130070 */   // Label 1839: @130070
     /* 130070 */   GIM_Try, /*On fail goto*//*Label 1840*/ GIMT_Encode4(130163), // Rule ID 3705 //
     /* 130075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 130079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 130083 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 130087 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 130091 */     // MIs[1] Operand 1
     /* 130091 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 130096 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 130100 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 130102 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, -1:{ *:[i32] }, SETLT:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } (AND:{ *:[i32] } ?:{ *:[i32] }:$s1, (ADDI:{ *:[i32] } ?:{ *:[i32] }:$s1, 1:{ *:[i32] })), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /* 130102 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 130105 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::ADDI),
     /* 130109 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130114 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 130118 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 130121 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 130123 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130126 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 130130 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130135 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 130139 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 130142 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 130147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 130149 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 130155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 130158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 130161 */     GIR_RootConstrainSelectedInstOperands,
     /* 130162 */     // GIR_Coverage, 3705,
     /* 130162 */     GIR_EraseRootFromParent_Done,
     /* 130163 */   // Label 1840: @130163
     /* 130163 */   GIM_Try, /*On fail goto*//*Label 1841*/ GIMT_Encode4(130283), // Rule ID 3708 //
     /* 130168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 130172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 130176 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 130180 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 130184 */     // MIs[1] Operand 1
     /* 130184 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 130189 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 130193 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 130195 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, -1:{ *:[i64] }, SETLT:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (AND8:{ *:[i64] } ?:{ *:[i64] }:$s1, (ADDI8:{ *:[i64] } ?:{ *:[i64] }:$s1, 1:{ *:[i64] })), 1:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 130195 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 130198 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::ADDI8),
     /* 130202 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130207 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 130211 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 130214 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 130216 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 130219 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 130223 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130228 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 130232 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 130235 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 130237 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 130240 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 130244 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130249 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 130252 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 130255 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /* 130258 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 130263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130265 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 130272 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 130277 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 130282 */     // GIR_Coverage, 3708,
     /* 130282 */     GIR_EraseRootFromParent_Done,
     /* 130283 */   // Label 1841: @130283
     /* 130283 */   GIM_Try, /*On fail goto*//*Label 1842*/ GIMT_Encode4(130376), // Rule ID 3713 //
     /* 130288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 130292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 130296 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 130300 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 130304 */     // MIs[1] Operand 1
     /* 130304 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 130309 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 130313 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 130315 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, -1:{ *:[i32] }, SETGE:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } (NAND:{ *:[i32] } ?:{ *:[i32] }:$s1, (ADDI:{ *:[i32] } ?:{ *:[i32] }:$s1, 1:{ *:[i32] })), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /* 130315 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 130318 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::ADDI),
     /* 130322 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130327 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 130331 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 130334 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 130336 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130339 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NAND),
     /* 130343 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130348 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 130352 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 130355 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 130360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 130362 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 130368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 130371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 130374 */     GIR_RootConstrainSelectedInstOperands,
     /* 130375 */     // GIR_Coverage, 3713,
     /* 130375 */     GIR_EraseRootFromParent_Done,
     /* 130376 */   // Label 1842: @130376
     /* 130376 */   GIM_Try, /*On fail goto*//*Label 1843*/ GIMT_Encode4(130496), // Rule ID 3716 //
     /* 130381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 130385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 130389 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 130393 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 130397 */     // MIs[1] Operand 1
     /* 130397 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 130402 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 130406 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 130408 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, -1:{ *:[i64] }, SETGE:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (NAND8:{ *:[i64] } ?:{ *:[i64] }:$s1, (ADDI8:{ *:[i64] } ?:{ *:[i64] }:$s1, 1:{ *:[i64] })), 1:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 130408 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 130411 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::ADDI8),
     /* 130415 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130420 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 130424 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 130427 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 130429 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 130432 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NAND8),
     /* 130436 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130441 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 130445 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 130448 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 130450 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 130453 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 130457 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130462 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 130465 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 130468 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /* 130471 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 130476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130478 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 130485 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 130490 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 130495 */     // GIR_Coverage, 3716,
     /* 130495 */     GIR_EraseRootFromParent_Done,
     /* 130496 */   // Label 1843: @130496
     /* 130496 */   GIM_Try, /*On fail goto*//*Label 1844*/ GIMT_Encode4(130569), // Rule ID 3721 //
     /* 130501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 130505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 130509 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 130513 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 130517 */     // MIs[1] Operand 1
     /* 130517 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 130522 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 130526 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 130528 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, -1:{ *:[i32] }, SETGT:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } (NOR:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s1), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /* 130528 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130531 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /* 130535 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130540 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 130544 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 130548 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 130553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 130555 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 130561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 130564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 130567 */     GIR_RootConstrainSelectedInstOperands,
     /* 130568 */     // GIR_Coverage, 3721,
     /* 130568 */     GIR_EraseRootFromParent_Done,
     /* 130569 */   // Label 1844: @130569
     /* 130569 */   GIM_Try, /*On fail goto*//*Label 1845*/ GIMT_Encode4(130669), // Rule ID 3724 //
     /* 130574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 130578 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 130582 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 130586 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 130590 */     // MIs[1] Operand 1
     /* 130590 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 130595 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 130599 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 130601 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, -1:{ *:[i64] }, SETGT:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (NOR8:{ *:[i64] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s1), 1:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 130601 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 130604 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /* 130608 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130613 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 130617 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 130621 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 130623 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 130626 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 130630 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130635 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 130638 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 130641 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /* 130644 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 130649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130651 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 130658 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 130663 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 130668 */     // GIR_Coverage, 3724,
     /* 130668 */     GIR_EraseRootFromParent_Done,
     /* 130669 */   // Label 1845: @130669
     /* 130669 */   GIM_Try, /*On fail goto*//*Label 1846*/ GIMT_Encode4(130721), // Rule ID 3729 //
     /* 130674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 130678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 130682 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 130686 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 130690 */     // MIs[1] Operand 1
     /* 130690 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 130695 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 130699 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 130701 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, -1:{ *:[i32] }, SETLE:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$s1, 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /* 130701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 130704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 130706 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 130710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 130713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 130716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 130719 */     GIR_RootConstrainSelectedInstOperands,
     /* 130720 */     // GIR_Coverage, 3729,
     /* 130720 */     GIR_EraseRootFromParent_Done,
     /* 130721 */   // Label 1846: @130721
     /* 130721 */   GIM_Try, /*On fail goto*//*Label 1847*/ GIMT_Encode4(130800), // Rule ID 3732 //
     /* 130726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 130730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 130734 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 130738 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 130742 */     // MIs[1] Operand 1
     /* 130742 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 130747 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 130751 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 130753 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, -1:{ *:[i64] }, SETLE:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$s1, 1:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 130753 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 130756 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 130760 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130765 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 130769 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 130772 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /* 130775 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 130780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130782 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 130789 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 130794 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 130799 */     // GIR_Coverage, 3732,
     /* 130799 */     GIR_EraseRootFromParent_Done,
     /* 130800 */   // Label 1847: @130800
     /* 130800 */   GIM_Try, /*On fail goto*//*Label 1848*/ GIMT_Encode4(130903), // Rule ID 3025 //
     /* 130805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 130808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 130812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 130816 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 130820 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 130824 */     // MIs[1] Operand 1
     /* 130824 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 130829 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 130833 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 130837 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 130841 */     // MIs[2] Operand 1
     /* 130841 */     // No operand predicates
     /* 130841 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 130843 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_lt:{ *:[i32] }))
     /* 130843 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 130846 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 130850 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130855 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 130859 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 130862 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 130864 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 130867 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 130871 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130876 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 130883 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 130888 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 130893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 130896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 130898 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130901 */     GIR_RootConstrainSelectedInstOperands,
     /* 130902 */     // GIR_Coverage, 3025,
     /* 130902 */     GIR_EraseRootFromParent_Done,
     /* 130903 */   // Label 1848: @130903
     /* 130903 */   GIM_Try, /*On fail goto*//*Label 1849*/ GIMT_Encode4(131006), // Rule ID 3041 //
     /* 130908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 130911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 130915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 130919 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 130923 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 130927 */     // MIs[1] Operand 1
     /* 130927 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 130932 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 130936 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 130940 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 130944 */     // MIs[2] Operand 1
     /* 130944 */     // No operand predicates
     /* 130944 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 130946 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_gt:{ *:[i32] }))
     /* 130946 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 130949 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 130953 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130958 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 130962 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 130965 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 130967 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 130970 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 130974 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130979 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 130986 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 130991 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 130996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 130999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 131001 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131004 */     GIR_RootConstrainSelectedInstOperands,
     /* 131005 */     // GIR_Coverage, 3041,
     /* 131005 */     GIR_EraseRootFromParent_Done,
     /* 131006 */   // Label 1849: @131006
     /* 131006 */   GIM_Try, /*On fail goto*//*Label 1850*/ GIMT_Encode4(131109), // Rule ID 3049 //
     /* 131011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 131014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 131018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 131022 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 131026 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 131030 */     // MIs[1] Operand 1
     /* 131030 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 131035 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 131039 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 131043 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 131047 */     // MIs[2] Operand 1
     /* 131047 */     // No operand predicates
     /* 131047 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 131049 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_eq:{ *:[i32] }))
     /* 131049 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 131052 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 131056 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131061 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 131065 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 131068 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 131070 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 131073 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 131077 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131082 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 131089 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 131094 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 131099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 131102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 131104 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131107 */     GIR_RootConstrainSelectedInstOperands,
     /* 131108 */     // GIR_Coverage, 3049,
     /* 131108 */     GIR_EraseRootFromParent_Done,
     /* 131109 */   // Label 1850: @131109
     /* 131109 */   GIM_Try, /*On fail goto*//*Label 1851*/ GIMT_Encode4(131212), // Rule ID 3121 //
     /* 131114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 131117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 131121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 131125 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 131129 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 131133 */     // MIs[1] Operand 1
     /* 131133 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 131138 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 131142 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 131146 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 131150 */     // MIs[2] Operand 1
     /* 131150 */     // No operand predicates
     /* 131150 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 131152 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_lt:{ *:[i32] }))
     /* 131152 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 131155 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 131159 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131164 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 131168 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 131171 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 131173 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 131176 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 131180 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131185 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 131192 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 131197 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 131202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 131205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 131207 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131210 */     GIR_RootConstrainSelectedInstOperands,
     /* 131211 */     // GIR_Coverage, 3121,
     /* 131211 */     GIR_EraseRootFromParent_Done,
     /* 131212 */   // Label 1851: @131212
     /* 131212 */   GIM_Try, /*On fail goto*//*Label 1852*/ GIMT_Encode4(131315), // Rule ID 3137 //
     /* 131217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 131220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 131224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 131228 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 131232 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 131236 */     // MIs[1] Operand 1
     /* 131236 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 131241 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 131245 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 131249 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 131253 */     // MIs[2] Operand 1
     /* 131253 */     // No operand predicates
     /* 131253 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 131255 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_gt:{ *:[i32] }))
     /* 131255 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 131258 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 131262 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131267 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 131271 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 131274 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 131276 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 131279 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 131283 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131288 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 131295 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 131300 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 131305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 131308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 131310 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131313 */     GIR_RootConstrainSelectedInstOperands,
     /* 131314 */     // GIR_Coverage, 3137,
     /* 131314 */     GIR_EraseRootFromParent_Done,
     /* 131315 */   // Label 1852: @131315
     /* 131315 */   GIM_Try, /*On fail goto*//*Label 1853*/ GIMT_Encode4(131418), // Rule ID 3145 //
     /* 131320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 131323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 131327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 131331 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 131335 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 131339 */     // MIs[1] Operand 1
     /* 131339 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 131344 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 131348 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 131352 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 131356 */     // MIs[2] Operand 1
     /* 131356 */     // No operand predicates
     /* 131356 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 131358 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_eq:{ *:[i32] }))
     /* 131358 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 131361 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 131365 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131370 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 131374 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 131377 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 131379 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 131382 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 131386 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131391 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 131398 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 131403 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 131408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 131411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 131413 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131416 */     GIR_RootConstrainSelectedInstOperands,
     /* 131417 */     // GIR_Coverage, 3145,
     /* 131417 */     GIR_EraseRootFromParent_Done,
     /* 131418 */   // Label 1853: @131418
     /* 131418 */   GIM_Try, /*On fail goto*//*Label 1854*/ GIMT_Encode4(131561), // Rule ID 3779 //
     /* 131423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 131426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 131430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 131434 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 131438 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 131442 */     // MIs[1] Operand 1
     /* 131442 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 131447 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 131451 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 131455 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 131459 */     // MIs[2] Operand 1
     /* 131459 */     // No operand predicates
     /* 131459 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 131461 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 131461 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 131464 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 131468 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131473 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 131477 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 131480 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 131482 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 131485 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 131489 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131494 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 131497 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 131499 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 131502 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 131506 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131511 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 131514 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 131516 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 131519 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 131523 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131528 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 131535 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 131540 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 131545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 131548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131550 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131553 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 131556 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 131559 */     GIR_RootConstrainSelectedInstOperands,
     /* 131560 */     // GIR_Coverage, 3779,
     /* 131560 */     GIR_EraseRootFromParent_Done,
     /* 131561 */   // Label 1854: @131561
     /* 131561 */   GIM_Try, /*On fail goto*//*Label 1855*/ GIMT_Encode4(131704), // Rule ID 3795 //
     /* 131566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 131569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 131573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 131577 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 131581 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 131585 */     // MIs[1] Operand 1
     /* 131585 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 131590 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 131594 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 131598 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 131602 */     // MIs[2] Operand 1
     /* 131602 */     // No operand predicates
     /* 131602 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 131604 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 131604 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 131607 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 131611 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131616 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 131620 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 131623 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 131625 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 131628 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 131632 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131637 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 131640 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 131642 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 131645 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 131649 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131654 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 131657 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 131659 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 131662 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 131666 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131671 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 131678 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 131683 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 131688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 131691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131693 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131696 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 131699 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 131702 */     GIR_RootConstrainSelectedInstOperands,
     /* 131703 */     // GIR_Coverage, 3795,
     /* 131703 */     GIR_EraseRootFromParent_Done,
     /* 131704 */   // Label 1855: @131704
     /* 131704 */   GIM_Try, /*On fail goto*//*Label 1856*/ GIMT_Encode4(131847), // Rule ID 3803 //
     /* 131709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 131712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 131716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 131720 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 131724 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 131728 */     // MIs[1] Operand 1
     /* 131728 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 131733 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 131737 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 131741 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 131745 */     // MIs[2] Operand 1
     /* 131745 */     // No operand predicates
     /* 131745 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 131747 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 131747 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 131750 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 131754 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131759 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 131763 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 131766 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 131768 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 131771 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 131775 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131780 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 131783 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 131785 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 131788 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 131792 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131797 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 131800 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 131802 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 131805 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 131809 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131814 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 131821 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 131826 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 131831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 131834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131836 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131839 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 131842 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 131845 */     GIR_RootConstrainSelectedInstOperands,
     /* 131846 */     // GIR_Coverage, 3803,
     /* 131846 */     GIR_EraseRootFromParent_Done,
     /* 131847 */   // Label 1856: @131847
     /* 131847 */   GIM_Try, /*On fail goto*//*Label 1857*/ GIMT_Encode4(131990), // Rule ID 3875 //
     /* 131852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 131855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 131859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 131863 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 131867 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 131871 */     // MIs[1] Operand 1
     /* 131871 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 131876 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 131880 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 131884 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 131888 */     // MIs[2] Operand 1
     /* 131888 */     // No operand predicates
     /* 131888 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 131890 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 131890 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 131893 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 131897 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131902 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 131906 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 131909 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 131911 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 131914 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 131918 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131923 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 131926 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 131928 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 131931 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 131935 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131940 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 131943 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 131945 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 131948 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 131952 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131957 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 131964 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 131969 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 131974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 131977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131979 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131982 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 131985 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 131988 */     GIR_RootConstrainSelectedInstOperands,
     /* 131989 */     // GIR_Coverage, 3875,
     /* 131989 */     GIR_EraseRootFromParent_Done,
     /* 131990 */   // Label 1857: @131990
     /* 131990 */   GIM_Try, /*On fail goto*//*Label 1858*/ GIMT_Encode4(132133), // Rule ID 3891 //
     /* 131995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 131998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 132002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 132006 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132010 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 132014 */     // MIs[1] Operand 1
     /* 132014 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 132019 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 132023 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 132027 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 132031 */     // MIs[2] Operand 1
     /* 132031 */     // No operand predicates
     /* 132031 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 132033 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 132033 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 132036 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 132040 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132045 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 132049 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 132052 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 132054 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 132057 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 132061 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132066 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 132069 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 132071 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 132074 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 132078 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132083 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 132086 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 132088 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 132091 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132095 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132100 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 132107 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 132112 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 132117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 132120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 132122 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132125 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 132128 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 132131 */     GIR_RootConstrainSelectedInstOperands,
     /* 132132 */     // GIR_Coverage, 3891,
     /* 132132 */     GIR_EraseRootFromParent_Done,
     /* 132133 */   // Label 1858: @132133
     /* 132133 */   GIM_Try, /*On fail goto*//*Label 1859*/ GIMT_Encode4(132276), // Rule ID 3899 //
     /* 132138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 132141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 132145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 132149 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132153 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 132157 */     // MIs[1] Operand 1
     /* 132157 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 132162 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 132166 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 132170 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 132174 */     // MIs[2] Operand 1
     /* 132174 */     // No operand predicates
     /* 132174 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 132176 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 132176 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 132179 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 132183 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132188 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 132192 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 132195 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 132197 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 132200 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 132204 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132209 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 132212 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 132214 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 132217 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 132221 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132226 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 132229 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 132231 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 132234 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132238 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132243 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 132250 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 132255 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 132260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 132263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 132265 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132268 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 132271 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 132274 */     GIR_RootConstrainSelectedInstOperands,
     /* 132275 */     // GIR_Coverage, 3899,
     /* 132275 */     GIR_EraseRootFromParent_Done,
     /* 132276 */   // Label 1859: @132276
     /* 132276 */   GIM_Try, /*On fail goto*//*Label 1860*/ GIMT_Encode4(132368), // Rule ID 3169 //
     /* 132281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 132284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 132288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 132292 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 132296 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 132300 */     // MIs[1] Operand 1
     /* 132300 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 132305 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132307 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_lt:{ *:[i32] }))
     /* 132307 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 132310 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 132314 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132319 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 132323 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 132327 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 132329 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 132332 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132336 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132341 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 132348 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 132353 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 132358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 132361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 132363 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132366 */     GIR_RootConstrainSelectedInstOperands,
     /* 132367 */     // GIR_Coverage, 3169,
     /* 132367 */     GIR_EraseRootFromParent_Done,
     /* 132368 */   // Label 1860: @132368
     /* 132368 */   GIM_Try, /*On fail goto*//*Label 1861*/ GIMT_Encode4(132460), // Rule ID 3185 //
     /* 132373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 132376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 132380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 132384 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 132388 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 132392 */     // MIs[1] Operand 1
     /* 132392 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 132397 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132399 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }))
     /* 132399 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 132402 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 132406 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132411 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 132415 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 132419 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 132421 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 132424 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132428 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132433 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 132440 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 132445 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 132450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 132453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 132455 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132458 */     GIR_RootConstrainSelectedInstOperands,
     /* 132459 */     // GIR_Coverage, 3185,
     /* 132459 */     GIR_EraseRootFromParent_Done,
     /* 132460 */   // Label 1861: @132460
     /* 132460 */   GIM_Try, /*On fail goto*//*Label 1862*/ GIMT_Encode4(132552), // Rule ID 3201 //
     /* 132465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 132468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 132472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 132476 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 132480 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 132484 */     // MIs[1] Operand 1
     /* 132484 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 132489 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132491 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_eq:{ *:[i32] }))
     /* 132491 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 132494 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 132498 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132503 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 132507 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 132511 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 132513 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 132516 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132520 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132525 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 132532 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 132537 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 132542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 132545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 132547 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132550 */     GIR_RootConstrainSelectedInstOperands,
     /* 132551 */     // GIR_Coverage, 3201,
     /* 132551 */     GIR_EraseRootFromParent_Done,
     /* 132552 */   // Label 1862: @132552
     /* 132552 */   GIM_Try, /*On fail goto*//*Label 1863*/ GIMT_Encode4(132644), // Rule ID 3217 //
     /* 132557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 132560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 132564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 132568 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 132572 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 132576 */     // MIs[1] Operand 1
     /* 132576 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 132581 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132583 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETO:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_un:{ *:[i32] }))
     /* 132583 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 132586 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 132590 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132595 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 132599 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 132603 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 132605 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 132608 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132612 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132617 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 132624 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 132629 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 132634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 132637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 132639 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132642 */     GIR_RootConstrainSelectedInstOperands,
     /* 132643 */     // GIR_Coverage, 3217,
     /* 132643 */     GIR_EraseRootFromParent_Done,
     /* 132644 */   // Label 1863: @132644
     /* 132644 */   GIM_Try, /*On fail goto*//*Label 1864*/ GIMT_Encode4(132736), // Rule ID 3225 //
     /* 132649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 132652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 132656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 132660 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132664 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 132668 */     // MIs[1] Operand 1
     /* 132668 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 132673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132675 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_lt:{ *:[i32] }))
     /* 132675 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 132678 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 132682 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132687 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 132691 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 132695 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 132697 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 132700 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132704 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132709 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 132716 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 132721 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 132726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 132729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 132731 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132734 */     GIR_RootConstrainSelectedInstOperands,
     /* 132735 */     // GIR_Coverage, 3225,
     /* 132735 */     GIR_EraseRootFromParent_Done,
     /* 132736 */   // Label 1864: @132736
     /* 132736 */   GIM_Try, /*On fail goto*//*Label 1865*/ GIMT_Encode4(132828), // Rule ID 3241 //
     /* 132741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 132744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 132748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 132752 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132756 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 132760 */     // MIs[1] Operand 1
     /* 132760 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 132765 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132767 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }))
     /* 132767 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 132770 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 132774 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132779 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 132783 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 132787 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 132789 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 132792 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132796 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132801 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 132808 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 132813 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 132818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 132821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 132823 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132826 */     GIR_RootConstrainSelectedInstOperands,
     /* 132827 */     // GIR_Coverage, 3241,
     /* 132827 */     GIR_EraseRootFromParent_Done,
     /* 132828 */   // Label 1865: @132828
     /* 132828 */   GIM_Try, /*On fail goto*//*Label 1866*/ GIMT_Encode4(132920), // Rule ID 3257 //
     /* 132833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 132836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 132840 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 132844 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132848 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 132852 */     // MIs[1] Operand 1
     /* 132852 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 132857 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132859 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_eq:{ *:[i32] }))
     /* 132859 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 132862 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 132866 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132871 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 132875 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 132879 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 132881 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 132884 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132888 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132893 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 132900 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 132905 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 132910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 132913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 132915 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132918 */     GIR_RootConstrainSelectedInstOperands,
     /* 132919 */     // GIR_Coverage, 3257,
     /* 132919 */     GIR_EraseRootFromParent_Done,
     /* 132920 */   // Label 1866: @132920
     /* 132920 */   GIM_Try, /*On fail goto*//*Label 1867*/ GIMT_Encode4(133012), // Rule ID 3273 //
     /* 132925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 132928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 132932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 132936 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132940 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 132944 */     // MIs[1] Operand 1
     /* 132944 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 132949 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132951 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETO:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_un:{ *:[i32] }))
     /* 132951 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 132954 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 132958 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132963 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 132967 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 132971 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 132973 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 132976 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132980 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132985 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 132992 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 132997 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 133002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 133005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 133007 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133010 */     GIR_RootConstrainSelectedInstOperands,
     /* 133011 */     // GIR_Coverage, 3273,
     /* 133011 */     GIR_EraseRootFromParent_Done,
     /* 133012 */   // Label 1867: @133012
     /* 133012 */   GIM_Try, /*On fail goto*//*Label 1868*/ GIMT_Encode4(133104), // Rule ID 3281 //
     /* 133017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 133020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 133024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 133028 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 133032 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 133036 */     // MIs[1] Operand 1
     /* 133036 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 133041 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133043 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_lt:{ *:[i32] }))
     /* 133043 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 133046 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 133050 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133055 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 133059 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 133063 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 133065 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 133068 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133072 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133077 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 133084 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 133089 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 133094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 133097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 133099 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133102 */     GIR_RootConstrainSelectedInstOperands,
     /* 133103 */     // GIR_Coverage, 3281,
     /* 133103 */     GIR_EraseRootFromParent_Done,
     /* 133104 */   // Label 1868: @133104
     /* 133104 */   GIM_Try, /*On fail goto*//*Label 1869*/ GIMT_Encode4(133196), // Rule ID 3297 //
     /* 133109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 133112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 133116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 133120 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 133124 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 133128 */     // MIs[1] Operand 1
     /* 133128 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 133133 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133135 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_gt:{ *:[i32] }))
     /* 133135 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 133138 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 133142 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133147 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 133151 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 133155 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 133157 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 133160 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133164 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133169 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 133176 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 133181 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 133186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 133189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 133191 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133194 */     GIR_RootConstrainSelectedInstOperands,
     /* 133195 */     // GIR_Coverage, 3297,
     /* 133195 */     GIR_EraseRootFromParent_Done,
     /* 133196 */   // Label 1869: @133196
     /* 133196 */   GIM_Try, /*On fail goto*//*Label 1870*/ GIMT_Encode4(133288), // Rule ID 3313 //
     /* 133201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 133204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 133208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 133212 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 133216 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 133220 */     // MIs[1] Operand 1
     /* 133220 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 133225 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133227 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUNE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_eq:{ *:[i32] }))
     /* 133227 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 133230 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 133234 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133239 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 133243 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 133247 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 133249 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 133252 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133256 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133261 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 133268 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 133273 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 133278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 133281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 133283 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133286 */     GIR_RootConstrainSelectedInstOperands,
     /* 133287 */     // GIR_Coverage, 3313,
     /* 133287 */     GIR_EraseRootFromParent_Done,
     /* 133288 */   // Label 1870: @133288
     /* 133288 */   GIM_Try, /*On fail goto*//*Label 1871*/ GIMT_Encode4(133380), // Rule ID 3329 //
     /* 133293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 133296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 133300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 133304 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 133308 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 133312 */     // MIs[1] Operand 1
     /* 133312 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 133317 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133319 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETO:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_un:{ *:[i32] }))
     /* 133319 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 133322 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 133326 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133331 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 133335 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 133339 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 133341 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 133344 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133348 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133353 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 133360 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 133365 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 133370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 133373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 133375 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133378 */     GIR_RootConstrainSelectedInstOperands,
     /* 133379 */     // GIR_Coverage, 3329,
     /* 133379 */     GIR_EraseRootFromParent_Done,
     /* 133380 */   // Label 1871: @133380
     /* 133380 */   GIM_Try, /*On fail goto*//*Label 1872*/ GIMT_Encode4(133512), // Rule ID 3980 //
     /* 133385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 133388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 133392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 133396 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 133400 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 133404 */     // MIs[1] Operand 1
     /* 133404 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 133409 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133411 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 133411 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 133414 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 133418 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133423 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 133427 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 133431 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 133433 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 133436 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 133440 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133445 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 133448 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 133450 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 133453 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 133457 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133462 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 133465 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 133467 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 133470 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133474 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133479 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 133486 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 133491 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 133496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 133499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 133501 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133504 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 133507 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 133510 */     GIR_RootConstrainSelectedInstOperands,
     /* 133511 */     // GIR_Coverage, 3980,
     /* 133511 */     GIR_EraseRootFromParent_Done,
     /* 133512 */   // Label 1872: @133512
     /* 133512 */   GIM_Try, /*On fail goto*//*Label 1873*/ GIMT_Encode4(133644), // Rule ID 4012 //
     /* 133517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 133520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 133524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 133528 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 133532 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 133536 */     // MIs[1] Operand 1
     /* 133536 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 133541 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133543 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 133543 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 133546 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 133550 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133555 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 133559 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 133563 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 133565 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 133568 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 133572 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133577 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 133580 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 133582 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 133585 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 133589 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133594 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 133597 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 133599 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 133602 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133606 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133611 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 133618 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 133623 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 133628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 133631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 133633 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133636 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 133639 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 133642 */     GIR_RootConstrainSelectedInstOperands,
     /* 133643 */     // GIR_Coverage, 4012,
     /* 133643 */     GIR_EraseRootFromParent_Done,
     /* 133644 */   // Label 1873: @133644
     /* 133644 */   GIM_Try, /*On fail goto*//*Label 1874*/ GIMT_Encode4(133776), // Rule ID 4044 //
     /* 133649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 133652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 133656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 133660 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 133664 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 133668 */     // MIs[1] Operand 1
     /* 133668 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 133673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133675 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 133675 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 133678 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 133682 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133687 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 133691 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 133695 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 133697 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 133700 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 133704 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133709 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 133712 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 133714 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 133717 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 133721 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133726 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 133729 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 133731 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 133734 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133738 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133743 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 133750 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 133755 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 133760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 133763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 133765 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133768 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 133771 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 133774 */     GIR_RootConstrainSelectedInstOperands,
     /* 133775 */     // GIR_Coverage, 4044,
     /* 133775 */     GIR_EraseRootFromParent_Done,
     /* 133776 */   // Label 1874: @133776
     /* 133776 */   GIM_Try, /*On fail goto*//*Label 1875*/ GIMT_Encode4(133908), // Rule ID 4076 //
     /* 133781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 133784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 133788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 133792 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 133796 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 133800 */     // MIs[1] Operand 1
     /* 133800 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 133805 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133807 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETO:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_un:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 133807 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 133810 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 133814 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133819 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 133823 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 133827 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 133829 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 133832 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 133836 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133841 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 133844 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 133846 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 133849 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 133853 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133858 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 133861 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 133863 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 133866 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133870 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133875 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 133882 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 133887 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 133892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 133895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 133897 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133900 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 133903 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 133906 */     GIR_RootConstrainSelectedInstOperands,
     /* 133907 */     // GIR_Coverage, 4076,
     /* 133907 */     GIR_EraseRootFromParent_Done,
     /* 133908 */   // Label 1875: @133908
     /* 133908 */   GIM_Try, /*On fail goto*//*Label 1876*/ GIMT_Encode4(134040), // Rule ID 4092 //
     /* 133913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 133916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 133920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 133924 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 133928 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 133932 */     // MIs[1] Operand 1
     /* 133932 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 133937 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133939 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 133939 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 133942 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 133946 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133951 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 133955 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 133959 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 133961 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 133964 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 133968 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133973 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 133976 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 133978 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 133981 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 133985 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133990 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 133993 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 133995 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 133998 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134002 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134007 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 134014 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 134019 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 134024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 134027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 134029 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 134032 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 134035 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 134038 */     GIR_RootConstrainSelectedInstOperands,
     /* 134039 */     // GIR_Coverage, 4092,
     /* 134039 */     GIR_EraseRootFromParent_Done,
     /* 134040 */   // Label 1876: @134040
     /* 134040 */   GIM_Try, /*On fail goto*//*Label 1877*/ GIMT_Encode4(134172), // Rule ID 4124 //
     /* 134045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 134048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 134052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 134056 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 134060 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 134064 */     // MIs[1] Operand 1
     /* 134064 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 134069 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 134071 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 134071 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 134074 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 134078 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134083 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 134087 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 134091 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 134093 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 134096 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 134100 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134105 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 134108 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 134110 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 134113 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 134117 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134122 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 134125 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 134127 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 134130 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134134 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134139 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 134146 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 134151 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 134156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 134159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 134161 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 134164 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 134167 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 134170 */     GIR_RootConstrainSelectedInstOperands,
     /* 134171 */     // GIR_Coverage, 4124,
     /* 134171 */     GIR_EraseRootFromParent_Done,
     /* 134172 */   // Label 1877: @134172
     /* 134172 */   GIM_Try, /*On fail goto*//*Label 1878*/ GIMT_Encode4(134304), // Rule ID 4156 //
     /* 134177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 134180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 134184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 134188 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 134192 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 134196 */     // MIs[1] Operand 1
     /* 134196 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 134201 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 134203 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 134203 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 134206 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 134210 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134215 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 134219 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 134223 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 134225 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 134228 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 134232 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134237 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 134240 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 134242 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 134245 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 134249 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134254 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 134257 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 134259 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 134262 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134266 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134271 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 134278 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 134283 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 134288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 134291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 134293 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 134296 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 134299 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 134302 */     GIR_RootConstrainSelectedInstOperands,
     /* 134303 */     // GIR_Coverage, 4156,
     /* 134303 */     GIR_EraseRootFromParent_Done,
     /* 134304 */   // Label 1878: @134304
     /* 134304 */   GIM_Try, /*On fail goto*//*Label 1879*/ GIMT_Encode4(134436), // Rule ID 4188 //
     /* 134309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 134312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 134316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 134320 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 134324 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 134328 */     // MIs[1] Operand 1
     /* 134328 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 134333 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 134335 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETO:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_un:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 134335 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 134338 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 134342 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134347 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 134351 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 134355 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 134357 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 134360 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 134364 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134369 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 134372 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 134374 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 134377 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 134381 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134386 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 134389 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 134391 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 134394 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134398 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134403 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 134410 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 134415 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 134420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 134423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 134425 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 134428 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 134431 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 134434 */     GIR_RootConstrainSelectedInstOperands,
     /* 134435 */     // GIR_Coverage, 4188,
     /* 134435 */     GIR_EraseRootFromParent_Done,
     /* 134436 */   // Label 1879: @134436
     /* 134436 */   GIM_Try, /*On fail goto*//*Label 1880*/ GIMT_Encode4(134568), // Rule ID 4218 //
     /* 134441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 134444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 134448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 134452 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 134456 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 134460 */     // MIs[1] Operand 1
     /* 134460 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 134465 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 134467 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 134467 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 134470 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 134474 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134479 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 134483 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 134487 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 134489 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 134492 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 134496 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134501 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 134504 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 134506 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 134509 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 134513 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134518 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 134521 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 134523 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 134526 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134530 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134535 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 134542 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 134547 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 134552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 134555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 134557 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 134560 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 134563 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 134566 */     GIR_RootConstrainSelectedInstOperands,
     /* 134567 */     // GIR_Coverage, 4218,
     /* 134567 */     GIR_EraseRootFromParent_Done,
     /* 134568 */   // Label 1880: @134568
     /* 134568 */   GIM_Try, /*On fail goto*//*Label 1881*/ GIMT_Encode4(134700), // Rule ID 4250 //
     /* 134573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 134576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 134580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 134584 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 134588 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 134592 */     // MIs[1] Operand 1
     /* 134592 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 134597 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 134599 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 134599 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 134602 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 134606 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134611 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 134615 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 134619 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 134621 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 134624 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 134628 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134633 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 134636 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 134638 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 134641 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 134645 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134650 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 134653 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 134655 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 134658 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134662 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134667 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 134674 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 134679 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 134684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 134687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 134689 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 134692 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 134695 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 134698 */     GIR_RootConstrainSelectedInstOperands,
     /* 134699 */     // GIR_Coverage, 4250,
     /* 134699 */     GIR_EraseRootFromParent_Done,
     /* 134700 */   // Label 1881: @134700
     /* 134700 */   GIM_Try, /*On fail goto*//*Label 1882*/ GIMT_Encode4(134832), // Rule ID 4282 //
     /* 134705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 134708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 134712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 134716 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 134720 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 134724 */     // MIs[1] Operand 1
     /* 134724 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 134729 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 134731 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 134731 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 134734 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 134738 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134743 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 134747 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 134751 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 134753 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 134756 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 134760 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134765 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 134768 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 134770 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 134773 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 134777 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134782 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 134785 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 134787 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 134790 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134794 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134799 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 134806 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 134811 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 134816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 134819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 134821 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 134824 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 134827 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 134830 */     GIR_RootConstrainSelectedInstOperands,
     /* 134831 */     // GIR_Coverage, 4282,
     /* 134831 */     GIR_EraseRootFromParent_Done,
     /* 134832 */   // Label 1882: @134832
     /* 134832 */   GIM_Try, /*On fail goto*//*Label 1883*/ GIMT_Encode4(134964), // Rule ID 4314 //
     /* 134837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 134840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 134844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 134848 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 134852 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 134856 */     // MIs[1] Operand 1
     /* 134856 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 134861 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 134863 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETO:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_un:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 134863 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 134866 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 134870 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134875 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 134879 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 134883 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 134885 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 134888 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 134892 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134897 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 134900 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 134902 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 134905 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 134909 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134914 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 134917 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 134919 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 134922 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134926 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134931 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 134938 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 134943 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 134948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 134951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 134953 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 134956 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 134959 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 134962 */     GIR_RootConstrainSelectedInstOperands,
     /* 134963 */     // GIR_Coverage, 4314,
     /* 134963 */     GIR_EraseRootFromParent_Done,
     /* 134964 */   // Label 1883: @134964
     /* 134964 */   GIM_Try, /*On fail goto*//*Label 1884*/ GIMT_Encode4(135096), // Rule ID 4545 //
     /* 134969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 134972 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 134976 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 134980 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 134984 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 134988 */     // MIs[1] Operand 1
     /* 134988 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 134993 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 134995 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPLT:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 134995 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 134998 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPLT),
     /* 135002 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135007 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 135011 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 135015 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 135017 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 135020 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 135024 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135029 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 135032 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 135034 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 135037 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 135041 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135046 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 135049 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 135051 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 135054 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135058 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135063 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 135070 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 135075 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 135080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 135083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 135085 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 135088 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 135091 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 135094 */     GIR_RootConstrainSelectedInstOperands,
     /* 135095 */     // GIR_Coverage, 4545,
     /* 135095 */     GIR_EraseRootFromParent_Done,
     /* 135096 */   // Label 1884: @135096
     /* 135096 */   GIM_Try, /*On fail goto*//*Label 1885*/ GIMT_Encode4(135228), // Rule ID 4577 //
     /* 135101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 135104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 135108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 135112 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 135116 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 135120 */     // MIs[1] Operand 1
     /* 135120 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 135125 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135127 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPGT:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 135127 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 135130 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPGT),
     /* 135134 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135139 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 135143 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 135147 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 135149 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 135152 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 135156 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135161 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 135164 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 135166 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 135169 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 135173 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135178 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 135181 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 135183 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 135186 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135190 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135195 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 135202 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 135207 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 135212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 135215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 135217 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 135220 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 135223 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 135226 */     GIR_RootConstrainSelectedInstOperands,
     /* 135227 */     // GIR_Coverage, 4577,
     /* 135227 */     GIR_EraseRootFromParent_Done,
     /* 135228 */   // Label 1885: @135228
     /* 135228 */   GIM_Try, /*On fail goto*//*Label 1886*/ GIMT_Encode4(135360), // Rule ID 4609 //
     /* 135233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 135236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 135240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 135244 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 135248 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 135252 */     // MIs[1] Operand 1
     /* 135252 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 135257 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135259 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPEQ:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 135259 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 135262 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPEQ),
     /* 135266 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135271 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 135275 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 135279 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 135281 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 135284 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 135288 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135293 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 135296 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 135298 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 135301 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 135305 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135310 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 135313 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 135315 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 135318 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135322 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135327 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 135334 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 135339 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 135344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 135347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 135349 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 135352 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 135355 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 135358 */     GIR_RootConstrainSelectedInstOperands,
     /* 135359 */     // GIR_Coverage, 4609,
     /* 135359 */     GIR_EraseRootFromParent_Done,
     /* 135360 */   // Label 1886: @135360
     /* 135360 */   GIM_Try, /*On fail goto*//*Label 1887*/ GIMT_Encode4(135492), // Rule ID 4653 //
     /* 135365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 135368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 135372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 135376 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 135380 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 135384 */     // MIs[1] Operand 1
     /* 135384 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 135389 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135391 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPLT:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 135391 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 135394 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPLT),
     /* 135398 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135403 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 135407 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 135411 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 135413 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 135416 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 135420 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135425 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 135428 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 135430 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 135433 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 135437 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135442 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 135445 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 135447 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 135450 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135454 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135459 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 135466 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 135471 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 135476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 135479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 135481 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 135484 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 135487 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 135490 */     GIR_RootConstrainSelectedInstOperands,
     /* 135491 */     // GIR_Coverage, 4653,
     /* 135491 */     GIR_EraseRootFromParent_Done,
     /* 135492 */   // Label 1887: @135492
     /* 135492 */   GIM_Try, /*On fail goto*//*Label 1888*/ GIMT_Encode4(135624), // Rule ID 4685 //
     /* 135497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 135500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 135504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 135508 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 135512 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 135516 */     // MIs[1] Operand 1
     /* 135516 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 135521 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135523 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPGT:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 135523 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 135526 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPGT),
     /* 135530 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135535 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 135539 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 135543 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 135545 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 135548 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 135552 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135557 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 135560 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 135562 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 135565 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 135569 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135574 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 135577 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 135579 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 135582 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135586 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135591 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 135598 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 135603 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 135608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 135611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 135613 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 135616 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 135619 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 135622 */     GIR_RootConstrainSelectedInstOperands,
     /* 135623 */     // GIR_Coverage, 4685,
     /* 135623 */     GIR_EraseRootFromParent_Done,
     /* 135624 */   // Label 1888: @135624
     /* 135624 */   GIM_Try, /*On fail goto*//*Label 1889*/ GIMT_Encode4(135756), // Rule ID 4717 //
     /* 135629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 135632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 135636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 135640 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 135644 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 135648 */     // MIs[1] Operand 1
     /* 135648 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 135653 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135655 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPEQ:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 135655 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 135658 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPEQ),
     /* 135662 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135667 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 135671 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 135675 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 135677 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 135680 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 135684 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135689 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 135692 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 135694 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 135697 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 135701 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135706 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 135709 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 135711 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 135714 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135718 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135723 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 135730 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 135735 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 135740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 135743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 135745 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 135748 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 135751 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 135754 */     GIR_RootConstrainSelectedInstOperands,
     /* 135755 */     // GIR_Coverage, 4717,
     /* 135755 */     GIR_EraseRootFromParent_Done,
     /* 135756 */   // Label 1889: @135756
     /* 135756 */   GIM_Try, /*On fail goto*//*Label 1890*/ GIMT_Encode4(135848), // Rule ID 2971 //
     /* 135761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 135764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 135768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 135772 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 135776 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 135780 */     // MIs[1] Operand 1
     /* 135780 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 135785 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135787 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }))
     /* 135787 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 135790 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 135794 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135799 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 135803 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 135807 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 135809 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 135812 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135816 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135821 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 135828 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 135833 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 135838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 135841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 135843 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 135846 */     GIR_RootConstrainSelectedInstOperands,
     /* 135847 */     // GIR_Coverage, 2971,
     /* 135847 */     GIR_EraseRootFromParent_Done,
     /* 135848 */   // Label 1890: @135848
     /* 135848 */   GIM_Try, /*On fail goto*//*Label 1891*/ GIMT_Encode4(135940), // Rule ID 2985 //
     /* 135853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 135856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 135860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 135864 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 135868 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 135872 */     // MIs[1] Operand 1
     /* 135872 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 135877 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135879 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETGE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }))
     /* 135879 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 135882 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 135886 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135891 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 135895 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 135899 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 135901 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 135904 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135908 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135913 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 135920 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 135925 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 135930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 135933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 135935 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 135938 */     GIR_RootConstrainSelectedInstOperands,
     /* 135939 */     // GIR_Coverage, 2985,
     /* 135939 */     GIR_EraseRootFromParent_Done,
     /* 135940 */   // Label 1891: @135940
     /* 135940 */   GIM_Try, /*On fail goto*//*Label 1892*/ GIMT_Encode4(136032), // Rule ID 2993 //
     /* 135945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 135948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 135952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 135956 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 135960 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 135964 */     // MIs[1] Operand 1
     /* 135964 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 135969 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135971 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }))
     /* 135971 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 135974 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 135978 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135983 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 135987 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 135991 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 135993 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 135996 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136000 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136005 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 136012 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 136017 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 136022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 136025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 136027 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 136030 */     GIR_RootConstrainSelectedInstOperands,
     /* 136031 */     // GIR_Coverage, 2993,
     /* 136031 */     GIR_EraseRootFromParent_Done,
     /* 136032 */   // Label 1892: @136032
     /* 136032 */   GIM_Try, /*On fail goto*//*Label 1893*/ GIMT_Encode4(136124), // Rule ID 3001 //
     /* 136037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 136040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 136044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 136048 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 136052 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 136056 */     // MIs[1] Operand 1
     /* 136056 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 136061 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136063 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETLE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }))
     /* 136063 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 136066 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 136070 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136075 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 136079 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 136083 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 136085 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 136088 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136092 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136097 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 136104 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 136109 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 136114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 136117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 136119 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 136122 */     GIR_RootConstrainSelectedInstOperands,
     /* 136123 */     // GIR_Coverage, 3001,
     /* 136123 */     GIR_EraseRootFromParent_Done,
     /* 136124 */   // Label 1893: @136124
     /* 136124 */   GIM_Try, /*On fail goto*//*Label 1894*/ GIMT_Encode4(136216), // Rule ID 3009 //
     /* 136129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 136132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 136136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 136140 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 136144 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 136148 */     // MIs[1] Operand 1
     /* 136148 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 136153 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136155 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETNE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_eq:{ *:[i32] }))
     /* 136155 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 136158 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 136162 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136167 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 136171 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 136175 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 136177 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 136180 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136184 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136189 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 136196 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 136201 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 136206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 136209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 136211 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 136214 */     GIR_RootConstrainSelectedInstOperands,
     /* 136215 */     // GIR_Coverage, 3009,
     /* 136215 */     GIR_EraseRootFromParent_Done,
     /* 136216 */   // Label 1894: @136216
     /* 136216 */   GIM_Try, /*On fail goto*//*Label 1895*/ GIMT_Encode4(136308), // Rule ID 3073 //
     /* 136221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 136224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 136228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 136232 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 136236 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 136240 */     // MIs[1] Operand 1
     /* 136240 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 136245 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136247 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }))
     /* 136247 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 136250 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 136254 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136259 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 136263 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 136267 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 136269 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 136272 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136276 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136281 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 136288 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 136293 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 136298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 136301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 136303 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 136306 */     GIR_RootConstrainSelectedInstOperands,
     /* 136307 */     // GIR_Coverage, 3073,
     /* 136307 */     GIR_EraseRootFromParent_Done,
     /* 136308 */   // Label 1895: @136308
     /* 136308 */   GIM_Try, /*On fail goto*//*Label 1896*/ GIMT_Encode4(136400), // Rule ID 3081 //
     /* 136313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 136316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 136320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 136324 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 136328 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 136332 */     // MIs[1] Operand 1
     /* 136332 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 136337 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136339 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETGE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }))
     /* 136339 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 136342 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 136346 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136351 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 136355 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 136359 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 136361 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 136364 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136368 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136373 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 136380 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 136385 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 136390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 136393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 136395 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 136398 */     GIR_RootConstrainSelectedInstOperands,
     /* 136399 */     // GIR_Coverage, 3081,
     /* 136399 */     GIR_EraseRootFromParent_Done,
     /* 136400 */   // Label 1896: @136400
     /* 136400 */   GIM_Try, /*On fail goto*//*Label 1897*/ GIMT_Encode4(136492), // Rule ID 3089 //
     /* 136405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 136408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 136412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 136416 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 136420 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 136424 */     // MIs[1] Operand 1
     /* 136424 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 136429 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136431 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }))
     /* 136431 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 136434 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 136438 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136443 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 136447 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 136451 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 136453 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 136456 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136460 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136465 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 136472 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 136477 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 136482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 136485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 136487 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 136490 */     GIR_RootConstrainSelectedInstOperands,
     /* 136491 */     // GIR_Coverage, 3089,
     /* 136491 */     GIR_EraseRootFromParent_Done,
     /* 136492 */   // Label 1897: @136492
     /* 136492 */   GIM_Try, /*On fail goto*//*Label 1898*/ GIMT_Encode4(136584), // Rule ID 3097 //
     /* 136497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 136500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 136504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 136508 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 136512 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 136516 */     // MIs[1] Operand 1
     /* 136516 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 136521 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136523 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETLE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }))
     /* 136523 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 136526 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 136530 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136535 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 136539 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 136543 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 136545 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 136548 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136552 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136557 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 136564 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 136569 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 136574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 136577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 136579 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 136582 */     GIR_RootConstrainSelectedInstOperands,
     /* 136583 */     // GIR_Coverage, 3097,
     /* 136583 */     GIR_EraseRootFromParent_Done,
     /* 136584 */   // Label 1898: @136584
     /* 136584 */   GIM_Try, /*On fail goto*//*Label 1899*/ GIMT_Encode4(136676), // Rule ID 3105 //
     /* 136589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 136592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 136596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 136600 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 136604 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 136608 */     // MIs[1] Operand 1
     /* 136608 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 136613 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136615 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETNE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_eq:{ *:[i32] }))
     /* 136615 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 136618 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 136622 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136627 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 136631 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 136635 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 136637 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 136640 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136644 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136649 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 136656 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 136661 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 136666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 136669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 136671 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 136674 */     GIR_RootConstrainSelectedInstOperands,
     /* 136675 */     // GIR_Coverage, 3105,
     /* 136675 */     GIR_EraseRootFromParent_Done,
     /* 136676 */   // Label 1899: @136676
     /* 136676 */   GIM_Try, /*On fail goto*//*Label 1900*/ GIMT_Encode4(136808), // Rule ID 3827 //
     /* 136681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 136684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 136688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 136692 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 136696 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 136700 */     // MIs[1] Operand 1
     /* 136700 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 136705 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136707 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 136707 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 136710 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 136714 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136719 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 136723 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 136727 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 136729 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 136732 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 136736 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136741 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 136744 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 136746 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 136749 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 136753 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136758 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 136761 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 136763 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 136766 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136770 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136775 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 136782 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 136787 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 136792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 136795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136797 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 136800 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 136803 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 136806 */     GIR_RootConstrainSelectedInstOperands,
     /* 136807 */     // GIR_Coverage, 3827,
     /* 136807 */     GIR_EraseRootFromParent_Done,
     /* 136808 */   // Label 1900: @136808
     /* 136808 */   GIM_Try, /*On fail goto*//*Label 1901*/ GIMT_Encode4(136940), // Rule ID 3835 //
     /* 136813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 136816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 136820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 136824 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 136828 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 136832 */     // MIs[1] Operand 1
     /* 136832 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 136837 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136839 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 136839 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 136842 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 136846 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136851 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 136855 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 136859 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 136861 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 136864 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 136868 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136873 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 136876 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 136878 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 136881 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 136885 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136890 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 136893 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 136895 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 136898 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136902 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136907 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 136914 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 136919 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 136924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 136927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136929 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 136932 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 136935 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 136938 */     GIR_RootConstrainSelectedInstOperands,
     /* 136939 */     // GIR_Coverage, 3835,
     /* 136939 */     GIR_EraseRootFromParent_Done,
     /* 136940 */   // Label 1901: @136940
     /* 136940 */   GIM_Try, /*On fail goto*//*Label 1902*/ GIMT_Encode4(137072), // Rule ID 3843 //
     /* 136945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 136948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 136952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 136956 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 136960 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 136964 */     // MIs[1] Operand 1
     /* 136964 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 136969 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136971 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 136971 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 136974 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 136978 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136983 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 136987 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 136991 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 136993 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 136996 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 137000 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137005 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 137008 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 137010 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 137013 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 137017 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137022 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 137025 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 137027 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 137030 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137034 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137039 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 137046 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 137051 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 137056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 137059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137061 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 137064 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 137067 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 137070 */     GIR_RootConstrainSelectedInstOperands,
     /* 137071 */     // GIR_Coverage, 3843,
     /* 137071 */     GIR_EraseRootFromParent_Done,
     /* 137072 */   // Label 1902: @137072
     /* 137072 */   GIM_Try, /*On fail goto*//*Label 1903*/ GIMT_Encode4(137204), // Rule ID 3851 //
     /* 137077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 137080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 137084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 137088 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 137092 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 137096 */     // MIs[1] Operand 1
     /* 137096 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 137101 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 137103 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETLE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 137103 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 137106 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 137110 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137115 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 137119 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 137123 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 137125 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 137128 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 137132 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137137 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 137140 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 137142 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 137145 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 137149 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137154 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 137157 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 137159 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 137162 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137166 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137171 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 137178 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 137183 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 137188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 137191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137193 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 137196 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 137199 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 137202 */     GIR_RootConstrainSelectedInstOperands,
     /* 137203 */     // GIR_Coverage, 3851,
     /* 137203 */     GIR_EraseRootFromParent_Done,
     /* 137204 */   // Label 1903: @137204
     /* 137204 */   GIM_Try, /*On fail goto*//*Label 1904*/ GIMT_Encode4(137336), // Rule ID 3859 //
     /* 137209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 137212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 137216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 137220 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 137224 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 137228 */     // MIs[1] Operand 1
     /* 137228 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 137233 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 137235 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 137235 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 137238 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 137242 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137247 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 137251 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 137255 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 137257 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 137260 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 137264 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137269 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 137272 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 137274 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 137277 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 137281 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137286 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 137289 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 137291 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 137294 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137298 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137303 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 137310 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 137315 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 137320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 137323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137325 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 137328 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 137331 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 137334 */     GIR_RootConstrainSelectedInstOperands,
     /* 137335 */     // GIR_Coverage, 3859,
     /* 137335 */     GIR_EraseRootFromParent_Done,
     /* 137336 */   // Label 1904: @137336
     /* 137336 */   GIM_Try, /*On fail goto*//*Label 1905*/ GIMT_Encode4(137468), // Rule ID 3923 //
     /* 137341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 137344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 137348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 137352 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 137356 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 137360 */     // MIs[1] Operand 1
     /* 137360 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 137365 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 137367 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 137367 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 137370 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 137374 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137379 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 137383 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 137387 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 137389 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 137392 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 137396 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137401 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 137404 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 137406 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 137409 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 137413 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137418 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 137421 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 137423 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 137426 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137430 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137435 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 137442 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 137447 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 137452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 137455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137457 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 137460 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 137463 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 137466 */     GIR_RootConstrainSelectedInstOperands,
     /* 137467 */     // GIR_Coverage, 3923,
     /* 137467 */     GIR_EraseRootFromParent_Done,
     /* 137468 */   // Label 1905: @137468
     /* 137468 */   GIM_Try, /*On fail goto*//*Label 1906*/ GIMT_Encode4(137600), // Rule ID 3931 //
     /* 137473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 137476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 137480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 137484 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 137488 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 137492 */     // MIs[1] Operand 1
     /* 137492 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 137497 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 137499 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 137499 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 137502 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 137506 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137511 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 137515 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 137519 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 137521 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 137524 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 137528 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137533 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 137536 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 137538 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 137541 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 137545 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137550 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 137553 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 137555 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 137558 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137562 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137567 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 137574 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 137579 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 137584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 137587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137589 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 137592 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 137595 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 137598 */     GIR_RootConstrainSelectedInstOperands,
     /* 137599 */     // GIR_Coverage, 3931,
     /* 137599 */     GIR_EraseRootFromParent_Done,
     /* 137600 */   // Label 1906: @137600
     /* 137600 */   GIM_Try, /*On fail goto*//*Label 1907*/ GIMT_Encode4(137732), // Rule ID 3939 //
     /* 137605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 137608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 137612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 137616 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 137620 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 137624 */     // MIs[1] Operand 1
     /* 137624 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 137629 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 137631 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 137631 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 137634 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 137638 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137643 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 137647 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 137651 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 137653 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 137656 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 137660 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137665 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 137668 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 137670 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 137673 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 137677 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137682 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 137685 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 137687 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 137690 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137694 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137699 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 137706 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 137711 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 137716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 137719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137721 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 137724 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 137727 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 137730 */     GIR_RootConstrainSelectedInstOperands,
     /* 137731 */     // GIR_Coverage, 3939,
     /* 137731 */     GIR_EraseRootFromParent_Done,
     /* 137732 */   // Label 1907: @137732
     /* 137732 */   GIM_Try, /*On fail goto*//*Label 1908*/ GIMT_Encode4(137864), // Rule ID 3947 //
     /* 137737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 137740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 137744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 137748 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 137752 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 137756 */     // MIs[1] Operand 1
     /* 137756 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 137761 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 137763 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETLE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 137763 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 137766 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 137770 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137775 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 137779 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 137783 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 137785 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 137788 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 137792 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137797 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 137800 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 137802 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 137805 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 137809 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137814 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 137817 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 137819 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 137822 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137826 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137831 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 137838 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 137843 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 137848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 137851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137853 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 137856 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 137859 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 137862 */     GIR_RootConstrainSelectedInstOperands,
     /* 137863 */     // GIR_Coverage, 3947,
     /* 137863 */     GIR_EraseRootFromParent_Done,
     /* 137864 */   // Label 1908: @137864
     /* 137864 */   GIM_Try, /*On fail goto*//*Label 1909*/ GIMT_Encode4(137996), // Rule ID 3955 //
     /* 137869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 137872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 137876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 137880 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 137884 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 137888 */     // MIs[1] Operand 1
     /* 137888 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 137893 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 137895 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 137895 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 137898 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 137902 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137907 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 137911 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 137915 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 137917 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 137920 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 137924 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137929 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 137932 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 137934 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 137937 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 137941 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137946 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 137949 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 137951 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 137954 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137958 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137963 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 137970 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 137975 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 137980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 137983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137985 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 137988 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 137991 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 137994 */     GIR_RootConstrainSelectedInstOperands,
     /* 137995 */     // GIR_Coverage, 3955,
     /* 137995 */     GIR_EraseRootFromParent_Done,
     /* 137996 */   // Label 1909: @137996
     /* 137996 */   GIM_Try, /*On fail goto*//*Label 1910*/ GIMT_Encode4(138011), // Rule ID 2977 //
     /* 138001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 138004 */     // (zext:{ *:[i32] } i1:{ *:[i1] }:$in)  =>  (SETBC:{ *:[i32] } ?:{ *:[i1] }:$in)
     /* 138004 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SETBC),
     /* 138009 */     GIR_RootConstrainSelectedInstOperands,
     /* 138010 */     // GIR_Coverage, 2977,
     /* 138010 */     GIR_Done,
     /* 138011 */   // Label 1910: @138011
     /* 138011 */   GIM_Try, /*On fail goto*//*Label 1911*/ GIMT_Encode4(138065), // Rule ID 3633 //
     /* 138016 */     // (zext:{ *:[i32] } i1:{ *:[i1] }:$in)  =>  (SELECT_I4:{ *:[i32] } ?:{ *:[i1] }:$in, (LI:{ *:[i32] } 1:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }))
     /* 138016 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 138019 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 138023 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138028 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 138031 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 138033 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 138036 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 138040 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138045 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 138048 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 138050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 138053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 138055 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /* 138057 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 138060 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 138063 */     GIR_RootConstrainSelectedInstOperands,
     /* 138064 */     // GIR_Coverage, 3633,
     /* 138064 */     GIR_EraseRootFromParent_Done,
     /* 138065 */   // Label 1911: @138065
     /* 138065 */   GIM_Reject,
     /* 138066 */ // Label 1819: @138066
     /* 138066 */ GIM_Reject,
     /* 138067 */ // Label 1817: @138067
     /* 138067 */ GIM_Try, /*On fail goto*//*Label 1912*/ GIMT_Encode4(138183), // Rule ID 5253 //
     /* 138072 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 138075 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 138079 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 138083 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 138087 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 138091 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 138095 */   // MIs[1] Operand 1
     /* 138095 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 138100 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 138104 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 138108 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 138112 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 138116 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 138120 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 138124 */   GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 138128 */   GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 138132 */   GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 138136 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 138140 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 138142 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } (and:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, i32:{ *:[i32] }:$sa), i64:{ *:[i64] }:$s1), 0:{ *:[i64] }, SETNE:{ *:[Other] }))  =>  (RLDCL:{ *:[i64] } ?:{ *:[i64] }:$s1, (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 64:{ *:[i32] }), 63:{ *:[i32] })
     /* 138142 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 138145 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 138149 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138154 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 138158 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/64,
     /* 138161 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for PPC::CARRY*/0,
     /* 138164 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 138166 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDCL),
     /* 138169 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 138171 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /* 138175 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 138178 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 138181 */   GIR_RootConstrainSelectedInstOperands,
     /* 138182 */   // GIR_Coverage, 5253,
     /* 138182 */   GIR_EraseRootFromParent_Done,
     /* 138183 */ // Label 1912: @138183
     /* 138183 */ GIM_Try, /*On fail goto*//*Label 1913*/ GIMT_Encode4(138353), // Rule ID 5254 //
     /* 138188 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 138191 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 138195 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 138199 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 138203 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 138207 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 138211 */   // MIs[1] Operand 1
     /* 138211 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 138216 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 138220 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 138224 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 138228 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 138232 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 138236 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 138240 */   GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 138244 */   GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 138248 */   GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 138252 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 138256 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 138258 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } (and:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$sa), i32:{ *:[i32] }:$s1), 0:{ *:[i32] }, SETNE:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWNM:{ *:[i32] } ?:{ *:[i32] }:$s1, (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 32:{ *:[i32] }), 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 138258 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 138261 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 138265 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138270 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 138274 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/32,
     /* 138277 */   GIR_SetImplicitDefDead, /*InsnID*/3, /*OpIdx for PPC::CARRY*/0,
     /* 138280 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 138282 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 138285 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWNM),
     /* 138289 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138294 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /* 138298 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 138301 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 138304 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 138307 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 138309 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 138312 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 138316 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138321 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 138323 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 138326 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 138328 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 138331 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 138334 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 138337 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 138342 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 138347 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 138352 */   // GIR_Coverage, 5254,
     /* 138352 */   GIR_EraseRootFromParent_Done,
     /* 138353 */ // Label 1913: @138353
     /* 138353 */ GIM_Try, /*On fail goto*//*Label 1914*/ GIMT_Encode4(138490), // Rule ID 5261 //
     /* 138358 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 138361 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 138365 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 138369 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 138373 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 138377 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 138381 */   // MIs[1] Operand 1
     /* 138381 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 138386 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 138390 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 138394 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 138398 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 138402 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 138406 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 138410 */   GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 138414 */   GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 138418 */   GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 138422 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 138426 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 138428 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } (and:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, i32:{ *:[i32] }:$sa), i64:{ *:[i64] }:$s1), 0:{ *:[i64] }, SETEQ:{ *:[Other] }))  =>  (RLDCL:{ *:[i64] } (NOR8:{ *:[i64] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s1), (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 64:{ *:[i32] }), 63:{ *:[i32] })
     /* 138428 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 138431 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 138435 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138440 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 138444 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/64,
     /* 138447 */   GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for PPC::CARRY*/0,
     /* 138450 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 138452 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 138455 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /* 138459 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138464 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /* 138468 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /* 138472 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 138474 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDCL),
     /* 138477 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 138479 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 138482 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 138485 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 138488 */   GIR_RootConstrainSelectedInstOperands,
     /* 138489 */   // GIR_Coverage, 5261,
     /* 138489 */   GIR_EraseRootFromParent_Done,
     /* 138490 */ // Label 1914: @138490
     /* 138490 */ GIM_Try, /*On fail goto*//*Label 1915*/ GIMT_Encode4(138681), // Rule ID 5262 //
     /* 138495 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 138498 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 138502 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 138506 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 138510 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 138514 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 138518 */   // MIs[1] Operand 1
     /* 138518 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 138523 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 138527 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 138531 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 138535 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 138539 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 138543 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 138547 */   GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 138551 */   GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 138555 */   GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 138559 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 138563 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 138565 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } (and:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$sa), i32:{ *:[i32] }:$s1), 0:{ *:[i32] }, SETEQ:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWNM:{ *:[i32] } (NOR:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s1), (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 32:{ *:[i32] }), 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 138565 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 138568 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 138572 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138577 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 138581 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/32,
     /* 138584 */   GIR_SetImplicitDefDead, /*InsnID*/4, /*OpIdx for PPC::CARRY*/0,
     /* 138587 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 138589 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 138592 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /* 138596 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138601 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /* 138605 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /* 138609 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 138611 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 138614 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWNM),
     /* 138618 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138623 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 138626 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 138629 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 138632 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 138635 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 138637 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 138640 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 138644 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138649 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 138651 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 138654 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 138656 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 138659 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 138662 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 138665 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 138670 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 138675 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 138680 */   // GIR_Coverage, 5262,
     /* 138680 */   GIR_EraseRootFromParent_Done,
     /* 138681 */ // Label 1915: @138681
     /* 138681 */ GIM_Try, /*On fail goto*//*Label 1916*/ GIMT_Encode4(138797), // Rule ID 3738 //
     /* 138686 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 138689 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 138693 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 138697 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 138701 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 138705 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 138709 */   // MIs[1] Operand 1
     /* 138709 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 138714 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 138718 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 138722 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 138726 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 138730 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 138734 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 138738 */   GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 138742 */   GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 138746 */   GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 138750 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 138754 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 138756 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } (and:{ *:[i64] } i64:{ *:[i64] }:$s1, (shl:{ *:[i64] } 1:{ *:[i64] }, i32:{ *:[i32] }:$sa)), 0:{ *:[i64] }, SETNE:{ *:[Other] }))  =>  (RLDCL:{ *:[i64] } ?:{ *:[i64] }:$s1, (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 64:{ *:[i32] }), 63:{ *:[i32] })
     /* 138756 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 138759 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 138763 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138768 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 138772 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/64,
     /* 138775 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for PPC::CARRY*/0,
     /* 138778 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 138780 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDCL),
     /* 138783 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 138785 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /* 138789 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 138792 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 138795 */   GIR_RootConstrainSelectedInstOperands,
     /* 138796 */   // GIR_Coverage, 3738,
     /* 138796 */   GIR_EraseRootFromParent_Done,
     /* 138797 */ // Label 1916: @138797
     /* 138797 */ GIM_Try, /*On fail goto*//*Label 1917*/ GIMT_Encode4(138967), // Rule ID 3739 //
     /* 138802 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 138805 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 138809 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 138813 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 138817 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 138821 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 138825 */   // MIs[1] Operand 1
     /* 138825 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 138830 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 138834 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 138838 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 138842 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 138846 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 138850 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 138854 */   GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 138858 */   GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 138862 */   GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 138866 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 138870 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 138872 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } (and:{ *:[i32] } i32:{ *:[i32] }:$s1, (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$sa)), 0:{ *:[i32] }, SETNE:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWNM:{ *:[i32] } ?:{ *:[i32] }:$s1, (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 32:{ *:[i32] }), 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 138872 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 138875 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 138879 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138884 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 138888 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/32,
     /* 138891 */   GIR_SetImplicitDefDead, /*InsnID*/3, /*OpIdx for PPC::CARRY*/0,
     /* 138894 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 138896 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 138899 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWNM),
     /* 138903 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138908 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /* 138912 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 138915 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 138918 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 138921 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 138923 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 138926 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 138930 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138935 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 138937 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 138940 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 138942 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 138945 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 138948 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 138951 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 138956 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 138961 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 138966 */   // GIR_Coverage, 3739,
     /* 138966 */   GIR_EraseRootFromParent_Done,
     /* 138967 */ // Label 1917: @138967
     /* 138967 */ GIM_Try, /*On fail goto*//*Label 1918*/ GIMT_Encode4(139104), // Rule ID 3746 //
     /* 138972 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 138975 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 138979 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 138983 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 138987 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 138991 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 138995 */   // MIs[1] Operand 1
     /* 138995 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 139000 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 139004 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 139008 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 139012 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 139016 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 139020 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 139024 */   GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 139028 */   GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 139032 */   GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 139036 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 139040 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 139042 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } (and:{ *:[i64] } i64:{ *:[i64] }:$s1, (shl:{ *:[i64] } 1:{ *:[i64] }, i32:{ *:[i32] }:$sa)), 0:{ *:[i64] }, SETEQ:{ *:[Other] }))  =>  (RLDCL:{ *:[i64] } (NOR8:{ *:[i64] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s1), (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 64:{ *:[i32] }), 63:{ *:[i32] })
     /* 139042 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 139045 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 139049 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139054 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 139058 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/64,
     /* 139061 */   GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for PPC::CARRY*/0,
     /* 139064 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 139066 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 139069 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /* 139073 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139078 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /* 139082 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /* 139086 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 139088 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDCL),
     /* 139091 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 139093 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 139096 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 139099 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 139102 */   GIR_RootConstrainSelectedInstOperands,
     /* 139103 */   // GIR_Coverage, 3746,
     /* 139103 */   GIR_EraseRootFromParent_Done,
     /* 139104 */ // Label 1918: @139104
     /* 139104 */ GIM_Try, /*On fail goto*//*Label 1919*/ GIMT_Encode4(139295), // Rule ID 3747 //
     /* 139109 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 139112 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 139116 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 139120 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 139124 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 139128 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 139132 */   // MIs[1] Operand 1
     /* 139132 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 139137 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 139141 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 139145 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 139149 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 139153 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 139157 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 139161 */   GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 139165 */   GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 139169 */   GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 139173 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 139177 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 139179 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } (and:{ *:[i32] } i32:{ *:[i32] }:$s1, (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$sa)), 0:{ *:[i32] }, SETEQ:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWNM:{ *:[i32] } (NOR:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s1), (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 32:{ *:[i32] }), 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 139179 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 139182 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 139186 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139191 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 139195 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/32,
     /* 139198 */   GIR_SetImplicitDefDead, /*InsnID*/4, /*OpIdx for PPC::CARRY*/0,
     /* 139201 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 139203 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 139206 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /* 139210 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139215 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /* 139219 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /* 139223 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 139225 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 139228 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWNM),
     /* 139232 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139237 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 139240 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 139243 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 139246 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 139249 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 139251 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 139254 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 139258 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139263 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 139265 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 139268 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139270 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 139273 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 139276 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 139279 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 139284 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 139289 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 139294 */   // GIR_Coverage, 3747,
     /* 139294 */   GIR_EraseRootFromParent_Done,
     /* 139295 */ // Label 1919: @139295
     /* 139295 */ GIM_Try, /*On fail goto*//*Label 1920*/ GIMT_Encode4(139378), // Rule ID 3346 //
     /* 139300 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 139303 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 139306 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 139310 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 139314 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 139318 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 139322 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 139326 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 139330 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 139334 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 139338 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /* 139342 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 139344 */   // (zext:{ *:[i64] } (srl:{ *:[i32] } (bswap:{ *:[i32] } i32:{ *:[i32] }:$RS), 16:{ *:[i32] }))  =>  (RLDICL_32_64:{ *:[i64] } (BRH:{ *:[i32] } ?:{ *:[i32] }:$RS), 0:{ *:[i32] }, 48:{ *:[i32] })
     /* 139344 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 139347 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::BRH),
     /* 139351 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139356 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // RS
     /* 139360 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 139362 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL_32_64),
     /* 139365 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 139367 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 139370 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139373 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/48,
     /* 139376 */   GIR_RootConstrainSelectedInstOperands,
     /* 139377 */   // GIR_Coverage, 3346,
     /* 139377 */   GIR_EraseRootFromParent_Done,
     /* 139378 */ // Label 1920: @139378
     /* 139378 */ GIM_Try, /*On fail goto*//*Label 1921*/ GIMT_Encode4(139451), // Rule ID 3658 //
     /* 139383 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 139386 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 139390 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 139394 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 139398 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 139402 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 139406 */   // MIs[1] Operand 1
     /* 139406 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 139411 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 139415 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139417 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETEQ:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } (CNTLZD:{ *:[i64] } ?:{ *:[i64] }:$s1), 58:{ *:[i32] }, 63:{ *:[i32] })
     /* 139417 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 139420 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CNTLZD),
     /* 139424 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139429 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 139433 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 139435 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 139438 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 139440 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 139443 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/58,
     /* 139446 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 139449 */   GIR_RootConstrainSelectedInstOperands,
     /* 139450 */   // GIR_Coverage, 3658,
     /* 139450 */   GIR_EraseRootFromParent_Done,
     /* 139451 */ // Label 1921: @139451
     /* 139451 */ GIM_Try, /*On fail goto*//*Label 1922*/ GIMT_Encode4(139578), // Rule ID 3659 //
     /* 139456 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 139459 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 139463 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 139467 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 139471 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 139475 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 139479 */   // MIs[1] Operand 1
     /* 139479 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 139484 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 139488 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139490 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETEQ:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } (CNTLZW:{ *:[i32] } ?:{ *:[i32] }:$s1), 27:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 139490 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 139493 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::CNTLZW),
     /* 139497 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139502 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 139506 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 139508 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 139511 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 139515 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139520 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 139523 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/27,
     /* 139526 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 139529 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 139532 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 139534 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 139537 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 139541 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139546 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 139548 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 139551 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139553 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 139556 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 139559 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 139562 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 139567 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 139572 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 139577 */   // GIR_Coverage, 3659,
     /* 139577 */   GIR_EraseRootFromParent_Done,
     /* 139578 */ // Label 1922: @139578
     /* 139578 */ GIM_Try, /*On fail goto*//*Label 1923*/ GIMT_Encode4(139689), // Rule ID 3666 //
     /* 139583 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 139586 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 139590 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 139594 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 139598 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 139602 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 139606 */   // MIs[1] Operand 1
     /* 139606 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 139611 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 139615 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139617 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETNE:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } (NOR8:{ *:[i64] } (CNTLZD:{ *:[i64] } ?:{ *:[i64] }:$s1), (CNTLZD:{ *:[i64] } ?:{ *:[i64] }:$s1)), 58:{ *:[i32] }, 63:{ *:[i32] })
     /* 139617 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 139620 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::CNTLZD),
     /* 139624 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139629 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 139633 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 139635 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 139638 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CNTLZD),
     /* 139642 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139647 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 139651 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 139653 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 139656 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /* 139660 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139665 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 139668 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 139671 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 139673 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 139676 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 139678 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 139681 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/58,
     /* 139684 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 139687 */   GIR_RootConstrainSelectedInstOperands,
     /* 139688 */   // GIR_Coverage, 3666,
     /* 139688 */   GIR_EraseRootFromParent_Done,
     /* 139689 */ // Label 1923: @139689
     /* 139689 */ GIM_Try, /*On fail goto*//*Label 1924*/ GIMT_Encode4(139854), // Rule ID 3667 //
     /* 139694 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 139697 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 139701 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 139705 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 139709 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 139713 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 139717 */   // MIs[1] Operand 1
     /* 139717 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 139722 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 139726 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139728 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETNE:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } (NOR:{ *:[i32] } (CNTLZW:{ *:[i32] } ?:{ *:[i32] }:$s1), (CNTLZW:{ *:[i32] } ?:{ *:[i32] }:$s1)), 27:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 139728 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 139731 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(PPC::CNTLZW),
     /* 139735 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139740 */   GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 139744 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 139746 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 139749 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::CNTLZW),
     /* 139753 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139758 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 139762 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 139764 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 139767 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /* 139771 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139776 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 139779 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 139782 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 139784 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 139787 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 139791 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139796 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 139799 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/27,
     /* 139802 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 139805 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 139808 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 139810 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 139813 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 139817 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139822 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 139824 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 139827 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139829 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 139832 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 139835 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 139838 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 139843 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 139848 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 139853 */   // GIR_Coverage, 3667,
     /* 139853 */   GIR_EraseRootFromParent_Done,
     /* 139854 */ // Label 1924: @139854
     /* 139854 */ GIM_Try, /*On fail goto*//*Label 1925*/ GIMT_Encode4(139910), // Rule ID 3674 //
     /* 139859 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 139862 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 139866 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 139870 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 139874 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 139878 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 139882 */   // MIs[1] Operand 1
     /* 139882 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 139887 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 139891 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139893 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETLT:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$s1, 1:{ *:[i32] }, 63:{ *:[i32] })
     /* 139893 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 139896 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 139898 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 139902 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 139905 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 139908 */   GIR_RootConstrainSelectedInstOperands,
     /* 139909 */   // GIR_Coverage, 3674,
     /* 139909 */   GIR_EraseRootFromParent_Done,
     /* 139910 */ // Label 1925: @139910
     /* 139910 */ GIM_Try, /*On fail goto*//*Label 1926*/ GIMT_Encode4(140020), // Rule ID 3675 //
     /* 139915 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 139918 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 139922 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 139926 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 139930 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 139934 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 139938 */   // MIs[1] Operand 1
     /* 139938 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 139943 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 139947 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139949 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETLT:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$s1, 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 139949 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 139952 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 139956 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139961 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 139965 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 139968 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 139971 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 139974 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 139976 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 139979 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 139983 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139988 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 139990 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 139993 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139995 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 139998 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 140001 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 140004 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 140009 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 140014 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 140019 */   // GIR_Coverage, 3675,
     /* 140019 */   GIR_EraseRootFromParent_Done,
     /* 140020 */ // Label 1926: @140020
     /* 140020 */ GIM_Try, /*On fail goto*//*Label 1927*/ GIMT_Encode4(140097), // Rule ID 3682 //
     /* 140025 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 140028 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 140032 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 140036 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 140040 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 140044 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 140048 */   // MIs[1] Operand 1
     /* 140048 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 140053 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 140057 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140059 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETGE:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } (NOR8:{ *:[i64] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s1), 1:{ *:[i32] }, 63:{ *:[i32] })
     /* 140059 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 140062 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /* 140066 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140071 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 140075 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 140079 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 140081 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 140084 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 140086 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 140089 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 140092 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 140095 */   GIR_RootConstrainSelectedInstOperands,
     /* 140096 */   // GIR_Coverage, 3682,
     /* 140096 */   GIR_EraseRootFromParent_Done,
     /* 140097 */ // Label 1927: @140097
     /* 140097 */ GIM_Try, /*On fail goto*//*Label 1928*/ GIMT_Encode4(140228), // Rule ID 3683 //
     /* 140102 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 140105 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 140109 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 140113 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 140117 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 140121 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 140125 */   // MIs[1] Operand 1
     /* 140125 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 140130 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 140134 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140136 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETGE:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } (NOR:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s1), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 140136 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 140139 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /* 140143 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140148 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 140152 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 140156 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 140158 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 140161 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 140165 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140170 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 140173 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 140176 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 140179 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 140182 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 140184 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 140187 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 140191 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140196 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 140198 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 140201 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140203 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 140206 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 140209 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 140212 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 140217 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 140222 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 140227 */   // GIR_Coverage, 3683,
     /* 140227 */   GIR_EraseRootFromParent_Done,
     /* 140228 */ // Label 1928: @140228
     /* 140228 */ GIM_Try, /*On fail goto*//*Label 1929*/ GIMT_Encode4(140322), // Rule ID 3690 //
     /* 140233 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 140236 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 140240 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 140244 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 140248 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 140252 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 140256 */   // MIs[1] Operand 1
     /* 140256 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 140261 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 140265 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140267 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETGT:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } (ANDC8:{ *:[i64] } (NEG8:{ *:[i64] } ?:{ *:[i64] }:$s1), ?:{ *:[i64] }:$s1), 1:{ *:[i32] }, 63:{ *:[i32] })
     /* 140267 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 140270 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NEG8),
     /* 140274 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140279 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 140283 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 140285 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 140288 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::ANDC8),
     /* 140292 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140297 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 140300 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 140304 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 140306 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 140309 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 140311 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 140314 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 140317 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 140320 */   GIR_RootConstrainSelectedInstOperands,
     /* 140321 */   // GIR_Coverage, 3690,
     /* 140321 */   GIR_EraseRootFromParent_Done,
     /* 140322 */ // Label 1929: @140322
     /* 140322 */ GIM_Try, /*On fail goto*//*Label 1930*/ GIMT_Encode4(140470), // Rule ID 3691 //
     /* 140327 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 140330 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 140334 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 140338 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 140342 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 140346 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 140350 */   // MIs[1] Operand 1
     /* 140350 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 140355 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 140359 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140361 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETGT:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } (ANDC:{ *:[i32] } (NEG:{ *:[i32] } ?:{ *:[i32] }:$s1), ?:{ *:[i32] }:$s1), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 140361 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 140364 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::NEG),
     /* 140368 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140373 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 140377 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 140379 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 140382 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::ANDC),
     /* 140386 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140391 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 140394 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 140398 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 140400 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 140403 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 140407 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140412 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 140415 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 140418 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 140421 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 140424 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 140426 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 140429 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 140433 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140438 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 140440 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 140443 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140445 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 140448 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 140451 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 140454 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 140459 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 140464 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 140469 */   // GIR_Coverage, 3691,
     /* 140469 */   GIR_EraseRootFromParent_Done,
     /* 140470 */ // Label 1930: @140470
     /* 140470 */ GIM_Try, /*On fail goto*//*Label 1931*/ GIMT_Encode4(140564), // Rule ID 3698 //
     /* 140475 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 140478 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 140482 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 140486 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 140490 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 140494 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 140498 */   // MIs[1] Operand 1
     /* 140498 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 140503 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 140507 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140509 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETLE:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } (ORC8:{ *:[i64] } ?:{ *:[i64] }:$s1, (NEG8:{ *:[i64] } ?:{ *:[i64] }:$s1)), 1:{ *:[i32] }, 63:{ *:[i32] })
     /* 140509 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 140512 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NEG8),
     /* 140516 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140521 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 140525 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 140527 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 140530 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::ORC8),
     /* 140534 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140539 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 140543 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 140546 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 140548 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 140551 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 140553 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 140556 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 140559 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 140562 */   GIR_RootConstrainSelectedInstOperands,
     /* 140563 */   // GIR_Coverage, 3698,
     /* 140563 */   GIR_EraseRootFromParent_Done,
     /* 140564 */ // Label 1931: @140564
     /* 140564 */ GIM_Try, /*On fail goto*//*Label 1932*/ GIMT_Encode4(140712), // Rule ID 3699 //
     /* 140569 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 140572 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 140576 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 140580 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 140584 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 140588 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 140592 */   // MIs[1] Operand 1
     /* 140592 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 140597 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 140601 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140603 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETLE:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } (ORC:{ *:[i32] } ?:{ *:[i32] }:$s1, (NEG:{ *:[i32] } ?:{ *:[i32] }:$s1)), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 140603 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 140606 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::NEG),
     /* 140610 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140615 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 140619 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 140621 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 140624 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::ORC),
     /* 140628 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140633 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 140637 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 140640 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 140642 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 140645 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 140649 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140654 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 140657 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 140660 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 140663 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 140666 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 140668 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 140671 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 140675 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140680 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 140682 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 140685 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140687 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 140690 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 140693 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 140696 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 140701 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 140706 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 140711 */   // GIR_Coverage, 3699,
     /* 140711 */   GIR_EraseRootFromParent_Done,
     /* 140712 */ // Label 1932: @140712
     /* 140712 */ GIM_Try, /*On fail goto*//*Label 1933*/ GIMT_Encode4(140809), // Rule ID 3706 //
     /* 140717 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 140720 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 140724 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 140728 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 140732 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 140736 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 140740 */   // MIs[1] Operand 1
     /* 140740 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 140745 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 140749 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140751 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, -1:{ *:[i64] }, SETLT:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } (AND8:{ *:[i64] } ?:{ *:[i64] }:$s1, (ADDI8:{ *:[i64] } ?:{ *:[i64] }:$s1, 1:{ *:[i64] })), 1:{ *:[i32] }, 63:{ *:[i32] })
     /* 140751 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 140754 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::ADDI8),
     /* 140758 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140763 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 140767 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 140770 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 140772 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 140775 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 140779 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140784 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 140788 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 140791 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 140793 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 140796 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 140798 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 140801 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 140804 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 140807 */   GIR_RootConstrainSelectedInstOperands,
     /* 140808 */   // GIR_Coverage, 3706,
     /* 140808 */   GIR_EraseRootFromParent_Done,
     /* 140809 */ // Label 1933: @140809
     /* 140809 */ GIM_Try, /*On fail goto*//*Label 1934*/ GIMT_Encode4(140960), // Rule ID 3707 //
     /* 140814 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 140817 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 140821 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 140825 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 140829 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 140833 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 140837 */   // MIs[1] Operand 1
     /* 140837 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 140842 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 140846 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140848 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, -1:{ *:[i32] }, SETLT:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } (AND:{ *:[i32] } ?:{ *:[i32] }:$s1, (ADDI:{ *:[i32] } ?:{ *:[i32] }:$s1, 1:{ *:[i32] })), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 140848 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 140851 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::ADDI),
     /* 140855 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140860 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 140864 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 140867 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 140869 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 140872 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 140876 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140881 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 140885 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 140888 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 140890 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 140893 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 140897 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140902 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 140905 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 140908 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 140911 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 140914 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 140916 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 140919 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 140923 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140928 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 140930 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 140933 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140935 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 140938 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 140941 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 140944 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 140949 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 140954 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 140959 */   // GIR_Coverage, 3707,
     /* 140959 */   GIR_EraseRootFromParent_Done,
     /* 140960 */ // Label 1934: @140960
     /* 140960 */ GIM_Try, /*On fail goto*//*Label 1935*/ GIMT_Encode4(141057), // Rule ID 3714 //
     /* 140965 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 140968 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 140972 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 140976 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 140980 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 140984 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 140988 */   // MIs[1] Operand 1
     /* 140988 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 140993 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 140997 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140999 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, -1:{ *:[i64] }, SETGE:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } (NAND8:{ *:[i64] } ?:{ *:[i64] }:$s1, (ADDI8:{ *:[i64] } ?:{ *:[i64] }:$s1, 1:{ *:[i64] })), 1:{ *:[i32] }, 63:{ *:[i32] })
     /* 140999 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 141002 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::ADDI8),
     /* 141006 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141011 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 141015 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 141018 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 141020 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 141023 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NAND8),
     /* 141027 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141032 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 141036 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 141039 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 141041 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 141044 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 141046 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 141049 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 141052 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 141055 */   GIR_RootConstrainSelectedInstOperands,
     /* 141056 */   // GIR_Coverage, 3714,
     /* 141056 */   GIR_EraseRootFromParent_Done,
     /* 141057 */ // Label 1935: @141057
     /* 141057 */ GIM_Try, /*On fail goto*//*Label 1936*/ GIMT_Encode4(141208), // Rule ID 3715 //
     /* 141062 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 141065 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 141069 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 141073 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 141077 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 141081 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 141085 */   // MIs[1] Operand 1
     /* 141085 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 141090 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 141094 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 141096 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, -1:{ *:[i32] }, SETGE:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } (NAND:{ *:[i32] } ?:{ *:[i32] }:$s1, (ADDI:{ *:[i32] } ?:{ *:[i32] }:$s1, 1:{ *:[i32] })), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 141096 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 141099 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::ADDI),
     /* 141103 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141108 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 141112 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 141115 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 141117 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 141120 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::NAND),
     /* 141124 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141129 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 141133 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 141136 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 141138 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 141141 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 141145 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141150 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 141153 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 141156 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 141159 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 141162 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 141164 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 141167 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 141171 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141176 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 141178 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 141181 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 141183 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 141186 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 141189 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 141192 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 141197 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 141202 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 141207 */   // GIR_Coverage, 3715,
     /* 141207 */   GIR_EraseRootFromParent_Done,
     /* 141208 */ // Label 1936: @141208
     /* 141208 */ GIM_Try, /*On fail goto*//*Label 1937*/ GIMT_Encode4(141285), // Rule ID 3722 //
     /* 141213 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 141216 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 141220 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 141224 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 141228 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 141232 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 141236 */   // MIs[1] Operand 1
     /* 141236 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 141241 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 141245 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 141247 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, -1:{ *:[i64] }, SETGT:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } (NOR8:{ *:[i64] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s1), 1:{ *:[i32] }, 63:{ *:[i32] })
     /* 141247 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 141250 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /* 141254 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141259 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 141263 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 141267 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 141269 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 141272 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 141274 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 141277 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 141280 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 141283 */   GIR_RootConstrainSelectedInstOperands,
     /* 141284 */   // GIR_Coverage, 3722,
     /* 141284 */   GIR_EraseRootFromParent_Done,
     /* 141285 */ // Label 1937: @141285
     /* 141285 */ GIM_Try, /*On fail goto*//*Label 1938*/ GIMT_Encode4(141416), // Rule ID 3723 //
     /* 141290 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 141293 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 141297 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 141301 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 141305 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 141309 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 141313 */   // MIs[1] Operand 1
     /* 141313 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 141318 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 141322 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 141324 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, -1:{ *:[i32] }, SETGT:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } (NOR:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s1), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 141324 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 141327 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /* 141331 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141336 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 141340 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 141344 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 141346 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 141349 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 141353 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141358 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 141361 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 141364 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 141367 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 141370 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 141372 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 141375 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 141379 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141384 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 141386 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 141389 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 141391 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 141394 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 141397 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 141400 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 141405 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 141410 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 141415 */   // GIR_Coverage, 3723,
     /* 141415 */   GIR_EraseRootFromParent_Done,
     /* 141416 */ // Label 1938: @141416
     /* 141416 */ GIM_Try, /*On fail goto*//*Label 1939*/ GIMT_Encode4(141472), // Rule ID 3730 //
     /* 141421 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 141424 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 141428 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 141432 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 141436 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 141440 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 141444 */   // MIs[1] Operand 1
     /* 141444 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 141449 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 141453 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 141455 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, -1:{ *:[i64] }, SETLE:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$s1, 1:{ *:[i32] }, 63:{ *:[i32] })
     /* 141455 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 141458 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 141460 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 141464 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 141467 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 141470 */   GIR_RootConstrainSelectedInstOperands,
     /* 141471 */   // GIR_Coverage, 3730,
     /* 141471 */   GIR_EraseRootFromParent_Done,
     /* 141472 */ // Label 1939: @141472
     /* 141472 */ GIM_Try, /*On fail goto*//*Label 1940*/ GIMT_Encode4(141582), // Rule ID 3731 //
     /* 141477 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 141480 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 141484 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 141488 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 141492 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 141496 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 141500 */   // MIs[1] Operand 1
     /* 141500 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 141505 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 141509 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 141511 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, -1:{ *:[i32] }, SETLE:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$s1, 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 141511 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 141514 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 141518 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141523 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 141527 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 141530 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 141533 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 141536 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 141538 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 141541 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 141545 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141550 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 141552 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 141555 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 141557 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 141560 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 141563 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 141566 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 141571 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 141576 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 141581 */   // GIR_Coverage, 3731,
     /* 141581 */   GIR_EraseRootFromParent_Done,
     /* 141582 */ // Label 1940: @141582
     /* 141582 */ GIM_Try, /*On fail goto*//*Label 1941*/ GIMT_Encode4(141692), // Rule ID 3026 //
     /* 141587 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 141590 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 141593 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 141597 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 141601 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 141605 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 141609 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 141613 */   // MIs[1] Operand 1
     /* 141613 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 141618 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 141622 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 141626 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 141630 */   // MIs[2] Operand 1
     /* 141630 */   // No operand predicates
     /* 141630 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 141632 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_lt:{ *:[i32] }))
     /* 141632 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 141635 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 141639 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141644 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 141648 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 141651 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 141653 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 141656 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 141660 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141665 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 141672 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 141677 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 141682 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 141685 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 141687 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 141690 */   GIR_RootConstrainSelectedInstOperands,
     /* 141691 */   // GIR_Coverage, 3026,
     /* 141691 */   GIR_EraseRootFromParent_Done,
     /* 141692 */ // Label 1941: @141692
     /* 141692 */ GIM_Try, /*On fail goto*//*Label 1942*/ GIMT_Encode4(141802), // Rule ID 3042 //
     /* 141697 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 141700 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 141703 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 141707 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 141711 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 141715 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 141719 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 141723 */   // MIs[1] Operand 1
     /* 141723 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 141728 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 141732 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 141736 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 141740 */   // MIs[2] Operand 1
     /* 141740 */   // No operand predicates
     /* 141740 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 141742 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_gt:{ *:[i32] }))
     /* 141742 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 141745 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 141749 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141754 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 141758 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 141761 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 141763 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 141766 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 141770 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141775 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 141782 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 141787 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 141792 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 141795 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 141797 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 141800 */   GIR_RootConstrainSelectedInstOperands,
     /* 141801 */   // GIR_Coverage, 3042,
     /* 141801 */   GIR_EraseRootFromParent_Done,
     /* 141802 */ // Label 1942: @141802
     /* 141802 */ GIM_Try, /*On fail goto*//*Label 1943*/ GIMT_Encode4(141912), // Rule ID 3050 //
     /* 141807 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 141810 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 141813 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 141817 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 141821 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 141825 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 141829 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 141833 */   // MIs[1] Operand 1
     /* 141833 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 141838 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 141842 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 141846 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 141850 */   // MIs[2] Operand 1
     /* 141850 */   // No operand predicates
     /* 141850 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 141852 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_eq:{ *:[i32] }))
     /* 141852 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 141855 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 141859 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141864 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 141868 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 141871 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 141873 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 141876 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 141880 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141885 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 141892 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 141897 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 141902 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 141905 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 141907 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 141910 */   GIR_RootConstrainSelectedInstOperands,
     /* 141911 */   // GIR_Coverage, 3050,
     /* 141911 */   GIR_EraseRootFromParent_Done,
     /* 141912 */ // Label 1943: @141912
     /* 141912 */ GIM_Try, /*On fail goto*//*Label 1944*/ GIMT_Encode4(142022), // Rule ID 3122 //
     /* 141917 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 141920 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 141923 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 141927 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 141931 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 141935 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 141939 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 141943 */   // MIs[1] Operand 1
     /* 141943 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 141948 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 141952 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 141956 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 141960 */   // MIs[2] Operand 1
     /* 141960 */   // No operand predicates
     /* 141960 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 141962 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_lt:{ *:[i32] }))
     /* 141962 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 141965 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 141969 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141974 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 141978 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 141981 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 141983 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 141986 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 141990 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141995 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 142002 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 142007 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 142012 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 142015 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 142017 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 142020 */   GIR_RootConstrainSelectedInstOperands,
     /* 142021 */   // GIR_Coverage, 3122,
     /* 142021 */   GIR_EraseRootFromParent_Done,
     /* 142022 */ // Label 1944: @142022
     /* 142022 */ GIM_Try, /*On fail goto*//*Label 1945*/ GIMT_Encode4(142132), // Rule ID 3138 //
     /* 142027 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 142030 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 142033 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 142037 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 142041 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 142045 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 142049 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 142053 */   // MIs[1] Operand 1
     /* 142053 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 142058 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 142062 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 142066 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 142070 */   // MIs[2] Operand 1
     /* 142070 */   // No operand predicates
     /* 142070 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 142072 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_gt:{ *:[i32] }))
     /* 142072 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 142075 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 142079 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142084 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 142088 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 142091 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 142093 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 142096 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 142100 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142105 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 142112 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 142117 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 142122 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 142125 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 142127 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 142130 */   GIR_RootConstrainSelectedInstOperands,
     /* 142131 */   // GIR_Coverage, 3138,
     /* 142131 */   GIR_EraseRootFromParent_Done,
     /* 142132 */ // Label 1945: @142132
     /* 142132 */ GIM_Try, /*On fail goto*//*Label 1946*/ GIMT_Encode4(142242), // Rule ID 3146 //
     /* 142137 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 142140 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 142143 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 142147 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 142151 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 142155 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 142159 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 142163 */   // MIs[1] Operand 1
     /* 142163 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 142168 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 142172 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 142176 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 142180 */   // MIs[2] Operand 1
     /* 142180 */   // No operand predicates
     /* 142180 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 142182 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_eq:{ *:[i32] }))
     /* 142182 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 142185 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 142189 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142194 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 142198 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 142201 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 142203 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 142206 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 142210 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142215 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 142222 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 142227 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 142232 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 142235 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 142237 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 142240 */   GIR_RootConstrainSelectedInstOperands,
     /* 142241 */   // GIR_Coverage, 3146,
     /* 142241 */   GIR_EraseRootFromParent_Done,
     /* 142242 */ // Label 1946: @142242
     /* 142242 */ GIM_Try, /*On fail goto*//*Label 1947*/ GIMT_Encode4(142392), // Rule ID 3781 //
     /* 142247 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 142250 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 142253 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 142257 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 142261 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 142265 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 142269 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 142273 */   // MIs[1] Operand 1
     /* 142273 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 142278 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 142282 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 142286 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 142290 */   // MIs[2] Operand 1
     /* 142290 */   // No operand predicates
     /* 142290 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 142292 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 142292 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 142295 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 142299 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142304 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 142308 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 142311 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 142313 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 142316 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 142320 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142325 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 142328 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 142330 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 142333 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 142337 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142342 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 142345 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 142347 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 142350 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 142354 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142359 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 142366 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 142371 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 142376 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 142379 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142381 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 142384 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 142387 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 142390 */   GIR_RootConstrainSelectedInstOperands,
     /* 142391 */   // GIR_Coverage, 3781,
     /* 142391 */   GIR_EraseRootFromParent_Done,
     /* 142392 */ // Label 1947: @142392
     /* 142392 */ GIM_Try, /*On fail goto*//*Label 1948*/ GIMT_Encode4(142542), // Rule ID 3797 //
     /* 142397 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 142400 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 142403 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 142407 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 142411 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 142415 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 142419 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 142423 */   // MIs[1] Operand 1
     /* 142423 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 142428 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 142432 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 142436 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 142440 */   // MIs[2] Operand 1
     /* 142440 */   // No operand predicates
     /* 142440 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 142442 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 142442 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 142445 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 142449 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142454 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 142458 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 142461 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 142463 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 142466 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 142470 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142475 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 142478 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 142480 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 142483 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 142487 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142492 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 142495 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 142497 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 142500 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 142504 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142509 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 142516 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 142521 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 142526 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 142529 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142531 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 142534 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 142537 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 142540 */   GIR_RootConstrainSelectedInstOperands,
     /* 142541 */   // GIR_Coverage, 3797,
     /* 142541 */   GIR_EraseRootFromParent_Done,
     /* 142542 */ // Label 1948: @142542
     /* 142542 */ GIM_Try, /*On fail goto*//*Label 1949*/ GIMT_Encode4(142692), // Rule ID 3805 //
     /* 142547 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 142550 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 142553 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 142557 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 142561 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 142565 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 142569 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 142573 */   // MIs[1] Operand 1
     /* 142573 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 142578 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 142582 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 142586 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 142590 */   // MIs[2] Operand 1
     /* 142590 */   // No operand predicates
     /* 142590 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 142592 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 142592 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 142595 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 142599 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142604 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 142608 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 142611 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 142613 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 142616 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 142620 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142625 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 142628 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 142630 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 142633 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 142637 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142642 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 142645 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 142647 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 142650 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 142654 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142659 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 142666 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 142671 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 142676 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 142679 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142681 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 142684 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 142687 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 142690 */   GIR_RootConstrainSelectedInstOperands,
     /* 142691 */   // GIR_Coverage, 3805,
     /* 142691 */   GIR_EraseRootFromParent_Done,
     /* 142692 */ // Label 1949: @142692
     /* 142692 */ GIM_Try, /*On fail goto*//*Label 1950*/ GIMT_Encode4(142842), // Rule ID 3877 //
     /* 142697 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 142700 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 142703 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 142707 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 142711 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 142715 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 142719 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 142723 */   // MIs[1] Operand 1
     /* 142723 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 142728 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 142732 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 142736 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 142740 */   // MIs[2] Operand 1
     /* 142740 */   // No operand predicates
     /* 142740 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 142742 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 142742 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 142745 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 142749 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142754 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 142758 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 142761 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 142763 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 142766 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 142770 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142775 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 142778 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 142780 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 142783 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 142787 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142792 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 142795 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 142797 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 142800 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 142804 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142809 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 142816 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 142821 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 142826 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 142829 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142831 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 142834 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 142837 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 142840 */   GIR_RootConstrainSelectedInstOperands,
     /* 142841 */   // GIR_Coverage, 3877,
     /* 142841 */   GIR_EraseRootFromParent_Done,
     /* 142842 */ // Label 1950: @142842
     /* 142842 */ GIM_Try, /*On fail goto*//*Label 1951*/ GIMT_Encode4(142992), // Rule ID 3893 //
     /* 142847 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 142850 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 142853 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 142857 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 142861 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 142865 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 142869 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 142873 */   // MIs[1] Operand 1
     /* 142873 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 142878 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 142882 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 142886 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 142890 */   // MIs[2] Operand 1
     /* 142890 */   // No operand predicates
     /* 142890 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 142892 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 142892 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 142895 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 142899 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142904 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 142908 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 142911 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 142913 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 142916 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 142920 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142925 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 142928 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 142930 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 142933 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 142937 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142942 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 142945 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 142947 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 142950 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 142954 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142959 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 142966 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 142971 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 142976 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 142979 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142981 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 142984 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 142987 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 142990 */   GIR_RootConstrainSelectedInstOperands,
     /* 142991 */   // GIR_Coverage, 3893,
     /* 142991 */   GIR_EraseRootFromParent_Done,
     /* 142992 */ // Label 1951: @142992
     /* 142992 */ GIM_Try, /*On fail goto*//*Label 1952*/ GIMT_Encode4(143142), // Rule ID 3901 //
     /* 142997 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 143000 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 143003 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 143007 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 143011 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 143015 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 143019 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 143023 */   // MIs[1] Operand 1
     /* 143023 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 143028 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 143032 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 143036 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 143040 */   // MIs[2] Operand 1
     /* 143040 */   // No operand predicates
     /* 143040 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 143042 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 143042 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 143045 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 143049 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143054 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 143058 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 143061 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 143063 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 143066 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 143070 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143075 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 143078 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 143080 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 143083 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 143087 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143092 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 143095 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 143097 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 143100 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 143104 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143109 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 143116 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 143121 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 143126 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 143129 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143131 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 143134 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 143137 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 143140 */   GIR_RootConstrainSelectedInstOperands,
     /* 143141 */   // GIR_Coverage, 3901,
     /* 143141 */   GIR_EraseRootFromParent_Done,
     /* 143142 */ // Label 1952: @143142
     /* 143142 */ GIM_Try, /*On fail goto*//*Label 1953*/ GIMT_Encode4(143241), // Rule ID 3170 //
     /* 143147 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 143150 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 143153 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 143157 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 143161 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 143165 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 143169 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 143173 */   // MIs[1] Operand 1
     /* 143173 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 143178 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143180 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_lt:{ *:[i32] }))
     /* 143180 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 143183 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 143187 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143192 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 143196 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 143200 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 143202 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 143205 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 143209 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143214 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 143221 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 143226 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 143231 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 143234 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 143236 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 143239 */   GIR_RootConstrainSelectedInstOperands,
     /* 143240 */   // GIR_Coverage, 3170,
     /* 143240 */   GIR_EraseRootFromParent_Done,
     /* 143241 */ // Label 1953: @143241
     /* 143241 */ GIM_Try, /*On fail goto*//*Label 1954*/ GIMT_Encode4(143340), // Rule ID 3186 //
     /* 143246 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 143249 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 143252 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 143256 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 143260 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 143264 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 143268 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 143272 */   // MIs[1] Operand 1
     /* 143272 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 143277 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143279 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }))
     /* 143279 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 143282 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 143286 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143291 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 143295 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 143299 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 143301 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 143304 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 143308 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143313 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 143320 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 143325 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 143330 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 143333 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 143335 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 143338 */   GIR_RootConstrainSelectedInstOperands,
     /* 143339 */   // GIR_Coverage, 3186,
     /* 143339 */   GIR_EraseRootFromParent_Done,
     /* 143340 */ // Label 1954: @143340
     /* 143340 */ GIM_Try, /*On fail goto*//*Label 1955*/ GIMT_Encode4(143439), // Rule ID 3202 //
     /* 143345 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 143348 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 143351 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 143355 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 143359 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 143363 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 143367 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 143371 */   // MIs[1] Operand 1
     /* 143371 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 143376 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143378 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_eq:{ *:[i32] }))
     /* 143378 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 143381 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 143385 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143390 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 143394 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 143398 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 143400 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 143403 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 143407 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143412 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 143419 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 143424 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 143429 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 143432 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 143434 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 143437 */   GIR_RootConstrainSelectedInstOperands,
     /* 143438 */   // GIR_Coverage, 3202,
     /* 143438 */   GIR_EraseRootFromParent_Done,
     /* 143439 */ // Label 1955: @143439
     /* 143439 */ GIM_Try, /*On fail goto*//*Label 1956*/ GIMT_Encode4(143538), // Rule ID 3218 //
     /* 143444 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 143447 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 143450 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 143454 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 143458 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 143462 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 143466 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 143470 */   // MIs[1] Operand 1
     /* 143470 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 143475 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143477 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETO:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_un:{ *:[i32] }))
     /* 143477 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 143480 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 143484 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143489 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 143493 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 143497 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 143499 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 143502 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 143506 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143511 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 143518 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 143523 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 143528 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 143531 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 143533 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 143536 */   GIR_RootConstrainSelectedInstOperands,
     /* 143537 */   // GIR_Coverage, 3218,
     /* 143537 */   GIR_EraseRootFromParent_Done,
     /* 143538 */ // Label 1956: @143538
     /* 143538 */ GIM_Try, /*On fail goto*//*Label 1957*/ GIMT_Encode4(143637), // Rule ID 3226 //
     /* 143543 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 143546 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 143549 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 143553 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 143557 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 143561 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 143565 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 143569 */   // MIs[1] Operand 1
     /* 143569 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 143574 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143576 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_lt:{ *:[i32] }))
     /* 143576 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 143579 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 143583 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143588 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 143592 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 143596 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 143598 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 143601 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 143605 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143610 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 143617 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 143622 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 143627 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 143630 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 143632 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 143635 */   GIR_RootConstrainSelectedInstOperands,
     /* 143636 */   // GIR_Coverage, 3226,
     /* 143636 */   GIR_EraseRootFromParent_Done,
     /* 143637 */ // Label 1957: @143637
     /* 143637 */ GIM_Try, /*On fail goto*//*Label 1958*/ GIMT_Encode4(143736), // Rule ID 3242 //
     /* 143642 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 143645 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 143648 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 143652 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 143656 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 143660 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 143664 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 143668 */   // MIs[1] Operand 1
     /* 143668 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 143673 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143675 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }))
     /* 143675 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 143678 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 143682 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143687 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 143691 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 143695 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 143697 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 143700 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 143704 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143709 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 143716 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 143721 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 143726 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 143729 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 143731 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 143734 */   GIR_RootConstrainSelectedInstOperands,
     /* 143735 */   // GIR_Coverage, 3242,
     /* 143735 */   GIR_EraseRootFromParent_Done,
     /* 143736 */ // Label 1958: @143736
     /* 143736 */ GIM_Try, /*On fail goto*//*Label 1959*/ GIMT_Encode4(143835), // Rule ID 3258 //
     /* 143741 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 143744 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 143747 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 143751 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 143755 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 143759 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 143763 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 143767 */   // MIs[1] Operand 1
     /* 143767 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 143772 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143774 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_eq:{ *:[i32] }))
     /* 143774 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 143777 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 143781 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143786 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 143790 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 143794 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 143796 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 143799 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 143803 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143808 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 143815 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 143820 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 143825 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 143828 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 143830 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 143833 */   GIR_RootConstrainSelectedInstOperands,
     /* 143834 */   // GIR_Coverage, 3258,
     /* 143834 */   GIR_EraseRootFromParent_Done,
     /* 143835 */ // Label 1959: @143835
     /* 143835 */ GIM_Try, /*On fail goto*//*Label 1960*/ GIMT_Encode4(143934), // Rule ID 3274 //
     /* 143840 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 143843 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 143846 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 143850 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 143854 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 143858 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 143862 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 143866 */   // MIs[1] Operand 1
     /* 143866 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 143871 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143873 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETO:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_un:{ *:[i32] }))
     /* 143873 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 143876 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 143880 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143885 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 143889 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 143893 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 143895 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 143898 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 143902 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143907 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 143914 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 143919 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 143924 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 143927 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 143929 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 143932 */   GIR_RootConstrainSelectedInstOperands,
     /* 143933 */   // GIR_Coverage, 3274,
     /* 143933 */   GIR_EraseRootFromParent_Done,
     /* 143934 */ // Label 1960: @143934
     /* 143934 */ GIM_Try, /*On fail goto*//*Label 1961*/ GIMT_Encode4(144033), // Rule ID 3282 //
     /* 143939 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 143942 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 143945 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 143949 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 143953 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 143957 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 143961 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 143965 */   // MIs[1] Operand 1
     /* 143965 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 143970 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143972 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_lt:{ *:[i32] }))
     /* 143972 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 143975 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 143979 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143984 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 143988 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 143992 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 143994 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 143997 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 144001 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144006 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 144013 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 144018 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 144023 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 144026 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 144028 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 144031 */   GIR_RootConstrainSelectedInstOperands,
     /* 144032 */   // GIR_Coverage, 3282,
     /* 144032 */   GIR_EraseRootFromParent_Done,
     /* 144033 */ // Label 1961: @144033
     /* 144033 */ GIM_Try, /*On fail goto*//*Label 1962*/ GIMT_Encode4(144132), // Rule ID 3298 //
     /* 144038 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 144041 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 144044 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 144048 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 144052 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 144056 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 144060 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 144064 */   // MIs[1] Operand 1
     /* 144064 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 144069 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 144071 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_gt:{ *:[i32] }))
     /* 144071 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 144074 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 144078 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144083 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 144087 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 144091 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 144093 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 144096 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 144100 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144105 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 144112 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 144117 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 144122 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 144125 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 144127 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 144130 */   GIR_RootConstrainSelectedInstOperands,
     /* 144131 */   // GIR_Coverage, 3298,
     /* 144131 */   GIR_EraseRootFromParent_Done,
     /* 144132 */ // Label 1962: @144132
     /* 144132 */ GIM_Try, /*On fail goto*//*Label 1963*/ GIMT_Encode4(144231), // Rule ID 3314 //
     /* 144137 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 144140 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 144143 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 144147 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 144151 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 144155 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 144159 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 144163 */   // MIs[1] Operand 1
     /* 144163 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 144168 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 144170 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUNE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_eq:{ *:[i32] }))
     /* 144170 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 144173 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 144177 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144182 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 144186 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 144190 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 144192 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 144195 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 144199 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144204 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 144211 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 144216 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 144221 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 144224 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 144226 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 144229 */   GIR_RootConstrainSelectedInstOperands,
     /* 144230 */   // GIR_Coverage, 3314,
     /* 144230 */   GIR_EraseRootFromParent_Done,
     /* 144231 */ // Label 1963: @144231
     /* 144231 */ GIM_Try, /*On fail goto*//*Label 1964*/ GIMT_Encode4(144330), // Rule ID 3330 //
     /* 144236 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 144239 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 144242 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 144246 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 144250 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 144254 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 144258 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 144262 */   // MIs[1] Operand 1
     /* 144262 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 144267 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 144269 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETO:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_un:{ *:[i32] }))
     /* 144269 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 144272 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 144276 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144281 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 144285 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 144289 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 144291 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 144294 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 144298 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144303 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 144310 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 144315 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 144320 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 144323 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 144325 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 144328 */   GIR_RootConstrainSelectedInstOperands,
     /* 144329 */   // GIR_Coverage, 3330,
     /* 144329 */   GIR_EraseRootFromParent_Done,
     /* 144330 */ // Label 1964: @144330
     /* 144330 */ GIM_Try, /*On fail goto*//*Label 1965*/ GIMT_Encode4(144469), // Rule ID 3984 //
     /* 144335 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 144338 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 144341 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 144345 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 144349 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 144353 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 144357 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 144361 */   // MIs[1] Operand 1
     /* 144361 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 144366 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 144368 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 144368 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 144371 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 144375 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144380 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 144384 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 144388 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 144390 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 144393 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 144397 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144402 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 144405 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 144407 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 144410 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 144414 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144419 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 144422 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 144424 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 144427 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 144431 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144436 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 144443 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 144448 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 144453 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 144456 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144458 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 144461 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 144464 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 144467 */   GIR_RootConstrainSelectedInstOperands,
     /* 144468 */   // GIR_Coverage, 3984,
     /* 144468 */   GIR_EraseRootFromParent_Done,
     /* 144469 */ // Label 1965: @144469
     /* 144469 */ GIM_Try, /*On fail goto*//*Label 1966*/ GIMT_Encode4(144608), // Rule ID 4016 //
     /* 144474 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 144477 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 144480 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 144484 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 144488 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 144492 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 144496 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 144500 */   // MIs[1] Operand 1
     /* 144500 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 144505 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 144507 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 144507 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 144510 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 144514 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144519 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 144523 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 144527 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 144529 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 144532 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 144536 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144541 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 144544 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 144546 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 144549 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 144553 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144558 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 144561 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 144563 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 144566 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 144570 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144575 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 144582 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 144587 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 144592 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 144595 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144597 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 144600 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 144603 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 144606 */   GIR_RootConstrainSelectedInstOperands,
     /* 144607 */   // GIR_Coverage, 4016,
     /* 144607 */   GIR_EraseRootFromParent_Done,
     /* 144608 */ // Label 1966: @144608
     /* 144608 */ GIM_Try, /*On fail goto*//*Label 1967*/ GIMT_Encode4(144747), // Rule ID 4048 //
     /* 144613 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 144616 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 144619 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 144623 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 144627 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 144631 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 144635 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 144639 */   // MIs[1] Operand 1
     /* 144639 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 144644 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 144646 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 144646 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 144649 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 144653 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144658 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 144662 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 144666 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 144668 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 144671 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 144675 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144680 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 144683 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 144685 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 144688 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 144692 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144697 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 144700 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 144702 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 144705 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 144709 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144714 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 144721 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 144726 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 144731 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 144734 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144736 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 144739 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 144742 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 144745 */   GIR_RootConstrainSelectedInstOperands,
     /* 144746 */   // GIR_Coverage, 4048,
     /* 144746 */   GIR_EraseRootFromParent_Done,
     /* 144747 */ // Label 1967: @144747
     /* 144747 */ GIM_Try, /*On fail goto*//*Label 1968*/ GIMT_Encode4(144886), // Rule ID 4080 //
     /* 144752 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 144755 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 144758 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 144762 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 144766 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 144770 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 144774 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 144778 */   // MIs[1] Operand 1
     /* 144778 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 144783 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 144785 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETO:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_un:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 144785 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 144788 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 144792 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144797 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 144801 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 144805 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 144807 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 144810 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 144814 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144819 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 144822 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 144824 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 144827 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 144831 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144836 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 144839 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 144841 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 144844 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 144848 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144853 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 144860 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 144865 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 144870 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 144873 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144875 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 144878 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 144881 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 144884 */   GIR_RootConstrainSelectedInstOperands,
     /* 144885 */   // GIR_Coverage, 4080,
     /* 144885 */   GIR_EraseRootFromParent_Done,
     /* 144886 */ // Label 1968: @144886
     /* 144886 */ GIM_Try, /*On fail goto*//*Label 1969*/ GIMT_Encode4(145025), // Rule ID 4096 //
     /* 144891 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 144894 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 144897 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 144901 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 144905 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 144909 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 144913 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 144917 */   // MIs[1] Operand 1
     /* 144917 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 144922 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 144924 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 144924 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 144927 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 144931 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144936 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 144940 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 144944 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 144946 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 144949 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 144953 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144958 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 144961 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 144963 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 144966 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 144970 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144975 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 144978 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 144980 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 144983 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 144987 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144992 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 144999 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 145004 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 145009 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 145012 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145014 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 145017 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 145020 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 145023 */   GIR_RootConstrainSelectedInstOperands,
     /* 145024 */   // GIR_Coverage, 4096,
     /* 145024 */   GIR_EraseRootFromParent_Done,
     /* 145025 */ // Label 1969: @145025
     /* 145025 */ GIM_Try, /*On fail goto*//*Label 1970*/ GIMT_Encode4(145164), // Rule ID 4128 //
     /* 145030 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 145033 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 145036 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 145040 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 145044 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 145048 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 145052 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 145056 */   // MIs[1] Operand 1
     /* 145056 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 145061 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 145063 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 145063 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 145066 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 145070 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145075 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 145079 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 145083 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 145085 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 145088 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 145092 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145097 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 145100 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 145102 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 145105 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 145109 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145114 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 145117 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 145119 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 145122 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 145126 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145131 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 145138 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 145143 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 145148 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 145151 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145153 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 145156 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 145159 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 145162 */   GIR_RootConstrainSelectedInstOperands,
     /* 145163 */   // GIR_Coverage, 4128,
     /* 145163 */   GIR_EraseRootFromParent_Done,
     /* 145164 */ // Label 1970: @145164
     /* 145164 */ GIM_Try, /*On fail goto*//*Label 1971*/ GIMT_Encode4(145303), // Rule ID 4160 //
     /* 145169 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 145172 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 145175 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 145179 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 145183 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 145187 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 145191 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 145195 */   // MIs[1] Operand 1
     /* 145195 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 145200 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 145202 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 145202 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 145205 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 145209 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145214 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 145218 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 145222 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 145224 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 145227 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 145231 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145236 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 145239 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 145241 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 145244 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 145248 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145253 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 145256 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 145258 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 145261 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 145265 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145270 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 145277 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 145282 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 145287 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 145290 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145292 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 145295 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 145298 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 145301 */   GIR_RootConstrainSelectedInstOperands,
     /* 145302 */   // GIR_Coverage, 4160,
     /* 145302 */   GIR_EraseRootFromParent_Done,
     /* 145303 */ // Label 1971: @145303
     /* 145303 */ GIM_Try, /*On fail goto*//*Label 1972*/ GIMT_Encode4(145442), // Rule ID 4192 //
     /* 145308 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 145311 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 145314 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 145318 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 145322 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 145326 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 145330 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 145334 */   // MIs[1] Operand 1
     /* 145334 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 145339 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 145341 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETO:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_un:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 145341 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 145344 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 145348 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145353 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 145357 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 145361 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 145363 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 145366 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 145370 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145375 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 145378 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 145380 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 145383 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 145387 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145392 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 145395 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 145397 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 145400 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 145404 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145409 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 145416 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 145421 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 145426 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 145429 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145431 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 145434 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 145437 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 145440 */   GIR_RootConstrainSelectedInstOperands,
     /* 145441 */   // GIR_Coverage, 4192,
     /* 145441 */   GIR_EraseRootFromParent_Done,
     /* 145442 */ // Label 1972: @145442
     /* 145442 */ GIM_Try, /*On fail goto*//*Label 1973*/ GIMT_Encode4(145581), // Rule ID 4222 //
     /* 145447 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 145450 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 145453 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 145457 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 145461 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 145465 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 145469 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 145473 */   // MIs[1] Operand 1
     /* 145473 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 145478 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 145480 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 145480 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 145483 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 145487 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145492 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 145496 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 145500 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 145502 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 145505 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 145509 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145514 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 145517 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 145519 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 145522 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 145526 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145531 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 145534 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 145536 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 145539 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 145543 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145548 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 145555 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 145560 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 145565 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 145568 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145570 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 145573 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 145576 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 145579 */   GIR_RootConstrainSelectedInstOperands,
     /* 145580 */   // GIR_Coverage, 4222,
     /* 145580 */   GIR_EraseRootFromParent_Done,
     /* 145581 */ // Label 1973: @145581
     /* 145581 */ GIM_Try, /*On fail goto*//*Label 1974*/ GIMT_Encode4(145720), // Rule ID 4254 //
     /* 145586 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 145589 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 145592 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 145596 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 145600 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 145604 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 145608 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 145612 */   // MIs[1] Operand 1
     /* 145612 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 145617 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 145619 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 145619 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 145622 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 145626 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145631 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 145635 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 145639 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 145641 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 145644 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 145648 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145653 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 145656 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 145658 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 145661 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 145665 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145670 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 145673 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 145675 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 145678 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 145682 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145687 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 145694 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 145699 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 145704 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 145707 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145709 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 145712 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 145715 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 145718 */   GIR_RootConstrainSelectedInstOperands,
     /* 145719 */   // GIR_Coverage, 4254,
     /* 145719 */   GIR_EraseRootFromParent_Done,
     /* 145720 */ // Label 1974: @145720
     /* 145720 */ GIM_Try, /*On fail goto*//*Label 1975*/ GIMT_Encode4(145859), // Rule ID 4286 //
     /* 145725 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 145728 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 145731 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 145735 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 145739 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 145743 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 145747 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 145751 */   // MIs[1] Operand 1
     /* 145751 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 145756 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 145758 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 145758 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 145761 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 145765 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145770 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 145774 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 145778 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 145780 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 145783 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 145787 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145792 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 145795 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 145797 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 145800 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 145804 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145809 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 145812 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 145814 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 145817 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 145821 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145826 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 145833 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 145838 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 145843 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 145846 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145848 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 145851 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 145854 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 145857 */   GIR_RootConstrainSelectedInstOperands,
     /* 145858 */   // GIR_Coverage, 4286,
     /* 145858 */   GIR_EraseRootFromParent_Done,
     /* 145859 */ // Label 1975: @145859
     /* 145859 */ GIM_Try, /*On fail goto*//*Label 1976*/ GIMT_Encode4(145998), // Rule ID 4318 //
     /* 145864 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 145867 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 145870 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 145874 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 145878 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 145882 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 145886 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 145890 */   // MIs[1] Operand 1
     /* 145890 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 145895 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 145897 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETO:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_un:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 145897 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 145900 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 145904 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145909 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 145913 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 145917 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 145919 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 145922 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 145926 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145931 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 145934 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 145936 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 145939 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 145943 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145948 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 145951 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 145953 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 145956 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 145960 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145965 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 145972 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 145977 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 145982 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 145985 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145987 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 145990 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 145993 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 145996 */   GIR_RootConstrainSelectedInstOperands,
     /* 145997 */   // GIR_Coverage, 4318,
     /* 145997 */   GIR_EraseRootFromParent_Done,
     /* 145998 */ // Label 1976: @145998
     /* 145998 */ GIM_Try, /*On fail goto*//*Label 1977*/ GIMT_Encode4(146137), // Rule ID 4549 //
     /* 146003 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 146006 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 146009 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 146013 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 146017 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 146021 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 146025 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 146029 */   // MIs[1] Operand 1
     /* 146029 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 146034 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146036 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPLT:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 146036 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 146039 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPLT),
     /* 146043 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146048 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 146052 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 146056 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 146058 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 146061 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 146065 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146070 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 146073 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 146075 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 146078 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 146082 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146087 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 146090 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 146092 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 146095 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 146099 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146104 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 146111 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 146116 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 146121 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 146124 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 146126 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 146129 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 146132 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 146135 */   GIR_RootConstrainSelectedInstOperands,
     /* 146136 */   // GIR_Coverage, 4549,
     /* 146136 */   GIR_EraseRootFromParent_Done,
     /* 146137 */ // Label 1977: @146137
     /* 146137 */ GIM_Try, /*On fail goto*//*Label 1978*/ GIMT_Encode4(146276), // Rule ID 4581 //
     /* 146142 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 146145 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 146148 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 146152 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 146156 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 146160 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 146164 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 146168 */   // MIs[1] Operand 1
     /* 146168 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 146173 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146175 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPGT:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 146175 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 146178 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPGT),
     /* 146182 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146187 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 146191 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 146195 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 146197 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 146200 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 146204 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146209 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 146212 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 146214 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 146217 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 146221 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146226 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 146229 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 146231 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 146234 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 146238 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146243 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 146250 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 146255 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 146260 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 146263 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 146265 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 146268 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 146271 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 146274 */   GIR_RootConstrainSelectedInstOperands,
     /* 146275 */   // GIR_Coverage, 4581,
     /* 146275 */   GIR_EraseRootFromParent_Done,
     /* 146276 */ // Label 1978: @146276
     /* 146276 */ GIM_Try, /*On fail goto*//*Label 1979*/ GIMT_Encode4(146415), // Rule ID 4613 //
     /* 146281 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 146284 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 146287 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 146291 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 146295 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 146299 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 146303 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 146307 */   // MIs[1] Operand 1
     /* 146307 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 146312 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146314 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPEQ:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 146314 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 146317 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPEQ),
     /* 146321 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146326 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 146330 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 146334 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 146336 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 146339 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 146343 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146348 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 146351 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 146353 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 146356 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 146360 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146365 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 146368 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 146370 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 146373 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 146377 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146382 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 146389 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 146394 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 146399 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 146402 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 146404 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 146407 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 146410 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 146413 */   GIR_RootConstrainSelectedInstOperands,
     /* 146414 */   // GIR_Coverage, 4613,
     /* 146414 */   GIR_EraseRootFromParent_Done,
     /* 146415 */ // Label 1979: @146415
     /* 146415 */ GIM_Try, /*On fail goto*//*Label 1980*/ GIMT_Encode4(146554), // Rule ID 4657 //
     /* 146420 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 146423 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 146426 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 146430 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 146434 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 146438 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 146442 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 146446 */   // MIs[1] Operand 1
     /* 146446 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 146451 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146453 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPLT:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 146453 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 146456 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPLT),
     /* 146460 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146465 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 146469 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 146473 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 146475 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 146478 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 146482 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146487 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 146490 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 146492 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 146495 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 146499 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146504 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 146507 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 146509 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 146512 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 146516 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146521 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 146528 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 146533 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 146538 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 146541 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 146543 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 146546 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 146549 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 146552 */   GIR_RootConstrainSelectedInstOperands,
     /* 146553 */   // GIR_Coverage, 4657,
     /* 146553 */   GIR_EraseRootFromParent_Done,
     /* 146554 */ // Label 1980: @146554
     /* 146554 */ GIM_Try, /*On fail goto*//*Label 1981*/ GIMT_Encode4(146693), // Rule ID 4689 //
     /* 146559 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 146562 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 146565 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 146569 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 146573 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 146577 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 146581 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 146585 */   // MIs[1] Operand 1
     /* 146585 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 146590 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146592 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPGT:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 146592 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 146595 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPGT),
     /* 146599 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146604 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 146608 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 146612 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 146614 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 146617 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 146621 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146626 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 146629 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 146631 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 146634 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 146638 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146643 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 146646 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 146648 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 146651 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 146655 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146660 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 146667 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 146672 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 146677 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 146680 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 146682 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 146685 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 146688 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 146691 */   GIR_RootConstrainSelectedInstOperands,
     /* 146692 */   // GIR_Coverage, 4689,
     /* 146692 */   GIR_EraseRootFromParent_Done,
     /* 146693 */ // Label 1981: @146693
     /* 146693 */ GIM_Try, /*On fail goto*//*Label 1982*/ GIMT_Encode4(146832), // Rule ID 4721 //
     /* 146698 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 146701 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 146704 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 146708 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 146712 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 146716 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 146720 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 146724 */   // MIs[1] Operand 1
     /* 146724 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 146729 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146731 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPEQ:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 146731 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 146734 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPEQ),
     /* 146738 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146743 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 146747 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 146751 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 146753 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 146756 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 146760 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146765 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 146768 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 146770 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 146773 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 146777 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146782 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 146785 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 146787 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 146790 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 146794 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146799 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 146806 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 146811 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 146816 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 146819 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 146821 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 146824 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 146827 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 146830 */   GIR_RootConstrainSelectedInstOperands,
     /* 146831 */   // GIR_Coverage, 4721,
     /* 146831 */   GIR_EraseRootFromParent_Done,
     /* 146832 */ // Label 1982: @146832
     /* 146832 */ GIM_Try, /*On fail goto*//*Label 1983*/ GIMT_Encode4(146931), // Rule ID 2972 //
     /* 146837 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 146840 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 146843 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 146847 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 146851 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 146855 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 146859 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 146863 */   // MIs[1] Operand 1
     /* 146863 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 146868 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146870 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }))
     /* 146870 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 146873 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 146877 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146882 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 146886 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 146890 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 146892 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 146895 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 146899 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146904 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 146911 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 146916 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 146921 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 146924 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 146926 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 146929 */   GIR_RootConstrainSelectedInstOperands,
     /* 146930 */   // GIR_Coverage, 2972,
     /* 146930 */   GIR_EraseRootFromParent_Done,
     /* 146931 */ // Label 1983: @146931
     /* 146931 */ GIM_Try, /*On fail goto*//*Label 1984*/ GIMT_Encode4(147030), // Rule ID 2986 //
     /* 146936 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 146939 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 146942 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 146946 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 146950 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 146954 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 146958 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 146962 */   // MIs[1] Operand 1
     /* 146962 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 146967 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146969 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETGE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }))
     /* 146969 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 146972 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 146976 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146981 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 146985 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 146989 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 146991 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 146994 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 146998 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147003 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 147010 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 147015 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 147020 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 147023 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 147025 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147028 */   GIR_RootConstrainSelectedInstOperands,
     /* 147029 */   // GIR_Coverage, 2986,
     /* 147029 */   GIR_EraseRootFromParent_Done,
     /* 147030 */ // Label 1984: @147030
     /* 147030 */ GIM_Try, /*On fail goto*//*Label 1985*/ GIMT_Encode4(147129), // Rule ID 2994 //
     /* 147035 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 147038 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 147041 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 147045 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 147049 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 147053 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 147057 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 147061 */   // MIs[1] Operand 1
     /* 147061 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 147066 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 147068 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }))
     /* 147068 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 147071 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 147075 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147080 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 147084 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 147088 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 147090 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 147093 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 147097 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147102 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 147109 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 147114 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 147119 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 147122 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 147124 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147127 */   GIR_RootConstrainSelectedInstOperands,
     /* 147128 */   // GIR_Coverage, 2994,
     /* 147128 */   GIR_EraseRootFromParent_Done,
     /* 147129 */ // Label 1985: @147129
     /* 147129 */ GIM_Try, /*On fail goto*//*Label 1986*/ GIMT_Encode4(147228), // Rule ID 3002 //
     /* 147134 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 147137 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 147140 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 147144 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 147148 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 147152 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 147156 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 147160 */   // MIs[1] Operand 1
     /* 147160 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 147165 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 147167 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETLE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }))
     /* 147167 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 147170 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 147174 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147179 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 147183 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 147187 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 147189 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 147192 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 147196 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147201 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 147208 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 147213 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 147218 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 147221 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 147223 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147226 */   GIR_RootConstrainSelectedInstOperands,
     /* 147227 */   // GIR_Coverage, 3002,
     /* 147227 */   GIR_EraseRootFromParent_Done,
     /* 147228 */ // Label 1986: @147228
     /* 147228 */ GIM_Try, /*On fail goto*//*Label 1987*/ GIMT_Encode4(147327), // Rule ID 3010 //
     /* 147233 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 147236 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 147239 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 147243 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 147247 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 147251 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 147255 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 147259 */   // MIs[1] Operand 1
     /* 147259 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 147264 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 147266 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETNE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_eq:{ *:[i32] }))
     /* 147266 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 147269 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 147273 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147278 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 147282 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 147286 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 147288 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 147291 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 147295 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147300 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 147307 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 147312 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 147317 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 147320 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 147322 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147325 */   GIR_RootConstrainSelectedInstOperands,
     /* 147326 */   // GIR_Coverage, 3010,
     /* 147326 */   GIR_EraseRootFromParent_Done,
     /* 147327 */ // Label 1987: @147327
     /* 147327 */ GIM_Try, /*On fail goto*//*Label 1988*/ GIMT_Encode4(147426), // Rule ID 3074 //
     /* 147332 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 147335 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 147338 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 147342 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 147346 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 147350 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 147354 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 147358 */   // MIs[1] Operand 1
     /* 147358 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 147363 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 147365 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }))
     /* 147365 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 147368 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 147372 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147377 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 147381 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 147385 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 147387 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 147390 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 147394 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147399 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 147406 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 147411 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 147416 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 147419 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 147421 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147424 */   GIR_RootConstrainSelectedInstOperands,
     /* 147425 */   // GIR_Coverage, 3074,
     /* 147425 */   GIR_EraseRootFromParent_Done,
     /* 147426 */ // Label 1988: @147426
     /* 147426 */ GIM_Try, /*On fail goto*//*Label 1989*/ GIMT_Encode4(147525), // Rule ID 3082 //
     /* 147431 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 147434 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 147437 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 147441 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 147445 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 147449 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 147453 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 147457 */   // MIs[1] Operand 1
     /* 147457 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 147462 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 147464 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETGE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }))
     /* 147464 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 147467 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 147471 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147476 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 147480 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 147484 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 147486 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 147489 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 147493 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147498 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 147505 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 147510 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 147515 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 147518 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 147520 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147523 */   GIR_RootConstrainSelectedInstOperands,
     /* 147524 */   // GIR_Coverage, 3082,
     /* 147524 */   GIR_EraseRootFromParent_Done,
     /* 147525 */ // Label 1989: @147525
     /* 147525 */ GIM_Try, /*On fail goto*//*Label 1990*/ GIMT_Encode4(147624), // Rule ID 3090 //
     /* 147530 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 147533 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 147536 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 147540 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 147544 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 147548 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 147552 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 147556 */   // MIs[1] Operand 1
     /* 147556 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 147561 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 147563 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }))
     /* 147563 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 147566 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 147570 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147575 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 147579 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 147583 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 147585 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 147588 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 147592 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147597 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 147604 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 147609 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 147614 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 147617 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 147619 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147622 */   GIR_RootConstrainSelectedInstOperands,
     /* 147623 */   // GIR_Coverage, 3090,
     /* 147623 */   GIR_EraseRootFromParent_Done,
     /* 147624 */ // Label 1990: @147624
     /* 147624 */ GIM_Try, /*On fail goto*//*Label 1991*/ GIMT_Encode4(147723), // Rule ID 3098 //
     /* 147629 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 147632 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 147635 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 147639 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 147643 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 147647 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 147651 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 147655 */   // MIs[1] Operand 1
     /* 147655 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 147660 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 147662 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETLE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }))
     /* 147662 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 147665 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 147669 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147674 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 147678 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 147682 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 147684 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 147687 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 147691 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147696 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 147703 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 147708 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 147713 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 147716 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 147718 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147721 */   GIR_RootConstrainSelectedInstOperands,
     /* 147722 */   // GIR_Coverage, 3098,
     /* 147722 */   GIR_EraseRootFromParent_Done,
     /* 147723 */ // Label 1991: @147723
     /* 147723 */ GIM_Try, /*On fail goto*//*Label 1992*/ GIMT_Encode4(147822), // Rule ID 3106 //
     /* 147728 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 147731 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 147734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 147738 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 147742 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 147746 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 147750 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 147754 */   // MIs[1] Operand 1
     /* 147754 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 147759 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 147761 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETNE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_eq:{ *:[i32] }))
     /* 147761 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 147764 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 147768 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147773 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 147777 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 147781 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 147783 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 147786 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 147790 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147795 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 147802 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 147807 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 147812 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 147815 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 147817 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147820 */   GIR_RootConstrainSelectedInstOperands,
     /* 147821 */   // GIR_Coverage, 3106,
     /* 147821 */   GIR_EraseRootFromParent_Done,
     /* 147822 */ // Label 1992: @147822
     /* 147822 */ GIM_Try, /*On fail goto*//*Label 1993*/ GIMT_Encode4(147961), // Rule ID 3829 //
     /* 147827 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 147830 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 147833 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 147837 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 147841 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 147845 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 147849 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 147853 */   // MIs[1] Operand 1
     /* 147853 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 147858 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 147860 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 147860 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 147863 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 147867 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147872 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 147876 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 147880 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 147882 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 147885 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 147889 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147894 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 147897 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 147899 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 147902 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 147906 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147911 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 147914 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 147916 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 147919 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 147923 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147928 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 147935 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 147940 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 147945 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 147948 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147950 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147953 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 147956 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 147959 */   GIR_RootConstrainSelectedInstOperands,
     /* 147960 */   // GIR_Coverage, 3829,
     /* 147960 */   GIR_EraseRootFromParent_Done,
     /* 147961 */ // Label 1993: @147961
     /* 147961 */ GIM_Try, /*On fail goto*//*Label 1994*/ GIMT_Encode4(148100), // Rule ID 3837 //
     /* 147966 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 147969 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 147972 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 147976 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 147980 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 147984 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 147988 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 147992 */   // MIs[1] Operand 1
     /* 147992 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 147997 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 147999 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 147999 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 148002 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 148006 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148011 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 148015 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 148019 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 148021 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 148024 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 148028 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148033 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 148036 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 148038 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 148041 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 148045 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148050 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 148053 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 148055 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 148058 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 148062 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148067 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 148074 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 148079 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 148084 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 148087 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148089 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148092 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 148095 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 148098 */   GIR_RootConstrainSelectedInstOperands,
     /* 148099 */   // GIR_Coverage, 3837,
     /* 148099 */   GIR_EraseRootFromParent_Done,
     /* 148100 */ // Label 1994: @148100
     /* 148100 */ GIM_Try, /*On fail goto*//*Label 1995*/ GIMT_Encode4(148239), // Rule ID 3845 //
     /* 148105 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 148108 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 148111 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 148115 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 148119 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 148123 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 148127 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 148131 */   // MIs[1] Operand 1
     /* 148131 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 148136 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 148138 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 148138 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 148141 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 148145 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148150 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 148154 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 148158 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 148160 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 148163 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 148167 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148172 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 148175 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 148177 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 148180 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 148184 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148189 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 148192 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 148194 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 148197 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 148201 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148206 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 148213 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 148218 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 148223 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 148226 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148228 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148231 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 148234 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 148237 */   GIR_RootConstrainSelectedInstOperands,
     /* 148238 */   // GIR_Coverage, 3845,
     /* 148238 */   GIR_EraseRootFromParent_Done,
     /* 148239 */ // Label 1995: @148239
     /* 148239 */ GIM_Try, /*On fail goto*//*Label 1996*/ GIMT_Encode4(148378), // Rule ID 3853 //
     /* 148244 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 148247 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 148250 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 148254 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 148258 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 148262 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 148266 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 148270 */   // MIs[1] Operand 1
     /* 148270 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 148275 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 148277 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETLE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 148277 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 148280 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 148284 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148289 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 148293 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 148297 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 148299 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 148302 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 148306 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148311 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 148314 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 148316 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 148319 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 148323 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148328 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 148331 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 148333 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 148336 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 148340 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148345 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 148352 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 148357 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 148362 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 148365 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148367 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148370 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 148373 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 148376 */   GIR_RootConstrainSelectedInstOperands,
     /* 148377 */   // GIR_Coverage, 3853,
     /* 148377 */   GIR_EraseRootFromParent_Done,
     /* 148378 */ // Label 1996: @148378
     /* 148378 */ GIM_Try, /*On fail goto*//*Label 1997*/ GIMT_Encode4(148517), // Rule ID 3861 //
     /* 148383 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 148386 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 148389 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 148393 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 148397 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 148401 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 148405 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 148409 */   // MIs[1] Operand 1
     /* 148409 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 148414 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 148416 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 148416 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 148419 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 148423 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148428 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 148432 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 148436 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 148438 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 148441 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 148445 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148450 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 148453 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 148455 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 148458 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 148462 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148467 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 148470 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 148472 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 148475 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 148479 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148484 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 148491 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 148496 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 148501 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 148504 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148506 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148509 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 148512 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 148515 */   GIR_RootConstrainSelectedInstOperands,
     /* 148516 */   // GIR_Coverage, 3861,
     /* 148516 */   GIR_EraseRootFromParent_Done,
     /* 148517 */ // Label 1997: @148517
     /* 148517 */ GIM_Try, /*On fail goto*//*Label 1998*/ GIMT_Encode4(148656), // Rule ID 3925 //
     /* 148522 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 148525 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 148528 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 148532 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 148536 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 148540 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 148544 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 148548 */   // MIs[1] Operand 1
     /* 148548 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 148553 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 148555 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 148555 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 148558 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 148562 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148567 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 148571 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 148575 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 148577 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 148580 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 148584 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148589 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 148592 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 148594 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 148597 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 148601 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148606 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 148609 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 148611 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 148614 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 148618 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148623 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 148630 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 148635 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 148640 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 148643 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148645 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148648 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 148651 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 148654 */   GIR_RootConstrainSelectedInstOperands,
     /* 148655 */   // GIR_Coverage, 3925,
     /* 148655 */   GIR_EraseRootFromParent_Done,
     /* 148656 */ // Label 1998: @148656
     /* 148656 */ GIM_Try, /*On fail goto*//*Label 1999*/ GIMT_Encode4(148795), // Rule ID 3933 //
     /* 148661 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 148664 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 148667 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 148671 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 148675 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 148679 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 148683 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 148687 */   // MIs[1] Operand 1
     /* 148687 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 148692 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 148694 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 148694 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 148697 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 148701 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148706 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 148710 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 148714 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 148716 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 148719 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 148723 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148728 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 148731 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 148733 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 148736 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 148740 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148745 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 148748 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 148750 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 148753 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 148757 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148762 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 148769 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 148774 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 148779 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 148782 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148784 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148787 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 148790 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 148793 */   GIR_RootConstrainSelectedInstOperands,
     /* 148794 */   // GIR_Coverage, 3933,
     /* 148794 */   GIR_EraseRootFromParent_Done,
     /* 148795 */ // Label 1999: @148795
     /* 148795 */ GIM_Try, /*On fail goto*//*Label 2000*/ GIMT_Encode4(148934), // Rule ID 3941 //
     /* 148800 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 148803 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 148806 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 148810 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 148814 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 148818 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 148822 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 148826 */   // MIs[1] Operand 1
     /* 148826 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 148831 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 148833 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 148833 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 148836 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 148840 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148845 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 148849 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 148853 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 148855 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 148858 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 148862 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148867 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 148870 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 148872 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 148875 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 148879 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148884 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 148887 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 148889 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 148892 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 148896 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148901 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 148908 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 148913 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 148918 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 148921 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148923 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148926 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 148929 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 148932 */   GIR_RootConstrainSelectedInstOperands,
     /* 148933 */   // GIR_Coverage, 3941,
     /* 148933 */   GIR_EraseRootFromParent_Done,
     /* 148934 */ // Label 2000: @148934
     /* 148934 */ GIM_Try, /*On fail goto*//*Label 2001*/ GIMT_Encode4(149073), // Rule ID 3949 //
     /* 148939 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 148942 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 148945 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 148949 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 148953 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 148957 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 148961 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 148965 */   // MIs[1] Operand 1
     /* 148965 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 148970 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 148972 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETLE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 148972 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 148975 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 148979 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148984 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 148988 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 148992 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 148994 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 148997 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 149001 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149006 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 149009 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 149011 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 149014 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 149018 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149023 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 149026 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 149028 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 149031 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149035 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149040 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 149047 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 149052 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 149057 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 149060 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149062 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149065 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 149068 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 149071 */   GIR_RootConstrainSelectedInstOperands,
     /* 149072 */   // GIR_Coverage, 3949,
     /* 149072 */   GIR_EraseRootFromParent_Done,
     /* 149073 */ // Label 2001: @149073
     /* 149073 */ GIM_Try, /*On fail goto*//*Label 2002*/ GIMT_Encode4(149212), // Rule ID 3957 //
     /* 149078 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 149081 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 149084 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 149088 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 149092 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 149096 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 149100 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 149104 */   // MIs[1] Operand 1
     /* 149104 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 149109 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 149111 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 149111 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 149114 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 149118 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149123 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 149127 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 149131 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 149133 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 149136 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 149140 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149145 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 149148 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 149150 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 149153 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 149157 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149162 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 149165 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 149167 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 149170 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149174 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149179 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 149186 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 149191 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 149196 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 149199 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149201 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149204 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 149207 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 149210 */   GIR_RootConstrainSelectedInstOperands,
     /* 149211 */   // GIR_Coverage, 3957,
     /* 149211 */   GIR_EraseRootFromParent_Done,
     /* 149212 */ // Label 2002: @149212
     /* 149212 */ GIM_Try, /*On fail goto*//*Label 2003*/ GIMT_Encode4(149234), // Rule ID 2978 //
     /* 149217 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 149220 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 149223 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 149227 */   // (zext:{ *:[i64] } i1:{ *:[i1] }:$in)  =>  (SETBC8:{ *:[i64] } ?:{ *:[i1] }:$in)
     /* 149227 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SETBC8),
     /* 149232 */   GIR_RootConstrainSelectedInstOperands,
     /* 149233 */   // GIR_Coverage, 2978,
     /* 149233 */   GIR_Done,
     /* 149234 */ // Label 2003: @149234
     /* 149234 */ GIM_Try, /*On fail goto*//*Label 2004*/ GIMT_Encode4(149295), // Rule ID 3635 //
     /* 149239 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 149242 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 149246 */   // (zext:{ *:[i64] } i1:{ *:[i1] }:$in)  =>  (SELECT_I8:{ *:[i64] } ?:{ *:[i1] }:$in, (LI8:{ *:[i64] } 1:{ *:[i64] }), (LI8:{ *:[i64] } 0:{ *:[i64] }))
     /* 149246 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 149249 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 149253 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149258 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 149261 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 149263 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 149266 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 149270 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149275 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 149278 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149280 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 149283 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149285 */   GIR_RootToRootCopy, /*OpIdx*/1, // in
     /* 149287 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149290 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 149293 */   GIR_RootConstrainSelectedInstOperands,
     /* 149294 */   // GIR_Coverage, 3635,
     /* 149294 */   GIR_EraseRootFromParent_Done,
     /* 149295 */ // Label 2004: @149295
     /* 149295 */ GIM_Reject,
     /* 149296 */ // Label 1818: @149296
     /* 149296 */ GIM_Reject,
     /* 149297 */ // Label 27: @149297
     /* 149297 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(8), /*)*//*default:*//*Label 2012*/ GIMT_Encode4(149652),
     /* 149308 */ /*GILLT_s32*//*Label 2005*/ GIMT_Encode4(149336),
     /* 149312 */ /*GILLT_s64*//*Label 2006*/ GIMT_Encode4(149359),
     /* 149316 */ /*GILLT_s128*//*Label 2007*/ GIMT_Encode4(149382),
     /* 149320 */ /*GILLT_v2s64*//*Label 2008*/ GIMT_Encode4(149548),
     /* 149324 */ /*GILLT_v4s32*//*Label 2009*/ GIMT_Encode4(149574),
     /* 149328 */ /*GILLT_v8s16*//*Label 2010*/ GIMT_Encode4(149600),
     /* 149332 */ /*GILLT_v16s8*//*Label 2011*/ GIMT_Encode4(149626),
     /* 149336 */ // Label 2005: @149336
     /* 149336 */ GIM_Try, /*On fail goto*//*Label 2013*/ GIMT_Encode4(149358), // Rule ID 1251 //
     /* 149341 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 149344 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 149347 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 149351 */   // (shl:{ *:[i32] } i32:{ *:[i32] }:$rS, i32:{ *:[i32] }:$rB)  =>  (SLW:{ *:[i32] } ?:{ *:[i32] }:$rS, ?:{ *:[i32] }:$rB)
     /* 149351 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SLW),
     /* 149356 */   GIR_RootConstrainSelectedInstOperands,
     /* 149357 */   // GIR_Coverage, 1251,
     /* 149357 */   GIR_Done,
     /* 149358 */ // Label 2013: @149358
     /* 149358 */ GIM_Reject,
     /* 149359 */ // Label 2006: @149359
     /* 149359 */ GIM_Try, /*On fail goto*//*Label 2014*/ GIMT_Encode4(149381), // Rule ID 1532 //
     /* 149364 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 149367 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 149370 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 149374 */   // (shl:{ *:[i64] } i64:{ *:[i64] }:$rS, i32:{ *:[i32] }:$rB)  =>  (SLD:{ *:[i64] } ?:{ *:[i64] }:$rS, ?:{ *:[i32] }:$rB)
     /* 149374 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SLD),
     /* 149379 */   GIR_RootConstrainSelectedInstOperands,
     /* 149380 */   // GIR_Coverage, 1532,
     /* 149380 */   GIR_Done,
     /* 149381 */ // Label 2014: @149381
     /* 149381 */ GIM_Reject,
     /* 149382 */ // Label 2007: @149382
     /* 149382 */ GIM_Try, /*On fail goto*//*Label 2015*/ GIMT_Encode4(149547),
     /* 149387 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 149390 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /* 149393 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 149397 */   GIM_Try, /*On fail goto*//*Label 2016*/ GIMT_Encode4(149482), // Rule ID 3365 //
     /* 149402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX_IsISA3_1),
     /* 149405 */     // (shl:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VRA, v1i128:{ *:[v1i128] }:$VRB)  =>  (VSLQ:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VRA, (XXPERMDI:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v1i128] }:$VRB, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v1i128] }:$VRB, VSRC:{ *:[i32] }), 2:{ *:[i32] }))
     /* 149405 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 149408 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149412 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149417 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // VRB
     /* 149421 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /* 149426 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 149429 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149433 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149438 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // VRB
     /* 149442 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /* 149447 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 149450 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXPERMDI),
     /* 149454 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149459 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 149462 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 149465 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/2,
     /* 149468 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSLQ),
     /* 149473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /* 149475 */     GIR_RootToRootCopy, /*OpIdx*/1, // VRA
     /* 149477 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149480 */     GIR_RootConstrainSelectedInstOperands,
     /* 149481 */     // GIR_Coverage, 3365,
     /* 149481 */     GIR_EraseRootFromParent_Done,
     /* 149482 */   // Label 2016: @149482
     /* 149482 */   GIM_Try, /*On fail goto*//*Label 2017*/ GIMT_Encode4(149546), // Rule ID 1390 //
     /* 149487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 149490 */     // (shl:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$vA, v1i128:{ *:[v1i128] }:$vB)  =>  (VSL:{ *:[v1i128] } (VSLO:{ *:[v16i8] } ?:{ *:[v1i128] }:$vA, ?:{ *:[v1i128] }:$vB), (VSPLTB:{ *:[v16i8] } 15:{ *:[i32] }, ?:{ *:[v1i128] }:$vB))
     /* 149490 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 149493 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::VSPLTB),
     /* 149497 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149502 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/15,
     /* 149505 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // vB
     /* 149509 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 149511 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 149514 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::VSLO),
     /* 149518 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149523 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vA
     /* 149527 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vB
     /* 149531 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSL),
     /* 149536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /* 149538 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149541 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 149544 */     GIR_RootConstrainSelectedInstOperands,
     /* 149545 */     // GIR_Coverage, 1390,
     /* 149545 */     GIR_EraseRootFromParent_Done,
     /* 149546 */   // Label 2017: @149546
     /* 149546 */   GIM_Reject,
     /* 149547 */ // Label 2015: @149547
     /* 149547 */ GIM_Reject,
     /* 149548 */ // Label 2008: @149548
     /* 149548 */ GIM_Try, /*On fail goto*//*Label 2018*/ GIMT_Encode4(149573), // Rule ID 1438 //
     /* 149553 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /* 149556 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 149559 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 149562 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 149566 */   // (shl:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$vA, v2i64:{ *:[v2i64] }:$vB)  =>  (VSLD:{ *:[v2i64] } ?:{ *:[v2i64] }:$vA, ?:{ *:[v2i64] }:$vB)
     /* 149566 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSLD),
     /* 149571 */   GIR_RootConstrainSelectedInstOperands,
     /* 149572 */   // GIR_Coverage, 1438,
     /* 149572 */   GIR_Done,
     /* 149573 */ // Label 2018: @149573
     /* 149573 */ GIM_Reject,
     /* 149574 */ // Label 2009: @149574
     /* 149574 */ GIM_Try, /*On fail goto*//*Label 2019*/ GIMT_Encode4(149599), // Rule ID 1389 //
     /* 149579 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 149582 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 149585 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 149588 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 149592 */   // (shl:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)  =>  (VSLW:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB)
     /* 149592 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSLW),
     /* 149597 */   GIR_RootConstrainSelectedInstOperands,
     /* 149598 */   // GIR_Coverage, 1389,
     /* 149598 */   GIR_Done,
     /* 149599 */ // Label 2019: @149599
     /* 149599 */ GIM_Reject,
     /* 149600 */ // Label 2010: @149600
     /* 149600 */ GIM_Try, /*On fail goto*//*Label 2020*/ GIMT_Encode4(149625), // Rule ID 1388 //
     /* 149605 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 149608 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 149611 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 149614 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 149618 */   // (shl:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$vA, v8i16:{ *:[v8i16] }:$vB)  =>  (VSLH:{ *:[v8i16] } ?:{ *:[v8i16] }:$vA, ?:{ *:[v8i16] }:$vB)
     /* 149618 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSLH),
     /* 149623 */   GIR_RootConstrainSelectedInstOperands,
     /* 149624 */   // GIR_Coverage, 1388,
     /* 149624 */   GIR_Done,
     /* 149625 */ // Label 2020: @149625
     /* 149625 */ GIM_Reject,
     /* 149626 */ // Label 2011: @149626
     /* 149626 */ GIM_Try, /*On fail goto*//*Label 2021*/ GIMT_Encode4(149651), // Rule ID 1387 //
     /* 149631 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 149634 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 149637 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 149640 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 149644 */   // (shl:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$vA, v16i8:{ *:[v16i8] }:$vB)  =>  (VSLB:{ *:[v16i8] } ?:{ *:[v16i8] }:$vA, ?:{ *:[v16i8] }:$vB)
     /* 149644 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSLB),
     /* 149649 */   GIR_RootConstrainSelectedInstOperands,
     /* 149650 */   // GIR_Coverage, 1387,
     /* 149650 */   GIR_Done,
     /* 149651 */ // Label 2021: @149651
     /* 149651 */ GIM_Reject,
     /* 149652 */ // Label 2012: @149652
     /* 149652 */ GIM_Reject,
     /* 149653 */ // Label 28: @149653
     /* 149653 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(8), /*)*//*default:*//*Label 2029*/ GIMT_Encode4(150074),
     /* 149664 */ /*GILLT_s32*//*Label 2022*/ GIMT_Encode4(149692),
     /* 149668 */ /*GILLT_s64*//*Label 2023*/ GIMT_Encode4(149781),
     /* 149672 */ /*GILLT_s128*//*Label 2024*/ GIMT_Encode4(149804),
     /* 149676 */ /*GILLT_v2s64*//*Label 2025*/ GIMT_Encode4(149970),
     /* 149680 */ /*GILLT_v4s32*//*Label 2026*/ GIMT_Encode4(149996),
     /* 149684 */ /*GILLT_v8s16*//*Label 2027*/ GIMT_Encode4(150022),
     /* 149688 */ /*GILLT_v16s8*//*Label 2028*/ GIMT_Encode4(150048),
     /* 149692 */ // Label 2022: @149692
     /* 149692 */ GIM_Try, /*On fail goto*//*Label 2030*/ GIMT_Encode4(149780),
     /* 149697 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 149700 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 149703 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 149707 */   GIM_Try, /*On fail goto*//*Label 2031*/ GIMT_Encode4(149767), // Rule ID 3345 //
     /* 149712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 149715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 149719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 149723 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 149727 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 149731 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 149733 */     // (srl:{ *:[i32] } (bswap:{ *:[i32] } i32:{ *:[i32] }:$RS), 16:{ *:[i32] })  =>  (RLDICL_32:{ *:[i32] } (BRH:{ *:[i32] } ?:{ *:[i32] }:$RS), 0:{ *:[i32] }, 48:{ *:[i32] })
     /* 149733 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 149736 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::BRH),
     /* 149740 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149745 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // RS
     /* 149749 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL_32),
     /* 149754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 149756 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 149762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/48,
     /* 149765 */     GIR_RootConstrainSelectedInstOperands,
     /* 149766 */     // GIR_Coverage, 3345,
     /* 149766 */     GIR_EraseRootFromParent_Done,
     /* 149767 */   // Label 2031: @149767
     /* 149767 */   GIM_Try, /*On fail goto*//*Label 2032*/ GIMT_Encode4(149779), // Rule ID 1250 //
     /* 149772 */     // (srl:{ *:[i32] } i32:{ *:[i32] }:$rS, i32:{ *:[i32] }:$rB)  =>  (SRW:{ *:[i32] } ?:{ *:[i32] }:$rS, ?:{ *:[i32] }:$rB)
     /* 149772 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SRW),
     /* 149777 */     GIR_RootConstrainSelectedInstOperands,
     /* 149778 */     // GIR_Coverage, 1250,
     /* 149778 */     GIR_Done,
     /* 149779 */   // Label 2032: @149779
     /* 149779 */   GIM_Reject,
     /* 149780 */ // Label 2030: @149780
     /* 149780 */ GIM_Reject,
     /* 149781 */ // Label 2023: @149781
     /* 149781 */ GIM_Try, /*On fail goto*//*Label 2033*/ GIMT_Encode4(149803), // Rule ID 1531 //
     /* 149786 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 149789 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 149792 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 149796 */   // (srl:{ *:[i64] } i64:{ *:[i64] }:$rS, i32:{ *:[i32] }:$rB)  =>  (SRD:{ *:[i64] } ?:{ *:[i64] }:$rS, ?:{ *:[i32] }:$rB)
     /* 149796 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SRD),
     /* 149801 */   GIR_RootConstrainSelectedInstOperands,
     /* 149802 */   // GIR_Coverage, 1531,
     /* 149802 */   GIR_Done,
     /* 149803 */ // Label 2033: @149803
     /* 149803 */ GIM_Reject,
     /* 149804 */ // Label 2024: @149804
     /* 149804 */ GIM_Try, /*On fail goto*//*Label 2034*/ GIMT_Encode4(149969),
     /* 149809 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 149812 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /* 149815 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 149819 */   GIM_Try, /*On fail goto*//*Label 2035*/ GIMT_Encode4(149904), // Rule ID 3367 //
     /* 149824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX_IsISA3_1),
     /* 149827 */     // (srl:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VRA, v1i128:{ *:[v1i128] }:$VRB)  =>  (VSRQ:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VRA, (XXPERMDI:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v1i128] }:$VRB, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v1i128] }:$VRB, VSRC:{ *:[i32] }), 2:{ *:[i32] }))
     /* 149827 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 149830 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149834 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149839 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // VRB
     /* 149843 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /* 149848 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 149851 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149855 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149860 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // VRB
     /* 149864 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /* 149869 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 149872 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXPERMDI),
     /* 149876 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149881 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 149884 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 149887 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/2,
     /* 149890 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSRQ),
     /* 149895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /* 149897 */     GIR_RootToRootCopy, /*OpIdx*/1, // VRA
     /* 149899 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149902 */     GIR_RootConstrainSelectedInstOperands,
     /* 149903 */     // GIR_Coverage, 3367,
     /* 149903 */     GIR_EraseRootFromParent_Done,
     /* 149904 */   // Label 2035: @149904
     /* 149904 */   GIM_Try, /*On fail goto*//*Label 2036*/ GIMT_Encode4(149968), // Rule ID 1398 //
     /* 149909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 149912 */     // (srl:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$vA, v1i128:{ *:[v1i128] }:$vB)  =>  (VSR:{ *:[v1i128] } (VSRO:{ *:[v16i8] } ?:{ *:[v1i128] }:$vA, ?:{ *:[v1i128] }:$vB), (VSPLTB:{ *:[v16i8] } 15:{ *:[i32] }, ?:{ *:[v1i128] }:$vB))
     /* 149912 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 149915 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::VSPLTB),
     /* 149919 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149924 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/15,
     /* 149927 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // vB
     /* 149931 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 149933 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 149936 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::VSRO),
     /* 149940 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149945 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vA
     /* 149949 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vB
     /* 149953 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSR),
     /* 149958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /* 149960 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149963 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 149966 */     GIR_RootConstrainSelectedInstOperands,
     /* 149967 */     // GIR_Coverage, 1398,
     /* 149967 */     GIR_EraseRootFromParent_Done,
     /* 149968 */   // Label 2036: @149968
     /* 149968 */   GIM_Reject,
     /* 149969 */ // Label 2034: @149969
     /* 149969 */ GIM_Reject,
     /* 149970 */ // Label 2025: @149970
     /* 149970 */ GIM_Try, /*On fail goto*//*Label 2037*/ GIMT_Encode4(149995), // Rule ID 1440 //
     /* 149975 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /* 149978 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 149981 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 149984 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 149988 */   // (srl:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$vA, v2i64:{ *:[v2i64] }:$vB)  =>  (VSRD:{ *:[v2i64] } ?:{ *:[v2i64] }:$vA, ?:{ *:[v2i64] }:$vB)
     /* 149988 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSRD),
     /* 149993 */   GIR_RootConstrainSelectedInstOperands,
     /* 149994 */   // GIR_Coverage, 1440,
     /* 149994 */   GIR_Done,
     /* 149995 */ // Label 2037: @149995
     /* 149995 */ GIM_Reject,
     /* 149996 */ // Label 2026: @149996
     /* 149996 */ GIM_Try, /*On fail goto*//*Label 2038*/ GIMT_Encode4(150021), // Rule ID 1397 //
     /* 150001 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 150004 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 150007 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 150010 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 150014 */   // (srl:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)  =>  (VSRW:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB)
     /* 150014 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSRW),
     /* 150019 */   GIR_RootConstrainSelectedInstOperands,
     /* 150020 */   // GIR_Coverage, 1397,
     /* 150020 */   GIR_Done,
     /* 150021 */ // Label 2038: @150021
     /* 150021 */ GIM_Reject,
     /* 150022 */ // Label 2027: @150022
     /* 150022 */ GIM_Try, /*On fail goto*//*Label 2039*/ GIMT_Encode4(150047), // Rule ID 1396 //
     /* 150027 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 150030 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 150033 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 150036 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 150040 */   // (srl:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$vA, v8i16:{ *:[v8i16] }:$vB)  =>  (VSRH:{ *:[v8i16] } ?:{ *:[v8i16] }:$vA, ?:{ *:[v8i16] }:$vB)
     /* 150040 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSRH),
     /* 150045 */   GIR_RootConstrainSelectedInstOperands,
     /* 150046 */   // GIR_Coverage, 1396,
     /* 150046 */   GIR_Done,
     /* 150047 */ // Label 2039: @150047
     /* 150047 */ GIM_Reject,
     /* 150048 */ // Label 2028: @150048
     /* 150048 */ GIM_Try, /*On fail goto*//*Label 2040*/ GIMT_Encode4(150073), // Rule ID 1395 //
     /* 150053 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 150056 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 150059 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 150062 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 150066 */   // (srl:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$vA, v16i8:{ *:[v16i8] }:$vB)  =>  (VSRB:{ *:[v16i8] } ?:{ *:[v16i8] }:$vA, ?:{ *:[v16i8] }:$vB)
     /* 150066 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSRB),
     /* 150071 */   GIR_RootConstrainSelectedInstOperands,
     /* 150072 */   // GIR_Coverage, 1395,
     /* 150072 */   GIR_Done,
     /* 150073 */ // Label 2040: @150073
     /* 150073 */ GIM_Reject,
     /* 150074 */ // Label 2029: @150074
     /* 150074 */ GIM_Reject,
     /* 150075 */ // Label 29: @150075
     /* 150075 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(8), /*)*//*default:*//*Label 2048*/ GIMT_Encode4(150444),
     /* 150086 */ /*GILLT_s32*//*Label 2041*/ GIMT_Encode4(150114),
     /* 150090 */ /*GILLT_s64*//*Label 2042*/ GIMT_Encode4(150179),
     /* 150094 */ /*GILLT_s128*//*Label 2043*/ GIMT_Encode4(150244),
     /* 150098 */ /*GILLT_v2s64*//*Label 2044*/ GIMT_Encode4(150340),
     /* 150102 */ /*GILLT_v4s32*//*Label 2045*/ GIMT_Encode4(150366),
     /* 150106 */ /*GILLT_v8s16*//*Label 2046*/ GIMT_Encode4(150392),
     /* 150110 */ /*GILLT_v16s8*//*Label 2047*/ GIMT_Encode4(150418),
     /* 150114 */ // Label 2041: @150114
     /* 150114 */ GIM_Try, /*On fail goto*//*Label 2049*/ GIMT_Encode4(150178),
     /* 150119 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 150122 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 150125 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 150129 */   GIM_Try, /*On fail goto*//*Label 2050*/ GIMT_Encode4(150159), // Rule ID 132 //
     /* 150134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 150138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 150142 */     // MIs[1] Operand 1
     /* 150142 */     // No operand predicates
     /* 150142 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150144 */     // (sra:{ *:[i32] } i32:{ *:[i32] }:$RST, (imm:{ *:[i32] }):$RB)  =>  (SRAWI:{ *:[i32] }:{ *:[i32] } i32:{ *:[i32] }:$RST, (imm:{ *:[i32] }):$RB)
     /* 150144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SRAWI),
     /* 150147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 150149 */     GIR_RootToRootCopy, /*OpIdx*/1, // RST
     /* 150151 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // RB
     /* 150154 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CARRY*/0,
     /* 150157 */     GIR_RootConstrainSelectedInstOperands,
     /* 150158 */     // GIR_Coverage, 132,
     /* 150158 */     GIR_EraseRootFromParent_Done,
     /* 150159 */   // Label 2050: @150159
     /* 150159 */   GIM_Try, /*On fail goto*//*Label 2051*/ GIMT_Encode4(150177), // Rule ID 1249 //
     /* 150164 */     // (sra:{ *:[i32] } i32:{ *:[i32] }:$rS, i32:{ *:[i32] }:$rB)  =>  (SRAW:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$rS, ?:{ *:[i32] }:$rB)
     /* 150164 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SRAW),
     /* 150169 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(PPC::CARRY), GIMT_Encode2(RegState::Dead),
     /* 150175 */     GIR_RootConstrainSelectedInstOperands,
     /* 150176 */     // GIR_Coverage, 1249,
     /* 150176 */     GIR_Done,
     /* 150177 */   // Label 2051: @150177
     /* 150177 */   GIM_Reject,
     /* 150178 */ // Label 2049: @150178
     /* 150178 */ GIM_Reject,
     /* 150179 */ // Label 2042: @150179
     /* 150179 */ GIM_Try, /*On fail goto*//*Label 2052*/ GIMT_Encode4(150243),
     /* 150184 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 150187 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 150190 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 150194 */   GIM_Try, /*On fail goto*//*Label 2053*/ GIMT_Encode4(150224), // Rule ID 681 //
     /* 150199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 150203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 150207 */     // MIs[1] Operand 1
     /* 150207 */     // No operand predicates
     /* 150207 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150209 */     // (sra:{ *:[i64] } i64:{ *:[i64] }:$RS, (imm:{ *:[i32] }):$SH)  =>  (SRADI:{ *:[i64] }:{ *:[i32] } i64:{ *:[i64] }:$RS, (imm:{ *:[i32] }):$SH)
     /* 150209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SRADI),
     /* 150212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 150214 */     GIR_RootToRootCopy, /*OpIdx*/1, // RS
     /* 150216 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SH
     /* 150219 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CARRY*/0,
     /* 150222 */     GIR_RootConstrainSelectedInstOperands,
     /* 150223 */     // GIR_Coverage, 681,
     /* 150223 */     GIR_EraseRootFromParent_Done,
     /* 150224 */   // Label 2053: @150224
     /* 150224 */   GIM_Try, /*On fail goto*//*Label 2054*/ GIMT_Encode4(150242), // Rule ID 1530 //
     /* 150229 */     // (sra:{ *:[i64] } i64:{ *:[i64] }:$rS, i32:{ *:[i32] }:$rB)  =>  (SRAD:{ *:[i64] }:{ *:[i32] } ?:{ *:[i64] }:$rS, ?:{ *:[i32] }:$rB)
     /* 150229 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SRAD),
     /* 150234 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(PPC::CARRY), GIMT_Encode2(RegState::Dead),
     /* 150240 */     GIR_RootConstrainSelectedInstOperands,
     /* 150241 */     // GIR_Coverage, 1530,
     /* 150241 */     GIR_Done,
     /* 150242 */   // Label 2054: @150242
     /* 150242 */   GIM_Reject,
     /* 150243 */ // Label 2052: @150243
     /* 150243 */ GIM_Reject,
     /* 150244 */ // Label 2043: @150244
     /* 150244 */ GIM_Try, /*On fail goto*//*Label 2055*/ GIMT_Encode4(150339), // Rule ID 3369 //
     /* 150249 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX_IsISA3_1),
     /* 150252 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 150255 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /* 150258 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 150262 */   // (sra:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VRA, v1i128:{ *:[v1i128] }:$VRB)  =>  (VSRAQ:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VRA, (XXPERMDI:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v1i128] }:$VRB, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v1i128] }:$VRB, VSRC:{ *:[i32] }), 2:{ *:[i32] }))
     /* 150262 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 150265 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 150269 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150274 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // VRB
     /* 150278 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /* 150283 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 150286 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 150290 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150295 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // VRB
     /* 150299 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /* 150304 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 150307 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXPERMDI),
     /* 150311 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150316 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 150319 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 150322 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/2,
     /* 150325 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 150327 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSRAQ),
     /* 150330 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /* 150332 */   GIR_RootToRootCopy, /*OpIdx*/1, // VRA
     /* 150334 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150337 */   GIR_RootConstrainSelectedInstOperands,
     /* 150338 */   // GIR_Coverage, 3369,
     /* 150338 */   GIR_EraseRootFromParent_Done,
     /* 150339 */ // Label 2055: @150339
     /* 150339 */ GIM_Reject,
     /* 150340 */ // Label 2044: @150340
     /* 150340 */ GIM_Try, /*On fail goto*//*Label 2056*/ GIMT_Encode4(150365), // Rule ID 1442 //
     /* 150345 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /* 150348 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 150351 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 150354 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 150358 */   // (sra:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$vA, v2i64:{ *:[v2i64] }:$vB)  =>  (VSRAD:{ *:[v2i64] } ?:{ *:[v2i64] }:$vA, ?:{ *:[v2i64] }:$vB)
     /* 150358 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSRAD),
     /* 150363 */   GIR_RootConstrainSelectedInstOperands,
     /* 150364 */   // GIR_Coverage, 1442,
     /* 150364 */   GIR_Done,
     /* 150365 */ // Label 2056: @150365
     /* 150365 */ GIM_Reject,
     /* 150366 */ // Label 2045: @150366
     /* 150366 */ GIM_Try, /*On fail goto*//*Label 2057*/ GIMT_Encode4(150391), // Rule ID 1405 //
     /* 150371 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 150374 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 150377 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 150380 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 150384 */   // (sra:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)  =>  (VSRAW:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB)
     /* 150384 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSRAW),
     /* 150389 */   GIR_RootConstrainSelectedInstOperands,
     /* 150390 */   // GIR_Coverage, 1405,
     /* 150390 */   GIR_Done,
     /* 150391 */ // Label 2057: @150391
     /* 150391 */ GIM_Reject,
     /* 150392 */ // Label 2046: @150392
     /* 150392 */ GIM_Try, /*On fail goto*//*Label 2058*/ GIMT_Encode4(150417), // Rule ID 1404 //
     /* 150397 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 150400 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 150403 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 150406 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 150410 */   // (sra:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$vA, v8i16:{ *:[v8i16] }:$vB)  =>  (VSRAH:{ *:[v8i16] } ?:{ *:[v8i16] }:$vA, ?:{ *:[v8i16] }:$vB)
     /* 150410 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSRAH),
     /* 150415 */   GIR_RootConstrainSelectedInstOperands,
     /* 150416 */   // GIR_Coverage, 1404,
     /* 150416 */   GIR_Done,
     /* 150417 */ // Label 2058: @150417
     /* 150417 */ GIM_Reject,
     /* 150418 */ // Label 2047: @150418
     /* 150418 */ GIM_Try, /*On fail goto*//*Label 2059*/ GIMT_Encode4(150443), // Rule ID 1403 //
     /* 150423 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 150426 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 150429 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 150432 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 150436 */   // (sra:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$vA, v16i8:{ *:[v16i8] }:$vB)  =>  (VSRAB:{ *:[v16i8] } ?:{ *:[v16i8] }:$vA, ?:{ *:[v16i8] }:$vB)
     /* 150436 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSRAB),
     /* 150441 */   GIR_RootConstrainSelectedInstOperands,
     /* 150442 */   // GIR_Coverage, 1403,
     /* 150442 */   GIR_Done,
     /* 150443 */ // Label 2059: @150443
     /* 150443 */ GIM_Reject,
     /* 150444 */ // Label 2048: @150444
     /* 150444 */ GIM_Reject,
     /* 150445 */ // Label 30: @150445
     /* 150445 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(8), /*)*//*default:*//*Label 2067*/ GIMT_Encode4(150752),
     /* 150456 */ /*GILLT_s32*//*Label 2060*/ GIMT_Encode4(150484),
     /* 150460 */ /*GILLT_s64*//*Label 2061*/ GIMT_Encode4(150556),
     /* 150464 */ /*GILLT_s128*//*Label 2062*/ GIMT_Encode4(150622),
     /* 150468 */ /*GILLT_v2s64*//*Label 2063*/ GIMT_Encode4(150648),
     /* 150472 */ /*GILLT_v4s32*//*Label 2064*/ GIMT_Encode4(150674),
     /* 150476 */ /*GILLT_v8s16*//*Label 2065*/ GIMT_Encode4(150700),
     /* 150480 */ /*GILLT_v16s8*//*Label 2066*/ GIMT_Encode4(150726),
     /* 150484 */ // Label 2060: @150484
     /* 150484 */ GIM_Try, /*On fail goto*//*Label 2068*/ GIMT_Encode4(150555),
     /* 150489 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 150492 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 150495 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 150499 */   GIM_Try, /*On fail goto*//*Label 2069*/ GIMT_Encode4(150532), // Rule ID 1215 //
     /* 150504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 150508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 150512 */     // MIs[1] Operand 1
     /* 150512 */     // No operand predicates
     /* 150512 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150514 */     // (rotl:{ *:[i32] } i32:{ *:[i32] }:$in, (imm:{ *:[i32] }):$imm)  =>  (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$in, (imm:{ *:[i32] }):$imm, 0:{ *:[i32] }, 31:{ *:[i32] })
     /* 150514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 150517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 150519 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /* 150521 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 150524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 150527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 150530 */     GIR_RootConstrainSelectedInstOperands,
     /* 150531 */     // GIR_Coverage, 1215,
     /* 150531 */     GIR_EraseRootFromParent_Done,
     /* 150532 */   // Label 2069: @150532
     /* 150532 */   GIM_Try, /*On fail goto*//*Label 2070*/ GIMT_Encode4(150554), // Rule ID 1214 //
     /* 150537 */     // (rotl:{ *:[i32] } i32:{ *:[i32] }:$in, i32:{ *:[i32] }:$sh)  =>  (RLWNM:{ *:[i32] } ?:{ *:[i32] }:$in, ?:{ *:[i32] }:$sh, 0:{ *:[i32] }, 31:{ *:[i32] })
     /* 150537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWNM),
     /* 150540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 150542 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /* 150544 */     GIR_RootToRootCopy, /*OpIdx*/2, // sh
     /* 150546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 150549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 150552 */     GIR_RootConstrainSelectedInstOperands,
     /* 150553 */     // GIR_Coverage, 1214,
     /* 150553 */     GIR_EraseRootFromParent_Done,
     /* 150554 */   // Label 2070: @150554
     /* 150554 */   GIM_Reject,
     /* 150555 */ // Label 2068: @150555
     /* 150555 */ GIM_Reject,
     /* 150556 */ // Label 2061: @150556
     /* 150556 */ GIM_Try, /*On fail goto*//*Label 2071*/ GIMT_Encode4(150621),
     /* 150561 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 150564 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 150567 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 150571 */   GIM_Try, /*On fail goto*//*Label 2072*/ GIMT_Encode4(150601), // Rule ID 1537 //
     /* 150576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 150580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 150584 */     // MIs[1] Operand 1
     /* 150584 */     // No operand predicates
     /* 150584 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150586 */     // (rotl:{ *:[i64] } i64:{ *:[i64] }:$in, (imm:{ *:[i32] }):$imm)  =>  (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$in, (imm:{ *:[i32] }):$imm, 0:{ *:[i32] })
     /* 150586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 150589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 150591 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /* 150593 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 150596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 150599 */     GIR_RootConstrainSelectedInstOperands,
     /* 150600 */     // GIR_Coverage, 1537,
     /* 150600 */     GIR_EraseRootFromParent_Done,
     /* 150601 */   // Label 2072: @150601
     /* 150601 */   GIM_Try, /*On fail goto*//*Label 2073*/ GIMT_Encode4(150620), // Rule ID 1536 //
     /* 150606 */     // (rotl:{ *:[i64] } i64:{ *:[i64] }:$in, i32:{ *:[i32] }:$sh)  =>  (RLDCL:{ *:[i64] } ?:{ *:[i64] }:$in, ?:{ *:[i32] }:$sh, 0:{ *:[i32] })
     /* 150606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDCL),
     /* 150609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 150611 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /* 150613 */     GIR_RootToRootCopy, /*OpIdx*/2, // sh
     /* 150615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 150618 */     GIR_RootConstrainSelectedInstOperands,
     /* 150619 */     // GIR_Coverage, 1536,
     /* 150619 */     GIR_EraseRootFromParent_Done,
     /* 150620 */   // Label 2073: @150620
     /* 150620 */   GIM_Reject,
     /* 150621 */ // Label 2071: @150621
     /* 150621 */ GIM_Reject,
     /* 150622 */ // Label 2062: @150622
     /* 150622 */ GIM_Try, /*On fail goto*//*Label 2074*/ GIMT_Encode4(150647), // Rule ID 3351 //
     /* 150627 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 150630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 150633 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /* 150636 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 150640 */   // (rotl:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$vA, v1i128:{ *:[v1i128] }:$vB)  =>  (VRLQ:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$vA, v1i128:{ *:[v1i128] }:$vB)
     /* 150640 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VRLQ),
     /* 150645 */   GIR_RootConstrainSelectedInstOperands,
     /* 150646 */   // GIR_Coverage, 3351,
     /* 150646 */   GIR_Done,
     /* 150647 */ // Label 2074: @150647
     /* 150647 */ GIM_Reject,
     /* 150648 */ // Label 2063: @150648
     /* 150648 */ GIM_Try, /*On fail goto*//*Label 2075*/ GIMT_Encode4(150673), // Rule ID 1437 //
     /* 150653 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /* 150656 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 150659 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 150662 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 150666 */   // (rotl:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$vA, v2i64:{ *:[v2i64] }:$vB)  =>  (VRLD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$vA, v2i64:{ *:[v2i64] }:$vB)
     /* 150666 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VRLD),
     /* 150671 */   GIR_RootConstrainSelectedInstOperands,
     /* 150672 */   // GIR_Coverage, 1437,
     /* 150672 */   GIR_Done,
     /* 150673 */ // Label 2075: @150673
     /* 150673 */ GIM_Reject,
     /* 150674 */ // Label 2064: @150674
     /* 150674 */ GIM_Try, /*On fail goto*//*Label 2076*/ GIMT_Encode4(150699), // Rule ID 1288 //
     /* 150679 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 150682 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 150685 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 150688 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 150692 */   // (rotl:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)  =>  (VRLW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)
     /* 150692 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VRLW),
     /* 150697 */   GIR_RootConstrainSelectedInstOperands,
     /* 150698 */   // GIR_Coverage, 1288,
     /* 150698 */   GIR_Done,
     /* 150699 */ // Label 2076: @150699
     /* 150699 */ GIM_Reject,
     /* 150700 */ // Label 2065: @150700
     /* 150700 */ GIM_Try, /*On fail goto*//*Label 2077*/ GIMT_Encode4(150725), // Rule ID 1287 //
     /* 150705 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 150708 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 150711 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 150714 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 150718 */   // (rotl:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$vA, v8i16:{ *:[v8i16] }:$vB)  =>  (VRLH:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$vA, v8i16:{ *:[v8i16] }:$vB)
     /* 150718 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VRLH),
     /* 150723 */   GIR_RootConstrainSelectedInstOperands,
     /* 150724 */   // GIR_Coverage, 1287,
     /* 150724 */   GIR_Done,
     /* 150725 */ // Label 2077: @150725
     /* 150725 */ GIM_Reject,
     /* 150726 */ // Label 2066: @150726
     /* 150726 */ GIM_Try, /*On fail goto*//*Label 2078*/ GIMT_Encode4(150751), // Rule ID 1286 //
     /* 150731 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 150734 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 150737 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 150740 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 150744 */   // (rotl:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$vA, v16i8:{ *:[v16i8] }:$vB)  =>  (VRLB:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$vA, v16i8:{ *:[v16i8] }:$vB)
     /* 150744 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VRLB),
     /* 150749 */   GIR_RootConstrainSelectedInstOperands,
     /* 150750 */   // GIR_Coverage, 1286,
     /* 150750 */   GIR_Done,
     /* 150751 */ // Label 2078: @150751
     /* 150751 */ GIM_Reject,
     /* 150752 */ // Label 2067: @150752
     /* 150752 */ GIM_Reject,
     /* 150753 */ // Label 31: @150753
     /* 150753 */ GIM_Try, /*On fail goto*//*Label 2079*/ GIMT_Encode4(154754),
     /* 150758 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
     /* 150761 */   GIM_SwitchType, /*MI*/0, /*Op*/2, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 2082*/ GIMT_Encode4(151330),
     /* 150772 */   /*GILLT_s32*//*Label 2080*/ GIMT_Encode4(150780),
     /* 150776 */   /*GILLT_s64*//*Label 2081*/ GIMT_Encode4(151055),
     /* 150780 */   // Label 2080: @150780
     /* 150780 */   GIM_Try, /*On fail goto*//*Label 2083*/ GIMT_Encode4(151054),
     /* 150785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 150788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 150792 */     GIM_Try, /*On fail goto*//*Label 2084*/ GIMT_Encode4(150879), // Rule ID 3023 //
     /* 150797 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 150800 */       // MIs[0] Operand 1
     /* 150800 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 150805 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 150809 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 150813 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 150817 */       // MIs[1] Operand 1
     /* 150817 */       // No operand predicates
     /* 150817 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150819 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_lt:{ *:[i32] }))
     /* 150819 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 150822 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 150826 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150831 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 150835 */       GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 150838 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 150840 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 150843 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 150847 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150852 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 150859 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 150864 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 150869 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 150872 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 150874 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150877 */       GIR_RootConstrainSelectedInstOperands,
     /* 150878 */       // GIR_Coverage, 3023,
     /* 150878 */       GIR_EraseRootFromParent_Done,
     /* 150879 */     // Label 2084: @150879
     /* 150879 */     GIM_Try, /*On fail goto*//*Label 2085*/ GIMT_Encode4(150966), // Rule ID 3039 //
     /* 150884 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 150887 */       // MIs[0] Operand 1
     /* 150887 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 150892 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 150896 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 150900 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 150904 */       // MIs[1] Operand 1
     /* 150904 */       // No operand predicates
     /* 150904 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150906 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETLE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_gt:{ *:[i32] }))
     /* 150906 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 150909 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 150913 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150918 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 150922 */       GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 150925 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 150927 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 150930 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 150934 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150939 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 150946 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 150951 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 150956 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 150959 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 150961 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150964 */       GIR_RootConstrainSelectedInstOperands,
     /* 150965 */       // GIR_Coverage, 3039,
     /* 150965 */       GIR_EraseRootFromParent_Done,
     /* 150966 */     // Label 2085: @150966
     /* 150966 */     GIM_Try, /*On fail goto*//*Label 2086*/ GIMT_Encode4(151053), // Rule ID 3047 //
     /* 150971 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 150974 */       // MIs[0] Operand 1
     /* 150974 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 150979 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 150983 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 150987 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 150991 */       // MIs[1] Operand 1
     /* 150991 */       // No operand predicates
     /* 150991 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150993 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETNE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_eq:{ *:[i32] }))
     /* 150993 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 150996 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 151000 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151005 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 151009 */       GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 151012 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 151014 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 151017 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 151021 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151026 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 151033 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 151038 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 151043 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 151046 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 151048 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 151051 */       GIR_RootConstrainSelectedInstOperands,
     /* 151052 */       // GIR_Coverage, 3047,
     /* 151052 */       GIR_EraseRootFromParent_Done,
     /* 151053 */     // Label 2086: @151053
     /* 151053 */     GIM_Reject,
     /* 151054 */   // Label 2083: @151054
     /* 151054 */   GIM_Reject,
     /* 151055 */   // Label 2081: @151055
     /* 151055 */   GIM_Try, /*On fail goto*//*Label 2087*/ GIMT_Encode4(151329),
     /* 151060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 151063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 151067 */     GIM_Try, /*On fail goto*//*Label 2088*/ GIMT_Encode4(151154), // Rule ID 3119 //
     /* 151072 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 151075 */       // MIs[0] Operand 1
     /* 151075 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 151080 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 151084 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 151088 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 151092 */       // MIs[1] Operand 1
     /* 151092 */       // No operand predicates
     /* 151092 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151094 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_lt:{ *:[i32] }))
     /* 151094 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 151097 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 151101 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151106 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 151110 */       GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 151113 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 151115 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 151118 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 151122 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151127 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 151134 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 151139 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 151144 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 151147 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 151149 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 151152 */       GIR_RootConstrainSelectedInstOperands,
     /* 151153 */       // GIR_Coverage, 3119,
     /* 151153 */       GIR_EraseRootFromParent_Done,
     /* 151154 */     // Label 2088: @151154
     /* 151154 */     GIM_Try, /*On fail goto*//*Label 2089*/ GIMT_Encode4(151241), // Rule ID 3135 //
     /* 151159 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 151162 */       // MIs[0] Operand 1
     /* 151162 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 151167 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 151171 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 151175 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 151179 */       // MIs[1] Operand 1
     /* 151179 */       // No operand predicates
     /* 151179 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151181 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETLE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_gt:{ *:[i32] }))
     /* 151181 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 151184 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 151188 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151193 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 151197 */       GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 151200 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 151202 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 151205 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 151209 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151214 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 151221 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 151226 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 151231 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 151234 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 151236 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 151239 */       GIR_RootConstrainSelectedInstOperands,
     /* 151240 */       // GIR_Coverage, 3135,
     /* 151240 */       GIR_EraseRootFromParent_Done,
     /* 151241 */     // Label 2089: @151241
     /* 151241 */     GIM_Try, /*On fail goto*//*Label 2090*/ GIMT_Encode4(151328), // Rule ID 3143 //
     /* 151246 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 151249 */       // MIs[0] Operand 1
     /* 151249 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 151254 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 151258 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 151262 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 151266 */       // MIs[1] Operand 1
     /* 151266 */       // No operand predicates
     /* 151266 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151268 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETNE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_eq:{ *:[i32] }))
     /* 151268 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 151271 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 151275 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151280 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 151284 */       GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 151287 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 151289 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 151292 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 151296 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151301 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 151308 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 151313 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 151318 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 151321 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 151323 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 151326 */       GIR_RootConstrainSelectedInstOperands,
     /* 151327 */       // GIR_Coverage, 3143,
     /* 151327 */       GIR_EraseRootFromParent_Done,
     /* 151328 */     // Label 2090: @151328
     /* 151328 */     GIM_Reject,
     /* 151329 */   // Label 2087: @151329
     /* 151329 */   GIM_Reject,
     /* 151330 */   // Label 2082: @151330
     /* 151330 */   GIM_SwitchType, /*MI*/0, /*Op*/2, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 2093*/ GIMT_Encode4(151785),
     /* 151341 */   /*GILLT_s32*//*Label 2091*/ GIMT_Encode4(151349),
     /* 151345 */   /*GILLT_s64*//*Label 2092*/ GIMT_Encode4(151567),
     /* 151349 */   // Label 2091: @151349
     /* 151349 */   GIM_Try, /*On fail goto*//*Label 2094*/ GIMT_Encode4(151566),
     /* 151354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 151357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 151361 */     GIM_Try, /*On fail goto*//*Label 2095*/ GIMT_Encode4(151429), // Rule ID 3754 //
     /* 151366 */       // MIs[0] Operand 1
     /* 151366 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 151371 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 151375 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 151379 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 151383 */       // MIs[1] Operand 1
     /* 151383 */       // No operand predicates
     /* 151383 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151385 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETLT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_lt:{ *:[i32] })
     /* 151385 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 151388 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 151392 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151397 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 151401 */       GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 151404 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 151406 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 151409 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151411 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 151418 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 151423 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 151428 */       // GIR_Coverage, 3754,
     /* 151428 */       GIR_EraseRootFromParent_Done,
     /* 151429 */     // Label 2095: @151429
     /* 151429 */     GIM_Try, /*On fail goto*//*Label 2096*/ GIMT_Encode4(151497), // Rule ID 3756 //
     /* 151434 */       // MIs[0] Operand 1
     /* 151434 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 151439 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 151443 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 151447 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 151451 */       // MIs[1] Operand 1
     /* 151451 */       // No operand predicates
     /* 151451 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151453 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETGT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_gt:{ *:[i32] })
     /* 151453 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 151456 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 151460 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151465 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 151469 */       GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 151472 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 151474 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 151477 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151479 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 151486 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 151491 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 151496 */       // GIR_Coverage, 3756,
     /* 151496 */       GIR_EraseRootFromParent_Done,
     /* 151497 */     // Label 2096: @151497
     /* 151497 */     GIM_Try, /*On fail goto*//*Label 2097*/ GIMT_Encode4(151565), // Rule ID 3757 //
     /* 151502 */       // MIs[0] Operand 1
     /* 151502 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 151507 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 151511 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 151515 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 151519 */       // MIs[1] Operand 1
     /* 151519 */       // No operand predicates
     /* 151519 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151521 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETEQ:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_eq:{ *:[i32] })
     /* 151521 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 151524 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 151528 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151533 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 151537 */       GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 151540 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 151542 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 151545 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151547 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 151554 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 151559 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 151564 */       // GIR_Coverage, 3757,
     /* 151564 */       GIR_EraseRootFromParent_Done,
     /* 151565 */     // Label 2097: @151565
     /* 151565 */     GIM_Reject,
     /* 151566 */   // Label 2094: @151566
     /* 151566 */   GIM_Reject,
     /* 151567 */   // Label 2092: @151567
     /* 151567 */   GIM_Try, /*On fail goto*//*Label 2098*/ GIMT_Encode4(151784),
     /* 151572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 151575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 151579 */     GIM_Try, /*On fail goto*//*Label 2099*/ GIMT_Encode4(151647), // Rule ID 3766 //
     /* 151584 */       // MIs[0] Operand 1
     /* 151584 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 151589 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 151593 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 151597 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 151601 */       // MIs[1] Operand 1
     /* 151601 */       // No operand predicates
     /* 151601 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151603 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETLT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_lt:{ *:[i32] })
     /* 151603 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 151606 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 151610 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151615 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 151619 */       GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 151622 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 151624 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 151627 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151629 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 151636 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 151641 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 151646 */       // GIR_Coverage, 3766,
     /* 151646 */       GIR_EraseRootFromParent_Done,
     /* 151647 */     // Label 2099: @151647
     /* 151647 */     GIM_Try, /*On fail goto*//*Label 2100*/ GIMT_Encode4(151715), // Rule ID 3768 //
     /* 151652 */       // MIs[0] Operand 1
     /* 151652 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 151657 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 151661 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 151665 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 151669 */       // MIs[1] Operand 1
     /* 151669 */       // No operand predicates
     /* 151669 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151671 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETGT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_gt:{ *:[i32] })
     /* 151671 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 151674 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 151678 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151683 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 151687 */       GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 151690 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 151692 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 151695 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151697 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 151704 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 151709 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 151714 */       // GIR_Coverage, 3768,
     /* 151714 */       GIR_EraseRootFromParent_Done,
     /* 151715 */     // Label 2100: @151715
     /* 151715 */     GIM_Try, /*On fail goto*//*Label 2101*/ GIMT_Encode4(151783), // Rule ID 3769 //
     /* 151720 */       // MIs[0] Operand 1
     /* 151720 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 151725 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 151729 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 151733 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 151737 */       // MIs[1] Operand 1
     /* 151737 */       // No operand predicates
     /* 151737 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151739 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETEQ:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_eq:{ *:[i32] })
     /* 151739 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 151742 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 151746 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151751 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 151755 */       GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 151758 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 151760 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 151763 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151765 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 151772 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 151777 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 151782 */       // GIR_Coverage, 3769,
     /* 151782 */       GIR_EraseRootFromParent_Done,
     /* 151783 */     // Label 2101: @151783
     /* 151783 */     GIM_Reject,
     /* 151784 */   // Label 2098: @151784
     /* 151784 */   GIM_Reject,
     /* 151785 */   // Label 2093: @151785
     /* 151785 */   GIM_SwitchType, /*MI*/0, /*Op*/2, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 2104*/ GIMT_Encode4(152354),
     /* 151796 */   /*GILLT_s32*//*Label 2102*/ GIMT_Encode4(151804),
     /* 151800 */   /*GILLT_s64*//*Label 2103*/ GIMT_Encode4(152079),
     /* 151804 */   // Label 2102: @151804
     /* 151804 */   GIM_Try, /*On fail goto*//*Label 2105*/ GIMT_Encode4(152078),
     /* 151809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 151812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 151816 */     GIM_Try, /*On fail goto*//*Label 2106*/ GIMT_Encode4(151903), // Rule ID 3777 //
     /* 151821 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 151824 */       // MIs[0] Operand 1
     /* 151824 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 151829 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 151833 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 151837 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 151841 */       // MIs[1] Operand 1
     /* 151841 */       // No operand predicates
     /* 151841 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151843 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_lt:{ *:[i32] }))
     /* 151843 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 151846 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 151850 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151855 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 151859 */       GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 151862 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 151864 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 151867 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 151871 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151876 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 151883 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 151888 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 151893 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 151896 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 151898 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 151901 */       GIR_RootConstrainSelectedInstOperands,
     /* 151902 */       // GIR_Coverage, 3777,
     /* 151902 */       GIR_EraseRootFromParent_Done,
     /* 151903 */     // Label 2106: @151903
     /* 151903 */     GIM_Try, /*On fail goto*//*Label 2107*/ GIMT_Encode4(151990), // Rule ID 3793 //
     /* 151908 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 151911 */       // MIs[0] Operand 1
     /* 151911 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 151916 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 151920 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 151924 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 151928 */       // MIs[1] Operand 1
     /* 151928 */       // No operand predicates
     /* 151928 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151930 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETLE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_gt:{ *:[i32] }))
     /* 151930 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 151933 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 151937 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151942 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 151946 */       GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 151949 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 151951 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 151954 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 151958 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151963 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 151970 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 151975 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 151980 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 151983 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 151985 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 151988 */       GIR_RootConstrainSelectedInstOperands,
     /* 151989 */       // GIR_Coverage, 3793,
     /* 151989 */       GIR_EraseRootFromParent_Done,
     /* 151990 */     // Label 2107: @151990
     /* 151990 */     GIM_Try, /*On fail goto*//*Label 2108*/ GIMT_Encode4(152077), // Rule ID 3801 //
     /* 151995 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 151998 */       // MIs[0] Operand 1
     /* 151998 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 152003 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 152007 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 152011 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 152015 */       // MIs[1] Operand 1
     /* 152015 */       // No operand predicates
     /* 152015 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152017 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETNE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_eq:{ *:[i32] }))
     /* 152017 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 152020 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 152024 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152029 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 152033 */       GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 152036 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 152038 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 152041 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 152045 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152050 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 152057 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 152062 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 152067 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 152070 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 152072 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 152075 */       GIR_RootConstrainSelectedInstOperands,
     /* 152076 */       // GIR_Coverage, 3801,
     /* 152076 */       GIR_EraseRootFromParent_Done,
     /* 152077 */     // Label 2108: @152077
     /* 152077 */     GIM_Reject,
     /* 152078 */   // Label 2105: @152078
     /* 152078 */   GIM_Reject,
     /* 152079 */   // Label 2103: @152079
     /* 152079 */   GIM_Try, /*On fail goto*//*Label 2109*/ GIMT_Encode4(152353),
     /* 152084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 152087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 152091 */     GIM_Try, /*On fail goto*//*Label 2110*/ GIMT_Encode4(152178), // Rule ID 3873 //
     /* 152096 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 152099 */       // MIs[0] Operand 1
     /* 152099 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 152104 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 152108 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 152112 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 152116 */       // MIs[1] Operand 1
     /* 152116 */       // No operand predicates
     /* 152116 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152118 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_lt:{ *:[i32] }))
     /* 152118 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 152121 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 152125 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152130 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 152134 */       GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 152137 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 152139 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 152142 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 152146 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152151 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 152158 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 152163 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 152168 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 152171 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 152173 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 152176 */       GIR_RootConstrainSelectedInstOperands,
     /* 152177 */       // GIR_Coverage, 3873,
     /* 152177 */       GIR_EraseRootFromParent_Done,
     /* 152178 */     // Label 2110: @152178
     /* 152178 */     GIM_Try, /*On fail goto*//*Label 2111*/ GIMT_Encode4(152265), // Rule ID 3889 //
     /* 152183 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 152186 */       // MIs[0] Operand 1
     /* 152186 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 152191 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 152195 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 152199 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 152203 */       // MIs[1] Operand 1
     /* 152203 */       // No operand predicates
     /* 152203 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152205 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETLE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_gt:{ *:[i32] }))
     /* 152205 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 152208 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 152212 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152217 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 152221 */       GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 152224 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 152226 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 152229 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 152233 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152238 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 152245 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 152250 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 152255 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 152258 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 152260 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 152263 */       GIR_RootConstrainSelectedInstOperands,
     /* 152264 */       // GIR_Coverage, 3889,
     /* 152264 */       GIR_EraseRootFromParent_Done,
     /* 152265 */     // Label 2111: @152265
     /* 152265 */     GIM_Try, /*On fail goto*//*Label 2112*/ GIMT_Encode4(152352), // Rule ID 3897 //
     /* 152270 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 152273 */       // MIs[0] Operand 1
     /* 152273 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 152278 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 152282 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 152286 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 152290 */       // MIs[1] Operand 1
     /* 152290 */       // No operand predicates
     /* 152290 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152292 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETNE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_eq:{ *:[i32] }))
     /* 152292 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 152295 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 152299 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152304 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 152308 */       GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 152311 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 152313 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 152316 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 152320 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152325 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 152332 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 152337 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 152342 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 152345 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 152347 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 152350 */       GIR_RootConstrainSelectedInstOperands,
     /* 152351 */       // GIR_Coverage, 3897,
     /* 152351 */       GIR_EraseRootFromParent_Done,
     /* 152352 */     // Label 2112: @152352
     /* 152352 */     GIM_Reject,
     /* 152353 */   // Label 2109: @152353
     /* 152353 */   GIM_Reject,
     /* 152354 */   // Label 2104: @152354
     /* 152354 */   GIM_SwitchType, /*MI*/0, /*Op*/2, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 2116*/ GIMT_Encode4(153369),
     /* 152365 */   /*GILLT_s1*//*Label 2113*/ GIMT_Encode4(152377),
     /* 152369 */   /*GILLT_s32*//*Label 2114*/ GIMT_Encode4(152601),
     /* 152373 */   /*GILLT_s64*//*Label 2115*/ GIMT_Encode4(152985),
     /* 152377 */   // Label 2113: @152377
     /* 152377 */   GIM_Try, /*On fail goto*//*Label 2117*/ GIMT_Encode4(152600),
     /* 152382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s1,
     /* 152385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 152389 */     GIM_Try, /*On fail goto*//*Label 2118*/ GIMT_Encode4(152410), // Rule ID 3639 //
     /* 152394 */       // MIs[0] Operand 1
     /* 152394 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 152399 */       // (setcc:{ *:[i1] } i1:{ *:[i1] }:$s1, i1:{ *:[i1] }:$s2, SETLT:{ *:[Other] })  =>  (CRANDC:{ *:[i1] } ?:{ *:[i1] }:$s1, ?:{ *:[i1] }:$s2)
     /* 152399 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRANDC),
     /* 152402 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 152404 */       GIR_RootToRootCopy, /*OpIdx*/2, // s1
     /* 152406 */       GIR_RootToRootCopy, /*OpIdx*/3, // s2
     /* 152408 */       GIR_RootConstrainSelectedInstOperands,
     /* 152409 */       // GIR_Coverage, 3639,
     /* 152409 */       GIR_EraseRootFromParent_Done,
     /* 152410 */     // Label 2118: @152410
     /* 152410 */     GIM_Try, /*On fail goto*//*Label 2119*/ GIMT_Encode4(152431), // Rule ID 3640 //
     /* 152415 */       // MIs[0] Operand 1
     /* 152415 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 152420 */       // (setcc:{ *:[i1] } i1:{ *:[i1] }:$s1, i1:{ *:[i1] }:$s2, SETULT:{ *:[Other] })  =>  (CRANDC:{ *:[i1] } ?:{ *:[i1] }:$s2, ?:{ *:[i1] }:$s1)
     /* 152420 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRANDC),
     /* 152423 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 152425 */       GIR_RootToRootCopy, /*OpIdx*/3, // s2
     /* 152427 */       GIR_RootToRootCopy, /*OpIdx*/2, // s1
     /* 152429 */       GIR_RootConstrainSelectedInstOperands,
     /* 152430 */       // GIR_Coverage, 3640,
     /* 152430 */       GIR_EraseRootFromParent_Done,
     /* 152431 */     // Label 2119: @152431
     /* 152431 */     GIM_Try, /*On fail goto*//*Label 2120*/ GIMT_Encode4(152452), // Rule ID 3641 //
     /* 152436 */       // MIs[0] Operand 1
     /* 152436 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 152441 */       // (setcc:{ *:[i1] } i1:{ *:[i1] }:$s1, i1:{ *:[i1] }:$s2, SETLE:{ *:[Other] })  =>  (CRORC:{ *:[i1] } ?:{ *:[i1] }:$s1, ?:{ *:[i1] }:$s2)
     /* 152441 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRORC),
     /* 152444 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 152446 */       GIR_RootToRootCopy, /*OpIdx*/2, // s1
     /* 152448 */       GIR_RootToRootCopy, /*OpIdx*/3, // s2
     /* 152450 */       GIR_RootConstrainSelectedInstOperands,
     /* 152451 */       // GIR_Coverage, 3641,
     /* 152451 */       GIR_EraseRootFromParent_Done,
     /* 152452 */     // Label 2120: @152452
     /* 152452 */     GIM_Try, /*On fail goto*//*Label 2121*/ GIMT_Encode4(152473), // Rule ID 3642 //
     /* 152457 */       // MIs[0] Operand 1
     /* 152457 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 152462 */       // (setcc:{ *:[i1] } i1:{ *:[i1] }:$s1, i1:{ *:[i1] }:$s2, SETULE:{ *:[Other] })  =>  (CRORC:{ *:[i1] } ?:{ *:[i1] }:$s2, ?:{ *:[i1] }:$s1)
     /* 152462 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRORC),
     /* 152465 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 152467 */       GIR_RootToRootCopy, /*OpIdx*/3, // s2
     /* 152469 */       GIR_RootToRootCopy, /*OpIdx*/2, // s1
     /* 152471 */       GIR_RootConstrainSelectedInstOperands,
     /* 152472 */       // GIR_Coverage, 3642,
     /* 152472 */       GIR_EraseRootFromParent_Done,
     /* 152473 */     // Label 2121: @152473
     /* 152473 */     GIM_Try, /*On fail goto*//*Label 2122*/ GIMT_Encode4(152494), // Rule ID 3643 //
     /* 152478 */       // MIs[0] Operand 1
     /* 152478 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 152483 */       // (setcc:{ *:[i1] } i1:{ *:[i1] }:$s1, i1:{ *:[i1] }:$s2, SETEQ:{ *:[Other] })  =>  (CREQV:{ *:[i1] } ?:{ *:[i1] }:$s1, ?:{ *:[i1] }:$s2)
     /* 152483 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CREQV),
     /* 152486 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 152488 */       GIR_RootToRootCopy, /*OpIdx*/2, // s1
     /* 152490 */       GIR_RootToRootCopy, /*OpIdx*/3, // s2
     /* 152492 */       GIR_RootConstrainSelectedInstOperands,
     /* 152493 */       // GIR_Coverage, 3643,
     /* 152493 */       GIR_EraseRootFromParent_Done,
     /* 152494 */     // Label 2122: @152494
     /* 152494 */     GIM_Try, /*On fail goto*//*Label 2123*/ GIMT_Encode4(152515), // Rule ID 3644 //
     /* 152499 */       // MIs[0] Operand 1
     /* 152499 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 152504 */       // (setcc:{ *:[i1] } i1:{ *:[i1] }:$s1, i1:{ *:[i1] }:$s2, SETGE:{ *:[Other] })  =>  (CRORC:{ *:[i1] } ?:{ *:[i1] }:$s2, ?:{ *:[i1] }:$s1)
     /* 152504 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRORC),
     /* 152507 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 152509 */       GIR_RootToRootCopy, /*OpIdx*/3, // s2
     /* 152511 */       GIR_RootToRootCopy, /*OpIdx*/2, // s1
     /* 152513 */       GIR_RootConstrainSelectedInstOperands,
     /* 152514 */       // GIR_Coverage, 3644,
     /* 152514 */       GIR_EraseRootFromParent_Done,
     /* 152515 */     // Label 2123: @152515
     /* 152515 */     GIM_Try, /*On fail goto*//*Label 2124*/ GIMT_Encode4(152536), // Rule ID 3645 //
     /* 152520 */       // MIs[0] Operand 1
     /* 152520 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 152525 */       // (setcc:{ *:[i1] } i1:{ *:[i1] }:$s1, i1:{ *:[i1] }:$s2, SETUGE:{ *:[Other] })  =>  (CRORC:{ *:[i1] } ?:{ *:[i1] }:$s1, ?:{ *:[i1] }:$s2)
     /* 152525 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRORC),
     /* 152528 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 152530 */       GIR_RootToRootCopy, /*OpIdx*/2, // s1
     /* 152532 */       GIR_RootToRootCopy, /*OpIdx*/3, // s2
     /* 152534 */       GIR_RootConstrainSelectedInstOperands,
     /* 152535 */       // GIR_Coverage, 3645,
     /* 152535 */       GIR_EraseRootFromParent_Done,
     /* 152536 */     // Label 2124: @152536
     /* 152536 */     GIM_Try, /*On fail goto*//*Label 2125*/ GIMT_Encode4(152557), // Rule ID 3646 //
     /* 152541 */       // MIs[0] Operand 1
     /* 152541 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 152546 */       // (setcc:{ *:[i1] } i1:{ *:[i1] }:$s1, i1:{ *:[i1] }:$s2, SETGT:{ *:[Other] })  =>  (CRANDC:{ *:[i1] } ?:{ *:[i1] }:$s2, ?:{ *:[i1] }:$s1)
     /* 152546 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRANDC),
     /* 152549 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 152551 */       GIR_RootToRootCopy, /*OpIdx*/3, // s2
     /* 152553 */       GIR_RootToRootCopy, /*OpIdx*/2, // s1
     /* 152555 */       GIR_RootConstrainSelectedInstOperands,
     /* 152556 */       // GIR_Coverage, 3646,
     /* 152556 */       GIR_EraseRootFromParent_Done,
     /* 152557 */     // Label 2125: @152557
     /* 152557 */     GIM_Try, /*On fail goto*//*Label 2126*/ GIMT_Encode4(152578), // Rule ID 3647 //
     /* 152562 */       // MIs[0] Operand 1
     /* 152562 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 152567 */       // (setcc:{ *:[i1] } i1:{ *:[i1] }:$s1, i1:{ *:[i1] }:$s2, SETUGT:{ *:[Other] })  =>  (CRANDC:{ *:[i1] } ?:{ *:[i1] }:$s1, ?:{ *:[i1] }:$s2)
     /* 152567 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRANDC),
     /* 152570 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 152572 */       GIR_RootToRootCopy, /*OpIdx*/2, // s1
     /* 152574 */       GIR_RootToRootCopy, /*OpIdx*/3, // s2
     /* 152576 */       GIR_RootConstrainSelectedInstOperands,
     /* 152577 */       // GIR_Coverage, 3647,
     /* 152577 */       GIR_EraseRootFromParent_Done,
     /* 152578 */     // Label 2126: @152578
     /* 152578 */     GIM_Try, /*On fail goto*//*Label 2127*/ GIMT_Encode4(152599), // Rule ID 3648 //
     /* 152583 */       // MIs[0] Operand 1
     /* 152583 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 152588 */       // (setcc:{ *:[i1] } i1:{ *:[i1] }:$s1, i1:{ *:[i1] }:$s2, SETNE:{ *:[Other] })  =>  (CRXOR:{ *:[i1] } ?:{ *:[i1] }:$s1, ?:{ *:[i1] }:$s2)
     /* 152588 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRXOR),
     /* 152591 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 152593 */       GIR_RootToRootCopy, /*OpIdx*/2, // s1
     /* 152595 */       GIR_RootToRootCopy, /*OpIdx*/3, // s2
     /* 152597 */       GIR_RootConstrainSelectedInstOperands,
     /* 152598 */       // GIR_Coverage, 3648,
     /* 152598 */       GIR_EraseRootFromParent_Done,
     /* 152599 */     // Label 2127: @152599
     /* 152599 */     GIM_Reject,
     /* 152600 */   // Label 2117: @152600
     /* 152600 */   GIM_Reject,
     /* 152601 */   // Label 2114: @152601
     /* 152601 */   GIM_Try, /*On fail goto*//*Label 2128*/ GIMT_Encode4(152984),
     /* 152606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 152609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 152613 */     GIM_Try, /*On fail goto*//*Label 2129*/ GIMT_Encode4(152687), // Rule ID 2969 //
     /* 152618 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 152621 */       // MIs[0] Operand 1
     /* 152621 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 152626 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETUGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }))
     /* 152626 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 152629 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 152633 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152638 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 152642 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 152646 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 152648 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 152651 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 152655 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152660 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 152667 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 152672 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 152677 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 152680 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 152682 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 152685 */       GIR_RootConstrainSelectedInstOperands,
     /* 152686 */       // GIR_Coverage, 2969,
     /* 152686 */       GIR_EraseRootFromParent_Done,
     /* 152687 */     // Label 2129: @152687
     /* 152687 */     GIM_Try, /*On fail goto*//*Label 2130*/ GIMT_Encode4(152761), // Rule ID 2983 //
     /* 152692 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 152695 */       // MIs[0] Operand 1
     /* 152695 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 152700 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }))
     /* 152700 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 152703 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 152707 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152712 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 152716 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 152720 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 152722 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 152725 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 152729 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152734 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 152741 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 152746 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 152751 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 152754 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 152756 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 152759 */       GIR_RootConstrainSelectedInstOperands,
     /* 152760 */       // GIR_Coverage, 2983,
     /* 152760 */       GIR_EraseRootFromParent_Done,
     /* 152761 */     // Label 2130: @152761
     /* 152761 */     GIM_Try, /*On fail goto*//*Label 2131*/ GIMT_Encode4(152835), // Rule ID 2991 //
     /* 152766 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 152769 */       // MIs[0] Operand 1
     /* 152769 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 152774 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETULE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }))
     /* 152774 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 152777 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 152781 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152786 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 152790 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 152794 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 152796 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 152799 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 152803 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152808 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 152815 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 152820 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 152825 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 152828 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 152830 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 152833 */       GIR_RootConstrainSelectedInstOperands,
     /* 152834 */       // GIR_Coverage, 2991,
     /* 152834 */       GIR_EraseRootFromParent_Done,
     /* 152835 */     // Label 2131: @152835
     /* 152835 */     GIM_Try, /*On fail goto*//*Label 2132*/ GIMT_Encode4(152909), // Rule ID 2999 //
     /* 152840 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 152843 */       // MIs[0] Operand 1
     /* 152843 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 152848 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETLE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }))
     /* 152848 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 152851 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 152855 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152860 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 152864 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 152868 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 152870 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 152873 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 152877 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152882 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 152889 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 152894 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 152899 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 152902 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 152904 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 152907 */       GIR_RootConstrainSelectedInstOperands,
     /* 152908 */       // GIR_Coverage, 2999,
     /* 152908 */       GIR_EraseRootFromParent_Done,
     /* 152909 */     // Label 2132: @152909
     /* 152909 */     GIM_Try, /*On fail goto*//*Label 2133*/ GIMT_Encode4(152983), // Rule ID 3007 //
     /* 152914 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 152917 */       // MIs[0] Operand 1
     /* 152917 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 152922 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETNE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_eq:{ *:[i32] }))
     /* 152922 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 152925 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 152929 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152934 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 152938 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 152942 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 152944 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 152947 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 152951 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152956 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 152963 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 152968 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 152973 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 152976 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 152978 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 152981 */       GIR_RootConstrainSelectedInstOperands,
     /* 152982 */       // GIR_Coverage, 3007,
     /* 152982 */       GIR_EraseRootFromParent_Done,
     /* 152983 */     // Label 2133: @152983
     /* 152983 */     GIM_Reject,
     /* 152984 */   // Label 2128: @152984
     /* 152984 */   GIM_Reject,
     /* 152985 */   // Label 2115: @152985
     /* 152985 */   GIM_Try, /*On fail goto*//*Label 2134*/ GIMT_Encode4(153368),
     /* 152990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 152993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 152997 */     GIM_Try, /*On fail goto*//*Label 2135*/ GIMT_Encode4(153071), // Rule ID 3071 //
     /* 153002 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 153005 */       // MIs[0] Operand 1
     /* 153005 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 153010 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETUGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }))
     /* 153010 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 153013 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 153017 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153022 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 153026 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 153030 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 153032 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 153035 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 153039 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153044 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 153051 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 153056 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 153061 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 153064 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 153066 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 153069 */       GIR_RootConstrainSelectedInstOperands,
     /* 153070 */       // GIR_Coverage, 3071,
     /* 153070 */       GIR_EraseRootFromParent_Done,
     /* 153071 */     // Label 2135: @153071
     /* 153071 */     GIM_Try, /*On fail goto*//*Label 2136*/ GIMT_Encode4(153145), // Rule ID 3079 //
     /* 153076 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 153079 */       // MIs[0] Operand 1
     /* 153079 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 153084 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }))
     /* 153084 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 153087 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 153091 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153096 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 153100 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 153104 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 153106 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 153109 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 153113 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153118 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 153125 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 153130 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 153135 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 153138 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 153140 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 153143 */       GIR_RootConstrainSelectedInstOperands,
     /* 153144 */       // GIR_Coverage, 3079,
     /* 153144 */       GIR_EraseRootFromParent_Done,
     /* 153145 */     // Label 2136: @153145
     /* 153145 */     GIM_Try, /*On fail goto*//*Label 2137*/ GIMT_Encode4(153219), // Rule ID 3087 //
     /* 153150 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 153153 */       // MIs[0] Operand 1
     /* 153153 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 153158 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETULE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }))
     /* 153158 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 153161 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 153165 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153170 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 153174 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 153178 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 153180 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 153183 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 153187 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153192 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 153199 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 153204 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 153209 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 153212 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 153214 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 153217 */       GIR_RootConstrainSelectedInstOperands,
     /* 153218 */       // GIR_Coverage, 3087,
     /* 153218 */       GIR_EraseRootFromParent_Done,
     /* 153219 */     // Label 2137: @153219
     /* 153219 */     GIM_Try, /*On fail goto*//*Label 2138*/ GIMT_Encode4(153293), // Rule ID 3095 //
     /* 153224 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 153227 */       // MIs[0] Operand 1
     /* 153227 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 153232 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETLE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }))
     /* 153232 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 153235 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 153239 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153244 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 153248 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 153252 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 153254 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 153257 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 153261 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153266 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 153273 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 153278 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 153283 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 153286 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 153288 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 153291 */       GIR_RootConstrainSelectedInstOperands,
     /* 153292 */       // GIR_Coverage, 3095,
     /* 153292 */       GIR_EraseRootFromParent_Done,
     /* 153293 */     // Label 2138: @153293
     /* 153293 */     GIM_Try, /*On fail goto*//*Label 2139*/ GIMT_Encode4(153367), // Rule ID 3103 //
     /* 153298 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 153301 */       // MIs[0] Operand 1
     /* 153301 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 153306 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETNE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_eq:{ *:[i32] }))
     /* 153306 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 153309 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 153313 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153318 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 153322 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 153326 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 153328 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 153331 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 153335 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153340 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 153347 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 153352 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 153357 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 153360 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 153362 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 153365 */       GIR_RootConstrainSelectedInstOperands,
     /* 153366 */       // GIR_Coverage, 3103,
     /* 153366 */       GIR_EraseRootFromParent_Done,
     /* 153367 */     // Label 2139: @153367
     /* 153367 */     GIM_Reject,
     /* 153368 */   // Label 2134: @153368
     /* 153368 */   GIM_Reject,
     /* 153369 */   // Label 2116: @153369
     /* 153369 */   GIM_SwitchType, /*MI*/0, /*Op*/2, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 2142*/ GIMT_Encode4(153966),
     /* 153380 */   /*GILLT_s32*//*Label 2140*/ GIMT_Encode4(153388),
     /* 153384 */   /*GILLT_s64*//*Label 2141*/ GIMT_Encode4(153677),
     /* 153388 */   // Label 2140: @153388
     /* 153388 */   GIM_Try, /*On fail goto*//*Label 2143*/ GIMT_Encode4(153676),
     /* 153393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 153396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 153400 */     GIM_Try, /*On fail goto*//*Label 2144*/ GIMT_Encode4(153455), // Rule ID 3760 //
     /* 153405 */       // MIs[0] Operand 1
     /* 153405 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 153410 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETULT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] })
     /* 153410 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 153413 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 153417 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153422 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 153426 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 153430 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 153432 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 153435 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153437 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 153444 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 153449 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 153454 */       // GIR_Coverage, 3760,
     /* 153454 */       GIR_EraseRootFromParent_Done,
     /* 153455 */     // Label 2144: @153455
     /* 153455 */     GIM_Try, /*On fail goto*//*Label 2145*/ GIMT_Encode4(153510), // Rule ID 3761 //
     /* 153460 */       // MIs[0] Operand 1
     /* 153460 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 153465 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETLT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] })
     /* 153465 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 153468 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 153472 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153477 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 153481 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 153485 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 153487 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 153490 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153492 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 153499 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 153504 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 153509 */       // GIR_Coverage, 3761,
     /* 153509 */       GIR_EraseRootFromParent_Done,
     /* 153510 */     // Label 2145: @153510
     /* 153510 */     GIM_Try, /*On fail goto*//*Label 2146*/ GIMT_Encode4(153565), // Rule ID 3762 //
     /* 153515 */       // MIs[0] Operand 1
     /* 153515 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 153520 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETUGT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] })
     /* 153520 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 153523 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 153527 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153532 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 153536 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 153540 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 153542 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 153545 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153547 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 153554 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 153559 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 153564 */       // GIR_Coverage, 3762,
     /* 153564 */       GIR_EraseRootFromParent_Done,
     /* 153565 */     // Label 2146: @153565
     /* 153565 */     GIM_Try, /*On fail goto*//*Label 2147*/ GIMT_Encode4(153620), // Rule ID 3763 //
     /* 153570 */       // MIs[0] Operand 1
     /* 153570 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 153575 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETGT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] })
     /* 153575 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 153578 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 153582 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153587 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 153591 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 153595 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 153597 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 153600 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153602 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 153609 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 153614 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 153619 */       // GIR_Coverage, 3763,
     /* 153619 */       GIR_EraseRootFromParent_Done,
     /* 153620 */     // Label 2147: @153620
     /* 153620 */     GIM_Try, /*On fail goto*//*Label 2148*/ GIMT_Encode4(153675), // Rule ID 3764 //
     /* 153625 */       // MIs[0] Operand 1
     /* 153625 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 153630 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETEQ:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_eq:{ *:[i32] })
     /* 153630 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 153633 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 153637 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153642 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 153646 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 153650 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 153652 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 153655 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153657 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 153664 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 153669 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 153674 */       // GIR_Coverage, 3764,
     /* 153674 */       GIR_EraseRootFromParent_Done,
     /* 153675 */     // Label 2148: @153675
     /* 153675 */     GIM_Reject,
     /* 153676 */   // Label 2143: @153676
     /* 153676 */   GIM_Reject,
     /* 153677 */   // Label 2141: @153677
     /* 153677 */   GIM_Try, /*On fail goto*//*Label 2149*/ GIMT_Encode4(153965),
     /* 153682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 153685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 153689 */     GIM_Try, /*On fail goto*//*Label 2150*/ GIMT_Encode4(153744), // Rule ID 3772 //
     /* 153694 */       // MIs[0] Operand 1
     /* 153694 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 153699 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETULT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] })
     /* 153699 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 153702 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 153706 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153711 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 153715 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 153719 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 153721 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 153724 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153726 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 153733 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 153738 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 153743 */       // GIR_Coverage, 3772,
     /* 153743 */       GIR_EraseRootFromParent_Done,
     /* 153744 */     // Label 2150: @153744
     /* 153744 */     GIM_Try, /*On fail goto*//*Label 2151*/ GIMT_Encode4(153799), // Rule ID 3773 //
     /* 153749 */       // MIs[0] Operand 1
     /* 153749 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 153754 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETLT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] })
     /* 153754 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 153757 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 153761 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153766 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 153770 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 153774 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 153776 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 153779 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153781 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 153788 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 153793 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 153798 */       // GIR_Coverage, 3773,
     /* 153798 */       GIR_EraseRootFromParent_Done,
     /* 153799 */     // Label 2151: @153799
     /* 153799 */     GIM_Try, /*On fail goto*//*Label 2152*/ GIMT_Encode4(153854), // Rule ID 3774 //
     /* 153804 */       // MIs[0] Operand 1
     /* 153804 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 153809 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETUGT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] })
     /* 153809 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 153812 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 153816 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153821 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 153825 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 153829 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 153831 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 153834 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153836 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 153843 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 153848 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 153853 */       // GIR_Coverage, 3774,
     /* 153853 */       GIR_EraseRootFromParent_Done,
     /* 153854 */     // Label 2152: @153854
     /* 153854 */     GIM_Try, /*On fail goto*//*Label 2153*/ GIMT_Encode4(153909), // Rule ID 3775 //
     /* 153859 */       // MIs[0] Operand 1
     /* 153859 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 153864 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETGT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] })
     /* 153864 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 153867 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 153871 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153876 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 153880 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 153884 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 153886 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 153889 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153891 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 153898 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 153903 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 153908 */       // GIR_Coverage, 3775,
     /* 153908 */       GIR_EraseRootFromParent_Done,
     /* 153909 */     // Label 2153: @153909
     /* 153909 */     GIM_Try, /*On fail goto*//*Label 2154*/ GIMT_Encode4(153964), // Rule ID 3776 //
     /* 153914 */       // MIs[0] Operand 1
     /* 153914 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 153919 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETEQ:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_eq:{ *:[i32] })
     /* 153919 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 153922 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 153926 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153931 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 153935 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 153939 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 153941 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 153944 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153946 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 153953 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 153958 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 153963 */       // GIR_Coverage, 3776,
     /* 153963 */       GIR_EraseRootFromParent_Done,
     /* 153964 */     // Label 2154: @153964
     /* 153964 */     GIM_Reject,
     /* 153965 */   // Label 2149: @153965
     /* 153965 */   GIM_Reject,
     /* 153966 */   // Label 2142: @153966
     /* 153966 */   GIM_SwitchType, /*MI*/0, /*Op*/2, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 2157*/ GIMT_Encode4(154753),
     /* 153977 */   /*GILLT_s32*//*Label 2155*/ GIMT_Encode4(153985),
     /* 153981 */   /*GILLT_s64*//*Label 2156*/ GIMT_Encode4(154369),
     /* 153985 */   // Label 2155: @153985
     /* 153985 */   GIM_Try, /*On fail goto*//*Label 2158*/ GIMT_Encode4(154368),
     /* 153990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 153993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 153997 */     GIM_Try, /*On fail goto*//*Label 2159*/ GIMT_Encode4(154071), // Rule ID 3825 //
     /* 154002 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 154005 */       // MIs[0] Operand 1
     /* 154005 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 154010 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETUGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }))
     /* 154010 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 154013 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 154017 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154022 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 154026 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 154030 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 154032 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 154035 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154039 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154044 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 154051 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 154056 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 154061 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 154064 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 154066 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 154069 */       GIR_RootConstrainSelectedInstOperands,
     /* 154070 */       // GIR_Coverage, 3825,
     /* 154070 */       GIR_EraseRootFromParent_Done,
     /* 154071 */     // Label 2159: @154071
     /* 154071 */     GIM_Try, /*On fail goto*//*Label 2160*/ GIMT_Encode4(154145), // Rule ID 3833 //
     /* 154076 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 154079 */       // MIs[0] Operand 1
     /* 154079 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 154084 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }))
     /* 154084 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 154087 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 154091 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154096 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 154100 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 154104 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 154106 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 154109 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154113 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154118 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 154125 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 154130 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 154135 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 154138 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 154140 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 154143 */       GIR_RootConstrainSelectedInstOperands,
     /* 154144 */       // GIR_Coverage, 3833,
     /* 154144 */       GIR_EraseRootFromParent_Done,
     /* 154145 */     // Label 2160: @154145
     /* 154145 */     GIM_Try, /*On fail goto*//*Label 2161*/ GIMT_Encode4(154219), // Rule ID 3841 //
     /* 154150 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 154153 */       // MIs[0] Operand 1
     /* 154153 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 154158 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETULE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }))
     /* 154158 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 154161 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 154165 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154170 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 154174 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 154178 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 154180 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 154183 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154187 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154192 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 154199 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 154204 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 154209 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 154212 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 154214 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 154217 */       GIR_RootConstrainSelectedInstOperands,
     /* 154218 */       // GIR_Coverage, 3841,
     /* 154218 */       GIR_EraseRootFromParent_Done,
     /* 154219 */     // Label 2161: @154219
     /* 154219 */     GIM_Try, /*On fail goto*//*Label 2162*/ GIMT_Encode4(154293), // Rule ID 3849 //
     /* 154224 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 154227 */       // MIs[0] Operand 1
     /* 154227 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 154232 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETLE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }))
     /* 154232 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 154235 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 154239 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154244 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 154248 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 154252 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 154254 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 154257 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154261 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154266 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 154273 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 154278 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 154283 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 154286 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 154288 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 154291 */       GIR_RootConstrainSelectedInstOperands,
     /* 154292 */       // GIR_Coverage, 3849,
     /* 154292 */       GIR_EraseRootFromParent_Done,
     /* 154293 */     // Label 2162: @154293
     /* 154293 */     GIM_Try, /*On fail goto*//*Label 2163*/ GIMT_Encode4(154367), // Rule ID 3857 //
     /* 154298 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 154301 */       // MIs[0] Operand 1
     /* 154301 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 154306 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETNE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_eq:{ *:[i32] }))
     /* 154306 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 154309 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 154313 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154318 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 154322 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 154326 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 154328 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 154331 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154335 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154340 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 154347 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 154352 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 154357 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 154360 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 154362 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 154365 */       GIR_RootConstrainSelectedInstOperands,
     /* 154366 */       // GIR_Coverage, 3857,
     /* 154366 */       GIR_EraseRootFromParent_Done,
     /* 154367 */     // Label 2163: @154367
     /* 154367 */     GIM_Reject,
     /* 154368 */   // Label 2158: @154368
     /* 154368 */   GIM_Reject,
     /* 154369 */   // Label 2156: @154369
     /* 154369 */   GIM_Try, /*On fail goto*//*Label 2164*/ GIMT_Encode4(154752),
     /* 154374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 154377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 154381 */     GIM_Try, /*On fail goto*//*Label 2165*/ GIMT_Encode4(154455), // Rule ID 3921 //
     /* 154386 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 154389 */       // MIs[0] Operand 1
     /* 154389 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 154394 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETUGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }))
     /* 154394 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 154397 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 154401 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154406 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 154410 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 154414 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 154416 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 154419 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154423 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154428 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 154435 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 154440 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 154445 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 154448 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 154450 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 154453 */       GIR_RootConstrainSelectedInstOperands,
     /* 154454 */       // GIR_Coverage, 3921,
     /* 154454 */       GIR_EraseRootFromParent_Done,
     /* 154455 */     // Label 2165: @154455
     /* 154455 */     GIM_Try, /*On fail goto*//*Label 2166*/ GIMT_Encode4(154529), // Rule ID 3929 //
     /* 154460 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 154463 */       // MIs[0] Operand 1
     /* 154463 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 154468 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }))
     /* 154468 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 154471 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 154475 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154480 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 154484 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 154488 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 154490 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 154493 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154497 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154502 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 154509 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 154514 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 154519 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 154522 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 154524 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 154527 */       GIR_RootConstrainSelectedInstOperands,
     /* 154528 */       // GIR_Coverage, 3929,
     /* 154528 */       GIR_EraseRootFromParent_Done,
     /* 154529 */     // Label 2166: @154529
     /* 154529 */     GIM_Try, /*On fail goto*//*Label 2167*/ GIMT_Encode4(154603), // Rule ID 3937 //
     /* 154534 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 154537 */       // MIs[0] Operand 1
     /* 154537 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 154542 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETULE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }))
     /* 154542 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 154545 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 154549 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154554 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 154558 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 154562 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 154564 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 154567 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154571 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154576 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 154583 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 154588 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 154593 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 154596 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 154598 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 154601 */       GIR_RootConstrainSelectedInstOperands,
     /* 154602 */       // GIR_Coverage, 3937,
     /* 154602 */       GIR_EraseRootFromParent_Done,
     /* 154603 */     // Label 2167: @154603
     /* 154603 */     GIM_Try, /*On fail goto*//*Label 2168*/ GIMT_Encode4(154677), // Rule ID 3945 //
     /* 154608 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 154611 */       // MIs[0] Operand 1
     /* 154611 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 154616 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETLE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }))
     /* 154616 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 154619 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 154623 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154628 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 154632 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 154636 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 154638 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 154641 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154645 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154650 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 154657 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 154662 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 154667 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 154670 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 154672 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 154675 */       GIR_RootConstrainSelectedInstOperands,
     /* 154676 */       // GIR_Coverage, 3945,
     /* 154676 */       GIR_EraseRootFromParent_Done,
     /* 154677 */     // Label 2168: @154677
     /* 154677 */     GIM_Try, /*On fail goto*//*Label 2169*/ GIMT_Encode4(154751), // Rule ID 3953 //
     /* 154682 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 154685 */       // MIs[0] Operand 1
     /* 154685 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 154690 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETNE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_eq:{ *:[i32] }))
     /* 154690 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 154693 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 154697 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154702 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 154706 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 154710 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 154712 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 154715 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154719 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154724 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 154731 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 154736 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 154741 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 154744 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 154746 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 154749 */       GIR_RootConstrainSelectedInstOperands,
     /* 154750 */       // GIR_Coverage, 3953,
     /* 154750 */       GIR_EraseRootFromParent_Done,
     /* 154751 */     // Label 2169: @154751
     /* 154751 */     GIM_Reject,
     /* 154752 */   // Label 2164: @154752
     /* 154752 */   GIM_Reject,
     /* 154753 */   // Label 2157: @154753
     /* 154753 */   GIM_Reject,
     /* 154754 */ // Label 2079: @154754
     /* 154754 */ GIM_Reject,
     /* 154755 */ // Label 32: @154755
     /* 154755 */ GIM_Try, /*On fail goto*//*Label 2170*/ GIMT_Encode4(158205),
     /* 154760 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
     /* 154763 */   GIM_SwitchType, /*MI*/0, /*Op*/2, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 2174*/ GIMT_Encode4(155716),
     /* 154774 */   /*GILLT_s32*//*Label 2171*/ GIMT_Encode4(154786),
     /* 154778 */   /*GILLT_s64*//*Label 2172*/ GIMT_Encode4(155096),
     /* 154782 */   /*GILLT_s128*//*Label 2173*/ GIMT_Encode4(155406),
     /* 154786 */   // Label 2171: @154786
     /* 154786 */   GIM_Try, /*On fail goto*//*Label 2175*/ GIMT_Encode4(155095),
     /* 154791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 154794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 154798 */     GIM_Try, /*On fail goto*//*Label 2176*/ GIMT_Encode4(154872), // Rule ID 3167 //
     /* 154803 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 154806 */       // MIs[0] Operand 1
     /* 154806 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 154811 */       // (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_lt:{ *:[i32] }))
     /* 154811 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 154814 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 154818 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154823 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 154827 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 154831 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 154833 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 154836 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154840 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154845 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 154852 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 154857 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 154862 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 154865 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 154867 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 154870 */       GIR_RootConstrainSelectedInstOperands,
     /* 154871 */       // GIR_Coverage, 3167,
     /* 154871 */       GIR_EraseRootFromParent_Done,
     /* 154872 */     // Label 2176: @154872
     /* 154872 */     GIM_Try, /*On fail goto*//*Label 2177*/ GIMT_Encode4(154946), // Rule ID 3183 //
     /* 154877 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 154880 */       // MIs[0] Operand 1
     /* 154880 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 154885 */       // (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }))
     /* 154885 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 154888 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 154892 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154897 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 154901 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 154905 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 154907 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 154910 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154914 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154919 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 154926 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 154931 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 154936 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 154939 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 154941 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 154944 */       GIR_RootConstrainSelectedInstOperands,
     /* 154945 */       // GIR_Coverage, 3183,
     /* 154945 */       GIR_EraseRootFromParent_Done,
     /* 154946 */     // Label 2177: @154946
     /* 154946 */     GIM_Try, /*On fail goto*//*Label 2178*/ GIMT_Encode4(155020), // Rule ID 3199 //
     /* 154951 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 154954 */       // MIs[0] Operand 1
     /* 154954 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 154959 */       // (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_eq:{ *:[i32] }))
     /* 154959 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 154962 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 154966 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154971 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 154975 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 154979 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 154981 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 154984 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154988 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154993 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 155000 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 155005 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 155010 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 155013 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 155015 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 155018 */       GIR_RootConstrainSelectedInstOperands,
     /* 155019 */       // GIR_Coverage, 3199,
     /* 155019 */       GIR_EraseRootFromParent_Done,
     /* 155020 */     // Label 2178: @155020
     /* 155020 */     GIM_Try, /*On fail goto*//*Label 2179*/ GIMT_Encode4(155094), // Rule ID 3215 //
     /* 155025 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 155028 */       // MIs[0] Operand 1
     /* 155028 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 155033 */       // (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETO:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_un:{ *:[i32] }))
     /* 155033 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 155036 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 155040 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155045 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 155049 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 155053 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 155055 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 155058 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155062 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155067 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 155074 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 155079 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 155084 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 155087 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 155089 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 155092 */       GIR_RootConstrainSelectedInstOperands,
     /* 155093 */       // GIR_Coverage, 3215,
     /* 155093 */       GIR_EraseRootFromParent_Done,
     /* 155094 */     // Label 2179: @155094
     /* 155094 */     GIM_Reject,
     /* 155095 */   // Label 2175: @155095
     /* 155095 */   GIM_Reject,
     /* 155096 */   // Label 2172: @155096
     /* 155096 */   GIM_Try, /*On fail goto*//*Label 2180*/ GIMT_Encode4(155405),
     /* 155101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 155104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 155108 */     GIM_Try, /*On fail goto*//*Label 2181*/ GIMT_Encode4(155182), // Rule ID 3223 //
     /* 155113 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 155116 */       // MIs[0] Operand 1
     /* 155116 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 155121 */       // (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_lt:{ *:[i32] }))
     /* 155121 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 155124 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 155128 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155133 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 155137 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 155141 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 155143 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 155146 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155150 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155155 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 155162 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 155167 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 155172 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 155175 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 155177 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 155180 */       GIR_RootConstrainSelectedInstOperands,
     /* 155181 */       // GIR_Coverage, 3223,
     /* 155181 */       GIR_EraseRootFromParent_Done,
     /* 155182 */     // Label 2181: @155182
     /* 155182 */     GIM_Try, /*On fail goto*//*Label 2182*/ GIMT_Encode4(155256), // Rule ID 3239 //
     /* 155187 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 155190 */       // MIs[0] Operand 1
     /* 155190 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 155195 */       // (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }))
     /* 155195 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 155198 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 155202 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155207 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 155211 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 155215 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 155217 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 155220 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155224 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155229 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 155236 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 155241 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 155246 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 155249 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 155251 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 155254 */       GIR_RootConstrainSelectedInstOperands,
     /* 155255 */       // GIR_Coverage, 3239,
     /* 155255 */       GIR_EraseRootFromParent_Done,
     /* 155256 */     // Label 2182: @155256
     /* 155256 */     GIM_Try, /*On fail goto*//*Label 2183*/ GIMT_Encode4(155330), // Rule ID 3255 //
     /* 155261 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 155264 */       // MIs[0] Operand 1
     /* 155264 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 155269 */       // (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_eq:{ *:[i32] }))
     /* 155269 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 155272 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 155276 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155281 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 155285 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 155289 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 155291 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 155294 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155298 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155303 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 155310 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 155315 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 155320 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 155323 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 155325 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 155328 */       GIR_RootConstrainSelectedInstOperands,
     /* 155329 */       // GIR_Coverage, 3255,
     /* 155329 */       GIR_EraseRootFromParent_Done,
     /* 155330 */     // Label 2183: @155330
     /* 155330 */     GIM_Try, /*On fail goto*//*Label 2184*/ GIMT_Encode4(155404), // Rule ID 3271 //
     /* 155335 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 155338 */       // MIs[0] Operand 1
     /* 155338 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 155343 */       // (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETO:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_un:{ *:[i32] }))
     /* 155343 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 155346 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 155350 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155355 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 155359 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 155363 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 155365 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 155368 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155372 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155377 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 155384 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 155389 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 155394 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 155397 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 155399 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 155402 */       GIR_RootConstrainSelectedInstOperands,
     /* 155403 */       // GIR_Coverage, 3271,
     /* 155403 */       GIR_EraseRootFromParent_Done,
     /* 155404 */     // Label 2184: @155404
     /* 155404 */     GIM_Reject,
     /* 155405 */   // Label 2180: @155405
     /* 155405 */   GIM_Reject,
     /* 155406 */   // Label 2173: @155406
     /* 155406 */   GIM_Try, /*On fail goto*//*Label 2185*/ GIMT_Encode4(155715),
     /* 155411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /* 155414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 155418 */     GIM_Try, /*On fail goto*//*Label 2186*/ GIMT_Encode4(155492), // Rule ID 3279 //
     /* 155423 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 155426 */       // MIs[0] Operand 1
     /* 155426 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 155431 */       // (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_lt:{ *:[i32] }))
     /* 155431 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 155434 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 155438 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155443 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 155447 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 155451 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 155453 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 155456 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155460 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155465 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 155472 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 155477 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 155482 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 155485 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 155487 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 155490 */       GIR_RootConstrainSelectedInstOperands,
     /* 155491 */       // GIR_Coverage, 3279,
     /* 155491 */       GIR_EraseRootFromParent_Done,
     /* 155492 */     // Label 2186: @155492
     /* 155492 */     GIM_Try, /*On fail goto*//*Label 2187*/ GIMT_Encode4(155566), // Rule ID 3295 //
     /* 155497 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 155500 */       // MIs[0] Operand 1
     /* 155500 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 155505 */       // (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETULE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_gt:{ *:[i32] }))
     /* 155505 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 155508 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 155512 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155517 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 155521 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 155525 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 155527 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 155530 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155534 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155539 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 155546 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 155551 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 155556 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 155559 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 155561 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 155564 */       GIR_RootConstrainSelectedInstOperands,
     /* 155565 */       // GIR_Coverage, 3295,
     /* 155565 */       GIR_EraseRootFromParent_Done,
     /* 155566 */     // Label 2187: @155566
     /* 155566 */     GIM_Try, /*On fail goto*//*Label 2188*/ GIMT_Encode4(155640), // Rule ID 3311 //
     /* 155571 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 155574 */       // MIs[0] Operand 1
     /* 155574 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 155579 */       // (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUNE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_eq:{ *:[i32] }))
     /* 155579 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 155582 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 155586 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155591 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 155595 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 155599 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 155601 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 155604 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155608 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155613 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 155620 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 155625 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 155630 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 155633 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 155635 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 155638 */       GIR_RootConstrainSelectedInstOperands,
     /* 155639 */       // GIR_Coverage, 3311,
     /* 155639 */       GIR_EraseRootFromParent_Done,
     /* 155640 */     // Label 2188: @155640
     /* 155640 */     GIM_Try, /*On fail goto*//*Label 2189*/ GIMT_Encode4(155714), // Rule ID 3327 //
     /* 155645 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 155648 */       // MIs[0] Operand 1
     /* 155648 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 155653 */       // (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETO:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_un:{ *:[i32] }))
     /* 155653 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 155656 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 155660 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155665 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 155669 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 155673 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 155675 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 155678 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155682 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155687 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 155694 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 155699 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 155704 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 155707 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 155709 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 155712 */       GIR_RootConstrainSelectedInstOperands,
     /* 155713 */       // GIR_Coverage, 3327,
     /* 155713 */       GIR_EraseRootFromParent_Done,
     /* 155714 */     // Label 2189: @155714
     /* 155714 */     GIM_Reject,
     /* 155715 */   // Label 2185: @155715
     /* 155715 */   GIM_Reject,
     /* 155716 */   // Label 2174: @155716
     /* 155716 */   GIM_SwitchType, /*MI*/0, /*Op*/2, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 2193*/ GIMT_Encode4(157365),
     /* 155727 */   /*GILLT_s32*//*Label 2190*/ GIMT_Encode4(155739),
     /* 155731 */   /*GILLT_s64*//*Label 2191*/ GIMT_Encode4(156281),
     /* 155735 */   /*GILLT_s128*//*Label 2192*/ GIMT_Encode4(156823),
     /* 155739 */   // Label 2190: @155739
     /* 155739 */   GIM_Try, /*On fail goto*//*Label 2194*/ GIMT_Encode4(156280),
     /* 155744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 155747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 155751 */     GIM_Try, /*On fail goto*//*Label 2195*/ GIMT_Encode4(155809), // Rule ID 3962 //
     /* 155756 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 155759 */       // MIs[0] Operand 1
     /* 155759 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 155764 */       // (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETOLT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_lt:{ *:[i32] })
     /* 155764 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 155767 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 155771 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155776 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 155780 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 155784 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 155786 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155789 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155791 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 155798 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 155803 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 155808 */       // GIR_Coverage, 3962,
     /* 155808 */       GIR_EraseRootFromParent_Done,
     /* 155809 */     // Label 2195: @155809
     /* 155809 */     GIM_Try, /*On fail goto*//*Label 2196*/ GIMT_Encode4(155867), // Rule ID 3966 //
     /* 155814 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 155817 */       // MIs[0] Operand 1
     /* 155817 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OGT),
     /* 155822 */       // (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETOGT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] })
     /* 155822 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 155825 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 155829 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155834 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 155838 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 155842 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 155844 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155847 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155849 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 155856 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 155861 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 155866 */       // GIR_Coverage, 3966,
     /* 155866 */       GIR_EraseRootFromParent_Done,
     /* 155867 */     // Label 2196: @155867
     /* 155867 */     GIM_Try, /*On fail goto*//*Label 2197*/ GIMT_Encode4(155925), // Rule ID 3970 //
     /* 155872 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 155875 */       // MIs[0] Operand 1
     /* 155875 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 155880 */       // (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETOEQ:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_eq:{ *:[i32] })
     /* 155880 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 155883 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 155887 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155892 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 155896 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 155900 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 155902 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155905 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155907 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 155914 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 155919 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 155924 */       // GIR_Coverage, 3970,
     /* 155924 */       GIR_EraseRootFromParent_Done,
     /* 155925 */     // Label 2197: @155925
     /* 155925 */     GIM_Try, /*On fail goto*//*Label 2198*/ GIMT_Encode4(155983), // Rule ID 3974 //
     /* 155930 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 155933 */       // MIs[0] Operand 1
     /* 155933 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNO),
     /* 155938 */       // (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUO:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_un:{ *:[i32] })
     /* 155938 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 155941 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 155945 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155950 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 155954 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 155958 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 155960 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155963 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155965 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 155972 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 155977 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 155982 */       // GIR_Coverage, 3974,
     /* 155982 */       GIR_EraseRootFromParent_Done,
     /* 155983 */     // Label 2198: @155983
     /* 155983 */     GIM_Try, /*On fail goto*//*Label 2199*/ GIMT_Encode4(156057), // Rule ID 3976 //
     /* 155988 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 155991 */       // MIs[0] Operand 1
     /* 155991 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 155996 */       // (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_lt:{ *:[i32] }))
     /* 155996 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 155999 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 156003 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156008 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 156012 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 156016 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 156018 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 156021 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156025 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156030 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 156037 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 156042 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 156047 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 156050 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 156052 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 156055 */       GIR_RootConstrainSelectedInstOperands,
     /* 156056 */       // GIR_Coverage, 3976,
     /* 156056 */       GIR_EraseRootFromParent_Done,
     /* 156057 */     // Label 2199: @156057
     /* 156057 */     GIM_Try, /*On fail goto*//*Label 2200*/ GIMT_Encode4(156131), // Rule ID 4008 //
     /* 156062 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 156065 */       // MIs[0] Operand 1
     /* 156065 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 156070 */       // (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }))
     /* 156070 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 156073 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 156077 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156082 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 156086 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 156090 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 156092 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 156095 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156099 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156104 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 156111 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 156116 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 156121 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 156124 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 156126 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 156129 */       GIR_RootConstrainSelectedInstOperands,
     /* 156130 */       // GIR_Coverage, 4008,
     /* 156130 */       GIR_EraseRootFromParent_Done,
     /* 156131 */     // Label 2200: @156131
     /* 156131 */     GIM_Try, /*On fail goto*//*Label 2201*/ GIMT_Encode4(156205), // Rule ID 4040 //
     /* 156136 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 156139 */       // MIs[0] Operand 1
     /* 156139 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 156144 */       // (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_eq:{ *:[i32] }))
     /* 156144 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 156147 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 156151 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156156 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 156160 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 156164 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 156166 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 156169 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156173 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156178 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 156185 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 156190 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 156195 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 156198 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 156200 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 156203 */       GIR_RootConstrainSelectedInstOperands,
     /* 156204 */       // GIR_Coverage, 4040,
     /* 156204 */       GIR_EraseRootFromParent_Done,
     /* 156205 */     // Label 2201: @156205
     /* 156205 */     GIM_Try, /*On fail goto*//*Label 2202*/ GIMT_Encode4(156279), // Rule ID 4072 //
     /* 156210 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 156213 */       // MIs[0] Operand 1
     /* 156213 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 156218 */       // (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETO:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_un:{ *:[i32] }))
     /* 156218 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 156221 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 156225 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156230 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 156234 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 156238 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 156240 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 156243 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156247 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156252 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 156259 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 156264 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 156269 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 156272 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 156274 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 156277 */       GIR_RootConstrainSelectedInstOperands,
     /* 156278 */       // GIR_Coverage, 4072,
     /* 156278 */       GIR_EraseRootFromParent_Done,
     /* 156279 */     // Label 2202: @156279
     /* 156279 */     GIM_Reject,
     /* 156280 */   // Label 2194: @156280
     /* 156280 */   GIM_Reject,
     /* 156281 */   // Label 2191: @156281
     /* 156281 */   GIM_Try, /*On fail goto*//*Label 2203*/ GIMT_Encode4(156822),
     /* 156286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 156289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 156293 */     GIM_Try, /*On fail goto*//*Label 2204*/ GIMT_Encode4(156367), // Rule ID 4088 //
     /* 156298 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 156301 */       // MIs[0] Operand 1
     /* 156301 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 156306 */       // (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_lt:{ *:[i32] }))
     /* 156306 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 156309 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 156313 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156318 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 156322 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 156326 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 156328 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 156331 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156335 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156340 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 156347 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 156352 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 156357 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 156360 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 156362 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 156365 */       GIR_RootConstrainSelectedInstOperands,
     /* 156366 */       // GIR_Coverage, 4088,
     /* 156366 */       GIR_EraseRootFromParent_Done,
     /* 156367 */     // Label 2204: @156367
     /* 156367 */     GIM_Try, /*On fail goto*//*Label 2205*/ GIMT_Encode4(156441), // Rule ID 4120 //
     /* 156372 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 156375 */       // MIs[0] Operand 1
     /* 156375 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 156380 */       // (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }))
     /* 156380 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 156383 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 156387 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156392 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 156396 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 156400 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 156402 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 156405 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156409 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156414 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 156421 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 156426 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 156431 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 156434 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 156436 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 156439 */       GIR_RootConstrainSelectedInstOperands,
     /* 156440 */       // GIR_Coverage, 4120,
     /* 156440 */       GIR_EraseRootFromParent_Done,
     /* 156441 */     // Label 2205: @156441
     /* 156441 */     GIM_Try, /*On fail goto*//*Label 2206*/ GIMT_Encode4(156515), // Rule ID 4152 //
     /* 156446 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 156449 */       // MIs[0] Operand 1
     /* 156449 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 156454 */       // (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_eq:{ *:[i32] }))
     /* 156454 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 156457 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 156461 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156466 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 156470 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 156474 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 156476 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 156479 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156483 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156488 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 156495 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 156500 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 156505 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 156508 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 156510 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 156513 */       GIR_RootConstrainSelectedInstOperands,
     /* 156514 */       // GIR_Coverage, 4152,
     /* 156514 */       GIR_EraseRootFromParent_Done,
     /* 156515 */     // Label 2206: @156515
     /* 156515 */     GIM_Try, /*On fail goto*//*Label 2207*/ GIMT_Encode4(156589), // Rule ID 4184 //
     /* 156520 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 156523 */       // MIs[0] Operand 1
     /* 156523 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 156528 */       // (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETO:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_un:{ *:[i32] }))
     /* 156528 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 156531 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 156535 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156540 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 156544 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 156548 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 156550 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 156553 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156557 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156562 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 156569 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 156574 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 156579 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 156582 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 156584 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 156587 */       GIR_RootConstrainSelectedInstOperands,
     /* 156588 */       // GIR_Coverage, 4184,
     /* 156588 */       GIR_EraseRootFromParent_Done,
     /* 156589 */     // Label 2207: @156589
     /* 156589 */     GIM_Try, /*On fail goto*//*Label 2208*/ GIMT_Encode4(156647), // Rule ID 4200 //
     /* 156594 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 156597 */       // MIs[0] Operand 1
     /* 156597 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 156602 */       // (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETOLT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_lt:{ *:[i32] })
     /* 156602 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 156605 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 156609 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156614 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 156618 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 156622 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 156624 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156627 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156629 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 156636 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 156641 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 156646 */       // GIR_Coverage, 4200,
     /* 156646 */       GIR_EraseRootFromParent_Done,
     /* 156647 */     // Label 2208: @156647
     /* 156647 */     GIM_Try, /*On fail goto*//*Label 2209*/ GIMT_Encode4(156705), // Rule ID 4204 //
     /* 156652 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 156655 */       // MIs[0] Operand 1
     /* 156655 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OGT),
     /* 156660 */       // (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETOGT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] })
     /* 156660 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 156663 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 156667 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156672 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 156676 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 156680 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 156682 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156685 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156687 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 156694 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 156699 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 156704 */       // GIR_Coverage, 4204,
     /* 156704 */       GIR_EraseRootFromParent_Done,
     /* 156705 */     // Label 2209: @156705
     /* 156705 */     GIM_Try, /*On fail goto*//*Label 2210*/ GIMT_Encode4(156763), // Rule ID 4208 //
     /* 156710 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 156713 */       // MIs[0] Operand 1
     /* 156713 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 156718 */       // (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETOEQ:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_eq:{ *:[i32] })
     /* 156718 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 156721 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 156725 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156730 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 156734 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 156738 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 156740 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156743 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156745 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 156752 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 156757 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 156762 */       // GIR_Coverage, 4208,
     /* 156762 */       GIR_EraseRootFromParent_Done,
     /* 156763 */     // Label 2210: @156763
     /* 156763 */     GIM_Try, /*On fail goto*//*Label 2211*/ GIMT_Encode4(156821), // Rule ID 4212 //
     /* 156768 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 156771 */       // MIs[0] Operand 1
     /* 156771 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNO),
     /* 156776 */       // (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUO:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_un:{ *:[i32] })
     /* 156776 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 156779 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 156783 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156788 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 156792 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 156796 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 156798 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156801 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156803 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 156810 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 156815 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 156820 */       // GIR_Coverage, 4212,
     /* 156820 */       GIR_EraseRootFromParent_Done,
     /* 156821 */     // Label 2211: @156821
     /* 156821 */     GIM_Reject,
     /* 156822 */   // Label 2203: @156822
     /* 156822 */   GIM_Reject,
     /* 156823 */   // Label 2192: @156823
     /* 156823 */   GIM_Try, /*On fail goto*//*Label 2212*/ GIMT_Encode4(157364),
     /* 156828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /* 156831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 156835 */     GIM_Try, /*On fail goto*//*Label 2213*/ GIMT_Encode4(156909), // Rule ID 4214 //
     /* 156840 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 156843 */       // MIs[0] Operand 1
     /* 156843 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 156848 */       // (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_lt:{ *:[i32] }))
     /* 156848 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 156851 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 156855 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156860 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 156864 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 156868 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 156870 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 156873 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156877 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156882 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 156889 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 156894 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 156899 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 156902 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 156904 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 156907 */       GIR_RootConstrainSelectedInstOperands,
     /* 156908 */       // GIR_Coverage, 4214,
     /* 156908 */       GIR_EraseRootFromParent_Done,
     /* 156909 */     // Label 2213: @156909
     /* 156909 */     GIM_Try, /*On fail goto*//*Label 2214*/ GIMT_Encode4(156983), // Rule ID 4246 //
     /* 156914 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 156917 */       // MIs[0] Operand 1
     /* 156917 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 156922 */       // (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETULE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_gt:{ *:[i32] }))
     /* 156922 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 156925 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 156929 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156934 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 156938 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 156942 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 156944 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 156947 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156951 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156956 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 156963 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 156968 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 156973 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 156976 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 156978 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 156981 */       GIR_RootConstrainSelectedInstOperands,
     /* 156982 */       // GIR_Coverage, 4246,
     /* 156982 */       GIR_EraseRootFromParent_Done,
     /* 156983 */     // Label 2214: @156983
     /* 156983 */     GIM_Try, /*On fail goto*//*Label 2215*/ GIMT_Encode4(157057), // Rule ID 4278 //
     /* 156988 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 156991 */       // MIs[0] Operand 1
     /* 156991 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 156996 */       // (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUNE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_eq:{ *:[i32] }))
     /* 156996 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 156999 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 157003 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157008 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 157012 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 157016 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 157018 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 157021 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157025 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157030 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 157037 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 157042 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 157047 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 157050 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 157052 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 157055 */       GIR_RootConstrainSelectedInstOperands,
     /* 157056 */       // GIR_Coverage, 4278,
     /* 157056 */       GIR_EraseRootFromParent_Done,
     /* 157057 */     // Label 2215: @157057
     /* 157057 */     GIM_Try, /*On fail goto*//*Label 2216*/ GIMT_Encode4(157131), // Rule ID 4310 //
     /* 157062 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 157065 */       // MIs[0] Operand 1
     /* 157065 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 157070 */       // (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETO:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_un:{ *:[i32] }))
     /* 157070 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 157073 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 157077 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157082 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 157086 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 157090 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 157092 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 157095 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157099 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157104 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 157111 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 157116 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 157121 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 157124 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 157126 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 157129 */       GIR_RootConstrainSelectedInstOperands,
     /* 157130 */       // GIR_Coverage, 4310,
     /* 157130 */       GIR_EraseRootFromParent_Done,
     /* 157131 */     // Label 2216: @157131
     /* 157131 */     GIM_Try, /*On fail goto*//*Label 2217*/ GIMT_Encode4(157189), // Rule ID 4326 //
     /* 157136 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 157139 */       // MIs[0] Operand 1
     /* 157139 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 157144 */       // (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETOLT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_lt:{ *:[i32] })
     /* 157144 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 157147 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 157151 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157156 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 157160 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 157164 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 157166 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157169 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157171 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 157178 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 157183 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 157188 */       // GIR_Coverage, 4326,
     /* 157188 */       GIR_EraseRootFromParent_Done,
     /* 157189 */     // Label 2217: @157189
     /* 157189 */     GIM_Try, /*On fail goto*//*Label 2218*/ GIMT_Encode4(157247), // Rule ID 4330 //
     /* 157194 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 157197 */       // MIs[0] Operand 1
     /* 157197 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OGT),
     /* 157202 */       // (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETOGT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_gt:{ *:[i32] })
     /* 157202 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 157205 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 157209 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157214 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 157218 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 157222 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 157224 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157227 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157229 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 157236 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 157241 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 157246 */       // GIR_Coverage, 4330,
     /* 157246 */       GIR_EraseRootFromParent_Done,
     /* 157247 */     // Label 2218: @157247
     /* 157247 */     GIM_Try, /*On fail goto*//*Label 2219*/ GIMT_Encode4(157305), // Rule ID 4334 //
     /* 157252 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 157255 */       // MIs[0] Operand 1
     /* 157255 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 157260 */       // (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETOEQ:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_eq:{ *:[i32] })
     /* 157260 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 157263 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 157267 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157272 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 157276 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 157280 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 157282 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157285 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157287 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 157294 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 157299 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 157304 */       // GIR_Coverage, 4334,
     /* 157304 */       GIR_EraseRootFromParent_Done,
     /* 157305 */     // Label 2219: @157305
     /* 157305 */     GIM_Try, /*On fail goto*//*Label 2220*/ GIMT_Encode4(157363), // Rule ID 4338 //
     /* 157310 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 157313 */       // MIs[0] Operand 1
     /* 157313 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNO),
     /* 157318 */       // (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUO:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_un:{ *:[i32] })
     /* 157318 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 157321 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 157325 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157330 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 157334 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 157338 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 157340 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157343 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157345 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 157352 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 157357 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 157362 */       // GIR_Coverage, 4338,
     /* 157362 */       GIR_EraseRootFromParent_Done,
     /* 157363 */     // Label 2220: @157363
     /* 157363 */     GIM_Reject,
     /* 157364 */   // Label 2212: @157364
     /* 157364 */   GIM_Reject,
     /* 157365 */   // Label 2193: @157365
     /* 157365 */   GIM_SwitchType, /*MI*/0, /*Op*/2, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 2223*/ GIMT_Encode4(158204),
     /* 157376 */   /*GILLT_s32*//*Label 2221*/ GIMT_Encode4(157384),
     /* 157380 */   /*GILLT_s64*//*Label 2222*/ GIMT_Encode4(157794),
     /* 157384 */   // Label 2221: @157384
     /* 157384 */   GIM_Try, /*On fail goto*//*Label 2224*/ GIMT_Encode4(157793),
     /* 157389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 157392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 157396 */     GIM_Try, /*On fail goto*//*Label 2225*/ GIMT_Encode4(157454), // Rule ID 4529 //
     /* 157401 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 157404 */       // MIs[0] Operand 1
     /* 157404 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 157409 */       // (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETOLT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPLT:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] })
     /* 157409 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 157412 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::EFSCMPLT),
     /* 157416 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157421 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 157425 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 157429 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 157431 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157434 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157436 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 157443 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 157448 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 157453 */       // GIR_Coverage, 4529,
     /* 157453 */       GIR_EraseRootFromParent_Done,
     /* 157454 */     // Label 2225: @157454
     /* 157454 */     GIM_Try, /*On fail goto*//*Label 2226*/ GIMT_Encode4(157512), // Rule ID 4533 //
     /* 157459 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 157462 */       // MIs[0] Operand 1
     /* 157462 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OGT),
     /* 157467 */       // (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETOGT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPGT:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] })
     /* 157467 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 157470 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::EFSCMPGT),
     /* 157474 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157479 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 157483 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 157487 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 157489 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157492 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157494 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 157501 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 157506 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 157511 */       // GIR_Coverage, 4533,
     /* 157511 */       GIR_EraseRootFromParent_Done,
     /* 157512 */     // Label 2226: @157512
     /* 157512 */     GIM_Try, /*On fail goto*//*Label 2227*/ GIMT_Encode4(157570), // Rule ID 4537 //
     /* 157517 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 157520 */       // MIs[0] Operand 1
     /* 157520 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 157525 */       // (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETOEQ:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPEQ:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] })
     /* 157525 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 157528 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::EFSCMPEQ),
     /* 157532 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157537 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 157541 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 157545 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 157547 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157550 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157552 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 157559 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 157564 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 157569 */       // GIR_Coverage, 4537,
     /* 157569 */       GIR_EraseRootFromParent_Done,
     /* 157570 */     // Label 2227: @157570
     /* 157570 */     GIM_Try, /*On fail goto*//*Label 2228*/ GIMT_Encode4(157644), // Rule ID 4541 //
     /* 157575 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 157578 */       // MIs[0] Operand 1
     /* 157578 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 157583 */       // (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPLT:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }))
     /* 157583 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 157586 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPLT),
     /* 157590 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157595 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 157599 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 157603 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 157605 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 157608 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157612 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157617 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 157624 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 157629 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 157634 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 157637 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 157639 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 157642 */       GIR_RootConstrainSelectedInstOperands,
     /* 157643 */       // GIR_Coverage, 4541,
     /* 157643 */       GIR_EraseRootFromParent_Done,
     /* 157644 */     // Label 2228: @157644
     /* 157644 */     GIM_Try, /*On fail goto*//*Label 2229*/ GIMT_Encode4(157718), // Rule ID 4573 //
     /* 157649 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 157652 */       // MIs[0] Operand 1
     /* 157652 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 157657 */       // (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPGT:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }))
     /* 157657 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 157660 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPGT),
     /* 157664 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157669 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 157673 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 157677 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 157679 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 157682 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157686 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157691 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 157698 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 157703 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 157708 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 157711 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 157713 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 157716 */       GIR_RootConstrainSelectedInstOperands,
     /* 157717 */       // GIR_Coverage, 4573,
     /* 157717 */       GIR_EraseRootFromParent_Done,
     /* 157718 */     // Label 2229: @157718
     /* 157718 */     GIM_Try, /*On fail goto*//*Label 2230*/ GIMT_Encode4(157792), // Rule ID 4605 //
     /* 157723 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 157726 */       // MIs[0] Operand 1
     /* 157726 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 157731 */       // (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPEQ:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }))
     /* 157731 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 157734 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPEQ),
     /* 157738 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157743 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 157747 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 157751 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 157753 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 157756 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157760 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157765 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 157772 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 157777 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 157782 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 157785 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 157787 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 157790 */       GIR_RootConstrainSelectedInstOperands,
     /* 157791 */       // GIR_Coverage, 4605,
     /* 157791 */       GIR_EraseRootFromParent_Done,
     /* 157792 */     // Label 2230: @157792
     /* 157792 */     GIM_Reject,
     /* 157793 */   // Label 2224: @157793
     /* 157793 */   GIM_Reject,
     /* 157794 */   // Label 2222: @157794
     /* 157794 */   GIM_Try, /*On fail goto*//*Label 2231*/ GIMT_Encode4(158203),
     /* 157799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 157802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 157806 */     GIM_Try, /*On fail goto*//*Label 2232*/ GIMT_Encode4(157864), // Rule ID 4637 //
     /* 157811 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 157814 */       // MIs[0] Operand 1
     /* 157814 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 157819 */       // (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETOLT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPLT:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] })
     /* 157819 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 157822 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::EFDCMPLT),
     /* 157826 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157831 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 157835 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 157839 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 157841 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157844 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157846 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 157853 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 157858 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 157863 */       // GIR_Coverage, 4637,
     /* 157863 */       GIR_EraseRootFromParent_Done,
     /* 157864 */     // Label 2232: @157864
     /* 157864 */     GIM_Try, /*On fail goto*//*Label 2233*/ GIMT_Encode4(157922), // Rule ID 4641 //
     /* 157869 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 157872 */       // MIs[0] Operand 1
     /* 157872 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OGT),
     /* 157877 */       // (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETOGT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPGT:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] })
     /* 157877 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 157880 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::EFDCMPGT),
     /* 157884 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157889 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 157893 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 157897 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 157899 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157902 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157904 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 157911 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 157916 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 157921 */       // GIR_Coverage, 4641,
     /* 157921 */       GIR_EraseRootFromParent_Done,
     /* 157922 */     // Label 2233: @157922
     /* 157922 */     GIM_Try, /*On fail goto*//*Label 2234*/ GIMT_Encode4(157980), // Rule ID 4645 //
     /* 157927 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 157930 */       // MIs[0] Operand 1
     /* 157930 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 157935 */       // (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETOEQ:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPEQ:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] })
     /* 157935 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 157938 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::EFDCMPEQ),
     /* 157942 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157947 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 157951 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 157955 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 157957 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157960 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157962 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 157969 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 157974 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 157979 */       // GIR_Coverage, 4645,
     /* 157979 */       GIR_EraseRootFromParent_Done,
     /* 157980 */     // Label 2234: @157980
     /* 157980 */     GIM_Try, /*On fail goto*//*Label 2235*/ GIMT_Encode4(158054), // Rule ID 4649 //
     /* 157985 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 157988 */       // MIs[0] Operand 1
     /* 157988 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 157993 */       // (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPLT:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }))
     /* 157993 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 157996 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPLT),
     /* 158000 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158005 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 158009 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 158013 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 158015 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 158018 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158022 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158027 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 158034 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 158039 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 158044 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 158047 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 158049 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 158052 */       GIR_RootConstrainSelectedInstOperands,
     /* 158053 */       // GIR_Coverage, 4649,
     /* 158053 */       GIR_EraseRootFromParent_Done,
     /* 158054 */     // Label 2235: @158054
     /* 158054 */     GIM_Try, /*On fail goto*//*Label 2236*/ GIMT_Encode4(158128), // Rule ID 4681 //
     /* 158059 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 158062 */       // MIs[0] Operand 1
     /* 158062 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 158067 */       // (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPGT:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }))
     /* 158067 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 158070 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPGT),
     /* 158074 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158079 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 158083 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 158087 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 158089 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 158092 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158096 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158101 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 158108 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 158113 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 158118 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 158121 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 158123 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 158126 */       GIR_RootConstrainSelectedInstOperands,
     /* 158127 */       // GIR_Coverage, 4681,
     /* 158127 */       GIR_EraseRootFromParent_Done,
     /* 158128 */     // Label 2236: @158128
     /* 158128 */     GIM_Try, /*On fail goto*//*Label 2237*/ GIMT_Encode4(158202), // Rule ID 4713 //
     /* 158133 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 158136 */       // MIs[0] Operand 1
     /* 158136 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 158141 */       // (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPEQ:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }))
     /* 158141 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 158144 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPEQ),
     /* 158148 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158153 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 158157 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 158161 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 158163 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 158166 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158170 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158175 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 158182 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 158187 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 158192 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 158195 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 158197 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 158200 */       GIR_RootConstrainSelectedInstOperands,
     /* 158201 */       // GIR_Coverage, 4713,
     /* 158201 */       GIR_EraseRootFromParent_Done,
     /* 158202 */     // Label 2237: @158202
     /* 158202 */     GIM_Reject,
     /* 158203 */   // Label 2231: @158203
     /* 158203 */   GIM_Reject,
     /* 158204 */   // Label 2223: @158204
     /* 158204 */   GIM_Reject,
     /* 158205 */ // Label 2170: @158205
     /* 158205 */ GIM_Reject,
     /* 158206 */ // Label 33: @158206
     /* 158206 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(8), /*)*//*default:*//*Label 2246*/ GIMT_Encode4(159329),
     /* 158217 */ /*GILLT_s1*//*Label 2238*/ GIMT_Encode4(158249),
     /* 158221 */ /*GILLT_s32*//*Label 2239*/ GIMT_Encode4(158342),
     /* 158225 */ /*GILLT_s64*//*Label 2240*/ GIMT_Encode4(158431),
     /* 158229 */ /*GILLT_s128*//*Label 2241*/ GIMT_Encode4(158520),
     /* 158233 */ /*GILLT_v2s64*//*Label 2242*/ GIMT_Encode4(158704),
     /* 158237 */ /*GILLT_v4s32*//*Label 2243*/ GIMT_Encode4(158869),
     /* 158241 */ /*GILLT_v8s16*//*Label 2244*/ GIMT_Encode4(159031),
     /* 158245 */ /*GILLT_v16s8*//*Label 2245*/ GIMT_Encode4(159180),
     /* 158249 */ // Label 2238: @158249
     /* 158249 */ GIM_Try, /*On fail goto*//*Label 2247*/ GIMT_Encode4(158341), // Rule ID 4744 //
     /* 158254 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 158257 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s1,
     /* 158260 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s1,
     /* 158263 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 158267 */   // (select:{ *:[i1] } i1:{ *:[i1] }:$cond, i1:{ *:[i1] }:$tval, i1:{ *:[i1] }:$fval)  =>  (CROR:{ *:[i1] } (CRAND:{ *:[i1] } ?:{ *:[i1] }:$cond, ?:{ *:[i1] }:$tval), (CRAND:{ *:[i1] } (CRNOT:{ *:[i1] } ?:{ *:[i1] }:$cond), ?:{ *:[i1] }:$fval))
     /* 158267 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s1,
     /* 158270 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 158274 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158279 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // cond
     /* 158283 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 158285 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s1,
     /* 158288 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CRAND),
     /* 158292 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158297 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 158300 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // fval
     /* 158304 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 158306 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 158309 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CRAND),
     /* 158313 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158318 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // cond
     /* 158322 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // tval
     /* 158326 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 158328 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CROR),
     /* 158331 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 158333 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 158336 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 158339 */   GIR_RootConstrainSelectedInstOperands,
     /* 158340 */   // GIR_Coverage, 4744,
     /* 158340 */   GIR_EraseRootFromParent_Done,
     /* 158341 */ // Label 2247: @158341
     /* 158341 */ GIM_Reject,
     /* 158342 */ // Label 2239: @158342
     /* 158342 */ GIM_Try, /*On fail goto*//*Label 2248*/ GIMT_Encode4(158430),
     /* 158347 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 158350 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 158353 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 158356 */   GIM_Try, /*On fail goto*//*Label 2249*/ GIMT_Encode4(158375), // Rule ID 1051 //
     /* 158361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 158364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 158368 */     // (select:{ *:[f32] } i1:{ *:[i1] }:$cond, f32:{ *:[f32] }:$T, f32:{ *:[f32] }:$F)  =>  (SELECT_VSSRC:{ *:[f32] } i1:{ *:[i1] }:$cond, f32:{ *:[f32] }:$T, f32:{ *:[f32] }:$F)
     /* 158368 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SELECT_VSSRC),
     /* 158373 */     GIR_RootConstrainSelectedInstOperands,
     /* 158374 */     // GIR_Coverage, 1051,
     /* 158374 */     GIR_Done,
     /* 158375 */   // Label 2249: @158375
     /* 158375 */   GIM_Try, /*On fail goto*//*Label 2250*/ GIMT_Encode4(158391), // Rule ID 5 //
     /* 158380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 158384 */     // (select:{ *:[i32] } i1:{ *:[i1] }:$cond, i32:{ *:[i32] }:$T, i32:{ *:[i32] }:$F)  =>  (SELECT_I4:{ *:[i32] } i1:{ *:[i1] }:$cond, i32:{ *:[i32] }:$T, i32:{ *:[i32] }:$F)
     /* 158384 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 158389 */     GIR_RootConstrainSelectedInstOperands,
     /* 158390 */     // GIR_Coverage, 5,
     /* 158390 */     GIR_Done,
     /* 158391 */   // Label 2250: @158391
     /* 158391 */   GIM_Try, /*On fail goto*//*Label 2251*/ GIMT_Encode4(158410), // Rule ID 7 //
     /* 158396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 158399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 158403 */     // (select:{ *:[f32] } i1:{ *:[i1] }:$cond, f32:{ *:[f32] }:$T, f32:{ *:[f32] }:$F)  =>  (SELECT_F4:{ *:[f32] } i1:{ *:[i1] }:$cond, f32:{ *:[f32] }:$T, f32:{ *:[f32] }:$F)
     /* 158403 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SELECT_F4),
     /* 158408 */     GIR_RootConstrainSelectedInstOperands,
     /* 158409 */     // GIR_Coverage, 7,
     /* 158409 */     GIR_Done,
     /* 158410 */   // Label 2251: @158410
     /* 158410 */   GIM_Try, /*On fail goto*//*Label 2252*/ GIMT_Encode4(158429), // Rule ID 606 //
     /* 158415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 158418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 158422 */     // (select:{ *:[f32] } i1:{ *:[i1] }:$cond, f32:{ *:[f32] }:$T, f32:{ *:[f32] }:$F)  =>  (SELECT_SPE4:{ *:[f32] } i1:{ *:[i1] }:$cond, f32:{ *:[f32] }:$T, f32:{ *:[f32] }:$F)
     /* 158422 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SELECT_SPE4),
     /* 158427 */     GIR_RootConstrainSelectedInstOperands,
     /* 158428 */     // GIR_Coverage, 606,
     /* 158428 */     GIR_Done,
     /* 158429 */   // Label 2252: @158429
     /* 158429 */   GIM_Reject,
     /* 158430 */ // Label 2248: @158430
     /* 158430 */ GIM_Reject,
     /* 158431 */ // Label 2240: @158431
     /* 158431 */ GIM_Try, /*On fail goto*//*Label 2253*/ GIMT_Encode4(158519),
     /* 158436 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 158439 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 158442 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 158445 */   GIM_Try, /*On fail goto*//*Label 2254*/ GIMT_Encode4(158464), // Rule ID 1050 //
     /* 158450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 158453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 158457 */     // (select:{ *:[f64] } i1:{ *:[i1] }:$cond, f64:{ *:[f64] }:$T, f64:{ *:[f64] }:$F)  =>  (SELECT_VSFRC:{ *:[f64] } i1:{ *:[i1] }:$cond, f64:{ *:[f64] }:$T, f64:{ *:[f64] }:$F)
     /* 158457 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SELECT_VSFRC),
     /* 158462 */     GIR_RootConstrainSelectedInstOperands,
     /* 158463 */     // GIR_Coverage, 1050,
     /* 158463 */     GIR_Done,
     /* 158464 */   // Label 2254: @158464
     /* 158464 */   GIM_Try, /*On fail goto*//*Label 2255*/ GIMT_Encode4(158480), // Rule ID 6 //
     /* 158469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 158473 */     // (select:{ *:[i64] } i1:{ *:[i1] }:$cond, i64:{ *:[i64] }:$T, i64:{ *:[i64] }:$F)  =>  (SELECT_I8:{ *:[i64] } i1:{ *:[i1] }:$cond, i64:{ *:[i64] }:$T, i64:{ *:[i64] }:$F)
     /* 158473 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 158478 */     GIR_RootConstrainSelectedInstOperands,
     /* 158479 */     // GIR_Coverage, 6,
     /* 158479 */     GIR_Done,
     /* 158480 */   // Label 2255: @158480
     /* 158480 */   GIM_Try, /*On fail goto*//*Label 2256*/ GIMT_Encode4(158499), // Rule ID 8 //
     /* 158485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 158488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 158492 */     // (select:{ *:[f64] } i1:{ *:[i1] }:$cond, f64:{ *:[f64] }:$T, f64:{ *:[f64] }:$F)  =>  (SELECT_F8:{ *:[f64] } i1:{ *:[i1] }:$cond, f64:{ *:[f64] }:$T, f64:{ *:[f64] }:$F)
     /* 158492 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SELECT_F8),
     /* 158497 */     GIR_RootConstrainSelectedInstOperands,
     /* 158498 */     // GIR_Coverage, 8,
     /* 158498 */     GIR_Done,
     /* 158499 */   // Label 2256: @158499
     /* 158499 */   GIM_Try, /*On fail goto*//*Label 2257*/ GIMT_Encode4(158518), // Rule ID 607 //
     /* 158504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 158507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::SPERCRegClassID),
     /* 158511 */     // (select:{ *:[f64] } i1:{ *:[i1] }:$cond, f64:{ *:[f64] }:$T, f64:{ *:[f64] }:$F)  =>  (SELECT_SPE:{ *:[f64] } i1:{ *:[i1] }:$cond, f64:{ *:[f64] }:$T, f64:{ *:[f64] }:$F)
     /* 158511 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SELECT_SPE),
     /* 158516 */     GIR_RootConstrainSelectedInstOperands,
     /* 158517 */     // GIR_Coverage, 607,
     /* 158517 */     GIR_Done,
     /* 158518 */   // Label 2257: @158518
     /* 158518 */   GIM_Reject,
     /* 158519 */ // Label 2253: @158519
     /* 158519 */ GIM_Reject,
     /* 158520 */ // Label 2241: @158520
     /* 158520 */ GIM_Try, /*On fail goto*//*Label 2258*/ GIMT_Encode4(158641), // Rule ID 1668 //
     /* 158525 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 158528 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 158531 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /* 158534 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /* 158537 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 158541 */   // (vselect:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$vA, v1i128:{ *:[v1i128] }:$vB, v1i128:{ *:[v1i128] }:$vC)  =>  (COPY_TO_REGCLASS:{ *:[v1i128] } (XXSEL:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v1i128] }:$vC, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v1i128] }:$vB, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v1i128] }:$vA, VSRC:{ *:[i32] })), VRRC:{ *:[i32] })
     /* 158541 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 158544 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158548 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158553 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // vA
     /* 158557 */   GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /* 158562 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 158565 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158569 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158574 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // vB
     /* 158578 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /* 158583 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 158586 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158590 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158595 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // vC
     /* 158599 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /* 158604 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 158607 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXSEL),
     /* 158611 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158616 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 158619 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 158622 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 158625 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 158627 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158630 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158632 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 158635 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /* 158640 */   // GIR_Coverage, 1668,
     /* 158640 */   GIR_EraseRootFromParent_Done,
     /* 158641 */ // Label 2258: @158641
     /* 158641 */ GIM_Try, /*On fail goto*//*Label 2259*/ GIMT_Encode4(158669), // Rule ID 9 //
     /* 158646 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 158649 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 158652 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /* 158655 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /* 158658 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 158662 */   // (select:{ *:[f128] } i1:{ *:[i1] }:$cond, f128:{ *:[f128] }:$T, f128:{ *:[f128] }:$F)  =>  (SELECT_F16:{ *:[f128] } i1:{ *:[i1] }:$cond, f128:{ *:[f128] }:$T, f128:{ *:[f128] }:$F)
     /* 158662 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SELECT_F16),
     /* 158667 */   GIR_RootConstrainSelectedInstOperands,
     /* 158668 */   // GIR_Coverage, 9,
     /* 158668 */   GIR_Done,
     /* 158669 */ // Label 2259: @158669
     /* 158669 */ GIM_Try, /*On fail goto*//*Label 2260*/ GIMT_Encode4(158703), // Rule ID 1423 //
     /* 158674 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 158677 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 158680 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /* 158683 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /* 158686 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 158690 */   // (vselect:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$vA, v1i128:{ *:[v1i128] }:$vB, v1i128:{ *:[v1i128] }:$vC)  =>  (VSEL:{ *:[v1i128] } ?:{ *:[v1i128] }:$vC, ?:{ *:[v1i128] }:$vB, ?:{ *:[v1i128] }:$vA)
     /* 158690 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSEL),
     /* 158693 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /* 158695 */   GIR_RootToRootCopy, /*OpIdx*/3, // vC
     /* 158697 */   GIR_RootToRootCopy, /*OpIdx*/2, // vB
     /* 158699 */   GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /* 158701 */   GIR_RootConstrainSelectedInstOperands,
     /* 158702 */   // GIR_Coverage, 1423,
     /* 158702 */   GIR_EraseRootFromParent_Done,
     /* 158703 */ // Label 2260: @158703
     /* 158703 */ GIM_Reject,
     /* 158704 */ // Label 2242: @158704
     /* 158704 */ GIM_Try, /*On fail goto*//*Label 2261*/ GIMT_Encode4(158732), // Rule ID 1049 //
     /* 158709 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 158712 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 158715 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 158718 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 158721 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 158725 */   // (select:{ *:[v2f64] } i1:{ *:[i1] }:$cond, v2f64:{ *:[v2f64] }:$T, v2f64:{ *:[v2f64] }:$F)  =>  (SELECT_VSRC:{ *:[v2f64] } i1:{ *:[i1] }:$cond, v2f64:{ *:[v2f64] }:$T, v2f64:{ *:[v2f64] }:$F)
     /* 158725 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SELECT_VSRC),
     /* 158730 */   GIR_RootConstrainSelectedInstOperands,
     /* 158731 */   // GIR_Coverage, 1049,
     /* 158731 */   GIR_Done,
     /* 158732 */ // Label 2261: @158732
     /* 158732 */ GIM_Try, /*On fail goto*//*Label 2262*/ GIMT_Encode4(158766), // Rule ID 1665 //
     /* 158737 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 158740 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 158743 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 158746 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 158749 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 158753 */   // (vselect:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$vA, v2i64:{ *:[v2i64] }:$vB, v2i64:{ *:[v2i64] }:$vC)  =>  (XXSEL:{ *:[v2i64] } ?:{ *:[v2i64] }:$vC, ?:{ *:[v2i64] }:$vB, ?:{ *:[v2i64] }:$vA)
     /* 158753 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSEL),
     /* 158756 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 158758 */   GIR_RootToRootCopy, /*OpIdx*/3, // vC
     /* 158760 */   GIR_RootToRootCopy, /*OpIdx*/2, // vB
     /* 158762 */   GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /* 158764 */   GIR_RootConstrainSelectedInstOperands,
     /* 158765 */   // GIR_Coverage, 1665,
     /* 158765 */   GIR_EraseRootFromParent_Done,
     /* 158766 */ // Label 2262: @158766
     /* 158766 */ GIM_Try, /*On fail goto*//*Label 2263*/ GIMT_Encode4(158800), // Rule ID 1667 //
     /* 158771 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 158774 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 158777 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 158780 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 158783 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 158787 */   // (vselect:{ *:[v2f64] } v2i64:{ *:[v2i64] }:$vA, v2f64:{ *:[v2f64] }:$vB, v2f64:{ *:[v2f64] }:$vC)  =>  (XXSEL:{ *:[v2f64] } ?:{ *:[v2f64] }:$vC, ?:{ *:[v2f64] }:$vB, ?:{ *:[v2i64] }:$vA)
     /* 158787 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSEL),
     /* 158790 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 158792 */   GIR_RootToRootCopy, /*OpIdx*/3, // vC
     /* 158794 */   GIR_RootToRootCopy, /*OpIdx*/2, // vB
     /* 158796 */   GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /* 158798 */   GIR_RootConstrainSelectedInstOperands,
     /* 158799 */   // GIR_Coverage, 1667,
     /* 158799 */   GIR_EraseRootFromParent_Done,
     /* 158800 */ // Label 2263: @158800
     /* 158800 */ GIM_Try, /*On fail goto*//*Label 2264*/ GIMT_Encode4(158834), // Rule ID 1420 //
     /* 158805 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 158808 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 158811 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 158814 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 158817 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 158821 */   // (vselect:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$vA, v2i64:{ *:[v2i64] }:$vB, v2i64:{ *:[v2i64] }:$vC)  =>  (VSEL:{ *:[v2i64] } ?:{ *:[v2i64] }:$vC, ?:{ *:[v2i64] }:$vB, ?:{ *:[v2i64] }:$vA)
     /* 158821 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSEL),
     /* 158824 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /* 158826 */   GIR_RootToRootCopy, /*OpIdx*/3, // vC
     /* 158828 */   GIR_RootToRootCopy, /*OpIdx*/2, // vB
     /* 158830 */   GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /* 158832 */   GIR_RootConstrainSelectedInstOperands,
     /* 158833 */   // GIR_Coverage, 1420,
     /* 158833 */   GIR_EraseRootFromParent_Done,
     /* 158834 */ // Label 2264: @158834
     /* 158834 */ GIM_Try, /*On fail goto*//*Label 2265*/ GIMT_Encode4(158868), // Rule ID 1422 //
     /* 158839 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 158842 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 158845 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 158848 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 158851 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 158855 */   // (vselect:{ *:[v2f64] } v2i64:{ *:[v2i64] }:$vA, v2f64:{ *:[v2f64] }:$vB, v2f64:{ *:[v2f64] }:$vC)  =>  (VSEL:{ *:[v2f64] } ?:{ *:[v2f64] }:$vC, ?:{ *:[v2f64] }:$vB, ?:{ *:[v2i64] }:$vA)
     /* 158855 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSEL),
     /* 158858 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /* 158860 */   GIR_RootToRootCopy, /*OpIdx*/3, // vC
     /* 158862 */   GIR_RootToRootCopy, /*OpIdx*/2, // vB
     /* 158864 */   GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /* 158866 */   GIR_RootConstrainSelectedInstOperands,
     /* 158867 */   // GIR_Coverage, 1422,
     /* 158867 */   GIR_EraseRootFromParent_Done,
     /* 158868 */ // Label 2265: @158868
     /* 158868 */ GIM_Reject,
     /* 158869 */ // Label 2243: @158869
     /* 158869 */ GIM_Try, /*On fail goto*//*Label 2266*/ GIMT_Encode4(158903), // Rule ID 1664 //
     /* 158874 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 158877 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 158880 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 158883 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 158886 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 158890 */   // (vselect:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)  =>  (XXSEL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vC, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vA)
     /* 158890 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSEL),
     /* 158893 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 158895 */   GIR_RootToRootCopy, /*OpIdx*/3, // vC
     /* 158897 */   GIR_RootToRootCopy, /*OpIdx*/2, // vB
     /* 158899 */   GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /* 158901 */   GIR_RootConstrainSelectedInstOperands,
     /* 158902 */   // GIR_Coverage, 1664,
     /* 158902 */   GIR_EraseRootFromParent_Done,
     /* 158903 */ // Label 2266: @158903
     /* 158903 */ GIM_Try, /*On fail goto*//*Label 2267*/ GIMT_Encode4(158937), // Rule ID 1666 //
     /* 158908 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 158911 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 158914 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 158917 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 158920 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 158924 */   // (vselect:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$vA, v4f32:{ *:[v4f32] }:$vB, v4f32:{ *:[v4f32] }:$vC)  =>  (XXSEL:{ *:[v4f32] } ?:{ *:[v4f32] }:$vC, ?:{ *:[v4f32] }:$vB, ?:{ *:[v4i32] }:$vA)
     /* 158924 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSEL),
     /* 158927 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 158929 */   GIR_RootToRootCopy, /*OpIdx*/3, // vC
     /* 158931 */   GIR_RootToRootCopy, /*OpIdx*/2, // vB
     /* 158933 */   GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /* 158935 */   GIR_RootConstrainSelectedInstOperands,
     /* 158936 */   // GIR_Coverage, 1666,
     /* 158936 */   GIR_EraseRootFromParent_Done,
     /* 158937 */ // Label 2267: @158937
     /* 158937 */ GIM_Try, /*On fail goto*//*Label 2268*/ GIMT_Encode4(158962), // Rule ID 10 //
     /* 158942 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 158945 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 158948 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 158951 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 158955 */   // (select:{ *:[v4i32] } i1:{ *:[i1] }:$cond, v4i32:{ *:[v4i32] }:$T, v4i32:{ *:[v4i32] }:$F)  =>  (SELECT_VRRC:{ *:[v4i32] } i1:{ *:[i1] }:$cond, v4i32:{ *:[v4i32] }:$T, v4i32:{ *:[v4i32] }:$F)
     /* 158955 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SELECT_VRRC),
     /* 158960 */   GIR_RootConstrainSelectedInstOperands,
     /* 158961 */   // GIR_Coverage, 10,
     /* 158961 */   GIR_Done,
     /* 158962 */ // Label 2268: @158962
     /* 158962 */ GIM_Try, /*On fail goto*//*Label 2269*/ GIMT_Encode4(158996), // Rule ID 1419 //
     /* 158967 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 158970 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 158973 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 158976 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 158979 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 158983 */   // (vselect:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)  =>  (VSEL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vC, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vA)
     /* 158983 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSEL),
     /* 158986 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /* 158988 */   GIR_RootToRootCopy, /*OpIdx*/3, // vC
     /* 158990 */   GIR_RootToRootCopy, /*OpIdx*/2, // vB
     /* 158992 */   GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /* 158994 */   GIR_RootConstrainSelectedInstOperands,
     /* 158995 */   // GIR_Coverage, 1419,
     /* 158995 */   GIR_EraseRootFromParent_Done,
     /* 158996 */ // Label 2269: @158996
     /* 158996 */ GIM_Try, /*On fail goto*//*Label 2270*/ GIMT_Encode4(159030), // Rule ID 1421 //
     /* 159001 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 159004 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 159007 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 159010 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 159013 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 159017 */   // (vselect:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$vA, v4f32:{ *:[v4f32] }:$vB, v4f32:{ *:[v4f32] }:$vC)  =>  (VSEL:{ *:[v4f32] } ?:{ *:[v4f32] }:$vC, ?:{ *:[v4f32] }:$vB, ?:{ *:[v4i32] }:$vA)
     /* 159017 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSEL),
     /* 159020 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /* 159022 */   GIR_RootToRootCopy, /*OpIdx*/3, // vC
     /* 159024 */   GIR_RootToRootCopy, /*OpIdx*/2, // vB
     /* 159026 */   GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /* 159028 */   GIR_RootConstrainSelectedInstOperands,
     /* 159029 */   // GIR_Coverage, 1421,
     /* 159029 */   GIR_EraseRootFromParent_Done,
     /* 159030 */ // Label 2270: @159030
     /* 159030 */ GIM_Reject,
     /* 159031 */ // Label 2244: @159031
     /* 159031 */ GIM_Try, /*On fail goto*//*Label 2271*/ GIMT_Encode4(159179),
     /* 159036 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 159039 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 159042 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 159045 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 159049 */   GIM_Try, /*On fail goto*//*Label 2272*/ GIMT_Encode4(159157), // Rule ID 1663 //
     /* 159054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 159057 */     // (vselect:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$vA, v8i16:{ *:[v8i16] }:$vB, v8i16:{ *:[v8i16] }:$vC)  =>  (COPY_TO_REGCLASS:{ *:[v8i16] } (XXSEL:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v8i16] }:$vC, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v8i16] }:$vB, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v8i16] }:$vA, VSRC:{ *:[i32] })), VRRC:{ *:[i32] })
     /* 159057 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 159060 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 159064 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159069 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // vA
     /* 159073 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /* 159078 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 159081 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 159085 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159090 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // vB
     /* 159094 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /* 159099 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 159102 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 159106 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159111 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // vC
     /* 159115 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /* 159120 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 159123 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXSEL),
     /* 159127 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159132 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 159135 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 159138 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 159141 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 159143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 159146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159148 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 159151 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /* 159156 */     // GIR_Coverage, 1663,
     /* 159156 */     GIR_EraseRootFromParent_Done,
     /* 159157 */   // Label 2272: @159157
     /* 159157 */   GIM_Try, /*On fail goto*//*Label 2273*/ GIMT_Encode4(159178), // Rule ID 1418 //
     /* 159162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 159165 */     // (vselect:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$vA, v8i16:{ *:[v8i16] }:$vB, v8i16:{ *:[v8i16] }:$vC)  =>  (VSEL:{ *:[v8i16] } ?:{ *:[v8i16] }:$vC, ?:{ *:[v8i16] }:$vB, ?:{ *:[v8i16] }:$vA)
     /* 159165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSEL),
     /* 159168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /* 159170 */     GIR_RootToRootCopy, /*OpIdx*/3, // vC
     /* 159172 */     GIR_RootToRootCopy, /*OpIdx*/2, // vB
     /* 159174 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /* 159176 */     GIR_RootConstrainSelectedInstOperands,
     /* 159177 */     // GIR_Coverage, 1418,
     /* 159177 */     GIR_EraseRootFromParent_Done,
     /* 159178 */   // Label 2273: @159178
     /* 159178 */   GIM_Reject,
     /* 159179 */ // Label 2271: @159179
     /* 159179 */ GIM_Reject,
     /* 159180 */ // Label 2245: @159180
     /* 159180 */ GIM_Try, /*On fail goto*//*Label 2274*/ GIMT_Encode4(159328),
     /* 159185 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 159188 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 159191 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 159194 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 159198 */   GIM_Try, /*On fail goto*//*Label 2275*/ GIMT_Encode4(159306), // Rule ID 1662 //
     /* 159203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 159206 */     // (vselect:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$vA, v16i8:{ *:[v16i8] }:$vB, v16i8:{ *:[v16i8] }:$vC)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } (XXSEL:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$vC, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$vB, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$vA, VSRC:{ *:[i32] })), VRRC:{ *:[i32] })
     /* 159206 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 159209 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 159213 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159218 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // vA
     /* 159222 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /* 159227 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 159230 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 159234 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159239 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // vB
     /* 159243 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /* 159248 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 159251 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 159255 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159260 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // vC
     /* 159264 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /* 159269 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 159272 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXSEL),
     /* 159276 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159281 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 159284 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 159287 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 159290 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 159292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 159295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159297 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 159300 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /* 159305 */     // GIR_Coverage, 1662,
     /* 159305 */     GIR_EraseRootFromParent_Done,
     /* 159306 */   // Label 2275: @159306
     /* 159306 */   GIM_Try, /*On fail goto*//*Label 2276*/ GIMT_Encode4(159327), // Rule ID 1417 //
     /* 159311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 159314 */     // (vselect:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$vA, v16i8:{ *:[v16i8] }:$vB, v16i8:{ *:[v16i8] }:$vC)  =>  (VSEL:{ *:[v16i8] } ?:{ *:[v16i8] }:$vC, ?:{ *:[v16i8] }:$vB, ?:{ *:[v16i8] }:$vA)
     /* 159314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSEL),
     /* 159317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /* 159319 */     GIR_RootToRootCopy, /*OpIdx*/3, // vC
     /* 159321 */     GIR_RootToRootCopy, /*OpIdx*/2, // vB
     /* 159323 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /* 159325 */     GIR_RootConstrainSelectedInstOperands,
     /* 159326 */     // GIR_Coverage, 1417,
     /* 159326 */     GIR_EraseRootFromParent_Done,
     /* 159327 */   // Label 2276: @159327
     /* 159327 */   GIM_Reject,
     /* 159328 */ // Label 2274: @159328
     /* 159328 */ GIM_Reject,
     /* 159329 */ // Label 2246: @159329
     /* 159329 */ GIM_Reject,
     /* 159330 */ // Label 34: @159330
     /* 159330 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2281*/ GIMT_Encode4(159459),
     /* 159341 */ /*GILLT_s32*//*Label 2277*/ GIMT_Encode4(159361),
     /* 159345 */ /*GILLT_s64*//*Label 2278*/ GIMT_Encode4(159384), GIMT_Encode4(0),
     /* 159353 */ /*GILLT_v2s64*//*Label 2279*/ GIMT_Encode4(159407),
     /* 159357 */ /*GILLT_v4s32*//*Label 2280*/ GIMT_Encode4(159433),
     /* 159361 */ // Label 2277: @159361
     /* 159361 */ GIM_Try, /*On fail goto*//*Label 2282*/ GIMT_Encode4(159383), // Rule ID 207 //
     /* 159366 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 159369 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 159372 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 159376 */   // (mulhu:{ *:[i32] } i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)  =>  (MULHWU:{ *:[i32] } i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)
     /* 159376 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::MULHWU),
     /* 159381 */   GIR_RootConstrainSelectedInstOperands,
     /* 159382 */   // GIR_Coverage, 207,
     /* 159382 */   GIR_Done,
     /* 159383 */ // Label 2282: @159383
     /* 159383 */ GIM_Reject,
     /* 159384 */ // Label 2278: @159384
     /* 159384 */ GIM_Try, /*On fail goto*//*Label 2283*/ GIMT_Encode4(159406), // Rule ID 673 //
     /* 159389 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 159392 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 159395 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 159399 */   // (mulhu:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)  =>  (MULHDU:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)
     /* 159399 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::MULHDU),
     /* 159404 */   GIR_RootConstrainSelectedInstOperands,
     /* 159405 */   // GIR_Coverage, 673,
     /* 159405 */   GIR_Done,
     /* 159406 */ // Label 2283: @159406
     /* 159406 */ GIM_Reject,
     /* 159407 */ // Label 2279: @159407
     /* 159407 */ GIM_Try, /*On fail goto*//*Label 2284*/ GIMT_Encode4(159432), // Rule ID 1124 //
     /* 159412 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 159415 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 159418 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 159421 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 159425 */   // (mulhu:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VMULHUD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /* 159425 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMULHUD),
     /* 159430 */   GIR_RootConstrainSelectedInstOperands,
     /* 159431 */   // GIR_Coverage, 1124,
     /* 159431 */   GIR_Done,
     /* 159432 */ // Label 2284: @159432
     /* 159432 */ GIM_Reject,
     /* 159433 */ // Label 2280: @159433
     /* 159433 */ GIM_Try, /*On fail goto*//*Label 2285*/ GIMT_Encode4(159458), // Rule ID 1122 //
     /* 159438 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 159441 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 159444 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 159447 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 159451 */   // (mulhu:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VMULHUW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /* 159451 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMULHUW),
     /* 159456 */   GIR_RootConstrainSelectedInstOperands,
     /* 159457 */   // GIR_Coverage, 1122,
     /* 159457 */   GIR_Done,
     /* 159458 */ // Label 2285: @159458
     /* 159458 */ GIM_Reject,
     /* 159459 */ // Label 2281: @159459
     /* 159459 */ GIM_Reject,
     /* 159460 */ // Label 35: @159460
     /* 159460 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2290*/ GIMT_Encode4(159589),
     /* 159471 */ /*GILLT_s32*//*Label 2286*/ GIMT_Encode4(159491),
     /* 159475 */ /*GILLT_s64*//*Label 2287*/ GIMT_Encode4(159514), GIMT_Encode4(0),
     /* 159483 */ /*GILLT_v2s64*//*Label 2288*/ GIMT_Encode4(159537),
     /* 159487 */ /*GILLT_v4s32*//*Label 2289*/ GIMT_Encode4(159563),
     /* 159491 */ // Label 2286: @159491
     /* 159491 */ GIM_Try, /*On fail goto*//*Label 2291*/ GIMT_Encode4(159513), // Rule ID 206 //
     /* 159496 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 159499 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 159502 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 159506 */   // (mulhs:{ *:[i32] } i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)  =>  (MULHW:{ *:[i32] } i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)
     /* 159506 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::MULHW),
     /* 159511 */   GIR_RootConstrainSelectedInstOperands,
     /* 159512 */   // GIR_Coverage, 206,
     /* 159512 */   GIR_Done,
     /* 159513 */ // Label 2291: @159513
     /* 159513 */ GIM_Reject,
     /* 159514 */ // Label 2287: @159514
     /* 159514 */ GIM_Try, /*On fail goto*//*Label 2292*/ GIMT_Encode4(159536), // Rule ID 672 //
     /* 159519 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 159522 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 159525 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 159529 */   // (mulhs:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)  =>  (MULHD:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)
     /* 159529 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::MULHD),
     /* 159534 */   GIR_RootConstrainSelectedInstOperands,
     /* 159535 */   // GIR_Coverage, 672,
     /* 159535 */   GIR_Done,
     /* 159536 */ // Label 2292: @159536
     /* 159536 */ GIM_Reject,
     /* 159537 */ // Label 2288: @159537
     /* 159537 */ GIM_Try, /*On fail goto*//*Label 2293*/ GIMT_Encode4(159562), // Rule ID 1123 //
     /* 159542 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 159545 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 159548 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 159551 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 159555 */   // (mulhs:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VMULHSD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /* 159555 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMULHSD),
     /* 159560 */   GIR_RootConstrainSelectedInstOperands,
     /* 159561 */   // GIR_Coverage, 1123,
     /* 159561 */   GIR_Done,
     /* 159562 */ // Label 2293: @159562
     /* 159562 */ GIM_Reject,
     /* 159563 */ // Label 2289: @159563
     /* 159563 */ GIM_Try, /*On fail goto*//*Label 2294*/ GIMT_Encode4(159588), // Rule ID 1121 //
     /* 159568 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 159571 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 159574 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 159577 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 159581 */   // (mulhs:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VMULHSW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /* 159581 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMULHSW),
     /* 159586 */   GIR_RootConstrainSelectedInstOperands,
     /* 159587 */   // GIR_Coverage, 1121,
     /* 159587 */   GIR_Done,
     /* 159588 */ // Label 2294: @159588
     /* 159588 */ GIM_Reject,
     /* 159589 */ // Label 2290: @159589
     /* 159589 */ GIM_Reject,
     /* 159590 */ // Label 36: @159590
     /* 159590 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(8), /*)*//*default:*//*Label 2298*/ GIMT_Encode4(159691),
     /* 159601 */ /*GILLT_v4s32*//*Label 2295*/ GIMT_Encode4(159613),
     /* 159605 */ /*GILLT_v8s16*//*Label 2296*/ GIMT_Encode4(159639),
     /* 159609 */ /*GILLT_v16s8*//*Label 2297*/ GIMT_Encode4(159665),
     /* 159613 */ // Label 2295: @159613
     /* 159613 */ GIM_Try, /*On fail goto*//*Label 2299*/ GIMT_Encode4(159638), // Rule ID 1296 //
     /* 159618 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 159621 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 159624 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 159627 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 159631 */   // (uaddsat:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)  =>  (VADDUWS:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB)
     /* 159631 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VADDUWS),
     /* 159636 */   GIR_RootConstrainSelectedInstOperands,
     /* 159637 */   // GIR_Coverage, 1296,
     /* 159637 */   GIR_Done,
     /* 159638 */ // Label 2299: @159638
     /* 159638 */ GIM_Reject,
     /* 159639 */ // Label 2296: @159639
     /* 159639 */ GIM_Try, /*On fail goto*//*Label 2300*/ GIMT_Encode4(159664), // Rule ID 1294 //
     /* 159644 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 159647 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 159650 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 159653 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 159657 */   // (uaddsat:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$vA, v8i16:{ *:[v8i16] }:$vB)  =>  (VADDUHS:{ *:[v8i16] } ?:{ *:[v8i16] }:$vA, ?:{ *:[v8i16] }:$vB)
     /* 159657 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VADDUHS),
     /* 159662 */   GIR_RootConstrainSelectedInstOperands,
     /* 159663 */   // GIR_Coverage, 1294,
     /* 159663 */   GIR_Done,
     /* 159664 */ // Label 2300: @159664
     /* 159664 */ GIM_Reject,
     /* 159665 */ // Label 2297: @159665
     /* 159665 */ GIM_Try, /*On fail goto*//*Label 2301*/ GIMT_Encode4(159690), // Rule ID 1292 //
     /* 159670 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 159673 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 159676 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 159679 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 159683 */   // (uaddsat:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$vA, v16i8:{ *:[v16i8] }:$vB)  =>  (VADDUBS:{ *:[v16i8] } ?:{ *:[v16i8] }:$vA, ?:{ *:[v16i8] }:$vB)
     /* 159683 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VADDUBS),
     /* 159688 */   GIR_RootConstrainSelectedInstOperands,
     /* 159689 */   // GIR_Coverage, 1292,
     /* 159689 */   GIR_Done,
     /* 159690 */ // Label 2301: @159690
     /* 159690 */ GIM_Reject,
     /* 159691 */ // Label 2298: @159691
     /* 159691 */ GIM_Reject,
     /* 159692 */ // Label 37: @159692
     /* 159692 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(8), /*)*//*default:*//*Label 2305*/ GIMT_Encode4(159793),
     /* 159703 */ /*GILLT_v4s32*//*Label 2302*/ GIMT_Encode4(159715),
     /* 159707 */ /*GILLT_v8s16*//*Label 2303*/ GIMT_Encode4(159741),
     /* 159711 */ /*GILLT_v16s8*//*Label 2304*/ GIMT_Encode4(159767),
     /* 159715 */ // Label 2302: @159715
     /* 159715 */ GIM_Try, /*On fail goto*//*Label 2306*/ GIMT_Encode4(159740), // Rule ID 1295 //
     /* 159720 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 159723 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 159726 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 159729 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 159733 */   // (saddsat:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)  =>  (VADDSWS:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB)
     /* 159733 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VADDSWS),
     /* 159738 */   GIR_RootConstrainSelectedInstOperands,
     /* 159739 */   // GIR_Coverage, 1295,
     /* 159739 */   GIR_Done,
     /* 159740 */ // Label 2306: @159740
     /* 159740 */ GIM_Reject,
     /* 159741 */ // Label 2303: @159741
     /* 159741 */ GIM_Try, /*On fail goto*//*Label 2307*/ GIMT_Encode4(159766), // Rule ID 1293 //
     /* 159746 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 159749 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 159752 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 159755 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 159759 */   // (saddsat:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$vA, v8i16:{ *:[v8i16] }:$vB)  =>  (VADDSHS:{ *:[v8i16] } ?:{ *:[v8i16] }:$vA, ?:{ *:[v8i16] }:$vB)
     /* 159759 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VADDSHS),
     /* 159764 */   GIR_RootConstrainSelectedInstOperands,
     /* 159765 */   // GIR_Coverage, 1293,
     /* 159765 */   GIR_Done,
     /* 159766 */ // Label 2307: @159766
     /* 159766 */ GIM_Reject,
     /* 159767 */ // Label 2304: @159767
     /* 159767 */ GIM_Try, /*On fail goto*//*Label 2308*/ GIMT_Encode4(159792), // Rule ID 1291 //
     /* 159772 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 159775 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 159778 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 159781 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 159785 */   // (saddsat:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$vA, v16i8:{ *:[v16i8] }:$vB)  =>  (VADDSBS:{ *:[v16i8] } ?:{ *:[v16i8] }:$vA, ?:{ *:[v16i8] }:$vB)
     /* 159785 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VADDSBS),
     /* 159790 */   GIR_RootConstrainSelectedInstOperands,
     /* 159791 */   // GIR_Coverage, 1291,
     /* 159791 */   GIR_Done,
     /* 159792 */ // Label 2308: @159792
     /* 159792 */ GIM_Reject,
     /* 159793 */ // Label 2305: @159793
     /* 159793 */ GIM_Reject,
     /* 159794 */ // Label 38: @159794
     /* 159794 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(8), /*)*//*default:*//*Label 2312*/ GIMT_Encode4(159895),
     /* 159805 */ /*GILLT_v4s32*//*Label 2309*/ GIMT_Encode4(159817),
     /* 159809 */ /*GILLT_v8s16*//*Label 2310*/ GIMT_Encode4(159843),
     /* 159813 */ /*GILLT_v16s8*//*Label 2311*/ GIMT_Encode4(159869),
     /* 159817 */ // Label 2309: @159817
     /* 159817 */ GIM_Try, /*On fail goto*//*Label 2313*/ GIMT_Encode4(159842), // Rule ID 1302 //
     /* 159822 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 159825 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 159828 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 159831 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 159835 */   // (usubsat:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)  =>  (VSUBUWS:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB)
     /* 159835 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSUBUWS),
     /* 159840 */   GIR_RootConstrainSelectedInstOperands,
     /* 159841 */   // GIR_Coverage, 1302,
     /* 159841 */   GIR_Done,
     /* 159842 */ // Label 2313: @159842
     /* 159842 */ GIM_Reject,
     /* 159843 */ // Label 2310: @159843
     /* 159843 */ GIM_Try, /*On fail goto*//*Label 2314*/ GIMT_Encode4(159868), // Rule ID 1300 //
     /* 159848 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 159851 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 159854 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 159857 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 159861 */   // (usubsat:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$vA, v8i16:{ *:[v8i16] }:$vB)  =>  (VSUBUHS:{ *:[v8i16] } ?:{ *:[v8i16] }:$vA, ?:{ *:[v8i16] }:$vB)
     /* 159861 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSUBUHS),
     /* 159866 */   GIR_RootConstrainSelectedInstOperands,
     /* 159867 */   // GIR_Coverage, 1300,
     /* 159867 */   GIR_Done,
     /* 159868 */ // Label 2314: @159868
     /* 159868 */ GIM_Reject,
     /* 159869 */ // Label 2311: @159869
     /* 159869 */ GIM_Try, /*On fail goto*//*Label 2315*/ GIMT_Encode4(159894), // Rule ID 1298 //
     /* 159874 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 159877 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 159880 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 159883 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 159887 */   // (usubsat:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$vA, v16i8:{ *:[v16i8] }:$vB)  =>  (VSUBUBS:{ *:[v16i8] } ?:{ *:[v16i8] }:$vA, ?:{ *:[v16i8] }:$vB)
     /* 159887 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSUBUBS),
     /* 159892 */   GIR_RootConstrainSelectedInstOperands,
     /* 159893 */   // GIR_Coverage, 1298,
     /* 159893 */   GIR_Done,
     /* 159894 */ // Label 2315: @159894
     /* 159894 */ GIM_Reject,
     /* 159895 */ // Label 2312: @159895
     /* 159895 */ GIM_Reject,
     /* 159896 */ // Label 39: @159896
     /* 159896 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(8), /*)*//*default:*//*Label 2319*/ GIMT_Encode4(159997),
     /* 159907 */ /*GILLT_v4s32*//*Label 2316*/ GIMT_Encode4(159919),
     /* 159911 */ /*GILLT_v8s16*//*Label 2317*/ GIMT_Encode4(159945),
     /* 159915 */ /*GILLT_v16s8*//*Label 2318*/ GIMT_Encode4(159971),
     /* 159919 */ // Label 2316: @159919
     /* 159919 */ GIM_Try, /*On fail goto*//*Label 2320*/ GIMT_Encode4(159944), // Rule ID 1301 //
     /* 159924 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 159927 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 159930 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 159933 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 159937 */   // (ssubsat:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)  =>  (VSUBSWS:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB)
     /* 159937 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSUBSWS),
     /* 159942 */   GIR_RootConstrainSelectedInstOperands,
     /* 159943 */   // GIR_Coverage, 1301,
     /* 159943 */   GIR_Done,
     /* 159944 */ // Label 2320: @159944
     /* 159944 */ GIM_Reject,
     /* 159945 */ // Label 2317: @159945
     /* 159945 */ GIM_Try, /*On fail goto*//*Label 2321*/ GIMT_Encode4(159970), // Rule ID 1299 //
     /* 159950 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 159953 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 159956 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 159959 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 159963 */   // (ssubsat:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$vA, v8i16:{ *:[v8i16] }:$vB)  =>  (VSUBSHS:{ *:[v8i16] } ?:{ *:[v8i16] }:$vA, ?:{ *:[v8i16] }:$vB)
     /* 159963 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSUBSHS),
     /* 159968 */   GIR_RootConstrainSelectedInstOperands,
     /* 159969 */   // GIR_Coverage, 1299,
     /* 159969 */   GIR_Done,
     /* 159970 */ // Label 2321: @159970
     /* 159970 */ GIM_Reject,
     /* 159971 */ // Label 2318: @159971
     /* 159971 */ GIM_Try, /*On fail goto*//*Label 2322*/ GIMT_Encode4(159996), // Rule ID 1297 //
     /* 159976 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 159979 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 159982 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 159985 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 159989 */   // (ssubsat:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$vA, v16i8:{ *:[v16i8] }:$vB)  =>  (VSUBSBS:{ *:[v16i8] } ?:{ *:[v16i8] }:$vA, ?:{ *:[v16i8] }:$vB)
     /* 159989 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSUBSBS),
     /* 159994 */   GIR_RootConstrainSelectedInstOperands,
     /* 159995 */   // GIR_Coverage, 1297,
     /* 159995 */   GIR_Done,
     /* 159996 */ // Label 2322: @159996
     /* 159996 */ GIM_Reject,
     /* 159997 */ // Label 2319: @159997
     /* 159997 */ GIM_Reject,
     /* 159998 */ // Label 40: @159998
     /* 159998 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2328*/ GIMT_Encode4(160292),
     /* 160009 */ /*GILLT_s32*//*Label 2323*/ GIMT_Encode4(160029),
     /* 160013 */ /*GILLT_s64*//*Label 2324*/ GIMT_Encode4(160103),
     /* 160017 */ /*GILLT_s128*//*Label 2325*/ GIMT_Encode4(160181),
     /* 160021 */ /*GILLT_v2s64*//*Label 2326*/ GIMT_Encode4(160207),
     /* 160025 */ /*GILLT_v4s32*//*Label 2327*/ GIMT_Encode4(160237),
     /* 160029 */ // Label 2323: @160029
     /* 160029 */ GIM_Try, /*On fail goto*//*Label 2329*/ GIMT_Encode4(160102),
     /* 160034 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 160037 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 160040 */   GIM_Try, /*On fail goto*//*Label 2330*/ GIMT_Encode4(160059), // Rule ID 949 //
     /* 160045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 160048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 160052 */     // (fadd:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)  =>  (XSADDSP:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)
     /* 160052 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSADDSP),
     /* 160057 */     GIR_RootConstrainSelectedInstOperands,
     /* 160058 */     // GIR_Coverage, 949,
     /* 160058 */     GIR_Done,
     /* 160059 */   // Label 2330: @160059
     /* 160059 */   GIM_Try, /*On fail goto*//*Label 2331*/ GIMT_Encode4(160082), // Rule ID 239 //
     /* 160064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 160067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 160071 */     // (fadd:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRB)  =>  (FADDS:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRB)
     /* 160071 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FADDS),
     /* 160076 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 160080 */     GIR_RootConstrainSelectedInstOperands,
     /* 160081 */     // GIR_Coverage, 239,
     /* 160081 */     GIR_Done,
     /* 160082 */   // Label 2331: @160082
     /* 160082 */   GIM_Try, /*On fail goto*//*Label 2332*/ GIMT_Encode4(160101), // Rule ID 579 //
     /* 160087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 160090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 160094 */     // (fadd:{ *:[f32] } f32:{ *:[f32] }:$RA, f32:{ *:[f32] }:$RB)  =>  (EFSADD:{ *:[f32] } f32:{ *:[f32] }:$RA, f32:{ *:[f32] }:$RB)
     /* 160094 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFSADD),
     /* 160099 */     GIR_RootConstrainSelectedInstOperands,
     /* 160100 */     // GIR_Coverage, 579,
     /* 160100 */     GIR_Done,
     /* 160101 */   // Label 2332: @160101
     /* 160101 */   GIM_Reject,
     /* 160102 */ // Label 2329: @160102
     /* 160102 */ GIM_Reject,
     /* 160103 */ // Label 2324: @160103
     /* 160103 */ GIM_Try, /*On fail goto*//*Label 2333*/ GIMT_Encode4(160180),
     /* 160108 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 160111 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 160114 */   GIM_Try, /*On fail goto*//*Label 2334*/ GIMT_Encode4(160137), // Rule ID 766 //
     /* 160119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 160122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 160126 */     // (fadd:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)  =>  (XSADDDP:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)
     /* 160126 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSADDDP),
     /* 160131 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 160135 */     GIR_RootConstrainSelectedInstOperands,
     /* 160136 */     // GIR_Coverage, 766,
     /* 160136 */     GIR_Done,
     /* 160137 */   // Label 2334: @160137
     /* 160137 */   GIM_Try, /*On fail goto*//*Label 2335*/ GIMT_Encode4(160160), // Rule ID 237 //
     /* 160142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 160145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 160149 */     // (fadd:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRB)  =>  (FADD:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRB)
     /* 160149 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FADD),
     /* 160154 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 160158 */     GIR_RootConstrainSelectedInstOperands,
     /* 160159 */     // GIR_Coverage, 237,
     /* 160159 */     GIR_Done,
     /* 160160 */   // Label 2335: @160160
     /* 160160 */   GIM_Try, /*On fail goto*//*Label 2336*/ GIMT_Encode4(160179), // Rule ID 558 //
     /* 160165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 160168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::SPERCRegClassID),
     /* 160172 */     // (fadd:{ *:[f64] } f64:{ *:[f64] }:$RA, f64:{ *:[f64] }:$RB)  =>  (EFDADD:{ *:[f64] } f64:{ *:[f64] }:$RA, f64:{ *:[f64] }:$RB)
     /* 160172 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFDADD),
     /* 160177 */     GIR_RootConstrainSelectedInstOperands,
     /* 160178 */     // GIR_Coverage, 558,
     /* 160178 */     GIR_Done,
     /* 160179 */   // Label 2336: @160179
     /* 160179 */   GIM_Reject,
     /* 160180 */ // Label 2333: @160180
     /* 160180 */ GIM_Reject,
     /* 160181 */ // Label 2325: @160181
     /* 160181 */ GIM_Try, /*On fail goto*//*Label 2337*/ GIMT_Encode4(160206), // Rule ID 984 //
     /* 160186 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 160189 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 160192 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /* 160195 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 160199 */   // (fadd:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)  =>  (XSADDQP:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 160199 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSADDQP),
     /* 160204 */   GIR_RootConstrainSelectedInstOperands,
     /* 160205 */   // GIR_Coverage, 984,
     /* 160205 */   GIR_Done,
     /* 160206 */ // Label 2337: @160206
     /* 160206 */ GIM_Reject,
     /* 160207 */ // Label 2326: @160207
     /* 160207 */ GIM_Try, /*On fail goto*//*Label 2338*/ GIMT_Encode4(160236), // Rule ID 770 //
     /* 160212 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 160215 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 160218 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 160221 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 160225 */   // (fadd:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)  =>  (XVADDDP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /* 160225 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVADDDP),
     /* 160230 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 160234 */   GIR_RootConstrainSelectedInstOperands,
     /* 160235 */   // GIR_Coverage, 770,
     /* 160235 */   GIR_Done,
     /* 160236 */ // Label 2338: @160236
     /* 160236 */ GIM_Reject,
     /* 160237 */ // Label 2327: @160237
     /* 160237 */ GIM_Try, /*On fail goto*//*Label 2339*/ GIMT_Encode4(160291),
     /* 160242 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 160245 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 160248 */   GIM_Try, /*On fail goto*//*Label 2340*/ GIMT_Encode4(160271), // Rule ID 772 //
     /* 160253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 160256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 160260 */     // (fadd:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)  =>  (XVADDSP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /* 160260 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVADDSP),
     /* 160265 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 160269 */     GIR_RootConstrainSelectedInstOperands,
     /* 160270 */     // GIR_Coverage, 772,
     /* 160270 */     GIR_Done,
     /* 160271 */   // Label 2340: @160271
     /* 160271 */   GIM_Try, /*On fail goto*//*Label 2341*/ GIMT_Encode4(160290), // Rule ID 300 //
     /* 160276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 160279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 160283 */     // (fadd:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$VA, v4f32:{ *:[v4f32] }:$VB)  =>  (VADDFP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$VA, v4f32:{ *:[v4f32] }:$VB)
     /* 160283 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VADDFP),
     /* 160288 */     GIR_RootConstrainSelectedInstOperands,
     /* 160289 */     // GIR_Coverage, 300,
     /* 160289 */     GIR_Done,
     /* 160290 */   // Label 2341: @160290
     /* 160290 */   GIM_Reject,
     /* 160291 */ // Label 2339: @160291
     /* 160291 */ GIM_Reject,
     /* 160292 */ // Label 2328: @160292
     /* 160292 */ GIM_Reject,
     /* 160293 */ // Label 41: @160293
     /* 160293 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2347*/ GIMT_Encode4(160587),
     /* 160304 */ /*GILLT_s32*//*Label 2342*/ GIMT_Encode4(160324),
     /* 160308 */ /*GILLT_s64*//*Label 2343*/ GIMT_Encode4(160398),
     /* 160312 */ /*GILLT_s128*//*Label 2344*/ GIMT_Encode4(160476),
     /* 160316 */ /*GILLT_v2s64*//*Label 2345*/ GIMT_Encode4(160502),
     /* 160320 */ /*GILLT_v4s32*//*Label 2346*/ GIMT_Encode4(160532),
     /* 160324 */ // Label 2342: @160324
     /* 160324 */ GIM_Try, /*On fail goto*//*Label 2348*/ GIMT_Encode4(160397),
     /* 160329 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 160332 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 160335 */   GIM_Try, /*On fail goto*//*Label 2349*/ GIMT_Encode4(160354), // Rule ID 953 //
     /* 160340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 160343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 160347 */     // (fsub:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)  =>  (XSSUBSP:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)
     /* 160347 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSSUBSP),
     /* 160352 */     GIR_RootConstrainSelectedInstOperands,
     /* 160353 */     // GIR_Coverage, 953,
     /* 160353 */     GIR_Done,
     /* 160354 */   // Label 2349: @160354
     /* 160354 */   GIM_Try, /*On fail goto*//*Label 2350*/ GIMT_Encode4(160377), // Rule ID 251 //
     /* 160359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 160362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 160366 */     // (fsub:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRB)  =>  (FSUBS:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRB)
     /* 160366 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FSUBS),
     /* 160371 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 160375 */     GIR_RootConstrainSelectedInstOperands,
     /* 160376 */     // GIR_Coverage, 251,
     /* 160376 */     GIR_Done,
     /* 160377 */   // Label 2350: @160377
     /* 160377 */   GIM_Try, /*On fail goto*//*Label 2351*/ GIMT_Encode4(160396), // Rule ID 597 //
     /* 160382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 160385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 160389 */     // (fsub:{ *:[f32] } f32:{ *:[f32] }:$RA, f32:{ *:[f32] }:$RB)  =>  (EFSSUB:{ *:[f32] } f32:{ *:[f32] }:$RA, f32:{ *:[f32] }:$RB)
     /* 160389 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFSSUB),
     /* 160394 */     GIR_RootConstrainSelectedInstOperands,
     /* 160395 */     // GIR_Coverage, 597,
     /* 160395 */     GIR_Done,
     /* 160396 */   // Label 2351: @160396
     /* 160396 */   GIM_Reject,
     /* 160397 */ // Label 2348: @160397
     /* 160397 */ GIM_Reject,
     /* 160398 */ // Label 2343: @160398
     /* 160398 */ GIM_Try, /*On fail goto*//*Label 2352*/ GIMT_Encode4(160475),
     /* 160403 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 160406 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 160409 */   GIM_Try, /*On fail goto*//*Label 2353*/ GIMT_Encode4(160432), // Rule ID 778 //
     /* 160414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 160417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 160421 */     // (fsub:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)  =>  (XSSUBDP:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)
     /* 160421 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSSUBDP),
     /* 160426 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 160430 */     GIR_RootConstrainSelectedInstOperands,
     /* 160431 */     // GIR_Coverage, 778,
     /* 160431 */     GIR_Done,
     /* 160432 */   // Label 2353: @160432
     /* 160432 */   GIM_Try, /*On fail goto*//*Label 2354*/ GIMT_Encode4(160455), // Rule ID 249 //
     /* 160437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 160440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 160444 */     // (fsub:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRB)  =>  (FSUB:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRB)
     /* 160444 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FSUB),
     /* 160449 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 160453 */     GIR_RootConstrainSelectedInstOperands,
     /* 160454 */     // GIR_Coverage, 249,
     /* 160454 */     GIR_Done,
     /* 160455 */   // Label 2354: @160455
     /* 160455 */   GIM_Try, /*On fail goto*//*Label 2355*/ GIMT_Encode4(160474), // Rule ID 576 //
     /* 160460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 160463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::SPERCRegClassID),
     /* 160467 */     // (fsub:{ *:[f64] } f64:{ *:[f64] }:$RA, f64:{ *:[f64] }:$RB)  =>  (EFDSUB:{ *:[f64] } f64:{ *:[f64] }:$RA, f64:{ *:[f64] }:$RB)
     /* 160467 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFDSUB),
     /* 160472 */     GIR_RootConstrainSelectedInstOperands,
     /* 160473 */     // GIR_Coverage, 576,
     /* 160473 */     GIR_Done,
     /* 160474 */   // Label 2355: @160474
     /* 160474 */   GIM_Reject,
     /* 160475 */ // Label 2352: @160475
     /* 160475 */ GIM_Reject,
     /* 160476 */ // Label 2344: @160476
     /* 160476 */ GIM_Try, /*On fail goto*//*Label 2356*/ GIMT_Encode4(160501), // Rule ID 988 //
     /* 160481 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 160484 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 160487 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /* 160490 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 160494 */   // (fsub:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)  =>  (XSSUBQP:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 160494 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSSUBQP),
     /* 160499 */   GIR_RootConstrainSelectedInstOperands,
     /* 160500 */   // GIR_Coverage, 988,
     /* 160500 */   GIR_Done,
     /* 160501 */ // Label 2356: @160501
     /* 160501 */ GIM_Reject,
     /* 160502 */ // Label 2345: @160502
     /* 160502 */ GIM_Try, /*On fail goto*//*Label 2357*/ GIMT_Encode4(160531), // Rule ID 780 //
     /* 160507 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 160510 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 160513 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 160516 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 160520 */   // (fsub:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)  =>  (XVSUBDP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /* 160520 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVSUBDP),
     /* 160525 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 160529 */   GIR_RootConstrainSelectedInstOperands,
     /* 160530 */   // GIR_Coverage, 780,
     /* 160530 */   GIR_Done,
     /* 160531 */ // Label 2357: @160531
     /* 160531 */ GIM_Reject,
     /* 160532 */ // Label 2346: @160532
     /* 160532 */ GIM_Try, /*On fail goto*//*Label 2358*/ GIMT_Encode4(160586),
     /* 160537 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 160540 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 160543 */   GIM_Try, /*On fail goto*//*Label 2359*/ GIMT_Encode4(160566), // Rule ID 782 //
     /* 160548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 160551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 160555 */     // (fsub:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)  =>  (XVSUBSP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /* 160555 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVSUBSP),
     /* 160560 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 160564 */     GIR_RootConstrainSelectedInstOperands,
     /* 160565 */     // GIR_Coverage, 782,
     /* 160565 */     GIR_Done,
     /* 160566 */   // Label 2359: @160566
     /* 160566 */   GIM_Try, /*On fail goto*//*Label 2360*/ GIMT_Encode4(160585), // Rule ID 370 //
     /* 160571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 160574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 160578 */     // (fsub:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$VA, v4f32:{ *:[v4f32] }:$VB)  =>  (VSUBFP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$VA, v4f32:{ *:[v4f32] }:$VB)
     /* 160578 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSUBFP),
     /* 160583 */     GIR_RootConstrainSelectedInstOperands,
     /* 160584 */     // GIR_Coverage, 370,
     /* 160584 */     GIR_Done,
     /* 160585 */   // Label 2360: @160585
     /* 160585 */   GIM_Reject,
     /* 160586 */ // Label 2358: @160586
     /* 160586 */ GIM_Reject,
     /* 160587 */ // Label 2347: @160587
     /* 160587 */ GIM_Reject,
     /* 160588 */ // Label 42: @160588
     /* 160588 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2366*/ GIMT_Encode4(160937),
     /* 160599 */ /*GILLT_s32*//*Label 2361*/ GIMT_Encode4(160619),
     /* 160603 */ /*GILLT_s64*//*Label 2362*/ GIMT_Encode4(160693),
     /* 160607 */ /*GILLT_s128*//*Label 2363*/ GIMT_Encode4(160771),
     /* 160611 */ /*GILLT_v2s64*//*Label 2364*/ GIMT_Encode4(160797),
     /* 160615 */ /*GILLT_v4s32*//*Label 2365*/ GIMT_Encode4(160827),
     /* 160619 */ // Label 2361: @160619
     /* 160619 */ GIM_Try, /*On fail goto*//*Label 2367*/ GIMT_Encode4(160692),
     /* 160624 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 160627 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 160630 */   GIM_Try, /*On fail goto*//*Label 2368*/ GIMT_Encode4(160649), // Rule ID 951 //
     /* 160635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 160638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 160642 */     // (fmul:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)  =>  (XSMULSP:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)
     /* 160642 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSMULSP),
     /* 160647 */     GIR_RootConstrainSelectedInstOperands,
     /* 160648 */     // GIR_Coverage, 951,
     /* 160648 */     GIR_Done,
     /* 160649 */   // Label 2368: @160649
     /* 160649 */   GIM_Try, /*On fail goto*//*Label 2369*/ GIMT_Encode4(160672), // Rule ID 247 //
     /* 160654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 160657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 160661 */     // (fmul:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC)  =>  (FMULS:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC)
     /* 160661 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FMULS),
     /* 160666 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 160670 */     GIR_RootConstrainSelectedInstOperands,
     /* 160671 */     // GIR_Coverage, 247,
     /* 160671 */     GIR_Done,
     /* 160672 */   // Label 2369: @160672
     /* 160672 */   GIM_Try, /*On fail goto*//*Label 2370*/ GIMT_Encode4(160691), // Rule ID 593 //
     /* 160677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 160680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 160684 */     // (fmul:{ *:[f32] } f32:{ *:[f32] }:$RA, f32:{ *:[f32] }:$RB)  =>  (EFSMUL:{ *:[f32] } f32:{ *:[f32] }:$RA, f32:{ *:[f32] }:$RB)
     /* 160684 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFSMUL),
     /* 160689 */     GIR_RootConstrainSelectedInstOperands,
     /* 160690 */     // GIR_Coverage, 593,
     /* 160690 */     GIR_Done,
     /* 160691 */   // Label 2370: @160691
     /* 160691 */   GIM_Reject,
     /* 160692 */ // Label 2367: @160692
     /* 160692 */ GIM_Reject,
     /* 160693 */ // Label 2362: @160693
     /* 160693 */ GIM_Try, /*On fail goto*//*Label 2371*/ GIMT_Encode4(160770),
     /* 160698 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 160701 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 160704 */   GIM_Try, /*On fail goto*//*Label 2372*/ GIMT_Encode4(160727), // Rule ID 768 //
     /* 160709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 160712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 160716 */     // (fmul:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)  =>  (XSMULDP:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)
     /* 160716 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSMULDP),
     /* 160721 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 160725 */     GIR_RootConstrainSelectedInstOperands,
     /* 160726 */     // GIR_Coverage, 768,
     /* 160726 */     GIR_Done,
     /* 160727 */   // Label 2372: @160727
     /* 160727 */   GIM_Try, /*On fail goto*//*Label 2373*/ GIMT_Encode4(160750), // Rule ID 245 //
     /* 160732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 160735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 160739 */     // (fmul:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC)  =>  (FMUL:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC)
     /* 160739 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FMUL),
     /* 160744 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 160748 */     GIR_RootConstrainSelectedInstOperands,
     /* 160749 */     // GIR_Coverage, 245,
     /* 160749 */     GIR_Done,
     /* 160750 */   // Label 2373: @160750
     /* 160750 */   GIM_Try, /*On fail goto*//*Label 2374*/ GIMT_Encode4(160769), // Rule ID 572 //
     /* 160755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 160758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::SPERCRegClassID),
     /* 160762 */     // (fmul:{ *:[f64] } f64:{ *:[f64] }:$RA, f64:{ *:[f64] }:$RB)  =>  (EFDMUL:{ *:[f64] } f64:{ *:[f64] }:$RA, f64:{ *:[f64] }:$RB)
     /* 160762 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFDMUL),
     /* 160767 */     GIR_RootConstrainSelectedInstOperands,
     /* 160768 */     // GIR_Coverage, 572,
     /* 160768 */     GIR_Done,
     /* 160769 */   // Label 2374: @160769
     /* 160769 */   GIM_Reject,
     /* 160770 */ // Label 2371: @160770
     /* 160770 */ GIM_Reject,
     /* 160771 */ // Label 2363: @160771
     /* 160771 */ GIM_Try, /*On fail goto*//*Label 2375*/ GIMT_Encode4(160796), // Rule ID 986 //
     /* 160776 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 160779 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 160782 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /* 160785 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 160789 */   // (fmul:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)  =>  (XSMULQP:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 160789 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSMULQP),
     /* 160794 */   GIR_RootConstrainSelectedInstOperands,
     /* 160795 */   // GIR_Coverage, 986,
     /* 160795 */   GIR_Done,
     /* 160796 */ // Label 2375: @160796
     /* 160796 */ GIM_Reject,
     /* 160797 */ // Label 2364: @160797
     /* 160797 */ GIM_Try, /*On fail goto*//*Label 2376*/ GIMT_Encode4(160826), // Rule ID 774 //
     /* 160802 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 160805 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 160808 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 160811 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 160815 */   // (fmul:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)  =>  (XVMULDP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /* 160815 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVMULDP),
     /* 160820 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 160824 */   GIR_RootConstrainSelectedInstOperands,
     /* 160825 */   // GIR_Coverage, 774,
     /* 160825 */   GIR_Done,
     /* 160826 */ // Label 2376: @160826
     /* 160826 */ GIM_Reject,
     /* 160827 */ // Label 2365: @160827
     /* 160827 */ GIM_Try, /*On fail goto*//*Label 2377*/ GIMT_Encode4(160936),
     /* 160832 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 160835 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 160838 */   GIM_Try, /*On fail goto*//*Label 2378*/ GIMT_Encode4(160861), // Rule ID 776 //
     /* 160843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 160846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 160850 */     // (fmul:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)  =>  (XVMULSP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /* 160850 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVMULSP),
     /* 160855 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 160859 */     GIR_RootConstrainSelectedInstOperands,
     /* 160860 */     // GIR_Coverage, 776,
     /* 160860 */     GIR_Done,
     /* 160861 */   // Label 2378: @160861
     /* 160861 */   GIM_Try, /*On fail goto*//*Label 2379*/ GIMT_Encode4(160935), // Rule ID 1379 //
     /* 160866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 160869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 160873 */     // (fmul:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$vA, v4f32:{ *:[v4f32] }:$vB)  =>  (VMADDFP:{ *:[v4f32] } ?:{ *:[v4f32] }:$vA, ?:{ *:[v4f32] }:$vB, (VSLW:{ *:[v4i32] } (V_SETALLONES:{ *:[v4i32] }), (V_SETALLONES:{ *:[v4i32] })))
     /* 160873 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 160876 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::V_SETALLONES),
     /* 160880 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160885 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 160887 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 160890 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::V_SETALLONES),
     /* 160894 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160899 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 160901 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 160904 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::VSLW),
     /* 160908 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160913 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 160916 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 160919 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 160921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMADDFP),
     /* 160924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /* 160926 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /* 160928 */     GIR_RootToRootCopy, /*OpIdx*/2, // vB
     /* 160930 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 160933 */     GIR_RootConstrainSelectedInstOperands,
     /* 160934 */     // GIR_Coverage, 1379,
     /* 160934 */     GIR_EraseRootFromParent_Done,
     /* 160935 */   // Label 2379: @160935
     /* 160935 */   GIM_Reject,
     /* 160936 */ // Label 2377: @160936
     /* 160936 */ GIM_Reject,
     /* 160937 */ // Label 2366: @160937
     /* 160937 */ GIM_Reject,
     /* 160938 */ // Label 43: @160938
     /* 160938 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2385*/ GIMT_Encode4(161518),
     /* 160949 */ /*GILLT_s32*//*Label 2380*/ GIMT_Encode4(160969),
     /* 160953 */ /*GILLT_s64*//*Label 2381*/ GIMT_Encode4(161115),
     /* 160957 */ /*GILLT_s128*//*Label 2382*/ GIMT_Encode4(161261),
     /* 160961 */ /*GILLT_v2s64*//*Label 2383*/ GIMT_Encode4(161339),
     /* 160965 */ /*GILLT_v4s32*//*Label 2384*/ GIMT_Encode4(161417),
     /* 160969 */ // Label 2380: @160969
     /* 160969 */ GIM_Try, /*On fail goto*//*Label 2386*/ GIMT_Encode4(161114),
     /* 160974 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 160977 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 160980 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 160983 */   GIM_Try, /*On fail goto*//*Label 2387*/ GIMT_Encode4(161024), // Rule ID 965 //
     /* 160988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 160991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 160995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 161003 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 161007 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161009 */     // (fma:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB, (fneg:{ *:[f32] } f32:{ *:[f32] }:$XTi))  =>  (XSMSUBASP:{ *:[f32] } f32:{ *:[f32] }:$XTi, f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)
     /* 161009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMSUBASP),
     /* 161012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 161014 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XTi
     /* 161018 */     GIR_RootToRootCopy, /*OpIdx*/1, // XA
     /* 161020 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /* 161022 */     GIR_RootConstrainSelectedInstOperands,
     /* 161023 */     // GIR_Coverage, 965,
     /* 161023 */     GIR_EraseRootFromParent_Done,
     /* 161024 */   // Label 2387: @161024
     /* 161024 */   GIM_Try, /*On fail goto*//*Label 2388*/ GIMT_Encode4(161049), // Rule ID 963 //
     /* 161029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 161032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 161036 */     // (fma:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB, f32:{ *:[f32] }:$XTi)  =>  (XSMADDASP:{ *:[f32] } f32:{ *:[f32] }:$XTi, f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)
     /* 161036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMADDASP),
     /* 161039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 161041 */     GIR_RootToRootCopy, /*OpIdx*/3, // XTi
     /* 161043 */     GIR_RootToRootCopy, /*OpIdx*/1, // XA
     /* 161045 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /* 161047 */     GIR_RootConstrainSelectedInstOperands,
     /* 161048 */     // GIR_Coverage, 963,
     /* 161048 */     GIR_EraseRootFromParent_Done,
     /* 161049 */   // Label 2388: @161049
     /* 161049 */   GIM_Try, /*On fail goto*//*Label 2389*/ GIMT_Encode4(161090), // Rule ID 225 //
     /* 161054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 161057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 161061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 161065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 161069 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 161073 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161075 */     // (fma:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC, (fneg:{ *:[f32] } f32:{ *:[f32] }:$FRB))  =>  (FMSUBS:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC, f32:{ *:[f32] }:$FRB)
     /* 161075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FMSUBS),
     /* 161078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /* 161080 */     GIR_RootToRootCopy, /*OpIdx*/1, // FRA
     /* 161082 */     GIR_RootToRootCopy, /*OpIdx*/2, // FRC
     /* 161084 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // FRB
     /* 161088 */     GIR_RootConstrainSelectedInstOperands,
     /* 161089 */     // GIR_Coverage, 225,
     /* 161089 */     GIR_EraseRootFromParent_Done,
     /* 161090 */   // Label 2389: @161090
     /* 161090 */   GIM_Try, /*On fail goto*//*Label 2390*/ GIMT_Encode4(161113), // Rule ID 221 //
     /* 161095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 161098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 161102 */     // (fma:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC, f32:{ *:[f32] }:$FRB)  =>  (FMADDS:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC, f32:{ *:[f32] }:$FRB)
     /* 161102 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FMADDS),
     /* 161107 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 161111 */     GIR_RootConstrainSelectedInstOperands,
     /* 161112 */     // GIR_Coverage, 221,
     /* 161112 */     GIR_Done,
     /* 161113 */   // Label 2390: @161113
     /* 161113 */   GIM_Reject,
     /* 161114 */ // Label 2386: @161114
     /* 161114 */ GIM_Reject,
     /* 161115 */ // Label 2381: @161115
     /* 161115 */ GIM_Try, /*On fail goto*//*Label 2391*/ GIMT_Encode4(161260),
     /* 161120 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 161123 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161126 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 161129 */   GIM_Try, /*On fail goto*//*Label 2392*/ GIMT_Encode4(161170), // Rule ID 786 //
     /* 161134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 161137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 161141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 161145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 161149 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 161153 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161155 */     // (fma:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB, (fneg:{ *:[f64] } f64:{ *:[f64] }:$XTi))  =>  (XSMSUBADP:{ *:[f64] } f64:{ *:[f64] }:$XTi, f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)
     /* 161155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMSUBADP),
     /* 161158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 161160 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XTi
     /* 161164 */     GIR_RootToRootCopy, /*OpIdx*/1, // XA
     /* 161166 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /* 161168 */     GIR_RootConstrainSelectedInstOperands,
     /* 161169 */     // GIR_Coverage, 786,
     /* 161169 */     GIR_EraseRootFromParent_Done,
     /* 161170 */   // Label 2392: @161170
     /* 161170 */   GIM_Try, /*On fail goto*//*Label 2393*/ GIMT_Encode4(161195), // Rule ID 784 //
     /* 161175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 161178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 161182 */     // (fma:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB, f64:{ *:[f64] }:$XTi)  =>  (XSMADDADP:{ *:[f64] } f64:{ *:[f64] }:$XTi, f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)
     /* 161182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMADDADP),
     /* 161185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 161187 */     GIR_RootToRootCopy, /*OpIdx*/3, // XTi
     /* 161189 */     GIR_RootToRootCopy, /*OpIdx*/1, // XA
     /* 161191 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /* 161193 */     GIR_RootConstrainSelectedInstOperands,
     /* 161194 */     // GIR_Coverage, 784,
     /* 161194 */     GIR_EraseRootFromParent_Done,
     /* 161195 */   // Label 2393: @161195
     /* 161195 */   GIM_Try, /*On fail goto*//*Label 2394*/ GIMT_Encode4(161236), // Rule ID 223 //
     /* 161200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 161203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 161207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 161211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 161215 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 161219 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161221 */     // (fma:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC, (fneg:{ *:[f64] } f64:{ *:[f64] }:$FRB))  =>  (FMSUB:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC, f64:{ *:[f64] }:$FRB)
     /* 161221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FMSUB),
     /* 161224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /* 161226 */     GIR_RootToRootCopy, /*OpIdx*/1, // FRA
     /* 161228 */     GIR_RootToRootCopy, /*OpIdx*/2, // FRC
     /* 161230 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // FRB
     /* 161234 */     GIR_RootConstrainSelectedInstOperands,
     /* 161235 */     // GIR_Coverage, 223,
     /* 161235 */     GIR_EraseRootFromParent_Done,
     /* 161236 */   // Label 2394: @161236
     /* 161236 */   GIM_Try, /*On fail goto*//*Label 2395*/ GIMT_Encode4(161259), // Rule ID 219 //
     /* 161241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 161244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 161248 */     // (fma:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC, f64:{ *:[f64] }:$FRB)  =>  (FMADD:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC, f64:{ *:[f64] }:$FRB)
     /* 161248 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FMADD),
     /* 161253 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 161257 */     GIR_RootConstrainSelectedInstOperands,
     /* 161258 */     // GIR_Coverage, 219,
     /* 161258 */     GIR_Done,
     /* 161259 */   // Label 2395: @161259
     /* 161259 */   GIM_Reject,
     /* 161260 */ // Label 2391: @161260
     /* 161260 */ GIM_Reject,
     /* 161261 */ // Label 2382: @161261
     /* 161261 */ GIM_Try, /*On fail goto*//*Label 2396*/ GIMT_Encode4(161338),
     /* 161266 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 161269 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /* 161272 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /* 161275 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 161279 */   GIM_Try, /*On fail goto*//*Label 2397*/ GIMT_Encode4(161316), // Rule ID 996 //
     /* 161284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 161287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 161291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 161295 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s128,
     /* 161299 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161301 */     // (fma:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB, (fneg:{ *:[f128] } f128:{ *:[f128] }:$RSTi))  =>  (XSMSUBQP:{ *:[f128] } f128:{ *:[f128] }:$RSTi, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 161301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMSUBQP),
     /* 161304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 161306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RSTi
     /* 161310 */     GIR_RootToRootCopy, /*OpIdx*/1, // RA
     /* 161312 */     GIR_RootToRootCopy, /*OpIdx*/2, // RB
     /* 161314 */     GIR_RootConstrainSelectedInstOperands,
     /* 161315 */     // GIR_Coverage, 996,
     /* 161315 */     GIR_EraseRootFromParent_Done,
     /* 161316 */   // Label 2397: @161316
     /* 161316 */   GIM_Try, /*On fail goto*//*Label 2398*/ GIMT_Encode4(161337), // Rule ID 994 //
     /* 161321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 161324 */     // (fma:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB, f128:{ *:[f128] }:$RSTi)  =>  (XSMADDQP:{ *:[f128] } f128:{ *:[f128] }:$RSTi, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 161324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMADDQP),
     /* 161327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 161329 */     GIR_RootToRootCopy, /*OpIdx*/3, // RSTi
     /* 161331 */     GIR_RootToRootCopy, /*OpIdx*/1, // RA
     /* 161333 */     GIR_RootToRootCopy, /*OpIdx*/2, // RB
     /* 161335 */     GIR_RootConstrainSelectedInstOperands,
     /* 161336 */     // GIR_Coverage, 994,
     /* 161336 */     GIR_EraseRootFromParent_Done,
     /* 161337 */   // Label 2398: @161337
     /* 161337 */   GIM_Reject,
     /* 161338 */ // Label 2396: @161338
     /* 161338 */ GIM_Reject,
     /* 161339 */ // Label 2383: @161339
     /* 161339 */ GIM_Try, /*On fail goto*//*Label 2399*/ GIMT_Encode4(161416),
     /* 161344 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 161347 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 161350 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 161353 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 161357 */   GIM_Try, /*On fail goto*//*Label 2400*/ GIMT_Encode4(161394), // Rule ID 796 //
     /* 161362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 161365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 161369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 161373 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 161377 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161379 */     // (fma:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB, (fneg:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XTi))  =>  (XVMSUBADP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XTi, v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /* 161379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVMSUBADP),
     /* 161382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 161384 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XTi
     /* 161388 */     GIR_RootToRootCopy, /*OpIdx*/1, // XA
     /* 161390 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /* 161392 */     GIR_RootConstrainSelectedInstOperands,
     /* 161393 */     // GIR_Coverage, 796,
     /* 161393 */     GIR_EraseRootFromParent_Done,
     /* 161394 */   // Label 2400: @161394
     /* 161394 */   GIM_Try, /*On fail goto*//*Label 2401*/ GIMT_Encode4(161415), // Rule ID 792 //
     /* 161399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 161402 */     // (fma:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB, v2f64:{ *:[v2f64] }:$XTi)  =>  (XVMADDADP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XTi, v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /* 161402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVMADDADP),
     /* 161405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 161407 */     GIR_RootToRootCopy, /*OpIdx*/3, // XTi
     /* 161409 */     GIR_RootToRootCopy, /*OpIdx*/1, // XA
     /* 161411 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /* 161413 */     GIR_RootConstrainSelectedInstOperands,
     /* 161414 */     // GIR_Coverage, 792,
     /* 161414 */     GIR_EraseRootFromParent_Done,
     /* 161415 */   // Label 2401: @161415
     /* 161415 */   GIM_Reject,
     /* 161416 */ // Label 2399: @161416
     /* 161416 */ GIM_Reject,
     /* 161417 */ // Label 2384: @161417
     /* 161417 */ GIM_Try, /*On fail goto*//*Label 2402*/ GIMT_Encode4(161517),
     /* 161422 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 161425 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 161428 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 161431 */   GIM_Try, /*On fail goto*//*Label 2403*/ GIMT_Encode4(161472), // Rule ID 798 //
     /* 161436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 161439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 161443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 161447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 161451 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 161455 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161457 */     // (fma:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB, (fneg:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XTi))  =>  (XVMSUBASP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XTi, v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /* 161457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVMSUBASP),
     /* 161460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 161462 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XTi
     /* 161466 */     GIR_RootToRootCopy, /*OpIdx*/1, // XA
     /* 161468 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /* 161470 */     GIR_RootConstrainSelectedInstOperands,
     /* 161471 */     // GIR_Coverage, 798,
     /* 161471 */     GIR_EraseRootFromParent_Done,
     /* 161472 */   // Label 2403: @161472
     /* 161472 */   GIM_Try, /*On fail goto*//*Label 2404*/ GIMT_Encode4(161497), // Rule ID 794 //
     /* 161477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 161480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 161484 */     // (fma:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB, v4f32:{ *:[v4f32] }:$XTi)  =>  (XVMADDASP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XTi, v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /* 161484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVMADDASP),
     /* 161487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 161489 */     GIR_RootToRootCopy, /*OpIdx*/3, // XTi
     /* 161491 */     GIR_RootToRootCopy, /*OpIdx*/1, // XA
     /* 161493 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /* 161495 */     GIR_RootConstrainSelectedInstOperands,
     /* 161496 */     // GIR_Coverage, 794,
     /* 161496 */     GIR_EraseRootFromParent_Done,
     /* 161497 */   // Label 2404: @161497
     /* 161497 */   GIM_Try, /*On fail goto*//*Label 2405*/ GIMT_Encode4(161516), // Rule ID 292 //
     /* 161502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 161505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 161509 */     // (fma:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$RA, v4f32:{ *:[v4f32] }:$RC, v4f32:{ *:[v4f32] }:$RB)  =>  (VMADDFP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$RA, v4f32:{ *:[v4f32] }:$RC, v4f32:{ *:[v4f32] }:$RB)
     /* 161509 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMADDFP),
     /* 161514 */     GIR_RootConstrainSelectedInstOperands,
     /* 161515 */     // GIR_Coverage, 292,
     /* 161515 */     GIR_Done,
     /* 161516 */   // Label 2405: @161516
     /* 161516 */   GIM_Reject,
     /* 161517 */ // Label 2402: @161517
     /* 161517 */ GIM_Reject,
     /* 161518 */ // Label 2385: @161518
     /* 161518 */ GIM_Reject,
     /* 161519 */ // Label 44: @161519
     /* 161519 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2411*/ GIMT_Encode4(161788),
     /* 161530 */ /*GILLT_s32*//*Label 2406*/ GIMT_Encode4(161550),
     /* 161534 */ /*GILLT_s64*//*Label 2407*/ GIMT_Encode4(161624),
     /* 161538 */ /*GILLT_s128*//*Label 2408*/ GIMT_Encode4(161702),
     /* 161542 */ /*GILLT_v2s64*//*Label 2409*/ GIMT_Encode4(161728),
     /* 161546 */ /*GILLT_v4s32*//*Label 2410*/ GIMT_Encode4(161758),
     /* 161550 */ // Label 2406: @161550
     /* 161550 */ GIM_Try, /*On fail goto*//*Label 2412*/ GIMT_Encode4(161623),
     /* 161555 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 161558 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161561 */   GIM_Try, /*On fail goto*//*Label 2413*/ GIMT_Encode4(161580), // Rule ID 955 //
     /* 161566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 161569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 161573 */     // (fdiv:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)  =>  (XSDIVSP:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)
     /* 161573 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSDIVSP),
     /* 161578 */     GIR_RootConstrainSelectedInstOperands,
     /* 161579 */     // GIR_Coverage, 955,
     /* 161579 */     GIR_Done,
     /* 161580 */   // Label 2413: @161580
     /* 161580 */   GIM_Try, /*On fail goto*//*Label 2414*/ GIMT_Encode4(161603), // Rule ID 243 //
     /* 161585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 161588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 161592 */     // (fdiv:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRB)  =>  (FDIVS:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRB)
     /* 161592 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FDIVS),
     /* 161597 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 161601 */     GIR_RootConstrainSelectedInstOperands,
     /* 161602 */     // GIR_Coverage, 243,
     /* 161602 */     GIR_Done,
     /* 161603 */   // Label 2414: @161603
     /* 161603 */   GIM_Try, /*On fail goto*//*Label 2415*/ GIMT_Encode4(161622), // Rule ID 591 //
     /* 161608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 161611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 161615 */     // (fdiv:{ *:[f32] } f32:{ *:[f32] }:$RA, f32:{ *:[f32] }:$RB)  =>  (EFSDIV:{ *:[f32] } f32:{ *:[f32] }:$RA, f32:{ *:[f32] }:$RB)
     /* 161615 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFSDIV),
     /* 161620 */     GIR_RootConstrainSelectedInstOperands,
     /* 161621 */     // GIR_Coverage, 591,
     /* 161621 */     GIR_Done,
     /* 161622 */   // Label 2415: @161622
     /* 161622 */   GIM_Reject,
     /* 161623 */ // Label 2412: @161623
     /* 161623 */ GIM_Reject,
     /* 161624 */ // Label 2407: @161624
     /* 161624 */ GIM_Try, /*On fail goto*//*Label 2416*/ GIMT_Encode4(161701),
     /* 161629 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 161632 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161635 */   GIM_Try, /*On fail goto*//*Label 2417*/ GIMT_Encode4(161658), // Rule ID 807 //
     /* 161640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 161643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 161647 */     // (fdiv:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)  =>  (XSDIVDP:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)
     /* 161647 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSDIVDP),
     /* 161652 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 161656 */     GIR_RootConstrainSelectedInstOperands,
     /* 161657 */     // GIR_Coverage, 807,
     /* 161657 */     GIR_Done,
     /* 161658 */   // Label 2417: @161658
     /* 161658 */   GIM_Try, /*On fail goto*//*Label 2418*/ GIMT_Encode4(161681), // Rule ID 241 //
     /* 161663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 161666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 161670 */     // (fdiv:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRB)  =>  (FDIV:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRB)
     /* 161670 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FDIV),
     /* 161675 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 161679 */     GIR_RootConstrainSelectedInstOperands,
     /* 161680 */     // GIR_Coverage, 241,
     /* 161680 */     GIR_Done,
     /* 161681 */   // Label 2418: @161681
     /* 161681 */   GIM_Try, /*On fail goto*//*Label 2419*/ GIMT_Encode4(161700), // Rule ID 570 //
     /* 161686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 161689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::SPERCRegClassID),
     /* 161693 */     // (fdiv:{ *:[f64] } f64:{ *:[f64] }:$RA, f64:{ *:[f64] }:$RB)  =>  (EFDDIV:{ *:[f64] } f64:{ *:[f64] }:$RA, f64:{ *:[f64] }:$RB)
     /* 161693 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFDDIV),
     /* 161698 */     GIR_RootConstrainSelectedInstOperands,
     /* 161699 */     // GIR_Coverage, 570,
     /* 161699 */     GIR_Done,
     /* 161700 */   // Label 2419: @161700
     /* 161700 */   GIM_Reject,
     /* 161701 */ // Label 2416: @161701
     /* 161701 */ GIM_Reject,
     /* 161702 */ // Label 2408: @161702
     /* 161702 */ GIM_Try, /*On fail goto*//*Label 2420*/ GIMT_Encode4(161727), // Rule ID 990 //
     /* 161707 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 161710 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 161713 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /* 161716 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 161720 */   // (fdiv:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)  =>  (XSDIVQP:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 161720 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSDIVQP),
     /* 161725 */   GIR_RootConstrainSelectedInstOperands,
     /* 161726 */   // GIR_Coverage, 990,
     /* 161726 */   GIR_Done,
     /* 161727 */ // Label 2420: @161727
     /* 161727 */ GIM_Reject,
     /* 161728 */ // Label 2409: @161728
     /* 161728 */ GIM_Try, /*On fail goto*//*Label 2421*/ GIMT_Encode4(161757), // Rule ID 816 //
     /* 161733 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 161736 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 161739 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 161742 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 161746 */   // (fdiv:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)  =>  (XVDIVDP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /* 161746 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVDIVDP),
     /* 161751 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 161755 */   GIR_RootConstrainSelectedInstOperands,
     /* 161756 */   // GIR_Coverage, 816,
     /* 161756 */   GIR_Done,
     /* 161757 */ // Label 2421: @161757
     /* 161757 */ GIM_Reject,
     /* 161758 */ // Label 2410: @161758
     /* 161758 */ GIM_Try, /*On fail goto*//*Label 2422*/ GIMT_Encode4(161787), // Rule ID 818 //
     /* 161763 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 161766 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 161769 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 161772 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 161776 */   // (fdiv:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)  =>  (XVDIVSP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /* 161776 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVDIVSP),
     /* 161781 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 161785 */   GIR_RootConstrainSelectedInstOperands,
     /* 161786 */   // GIR_Coverage, 818,
     /* 161786 */   GIR_Done,
     /* 161787 */ // Label 2422: @161787
     /* 161787 */ GIM_Reject,
     /* 161788 */ // Label 2411: @161788
     /* 161788 */ GIM_Reject,
     /* 161789 */ // Label 45: @161789
     /* 161789 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2428*/ GIMT_Encode4(164259),
     /* 161800 */ /*GILLT_s32*//*Label 2423*/ GIMT_Encode4(161820),
     /* 161804 */ /*GILLT_s64*//*Label 2424*/ GIMT_Encode4(162593),
     /* 161808 */ /*GILLT_s128*//*Label 2425*/ GIMT_Encode4(163247),
     /* 161812 */ /*GILLT_v2s64*//*Label 2426*/ GIMT_Encode4(163655),
     /* 161816 */ /*GILLT_v4s32*//*Label 2427*/ GIMT_Encode4(163941),
     /* 161820 */ // Label 2423: @161820
     /* 161820 */ GIM_Try, /*On fail goto*//*Label 2429*/ GIMT_Encode4(162592),
     /* 161825 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 161828 */   GIM_Try, /*On fail goto*//*Label 2430*/ GIMT_Encode4(161893), // Rule ID 969 //
     /* 161833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 161836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 161840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 161844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 161848 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 161852 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 161856 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 161860 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 161864 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 161868 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 161872 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 161874 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB, (fneg:{ *:[f32] } f32:{ *:[f32] }:$XTi)))  =>  (XSNMSUBASP:{ *:[f32] } f32:{ *:[f32] }:$XTi, f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)
     /* 161874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNMSUBASP),
     /* 161877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 161879 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // XTi
     /* 161883 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /* 161887 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // XB
     /* 161891 */     GIR_RootConstrainSelectedInstOperands,
     /* 161892 */     // GIR_Coverage, 969,
     /* 161892 */     GIR_EraseRootFromParent_Done,
     /* 161893 */   // Label 2430: @161893
     /* 161893 */   GIM_Try, /*On fail goto*//*Label 2431*/ GIMT_Encode4(161958), // Rule ID 968 //
     /* 161898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 161901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 161905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 161909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 161913 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 161917 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 161921 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 161925 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 161929 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 161933 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 161937 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 161939 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB, (fneg:{ *:[f32] } f32:{ *:[f32] }:$XTi)))  =>  (XSNMSUBASP:{ *:[f32] } f32:{ *:[f32] }:$XTi, f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)
     /* 161939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNMSUBASP),
     /* 161942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 161944 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // XTi
     /* 161948 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /* 161952 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // XB
     /* 161956 */     GIR_RootConstrainSelectedInstOperands,
     /* 161957 */     // GIR_Coverage, 968,
     /* 161957 */     GIR_EraseRootFromParent_Done,
     /* 161958 */   // Label 2431: @161958
     /* 161958 */   GIM_Try, /*On fail goto*//*Label 2432*/ GIMT_Encode4(162011), // Rule ID 967 //
     /* 161963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 161966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 161970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 161974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 161978 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 161982 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 161986 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 161990 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161992 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB, f32:{ *:[f32] }:$XTi))  =>  (XSNMADDASP:{ *:[f32] } f32:{ *:[f32] }:$XTi, f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)
     /* 161992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNMADDASP),
     /* 161995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 161997 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // XTi
     /* 162001 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /* 162005 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // XB
     /* 162009 */     GIR_RootConstrainSelectedInstOperands,
     /* 162010 */     // GIR_Coverage, 967,
     /* 162010 */     GIR_EraseRootFromParent_Done,
     /* 162011 */   // Label 2432: @162011
     /* 162011 */   GIM_Try, /*On fail goto*//*Label 2433*/ GIMT_Encode4(162064), // Rule ID 966 //
     /* 162016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 162019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 162023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 162027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 162031 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 162035 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 162039 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 162043 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162045 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB, f32:{ *:[f32] }:$XTi))  =>  (XSNMADDASP:{ *:[f32] } f32:{ *:[f32] }:$XTi, f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)
     /* 162045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNMADDASP),
     /* 162048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 162050 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // XTi
     /* 162054 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /* 162058 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // XB
     /* 162062 */     GIR_RootConstrainSelectedInstOperands,
     /* 162063 */     // GIR_Coverage, 966,
     /* 162063 */     GIR_EraseRootFromParent_Done,
     /* 162064 */   // Label 2433: @162064
     /* 162064 */   GIM_Try, /*On fail goto*//*Label 2434*/ GIMT_Encode4(162101), // Rule ID 841 //
     /* 162069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 162072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 162076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 162080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 162084 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 162088 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162090 */     // (fneg:{ *:[f32] } (fabs:{ *:[f32] } f32:{ *:[f32] }:$XB))  =>  (XSNABSDPs:{ *:[f32] } f32:{ *:[f32] }:$XB)
     /* 162090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNABSDPs),
     /* 162093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 162095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XB
     /* 162099 */     GIR_RootConstrainSelectedInstOperands,
     /* 162100 */     // GIR_Coverage, 841,
     /* 162100 */     GIR_EraseRootFromParent_Done,
     /* 162101 */   // Label 2434: @162101
     /* 162101 */   GIM_Try, /*On fail goto*//*Label 2435*/ GIMT_Encode4(162179), // Rule ID 1678 //
     /* 162106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 162109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 162113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 162117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 162121 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 162125 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162127 */     // (fneg:{ *:[f32] } (fabs:{ *:[f32] } f32:{ *:[f32] }:$S))  =>  (COPY_TO_REGCLASS:{ *:[f32] } (XSNABSDP:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$S, VSFRC:{ *:[i32] })), VSSRC:{ *:[i32] })
     /* 162127 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 162130 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 162134 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 162139 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // S
     /* 162143 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 162148 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 162151 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSNABSDP),
     /* 162155 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 162160 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 162163 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 162165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 162168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162170 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 162173 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 162178 */     // GIR_Coverage, 1678,
     /* 162178 */     GIR_EraseRootFromParent_Done,
     /* 162179 */   // Label 2435: @162179
     /* 162179 */   GIM_Try, /*On fail goto*//*Label 2436*/ GIMT_Encode4(162243), // Rule ID 1919 //
     /* 162184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 162187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 162191 */     // (fneg:{ *:[f32] } f32:{ *:[f32] }:$S)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (XSNEGDP:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$S, VSFRC:{ *:[i32] })), VSSRC:{ *:[i32] })
     /* 162191 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 162194 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 162198 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 162203 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // S
     /* 162207 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 162212 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 162215 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSNEGDP),
     /* 162219 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 162224 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 162227 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 162229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 162232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162234 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 162237 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 162242 */     // GIR_Coverage, 1919,
     /* 162242 */     GIR_EraseRootFromParent_Done,
     /* 162243 */   // Label 2436: @162243
     /* 162243 */   GIM_Try, /*On fail goto*//*Label 2437*/ GIMT_Encode4(162308), // Rule ID 233 //
     /* 162248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 162251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 162255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 162259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 162263 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 162267 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 162271 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 162275 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 162279 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 162283 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 162287 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 162289 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC, (fneg:{ *:[f32] } f32:{ *:[f32] }:$FRB)))  =>  (FNMSUBS:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC, f32:{ *:[f32] }:$FRB)
     /* 162289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FNMSUBS),
     /* 162292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /* 162294 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // FRA
     /* 162298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // FRC
     /* 162302 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // FRB
     /* 162306 */     GIR_RootConstrainSelectedInstOperands,
     /* 162307 */     // GIR_Coverage, 233,
     /* 162307 */     GIR_EraseRootFromParent_Done,
     /* 162308 */   // Label 2437: @162308
     /* 162308 */   GIM_Try, /*On fail goto*//*Label 2438*/ GIMT_Encode4(162373), // Rule ID 232 //
     /* 162313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 162316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 162320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 162324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 162328 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 162332 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 162336 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 162340 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 162344 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 162348 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 162352 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 162354 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC, (fneg:{ *:[f32] } f32:{ *:[f32] }:$FRB)))  =>  (FNMSUBS:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC, f32:{ *:[f32] }:$FRB)
     /* 162354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FNMSUBS),
     /* 162357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /* 162359 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // FRA
     /* 162363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // FRC
     /* 162367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // FRB
     /* 162371 */     GIR_RootConstrainSelectedInstOperands,
     /* 162372 */     // GIR_Coverage, 232,
     /* 162372 */     GIR_EraseRootFromParent_Done,
     /* 162373 */   // Label 2438: @162373
     /* 162373 */   GIM_Try, /*On fail goto*//*Label 2439*/ GIMT_Encode4(162426), // Rule ID 229 //
     /* 162378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 162381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 162385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 162389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 162393 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 162397 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 162401 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 162405 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162407 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC, f32:{ *:[f32] }:$FRB))  =>  (FNMADDS:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC, f32:{ *:[f32] }:$FRB)
     /* 162407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FNMADDS),
     /* 162410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /* 162412 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // FRA
     /* 162416 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // FRC
     /* 162420 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // FRB
     /* 162424 */     GIR_RootConstrainSelectedInstOperands,
     /* 162425 */     // GIR_Coverage, 229,
     /* 162425 */     GIR_EraseRootFromParent_Done,
     /* 162426 */   // Label 2439: @162426
     /* 162426 */   GIM_Try, /*On fail goto*//*Label 2440*/ GIMT_Encode4(162479), // Rule ID 228 //
     /* 162431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 162434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 162438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 162442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 162446 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 162450 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 162454 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 162458 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162460 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC, f32:{ *:[f32] }:$FRB))  =>  (FNMADDS:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC, f32:{ *:[f32] }:$FRB)
     /* 162460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FNMADDS),
     /* 162463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /* 162465 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // FRA
     /* 162469 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // FRC
     /* 162473 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // FRB
     /* 162477 */     GIR_RootConstrainSelectedInstOperands,
     /* 162478 */     // GIR_Coverage, 228,
     /* 162478 */     GIR_EraseRootFromParent_Done,
     /* 162479 */   // Label 2440: @162479
     /* 162479 */   GIM_Try, /*On fail goto*//*Label 2441*/ GIMT_Encode4(162516), // Rule ID 165 //
     /* 162484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 162487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 162491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 162495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 162499 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 162503 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162505 */     // (fneg:{ *:[f32] } (fabs:{ *:[f32] } f32:{ *:[f32] }:$RB))  =>  (FNABSS:{ *:[f32] } f32:{ *:[f32] }:$RB)
     /* 162505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FNABSS),
     /* 162508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 162510 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RB
     /* 162514 */     GIR_RootConstrainSelectedInstOperands,
     /* 162515 */     // GIR_Coverage, 165,
     /* 162515 */     GIR_EraseRootFromParent_Done,
     /* 162516 */   // Label 2441: @162516
     /* 162516 */   GIM_Try, /*On fail goto*//*Label 2442*/ GIMT_Encode4(162553), // Rule ID 594 //
     /* 162521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 162524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 162528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 162532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 162536 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 162540 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162542 */     // (fneg:{ *:[f32] } (fabs:{ *:[f32] } f32:{ *:[f32] }:$RA))  =>  (EFSNABS:{ *:[f32] } f32:{ *:[f32] }:$RA)
     /* 162542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::EFSNABS),
     /* 162545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /* 162547 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RA
     /* 162551 */     GIR_RootConstrainSelectedInstOperands,
     /* 162552 */     // GIR_Coverage, 594,
     /* 162552 */     GIR_EraseRootFromParent_Done,
     /* 162553 */   // Label 2442: @162553
     /* 162553 */   GIM_Try, /*On fail goto*//*Label 2443*/ GIMT_Encode4(162572), // Rule ID 167 //
     /* 162558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 162561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 162565 */     // (fneg:{ *:[f32] } f32:{ *:[f32] }:$RB)  =>  (FNEGS:{ *:[f32] } f32:{ *:[f32] }:$RB)
     /* 162565 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FNEGS),
     /* 162570 */     GIR_RootConstrainSelectedInstOperands,
     /* 162571 */     // GIR_Coverage, 167,
     /* 162571 */     GIR_Done,
     /* 162572 */   // Label 2443: @162572
     /* 162572 */   GIM_Try, /*On fail goto*//*Label 2444*/ GIMT_Encode4(162591), // Rule ID 595 //
     /* 162577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 162580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 162584 */     // (fneg:{ *:[f32] } f32:{ *:[f32] }:$RA)  =>  (EFSNEG:{ *:[f32] } f32:{ *:[f32] }:$RA)
     /* 162584 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFSNEG),
     /* 162589 */     GIR_RootConstrainSelectedInstOperands,
     /* 162590 */     // GIR_Coverage, 595,
     /* 162590 */     GIR_Done,
     /* 162591 */   // Label 2444: @162591
     /* 162591 */   GIM_Reject,
     /* 162592 */ // Label 2429: @162592
     /* 162592 */ GIM_Reject,
     /* 162593 */ // Label 2424: @162593
     /* 162593 */ GIM_Try, /*On fail goto*//*Label 2445*/ GIMT_Encode4(163246),
     /* 162598 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 162601 */   GIM_Try, /*On fail goto*//*Label 2446*/ GIMT_Encode4(162666), // Rule ID 790 //
     /* 162606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 162609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 162613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 162617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 162621 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 162625 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 162629 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 162633 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 162637 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 162641 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 162645 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 162647 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB, (fneg:{ *:[f64] } f64:{ *:[f64] }:$XTi)))  =>  (XSNMSUBADP:{ *:[f64] } f64:{ *:[f64] }:$XTi, f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)
     /* 162647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNMSUBADP),
     /* 162650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 162652 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // XTi
     /* 162656 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /* 162660 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // XB
     /* 162664 */     GIR_RootConstrainSelectedInstOperands,
     /* 162665 */     // GIR_Coverage, 790,
     /* 162665 */     GIR_EraseRootFromParent_Done,
     /* 162666 */   // Label 2446: @162666
     /* 162666 */   GIM_Try, /*On fail goto*//*Label 2447*/ GIMT_Encode4(162731), // Rule ID 789 //
     /* 162671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 162674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 162678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 162682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 162686 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 162690 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 162694 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 162698 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 162702 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 162706 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 162710 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 162712 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB, (fneg:{ *:[f64] } f64:{ *:[f64] }:$XTi)))  =>  (XSNMSUBADP:{ *:[f64] } f64:{ *:[f64] }:$XTi, f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)
     /* 162712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNMSUBADP),
     /* 162715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 162717 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // XTi
     /* 162721 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /* 162725 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // XB
     /* 162729 */     GIR_RootConstrainSelectedInstOperands,
     /* 162730 */     // GIR_Coverage, 789,
     /* 162730 */     GIR_EraseRootFromParent_Done,
     /* 162731 */   // Label 2447: @162731
     /* 162731 */   GIM_Try, /*On fail goto*//*Label 2448*/ GIMT_Encode4(162784), // Rule ID 788 //
     /* 162736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 162739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 162743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 162747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 162751 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 162755 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 162759 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 162763 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162765 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB, f64:{ *:[f64] }:$XTi))  =>  (XSNMADDADP:{ *:[f64] } f64:{ *:[f64] }:$XTi, f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)
     /* 162765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNMADDADP),
     /* 162768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 162770 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // XTi
     /* 162774 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /* 162778 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // XB
     /* 162782 */     GIR_RootConstrainSelectedInstOperands,
     /* 162783 */     // GIR_Coverage, 788,
     /* 162783 */     GIR_EraseRootFromParent_Done,
     /* 162784 */   // Label 2448: @162784
     /* 162784 */   GIM_Try, /*On fail goto*//*Label 2449*/ GIMT_Encode4(162837), // Rule ID 787 //
     /* 162789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 162792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 162796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 162800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 162804 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 162808 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 162812 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 162816 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162818 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB, f64:{ *:[f64] }:$XTi))  =>  (XSNMADDADP:{ *:[f64] } f64:{ *:[f64] }:$XTi, f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)
     /* 162818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNMADDADP),
     /* 162821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 162823 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // XTi
     /* 162827 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /* 162831 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // XB
     /* 162835 */     GIR_RootConstrainSelectedInstOperands,
     /* 162836 */     // GIR_Coverage, 787,
     /* 162836 */     GIR_EraseRootFromParent_Done,
     /* 162837 */   // Label 2449: @162837
     /* 162837 */   GIM_Try, /*On fail goto*//*Label 2450*/ GIMT_Encode4(162874), // Rule ID 840 //
     /* 162842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 162845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 162849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 162853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 162857 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 162861 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162863 */     // (fneg:{ *:[f64] } (fabs:{ *:[f64] } f64:{ *:[f64] }:$XB))  =>  (XSNABSDP:{ *:[f64] } f64:{ *:[f64] }:$XB)
     /* 162863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNABSDP),
     /* 162866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 162868 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XB
     /* 162872 */     GIR_RootConstrainSelectedInstOperands,
     /* 162873 */     // GIR_Coverage, 840,
     /* 162873 */     GIR_EraseRootFromParent_Done,
     /* 162874 */   // Label 2450: @162874
     /* 162874 */   GIM_Try, /*On fail goto*//*Label 2451*/ GIMT_Encode4(162897), // Rule ID 842 //
     /* 162879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 162882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 162886 */     // (fneg:{ *:[f64] } f64:{ *:[f64] }:$XB)  =>  (XSNEGDP:{ *:[f64] } f64:{ *:[f64] }:$XB)
     /* 162886 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSNEGDP),
     /* 162891 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 162895 */     GIR_RootConstrainSelectedInstOperands,
     /* 162896 */     // GIR_Coverage, 842,
     /* 162896 */     GIR_Done,
     /* 162897 */   // Label 2451: @162897
     /* 162897 */   GIM_Try, /*On fail goto*//*Label 2452*/ GIMT_Encode4(162962), // Rule ID 231 //
     /* 162902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 162905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 162909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 162913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 162917 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 162921 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 162925 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 162929 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 162933 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 162937 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 162941 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 162943 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC, (fneg:{ *:[f64] } f64:{ *:[f64] }:$FRB)))  =>  (FNMSUB:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC, f64:{ *:[f64] }:$FRB)
     /* 162943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FNMSUB),
     /* 162946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /* 162948 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // FRA
     /* 162952 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // FRC
     /* 162956 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // FRB
     /* 162960 */     GIR_RootConstrainSelectedInstOperands,
     /* 162961 */     // GIR_Coverage, 231,
     /* 162961 */     GIR_EraseRootFromParent_Done,
     /* 162962 */   // Label 2452: @162962
     /* 162962 */   GIM_Try, /*On fail goto*//*Label 2453*/ GIMT_Encode4(163027), // Rule ID 230 //
     /* 162967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 162970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 162974 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 162978 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 162982 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 162986 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 162990 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 162994 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 162998 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 163002 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 163006 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 163008 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC, (fneg:{ *:[f64] } f64:{ *:[f64] }:$FRB)))  =>  (FNMSUB:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC, f64:{ *:[f64] }:$FRB)
     /* 163008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FNMSUB),
     /* 163011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /* 163013 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // FRA
     /* 163017 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // FRC
     /* 163021 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // FRB
     /* 163025 */     GIR_RootConstrainSelectedInstOperands,
     /* 163026 */     // GIR_Coverage, 230,
     /* 163026 */     GIR_EraseRootFromParent_Done,
     /* 163027 */   // Label 2453: @163027
     /* 163027 */   GIM_Try, /*On fail goto*//*Label 2454*/ GIMT_Encode4(163080), // Rule ID 227 //
     /* 163032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 163035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 163039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 163043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 163047 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 163051 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 163055 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 163059 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163061 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC, f64:{ *:[f64] }:$FRB))  =>  (FNMADD:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC, f64:{ *:[f64] }:$FRB)
     /* 163061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FNMADD),
     /* 163064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /* 163066 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // FRA
     /* 163070 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // FRC
     /* 163074 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // FRB
     /* 163078 */     GIR_RootConstrainSelectedInstOperands,
     /* 163079 */     // GIR_Coverage, 227,
     /* 163079 */     GIR_EraseRootFromParent_Done,
     /* 163080 */   // Label 2454: @163080
     /* 163080 */   GIM_Try, /*On fail goto*//*Label 2455*/ GIMT_Encode4(163133), // Rule ID 226 //
     /* 163085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 163088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 163092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 163096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 163100 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 163104 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 163108 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 163112 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163114 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC, f64:{ *:[f64] }:$FRB))  =>  (FNMADD:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC, f64:{ *:[f64] }:$FRB)
     /* 163114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FNMADD),
     /* 163117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /* 163119 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // FRA
     /* 163123 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // FRC
     /* 163127 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // FRB
     /* 163131 */     GIR_RootConstrainSelectedInstOperands,
     /* 163132 */     // GIR_Coverage, 226,
     /* 163132 */     GIR_EraseRootFromParent_Done,
     /* 163133 */   // Label 2455: @163133
     /* 163133 */   GIM_Try, /*On fail goto*//*Label 2456*/ GIMT_Encode4(163170), // Rule ID 166 //
     /* 163138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 163141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 163145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 163149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 163153 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 163157 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163159 */     // (fneg:{ *:[f64] } (fabs:{ *:[f64] } f64:{ *:[f64] }:$RB))  =>  (FNABSD:{ *:[f64] } f64:{ *:[f64] }:$RB)
     /* 163159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FNABSD),
     /* 163162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 163164 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RB
     /* 163168 */     GIR_RootConstrainSelectedInstOperands,
     /* 163169 */     // GIR_Coverage, 166,
     /* 163169 */     GIR_EraseRootFromParent_Done,
     /* 163170 */   // Label 2456: @163170
     /* 163170 */   GIM_Try, /*On fail goto*//*Label 2457*/ GIMT_Encode4(163207), // Rule ID 573 //
     /* 163175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 163178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::SPERCRegClassID),
     /* 163182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 163186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 163190 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 163194 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163196 */     // (fneg:{ *:[f64] } (fabs:{ *:[f64] } f64:{ *:[f64] }:$RA))  =>  (EFDNABS:{ *:[f64] } f64:{ *:[f64] }:$RA)
     /* 163196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::EFDNABS),
     /* 163199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /* 163201 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RA
     /* 163205 */     GIR_RootConstrainSelectedInstOperands,
     /* 163206 */     // GIR_Coverage, 573,
     /* 163206 */     GIR_EraseRootFromParent_Done,
     /* 163207 */   // Label 2457: @163207
     /* 163207 */   GIM_Try, /*On fail goto*//*Label 2458*/ GIMT_Encode4(163226), // Rule ID 168 //
     /* 163212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 163215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 163219 */     // (fneg:{ *:[f64] } f64:{ *:[f64] }:$RB)  =>  (FNEGD:{ *:[f64] } f64:{ *:[f64] }:$RB)
     /* 163219 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FNEGD),
     /* 163224 */     GIR_RootConstrainSelectedInstOperands,
     /* 163225 */     // GIR_Coverage, 168,
     /* 163225 */     GIR_Done,
     /* 163226 */   // Label 2458: @163226
     /* 163226 */   GIM_Try, /*On fail goto*//*Label 2459*/ GIMT_Encode4(163245), // Rule ID 574 //
     /* 163231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 163234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::SPERCRegClassID),
     /* 163238 */     // (fneg:{ *:[f64] } f64:{ *:[f64] }:$RA)  =>  (EFDNEG:{ *:[f64] } f64:{ *:[f64] }:$RA)
     /* 163238 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFDNEG),
     /* 163243 */     GIR_RootConstrainSelectedInstOperands,
     /* 163244 */     // GIR_Coverage, 574,
     /* 163244 */     GIR_Done,
     /* 163245 */   // Label 2459: @163245
     /* 163245 */   GIM_Reject,
     /* 163246 */ // Label 2445: @163246
     /* 163246 */ GIM_Reject,
     /* 163247 */ // Label 2425: @163247
     /* 163247 */ GIM_Try, /*On fail goto*//*Label 2460*/ GIMT_Encode4(163654),
     /* 163252 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 163255 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 163259 */   GIM_Try, /*On fail goto*//*Label 2461*/ GIMT_Encode4(163328), // Rule ID 1009 //
     /* 163264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 163267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 163271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 163275 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/5,
     /* 163278 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fmaf128_round_to_odd),
     /* 163283 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 163287 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 163291 */     GIM_CheckType, /*MI*/1, /*Op*/4, /*Type*/GILLT_s128,
     /* 163295 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/4, // MIs[2]
     /* 163299 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 163303 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s128,
     /* 163307 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 163309 */     // (fneg:{ *:[f128] } (intrinsic_wo_chain:{ *:[f128] } 10458:{ *:[iPTR] }, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB, (fneg:{ *:[f128] } f128:{ *:[f128] }:$RSTi)))  =>  (XSNMSUBQPO:{ *:[f128] } f128:{ *:[f128] }:$RSTi, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 163309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNMSUBQPO),
     /* 163312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 163314 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RSTi
     /* 163318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RA
     /* 163322 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // RB
     /* 163326 */     GIR_RootConstrainSelectedInstOperands,
     /* 163327 */     // GIR_Coverage, 1009,
     /* 163327 */     GIR_EraseRootFromParent_Done,
     /* 163328 */   // Label 2461: @163328
     /* 163328 */   GIM_Try, /*On fail goto*//*Label 2462*/ GIMT_Encode4(163385), // Rule ID 1008 //
     /* 163333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 163336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 163340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 163344 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/5,
     /* 163347 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fmaf128_round_to_odd),
     /* 163352 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 163356 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 163360 */     GIM_CheckType, /*MI*/1, /*Op*/4, /*Type*/GILLT_s128,
     /* 163364 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163366 */     // (fneg:{ *:[f128] } (intrinsic_wo_chain:{ *:[f128] } 10458:{ *:[iPTR] }, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB, f128:{ *:[f128] }:$RSTi))  =>  (XSNMADDQPO:{ *:[f128] } f128:{ *:[f128] }:$RSTi, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 163366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNMADDQPO),
     /* 163369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 163371 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/4, // RSTi
     /* 163375 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RA
     /* 163379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // RB
     /* 163383 */     GIR_RootConstrainSelectedInstOperands,
     /* 163384 */     // GIR_Coverage, 1008,
     /* 163384 */     GIR_EraseRootFromParent_Done,
     /* 163385 */   // Label 2462: @163385
     /* 163385 */   GIM_Try, /*On fail goto*//*Label 2463*/ GIMT_Encode4(163446), // Rule ID 1000 //
     /* 163390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 163393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 163397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 163401 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s128,
     /* 163405 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 163409 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 163413 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 163417 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 163421 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s128,
     /* 163425 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 163427 */     // (fneg:{ *:[f128] } (fma:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB, (fneg:{ *:[f128] } f128:{ *:[f128] }:$RSTi)))  =>  (XSNMSUBQP:{ *:[f128] } f128:{ *:[f128] }:$RSTi, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 163427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNMSUBQP),
     /* 163430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 163432 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RSTi
     /* 163436 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RA
     /* 163440 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RB
     /* 163444 */     GIR_RootConstrainSelectedInstOperands,
     /* 163445 */     // GIR_Coverage, 1000,
     /* 163445 */     GIR_EraseRootFromParent_Done,
     /* 163446 */   // Label 2463: @163446
     /* 163446 */   GIM_Try, /*On fail goto*//*Label 2464*/ GIMT_Encode4(163507), // Rule ID 999 //
     /* 163451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 163454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 163458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 163462 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s128,
     /* 163466 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 163470 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 163474 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 163478 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 163482 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s128,
     /* 163486 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 163488 */     // (fneg:{ *:[f128] } (strict_fma:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB, (fneg:{ *:[f128] } f128:{ *:[f128] }:$RSTi)))  =>  (XSNMSUBQP:{ *:[f128] } f128:{ *:[f128] }:$RSTi, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 163488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNMSUBQP),
     /* 163491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 163493 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RSTi
     /* 163497 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RA
     /* 163501 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RB
     /* 163505 */     GIR_RootConstrainSelectedInstOperands,
     /* 163506 */     // GIR_Coverage, 999,
     /* 163506 */     GIR_EraseRootFromParent_Done,
     /* 163507 */   // Label 2464: @163507
     /* 163507 */   GIM_Try, /*On fail goto*//*Label 2465*/ GIMT_Encode4(163556), // Rule ID 998 //
     /* 163512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 163515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 163519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 163523 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s128,
     /* 163527 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 163531 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 163535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163537 */     // (fneg:{ *:[f128] } (fma:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB, f128:{ *:[f128] }:$RSTi))  =>  (XSNMADDQP:{ *:[f128] } f128:{ *:[f128] }:$RSTi, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 163537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNMADDQP),
     /* 163540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 163542 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // RSTi
     /* 163546 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RA
     /* 163550 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RB
     /* 163554 */     GIR_RootConstrainSelectedInstOperands,
     /* 163555 */     // GIR_Coverage, 998,
     /* 163555 */     GIR_EraseRootFromParent_Done,
     /* 163556 */   // Label 2465: @163556
     /* 163556 */   GIM_Try, /*On fail goto*//*Label 2466*/ GIMT_Encode4(163605), // Rule ID 997 //
     /* 163561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 163564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 163568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 163572 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s128,
     /* 163576 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 163580 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 163584 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163586 */     // (fneg:{ *:[f128] } (strict_fma:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB, f128:{ *:[f128] }:$RSTi))  =>  (XSNMADDQP:{ *:[f128] } f128:{ *:[f128] }:$RSTi, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 163586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNMADDQP),
     /* 163589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 163591 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // RSTi
     /* 163595 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RA
     /* 163599 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RB
     /* 163603 */     GIR_RootConstrainSelectedInstOperands,
     /* 163604 */     // GIR_Coverage, 997,
     /* 163604 */     GIR_EraseRootFromParent_Done,
     /* 163605 */   // Label 2466: @163605
     /* 163605 */   GIM_Try, /*On fail goto*//*Label 2467*/ GIMT_Encode4(163638), // Rule ID 981 //
     /* 163610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 163613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 163617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 163621 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s128,
     /* 163625 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163627 */     // (fneg:{ *:[f128] } (fabs:{ *:[f128] } f128:{ *:[f128] }:$RB))  =>  (XSNABSQP:{ *:[f128] } f128:{ *:[f128] }:$RB)
     /* 163627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNABSQP),
     /* 163630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 163632 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RB
     /* 163636 */     GIR_RootConstrainSelectedInstOperands,
     /* 163637 */     // GIR_Coverage, 981,
     /* 163637 */     GIR_EraseRootFromParent_Done,
     /* 163638 */   // Label 2467: @163638
     /* 163638 */   GIM_Try, /*On fail goto*//*Label 2468*/ GIMT_Encode4(163653), // Rule ID 982 //
     /* 163643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 163646 */     // (fneg:{ *:[f128] } f128:{ *:[f128] }:$RB)  =>  (XSNEGQP:{ *:[f128] } f128:{ *:[f128] }:$RB)
     /* 163646 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSNEGQP),
     /* 163651 */     GIR_RootConstrainSelectedInstOperands,
     /* 163652 */     // GIR_Coverage, 982,
     /* 163652 */     GIR_Done,
     /* 163653 */   // Label 2468: @163653
     /* 163653 */   GIM_Reject,
     /* 163654 */ // Label 2460: @163654
     /* 163654 */ GIM_Reject,
     /* 163655 */ // Label 2426: @163655
     /* 163655 */ GIM_Try, /*On fail goto*//*Label 2469*/ GIMT_Encode4(163940),
     /* 163660 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 163663 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 163667 */   GIM_Try, /*On fail goto*//*Label 2470*/ GIMT_Encode4(163728), // Rule ID 803 //
     /* 163672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 163675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 163679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 163683 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 163687 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 163691 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 163695 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 163699 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 163703 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 163707 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 163709 */     // (fneg:{ *:[v2f64] } (fma:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB, (fneg:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XTi)))  =>  (XVNMSUBADP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XTi, v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /* 163709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVNMSUBADP),
     /* 163712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 163714 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // XTi
     /* 163718 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /* 163722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // XB
     /* 163726 */     GIR_RootConstrainSelectedInstOperands,
     /* 163727 */     // GIR_Coverage, 803,
     /* 163727 */     GIR_EraseRootFromParent_Done,
     /* 163728 */   // Label 2470: @163728
     /* 163728 */   GIM_Try, /*On fail goto*//*Label 2471*/ GIMT_Encode4(163789), // Rule ID 802 //
     /* 163733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 163736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 163740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 163744 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 163748 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 163752 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 163756 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 163760 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 163764 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 163768 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 163770 */     // (fneg:{ *:[v2f64] } (strict_fma:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB, (fneg:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XTi)))  =>  (XVNMSUBADP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XTi, v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /* 163770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVNMSUBADP),
     /* 163773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 163775 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // XTi
     /* 163779 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /* 163783 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // XB
     /* 163787 */     GIR_RootConstrainSelectedInstOperands,
     /* 163788 */     // GIR_Coverage, 802,
     /* 163788 */     GIR_EraseRootFromParent_Done,
     /* 163789 */   // Label 2471: @163789
     /* 163789 */   GIM_Try, /*On fail goto*//*Label 2472*/ GIMT_Encode4(163838), // Rule ID 800 //
     /* 163794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 163797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 163801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 163805 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 163809 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 163813 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 163817 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163819 */     // (fneg:{ *:[v2f64] } (fma:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB, v2f64:{ *:[v2f64] }:$XTi))  =>  (XVNMADDADP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XTi, v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /* 163819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVNMADDADP),
     /* 163822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 163824 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // XTi
     /* 163828 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /* 163832 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // XB
     /* 163836 */     GIR_RootConstrainSelectedInstOperands,
     /* 163837 */     // GIR_Coverage, 800,
     /* 163837 */     GIR_EraseRootFromParent_Done,
     /* 163838 */   // Label 2472: @163838
     /* 163838 */   GIM_Try, /*On fail goto*//*Label 2473*/ GIMT_Encode4(163887), // Rule ID 799 //
     /* 163843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 163846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 163850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 163854 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 163858 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 163862 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 163866 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163868 */     // (fneg:{ *:[v2f64] } (strict_fma:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB, v2f64:{ *:[v2f64] }:$XTi))  =>  (XVNMADDADP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XTi, v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /* 163868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVNMADDADP),
     /* 163871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 163873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // XTi
     /* 163877 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /* 163881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // XB
     /* 163885 */     GIR_RootConstrainSelectedInstOperands,
     /* 163886 */     // GIR_Coverage, 799,
     /* 163886 */     GIR_EraseRootFromParent_Done,
     /* 163887 */   // Label 2473: @163887
     /* 163887 */   GIM_Try, /*On fail goto*//*Label 2474*/ GIMT_Encode4(163920), // Rule ID 848 //
     /* 163892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 163895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 163899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 163903 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 163907 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163909 */     // (fneg:{ *:[v2f64] } (fabs:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB))  =>  (XVNABSDP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB)
     /* 163909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVNABSDP),
     /* 163912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 163914 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XB
     /* 163918 */     GIR_RootConstrainSelectedInstOperands,
     /* 163919 */     // GIR_Coverage, 848,
     /* 163919 */     GIR_EraseRootFromParent_Done,
     /* 163920 */   // Label 2474: @163920
     /* 163920 */   GIM_Try, /*On fail goto*//*Label 2475*/ GIMT_Encode4(163939), // Rule ID 850 //
     /* 163925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 163928 */     // (fneg:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB)  =>  (XVNEGDP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB)
     /* 163928 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVNEGDP),
     /* 163933 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 163937 */     GIR_RootConstrainSelectedInstOperands,
     /* 163938 */     // GIR_Coverage, 850,
     /* 163938 */     GIR_Done,
     /* 163939 */   // Label 2475: @163939
     /* 163939 */   GIM_Reject,
     /* 163940 */ // Label 2469: @163940
     /* 163940 */ GIM_Reject,
     /* 163941 */ // Label 2427: @163941
     /* 163941 */ GIM_Try, /*On fail goto*//*Label 2476*/ GIMT_Encode4(164258),
     /* 163946 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 163949 */   GIM_Try, /*On fail goto*//*Label 2477*/ GIMT_Encode4(164014), // Rule ID 805 //
     /* 163954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 163957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 163961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 163965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 163969 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 163973 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 163977 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 163981 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 163985 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 163989 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 163993 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 163995 */     // (fneg:{ *:[v4f32] } (fma:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB, (fneg:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XTi)))  =>  (XVNMSUBASP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XTi, v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /* 163995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVNMSUBASP),
     /* 163998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 164000 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // XTi
     /* 164004 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /* 164008 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // XB
     /* 164012 */     GIR_RootConstrainSelectedInstOperands,
     /* 164013 */     // GIR_Coverage, 805,
     /* 164013 */     GIR_EraseRootFromParent_Done,
     /* 164014 */   // Label 2477: @164014
     /* 164014 */   GIM_Try, /*On fail goto*//*Label 2478*/ GIMT_Encode4(164079), // Rule ID 804 //
     /* 164019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 164022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 164026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 164030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 164034 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 164038 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 164042 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 164046 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 164050 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 164054 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 164058 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 164060 */     // (fneg:{ *:[v4f32] } (strict_fma:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB, (fneg:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XTi)))  =>  (XVNMSUBASP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XTi, v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /* 164060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVNMSUBASP),
     /* 164063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 164065 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // XTi
     /* 164069 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /* 164073 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // XB
     /* 164077 */     GIR_RootConstrainSelectedInstOperands,
     /* 164078 */     // GIR_Coverage, 804,
     /* 164078 */     GIR_EraseRootFromParent_Done,
     /* 164079 */   // Label 2478: @164079
     /* 164079 */   GIM_Try, /*On fail goto*//*Label 2479*/ GIMT_Encode4(164132), // Rule ID 801 //
     /* 164084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 164087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 164091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 164095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 164099 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 164103 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 164107 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 164111 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164113 */     // (fneg:{ *:[v4f32] } (fma:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB, v4f32:{ *:[v4f32] }:$XTi))  =>  (XVNMADDASP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XTi, v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /* 164113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVNMADDASP),
     /* 164116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 164118 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // XTi
     /* 164122 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /* 164126 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // XB
     /* 164130 */     GIR_RootConstrainSelectedInstOperands,
     /* 164131 */     // GIR_Coverage, 801,
     /* 164131 */     GIR_EraseRootFromParent_Done,
     /* 164132 */   // Label 2479: @164132
     /* 164132 */   GIM_Try, /*On fail goto*//*Label 2480*/ GIMT_Encode4(164169), // Rule ID 849 //
     /* 164137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 164140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 164144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 164148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 164152 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 164156 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164158 */     // (fneg:{ *:[v4f32] } (fabs:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB))  =>  (XVNABSSP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB)
     /* 164158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVNABSSP),
     /* 164161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 164163 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XB
     /* 164167 */     GIR_RootConstrainSelectedInstOperands,
     /* 164168 */     // GIR_Coverage, 849,
     /* 164168 */     GIR_EraseRootFromParent_Done,
     /* 164169 */   // Label 2480: @164169
     /* 164169 */   GIM_Try, /*On fail goto*//*Label 2481*/ GIMT_Encode4(164192), // Rule ID 851 //
     /* 164174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 164177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 164181 */     // (fneg:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB)  =>  (XVNEGSP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB)
     /* 164181 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVNEGSP),
     /* 164186 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 164190 */     GIR_RootConstrainSelectedInstOperands,
     /* 164191 */     // GIR_Coverage, 851,
     /* 164191 */     GIR_Done,
     /* 164192 */   // Label 2481: @164192
     /* 164192 */   GIM_Try, /*On fail goto*//*Label 2482*/ GIMT_Encode4(164257), // Rule ID 293 //
     /* 164197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 164200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 164204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 164208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 164212 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 164216 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 164220 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 164224 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 164228 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 164232 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 164236 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 164238 */     // (fneg:{ *:[v4f32] } (fma:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$RA, v4f32:{ *:[v4f32] }:$RC, (fneg:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$RB)))  =>  (VNMSUBFP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$RA, v4f32:{ *:[v4f32] }:$RC, v4f32:{ *:[v4f32] }:$RB)
     /* 164238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VNMSUBFP),
     /* 164241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /* 164243 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RA
     /* 164247 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RC
     /* 164251 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RB
     /* 164255 */     GIR_RootConstrainSelectedInstOperands,
     /* 164256 */     // GIR_Coverage, 293,
     /* 164256 */     GIR_EraseRootFromParent_Done,
     /* 164257 */   // Label 2482: @164257
     /* 164257 */   GIM_Reject,
     /* 164258 */ // Label 2476: @164258
     /* 164258 */ GIM_Reject,
     /* 164259 */ // Label 2428: @164259
     /* 164259 */ GIM_Reject,
     /* 164260 */ // Label 46: @164260
     /* 164260 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2485*/ GIMT_Encode4(164423),
     /* 164271 */ /*GILLT_s64*//*Label 2483*/ GIMT_Encode4(164279),
     /* 164275 */ /*GILLT_s128*//*Label 2484*/ GIMT_Encode4(164354),
     /* 164279 */ // Label 2483: @164279
     /* 164279 */ GIM_Try, /*On fail goto*//*Label 2486*/ GIMT_Encode4(164353),
     /* 164284 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 164287 */   GIM_Try, /*On fail goto*//*Label 2487*/ GIMT_Encode4(164310), // Rule ID 1903 //
     /* 164292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 164295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 164299 */     // (fpextend:{ *:[f64] } f32:{ *:[f32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$src, VSFRC:{ *:[i32] })
     /* 164299 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 164304 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 164309 */     // GIR_Coverage, 1903,
     /* 164309 */     GIR_Done,
     /* 164310 */   // Label 2487: @164310
     /* 164310 */   GIM_Try, /*On fail goto*//*Label 2488*/ GIMT_Encode4(164329), // Rule ID 560 //
     /* 164315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 164318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::SPERCRegClassID),
     /* 164322 */     // (fpextend:{ *:[f64] } f32:{ *:[f32] }:$RB)  =>  (EFDCFS:{ *:[f64] } f32:{ *:[f32] }:$RB)
     /* 164322 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFDCFS),
     /* 164327 */     GIR_RootConstrainSelectedInstOperands,
     /* 164328 */     // GIR_Coverage, 560,
     /* 164328 */     GIR_Done,
     /* 164329 */   // Label 2488: @164329
     /* 164329 */   GIM_Try, /*On fail goto*//*Label 2489*/ GIMT_Encode4(164352), // Rule ID 1263 //
     /* 164334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 164337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 164341 */     // (fpextend:{ *:[f64] } f32:{ *:[f32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$src, F8RC:{ *:[i32] })
     /* 164341 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 164346 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::F8RCRegClassID),
     /* 164351 */     // GIR_Coverage, 1263,
     /* 164351 */     GIR_Done,
     /* 164352 */   // Label 2489: @164352
     /* 164352 */   GIM_Reject,
     /* 164353 */ // Label 2486: @164353
     /* 164353 */ GIM_Reject,
     /* 164354 */ // Label 2484: @164354
     /* 164354 */ GIM_Try, /*On fail goto*//*Label 2490*/ GIMT_Encode4(164376), // Rule ID 1011 //
     /* 164359 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 164362 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 164365 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 164369 */   // (fpextend:{ *:[f128] } f64:{ *:[f64] }:$RB)  =>  (XSCVDPQP:{ *:[f128] } f64:{ *:[f64] }:$RB)
     /* 164369 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSCVDPQP),
     /* 164374 */   GIR_RootConstrainSelectedInstOperands,
     /* 164375 */   // GIR_Coverage, 1011,
     /* 164375 */   GIR_Done,
     /* 164376 */ // Label 2490: @164376
     /* 164376 */ GIM_Try, /*On fail goto*//*Label 2491*/ GIMT_Encode4(164422), // Rule ID 2255 //
     /* 164381 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 164384 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 164387 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 164391 */   // (fpextend:{ *:[f128] } f32:{ *:[f32] }:$src)  =>  (XSCVDPQP:{ *:[f128] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$src, VFRC:{ *:[i32] }))
     /* 164391 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 164394 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 164398 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 164403 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 164407 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VFRCRegClassID),
     /* 164412 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSCVDPQP),
     /* 164415 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 164417 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 164420 */   GIR_RootConstrainSelectedInstOperands,
     /* 164421 */   // GIR_Coverage, 2255,
     /* 164421 */   GIR_EraseRootFromParent_Done,
     /* 164422 */ // Label 2491: @164422
     /* 164422 */ GIM_Reject,
     /* 164423 */ // Label 2485: @164423
     /* 164423 */ GIM_Reject,
     /* 164424 */ // Label 47: @164424
     /* 164424 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 2494*/ GIMT_Encode4(164580),
     /* 164435 */ /*GILLT_s32*//*Label 2492*/ GIMT_Encode4(164443),
     /* 164439 */ /*GILLT_s64*//*Label 2493*/ GIMT_Encode4(164557),
     /* 164443 */ // Label 2492: @164443
     /* 164443 */ GIM_Try, /*On fail goto*//*Label 2495*/ GIMT_Encode4(164465), // Rule ID 958 //
     /* 164448 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 164451 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 164454 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 164458 */   // (fpround:{ *:[f32] } f64:{ *:[f64] }:$XB)  =>  (XSRSP:{ *:[f32] } f64:{ *:[f64] }:$XB)
     /* 164458 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSRSP),
     /* 164463 */   GIR_RootConstrainSelectedInstOperands,
     /* 164464 */   // GIR_Coverage, 958,
     /* 164464 */   GIR_Done,
     /* 164465 */ // Label 2495: @164465
     /* 164465 */ GIM_Try, /*On fail goto*//*Label 2496*/ GIMT_Encode4(164508), // Rule ID 2253 //
     /* 164470 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 164473 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 164476 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 164480 */   // (fpround:{ *:[f32] } f128:{ *:[f128] }:$src)  =>  (XSRSP:{ *:[f32] } (XSCVQPDPO:{ *:[f64] } ?:{ *:[f128] }:$src))
     /* 164480 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 164483 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSCVQPDPO),
     /* 164487 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 164492 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 164496 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 164498 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSRSP),
     /* 164501 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 164503 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 164506 */   GIR_RootConstrainSelectedInstOperands,
     /* 164507 */   // GIR_Coverage, 2253,
     /* 164507 */   GIR_EraseRootFromParent_Done,
     /* 164508 */ // Label 2496: @164508
     /* 164508 */ GIM_Try, /*On fail goto*//*Label 2497*/ GIMT_Encode4(164534), // Rule ID 158 //
     /* 164513 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 164516 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 164519 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 164523 */   // (fpround:{ *:[f32] } f64:{ *:[f64] }:$RB)  =>  (FRSP:{ *:[f32] } f64:{ *:[f64] }:$RB)
     /* 164523 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FRSP),
     /* 164528 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 164532 */   GIR_RootConstrainSelectedInstOperands,
     /* 164533 */   // GIR_Coverage, 158,
     /* 164533 */   GIR_Done,
     /* 164534 */ // Label 2497: @164534
     /* 164534 */ GIM_Try, /*On fail goto*//*Label 2498*/ GIMT_Encode4(164556), // Rule ID 581 //
     /* 164539 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 164542 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 164545 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 164549 */   // (fpround:{ *:[f32] } f64:{ *:[f64] }:$RB)  =>  (EFSCFD:{ *:[f32] } f64:{ *:[f64] }:$RB)
     /* 164549 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFSCFD),
     /* 164554 */   GIR_RootConstrainSelectedInstOperands,
     /* 164555 */   // GIR_Coverage, 581,
     /* 164555 */   GIR_Done,
     /* 164556 */ // Label 2498: @164556
     /* 164556 */ GIM_Reject,
     /* 164557 */ // Label 2493: @164557
     /* 164557 */ GIM_Try, /*On fail goto*//*Label 2499*/ GIMT_Encode4(164579), // Rule ID 2251 //
     /* 164562 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 164565 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 164568 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VFRCRegClassID),
     /* 164572 */   // (fpround:{ *:[f64] } f128:{ *:[f128] }:$src)  =>  (XSCVQPDP:{ *:[f64] } ?:{ *:[f128] }:$src)
     /* 164572 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSCVQPDP),
     /* 164577 */   GIR_RootConstrainSelectedInstOperands,
     /* 164578 */   // GIR_Coverage, 2251,
     /* 164578 */   GIR_Done,
     /* 164579 */ // Label 2499: @164579
     /* 164579 */ GIM_Reject,
     /* 164580 */ // Label 2494: @164580
     /* 164580 */ GIM_Reject,
     /* 164581 */ // Label 48: @164581
     /* 164581 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2504*/ GIMT_Encode4(164843),
     /* 164592 */ /*GILLT_s32*//*Label 2500*/ GIMT_Encode4(164612),
     /* 164596 */ /*GILLT_s64*//*Label 2501*/ GIMT_Encode4(164720), GIMT_Encode4(0),
     /* 164604 */ /*GILLT_v2s64*//*Label 2502*/ GIMT_Encode4(164764),
     /* 164608 */ /*GILLT_v4s32*//*Label 2503*/ GIMT_Encode4(164791),
     /* 164612 */ // Label 2500: @164612
     /* 164612 */ GIM_Try, /*On fail goto*//*Label 2505*/ GIMT_Encode4(164675), // Rule ID 2241 //
     /* 164617 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 164620 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 164623 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 164627 */   // (fp_to_sint:{ *:[i32] } f128:{ *:[f128] }:$src)  =>  (MFVSRWZ:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[f64] } (XSCVQPSWZ:{ *:[f128] } ?:{ *:[f128] }:$src), VFRC:{ *:[i32] }))
     /* 164627 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 164630 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCVQPSWZ),
     /* 164634 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 164639 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 164643 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 164645 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 164648 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 164652 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 164657 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 164660 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VFRCRegClassID),
     /* 164665 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFVSRWZ),
     /* 164668 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 164670 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 164673 */   GIR_RootConstrainSelectedInstOperands,
     /* 164674 */   // GIR_Coverage, 2241,
     /* 164674 */   GIR_EraseRootFromParent_Done,
     /* 164675 */ // Label 2505: @164675
     /* 164675 */ GIM_Try, /*On fail goto*//*Label 2506*/ GIMT_Encode4(164697), // Rule ID 566 //
     /* 164680 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 164683 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 164686 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 164690 */   // (fp_to_sint:{ *:[i32] } f64:{ *:[f64] }:$RB)  =>  (EFDCTSIZ:{ *:[i32] } f64:{ *:[f64] }:$RB)
     /* 164690 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFDCTSIZ),
     /* 164695 */   GIR_RootConstrainSelectedInstOperands,
     /* 164696 */   // GIR_Coverage, 566,
     /* 164696 */   GIR_Done,
     /* 164697 */ // Label 2506: @164697
     /* 164697 */ GIM_Try, /*On fail goto*//*Label 2507*/ GIMT_Encode4(164719), // Rule ID 587 //
     /* 164702 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 164705 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 164708 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 164712 */   // (fp_to_sint:{ *:[i32] } f32:{ *:[f32] }:$RB)  =>  (EFSCTSIZ:{ *:[i32] } f32:{ *:[f32] }:$RB)
     /* 164712 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFSCTSIZ),
     /* 164717 */   GIR_RootConstrainSelectedInstOperands,
     /* 164718 */   // GIR_Coverage, 587,
     /* 164718 */   GIR_Done,
     /* 164719 */ // Label 2507: @164719
     /* 164719 */ GIM_Reject,
     /* 164720 */ // Label 2501: @164720
     /* 164720 */ GIM_Try, /*On fail goto*//*Label 2508*/ GIMT_Encode4(164763), // Rule ID 2237 //
     /* 164725 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 164728 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 164731 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 164735 */   // (fp_to_sint:{ *:[i64] } f128:{ *:[f128] }:$src)  =>  (MFVRD:{ *:[i64] } (XSCVQPSDZ:{ *:[v4i32] } ?:{ *:[f128] }:$src))
     /* 164735 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 164738 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSCVQPSDZ),
     /* 164742 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 164747 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 164751 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 164753 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFVRD),
     /* 164756 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 164758 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 164761 */   GIR_RootConstrainSelectedInstOperands,
     /* 164762 */   // GIR_Coverage, 2237,
     /* 164762 */   GIR_EraseRootFromParent_Done,
     /* 164763 */ // Label 2508: @164763
     /* 164763 */ GIM_Reject,
     /* 164764 */ // Label 2502: @164764
     /* 164764 */ GIM_Try, /*On fail goto*//*Label 2509*/ GIMT_Encode4(164790), // Rule ID 874 //
     /* 164769 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 164772 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 164775 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 164779 */   // (fp_to_sint:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$XB)  =>  (XVCVDPSXDS:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$XB)
     /* 164779 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVCVDPSXDS),
     /* 164784 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 164788 */   GIR_RootConstrainSelectedInstOperands,
     /* 164789 */   // GIR_Coverage, 874,
     /* 164789 */   GIR_Done,
     /* 164790 */ // Label 2509: @164790
     /* 164790 */ GIM_Reject,
     /* 164791 */ // Label 2503: @164791
     /* 164791 */ GIM_Try, /*On fail goto*//*Label 2510*/ GIMT_Encode4(164842),
     /* 164796 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 164799 */   GIM_Try, /*On fail goto*//*Label 2511*/ GIMT_Encode4(164822), // Rule ID 882 //
     /* 164804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 164807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 164811 */     // (fp_to_sint:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$XB)  =>  (XVCVSPSXWS:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$XB)
     /* 164811 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVCVSPSXWS),
     /* 164816 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 164820 */     GIR_RootConstrainSelectedInstOperands,
     /* 164821 */     // GIR_Coverage, 882,
     /* 164821 */     GIR_Done,
     /* 164822 */   // Label 2511: @164822
     /* 164822 */   GIM_Try, /*On fail goto*//*Label 2512*/ GIMT_Encode4(164841), // Rule ID 1409 //
     /* 164827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 164830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 164834 */     // (fp_to_sint:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$vA)  =>  (VCTSXS_0:{ *:[v4i32] } ?:{ *:[v4f32] }:$vA)
     /* 164834 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VCTSXS_0),
     /* 164839 */     GIR_RootConstrainSelectedInstOperands,
     /* 164840 */     // GIR_Coverage, 1409,
     /* 164840 */     GIR_Done,
     /* 164841 */   // Label 2512: @164841
     /* 164841 */   GIM_Reject,
     /* 164842 */ // Label 2510: @164842
     /* 164842 */ GIM_Reject,
     /* 164843 */ // Label 2504: @164843
     /* 164843 */ GIM_Reject,
     /* 164844 */ // Label 49: @164844
     /* 164844 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2517*/ GIMT_Encode4(165106),
     /* 164855 */ /*GILLT_s32*//*Label 2513*/ GIMT_Encode4(164875),
     /* 164859 */ /*GILLT_s64*//*Label 2514*/ GIMT_Encode4(164983), GIMT_Encode4(0),
     /* 164867 */ /*GILLT_v2s64*//*Label 2515*/ GIMT_Encode4(165027),
     /* 164871 */ /*GILLT_v4s32*//*Label 2516*/ GIMT_Encode4(165054),
     /* 164875 */ // Label 2513: @164875
     /* 164875 */ GIM_Try, /*On fail goto*//*Label 2518*/ GIMT_Encode4(164938), // Rule ID 2243 //
     /* 164880 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 164883 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 164886 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 164890 */   // (fp_to_uint:{ *:[i32] } f128:{ *:[f128] }:$src)  =>  (MFVSRWZ:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[f64] } (XSCVQPUWZ:{ *:[f128] } ?:{ *:[f128] }:$src), VFRC:{ *:[i32] }))
     /* 164890 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 164893 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCVQPUWZ),
     /* 164897 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 164902 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 164906 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 164908 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 164911 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 164915 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 164920 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 164923 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VFRCRegClassID),
     /* 164928 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFVSRWZ),
     /* 164931 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 164933 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 164936 */   GIR_RootConstrainSelectedInstOperands,
     /* 164937 */   // GIR_Coverage, 2243,
     /* 164937 */   GIR_EraseRootFromParent_Done,
     /* 164938 */ // Label 2518: @164938
     /* 164938 */ GIM_Try, /*On fail goto*//*Label 2519*/ GIMT_Encode4(164960), // Rule ID 568 //
     /* 164943 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 164946 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 164949 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 164953 */   // (fp_to_uint:{ *:[i32] } f64:{ *:[f64] }:$RB)  =>  (EFDCTUIZ:{ *:[i32] } f64:{ *:[f64] }:$RB)
     /* 164953 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFDCTUIZ),
     /* 164958 */   GIR_RootConstrainSelectedInstOperands,
     /* 164959 */   // GIR_Coverage, 568,
     /* 164959 */   GIR_Done,
     /* 164960 */ // Label 2519: @164960
     /* 164960 */ GIM_Try, /*On fail goto*//*Label 2520*/ GIMT_Encode4(164982), // Rule ID 589 //
     /* 164965 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 164968 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 164971 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 164975 */   // (fp_to_uint:{ *:[i32] } f32:{ *:[f32] }:$RB)  =>  (EFSCTUIZ:{ *:[i32] } f32:{ *:[f32] }:$RB)
     /* 164975 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFSCTUIZ),
     /* 164980 */   GIR_RootConstrainSelectedInstOperands,
     /* 164981 */   // GIR_Coverage, 589,
     /* 164981 */   GIR_Done,
     /* 164982 */ // Label 2520: @164982
     /* 164982 */ GIM_Reject,
     /* 164983 */ // Label 2514: @164983
     /* 164983 */ GIM_Try, /*On fail goto*//*Label 2521*/ GIMT_Encode4(165026), // Rule ID 2239 //
     /* 164988 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 164991 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 164994 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 164998 */   // (fp_to_uint:{ *:[i64] } f128:{ *:[f128] }:$src)  =>  (MFVRD:{ *:[i64] } (XSCVQPUDZ:{ *:[v4i32] } ?:{ *:[f128] }:$src))
     /* 164998 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 165001 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSCVQPUDZ),
     /* 165005 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 165010 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 165014 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 165016 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFVRD),
     /* 165019 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 165021 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 165024 */   GIR_RootConstrainSelectedInstOperands,
     /* 165025 */   // GIR_Coverage, 2239,
     /* 165025 */   GIR_EraseRootFromParent_Done,
     /* 165026 */ // Label 2521: @165026
     /* 165026 */ GIM_Reject,
     /* 165027 */ // Label 2515: @165027
     /* 165027 */ GIM_Try, /*On fail goto*//*Label 2522*/ GIMT_Encode4(165053), // Rule ID 877 //
     /* 165032 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 165035 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 165038 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 165042 */   // (fp_to_uint:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$XB)  =>  (XVCVDPUXDS:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$XB)
     /* 165042 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVCVDPUXDS),
     /* 165047 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 165051 */   GIR_RootConstrainSelectedInstOperands,
     /* 165052 */   // GIR_Coverage, 877,
     /* 165052 */   GIR_Done,
     /* 165053 */ // Label 2522: @165053
     /* 165053 */ GIM_Reject,
     /* 165054 */ // Label 2516: @165054
     /* 165054 */ GIM_Try, /*On fail goto*//*Label 2523*/ GIMT_Encode4(165105),
     /* 165059 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 165062 */   GIM_Try, /*On fail goto*//*Label 2524*/ GIMT_Encode4(165085), // Rule ID 885 //
     /* 165067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 165070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 165074 */     // (fp_to_uint:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$XB)  =>  (XVCVSPUXWS:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$XB)
     /* 165074 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVCVSPUXWS),
     /* 165079 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 165083 */     GIR_RootConstrainSelectedInstOperands,
     /* 165084 */     // GIR_Coverage, 885,
     /* 165084 */     GIR_Done,
     /* 165085 */   // Label 2524: @165085
     /* 165085 */   GIM_Try, /*On fail goto*//*Label 2525*/ GIMT_Encode4(165104), // Rule ID 1410 //
     /* 165090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 165093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 165097 */     // (fp_to_uint:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$vA)  =>  (VCTUXS_0:{ *:[v4i32] } ?:{ *:[v4f32] }:$vA)
     /* 165097 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VCTUXS_0),
     /* 165102 */     GIR_RootConstrainSelectedInstOperands,
     /* 165103 */     // GIR_Coverage, 1410,
     /* 165103 */     GIR_Done,
     /* 165104 */   // Label 2525: @165104
     /* 165104 */   GIM_Reject,
     /* 165105 */ // Label 2523: @165105
     /* 165105 */ GIM_Reject,
     /* 165106 */ // Label 2517: @165106
     /* 165106 */ GIM_Reject,
     /* 165107 */ // Label 50: @165107
     /* 165107 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2531*/ GIMT_Encode4(165353),
     /* 165118 */ /*GILLT_s32*//*Label 2526*/ GIMT_Encode4(165138),
     /* 165122 */ /*GILLT_s64*//*Label 2527*/ GIMT_Encode4(165161),
     /* 165126 */ /*GILLT_s128*//*Label 2528*/ GIMT_Encode4(165184),
     /* 165130 */ /*GILLT_v2s64*//*Label 2529*/ GIMT_Encode4(165274),
     /* 165134 */ /*GILLT_v4s32*//*Label 2530*/ GIMT_Encode4(165301),
     /* 165138 */ // Label 2526: @165138
     /* 165138 */ GIM_Try, /*On fail goto*//*Label 2532*/ GIMT_Encode4(165160), // Rule ID 583 //
     /* 165143 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 165146 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 165149 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 165153 */   // (sint_to_fp:{ *:[f32] } i32:{ *:[i32] }:$RB)  =>  (EFSCFSI:{ *:[f32] } i32:{ *:[i32] }:$RB)
     /* 165153 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFSCFSI),
     /* 165158 */   GIR_RootConstrainSelectedInstOperands,
     /* 165159 */   // GIR_Coverage, 583,
     /* 165159 */   GIR_Done,
     /* 165160 */ // Label 2532: @165160
     /* 165160 */ GIM_Reject,
     /* 165161 */ // Label 2527: @165161
     /* 165161 */ GIM_Try, /*On fail goto*//*Label 2533*/ GIMT_Encode4(165183), // Rule ID 562 //
     /* 165166 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 165169 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 165172 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::SPERCRegClassID),
     /* 165176 */   // (sint_to_fp:{ *:[f64] } i32:{ *:[i32] }:$RB)  =>  (EFDCFSI:{ *:[f64] } i32:{ *:[i32] }:$RB)
     /* 165176 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFDCFSI),
     /* 165181 */   GIR_RootConstrainSelectedInstOperands,
     /* 165182 */   // GIR_Coverage, 562,
     /* 165182 */   GIR_Done,
     /* 165183 */ // Label 2533: @165183
     /* 165183 */ GIM_Reject,
     /* 165184 */ // Label 2528: @165184
     /* 165184 */ GIM_Try, /*On fail goto*//*Label 2534*/ GIMT_Encode4(165230), // Rule ID 2134 //
     /* 165189 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 165192 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 165195 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 165199 */   // (sint_to_fp:{ *:[f128] } i64:{ *:[i64] }:$src)  =>  (XSCVSDQP:{ *:[f128] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[i64] }:$src, VFRC:{ *:[i32] }))
     /* 165199 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 165202 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 165206 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 165211 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 165215 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VFRCRegClassID),
     /* 165220 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSCVSDQP),
     /* 165223 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 165225 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 165228 */   GIR_RootConstrainSelectedInstOperands,
     /* 165229 */   // GIR_Coverage, 2134,
     /* 165229 */   GIR_EraseRootFromParent_Done,
     /* 165230 */ // Label 2534: @165230
     /* 165230 */ GIM_Try, /*On fail goto*//*Label 2535*/ GIMT_Encode4(165273), // Rule ID 2144 //
     /* 165235 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 165238 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 165241 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 165245 */   // (sint_to_fp:{ *:[f128] } i32:{ *:[i32] }:$src)  =>  (XSCVSDQP:{ *:[f128] } (MTVSRWA:{ *:[f64] } ?:{ *:[i32] }:$src))
     /* 165245 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 165248 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::MTVSRWA),
     /* 165252 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 165257 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 165261 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 165263 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSCVSDQP),
     /* 165266 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 165268 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 165271 */   GIR_RootConstrainSelectedInstOperands,
     /* 165272 */   // GIR_Coverage, 2144,
     /* 165272 */   GIR_EraseRootFromParent_Done,
     /* 165273 */ // Label 2535: @165273
     /* 165273 */ GIM_Reject,
     /* 165274 */ // Label 2529: @165274
     /* 165274 */ GIM_Try, /*On fail goto*//*Label 2536*/ GIMT_Encode4(165300), // Rule ID 887 //
     /* 165279 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 165282 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 165285 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 165289 */   // (sint_to_fp:{ *:[v2f64] } v2i64:{ *:[v2i64] }:$XB)  =>  (XVCVSXDDP:{ *:[v2f64] } v2i64:{ *:[v2i64] }:$XB)
     /* 165289 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVCVSXDDP),
     /* 165294 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 165298 */   GIR_RootConstrainSelectedInstOperands,
     /* 165299 */   // GIR_Coverage, 887,
     /* 165299 */   GIR_Done,
     /* 165300 */ // Label 2536: @165300
     /* 165300 */ GIM_Reject,
     /* 165301 */ // Label 2530: @165301
     /* 165301 */ GIM_Try, /*On fail goto*//*Label 2537*/ GIMT_Encode4(165352),
     /* 165306 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 165309 */   GIM_Try, /*On fail goto*//*Label 2538*/ GIMT_Encode4(165332), // Rule ID 890 //
     /* 165314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 165317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 165321 */     // (sint_to_fp:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$XB)  =>  (XVCVSXWSP:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$XB)
     /* 165321 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVCVSXWSP),
     /* 165326 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 165330 */     GIR_RootConstrainSelectedInstOperands,
     /* 165331 */     // GIR_Coverage, 890,
     /* 165331 */     GIR_Done,
     /* 165332 */   // Label 2538: @165332
     /* 165332 */   GIM_Try, /*On fail goto*//*Label 2539*/ GIMT_Encode4(165351), // Rule ID 1411 //
     /* 165337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 165340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 165344 */     // (sint_to_fp:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$vA)  =>  (VCFSX_0:{ *:[v4f32] } ?:{ *:[v4i32] }:$vA)
     /* 165344 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VCFSX_0),
     /* 165349 */     GIR_RootConstrainSelectedInstOperands,
     /* 165350 */     // GIR_Coverage, 1411,
     /* 165350 */     GIR_Done,
     /* 165351 */   // Label 2539: @165351
     /* 165351 */   GIM_Reject,
     /* 165352 */ // Label 2537: @165352
     /* 165352 */ GIM_Reject,
     /* 165353 */ // Label 2531: @165353
     /* 165353 */ GIM_Reject,
     /* 165354 */ // Label 51: @165354
     /* 165354 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2545*/ GIMT_Encode4(165600),
     /* 165365 */ /*GILLT_s32*//*Label 2540*/ GIMT_Encode4(165385),
     /* 165369 */ /*GILLT_s64*//*Label 2541*/ GIMT_Encode4(165408),
     /* 165373 */ /*GILLT_s128*//*Label 2542*/ GIMT_Encode4(165431),
     /* 165377 */ /*GILLT_v2s64*//*Label 2543*/ GIMT_Encode4(165521),
     /* 165381 */ /*GILLT_v4s32*//*Label 2544*/ GIMT_Encode4(165548),
     /* 165385 */ // Label 2540: @165385
     /* 165385 */ GIM_Try, /*On fail goto*//*Label 2546*/ GIMT_Encode4(165407), // Rule ID 585 //
     /* 165390 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 165393 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 165396 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 165400 */   // (uint_to_fp:{ *:[f32] } i32:{ *:[i32] }:$RB)  =>  (EFSCFUI:{ *:[f32] } i32:{ *:[i32] }:$RB)
     /* 165400 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFSCFUI),
     /* 165405 */   GIR_RootConstrainSelectedInstOperands,
     /* 165406 */   // GIR_Coverage, 585,
     /* 165406 */   GIR_Done,
     /* 165407 */ // Label 2546: @165407
     /* 165407 */ GIM_Reject,
     /* 165408 */ // Label 2541: @165408
     /* 165408 */ GIM_Try, /*On fail goto*//*Label 2547*/ GIMT_Encode4(165430), // Rule ID 564 //
     /* 165413 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 165416 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 165419 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::SPERCRegClassID),
     /* 165423 */   // (uint_to_fp:{ *:[f64] } i32:{ *:[i32] }:$RB)  =>  (EFDCFUI:{ *:[f64] } i32:{ *:[i32] }:$RB)
     /* 165423 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFDCFUI),
     /* 165428 */   GIR_RootConstrainSelectedInstOperands,
     /* 165429 */   // GIR_Coverage, 564,
     /* 165429 */   GIR_Done,
     /* 165430 */ // Label 2547: @165430
     /* 165430 */ GIM_Reject,
     /* 165431 */ // Label 2542: @165431
     /* 165431 */ GIM_Try, /*On fail goto*//*Label 2548*/ GIMT_Encode4(165477), // Rule ID 2140 //
     /* 165436 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 165439 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 165442 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 165446 */   // (uint_to_fp:{ *:[f128] } i64:{ *:[i64] }:$src)  =>  (XSCVUDQP:{ *:[f128] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[i64] }:$src, VFRC:{ *:[i32] }))
     /* 165446 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 165449 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 165453 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 165458 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 165462 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VFRCRegClassID),
     /* 165467 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSCVUDQP),
     /* 165470 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 165472 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 165475 */   GIR_RootConstrainSelectedInstOperands,
     /* 165476 */   // GIR_Coverage, 2140,
     /* 165476 */   GIR_EraseRootFromParent_Done,
     /* 165477 */ // Label 2548: @165477
     /* 165477 */ GIM_Try, /*On fail goto*//*Label 2549*/ GIMT_Encode4(165520), // Rule ID 2148 //
     /* 165482 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 165485 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 165488 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 165492 */   // (uint_to_fp:{ *:[f128] } i32:{ *:[i32] }:$src)  =>  (XSCVUDQP:{ *:[f128] } (MTVSRWZ:{ *:[f64] } ?:{ *:[i32] }:$src))
     /* 165492 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 165495 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::MTVSRWZ),
     /* 165499 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 165504 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 165508 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 165510 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSCVUDQP),
     /* 165513 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 165515 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 165518 */   GIR_RootConstrainSelectedInstOperands,
     /* 165519 */   // GIR_Coverage, 2148,
     /* 165519 */   GIR_EraseRootFromParent_Done,
     /* 165520 */ // Label 2549: @165520
     /* 165520 */ GIM_Reject,
     /* 165521 */ // Label 2543: @165521
     /* 165521 */ GIM_Try, /*On fail goto*//*Label 2550*/ GIMT_Encode4(165547), // Rule ID 892 //
     /* 165526 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 165529 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 165532 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 165536 */   // (uint_to_fp:{ *:[v2f64] } v2i64:{ *:[v2i64] }:$XB)  =>  (XVCVUXDDP:{ *:[v2f64] } v2i64:{ *:[v2i64] }:$XB)
     /* 165536 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVCVUXDDP),
     /* 165541 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 165545 */   GIR_RootConstrainSelectedInstOperands,
     /* 165546 */   // GIR_Coverage, 892,
     /* 165546 */   GIR_Done,
     /* 165547 */ // Label 2550: @165547
     /* 165547 */ GIM_Reject,
     /* 165548 */ // Label 2544: @165548
     /* 165548 */ GIM_Try, /*On fail goto*//*Label 2551*/ GIMT_Encode4(165599),
     /* 165553 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 165556 */   GIM_Try, /*On fail goto*//*Label 2552*/ GIMT_Encode4(165579), // Rule ID 895 //
     /* 165561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 165564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 165568 */     // (uint_to_fp:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$XB)  =>  (XVCVUXWSP:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$XB)
     /* 165568 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVCVUXWSP),
     /* 165573 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 165577 */     GIR_RootConstrainSelectedInstOperands,
     /* 165578 */     // GIR_Coverage, 895,
     /* 165578 */     GIR_Done,
     /* 165579 */   // Label 2552: @165579
     /* 165579 */   GIM_Try, /*On fail goto*//*Label 2553*/ GIMT_Encode4(165598), // Rule ID 1412 //
     /* 165584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 165587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 165591 */     // (uint_to_fp:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$vA)  =>  (VCFUX_0:{ *:[v4f32] } ?:{ *:[v4i32] }:$vA)
     /* 165591 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VCFUX_0),
     /* 165596 */     GIR_RootConstrainSelectedInstOperands,
     /* 165597 */     // GIR_Coverage, 1412,
     /* 165597 */     GIR_Done,
     /* 165598 */   // Label 2553: @165598
     /* 165598 */   GIM_Reject,
     /* 165599 */ // Label 2551: @165599
     /* 165599 */ GIM_Reject,
     /* 165600 */ // Label 2545: @165600
     /* 165600 */ GIM_Reject,
     /* 165601 */ // Label 52: @165601
     /* 165601 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2559*/ GIMT_Encode4(165892),
     /* 165612 */ /*GILLT_s32*//*Label 2554*/ GIMT_Encode4(165632),
     /* 165616 */ /*GILLT_s64*//*Label 2555*/ GIMT_Encode4(165744),
     /* 165620 */ /*GILLT_s128*//*Label 2556*/ GIMT_Encode4(165815),
     /* 165624 */ /*GILLT_v2s64*//*Label 2557*/ GIMT_Encode4(165838),
     /* 165628 */ /*GILLT_v4s32*//*Label 2558*/ GIMT_Encode4(165865),
     /* 165632 */ // Label 2554: @165632
     /* 165632 */ GIM_Try, /*On fail goto*//*Label 2560*/ GIMT_Encode4(165743),
     /* 165637 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 165640 */   GIM_Try, /*On fail goto*//*Label 2561*/ GIMT_Encode4(165704), // Rule ID 1677 //
     /* 165645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 165648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 165652 */     // (fabs:{ *:[f32] } f32:{ *:[f32] }:$S)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (XSABSDP:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$S, VSFRC:{ *:[i32] })), VSSRC:{ *:[i32] })
     /* 165652 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 165655 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 165659 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 165664 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // S
     /* 165668 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 165673 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 165676 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSABSDP),
     /* 165680 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 165685 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 165688 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 165690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 165693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 165695 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 165698 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 165703 */     // GIR_Coverage, 1677,
     /* 165703 */     GIR_EraseRootFromParent_Done,
     /* 165704 */   // Label 2561: @165704
     /* 165704 */   GIM_Try, /*On fail goto*//*Label 2562*/ GIMT_Encode4(165723), // Rule ID 163 //
     /* 165709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 165712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 165716 */     // (fabs:{ *:[f32] } f32:{ *:[f32] }:$RB)  =>  (FABSS:{ *:[f32] } f32:{ *:[f32] }:$RB)
     /* 165716 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FABSS),
     /* 165721 */     GIR_RootConstrainSelectedInstOperands,
     /* 165722 */     // GIR_Coverage, 163,
     /* 165722 */     GIR_Done,
     /* 165723 */   // Label 2562: @165723
     /* 165723 */   GIM_Try, /*On fail goto*//*Label 2563*/ GIMT_Encode4(165742), // Rule ID 577 //
     /* 165728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 165731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 165735 */     // (fabs:{ *:[f32] } f32:{ *:[f32] }:$RA)  =>  (EFSABS:{ *:[f32] } f32:{ *:[f32] }:$RA)
     /* 165735 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFSABS),
     /* 165740 */     GIR_RootConstrainSelectedInstOperands,
     /* 165741 */     // GIR_Coverage, 577,
     /* 165741 */     GIR_Done,
     /* 165742 */   // Label 2563: @165742
     /* 165742 */   GIM_Reject,
     /* 165743 */ // Label 2560: @165743
     /* 165743 */ GIM_Reject,
     /* 165744 */ // Label 2555: @165744
     /* 165744 */ GIM_Try, /*On fail goto*//*Label 2564*/ GIMT_Encode4(165814),
     /* 165749 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 165752 */   GIM_Try, /*On fail goto*//*Label 2565*/ GIMT_Encode4(165775), // Rule ID 839 //
     /* 165757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 165760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 165764 */     // (fabs:{ *:[f64] } f64:{ *:[f64] }:$XB)  =>  (XSABSDP:{ *:[f64] } f64:{ *:[f64] }:$XB)
     /* 165764 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSABSDP),
     /* 165769 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 165773 */     GIR_RootConstrainSelectedInstOperands,
     /* 165774 */     // GIR_Coverage, 839,
     /* 165774 */     GIR_Done,
     /* 165775 */   // Label 2565: @165775
     /* 165775 */   GIM_Try, /*On fail goto*//*Label 2566*/ GIMT_Encode4(165794), // Rule ID 164 //
     /* 165780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 165783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 165787 */     // (fabs:{ *:[f64] } f64:{ *:[f64] }:$RB)  =>  (FABSD:{ *:[f64] } f64:{ *:[f64] }:$RB)
     /* 165787 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FABSD),
     /* 165792 */     GIR_RootConstrainSelectedInstOperands,
     /* 165793 */     // GIR_Coverage, 164,
     /* 165793 */     GIR_Done,
     /* 165794 */   // Label 2566: @165794
     /* 165794 */   GIM_Try, /*On fail goto*//*Label 2567*/ GIMT_Encode4(165813), // Rule ID 556 //
     /* 165799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 165802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::SPERCRegClassID),
     /* 165806 */     // (fabs:{ *:[f64] } f64:{ *:[f64] }:$RA)  =>  (EFDABS:{ *:[f64] } f64:{ *:[f64] }:$RA)
     /* 165806 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFDABS),
     /* 165811 */     GIR_RootConstrainSelectedInstOperands,
     /* 165812 */     // GIR_Coverage, 556,
     /* 165812 */     GIR_Done,
     /* 165813 */   // Label 2567: @165813
     /* 165813 */   GIM_Reject,
     /* 165814 */ // Label 2564: @165814
     /* 165814 */ GIM_Reject,
     /* 165815 */ // Label 2556: @165815
     /* 165815 */ GIM_Try, /*On fail goto*//*Label 2568*/ GIMT_Encode4(165837), // Rule ID 980 //
     /* 165820 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 165823 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 165826 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 165830 */   // (fabs:{ *:[f128] } f128:{ *:[f128] }:$RB)  =>  (XSABSQP:{ *:[f128] } f128:{ *:[f128] }:$RB)
     /* 165830 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSABSQP),
     /* 165835 */   GIR_RootConstrainSelectedInstOperands,
     /* 165836 */   // GIR_Coverage, 980,
     /* 165836 */   GIR_Done,
     /* 165837 */ // Label 2568: @165837
     /* 165837 */ GIM_Reject,
     /* 165838 */ // Label 2557: @165838
     /* 165838 */ GIM_Try, /*On fail goto*//*Label 2569*/ GIMT_Encode4(165864), // Rule ID 844 //
     /* 165843 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 165846 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 165849 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 165853 */   // (fabs:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB)  =>  (XVABSDP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB)
     /* 165853 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVABSDP),
     /* 165858 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 165862 */   GIR_RootConstrainSelectedInstOperands,
     /* 165863 */   // GIR_Coverage, 844,
     /* 165863 */   GIR_Done,
     /* 165864 */ // Label 2569: @165864
     /* 165864 */ GIM_Reject,
     /* 165865 */ // Label 2558: @165865
     /* 165865 */ GIM_Try, /*On fail goto*//*Label 2570*/ GIMT_Encode4(165891), // Rule ID 845 //
     /* 165870 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 165873 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 165876 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 165880 */   // (fabs:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB)  =>  (XVABSSP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB)
     /* 165880 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVABSSP),
     /* 165885 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 165889 */   GIR_RootConstrainSelectedInstOperands,
     /* 165890 */   // GIR_Coverage, 845,
     /* 165890 */   GIR_Done,
     /* 165891 */ // Label 2570: @165891
     /* 165891 */ GIM_Reject,
     /* 165892 */ // Label 2559: @165892
     /* 165892 */ GIM_Reject,
     /* 165893 */ // Label 53: @165893
     /* 165893 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2576*/ GIMT_Encode4(166208),
     /* 165904 */ /*GILLT_s32*//*Label 2571*/ GIMT_Encode4(165924),
     /* 165908 */ /*GILLT_s64*//*Label 2572*/ GIMT_Encode4(166008),
     /* 165912 */ /*GILLT_s128*//*Label 2573*/ GIMT_Encode4(166118),
     /* 165916 */ /*GILLT_v2s64*//*Label 2574*/ GIMT_Encode4(166148),
     /* 165920 */ /*GILLT_v4s32*//*Label 2575*/ GIMT_Encode4(166178),
     /* 165924 */ // Label 2571: @165924
     /* 165924 */ GIM_Try, /*On fail goto*//*Label 2577*/ GIMT_Encode4(166007),
     /* 165929 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 165932 */   GIM_Try, /*On fail goto*//*Label 2578*/ GIMT_Encode4(165958), // Rule ID 169 //
     /* 165937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 165940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 165943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 165947 */     // (fcopysign:{ *:[f32] } f32:{ *:[f32] }:$RB, f32:{ *:[f32] }:$RA)  =>  (FCPSGNS:{ *:[f32] } f32:{ *:[f32] }:$RA, f32:{ *:[f32] }:$RB)
     /* 165947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FCPSGNS),
     /* 165950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 165952 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /* 165954 */     GIR_RootToRootCopy, /*OpIdx*/1, // RB
     /* 165956 */     GIR_RootConstrainSelectedInstOperands,
     /* 165957 */     // GIR_Coverage, 169,
     /* 165957 */     GIR_EraseRootFromParent_Done,
     /* 165958 */   // Label 2578: @165958
     /* 165958 */   GIM_Try, /*On fail goto*//*Label 2579*/ GIMT_Encode4(166006), // Rule ID 1275 //
     /* 165963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 165966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 165969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 165973 */     // (fcopysign:{ *:[f32] } f32:{ *:[f32] }:$frB, f64:{ *:[f64] }:$frA)  =>  (FCPSGNS:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[f32] } ?:{ *:[f64] }:$frA, F4RC:{ *:[i32] }), ?:{ *:[f32] }:$frB)
     /* 165973 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 165976 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 165980 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 165985 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // frA
     /* 165989 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::F4RCRegClassID),
     /* 165994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FCPSGNS),
     /* 165997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 165999 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 166002 */     GIR_RootToRootCopy, /*OpIdx*/1, // frB
     /* 166004 */     GIR_RootConstrainSelectedInstOperands,
     /* 166005 */     // GIR_Coverage, 1275,
     /* 166005 */     GIR_EraseRootFromParent_Done,
     /* 166006 */   // Label 2579: @166006
     /* 166006 */   GIM_Reject,
     /* 166007 */ // Label 2577: @166007
     /* 166007 */ GIM_Reject,
     /* 166008 */ // Label 2572: @166008
     /* 166008 */ GIM_Try, /*On fail goto*//*Label 2580*/ GIMT_Encode4(166117),
     /* 166013 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 166016 */   GIM_Try, /*On fail goto*//*Label 2581*/ GIMT_Encode4(166042), // Rule ID 843 //
     /* 166021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 166024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 166027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 166031 */     // (fcopysign:{ *:[f64] } f64:{ *:[f64] }:$XB, f64:{ *:[f64] }:$XA)  =>  (XSCPSGNDP:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)
     /* 166031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSCPSGNDP),
     /* 166034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 166036 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /* 166038 */     GIR_RootToRootCopy, /*OpIdx*/1, // XB
     /* 166040 */     GIR_RootConstrainSelectedInstOperands,
     /* 166041 */     // GIR_Coverage, 843,
     /* 166041 */     GIR_EraseRootFromParent_Done,
     /* 166042 */   // Label 2581: @166042
     /* 166042 */   GIM_Try, /*On fail goto*//*Label 2582*/ GIMT_Encode4(166068), // Rule ID 170 //
     /* 166047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 166050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 166053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 166057 */     // (fcopysign:{ *:[f64] } f64:{ *:[f64] }:$RB, f64:{ *:[f64] }:$RA)  =>  (FCPSGND:{ *:[f64] } f64:{ *:[f64] }:$RA, f64:{ *:[f64] }:$RB)
     /* 166057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FCPSGND),
     /* 166060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 166062 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /* 166064 */     GIR_RootToRootCopy, /*OpIdx*/1, // RB
     /* 166066 */     GIR_RootConstrainSelectedInstOperands,
     /* 166067 */     // GIR_Coverage, 170,
     /* 166067 */     GIR_EraseRootFromParent_Done,
     /* 166068 */   // Label 2582: @166068
     /* 166068 */   GIM_Try, /*On fail goto*//*Label 2583*/ GIMT_Encode4(166116), // Rule ID 1274 //
     /* 166073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 166076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 166079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 166083 */     // (fcopysign:{ *:[f64] } f64:{ *:[f64] }:$frB, f32:{ *:[f32] }:$frA)  =>  (FCPSGND:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$frA, F8RC:{ *:[i32] }), ?:{ *:[f64] }:$frB)
     /* 166083 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 166086 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 166090 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 166095 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // frA
     /* 166099 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::F8RCRegClassID),
     /* 166104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FCPSGND),
     /* 166107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 166109 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 166112 */     GIR_RootToRootCopy, /*OpIdx*/1, // frB
     /* 166114 */     GIR_RootConstrainSelectedInstOperands,
     /* 166115 */     // GIR_Coverage, 1274,
     /* 166115 */     GIR_EraseRootFromParent_Done,
     /* 166116 */   // Label 2583: @166116
     /* 166116 */   GIM_Reject,
     /* 166117 */ // Label 2580: @166117
     /* 166117 */ GIM_Reject,
     /* 166118 */ // Label 2573: @166118
     /* 166118 */ GIM_Try, /*On fail goto*//*Label 2584*/ GIMT_Encode4(166147), // Rule ID 979 //
     /* 166123 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 166126 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 166129 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /* 166132 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 166136 */   // (fcopysign:{ *:[f128] } f128:{ *:[f128] }:$RB, f128:{ *:[f128] }:$RA)  =>  (XSCPSGNQP:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 166136 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSCPSGNQP),
     /* 166139 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 166141 */   GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /* 166143 */   GIR_RootToRootCopy, /*OpIdx*/1, // RB
     /* 166145 */   GIR_RootConstrainSelectedInstOperands,
     /* 166146 */   // GIR_Coverage, 979,
     /* 166146 */   GIR_EraseRootFromParent_Done,
     /* 166147 */ // Label 2584: @166147
     /* 166147 */ GIM_Reject,
     /* 166148 */ // Label 2574: @166148
     /* 166148 */ GIM_Try, /*On fail goto*//*Label 2585*/ GIMT_Encode4(166177), // Rule ID 846 //
     /* 166153 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 166156 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 166159 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 166162 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 166166 */   // (fcopysign:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB, v2f64:{ *:[v2f64] }:$XA)  =>  (XVCPSGNDP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /* 166166 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCPSGNDP),
     /* 166169 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 166171 */   GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /* 166173 */   GIR_RootToRootCopy, /*OpIdx*/1, // XB
     /* 166175 */   GIR_RootConstrainSelectedInstOperands,
     /* 166176 */   // GIR_Coverage, 846,
     /* 166176 */   GIR_EraseRootFromParent_Done,
     /* 166177 */ // Label 2585: @166177
     /* 166177 */ GIM_Reject,
     /* 166178 */ // Label 2575: @166178
     /* 166178 */ GIM_Try, /*On fail goto*//*Label 2586*/ GIMT_Encode4(166207), // Rule ID 847 //
     /* 166183 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 166186 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 166189 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 166192 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 166196 */   // (fcopysign:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB, v4f32:{ *:[v4f32] }:$XA)  =>  (XVCPSGNSP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /* 166196 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCPSGNSP),
     /* 166199 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 166201 */   GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /* 166203 */   GIR_RootToRootCopy, /*OpIdx*/1, // XB
     /* 166205 */   GIR_RootConstrainSelectedInstOperands,
     /* 166206 */   // GIR_Coverage, 847,
     /* 166206 */   GIR_EraseRootFromParent_Done,
     /* 166207 */ // Label 2586: @166207
     /* 166207 */ GIM_Reject,
     /* 166208 */ // Label 2576: @166208
     /* 166208 */ GIM_Reject,
     /* 166209 */ // Label 54: @166209
     /* 166209 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(6), /*)*//*default:*//*Label 2589*/ GIMT_Encode4(166288),
     /* 166220 */ /*GILLT_v2s64*//*Label 2587*/ GIMT_Encode4(166228),
     /* 166224 */ /*GILLT_v4s32*//*Label 2588*/ GIMT_Encode4(166258),
     /* 166228 */ // Label 2587: @166228
     /* 166228 */ GIM_Try, /*On fail goto*//*Label 2590*/ GIMT_Encode4(166257), // Rule ID 1676 //
     /* 166233 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 166236 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 166239 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 166242 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 166246 */   // (fminnum:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$src1, v2f64:{ *:[v2f64] }:$src2)  =>  (XVMINDP:{ *:[v2f64] } ?:{ *:[v2f64] }:$src1, ?:{ *:[v2f64] }:$src2)
     /* 166246 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVMINDP),
     /* 166251 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 166255 */   GIR_RootConstrainSelectedInstOperands,
     /* 166256 */   // GIR_Coverage, 1676,
     /* 166256 */   GIR_Done,
     /* 166257 */ // Label 2590: @166257
     /* 166257 */ GIM_Reject,
     /* 166258 */ // Label 2588: @166258
     /* 166258 */ GIM_Try, /*On fail goto*//*Label 2591*/ GIMT_Encode4(166287), // Rule ID 1672 //
     /* 166263 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 166266 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 166269 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 166272 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 166276 */   // (fminnum:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$src1, v4f32:{ *:[v4f32] }:$src2)  =>  (XVMINSP:{ *:[v4f32] } ?:{ *:[v4f32] }:$src1, ?:{ *:[v4f32] }:$src2)
     /* 166276 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVMINSP),
     /* 166281 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 166285 */   GIR_RootConstrainSelectedInstOperands,
     /* 166286 */   // GIR_Coverage, 1672,
     /* 166286 */   GIR_Done,
     /* 166287 */ // Label 2591: @166287
     /* 166287 */ GIM_Reject,
     /* 166288 */ // Label 2589: @166288
     /* 166288 */ GIM_Reject,
     /* 166289 */ // Label 55: @166289
     /* 166289 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(6), /*)*//*default:*//*Label 2594*/ GIMT_Encode4(166368),
     /* 166300 */ /*GILLT_v2s64*//*Label 2592*/ GIMT_Encode4(166308),
     /* 166304 */ /*GILLT_v4s32*//*Label 2593*/ GIMT_Encode4(166338),
     /* 166308 */ // Label 2592: @166308
     /* 166308 */ GIM_Try, /*On fail goto*//*Label 2595*/ GIMT_Encode4(166337), // Rule ID 1674 //
     /* 166313 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 166316 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 166319 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 166322 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 166326 */   // (fmaxnum:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$src1, v2f64:{ *:[v2f64] }:$src2)  =>  (XVMAXDP:{ *:[v2f64] } ?:{ *:[v2f64] }:$src1, ?:{ *:[v2f64] }:$src2)
     /* 166326 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVMAXDP),
     /* 166331 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 166335 */   GIR_RootConstrainSelectedInstOperands,
     /* 166336 */   // GIR_Coverage, 1674,
     /* 166336 */   GIR_Done,
     /* 166337 */ // Label 2595: @166337
     /* 166337 */ GIM_Reject,
     /* 166338 */ // Label 2593: @166338
     /* 166338 */ GIM_Try, /*On fail goto*//*Label 2596*/ GIMT_Encode4(166367), // Rule ID 1670 //
     /* 166343 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 166346 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 166349 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 166352 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 166356 */   // (fmaxnum:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$src1, v4f32:{ *:[v4f32] }:$src2)  =>  (XVMAXSP:{ *:[v4f32] } ?:{ *:[v4f32] }:$src1, ?:{ *:[v4f32] }:$src2)
     /* 166356 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVMAXSP),
     /* 166361 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 166365 */   GIR_RootConstrainSelectedInstOperands,
     /* 166366 */   // GIR_Coverage, 1670,
     /* 166366 */   GIR_Done,
     /* 166367 */ // Label 2596: @166367
     /* 166367 */ GIM_Reject,
     /* 166368 */ // Label 2594: @166368
     /* 166368 */ GIM_Reject,
     /* 166369 */ // Label 56: @166369
     /* 166369 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 2599*/ GIMT_Encode4(166950),
     /* 166380 */ /*GILLT_s32*//*Label 2597*/ GIMT_Encode4(166388),
     /* 166384 */ /*GILLT_s64*//*Label 2598*/ GIMT_Encode4(166795),
     /* 166388 */ // Label 2597: @166388
     /* 166388 */ GIM_Try, /*On fail goto*//*Label 2600*/ GIMT_Encode4(166794),
     /* 166393 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 166396 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 166399 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 166403 */   GIM_Try, /*On fail goto*//*Label 2601*/ GIMT_Encode4(166513), // Rule ID 1682 //
     /* 166408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 166411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 166415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 166419 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 166423 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 166427 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 166431 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 166435 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 166437 */     // (fminnum_ieee:{ *:[f32] } (fcanonicalize:{ *:[f32] } f32:{ *:[f32] }:$A), (fcanonicalize:{ *:[f32] } f32:{ *:[f32] }:$B))  =>  (COPY_TO_REGCLASS:{ *:[f32] } (XSMINDP:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$A, VSFRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$B, VSFRC:{ *:[i32] })), VSSRC:{ *:[i32] })
     /* 166437 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 166440 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 166444 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 166449 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, // B
     /* 166453 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 166458 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 166461 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 166465 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 166470 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // A
     /* 166474 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 166479 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 166482 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSMINDP),
     /* 166486 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 166491 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 166494 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 166497 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 166499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 166502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166504 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 166507 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 166512 */     // GIR_Coverage, 1682,
     /* 166512 */     GIR_EraseRootFromParent_Done,
     /* 166513 */   // Label 2601: @166513
     /* 166513 */   GIM_Try, /*On fail goto*//*Label 2602*/ GIMT_Encode4(166611), // Rule ID 1680 //
     /* 166518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 166521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 166525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 166529 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 166533 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166535 */     // (fminnum_ieee:{ *:[f32] } (fcanonicalize:{ *:[f32] } f32:{ *:[f32] }:$A), f32:{ *:[f32] }:$B)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (XSMINDP:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$A, VSFRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$B, VSFRC:{ *:[i32] })), VSSRC:{ *:[i32] })
     /* 166535 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 166538 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 166542 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 166547 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // B
     /* 166551 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 166556 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 166559 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 166563 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 166568 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // A
     /* 166572 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 166577 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 166580 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSMINDP),
     /* 166584 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 166589 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 166592 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 166595 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 166597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 166600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166602 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 166605 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 166610 */     // GIR_Coverage, 1680,
     /* 166610 */     GIR_EraseRootFromParent_Done,
     /* 166611 */   // Label 2602: @166611
     /* 166611 */   GIM_Try, /*On fail goto*//*Label 2603*/ GIMT_Encode4(166709), // Rule ID 1681 //
     /* 166616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 166619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 166623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 166627 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 166631 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166633 */     // (fminnum_ieee:{ *:[f32] } f32:{ *:[f32] }:$A, (fcanonicalize:{ *:[f32] } f32:{ *:[f32] }:$B))  =>  (COPY_TO_REGCLASS:{ *:[f32] } (XSMINDP:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$A, VSFRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$B, VSFRC:{ *:[i32] })), VSSRC:{ *:[i32] })
     /* 166633 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 166636 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 166640 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 166645 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // B
     /* 166649 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 166654 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 166657 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 166661 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 166666 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 166670 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 166675 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 166678 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSMINDP),
     /* 166682 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 166687 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 166690 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 166693 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 166695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 166698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166700 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 166703 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 166708 */     // GIR_Coverage, 1681,
     /* 166708 */     GIR_EraseRootFromParent_Done,
     /* 166709 */   // Label 2603: @166709
     /* 166709 */   GIM_Try, /*On fail goto*//*Label 2604*/ GIMT_Encode4(166793), // Rule ID 1679 //
     /* 166714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 166717 */     // (fminnum_ieee:{ *:[f32] } f32:{ *:[f32] }:$A, f32:{ *:[f32] }:$B)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (XSMINDP:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$A, VSFRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$B, VSFRC:{ *:[i32] })), VSSRC:{ *:[i32] })
     /* 166717 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 166720 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 166724 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 166729 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // B
     /* 166733 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 166738 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 166741 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 166745 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 166750 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 166754 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 166759 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 166762 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSMINDP),
     /* 166766 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 166771 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 166774 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 166777 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 166779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 166782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166784 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 166787 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 166792 */     // GIR_Coverage, 1679,
     /* 166792 */     GIR_EraseRootFromParent_Done,
     /* 166793 */   // Label 2604: @166793
     /* 166793 */   GIM_Reject,
     /* 166794 */ // Label 2600: @166794
     /* 166794 */ GIM_Reject,
     /* 166795 */ // Label 2598: @166795
     /* 166795 */ GIM_Try, /*On fail goto*//*Label 2605*/ GIMT_Encode4(166949),
     /* 166800 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 166803 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 166806 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 166810 */   GIM_Try, /*On fail goto*//*Label 2606*/ GIMT_Encode4(166859), // Rule ID 1690 //
     /* 166815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 166818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 166822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 166826 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 166830 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 166834 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 166838 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 166842 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 166844 */     // (fminnum_ieee:{ *:[f64] } (fcanonicalize:{ *:[f64] } f64:{ *:[f64] }:$A), (fcanonicalize:{ *:[f64] } f64:{ *:[f64] }:$B))  =>  (XSMINDP:{ *:[f64] } ?:{ *:[f64] }:$A, ?:{ *:[f64] }:$B)
     /* 166844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMINDP),
     /* 166847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 166849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // A
     /* 166853 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // B
     /* 166857 */     GIR_RootConstrainSelectedInstOperands,
     /* 166858 */     // GIR_Coverage, 1690,
     /* 166858 */     GIR_EraseRootFromParent_Done,
     /* 166859 */   // Label 2606: @166859
     /* 166859 */   GIM_Try, /*On fail goto*//*Label 2607*/ GIMT_Encode4(166894), // Rule ID 1688 //
     /* 166864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 166867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 166871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 166875 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 166879 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166881 */     // (fminnum_ieee:{ *:[f64] } (fcanonicalize:{ *:[f64] } f64:{ *:[f64] }:$A), f64:{ *:[f64] }:$B)  =>  (XSMINDP:{ *:[f64] } ?:{ *:[f64] }:$A, ?:{ *:[f64] }:$B)
     /* 166881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMINDP),
     /* 166884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 166886 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // A
     /* 166890 */     GIR_RootToRootCopy, /*OpIdx*/2, // B
     /* 166892 */     GIR_RootConstrainSelectedInstOperands,
     /* 166893 */     // GIR_Coverage, 1688,
     /* 166893 */     GIR_EraseRootFromParent_Done,
     /* 166894 */   // Label 2607: @166894
     /* 166894 */   GIM_Try, /*On fail goto*//*Label 2608*/ GIMT_Encode4(166929), // Rule ID 1689 //
     /* 166899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 166902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 166906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 166910 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 166914 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166916 */     // (fminnum_ieee:{ *:[f64] } f64:{ *:[f64] }:$A, (fcanonicalize:{ *:[f64] } f64:{ *:[f64] }:$B))  =>  (XSMINDP:{ *:[f64] } ?:{ *:[f64] }:$A, ?:{ *:[f64] }:$B)
     /* 166916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMINDP),
     /* 166919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 166921 */     GIR_RootToRootCopy, /*OpIdx*/1, // A
     /* 166923 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // B
     /* 166927 */     GIR_RootConstrainSelectedInstOperands,
     /* 166928 */     // GIR_Coverage, 1689,
     /* 166928 */     GIR_EraseRootFromParent_Done,
     /* 166929 */   // Label 2608: @166929
     /* 166929 */   GIM_Try, /*On fail goto*//*Label 2609*/ GIMT_Encode4(166948), // Rule ID 1687 //
     /* 166934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 166937 */     // (fminnum_ieee:{ *:[f64] } f64:{ *:[f64] }:$A, f64:{ *:[f64] }:$B)  =>  (XSMINDP:{ *:[f64] } ?:{ *:[f64] }:$A, ?:{ *:[f64] }:$B)
     /* 166937 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSMINDP),
     /* 166942 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 166946 */     GIR_RootConstrainSelectedInstOperands,
     /* 166947 */     // GIR_Coverage, 1687,
     /* 166947 */     GIR_Done,
     /* 166948 */   // Label 2609: @166948
     /* 166948 */   GIM_Reject,
     /* 166949 */ // Label 2605: @166949
     /* 166949 */ GIM_Reject,
     /* 166950 */ // Label 2599: @166950
     /* 166950 */ GIM_Reject,
     /* 166951 */ // Label 57: @166951
     /* 166951 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 2612*/ GIMT_Encode4(167532),
     /* 166962 */ /*GILLT_s32*//*Label 2610*/ GIMT_Encode4(166970),
     /* 166966 */ /*GILLT_s64*//*Label 2611*/ GIMT_Encode4(167377),
     /* 166970 */ // Label 2610: @166970
     /* 166970 */ GIM_Try, /*On fail goto*//*Label 2613*/ GIMT_Encode4(167376),
     /* 166975 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 166978 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 166981 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 166985 */   GIM_Try, /*On fail goto*//*Label 2614*/ GIMT_Encode4(167095), // Rule ID 1686 //
     /* 166990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 166993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 166997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 167001 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 167005 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 167009 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 167013 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 167017 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 167019 */     // (fmaxnum_ieee:{ *:[f32] } (fcanonicalize:{ *:[f32] } f32:{ *:[f32] }:$A), (fcanonicalize:{ *:[f32] } f32:{ *:[f32] }:$B))  =>  (COPY_TO_REGCLASS:{ *:[f32] } (XSMAXDP:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$A, VSFRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$B, VSFRC:{ *:[i32] })), VSSRC:{ *:[i32] })
     /* 167019 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 167022 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 167026 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 167031 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, // B
     /* 167035 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 167040 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 167043 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 167047 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 167052 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // A
     /* 167056 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 167061 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 167064 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSMAXDP),
     /* 167068 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 167073 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 167076 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 167079 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 167081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 167084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167086 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 167089 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 167094 */     // GIR_Coverage, 1686,
     /* 167094 */     GIR_EraseRootFromParent_Done,
     /* 167095 */   // Label 2614: @167095
     /* 167095 */   GIM_Try, /*On fail goto*//*Label 2615*/ GIMT_Encode4(167193), // Rule ID 1684 //
     /* 167100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 167103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 167107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 167111 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 167115 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167117 */     // (fmaxnum_ieee:{ *:[f32] } (fcanonicalize:{ *:[f32] } f32:{ *:[f32] }:$A), f32:{ *:[f32] }:$B)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (XSMAXDP:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$A, VSFRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$B, VSFRC:{ *:[i32] })), VSSRC:{ *:[i32] })
     /* 167117 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 167120 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 167124 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 167129 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // B
     /* 167133 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 167138 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 167141 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 167145 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 167150 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // A
     /* 167154 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 167159 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 167162 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSMAXDP),
     /* 167166 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 167171 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 167174 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 167177 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 167179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 167182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167184 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 167187 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 167192 */     // GIR_Coverage, 1684,
     /* 167192 */     GIR_EraseRootFromParent_Done,
     /* 167193 */   // Label 2615: @167193
     /* 167193 */   GIM_Try, /*On fail goto*//*Label 2616*/ GIMT_Encode4(167291), // Rule ID 1685 //
     /* 167198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 167201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 167205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 167209 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 167213 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167215 */     // (fmaxnum_ieee:{ *:[f32] } f32:{ *:[f32] }:$A, (fcanonicalize:{ *:[f32] } f32:{ *:[f32] }:$B))  =>  (COPY_TO_REGCLASS:{ *:[f32] } (XSMAXDP:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$A, VSFRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$B, VSFRC:{ *:[i32] })), VSSRC:{ *:[i32] })
     /* 167215 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 167218 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 167222 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 167227 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // B
     /* 167231 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 167236 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 167239 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 167243 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 167248 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 167252 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 167257 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 167260 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSMAXDP),
     /* 167264 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 167269 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 167272 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 167275 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 167277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 167280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167282 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 167285 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 167290 */     // GIR_Coverage, 1685,
     /* 167290 */     GIR_EraseRootFromParent_Done,
     /* 167291 */   // Label 2616: @167291
     /* 167291 */   GIM_Try, /*On fail goto*//*Label 2617*/ GIMT_Encode4(167375), // Rule ID 1683 //
     /* 167296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 167299 */     // (fmaxnum_ieee:{ *:[f32] } f32:{ *:[f32] }:$A, f32:{ *:[f32] }:$B)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (XSMAXDP:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$A, VSFRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$B, VSFRC:{ *:[i32] })), VSSRC:{ *:[i32] })
     /* 167299 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 167302 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 167306 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 167311 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // B
     /* 167315 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 167320 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 167323 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 167327 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 167332 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 167336 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 167341 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 167344 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSMAXDP),
     /* 167348 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 167353 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 167356 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 167359 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 167361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 167364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167366 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 167369 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 167374 */     // GIR_Coverage, 1683,
     /* 167374 */     GIR_EraseRootFromParent_Done,
     /* 167375 */   // Label 2617: @167375
     /* 167375 */   GIM_Reject,
     /* 167376 */ // Label 2613: @167376
     /* 167376 */ GIM_Reject,
     /* 167377 */ // Label 2611: @167377
     /* 167377 */ GIM_Try, /*On fail goto*//*Label 2618*/ GIMT_Encode4(167531),
     /* 167382 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 167385 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 167388 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 167392 */   GIM_Try, /*On fail goto*//*Label 2619*/ GIMT_Encode4(167441), // Rule ID 1694 //
     /* 167397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 167400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 167404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 167408 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 167412 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 167416 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 167420 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 167424 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 167426 */     // (fmaxnum_ieee:{ *:[f64] } (fcanonicalize:{ *:[f64] } f64:{ *:[f64] }:$A), (fcanonicalize:{ *:[f64] } f64:{ *:[f64] }:$B))  =>  (XSMAXDP:{ *:[f64] } ?:{ *:[f64] }:$A, ?:{ *:[f64] }:$B)
     /* 167426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMAXDP),
     /* 167429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 167431 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // A
     /* 167435 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // B
     /* 167439 */     GIR_RootConstrainSelectedInstOperands,
     /* 167440 */     // GIR_Coverage, 1694,
     /* 167440 */     GIR_EraseRootFromParent_Done,
     /* 167441 */   // Label 2619: @167441
     /* 167441 */   GIM_Try, /*On fail goto*//*Label 2620*/ GIMT_Encode4(167476), // Rule ID 1692 //
     /* 167446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 167449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 167453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 167457 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 167461 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167463 */     // (fmaxnum_ieee:{ *:[f64] } (fcanonicalize:{ *:[f64] } f64:{ *:[f64] }:$A), f64:{ *:[f64] }:$B)  =>  (XSMAXDP:{ *:[f64] } ?:{ *:[f64] }:$A, ?:{ *:[f64] }:$B)
     /* 167463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMAXDP),
     /* 167466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 167468 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // A
     /* 167472 */     GIR_RootToRootCopy, /*OpIdx*/2, // B
     /* 167474 */     GIR_RootConstrainSelectedInstOperands,
     /* 167475 */     // GIR_Coverage, 1692,
     /* 167475 */     GIR_EraseRootFromParent_Done,
     /* 167476 */   // Label 2620: @167476
     /* 167476 */   GIM_Try, /*On fail goto*//*Label 2621*/ GIMT_Encode4(167511), // Rule ID 1693 //
     /* 167481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 167484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 167488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 167492 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 167496 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167498 */     // (fmaxnum_ieee:{ *:[f64] } f64:{ *:[f64] }:$A, (fcanonicalize:{ *:[f64] } f64:{ *:[f64] }:$B))  =>  (XSMAXDP:{ *:[f64] } ?:{ *:[f64] }:$A, ?:{ *:[f64] }:$B)
     /* 167498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMAXDP),
     /* 167501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 167503 */     GIR_RootToRootCopy, /*OpIdx*/1, // A
     /* 167505 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // B
     /* 167509 */     GIR_RootConstrainSelectedInstOperands,
     /* 167510 */     // GIR_Coverage, 1693,
     /* 167510 */     GIR_EraseRootFromParent_Done,
     /* 167511 */   // Label 2621: @167511
     /* 167511 */   GIM_Try, /*On fail goto*//*Label 2622*/ GIMT_Encode4(167530), // Rule ID 1691 //
     /* 167516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 167519 */     // (fmaxnum_ieee:{ *:[f64] } f64:{ *:[f64] }:$A, f64:{ *:[f64] }:$B)  =>  (XSMAXDP:{ *:[f64] } ?:{ *:[f64] }:$A, ?:{ *:[f64] }:$B)
     /* 167519 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSMAXDP),
     /* 167524 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 167528 */     GIR_RootConstrainSelectedInstOperands,
     /* 167529 */     // GIR_Coverage, 1691,
     /* 167529 */     GIR_Done,
     /* 167530 */   // Label 2622: @167530
     /* 167530 */   GIM_Reject,
     /* 167531 */ // Label 2618: @167531
     /* 167531 */ GIM_Reject,
     /* 167532 */ // Label 2612: @167532
     /* 167532 */ GIM_Reject,
     /* 167533 */ // Label 58: @167533
     /* 167533 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(8), /*)*//*default:*//*Label 2627*/ GIMT_Encode4(167712),
     /* 167544 */ /*GILLT_v2s64*//*Label 2623*/ GIMT_Encode4(167560),
     /* 167548 */ /*GILLT_v4s32*//*Label 2624*/ GIMT_Encode4(167634),
     /* 167552 */ /*GILLT_v8s16*//*Label 2625*/ GIMT_Encode4(167660),
     /* 167556 */ /*GILLT_v16s8*//*Label 2626*/ GIMT_Encode4(167686),
     /* 167560 */ // Label 2623: @167560
     /* 167560 */ GIM_Try, /*On fail goto*//*Label 2628*/ GIMT_Encode4(167633), // Rule ID 1926 //
     /* 167565 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 167568 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 167571 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 167574 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 167578 */   // (smin:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$src1, v2i64:{ *:[v2i64] }:$src2)  =>  (VMINSD:{ *:[v2i64] } (COPY_TO_REGCLASS:{ *:[f128] } ?:{ *:[v2i64] }:$src1, VRRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[f128] } ?:{ *:[v2i64] }:$src2, VRRC:{ *:[i32] }))
     /* 167578 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 167581 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 167585 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 167590 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 167594 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /* 167599 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 167602 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 167606 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 167611 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 167615 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /* 167620 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMINSD),
     /* 167623 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /* 167625 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 167628 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 167631 */   GIR_RootConstrainSelectedInstOperands,
     /* 167632 */   // GIR_Coverage, 1926,
     /* 167632 */   GIR_EraseRootFromParent_Done,
     /* 167633 */ // Label 2628: @167633
     /* 167633 */ GIM_Reject,
     /* 167634 */ // Label 2624: @167634
     /* 167634 */ GIM_Try, /*On fail goto*//*Label 2629*/ GIMT_Encode4(167659), // Rule ID 1356 //
     /* 167639 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 167642 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 167645 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 167648 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 167652 */   // (smin:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$src1, v4i32:{ *:[v4i32] }:$src2)  =>  (VMINSW:{ *:[v4i32] } ?:{ *:[v4i32] }:$src1, ?:{ *:[v4i32] }:$src2)
     /* 167652 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMINSW),
     /* 167657 */   GIR_RootConstrainSelectedInstOperands,
     /* 167658 */   // GIR_Coverage, 1356,
     /* 167658 */   GIR_Done,
     /* 167659 */ // Label 2629: @167659
     /* 167659 */ GIM_Reject,
     /* 167660 */ // Label 2625: @167660
     /* 167660 */ GIM_Try, /*On fail goto*//*Label 2630*/ GIMT_Encode4(167685), // Rule ID 1354 //
     /* 167665 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 167668 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 167671 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 167674 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 167678 */   // (smin:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$src1, v8i16:{ *:[v8i16] }:$src2)  =>  (VMINSH:{ *:[v8i16] } ?:{ *:[v8i16] }:$src1, ?:{ *:[v8i16] }:$src2)
     /* 167678 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMINSH),
     /* 167683 */   GIR_RootConstrainSelectedInstOperands,
     /* 167684 */   // GIR_Coverage, 1354,
     /* 167684 */   GIR_Done,
     /* 167685 */ // Label 2630: @167685
     /* 167685 */ GIM_Reject,
     /* 167686 */ // Label 2626: @167686
     /* 167686 */ GIM_Try, /*On fail goto*//*Label 2631*/ GIMT_Encode4(167711), // Rule ID 1352 //
     /* 167691 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 167694 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 167697 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 167700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 167704 */   // (smin:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$src1, v16i8:{ *:[v16i8] }:$src2)  =>  (VMINSB:{ *:[v16i8] } ?:{ *:[v16i8] }:$src1, ?:{ *:[v16i8] }:$src2)
     /* 167704 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMINSB),
     /* 167709 */   GIR_RootConstrainSelectedInstOperands,
     /* 167710 */   // GIR_Coverage, 1352,
     /* 167710 */   GIR_Done,
     /* 167711 */ // Label 2631: @167711
     /* 167711 */ GIM_Reject,
     /* 167712 */ // Label 2627: @167712
     /* 167712 */ GIM_Reject,
     /* 167713 */ // Label 59: @167713
     /* 167713 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(8), /*)*//*default:*//*Label 2636*/ GIMT_Encode4(167892),
     /* 167724 */ /*GILLT_v2s64*//*Label 2632*/ GIMT_Encode4(167740),
     /* 167728 */ /*GILLT_v4s32*//*Label 2633*/ GIMT_Encode4(167814),
     /* 167732 */ /*GILLT_v8s16*//*Label 2634*/ GIMT_Encode4(167840),
     /* 167736 */ /*GILLT_v16s8*//*Label 2635*/ GIMT_Encode4(167866),
     /* 167740 */ // Label 2632: @167740
     /* 167740 */ GIM_Try, /*On fail goto*//*Label 2637*/ GIMT_Encode4(167813), // Rule ID 1924 //
     /* 167745 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 167748 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 167751 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 167754 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 167758 */   // (smax:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$src1, v2i64:{ *:[v2i64] }:$src2)  =>  (VMAXSD:{ *:[v2i64] } (COPY_TO_REGCLASS:{ *:[f128] } ?:{ *:[v2i64] }:$src1, VRRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[f128] } ?:{ *:[v2i64] }:$src2, VRRC:{ *:[i32] }))
     /* 167758 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 167761 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 167765 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 167770 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 167774 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /* 167779 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 167782 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 167786 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 167791 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 167795 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /* 167800 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMAXSD),
     /* 167803 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /* 167805 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 167808 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 167811 */   GIR_RootConstrainSelectedInstOperands,
     /* 167812 */   // GIR_Coverage, 1924,
     /* 167812 */   GIR_EraseRootFromParent_Done,
     /* 167813 */ // Label 2637: @167813
     /* 167813 */ GIM_Reject,
     /* 167814 */ // Label 2633: @167814
     /* 167814 */ GIM_Try, /*On fail goto*//*Label 2638*/ GIMT_Encode4(167839), // Rule ID 1350 //
     /* 167819 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 167822 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 167825 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 167828 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 167832 */   // (smax:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$src1, v4i32:{ *:[v4i32] }:$src2)  =>  (VMAXSW:{ *:[v4i32] } ?:{ *:[v4i32] }:$src1, ?:{ *:[v4i32] }:$src2)
     /* 167832 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMAXSW),
     /* 167837 */   GIR_RootConstrainSelectedInstOperands,
     /* 167838 */   // GIR_Coverage, 1350,
     /* 167838 */   GIR_Done,
     /* 167839 */ // Label 2638: @167839
     /* 167839 */ GIM_Reject,
     /* 167840 */ // Label 2634: @167840
     /* 167840 */ GIM_Try, /*On fail goto*//*Label 2639*/ GIMT_Encode4(167865), // Rule ID 1348 //
     /* 167845 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 167848 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 167851 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 167854 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 167858 */   // (smax:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$src1, v8i16:{ *:[v8i16] }:$src2)  =>  (VMAXSH:{ *:[v8i16] } ?:{ *:[v8i16] }:$src1, ?:{ *:[v8i16] }:$src2)
     /* 167858 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMAXSH),
     /* 167863 */   GIR_RootConstrainSelectedInstOperands,
     /* 167864 */   // GIR_Coverage, 1348,
     /* 167864 */   GIR_Done,
     /* 167865 */ // Label 2639: @167865
     /* 167865 */ GIM_Reject,
     /* 167866 */ // Label 2635: @167866
     /* 167866 */ GIM_Try, /*On fail goto*//*Label 2640*/ GIMT_Encode4(167891), // Rule ID 1346 //
     /* 167871 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 167874 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 167877 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 167880 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 167884 */   // (smax:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$src1, v16i8:{ *:[v16i8] }:$src2)  =>  (VMAXSB:{ *:[v16i8] } ?:{ *:[v16i8] }:$src1, ?:{ *:[v16i8] }:$src2)
     /* 167884 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMAXSB),
     /* 167889 */   GIR_RootConstrainSelectedInstOperands,
     /* 167890 */   // GIR_Coverage, 1346,
     /* 167890 */   GIR_Done,
     /* 167891 */ // Label 2640: @167891
     /* 167891 */ GIM_Reject,
     /* 167892 */ // Label 2636: @167892
     /* 167892 */ GIM_Reject,
     /* 167893 */ // Label 60: @167893
     /* 167893 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(8), /*)*//*default:*//*Label 2645*/ GIMT_Encode4(168072),
     /* 167904 */ /*GILLT_v2s64*//*Label 2641*/ GIMT_Encode4(167920),
     /* 167908 */ /*GILLT_v4s32*//*Label 2642*/ GIMT_Encode4(167994),
     /* 167912 */ /*GILLT_v8s16*//*Label 2643*/ GIMT_Encode4(168020),
     /* 167916 */ /*GILLT_v16s8*//*Label 2644*/ GIMT_Encode4(168046),
     /* 167920 */ // Label 2641: @167920
     /* 167920 */ GIM_Try, /*On fail goto*//*Label 2646*/ GIMT_Encode4(167993), // Rule ID 1927 //
     /* 167925 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 167928 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 167931 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 167934 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 167938 */   // (umin:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$src1, v2i64:{ *:[v2i64] }:$src2)  =>  (VMINUD:{ *:[v2i64] } (COPY_TO_REGCLASS:{ *:[f128] } ?:{ *:[v2i64] }:$src1, VRRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[f128] } ?:{ *:[v2i64] }:$src2, VRRC:{ *:[i32] }))
     /* 167938 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 167941 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 167945 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 167950 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 167954 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /* 167959 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 167962 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 167966 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 167971 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 167975 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /* 167980 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMINUD),
     /* 167983 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /* 167985 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 167988 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 167991 */   GIR_RootConstrainSelectedInstOperands,
     /* 167992 */   // GIR_Coverage, 1927,
     /* 167992 */   GIR_EraseRootFromParent_Done,
     /* 167993 */ // Label 2646: @167993
     /* 167993 */ GIM_Reject,
     /* 167994 */ // Label 2642: @167994
     /* 167994 */ GIM_Try, /*On fail goto*//*Label 2647*/ GIMT_Encode4(168019), // Rule ID 1355 //
     /* 167999 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 168002 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 168005 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 168008 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 168012 */   // (umin:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$src1, v4i32:{ *:[v4i32] }:$src2)  =>  (VMINUW:{ *:[v4i32] } ?:{ *:[v4i32] }:$src1, ?:{ *:[v4i32] }:$src2)
     /* 168012 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMINUW),
     /* 168017 */   GIR_RootConstrainSelectedInstOperands,
     /* 168018 */   // GIR_Coverage, 1355,
     /* 168018 */   GIR_Done,
     /* 168019 */ // Label 2647: @168019
     /* 168019 */ GIM_Reject,
     /* 168020 */ // Label 2643: @168020
     /* 168020 */ GIM_Try, /*On fail goto*//*Label 2648*/ GIMT_Encode4(168045), // Rule ID 1353 //
     /* 168025 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 168028 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 168031 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 168034 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 168038 */   // (umin:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$src1, v8i16:{ *:[v8i16] }:$src2)  =>  (VMINUH:{ *:[v8i16] } ?:{ *:[v8i16] }:$src1, ?:{ *:[v8i16] }:$src2)
     /* 168038 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMINUH),
     /* 168043 */   GIR_RootConstrainSelectedInstOperands,
     /* 168044 */   // GIR_Coverage, 1353,
     /* 168044 */   GIR_Done,
     /* 168045 */ // Label 2648: @168045
     /* 168045 */ GIM_Reject,
     /* 168046 */ // Label 2644: @168046
     /* 168046 */ GIM_Try, /*On fail goto*//*Label 2649*/ GIMT_Encode4(168071), // Rule ID 1351 //
     /* 168051 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 168054 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 168057 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 168060 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 168064 */   // (umin:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$src1, v16i8:{ *:[v16i8] }:$src2)  =>  (VMINUB:{ *:[v16i8] } ?:{ *:[v16i8] }:$src1, ?:{ *:[v16i8] }:$src2)
     /* 168064 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMINUB),
     /* 168069 */   GIR_RootConstrainSelectedInstOperands,
     /* 168070 */   // GIR_Coverage, 1351,
     /* 168070 */   GIR_Done,
     /* 168071 */ // Label 2649: @168071
     /* 168071 */ GIM_Reject,
     /* 168072 */ // Label 2645: @168072
     /* 168072 */ GIM_Reject,
     /* 168073 */ // Label 61: @168073
     /* 168073 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(8), /*)*//*default:*//*Label 2654*/ GIMT_Encode4(168252),
     /* 168084 */ /*GILLT_v2s64*//*Label 2650*/ GIMT_Encode4(168100),
     /* 168088 */ /*GILLT_v4s32*//*Label 2651*/ GIMT_Encode4(168174),
     /* 168092 */ /*GILLT_v8s16*//*Label 2652*/ GIMT_Encode4(168200),
     /* 168096 */ /*GILLT_v16s8*//*Label 2653*/ GIMT_Encode4(168226),
     /* 168100 */ // Label 2650: @168100
     /* 168100 */ GIM_Try, /*On fail goto*//*Label 2655*/ GIMT_Encode4(168173), // Rule ID 1925 //
     /* 168105 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 168108 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 168111 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 168114 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 168118 */   // (umax:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$src1, v2i64:{ *:[v2i64] }:$src2)  =>  (VMAXUD:{ *:[v2i64] } (COPY_TO_REGCLASS:{ *:[f128] } ?:{ *:[v2i64] }:$src1, VRRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[f128] } ?:{ *:[v2i64] }:$src2, VRRC:{ *:[i32] }))
     /* 168118 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 168121 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 168125 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168130 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 168134 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /* 168139 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 168142 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 168146 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168151 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 168155 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /* 168160 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMAXUD),
     /* 168163 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /* 168165 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 168168 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 168171 */   GIR_RootConstrainSelectedInstOperands,
     /* 168172 */   // GIR_Coverage, 1925,
     /* 168172 */   GIR_EraseRootFromParent_Done,
     /* 168173 */ // Label 2655: @168173
     /* 168173 */ GIM_Reject,
     /* 168174 */ // Label 2651: @168174
     /* 168174 */ GIM_Try, /*On fail goto*//*Label 2656*/ GIMT_Encode4(168199), // Rule ID 1349 //
     /* 168179 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 168182 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 168185 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 168188 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 168192 */   // (umax:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$src1, v4i32:{ *:[v4i32] }:$src2)  =>  (VMAXUW:{ *:[v4i32] } ?:{ *:[v4i32] }:$src1, ?:{ *:[v4i32] }:$src2)
     /* 168192 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMAXUW),
     /* 168197 */   GIR_RootConstrainSelectedInstOperands,
     /* 168198 */   // GIR_Coverage, 1349,
     /* 168198 */   GIR_Done,
     /* 168199 */ // Label 2656: @168199
     /* 168199 */ GIM_Reject,
     /* 168200 */ // Label 2652: @168200
     /* 168200 */ GIM_Try, /*On fail goto*//*Label 2657*/ GIMT_Encode4(168225), // Rule ID 1347 //
     /* 168205 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 168208 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 168211 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 168214 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 168218 */   // (umax:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$src1, v8i16:{ *:[v8i16] }:$src2)  =>  (VMAXUH:{ *:[v8i16] } ?:{ *:[v8i16] }:$src1, ?:{ *:[v8i16] }:$src2)
     /* 168218 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMAXUH),
     /* 168223 */   GIR_RootConstrainSelectedInstOperands,
     /* 168224 */   // GIR_Coverage, 1347,
     /* 168224 */   GIR_Done,
     /* 168225 */ // Label 2657: @168225
     /* 168225 */ GIM_Reject,
     /* 168226 */ // Label 2653: @168226
     /* 168226 */ GIM_Try, /*On fail goto*//*Label 2658*/ GIMT_Encode4(168251), // Rule ID 1345 //
     /* 168231 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 168234 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 168237 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 168240 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 168244 */   // (umax:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$src1, v16i8:{ *:[v16i8] }:$src2)  =>  (VMAXUB:{ *:[v16i8] } ?:{ *:[v16i8] }:$src1, ?:{ *:[v16i8] }:$src2)
     /* 168244 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMAXUB),
     /* 168249 */   GIR_RootConstrainSelectedInstOperands,
     /* 168250 */   // GIR_Coverage, 1345,
     /* 168250 */   GIR_Done,
     /* 168251 */ // Label 2658: @168251
     /* 168251 */ GIM_Reject,
     /* 168252 */ // Label 2654: @168252
     /* 168252 */ GIM_Reject,
     /* 168253 */ // Label 62: @168253
     /* 168253 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 2661*/ GIMT_Encode4(168554),
     /* 168264 */ /*GILLT_s32*//*Label 2659*/ GIMT_Encode4(168272),
     /* 168268 */ /*GILLT_s64*//*Label 2660*/ GIMT_Encode4(168413),
     /* 168272 */ // Label 2659: @168272
     /* 168272 */ GIM_Try, /*On fail goto*//*Label 2662*/ GIMT_Encode4(168332), // Rule ID 2032 //
     /* 168277 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX),
     /* 168280 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 168283 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 168287 */   // (lround:{ *:[i32] } f64:{ *:[f64] }:$S)  =>  (MFVSRWZ:{ *:[i32] } (FCTIW:{ *:[f64] } (XSRDPI:{ *:[f64] } ?:{ *:[f64] }:$S)))
     /* 168287 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 168290 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSRDPI),
     /* 168294 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168299 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // S
     /* 168303 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 168305 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 168308 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCTIW),
     /* 168312 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168317 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 168320 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 168322 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFVSRWZ),
     /* 168325 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 168327 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 168330 */   GIR_RootConstrainSelectedInstOperands,
     /* 168331 */   // GIR_Coverage, 2032,
     /* 168331 */   GIR_EraseRootFromParent_Done,
     /* 168332 */ // Label 2662: @168332
     /* 168332 */ GIM_Try, /*On fail goto*//*Label 2663*/ GIMT_Encode4(168412), // Rule ID 2033 //
     /* 168337 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX),
     /* 168340 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 168343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 168347 */   // (lround:{ *:[i32] } f32:{ *:[f32] }:$S)  =>  (MFVSRWZ:{ *:[i32] } (FCTIW:{ *:[f64] } (XSRDPI:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$S, VSFRC:{ *:[i32] }))))
     /* 168347 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 168350 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 168354 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168359 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // S
     /* 168363 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 168368 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 168371 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSRDPI),
     /* 168375 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168380 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 168383 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 168385 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 168388 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCTIW),
     /* 168392 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168397 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 168400 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 168402 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFVSRWZ),
     /* 168405 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 168407 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 168410 */   GIR_RootConstrainSelectedInstOperands,
     /* 168411 */   // GIR_Coverage, 2033,
     /* 168411 */   GIR_EraseRootFromParent_Done,
     /* 168412 */ // Label 2663: @168412
     /* 168412 */ GIM_Reject,
     /* 168413 */ // Label 2660: @168413
     /* 168413 */ GIM_Try, /*On fail goto*//*Label 2664*/ GIMT_Encode4(168473), // Rule ID 2030 //
     /* 168418 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX),
     /* 168421 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 168424 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 168428 */   // (lround:{ *:[i64] } f64:{ *:[f64] }:$S)  =>  (MFVSRD:{ *:[i64] } (FCTID:{ *:[f64] } (XSRDPI:{ *:[f64] } ?:{ *:[f64] }:$S)))
     /* 168428 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 168431 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSRDPI),
     /* 168435 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168440 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // S
     /* 168444 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 168446 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 168449 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCTID),
     /* 168453 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168458 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 168461 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 168463 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFVSRD),
     /* 168466 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 168468 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 168471 */   GIR_RootConstrainSelectedInstOperands,
     /* 168472 */   // GIR_Coverage, 2030,
     /* 168472 */   GIR_EraseRootFromParent_Done,
     /* 168473 */ // Label 2664: @168473
     /* 168473 */ GIM_Try, /*On fail goto*//*Label 2665*/ GIMT_Encode4(168553), // Rule ID 2031 //
     /* 168478 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX),
     /* 168481 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 168484 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 168488 */   // (lround:{ *:[i64] } f32:{ *:[f32] }:$S)  =>  (MFVSRD:{ *:[i64] } (FCTID:{ *:[f64] } (XSRDPI:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$S, VSFRC:{ *:[i32] }))))
     /* 168488 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 168491 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 168495 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168500 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // S
     /* 168504 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 168509 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 168512 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSRDPI),
     /* 168516 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168521 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 168524 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 168526 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 168529 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCTID),
     /* 168533 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168538 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 168541 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 168543 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFVSRD),
     /* 168546 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 168548 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 168551 */   GIR_RootConstrainSelectedInstOperands,
     /* 168552 */   // GIR_Coverage, 2031,
     /* 168552 */   GIR_EraseRootFromParent_Done,
     /* 168553 */ // Label 2665: @168553
     /* 168553 */ GIM_Reject,
     /* 168554 */ // Label 2661: @168554
     /* 168554 */ GIM_Reject,
     /* 168555 */ // Label 63: @168555
     /* 168555 */ GIM_Try, /*On fail goto*//*Label 2666*/ GIMT_Encode4(168719),
     /* 168560 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 168563 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 2669*/ GIMT_Encode4(168718),
     /* 168574 */   /*GILLT_s32*//*Label 2667*/ GIMT_Encode4(168582),
     /* 168578 */   /*GILLT_s64*//*Label 2668*/ GIMT_Encode4(168660),
     /* 168582 */   // Label 2667: @168582
     /* 168582 */   GIM_Try, /*On fail goto*//*Label 2670*/ GIMT_Encode4(168659), // Rule ID 2035 //
     /* 168587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX),
     /* 168590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 168594 */     // (llround:{ *:[i64] } f32:{ *:[f32] }:$S)  =>  (MFVSRD:{ *:[i64] } (FCTID:{ *:[f64] } (XSRDPI:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$S, VSFRC:{ *:[i32] }))))
     /* 168594 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 168597 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 168601 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168606 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // S
     /* 168610 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 168615 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 168618 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSRDPI),
     /* 168622 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168627 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 168630 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 168632 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 168635 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCTID),
     /* 168639 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168644 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 168647 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 168649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFVSRD),
     /* 168652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 168654 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 168657 */     GIR_RootConstrainSelectedInstOperands,
     /* 168658 */     // GIR_Coverage, 2035,
     /* 168658 */     GIR_EraseRootFromParent_Done,
     /* 168659 */   // Label 2670: @168659
     /* 168659 */   GIM_Reject,
     /* 168660 */   // Label 2668: @168660
     /* 168660 */   GIM_Try, /*On fail goto*//*Label 2671*/ GIMT_Encode4(168717), // Rule ID 2034 //
     /* 168665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX),
     /* 168668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 168672 */     // (llround:{ *:[i64] } f64:{ *:[f64] }:$S)  =>  (MFVSRD:{ *:[i64] } (FCTID:{ *:[f64] } (XSRDPI:{ *:[f64] } ?:{ *:[f64] }:$S)))
     /* 168672 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 168675 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSRDPI),
     /* 168679 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168684 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // S
     /* 168688 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 168690 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 168693 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCTID),
     /* 168697 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168702 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 168705 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 168707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFVSRD),
     /* 168710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 168712 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 168715 */     GIR_RootConstrainSelectedInstOperands,
     /* 168716 */     // GIR_Coverage, 2034,
     /* 168716 */     GIR_EraseRootFromParent_Done,
     /* 168717 */   // Label 2671: @168717
     /* 168717 */   GIM_Reject,
     /* 168718 */   // Label 2669: @168718
     /* 168718 */   GIM_Reject,
     /* 168719 */ // Label 2666: @168719
     /* 168719 */ GIM_Reject,
     /* 168720 */ // Label 64: @168720
     /* 168720 */ GIM_Try, /*On fail goto*//*Label 2672*/ GIMT_Encode4(168735), // Rule ID 15 //
     /* 168725 */   // MIs[0] LI
     /* 168725 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/0,
     /* 168728 */   // (br (bb:{ *:[Other] }):$LI)  =>  (B (bb:{ *:[Other] }):$LI)
     /* 168728 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::B),
     /* 168733 */   GIR_RootConstrainSelectedInstOperands,
     /* 168734 */   // GIR_Coverage, 15,
     /* 168734 */   GIR_Done,
     /* 168735 */ // Label 2672: @168735
     /* 168735 */ GIM_Reject,
     /* 168736 */ // Label 65: @168736
     /* 168736 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(8), /*)*//*default:*//*Label 2675*/ GIMT_Encode4(168853),
     /* 168747 */ /*GILLT_v8s16*//*Label 2673*/ GIMT_Encode4(168755),
     /* 168751 */ /*GILLT_v16s8*//*Label 2674*/ GIMT_Encode4(168818),
     /* 168755 */ // Label 2673: @168755
     /* 168755 */ GIM_Try, /*On fail goto*//*Label 2676*/ GIMT_Encode4(168817), // Rule ID 3481 //
     /* 168760 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX_IsBigEndian_IsISA3_1_IsPPC32),
     /* 168763 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 168766 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 168769 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 168772 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 168776 */   // (vector_insert:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$vDi, i32:{ *:[i32] }:$rA, i32:{ *:[i32] }:$rB)  =>  (VINSHLX:{ *:[v8i16] } ?:{ *:[v8i16] }:$vDi, (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$rB, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), ?:{ *:[i32] }:$rA)
     /* 168776 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 168779 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 168783 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168788 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rB
     /* 168792 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 168795 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 168798 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/30,
     /* 168801 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 168803 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VINSHLX),
     /* 168806 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /* 168808 */   GIR_RootToRootCopy, /*OpIdx*/1, // vDi
     /* 168810 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 168813 */   GIR_RootToRootCopy, /*OpIdx*/2, // rA
     /* 168815 */   GIR_RootConstrainSelectedInstOperands,
     /* 168816 */   // GIR_Coverage, 3481,
     /* 168816 */   GIR_EraseRootFromParent_Done,
     /* 168817 */ // Label 2676: @168817
     /* 168817 */ GIM_Reject,
     /* 168818 */ // Label 2674: @168818
     /* 168818 */ GIM_Try, /*On fail goto*//*Label 2677*/ GIMT_Encode4(168852), // Rule ID 3480 //
     /* 168823 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX_IsBigEndian_IsISA3_1_IsPPC32),
     /* 168826 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 168829 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 168832 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 168835 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 168839 */   // (vector_insert:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$vDi, i32:{ *:[i32] }:$rA, i32:{ *:[i32] }:$rB)  =>  (VINSBLX:{ *:[v16i8] } ?:{ *:[v16i8] }:$vDi, ?:{ *:[i32] }:$rB, ?:{ *:[i32] }:$rA)
     /* 168839 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VINSBLX),
     /* 168842 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /* 168844 */   GIR_RootToRootCopy, /*OpIdx*/1, // vDi
     /* 168846 */   GIR_RootToRootCopy, /*OpIdx*/3, // rB
     /* 168848 */   GIR_RootToRootCopy, /*OpIdx*/2, // rA
     /* 168850 */   GIR_RootConstrainSelectedInstOperands,
     /* 168851 */   // GIR_Coverage, 3480,
     /* 168851 */   GIR_EraseRootFromParent_Done,
     /* 168852 */ // Label 2677: @168852
     /* 168852 */ GIM_Reject,
     /* 168853 */ // Label 2675: @168853
     /* 168853 */ GIM_Reject,
     /* 168854 */ // Label 66: @168854
     /* 168854 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(8), /*)*//*default:*//*Label 2684*/ GIMT_Encode4(169031),
     /* 168865 */ /*GILLT_s32*//*Label 2678*/ GIMT_Encode4(168893),
     /* 168869 */ /*GILLT_s64*//*Label 2679*/ GIMT_Encode4(168916), GIMT_Encode4(0),
     /* 168877 */ /*GILLT_v2s64*//*Label 2680*/ GIMT_Encode4(168939),
     /* 168881 */ /*GILLT_v4s32*//*Label 2681*/ GIMT_Encode4(168962),
     /* 168885 */ /*GILLT_v8s16*//*Label 2682*/ GIMT_Encode4(168985),
     /* 168889 */ /*GILLT_v16s8*//*Label 2683*/ GIMT_Encode4(169008),
     /* 168893 */ // Label 2678: @168893
     /* 168893 */ GIM_Try, /*On fail goto*//*Label 2685*/ GIMT_Encode4(168915), // Rule ID 134 //
     /* 168898 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_0),
     /* 168901 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 168904 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 168908 */   // (cttz:{ *:[i32] } i32:{ *:[i32] }:$RST)  =>  (CNTTZW:{ *:[i32] } i32:{ *:[i32] }:$RST)
     /* 168908 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::CNTTZW),
     /* 168913 */   GIR_RootConstrainSelectedInstOperands,
     /* 168914 */   // GIR_Coverage, 134,
     /* 168914 */   GIR_Done,
     /* 168915 */ // Label 2685: @168915
     /* 168915 */ GIM_Reject,
     /* 168916 */ // Label 2679: @168916
     /* 168916 */ GIM_Try, /*On fail goto*//*Label 2686*/ GIMT_Encode4(168938), // Rule ID 684 //
     /* 168921 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_0),
     /* 168924 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 168927 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 168931 */   // (cttz:{ *:[i64] } i64:{ *:[i64] }:$RST)  =>  (CNTTZD:{ *:[i64] } i64:{ *:[i64] }:$RST)
     /* 168931 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::CNTTZD),
     /* 168936 */   GIR_RootConstrainSelectedInstOperands,
     /* 168937 */   // GIR_Coverage, 684,
     /* 168937 */   GIR_Done,
     /* 168938 */ // Label 2686: @168938
     /* 168938 */ GIM_Reject,
     /* 168939 */ // Label 2680: @168939
     /* 168939 */ GIM_Try, /*On fail goto*//*Label 2687*/ GIMT_Encode4(168961), // Rule ID 535 //
     /* 168944 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /* 168947 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 168950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 168954 */   // (cttz:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VB)  =>  (VCTZD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VB)
     /* 168954 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VCTZD),
     /* 168959 */   GIR_RootConstrainSelectedInstOperands,
     /* 168960 */   // GIR_Coverage, 535,
     /* 168960 */   GIR_Done,
     /* 168961 */ // Label 2687: @168961
     /* 168961 */ GIM_Reject,
     /* 168962 */ // Label 2681: @168962
     /* 168962 */ GIM_Try, /*On fail goto*//*Label 2688*/ GIMT_Encode4(168984), // Rule ID 534 //
     /* 168967 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /* 168970 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 168973 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 168977 */   // (cttz:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VB)  =>  (VCTZW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VB)
     /* 168977 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VCTZW),
     /* 168982 */   GIR_RootConstrainSelectedInstOperands,
     /* 168983 */   // GIR_Coverage, 534,
     /* 168983 */   GIR_Done,
     /* 168984 */ // Label 2688: @168984
     /* 168984 */ GIM_Reject,
     /* 168985 */ // Label 2682: @168985
     /* 168985 */ GIM_Try, /*On fail goto*//*Label 2689*/ GIMT_Encode4(169007), // Rule ID 533 //
     /* 168990 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /* 168993 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 168996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 169000 */   // (cttz:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VB)  =>  (VCTZH:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VB)
     /* 169000 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VCTZH),
     /* 169005 */   GIR_RootConstrainSelectedInstOperands,
     /* 169006 */   // GIR_Coverage, 533,
     /* 169006 */   GIR_Done,
     /* 169007 */ // Label 2689: @169007
     /* 169007 */ GIM_Reject,
     /* 169008 */ // Label 2683: @169008
     /* 169008 */ GIM_Try, /*On fail goto*//*Label 2690*/ GIMT_Encode4(169030), // Rule ID 532 //
     /* 169013 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /* 169016 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 169019 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 169023 */   // (cttz:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VB)  =>  (VCTZB:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VB)
     /* 169023 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VCTZB),
     /* 169028 */   GIR_RootConstrainSelectedInstOperands,
     /* 169029 */   // GIR_Coverage, 532,
     /* 169029 */   GIR_Done,
     /* 169030 */ // Label 2690: @169030
     /* 169030 */ GIM_Reject,
     /* 169031 */ // Label 2684: @169031
     /* 169031 */ GIM_Reject,
     /* 169032 */ // Label 67: @169032
     /* 169032 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(8), /*)*//*default:*//*Label 2697*/ GIMT_Encode4(169203),
     /* 169043 */ /*GILLT_s32*//*Label 2691*/ GIMT_Encode4(169071),
     /* 169047 */ /*GILLT_s64*//*Label 2692*/ GIMT_Encode4(169091), GIMT_Encode4(0),
     /* 169055 */ /*GILLT_v2s64*//*Label 2693*/ GIMT_Encode4(169111),
     /* 169059 */ /*GILLT_v4s32*//*Label 2694*/ GIMT_Encode4(169134),
     /* 169063 */ /*GILLT_v8s16*//*Label 2695*/ GIMT_Encode4(169157),
     /* 169067 */ /*GILLT_v16s8*//*Label 2696*/ GIMT_Encode4(169180),
     /* 169071 */ // Label 2691: @169071
     /* 169071 */ GIM_Try, /*On fail goto*//*Label 2698*/ GIMT_Encode4(169090), // Rule ID 133 //
     /* 169076 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 169079 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 169083 */   // (ctlz:{ *:[i32] } i32:{ *:[i32] }:$RST)  =>  (CNTLZW:{ *:[i32] } i32:{ *:[i32] }:$RST)
     /* 169083 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::CNTLZW),
     /* 169088 */   GIR_RootConstrainSelectedInstOperands,
     /* 169089 */   // GIR_Coverage, 133,
     /* 169089 */   GIR_Done,
     /* 169090 */ // Label 2698: @169090
     /* 169090 */ GIM_Reject,
     /* 169091 */ // Label 2692: @169091
     /* 169091 */ GIM_Try, /*On fail goto*//*Label 2699*/ GIMT_Encode4(169110), // Rule ID 683 //
     /* 169096 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 169099 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 169103 */   // (ctlz:{ *:[i64] } i64:{ *:[i64] }:$RST)  =>  (CNTLZD:{ *:[i64] } i64:{ *:[i64] }:$RST)
     /* 169103 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::CNTLZD),
     /* 169108 */   GIR_RootConstrainSelectedInstOperands,
     /* 169109 */   // GIR_Coverage, 683,
     /* 169109 */   GIR_Done,
     /* 169110 */ // Label 2699: @169110
     /* 169110 */ GIM_Reject,
     /* 169111 */ // Label 2693: @169111
     /* 169111 */ GIM_Try, /*On fail goto*//*Label 2700*/ GIMT_Encode4(169133), // Rule ID 482 //
     /* 169116 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /* 169119 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 169122 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 169126 */   // (ctlz:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VB)  =>  (VCLZD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VB)
     /* 169126 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VCLZD),
     /* 169131 */   GIR_RootConstrainSelectedInstOperands,
     /* 169132 */   // GIR_Coverage, 482,
     /* 169132 */   GIR_Done,
     /* 169133 */ // Label 2700: @169133
     /* 169133 */ GIM_Reject,
     /* 169134 */ // Label 2694: @169134
     /* 169134 */ GIM_Try, /*On fail goto*//*Label 2701*/ GIMT_Encode4(169156), // Rule ID 481 //
     /* 169139 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /* 169142 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 169145 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 169149 */   // (ctlz:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VB)  =>  (VCLZW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VB)
     /* 169149 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VCLZW),
     /* 169154 */   GIR_RootConstrainSelectedInstOperands,
     /* 169155 */   // GIR_Coverage, 481,
     /* 169155 */   GIR_Done,
     /* 169156 */ // Label 2701: @169156
     /* 169156 */ GIM_Reject,
     /* 169157 */ // Label 2695: @169157
     /* 169157 */ GIM_Try, /*On fail goto*//*Label 2702*/ GIMT_Encode4(169179), // Rule ID 480 //
     /* 169162 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /* 169165 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 169168 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 169172 */   // (ctlz:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VB)  =>  (VCLZH:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VB)
     /* 169172 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VCLZH),
     /* 169177 */   GIR_RootConstrainSelectedInstOperands,
     /* 169178 */   // GIR_Coverage, 480,
     /* 169178 */   GIR_Done,
     /* 169179 */ // Label 2702: @169179
     /* 169179 */ GIM_Reject,
     /* 169180 */ // Label 2696: @169180
     /* 169180 */ GIM_Try, /*On fail goto*//*Label 2703*/ GIMT_Encode4(169202), // Rule ID 479 //
     /* 169185 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /* 169188 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 169191 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 169195 */   // (ctlz:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VB)  =>  (VCLZB:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VB)
     /* 169195 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VCLZB),
     /* 169200 */   GIR_RootConstrainSelectedInstOperands,
     /* 169201 */   // GIR_Coverage, 479,
     /* 169201 */   GIR_Done,
     /* 169202 */ // Label 2703: @169202
     /* 169202 */ GIM_Reject,
     /* 169203 */ // Label 2697: @169203
     /* 169203 */ GIM_Reject,
     /* 169204 */ // Label 68: @169204
     /* 169204 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(8), /*)*//*default:*//*Label 2710*/ GIMT_Encode4(169375),
     /* 169215 */ /*GILLT_s32*//*Label 2704*/ GIMT_Encode4(169243),
     /* 169219 */ /*GILLT_s64*//*Label 2705*/ GIMT_Encode4(169263), GIMT_Encode4(0),
     /* 169227 */ /*GILLT_v2s64*//*Label 2706*/ GIMT_Encode4(169283),
     /* 169231 */ /*GILLT_v4s32*//*Label 2707*/ GIMT_Encode4(169306),
     /* 169235 */ /*GILLT_v8s16*//*Label 2708*/ GIMT_Encode4(169329),
     /* 169239 */ /*GILLT_v16s8*//*Label 2709*/ GIMT_Encode4(169352),
     /* 169243 */ // Label 2704: @169243
     /* 169243 */ GIM_Try, /*On fail goto*//*Label 2711*/ GIMT_Encode4(169262), // Rule ID 688 //
     /* 169248 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 169251 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 169255 */   // (ctpop:{ *:[i32] } i32:{ *:[i32] }:$RST)  =>  (POPCNTW:{ *:[i32] } i32:{ *:[i32] }:$RST)
     /* 169255 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::POPCNTW),
     /* 169260 */   GIR_RootConstrainSelectedInstOperands,
     /* 169261 */   // GIR_Coverage, 688,
     /* 169261 */   GIR_Done,
     /* 169262 */ // Label 2711: @169262
     /* 169262 */ GIM_Reject,
     /* 169263 */ // Label 2705: @169263
     /* 169263 */ GIM_Try, /*On fail goto*//*Label 2712*/ GIMT_Encode4(169282), // Rule ID 685 //
     /* 169268 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 169271 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 169275 */   // (ctpop:{ *:[i64] } i64:{ *:[i64] }:$RST)  =>  (POPCNTD:{ *:[i64] } i64:{ *:[i64] }:$RST)
     /* 169275 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::POPCNTD),
     /* 169280 */   GIR_RootConstrainSelectedInstOperands,
     /* 169281 */   // GIR_Coverage, 685,
     /* 169281 */   GIR_Done,
     /* 169282 */ // Label 2712: @169282
     /* 169282 */ GIM_Reject,
     /* 169283 */ // Label 2706: @169283
     /* 169283 */ GIM_Try, /*On fail goto*//*Label 2713*/ GIMT_Encode4(169305), // Rule ID 486 //
     /* 169288 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /* 169291 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 169294 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 169298 */   // (ctpop:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VB)  =>  (VPOPCNTD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VB)
     /* 169298 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VPOPCNTD),
     /* 169303 */   GIR_RootConstrainSelectedInstOperands,
     /* 169304 */   // GIR_Coverage, 486,
     /* 169304 */   GIR_Done,
     /* 169305 */ // Label 2713: @169305
     /* 169305 */ GIM_Reject,
     /* 169306 */ // Label 2707: @169306
     /* 169306 */ GIM_Try, /*On fail goto*//*Label 2714*/ GIMT_Encode4(169328), // Rule ID 485 //
     /* 169311 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /* 169314 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 169317 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 169321 */   // (ctpop:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VB)  =>  (VPOPCNTW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VB)
     /* 169321 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VPOPCNTW),
     /* 169326 */   GIR_RootConstrainSelectedInstOperands,
     /* 169327 */   // GIR_Coverage, 485,
     /* 169327 */   GIR_Done,
     /* 169328 */ // Label 2714: @169328
     /* 169328 */ GIM_Reject,
     /* 169329 */ // Label 2708: @169329
     /* 169329 */ GIM_Try, /*On fail goto*//*Label 2715*/ GIMT_Encode4(169351), // Rule ID 484 //
     /* 169334 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /* 169337 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 169340 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 169344 */   // (ctpop:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VB)  =>  (VPOPCNTH:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VB)
     /* 169344 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VPOPCNTH),
     /* 169349 */   GIR_RootConstrainSelectedInstOperands,
     /* 169350 */   // GIR_Coverage, 484,
     /* 169350 */   GIR_Done,
     /* 169351 */ // Label 2715: @169351
     /* 169351 */ GIM_Reject,
     /* 169352 */ // Label 2709: @169352
     /* 169352 */ GIM_Try, /*On fail goto*//*Label 2716*/ GIMT_Encode4(169374), // Rule ID 483 //
     /* 169357 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /* 169360 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 169363 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 169367 */   // (ctpop:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VB)  =>  (VPOPCNTB:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VB)
     /* 169367 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VPOPCNTB),
     /* 169372 */   GIR_RootConstrainSelectedInstOperands,
     /* 169373 */   // GIR_Coverage, 483,
     /* 169373 */   GIR_Done,
     /* 169374 */ // Label 2716: @169374
     /* 169374 */ GIM_Reject,
     /* 169375 */ // Label 2710: @169375
     /* 169375 */ GIM_Reject,
     /* 169376 */ // Label 69: @169376
     /* 169376 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(7), /*)*//*default:*//*Label 2723*/ GIMT_Encode4(169639),
     /* 169387 */ /*GILLT_s32*//*Label 2717*/ GIMT_Encode4(169411),
     /* 169391 */ /*GILLT_s64*//*Label 2718*/ GIMT_Encode4(169434),
     /* 169395 */ /*GILLT_s128*//*Label 2719*/ GIMT_Encode4(169457),
     /* 169399 */ /*GILLT_v2s64*//*Label 2720*/ GIMT_Encode4(169525),
     /* 169403 */ /*GILLT_v4s32*//*Label 2721*/ GIMT_Encode4(169548),
     /* 169407 */ /*GILLT_v8s16*//*Label 2722*/ GIMT_Encode4(169571),
     /* 169411 */ // Label 2717: @169411
     /* 169411 */ GIM_Try, /*On fail goto*//*Label 2724*/ GIMT_Encode4(169433), // Rule ID 1137 //
     /* 169416 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 169419 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 169422 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 169426 */   // (bswap:{ *:[i32] } i32:{ *:[i32] }:$RST)  =>  (BRW:{ *:[i32] } i32:{ *:[i32] }:$RST)
     /* 169426 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::BRW),
     /* 169431 */   GIR_RootConstrainSelectedInstOperands,
     /* 169432 */   // GIR_Coverage, 1137,
     /* 169432 */   GIR_Done,
     /* 169433 */ // Label 2724: @169433
     /* 169433 */ GIM_Reject,
     /* 169434 */ // Label 2718: @169434
     /* 169434 */ GIM_Try, /*On fail goto*//*Label 2725*/ GIMT_Encode4(169456), // Rule ID 1138 //
     /* 169439 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 169442 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 169445 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 169449 */   // (bswap:{ *:[i64] } i64:{ *:[i64] }:$RST)  =>  (BRD:{ *:[i64] } i64:{ *:[i64] }:$RST)
     /* 169449 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::BRD),
     /* 169454 */   GIR_RootConstrainSelectedInstOperands,
     /* 169455 */   // GIR_Coverage, 1138,
     /* 169455 */   GIR_Done,
     /* 169456 */ // Label 2725: @169456
     /* 169456 */ GIM_Reject,
     /* 169457 */ // Label 2719: @169457
     /* 169457 */ GIM_Try, /*On fail goto*//*Label 2726*/ GIMT_Encode4(169524), // Rule ID 2169 //
     /* 169462 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 169465 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 169468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 169472 */   // (bswap:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v1i128] } (XXBRQ:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v1i128] }:$A, VSRC:{ *:[i32] })), VRRC:{ *:[i32] })
     /* 169472 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 169475 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169479 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169484 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 169488 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /* 169493 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 169496 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXBRQ),
     /* 169500 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169505 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 169508 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 169510 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169513 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169515 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 169518 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /* 169523 */   // GIR_Coverage, 2169,
     /* 169523 */   GIR_EraseRootFromParent_Done,
     /* 169524 */ // Label 2726: @169524
     /* 169524 */ GIM_Reject,
     /* 169525 */ // Label 2720: @169525
     /* 169525 */ GIM_Try, /*On fail goto*//*Label 2727*/ GIMT_Encode4(169547), // Rule ID 1034 //
     /* 169530 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 169533 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 169536 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 169540 */   // (bswap:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$XB)  =>  (XXBRD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$XB)
     /* 169540 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XXBRD),
     /* 169545 */   GIR_RootConstrainSelectedInstOperands,
     /* 169546 */   // GIR_Coverage, 1034,
     /* 169546 */   GIR_Done,
     /* 169547 */ // Label 2727: @169547
     /* 169547 */ GIM_Reject,
     /* 169548 */ // Label 2721: @169548
     /* 169548 */ GIM_Try, /*On fail goto*//*Label 2728*/ GIMT_Encode4(169570), // Rule ID 1033 //
     /* 169553 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 169556 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 169559 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 169563 */   // (bswap:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XB)  =>  (XXBRW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XB)
     /* 169563 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XXBRW),
     /* 169568 */   GIR_RootConstrainSelectedInstOperands,
     /* 169569 */   // GIR_Coverage, 1033,
     /* 169569 */   GIR_Done,
     /* 169570 */ // Label 2728: @169570
     /* 169570 */ GIM_Reject,
     /* 169571 */ // Label 2722: @169571
     /* 169571 */ GIM_Try, /*On fail goto*//*Label 2729*/ GIMT_Encode4(169638), // Rule ID 2168 //
     /* 169576 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 169579 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 169582 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 169586 */   // (bswap:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v8i16] } (XXBRH:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v8i16] }:$A, VSRC:{ *:[i32] })), VRRC:{ *:[i32] })
     /* 169586 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 169589 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169593 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169598 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 169602 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /* 169607 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 169610 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXBRH),
     /* 169614 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169619 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 169622 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 169624 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169627 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169629 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 169632 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /* 169637 */   // GIR_Coverage, 2168,
     /* 169637 */   GIR_EraseRootFromParent_Done,
     /* 169638 */ // Label 2729: @169638
     /* 169638 */ GIM_Reject,
     /* 169639 */ // Label 2723: @169639
     /* 169639 */ GIM_Reject,
     /* 169640 */ // Label 70: @169640
     /* 169640 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 2732*/ GIMT_Encode4(205645),
     /* 169651 */ /*GILLT_s32*//*Label 2730*/ GIMT_Encode4(169659),
     /* 169655 */ /*GILLT_s64*//*Label 2731*/ GIMT_Encode4(179954),
     /* 169659 */ // Label 2730: @169659
     /* 169659 */ GIM_Try, /*On fail goto*//*Label 2733*/ GIMT_Encode4(179953),
     /* 169664 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 169667 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 169671 */   GIM_Try, /*On fail goto*//*Label 2734*/ GIMT_Encode4(174827), // Rule ID 4845 //
     /* 169676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /* 169679 */     // (bitreverse:{ *:[i32] } i32:{ *:[i32] }:$A)  =>  (RLDICL_32:{ *:[i32] } (RLWIMI:{ *:[i32] } (RLWIMI:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 30:{ *:[i32] }, 2:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 2:{ *:[i32] }, 0:{ *:[i32] }, 29:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }))), 28:{ *:[i32] }, 4:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 3855:{ *:[i32] }), 3855:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 30:{ *:[i32] }, 2:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 2:{ *:[i32] }, 0:{ *:[i32] }, 29:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }))), 4:{ *:[i32] }, 0:{ *:[i32] }, 27:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 61680:{ *:[i32] }), 61680:{ *:[i32] }))), 24:{ *:[i32] }, 0:{ *:[i32] }, 31:{ *:[i32] }), (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 30:{ *:[i32] }, 2:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 2:{ *:[i32] }, 0:{ *:[i32] }, 29:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }))), 28:{ *:[i32] }, 4:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 3855:{ *:[i32] }), 3855:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 30:{ *:[i32] }, 2:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 2:{ *:[i32] }, 0:{ *:[i32] }, 29:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }))), 4:{ *:[i32] }, 0:{ *:[i32] }, 27:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 61680:{ *:[i32] }), 61680:{ *:[i32] }))), 8:{ *:[i32] }, 8:{ *:[i32] }, 15:{ *:[i32] }), (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 30:{ *:[i32] }, 2:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 2:{ *:[i32] }, 0:{ *:[i32] }, 29:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }))), 28:{ *:[i32] }, 4:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 3855:{ *:[i32] }), 3855:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 30:{ *:[i32] }, 2:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 2:{ *:[i32] }, 0:{ *:[i32] }, 29:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }))), 4:{ *:[i32] }, 0:{ *:[i32] }, 27:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 61680:{ *:[i32] }), 61680:{ *:[i32] }))), 8:{ *:[i32] }, 24:{ *:[i32] }, 31:{ *:[i32] }), 0:{ *:[i32] }, 32:{ *:[i32] })
     /* 169679 */     GIR_MakeTempReg, /*TempRegID*//* 191(*/0xBF, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 169683 */     GIR_BuildMI, /*InsnID*//* 192(*/0xC0, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 169688 */     GIR_AddTempRegister, /*InsnID*//* 192(*/0xC0, 0x01/*)*/, /*TempRegID*//* 191(*/0xBF, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169695 */     GIR_AddImm, /*InsnID*//* 192(*/0xC0, 0x01/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 169706 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 192(*/0xC0, 0x01/*)*/,
     /* 169709 */     GIR_MakeTempReg, /*TempRegID*//* 190(*/0xBE, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 169713 */     GIR_BuildMI, /*InsnID*//* 191(*/0xBF, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 169718 */     GIR_AddTempRegister, /*InsnID*//* 191(*/0xBF, 0x01/*)*/, /*TempRegID*//* 190(*/0xBE, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169725 */     GIR_AddSimpleTempRegister, /*InsnID*//* 191(*/0xBF, 0x01/*)*/, /*TempRegID*//* 191(*/0xBF, 0x01/*)*/,
     /* 169730 */     GIR_AddImm, /*InsnID*//* 191(*/0xBF, 0x01/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 169741 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 191(*/0xBF, 0x01/*)*/,
     /* 169744 */     GIR_MakeTempReg, /*TempRegID*//* 189(*/0xBD, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 169748 */     GIR_BuildMI, /*InsnID*//* 190(*/0xBE, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 169753 */     GIR_AddTempRegister, /*InsnID*//* 190(*/0xBE, 0x01/*)*/, /*TempRegID*//* 189(*/0xBD, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169760 */     GIR_AddImm, /*InsnID*//* 190(*/0xBE, 0x01/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 169771 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 190(*/0xBE, 0x01/*)*/,
     /* 169774 */     GIR_MakeTempReg, /*TempRegID*//* 188(*/0xBC, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 169778 */     GIR_BuildMI, /*InsnID*//* 189(*/0xBD, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 169783 */     GIR_AddTempRegister, /*InsnID*//* 189(*/0xBD, 0x01/*)*/, /*TempRegID*//* 188(*/0xBC, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169790 */     GIR_AddSimpleTempRegister, /*InsnID*//* 189(*/0xBD, 0x01/*)*/, /*TempRegID*//* 189(*/0xBD, 0x01/*)*/,
     /* 169795 */     GIR_AddImm, /*InsnID*//* 189(*/0xBD, 0x01/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 169806 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 189(*/0xBD, 0x01/*)*/,
     /* 169809 */     GIR_MakeTempReg, /*TempRegID*//* 187(*/0xBB, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 169813 */     GIR_BuildMI, /*InsnID*//* 188(*/0xBC, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 169818 */     GIR_AddTempRegister, /*InsnID*//* 188(*/0xBC, 0x01/*)*/, /*TempRegID*//* 187(*/0xBB, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169825 */     GIR_AddImm, /*InsnID*//* 188(*/0xBC, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 169836 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 188(*/0xBC, 0x01/*)*/,
     /* 169839 */     GIR_MakeTempReg, /*TempRegID*//* 186(*/0xBA, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 169843 */     GIR_BuildMI, /*InsnID*//* 187(*/0xBB, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 169848 */     GIR_AddTempRegister, /*InsnID*//* 187(*/0xBB, 0x01/*)*/, /*TempRegID*//* 186(*/0xBA, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169855 */     GIR_AddSimpleTempRegister, /*InsnID*//* 187(*/0xBB, 0x01/*)*/, /*TempRegID*//* 187(*/0xBB, 0x01/*)*/,
     /* 169860 */     GIR_AddImm, /*InsnID*//* 187(*/0xBB, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 169871 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 187(*/0xBB, 0x01/*)*/,
     /* 169874 */     GIR_MakeTempReg, /*TempRegID*//* 185(*/0xB9, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 169878 */     GIR_BuildMI, /*InsnID*//* 186(*/0xBA, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 169883 */     GIR_AddTempRegister, /*InsnID*//* 186(*/0xBA, 0x01/*)*/, /*TempRegID*//* 185(*/0xB9, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169890 */     GIR_Copy, /*NewInsnID*//* 186(*/0xBA, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 169895 */     GIR_AddImm8, /*InsnID*//* 186(*/0xBA, 0x01/*)*/, /*Imm*/1,
     /* 169899 */     GIR_AddImm8, /*InsnID*//* 186(*/0xBA, 0x01/*)*/, /*Imm*/0,
     /* 169903 */     GIR_AddImm8, /*InsnID*//* 186(*/0xBA, 0x01/*)*/, /*Imm*/30,
     /* 169907 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 186(*/0xBA, 0x01/*)*/,
     /* 169910 */     GIR_MakeTempReg, /*TempRegID*//* 184(*/0xB8, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 169914 */     GIR_BuildMI, /*InsnID*//* 185(*/0xB9, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 169919 */     GIR_AddTempRegister, /*InsnID*//* 185(*/0xB9, 0x01/*)*/, /*TempRegID*//* 184(*/0xB8, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169926 */     GIR_AddSimpleTempRegister, /*InsnID*//* 185(*/0xB9, 0x01/*)*/, /*TempRegID*//* 185(*/0xB9, 0x01/*)*/,
     /* 169931 */     GIR_AddSimpleTempRegister, /*InsnID*//* 185(*/0xB9, 0x01/*)*/, /*TempRegID*//* 186(*/0xBA, 0x01/*)*/,
     /* 169936 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 185(*/0xB9, 0x01/*)*/,
     /* 169939 */     GIR_MakeTempReg, /*TempRegID*//* 183(*/0xB7, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 169943 */     GIR_BuildMI, /*InsnID*//* 184(*/0xB8, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 169948 */     GIR_AddTempRegister, /*InsnID*//* 184(*/0xB8, 0x01/*)*/, /*TempRegID*//* 183(*/0xB7, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169955 */     GIR_AddImm, /*InsnID*//* 184(*/0xB8, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 169966 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 184(*/0xB8, 0x01/*)*/,
     /* 169969 */     GIR_MakeTempReg, /*TempRegID*//* 182(*/0xB6, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 169973 */     GIR_BuildMI, /*InsnID*//* 183(*/0xB7, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 169978 */     GIR_AddTempRegister, /*InsnID*//* 183(*/0xB7, 0x01/*)*/, /*TempRegID*//* 182(*/0xB6, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169985 */     GIR_AddSimpleTempRegister, /*InsnID*//* 183(*/0xB7, 0x01/*)*/, /*TempRegID*//* 183(*/0xB7, 0x01/*)*/,
     /* 169990 */     GIR_AddImm, /*InsnID*//* 183(*/0xB7, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 170001 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 183(*/0xB7, 0x01/*)*/,
     /* 170004 */     GIR_MakeTempReg, /*TempRegID*//* 181(*/0xB5, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 170008 */     GIR_BuildMI, /*InsnID*//* 182(*/0xB6, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 170013 */     GIR_AddTempRegister, /*InsnID*//* 182(*/0xB6, 0x01/*)*/, /*TempRegID*//* 181(*/0xB5, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170020 */     GIR_Copy, /*NewInsnID*//* 182(*/0xB6, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 170025 */     GIR_AddImm8, /*InsnID*//* 182(*/0xB6, 0x01/*)*/, /*Imm*/31,
     /* 170029 */     GIR_AddImm8, /*InsnID*//* 182(*/0xB6, 0x01/*)*/, /*Imm*/1,
     /* 170033 */     GIR_AddImm8, /*InsnID*//* 182(*/0xB6, 0x01/*)*/, /*Imm*/31,
     /* 170037 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 182(*/0xB6, 0x01/*)*/,
     /* 170040 */     GIR_MakeTempReg, /*TempRegID*//* 180(*/0xB4, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 170044 */     GIR_BuildMI, /*InsnID*//* 181(*/0xB5, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 170049 */     GIR_AddTempRegister, /*InsnID*//* 181(*/0xB5, 0x01/*)*/, /*TempRegID*//* 180(*/0xB4, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170056 */     GIR_AddSimpleTempRegister, /*InsnID*//* 181(*/0xB5, 0x01/*)*/, /*TempRegID*//* 181(*/0xB5, 0x01/*)*/,
     /* 170061 */     GIR_AddSimpleTempRegister, /*InsnID*//* 181(*/0xB5, 0x01/*)*/, /*TempRegID*//* 182(*/0xB6, 0x01/*)*/,
     /* 170066 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 181(*/0xB5, 0x01/*)*/,
     /* 170069 */     GIR_MakeTempReg, /*TempRegID*//* 179(*/0xB3, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 170073 */     GIR_BuildMI, /*InsnID*//* 180(*/0xB4, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 170078 */     GIR_AddTempRegister, /*InsnID*//* 180(*/0xB4, 0x01/*)*/, /*TempRegID*//* 179(*/0xB3, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170085 */     GIR_AddSimpleTempRegister, /*InsnID*//* 180(*/0xB4, 0x01/*)*/, /*TempRegID*//* 180(*/0xB4, 0x01/*)*/,
     /* 170090 */     GIR_AddSimpleTempRegister, /*InsnID*//* 180(*/0xB4, 0x01/*)*/, /*TempRegID*//* 184(*/0xB8, 0x01/*)*/,
     /* 170095 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 180(*/0xB4, 0x01/*)*/,
     /* 170098 */     GIR_MakeTempReg, /*TempRegID*//* 178(*/0xB2, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 170102 */     GIR_BuildMI, /*InsnID*//* 179(*/0xB3, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 170107 */     GIR_AddTempRegister, /*InsnID*//* 179(*/0xB3, 0x01/*)*/, /*TempRegID*//* 178(*/0xB2, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170114 */     GIR_AddSimpleTempRegister, /*InsnID*//* 179(*/0xB3, 0x01/*)*/, /*TempRegID*//* 179(*/0xB3, 0x01/*)*/,
     /* 170119 */     GIR_AddImm8, /*InsnID*//* 179(*/0xB3, 0x01/*)*/, /*Imm*/2,
     /* 170123 */     GIR_AddImm8, /*InsnID*//* 179(*/0xB3, 0x01/*)*/, /*Imm*/0,
     /* 170127 */     GIR_AddImm8, /*InsnID*//* 179(*/0xB3, 0x01/*)*/, /*Imm*/29,
     /* 170131 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 179(*/0xB3, 0x01/*)*/,
     /* 170134 */     GIR_MakeTempReg, /*TempRegID*//* 177(*/0xB1, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 170138 */     GIR_BuildMI, /*InsnID*//* 178(*/0xB2, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 170143 */     GIR_AddTempRegister, /*InsnID*//* 178(*/0xB2, 0x01/*)*/, /*TempRegID*//* 177(*/0xB1, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170150 */     GIR_AddSimpleTempRegister, /*InsnID*//* 178(*/0xB2, 0x01/*)*/, /*TempRegID*//* 178(*/0xB2, 0x01/*)*/,
     /* 170155 */     GIR_AddSimpleTempRegister, /*InsnID*//* 178(*/0xB2, 0x01/*)*/, /*TempRegID*//* 188(*/0xBC, 0x01/*)*/,
     /* 170160 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 178(*/0xB2, 0x01/*)*/,
     /* 170163 */     GIR_MakeTempReg, /*TempRegID*//* 176(*/0xB0, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 170167 */     GIR_BuildMI, /*InsnID*//* 177(*/0xB1, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 170172 */     GIR_AddTempRegister, /*InsnID*//* 177(*/0xB1, 0x01/*)*/, /*TempRegID*//* 176(*/0xB0, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170179 */     GIR_AddImm, /*InsnID*//* 177(*/0xB1, 0x01/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 170190 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 177(*/0xB1, 0x01/*)*/,
     /* 170193 */     GIR_MakeTempReg, /*TempRegID*//* 175(*/0xAF, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 170197 */     GIR_BuildMI, /*InsnID*//* 176(*/0xB0, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 170202 */     GIR_AddTempRegister, /*InsnID*//* 176(*/0xB0, 0x01/*)*/, /*TempRegID*//* 175(*/0xAF, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170209 */     GIR_AddSimpleTempRegister, /*InsnID*//* 176(*/0xB0, 0x01/*)*/, /*TempRegID*//* 176(*/0xB0, 0x01/*)*/,
     /* 170214 */     GIR_AddImm, /*InsnID*//* 176(*/0xB0, 0x01/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 170225 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 176(*/0xB0, 0x01/*)*/,
     /* 170228 */     GIR_MakeTempReg, /*TempRegID*//* 174(*/0xAE, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 170232 */     GIR_BuildMI, /*InsnID*//* 175(*/0xAF, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 170237 */     GIR_AddTempRegister, /*InsnID*//* 175(*/0xAF, 0x01/*)*/, /*TempRegID*//* 174(*/0xAE, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170244 */     GIR_AddImm, /*InsnID*//* 175(*/0xAF, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 170255 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 175(*/0xAF, 0x01/*)*/,
     /* 170258 */     GIR_MakeTempReg, /*TempRegID*//* 173(*/0xAD, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 170262 */     GIR_BuildMI, /*InsnID*//* 174(*/0xAE, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 170267 */     GIR_AddTempRegister, /*InsnID*//* 174(*/0xAE, 0x01/*)*/, /*TempRegID*//* 173(*/0xAD, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170274 */     GIR_AddSimpleTempRegister, /*InsnID*//* 174(*/0xAE, 0x01/*)*/, /*TempRegID*//* 174(*/0xAE, 0x01/*)*/,
     /* 170279 */     GIR_AddImm, /*InsnID*//* 174(*/0xAE, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 170290 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 174(*/0xAE, 0x01/*)*/,
     /* 170293 */     GIR_MakeTempReg, /*TempRegID*//* 172(*/0xAC, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 170297 */     GIR_BuildMI, /*InsnID*//* 173(*/0xAD, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 170302 */     GIR_AddTempRegister, /*InsnID*//* 173(*/0xAD, 0x01/*)*/, /*TempRegID*//* 172(*/0xAC, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170309 */     GIR_Copy, /*NewInsnID*//* 173(*/0xAD, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 170314 */     GIR_AddImm8, /*InsnID*//* 173(*/0xAD, 0x01/*)*/, /*Imm*/1,
     /* 170318 */     GIR_AddImm8, /*InsnID*//* 173(*/0xAD, 0x01/*)*/, /*Imm*/0,
     /* 170322 */     GIR_AddImm8, /*InsnID*//* 173(*/0xAD, 0x01/*)*/, /*Imm*/30,
     /* 170326 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 173(*/0xAD, 0x01/*)*/,
     /* 170329 */     GIR_MakeTempReg, /*TempRegID*//* 171(*/0xAB, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 170333 */     GIR_BuildMI, /*InsnID*//* 172(*/0xAC, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 170338 */     GIR_AddTempRegister, /*InsnID*//* 172(*/0xAC, 0x01/*)*/, /*TempRegID*//* 171(*/0xAB, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170345 */     GIR_AddSimpleTempRegister, /*InsnID*//* 172(*/0xAC, 0x01/*)*/, /*TempRegID*//* 172(*/0xAC, 0x01/*)*/,
     /* 170350 */     GIR_AddSimpleTempRegister, /*InsnID*//* 172(*/0xAC, 0x01/*)*/, /*TempRegID*//* 173(*/0xAD, 0x01/*)*/,
     /* 170355 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 172(*/0xAC, 0x01/*)*/,
     /* 170358 */     GIR_MakeTempReg, /*TempRegID*//* 170(*/0xAA, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 170362 */     GIR_BuildMI, /*InsnID*//* 171(*/0xAB, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 170367 */     GIR_AddTempRegister, /*InsnID*//* 171(*/0xAB, 0x01/*)*/, /*TempRegID*//* 170(*/0xAA, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170374 */     GIR_AddImm, /*InsnID*//* 171(*/0xAB, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 170385 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 171(*/0xAB, 0x01/*)*/,
     /* 170388 */     GIR_MakeTempReg, /*TempRegID*//* 169(*/0xA9, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 170392 */     GIR_BuildMI, /*InsnID*//* 170(*/0xAA, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 170397 */     GIR_AddTempRegister, /*InsnID*//* 170(*/0xAA, 0x01/*)*/, /*TempRegID*//* 169(*/0xA9, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170404 */     GIR_AddSimpleTempRegister, /*InsnID*//* 170(*/0xAA, 0x01/*)*/, /*TempRegID*//* 170(*/0xAA, 0x01/*)*/,
     /* 170409 */     GIR_AddImm, /*InsnID*//* 170(*/0xAA, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 170420 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 170(*/0xAA, 0x01/*)*/,
     /* 170423 */     GIR_MakeTempReg, /*TempRegID*//* 168(*/0xA8, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 170427 */     GIR_BuildMI, /*InsnID*//* 169(*/0xA9, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 170432 */     GIR_AddTempRegister, /*InsnID*//* 169(*/0xA9, 0x01/*)*/, /*TempRegID*//* 168(*/0xA8, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170439 */     GIR_Copy, /*NewInsnID*//* 169(*/0xA9, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 170444 */     GIR_AddImm8, /*InsnID*//* 169(*/0xA9, 0x01/*)*/, /*Imm*/31,
     /* 170448 */     GIR_AddImm8, /*InsnID*//* 169(*/0xA9, 0x01/*)*/, /*Imm*/1,
     /* 170452 */     GIR_AddImm8, /*InsnID*//* 169(*/0xA9, 0x01/*)*/, /*Imm*/31,
     /* 170456 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 169(*/0xA9, 0x01/*)*/,
     /* 170459 */     GIR_MakeTempReg, /*TempRegID*//* 167(*/0xA7, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 170463 */     GIR_BuildMI, /*InsnID*//* 168(*/0xA8, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 170468 */     GIR_AddTempRegister, /*InsnID*//* 168(*/0xA8, 0x01/*)*/, /*TempRegID*//* 167(*/0xA7, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170475 */     GIR_AddSimpleTempRegister, /*InsnID*//* 168(*/0xA8, 0x01/*)*/, /*TempRegID*//* 168(*/0xA8, 0x01/*)*/,
     /* 170480 */     GIR_AddSimpleTempRegister, /*InsnID*//* 168(*/0xA8, 0x01/*)*/, /*TempRegID*//* 169(*/0xA9, 0x01/*)*/,
     /* 170485 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 168(*/0xA8, 0x01/*)*/,
     /* 170488 */     GIR_MakeTempReg, /*TempRegID*//* 166(*/0xA6, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 170492 */     GIR_BuildMI, /*InsnID*//* 167(*/0xA7, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 170497 */     GIR_AddTempRegister, /*InsnID*//* 167(*/0xA7, 0x01/*)*/, /*TempRegID*//* 166(*/0xA6, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170504 */     GIR_AddSimpleTempRegister, /*InsnID*//* 167(*/0xA7, 0x01/*)*/, /*TempRegID*//* 167(*/0xA7, 0x01/*)*/,
     /* 170509 */     GIR_AddSimpleTempRegister, /*InsnID*//* 167(*/0xA7, 0x01/*)*/, /*TempRegID*//* 171(*/0xAB, 0x01/*)*/,
     /* 170514 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 167(*/0xA7, 0x01/*)*/,
     /* 170517 */     GIR_MakeTempReg, /*TempRegID*//* 165(*/0xA5, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 170521 */     GIR_BuildMI, /*InsnID*//* 166(*/0xA6, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 170526 */     GIR_AddTempRegister, /*InsnID*//* 166(*/0xA6, 0x01/*)*/, /*TempRegID*//* 165(*/0xA5, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170533 */     GIR_AddSimpleTempRegister, /*InsnID*//* 166(*/0xA6, 0x01/*)*/, /*TempRegID*//* 166(*/0xA6, 0x01/*)*/,
     /* 170538 */     GIR_AddImm8, /*InsnID*//* 166(*/0xA6, 0x01/*)*/, /*Imm*/30,
     /* 170542 */     GIR_AddImm8, /*InsnID*//* 166(*/0xA6, 0x01/*)*/, /*Imm*/2,
     /* 170546 */     GIR_AddImm8, /*InsnID*//* 166(*/0xA6, 0x01/*)*/, /*Imm*/31,
     /* 170550 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 166(*/0xA6, 0x01/*)*/,
     /* 170553 */     GIR_MakeTempReg, /*TempRegID*//* 164(*/0xA4, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 170557 */     GIR_BuildMI, /*InsnID*//* 165(*/0xA5, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 170562 */     GIR_AddTempRegister, /*InsnID*//* 165(*/0xA5, 0x01/*)*/, /*TempRegID*//* 164(*/0xA4, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170569 */     GIR_AddSimpleTempRegister, /*InsnID*//* 165(*/0xA5, 0x01/*)*/, /*TempRegID*//* 165(*/0xA5, 0x01/*)*/,
     /* 170574 */     GIR_AddSimpleTempRegister, /*InsnID*//* 165(*/0xA5, 0x01/*)*/, /*TempRegID*//* 175(*/0xAF, 0x01/*)*/,
     /* 170579 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 165(*/0xA5, 0x01/*)*/,
     /* 170582 */     GIR_MakeTempReg, /*TempRegID*//* 163(*/0xA3, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 170586 */     GIR_BuildMI, /*InsnID*//* 164(*/0xA4, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 170591 */     GIR_AddTempRegister, /*InsnID*//* 164(*/0xA4, 0x01/*)*/, /*TempRegID*//* 163(*/0xA3, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170598 */     GIR_AddSimpleTempRegister, /*InsnID*//* 164(*/0xA4, 0x01/*)*/, /*TempRegID*//* 164(*/0xA4, 0x01/*)*/,
     /* 170603 */     GIR_AddSimpleTempRegister, /*InsnID*//* 164(*/0xA4, 0x01/*)*/, /*TempRegID*//* 177(*/0xB1, 0x01/*)*/,
     /* 170608 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 164(*/0xA4, 0x01/*)*/,
     /* 170611 */     GIR_MakeTempReg, /*TempRegID*//* 162(*/0xA2, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 170615 */     GIR_BuildMI, /*InsnID*//* 163(*/0xA3, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 170620 */     GIR_AddTempRegister, /*InsnID*//* 163(*/0xA3, 0x01/*)*/, /*TempRegID*//* 162(*/0xA2, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170627 */     GIR_AddSimpleTempRegister, /*InsnID*//* 163(*/0xA3, 0x01/*)*/, /*TempRegID*//* 163(*/0xA3, 0x01/*)*/,
     /* 170632 */     GIR_AddImm8, /*InsnID*//* 163(*/0xA3, 0x01/*)*/, /*Imm*/4,
     /* 170636 */     GIR_AddImm8, /*InsnID*//* 163(*/0xA3, 0x01/*)*/, /*Imm*/0,
     /* 170640 */     GIR_AddImm8, /*InsnID*//* 163(*/0xA3, 0x01/*)*/, /*Imm*/27,
     /* 170644 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 163(*/0xA3, 0x01/*)*/,
     /* 170647 */     GIR_MakeTempReg, /*TempRegID*//* 161(*/0xA1, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 170651 */     GIR_BuildMI, /*InsnID*//* 162(*/0xA2, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 170656 */     GIR_AddTempRegister, /*InsnID*//* 162(*/0xA2, 0x01/*)*/, /*TempRegID*//* 161(*/0xA1, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170663 */     GIR_AddSimpleTempRegister, /*InsnID*//* 162(*/0xA2, 0x01/*)*/, /*TempRegID*//* 162(*/0xA2, 0x01/*)*/,
     /* 170668 */     GIR_AddSimpleTempRegister, /*InsnID*//* 162(*/0xA2, 0x01/*)*/, /*TempRegID*//* 190(*/0xBE, 0x01/*)*/,
     /* 170673 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 162(*/0xA2, 0x01/*)*/,
     /* 170676 */     GIR_MakeTempReg, /*TempRegID*//* 160(*/0xA0, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 170680 */     GIR_BuildMI, /*InsnID*//* 161(*/0xA1, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 170685 */     GIR_AddTempRegister, /*InsnID*//* 161(*/0xA1, 0x01/*)*/, /*TempRegID*//* 160(*/0xA0, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170692 */     GIR_AddImm, /*InsnID*//* 161(*/0xA1, 0x01/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 170703 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 161(*/0xA1, 0x01/*)*/,
     /* 170706 */     GIR_MakeTempReg, /*TempRegID*//* 159(*/0x9F, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 170710 */     GIR_BuildMI, /*InsnID*//* 160(*/0xA0, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 170715 */     GIR_AddTempRegister, /*InsnID*//* 160(*/0xA0, 0x01/*)*/, /*TempRegID*//* 159(*/0x9F, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170722 */     GIR_AddSimpleTempRegister, /*InsnID*//* 160(*/0xA0, 0x01/*)*/, /*TempRegID*//* 160(*/0xA0, 0x01/*)*/,
     /* 170727 */     GIR_AddImm, /*InsnID*//* 160(*/0xA0, 0x01/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 170738 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 160(*/0xA0, 0x01/*)*/,
     /* 170741 */     GIR_MakeTempReg, /*TempRegID*//* 158(*/0x9E, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 170745 */     GIR_BuildMI, /*InsnID*//* 159(*/0x9F, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 170750 */     GIR_AddTempRegister, /*InsnID*//* 159(*/0x9F, 0x01/*)*/, /*TempRegID*//* 158(*/0x9E, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170757 */     GIR_AddImm, /*InsnID*//* 159(*/0x9F, 0x01/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 170768 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 159(*/0x9F, 0x01/*)*/,
     /* 170771 */     GIR_MakeTempReg, /*TempRegID*//* 157(*/0x9D, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 170775 */     GIR_BuildMI, /*InsnID*//* 158(*/0x9E, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 170780 */     GIR_AddTempRegister, /*InsnID*//* 158(*/0x9E, 0x01/*)*/, /*TempRegID*//* 157(*/0x9D, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170787 */     GIR_AddSimpleTempRegister, /*InsnID*//* 158(*/0x9E, 0x01/*)*/, /*TempRegID*//* 158(*/0x9E, 0x01/*)*/,
     /* 170792 */     GIR_AddImm, /*InsnID*//* 158(*/0x9E, 0x01/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 170803 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 158(*/0x9E, 0x01/*)*/,
     /* 170806 */     GIR_MakeTempReg, /*TempRegID*//* 156(*/0x9C, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 170810 */     GIR_BuildMI, /*InsnID*//* 157(*/0x9D, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 170815 */     GIR_AddTempRegister, /*InsnID*//* 157(*/0x9D, 0x01/*)*/, /*TempRegID*//* 156(*/0x9C, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170822 */     GIR_AddImm, /*InsnID*//* 157(*/0x9D, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 170833 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 157(*/0x9D, 0x01/*)*/,
     /* 170836 */     GIR_MakeTempReg, /*TempRegID*//* 155(*/0x9B, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 170840 */     GIR_BuildMI, /*InsnID*//* 156(*/0x9C, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 170845 */     GIR_AddTempRegister, /*InsnID*//* 156(*/0x9C, 0x01/*)*/, /*TempRegID*//* 155(*/0x9B, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170852 */     GIR_AddSimpleTempRegister, /*InsnID*//* 156(*/0x9C, 0x01/*)*/, /*TempRegID*//* 156(*/0x9C, 0x01/*)*/,
     /* 170857 */     GIR_AddImm, /*InsnID*//* 156(*/0x9C, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 170868 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 156(*/0x9C, 0x01/*)*/,
     /* 170871 */     GIR_MakeTempReg, /*TempRegID*//* 154(*/0x9A, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 170875 */     GIR_BuildMI, /*InsnID*//* 155(*/0x9B, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 170880 */     GIR_AddTempRegister, /*InsnID*//* 155(*/0x9B, 0x01/*)*/, /*TempRegID*//* 154(*/0x9A, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170887 */     GIR_Copy, /*NewInsnID*//* 155(*/0x9B, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 170892 */     GIR_AddImm8, /*InsnID*//* 155(*/0x9B, 0x01/*)*/, /*Imm*/1,
     /* 170896 */     GIR_AddImm8, /*InsnID*//* 155(*/0x9B, 0x01/*)*/, /*Imm*/0,
     /* 170900 */     GIR_AddImm8, /*InsnID*//* 155(*/0x9B, 0x01/*)*/, /*Imm*/30,
     /* 170904 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 155(*/0x9B, 0x01/*)*/,
     /* 170907 */     GIR_MakeTempReg, /*TempRegID*//* 153(*/0x99, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 170911 */     GIR_BuildMI, /*InsnID*//* 154(*/0x9A, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 170916 */     GIR_AddTempRegister, /*InsnID*//* 154(*/0x9A, 0x01/*)*/, /*TempRegID*//* 153(*/0x99, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170923 */     GIR_AddSimpleTempRegister, /*InsnID*//* 154(*/0x9A, 0x01/*)*/, /*TempRegID*//* 154(*/0x9A, 0x01/*)*/,
     /* 170928 */     GIR_AddSimpleTempRegister, /*InsnID*//* 154(*/0x9A, 0x01/*)*/, /*TempRegID*//* 155(*/0x9B, 0x01/*)*/,
     /* 170933 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 154(*/0x9A, 0x01/*)*/,
     /* 170936 */     GIR_MakeTempReg, /*TempRegID*//* 152(*/0x98, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 170940 */     GIR_BuildMI, /*InsnID*//* 153(*/0x99, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 170945 */     GIR_AddTempRegister, /*InsnID*//* 153(*/0x99, 0x01/*)*/, /*TempRegID*//* 152(*/0x98, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170952 */     GIR_AddImm, /*InsnID*//* 153(*/0x99, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 170963 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 153(*/0x99, 0x01/*)*/,
     /* 170966 */     GIR_MakeTempReg, /*TempRegID*//* 151(*/0x97, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 170970 */     GIR_BuildMI, /*InsnID*//* 152(*/0x98, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 170975 */     GIR_AddTempRegister, /*InsnID*//* 152(*/0x98, 0x01/*)*/, /*TempRegID*//* 151(*/0x97, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170982 */     GIR_AddSimpleTempRegister, /*InsnID*//* 152(*/0x98, 0x01/*)*/, /*TempRegID*//* 152(*/0x98, 0x01/*)*/,
     /* 170987 */     GIR_AddImm, /*InsnID*//* 152(*/0x98, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 170998 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 152(*/0x98, 0x01/*)*/,
     /* 171001 */     GIR_MakeTempReg, /*TempRegID*//* 150(*/0x96, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 171005 */     GIR_BuildMI, /*InsnID*//* 151(*/0x97, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 171010 */     GIR_AddTempRegister, /*InsnID*//* 151(*/0x97, 0x01/*)*/, /*TempRegID*//* 150(*/0x96, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171017 */     GIR_Copy, /*NewInsnID*//* 151(*/0x97, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 171022 */     GIR_AddImm8, /*InsnID*//* 151(*/0x97, 0x01/*)*/, /*Imm*/31,
     /* 171026 */     GIR_AddImm8, /*InsnID*//* 151(*/0x97, 0x01/*)*/, /*Imm*/1,
     /* 171030 */     GIR_AddImm8, /*InsnID*//* 151(*/0x97, 0x01/*)*/, /*Imm*/31,
     /* 171034 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 151(*/0x97, 0x01/*)*/,
     /* 171037 */     GIR_MakeTempReg, /*TempRegID*//* 149(*/0x95, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 171041 */     GIR_BuildMI, /*InsnID*//* 150(*/0x96, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 171046 */     GIR_AddTempRegister, /*InsnID*//* 150(*/0x96, 0x01/*)*/, /*TempRegID*//* 149(*/0x95, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171053 */     GIR_AddSimpleTempRegister, /*InsnID*//* 150(*/0x96, 0x01/*)*/, /*TempRegID*//* 150(*/0x96, 0x01/*)*/,
     /* 171058 */     GIR_AddSimpleTempRegister, /*InsnID*//* 150(*/0x96, 0x01/*)*/, /*TempRegID*//* 151(*/0x97, 0x01/*)*/,
     /* 171063 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 150(*/0x96, 0x01/*)*/,
     /* 171066 */     GIR_MakeTempReg, /*TempRegID*//* 148(*/0x94, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 171070 */     GIR_BuildMI, /*InsnID*//* 149(*/0x95, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 171075 */     GIR_AddTempRegister, /*InsnID*//* 149(*/0x95, 0x01/*)*/, /*TempRegID*//* 148(*/0x94, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171082 */     GIR_AddSimpleTempRegister, /*InsnID*//* 149(*/0x95, 0x01/*)*/, /*TempRegID*//* 149(*/0x95, 0x01/*)*/,
     /* 171087 */     GIR_AddSimpleTempRegister, /*InsnID*//* 149(*/0x95, 0x01/*)*/, /*TempRegID*//* 153(*/0x99, 0x01/*)*/,
     /* 171092 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 149(*/0x95, 0x01/*)*/,
     /* 171095 */     GIR_MakeTempReg, /*TempRegID*//* 147(*/0x93, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 171099 */     GIR_BuildMI, /*InsnID*//* 148(*/0x94, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 171104 */     GIR_AddTempRegister, /*InsnID*//* 148(*/0x94, 0x01/*)*/, /*TempRegID*//* 147(*/0x93, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171111 */     GIR_AddSimpleTempRegister, /*InsnID*//* 148(*/0x94, 0x01/*)*/, /*TempRegID*//* 148(*/0x94, 0x01/*)*/,
     /* 171116 */     GIR_AddImm8, /*InsnID*//* 148(*/0x94, 0x01/*)*/, /*Imm*/2,
     /* 171120 */     GIR_AddImm8, /*InsnID*//* 148(*/0x94, 0x01/*)*/, /*Imm*/0,
     /* 171124 */     GIR_AddImm8, /*InsnID*//* 148(*/0x94, 0x01/*)*/, /*Imm*/29,
     /* 171128 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 148(*/0x94, 0x01/*)*/,
     /* 171131 */     GIR_MakeTempReg, /*TempRegID*//* 146(*/0x92, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 171135 */     GIR_BuildMI, /*InsnID*//* 147(*/0x93, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 171140 */     GIR_AddTempRegister, /*InsnID*//* 147(*/0x93, 0x01/*)*/, /*TempRegID*//* 146(*/0x92, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171147 */     GIR_AddSimpleTempRegister, /*InsnID*//* 147(*/0x93, 0x01/*)*/, /*TempRegID*//* 147(*/0x93, 0x01/*)*/,
     /* 171152 */     GIR_AddSimpleTempRegister, /*InsnID*//* 147(*/0x93, 0x01/*)*/, /*TempRegID*//* 157(*/0x9D, 0x01/*)*/,
     /* 171157 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 147(*/0x93, 0x01/*)*/,
     /* 171160 */     GIR_MakeTempReg, /*TempRegID*//* 145(*/0x91, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 171164 */     GIR_BuildMI, /*InsnID*//* 146(*/0x92, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 171169 */     GIR_AddTempRegister, /*InsnID*//* 146(*/0x92, 0x01/*)*/, /*TempRegID*//* 145(*/0x91, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171176 */     GIR_AddImm, /*InsnID*//* 146(*/0x92, 0x01/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 171187 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 146(*/0x92, 0x01/*)*/,
     /* 171190 */     GIR_MakeTempReg, /*TempRegID*//* 144(*/0x90, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 171194 */     GIR_BuildMI, /*InsnID*//* 145(*/0x91, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 171199 */     GIR_AddTempRegister, /*InsnID*//* 145(*/0x91, 0x01/*)*/, /*TempRegID*//* 144(*/0x90, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171206 */     GIR_AddSimpleTempRegister, /*InsnID*//* 145(*/0x91, 0x01/*)*/, /*TempRegID*//* 145(*/0x91, 0x01/*)*/,
     /* 171211 */     GIR_AddImm, /*InsnID*//* 145(*/0x91, 0x01/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 171222 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 145(*/0x91, 0x01/*)*/,
     /* 171225 */     GIR_MakeTempReg, /*TempRegID*//* 143(*/0x8F, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 171229 */     GIR_BuildMI, /*InsnID*//* 144(*/0x90, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 171234 */     GIR_AddTempRegister, /*InsnID*//* 144(*/0x90, 0x01/*)*/, /*TempRegID*//* 143(*/0x8F, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171241 */     GIR_AddImm, /*InsnID*//* 144(*/0x90, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 171252 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 144(*/0x90, 0x01/*)*/,
     /* 171255 */     GIR_MakeTempReg, /*TempRegID*//* 142(*/0x8E, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 171259 */     GIR_BuildMI, /*InsnID*//* 143(*/0x8F, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 171264 */     GIR_AddTempRegister, /*InsnID*//* 143(*/0x8F, 0x01/*)*/, /*TempRegID*//* 142(*/0x8E, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171271 */     GIR_AddSimpleTempRegister, /*InsnID*//* 143(*/0x8F, 0x01/*)*/, /*TempRegID*//* 143(*/0x8F, 0x01/*)*/,
     /* 171276 */     GIR_AddImm, /*InsnID*//* 143(*/0x8F, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 171287 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 143(*/0x8F, 0x01/*)*/,
     /* 171290 */     GIR_MakeTempReg, /*TempRegID*//* 141(*/0x8D, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 171294 */     GIR_BuildMI, /*InsnID*//* 142(*/0x8E, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 171299 */     GIR_AddTempRegister, /*InsnID*//* 142(*/0x8E, 0x01/*)*/, /*TempRegID*//* 141(*/0x8D, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171306 */     GIR_Copy, /*NewInsnID*//* 142(*/0x8E, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 171311 */     GIR_AddImm8, /*InsnID*//* 142(*/0x8E, 0x01/*)*/, /*Imm*/1,
     /* 171315 */     GIR_AddImm8, /*InsnID*//* 142(*/0x8E, 0x01/*)*/, /*Imm*/0,
     /* 171319 */     GIR_AddImm8, /*InsnID*//* 142(*/0x8E, 0x01/*)*/, /*Imm*/30,
     /* 171323 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 142(*/0x8E, 0x01/*)*/,
     /* 171326 */     GIR_MakeTempReg, /*TempRegID*//* 140(*/0x8C, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 171330 */     GIR_BuildMI, /*InsnID*//* 141(*/0x8D, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 171335 */     GIR_AddTempRegister, /*InsnID*//* 141(*/0x8D, 0x01/*)*/, /*TempRegID*//* 140(*/0x8C, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171342 */     GIR_AddSimpleTempRegister, /*InsnID*//* 141(*/0x8D, 0x01/*)*/, /*TempRegID*//* 141(*/0x8D, 0x01/*)*/,
     /* 171347 */     GIR_AddSimpleTempRegister, /*InsnID*//* 141(*/0x8D, 0x01/*)*/, /*TempRegID*//* 142(*/0x8E, 0x01/*)*/,
     /* 171352 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 141(*/0x8D, 0x01/*)*/,
     /* 171355 */     GIR_MakeTempReg, /*TempRegID*//* 139(*/0x8B, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 171359 */     GIR_BuildMI, /*InsnID*//* 140(*/0x8C, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 171364 */     GIR_AddTempRegister, /*InsnID*//* 140(*/0x8C, 0x01/*)*/, /*TempRegID*//* 139(*/0x8B, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171371 */     GIR_AddImm, /*InsnID*//* 140(*/0x8C, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 171382 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 140(*/0x8C, 0x01/*)*/,
     /* 171385 */     GIR_MakeTempReg, /*TempRegID*//* 138(*/0x8A, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 171389 */     GIR_BuildMI, /*InsnID*//* 139(*/0x8B, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 171394 */     GIR_AddTempRegister, /*InsnID*//* 139(*/0x8B, 0x01/*)*/, /*TempRegID*//* 138(*/0x8A, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171401 */     GIR_AddSimpleTempRegister, /*InsnID*//* 139(*/0x8B, 0x01/*)*/, /*TempRegID*//* 139(*/0x8B, 0x01/*)*/,
     /* 171406 */     GIR_AddImm, /*InsnID*//* 139(*/0x8B, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 171417 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 139(*/0x8B, 0x01/*)*/,
     /* 171420 */     GIR_MakeTempReg, /*TempRegID*//* 137(*/0x89, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 171424 */     GIR_BuildMI, /*InsnID*//* 138(*/0x8A, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 171429 */     GIR_AddTempRegister, /*InsnID*//* 138(*/0x8A, 0x01/*)*/, /*TempRegID*//* 137(*/0x89, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171436 */     GIR_Copy, /*NewInsnID*//* 138(*/0x8A, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 171441 */     GIR_AddImm8, /*InsnID*//* 138(*/0x8A, 0x01/*)*/, /*Imm*/31,
     /* 171445 */     GIR_AddImm8, /*InsnID*//* 138(*/0x8A, 0x01/*)*/, /*Imm*/1,
     /* 171449 */     GIR_AddImm8, /*InsnID*//* 138(*/0x8A, 0x01/*)*/, /*Imm*/31,
     /* 171453 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 138(*/0x8A, 0x01/*)*/,
     /* 171456 */     GIR_MakeTempReg, /*TempRegID*//* 136(*/0x88, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 171460 */     GIR_BuildMI, /*InsnID*//* 137(*/0x89, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 171465 */     GIR_AddTempRegister, /*InsnID*//* 137(*/0x89, 0x01/*)*/, /*TempRegID*//* 136(*/0x88, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171472 */     GIR_AddSimpleTempRegister, /*InsnID*//* 137(*/0x89, 0x01/*)*/, /*TempRegID*//* 137(*/0x89, 0x01/*)*/,
     /* 171477 */     GIR_AddSimpleTempRegister, /*InsnID*//* 137(*/0x89, 0x01/*)*/, /*TempRegID*//* 138(*/0x8A, 0x01/*)*/,
     /* 171482 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 137(*/0x89, 0x01/*)*/,
     /* 171485 */     GIR_MakeTempReg, /*TempRegID*//* 135(*/0x87, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 171489 */     GIR_BuildMI, /*InsnID*//* 136(*/0x88, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 171494 */     GIR_AddTempRegister, /*InsnID*//* 136(*/0x88, 0x01/*)*/, /*TempRegID*//* 135(*/0x87, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171501 */     GIR_AddSimpleTempRegister, /*InsnID*//* 136(*/0x88, 0x01/*)*/, /*TempRegID*//* 136(*/0x88, 0x01/*)*/,
     /* 171506 */     GIR_AddSimpleTempRegister, /*InsnID*//* 136(*/0x88, 0x01/*)*/, /*TempRegID*//* 140(*/0x8C, 0x01/*)*/,
     /* 171511 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 136(*/0x88, 0x01/*)*/,
     /* 171514 */     GIR_MakeTempReg, /*TempRegID*//* 134(*/0x86, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 171518 */     GIR_BuildMI, /*InsnID*//* 135(*/0x87, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 171523 */     GIR_AddTempRegister, /*InsnID*//* 135(*/0x87, 0x01/*)*/, /*TempRegID*//* 134(*/0x86, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171530 */     GIR_AddSimpleTempRegister, /*InsnID*//* 135(*/0x87, 0x01/*)*/, /*TempRegID*//* 135(*/0x87, 0x01/*)*/,
     /* 171535 */     GIR_AddImm8, /*InsnID*//* 135(*/0x87, 0x01/*)*/, /*Imm*/30,
     /* 171539 */     GIR_AddImm8, /*InsnID*//* 135(*/0x87, 0x01/*)*/, /*Imm*/2,
     /* 171543 */     GIR_AddImm8, /*InsnID*//* 135(*/0x87, 0x01/*)*/, /*Imm*/31,
     /* 171547 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 135(*/0x87, 0x01/*)*/,
     /* 171550 */     GIR_MakeTempReg, /*TempRegID*//* 133(*/0x85, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 171554 */     GIR_BuildMI, /*InsnID*//* 134(*/0x86, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 171559 */     GIR_AddTempRegister, /*InsnID*//* 134(*/0x86, 0x01/*)*/, /*TempRegID*//* 133(*/0x85, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171566 */     GIR_AddSimpleTempRegister, /*InsnID*//* 134(*/0x86, 0x01/*)*/, /*TempRegID*//* 134(*/0x86, 0x01/*)*/,
     /* 171571 */     GIR_AddSimpleTempRegister, /*InsnID*//* 134(*/0x86, 0x01/*)*/, /*TempRegID*//* 144(*/0x90, 0x01/*)*/,
     /* 171576 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 134(*/0x86, 0x01/*)*/,
     /* 171579 */     GIR_MakeTempReg, /*TempRegID*//* 132(*/0x84, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 171583 */     GIR_BuildMI, /*InsnID*//* 133(*/0x85, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 171588 */     GIR_AddTempRegister, /*InsnID*//* 133(*/0x85, 0x01/*)*/, /*TempRegID*//* 132(*/0x84, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171595 */     GIR_AddSimpleTempRegister, /*InsnID*//* 133(*/0x85, 0x01/*)*/, /*TempRegID*//* 133(*/0x85, 0x01/*)*/,
     /* 171600 */     GIR_AddSimpleTempRegister, /*InsnID*//* 133(*/0x85, 0x01/*)*/, /*TempRegID*//* 146(*/0x92, 0x01/*)*/,
     /* 171605 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 133(*/0x85, 0x01/*)*/,
     /* 171608 */     GIR_MakeTempReg, /*TempRegID*//* 131(*/0x83, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 171612 */     GIR_BuildMI, /*InsnID*//* 132(*/0x84, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 171617 */     GIR_AddTempRegister, /*InsnID*//* 132(*/0x84, 0x01/*)*/, /*TempRegID*//* 131(*/0x83, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171624 */     GIR_AddSimpleTempRegister, /*InsnID*//* 132(*/0x84, 0x01/*)*/, /*TempRegID*//* 132(*/0x84, 0x01/*)*/,
     /* 171629 */     GIR_AddImm8, /*InsnID*//* 132(*/0x84, 0x01/*)*/, /*Imm*/28,
     /* 171633 */     GIR_AddImm8, /*InsnID*//* 132(*/0x84, 0x01/*)*/, /*Imm*/4,
     /* 171637 */     GIR_AddImm8, /*InsnID*//* 132(*/0x84, 0x01/*)*/, /*Imm*/31,
     /* 171641 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 132(*/0x84, 0x01/*)*/,
     /* 171644 */     GIR_MakeTempReg, /*TempRegID*//* 130(*/0x82, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 171648 */     GIR_BuildMI, /*InsnID*//* 131(*/0x83, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 171653 */     GIR_AddTempRegister, /*InsnID*//* 131(*/0x83, 0x01/*)*/, /*TempRegID*//* 130(*/0x82, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171660 */     GIR_AddSimpleTempRegister, /*InsnID*//* 131(*/0x83, 0x01/*)*/, /*TempRegID*//* 131(*/0x83, 0x01/*)*/,
     /* 171665 */     GIR_AddSimpleTempRegister, /*InsnID*//* 131(*/0x83, 0x01/*)*/, /*TempRegID*//* 159(*/0x9F, 0x01/*)*/,
     /* 171670 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 131(*/0x83, 0x01/*)*/,
     /* 171673 */     GIR_MakeTempReg, /*TempRegID*//* 129(*/0x81, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 171677 */     GIR_BuildMI, /*InsnID*//* 130(*/0x82, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 171682 */     GIR_AddTempRegister, /*InsnID*//* 130(*/0x82, 0x01/*)*/, /*TempRegID*//* 129(*/0x81, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171689 */     GIR_AddSimpleTempRegister, /*InsnID*//* 130(*/0x82, 0x01/*)*/, /*TempRegID*//* 130(*/0x82, 0x01/*)*/,
     /* 171694 */     GIR_AddSimpleTempRegister, /*InsnID*//* 130(*/0x82, 0x01/*)*/, /*TempRegID*//* 161(*/0xA1, 0x01/*)*/,
     /* 171699 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 130(*/0x82, 0x01/*)*/,
     /* 171702 */     GIR_MakeTempReg, /*TempRegID*//* 128(*/0x80, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 171706 */     GIR_BuildMI, /*InsnID*//* 129(*/0x81, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 171711 */     GIR_AddTempRegister, /*InsnID*//* 129(*/0x81, 0x01/*)*/, /*TempRegID*//* 128(*/0x80, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171718 */     GIR_AddImm, /*InsnID*//* 129(*/0x81, 0x01/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 171729 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 129(*/0x81, 0x01/*)*/,
     /* 171732 */     GIR_MakeTempReg, /*TempRegID*/127, /*TypeID*/GILLT_s32,
     /* 171735 */     GIR_BuildMI, /*InsnID*//* 128(*/0x80, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 171740 */     GIR_AddTempRegister, /*InsnID*//* 128(*/0x80, 0x01/*)*/, /*TempRegID*/127, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171746 */     GIR_AddSimpleTempRegister, /*InsnID*//* 128(*/0x80, 0x01/*)*/, /*TempRegID*//* 128(*/0x80, 0x01/*)*/,
     /* 171751 */     GIR_AddImm, /*InsnID*//* 128(*/0x80, 0x01/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 171762 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 128(*/0x80, 0x01/*)*/,
     /* 171765 */     GIR_MakeTempReg, /*TempRegID*/126, /*TypeID*/GILLT_s32,
     /* 171768 */     GIR_BuildMI, /*InsnID*/127, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 171772 */     GIR_AddTempRegister, /*InsnID*/127, /*TempRegID*/126, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171777 */     GIR_AddImm, /*InsnID*/127, /*Imm*/GIMT_Encode8(52428),
     /* 171787 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/127,
     /* 171789 */     GIR_MakeTempReg, /*TempRegID*/125, /*TypeID*/GILLT_s32,
     /* 171792 */     GIR_BuildMI, /*InsnID*/126, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 171796 */     GIR_AddTempRegister, /*InsnID*/126, /*TempRegID*/125, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171801 */     GIR_AddSimpleTempRegister, /*InsnID*/126, /*TempRegID*/126,
     /* 171804 */     GIR_AddImm, /*InsnID*/126, /*Imm*/GIMT_Encode8(52428),
     /* 171814 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/126,
     /* 171816 */     GIR_MakeTempReg, /*TempRegID*/124, /*TypeID*/GILLT_s32,
     /* 171819 */     GIR_BuildMI, /*InsnID*/125, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 171823 */     GIR_AddTempRegister, /*InsnID*/125, /*TempRegID*/124, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171828 */     GIR_AddImm, /*InsnID*/125, /*Imm*/GIMT_Encode8(43690),
     /* 171838 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/125,
     /* 171840 */     GIR_MakeTempReg, /*TempRegID*/123, /*TypeID*/GILLT_s32,
     /* 171843 */     GIR_BuildMI, /*InsnID*/124, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 171847 */     GIR_AddTempRegister, /*InsnID*/124, /*TempRegID*/123, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171852 */     GIR_AddSimpleTempRegister, /*InsnID*/124, /*TempRegID*/124,
     /* 171855 */     GIR_AddImm, /*InsnID*/124, /*Imm*/GIMT_Encode8(43690),
     /* 171865 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/124,
     /* 171867 */     GIR_MakeTempReg, /*TempRegID*/122, /*TypeID*/GILLT_s32,
     /* 171870 */     GIR_BuildMI, /*InsnID*/123, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 171874 */     GIR_AddTempRegister, /*InsnID*/123, /*TempRegID*/122, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171879 */     GIR_Copy, /*NewInsnID*/123, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 171883 */     GIR_AddImm8, /*InsnID*/123, /*Imm*/1,
     /* 171886 */     GIR_AddImm8, /*InsnID*/123, /*Imm*/0,
     /* 171889 */     GIR_AddImm8, /*InsnID*/123, /*Imm*/30,
     /* 171892 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/123,
     /* 171894 */     GIR_MakeTempReg, /*TempRegID*/121, /*TypeID*/GILLT_s32,
     /* 171897 */     GIR_BuildMI, /*InsnID*/122, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 171901 */     GIR_AddTempRegister, /*InsnID*/122, /*TempRegID*/121, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171906 */     GIR_AddSimpleTempRegister, /*InsnID*/122, /*TempRegID*/122,
     /* 171909 */     GIR_AddSimpleTempRegister, /*InsnID*/122, /*TempRegID*/123,
     /* 171912 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/122,
     /* 171914 */     GIR_MakeTempReg, /*TempRegID*/120, /*TypeID*/GILLT_s32,
     /* 171917 */     GIR_BuildMI, /*InsnID*/121, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 171921 */     GIR_AddTempRegister, /*InsnID*/121, /*TempRegID*/120, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171926 */     GIR_AddImm, /*InsnID*/121, /*Imm*/GIMT_Encode8(21845),
     /* 171936 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/121,
     /* 171938 */     GIR_MakeTempReg, /*TempRegID*/119, /*TypeID*/GILLT_s32,
     /* 171941 */     GIR_BuildMI, /*InsnID*/120, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 171945 */     GIR_AddTempRegister, /*InsnID*/120, /*TempRegID*/119, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171950 */     GIR_AddSimpleTempRegister, /*InsnID*/120, /*TempRegID*/120,
     /* 171953 */     GIR_AddImm, /*InsnID*/120, /*Imm*/GIMT_Encode8(21845),
     /* 171963 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/120,
     /* 171965 */     GIR_MakeTempReg, /*TempRegID*/118, /*TypeID*/GILLT_s32,
     /* 171968 */     GIR_BuildMI, /*InsnID*/119, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 171972 */     GIR_AddTempRegister, /*InsnID*/119, /*TempRegID*/118, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171977 */     GIR_Copy, /*NewInsnID*/119, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 171981 */     GIR_AddImm8, /*InsnID*/119, /*Imm*/31,
     /* 171984 */     GIR_AddImm8, /*InsnID*/119, /*Imm*/1,
     /* 171987 */     GIR_AddImm8, /*InsnID*/119, /*Imm*/31,
     /* 171990 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/119,
     /* 171992 */     GIR_MakeTempReg, /*TempRegID*/117, /*TypeID*/GILLT_s32,
     /* 171995 */     GIR_BuildMI, /*InsnID*/118, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 171999 */     GIR_AddTempRegister, /*InsnID*/118, /*TempRegID*/117, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172004 */     GIR_AddSimpleTempRegister, /*InsnID*/118, /*TempRegID*/118,
     /* 172007 */     GIR_AddSimpleTempRegister, /*InsnID*/118, /*TempRegID*/119,
     /* 172010 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/118,
     /* 172012 */     GIR_MakeTempReg, /*TempRegID*/116, /*TypeID*/GILLT_s32,
     /* 172015 */     GIR_BuildMI, /*InsnID*/117, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 172019 */     GIR_AddTempRegister, /*InsnID*/117, /*TempRegID*/116, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172024 */     GIR_AddSimpleTempRegister, /*InsnID*/117, /*TempRegID*/117,
     /* 172027 */     GIR_AddSimpleTempRegister, /*InsnID*/117, /*TempRegID*/121,
     /* 172030 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/117,
     /* 172032 */     GIR_MakeTempReg, /*TempRegID*/115, /*TypeID*/GILLT_s32,
     /* 172035 */     GIR_BuildMI, /*InsnID*/116, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 172039 */     GIR_AddTempRegister, /*InsnID*/116, /*TempRegID*/115, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172044 */     GIR_AddSimpleTempRegister, /*InsnID*/116, /*TempRegID*/116,
     /* 172047 */     GIR_AddImm8, /*InsnID*/116, /*Imm*/2,
     /* 172050 */     GIR_AddImm8, /*InsnID*/116, /*Imm*/0,
     /* 172053 */     GIR_AddImm8, /*InsnID*/116, /*Imm*/29,
     /* 172056 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/116,
     /* 172058 */     GIR_MakeTempReg, /*TempRegID*/114, /*TypeID*/GILLT_s32,
     /* 172061 */     GIR_BuildMI, /*InsnID*/115, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 172065 */     GIR_AddTempRegister, /*InsnID*/115, /*TempRegID*/114, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172070 */     GIR_AddSimpleTempRegister, /*InsnID*/115, /*TempRegID*/115,
     /* 172073 */     GIR_AddSimpleTempRegister, /*InsnID*/115, /*TempRegID*/125,
     /* 172076 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/115,
     /* 172078 */     GIR_MakeTempReg, /*TempRegID*/113, /*TypeID*/GILLT_s32,
     /* 172081 */     GIR_BuildMI, /*InsnID*/114, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 172085 */     GIR_AddTempRegister, /*InsnID*/114, /*TempRegID*/113, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172090 */     GIR_AddImm, /*InsnID*/114, /*Imm*/GIMT_Encode8(13107),
     /* 172100 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/114,
     /* 172102 */     GIR_MakeTempReg, /*TempRegID*/112, /*TypeID*/GILLT_s32,
     /* 172105 */     GIR_BuildMI, /*InsnID*/113, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 172109 */     GIR_AddTempRegister, /*InsnID*/113, /*TempRegID*/112, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172114 */     GIR_AddSimpleTempRegister, /*InsnID*/113, /*TempRegID*/113,
     /* 172117 */     GIR_AddImm, /*InsnID*/113, /*Imm*/GIMT_Encode8(13107),
     /* 172127 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/113,
     /* 172129 */     GIR_MakeTempReg, /*TempRegID*/111, /*TypeID*/GILLT_s32,
     /* 172132 */     GIR_BuildMI, /*InsnID*/112, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 172136 */     GIR_AddTempRegister, /*InsnID*/112, /*TempRegID*/111, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172141 */     GIR_AddImm, /*InsnID*/112, /*Imm*/GIMT_Encode8(43690),
     /* 172151 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/112,
     /* 172153 */     GIR_MakeTempReg, /*TempRegID*/110, /*TypeID*/GILLT_s32,
     /* 172156 */     GIR_BuildMI, /*InsnID*/111, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 172160 */     GIR_AddTempRegister, /*InsnID*/111, /*TempRegID*/110, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172165 */     GIR_AddSimpleTempRegister, /*InsnID*/111, /*TempRegID*/111,
     /* 172168 */     GIR_AddImm, /*InsnID*/111, /*Imm*/GIMT_Encode8(43690),
     /* 172178 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/111,
     /* 172180 */     GIR_MakeTempReg, /*TempRegID*/109, /*TypeID*/GILLT_s32,
     /* 172183 */     GIR_BuildMI, /*InsnID*/110, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 172187 */     GIR_AddTempRegister, /*InsnID*/110, /*TempRegID*/109, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172192 */     GIR_Copy, /*NewInsnID*/110, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 172196 */     GIR_AddImm8, /*InsnID*/110, /*Imm*/1,
     /* 172199 */     GIR_AddImm8, /*InsnID*/110, /*Imm*/0,
     /* 172202 */     GIR_AddImm8, /*InsnID*/110, /*Imm*/30,
     /* 172205 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/110,
     /* 172207 */     GIR_MakeTempReg, /*TempRegID*/108, /*TypeID*/GILLT_s32,
     /* 172210 */     GIR_BuildMI, /*InsnID*/109, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 172214 */     GIR_AddTempRegister, /*InsnID*/109, /*TempRegID*/108, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172219 */     GIR_AddSimpleTempRegister, /*InsnID*/109, /*TempRegID*/109,
     /* 172222 */     GIR_AddSimpleTempRegister, /*InsnID*/109, /*TempRegID*/110,
     /* 172225 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/109,
     /* 172227 */     GIR_MakeTempReg, /*TempRegID*/107, /*TypeID*/GILLT_s32,
     /* 172230 */     GIR_BuildMI, /*InsnID*/108, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 172234 */     GIR_AddTempRegister, /*InsnID*/108, /*TempRegID*/107, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172239 */     GIR_AddImm, /*InsnID*/108, /*Imm*/GIMT_Encode8(21845),
     /* 172249 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/108,
     /* 172251 */     GIR_MakeTempReg, /*TempRegID*/106, /*TypeID*/GILLT_s32,
     /* 172254 */     GIR_BuildMI, /*InsnID*/107, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 172258 */     GIR_AddTempRegister, /*InsnID*/107, /*TempRegID*/106, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172263 */     GIR_AddSimpleTempRegister, /*InsnID*/107, /*TempRegID*/107,
     /* 172266 */     GIR_AddImm, /*InsnID*/107, /*Imm*/GIMT_Encode8(21845),
     /* 172276 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/107,
     /* 172278 */     GIR_MakeTempReg, /*TempRegID*/105, /*TypeID*/GILLT_s32,
     /* 172281 */     GIR_BuildMI, /*InsnID*/106, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 172285 */     GIR_AddTempRegister, /*InsnID*/106, /*TempRegID*/105, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172290 */     GIR_Copy, /*NewInsnID*/106, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 172294 */     GIR_AddImm8, /*InsnID*/106, /*Imm*/31,
     /* 172297 */     GIR_AddImm8, /*InsnID*/106, /*Imm*/1,
     /* 172300 */     GIR_AddImm8, /*InsnID*/106, /*Imm*/31,
     /* 172303 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/106,
     /* 172305 */     GIR_MakeTempReg, /*TempRegID*/104, /*TypeID*/GILLT_s32,
     /* 172308 */     GIR_BuildMI, /*InsnID*/105, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 172312 */     GIR_AddTempRegister, /*InsnID*/105, /*TempRegID*/104, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172317 */     GIR_AddSimpleTempRegister, /*InsnID*/105, /*TempRegID*/105,
     /* 172320 */     GIR_AddSimpleTempRegister, /*InsnID*/105, /*TempRegID*/106,
     /* 172323 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/105,
     /* 172325 */     GIR_MakeTempReg, /*TempRegID*/103, /*TypeID*/GILLT_s32,
     /* 172328 */     GIR_BuildMI, /*InsnID*/104, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 172332 */     GIR_AddTempRegister, /*InsnID*/104, /*TempRegID*/103, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172337 */     GIR_AddSimpleTempRegister, /*InsnID*/104, /*TempRegID*/104,
     /* 172340 */     GIR_AddSimpleTempRegister, /*InsnID*/104, /*TempRegID*/108,
     /* 172343 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/104,
     /* 172345 */     GIR_MakeTempReg, /*TempRegID*/102, /*TypeID*/GILLT_s32,
     /* 172348 */     GIR_BuildMI, /*InsnID*/103, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 172352 */     GIR_AddTempRegister, /*InsnID*/103, /*TempRegID*/102, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172357 */     GIR_AddSimpleTempRegister, /*InsnID*/103, /*TempRegID*/103,
     /* 172360 */     GIR_AddImm8, /*InsnID*/103, /*Imm*/30,
     /* 172363 */     GIR_AddImm8, /*InsnID*/103, /*Imm*/2,
     /* 172366 */     GIR_AddImm8, /*InsnID*/103, /*Imm*/31,
     /* 172369 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/103,
     /* 172371 */     GIR_MakeTempReg, /*TempRegID*/101, /*TypeID*/GILLT_s32,
     /* 172374 */     GIR_BuildMI, /*InsnID*/102, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 172378 */     GIR_AddTempRegister, /*InsnID*/102, /*TempRegID*/101, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172383 */     GIR_AddSimpleTempRegister, /*InsnID*/102, /*TempRegID*/102,
     /* 172386 */     GIR_AddSimpleTempRegister, /*InsnID*/102, /*TempRegID*/112,
     /* 172389 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/102,
     /* 172391 */     GIR_MakeTempReg, /*TempRegID*/100, /*TypeID*/GILLT_s32,
     /* 172394 */     GIR_BuildMI, /*InsnID*/101, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 172398 */     GIR_AddTempRegister, /*InsnID*/101, /*TempRegID*/100, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172403 */     GIR_AddSimpleTempRegister, /*InsnID*/101, /*TempRegID*/101,
     /* 172406 */     GIR_AddSimpleTempRegister, /*InsnID*/101, /*TempRegID*/114,
     /* 172409 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/101,
     /* 172411 */     GIR_MakeTempReg, /*TempRegID*/99, /*TypeID*/GILLT_s32,
     /* 172414 */     GIR_BuildMI, /*InsnID*/100, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 172418 */     GIR_AddTempRegister, /*InsnID*/100, /*TempRegID*/99, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172423 */     GIR_AddSimpleTempRegister, /*InsnID*/100, /*TempRegID*/100,
     /* 172426 */     GIR_AddImm8, /*InsnID*/100, /*Imm*/4,
     /* 172429 */     GIR_AddImm8, /*InsnID*/100, /*Imm*/0,
     /* 172432 */     GIR_AddImm8, /*InsnID*/100, /*Imm*/27,
     /* 172435 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/100,
     /* 172437 */     GIR_MakeTempReg, /*TempRegID*/98, /*TypeID*/GILLT_s32,
     /* 172440 */     GIR_BuildMI, /*InsnID*/99, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 172444 */     GIR_AddTempRegister, /*InsnID*/99, /*TempRegID*/98, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172449 */     GIR_AddSimpleTempRegister, /*InsnID*/99, /*TempRegID*/99,
     /* 172452 */     GIR_AddSimpleTempRegister, /*InsnID*/99, /*TempRegID*/127,
     /* 172455 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/99,
     /* 172457 */     GIR_MakeTempReg, /*TempRegID*/97, /*TypeID*/GILLT_s32,
     /* 172460 */     GIR_BuildMI, /*InsnID*/98, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 172464 */     GIR_AddTempRegister, /*InsnID*/98, /*TempRegID*/97, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172469 */     GIR_AddImm, /*InsnID*/98, /*Imm*/GIMT_Encode8(3855),
     /* 172479 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/98,
     /* 172481 */     GIR_MakeTempReg, /*TempRegID*/96, /*TypeID*/GILLT_s32,
     /* 172484 */     GIR_BuildMI, /*InsnID*/97, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 172488 */     GIR_AddTempRegister, /*InsnID*/97, /*TempRegID*/96, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172493 */     GIR_AddSimpleTempRegister, /*InsnID*/97, /*TempRegID*/97,
     /* 172496 */     GIR_AddImm, /*InsnID*/97, /*Imm*/GIMT_Encode8(3855),
     /* 172506 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/97,
     /* 172508 */     GIR_MakeTempReg, /*TempRegID*/95, /*TypeID*/GILLT_s32,
     /* 172511 */     GIR_BuildMI, /*InsnID*/96, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 172515 */     GIR_AddTempRegister, /*InsnID*/96, /*TempRegID*/95, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172520 */     GIR_AddImm, /*InsnID*/96, /*Imm*/GIMT_Encode8(52428),
     /* 172530 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/96,
     /* 172532 */     GIR_MakeTempReg, /*TempRegID*/94, /*TypeID*/GILLT_s32,
     /* 172535 */     GIR_BuildMI, /*InsnID*/95, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 172539 */     GIR_AddTempRegister, /*InsnID*/95, /*TempRegID*/94, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172544 */     GIR_AddSimpleTempRegister, /*InsnID*/95, /*TempRegID*/95,
     /* 172547 */     GIR_AddImm, /*InsnID*/95, /*Imm*/GIMT_Encode8(52428),
     /* 172557 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/95,
     /* 172559 */     GIR_MakeTempReg, /*TempRegID*/93, /*TypeID*/GILLT_s32,
     /* 172562 */     GIR_BuildMI, /*InsnID*/94, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 172566 */     GIR_AddTempRegister, /*InsnID*/94, /*TempRegID*/93, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172571 */     GIR_AddImm, /*InsnID*/94, /*Imm*/GIMT_Encode8(43690),
     /* 172581 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/94,
     /* 172583 */     GIR_MakeTempReg, /*TempRegID*/92, /*TypeID*/GILLT_s32,
     /* 172586 */     GIR_BuildMI, /*InsnID*/93, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 172590 */     GIR_AddTempRegister, /*InsnID*/93, /*TempRegID*/92, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172595 */     GIR_AddSimpleTempRegister, /*InsnID*/93, /*TempRegID*/93,
     /* 172598 */     GIR_AddImm, /*InsnID*/93, /*Imm*/GIMT_Encode8(43690),
     /* 172608 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/93,
     /* 172610 */     GIR_MakeTempReg, /*TempRegID*/91, /*TypeID*/GILLT_s32,
     /* 172613 */     GIR_BuildMI, /*InsnID*/92, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 172617 */     GIR_AddTempRegister, /*InsnID*/92, /*TempRegID*/91, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172622 */     GIR_Copy, /*NewInsnID*/92, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 172626 */     GIR_AddImm8, /*InsnID*/92, /*Imm*/1,
     /* 172629 */     GIR_AddImm8, /*InsnID*/92, /*Imm*/0,
     /* 172632 */     GIR_AddImm8, /*InsnID*/92, /*Imm*/30,
     /* 172635 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/92,
     /* 172637 */     GIR_MakeTempReg, /*TempRegID*/90, /*TypeID*/GILLT_s32,
     /* 172640 */     GIR_BuildMI, /*InsnID*/91, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 172644 */     GIR_AddTempRegister, /*InsnID*/91, /*TempRegID*/90, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172649 */     GIR_AddSimpleTempRegister, /*InsnID*/91, /*TempRegID*/91,
     /* 172652 */     GIR_AddSimpleTempRegister, /*InsnID*/91, /*TempRegID*/92,
     /* 172655 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/91,
     /* 172657 */     GIR_MakeTempReg, /*TempRegID*/89, /*TypeID*/GILLT_s32,
     /* 172660 */     GIR_BuildMI, /*InsnID*/90, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 172664 */     GIR_AddTempRegister, /*InsnID*/90, /*TempRegID*/89, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172669 */     GIR_AddImm, /*InsnID*/90, /*Imm*/GIMT_Encode8(21845),
     /* 172679 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/90,
     /* 172681 */     GIR_MakeTempReg, /*TempRegID*/88, /*TypeID*/GILLT_s32,
     /* 172684 */     GIR_BuildMI, /*InsnID*/89, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 172688 */     GIR_AddTempRegister, /*InsnID*/89, /*TempRegID*/88, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172693 */     GIR_AddSimpleTempRegister, /*InsnID*/89, /*TempRegID*/89,
     /* 172696 */     GIR_AddImm, /*InsnID*/89, /*Imm*/GIMT_Encode8(21845),
     /* 172706 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/89,
     /* 172708 */     GIR_MakeTempReg, /*TempRegID*/87, /*TypeID*/GILLT_s32,
     /* 172711 */     GIR_BuildMI, /*InsnID*/88, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 172715 */     GIR_AddTempRegister, /*InsnID*/88, /*TempRegID*/87, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172720 */     GIR_Copy, /*NewInsnID*/88, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 172724 */     GIR_AddImm8, /*InsnID*/88, /*Imm*/31,
     /* 172727 */     GIR_AddImm8, /*InsnID*/88, /*Imm*/1,
     /* 172730 */     GIR_AddImm8, /*InsnID*/88, /*Imm*/31,
     /* 172733 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/88,
     /* 172735 */     GIR_MakeTempReg, /*TempRegID*/86, /*TypeID*/GILLT_s32,
     /* 172738 */     GIR_BuildMI, /*InsnID*/87, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 172742 */     GIR_AddTempRegister, /*InsnID*/87, /*TempRegID*/86, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172747 */     GIR_AddSimpleTempRegister, /*InsnID*/87, /*TempRegID*/87,
     /* 172750 */     GIR_AddSimpleTempRegister, /*InsnID*/87, /*TempRegID*/88,
     /* 172753 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/87,
     /* 172755 */     GIR_MakeTempReg, /*TempRegID*/85, /*TypeID*/GILLT_s32,
     /* 172758 */     GIR_BuildMI, /*InsnID*/86, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 172762 */     GIR_AddTempRegister, /*InsnID*/86, /*TempRegID*/85, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172767 */     GIR_AddSimpleTempRegister, /*InsnID*/86, /*TempRegID*/86,
     /* 172770 */     GIR_AddSimpleTempRegister, /*InsnID*/86, /*TempRegID*/90,
     /* 172773 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/86,
     /* 172775 */     GIR_MakeTempReg, /*TempRegID*/84, /*TypeID*/GILLT_s32,
     /* 172778 */     GIR_BuildMI, /*InsnID*/85, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 172782 */     GIR_AddTempRegister, /*InsnID*/85, /*TempRegID*/84, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172787 */     GIR_AddSimpleTempRegister, /*InsnID*/85, /*TempRegID*/85,
     /* 172790 */     GIR_AddImm8, /*InsnID*/85, /*Imm*/2,
     /* 172793 */     GIR_AddImm8, /*InsnID*/85, /*Imm*/0,
     /* 172796 */     GIR_AddImm8, /*InsnID*/85, /*Imm*/29,
     /* 172799 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/85,
     /* 172801 */     GIR_MakeTempReg, /*TempRegID*/83, /*TypeID*/GILLT_s32,
     /* 172804 */     GIR_BuildMI, /*InsnID*/84, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 172808 */     GIR_AddTempRegister, /*InsnID*/84, /*TempRegID*/83, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172813 */     GIR_AddSimpleTempRegister, /*InsnID*/84, /*TempRegID*/84,
     /* 172816 */     GIR_AddSimpleTempRegister, /*InsnID*/84, /*TempRegID*/94,
     /* 172819 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/84,
     /* 172821 */     GIR_MakeTempReg, /*TempRegID*/82, /*TypeID*/GILLT_s32,
     /* 172824 */     GIR_BuildMI, /*InsnID*/83, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 172828 */     GIR_AddTempRegister, /*InsnID*/83, /*TempRegID*/82, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172833 */     GIR_AddImm, /*InsnID*/83, /*Imm*/GIMT_Encode8(13107),
     /* 172843 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/83,
     /* 172845 */     GIR_MakeTempReg, /*TempRegID*/81, /*TypeID*/GILLT_s32,
     /* 172848 */     GIR_BuildMI, /*InsnID*/82, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 172852 */     GIR_AddTempRegister, /*InsnID*/82, /*TempRegID*/81, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172857 */     GIR_AddSimpleTempRegister, /*InsnID*/82, /*TempRegID*/82,
     /* 172860 */     GIR_AddImm, /*InsnID*/82, /*Imm*/GIMT_Encode8(13107),
     /* 172870 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/82,
     /* 172872 */     GIR_MakeTempReg, /*TempRegID*/80, /*TypeID*/GILLT_s32,
     /* 172875 */     GIR_BuildMI, /*InsnID*/81, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 172879 */     GIR_AddTempRegister, /*InsnID*/81, /*TempRegID*/80, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172884 */     GIR_AddImm, /*InsnID*/81, /*Imm*/GIMT_Encode8(43690),
     /* 172894 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/81,
     /* 172896 */     GIR_MakeTempReg, /*TempRegID*/79, /*TypeID*/GILLT_s32,
     /* 172899 */     GIR_BuildMI, /*InsnID*/80, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 172903 */     GIR_AddTempRegister, /*InsnID*/80, /*TempRegID*/79, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172908 */     GIR_AddSimpleTempRegister, /*InsnID*/80, /*TempRegID*/80,
     /* 172911 */     GIR_AddImm, /*InsnID*/80, /*Imm*/GIMT_Encode8(43690),
     /* 172921 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/80,
     /* 172923 */     GIR_MakeTempReg, /*TempRegID*/78, /*TypeID*/GILLT_s32,
     /* 172926 */     GIR_BuildMI, /*InsnID*/79, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 172930 */     GIR_AddTempRegister, /*InsnID*/79, /*TempRegID*/78, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172935 */     GIR_Copy, /*NewInsnID*/79, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 172939 */     GIR_AddImm8, /*InsnID*/79, /*Imm*/1,
     /* 172942 */     GIR_AddImm8, /*InsnID*/79, /*Imm*/0,
     /* 172945 */     GIR_AddImm8, /*InsnID*/79, /*Imm*/30,
     /* 172948 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/79,
     /* 172950 */     GIR_MakeTempReg, /*TempRegID*/77, /*TypeID*/GILLT_s32,
     /* 172953 */     GIR_BuildMI, /*InsnID*/78, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 172957 */     GIR_AddTempRegister, /*InsnID*/78, /*TempRegID*/77, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172962 */     GIR_AddSimpleTempRegister, /*InsnID*/78, /*TempRegID*/78,
     /* 172965 */     GIR_AddSimpleTempRegister, /*InsnID*/78, /*TempRegID*/79,
     /* 172968 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/78,
     /* 172970 */     GIR_MakeTempReg, /*TempRegID*/76, /*TypeID*/GILLT_s32,
     /* 172973 */     GIR_BuildMI, /*InsnID*/77, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 172977 */     GIR_AddTempRegister, /*InsnID*/77, /*TempRegID*/76, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172982 */     GIR_AddImm, /*InsnID*/77, /*Imm*/GIMT_Encode8(21845),
     /* 172992 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/77,
     /* 172994 */     GIR_MakeTempReg, /*TempRegID*/75, /*TypeID*/GILLT_s32,
     /* 172997 */     GIR_BuildMI, /*InsnID*/76, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 173001 */     GIR_AddTempRegister, /*InsnID*/76, /*TempRegID*/75, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173006 */     GIR_AddSimpleTempRegister, /*InsnID*/76, /*TempRegID*/76,
     /* 173009 */     GIR_AddImm, /*InsnID*/76, /*Imm*/GIMT_Encode8(21845),
     /* 173019 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/76,
     /* 173021 */     GIR_MakeTempReg, /*TempRegID*/74, /*TypeID*/GILLT_s32,
     /* 173024 */     GIR_BuildMI, /*InsnID*/75, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 173028 */     GIR_AddTempRegister, /*InsnID*/75, /*TempRegID*/74, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173033 */     GIR_Copy, /*NewInsnID*/75, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 173037 */     GIR_AddImm8, /*InsnID*/75, /*Imm*/31,
     /* 173040 */     GIR_AddImm8, /*InsnID*/75, /*Imm*/1,
     /* 173043 */     GIR_AddImm8, /*InsnID*/75, /*Imm*/31,
     /* 173046 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/75,
     /* 173048 */     GIR_MakeTempReg, /*TempRegID*/73, /*TypeID*/GILLT_s32,
     /* 173051 */     GIR_BuildMI, /*InsnID*/74, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 173055 */     GIR_AddTempRegister, /*InsnID*/74, /*TempRegID*/73, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173060 */     GIR_AddSimpleTempRegister, /*InsnID*/74, /*TempRegID*/74,
     /* 173063 */     GIR_AddSimpleTempRegister, /*InsnID*/74, /*TempRegID*/75,
     /* 173066 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/74,
     /* 173068 */     GIR_MakeTempReg, /*TempRegID*/72, /*TypeID*/GILLT_s32,
     /* 173071 */     GIR_BuildMI, /*InsnID*/73, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 173075 */     GIR_AddTempRegister, /*InsnID*/73, /*TempRegID*/72, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173080 */     GIR_AddSimpleTempRegister, /*InsnID*/73, /*TempRegID*/73,
     /* 173083 */     GIR_AddSimpleTempRegister, /*InsnID*/73, /*TempRegID*/77,
     /* 173086 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/73,
     /* 173088 */     GIR_MakeTempReg, /*TempRegID*/71, /*TypeID*/GILLT_s32,
     /* 173091 */     GIR_BuildMI, /*InsnID*/72, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 173095 */     GIR_AddTempRegister, /*InsnID*/72, /*TempRegID*/71, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173100 */     GIR_AddSimpleTempRegister, /*InsnID*/72, /*TempRegID*/72,
     /* 173103 */     GIR_AddImm8, /*InsnID*/72, /*Imm*/30,
     /* 173106 */     GIR_AddImm8, /*InsnID*/72, /*Imm*/2,
     /* 173109 */     GIR_AddImm8, /*InsnID*/72, /*Imm*/31,
     /* 173112 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/72,
     /* 173114 */     GIR_MakeTempReg, /*TempRegID*/70, /*TypeID*/GILLT_s32,
     /* 173117 */     GIR_BuildMI, /*InsnID*/71, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 173121 */     GIR_AddTempRegister, /*InsnID*/71, /*TempRegID*/70, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173126 */     GIR_AddSimpleTempRegister, /*InsnID*/71, /*TempRegID*/71,
     /* 173129 */     GIR_AddSimpleTempRegister, /*InsnID*/71, /*TempRegID*/81,
     /* 173132 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/71,
     /* 173134 */     GIR_MakeTempReg, /*TempRegID*/69, /*TypeID*/GILLT_s32,
     /* 173137 */     GIR_BuildMI, /*InsnID*/70, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 173141 */     GIR_AddTempRegister, /*InsnID*/70, /*TempRegID*/69, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173146 */     GIR_AddSimpleTempRegister, /*InsnID*/70, /*TempRegID*/70,
     /* 173149 */     GIR_AddSimpleTempRegister, /*InsnID*/70, /*TempRegID*/83,
     /* 173152 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/70,
     /* 173154 */     GIR_MakeTempReg, /*TempRegID*/68, /*TypeID*/GILLT_s32,
     /* 173157 */     GIR_BuildMI, /*InsnID*/69, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 173161 */     GIR_AddTempRegister, /*InsnID*/69, /*TempRegID*/68, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173166 */     GIR_AddSimpleTempRegister, /*InsnID*/69, /*TempRegID*/69,
     /* 173169 */     GIR_AddImm8, /*InsnID*/69, /*Imm*/28,
     /* 173172 */     GIR_AddImm8, /*InsnID*/69, /*Imm*/4,
     /* 173175 */     GIR_AddImm8, /*InsnID*/69, /*Imm*/31,
     /* 173178 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/69,
     /* 173180 */     GIR_MakeTempReg, /*TempRegID*/67, /*TypeID*/GILLT_s32,
     /* 173183 */     GIR_BuildMI, /*InsnID*/68, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 173187 */     GIR_AddTempRegister, /*InsnID*/68, /*TempRegID*/67, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173192 */     GIR_AddSimpleTempRegister, /*InsnID*/68, /*TempRegID*/68,
     /* 173195 */     GIR_AddSimpleTempRegister, /*InsnID*/68, /*TempRegID*/96,
     /* 173198 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/68,
     /* 173200 */     GIR_MakeTempReg, /*TempRegID*/66, /*TypeID*/GILLT_s32,
     /* 173203 */     GIR_BuildMI, /*InsnID*/67, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 173207 */     GIR_AddTempRegister, /*InsnID*/67, /*TempRegID*/66, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173212 */     GIR_AddSimpleTempRegister, /*InsnID*/67, /*TempRegID*/67,
     /* 173215 */     GIR_AddSimpleTempRegister, /*InsnID*/67, /*TempRegID*/98,
     /* 173218 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/67,
     /* 173220 */     GIR_MakeTempReg, /*TempRegID*/65, /*TypeID*/GILLT_s32,
     /* 173223 */     GIR_BuildMI, /*InsnID*/66, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 173227 */     GIR_AddTempRegister, /*InsnID*/66, /*TempRegID*/65, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173232 */     GIR_AddImm, /*InsnID*/66, /*Imm*/GIMT_Encode8(61680),
     /* 173242 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/66,
     /* 173244 */     GIR_MakeTempReg, /*TempRegID*/64, /*TypeID*/GILLT_s32,
     /* 173247 */     GIR_BuildMI, /*InsnID*/65, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 173251 */     GIR_AddTempRegister, /*InsnID*/65, /*TempRegID*/64, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173256 */     GIR_AddSimpleTempRegister, /*InsnID*/65, /*TempRegID*/65,
     /* 173259 */     GIR_AddImm, /*InsnID*/65, /*Imm*/GIMT_Encode8(61680),
     /* 173269 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/65,
     /* 173271 */     GIR_MakeTempReg, /*TempRegID*/63, /*TypeID*/GILLT_s32,
     /* 173274 */     GIR_BuildMI, /*InsnID*/64, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 173278 */     GIR_AddTempRegister, /*InsnID*/64, /*TempRegID*/63, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173283 */     GIR_AddImm, /*InsnID*/64, /*Imm*/GIMT_Encode8(52428),
     /* 173293 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/64,
     /* 173295 */     GIR_MakeTempReg, /*TempRegID*/62, /*TypeID*/GILLT_s32,
     /* 173298 */     GIR_BuildMI, /*InsnID*/63, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 173302 */     GIR_AddTempRegister, /*InsnID*/63, /*TempRegID*/62, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173307 */     GIR_AddSimpleTempRegister, /*InsnID*/63, /*TempRegID*/63,
     /* 173310 */     GIR_AddImm, /*InsnID*/63, /*Imm*/GIMT_Encode8(52428),
     /* 173320 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/63,
     /* 173322 */     GIR_MakeTempReg, /*TempRegID*/61, /*TypeID*/GILLT_s32,
     /* 173325 */     GIR_BuildMI, /*InsnID*/62, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 173329 */     GIR_AddTempRegister, /*InsnID*/62, /*TempRegID*/61, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173334 */     GIR_AddImm, /*InsnID*/62, /*Imm*/GIMT_Encode8(43690),
     /* 173344 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/62,
     /* 173346 */     GIR_MakeTempReg, /*TempRegID*/60, /*TypeID*/GILLT_s32,
     /* 173349 */     GIR_BuildMI, /*InsnID*/61, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 173353 */     GIR_AddTempRegister, /*InsnID*/61, /*TempRegID*/60, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173358 */     GIR_AddSimpleTempRegister, /*InsnID*/61, /*TempRegID*/61,
     /* 173361 */     GIR_AddImm, /*InsnID*/61, /*Imm*/GIMT_Encode8(43690),
     /* 173371 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/61,
     /* 173373 */     GIR_MakeTempReg, /*TempRegID*/59, /*TypeID*/GILLT_s32,
     /* 173376 */     GIR_BuildMI, /*InsnID*/60, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 173380 */     GIR_AddTempRegister, /*InsnID*/60, /*TempRegID*/59, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173385 */     GIR_Copy, /*NewInsnID*/60, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 173389 */     GIR_AddImm8, /*InsnID*/60, /*Imm*/1,
     /* 173392 */     GIR_AddImm8, /*InsnID*/60, /*Imm*/0,
     /* 173395 */     GIR_AddImm8, /*InsnID*/60, /*Imm*/30,
     /* 173398 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/60,
     /* 173400 */     GIR_MakeTempReg, /*TempRegID*/58, /*TypeID*/GILLT_s32,
     /* 173403 */     GIR_BuildMI, /*InsnID*/59, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 173407 */     GIR_AddTempRegister, /*InsnID*/59, /*TempRegID*/58, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173412 */     GIR_AddSimpleTempRegister, /*InsnID*/59, /*TempRegID*/59,
     /* 173415 */     GIR_AddSimpleTempRegister, /*InsnID*/59, /*TempRegID*/60,
     /* 173418 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/59,
     /* 173420 */     GIR_MakeTempReg, /*TempRegID*/57, /*TypeID*/GILLT_s32,
     /* 173423 */     GIR_BuildMI, /*InsnID*/58, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 173427 */     GIR_AddTempRegister, /*InsnID*/58, /*TempRegID*/57, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173432 */     GIR_AddImm, /*InsnID*/58, /*Imm*/GIMT_Encode8(21845),
     /* 173442 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/58,
     /* 173444 */     GIR_MakeTempReg, /*TempRegID*/56, /*TypeID*/GILLT_s32,
     /* 173447 */     GIR_BuildMI, /*InsnID*/57, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 173451 */     GIR_AddTempRegister, /*InsnID*/57, /*TempRegID*/56, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173456 */     GIR_AddSimpleTempRegister, /*InsnID*/57, /*TempRegID*/57,
     /* 173459 */     GIR_AddImm, /*InsnID*/57, /*Imm*/GIMT_Encode8(21845),
     /* 173469 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/57,
     /* 173471 */     GIR_MakeTempReg, /*TempRegID*/55, /*TypeID*/GILLT_s32,
     /* 173474 */     GIR_BuildMI, /*InsnID*/56, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 173478 */     GIR_AddTempRegister, /*InsnID*/56, /*TempRegID*/55, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173483 */     GIR_Copy, /*NewInsnID*/56, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 173487 */     GIR_AddImm8, /*InsnID*/56, /*Imm*/31,
     /* 173490 */     GIR_AddImm8, /*InsnID*/56, /*Imm*/1,
     /* 173493 */     GIR_AddImm8, /*InsnID*/56, /*Imm*/31,
     /* 173496 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/56,
     /* 173498 */     GIR_MakeTempReg, /*TempRegID*/54, /*TypeID*/GILLT_s32,
     /* 173501 */     GIR_BuildMI, /*InsnID*/55, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 173505 */     GIR_AddTempRegister, /*InsnID*/55, /*TempRegID*/54, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173510 */     GIR_AddSimpleTempRegister, /*InsnID*/55, /*TempRegID*/55,
     /* 173513 */     GIR_AddSimpleTempRegister, /*InsnID*/55, /*TempRegID*/56,
     /* 173516 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/55,
     /* 173518 */     GIR_MakeTempReg, /*TempRegID*/53, /*TypeID*/GILLT_s32,
     /* 173521 */     GIR_BuildMI, /*InsnID*/54, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 173525 */     GIR_AddTempRegister, /*InsnID*/54, /*TempRegID*/53, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173530 */     GIR_AddSimpleTempRegister, /*InsnID*/54, /*TempRegID*/54,
     /* 173533 */     GIR_AddSimpleTempRegister, /*InsnID*/54, /*TempRegID*/58,
     /* 173536 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/54,
     /* 173538 */     GIR_MakeTempReg, /*TempRegID*/52, /*TypeID*/GILLT_s32,
     /* 173541 */     GIR_BuildMI, /*InsnID*/53, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 173545 */     GIR_AddTempRegister, /*InsnID*/53, /*TempRegID*/52, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173550 */     GIR_AddSimpleTempRegister, /*InsnID*/53, /*TempRegID*/53,
     /* 173553 */     GIR_AddImm8, /*InsnID*/53, /*Imm*/2,
     /* 173556 */     GIR_AddImm8, /*InsnID*/53, /*Imm*/0,
     /* 173559 */     GIR_AddImm8, /*InsnID*/53, /*Imm*/29,
     /* 173562 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/53,
     /* 173564 */     GIR_MakeTempReg, /*TempRegID*/51, /*TypeID*/GILLT_s32,
     /* 173567 */     GIR_BuildMI, /*InsnID*/52, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 173571 */     GIR_AddTempRegister, /*InsnID*/52, /*TempRegID*/51, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173576 */     GIR_AddSimpleTempRegister, /*InsnID*/52, /*TempRegID*/52,
     /* 173579 */     GIR_AddSimpleTempRegister, /*InsnID*/52, /*TempRegID*/62,
     /* 173582 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/52,
     /* 173584 */     GIR_MakeTempReg, /*TempRegID*/50, /*TypeID*/GILLT_s32,
     /* 173587 */     GIR_BuildMI, /*InsnID*/51, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 173591 */     GIR_AddTempRegister, /*InsnID*/51, /*TempRegID*/50, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173596 */     GIR_AddImm, /*InsnID*/51, /*Imm*/GIMT_Encode8(13107),
     /* 173606 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/51,
     /* 173608 */     GIR_MakeTempReg, /*TempRegID*/49, /*TypeID*/GILLT_s32,
     /* 173611 */     GIR_BuildMI, /*InsnID*/50, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 173615 */     GIR_AddTempRegister, /*InsnID*/50, /*TempRegID*/49, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173620 */     GIR_AddSimpleTempRegister, /*InsnID*/50, /*TempRegID*/50,
     /* 173623 */     GIR_AddImm, /*InsnID*/50, /*Imm*/GIMT_Encode8(13107),
     /* 173633 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/50,
     /* 173635 */     GIR_MakeTempReg, /*TempRegID*/48, /*TypeID*/GILLT_s32,
     /* 173638 */     GIR_BuildMI, /*InsnID*/49, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 173642 */     GIR_AddTempRegister, /*InsnID*/49, /*TempRegID*/48, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173647 */     GIR_AddImm, /*InsnID*/49, /*Imm*/GIMT_Encode8(43690),
     /* 173657 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/49,
     /* 173659 */     GIR_MakeTempReg, /*TempRegID*/47, /*TypeID*/GILLT_s32,
     /* 173662 */     GIR_BuildMI, /*InsnID*/48, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 173666 */     GIR_AddTempRegister, /*InsnID*/48, /*TempRegID*/47, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173671 */     GIR_AddSimpleTempRegister, /*InsnID*/48, /*TempRegID*/48,
     /* 173674 */     GIR_AddImm, /*InsnID*/48, /*Imm*/GIMT_Encode8(43690),
     /* 173684 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/48,
     /* 173686 */     GIR_MakeTempReg, /*TempRegID*/46, /*TypeID*/GILLT_s32,
     /* 173689 */     GIR_BuildMI, /*InsnID*/47, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 173693 */     GIR_AddTempRegister, /*InsnID*/47, /*TempRegID*/46, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173698 */     GIR_Copy, /*NewInsnID*/47, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 173702 */     GIR_AddImm8, /*InsnID*/47, /*Imm*/1,
     /* 173705 */     GIR_AddImm8, /*InsnID*/47, /*Imm*/0,
     /* 173708 */     GIR_AddImm8, /*InsnID*/47, /*Imm*/30,
     /* 173711 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/47,
     /* 173713 */     GIR_MakeTempReg, /*TempRegID*/45, /*TypeID*/GILLT_s32,
     /* 173716 */     GIR_BuildMI, /*InsnID*/46, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 173720 */     GIR_AddTempRegister, /*InsnID*/46, /*TempRegID*/45, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173725 */     GIR_AddSimpleTempRegister, /*InsnID*/46, /*TempRegID*/46,
     /* 173728 */     GIR_AddSimpleTempRegister, /*InsnID*/46, /*TempRegID*/47,
     /* 173731 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/46,
     /* 173733 */     GIR_MakeTempReg, /*TempRegID*/44, /*TypeID*/GILLT_s32,
     /* 173736 */     GIR_BuildMI, /*InsnID*/45, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 173740 */     GIR_AddTempRegister, /*InsnID*/45, /*TempRegID*/44, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173745 */     GIR_AddImm, /*InsnID*/45, /*Imm*/GIMT_Encode8(21845),
     /* 173755 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/45,
     /* 173757 */     GIR_MakeTempReg, /*TempRegID*/43, /*TypeID*/GILLT_s32,
     /* 173760 */     GIR_BuildMI, /*InsnID*/44, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 173764 */     GIR_AddTempRegister, /*InsnID*/44, /*TempRegID*/43, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173769 */     GIR_AddSimpleTempRegister, /*InsnID*/44, /*TempRegID*/44,
     /* 173772 */     GIR_AddImm, /*InsnID*/44, /*Imm*/GIMT_Encode8(21845),
     /* 173782 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/44,
     /* 173784 */     GIR_MakeTempReg, /*TempRegID*/42, /*TypeID*/GILLT_s32,
     /* 173787 */     GIR_BuildMI, /*InsnID*/43, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 173791 */     GIR_AddTempRegister, /*InsnID*/43, /*TempRegID*/42, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173796 */     GIR_Copy, /*NewInsnID*/43, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 173800 */     GIR_AddImm8, /*InsnID*/43, /*Imm*/31,
     /* 173803 */     GIR_AddImm8, /*InsnID*/43, /*Imm*/1,
     /* 173806 */     GIR_AddImm8, /*InsnID*/43, /*Imm*/31,
     /* 173809 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/43,
     /* 173811 */     GIR_MakeTempReg, /*TempRegID*/41, /*TypeID*/GILLT_s32,
     /* 173814 */     GIR_BuildMI, /*InsnID*/42, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 173818 */     GIR_AddTempRegister, /*InsnID*/42, /*TempRegID*/41, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173823 */     GIR_AddSimpleTempRegister, /*InsnID*/42, /*TempRegID*/42,
     /* 173826 */     GIR_AddSimpleTempRegister, /*InsnID*/42, /*TempRegID*/43,
     /* 173829 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/42,
     /* 173831 */     GIR_MakeTempReg, /*TempRegID*/40, /*TypeID*/GILLT_s32,
     /* 173834 */     GIR_BuildMI, /*InsnID*/41, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 173838 */     GIR_AddTempRegister, /*InsnID*/41, /*TempRegID*/40, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173843 */     GIR_AddSimpleTempRegister, /*InsnID*/41, /*TempRegID*/41,
     /* 173846 */     GIR_AddSimpleTempRegister, /*InsnID*/41, /*TempRegID*/45,
     /* 173849 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/41,
     /* 173851 */     GIR_MakeTempReg, /*TempRegID*/39, /*TypeID*/GILLT_s32,
     /* 173854 */     GIR_BuildMI, /*InsnID*/40, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 173858 */     GIR_AddTempRegister, /*InsnID*/40, /*TempRegID*/39, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173863 */     GIR_AddSimpleTempRegister, /*InsnID*/40, /*TempRegID*/40,
     /* 173866 */     GIR_AddImm8, /*InsnID*/40, /*Imm*/30,
     /* 173869 */     GIR_AddImm8, /*InsnID*/40, /*Imm*/2,
     /* 173872 */     GIR_AddImm8, /*InsnID*/40, /*Imm*/31,
     /* 173875 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/40,
     /* 173877 */     GIR_MakeTempReg, /*TempRegID*/38, /*TypeID*/GILLT_s32,
     /* 173880 */     GIR_BuildMI, /*InsnID*/39, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 173884 */     GIR_AddTempRegister, /*InsnID*/39, /*TempRegID*/38, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173889 */     GIR_AddSimpleTempRegister, /*InsnID*/39, /*TempRegID*/39,
     /* 173892 */     GIR_AddSimpleTempRegister, /*InsnID*/39, /*TempRegID*/49,
     /* 173895 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/39,
     /* 173897 */     GIR_MakeTempReg, /*TempRegID*/37, /*TypeID*/GILLT_s32,
     /* 173900 */     GIR_BuildMI, /*InsnID*/38, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 173904 */     GIR_AddTempRegister, /*InsnID*/38, /*TempRegID*/37, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173909 */     GIR_AddSimpleTempRegister, /*InsnID*/38, /*TempRegID*/38,
     /* 173912 */     GIR_AddSimpleTempRegister, /*InsnID*/38, /*TempRegID*/51,
     /* 173915 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/38,
     /* 173917 */     GIR_MakeTempReg, /*TempRegID*/36, /*TypeID*/GILLT_s32,
     /* 173920 */     GIR_BuildMI, /*InsnID*/37, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 173924 */     GIR_AddTempRegister, /*InsnID*/37, /*TempRegID*/36, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173929 */     GIR_AddSimpleTempRegister, /*InsnID*/37, /*TempRegID*/37,
     /* 173932 */     GIR_AddImm8, /*InsnID*/37, /*Imm*/4,
     /* 173935 */     GIR_AddImm8, /*InsnID*/37, /*Imm*/0,
     /* 173938 */     GIR_AddImm8, /*InsnID*/37, /*Imm*/27,
     /* 173941 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/37,
     /* 173943 */     GIR_MakeTempReg, /*TempRegID*/35, /*TypeID*/GILLT_s32,
     /* 173946 */     GIR_BuildMI, /*InsnID*/36, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 173950 */     GIR_AddTempRegister, /*InsnID*/36, /*TempRegID*/35, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173955 */     GIR_AddSimpleTempRegister, /*InsnID*/36, /*TempRegID*/36,
     /* 173958 */     GIR_AddSimpleTempRegister, /*InsnID*/36, /*TempRegID*/64,
     /* 173961 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/36,
     /* 173963 */     GIR_MakeTempReg, /*TempRegID*/34, /*TypeID*/GILLT_s32,
     /* 173966 */     GIR_BuildMI, /*InsnID*/35, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 173970 */     GIR_AddTempRegister, /*InsnID*/35, /*TempRegID*/34, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173975 */     GIR_AddImm, /*InsnID*/35, /*Imm*/GIMT_Encode8(3855),
     /* 173985 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/35,
     /* 173987 */     GIR_MakeTempReg, /*TempRegID*/33, /*TypeID*/GILLT_s32,
     /* 173990 */     GIR_BuildMI, /*InsnID*/34, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 173994 */     GIR_AddTempRegister, /*InsnID*/34, /*TempRegID*/33, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173999 */     GIR_AddSimpleTempRegister, /*InsnID*/34, /*TempRegID*/34,
     /* 174002 */     GIR_AddImm, /*InsnID*/34, /*Imm*/GIMT_Encode8(3855),
     /* 174012 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/34,
     /* 174014 */     GIR_MakeTempReg, /*TempRegID*/32, /*TypeID*/GILLT_s32,
     /* 174017 */     GIR_BuildMI, /*InsnID*/33, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 174021 */     GIR_AddTempRegister, /*InsnID*/33, /*TempRegID*/32, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174026 */     GIR_AddImm, /*InsnID*/33, /*Imm*/GIMT_Encode8(52428),
     /* 174036 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/33,
     /* 174038 */     GIR_MakeTempReg, /*TempRegID*/31, /*TypeID*/GILLT_s32,
     /* 174041 */     GIR_BuildMI, /*InsnID*/32, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 174045 */     GIR_AddTempRegister, /*InsnID*/32, /*TempRegID*/31, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174050 */     GIR_AddSimpleTempRegister, /*InsnID*/32, /*TempRegID*/32,
     /* 174053 */     GIR_AddImm, /*InsnID*/32, /*Imm*/GIMT_Encode8(52428),
     /* 174063 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/32,
     /* 174065 */     GIR_MakeTempReg, /*TempRegID*/30, /*TypeID*/GILLT_s32,
     /* 174068 */     GIR_BuildMI, /*InsnID*/31, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 174072 */     GIR_AddTempRegister, /*InsnID*/31, /*TempRegID*/30, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174077 */     GIR_AddImm, /*InsnID*/31, /*Imm*/GIMT_Encode8(43690),
     /* 174087 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/31,
     /* 174089 */     GIR_MakeTempReg, /*TempRegID*/29, /*TypeID*/GILLT_s32,
     /* 174092 */     GIR_BuildMI, /*InsnID*/30, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 174096 */     GIR_AddTempRegister, /*InsnID*/30, /*TempRegID*/29, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174101 */     GIR_AddSimpleTempRegister, /*InsnID*/30, /*TempRegID*/30,
     /* 174104 */     GIR_AddImm, /*InsnID*/30, /*Imm*/GIMT_Encode8(43690),
     /* 174114 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/30,
     /* 174116 */     GIR_MakeTempReg, /*TempRegID*/28, /*TypeID*/GILLT_s32,
     /* 174119 */     GIR_BuildMI, /*InsnID*/29, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 174123 */     GIR_AddTempRegister, /*InsnID*/29, /*TempRegID*/28, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174128 */     GIR_Copy, /*NewInsnID*/29, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 174132 */     GIR_AddImm8, /*InsnID*/29, /*Imm*/1,
     /* 174135 */     GIR_AddImm8, /*InsnID*/29, /*Imm*/0,
     /* 174138 */     GIR_AddImm8, /*InsnID*/29, /*Imm*/30,
     /* 174141 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/29,
     /* 174143 */     GIR_MakeTempReg, /*TempRegID*/27, /*TypeID*/GILLT_s32,
     /* 174146 */     GIR_BuildMI, /*InsnID*/28, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 174150 */     GIR_AddTempRegister, /*InsnID*/28, /*TempRegID*/27, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174155 */     GIR_AddSimpleTempRegister, /*InsnID*/28, /*TempRegID*/28,
     /* 174158 */     GIR_AddSimpleTempRegister, /*InsnID*/28, /*TempRegID*/29,
     /* 174161 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/28,
     /* 174163 */     GIR_MakeTempReg, /*TempRegID*/26, /*TypeID*/GILLT_s32,
     /* 174166 */     GIR_BuildMI, /*InsnID*/27, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 174170 */     GIR_AddTempRegister, /*InsnID*/27, /*TempRegID*/26, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174175 */     GIR_AddImm, /*InsnID*/27, /*Imm*/GIMT_Encode8(21845),
     /* 174185 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/27,
     /* 174187 */     GIR_MakeTempReg, /*TempRegID*/25, /*TypeID*/GILLT_s32,
     /* 174190 */     GIR_BuildMI, /*InsnID*/26, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 174194 */     GIR_AddTempRegister, /*InsnID*/26, /*TempRegID*/25, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174199 */     GIR_AddSimpleTempRegister, /*InsnID*/26, /*TempRegID*/26,
     /* 174202 */     GIR_AddImm, /*InsnID*/26, /*Imm*/GIMT_Encode8(21845),
     /* 174212 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/26,
     /* 174214 */     GIR_MakeTempReg, /*TempRegID*/24, /*TypeID*/GILLT_s32,
     /* 174217 */     GIR_BuildMI, /*InsnID*/25, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 174221 */     GIR_AddTempRegister, /*InsnID*/25, /*TempRegID*/24, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174226 */     GIR_Copy, /*NewInsnID*/25, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 174230 */     GIR_AddImm8, /*InsnID*/25, /*Imm*/31,
     /* 174233 */     GIR_AddImm8, /*InsnID*/25, /*Imm*/1,
     /* 174236 */     GIR_AddImm8, /*InsnID*/25, /*Imm*/31,
     /* 174239 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/25,
     /* 174241 */     GIR_MakeTempReg, /*TempRegID*/23, /*TypeID*/GILLT_s32,
     /* 174244 */     GIR_BuildMI, /*InsnID*/24, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 174248 */     GIR_AddTempRegister, /*InsnID*/24, /*TempRegID*/23, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174253 */     GIR_AddSimpleTempRegister, /*InsnID*/24, /*TempRegID*/24,
     /* 174256 */     GIR_AddSimpleTempRegister, /*InsnID*/24, /*TempRegID*/25,
     /* 174259 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/24,
     /* 174261 */     GIR_MakeTempReg, /*TempRegID*/22, /*TypeID*/GILLT_s32,
     /* 174264 */     GIR_BuildMI, /*InsnID*/23, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 174268 */     GIR_AddTempRegister, /*InsnID*/23, /*TempRegID*/22, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174273 */     GIR_AddSimpleTempRegister, /*InsnID*/23, /*TempRegID*/23,
     /* 174276 */     GIR_AddSimpleTempRegister, /*InsnID*/23, /*TempRegID*/27,
     /* 174279 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/23,
     /* 174281 */     GIR_MakeTempReg, /*TempRegID*/21, /*TypeID*/GILLT_s32,
     /* 174284 */     GIR_BuildMI, /*InsnID*/22, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 174288 */     GIR_AddTempRegister, /*InsnID*/22, /*TempRegID*/21, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174293 */     GIR_AddSimpleTempRegister, /*InsnID*/22, /*TempRegID*/22,
     /* 174296 */     GIR_AddImm8, /*InsnID*/22, /*Imm*/2,
     /* 174299 */     GIR_AddImm8, /*InsnID*/22, /*Imm*/0,
     /* 174302 */     GIR_AddImm8, /*InsnID*/22, /*Imm*/29,
     /* 174305 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/22,
     /* 174307 */     GIR_MakeTempReg, /*TempRegID*/20, /*TypeID*/GILLT_s32,
     /* 174310 */     GIR_BuildMI, /*InsnID*/21, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 174314 */     GIR_AddTempRegister, /*InsnID*/21, /*TempRegID*/20, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174319 */     GIR_AddSimpleTempRegister, /*InsnID*/21, /*TempRegID*/21,
     /* 174322 */     GIR_AddSimpleTempRegister, /*InsnID*/21, /*TempRegID*/31,
     /* 174325 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/21,
     /* 174327 */     GIR_MakeTempReg, /*TempRegID*/19, /*TypeID*/GILLT_s32,
     /* 174330 */     GIR_BuildMI, /*InsnID*/20, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 174334 */     GIR_AddTempRegister, /*InsnID*/20, /*TempRegID*/19, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174339 */     GIR_AddImm, /*InsnID*/20, /*Imm*/GIMT_Encode8(13107),
     /* 174349 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/20,
     /* 174351 */     GIR_MakeTempReg, /*TempRegID*/18, /*TypeID*/GILLT_s32,
     /* 174354 */     GIR_BuildMI, /*InsnID*/19, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 174358 */     GIR_AddTempRegister, /*InsnID*/19, /*TempRegID*/18, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174363 */     GIR_AddSimpleTempRegister, /*InsnID*/19, /*TempRegID*/19,
     /* 174366 */     GIR_AddImm, /*InsnID*/19, /*Imm*/GIMT_Encode8(13107),
     /* 174376 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/19,
     /* 174378 */     GIR_MakeTempReg, /*TempRegID*/17, /*TypeID*/GILLT_s32,
     /* 174381 */     GIR_BuildMI, /*InsnID*/18, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 174385 */     GIR_AddTempRegister, /*InsnID*/18, /*TempRegID*/17, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174390 */     GIR_AddImm, /*InsnID*/18, /*Imm*/GIMT_Encode8(43690),
     /* 174400 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/18,
     /* 174402 */     GIR_MakeTempReg, /*TempRegID*/16, /*TypeID*/GILLT_s32,
     /* 174405 */     GIR_BuildMI, /*InsnID*/17, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 174409 */     GIR_AddTempRegister, /*InsnID*/17, /*TempRegID*/16, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174414 */     GIR_AddSimpleTempRegister, /*InsnID*/17, /*TempRegID*/17,
     /* 174417 */     GIR_AddImm, /*InsnID*/17, /*Imm*/GIMT_Encode8(43690),
     /* 174427 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/17,
     /* 174429 */     GIR_MakeTempReg, /*TempRegID*/15, /*TypeID*/GILLT_s32,
     /* 174432 */     GIR_BuildMI, /*InsnID*/16, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 174436 */     GIR_AddTempRegister, /*InsnID*/16, /*TempRegID*/15, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174441 */     GIR_Copy, /*NewInsnID*/16, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 174445 */     GIR_AddImm8, /*InsnID*/16, /*Imm*/1,
     /* 174448 */     GIR_AddImm8, /*InsnID*/16, /*Imm*/0,
     /* 174451 */     GIR_AddImm8, /*InsnID*/16, /*Imm*/30,
     /* 174454 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/16,
     /* 174456 */     GIR_MakeTempReg, /*TempRegID*/14, /*TypeID*/GILLT_s32,
     /* 174459 */     GIR_BuildMI, /*InsnID*/15, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 174463 */     GIR_AddTempRegister, /*InsnID*/15, /*TempRegID*/14, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174468 */     GIR_AddSimpleTempRegister, /*InsnID*/15, /*TempRegID*/15,
     /* 174471 */     GIR_AddSimpleTempRegister, /*InsnID*/15, /*TempRegID*/16,
     /* 174474 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/15,
     /* 174476 */     GIR_MakeTempReg, /*TempRegID*/13, /*TypeID*/GILLT_s32,
     /* 174479 */     GIR_BuildMI, /*InsnID*/14, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 174483 */     GIR_AddTempRegister, /*InsnID*/14, /*TempRegID*/13, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174488 */     GIR_AddImm, /*InsnID*/14, /*Imm*/GIMT_Encode8(21845),
     /* 174498 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/14,
     /* 174500 */     GIR_MakeTempReg, /*TempRegID*/12, /*TypeID*/GILLT_s32,
     /* 174503 */     GIR_BuildMI, /*InsnID*/13, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 174507 */     GIR_AddTempRegister, /*InsnID*/13, /*TempRegID*/12, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174512 */     GIR_AddSimpleTempRegister, /*InsnID*/13, /*TempRegID*/13,
     /* 174515 */     GIR_AddImm, /*InsnID*/13, /*Imm*/GIMT_Encode8(21845),
     /* 174525 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/13,
     /* 174527 */     GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_s32,
     /* 174530 */     GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 174534 */     GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174539 */     GIR_Copy, /*NewInsnID*/12, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 174543 */     GIR_AddImm8, /*InsnID*/12, /*Imm*/31,
     /* 174546 */     GIR_AddImm8, /*InsnID*/12, /*Imm*/1,
     /* 174549 */     GIR_AddImm8, /*InsnID*/12, /*Imm*/31,
     /* 174552 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/12,
     /* 174554 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_s32,
     /* 174557 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 174561 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174566 */     GIR_AddSimpleTempRegister, /*InsnID*/11, /*TempRegID*/11,
     /* 174569 */     GIR_AddSimpleTempRegister, /*InsnID*/11, /*TempRegID*/12,
     /* 174572 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 174574 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s32,
     /* 174577 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 174581 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174586 */     GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
     /* 174589 */     GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/14,
     /* 174592 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 174594 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s32,
     /* 174597 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 174601 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174606 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 174609 */     GIR_AddImm8, /*InsnID*/9, /*Imm*/30,
     /* 174612 */     GIR_AddImm8, /*InsnID*/9, /*Imm*/2,
     /* 174615 */     GIR_AddImm8, /*InsnID*/9, /*Imm*/31,
     /* 174618 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 174620 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s32,
     /* 174623 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 174627 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174632 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
     /* 174635 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/18,
     /* 174638 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 174640 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s32,
     /* 174643 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 174647 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174652 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 174655 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/20,
     /* 174658 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 174660 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /* 174663 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 174667 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174672 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 174675 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/28,
     /* 174678 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/4,
     /* 174681 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/31,
     /* 174684 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 174686 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 174689 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 174693 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174698 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 174701 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/33,
     /* 174704 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 174706 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 174709 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 174713 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174718 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 174721 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/35,
     /* 174724 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 174726 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 174729 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 174733 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174738 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 174741 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/24,
     /* 174744 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 174747 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/31,
     /* 174750 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 174752 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 174755 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWIMI),
     /* 174759 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174764 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 174767 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/66,
     /* 174770 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/8,
     /* 174773 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/8,
     /* 174776 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/15,
     /* 174779 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 174781 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 174784 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLWIMI),
     /* 174788 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174793 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 174796 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*//* 129(*/0x81, 0x01/*)*/,
     /* 174800 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 174803 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/24,
     /* 174806 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 174809 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL_32),
     /* 174814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 174816 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 174819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 174822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/32,
     /* 174825 */     GIR_RootConstrainSelectedInstOperands,
     /* 174826 */     // GIR_Coverage, 4845,
     /* 174826 */     GIR_EraseRootFromParent_Done,
     /* 174827 */   // Label 2734: @174827
     /* 174827 */   GIM_Try, /*On fail goto*//*Label 2735*/ GIMT_Encode4(179952), // Rule ID 4846 //
     /* 174832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_In32BitMode),
     /* 174835 */     // (bitreverse:{ *:[i32] } i32:{ *:[i32] }:$A)  =>  (RLWIMI:{ *:[i32] } (RLWIMI:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 30:{ *:[i32] }, 2:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 2:{ *:[i32] }, 0:{ *:[i32] }, 29:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }))), 28:{ *:[i32] }, 4:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 3855:{ *:[i32] }), 3855:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 30:{ *:[i32] }, 2:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 2:{ *:[i32] }, 0:{ *:[i32] }, 29:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }))), 4:{ *:[i32] }, 0:{ *:[i32] }, 27:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 61680:{ *:[i32] }), 61680:{ *:[i32] }))), 24:{ *:[i32] }, 0:{ *:[i32] }, 31:{ *:[i32] }), (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 30:{ *:[i32] }, 2:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 2:{ *:[i32] }, 0:{ *:[i32] }, 29:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }))), 28:{ *:[i32] }, 4:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 3855:{ *:[i32] }), 3855:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 30:{ *:[i32] }, 2:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 2:{ *:[i32] }, 0:{ *:[i32] }, 29:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }))), 4:{ *:[i32] }, 0:{ *:[i32] }, 27:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 61680:{ *:[i32] }), 61680:{ *:[i32] }))), 8:{ *:[i32] }, 8:{ *:[i32] }, 15:{ *:[i32] }), (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 30:{ *:[i32] }, 2:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 2:{ *:[i32] }, 0:{ *:[i32] }, 29:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }))), 28:{ *:[i32] }, 4:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 3855:{ *:[i32] }), 3855:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 30:{ *:[i32] }, 2:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 2:{ *:[i32] }, 0:{ *:[i32] }, 29:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }))), 4:{ *:[i32] }, 0:{ *:[i32] }, 27:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 61680:{ *:[i32] }), 61680:{ *:[i32] }))), 8:{ *:[i32] }, 24:{ *:[i32] }, 31:{ *:[i32] })
     /* 174835 */     GIR_MakeTempReg, /*TempRegID*//* 190(*/0xBE, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 174839 */     GIR_BuildMI, /*InsnID*//* 191(*/0xBF, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 174844 */     GIR_AddTempRegister, /*InsnID*//* 191(*/0xBF, 0x01/*)*/, /*TempRegID*//* 190(*/0xBE, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174851 */     GIR_AddImm, /*InsnID*//* 191(*/0xBF, 0x01/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 174862 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 191(*/0xBF, 0x01/*)*/,
     /* 174865 */     GIR_MakeTempReg, /*TempRegID*//* 189(*/0xBD, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 174869 */     GIR_BuildMI, /*InsnID*//* 190(*/0xBE, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 174874 */     GIR_AddTempRegister, /*InsnID*//* 190(*/0xBE, 0x01/*)*/, /*TempRegID*//* 189(*/0xBD, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174881 */     GIR_AddSimpleTempRegister, /*InsnID*//* 190(*/0xBE, 0x01/*)*/, /*TempRegID*//* 190(*/0xBE, 0x01/*)*/,
     /* 174886 */     GIR_AddImm, /*InsnID*//* 190(*/0xBE, 0x01/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 174897 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 190(*/0xBE, 0x01/*)*/,
     /* 174900 */     GIR_MakeTempReg, /*TempRegID*//* 188(*/0xBC, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 174904 */     GIR_BuildMI, /*InsnID*//* 189(*/0xBD, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 174909 */     GIR_AddTempRegister, /*InsnID*//* 189(*/0xBD, 0x01/*)*/, /*TempRegID*//* 188(*/0xBC, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174916 */     GIR_AddImm, /*InsnID*//* 189(*/0xBD, 0x01/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 174927 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 189(*/0xBD, 0x01/*)*/,
     /* 174930 */     GIR_MakeTempReg, /*TempRegID*//* 187(*/0xBB, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 174934 */     GIR_BuildMI, /*InsnID*//* 188(*/0xBC, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 174939 */     GIR_AddTempRegister, /*InsnID*//* 188(*/0xBC, 0x01/*)*/, /*TempRegID*//* 187(*/0xBB, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174946 */     GIR_AddSimpleTempRegister, /*InsnID*//* 188(*/0xBC, 0x01/*)*/, /*TempRegID*//* 188(*/0xBC, 0x01/*)*/,
     /* 174951 */     GIR_AddImm, /*InsnID*//* 188(*/0xBC, 0x01/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 174962 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 188(*/0xBC, 0x01/*)*/,
     /* 174965 */     GIR_MakeTempReg, /*TempRegID*//* 186(*/0xBA, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 174969 */     GIR_BuildMI, /*InsnID*//* 187(*/0xBB, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 174974 */     GIR_AddTempRegister, /*InsnID*//* 187(*/0xBB, 0x01/*)*/, /*TempRegID*//* 186(*/0xBA, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174981 */     GIR_AddImm, /*InsnID*//* 187(*/0xBB, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 174992 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 187(*/0xBB, 0x01/*)*/,
     /* 174995 */     GIR_MakeTempReg, /*TempRegID*//* 185(*/0xB9, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 174999 */     GIR_BuildMI, /*InsnID*//* 186(*/0xBA, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 175004 */     GIR_AddTempRegister, /*InsnID*//* 186(*/0xBA, 0x01/*)*/, /*TempRegID*//* 185(*/0xB9, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175011 */     GIR_AddSimpleTempRegister, /*InsnID*//* 186(*/0xBA, 0x01/*)*/, /*TempRegID*//* 186(*/0xBA, 0x01/*)*/,
     /* 175016 */     GIR_AddImm, /*InsnID*//* 186(*/0xBA, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 175027 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 186(*/0xBA, 0x01/*)*/,
     /* 175030 */     GIR_MakeTempReg, /*TempRegID*//* 184(*/0xB8, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 175034 */     GIR_BuildMI, /*InsnID*//* 185(*/0xB9, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 175039 */     GIR_AddTempRegister, /*InsnID*//* 185(*/0xB9, 0x01/*)*/, /*TempRegID*//* 184(*/0xB8, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175046 */     GIR_Copy, /*NewInsnID*//* 185(*/0xB9, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 175051 */     GIR_AddImm8, /*InsnID*//* 185(*/0xB9, 0x01/*)*/, /*Imm*/1,
     /* 175055 */     GIR_AddImm8, /*InsnID*//* 185(*/0xB9, 0x01/*)*/, /*Imm*/0,
     /* 175059 */     GIR_AddImm8, /*InsnID*//* 185(*/0xB9, 0x01/*)*/, /*Imm*/30,
     /* 175063 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 185(*/0xB9, 0x01/*)*/,
     /* 175066 */     GIR_MakeTempReg, /*TempRegID*//* 183(*/0xB7, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 175070 */     GIR_BuildMI, /*InsnID*//* 184(*/0xB8, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 175075 */     GIR_AddTempRegister, /*InsnID*//* 184(*/0xB8, 0x01/*)*/, /*TempRegID*//* 183(*/0xB7, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175082 */     GIR_AddSimpleTempRegister, /*InsnID*//* 184(*/0xB8, 0x01/*)*/, /*TempRegID*//* 184(*/0xB8, 0x01/*)*/,
     /* 175087 */     GIR_AddSimpleTempRegister, /*InsnID*//* 184(*/0xB8, 0x01/*)*/, /*TempRegID*//* 185(*/0xB9, 0x01/*)*/,
     /* 175092 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 184(*/0xB8, 0x01/*)*/,
     /* 175095 */     GIR_MakeTempReg, /*TempRegID*//* 182(*/0xB6, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 175099 */     GIR_BuildMI, /*InsnID*//* 183(*/0xB7, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 175104 */     GIR_AddTempRegister, /*InsnID*//* 183(*/0xB7, 0x01/*)*/, /*TempRegID*//* 182(*/0xB6, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175111 */     GIR_AddImm, /*InsnID*//* 183(*/0xB7, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 175122 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 183(*/0xB7, 0x01/*)*/,
     /* 175125 */     GIR_MakeTempReg, /*TempRegID*//* 181(*/0xB5, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 175129 */     GIR_BuildMI, /*InsnID*//* 182(*/0xB6, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 175134 */     GIR_AddTempRegister, /*InsnID*//* 182(*/0xB6, 0x01/*)*/, /*TempRegID*//* 181(*/0xB5, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175141 */     GIR_AddSimpleTempRegister, /*InsnID*//* 182(*/0xB6, 0x01/*)*/, /*TempRegID*//* 182(*/0xB6, 0x01/*)*/,
     /* 175146 */     GIR_AddImm, /*InsnID*//* 182(*/0xB6, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 175157 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 182(*/0xB6, 0x01/*)*/,
     /* 175160 */     GIR_MakeTempReg, /*TempRegID*//* 180(*/0xB4, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 175164 */     GIR_BuildMI, /*InsnID*//* 181(*/0xB5, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 175169 */     GIR_AddTempRegister, /*InsnID*//* 181(*/0xB5, 0x01/*)*/, /*TempRegID*//* 180(*/0xB4, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175176 */     GIR_Copy, /*NewInsnID*//* 181(*/0xB5, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 175181 */     GIR_AddImm8, /*InsnID*//* 181(*/0xB5, 0x01/*)*/, /*Imm*/31,
     /* 175185 */     GIR_AddImm8, /*InsnID*//* 181(*/0xB5, 0x01/*)*/, /*Imm*/1,
     /* 175189 */     GIR_AddImm8, /*InsnID*//* 181(*/0xB5, 0x01/*)*/, /*Imm*/31,
     /* 175193 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 181(*/0xB5, 0x01/*)*/,
     /* 175196 */     GIR_MakeTempReg, /*TempRegID*//* 179(*/0xB3, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 175200 */     GIR_BuildMI, /*InsnID*//* 180(*/0xB4, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 175205 */     GIR_AddTempRegister, /*InsnID*//* 180(*/0xB4, 0x01/*)*/, /*TempRegID*//* 179(*/0xB3, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175212 */     GIR_AddSimpleTempRegister, /*InsnID*//* 180(*/0xB4, 0x01/*)*/, /*TempRegID*//* 180(*/0xB4, 0x01/*)*/,
     /* 175217 */     GIR_AddSimpleTempRegister, /*InsnID*//* 180(*/0xB4, 0x01/*)*/, /*TempRegID*//* 181(*/0xB5, 0x01/*)*/,
     /* 175222 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 180(*/0xB4, 0x01/*)*/,
     /* 175225 */     GIR_MakeTempReg, /*TempRegID*//* 178(*/0xB2, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 175229 */     GIR_BuildMI, /*InsnID*//* 179(*/0xB3, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 175234 */     GIR_AddTempRegister, /*InsnID*//* 179(*/0xB3, 0x01/*)*/, /*TempRegID*//* 178(*/0xB2, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175241 */     GIR_AddSimpleTempRegister, /*InsnID*//* 179(*/0xB3, 0x01/*)*/, /*TempRegID*//* 179(*/0xB3, 0x01/*)*/,
     /* 175246 */     GIR_AddSimpleTempRegister, /*InsnID*//* 179(*/0xB3, 0x01/*)*/, /*TempRegID*//* 183(*/0xB7, 0x01/*)*/,
     /* 175251 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 179(*/0xB3, 0x01/*)*/,
     /* 175254 */     GIR_MakeTempReg, /*TempRegID*//* 177(*/0xB1, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 175258 */     GIR_BuildMI, /*InsnID*//* 178(*/0xB2, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 175263 */     GIR_AddTempRegister, /*InsnID*//* 178(*/0xB2, 0x01/*)*/, /*TempRegID*//* 177(*/0xB1, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175270 */     GIR_AddSimpleTempRegister, /*InsnID*//* 178(*/0xB2, 0x01/*)*/, /*TempRegID*//* 178(*/0xB2, 0x01/*)*/,
     /* 175275 */     GIR_AddImm8, /*InsnID*//* 178(*/0xB2, 0x01/*)*/, /*Imm*/2,
     /* 175279 */     GIR_AddImm8, /*InsnID*//* 178(*/0xB2, 0x01/*)*/, /*Imm*/0,
     /* 175283 */     GIR_AddImm8, /*InsnID*//* 178(*/0xB2, 0x01/*)*/, /*Imm*/29,
     /* 175287 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 178(*/0xB2, 0x01/*)*/,
     /* 175290 */     GIR_MakeTempReg, /*TempRegID*//* 176(*/0xB0, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 175294 */     GIR_BuildMI, /*InsnID*//* 177(*/0xB1, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 175299 */     GIR_AddTempRegister, /*InsnID*//* 177(*/0xB1, 0x01/*)*/, /*TempRegID*//* 176(*/0xB0, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175306 */     GIR_AddSimpleTempRegister, /*InsnID*//* 177(*/0xB1, 0x01/*)*/, /*TempRegID*//* 177(*/0xB1, 0x01/*)*/,
     /* 175311 */     GIR_AddSimpleTempRegister, /*InsnID*//* 177(*/0xB1, 0x01/*)*/, /*TempRegID*//* 187(*/0xBB, 0x01/*)*/,
     /* 175316 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 177(*/0xB1, 0x01/*)*/,
     /* 175319 */     GIR_MakeTempReg, /*TempRegID*//* 175(*/0xAF, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 175323 */     GIR_BuildMI, /*InsnID*//* 176(*/0xB0, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 175328 */     GIR_AddTempRegister, /*InsnID*//* 176(*/0xB0, 0x01/*)*/, /*TempRegID*//* 175(*/0xAF, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175335 */     GIR_AddImm, /*InsnID*//* 176(*/0xB0, 0x01/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 175346 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 176(*/0xB0, 0x01/*)*/,
     /* 175349 */     GIR_MakeTempReg, /*TempRegID*//* 174(*/0xAE, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 175353 */     GIR_BuildMI, /*InsnID*//* 175(*/0xAF, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 175358 */     GIR_AddTempRegister, /*InsnID*//* 175(*/0xAF, 0x01/*)*/, /*TempRegID*//* 174(*/0xAE, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175365 */     GIR_AddSimpleTempRegister, /*InsnID*//* 175(*/0xAF, 0x01/*)*/, /*TempRegID*//* 175(*/0xAF, 0x01/*)*/,
     /* 175370 */     GIR_AddImm, /*InsnID*//* 175(*/0xAF, 0x01/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 175381 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 175(*/0xAF, 0x01/*)*/,
     /* 175384 */     GIR_MakeTempReg, /*TempRegID*//* 173(*/0xAD, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 175388 */     GIR_BuildMI, /*InsnID*//* 174(*/0xAE, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 175393 */     GIR_AddTempRegister, /*InsnID*//* 174(*/0xAE, 0x01/*)*/, /*TempRegID*//* 173(*/0xAD, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175400 */     GIR_AddImm, /*InsnID*//* 174(*/0xAE, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 175411 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 174(*/0xAE, 0x01/*)*/,
     /* 175414 */     GIR_MakeTempReg, /*TempRegID*//* 172(*/0xAC, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 175418 */     GIR_BuildMI, /*InsnID*//* 173(*/0xAD, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 175423 */     GIR_AddTempRegister, /*InsnID*//* 173(*/0xAD, 0x01/*)*/, /*TempRegID*//* 172(*/0xAC, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175430 */     GIR_AddSimpleTempRegister, /*InsnID*//* 173(*/0xAD, 0x01/*)*/, /*TempRegID*//* 173(*/0xAD, 0x01/*)*/,
     /* 175435 */     GIR_AddImm, /*InsnID*//* 173(*/0xAD, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 175446 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 173(*/0xAD, 0x01/*)*/,
     /* 175449 */     GIR_MakeTempReg, /*TempRegID*//* 171(*/0xAB, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 175453 */     GIR_BuildMI, /*InsnID*//* 172(*/0xAC, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 175458 */     GIR_AddTempRegister, /*InsnID*//* 172(*/0xAC, 0x01/*)*/, /*TempRegID*//* 171(*/0xAB, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175465 */     GIR_Copy, /*NewInsnID*//* 172(*/0xAC, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 175470 */     GIR_AddImm8, /*InsnID*//* 172(*/0xAC, 0x01/*)*/, /*Imm*/1,
     /* 175474 */     GIR_AddImm8, /*InsnID*//* 172(*/0xAC, 0x01/*)*/, /*Imm*/0,
     /* 175478 */     GIR_AddImm8, /*InsnID*//* 172(*/0xAC, 0x01/*)*/, /*Imm*/30,
     /* 175482 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 172(*/0xAC, 0x01/*)*/,
     /* 175485 */     GIR_MakeTempReg, /*TempRegID*//* 170(*/0xAA, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 175489 */     GIR_BuildMI, /*InsnID*//* 171(*/0xAB, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 175494 */     GIR_AddTempRegister, /*InsnID*//* 171(*/0xAB, 0x01/*)*/, /*TempRegID*//* 170(*/0xAA, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175501 */     GIR_AddSimpleTempRegister, /*InsnID*//* 171(*/0xAB, 0x01/*)*/, /*TempRegID*//* 171(*/0xAB, 0x01/*)*/,
     /* 175506 */     GIR_AddSimpleTempRegister, /*InsnID*//* 171(*/0xAB, 0x01/*)*/, /*TempRegID*//* 172(*/0xAC, 0x01/*)*/,
     /* 175511 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 171(*/0xAB, 0x01/*)*/,
     /* 175514 */     GIR_MakeTempReg, /*TempRegID*//* 169(*/0xA9, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 175518 */     GIR_BuildMI, /*InsnID*//* 170(*/0xAA, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 175523 */     GIR_AddTempRegister, /*InsnID*//* 170(*/0xAA, 0x01/*)*/, /*TempRegID*//* 169(*/0xA9, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175530 */     GIR_AddImm, /*InsnID*//* 170(*/0xAA, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 175541 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 170(*/0xAA, 0x01/*)*/,
     /* 175544 */     GIR_MakeTempReg, /*TempRegID*//* 168(*/0xA8, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 175548 */     GIR_BuildMI, /*InsnID*//* 169(*/0xA9, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 175553 */     GIR_AddTempRegister, /*InsnID*//* 169(*/0xA9, 0x01/*)*/, /*TempRegID*//* 168(*/0xA8, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175560 */     GIR_AddSimpleTempRegister, /*InsnID*//* 169(*/0xA9, 0x01/*)*/, /*TempRegID*//* 169(*/0xA9, 0x01/*)*/,
     /* 175565 */     GIR_AddImm, /*InsnID*//* 169(*/0xA9, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 175576 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 169(*/0xA9, 0x01/*)*/,
     /* 175579 */     GIR_MakeTempReg, /*TempRegID*//* 167(*/0xA7, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 175583 */     GIR_BuildMI, /*InsnID*//* 168(*/0xA8, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 175588 */     GIR_AddTempRegister, /*InsnID*//* 168(*/0xA8, 0x01/*)*/, /*TempRegID*//* 167(*/0xA7, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175595 */     GIR_Copy, /*NewInsnID*//* 168(*/0xA8, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 175600 */     GIR_AddImm8, /*InsnID*//* 168(*/0xA8, 0x01/*)*/, /*Imm*/31,
     /* 175604 */     GIR_AddImm8, /*InsnID*//* 168(*/0xA8, 0x01/*)*/, /*Imm*/1,
     /* 175608 */     GIR_AddImm8, /*InsnID*//* 168(*/0xA8, 0x01/*)*/, /*Imm*/31,
     /* 175612 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 168(*/0xA8, 0x01/*)*/,
     /* 175615 */     GIR_MakeTempReg, /*TempRegID*//* 166(*/0xA6, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 175619 */     GIR_BuildMI, /*InsnID*//* 167(*/0xA7, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 175624 */     GIR_AddTempRegister, /*InsnID*//* 167(*/0xA7, 0x01/*)*/, /*TempRegID*//* 166(*/0xA6, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175631 */     GIR_AddSimpleTempRegister, /*InsnID*//* 167(*/0xA7, 0x01/*)*/, /*TempRegID*//* 167(*/0xA7, 0x01/*)*/,
     /* 175636 */     GIR_AddSimpleTempRegister, /*InsnID*//* 167(*/0xA7, 0x01/*)*/, /*TempRegID*//* 168(*/0xA8, 0x01/*)*/,
     /* 175641 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 167(*/0xA7, 0x01/*)*/,
     /* 175644 */     GIR_MakeTempReg, /*TempRegID*//* 165(*/0xA5, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 175648 */     GIR_BuildMI, /*InsnID*//* 166(*/0xA6, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 175653 */     GIR_AddTempRegister, /*InsnID*//* 166(*/0xA6, 0x01/*)*/, /*TempRegID*//* 165(*/0xA5, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175660 */     GIR_AddSimpleTempRegister, /*InsnID*//* 166(*/0xA6, 0x01/*)*/, /*TempRegID*//* 166(*/0xA6, 0x01/*)*/,
     /* 175665 */     GIR_AddSimpleTempRegister, /*InsnID*//* 166(*/0xA6, 0x01/*)*/, /*TempRegID*//* 170(*/0xAA, 0x01/*)*/,
     /* 175670 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 166(*/0xA6, 0x01/*)*/,
     /* 175673 */     GIR_MakeTempReg, /*TempRegID*//* 164(*/0xA4, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 175677 */     GIR_BuildMI, /*InsnID*//* 165(*/0xA5, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 175682 */     GIR_AddTempRegister, /*InsnID*//* 165(*/0xA5, 0x01/*)*/, /*TempRegID*//* 164(*/0xA4, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175689 */     GIR_AddSimpleTempRegister, /*InsnID*//* 165(*/0xA5, 0x01/*)*/, /*TempRegID*//* 165(*/0xA5, 0x01/*)*/,
     /* 175694 */     GIR_AddImm8, /*InsnID*//* 165(*/0xA5, 0x01/*)*/, /*Imm*/30,
     /* 175698 */     GIR_AddImm8, /*InsnID*//* 165(*/0xA5, 0x01/*)*/, /*Imm*/2,
     /* 175702 */     GIR_AddImm8, /*InsnID*//* 165(*/0xA5, 0x01/*)*/, /*Imm*/31,
     /* 175706 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 165(*/0xA5, 0x01/*)*/,
     /* 175709 */     GIR_MakeTempReg, /*TempRegID*//* 163(*/0xA3, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 175713 */     GIR_BuildMI, /*InsnID*//* 164(*/0xA4, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 175718 */     GIR_AddTempRegister, /*InsnID*//* 164(*/0xA4, 0x01/*)*/, /*TempRegID*//* 163(*/0xA3, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175725 */     GIR_AddSimpleTempRegister, /*InsnID*//* 164(*/0xA4, 0x01/*)*/, /*TempRegID*//* 164(*/0xA4, 0x01/*)*/,
     /* 175730 */     GIR_AddSimpleTempRegister, /*InsnID*//* 164(*/0xA4, 0x01/*)*/, /*TempRegID*//* 174(*/0xAE, 0x01/*)*/,
     /* 175735 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 164(*/0xA4, 0x01/*)*/,
     /* 175738 */     GIR_MakeTempReg, /*TempRegID*//* 162(*/0xA2, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 175742 */     GIR_BuildMI, /*InsnID*//* 163(*/0xA3, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 175747 */     GIR_AddTempRegister, /*InsnID*//* 163(*/0xA3, 0x01/*)*/, /*TempRegID*//* 162(*/0xA2, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175754 */     GIR_AddSimpleTempRegister, /*InsnID*//* 163(*/0xA3, 0x01/*)*/, /*TempRegID*//* 163(*/0xA3, 0x01/*)*/,
     /* 175759 */     GIR_AddSimpleTempRegister, /*InsnID*//* 163(*/0xA3, 0x01/*)*/, /*TempRegID*//* 176(*/0xB0, 0x01/*)*/,
     /* 175764 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 163(*/0xA3, 0x01/*)*/,
     /* 175767 */     GIR_MakeTempReg, /*TempRegID*//* 161(*/0xA1, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 175771 */     GIR_BuildMI, /*InsnID*//* 162(*/0xA2, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 175776 */     GIR_AddTempRegister, /*InsnID*//* 162(*/0xA2, 0x01/*)*/, /*TempRegID*//* 161(*/0xA1, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175783 */     GIR_AddSimpleTempRegister, /*InsnID*//* 162(*/0xA2, 0x01/*)*/, /*TempRegID*//* 162(*/0xA2, 0x01/*)*/,
     /* 175788 */     GIR_AddImm8, /*InsnID*//* 162(*/0xA2, 0x01/*)*/, /*Imm*/4,
     /* 175792 */     GIR_AddImm8, /*InsnID*//* 162(*/0xA2, 0x01/*)*/, /*Imm*/0,
     /* 175796 */     GIR_AddImm8, /*InsnID*//* 162(*/0xA2, 0x01/*)*/, /*Imm*/27,
     /* 175800 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 162(*/0xA2, 0x01/*)*/,
     /* 175803 */     GIR_MakeTempReg, /*TempRegID*//* 160(*/0xA0, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 175807 */     GIR_BuildMI, /*InsnID*//* 161(*/0xA1, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 175812 */     GIR_AddTempRegister, /*InsnID*//* 161(*/0xA1, 0x01/*)*/, /*TempRegID*//* 160(*/0xA0, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175819 */     GIR_AddSimpleTempRegister, /*InsnID*//* 161(*/0xA1, 0x01/*)*/, /*TempRegID*//* 161(*/0xA1, 0x01/*)*/,
     /* 175824 */     GIR_AddSimpleTempRegister, /*InsnID*//* 161(*/0xA1, 0x01/*)*/, /*TempRegID*//* 189(*/0xBD, 0x01/*)*/,
     /* 175829 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 161(*/0xA1, 0x01/*)*/,
     /* 175832 */     GIR_MakeTempReg, /*TempRegID*//* 159(*/0x9F, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 175836 */     GIR_BuildMI, /*InsnID*//* 160(*/0xA0, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 175841 */     GIR_AddTempRegister, /*InsnID*//* 160(*/0xA0, 0x01/*)*/, /*TempRegID*//* 159(*/0x9F, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175848 */     GIR_AddImm, /*InsnID*//* 160(*/0xA0, 0x01/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 175859 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 160(*/0xA0, 0x01/*)*/,
     /* 175862 */     GIR_MakeTempReg, /*TempRegID*//* 158(*/0x9E, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 175866 */     GIR_BuildMI, /*InsnID*//* 159(*/0x9F, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 175871 */     GIR_AddTempRegister, /*InsnID*//* 159(*/0x9F, 0x01/*)*/, /*TempRegID*//* 158(*/0x9E, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175878 */     GIR_AddSimpleTempRegister, /*InsnID*//* 159(*/0x9F, 0x01/*)*/, /*TempRegID*//* 159(*/0x9F, 0x01/*)*/,
     /* 175883 */     GIR_AddImm, /*InsnID*//* 159(*/0x9F, 0x01/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 175894 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 159(*/0x9F, 0x01/*)*/,
     /* 175897 */     GIR_MakeTempReg, /*TempRegID*//* 157(*/0x9D, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 175901 */     GIR_BuildMI, /*InsnID*//* 158(*/0x9E, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 175906 */     GIR_AddTempRegister, /*InsnID*//* 158(*/0x9E, 0x01/*)*/, /*TempRegID*//* 157(*/0x9D, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175913 */     GIR_AddImm, /*InsnID*//* 158(*/0x9E, 0x01/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 175924 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 158(*/0x9E, 0x01/*)*/,
     /* 175927 */     GIR_MakeTempReg, /*TempRegID*//* 156(*/0x9C, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 175931 */     GIR_BuildMI, /*InsnID*//* 157(*/0x9D, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 175936 */     GIR_AddTempRegister, /*InsnID*//* 157(*/0x9D, 0x01/*)*/, /*TempRegID*//* 156(*/0x9C, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175943 */     GIR_AddSimpleTempRegister, /*InsnID*//* 157(*/0x9D, 0x01/*)*/, /*TempRegID*//* 157(*/0x9D, 0x01/*)*/,
     /* 175948 */     GIR_AddImm, /*InsnID*//* 157(*/0x9D, 0x01/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 175959 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 157(*/0x9D, 0x01/*)*/,
     /* 175962 */     GIR_MakeTempReg, /*TempRegID*//* 155(*/0x9B, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 175966 */     GIR_BuildMI, /*InsnID*//* 156(*/0x9C, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 175971 */     GIR_AddTempRegister, /*InsnID*//* 156(*/0x9C, 0x01/*)*/, /*TempRegID*//* 155(*/0x9B, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175978 */     GIR_AddImm, /*InsnID*//* 156(*/0x9C, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 175989 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 156(*/0x9C, 0x01/*)*/,
     /* 175992 */     GIR_MakeTempReg, /*TempRegID*//* 154(*/0x9A, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 175996 */     GIR_BuildMI, /*InsnID*//* 155(*/0x9B, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 176001 */     GIR_AddTempRegister, /*InsnID*//* 155(*/0x9B, 0x01/*)*/, /*TempRegID*//* 154(*/0x9A, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176008 */     GIR_AddSimpleTempRegister, /*InsnID*//* 155(*/0x9B, 0x01/*)*/, /*TempRegID*//* 155(*/0x9B, 0x01/*)*/,
     /* 176013 */     GIR_AddImm, /*InsnID*//* 155(*/0x9B, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 176024 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 155(*/0x9B, 0x01/*)*/,
     /* 176027 */     GIR_MakeTempReg, /*TempRegID*//* 153(*/0x99, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 176031 */     GIR_BuildMI, /*InsnID*//* 154(*/0x9A, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 176036 */     GIR_AddTempRegister, /*InsnID*//* 154(*/0x9A, 0x01/*)*/, /*TempRegID*//* 153(*/0x99, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176043 */     GIR_Copy, /*NewInsnID*//* 154(*/0x9A, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 176048 */     GIR_AddImm8, /*InsnID*//* 154(*/0x9A, 0x01/*)*/, /*Imm*/1,
     /* 176052 */     GIR_AddImm8, /*InsnID*//* 154(*/0x9A, 0x01/*)*/, /*Imm*/0,
     /* 176056 */     GIR_AddImm8, /*InsnID*//* 154(*/0x9A, 0x01/*)*/, /*Imm*/30,
     /* 176060 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 154(*/0x9A, 0x01/*)*/,
     /* 176063 */     GIR_MakeTempReg, /*TempRegID*//* 152(*/0x98, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 176067 */     GIR_BuildMI, /*InsnID*//* 153(*/0x99, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 176072 */     GIR_AddTempRegister, /*InsnID*//* 153(*/0x99, 0x01/*)*/, /*TempRegID*//* 152(*/0x98, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176079 */     GIR_AddSimpleTempRegister, /*InsnID*//* 153(*/0x99, 0x01/*)*/, /*TempRegID*//* 153(*/0x99, 0x01/*)*/,
     /* 176084 */     GIR_AddSimpleTempRegister, /*InsnID*//* 153(*/0x99, 0x01/*)*/, /*TempRegID*//* 154(*/0x9A, 0x01/*)*/,
     /* 176089 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 153(*/0x99, 0x01/*)*/,
     /* 176092 */     GIR_MakeTempReg, /*TempRegID*//* 151(*/0x97, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 176096 */     GIR_BuildMI, /*InsnID*//* 152(*/0x98, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 176101 */     GIR_AddTempRegister, /*InsnID*//* 152(*/0x98, 0x01/*)*/, /*TempRegID*//* 151(*/0x97, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176108 */     GIR_AddImm, /*InsnID*//* 152(*/0x98, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 176119 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 152(*/0x98, 0x01/*)*/,
     /* 176122 */     GIR_MakeTempReg, /*TempRegID*//* 150(*/0x96, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 176126 */     GIR_BuildMI, /*InsnID*//* 151(*/0x97, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 176131 */     GIR_AddTempRegister, /*InsnID*//* 151(*/0x97, 0x01/*)*/, /*TempRegID*//* 150(*/0x96, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176138 */     GIR_AddSimpleTempRegister, /*InsnID*//* 151(*/0x97, 0x01/*)*/, /*TempRegID*//* 151(*/0x97, 0x01/*)*/,
     /* 176143 */     GIR_AddImm, /*InsnID*//* 151(*/0x97, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 176154 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 151(*/0x97, 0x01/*)*/,
     /* 176157 */     GIR_MakeTempReg, /*TempRegID*//* 149(*/0x95, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 176161 */     GIR_BuildMI, /*InsnID*//* 150(*/0x96, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 176166 */     GIR_AddTempRegister, /*InsnID*//* 150(*/0x96, 0x01/*)*/, /*TempRegID*//* 149(*/0x95, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176173 */     GIR_Copy, /*NewInsnID*//* 150(*/0x96, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 176178 */     GIR_AddImm8, /*InsnID*//* 150(*/0x96, 0x01/*)*/, /*Imm*/31,
     /* 176182 */     GIR_AddImm8, /*InsnID*//* 150(*/0x96, 0x01/*)*/, /*Imm*/1,
     /* 176186 */     GIR_AddImm8, /*InsnID*//* 150(*/0x96, 0x01/*)*/, /*Imm*/31,
     /* 176190 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 150(*/0x96, 0x01/*)*/,
     /* 176193 */     GIR_MakeTempReg, /*TempRegID*//* 148(*/0x94, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 176197 */     GIR_BuildMI, /*InsnID*//* 149(*/0x95, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 176202 */     GIR_AddTempRegister, /*InsnID*//* 149(*/0x95, 0x01/*)*/, /*TempRegID*//* 148(*/0x94, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176209 */     GIR_AddSimpleTempRegister, /*InsnID*//* 149(*/0x95, 0x01/*)*/, /*TempRegID*//* 149(*/0x95, 0x01/*)*/,
     /* 176214 */     GIR_AddSimpleTempRegister, /*InsnID*//* 149(*/0x95, 0x01/*)*/, /*TempRegID*//* 150(*/0x96, 0x01/*)*/,
     /* 176219 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 149(*/0x95, 0x01/*)*/,
     /* 176222 */     GIR_MakeTempReg, /*TempRegID*//* 147(*/0x93, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 176226 */     GIR_BuildMI, /*InsnID*//* 148(*/0x94, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 176231 */     GIR_AddTempRegister, /*InsnID*//* 148(*/0x94, 0x01/*)*/, /*TempRegID*//* 147(*/0x93, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176238 */     GIR_AddSimpleTempRegister, /*InsnID*//* 148(*/0x94, 0x01/*)*/, /*TempRegID*//* 148(*/0x94, 0x01/*)*/,
     /* 176243 */     GIR_AddSimpleTempRegister, /*InsnID*//* 148(*/0x94, 0x01/*)*/, /*TempRegID*//* 152(*/0x98, 0x01/*)*/,
     /* 176248 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 148(*/0x94, 0x01/*)*/,
     /* 176251 */     GIR_MakeTempReg, /*TempRegID*//* 146(*/0x92, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 176255 */     GIR_BuildMI, /*InsnID*//* 147(*/0x93, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 176260 */     GIR_AddTempRegister, /*InsnID*//* 147(*/0x93, 0x01/*)*/, /*TempRegID*//* 146(*/0x92, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176267 */     GIR_AddSimpleTempRegister, /*InsnID*//* 147(*/0x93, 0x01/*)*/, /*TempRegID*//* 147(*/0x93, 0x01/*)*/,
     /* 176272 */     GIR_AddImm8, /*InsnID*//* 147(*/0x93, 0x01/*)*/, /*Imm*/2,
     /* 176276 */     GIR_AddImm8, /*InsnID*//* 147(*/0x93, 0x01/*)*/, /*Imm*/0,
     /* 176280 */     GIR_AddImm8, /*InsnID*//* 147(*/0x93, 0x01/*)*/, /*Imm*/29,
     /* 176284 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 147(*/0x93, 0x01/*)*/,
     /* 176287 */     GIR_MakeTempReg, /*TempRegID*//* 145(*/0x91, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 176291 */     GIR_BuildMI, /*InsnID*//* 146(*/0x92, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 176296 */     GIR_AddTempRegister, /*InsnID*//* 146(*/0x92, 0x01/*)*/, /*TempRegID*//* 145(*/0x91, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176303 */     GIR_AddSimpleTempRegister, /*InsnID*//* 146(*/0x92, 0x01/*)*/, /*TempRegID*//* 146(*/0x92, 0x01/*)*/,
     /* 176308 */     GIR_AddSimpleTempRegister, /*InsnID*//* 146(*/0x92, 0x01/*)*/, /*TempRegID*//* 156(*/0x9C, 0x01/*)*/,
     /* 176313 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 146(*/0x92, 0x01/*)*/,
     /* 176316 */     GIR_MakeTempReg, /*TempRegID*//* 144(*/0x90, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 176320 */     GIR_BuildMI, /*InsnID*//* 145(*/0x91, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 176325 */     GIR_AddTempRegister, /*InsnID*//* 145(*/0x91, 0x01/*)*/, /*TempRegID*//* 144(*/0x90, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176332 */     GIR_AddImm, /*InsnID*//* 145(*/0x91, 0x01/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 176343 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 145(*/0x91, 0x01/*)*/,
     /* 176346 */     GIR_MakeTempReg, /*TempRegID*//* 143(*/0x8F, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 176350 */     GIR_BuildMI, /*InsnID*//* 144(*/0x90, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 176355 */     GIR_AddTempRegister, /*InsnID*//* 144(*/0x90, 0x01/*)*/, /*TempRegID*//* 143(*/0x8F, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176362 */     GIR_AddSimpleTempRegister, /*InsnID*//* 144(*/0x90, 0x01/*)*/, /*TempRegID*//* 144(*/0x90, 0x01/*)*/,
     /* 176367 */     GIR_AddImm, /*InsnID*//* 144(*/0x90, 0x01/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 176378 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 144(*/0x90, 0x01/*)*/,
     /* 176381 */     GIR_MakeTempReg, /*TempRegID*//* 142(*/0x8E, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 176385 */     GIR_BuildMI, /*InsnID*//* 143(*/0x8F, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 176390 */     GIR_AddTempRegister, /*InsnID*//* 143(*/0x8F, 0x01/*)*/, /*TempRegID*//* 142(*/0x8E, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176397 */     GIR_AddImm, /*InsnID*//* 143(*/0x8F, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 176408 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 143(*/0x8F, 0x01/*)*/,
     /* 176411 */     GIR_MakeTempReg, /*TempRegID*//* 141(*/0x8D, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 176415 */     GIR_BuildMI, /*InsnID*//* 142(*/0x8E, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 176420 */     GIR_AddTempRegister, /*InsnID*//* 142(*/0x8E, 0x01/*)*/, /*TempRegID*//* 141(*/0x8D, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176427 */     GIR_AddSimpleTempRegister, /*InsnID*//* 142(*/0x8E, 0x01/*)*/, /*TempRegID*//* 142(*/0x8E, 0x01/*)*/,
     /* 176432 */     GIR_AddImm, /*InsnID*//* 142(*/0x8E, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 176443 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 142(*/0x8E, 0x01/*)*/,
     /* 176446 */     GIR_MakeTempReg, /*TempRegID*//* 140(*/0x8C, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 176450 */     GIR_BuildMI, /*InsnID*//* 141(*/0x8D, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 176455 */     GIR_AddTempRegister, /*InsnID*//* 141(*/0x8D, 0x01/*)*/, /*TempRegID*//* 140(*/0x8C, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176462 */     GIR_Copy, /*NewInsnID*//* 141(*/0x8D, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 176467 */     GIR_AddImm8, /*InsnID*//* 141(*/0x8D, 0x01/*)*/, /*Imm*/1,
     /* 176471 */     GIR_AddImm8, /*InsnID*//* 141(*/0x8D, 0x01/*)*/, /*Imm*/0,
     /* 176475 */     GIR_AddImm8, /*InsnID*//* 141(*/0x8D, 0x01/*)*/, /*Imm*/30,
     /* 176479 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 141(*/0x8D, 0x01/*)*/,
     /* 176482 */     GIR_MakeTempReg, /*TempRegID*//* 139(*/0x8B, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 176486 */     GIR_BuildMI, /*InsnID*//* 140(*/0x8C, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 176491 */     GIR_AddTempRegister, /*InsnID*//* 140(*/0x8C, 0x01/*)*/, /*TempRegID*//* 139(*/0x8B, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176498 */     GIR_AddSimpleTempRegister, /*InsnID*//* 140(*/0x8C, 0x01/*)*/, /*TempRegID*//* 140(*/0x8C, 0x01/*)*/,
     /* 176503 */     GIR_AddSimpleTempRegister, /*InsnID*//* 140(*/0x8C, 0x01/*)*/, /*TempRegID*//* 141(*/0x8D, 0x01/*)*/,
     /* 176508 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 140(*/0x8C, 0x01/*)*/,
     /* 176511 */     GIR_MakeTempReg, /*TempRegID*//* 138(*/0x8A, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 176515 */     GIR_BuildMI, /*InsnID*//* 139(*/0x8B, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 176520 */     GIR_AddTempRegister, /*InsnID*//* 139(*/0x8B, 0x01/*)*/, /*TempRegID*//* 138(*/0x8A, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176527 */     GIR_AddImm, /*InsnID*//* 139(*/0x8B, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 176538 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 139(*/0x8B, 0x01/*)*/,
     /* 176541 */     GIR_MakeTempReg, /*TempRegID*//* 137(*/0x89, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 176545 */     GIR_BuildMI, /*InsnID*//* 138(*/0x8A, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 176550 */     GIR_AddTempRegister, /*InsnID*//* 138(*/0x8A, 0x01/*)*/, /*TempRegID*//* 137(*/0x89, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176557 */     GIR_AddSimpleTempRegister, /*InsnID*//* 138(*/0x8A, 0x01/*)*/, /*TempRegID*//* 138(*/0x8A, 0x01/*)*/,
     /* 176562 */     GIR_AddImm, /*InsnID*//* 138(*/0x8A, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 176573 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 138(*/0x8A, 0x01/*)*/,
     /* 176576 */     GIR_MakeTempReg, /*TempRegID*//* 136(*/0x88, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 176580 */     GIR_BuildMI, /*InsnID*//* 137(*/0x89, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 176585 */     GIR_AddTempRegister, /*InsnID*//* 137(*/0x89, 0x01/*)*/, /*TempRegID*//* 136(*/0x88, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176592 */     GIR_Copy, /*NewInsnID*//* 137(*/0x89, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 176597 */     GIR_AddImm8, /*InsnID*//* 137(*/0x89, 0x01/*)*/, /*Imm*/31,
     /* 176601 */     GIR_AddImm8, /*InsnID*//* 137(*/0x89, 0x01/*)*/, /*Imm*/1,
     /* 176605 */     GIR_AddImm8, /*InsnID*//* 137(*/0x89, 0x01/*)*/, /*Imm*/31,
     /* 176609 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 137(*/0x89, 0x01/*)*/,
     /* 176612 */     GIR_MakeTempReg, /*TempRegID*//* 135(*/0x87, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 176616 */     GIR_BuildMI, /*InsnID*//* 136(*/0x88, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 176621 */     GIR_AddTempRegister, /*InsnID*//* 136(*/0x88, 0x01/*)*/, /*TempRegID*//* 135(*/0x87, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176628 */     GIR_AddSimpleTempRegister, /*InsnID*//* 136(*/0x88, 0x01/*)*/, /*TempRegID*//* 136(*/0x88, 0x01/*)*/,
     /* 176633 */     GIR_AddSimpleTempRegister, /*InsnID*//* 136(*/0x88, 0x01/*)*/, /*TempRegID*//* 137(*/0x89, 0x01/*)*/,
     /* 176638 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 136(*/0x88, 0x01/*)*/,
     /* 176641 */     GIR_MakeTempReg, /*TempRegID*//* 134(*/0x86, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 176645 */     GIR_BuildMI, /*InsnID*//* 135(*/0x87, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 176650 */     GIR_AddTempRegister, /*InsnID*//* 135(*/0x87, 0x01/*)*/, /*TempRegID*//* 134(*/0x86, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176657 */     GIR_AddSimpleTempRegister, /*InsnID*//* 135(*/0x87, 0x01/*)*/, /*TempRegID*//* 135(*/0x87, 0x01/*)*/,
     /* 176662 */     GIR_AddSimpleTempRegister, /*InsnID*//* 135(*/0x87, 0x01/*)*/, /*TempRegID*//* 139(*/0x8B, 0x01/*)*/,
     /* 176667 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 135(*/0x87, 0x01/*)*/,
     /* 176670 */     GIR_MakeTempReg, /*TempRegID*//* 133(*/0x85, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 176674 */     GIR_BuildMI, /*InsnID*//* 134(*/0x86, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 176679 */     GIR_AddTempRegister, /*InsnID*//* 134(*/0x86, 0x01/*)*/, /*TempRegID*//* 133(*/0x85, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176686 */     GIR_AddSimpleTempRegister, /*InsnID*//* 134(*/0x86, 0x01/*)*/, /*TempRegID*//* 134(*/0x86, 0x01/*)*/,
     /* 176691 */     GIR_AddImm8, /*InsnID*//* 134(*/0x86, 0x01/*)*/, /*Imm*/30,
     /* 176695 */     GIR_AddImm8, /*InsnID*//* 134(*/0x86, 0x01/*)*/, /*Imm*/2,
     /* 176699 */     GIR_AddImm8, /*InsnID*//* 134(*/0x86, 0x01/*)*/, /*Imm*/31,
     /* 176703 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 134(*/0x86, 0x01/*)*/,
     /* 176706 */     GIR_MakeTempReg, /*TempRegID*//* 132(*/0x84, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 176710 */     GIR_BuildMI, /*InsnID*//* 133(*/0x85, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 176715 */     GIR_AddTempRegister, /*InsnID*//* 133(*/0x85, 0x01/*)*/, /*TempRegID*//* 132(*/0x84, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176722 */     GIR_AddSimpleTempRegister, /*InsnID*//* 133(*/0x85, 0x01/*)*/, /*TempRegID*//* 133(*/0x85, 0x01/*)*/,
     /* 176727 */     GIR_AddSimpleTempRegister, /*InsnID*//* 133(*/0x85, 0x01/*)*/, /*TempRegID*//* 143(*/0x8F, 0x01/*)*/,
     /* 176732 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 133(*/0x85, 0x01/*)*/,
     /* 176735 */     GIR_MakeTempReg, /*TempRegID*//* 131(*/0x83, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 176739 */     GIR_BuildMI, /*InsnID*//* 132(*/0x84, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 176744 */     GIR_AddTempRegister, /*InsnID*//* 132(*/0x84, 0x01/*)*/, /*TempRegID*//* 131(*/0x83, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176751 */     GIR_AddSimpleTempRegister, /*InsnID*//* 132(*/0x84, 0x01/*)*/, /*TempRegID*//* 132(*/0x84, 0x01/*)*/,
     /* 176756 */     GIR_AddSimpleTempRegister, /*InsnID*//* 132(*/0x84, 0x01/*)*/, /*TempRegID*//* 145(*/0x91, 0x01/*)*/,
     /* 176761 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 132(*/0x84, 0x01/*)*/,
     /* 176764 */     GIR_MakeTempReg, /*TempRegID*//* 130(*/0x82, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 176768 */     GIR_BuildMI, /*InsnID*//* 131(*/0x83, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 176773 */     GIR_AddTempRegister, /*InsnID*//* 131(*/0x83, 0x01/*)*/, /*TempRegID*//* 130(*/0x82, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176780 */     GIR_AddSimpleTempRegister, /*InsnID*//* 131(*/0x83, 0x01/*)*/, /*TempRegID*//* 131(*/0x83, 0x01/*)*/,
     /* 176785 */     GIR_AddImm8, /*InsnID*//* 131(*/0x83, 0x01/*)*/, /*Imm*/28,
     /* 176789 */     GIR_AddImm8, /*InsnID*//* 131(*/0x83, 0x01/*)*/, /*Imm*/4,
     /* 176793 */     GIR_AddImm8, /*InsnID*//* 131(*/0x83, 0x01/*)*/, /*Imm*/31,
     /* 176797 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 131(*/0x83, 0x01/*)*/,
     /* 176800 */     GIR_MakeTempReg, /*TempRegID*//* 129(*/0x81, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 176804 */     GIR_BuildMI, /*InsnID*//* 130(*/0x82, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 176809 */     GIR_AddTempRegister, /*InsnID*//* 130(*/0x82, 0x01/*)*/, /*TempRegID*//* 129(*/0x81, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176816 */     GIR_AddSimpleTempRegister, /*InsnID*//* 130(*/0x82, 0x01/*)*/, /*TempRegID*//* 130(*/0x82, 0x01/*)*/,
     /* 176821 */     GIR_AddSimpleTempRegister, /*InsnID*//* 130(*/0x82, 0x01/*)*/, /*TempRegID*//* 158(*/0x9E, 0x01/*)*/,
     /* 176826 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 130(*/0x82, 0x01/*)*/,
     /* 176829 */     GIR_MakeTempReg, /*TempRegID*//* 128(*/0x80, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 176833 */     GIR_BuildMI, /*InsnID*//* 129(*/0x81, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 176838 */     GIR_AddTempRegister, /*InsnID*//* 129(*/0x81, 0x01/*)*/, /*TempRegID*//* 128(*/0x80, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176845 */     GIR_AddSimpleTempRegister, /*InsnID*//* 129(*/0x81, 0x01/*)*/, /*TempRegID*//* 129(*/0x81, 0x01/*)*/,
     /* 176850 */     GIR_AddSimpleTempRegister, /*InsnID*//* 129(*/0x81, 0x01/*)*/, /*TempRegID*//* 160(*/0xA0, 0x01/*)*/,
     /* 176855 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 129(*/0x81, 0x01/*)*/,
     /* 176858 */     GIR_MakeTempReg, /*TempRegID*/127, /*TypeID*/GILLT_s32,
     /* 176861 */     GIR_BuildMI, /*InsnID*//* 128(*/0x80, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 176866 */     GIR_AddTempRegister, /*InsnID*//* 128(*/0x80, 0x01/*)*/, /*TempRegID*/127, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176872 */     GIR_AddImm, /*InsnID*//* 128(*/0x80, 0x01/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 176883 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 128(*/0x80, 0x01/*)*/,
     /* 176886 */     GIR_MakeTempReg, /*TempRegID*/126, /*TypeID*/GILLT_s32,
     /* 176889 */     GIR_BuildMI, /*InsnID*/127, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 176893 */     GIR_AddTempRegister, /*InsnID*/127, /*TempRegID*/126, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176898 */     GIR_AddSimpleTempRegister, /*InsnID*/127, /*TempRegID*/127,
     /* 176901 */     GIR_AddImm, /*InsnID*/127, /*Imm*/GIMT_Encode8(61680),
     /* 176911 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/127,
     /* 176913 */     GIR_MakeTempReg, /*TempRegID*/125, /*TypeID*/GILLT_s32,
     /* 176916 */     GIR_BuildMI, /*InsnID*/126, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 176920 */     GIR_AddTempRegister, /*InsnID*/126, /*TempRegID*/125, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176925 */     GIR_AddImm, /*InsnID*/126, /*Imm*/GIMT_Encode8(52428),
     /* 176935 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/126,
     /* 176937 */     GIR_MakeTempReg, /*TempRegID*/124, /*TypeID*/GILLT_s32,
     /* 176940 */     GIR_BuildMI, /*InsnID*/125, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 176944 */     GIR_AddTempRegister, /*InsnID*/125, /*TempRegID*/124, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176949 */     GIR_AddSimpleTempRegister, /*InsnID*/125, /*TempRegID*/125,
     /* 176952 */     GIR_AddImm, /*InsnID*/125, /*Imm*/GIMT_Encode8(52428),
     /* 176962 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/125,
     /* 176964 */     GIR_MakeTempReg, /*TempRegID*/123, /*TypeID*/GILLT_s32,
     /* 176967 */     GIR_BuildMI, /*InsnID*/124, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 176971 */     GIR_AddTempRegister, /*InsnID*/124, /*TempRegID*/123, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176976 */     GIR_AddImm, /*InsnID*/124, /*Imm*/GIMT_Encode8(43690),
     /* 176986 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/124,
     /* 176988 */     GIR_MakeTempReg, /*TempRegID*/122, /*TypeID*/GILLT_s32,
     /* 176991 */     GIR_BuildMI, /*InsnID*/123, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 176995 */     GIR_AddTempRegister, /*InsnID*/123, /*TempRegID*/122, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177000 */     GIR_AddSimpleTempRegister, /*InsnID*/123, /*TempRegID*/123,
     /* 177003 */     GIR_AddImm, /*InsnID*/123, /*Imm*/GIMT_Encode8(43690),
     /* 177013 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/123,
     /* 177015 */     GIR_MakeTempReg, /*TempRegID*/121, /*TypeID*/GILLT_s32,
     /* 177018 */     GIR_BuildMI, /*InsnID*/122, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 177022 */     GIR_AddTempRegister, /*InsnID*/122, /*TempRegID*/121, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177027 */     GIR_Copy, /*NewInsnID*/122, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 177031 */     GIR_AddImm8, /*InsnID*/122, /*Imm*/1,
     /* 177034 */     GIR_AddImm8, /*InsnID*/122, /*Imm*/0,
     /* 177037 */     GIR_AddImm8, /*InsnID*/122, /*Imm*/30,
     /* 177040 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/122,
     /* 177042 */     GIR_MakeTempReg, /*TempRegID*/120, /*TypeID*/GILLT_s32,
     /* 177045 */     GIR_BuildMI, /*InsnID*/121, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 177049 */     GIR_AddTempRegister, /*InsnID*/121, /*TempRegID*/120, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177054 */     GIR_AddSimpleTempRegister, /*InsnID*/121, /*TempRegID*/121,
     /* 177057 */     GIR_AddSimpleTempRegister, /*InsnID*/121, /*TempRegID*/122,
     /* 177060 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/121,
     /* 177062 */     GIR_MakeTempReg, /*TempRegID*/119, /*TypeID*/GILLT_s32,
     /* 177065 */     GIR_BuildMI, /*InsnID*/120, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 177069 */     GIR_AddTempRegister, /*InsnID*/120, /*TempRegID*/119, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177074 */     GIR_AddImm, /*InsnID*/120, /*Imm*/GIMT_Encode8(21845),
     /* 177084 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/120,
     /* 177086 */     GIR_MakeTempReg, /*TempRegID*/118, /*TypeID*/GILLT_s32,
     /* 177089 */     GIR_BuildMI, /*InsnID*/119, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 177093 */     GIR_AddTempRegister, /*InsnID*/119, /*TempRegID*/118, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177098 */     GIR_AddSimpleTempRegister, /*InsnID*/119, /*TempRegID*/119,
     /* 177101 */     GIR_AddImm, /*InsnID*/119, /*Imm*/GIMT_Encode8(21845),
     /* 177111 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/119,
     /* 177113 */     GIR_MakeTempReg, /*TempRegID*/117, /*TypeID*/GILLT_s32,
     /* 177116 */     GIR_BuildMI, /*InsnID*/118, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 177120 */     GIR_AddTempRegister, /*InsnID*/118, /*TempRegID*/117, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177125 */     GIR_Copy, /*NewInsnID*/118, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 177129 */     GIR_AddImm8, /*InsnID*/118, /*Imm*/31,
     /* 177132 */     GIR_AddImm8, /*InsnID*/118, /*Imm*/1,
     /* 177135 */     GIR_AddImm8, /*InsnID*/118, /*Imm*/31,
     /* 177138 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/118,
     /* 177140 */     GIR_MakeTempReg, /*TempRegID*/116, /*TypeID*/GILLT_s32,
     /* 177143 */     GIR_BuildMI, /*InsnID*/117, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 177147 */     GIR_AddTempRegister, /*InsnID*/117, /*TempRegID*/116, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177152 */     GIR_AddSimpleTempRegister, /*InsnID*/117, /*TempRegID*/117,
     /* 177155 */     GIR_AddSimpleTempRegister, /*InsnID*/117, /*TempRegID*/118,
     /* 177158 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/117,
     /* 177160 */     GIR_MakeTempReg, /*TempRegID*/115, /*TypeID*/GILLT_s32,
     /* 177163 */     GIR_BuildMI, /*InsnID*/116, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 177167 */     GIR_AddTempRegister, /*InsnID*/116, /*TempRegID*/115, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177172 */     GIR_AddSimpleTempRegister, /*InsnID*/116, /*TempRegID*/116,
     /* 177175 */     GIR_AddSimpleTempRegister, /*InsnID*/116, /*TempRegID*/120,
     /* 177178 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/116,
     /* 177180 */     GIR_MakeTempReg, /*TempRegID*/114, /*TypeID*/GILLT_s32,
     /* 177183 */     GIR_BuildMI, /*InsnID*/115, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 177187 */     GIR_AddTempRegister, /*InsnID*/115, /*TempRegID*/114, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177192 */     GIR_AddSimpleTempRegister, /*InsnID*/115, /*TempRegID*/115,
     /* 177195 */     GIR_AddImm8, /*InsnID*/115, /*Imm*/2,
     /* 177198 */     GIR_AddImm8, /*InsnID*/115, /*Imm*/0,
     /* 177201 */     GIR_AddImm8, /*InsnID*/115, /*Imm*/29,
     /* 177204 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/115,
     /* 177206 */     GIR_MakeTempReg, /*TempRegID*/113, /*TypeID*/GILLT_s32,
     /* 177209 */     GIR_BuildMI, /*InsnID*/114, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 177213 */     GIR_AddTempRegister, /*InsnID*/114, /*TempRegID*/113, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177218 */     GIR_AddSimpleTempRegister, /*InsnID*/114, /*TempRegID*/114,
     /* 177221 */     GIR_AddSimpleTempRegister, /*InsnID*/114, /*TempRegID*/124,
     /* 177224 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/114,
     /* 177226 */     GIR_MakeTempReg, /*TempRegID*/112, /*TypeID*/GILLT_s32,
     /* 177229 */     GIR_BuildMI, /*InsnID*/113, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 177233 */     GIR_AddTempRegister, /*InsnID*/113, /*TempRegID*/112, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177238 */     GIR_AddImm, /*InsnID*/113, /*Imm*/GIMT_Encode8(13107),
     /* 177248 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/113,
     /* 177250 */     GIR_MakeTempReg, /*TempRegID*/111, /*TypeID*/GILLT_s32,
     /* 177253 */     GIR_BuildMI, /*InsnID*/112, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 177257 */     GIR_AddTempRegister, /*InsnID*/112, /*TempRegID*/111, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177262 */     GIR_AddSimpleTempRegister, /*InsnID*/112, /*TempRegID*/112,
     /* 177265 */     GIR_AddImm, /*InsnID*/112, /*Imm*/GIMT_Encode8(13107),
     /* 177275 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/112,
     /* 177277 */     GIR_MakeTempReg, /*TempRegID*/110, /*TypeID*/GILLT_s32,
     /* 177280 */     GIR_BuildMI, /*InsnID*/111, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 177284 */     GIR_AddTempRegister, /*InsnID*/111, /*TempRegID*/110, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177289 */     GIR_AddImm, /*InsnID*/111, /*Imm*/GIMT_Encode8(43690),
     /* 177299 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/111,
     /* 177301 */     GIR_MakeTempReg, /*TempRegID*/109, /*TypeID*/GILLT_s32,
     /* 177304 */     GIR_BuildMI, /*InsnID*/110, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 177308 */     GIR_AddTempRegister, /*InsnID*/110, /*TempRegID*/109, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177313 */     GIR_AddSimpleTempRegister, /*InsnID*/110, /*TempRegID*/110,
     /* 177316 */     GIR_AddImm, /*InsnID*/110, /*Imm*/GIMT_Encode8(43690),
     /* 177326 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/110,
     /* 177328 */     GIR_MakeTempReg, /*TempRegID*/108, /*TypeID*/GILLT_s32,
     /* 177331 */     GIR_BuildMI, /*InsnID*/109, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 177335 */     GIR_AddTempRegister, /*InsnID*/109, /*TempRegID*/108, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177340 */     GIR_Copy, /*NewInsnID*/109, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 177344 */     GIR_AddImm8, /*InsnID*/109, /*Imm*/1,
     /* 177347 */     GIR_AddImm8, /*InsnID*/109, /*Imm*/0,
     /* 177350 */     GIR_AddImm8, /*InsnID*/109, /*Imm*/30,
     /* 177353 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/109,
     /* 177355 */     GIR_MakeTempReg, /*TempRegID*/107, /*TypeID*/GILLT_s32,
     /* 177358 */     GIR_BuildMI, /*InsnID*/108, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 177362 */     GIR_AddTempRegister, /*InsnID*/108, /*TempRegID*/107, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177367 */     GIR_AddSimpleTempRegister, /*InsnID*/108, /*TempRegID*/108,
     /* 177370 */     GIR_AddSimpleTempRegister, /*InsnID*/108, /*TempRegID*/109,
     /* 177373 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/108,
     /* 177375 */     GIR_MakeTempReg, /*TempRegID*/106, /*TypeID*/GILLT_s32,
     /* 177378 */     GIR_BuildMI, /*InsnID*/107, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 177382 */     GIR_AddTempRegister, /*InsnID*/107, /*TempRegID*/106, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177387 */     GIR_AddImm, /*InsnID*/107, /*Imm*/GIMT_Encode8(21845),
     /* 177397 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/107,
     /* 177399 */     GIR_MakeTempReg, /*TempRegID*/105, /*TypeID*/GILLT_s32,
     /* 177402 */     GIR_BuildMI, /*InsnID*/106, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 177406 */     GIR_AddTempRegister, /*InsnID*/106, /*TempRegID*/105, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177411 */     GIR_AddSimpleTempRegister, /*InsnID*/106, /*TempRegID*/106,
     /* 177414 */     GIR_AddImm, /*InsnID*/106, /*Imm*/GIMT_Encode8(21845),
     /* 177424 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/106,
     /* 177426 */     GIR_MakeTempReg, /*TempRegID*/104, /*TypeID*/GILLT_s32,
     /* 177429 */     GIR_BuildMI, /*InsnID*/105, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 177433 */     GIR_AddTempRegister, /*InsnID*/105, /*TempRegID*/104, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177438 */     GIR_Copy, /*NewInsnID*/105, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 177442 */     GIR_AddImm8, /*InsnID*/105, /*Imm*/31,
     /* 177445 */     GIR_AddImm8, /*InsnID*/105, /*Imm*/1,
     /* 177448 */     GIR_AddImm8, /*InsnID*/105, /*Imm*/31,
     /* 177451 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/105,
     /* 177453 */     GIR_MakeTempReg, /*TempRegID*/103, /*TypeID*/GILLT_s32,
     /* 177456 */     GIR_BuildMI, /*InsnID*/104, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 177460 */     GIR_AddTempRegister, /*InsnID*/104, /*TempRegID*/103, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177465 */     GIR_AddSimpleTempRegister, /*InsnID*/104, /*TempRegID*/104,
     /* 177468 */     GIR_AddSimpleTempRegister, /*InsnID*/104, /*TempRegID*/105,
     /* 177471 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/104,
     /* 177473 */     GIR_MakeTempReg, /*TempRegID*/102, /*TypeID*/GILLT_s32,
     /* 177476 */     GIR_BuildMI, /*InsnID*/103, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 177480 */     GIR_AddTempRegister, /*InsnID*/103, /*TempRegID*/102, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177485 */     GIR_AddSimpleTempRegister, /*InsnID*/103, /*TempRegID*/103,
     /* 177488 */     GIR_AddSimpleTempRegister, /*InsnID*/103, /*TempRegID*/107,
     /* 177491 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/103,
     /* 177493 */     GIR_MakeTempReg, /*TempRegID*/101, /*TypeID*/GILLT_s32,
     /* 177496 */     GIR_BuildMI, /*InsnID*/102, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 177500 */     GIR_AddTempRegister, /*InsnID*/102, /*TempRegID*/101, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177505 */     GIR_AddSimpleTempRegister, /*InsnID*/102, /*TempRegID*/102,
     /* 177508 */     GIR_AddImm8, /*InsnID*/102, /*Imm*/30,
     /* 177511 */     GIR_AddImm8, /*InsnID*/102, /*Imm*/2,
     /* 177514 */     GIR_AddImm8, /*InsnID*/102, /*Imm*/31,
     /* 177517 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/102,
     /* 177519 */     GIR_MakeTempReg, /*TempRegID*/100, /*TypeID*/GILLT_s32,
     /* 177522 */     GIR_BuildMI, /*InsnID*/101, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 177526 */     GIR_AddTempRegister, /*InsnID*/101, /*TempRegID*/100, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177531 */     GIR_AddSimpleTempRegister, /*InsnID*/101, /*TempRegID*/101,
     /* 177534 */     GIR_AddSimpleTempRegister, /*InsnID*/101, /*TempRegID*/111,
     /* 177537 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/101,
     /* 177539 */     GIR_MakeTempReg, /*TempRegID*/99, /*TypeID*/GILLT_s32,
     /* 177542 */     GIR_BuildMI, /*InsnID*/100, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 177546 */     GIR_AddTempRegister, /*InsnID*/100, /*TempRegID*/99, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177551 */     GIR_AddSimpleTempRegister, /*InsnID*/100, /*TempRegID*/100,
     /* 177554 */     GIR_AddSimpleTempRegister, /*InsnID*/100, /*TempRegID*/113,
     /* 177557 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/100,
     /* 177559 */     GIR_MakeTempReg, /*TempRegID*/98, /*TypeID*/GILLT_s32,
     /* 177562 */     GIR_BuildMI, /*InsnID*/99, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 177566 */     GIR_AddTempRegister, /*InsnID*/99, /*TempRegID*/98, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177571 */     GIR_AddSimpleTempRegister, /*InsnID*/99, /*TempRegID*/99,
     /* 177574 */     GIR_AddImm8, /*InsnID*/99, /*Imm*/4,
     /* 177577 */     GIR_AddImm8, /*InsnID*/99, /*Imm*/0,
     /* 177580 */     GIR_AddImm8, /*InsnID*/99, /*Imm*/27,
     /* 177583 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/99,
     /* 177585 */     GIR_MakeTempReg, /*TempRegID*/97, /*TypeID*/GILLT_s32,
     /* 177588 */     GIR_BuildMI, /*InsnID*/98, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 177592 */     GIR_AddTempRegister, /*InsnID*/98, /*TempRegID*/97, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177597 */     GIR_AddSimpleTempRegister, /*InsnID*/98, /*TempRegID*/98,
     /* 177600 */     GIR_AddSimpleTempRegister, /*InsnID*/98, /*TempRegID*/126,
     /* 177603 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/98,
     /* 177605 */     GIR_MakeTempReg, /*TempRegID*/96, /*TypeID*/GILLT_s32,
     /* 177608 */     GIR_BuildMI, /*InsnID*/97, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 177612 */     GIR_AddTempRegister, /*InsnID*/97, /*TempRegID*/96, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177617 */     GIR_AddImm, /*InsnID*/97, /*Imm*/GIMT_Encode8(3855),
     /* 177627 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/97,
     /* 177629 */     GIR_MakeTempReg, /*TempRegID*/95, /*TypeID*/GILLT_s32,
     /* 177632 */     GIR_BuildMI, /*InsnID*/96, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 177636 */     GIR_AddTempRegister, /*InsnID*/96, /*TempRegID*/95, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177641 */     GIR_AddSimpleTempRegister, /*InsnID*/96, /*TempRegID*/96,
     /* 177644 */     GIR_AddImm, /*InsnID*/96, /*Imm*/GIMT_Encode8(3855),
     /* 177654 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/96,
     /* 177656 */     GIR_MakeTempReg, /*TempRegID*/94, /*TypeID*/GILLT_s32,
     /* 177659 */     GIR_BuildMI, /*InsnID*/95, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 177663 */     GIR_AddTempRegister, /*InsnID*/95, /*TempRegID*/94, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177668 */     GIR_AddImm, /*InsnID*/95, /*Imm*/GIMT_Encode8(52428),
     /* 177678 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/95,
     /* 177680 */     GIR_MakeTempReg, /*TempRegID*/93, /*TypeID*/GILLT_s32,
     /* 177683 */     GIR_BuildMI, /*InsnID*/94, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 177687 */     GIR_AddTempRegister, /*InsnID*/94, /*TempRegID*/93, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177692 */     GIR_AddSimpleTempRegister, /*InsnID*/94, /*TempRegID*/94,
     /* 177695 */     GIR_AddImm, /*InsnID*/94, /*Imm*/GIMT_Encode8(52428),
     /* 177705 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/94,
     /* 177707 */     GIR_MakeTempReg, /*TempRegID*/92, /*TypeID*/GILLT_s32,
     /* 177710 */     GIR_BuildMI, /*InsnID*/93, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 177714 */     GIR_AddTempRegister, /*InsnID*/93, /*TempRegID*/92, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177719 */     GIR_AddImm, /*InsnID*/93, /*Imm*/GIMT_Encode8(43690),
     /* 177729 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/93,
     /* 177731 */     GIR_MakeTempReg, /*TempRegID*/91, /*TypeID*/GILLT_s32,
     /* 177734 */     GIR_BuildMI, /*InsnID*/92, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 177738 */     GIR_AddTempRegister, /*InsnID*/92, /*TempRegID*/91, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177743 */     GIR_AddSimpleTempRegister, /*InsnID*/92, /*TempRegID*/92,
     /* 177746 */     GIR_AddImm, /*InsnID*/92, /*Imm*/GIMT_Encode8(43690),
     /* 177756 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/92,
     /* 177758 */     GIR_MakeTempReg, /*TempRegID*/90, /*TypeID*/GILLT_s32,
     /* 177761 */     GIR_BuildMI, /*InsnID*/91, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 177765 */     GIR_AddTempRegister, /*InsnID*/91, /*TempRegID*/90, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177770 */     GIR_Copy, /*NewInsnID*/91, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 177774 */     GIR_AddImm8, /*InsnID*/91, /*Imm*/1,
     /* 177777 */     GIR_AddImm8, /*InsnID*/91, /*Imm*/0,
     /* 177780 */     GIR_AddImm8, /*InsnID*/91, /*Imm*/30,
     /* 177783 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/91,
     /* 177785 */     GIR_MakeTempReg, /*TempRegID*/89, /*TypeID*/GILLT_s32,
     /* 177788 */     GIR_BuildMI, /*InsnID*/90, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 177792 */     GIR_AddTempRegister, /*InsnID*/90, /*TempRegID*/89, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177797 */     GIR_AddSimpleTempRegister, /*InsnID*/90, /*TempRegID*/90,
     /* 177800 */     GIR_AddSimpleTempRegister, /*InsnID*/90, /*TempRegID*/91,
     /* 177803 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/90,
     /* 177805 */     GIR_MakeTempReg, /*TempRegID*/88, /*TypeID*/GILLT_s32,
     /* 177808 */     GIR_BuildMI, /*InsnID*/89, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 177812 */     GIR_AddTempRegister, /*InsnID*/89, /*TempRegID*/88, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177817 */     GIR_AddImm, /*InsnID*/89, /*Imm*/GIMT_Encode8(21845),
     /* 177827 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/89,
     /* 177829 */     GIR_MakeTempReg, /*TempRegID*/87, /*TypeID*/GILLT_s32,
     /* 177832 */     GIR_BuildMI, /*InsnID*/88, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 177836 */     GIR_AddTempRegister, /*InsnID*/88, /*TempRegID*/87, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177841 */     GIR_AddSimpleTempRegister, /*InsnID*/88, /*TempRegID*/88,
     /* 177844 */     GIR_AddImm, /*InsnID*/88, /*Imm*/GIMT_Encode8(21845),
     /* 177854 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/88,
     /* 177856 */     GIR_MakeTempReg, /*TempRegID*/86, /*TypeID*/GILLT_s32,
     /* 177859 */     GIR_BuildMI, /*InsnID*/87, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 177863 */     GIR_AddTempRegister, /*InsnID*/87, /*TempRegID*/86, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177868 */     GIR_Copy, /*NewInsnID*/87, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 177872 */     GIR_AddImm8, /*InsnID*/87, /*Imm*/31,
     /* 177875 */     GIR_AddImm8, /*InsnID*/87, /*Imm*/1,
     /* 177878 */     GIR_AddImm8, /*InsnID*/87, /*Imm*/31,
     /* 177881 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/87,
     /* 177883 */     GIR_MakeTempReg, /*TempRegID*/85, /*TypeID*/GILLT_s32,
     /* 177886 */     GIR_BuildMI, /*InsnID*/86, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 177890 */     GIR_AddTempRegister, /*InsnID*/86, /*TempRegID*/85, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177895 */     GIR_AddSimpleTempRegister, /*InsnID*/86, /*TempRegID*/86,
     /* 177898 */     GIR_AddSimpleTempRegister, /*InsnID*/86, /*TempRegID*/87,
     /* 177901 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/86,
     /* 177903 */     GIR_MakeTempReg, /*TempRegID*/84, /*TypeID*/GILLT_s32,
     /* 177906 */     GIR_BuildMI, /*InsnID*/85, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 177910 */     GIR_AddTempRegister, /*InsnID*/85, /*TempRegID*/84, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177915 */     GIR_AddSimpleTempRegister, /*InsnID*/85, /*TempRegID*/85,
     /* 177918 */     GIR_AddSimpleTempRegister, /*InsnID*/85, /*TempRegID*/89,
     /* 177921 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/85,
     /* 177923 */     GIR_MakeTempReg, /*TempRegID*/83, /*TypeID*/GILLT_s32,
     /* 177926 */     GIR_BuildMI, /*InsnID*/84, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 177930 */     GIR_AddTempRegister, /*InsnID*/84, /*TempRegID*/83, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177935 */     GIR_AddSimpleTempRegister, /*InsnID*/84, /*TempRegID*/84,
     /* 177938 */     GIR_AddImm8, /*InsnID*/84, /*Imm*/2,
     /* 177941 */     GIR_AddImm8, /*InsnID*/84, /*Imm*/0,
     /* 177944 */     GIR_AddImm8, /*InsnID*/84, /*Imm*/29,
     /* 177947 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/84,
     /* 177949 */     GIR_MakeTempReg, /*TempRegID*/82, /*TypeID*/GILLT_s32,
     /* 177952 */     GIR_BuildMI, /*InsnID*/83, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 177956 */     GIR_AddTempRegister, /*InsnID*/83, /*TempRegID*/82, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177961 */     GIR_AddSimpleTempRegister, /*InsnID*/83, /*TempRegID*/83,
     /* 177964 */     GIR_AddSimpleTempRegister, /*InsnID*/83, /*TempRegID*/93,
     /* 177967 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/83,
     /* 177969 */     GIR_MakeTempReg, /*TempRegID*/81, /*TypeID*/GILLT_s32,
     /* 177972 */     GIR_BuildMI, /*InsnID*/82, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 177976 */     GIR_AddTempRegister, /*InsnID*/82, /*TempRegID*/81, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177981 */     GIR_AddImm, /*InsnID*/82, /*Imm*/GIMT_Encode8(13107),
     /* 177991 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/82,
     /* 177993 */     GIR_MakeTempReg, /*TempRegID*/80, /*TypeID*/GILLT_s32,
     /* 177996 */     GIR_BuildMI, /*InsnID*/81, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 178000 */     GIR_AddTempRegister, /*InsnID*/81, /*TempRegID*/80, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178005 */     GIR_AddSimpleTempRegister, /*InsnID*/81, /*TempRegID*/81,
     /* 178008 */     GIR_AddImm, /*InsnID*/81, /*Imm*/GIMT_Encode8(13107),
     /* 178018 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/81,
     /* 178020 */     GIR_MakeTempReg, /*TempRegID*/79, /*TypeID*/GILLT_s32,
     /* 178023 */     GIR_BuildMI, /*InsnID*/80, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 178027 */     GIR_AddTempRegister, /*InsnID*/80, /*TempRegID*/79, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178032 */     GIR_AddImm, /*InsnID*/80, /*Imm*/GIMT_Encode8(43690),
     /* 178042 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/80,
     /* 178044 */     GIR_MakeTempReg, /*TempRegID*/78, /*TypeID*/GILLT_s32,
     /* 178047 */     GIR_BuildMI, /*InsnID*/79, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 178051 */     GIR_AddTempRegister, /*InsnID*/79, /*TempRegID*/78, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178056 */     GIR_AddSimpleTempRegister, /*InsnID*/79, /*TempRegID*/79,
     /* 178059 */     GIR_AddImm, /*InsnID*/79, /*Imm*/GIMT_Encode8(43690),
     /* 178069 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/79,
     /* 178071 */     GIR_MakeTempReg, /*TempRegID*/77, /*TypeID*/GILLT_s32,
     /* 178074 */     GIR_BuildMI, /*InsnID*/78, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 178078 */     GIR_AddTempRegister, /*InsnID*/78, /*TempRegID*/77, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178083 */     GIR_Copy, /*NewInsnID*/78, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 178087 */     GIR_AddImm8, /*InsnID*/78, /*Imm*/1,
     /* 178090 */     GIR_AddImm8, /*InsnID*/78, /*Imm*/0,
     /* 178093 */     GIR_AddImm8, /*InsnID*/78, /*Imm*/30,
     /* 178096 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/78,
     /* 178098 */     GIR_MakeTempReg, /*TempRegID*/76, /*TypeID*/GILLT_s32,
     /* 178101 */     GIR_BuildMI, /*InsnID*/77, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 178105 */     GIR_AddTempRegister, /*InsnID*/77, /*TempRegID*/76, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178110 */     GIR_AddSimpleTempRegister, /*InsnID*/77, /*TempRegID*/77,
     /* 178113 */     GIR_AddSimpleTempRegister, /*InsnID*/77, /*TempRegID*/78,
     /* 178116 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/77,
     /* 178118 */     GIR_MakeTempReg, /*TempRegID*/75, /*TypeID*/GILLT_s32,
     /* 178121 */     GIR_BuildMI, /*InsnID*/76, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 178125 */     GIR_AddTempRegister, /*InsnID*/76, /*TempRegID*/75, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178130 */     GIR_AddImm, /*InsnID*/76, /*Imm*/GIMT_Encode8(21845),
     /* 178140 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/76,
     /* 178142 */     GIR_MakeTempReg, /*TempRegID*/74, /*TypeID*/GILLT_s32,
     /* 178145 */     GIR_BuildMI, /*InsnID*/75, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 178149 */     GIR_AddTempRegister, /*InsnID*/75, /*TempRegID*/74, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178154 */     GIR_AddSimpleTempRegister, /*InsnID*/75, /*TempRegID*/75,
     /* 178157 */     GIR_AddImm, /*InsnID*/75, /*Imm*/GIMT_Encode8(21845),
     /* 178167 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/75,
     /* 178169 */     GIR_MakeTempReg, /*TempRegID*/73, /*TypeID*/GILLT_s32,
     /* 178172 */     GIR_BuildMI, /*InsnID*/74, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 178176 */     GIR_AddTempRegister, /*InsnID*/74, /*TempRegID*/73, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178181 */     GIR_Copy, /*NewInsnID*/74, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 178185 */     GIR_AddImm8, /*InsnID*/74, /*Imm*/31,
     /* 178188 */     GIR_AddImm8, /*InsnID*/74, /*Imm*/1,
     /* 178191 */     GIR_AddImm8, /*InsnID*/74, /*Imm*/31,
     /* 178194 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/74,
     /* 178196 */     GIR_MakeTempReg, /*TempRegID*/72, /*TypeID*/GILLT_s32,
     /* 178199 */     GIR_BuildMI, /*InsnID*/73, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 178203 */     GIR_AddTempRegister, /*InsnID*/73, /*TempRegID*/72, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178208 */     GIR_AddSimpleTempRegister, /*InsnID*/73, /*TempRegID*/73,
     /* 178211 */     GIR_AddSimpleTempRegister, /*InsnID*/73, /*TempRegID*/74,
     /* 178214 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/73,
     /* 178216 */     GIR_MakeTempReg, /*TempRegID*/71, /*TypeID*/GILLT_s32,
     /* 178219 */     GIR_BuildMI, /*InsnID*/72, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 178223 */     GIR_AddTempRegister, /*InsnID*/72, /*TempRegID*/71, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178228 */     GIR_AddSimpleTempRegister, /*InsnID*/72, /*TempRegID*/72,
     /* 178231 */     GIR_AddSimpleTempRegister, /*InsnID*/72, /*TempRegID*/76,
     /* 178234 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/72,
     /* 178236 */     GIR_MakeTempReg, /*TempRegID*/70, /*TypeID*/GILLT_s32,
     /* 178239 */     GIR_BuildMI, /*InsnID*/71, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 178243 */     GIR_AddTempRegister, /*InsnID*/71, /*TempRegID*/70, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178248 */     GIR_AddSimpleTempRegister, /*InsnID*/71, /*TempRegID*/71,
     /* 178251 */     GIR_AddImm8, /*InsnID*/71, /*Imm*/30,
     /* 178254 */     GIR_AddImm8, /*InsnID*/71, /*Imm*/2,
     /* 178257 */     GIR_AddImm8, /*InsnID*/71, /*Imm*/31,
     /* 178260 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/71,
     /* 178262 */     GIR_MakeTempReg, /*TempRegID*/69, /*TypeID*/GILLT_s32,
     /* 178265 */     GIR_BuildMI, /*InsnID*/70, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 178269 */     GIR_AddTempRegister, /*InsnID*/70, /*TempRegID*/69, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178274 */     GIR_AddSimpleTempRegister, /*InsnID*/70, /*TempRegID*/70,
     /* 178277 */     GIR_AddSimpleTempRegister, /*InsnID*/70, /*TempRegID*/80,
     /* 178280 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/70,
     /* 178282 */     GIR_MakeTempReg, /*TempRegID*/68, /*TypeID*/GILLT_s32,
     /* 178285 */     GIR_BuildMI, /*InsnID*/69, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 178289 */     GIR_AddTempRegister, /*InsnID*/69, /*TempRegID*/68, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178294 */     GIR_AddSimpleTempRegister, /*InsnID*/69, /*TempRegID*/69,
     /* 178297 */     GIR_AddSimpleTempRegister, /*InsnID*/69, /*TempRegID*/82,
     /* 178300 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/69,
     /* 178302 */     GIR_MakeTempReg, /*TempRegID*/67, /*TypeID*/GILLT_s32,
     /* 178305 */     GIR_BuildMI, /*InsnID*/68, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 178309 */     GIR_AddTempRegister, /*InsnID*/68, /*TempRegID*/67, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178314 */     GIR_AddSimpleTempRegister, /*InsnID*/68, /*TempRegID*/68,
     /* 178317 */     GIR_AddImm8, /*InsnID*/68, /*Imm*/28,
     /* 178320 */     GIR_AddImm8, /*InsnID*/68, /*Imm*/4,
     /* 178323 */     GIR_AddImm8, /*InsnID*/68, /*Imm*/31,
     /* 178326 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/68,
     /* 178328 */     GIR_MakeTempReg, /*TempRegID*/66, /*TypeID*/GILLT_s32,
     /* 178331 */     GIR_BuildMI, /*InsnID*/67, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 178335 */     GIR_AddTempRegister, /*InsnID*/67, /*TempRegID*/66, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178340 */     GIR_AddSimpleTempRegister, /*InsnID*/67, /*TempRegID*/67,
     /* 178343 */     GIR_AddSimpleTempRegister, /*InsnID*/67, /*TempRegID*/95,
     /* 178346 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/67,
     /* 178348 */     GIR_MakeTempReg, /*TempRegID*/65, /*TypeID*/GILLT_s32,
     /* 178351 */     GIR_BuildMI, /*InsnID*/66, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 178355 */     GIR_AddTempRegister, /*InsnID*/66, /*TempRegID*/65, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178360 */     GIR_AddSimpleTempRegister, /*InsnID*/66, /*TempRegID*/66,
     /* 178363 */     GIR_AddSimpleTempRegister, /*InsnID*/66, /*TempRegID*/97,
     /* 178366 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/66,
     /* 178368 */     GIR_MakeTempReg, /*TempRegID*/64, /*TypeID*/GILLT_s32,
     /* 178371 */     GIR_BuildMI, /*InsnID*/65, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 178375 */     GIR_AddTempRegister, /*InsnID*/65, /*TempRegID*/64, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178380 */     GIR_AddImm, /*InsnID*/65, /*Imm*/GIMT_Encode8(61680),
     /* 178390 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/65,
     /* 178392 */     GIR_MakeTempReg, /*TempRegID*/63, /*TypeID*/GILLT_s32,
     /* 178395 */     GIR_BuildMI, /*InsnID*/64, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 178399 */     GIR_AddTempRegister, /*InsnID*/64, /*TempRegID*/63, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178404 */     GIR_AddSimpleTempRegister, /*InsnID*/64, /*TempRegID*/64,
     /* 178407 */     GIR_AddImm, /*InsnID*/64, /*Imm*/GIMT_Encode8(61680),
     /* 178417 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/64,
     /* 178419 */     GIR_MakeTempReg, /*TempRegID*/62, /*TypeID*/GILLT_s32,
     /* 178422 */     GIR_BuildMI, /*InsnID*/63, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 178426 */     GIR_AddTempRegister, /*InsnID*/63, /*TempRegID*/62, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178431 */     GIR_AddImm, /*InsnID*/63, /*Imm*/GIMT_Encode8(52428),
     /* 178441 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/63,
     /* 178443 */     GIR_MakeTempReg, /*TempRegID*/61, /*TypeID*/GILLT_s32,
     /* 178446 */     GIR_BuildMI, /*InsnID*/62, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 178450 */     GIR_AddTempRegister, /*InsnID*/62, /*TempRegID*/61, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178455 */     GIR_AddSimpleTempRegister, /*InsnID*/62, /*TempRegID*/62,
     /* 178458 */     GIR_AddImm, /*InsnID*/62, /*Imm*/GIMT_Encode8(52428),
     /* 178468 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/62,
     /* 178470 */     GIR_MakeTempReg, /*TempRegID*/60, /*TypeID*/GILLT_s32,
     /* 178473 */     GIR_BuildMI, /*InsnID*/61, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 178477 */     GIR_AddTempRegister, /*InsnID*/61, /*TempRegID*/60, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178482 */     GIR_AddImm, /*InsnID*/61, /*Imm*/GIMT_Encode8(43690),
     /* 178492 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/61,
     /* 178494 */     GIR_MakeTempReg, /*TempRegID*/59, /*TypeID*/GILLT_s32,
     /* 178497 */     GIR_BuildMI, /*InsnID*/60, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 178501 */     GIR_AddTempRegister, /*InsnID*/60, /*TempRegID*/59, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178506 */     GIR_AddSimpleTempRegister, /*InsnID*/60, /*TempRegID*/60,
     /* 178509 */     GIR_AddImm, /*InsnID*/60, /*Imm*/GIMT_Encode8(43690),
     /* 178519 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/60,
     /* 178521 */     GIR_MakeTempReg, /*TempRegID*/58, /*TypeID*/GILLT_s32,
     /* 178524 */     GIR_BuildMI, /*InsnID*/59, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 178528 */     GIR_AddTempRegister, /*InsnID*/59, /*TempRegID*/58, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178533 */     GIR_Copy, /*NewInsnID*/59, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 178537 */     GIR_AddImm8, /*InsnID*/59, /*Imm*/1,
     /* 178540 */     GIR_AddImm8, /*InsnID*/59, /*Imm*/0,
     /* 178543 */     GIR_AddImm8, /*InsnID*/59, /*Imm*/30,
     /* 178546 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/59,
     /* 178548 */     GIR_MakeTempReg, /*TempRegID*/57, /*TypeID*/GILLT_s32,
     /* 178551 */     GIR_BuildMI, /*InsnID*/58, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 178555 */     GIR_AddTempRegister, /*InsnID*/58, /*TempRegID*/57, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178560 */     GIR_AddSimpleTempRegister, /*InsnID*/58, /*TempRegID*/58,
     /* 178563 */     GIR_AddSimpleTempRegister, /*InsnID*/58, /*TempRegID*/59,
     /* 178566 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/58,
     /* 178568 */     GIR_MakeTempReg, /*TempRegID*/56, /*TypeID*/GILLT_s32,
     /* 178571 */     GIR_BuildMI, /*InsnID*/57, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 178575 */     GIR_AddTempRegister, /*InsnID*/57, /*TempRegID*/56, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178580 */     GIR_AddImm, /*InsnID*/57, /*Imm*/GIMT_Encode8(21845),
     /* 178590 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/57,
     /* 178592 */     GIR_MakeTempReg, /*TempRegID*/55, /*TypeID*/GILLT_s32,
     /* 178595 */     GIR_BuildMI, /*InsnID*/56, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 178599 */     GIR_AddTempRegister, /*InsnID*/56, /*TempRegID*/55, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178604 */     GIR_AddSimpleTempRegister, /*InsnID*/56, /*TempRegID*/56,
     /* 178607 */     GIR_AddImm, /*InsnID*/56, /*Imm*/GIMT_Encode8(21845),
     /* 178617 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/56,
     /* 178619 */     GIR_MakeTempReg, /*TempRegID*/54, /*TypeID*/GILLT_s32,
     /* 178622 */     GIR_BuildMI, /*InsnID*/55, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 178626 */     GIR_AddTempRegister, /*InsnID*/55, /*TempRegID*/54, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178631 */     GIR_Copy, /*NewInsnID*/55, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 178635 */     GIR_AddImm8, /*InsnID*/55, /*Imm*/31,
     /* 178638 */     GIR_AddImm8, /*InsnID*/55, /*Imm*/1,
     /* 178641 */     GIR_AddImm8, /*InsnID*/55, /*Imm*/31,
     /* 178644 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/55,
     /* 178646 */     GIR_MakeTempReg, /*TempRegID*/53, /*TypeID*/GILLT_s32,
     /* 178649 */     GIR_BuildMI, /*InsnID*/54, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 178653 */     GIR_AddTempRegister, /*InsnID*/54, /*TempRegID*/53, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178658 */     GIR_AddSimpleTempRegister, /*InsnID*/54, /*TempRegID*/54,
     /* 178661 */     GIR_AddSimpleTempRegister, /*InsnID*/54, /*TempRegID*/55,
     /* 178664 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/54,
     /* 178666 */     GIR_MakeTempReg, /*TempRegID*/52, /*TypeID*/GILLT_s32,
     /* 178669 */     GIR_BuildMI, /*InsnID*/53, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 178673 */     GIR_AddTempRegister, /*InsnID*/53, /*TempRegID*/52, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178678 */     GIR_AddSimpleTempRegister, /*InsnID*/53, /*TempRegID*/53,
     /* 178681 */     GIR_AddSimpleTempRegister, /*InsnID*/53, /*TempRegID*/57,
     /* 178684 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/53,
     /* 178686 */     GIR_MakeTempReg, /*TempRegID*/51, /*TypeID*/GILLT_s32,
     /* 178689 */     GIR_BuildMI, /*InsnID*/52, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 178693 */     GIR_AddTempRegister, /*InsnID*/52, /*TempRegID*/51, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178698 */     GIR_AddSimpleTempRegister, /*InsnID*/52, /*TempRegID*/52,
     /* 178701 */     GIR_AddImm8, /*InsnID*/52, /*Imm*/2,
     /* 178704 */     GIR_AddImm8, /*InsnID*/52, /*Imm*/0,
     /* 178707 */     GIR_AddImm8, /*InsnID*/52, /*Imm*/29,
     /* 178710 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/52,
     /* 178712 */     GIR_MakeTempReg, /*TempRegID*/50, /*TypeID*/GILLT_s32,
     /* 178715 */     GIR_BuildMI, /*InsnID*/51, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 178719 */     GIR_AddTempRegister, /*InsnID*/51, /*TempRegID*/50, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178724 */     GIR_AddSimpleTempRegister, /*InsnID*/51, /*TempRegID*/51,
     /* 178727 */     GIR_AddSimpleTempRegister, /*InsnID*/51, /*TempRegID*/61,
     /* 178730 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/51,
     /* 178732 */     GIR_MakeTempReg, /*TempRegID*/49, /*TypeID*/GILLT_s32,
     /* 178735 */     GIR_BuildMI, /*InsnID*/50, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 178739 */     GIR_AddTempRegister, /*InsnID*/50, /*TempRegID*/49, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178744 */     GIR_AddImm, /*InsnID*/50, /*Imm*/GIMT_Encode8(13107),
     /* 178754 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/50,
     /* 178756 */     GIR_MakeTempReg, /*TempRegID*/48, /*TypeID*/GILLT_s32,
     /* 178759 */     GIR_BuildMI, /*InsnID*/49, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 178763 */     GIR_AddTempRegister, /*InsnID*/49, /*TempRegID*/48, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178768 */     GIR_AddSimpleTempRegister, /*InsnID*/49, /*TempRegID*/49,
     /* 178771 */     GIR_AddImm, /*InsnID*/49, /*Imm*/GIMT_Encode8(13107),
     /* 178781 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/49,
     /* 178783 */     GIR_MakeTempReg, /*TempRegID*/47, /*TypeID*/GILLT_s32,
     /* 178786 */     GIR_BuildMI, /*InsnID*/48, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 178790 */     GIR_AddTempRegister, /*InsnID*/48, /*TempRegID*/47, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178795 */     GIR_AddImm, /*InsnID*/48, /*Imm*/GIMT_Encode8(43690),
     /* 178805 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/48,
     /* 178807 */     GIR_MakeTempReg, /*TempRegID*/46, /*TypeID*/GILLT_s32,
     /* 178810 */     GIR_BuildMI, /*InsnID*/47, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 178814 */     GIR_AddTempRegister, /*InsnID*/47, /*TempRegID*/46, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178819 */     GIR_AddSimpleTempRegister, /*InsnID*/47, /*TempRegID*/47,
     /* 178822 */     GIR_AddImm, /*InsnID*/47, /*Imm*/GIMT_Encode8(43690),
     /* 178832 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/47,
     /* 178834 */     GIR_MakeTempReg, /*TempRegID*/45, /*TypeID*/GILLT_s32,
     /* 178837 */     GIR_BuildMI, /*InsnID*/46, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 178841 */     GIR_AddTempRegister, /*InsnID*/46, /*TempRegID*/45, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178846 */     GIR_Copy, /*NewInsnID*/46, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 178850 */     GIR_AddImm8, /*InsnID*/46, /*Imm*/1,
     /* 178853 */     GIR_AddImm8, /*InsnID*/46, /*Imm*/0,
     /* 178856 */     GIR_AddImm8, /*InsnID*/46, /*Imm*/30,
     /* 178859 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/46,
     /* 178861 */     GIR_MakeTempReg, /*TempRegID*/44, /*TypeID*/GILLT_s32,
     /* 178864 */     GIR_BuildMI, /*InsnID*/45, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 178868 */     GIR_AddTempRegister, /*InsnID*/45, /*TempRegID*/44, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178873 */     GIR_AddSimpleTempRegister, /*InsnID*/45, /*TempRegID*/45,
     /* 178876 */     GIR_AddSimpleTempRegister, /*InsnID*/45, /*TempRegID*/46,
     /* 178879 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/45,
     /* 178881 */     GIR_MakeTempReg, /*TempRegID*/43, /*TypeID*/GILLT_s32,
     /* 178884 */     GIR_BuildMI, /*InsnID*/44, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 178888 */     GIR_AddTempRegister, /*InsnID*/44, /*TempRegID*/43, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178893 */     GIR_AddImm, /*InsnID*/44, /*Imm*/GIMT_Encode8(21845),
     /* 178903 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/44,
     /* 178905 */     GIR_MakeTempReg, /*TempRegID*/42, /*TypeID*/GILLT_s32,
     /* 178908 */     GIR_BuildMI, /*InsnID*/43, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 178912 */     GIR_AddTempRegister, /*InsnID*/43, /*TempRegID*/42, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178917 */     GIR_AddSimpleTempRegister, /*InsnID*/43, /*TempRegID*/43,
     /* 178920 */     GIR_AddImm, /*InsnID*/43, /*Imm*/GIMT_Encode8(21845),
     /* 178930 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/43,
     /* 178932 */     GIR_MakeTempReg, /*TempRegID*/41, /*TypeID*/GILLT_s32,
     /* 178935 */     GIR_BuildMI, /*InsnID*/42, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 178939 */     GIR_AddTempRegister, /*InsnID*/42, /*TempRegID*/41, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178944 */     GIR_Copy, /*NewInsnID*/42, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 178948 */     GIR_AddImm8, /*InsnID*/42, /*Imm*/31,
     /* 178951 */     GIR_AddImm8, /*InsnID*/42, /*Imm*/1,
     /* 178954 */     GIR_AddImm8, /*InsnID*/42, /*Imm*/31,
     /* 178957 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/42,
     /* 178959 */     GIR_MakeTempReg, /*TempRegID*/40, /*TypeID*/GILLT_s32,
     /* 178962 */     GIR_BuildMI, /*InsnID*/41, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 178966 */     GIR_AddTempRegister, /*InsnID*/41, /*TempRegID*/40, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178971 */     GIR_AddSimpleTempRegister, /*InsnID*/41, /*TempRegID*/41,
     /* 178974 */     GIR_AddSimpleTempRegister, /*InsnID*/41, /*TempRegID*/42,
     /* 178977 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/41,
     /* 178979 */     GIR_MakeTempReg, /*TempRegID*/39, /*TypeID*/GILLT_s32,
     /* 178982 */     GIR_BuildMI, /*InsnID*/40, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 178986 */     GIR_AddTempRegister, /*InsnID*/40, /*TempRegID*/39, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178991 */     GIR_AddSimpleTempRegister, /*InsnID*/40, /*TempRegID*/40,
     /* 178994 */     GIR_AddSimpleTempRegister, /*InsnID*/40, /*TempRegID*/44,
     /* 178997 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/40,
     /* 178999 */     GIR_MakeTempReg, /*TempRegID*/38, /*TypeID*/GILLT_s32,
     /* 179002 */     GIR_BuildMI, /*InsnID*/39, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 179006 */     GIR_AddTempRegister, /*InsnID*/39, /*TempRegID*/38, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179011 */     GIR_AddSimpleTempRegister, /*InsnID*/39, /*TempRegID*/39,
     /* 179014 */     GIR_AddImm8, /*InsnID*/39, /*Imm*/30,
     /* 179017 */     GIR_AddImm8, /*InsnID*/39, /*Imm*/2,
     /* 179020 */     GIR_AddImm8, /*InsnID*/39, /*Imm*/31,
     /* 179023 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/39,
     /* 179025 */     GIR_MakeTempReg, /*TempRegID*/37, /*TypeID*/GILLT_s32,
     /* 179028 */     GIR_BuildMI, /*InsnID*/38, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 179032 */     GIR_AddTempRegister, /*InsnID*/38, /*TempRegID*/37, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179037 */     GIR_AddSimpleTempRegister, /*InsnID*/38, /*TempRegID*/38,
     /* 179040 */     GIR_AddSimpleTempRegister, /*InsnID*/38, /*TempRegID*/48,
     /* 179043 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/38,
     /* 179045 */     GIR_MakeTempReg, /*TempRegID*/36, /*TypeID*/GILLT_s32,
     /* 179048 */     GIR_BuildMI, /*InsnID*/37, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 179052 */     GIR_AddTempRegister, /*InsnID*/37, /*TempRegID*/36, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179057 */     GIR_AddSimpleTempRegister, /*InsnID*/37, /*TempRegID*/37,
     /* 179060 */     GIR_AddSimpleTempRegister, /*InsnID*/37, /*TempRegID*/50,
     /* 179063 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/37,
     /* 179065 */     GIR_MakeTempReg, /*TempRegID*/35, /*TypeID*/GILLT_s32,
     /* 179068 */     GIR_BuildMI, /*InsnID*/36, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 179072 */     GIR_AddTempRegister, /*InsnID*/36, /*TempRegID*/35, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179077 */     GIR_AddSimpleTempRegister, /*InsnID*/36, /*TempRegID*/36,
     /* 179080 */     GIR_AddImm8, /*InsnID*/36, /*Imm*/4,
     /* 179083 */     GIR_AddImm8, /*InsnID*/36, /*Imm*/0,
     /* 179086 */     GIR_AddImm8, /*InsnID*/36, /*Imm*/27,
     /* 179089 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/36,
     /* 179091 */     GIR_MakeTempReg, /*TempRegID*/34, /*TypeID*/GILLT_s32,
     /* 179094 */     GIR_BuildMI, /*InsnID*/35, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 179098 */     GIR_AddTempRegister, /*InsnID*/35, /*TempRegID*/34, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179103 */     GIR_AddSimpleTempRegister, /*InsnID*/35, /*TempRegID*/35,
     /* 179106 */     GIR_AddSimpleTempRegister, /*InsnID*/35, /*TempRegID*/63,
     /* 179109 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/35,
     /* 179111 */     GIR_MakeTempReg, /*TempRegID*/33, /*TypeID*/GILLT_s32,
     /* 179114 */     GIR_BuildMI, /*InsnID*/34, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 179118 */     GIR_AddTempRegister, /*InsnID*/34, /*TempRegID*/33, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179123 */     GIR_AddImm, /*InsnID*/34, /*Imm*/GIMT_Encode8(3855),
     /* 179133 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/34,
     /* 179135 */     GIR_MakeTempReg, /*TempRegID*/32, /*TypeID*/GILLT_s32,
     /* 179138 */     GIR_BuildMI, /*InsnID*/33, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 179142 */     GIR_AddTempRegister, /*InsnID*/33, /*TempRegID*/32, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179147 */     GIR_AddSimpleTempRegister, /*InsnID*/33, /*TempRegID*/33,
     /* 179150 */     GIR_AddImm, /*InsnID*/33, /*Imm*/GIMT_Encode8(3855),
     /* 179160 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/33,
     /* 179162 */     GIR_MakeTempReg, /*TempRegID*/31, /*TypeID*/GILLT_s32,
     /* 179165 */     GIR_BuildMI, /*InsnID*/32, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 179169 */     GIR_AddTempRegister, /*InsnID*/32, /*TempRegID*/31, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179174 */     GIR_AddImm, /*InsnID*/32, /*Imm*/GIMT_Encode8(52428),
     /* 179184 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/32,
     /* 179186 */     GIR_MakeTempReg, /*TempRegID*/30, /*TypeID*/GILLT_s32,
     /* 179189 */     GIR_BuildMI, /*InsnID*/31, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 179193 */     GIR_AddTempRegister, /*InsnID*/31, /*TempRegID*/30, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179198 */     GIR_AddSimpleTempRegister, /*InsnID*/31, /*TempRegID*/31,
     /* 179201 */     GIR_AddImm, /*InsnID*/31, /*Imm*/GIMT_Encode8(52428),
     /* 179211 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/31,
     /* 179213 */     GIR_MakeTempReg, /*TempRegID*/29, /*TypeID*/GILLT_s32,
     /* 179216 */     GIR_BuildMI, /*InsnID*/30, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 179220 */     GIR_AddTempRegister, /*InsnID*/30, /*TempRegID*/29, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179225 */     GIR_AddImm, /*InsnID*/30, /*Imm*/GIMT_Encode8(43690),
     /* 179235 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/30,
     /* 179237 */     GIR_MakeTempReg, /*TempRegID*/28, /*TypeID*/GILLT_s32,
     /* 179240 */     GIR_BuildMI, /*InsnID*/29, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 179244 */     GIR_AddTempRegister, /*InsnID*/29, /*TempRegID*/28, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179249 */     GIR_AddSimpleTempRegister, /*InsnID*/29, /*TempRegID*/29,
     /* 179252 */     GIR_AddImm, /*InsnID*/29, /*Imm*/GIMT_Encode8(43690),
     /* 179262 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/29,
     /* 179264 */     GIR_MakeTempReg, /*TempRegID*/27, /*TypeID*/GILLT_s32,
     /* 179267 */     GIR_BuildMI, /*InsnID*/28, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 179271 */     GIR_AddTempRegister, /*InsnID*/28, /*TempRegID*/27, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179276 */     GIR_Copy, /*NewInsnID*/28, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 179280 */     GIR_AddImm8, /*InsnID*/28, /*Imm*/1,
     /* 179283 */     GIR_AddImm8, /*InsnID*/28, /*Imm*/0,
     /* 179286 */     GIR_AddImm8, /*InsnID*/28, /*Imm*/30,
     /* 179289 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/28,
     /* 179291 */     GIR_MakeTempReg, /*TempRegID*/26, /*TypeID*/GILLT_s32,
     /* 179294 */     GIR_BuildMI, /*InsnID*/27, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 179298 */     GIR_AddTempRegister, /*InsnID*/27, /*TempRegID*/26, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179303 */     GIR_AddSimpleTempRegister, /*InsnID*/27, /*TempRegID*/27,
     /* 179306 */     GIR_AddSimpleTempRegister, /*InsnID*/27, /*TempRegID*/28,
     /* 179309 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/27,
     /* 179311 */     GIR_MakeTempReg, /*TempRegID*/25, /*TypeID*/GILLT_s32,
     /* 179314 */     GIR_BuildMI, /*InsnID*/26, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 179318 */     GIR_AddTempRegister, /*InsnID*/26, /*TempRegID*/25, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179323 */     GIR_AddImm, /*InsnID*/26, /*Imm*/GIMT_Encode8(21845),
     /* 179333 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/26,
     /* 179335 */     GIR_MakeTempReg, /*TempRegID*/24, /*TypeID*/GILLT_s32,
     /* 179338 */     GIR_BuildMI, /*InsnID*/25, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 179342 */     GIR_AddTempRegister, /*InsnID*/25, /*TempRegID*/24, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179347 */     GIR_AddSimpleTempRegister, /*InsnID*/25, /*TempRegID*/25,
     /* 179350 */     GIR_AddImm, /*InsnID*/25, /*Imm*/GIMT_Encode8(21845),
     /* 179360 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/25,
     /* 179362 */     GIR_MakeTempReg, /*TempRegID*/23, /*TypeID*/GILLT_s32,
     /* 179365 */     GIR_BuildMI, /*InsnID*/24, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 179369 */     GIR_AddTempRegister, /*InsnID*/24, /*TempRegID*/23, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179374 */     GIR_Copy, /*NewInsnID*/24, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 179378 */     GIR_AddImm8, /*InsnID*/24, /*Imm*/31,
     /* 179381 */     GIR_AddImm8, /*InsnID*/24, /*Imm*/1,
     /* 179384 */     GIR_AddImm8, /*InsnID*/24, /*Imm*/31,
     /* 179387 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/24,
     /* 179389 */     GIR_MakeTempReg, /*TempRegID*/22, /*TypeID*/GILLT_s32,
     /* 179392 */     GIR_BuildMI, /*InsnID*/23, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 179396 */     GIR_AddTempRegister, /*InsnID*/23, /*TempRegID*/22, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179401 */     GIR_AddSimpleTempRegister, /*InsnID*/23, /*TempRegID*/23,
     /* 179404 */     GIR_AddSimpleTempRegister, /*InsnID*/23, /*TempRegID*/24,
     /* 179407 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/23,
     /* 179409 */     GIR_MakeTempReg, /*TempRegID*/21, /*TypeID*/GILLT_s32,
     /* 179412 */     GIR_BuildMI, /*InsnID*/22, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 179416 */     GIR_AddTempRegister, /*InsnID*/22, /*TempRegID*/21, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179421 */     GIR_AddSimpleTempRegister, /*InsnID*/22, /*TempRegID*/22,
     /* 179424 */     GIR_AddSimpleTempRegister, /*InsnID*/22, /*TempRegID*/26,
     /* 179427 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/22,
     /* 179429 */     GIR_MakeTempReg, /*TempRegID*/20, /*TypeID*/GILLT_s32,
     /* 179432 */     GIR_BuildMI, /*InsnID*/21, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 179436 */     GIR_AddTempRegister, /*InsnID*/21, /*TempRegID*/20, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179441 */     GIR_AddSimpleTempRegister, /*InsnID*/21, /*TempRegID*/21,
     /* 179444 */     GIR_AddImm8, /*InsnID*/21, /*Imm*/2,
     /* 179447 */     GIR_AddImm8, /*InsnID*/21, /*Imm*/0,
     /* 179450 */     GIR_AddImm8, /*InsnID*/21, /*Imm*/29,
     /* 179453 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/21,
     /* 179455 */     GIR_MakeTempReg, /*TempRegID*/19, /*TypeID*/GILLT_s32,
     /* 179458 */     GIR_BuildMI, /*InsnID*/20, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 179462 */     GIR_AddTempRegister, /*InsnID*/20, /*TempRegID*/19, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179467 */     GIR_AddSimpleTempRegister, /*InsnID*/20, /*TempRegID*/20,
     /* 179470 */     GIR_AddSimpleTempRegister, /*InsnID*/20, /*TempRegID*/30,
     /* 179473 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/20,
     /* 179475 */     GIR_MakeTempReg, /*TempRegID*/18, /*TypeID*/GILLT_s32,
     /* 179478 */     GIR_BuildMI, /*InsnID*/19, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 179482 */     GIR_AddTempRegister, /*InsnID*/19, /*TempRegID*/18, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179487 */     GIR_AddImm, /*InsnID*/19, /*Imm*/GIMT_Encode8(13107),
     /* 179497 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/19,
     /* 179499 */     GIR_MakeTempReg, /*TempRegID*/17, /*TypeID*/GILLT_s32,
     /* 179502 */     GIR_BuildMI, /*InsnID*/18, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 179506 */     GIR_AddTempRegister, /*InsnID*/18, /*TempRegID*/17, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179511 */     GIR_AddSimpleTempRegister, /*InsnID*/18, /*TempRegID*/18,
     /* 179514 */     GIR_AddImm, /*InsnID*/18, /*Imm*/GIMT_Encode8(13107),
     /* 179524 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/18,
     /* 179526 */     GIR_MakeTempReg, /*TempRegID*/16, /*TypeID*/GILLT_s32,
     /* 179529 */     GIR_BuildMI, /*InsnID*/17, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 179533 */     GIR_AddTempRegister, /*InsnID*/17, /*TempRegID*/16, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179538 */     GIR_AddImm, /*InsnID*/17, /*Imm*/GIMT_Encode8(43690),
     /* 179548 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/17,
     /* 179550 */     GIR_MakeTempReg, /*TempRegID*/15, /*TypeID*/GILLT_s32,
     /* 179553 */     GIR_BuildMI, /*InsnID*/16, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 179557 */     GIR_AddTempRegister, /*InsnID*/16, /*TempRegID*/15, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179562 */     GIR_AddSimpleTempRegister, /*InsnID*/16, /*TempRegID*/16,
     /* 179565 */     GIR_AddImm, /*InsnID*/16, /*Imm*/GIMT_Encode8(43690),
     /* 179575 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/16,
     /* 179577 */     GIR_MakeTempReg, /*TempRegID*/14, /*TypeID*/GILLT_s32,
     /* 179580 */     GIR_BuildMI, /*InsnID*/15, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 179584 */     GIR_AddTempRegister, /*InsnID*/15, /*TempRegID*/14, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179589 */     GIR_Copy, /*NewInsnID*/15, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 179593 */     GIR_AddImm8, /*InsnID*/15, /*Imm*/1,
     /* 179596 */     GIR_AddImm8, /*InsnID*/15, /*Imm*/0,
     /* 179599 */     GIR_AddImm8, /*InsnID*/15, /*Imm*/30,
     /* 179602 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/15,
     /* 179604 */     GIR_MakeTempReg, /*TempRegID*/13, /*TypeID*/GILLT_s32,
     /* 179607 */     GIR_BuildMI, /*InsnID*/14, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 179611 */     GIR_AddTempRegister, /*InsnID*/14, /*TempRegID*/13, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179616 */     GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/14,
     /* 179619 */     GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/15,
     /* 179622 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/14,
     /* 179624 */     GIR_MakeTempReg, /*TempRegID*/12, /*TypeID*/GILLT_s32,
     /* 179627 */     GIR_BuildMI, /*InsnID*/13, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 179631 */     GIR_AddTempRegister, /*InsnID*/13, /*TempRegID*/12, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179636 */     GIR_AddImm, /*InsnID*/13, /*Imm*/GIMT_Encode8(21845),
     /* 179646 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/13,
     /* 179648 */     GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_s32,
     /* 179651 */     GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 179655 */     GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179660 */     GIR_AddSimpleTempRegister, /*InsnID*/12, /*TempRegID*/12,
     /* 179663 */     GIR_AddImm, /*InsnID*/12, /*Imm*/GIMT_Encode8(21845),
     /* 179673 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/12,
     /* 179675 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_s32,
     /* 179678 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 179682 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179687 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 179691 */     GIR_AddImm8, /*InsnID*/11, /*Imm*/31,
     /* 179694 */     GIR_AddImm8, /*InsnID*/11, /*Imm*/1,
     /* 179697 */     GIR_AddImm8, /*InsnID*/11, /*Imm*/31,
     /* 179700 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 179702 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s32,
     /* 179705 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 179709 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179714 */     GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
     /* 179717 */     GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/11,
     /* 179720 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 179722 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s32,
     /* 179725 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 179729 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179734 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 179737 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/13,
     /* 179740 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 179742 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s32,
     /* 179745 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 179749 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179754 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
     /* 179757 */     GIR_AddImm8, /*InsnID*/8, /*Imm*/30,
     /* 179760 */     GIR_AddImm8, /*InsnID*/8, /*Imm*/2,
     /* 179763 */     GIR_AddImm8, /*InsnID*/8, /*Imm*/31,
     /* 179766 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 179768 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s32,
     /* 179771 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 179775 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179780 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 179783 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/17,
     /* 179786 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 179788 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /* 179791 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 179795 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179800 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 179803 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/19,
     /* 179806 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 179808 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 179811 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 179815 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179820 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 179823 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/28,
     /* 179826 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/4,
     /* 179829 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/31,
     /* 179832 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 179834 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 179837 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 179841 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179846 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 179849 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/32,
     /* 179852 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 179854 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 179857 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 179861 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179866 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 179869 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/34,
     /* 179872 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 179874 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 179877 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 179881 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179886 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 179889 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/24,
     /* 179892 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 179895 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 179898 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 179900 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 179903 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLWIMI),
     /* 179907 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179912 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 179915 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/65,
     /* 179918 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 179921 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 179924 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/15,
     /* 179927 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 179929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWIMI),
     /* 179932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 179934 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 179937 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*//* 128(*/0x80, 0x01/*)*/,
     /* 179941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 179944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/24,
     /* 179947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 179950 */     GIR_RootConstrainSelectedInstOperands,
     /* 179951 */     // GIR_Coverage, 4846,
     /* 179951 */     GIR_EraseRootFromParent_Done,
     /* 179952 */   // Label 2735: @179952
     /* 179952 */   GIM_Reject,
     /* 179953 */ // Label 2733: @179953
     /* 179953 */ GIM_Reject,
     /* 179954 */ // Label 2731: @179954
     /* 179954 */ GIM_Try, /*On fail goto*//*Label 2736*/ GIMT_Encode4(205644), // Rule ID 4847 //
     /* 179959 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 179962 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 179966 */   // (bitreverse:{ *:[i64] } i64:{ *:[i64] }:$A)  =>  (OR8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWIMI:{ *:[i32] } (RLWIMI:{ *:[i32] } (RLWINM:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 62:{ *:[i32] }, 2:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 13107:{ *:[i64] }), 13107:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 2:{ *:[i32] }, 61:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 52428:{ *:[i64] }), 52428:{ *:[i64] }))), 60:{ *:[i32] }, 4:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 3855:{ *:[i32] }), 3855:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 3855:{ *:[i64] }), 3855:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 62:{ *:[i32] }, 2:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 13107:{ *:[i64] }), 13107:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 2:{ *:[i32] }, 61:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 52428:{ *:[i64] }), 52428:{ *:[i64] }))), 4:{ *:[i32] }, 59:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 61680:{ *:[i32] }), 61680:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 61680:{ *:[i64] }), 61680:{ *:[i64] }))), sub_32:{ *:[i32] }), 24:{ *:[i32] }, 0:{ *:[i32] }, 31:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 62:{ *:[i32] }, 2:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 13107:{ *:[i64] }), 13107:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 2:{ *:[i32] }, 61:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 52428:{ *:[i64] }), 52428:{ *:[i64] }))), 60:{ *:[i32] }, 4:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 3855:{ *:[i32] }), 3855:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 3855:{ *:[i64] }), 3855:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 62:{ *:[i32] }, 2:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 13107:{ *:[i64] }), 13107:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 2:{ *:[i32] }, 61:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 52428:{ *:[i64] }), 52428:{ *:[i64] }))), 4:{ *:[i32] }, 59:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 61680:{ *:[i32] }), 61680:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 61680:{ *:[i64] }), 61680:{ *:[i64] }))), sub_32:{ *:[i32] }), 8:{ *:[i32] }, 8:{ *:[i32] }, 15:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 62:{ *:[i32] }, 2:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 13107:{ *:[i64] }), 13107:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 2:{ *:[i32] }, 61:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 52428:{ *:[i64] }), 52428:{ *:[i64] }))), 60:{ *:[i32] }, 4:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 3855:{ *:[i32] }), 3855:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 3855:{ *:[i64] }), 3855:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 62:{ *:[i32] }, 2:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 13107:{ *:[i64] }), 13107:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 2:{ *:[i32] }, 61:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 52428:{ *:[i64] }), 52428:{ *:[i64] }))), 4:{ *:[i32] }, 59:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 61680:{ *:[i32] }), 61680:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 61680:{ *:[i64] }), 61680:{ *:[i64] }))), sub_32:{ *:[i32] }), 8:{ *:[i32] }, 24:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWIMI:{ *:[i32] } (RLWIMI:{ *:[i32] } (RLWINM:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 62:{ *:[i32] }, 2:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 13107:{ *:[i64] }), 13107:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 2:{ *:[i32] }, 61:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 52428:{ *:[i64] }), 52428:{ *:[i64] }))), 60:{ *:[i32] }, 4:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 3855:{ *:[i32] }), 3855:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 3855:{ *:[i64] }), 3855:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 62:{ *:[i32] }, 2:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 13107:{ *:[i64] }), 13107:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 2:{ *:[i32] }, 61:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 52428:{ *:[i64] }), 52428:{ *:[i64] }))), 4:{ *:[i32] }, 59:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 61680:{ *:[i32] }), 61680:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 61680:{ *:[i64] }), 61680:{ *:[i64] }))), 32:{ *:[i32] }, 32:{ *:[i32] }), sub_32:{ *:[i32] }), 24:{ *:[i32] }, 0:{ *:[i32] }, 31:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 62:{ *:[i32] }, 2:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 13107:{ *:[i64] }), 13107:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 2:{ *:[i32] }, 61:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 52428:{ *:[i64] }), 52428:{ *:[i64] }))), 60:{ *:[i32] }, 4:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 3855:{ *:[i32] }), 3855:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 3855:{ *:[i64] }), 3855:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 62:{ *:[i32] }, 2:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 13107:{ *:[i64] }), 13107:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 2:{ *:[i32] }, 61:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 52428:{ *:[i64] }), 52428:{ *:[i64] }))), 4:{ *:[i32] }, 59:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 61680:{ *:[i32] }), 61680:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 61680:{ *:[i64] }), 61680:{ *:[i64] }))), 32:{ *:[i32] }, 32:{ *:[i32] }), sub_32:{ *:[i32] }), 8:{ *:[i32] }, 8:{ *:[i32] }, 15:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 62:{ *:[i32] }, 2:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 13107:{ *:[i64] }), 13107:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 2:{ *:[i32] }, 61:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 52428:{ *:[i64] }), 52428:{ *:[i64] }))), 60:{ *:[i32] }, 4:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 3855:{ *:[i32] }), 3855:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 3855:{ *:[i64] }), 3855:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 62:{ *:[i32] }, 2:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 13107:{ *:[i64] }), 13107:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 2:{ *:[i32] }, 61:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 52428:{ *:[i64] }), 52428:{ *:[i64] }))), 4:{ *:[i32] }, 59:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 61680:{ *:[i32] }), 61680:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 61680:{ *:[i64] }), 61680:{ *:[i64] }))), 32:{ *:[i32] }, 32:{ *:[i32] }), sub_32:{ *:[i32] }), 8:{ *:[i32] }, 24:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] }))
     /* 179966 */   GIR_MakeTempReg, /*TempRegID*//* 139(*/0x8B, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 179970 */   GIR_BuildMI, /*InsnID*//* 140(*/0x8C, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 179975 */   GIR_AddTempRegister, /*InsnID*//* 140(*/0x8C, 0x01/*)*/, /*TempRegID*//* 139(*/0x8B, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179982 */   GIR_AddImm, /*InsnID*//* 140(*/0x8C, 0x01/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 179993 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 140(*/0x8C, 0x01/*)*/,
     /* 179996 */   GIR_MakeTempReg, /*TempRegID*//* 138(*/0x8A, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 180000 */   GIR_BuildMI, /*InsnID*//* 139(*/0x8B, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 180005 */   GIR_AddTempRegister, /*InsnID*//* 139(*/0x8B, 0x01/*)*/, /*TempRegID*//* 138(*/0x8A, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180012 */   GIR_AddSimpleTempRegister, /*InsnID*//* 139(*/0x8B, 0x01/*)*/, /*TempRegID*//* 139(*/0x8B, 0x01/*)*/,
     /* 180017 */   GIR_AddImm, /*InsnID*//* 139(*/0x8B, 0x01/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 180028 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 139(*/0x8B, 0x01/*)*/,
     /* 180031 */   GIR_MakeTempReg, /*TempRegID*//* 137(*/0x89, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 180035 */   GIR_BuildMI, /*InsnID*//* 138(*/0x8A, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 180040 */   GIR_AddTempRegister, /*InsnID*//* 138(*/0x8A, 0x01/*)*/, /*TempRegID*//* 137(*/0x89, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180047 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 138(*/0x8A, 0x01/*)*/,
     /* 180050 */   GIR_MakeTempReg, /*TempRegID*//* 136(*/0x88, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 180054 */   GIR_BuildMI, /*InsnID*//* 137(*/0x89, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 180059 */   GIR_AddTempRegister, /*InsnID*//* 137(*/0x89, 0x01/*)*/, /*TempRegID*//* 136(*/0x88, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180066 */   GIR_AddSimpleTempRegister, /*InsnID*//* 137(*/0x89, 0x01/*)*/, /*TempRegID*//* 137(*/0x89, 0x01/*)*/,
     /* 180071 */   GIR_AddSimpleTempRegister, /*InsnID*//* 137(*/0x89, 0x01/*)*/, /*TempRegID*//* 138(*/0x8A, 0x01/*)*/,
     /* 180076 */   GIR_AddImm8, /*InsnID*//* 137(*/0x89, 0x01/*)*/, /*Imm*/1,
     /* 180080 */   GIR_ConstrainOperandRC, /*InsnID*//* 137(*/0x89, 0x01/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 180086 */   GIR_ConstrainOperandRC, /*InsnID*//* 137(*/0x89, 0x01/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 180092 */   GIR_ConstrainOperandRC, /*InsnID*//* 137(*/0x89, 0x01/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 180098 */   GIR_MakeTempReg, /*TempRegID*//* 135(*/0x87, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 180102 */   GIR_BuildMI, /*InsnID*//* 136(*/0x88, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 180107 */   GIR_AddTempRegister, /*InsnID*//* 136(*/0x88, 0x01/*)*/, /*TempRegID*//* 135(*/0x87, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180114 */   GIR_AddSimpleTempRegister, /*InsnID*//* 136(*/0x88, 0x01/*)*/, /*TempRegID*//* 136(*/0x88, 0x01/*)*/,
     /* 180119 */   GIR_AddImm8, /*InsnID*//* 136(*/0x88, 0x01/*)*/, /*Imm*/32,
     /* 180123 */   GIR_AddImm8, /*InsnID*//* 136(*/0x88, 0x01/*)*/, /*Imm*/31,
     /* 180127 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 136(*/0x88, 0x01/*)*/,
     /* 180130 */   GIR_MakeTempReg, /*TempRegID*//* 134(*/0x86, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 180134 */   GIR_BuildMI, /*InsnID*//* 135(*/0x87, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 180139 */   GIR_AddTempRegister, /*InsnID*//* 135(*/0x87, 0x01/*)*/, /*TempRegID*//* 134(*/0x86, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180146 */   GIR_AddSimpleTempRegister, /*InsnID*//* 135(*/0x87, 0x01/*)*/, /*TempRegID*//* 135(*/0x87, 0x01/*)*/,
     /* 180151 */   GIR_AddImm, /*InsnID*//* 135(*/0x87, 0x01/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 180162 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 135(*/0x87, 0x01/*)*/,
     /* 180165 */   GIR_MakeTempReg, /*TempRegID*//* 133(*/0x85, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 180169 */   GIR_BuildMI, /*InsnID*//* 134(*/0x86, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 180174 */   GIR_AddTempRegister, /*InsnID*//* 134(*/0x86, 0x01/*)*/, /*TempRegID*//* 133(*/0x85, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180181 */   GIR_AddSimpleTempRegister, /*InsnID*//* 134(*/0x86, 0x01/*)*/, /*TempRegID*//* 134(*/0x86, 0x01/*)*/,
     /* 180186 */   GIR_AddImm, /*InsnID*//* 134(*/0x86, 0x01/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 180197 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 134(*/0x86, 0x01/*)*/,
     /* 180200 */   GIR_MakeTempReg, /*TempRegID*//* 132(*/0x84, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 180204 */   GIR_BuildMI, /*InsnID*//* 133(*/0x85, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 180209 */   GIR_AddTempRegister, /*InsnID*//* 133(*/0x85, 0x01/*)*/, /*TempRegID*//* 132(*/0x84, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180216 */   GIR_AddImm, /*InsnID*//* 133(*/0x85, 0x01/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 180227 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 133(*/0x85, 0x01/*)*/,
     /* 180230 */   GIR_MakeTempReg, /*TempRegID*//* 131(*/0x83, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 180234 */   GIR_BuildMI, /*InsnID*//* 132(*/0x84, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 180239 */   GIR_AddTempRegister, /*InsnID*//* 132(*/0x84, 0x01/*)*/, /*TempRegID*//* 131(*/0x83, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180246 */   GIR_AddSimpleTempRegister, /*InsnID*//* 132(*/0x84, 0x01/*)*/, /*TempRegID*//* 132(*/0x84, 0x01/*)*/,
     /* 180251 */   GIR_AddImm, /*InsnID*//* 132(*/0x84, 0x01/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 180262 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 132(*/0x84, 0x01/*)*/,
     /* 180265 */   GIR_MakeTempReg, /*TempRegID*//* 130(*/0x82, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 180269 */   GIR_BuildMI, /*InsnID*//* 131(*/0x83, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 180274 */   GIR_AddTempRegister, /*InsnID*//* 131(*/0x83, 0x01/*)*/, /*TempRegID*//* 130(*/0x82, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180281 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 131(*/0x83, 0x01/*)*/,
     /* 180284 */   GIR_MakeTempReg, /*TempRegID*//* 129(*/0x81, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 180288 */   GIR_BuildMI, /*InsnID*//* 130(*/0x82, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 180293 */   GIR_AddTempRegister, /*InsnID*//* 130(*/0x82, 0x01/*)*/, /*TempRegID*//* 129(*/0x81, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180300 */   GIR_AddSimpleTempRegister, /*InsnID*//* 130(*/0x82, 0x01/*)*/, /*TempRegID*//* 130(*/0x82, 0x01/*)*/,
     /* 180305 */   GIR_AddSimpleTempRegister, /*InsnID*//* 130(*/0x82, 0x01/*)*/, /*TempRegID*//* 131(*/0x83, 0x01/*)*/,
     /* 180310 */   GIR_AddImm8, /*InsnID*//* 130(*/0x82, 0x01/*)*/, /*Imm*/1,
     /* 180314 */   GIR_ConstrainOperandRC, /*InsnID*//* 130(*/0x82, 0x01/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 180320 */   GIR_ConstrainOperandRC, /*InsnID*//* 130(*/0x82, 0x01/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 180326 */   GIR_ConstrainOperandRC, /*InsnID*//* 130(*/0x82, 0x01/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 180332 */   GIR_MakeTempReg, /*TempRegID*//* 128(*/0x80, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 180336 */   GIR_BuildMI, /*InsnID*//* 129(*/0x81, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 180341 */   GIR_AddTempRegister, /*InsnID*//* 129(*/0x81, 0x01/*)*/, /*TempRegID*//* 128(*/0x80, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180348 */   GIR_AddSimpleTempRegister, /*InsnID*//* 129(*/0x81, 0x01/*)*/, /*TempRegID*//* 129(*/0x81, 0x01/*)*/,
     /* 180353 */   GIR_AddImm8, /*InsnID*//* 129(*/0x81, 0x01/*)*/, /*Imm*/32,
     /* 180357 */   GIR_AddImm8, /*InsnID*//* 129(*/0x81, 0x01/*)*/, /*Imm*/31,
     /* 180361 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 129(*/0x81, 0x01/*)*/,
     /* 180364 */   GIR_MakeTempReg, /*TempRegID*/127, /*TypeID*/GILLT_s64,
     /* 180367 */   GIR_BuildMI, /*InsnID*//* 128(*/0x80, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 180372 */   GIR_AddTempRegister, /*InsnID*//* 128(*/0x80, 0x01/*)*/, /*TempRegID*/127, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180378 */   GIR_AddSimpleTempRegister, /*InsnID*//* 128(*/0x80, 0x01/*)*/, /*TempRegID*//* 128(*/0x80, 0x01/*)*/,
     /* 180383 */   GIR_AddImm, /*InsnID*//* 128(*/0x80, 0x01/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 180394 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 128(*/0x80, 0x01/*)*/,
     /* 180397 */   GIR_MakeTempReg, /*TempRegID*/126, /*TypeID*/GILLT_s64,
     /* 180400 */   GIR_BuildMI, /*InsnID*/127, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 180404 */   GIR_AddTempRegister, /*InsnID*/127, /*TempRegID*/126, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180409 */   GIR_AddSimpleTempRegister, /*InsnID*/127, /*TempRegID*/127,
     /* 180412 */   GIR_AddImm, /*InsnID*/127, /*Imm*/GIMT_Encode8(52428),
     /* 180422 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/127,
     /* 180424 */   GIR_MakeTempReg, /*TempRegID*/125, /*TypeID*/GILLT_s32,
     /* 180427 */   GIR_BuildMI, /*InsnID*/126, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 180431 */   GIR_AddTempRegister, /*InsnID*/126, /*TempRegID*/125, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180436 */   GIR_AddImm, /*InsnID*/126, /*Imm*/GIMT_Encode8(43690),
     /* 180446 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/126,
     /* 180448 */   GIR_MakeTempReg, /*TempRegID*/124, /*TypeID*/GILLT_s32,
     /* 180451 */   GIR_BuildMI, /*InsnID*/125, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 180455 */   GIR_AddTempRegister, /*InsnID*/125, /*TempRegID*/124, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180460 */   GIR_AddSimpleTempRegister, /*InsnID*/125, /*TempRegID*/125,
     /* 180463 */   GIR_AddImm, /*InsnID*/125, /*Imm*/GIMT_Encode8(43690),
     /* 180473 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/125,
     /* 180475 */   GIR_MakeTempReg, /*TempRegID*/123, /*TypeID*/GILLT_s64,
     /* 180478 */   GIR_BuildMI, /*InsnID*/124, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 180482 */   GIR_AddTempRegister, /*InsnID*/124, /*TempRegID*/123, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180487 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/124,
     /* 180489 */   GIR_MakeTempReg, /*TempRegID*/122, /*TypeID*/GILLT_s64,
     /* 180492 */   GIR_BuildMI, /*InsnID*/123, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 180496 */   GIR_AddTempRegister, /*InsnID*/123, /*TempRegID*/122, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180501 */   GIR_AddSimpleTempRegister, /*InsnID*/123, /*TempRegID*/123,
     /* 180504 */   GIR_AddSimpleTempRegister, /*InsnID*/123, /*TempRegID*/124,
     /* 180507 */   GIR_AddImm8, /*InsnID*/123, /*Imm*/1,
     /* 180510 */   GIR_ConstrainOperandRC, /*InsnID*/123, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 180515 */   GIR_ConstrainOperandRC, /*InsnID*/123, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 180520 */   GIR_ConstrainOperandRC, /*InsnID*/123, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 180525 */   GIR_MakeTempReg, /*TempRegID*/121, /*TypeID*/GILLT_s64,
     /* 180528 */   GIR_BuildMI, /*InsnID*/122, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 180532 */   GIR_AddTempRegister, /*InsnID*/122, /*TempRegID*/121, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180537 */   GIR_AddSimpleTempRegister, /*InsnID*/122, /*TempRegID*/122,
     /* 180540 */   GIR_AddImm8, /*InsnID*/122, /*Imm*/32,
     /* 180543 */   GIR_AddImm8, /*InsnID*/122, /*Imm*/31,
     /* 180546 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/122,
     /* 180548 */   GIR_MakeTempReg, /*TempRegID*/120, /*TypeID*/GILLT_s64,
     /* 180551 */   GIR_BuildMI, /*InsnID*/121, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 180555 */   GIR_AddTempRegister, /*InsnID*/121, /*TempRegID*/120, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180560 */   GIR_AddSimpleTempRegister, /*InsnID*/121, /*TempRegID*/121,
     /* 180563 */   GIR_AddImm, /*InsnID*/121, /*Imm*/GIMT_Encode8(43690),
     /* 180573 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/121,
     /* 180575 */   GIR_MakeTempReg, /*TempRegID*/119, /*TypeID*/GILLT_s64,
     /* 180578 */   GIR_BuildMI, /*InsnID*/120, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 180582 */   GIR_AddTempRegister, /*InsnID*/120, /*TempRegID*/119, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180587 */   GIR_AddSimpleTempRegister, /*InsnID*/120, /*TempRegID*/120,
     /* 180590 */   GIR_AddImm, /*InsnID*/120, /*Imm*/GIMT_Encode8(43690),
     /* 180600 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/120,
     /* 180602 */   GIR_MakeTempReg, /*TempRegID*/118, /*TypeID*/GILLT_s64,
     /* 180605 */   GIR_BuildMI, /*InsnID*/119, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 180609 */   GIR_AddTempRegister, /*InsnID*/119, /*TempRegID*/118, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180614 */   GIR_Copy, /*NewInsnID*/119, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 180618 */   GIR_AddImm8, /*InsnID*/119, /*Imm*/1,
     /* 180621 */   GIR_AddImm8, /*InsnID*/119, /*Imm*/62,
     /* 180624 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/119,
     /* 180626 */   GIR_MakeTempReg, /*TempRegID*/117, /*TypeID*/GILLT_s64,
     /* 180629 */   GIR_BuildMI, /*InsnID*/118, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 180633 */   GIR_AddTempRegister, /*InsnID*/118, /*TempRegID*/117, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180638 */   GIR_AddSimpleTempRegister, /*InsnID*/118, /*TempRegID*/118,
     /* 180641 */   GIR_AddSimpleTempRegister, /*InsnID*/118, /*TempRegID*/119,
     /* 180644 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/118,
     /* 180646 */   GIR_MakeTempReg, /*TempRegID*/116, /*TypeID*/GILLT_s32,
     /* 180649 */   GIR_BuildMI, /*InsnID*/117, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 180653 */   GIR_AddTempRegister, /*InsnID*/117, /*TempRegID*/116, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180658 */   GIR_AddImm, /*InsnID*/117, /*Imm*/GIMT_Encode8(21845),
     /* 180668 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/117,
     /* 180670 */   GIR_MakeTempReg, /*TempRegID*/115, /*TypeID*/GILLT_s32,
     /* 180673 */   GIR_BuildMI, /*InsnID*/116, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 180677 */   GIR_AddTempRegister, /*InsnID*/116, /*TempRegID*/115, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180682 */   GIR_AddSimpleTempRegister, /*InsnID*/116, /*TempRegID*/116,
     /* 180685 */   GIR_AddImm, /*InsnID*/116, /*Imm*/GIMT_Encode8(21845),
     /* 180695 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/116,
     /* 180697 */   GIR_MakeTempReg, /*TempRegID*/114, /*TypeID*/GILLT_s64,
     /* 180700 */   GIR_BuildMI, /*InsnID*/115, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 180704 */   GIR_AddTempRegister, /*InsnID*/115, /*TempRegID*/114, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180709 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/115,
     /* 180711 */   GIR_MakeTempReg, /*TempRegID*/113, /*TypeID*/GILLT_s64,
     /* 180714 */   GIR_BuildMI, /*InsnID*/114, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 180718 */   GIR_AddTempRegister, /*InsnID*/114, /*TempRegID*/113, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180723 */   GIR_AddSimpleTempRegister, /*InsnID*/114, /*TempRegID*/114,
     /* 180726 */   GIR_AddSimpleTempRegister, /*InsnID*/114, /*TempRegID*/115,
     /* 180729 */   GIR_AddImm8, /*InsnID*/114, /*Imm*/1,
     /* 180732 */   GIR_ConstrainOperandRC, /*InsnID*/114, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 180737 */   GIR_ConstrainOperandRC, /*InsnID*/114, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 180742 */   GIR_ConstrainOperandRC, /*InsnID*/114, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 180747 */   GIR_MakeTempReg, /*TempRegID*/112, /*TypeID*/GILLT_s64,
     /* 180750 */   GIR_BuildMI, /*InsnID*/113, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 180754 */   GIR_AddTempRegister, /*InsnID*/113, /*TempRegID*/112, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180759 */   GIR_AddSimpleTempRegister, /*InsnID*/113, /*TempRegID*/113,
     /* 180762 */   GIR_AddImm8, /*InsnID*/113, /*Imm*/32,
     /* 180765 */   GIR_AddImm8, /*InsnID*/113, /*Imm*/31,
     /* 180768 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/113,
     /* 180770 */   GIR_MakeTempReg, /*TempRegID*/111, /*TypeID*/GILLT_s64,
     /* 180773 */   GIR_BuildMI, /*InsnID*/112, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 180777 */   GIR_AddTempRegister, /*InsnID*/112, /*TempRegID*/111, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180782 */   GIR_AddSimpleTempRegister, /*InsnID*/112, /*TempRegID*/112,
     /* 180785 */   GIR_AddImm, /*InsnID*/112, /*Imm*/GIMT_Encode8(21845),
     /* 180795 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/112,
     /* 180797 */   GIR_MakeTempReg, /*TempRegID*/110, /*TypeID*/GILLT_s64,
     /* 180800 */   GIR_BuildMI, /*InsnID*/111, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 180804 */   GIR_AddTempRegister, /*InsnID*/111, /*TempRegID*/110, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180809 */   GIR_AddSimpleTempRegister, /*InsnID*/111, /*TempRegID*/111,
     /* 180812 */   GIR_AddImm, /*InsnID*/111, /*Imm*/GIMT_Encode8(21845),
     /* 180822 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/111,
     /* 180824 */   GIR_MakeTempReg, /*TempRegID*/109, /*TypeID*/GILLT_s64,
     /* 180827 */   GIR_BuildMI, /*InsnID*/110, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 180831 */   GIR_AddTempRegister, /*InsnID*/110, /*TempRegID*/109, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180836 */   GIR_Copy, /*NewInsnID*/110, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 180840 */   GIR_AddImm8, /*InsnID*/110, /*Imm*/63,
     /* 180843 */   GIR_AddImm8, /*InsnID*/110, /*Imm*/1,
     /* 180846 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/110,
     /* 180848 */   GIR_MakeTempReg, /*TempRegID*/108, /*TypeID*/GILLT_s64,
     /* 180851 */   GIR_BuildMI, /*InsnID*/109, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 180855 */   GIR_AddTempRegister, /*InsnID*/109, /*TempRegID*/108, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180860 */   GIR_AddSimpleTempRegister, /*InsnID*/109, /*TempRegID*/109,
     /* 180863 */   GIR_AddSimpleTempRegister, /*InsnID*/109, /*TempRegID*/110,
     /* 180866 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/109,
     /* 180868 */   GIR_MakeTempReg, /*TempRegID*/107, /*TypeID*/GILLT_s64,
     /* 180871 */   GIR_BuildMI, /*InsnID*/108, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 180875 */   GIR_AddTempRegister, /*InsnID*/108, /*TempRegID*/107, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180880 */   GIR_AddSimpleTempRegister, /*InsnID*/108, /*TempRegID*/108,
     /* 180883 */   GIR_AddSimpleTempRegister, /*InsnID*/108, /*TempRegID*/117,
     /* 180886 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/108,
     /* 180888 */   GIR_MakeTempReg, /*TempRegID*/106, /*TypeID*/GILLT_s64,
     /* 180891 */   GIR_BuildMI, /*InsnID*/107, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 180895 */   GIR_AddTempRegister, /*InsnID*/107, /*TempRegID*/106, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180900 */   GIR_AddSimpleTempRegister, /*InsnID*/107, /*TempRegID*/107,
     /* 180903 */   GIR_AddImm8, /*InsnID*/107, /*Imm*/2,
     /* 180906 */   GIR_AddImm8, /*InsnID*/107, /*Imm*/61,
     /* 180909 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/107,
     /* 180911 */   GIR_MakeTempReg, /*TempRegID*/105, /*TypeID*/GILLT_s64,
     /* 180914 */   GIR_BuildMI, /*InsnID*/106, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 180918 */   GIR_AddTempRegister, /*InsnID*/106, /*TempRegID*/105, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180923 */   GIR_AddSimpleTempRegister, /*InsnID*/106, /*TempRegID*/106,
     /* 180926 */   GIR_AddSimpleTempRegister, /*InsnID*/106, /*TempRegID*/126,
     /* 180929 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/106,
     /* 180931 */   GIR_MakeTempReg, /*TempRegID*/104, /*TypeID*/GILLT_s32,
     /* 180934 */   GIR_BuildMI, /*InsnID*/105, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 180938 */   GIR_AddTempRegister, /*InsnID*/105, /*TempRegID*/104, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180943 */   GIR_AddImm, /*InsnID*/105, /*Imm*/GIMT_Encode8(13107),
     /* 180953 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/105,
     /* 180955 */   GIR_MakeTempReg, /*TempRegID*/103, /*TypeID*/GILLT_s32,
     /* 180958 */   GIR_BuildMI, /*InsnID*/104, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 180962 */   GIR_AddTempRegister, /*InsnID*/104, /*TempRegID*/103, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180967 */   GIR_AddSimpleTempRegister, /*InsnID*/104, /*TempRegID*/104,
     /* 180970 */   GIR_AddImm, /*InsnID*/104, /*Imm*/GIMT_Encode8(13107),
     /* 180980 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/104,
     /* 180982 */   GIR_MakeTempReg, /*TempRegID*/102, /*TypeID*/GILLT_s64,
     /* 180985 */   GIR_BuildMI, /*InsnID*/103, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 180989 */   GIR_AddTempRegister, /*InsnID*/103, /*TempRegID*/102, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180994 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/103,
     /* 180996 */   GIR_MakeTempReg, /*TempRegID*/101, /*TypeID*/GILLT_s64,
     /* 180999 */   GIR_BuildMI, /*InsnID*/102, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 181003 */   GIR_AddTempRegister, /*InsnID*/102, /*TempRegID*/101, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181008 */   GIR_AddSimpleTempRegister, /*InsnID*/102, /*TempRegID*/102,
     /* 181011 */   GIR_AddSimpleTempRegister, /*InsnID*/102, /*TempRegID*/103,
     /* 181014 */   GIR_AddImm8, /*InsnID*/102, /*Imm*/1,
     /* 181017 */   GIR_ConstrainOperandRC, /*InsnID*/102, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 181022 */   GIR_ConstrainOperandRC, /*InsnID*/102, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 181027 */   GIR_ConstrainOperandRC, /*InsnID*/102, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 181032 */   GIR_MakeTempReg, /*TempRegID*/100, /*TypeID*/GILLT_s64,
     /* 181035 */   GIR_BuildMI, /*InsnID*/101, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 181039 */   GIR_AddTempRegister, /*InsnID*/101, /*TempRegID*/100, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181044 */   GIR_AddSimpleTempRegister, /*InsnID*/101, /*TempRegID*/101,
     /* 181047 */   GIR_AddImm8, /*InsnID*/101, /*Imm*/32,
     /* 181050 */   GIR_AddImm8, /*InsnID*/101, /*Imm*/31,
     /* 181053 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/101,
     /* 181055 */   GIR_MakeTempReg, /*TempRegID*/99, /*TypeID*/GILLT_s64,
     /* 181058 */   GIR_BuildMI, /*InsnID*/100, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 181062 */   GIR_AddTempRegister, /*InsnID*/100, /*TempRegID*/99, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181067 */   GIR_AddSimpleTempRegister, /*InsnID*/100, /*TempRegID*/100,
     /* 181070 */   GIR_AddImm, /*InsnID*/100, /*Imm*/GIMT_Encode8(13107),
     /* 181080 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/100,
     /* 181082 */   GIR_MakeTempReg, /*TempRegID*/98, /*TypeID*/GILLT_s64,
     /* 181085 */   GIR_BuildMI, /*InsnID*/99, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 181089 */   GIR_AddTempRegister, /*InsnID*/99, /*TempRegID*/98, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181094 */   GIR_AddSimpleTempRegister, /*InsnID*/99, /*TempRegID*/99,
     /* 181097 */   GIR_AddImm, /*InsnID*/99, /*Imm*/GIMT_Encode8(13107),
     /* 181107 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/99,
     /* 181109 */   GIR_MakeTempReg, /*TempRegID*/97, /*TypeID*/GILLT_s32,
     /* 181112 */   GIR_BuildMI, /*InsnID*/98, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 181116 */   GIR_AddTempRegister, /*InsnID*/98, /*TempRegID*/97, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181121 */   GIR_AddImm, /*InsnID*/98, /*Imm*/GIMT_Encode8(43690),
     /* 181131 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/98,
     /* 181133 */   GIR_MakeTempReg, /*TempRegID*/96, /*TypeID*/GILLT_s32,
     /* 181136 */   GIR_BuildMI, /*InsnID*/97, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 181140 */   GIR_AddTempRegister, /*InsnID*/97, /*TempRegID*/96, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181145 */   GIR_AddSimpleTempRegister, /*InsnID*/97, /*TempRegID*/97,
     /* 181148 */   GIR_AddImm, /*InsnID*/97, /*Imm*/GIMT_Encode8(43690),
     /* 181158 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/97,
     /* 181160 */   GIR_MakeTempReg, /*TempRegID*/95, /*TypeID*/GILLT_s64,
     /* 181163 */   GIR_BuildMI, /*InsnID*/96, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 181167 */   GIR_AddTempRegister, /*InsnID*/96, /*TempRegID*/95, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181172 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/96,
     /* 181174 */   GIR_MakeTempReg, /*TempRegID*/94, /*TypeID*/GILLT_s64,
     /* 181177 */   GIR_BuildMI, /*InsnID*/95, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 181181 */   GIR_AddTempRegister, /*InsnID*/95, /*TempRegID*/94, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181186 */   GIR_AddSimpleTempRegister, /*InsnID*/95, /*TempRegID*/95,
     /* 181189 */   GIR_AddSimpleTempRegister, /*InsnID*/95, /*TempRegID*/96,
     /* 181192 */   GIR_AddImm8, /*InsnID*/95, /*Imm*/1,
     /* 181195 */   GIR_ConstrainOperandRC, /*InsnID*/95, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 181200 */   GIR_ConstrainOperandRC, /*InsnID*/95, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 181205 */   GIR_ConstrainOperandRC, /*InsnID*/95, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 181210 */   GIR_MakeTempReg, /*TempRegID*/93, /*TypeID*/GILLT_s64,
     /* 181213 */   GIR_BuildMI, /*InsnID*/94, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 181217 */   GIR_AddTempRegister, /*InsnID*/94, /*TempRegID*/93, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181222 */   GIR_AddSimpleTempRegister, /*InsnID*/94, /*TempRegID*/94,
     /* 181225 */   GIR_AddImm8, /*InsnID*/94, /*Imm*/32,
     /* 181228 */   GIR_AddImm8, /*InsnID*/94, /*Imm*/31,
     /* 181231 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/94,
     /* 181233 */   GIR_MakeTempReg, /*TempRegID*/92, /*TypeID*/GILLT_s64,
     /* 181236 */   GIR_BuildMI, /*InsnID*/93, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 181240 */   GIR_AddTempRegister, /*InsnID*/93, /*TempRegID*/92, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181245 */   GIR_AddSimpleTempRegister, /*InsnID*/93, /*TempRegID*/93,
     /* 181248 */   GIR_AddImm, /*InsnID*/93, /*Imm*/GIMT_Encode8(43690),
     /* 181258 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/93,
     /* 181260 */   GIR_MakeTempReg, /*TempRegID*/91, /*TypeID*/GILLT_s64,
     /* 181263 */   GIR_BuildMI, /*InsnID*/92, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 181267 */   GIR_AddTempRegister, /*InsnID*/92, /*TempRegID*/91, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181272 */   GIR_AddSimpleTempRegister, /*InsnID*/92, /*TempRegID*/92,
     /* 181275 */   GIR_AddImm, /*InsnID*/92, /*Imm*/GIMT_Encode8(43690),
     /* 181285 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/92,
     /* 181287 */   GIR_MakeTempReg, /*TempRegID*/90, /*TypeID*/GILLT_s64,
     /* 181290 */   GIR_BuildMI, /*InsnID*/91, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 181294 */   GIR_AddTempRegister, /*InsnID*/91, /*TempRegID*/90, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181299 */   GIR_Copy, /*NewInsnID*/91, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 181303 */   GIR_AddImm8, /*InsnID*/91, /*Imm*/1,
     /* 181306 */   GIR_AddImm8, /*InsnID*/91, /*Imm*/62,
     /* 181309 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/91,
     /* 181311 */   GIR_MakeTempReg, /*TempRegID*/89, /*TypeID*/GILLT_s64,
     /* 181314 */   GIR_BuildMI, /*InsnID*/90, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 181318 */   GIR_AddTempRegister, /*InsnID*/90, /*TempRegID*/89, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181323 */   GIR_AddSimpleTempRegister, /*InsnID*/90, /*TempRegID*/90,
     /* 181326 */   GIR_AddSimpleTempRegister, /*InsnID*/90, /*TempRegID*/91,
     /* 181329 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/90,
     /* 181331 */   GIR_MakeTempReg, /*TempRegID*/88, /*TypeID*/GILLT_s32,
     /* 181334 */   GIR_BuildMI, /*InsnID*/89, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 181338 */   GIR_AddTempRegister, /*InsnID*/89, /*TempRegID*/88, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181343 */   GIR_AddImm, /*InsnID*/89, /*Imm*/GIMT_Encode8(21845),
     /* 181353 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/89,
     /* 181355 */   GIR_MakeTempReg, /*TempRegID*/87, /*TypeID*/GILLT_s32,
     /* 181358 */   GIR_BuildMI, /*InsnID*/88, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 181362 */   GIR_AddTempRegister, /*InsnID*/88, /*TempRegID*/87, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181367 */   GIR_AddSimpleTempRegister, /*InsnID*/88, /*TempRegID*/88,
     /* 181370 */   GIR_AddImm, /*InsnID*/88, /*Imm*/GIMT_Encode8(21845),
     /* 181380 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/88,
     /* 181382 */   GIR_MakeTempReg, /*TempRegID*/86, /*TypeID*/GILLT_s64,
     /* 181385 */   GIR_BuildMI, /*InsnID*/87, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 181389 */   GIR_AddTempRegister, /*InsnID*/87, /*TempRegID*/86, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181394 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/87,
     /* 181396 */   GIR_MakeTempReg, /*TempRegID*/85, /*TypeID*/GILLT_s64,
     /* 181399 */   GIR_BuildMI, /*InsnID*/86, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 181403 */   GIR_AddTempRegister, /*InsnID*/86, /*TempRegID*/85, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181408 */   GIR_AddSimpleTempRegister, /*InsnID*/86, /*TempRegID*/86,
     /* 181411 */   GIR_AddSimpleTempRegister, /*InsnID*/86, /*TempRegID*/87,
     /* 181414 */   GIR_AddImm8, /*InsnID*/86, /*Imm*/1,
     /* 181417 */   GIR_ConstrainOperandRC, /*InsnID*/86, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 181422 */   GIR_ConstrainOperandRC, /*InsnID*/86, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 181427 */   GIR_ConstrainOperandRC, /*InsnID*/86, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 181432 */   GIR_MakeTempReg, /*TempRegID*/84, /*TypeID*/GILLT_s64,
     /* 181435 */   GIR_BuildMI, /*InsnID*/85, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 181439 */   GIR_AddTempRegister, /*InsnID*/85, /*TempRegID*/84, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181444 */   GIR_AddSimpleTempRegister, /*InsnID*/85, /*TempRegID*/85,
     /* 181447 */   GIR_AddImm8, /*InsnID*/85, /*Imm*/32,
     /* 181450 */   GIR_AddImm8, /*InsnID*/85, /*Imm*/31,
     /* 181453 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/85,
     /* 181455 */   GIR_MakeTempReg, /*TempRegID*/83, /*TypeID*/GILLT_s64,
     /* 181458 */   GIR_BuildMI, /*InsnID*/84, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 181462 */   GIR_AddTempRegister, /*InsnID*/84, /*TempRegID*/83, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181467 */   GIR_AddSimpleTempRegister, /*InsnID*/84, /*TempRegID*/84,
     /* 181470 */   GIR_AddImm, /*InsnID*/84, /*Imm*/GIMT_Encode8(21845),
     /* 181480 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/84,
     /* 181482 */   GIR_MakeTempReg, /*TempRegID*/82, /*TypeID*/GILLT_s64,
     /* 181485 */   GIR_BuildMI, /*InsnID*/83, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 181489 */   GIR_AddTempRegister, /*InsnID*/83, /*TempRegID*/82, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181494 */   GIR_AddSimpleTempRegister, /*InsnID*/83, /*TempRegID*/83,
     /* 181497 */   GIR_AddImm, /*InsnID*/83, /*Imm*/GIMT_Encode8(21845),
     /* 181507 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/83,
     /* 181509 */   GIR_MakeTempReg, /*TempRegID*/81, /*TypeID*/GILLT_s64,
     /* 181512 */   GIR_BuildMI, /*InsnID*/82, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 181516 */   GIR_AddTempRegister, /*InsnID*/82, /*TempRegID*/81, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181521 */   GIR_Copy, /*NewInsnID*/82, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 181525 */   GIR_AddImm8, /*InsnID*/82, /*Imm*/63,
     /* 181528 */   GIR_AddImm8, /*InsnID*/82, /*Imm*/1,
     /* 181531 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/82,
     /* 181533 */   GIR_MakeTempReg, /*TempRegID*/80, /*TypeID*/GILLT_s64,
     /* 181536 */   GIR_BuildMI, /*InsnID*/81, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 181540 */   GIR_AddTempRegister, /*InsnID*/81, /*TempRegID*/80, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181545 */   GIR_AddSimpleTempRegister, /*InsnID*/81, /*TempRegID*/81,
     /* 181548 */   GIR_AddSimpleTempRegister, /*InsnID*/81, /*TempRegID*/82,
     /* 181551 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/81,
     /* 181553 */   GIR_MakeTempReg, /*TempRegID*/79, /*TypeID*/GILLT_s64,
     /* 181556 */   GIR_BuildMI, /*InsnID*/80, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 181560 */   GIR_AddTempRegister, /*InsnID*/80, /*TempRegID*/79, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181565 */   GIR_AddSimpleTempRegister, /*InsnID*/80, /*TempRegID*/80,
     /* 181568 */   GIR_AddSimpleTempRegister, /*InsnID*/80, /*TempRegID*/89,
     /* 181571 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/80,
     /* 181573 */   GIR_MakeTempReg, /*TempRegID*/78, /*TypeID*/GILLT_s64,
     /* 181576 */   GIR_BuildMI, /*InsnID*/79, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 181580 */   GIR_AddTempRegister, /*InsnID*/79, /*TempRegID*/78, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181585 */   GIR_AddSimpleTempRegister, /*InsnID*/79, /*TempRegID*/79,
     /* 181588 */   GIR_AddImm8, /*InsnID*/79, /*Imm*/62,
     /* 181591 */   GIR_AddImm8, /*InsnID*/79, /*Imm*/2,
     /* 181594 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/79,
     /* 181596 */   GIR_MakeTempReg, /*TempRegID*/77, /*TypeID*/GILLT_s64,
     /* 181599 */   GIR_BuildMI, /*InsnID*/78, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 181603 */   GIR_AddTempRegister, /*InsnID*/78, /*TempRegID*/77, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181608 */   GIR_AddSimpleTempRegister, /*InsnID*/78, /*TempRegID*/78,
     /* 181611 */   GIR_AddSimpleTempRegister, /*InsnID*/78, /*TempRegID*/98,
     /* 181614 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/78,
     /* 181616 */   GIR_MakeTempReg, /*TempRegID*/76, /*TypeID*/GILLT_s64,
     /* 181619 */   GIR_BuildMI, /*InsnID*/77, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 181623 */   GIR_AddTempRegister, /*InsnID*/77, /*TempRegID*/76, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181628 */   GIR_AddSimpleTempRegister, /*InsnID*/77, /*TempRegID*/77,
     /* 181631 */   GIR_AddSimpleTempRegister, /*InsnID*/77, /*TempRegID*/105,
     /* 181634 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/77,
     /* 181636 */   GIR_MakeTempReg, /*TempRegID*/75, /*TypeID*/GILLT_s64,
     /* 181639 */   GIR_BuildMI, /*InsnID*/76, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 181643 */   GIR_AddTempRegister, /*InsnID*/76, /*TempRegID*/75, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181648 */   GIR_AddSimpleTempRegister, /*InsnID*/76, /*TempRegID*/76,
     /* 181651 */   GIR_AddImm8, /*InsnID*/76, /*Imm*/4,
     /* 181654 */   GIR_AddImm8, /*InsnID*/76, /*Imm*/59,
     /* 181657 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/76,
     /* 181659 */   GIR_MakeTempReg, /*TempRegID*/74, /*TypeID*/GILLT_s64,
     /* 181662 */   GIR_BuildMI, /*InsnID*/75, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 181666 */   GIR_AddTempRegister, /*InsnID*/75, /*TempRegID*/74, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181671 */   GIR_AddSimpleTempRegister, /*InsnID*/75, /*TempRegID*/75,
     /* 181674 */   GIR_AddSimpleTempRegister, /*InsnID*/75, /*TempRegID*//* 133(*/0x85, 0x01/*)*/,
     /* 181678 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/75,
     /* 181680 */   GIR_MakeTempReg, /*TempRegID*/73, /*TypeID*/GILLT_s32,
     /* 181683 */   GIR_BuildMI, /*InsnID*/74, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 181687 */   GIR_AddTempRegister, /*InsnID*/74, /*TempRegID*/73, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181692 */   GIR_AddImm, /*InsnID*/74, /*Imm*/GIMT_Encode8(3855),
     /* 181702 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/74,
     /* 181704 */   GIR_MakeTempReg, /*TempRegID*/72, /*TypeID*/GILLT_s32,
     /* 181707 */   GIR_BuildMI, /*InsnID*/73, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 181711 */   GIR_AddTempRegister, /*InsnID*/73, /*TempRegID*/72, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181716 */   GIR_AddSimpleTempRegister, /*InsnID*/73, /*TempRegID*/73,
     /* 181719 */   GIR_AddImm, /*InsnID*/73, /*Imm*/GIMT_Encode8(3855),
     /* 181729 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/73,
     /* 181731 */   GIR_MakeTempReg, /*TempRegID*/71, /*TypeID*/GILLT_s64,
     /* 181734 */   GIR_BuildMI, /*InsnID*/72, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 181738 */   GIR_AddTempRegister, /*InsnID*/72, /*TempRegID*/71, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181743 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/72,
     /* 181745 */   GIR_MakeTempReg, /*TempRegID*/70, /*TypeID*/GILLT_s64,
     /* 181748 */   GIR_BuildMI, /*InsnID*/71, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 181752 */   GIR_AddTempRegister, /*InsnID*/71, /*TempRegID*/70, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181757 */   GIR_AddSimpleTempRegister, /*InsnID*/71, /*TempRegID*/71,
     /* 181760 */   GIR_AddSimpleTempRegister, /*InsnID*/71, /*TempRegID*/72,
     /* 181763 */   GIR_AddImm8, /*InsnID*/71, /*Imm*/1,
     /* 181766 */   GIR_ConstrainOperandRC, /*InsnID*/71, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 181771 */   GIR_ConstrainOperandRC, /*InsnID*/71, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 181776 */   GIR_ConstrainOperandRC, /*InsnID*/71, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 181781 */   GIR_MakeTempReg, /*TempRegID*/69, /*TypeID*/GILLT_s64,
     /* 181784 */   GIR_BuildMI, /*InsnID*/70, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 181788 */   GIR_AddTempRegister, /*InsnID*/70, /*TempRegID*/69, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181793 */   GIR_AddSimpleTempRegister, /*InsnID*/70, /*TempRegID*/70,
     /* 181796 */   GIR_AddImm8, /*InsnID*/70, /*Imm*/32,
     /* 181799 */   GIR_AddImm8, /*InsnID*/70, /*Imm*/31,
     /* 181802 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/70,
     /* 181804 */   GIR_MakeTempReg, /*TempRegID*/68, /*TypeID*/GILLT_s64,
     /* 181807 */   GIR_BuildMI, /*InsnID*/69, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 181811 */   GIR_AddTempRegister, /*InsnID*/69, /*TempRegID*/68, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181816 */   GIR_AddSimpleTempRegister, /*InsnID*/69, /*TempRegID*/69,
     /* 181819 */   GIR_AddImm, /*InsnID*/69, /*Imm*/GIMT_Encode8(3855),
     /* 181829 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/69,
     /* 181831 */   GIR_MakeTempReg, /*TempRegID*/67, /*TypeID*/GILLT_s64,
     /* 181834 */   GIR_BuildMI, /*InsnID*/68, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 181838 */   GIR_AddTempRegister, /*InsnID*/68, /*TempRegID*/67, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181843 */   GIR_AddSimpleTempRegister, /*InsnID*/68, /*TempRegID*/68,
     /* 181846 */   GIR_AddImm, /*InsnID*/68, /*Imm*/GIMT_Encode8(3855),
     /* 181856 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/68,
     /* 181858 */   GIR_MakeTempReg, /*TempRegID*/66, /*TypeID*/GILLT_s32,
     /* 181861 */   GIR_BuildMI, /*InsnID*/67, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 181865 */   GIR_AddTempRegister, /*InsnID*/67, /*TempRegID*/66, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181870 */   GIR_AddImm, /*InsnID*/67, /*Imm*/GIMT_Encode8(52428),
     /* 181880 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/67,
     /* 181882 */   GIR_MakeTempReg, /*TempRegID*/65, /*TypeID*/GILLT_s32,
     /* 181885 */   GIR_BuildMI, /*InsnID*/66, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 181889 */   GIR_AddTempRegister, /*InsnID*/66, /*TempRegID*/65, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181894 */   GIR_AddSimpleTempRegister, /*InsnID*/66, /*TempRegID*/66,
     /* 181897 */   GIR_AddImm, /*InsnID*/66, /*Imm*/GIMT_Encode8(52428),
     /* 181907 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/66,
     /* 181909 */   GIR_MakeTempReg, /*TempRegID*/64, /*TypeID*/GILLT_s64,
     /* 181912 */   GIR_BuildMI, /*InsnID*/65, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 181916 */   GIR_AddTempRegister, /*InsnID*/65, /*TempRegID*/64, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181921 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/65,
     /* 181923 */   GIR_MakeTempReg, /*TempRegID*/63, /*TypeID*/GILLT_s64,
     /* 181926 */   GIR_BuildMI, /*InsnID*/64, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 181930 */   GIR_AddTempRegister, /*InsnID*/64, /*TempRegID*/63, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181935 */   GIR_AddSimpleTempRegister, /*InsnID*/64, /*TempRegID*/64,
     /* 181938 */   GIR_AddSimpleTempRegister, /*InsnID*/64, /*TempRegID*/65,
     /* 181941 */   GIR_AddImm8, /*InsnID*/64, /*Imm*/1,
     /* 181944 */   GIR_ConstrainOperandRC, /*InsnID*/64, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 181949 */   GIR_ConstrainOperandRC, /*InsnID*/64, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 181954 */   GIR_ConstrainOperandRC, /*InsnID*/64, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 181959 */   GIR_MakeTempReg, /*TempRegID*/62, /*TypeID*/GILLT_s64,
     /* 181962 */   GIR_BuildMI, /*InsnID*/63, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 181966 */   GIR_AddTempRegister, /*InsnID*/63, /*TempRegID*/62, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181971 */   GIR_AddSimpleTempRegister, /*InsnID*/63, /*TempRegID*/63,
     /* 181974 */   GIR_AddImm8, /*InsnID*/63, /*Imm*/32,
     /* 181977 */   GIR_AddImm8, /*InsnID*/63, /*Imm*/31,
     /* 181980 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/63,
     /* 181982 */   GIR_MakeTempReg, /*TempRegID*/61, /*TypeID*/GILLT_s64,
     /* 181985 */   GIR_BuildMI, /*InsnID*/62, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 181989 */   GIR_AddTempRegister, /*InsnID*/62, /*TempRegID*/61, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181994 */   GIR_AddSimpleTempRegister, /*InsnID*/62, /*TempRegID*/62,
     /* 181997 */   GIR_AddImm, /*InsnID*/62, /*Imm*/GIMT_Encode8(52428),
     /* 182007 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/62,
     /* 182009 */   GIR_MakeTempReg, /*TempRegID*/60, /*TypeID*/GILLT_s64,
     /* 182012 */   GIR_BuildMI, /*InsnID*/61, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 182016 */   GIR_AddTempRegister, /*InsnID*/61, /*TempRegID*/60, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182021 */   GIR_AddSimpleTempRegister, /*InsnID*/61, /*TempRegID*/61,
     /* 182024 */   GIR_AddImm, /*InsnID*/61, /*Imm*/GIMT_Encode8(52428),
     /* 182034 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/61,
     /* 182036 */   GIR_MakeTempReg, /*TempRegID*/59, /*TypeID*/GILLT_s32,
     /* 182039 */   GIR_BuildMI, /*InsnID*/60, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 182043 */   GIR_AddTempRegister, /*InsnID*/60, /*TempRegID*/59, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182048 */   GIR_AddImm, /*InsnID*/60, /*Imm*/GIMT_Encode8(43690),
     /* 182058 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/60,
     /* 182060 */   GIR_MakeTempReg, /*TempRegID*/58, /*TypeID*/GILLT_s32,
     /* 182063 */   GIR_BuildMI, /*InsnID*/59, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 182067 */   GIR_AddTempRegister, /*InsnID*/59, /*TempRegID*/58, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182072 */   GIR_AddSimpleTempRegister, /*InsnID*/59, /*TempRegID*/59,
     /* 182075 */   GIR_AddImm, /*InsnID*/59, /*Imm*/GIMT_Encode8(43690),
     /* 182085 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/59,
     /* 182087 */   GIR_MakeTempReg, /*TempRegID*/57, /*TypeID*/GILLT_s64,
     /* 182090 */   GIR_BuildMI, /*InsnID*/58, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 182094 */   GIR_AddTempRegister, /*InsnID*/58, /*TempRegID*/57, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182099 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/58,
     /* 182101 */   GIR_MakeTempReg, /*TempRegID*/56, /*TypeID*/GILLT_s64,
     /* 182104 */   GIR_BuildMI, /*InsnID*/57, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 182108 */   GIR_AddTempRegister, /*InsnID*/57, /*TempRegID*/56, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182113 */   GIR_AddSimpleTempRegister, /*InsnID*/57, /*TempRegID*/57,
     /* 182116 */   GIR_AddSimpleTempRegister, /*InsnID*/57, /*TempRegID*/58,
     /* 182119 */   GIR_AddImm8, /*InsnID*/57, /*Imm*/1,
     /* 182122 */   GIR_ConstrainOperandRC, /*InsnID*/57, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 182127 */   GIR_ConstrainOperandRC, /*InsnID*/57, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 182132 */   GIR_ConstrainOperandRC, /*InsnID*/57, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 182137 */   GIR_MakeTempReg, /*TempRegID*/55, /*TypeID*/GILLT_s64,
     /* 182140 */   GIR_BuildMI, /*InsnID*/56, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 182144 */   GIR_AddTempRegister, /*InsnID*/56, /*TempRegID*/55, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182149 */   GIR_AddSimpleTempRegister, /*InsnID*/56, /*TempRegID*/56,
     /* 182152 */   GIR_AddImm8, /*InsnID*/56, /*Imm*/32,
     /* 182155 */   GIR_AddImm8, /*InsnID*/56, /*Imm*/31,
     /* 182158 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/56,
     /* 182160 */   GIR_MakeTempReg, /*TempRegID*/54, /*TypeID*/GILLT_s64,
     /* 182163 */   GIR_BuildMI, /*InsnID*/55, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 182167 */   GIR_AddTempRegister, /*InsnID*/55, /*TempRegID*/54, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182172 */   GIR_AddSimpleTempRegister, /*InsnID*/55, /*TempRegID*/55,
     /* 182175 */   GIR_AddImm, /*InsnID*/55, /*Imm*/GIMT_Encode8(43690),
     /* 182185 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/55,
     /* 182187 */   GIR_MakeTempReg, /*TempRegID*/53, /*TypeID*/GILLT_s64,
     /* 182190 */   GIR_BuildMI, /*InsnID*/54, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 182194 */   GIR_AddTempRegister, /*InsnID*/54, /*TempRegID*/53, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182199 */   GIR_AddSimpleTempRegister, /*InsnID*/54, /*TempRegID*/54,
     /* 182202 */   GIR_AddImm, /*InsnID*/54, /*Imm*/GIMT_Encode8(43690),
     /* 182212 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/54,
     /* 182214 */   GIR_MakeTempReg, /*TempRegID*/52, /*TypeID*/GILLT_s64,
     /* 182217 */   GIR_BuildMI, /*InsnID*/53, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 182221 */   GIR_AddTempRegister, /*InsnID*/53, /*TempRegID*/52, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182226 */   GIR_Copy, /*NewInsnID*/53, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 182230 */   GIR_AddImm8, /*InsnID*/53, /*Imm*/1,
     /* 182233 */   GIR_AddImm8, /*InsnID*/53, /*Imm*/62,
     /* 182236 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/53,
     /* 182238 */   GIR_MakeTempReg, /*TempRegID*/51, /*TypeID*/GILLT_s64,
     /* 182241 */   GIR_BuildMI, /*InsnID*/52, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 182245 */   GIR_AddTempRegister, /*InsnID*/52, /*TempRegID*/51, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182250 */   GIR_AddSimpleTempRegister, /*InsnID*/52, /*TempRegID*/52,
     /* 182253 */   GIR_AddSimpleTempRegister, /*InsnID*/52, /*TempRegID*/53,
     /* 182256 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/52,
     /* 182258 */   GIR_MakeTempReg, /*TempRegID*/50, /*TypeID*/GILLT_s32,
     /* 182261 */   GIR_BuildMI, /*InsnID*/51, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 182265 */   GIR_AddTempRegister, /*InsnID*/51, /*TempRegID*/50, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182270 */   GIR_AddImm, /*InsnID*/51, /*Imm*/GIMT_Encode8(21845),
     /* 182280 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/51,
     /* 182282 */   GIR_MakeTempReg, /*TempRegID*/49, /*TypeID*/GILLT_s32,
     /* 182285 */   GIR_BuildMI, /*InsnID*/50, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 182289 */   GIR_AddTempRegister, /*InsnID*/50, /*TempRegID*/49, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182294 */   GIR_AddSimpleTempRegister, /*InsnID*/50, /*TempRegID*/50,
     /* 182297 */   GIR_AddImm, /*InsnID*/50, /*Imm*/GIMT_Encode8(21845),
     /* 182307 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/50,
     /* 182309 */   GIR_MakeTempReg, /*TempRegID*/48, /*TypeID*/GILLT_s64,
     /* 182312 */   GIR_BuildMI, /*InsnID*/49, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 182316 */   GIR_AddTempRegister, /*InsnID*/49, /*TempRegID*/48, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182321 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/49,
     /* 182323 */   GIR_MakeTempReg, /*TempRegID*/47, /*TypeID*/GILLT_s64,
     /* 182326 */   GIR_BuildMI, /*InsnID*/48, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 182330 */   GIR_AddTempRegister, /*InsnID*/48, /*TempRegID*/47, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182335 */   GIR_AddSimpleTempRegister, /*InsnID*/48, /*TempRegID*/48,
     /* 182338 */   GIR_AddSimpleTempRegister, /*InsnID*/48, /*TempRegID*/49,
     /* 182341 */   GIR_AddImm8, /*InsnID*/48, /*Imm*/1,
     /* 182344 */   GIR_ConstrainOperandRC, /*InsnID*/48, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 182349 */   GIR_ConstrainOperandRC, /*InsnID*/48, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 182354 */   GIR_ConstrainOperandRC, /*InsnID*/48, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 182359 */   GIR_MakeTempReg, /*TempRegID*/46, /*TypeID*/GILLT_s64,
     /* 182362 */   GIR_BuildMI, /*InsnID*/47, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 182366 */   GIR_AddTempRegister, /*InsnID*/47, /*TempRegID*/46, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182371 */   GIR_AddSimpleTempRegister, /*InsnID*/47, /*TempRegID*/47,
     /* 182374 */   GIR_AddImm8, /*InsnID*/47, /*Imm*/32,
     /* 182377 */   GIR_AddImm8, /*InsnID*/47, /*Imm*/31,
     /* 182380 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/47,
     /* 182382 */   GIR_MakeTempReg, /*TempRegID*/45, /*TypeID*/GILLT_s64,
     /* 182385 */   GIR_BuildMI, /*InsnID*/46, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 182389 */   GIR_AddTempRegister, /*InsnID*/46, /*TempRegID*/45, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182394 */   GIR_AddSimpleTempRegister, /*InsnID*/46, /*TempRegID*/46,
     /* 182397 */   GIR_AddImm, /*InsnID*/46, /*Imm*/GIMT_Encode8(21845),
     /* 182407 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/46,
     /* 182409 */   GIR_MakeTempReg, /*TempRegID*/44, /*TypeID*/GILLT_s64,
     /* 182412 */   GIR_BuildMI, /*InsnID*/45, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 182416 */   GIR_AddTempRegister, /*InsnID*/45, /*TempRegID*/44, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182421 */   GIR_AddSimpleTempRegister, /*InsnID*/45, /*TempRegID*/45,
     /* 182424 */   GIR_AddImm, /*InsnID*/45, /*Imm*/GIMT_Encode8(21845),
     /* 182434 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/45,
     /* 182436 */   GIR_MakeTempReg, /*TempRegID*/43, /*TypeID*/GILLT_s64,
     /* 182439 */   GIR_BuildMI, /*InsnID*/44, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 182443 */   GIR_AddTempRegister, /*InsnID*/44, /*TempRegID*/43, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182448 */   GIR_Copy, /*NewInsnID*/44, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 182452 */   GIR_AddImm8, /*InsnID*/44, /*Imm*/63,
     /* 182455 */   GIR_AddImm8, /*InsnID*/44, /*Imm*/1,
     /* 182458 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/44,
     /* 182460 */   GIR_MakeTempReg, /*TempRegID*/42, /*TypeID*/GILLT_s64,
     /* 182463 */   GIR_BuildMI, /*InsnID*/43, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 182467 */   GIR_AddTempRegister, /*InsnID*/43, /*TempRegID*/42, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182472 */   GIR_AddSimpleTempRegister, /*InsnID*/43, /*TempRegID*/43,
     /* 182475 */   GIR_AddSimpleTempRegister, /*InsnID*/43, /*TempRegID*/44,
     /* 182478 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/43,
     /* 182480 */   GIR_MakeTempReg, /*TempRegID*/41, /*TypeID*/GILLT_s64,
     /* 182483 */   GIR_BuildMI, /*InsnID*/42, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 182487 */   GIR_AddTempRegister, /*InsnID*/42, /*TempRegID*/41, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182492 */   GIR_AddSimpleTempRegister, /*InsnID*/42, /*TempRegID*/42,
     /* 182495 */   GIR_AddSimpleTempRegister, /*InsnID*/42, /*TempRegID*/51,
     /* 182498 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/42,
     /* 182500 */   GIR_MakeTempReg, /*TempRegID*/40, /*TypeID*/GILLT_s64,
     /* 182503 */   GIR_BuildMI, /*InsnID*/41, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 182507 */   GIR_AddTempRegister, /*InsnID*/41, /*TempRegID*/40, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182512 */   GIR_AddSimpleTempRegister, /*InsnID*/41, /*TempRegID*/41,
     /* 182515 */   GIR_AddImm8, /*InsnID*/41, /*Imm*/2,
     /* 182518 */   GIR_AddImm8, /*InsnID*/41, /*Imm*/61,
     /* 182521 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/41,
     /* 182523 */   GIR_MakeTempReg, /*TempRegID*/39, /*TypeID*/GILLT_s64,
     /* 182526 */   GIR_BuildMI, /*InsnID*/40, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 182530 */   GIR_AddTempRegister, /*InsnID*/40, /*TempRegID*/39, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182535 */   GIR_AddSimpleTempRegister, /*InsnID*/40, /*TempRegID*/40,
     /* 182538 */   GIR_AddSimpleTempRegister, /*InsnID*/40, /*TempRegID*/60,
     /* 182541 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/40,
     /* 182543 */   GIR_MakeTempReg, /*TempRegID*/38, /*TypeID*/GILLT_s32,
     /* 182546 */   GIR_BuildMI, /*InsnID*/39, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 182550 */   GIR_AddTempRegister, /*InsnID*/39, /*TempRegID*/38, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182555 */   GIR_AddImm, /*InsnID*/39, /*Imm*/GIMT_Encode8(13107),
     /* 182565 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/39,
     /* 182567 */   GIR_MakeTempReg, /*TempRegID*/37, /*TypeID*/GILLT_s32,
     /* 182570 */   GIR_BuildMI, /*InsnID*/38, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 182574 */   GIR_AddTempRegister, /*InsnID*/38, /*TempRegID*/37, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182579 */   GIR_AddSimpleTempRegister, /*InsnID*/38, /*TempRegID*/38,
     /* 182582 */   GIR_AddImm, /*InsnID*/38, /*Imm*/GIMT_Encode8(13107),
     /* 182592 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/38,
     /* 182594 */   GIR_MakeTempReg, /*TempRegID*/36, /*TypeID*/GILLT_s64,
     /* 182597 */   GIR_BuildMI, /*InsnID*/37, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 182601 */   GIR_AddTempRegister, /*InsnID*/37, /*TempRegID*/36, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182606 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/37,
     /* 182608 */   GIR_MakeTempReg, /*TempRegID*/35, /*TypeID*/GILLT_s64,
     /* 182611 */   GIR_BuildMI, /*InsnID*/36, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 182615 */   GIR_AddTempRegister, /*InsnID*/36, /*TempRegID*/35, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182620 */   GIR_AddSimpleTempRegister, /*InsnID*/36, /*TempRegID*/36,
     /* 182623 */   GIR_AddSimpleTempRegister, /*InsnID*/36, /*TempRegID*/37,
     /* 182626 */   GIR_AddImm8, /*InsnID*/36, /*Imm*/1,
     /* 182629 */   GIR_ConstrainOperandRC, /*InsnID*/36, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 182634 */   GIR_ConstrainOperandRC, /*InsnID*/36, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 182639 */   GIR_ConstrainOperandRC, /*InsnID*/36, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 182644 */   GIR_MakeTempReg, /*TempRegID*/34, /*TypeID*/GILLT_s64,
     /* 182647 */   GIR_BuildMI, /*InsnID*/35, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 182651 */   GIR_AddTempRegister, /*InsnID*/35, /*TempRegID*/34, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182656 */   GIR_AddSimpleTempRegister, /*InsnID*/35, /*TempRegID*/35,
     /* 182659 */   GIR_AddImm8, /*InsnID*/35, /*Imm*/32,
     /* 182662 */   GIR_AddImm8, /*InsnID*/35, /*Imm*/31,
     /* 182665 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/35,
     /* 182667 */   GIR_MakeTempReg, /*TempRegID*/33, /*TypeID*/GILLT_s64,
     /* 182670 */   GIR_BuildMI, /*InsnID*/34, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 182674 */   GIR_AddTempRegister, /*InsnID*/34, /*TempRegID*/33, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182679 */   GIR_AddSimpleTempRegister, /*InsnID*/34, /*TempRegID*/34,
     /* 182682 */   GIR_AddImm, /*InsnID*/34, /*Imm*/GIMT_Encode8(13107),
     /* 182692 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/34,
     /* 182694 */   GIR_MakeTempReg, /*TempRegID*/32, /*TypeID*/GILLT_s64,
     /* 182697 */   GIR_BuildMI, /*InsnID*/33, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 182701 */   GIR_AddTempRegister, /*InsnID*/33, /*TempRegID*/32, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182706 */   GIR_AddSimpleTempRegister, /*InsnID*/33, /*TempRegID*/33,
     /* 182709 */   GIR_AddImm, /*InsnID*/33, /*Imm*/GIMT_Encode8(13107),
     /* 182719 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/33,
     /* 182721 */   GIR_MakeTempReg, /*TempRegID*/31, /*TypeID*/GILLT_s32,
     /* 182724 */   GIR_BuildMI, /*InsnID*/32, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 182728 */   GIR_AddTempRegister, /*InsnID*/32, /*TempRegID*/31, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182733 */   GIR_AddImm, /*InsnID*/32, /*Imm*/GIMT_Encode8(43690),
     /* 182743 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/32,
     /* 182745 */   GIR_MakeTempReg, /*TempRegID*/30, /*TypeID*/GILLT_s32,
     /* 182748 */   GIR_BuildMI, /*InsnID*/31, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 182752 */   GIR_AddTempRegister, /*InsnID*/31, /*TempRegID*/30, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182757 */   GIR_AddSimpleTempRegister, /*InsnID*/31, /*TempRegID*/31,
     /* 182760 */   GIR_AddImm, /*InsnID*/31, /*Imm*/GIMT_Encode8(43690),
     /* 182770 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/31,
     /* 182772 */   GIR_MakeTempReg, /*TempRegID*/29, /*TypeID*/GILLT_s64,
     /* 182775 */   GIR_BuildMI, /*InsnID*/30, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 182779 */   GIR_AddTempRegister, /*InsnID*/30, /*TempRegID*/29, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182784 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/30,
     /* 182786 */   GIR_MakeTempReg, /*TempRegID*/28, /*TypeID*/GILLT_s64,
     /* 182789 */   GIR_BuildMI, /*InsnID*/29, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 182793 */   GIR_AddTempRegister, /*InsnID*/29, /*TempRegID*/28, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182798 */   GIR_AddSimpleTempRegister, /*InsnID*/29, /*TempRegID*/29,
     /* 182801 */   GIR_AddSimpleTempRegister, /*InsnID*/29, /*TempRegID*/30,
     /* 182804 */   GIR_AddImm8, /*InsnID*/29, /*Imm*/1,
     /* 182807 */   GIR_ConstrainOperandRC, /*InsnID*/29, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 182812 */   GIR_ConstrainOperandRC, /*InsnID*/29, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 182817 */   GIR_ConstrainOperandRC, /*InsnID*/29, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 182822 */   GIR_MakeTempReg, /*TempRegID*/27, /*TypeID*/GILLT_s64,
     /* 182825 */   GIR_BuildMI, /*InsnID*/28, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 182829 */   GIR_AddTempRegister, /*InsnID*/28, /*TempRegID*/27, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182834 */   GIR_AddSimpleTempRegister, /*InsnID*/28, /*TempRegID*/28,
     /* 182837 */   GIR_AddImm8, /*InsnID*/28, /*Imm*/32,
     /* 182840 */   GIR_AddImm8, /*InsnID*/28, /*Imm*/31,
     /* 182843 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/28,
     /* 182845 */   GIR_MakeTempReg, /*TempRegID*/26, /*TypeID*/GILLT_s64,
     /* 182848 */   GIR_BuildMI, /*InsnID*/27, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 182852 */   GIR_AddTempRegister, /*InsnID*/27, /*TempRegID*/26, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182857 */   GIR_AddSimpleTempRegister, /*InsnID*/27, /*TempRegID*/27,
     /* 182860 */   GIR_AddImm, /*InsnID*/27, /*Imm*/GIMT_Encode8(43690),
     /* 182870 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/27,
     /* 182872 */   GIR_MakeTempReg, /*TempRegID*/25, /*TypeID*/GILLT_s64,
     /* 182875 */   GIR_BuildMI, /*InsnID*/26, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 182879 */   GIR_AddTempRegister, /*InsnID*/26, /*TempRegID*/25, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182884 */   GIR_AddSimpleTempRegister, /*InsnID*/26, /*TempRegID*/26,
     /* 182887 */   GIR_AddImm, /*InsnID*/26, /*Imm*/GIMT_Encode8(43690),
     /* 182897 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/26,
     /* 182899 */   GIR_MakeTempReg, /*TempRegID*/24, /*TypeID*/GILLT_s64,
     /* 182902 */   GIR_BuildMI, /*InsnID*/25, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 182906 */   GIR_AddTempRegister, /*InsnID*/25, /*TempRegID*/24, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182911 */   GIR_Copy, /*NewInsnID*/25, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 182915 */   GIR_AddImm8, /*InsnID*/25, /*Imm*/1,
     /* 182918 */   GIR_AddImm8, /*InsnID*/25, /*Imm*/62,
     /* 182921 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/25,
     /* 182923 */   GIR_MakeTempReg, /*TempRegID*/23, /*TypeID*/GILLT_s64,
     /* 182926 */   GIR_BuildMI, /*InsnID*/24, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 182930 */   GIR_AddTempRegister, /*InsnID*/24, /*TempRegID*/23, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182935 */   GIR_AddSimpleTempRegister, /*InsnID*/24, /*TempRegID*/24,
     /* 182938 */   GIR_AddSimpleTempRegister, /*InsnID*/24, /*TempRegID*/25,
     /* 182941 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/24,
     /* 182943 */   GIR_MakeTempReg, /*TempRegID*/22, /*TypeID*/GILLT_s32,
     /* 182946 */   GIR_BuildMI, /*InsnID*/23, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 182950 */   GIR_AddTempRegister, /*InsnID*/23, /*TempRegID*/22, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182955 */   GIR_AddImm, /*InsnID*/23, /*Imm*/GIMT_Encode8(21845),
     /* 182965 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/23,
     /* 182967 */   GIR_MakeTempReg, /*TempRegID*/21, /*TypeID*/GILLT_s32,
     /* 182970 */   GIR_BuildMI, /*InsnID*/22, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 182974 */   GIR_AddTempRegister, /*InsnID*/22, /*TempRegID*/21, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182979 */   GIR_AddSimpleTempRegister, /*InsnID*/22, /*TempRegID*/22,
     /* 182982 */   GIR_AddImm, /*InsnID*/22, /*Imm*/GIMT_Encode8(21845),
     /* 182992 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/22,
     /* 182994 */   GIR_MakeTempReg, /*TempRegID*/20, /*TypeID*/GILLT_s64,
     /* 182997 */   GIR_BuildMI, /*InsnID*/21, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 183001 */   GIR_AddTempRegister, /*InsnID*/21, /*TempRegID*/20, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183006 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/21,
     /* 183008 */   GIR_MakeTempReg, /*TempRegID*/19, /*TypeID*/GILLT_s64,
     /* 183011 */   GIR_BuildMI, /*InsnID*/20, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 183015 */   GIR_AddTempRegister, /*InsnID*/20, /*TempRegID*/19, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183020 */   GIR_AddSimpleTempRegister, /*InsnID*/20, /*TempRegID*/20,
     /* 183023 */   GIR_AddSimpleTempRegister, /*InsnID*/20, /*TempRegID*/21,
     /* 183026 */   GIR_AddImm8, /*InsnID*/20, /*Imm*/1,
     /* 183029 */   GIR_ConstrainOperandRC, /*InsnID*/20, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 183034 */   GIR_ConstrainOperandRC, /*InsnID*/20, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 183039 */   GIR_ConstrainOperandRC, /*InsnID*/20, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 183044 */   GIR_MakeTempReg, /*TempRegID*/18, /*TypeID*/GILLT_s64,
     /* 183047 */   GIR_BuildMI, /*InsnID*/19, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 183051 */   GIR_AddTempRegister, /*InsnID*/19, /*TempRegID*/18, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183056 */   GIR_AddSimpleTempRegister, /*InsnID*/19, /*TempRegID*/19,
     /* 183059 */   GIR_AddImm8, /*InsnID*/19, /*Imm*/32,
     /* 183062 */   GIR_AddImm8, /*InsnID*/19, /*Imm*/31,
     /* 183065 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/19,
     /* 183067 */   GIR_MakeTempReg, /*TempRegID*/17, /*TypeID*/GILLT_s64,
     /* 183070 */   GIR_BuildMI, /*InsnID*/18, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 183074 */   GIR_AddTempRegister, /*InsnID*/18, /*TempRegID*/17, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183079 */   GIR_AddSimpleTempRegister, /*InsnID*/18, /*TempRegID*/18,
     /* 183082 */   GIR_AddImm, /*InsnID*/18, /*Imm*/GIMT_Encode8(21845),
     /* 183092 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/18,
     /* 183094 */   GIR_MakeTempReg, /*TempRegID*/16, /*TypeID*/GILLT_s64,
     /* 183097 */   GIR_BuildMI, /*InsnID*/17, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 183101 */   GIR_AddTempRegister, /*InsnID*/17, /*TempRegID*/16, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183106 */   GIR_AddSimpleTempRegister, /*InsnID*/17, /*TempRegID*/17,
     /* 183109 */   GIR_AddImm, /*InsnID*/17, /*Imm*/GIMT_Encode8(21845),
     /* 183119 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/17,
     /* 183121 */   GIR_MakeTempReg, /*TempRegID*/15, /*TypeID*/GILLT_s64,
     /* 183124 */   GIR_BuildMI, /*InsnID*/16, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 183128 */   GIR_AddTempRegister, /*InsnID*/16, /*TempRegID*/15, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183133 */   GIR_Copy, /*NewInsnID*/16, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 183137 */   GIR_AddImm8, /*InsnID*/16, /*Imm*/63,
     /* 183140 */   GIR_AddImm8, /*InsnID*/16, /*Imm*/1,
     /* 183143 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/16,
     /* 183145 */   GIR_MakeTempReg, /*TempRegID*/14, /*TypeID*/GILLT_s64,
     /* 183148 */   GIR_BuildMI, /*InsnID*/15, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 183152 */   GIR_AddTempRegister, /*InsnID*/15, /*TempRegID*/14, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183157 */   GIR_AddSimpleTempRegister, /*InsnID*/15, /*TempRegID*/15,
     /* 183160 */   GIR_AddSimpleTempRegister, /*InsnID*/15, /*TempRegID*/16,
     /* 183163 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/15,
     /* 183165 */   GIR_MakeTempReg, /*TempRegID*/13, /*TypeID*/GILLT_s64,
     /* 183168 */   GIR_BuildMI, /*InsnID*/14, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 183172 */   GIR_AddTempRegister, /*InsnID*/14, /*TempRegID*/13, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183177 */   GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/14,
     /* 183180 */   GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/23,
     /* 183183 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/14,
     /* 183185 */   GIR_MakeTempReg, /*TempRegID*/12, /*TypeID*/GILLT_s64,
     /* 183188 */   GIR_BuildMI, /*InsnID*/13, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 183192 */   GIR_AddTempRegister, /*InsnID*/13, /*TempRegID*/12, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183197 */   GIR_AddSimpleTempRegister, /*InsnID*/13, /*TempRegID*/13,
     /* 183200 */   GIR_AddImm8, /*InsnID*/13, /*Imm*/62,
     /* 183203 */   GIR_AddImm8, /*InsnID*/13, /*Imm*/2,
     /* 183206 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/13,
     /* 183208 */   GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_s64,
     /* 183211 */   GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 183215 */   GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183220 */   GIR_AddSimpleTempRegister, /*InsnID*/12, /*TempRegID*/12,
     /* 183223 */   GIR_AddSimpleTempRegister, /*InsnID*/12, /*TempRegID*/32,
     /* 183226 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/12,
     /* 183228 */   GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_s64,
     /* 183231 */   GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 183235 */   GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183240 */   GIR_AddSimpleTempRegister, /*InsnID*/11, /*TempRegID*/11,
     /* 183243 */   GIR_AddSimpleTempRegister, /*InsnID*/11, /*TempRegID*/39,
     /* 183246 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 183248 */   GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s64,
     /* 183251 */   GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 183255 */   GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183260 */   GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
     /* 183263 */   GIR_AddImm8, /*InsnID*/10, /*Imm*/60,
     /* 183266 */   GIR_AddImm8, /*InsnID*/10, /*Imm*/4,
     /* 183269 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 183271 */   GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s64,
     /* 183274 */   GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 183278 */   GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183283 */   GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 183286 */   GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/67,
     /* 183289 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 183291 */   GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s64,
     /* 183294 */   GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 183298 */   GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183303 */   GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
     /* 183306 */   GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/74,
     /* 183309 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 183311 */   GIR_MakeTempReg, /*TempRegID*//* 273(*/0x91, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 183315 */   GIR_BuildMI, /*InsnID*//* 274(*/0x92, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 183320 */   GIR_AddTempRegister, /*InsnID*//* 274(*/0x92, 0x02/*)*/, /*TempRegID*//* 273(*/0x91, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183327 */   GIR_AddImm, /*InsnID*//* 274(*/0x92, 0x02/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 183338 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 274(*/0x92, 0x02/*)*/,
     /* 183341 */   GIR_MakeTempReg, /*TempRegID*//* 272(*/0x90, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 183345 */   GIR_BuildMI, /*InsnID*//* 273(*/0x91, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 183350 */   GIR_AddTempRegister, /*InsnID*//* 273(*/0x91, 0x02/*)*/, /*TempRegID*//* 272(*/0x90, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183357 */   GIR_AddSimpleTempRegister, /*InsnID*//* 273(*/0x91, 0x02/*)*/, /*TempRegID*//* 273(*/0x91, 0x02/*)*/,
     /* 183362 */   GIR_AddImm, /*InsnID*//* 273(*/0x91, 0x02/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 183373 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 273(*/0x91, 0x02/*)*/,
     /* 183376 */   GIR_MakeTempReg, /*TempRegID*//* 271(*/0x8F, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 183380 */   GIR_BuildMI, /*InsnID*//* 272(*/0x90, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 183385 */   GIR_AddTempRegister, /*InsnID*//* 272(*/0x90, 0x02/*)*/, /*TempRegID*//* 271(*/0x8F, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183392 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 272(*/0x90, 0x02/*)*/,
     /* 183395 */   GIR_MakeTempReg, /*TempRegID*//* 270(*/0x8E, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 183399 */   GIR_BuildMI, /*InsnID*//* 271(*/0x8F, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 183404 */   GIR_AddTempRegister, /*InsnID*//* 271(*/0x8F, 0x02/*)*/, /*TempRegID*//* 270(*/0x8E, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183411 */   GIR_AddSimpleTempRegister, /*InsnID*//* 271(*/0x8F, 0x02/*)*/, /*TempRegID*//* 271(*/0x8F, 0x02/*)*/,
     /* 183416 */   GIR_AddSimpleTempRegister, /*InsnID*//* 271(*/0x8F, 0x02/*)*/, /*TempRegID*//* 272(*/0x90, 0x02/*)*/,
     /* 183421 */   GIR_AddImm8, /*InsnID*//* 271(*/0x8F, 0x02/*)*/, /*Imm*/1,
     /* 183425 */   GIR_ConstrainOperandRC, /*InsnID*//* 271(*/0x8F, 0x02/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 183431 */   GIR_ConstrainOperandRC, /*InsnID*//* 271(*/0x8F, 0x02/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 183437 */   GIR_ConstrainOperandRC, /*InsnID*//* 271(*/0x8F, 0x02/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 183443 */   GIR_MakeTempReg, /*TempRegID*//* 269(*/0x8D, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 183447 */   GIR_BuildMI, /*InsnID*//* 270(*/0x8E, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 183452 */   GIR_AddTempRegister, /*InsnID*//* 270(*/0x8E, 0x02/*)*/, /*TempRegID*//* 269(*/0x8D, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183459 */   GIR_AddSimpleTempRegister, /*InsnID*//* 270(*/0x8E, 0x02/*)*/, /*TempRegID*//* 270(*/0x8E, 0x02/*)*/,
     /* 183464 */   GIR_AddImm8, /*InsnID*//* 270(*/0x8E, 0x02/*)*/, /*Imm*/32,
     /* 183468 */   GIR_AddImm8, /*InsnID*//* 270(*/0x8E, 0x02/*)*/, /*Imm*/31,
     /* 183472 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 270(*/0x8E, 0x02/*)*/,
     /* 183475 */   GIR_MakeTempReg, /*TempRegID*//* 268(*/0x8C, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 183479 */   GIR_BuildMI, /*InsnID*//* 269(*/0x8D, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 183484 */   GIR_AddTempRegister, /*InsnID*//* 269(*/0x8D, 0x02/*)*/, /*TempRegID*//* 268(*/0x8C, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183491 */   GIR_AddSimpleTempRegister, /*InsnID*//* 269(*/0x8D, 0x02/*)*/, /*TempRegID*//* 269(*/0x8D, 0x02/*)*/,
     /* 183496 */   GIR_AddImm, /*InsnID*//* 269(*/0x8D, 0x02/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 183507 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 269(*/0x8D, 0x02/*)*/,
     /* 183510 */   GIR_MakeTempReg, /*TempRegID*//* 267(*/0x8B, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 183514 */   GIR_BuildMI, /*InsnID*//* 268(*/0x8C, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 183519 */   GIR_AddTempRegister, /*InsnID*//* 268(*/0x8C, 0x02/*)*/, /*TempRegID*//* 267(*/0x8B, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183526 */   GIR_AddSimpleTempRegister, /*InsnID*//* 268(*/0x8C, 0x02/*)*/, /*TempRegID*//* 268(*/0x8C, 0x02/*)*/,
     /* 183531 */   GIR_AddImm, /*InsnID*//* 268(*/0x8C, 0x02/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 183542 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 268(*/0x8C, 0x02/*)*/,
     /* 183545 */   GIR_MakeTempReg, /*TempRegID*//* 266(*/0x8A, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 183549 */   GIR_BuildMI, /*InsnID*//* 267(*/0x8B, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 183554 */   GIR_AddTempRegister, /*InsnID*//* 267(*/0x8B, 0x02/*)*/, /*TempRegID*//* 266(*/0x8A, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183561 */   GIR_AddImm, /*InsnID*//* 267(*/0x8B, 0x02/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 183572 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 267(*/0x8B, 0x02/*)*/,
     /* 183575 */   GIR_MakeTempReg, /*TempRegID*//* 265(*/0x89, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 183579 */   GIR_BuildMI, /*InsnID*//* 266(*/0x8A, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 183584 */   GIR_AddTempRegister, /*InsnID*//* 266(*/0x8A, 0x02/*)*/, /*TempRegID*//* 265(*/0x89, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183591 */   GIR_AddSimpleTempRegister, /*InsnID*//* 266(*/0x8A, 0x02/*)*/, /*TempRegID*//* 266(*/0x8A, 0x02/*)*/,
     /* 183596 */   GIR_AddImm, /*InsnID*//* 266(*/0x8A, 0x02/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 183607 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 266(*/0x8A, 0x02/*)*/,
     /* 183610 */   GIR_MakeTempReg, /*TempRegID*//* 264(*/0x88, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 183614 */   GIR_BuildMI, /*InsnID*//* 265(*/0x89, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 183619 */   GIR_AddTempRegister, /*InsnID*//* 265(*/0x89, 0x02/*)*/, /*TempRegID*//* 264(*/0x88, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183626 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 265(*/0x89, 0x02/*)*/,
     /* 183629 */   GIR_MakeTempReg, /*TempRegID*//* 263(*/0x87, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 183633 */   GIR_BuildMI, /*InsnID*//* 264(*/0x88, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 183638 */   GIR_AddTempRegister, /*InsnID*//* 264(*/0x88, 0x02/*)*/, /*TempRegID*//* 263(*/0x87, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183645 */   GIR_AddSimpleTempRegister, /*InsnID*//* 264(*/0x88, 0x02/*)*/, /*TempRegID*//* 264(*/0x88, 0x02/*)*/,
     /* 183650 */   GIR_AddSimpleTempRegister, /*InsnID*//* 264(*/0x88, 0x02/*)*/, /*TempRegID*//* 265(*/0x89, 0x02/*)*/,
     /* 183655 */   GIR_AddImm8, /*InsnID*//* 264(*/0x88, 0x02/*)*/, /*Imm*/1,
     /* 183659 */   GIR_ConstrainOperandRC, /*InsnID*//* 264(*/0x88, 0x02/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 183665 */   GIR_ConstrainOperandRC, /*InsnID*//* 264(*/0x88, 0x02/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 183671 */   GIR_ConstrainOperandRC, /*InsnID*//* 264(*/0x88, 0x02/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 183677 */   GIR_MakeTempReg, /*TempRegID*//* 262(*/0x86, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 183681 */   GIR_BuildMI, /*InsnID*//* 263(*/0x87, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 183686 */   GIR_AddTempRegister, /*InsnID*//* 263(*/0x87, 0x02/*)*/, /*TempRegID*//* 262(*/0x86, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183693 */   GIR_AddSimpleTempRegister, /*InsnID*//* 263(*/0x87, 0x02/*)*/, /*TempRegID*//* 263(*/0x87, 0x02/*)*/,
     /* 183698 */   GIR_AddImm8, /*InsnID*//* 263(*/0x87, 0x02/*)*/, /*Imm*/32,
     /* 183702 */   GIR_AddImm8, /*InsnID*//* 263(*/0x87, 0x02/*)*/, /*Imm*/31,
     /* 183706 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 263(*/0x87, 0x02/*)*/,
     /* 183709 */   GIR_MakeTempReg, /*TempRegID*//* 261(*/0x85, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 183713 */   GIR_BuildMI, /*InsnID*//* 262(*/0x86, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 183718 */   GIR_AddTempRegister, /*InsnID*//* 262(*/0x86, 0x02/*)*/, /*TempRegID*//* 261(*/0x85, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183725 */   GIR_AddSimpleTempRegister, /*InsnID*//* 262(*/0x86, 0x02/*)*/, /*TempRegID*//* 262(*/0x86, 0x02/*)*/,
     /* 183730 */   GIR_AddImm, /*InsnID*//* 262(*/0x86, 0x02/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 183741 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 262(*/0x86, 0x02/*)*/,
     /* 183744 */   GIR_MakeTempReg, /*TempRegID*//* 260(*/0x84, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 183748 */   GIR_BuildMI, /*InsnID*//* 261(*/0x85, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 183753 */   GIR_AddTempRegister, /*InsnID*//* 261(*/0x85, 0x02/*)*/, /*TempRegID*//* 260(*/0x84, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183760 */   GIR_AddSimpleTempRegister, /*InsnID*//* 261(*/0x85, 0x02/*)*/, /*TempRegID*//* 261(*/0x85, 0x02/*)*/,
     /* 183765 */   GIR_AddImm, /*InsnID*//* 261(*/0x85, 0x02/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 183776 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 261(*/0x85, 0x02/*)*/,
     /* 183779 */   GIR_MakeTempReg, /*TempRegID*//* 259(*/0x83, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 183783 */   GIR_BuildMI, /*InsnID*//* 260(*/0x84, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 183788 */   GIR_AddTempRegister, /*InsnID*//* 260(*/0x84, 0x02/*)*/, /*TempRegID*//* 259(*/0x83, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183795 */   GIR_AddImm, /*InsnID*//* 260(*/0x84, 0x02/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 183806 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 260(*/0x84, 0x02/*)*/,
     /* 183809 */   GIR_MakeTempReg, /*TempRegID*//* 258(*/0x82, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 183813 */   GIR_BuildMI, /*InsnID*//* 259(*/0x83, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 183818 */   GIR_AddTempRegister, /*InsnID*//* 259(*/0x83, 0x02/*)*/, /*TempRegID*//* 258(*/0x82, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183825 */   GIR_AddSimpleTempRegister, /*InsnID*//* 259(*/0x83, 0x02/*)*/, /*TempRegID*//* 259(*/0x83, 0x02/*)*/,
     /* 183830 */   GIR_AddImm, /*InsnID*//* 259(*/0x83, 0x02/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 183841 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 259(*/0x83, 0x02/*)*/,
     /* 183844 */   GIR_MakeTempReg, /*TempRegID*//* 257(*/0x81, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 183848 */   GIR_BuildMI, /*InsnID*//* 258(*/0x82, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 183853 */   GIR_AddTempRegister, /*InsnID*//* 258(*/0x82, 0x02/*)*/, /*TempRegID*//* 257(*/0x81, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183860 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 258(*/0x82, 0x02/*)*/,
     /* 183863 */   GIR_MakeTempReg, /*TempRegID*//* 256(*/0x80, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 183867 */   GIR_BuildMI, /*InsnID*//* 257(*/0x81, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 183872 */   GIR_AddTempRegister, /*InsnID*//* 257(*/0x81, 0x02/*)*/, /*TempRegID*//* 256(*/0x80, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183879 */   GIR_AddSimpleTempRegister, /*InsnID*//* 257(*/0x81, 0x02/*)*/, /*TempRegID*//* 257(*/0x81, 0x02/*)*/,
     /* 183884 */   GIR_AddSimpleTempRegister, /*InsnID*//* 257(*/0x81, 0x02/*)*/, /*TempRegID*//* 258(*/0x82, 0x02/*)*/,
     /* 183889 */   GIR_AddImm8, /*InsnID*//* 257(*/0x81, 0x02/*)*/, /*Imm*/1,
     /* 183893 */   GIR_ConstrainOperandRC, /*InsnID*//* 257(*/0x81, 0x02/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 183899 */   GIR_ConstrainOperandRC, /*InsnID*//* 257(*/0x81, 0x02/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 183905 */   GIR_ConstrainOperandRC, /*InsnID*//* 257(*/0x81, 0x02/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 183911 */   GIR_MakeTempReg, /*TempRegID*//* 255(*/0xFF, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 183915 */   GIR_BuildMI, /*InsnID*//* 256(*/0x80, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 183920 */   GIR_AddTempRegister, /*InsnID*//* 256(*/0x80, 0x02/*)*/, /*TempRegID*//* 255(*/0xFF, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183927 */   GIR_AddSimpleTempRegister, /*InsnID*//* 256(*/0x80, 0x02/*)*/, /*TempRegID*//* 256(*/0x80, 0x02/*)*/,
     /* 183932 */   GIR_AddImm8, /*InsnID*//* 256(*/0x80, 0x02/*)*/, /*Imm*/32,
     /* 183936 */   GIR_AddImm8, /*InsnID*//* 256(*/0x80, 0x02/*)*/, /*Imm*/31,
     /* 183940 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 256(*/0x80, 0x02/*)*/,
     /* 183943 */   GIR_MakeTempReg, /*TempRegID*//* 254(*/0xFE, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 183947 */   GIR_BuildMI, /*InsnID*//* 255(*/0xFF, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 183952 */   GIR_AddTempRegister, /*InsnID*//* 255(*/0xFF, 0x01/*)*/, /*TempRegID*//* 254(*/0xFE, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183959 */   GIR_AddSimpleTempRegister, /*InsnID*//* 255(*/0xFF, 0x01/*)*/, /*TempRegID*//* 255(*/0xFF, 0x01/*)*/,
     /* 183964 */   GIR_AddImm, /*InsnID*//* 255(*/0xFF, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 183975 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 255(*/0xFF, 0x01/*)*/,
     /* 183978 */   GIR_MakeTempReg, /*TempRegID*//* 253(*/0xFD, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 183982 */   GIR_BuildMI, /*InsnID*//* 254(*/0xFE, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 183987 */   GIR_AddTempRegister, /*InsnID*//* 254(*/0xFE, 0x01/*)*/, /*TempRegID*//* 253(*/0xFD, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183994 */   GIR_AddSimpleTempRegister, /*InsnID*//* 254(*/0xFE, 0x01/*)*/, /*TempRegID*//* 254(*/0xFE, 0x01/*)*/,
     /* 183999 */   GIR_AddImm, /*InsnID*//* 254(*/0xFE, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 184010 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 254(*/0xFE, 0x01/*)*/,
     /* 184013 */   GIR_MakeTempReg, /*TempRegID*//* 252(*/0xFC, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 184017 */   GIR_BuildMI, /*InsnID*//* 253(*/0xFD, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 184022 */   GIR_AddTempRegister, /*InsnID*//* 253(*/0xFD, 0x01/*)*/, /*TempRegID*//* 252(*/0xFC, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184029 */   GIR_Copy, /*NewInsnID*//* 253(*/0xFD, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 184034 */   GIR_AddImm8, /*InsnID*//* 253(*/0xFD, 0x01/*)*/, /*Imm*/1,
     /* 184038 */   GIR_AddImm8, /*InsnID*//* 253(*/0xFD, 0x01/*)*/, /*Imm*/62,
     /* 184042 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 253(*/0xFD, 0x01/*)*/,
     /* 184045 */   GIR_MakeTempReg, /*TempRegID*//* 251(*/0xFB, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 184049 */   GIR_BuildMI, /*InsnID*//* 252(*/0xFC, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 184054 */   GIR_AddTempRegister, /*InsnID*//* 252(*/0xFC, 0x01/*)*/, /*TempRegID*//* 251(*/0xFB, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184061 */   GIR_AddSimpleTempRegister, /*InsnID*//* 252(*/0xFC, 0x01/*)*/, /*TempRegID*//* 252(*/0xFC, 0x01/*)*/,
     /* 184066 */   GIR_AddSimpleTempRegister, /*InsnID*//* 252(*/0xFC, 0x01/*)*/, /*TempRegID*//* 253(*/0xFD, 0x01/*)*/,
     /* 184071 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 252(*/0xFC, 0x01/*)*/,
     /* 184074 */   GIR_MakeTempReg, /*TempRegID*//* 250(*/0xFA, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 184078 */   GIR_BuildMI, /*InsnID*//* 251(*/0xFB, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 184083 */   GIR_AddTempRegister, /*InsnID*//* 251(*/0xFB, 0x01/*)*/, /*TempRegID*//* 250(*/0xFA, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184090 */   GIR_AddImm, /*InsnID*//* 251(*/0xFB, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 184101 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 251(*/0xFB, 0x01/*)*/,
     /* 184104 */   GIR_MakeTempReg, /*TempRegID*//* 249(*/0xF9, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 184108 */   GIR_BuildMI, /*InsnID*//* 250(*/0xFA, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 184113 */   GIR_AddTempRegister, /*InsnID*//* 250(*/0xFA, 0x01/*)*/, /*TempRegID*//* 249(*/0xF9, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184120 */   GIR_AddSimpleTempRegister, /*InsnID*//* 250(*/0xFA, 0x01/*)*/, /*TempRegID*//* 250(*/0xFA, 0x01/*)*/,
     /* 184125 */   GIR_AddImm, /*InsnID*//* 250(*/0xFA, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 184136 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 250(*/0xFA, 0x01/*)*/,
     /* 184139 */   GIR_MakeTempReg, /*TempRegID*//* 248(*/0xF8, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 184143 */   GIR_BuildMI, /*InsnID*//* 249(*/0xF9, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 184148 */   GIR_AddTempRegister, /*InsnID*//* 249(*/0xF9, 0x01/*)*/, /*TempRegID*//* 248(*/0xF8, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184155 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 249(*/0xF9, 0x01/*)*/,
     /* 184158 */   GIR_MakeTempReg, /*TempRegID*//* 247(*/0xF7, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 184162 */   GIR_BuildMI, /*InsnID*//* 248(*/0xF8, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 184167 */   GIR_AddTempRegister, /*InsnID*//* 248(*/0xF8, 0x01/*)*/, /*TempRegID*//* 247(*/0xF7, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184174 */   GIR_AddSimpleTempRegister, /*InsnID*//* 248(*/0xF8, 0x01/*)*/, /*TempRegID*//* 248(*/0xF8, 0x01/*)*/,
     /* 184179 */   GIR_AddSimpleTempRegister, /*InsnID*//* 248(*/0xF8, 0x01/*)*/, /*TempRegID*//* 249(*/0xF9, 0x01/*)*/,
     /* 184184 */   GIR_AddImm8, /*InsnID*//* 248(*/0xF8, 0x01/*)*/, /*Imm*/1,
     /* 184188 */   GIR_ConstrainOperandRC, /*InsnID*//* 248(*/0xF8, 0x01/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 184194 */   GIR_ConstrainOperandRC, /*InsnID*//* 248(*/0xF8, 0x01/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 184200 */   GIR_ConstrainOperandRC, /*InsnID*//* 248(*/0xF8, 0x01/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 184206 */   GIR_MakeTempReg, /*TempRegID*//* 246(*/0xF6, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 184210 */   GIR_BuildMI, /*InsnID*//* 247(*/0xF7, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 184215 */   GIR_AddTempRegister, /*InsnID*//* 247(*/0xF7, 0x01/*)*/, /*TempRegID*//* 246(*/0xF6, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184222 */   GIR_AddSimpleTempRegister, /*InsnID*//* 247(*/0xF7, 0x01/*)*/, /*TempRegID*//* 247(*/0xF7, 0x01/*)*/,
     /* 184227 */   GIR_AddImm8, /*InsnID*//* 247(*/0xF7, 0x01/*)*/, /*Imm*/32,
     /* 184231 */   GIR_AddImm8, /*InsnID*//* 247(*/0xF7, 0x01/*)*/, /*Imm*/31,
     /* 184235 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 247(*/0xF7, 0x01/*)*/,
     /* 184238 */   GIR_MakeTempReg, /*TempRegID*//* 245(*/0xF5, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 184242 */   GIR_BuildMI, /*InsnID*//* 246(*/0xF6, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 184247 */   GIR_AddTempRegister, /*InsnID*//* 246(*/0xF6, 0x01/*)*/, /*TempRegID*//* 245(*/0xF5, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184254 */   GIR_AddSimpleTempRegister, /*InsnID*//* 246(*/0xF6, 0x01/*)*/, /*TempRegID*//* 246(*/0xF6, 0x01/*)*/,
     /* 184259 */   GIR_AddImm, /*InsnID*//* 246(*/0xF6, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 184270 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 246(*/0xF6, 0x01/*)*/,
     /* 184273 */   GIR_MakeTempReg, /*TempRegID*//* 244(*/0xF4, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 184277 */   GIR_BuildMI, /*InsnID*//* 245(*/0xF5, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 184282 */   GIR_AddTempRegister, /*InsnID*//* 245(*/0xF5, 0x01/*)*/, /*TempRegID*//* 244(*/0xF4, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184289 */   GIR_AddSimpleTempRegister, /*InsnID*//* 245(*/0xF5, 0x01/*)*/, /*TempRegID*//* 245(*/0xF5, 0x01/*)*/,
     /* 184294 */   GIR_AddImm, /*InsnID*//* 245(*/0xF5, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 184305 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 245(*/0xF5, 0x01/*)*/,
     /* 184308 */   GIR_MakeTempReg, /*TempRegID*//* 243(*/0xF3, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 184312 */   GIR_BuildMI, /*InsnID*//* 244(*/0xF4, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 184317 */   GIR_AddTempRegister, /*InsnID*//* 244(*/0xF4, 0x01/*)*/, /*TempRegID*//* 243(*/0xF3, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184324 */   GIR_Copy, /*NewInsnID*//* 244(*/0xF4, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 184329 */   GIR_AddImm8, /*InsnID*//* 244(*/0xF4, 0x01/*)*/, /*Imm*/63,
     /* 184333 */   GIR_AddImm8, /*InsnID*//* 244(*/0xF4, 0x01/*)*/, /*Imm*/1,
     /* 184337 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 244(*/0xF4, 0x01/*)*/,
     /* 184340 */   GIR_MakeTempReg, /*TempRegID*//* 242(*/0xF2, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 184344 */   GIR_BuildMI, /*InsnID*//* 243(*/0xF3, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 184349 */   GIR_AddTempRegister, /*InsnID*//* 243(*/0xF3, 0x01/*)*/, /*TempRegID*//* 242(*/0xF2, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184356 */   GIR_AddSimpleTempRegister, /*InsnID*//* 243(*/0xF3, 0x01/*)*/, /*TempRegID*//* 243(*/0xF3, 0x01/*)*/,
     /* 184361 */   GIR_AddSimpleTempRegister, /*InsnID*//* 243(*/0xF3, 0x01/*)*/, /*TempRegID*//* 244(*/0xF4, 0x01/*)*/,
     /* 184366 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 243(*/0xF3, 0x01/*)*/,
     /* 184369 */   GIR_MakeTempReg, /*TempRegID*//* 241(*/0xF1, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 184373 */   GIR_BuildMI, /*InsnID*//* 242(*/0xF2, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 184378 */   GIR_AddTempRegister, /*InsnID*//* 242(*/0xF2, 0x01/*)*/, /*TempRegID*//* 241(*/0xF1, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184385 */   GIR_AddSimpleTempRegister, /*InsnID*//* 242(*/0xF2, 0x01/*)*/, /*TempRegID*//* 242(*/0xF2, 0x01/*)*/,
     /* 184390 */   GIR_AddSimpleTempRegister, /*InsnID*//* 242(*/0xF2, 0x01/*)*/, /*TempRegID*//* 251(*/0xFB, 0x01/*)*/,
     /* 184395 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 242(*/0xF2, 0x01/*)*/,
     /* 184398 */   GIR_MakeTempReg, /*TempRegID*//* 240(*/0xF0, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 184402 */   GIR_BuildMI, /*InsnID*//* 241(*/0xF1, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 184407 */   GIR_AddTempRegister, /*InsnID*//* 241(*/0xF1, 0x01/*)*/, /*TempRegID*//* 240(*/0xF0, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184414 */   GIR_AddSimpleTempRegister, /*InsnID*//* 241(*/0xF1, 0x01/*)*/, /*TempRegID*//* 241(*/0xF1, 0x01/*)*/,
     /* 184419 */   GIR_AddImm8, /*InsnID*//* 241(*/0xF1, 0x01/*)*/, /*Imm*/2,
     /* 184423 */   GIR_AddImm8, /*InsnID*//* 241(*/0xF1, 0x01/*)*/, /*Imm*/61,
     /* 184427 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 241(*/0xF1, 0x01/*)*/,
     /* 184430 */   GIR_MakeTempReg, /*TempRegID*//* 239(*/0xEF, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 184434 */   GIR_BuildMI, /*InsnID*//* 240(*/0xF0, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 184439 */   GIR_AddTempRegister, /*InsnID*//* 240(*/0xF0, 0x01/*)*/, /*TempRegID*//* 239(*/0xEF, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184446 */   GIR_AddSimpleTempRegister, /*InsnID*//* 240(*/0xF0, 0x01/*)*/, /*TempRegID*//* 240(*/0xF0, 0x01/*)*/,
     /* 184451 */   GIR_AddSimpleTempRegister, /*InsnID*//* 240(*/0xF0, 0x01/*)*/, /*TempRegID*//* 260(*/0x84, 0x02/*)*/,
     /* 184456 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 240(*/0xF0, 0x01/*)*/,
     /* 184459 */   GIR_MakeTempReg, /*TempRegID*//* 238(*/0xEE, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 184463 */   GIR_BuildMI, /*InsnID*//* 239(*/0xEF, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 184468 */   GIR_AddTempRegister, /*InsnID*//* 239(*/0xEF, 0x01/*)*/, /*TempRegID*//* 238(*/0xEE, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184475 */   GIR_AddImm, /*InsnID*//* 239(*/0xEF, 0x01/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 184486 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 239(*/0xEF, 0x01/*)*/,
     /* 184489 */   GIR_MakeTempReg, /*TempRegID*//* 237(*/0xED, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 184493 */   GIR_BuildMI, /*InsnID*//* 238(*/0xEE, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 184498 */   GIR_AddTempRegister, /*InsnID*//* 238(*/0xEE, 0x01/*)*/, /*TempRegID*//* 237(*/0xED, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184505 */   GIR_AddSimpleTempRegister, /*InsnID*//* 238(*/0xEE, 0x01/*)*/, /*TempRegID*//* 238(*/0xEE, 0x01/*)*/,
     /* 184510 */   GIR_AddImm, /*InsnID*//* 238(*/0xEE, 0x01/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 184521 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 238(*/0xEE, 0x01/*)*/,
     /* 184524 */   GIR_MakeTempReg, /*TempRegID*//* 236(*/0xEC, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 184528 */   GIR_BuildMI, /*InsnID*//* 237(*/0xED, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 184533 */   GIR_AddTempRegister, /*InsnID*//* 237(*/0xED, 0x01/*)*/, /*TempRegID*//* 236(*/0xEC, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184540 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 237(*/0xED, 0x01/*)*/,
     /* 184543 */   GIR_MakeTempReg, /*TempRegID*//* 235(*/0xEB, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 184547 */   GIR_BuildMI, /*InsnID*//* 236(*/0xEC, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 184552 */   GIR_AddTempRegister, /*InsnID*//* 236(*/0xEC, 0x01/*)*/, /*TempRegID*//* 235(*/0xEB, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184559 */   GIR_AddSimpleTempRegister, /*InsnID*//* 236(*/0xEC, 0x01/*)*/, /*TempRegID*//* 236(*/0xEC, 0x01/*)*/,
     /* 184564 */   GIR_AddSimpleTempRegister, /*InsnID*//* 236(*/0xEC, 0x01/*)*/, /*TempRegID*//* 237(*/0xED, 0x01/*)*/,
     /* 184569 */   GIR_AddImm8, /*InsnID*//* 236(*/0xEC, 0x01/*)*/, /*Imm*/1,
     /* 184573 */   GIR_ConstrainOperandRC, /*InsnID*//* 236(*/0xEC, 0x01/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 184579 */   GIR_ConstrainOperandRC, /*InsnID*//* 236(*/0xEC, 0x01/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 184585 */   GIR_ConstrainOperandRC, /*InsnID*//* 236(*/0xEC, 0x01/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 184591 */   GIR_MakeTempReg, /*TempRegID*//* 234(*/0xEA, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 184595 */   GIR_BuildMI, /*InsnID*//* 235(*/0xEB, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 184600 */   GIR_AddTempRegister, /*InsnID*//* 235(*/0xEB, 0x01/*)*/, /*TempRegID*//* 234(*/0xEA, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184607 */   GIR_AddSimpleTempRegister, /*InsnID*//* 235(*/0xEB, 0x01/*)*/, /*TempRegID*//* 235(*/0xEB, 0x01/*)*/,
     /* 184612 */   GIR_AddImm8, /*InsnID*//* 235(*/0xEB, 0x01/*)*/, /*Imm*/32,
     /* 184616 */   GIR_AddImm8, /*InsnID*//* 235(*/0xEB, 0x01/*)*/, /*Imm*/31,
     /* 184620 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 235(*/0xEB, 0x01/*)*/,
     /* 184623 */   GIR_MakeTempReg, /*TempRegID*//* 233(*/0xE9, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 184627 */   GIR_BuildMI, /*InsnID*//* 234(*/0xEA, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 184632 */   GIR_AddTempRegister, /*InsnID*//* 234(*/0xEA, 0x01/*)*/, /*TempRegID*//* 233(*/0xE9, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184639 */   GIR_AddSimpleTempRegister, /*InsnID*//* 234(*/0xEA, 0x01/*)*/, /*TempRegID*//* 234(*/0xEA, 0x01/*)*/,
     /* 184644 */   GIR_AddImm, /*InsnID*//* 234(*/0xEA, 0x01/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 184655 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 234(*/0xEA, 0x01/*)*/,
     /* 184658 */   GIR_MakeTempReg, /*TempRegID*//* 232(*/0xE8, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 184662 */   GIR_BuildMI, /*InsnID*//* 233(*/0xE9, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 184667 */   GIR_AddTempRegister, /*InsnID*//* 233(*/0xE9, 0x01/*)*/, /*TempRegID*//* 232(*/0xE8, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184674 */   GIR_AddSimpleTempRegister, /*InsnID*//* 233(*/0xE9, 0x01/*)*/, /*TempRegID*//* 233(*/0xE9, 0x01/*)*/,
     /* 184679 */   GIR_AddImm, /*InsnID*//* 233(*/0xE9, 0x01/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 184690 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 233(*/0xE9, 0x01/*)*/,
     /* 184693 */   GIR_MakeTempReg, /*TempRegID*//* 231(*/0xE7, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 184697 */   GIR_BuildMI, /*InsnID*//* 232(*/0xE8, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 184702 */   GIR_AddTempRegister, /*InsnID*//* 232(*/0xE8, 0x01/*)*/, /*TempRegID*//* 231(*/0xE7, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184709 */   GIR_AddImm, /*InsnID*//* 232(*/0xE8, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 184720 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 232(*/0xE8, 0x01/*)*/,
     /* 184723 */   GIR_MakeTempReg, /*TempRegID*//* 230(*/0xE6, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 184727 */   GIR_BuildMI, /*InsnID*//* 231(*/0xE7, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 184732 */   GIR_AddTempRegister, /*InsnID*//* 231(*/0xE7, 0x01/*)*/, /*TempRegID*//* 230(*/0xE6, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184739 */   GIR_AddSimpleTempRegister, /*InsnID*//* 231(*/0xE7, 0x01/*)*/, /*TempRegID*//* 231(*/0xE7, 0x01/*)*/,
     /* 184744 */   GIR_AddImm, /*InsnID*//* 231(*/0xE7, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 184755 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 231(*/0xE7, 0x01/*)*/,
     /* 184758 */   GIR_MakeTempReg, /*TempRegID*//* 229(*/0xE5, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 184762 */   GIR_BuildMI, /*InsnID*//* 230(*/0xE6, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 184767 */   GIR_AddTempRegister, /*InsnID*//* 230(*/0xE6, 0x01/*)*/, /*TempRegID*//* 229(*/0xE5, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184774 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 230(*/0xE6, 0x01/*)*/,
     /* 184777 */   GIR_MakeTempReg, /*TempRegID*//* 228(*/0xE4, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 184781 */   GIR_BuildMI, /*InsnID*//* 229(*/0xE5, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 184786 */   GIR_AddTempRegister, /*InsnID*//* 229(*/0xE5, 0x01/*)*/, /*TempRegID*//* 228(*/0xE4, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184793 */   GIR_AddSimpleTempRegister, /*InsnID*//* 229(*/0xE5, 0x01/*)*/, /*TempRegID*//* 229(*/0xE5, 0x01/*)*/,
     /* 184798 */   GIR_AddSimpleTempRegister, /*InsnID*//* 229(*/0xE5, 0x01/*)*/, /*TempRegID*//* 230(*/0xE6, 0x01/*)*/,
     /* 184803 */   GIR_AddImm8, /*InsnID*//* 229(*/0xE5, 0x01/*)*/, /*Imm*/1,
     /* 184807 */   GIR_ConstrainOperandRC, /*InsnID*//* 229(*/0xE5, 0x01/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 184813 */   GIR_ConstrainOperandRC, /*InsnID*//* 229(*/0xE5, 0x01/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 184819 */   GIR_ConstrainOperandRC, /*InsnID*//* 229(*/0xE5, 0x01/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 184825 */   GIR_MakeTempReg, /*TempRegID*//* 227(*/0xE3, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 184829 */   GIR_BuildMI, /*InsnID*//* 228(*/0xE4, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 184834 */   GIR_AddTempRegister, /*InsnID*//* 228(*/0xE4, 0x01/*)*/, /*TempRegID*//* 227(*/0xE3, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184841 */   GIR_AddSimpleTempRegister, /*InsnID*//* 228(*/0xE4, 0x01/*)*/, /*TempRegID*//* 228(*/0xE4, 0x01/*)*/,
     /* 184846 */   GIR_AddImm8, /*InsnID*//* 228(*/0xE4, 0x01/*)*/, /*Imm*/32,
     /* 184850 */   GIR_AddImm8, /*InsnID*//* 228(*/0xE4, 0x01/*)*/, /*Imm*/31,
     /* 184854 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 228(*/0xE4, 0x01/*)*/,
     /* 184857 */   GIR_MakeTempReg, /*TempRegID*//* 226(*/0xE2, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 184861 */   GIR_BuildMI, /*InsnID*//* 227(*/0xE3, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 184866 */   GIR_AddTempRegister, /*InsnID*//* 227(*/0xE3, 0x01/*)*/, /*TempRegID*//* 226(*/0xE2, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184873 */   GIR_AddSimpleTempRegister, /*InsnID*//* 227(*/0xE3, 0x01/*)*/, /*TempRegID*//* 227(*/0xE3, 0x01/*)*/,
     /* 184878 */   GIR_AddImm, /*InsnID*//* 227(*/0xE3, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 184889 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 227(*/0xE3, 0x01/*)*/,
     /* 184892 */   GIR_MakeTempReg, /*TempRegID*//* 225(*/0xE1, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 184896 */   GIR_BuildMI, /*InsnID*//* 226(*/0xE2, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 184901 */   GIR_AddTempRegister, /*InsnID*//* 226(*/0xE2, 0x01/*)*/, /*TempRegID*//* 225(*/0xE1, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184908 */   GIR_AddSimpleTempRegister, /*InsnID*//* 226(*/0xE2, 0x01/*)*/, /*TempRegID*//* 226(*/0xE2, 0x01/*)*/,
     /* 184913 */   GIR_AddImm, /*InsnID*//* 226(*/0xE2, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 184924 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 226(*/0xE2, 0x01/*)*/,
     /* 184927 */   GIR_MakeTempReg, /*TempRegID*//* 224(*/0xE0, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 184931 */   GIR_BuildMI, /*InsnID*//* 225(*/0xE1, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 184936 */   GIR_AddTempRegister, /*InsnID*//* 225(*/0xE1, 0x01/*)*/, /*TempRegID*//* 224(*/0xE0, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184943 */   GIR_Copy, /*NewInsnID*//* 225(*/0xE1, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 184948 */   GIR_AddImm8, /*InsnID*//* 225(*/0xE1, 0x01/*)*/, /*Imm*/1,
     /* 184952 */   GIR_AddImm8, /*InsnID*//* 225(*/0xE1, 0x01/*)*/, /*Imm*/62,
     /* 184956 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 225(*/0xE1, 0x01/*)*/,
     /* 184959 */   GIR_MakeTempReg, /*TempRegID*//* 223(*/0xDF, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 184963 */   GIR_BuildMI, /*InsnID*//* 224(*/0xE0, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 184968 */   GIR_AddTempRegister, /*InsnID*//* 224(*/0xE0, 0x01/*)*/, /*TempRegID*//* 223(*/0xDF, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184975 */   GIR_AddSimpleTempRegister, /*InsnID*//* 224(*/0xE0, 0x01/*)*/, /*TempRegID*//* 224(*/0xE0, 0x01/*)*/,
     /* 184980 */   GIR_AddSimpleTempRegister, /*InsnID*//* 224(*/0xE0, 0x01/*)*/, /*TempRegID*//* 225(*/0xE1, 0x01/*)*/,
     /* 184985 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 224(*/0xE0, 0x01/*)*/,
     /* 184988 */   GIR_MakeTempReg, /*TempRegID*//* 222(*/0xDE, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 184992 */   GIR_BuildMI, /*InsnID*//* 223(*/0xDF, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 184997 */   GIR_AddTempRegister, /*InsnID*//* 223(*/0xDF, 0x01/*)*/, /*TempRegID*//* 222(*/0xDE, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185004 */   GIR_AddImm, /*InsnID*//* 223(*/0xDF, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 185015 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 223(*/0xDF, 0x01/*)*/,
     /* 185018 */   GIR_MakeTempReg, /*TempRegID*//* 221(*/0xDD, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 185022 */   GIR_BuildMI, /*InsnID*//* 222(*/0xDE, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 185027 */   GIR_AddTempRegister, /*InsnID*//* 222(*/0xDE, 0x01/*)*/, /*TempRegID*//* 221(*/0xDD, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185034 */   GIR_AddSimpleTempRegister, /*InsnID*//* 222(*/0xDE, 0x01/*)*/, /*TempRegID*//* 222(*/0xDE, 0x01/*)*/,
     /* 185039 */   GIR_AddImm, /*InsnID*//* 222(*/0xDE, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 185050 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 222(*/0xDE, 0x01/*)*/,
     /* 185053 */   GIR_MakeTempReg, /*TempRegID*//* 220(*/0xDC, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 185057 */   GIR_BuildMI, /*InsnID*//* 221(*/0xDD, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 185062 */   GIR_AddTempRegister, /*InsnID*//* 221(*/0xDD, 0x01/*)*/, /*TempRegID*//* 220(*/0xDC, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185069 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 221(*/0xDD, 0x01/*)*/,
     /* 185072 */   GIR_MakeTempReg, /*TempRegID*//* 219(*/0xDB, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 185076 */   GIR_BuildMI, /*InsnID*//* 220(*/0xDC, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 185081 */   GIR_AddTempRegister, /*InsnID*//* 220(*/0xDC, 0x01/*)*/, /*TempRegID*//* 219(*/0xDB, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185088 */   GIR_AddSimpleTempRegister, /*InsnID*//* 220(*/0xDC, 0x01/*)*/, /*TempRegID*//* 220(*/0xDC, 0x01/*)*/,
     /* 185093 */   GIR_AddSimpleTempRegister, /*InsnID*//* 220(*/0xDC, 0x01/*)*/, /*TempRegID*//* 221(*/0xDD, 0x01/*)*/,
     /* 185098 */   GIR_AddImm8, /*InsnID*//* 220(*/0xDC, 0x01/*)*/, /*Imm*/1,
     /* 185102 */   GIR_ConstrainOperandRC, /*InsnID*//* 220(*/0xDC, 0x01/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 185108 */   GIR_ConstrainOperandRC, /*InsnID*//* 220(*/0xDC, 0x01/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 185114 */   GIR_ConstrainOperandRC, /*InsnID*//* 220(*/0xDC, 0x01/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 185120 */   GIR_MakeTempReg, /*TempRegID*//* 218(*/0xDA, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 185124 */   GIR_BuildMI, /*InsnID*//* 219(*/0xDB, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 185129 */   GIR_AddTempRegister, /*InsnID*//* 219(*/0xDB, 0x01/*)*/, /*TempRegID*//* 218(*/0xDA, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185136 */   GIR_AddSimpleTempRegister, /*InsnID*//* 219(*/0xDB, 0x01/*)*/, /*TempRegID*//* 219(*/0xDB, 0x01/*)*/,
     /* 185141 */   GIR_AddImm8, /*InsnID*//* 219(*/0xDB, 0x01/*)*/, /*Imm*/32,
     /* 185145 */   GIR_AddImm8, /*InsnID*//* 219(*/0xDB, 0x01/*)*/, /*Imm*/31,
     /* 185149 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 219(*/0xDB, 0x01/*)*/,
     /* 185152 */   GIR_MakeTempReg, /*TempRegID*//* 217(*/0xD9, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 185156 */   GIR_BuildMI, /*InsnID*//* 218(*/0xDA, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 185161 */   GIR_AddTempRegister, /*InsnID*//* 218(*/0xDA, 0x01/*)*/, /*TempRegID*//* 217(*/0xD9, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185168 */   GIR_AddSimpleTempRegister, /*InsnID*//* 218(*/0xDA, 0x01/*)*/, /*TempRegID*//* 218(*/0xDA, 0x01/*)*/,
     /* 185173 */   GIR_AddImm, /*InsnID*//* 218(*/0xDA, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 185184 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 218(*/0xDA, 0x01/*)*/,
     /* 185187 */   GIR_MakeTempReg, /*TempRegID*//* 216(*/0xD8, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 185191 */   GIR_BuildMI, /*InsnID*//* 217(*/0xD9, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 185196 */   GIR_AddTempRegister, /*InsnID*//* 217(*/0xD9, 0x01/*)*/, /*TempRegID*//* 216(*/0xD8, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185203 */   GIR_AddSimpleTempRegister, /*InsnID*//* 217(*/0xD9, 0x01/*)*/, /*TempRegID*//* 217(*/0xD9, 0x01/*)*/,
     /* 185208 */   GIR_AddImm, /*InsnID*//* 217(*/0xD9, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 185219 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 217(*/0xD9, 0x01/*)*/,
     /* 185222 */   GIR_MakeTempReg, /*TempRegID*//* 215(*/0xD7, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 185226 */   GIR_BuildMI, /*InsnID*//* 216(*/0xD8, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 185231 */   GIR_AddTempRegister, /*InsnID*//* 216(*/0xD8, 0x01/*)*/, /*TempRegID*//* 215(*/0xD7, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185238 */   GIR_Copy, /*NewInsnID*//* 216(*/0xD8, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 185243 */   GIR_AddImm8, /*InsnID*//* 216(*/0xD8, 0x01/*)*/, /*Imm*/63,
     /* 185247 */   GIR_AddImm8, /*InsnID*//* 216(*/0xD8, 0x01/*)*/, /*Imm*/1,
     /* 185251 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 216(*/0xD8, 0x01/*)*/,
     /* 185254 */   GIR_MakeTempReg, /*TempRegID*//* 214(*/0xD6, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 185258 */   GIR_BuildMI, /*InsnID*//* 215(*/0xD7, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 185263 */   GIR_AddTempRegister, /*InsnID*//* 215(*/0xD7, 0x01/*)*/, /*TempRegID*//* 214(*/0xD6, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185270 */   GIR_AddSimpleTempRegister, /*InsnID*//* 215(*/0xD7, 0x01/*)*/, /*TempRegID*//* 215(*/0xD7, 0x01/*)*/,
     /* 185275 */   GIR_AddSimpleTempRegister, /*InsnID*//* 215(*/0xD7, 0x01/*)*/, /*TempRegID*//* 216(*/0xD8, 0x01/*)*/,
     /* 185280 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 215(*/0xD7, 0x01/*)*/,
     /* 185283 */   GIR_MakeTempReg, /*TempRegID*//* 213(*/0xD5, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 185287 */   GIR_BuildMI, /*InsnID*//* 214(*/0xD6, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 185292 */   GIR_AddTempRegister, /*InsnID*//* 214(*/0xD6, 0x01/*)*/, /*TempRegID*//* 213(*/0xD5, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185299 */   GIR_AddSimpleTempRegister, /*InsnID*//* 214(*/0xD6, 0x01/*)*/, /*TempRegID*//* 214(*/0xD6, 0x01/*)*/,
     /* 185304 */   GIR_AddSimpleTempRegister, /*InsnID*//* 214(*/0xD6, 0x01/*)*/, /*TempRegID*//* 223(*/0xDF, 0x01/*)*/,
     /* 185309 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 214(*/0xD6, 0x01/*)*/,
     /* 185312 */   GIR_MakeTempReg, /*TempRegID*//* 212(*/0xD4, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 185316 */   GIR_BuildMI, /*InsnID*//* 213(*/0xD5, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 185321 */   GIR_AddTempRegister, /*InsnID*//* 213(*/0xD5, 0x01/*)*/, /*TempRegID*//* 212(*/0xD4, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185328 */   GIR_AddSimpleTempRegister, /*InsnID*//* 213(*/0xD5, 0x01/*)*/, /*TempRegID*//* 213(*/0xD5, 0x01/*)*/,
     /* 185333 */   GIR_AddImm8, /*InsnID*//* 213(*/0xD5, 0x01/*)*/, /*Imm*/62,
     /* 185337 */   GIR_AddImm8, /*InsnID*//* 213(*/0xD5, 0x01/*)*/, /*Imm*/2,
     /* 185341 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 213(*/0xD5, 0x01/*)*/,
     /* 185344 */   GIR_MakeTempReg, /*TempRegID*//* 211(*/0xD3, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 185348 */   GIR_BuildMI, /*InsnID*//* 212(*/0xD4, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 185353 */   GIR_AddTempRegister, /*InsnID*//* 212(*/0xD4, 0x01/*)*/, /*TempRegID*//* 211(*/0xD3, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185360 */   GIR_AddSimpleTempRegister, /*InsnID*//* 212(*/0xD4, 0x01/*)*/, /*TempRegID*//* 212(*/0xD4, 0x01/*)*/,
     /* 185365 */   GIR_AddSimpleTempRegister, /*InsnID*//* 212(*/0xD4, 0x01/*)*/, /*TempRegID*//* 232(*/0xE8, 0x01/*)*/,
     /* 185370 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 212(*/0xD4, 0x01/*)*/,
     /* 185373 */   GIR_MakeTempReg, /*TempRegID*//* 210(*/0xD2, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 185377 */   GIR_BuildMI, /*InsnID*//* 211(*/0xD3, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 185382 */   GIR_AddTempRegister, /*InsnID*//* 211(*/0xD3, 0x01/*)*/, /*TempRegID*//* 210(*/0xD2, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185389 */   GIR_AddSimpleTempRegister, /*InsnID*//* 211(*/0xD3, 0x01/*)*/, /*TempRegID*//* 211(*/0xD3, 0x01/*)*/,
     /* 185394 */   GIR_AddSimpleTempRegister, /*InsnID*//* 211(*/0xD3, 0x01/*)*/, /*TempRegID*//* 239(*/0xEF, 0x01/*)*/,
     /* 185399 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 211(*/0xD3, 0x01/*)*/,
     /* 185402 */   GIR_MakeTempReg, /*TempRegID*//* 209(*/0xD1, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 185406 */   GIR_BuildMI, /*InsnID*//* 210(*/0xD2, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 185411 */   GIR_AddTempRegister, /*InsnID*//* 210(*/0xD2, 0x01/*)*/, /*TempRegID*//* 209(*/0xD1, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185418 */   GIR_AddSimpleTempRegister, /*InsnID*//* 210(*/0xD2, 0x01/*)*/, /*TempRegID*//* 210(*/0xD2, 0x01/*)*/,
     /* 185423 */   GIR_AddImm8, /*InsnID*//* 210(*/0xD2, 0x01/*)*/, /*Imm*/4,
     /* 185427 */   GIR_AddImm8, /*InsnID*//* 210(*/0xD2, 0x01/*)*/, /*Imm*/59,
     /* 185431 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 210(*/0xD2, 0x01/*)*/,
     /* 185434 */   GIR_MakeTempReg, /*TempRegID*//* 208(*/0xD0, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 185438 */   GIR_BuildMI, /*InsnID*//* 209(*/0xD1, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 185443 */   GIR_AddTempRegister, /*InsnID*//* 209(*/0xD1, 0x01/*)*/, /*TempRegID*//* 208(*/0xD0, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185450 */   GIR_AddSimpleTempRegister, /*InsnID*//* 209(*/0xD1, 0x01/*)*/, /*TempRegID*//* 209(*/0xD1, 0x01/*)*/,
     /* 185455 */   GIR_AddSimpleTempRegister, /*InsnID*//* 209(*/0xD1, 0x01/*)*/, /*TempRegID*//* 267(*/0x8B, 0x02/*)*/,
     /* 185460 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 209(*/0xD1, 0x01/*)*/,
     /* 185463 */   GIR_MakeTempReg, /*TempRegID*//* 207(*/0xCF, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 185467 */   GIR_BuildMI, /*InsnID*//* 208(*/0xD0, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 185472 */   GIR_AddTempRegister, /*InsnID*//* 208(*/0xD0, 0x01/*)*/, /*TempRegID*//* 207(*/0xCF, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185479 */   GIR_AddImm, /*InsnID*//* 208(*/0xD0, 0x01/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 185490 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 208(*/0xD0, 0x01/*)*/,
     /* 185493 */   GIR_MakeTempReg, /*TempRegID*//* 206(*/0xCE, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 185497 */   GIR_BuildMI, /*InsnID*//* 207(*/0xCF, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 185502 */   GIR_AddTempRegister, /*InsnID*//* 207(*/0xCF, 0x01/*)*/, /*TempRegID*//* 206(*/0xCE, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185509 */   GIR_AddSimpleTempRegister, /*InsnID*//* 207(*/0xCF, 0x01/*)*/, /*TempRegID*//* 207(*/0xCF, 0x01/*)*/,
     /* 185514 */   GIR_AddImm, /*InsnID*//* 207(*/0xCF, 0x01/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 185525 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 207(*/0xCF, 0x01/*)*/,
     /* 185528 */   GIR_MakeTempReg, /*TempRegID*//* 205(*/0xCD, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 185532 */   GIR_BuildMI, /*InsnID*//* 206(*/0xCE, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 185537 */   GIR_AddTempRegister, /*InsnID*//* 206(*/0xCE, 0x01/*)*/, /*TempRegID*//* 205(*/0xCD, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185544 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 206(*/0xCE, 0x01/*)*/,
     /* 185547 */   GIR_MakeTempReg, /*TempRegID*//* 204(*/0xCC, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 185551 */   GIR_BuildMI, /*InsnID*//* 205(*/0xCD, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 185556 */   GIR_AddTempRegister, /*InsnID*//* 205(*/0xCD, 0x01/*)*/, /*TempRegID*//* 204(*/0xCC, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185563 */   GIR_AddSimpleTempRegister, /*InsnID*//* 205(*/0xCD, 0x01/*)*/, /*TempRegID*//* 205(*/0xCD, 0x01/*)*/,
     /* 185568 */   GIR_AddSimpleTempRegister, /*InsnID*//* 205(*/0xCD, 0x01/*)*/, /*TempRegID*//* 206(*/0xCE, 0x01/*)*/,
     /* 185573 */   GIR_AddImm8, /*InsnID*//* 205(*/0xCD, 0x01/*)*/, /*Imm*/1,
     /* 185577 */   GIR_ConstrainOperandRC, /*InsnID*//* 205(*/0xCD, 0x01/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 185583 */   GIR_ConstrainOperandRC, /*InsnID*//* 205(*/0xCD, 0x01/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 185589 */   GIR_ConstrainOperandRC, /*InsnID*//* 205(*/0xCD, 0x01/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 185595 */   GIR_MakeTempReg, /*TempRegID*//* 203(*/0xCB, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 185599 */   GIR_BuildMI, /*InsnID*//* 204(*/0xCC, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 185604 */   GIR_AddTempRegister, /*InsnID*//* 204(*/0xCC, 0x01/*)*/, /*TempRegID*//* 203(*/0xCB, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185611 */   GIR_AddSimpleTempRegister, /*InsnID*//* 204(*/0xCC, 0x01/*)*/, /*TempRegID*//* 204(*/0xCC, 0x01/*)*/,
     /* 185616 */   GIR_AddImm8, /*InsnID*//* 204(*/0xCC, 0x01/*)*/, /*Imm*/32,
     /* 185620 */   GIR_AddImm8, /*InsnID*//* 204(*/0xCC, 0x01/*)*/, /*Imm*/31,
     /* 185624 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 204(*/0xCC, 0x01/*)*/,
     /* 185627 */   GIR_MakeTempReg, /*TempRegID*//* 202(*/0xCA, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 185631 */   GIR_BuildMI, /*InsnID*//* 203(*/0xCB, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 185636 */   GIR_AddTempRegister, /*InsnID*//* 203(*/0xCB, 0x01/*)*/, /*TempRegID*//* 202(*/0xCA, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185643 */   GIR_AddSimpleTempRegister, /*InsnID*//* 203(*/0xCB, 0x01/*)*/, /*TempRegID*//* 203(*/0xCB, 0x01/*)*/,
     /* 185648 */   GIR_AddImm, /*InsnID*//* 203(*/0xCB, 0x01/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 185659 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 203(*/0xCB, 0x01/*)*/,
     /* 185662 */   GIR_MakeTempReg, /*TempRegID*//* 201(*/0xC9, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 185666 */   GIR_BuildMI, /*InsnID*//* 202(*/0xCA, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 185671 */   GIR_AddTempRegister, /*InsnID*//* 202(*/0xCA, 0x01/*)*/, /*TempRegID*//* 201(*/0xC9, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185678 */   GIR_AddSimpleTempRegister, /*InsnID*//* 202(*/0xCA, 0x01/*)*/, /*TempRegID*//* 202(*/0xCA, 0x01/*)*/,
     /* 185683 */   GIR_AddImm, /*InsnID*//* 202(*/0xCA, 0x01/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 185694 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 202(*/0xCA, 0x01/*)*/,
     /* 185697 */   GIR_MakeTempReg, /*TempRegID*//* 200(*/0xC8, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 185701 */   GIR_BuildMI, /*InsnID*//* 201(*/0xC9, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 185706 */   GIR_AddTempRegister, /*InsnID*//* 201(*/0xC9, 0x01/*)*/, /*TempRegID*//* 200(*/0xC8, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185713 */   GIR_AddImm, /*InsnID*//* 201(*/0xC9, 0x01/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 185724 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 201(*/0xC9, 0x01/*)*/,
     /* 185727 */   GIR_MakeTempReg, /*TempRegID*//* 199(*/0xC7, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 185731 */   GIR_BuildMI, /*InsnID*//* 200(*/0xC8, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 185736 */   GIR_AddTempRegister, /*InsnID*//* 200(*/0xC8, 0x01/*)*/, /*TempRegID*//* 199(*/0xC7, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185743 */   GIR_AddSimpleTempRegister, /*InsnID*//* 200(*/0xC8, 0x01/*)*/, /*TempRegID*//* 200(*/0xC8, 0x01/*)*/,
     /* 185748 */   GIR_AddImm, /*InsnID*//* 200(*/0xC8, 0x01/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 185759 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 200(*/0xC8, 0x01/*)*/,
     /* 185762 */   GIR_MakeTempReg, /*TempRegID*//* 198(*/0xC6, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 185766 */   GIR_BuildMI, /*InsnID*//* 199(*/0xC7, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 185771 */   GIR_AddTempRegister, /*InsnID*//* 199(*/0xC7, 0x01/*)*/, /*TempRegID*//* 198(*/0xC6, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185778 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 199(*/0xC7, 0x01/*)*/,
     /* 185781 */   GIR_MakeTempReg, /*TempRegID*//* 197(*/0xC5, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 185785 */   GIR_BuildMI, /*InsnID*//* 198(*/0xC6, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 185790 */   GIR_AddTempRegister, /*InsnID*//* 198(*/0xC6, 0x01/*)*/, /*TempRegID*//* 197(*/0xC5, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185797 */   GIR_AddSimpleTempRegister, /*InsnID*//* 198(*/0xC6, 0x01/*)*/, /*TempRegID*//* 198(*/0xC6, 0x01/*)*/,
     /* 185802 */   GIR_AddSimpleTempRegister, /*InsnID*//* 198(*/0xC6, 0x01/*)*/, /*TempRegID*//* 199(*/0xC7, 0x01/*)*/,
     /* 185807 */   GIR_AddImm8, /*InsnID*//* 198(*/0xC6, 0x01/*)*/, /*Imm*/1,
     /* 185811 */   GIR_ConstrainOperandRC, /*InsnID*//* 198(*/0xC6, 0x01/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 185817 */   GIR_ConstrainOperandRC, /*InsnID*//* 198(*/0xC6, 0x01/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 185823 */   GIR_ConstrainOperandRC, /*InsnID*//* 198(*/0xC6, 0x01/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 185829 */   GIR_MakeTempReg, /*TempRegID*//* 196(*/0xC4, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 185833 */   GIR_BuildMI, /*InsnID*//* 197(*/0xC5, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 185838 */   GIR_AddTempRegister, /*InsnID*//* 197(*/0xC5, 0x01/*)*/, /*TempRegID*//* 196(*/0xC4, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185845 */   GIR_AddSimpleTempRegister, /*InsnID*//* 197(*/0xC5, 0x01/*)*/, /*TempRegID*//* 197(*/0xC5, 0x01/*)*/,
     /* 185850 */   GIR_AddImm8, /*InsnID*//* 197(*/0xC5, 0x01/*)*/, /*Imm*/32,
     /* 185854 */   GIR_AddImm8, /*InsnID*//* 197(*/0xC5, 0x01/*)*/, /*Imm*/31,
     /* 185858 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 197(*/0xC5, 0x01/*)*/,
     /* 185861 */   GIR_MakeTempReg, /*TempRegID*//* 195(*/0xC3, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 185865 */   GIR_BuildMI, /*InsnID*//* 196(*/0xC4, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 185870 */   GIR_AddTempRegister, /*InsnID*//* 196(*/0xC4, 0x01/*)*/, /*TempRegID*//* 195(*/0xC3, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185877 */   GIR_AddSimpleTempRegister, /*InsnID*//* 196(*/0xC4, 0x01/*)*/, /*TempRegID*//* 196(*/0xC4, 0x01/*)*/,
     /* 185882 */   GIR_AddImm, /*InsnID*//* 196(*/0xC4, 0x01/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 185893 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 196(*/0xC4, 0x01/*)*/,
     /* 185896 */   GIR_MakeTempReg, /*TempRegID*//* 194(*/0xC2, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 185900 */   GIR_BuildMI, /*InsnID*//* 195(*/0xC3, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 185905 */   GIR_AddTempRegister, /*InsnID*//* 195(*/0xC3, 0x01/*)*/, /*TempRegID*//* 194(*/0xC2, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185912 */   GIR_AddSimpleTempRegister, /*InsnID*//* 195(*/0xC3, 0x01/*)*/, /*TempRegID*//* 195(*/0xC3, 0x01/*)*/,
     /* 185917 */   GIR_AddImm, /*InsnID*//* 195(*/0xC3, 0x01/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 185928 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 195(*/0xC3, 0x01/*)*/,
     /* 185931 */   GIR_MakeTempReg, /*TempRegID*//* 193(*/0xC1, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 185935 */   GIR_BuildMI, /*InsnID*//* 194(*/0xC2, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 185940 */   GIR_AddTempRegister, /*InsnID*//* 194(*/0xC2, 0x01/*)*/, /*TempRegID*//* 193(*/0xC1, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185947 */   GIR_AddImm, /*InsnID*//* 194(*/0xC2, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 185958 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 194(*/0xC2, 0x01/*)*/,
     /* 185961 */   GIR_MakeTempReg, /*TempRegID*//* 192(*/0xC0, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 185965 */   GIR_BuildMI, /*InsnID*//* 193(*/0xC1, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 185970 */   GIR_AddTempRegister, /*InsnID*//* 193(*/0xC1, 0x01/*)*/, /*TempRegID*//* 192(*/0xC0, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185977 */   GIR_AddSimpleTempRegister, /*InsnID*//* 193(*/0xC1, 0x01/*)*/, /*TempRegID*//* 193(*/0xC1, 0x01/*)*/,
     /* 185982 */   GIR_AddImm, /*InsnID*//* 193(*/0xC1, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 185993 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 193(*/0xC1, 0x01/*)*/,
     /* 185996 */   GIR_MakeTempReg, /*TempRegID*//* 191(*/0xBF, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 186000 */   GIR_BuildMI, /*InsnID*//* 192(*/0xC0, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 186005 */   GIR_AddTempRegister, /*InsnID*//* 192(*/0xC0, 0x01/*)*/, /*TempRegID*//* 191(*/0xBF, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186012 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 192(*/0xC0, 0x01/*)*/,
     /* 186015 */   GIR_MakeTempReg, /*TempRegID*//* 190(*/0xBE, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 186019 */   GIR_BuildMI, /*InsnID*//* 191(*/0xBF, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 186024 */   GIR_AddTempRegister, /*InsnID*//* 191(*/0xBF, 0x01/*)*/, /*TempRegID*//* 190(*/0xBE, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186031 */   GIR_AddSimpleTempRegister, /*InsnID*//* 191(*/0xBF, 0x01/*)*/, /*TempRegID*//* 191(*/0xBF, 0x01/*)*/,
     /* 186036 */   GIR_AddSimpleTempRegister, /*InsnID*//* 191(*/0xBF, 0x01/*)*/, /*TempRegID*//* 192(*/0xC0, 0x01/*)*/,
     /* 186041 */   GIR_AddImm8, /*InsnID*//* 191(*/0xBF, 0x01/*)*/, /*Imm*/1,
     /* 186045 */   GIR_ConstrainOperandRC, /*InsnID*//* 191(*/0xBF, 0x01/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 186051 */   GIR_ConstrainOperandRC, /*InsnID*//* 191(*/0xBF, 0x01/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 186057 */   GIR_ConstrainOperandRC, /*InsnID*//* 191(*/0xBF, 0x01/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 186063 */   GIR_MakeTempReg, /*TempRegID*//* 189(*/0xBD, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 186067 */   GIR_BuildMI, /*InsnID*//* 190(*/0xBE, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 186072 */   GIR_AddTempRegister, /*InsnID*//* 190(*/0xBE, 0x01/*)*/, /*TempRegID*//* 189(*/0xBD, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186079 */   GIR_AddSimpleTempRegister, /*InsnID*//* 190(*/0xBE, 0x01/*)*/, /*TempRegID*//* 190(*/0xBE, 0x01/*)*/,
     /* 186084 */   GIR_AddImm8, /*InsnID*//* 190(*/0xBE, 0x01/*)*/, /*Imm*/32,
     /* 186088 */   GIR_AddImm8, /*InsnID*//* 190(*/0xBE, 0x01/*)*/, /*Imm*/31,
     /* 186092 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 190(*/0xBE, 0x01/*)*/,
     /* 186095 */   GIR_MakeTempReg, /*TempRegID*//* 188(*/0xBC, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 186099 */   GIR_BuildMI, /*InsnID*//* 189(*/0xBD, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 186104 */   GIR_AddTempRegister, /*InsnID*//* 189(*/0xBD, 0x01/*)*/, /*TempRegID*//* 188(*/0xBC, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186111 */   GIR_AddSimpleTempRegister, /*InsnID*//* 189(*/0xBD, 0x01/*)*/, /*TempRegID*//* 189(*/0xBD, 0x01/*)*/,
     /* 186116 */   GIR_AddImm, /*InsnID*//* 189(*/0xBD, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 186127 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 189(*/0xBD, 0x01/*)*/,
     /* 186130 */   GIR_MakeTempReg, /*TempRegID*//* 187(*/0xBB, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 186134 */   GIR_BuildMI, /*InsnID*//* 188(*/0xBC, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 186139 */   GIR_AddTempRegister, /*InsnID*//* 188(*/0xBC, 0x01/*)*/, /*TempRegID*//* 187(*/0xBB, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186146 */   GIR_AddSimpleTempRegister, /*InsnID*//* 188(*/0xBC, 0x01/*)*/, /*TempRegID*//* 188(*/0xBC, 0x01/*)*/,
     /* 186151 */   GIR_AddImm, /*InsnID*//* 188(*/0xBC, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 186162 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 188(*/0xBC, 0x01/*)*/,
     /* 186165 */   GIR_MakeTempReg, /*TempRegID*//* 186(*/0xBA, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 186169 */   GIR_BuildMI, /*InsnID*//* 187(*/0xBB, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 186174 */   GIR_AddTempRegister, /*InsnID*//* 187(*/0xBB, 0x01/*)*/, /*TempRegID*//* 186(*/0xBA, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186181 */   GIR_Copy, /*NewInsnID*//* 187(*/0xBB, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 186186 */   GIR_AddImm8, /*InsnID*//* 187(*/0xBB, 0x01/*)*/, /*Imm*/1,
     /* 186190 */   GIR_AddImm8, /*InsnID*//* 187(*/0xBB, 0x01/*)*/, /*Imm*/62,
     /* 186194 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 187(*/0xBB, 0x01/*)*/,
     /* 186197 */   GIR_MakeTempReg, /*TempRegID*//* 185(*/0xB9, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 186201 */   GIR_BuildMI, /*InsnID*//* 186(*/0xBA, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 186206 */   GIR_AddTempRegister, /*InsnID*//* 186(*/0xBA, 0x01/*)*/, /*TempRegID*//* 185(*/0xB9, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186213 */   GIR_AddSimpleTempRegister, /*InsnID*//* 186(*/0xBA, 0x01/*)*/, /*TempRegID*//* 186(*/0xBA, 0x01/*)*/,
     /* 186218 */   GIR_AddSimpleTempRegister, /*InsnID*//* 186(*/0xBA, 0x01/*)*/, /*TempRegID*//* 187(*/0xBB, 0x01/*)*/,
     /* 186223 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 186(*/0xBA, 0x01/*)*/,
     /* 186226 */   GIR_MakeTempReg, /*TempRegID*//* 184(*/0xB8, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 186230 */   GIR_BuildMI, /*InsnID*//* 185(*/0xB9, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 186235 */   GIR_AddTempRegister, /*InsnID*//* 185(*/0xB9, 0x01/*)*/, /*TempRegID*//* 184(*/0xB8, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186242 */   GIR_AddImm, /*InsnID*//* 185(*/0xB9, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 186253 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 185(*/0xB9, 0x01/*)*/,
     /* 186256 */   GIR_MakeTempReg, /*TempRegID*//* 183(*/0xB7, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 186260 */   GIR_BuildMI, /*InsnID*//* 184(*/0xB8, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 186265 */   GIR_AddTempRegister, /*InsnID*//* 184(*/0xB8, 0x01/*)*/, /*TempRegID*//* 183(*/0xB7, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186272 */   GIR_AddSimpleTempRegister, /*InsnID*//* 184(*/0xB8, 0x01/*)*/, /*TempRegID*//* 184(*/0xB8, 0x01/*)*/,
     /* 186277 */   GIR_AddImm, /*InsnID*//* 184(*/0xB8, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 186288 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 184(*/0xB8, 0x01/*)*/,
     /* 186291 */   GIR_MakeTempReg, /*TempRegID*//* 182(*/0xB6, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 186295 */   GIR_BuildMI, /*InsnID*//* 183(*/0xB7, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 186300 */   GIR_AddTempRegister, /*InsnID*//* 183(*/0xB7, 0x01/*)*/, /*TempRegID*//* 182(*/0xB6, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186307 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 183(*/0xB7, 0x01/*)*/,
     /* 186310 */   GIR_MakeTempReg, /*TempRegID*//* 181(*/0xB5, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 186314 */   GIR_BuildMI, /*InsnID*//* 182(*/0xB6, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 186319 */   GIR_AddTempRegister, /*InsnID*//* 182(*/0xB6, 0x01/*)*/, /*TempRegID*//* 181(*/0xB5, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186326 */   GIR_AddSimpleTempRegister, /*InsnID*//* 182(*/0xB6, 0x01/*)*/, /*TempRegID*//* 182(*/0xB6, 0x01/*)*/,
     /* 186331 */   GIR_AddSimpleTempRegister, /*InsnID*//* 182(*/0xB6, 0x01/*)*/, /*TempRegID*//* 183(*/0xB7, 0x01/*)*/,
     /* 186336 */   GIR_AddImm8, /*InsnID*//* 182(*/0xB6, 0x01/*)*/, /*Imm*/1,
     /* 186340 */   GIR_ConstrainOperandRC, /*InsnID*//* 182(*/0xB6, 0x01/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 186346 */   GIR_ConstrainOperandRC, /*InsnID*//* 182(*/0xB6, 0x01/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 186352 */   GIR_ConstrainOperandRC, /*InsnID*//* 182(*/0xB6, 0x01/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 186358 */   GIR_MakeTempReg, /*TempRegID*//* 180(*/0xB4, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 186362 */   GIR_BuildMI, /*InsnID*//* 181(*/0xB5, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 186367 */   GIR_AddTempRegister, /*InsnID*//* 181(*/0xB5, 0x01/*)*/, /*TempRegID*//* 180(*/0xB4, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186374 */   GIR_AddSimpleTempRegister, /*InsnID*//* 181(*/0xB5, 0x01/*)*/, /*TempRegID*//* 181(*/0xB5, 0x01/*)*/,
     /* 186379 */   GIR_AddImm8, /*InsnID*//* 181(*/0xB5, 0x01/*)*/, /*Imm*/32,
     /* 186383 */   GIR_AddImm8, /*InsnID*//* 181(*/0xB5, 0x01/*)*/, /*Imm*/31,
     /* 186387 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 181(*/0xB5, 0x01/*)*/,
     /* 186390 */   GIR_MakeTempReg, /*TempRegID*//* 179(*/0xB3, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 186394 */   GIR_BuildMI, /*InsnID*//* 180(*/0xB4, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 186399 */   GIR_AddTempRegister, /*InsnID*//* 180(*/0xB4, 0x01/*)*/, /*TempRegID*//* 179(*/0xB3, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186406 */   GIR_AddSimpleTempRegister, /*InsnID*//* 180(*/0xB4, 0x01/*)*/, /*TempRegID*//* 180(*/0xB4, 0x01/*)*/,
     /* 186411 */   GIR_AddImm, /*InsnID*//* 180(*/0xB4, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 186422 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 180(*/0xB4, 0x01/*)*/,
     /* 186425 */   GIR_MakeTempReg, /*TempRegID*//* 178(*/0xB2, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 186429 */   GIR_BuildMI, /*InsnID*//* 179(*/0xB3, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 186434 */   GIR_AddTempRegister, /*InsnID*//* 179(*/0xB3, 0x01/*)*/, /*TempRegID*//* 178(*/0xB2, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186441 */   GIR_AddSimpleTempRegister, /*InsnID*//* 179(*/0xB3, 0x01/*)*/, /*TempRegID*//* 179(*/0xB3, 0x01/*)*/,
     /* 186446 */   GIR_AddImm, /*InsnID*//* 179(*/0xB3, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 186457 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 179(*/0xB3, 0x01/*)*/,
     /* 186460 */   GIR_MakeTempReg, /*TempRegID*//* 177(*/0xB1, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 186464 */   GIR_BuildMI, /*InsnID*//* 178(*/0xB2, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 186469 */   GIR_AddTempRegister, /*InsnID*//* 178(*/0xB2, 0x01/*)*/, /*TempRegID*//* 177(*/0xB1, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186476 */   GIR_Copy, /*NewInsnID*//* 178(*/0xB2, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 186481 */   GIR_AddImm8, /*InsnID*//* 178(*/0xB2, 0x01/*)*/, /*Imm*/63,
     /* 186485 */   GIR_AddImm8, /*InsnID*//* 178(*/0xB2, 0x01/*)*/, /*Imm*/1,
     /* 186489 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 178(*/0xB2, 0x01/*)*/,
     /* 186492 */   GIR_MakeTempReg, /*TempRegID*//* 176(*/0xB0, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 186496 */   GIR_BuildMI, /*InsnID*//* 177(*/0xB1, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 186501 */   GIR_AddTempRegister, /*InsnID*//* 177(*/0xB1, 0x01/*)*/, /*TempRegID*//* 176(*/0xB0, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186508 */   GIR_AddSimpleTempRegister, /*InsnID*//* 177(*/0xB1, 0x01/*)*/, /*TempRegID*//* 177(*/0xB1, 0x01/*)*/,
     /* 186513 */   GIR_AddSimpleTempRegister, /*InsnID*//* 177(*/0xB1, 0x01/*)*/, /*TempRegID*//* 178(*/0xB2, 0x01/*)*/,
     /* 186518 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 177(*/0xB1, 0x01/*)*/,
     /* 186521 */   GIR_MakeTempReg, /*TempRegID*//* 175(*/0xAF, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 186525 */   GIR_BuildMI, /*InsnID*//* 176(*/0xB0, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 186530 */   GIR_AddTempRegister, /*InsnID*//* 176(*/0xB0, 0x01/*)*/, /*TempRegID*//* 175(*/0xAF, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186537 */   GIR_AddSimpleTempRegister, /*InsnID*//* 176(*/0xB0, 0x01/*)*/, /*TempRegID*//* 176(*/0xB0, 0x01/*)*/,
     /* 186542 */   GIR_AddSimpleTempRegister, /*InsnID*//* 176(*/0xB0, 0x01/*)*/, /*TempRegID*//* 185(*/0xB9, 0x01/*)*/,
     /* 186547 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 176(*/0xB0, 0x01/*)*/,
     /* 186550 */   GIR_MakeTempReg, /*TempRegID*//* 174(*/0xAE, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 186554 */   GIR_BuildMI, /*InsnID*//* 175(*/0xAF, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 186559 */   GIR_AddTempRegister, /*InsnID*//* 175(*/0xAF, 0x01/*)*/, /*TempRegID*//* 174(*/0xAE, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186566 */   GIR_AddSimpleTempRegister, /*InsnID*//* 175(*/0xAF, 0x01/*)*/, /*TempRegID*//* 175(*/0xAF, 0x01/*)*/,
     /* 186571 */   GIR_AddImm8, /*InsnID*//* 175(*/0xAF, 0x01/*)*/, /*Imm*/2,
     /* 186575 */   GIR_AddImm8, /*InsnID*//* 175(*/0xAF, 0x01/*)*/, /*Imm*/61,
     /* 186579 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 175(*/0xAF, 0x01/*)*/,
     /* 186582 */   GIR_MakeTempReg, /*TempRegID*//* 173(*/0xAD, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 186586 */   GIR_BuildMI, /*InsnID*//* 174(*/0xAE, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 186591 */   GIR_AddTempRegister, /*InsnID*//* 174(*/0xAE, 0x01/*)*/, /*TempRegID*//* 173(*/0xAD, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186598 */   GIR_AddSimpleTempRegister, /*InsnID*//* 174(*/0xAE, 0x01/*)*/, /*TempRegID*//* 174(*/0xAE, 0x01/*)*/,
     /* 186603 */   GIR_AddSimpleTempRegister, /*InsnID*//* 174(*/0xAE, 0x01/*)*/, /*TempRegID*//* 194(*/0xC2, 0x01/*)*/,
     /* 186608 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 174(*/0xAE, 0x01/*)*/,
     /* 186611 */   GIR_MakeTempReg, /*TempRegID*//* 172(*/0xAC, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 186615 */   GIR_BuildMI, /*InsnID*//* 173(*/0xAD, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 186620 */   GIR_AddTempRegister, /*InsnID*//* 173(*/0xAD, 0x01/*)*/, /*TempRegID*//* 172(*/0xAC, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186627 */   GIR_AddImm, /*InsnID*//* 173(*/0xAD, 0x01/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 186638 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 173(*/0xAD, 0x01/*)*/,
     /* 186641 */   GIR_MakeTempReg, /*TempRegID*//* 171(*/0xAB, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 186645 */   GIR_BuildMI, /*InsnID*//* 172(*/0xAC, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 186650 */   GIR_AddTempRegister, /*InsnID*//* 172(*/0xAC, 0x01/*)*/, /*TempRegID*//* 171(*/0xAB, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186657 */   GIR_AddSimpleTempRegister, /*InsnID*//* 172(*/0xAC, 0x01/*)*/, /*TempRegID*//* 172(*/0xAC, 0x01/*)*/,
     /* 186662 */   GIR_AddImm, /*InsnID*//* 172(*/0xAC, 0x01/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 186673 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 172(*/0xAC, 0x01/*)*/,
     /* 186676 */   GIR_MakeTempReg, /*TempRegID*//* 170(*/0xAA, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 186680 */   GIR_BuildMI, /*InsnID*//* 171(*/0xAB, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 186685 */   GIR_AddTempRegister, /*InsnID*//* 171(*/0xAB, 0x01/*)*/, /*TempRegID*//* 170(*/0xAA, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186692 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 171(*/0xAB, 0x01/*)*/,
     /* 186695 */   GIR_MakeTempReg, /*TempRegID*//* 169(*/0xA9, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 186699 */   GIR_BuildMI, /*InsnID*//* 170(*/0xAA, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 186704 */   GIR_AddTempRegister, /*InsnID*//* 170(*/0xAA, 0x01/*)*/, /*TempRegID*//* 169(*/0xA9, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186711 */   GIR_AddSimpleTempRegister, /*InsnID*//* 170(*/0xAA, 0x01/*)*/, /*TempRegID*//* 170(*/0xAA, 0x01/*)*/,
     /* 186716 */   GIR_AddSimpleTempRegister, /*InsnID*//* 170(*/0xAA, 0x01/*)*/, /*TempRegID*//* 171(*/0xAB, 0x01/*)*/,
     /* 186721 */   GIR_AddImm8, /*InsnID*//* 170(*/0xAA, 0x01/*)*/, /*Imm*/1,
     /* 186725 */   GIR_ConstrainOperandRC, /*InsnID*//* 170(*/0xAA, 0x01/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 186731 */   GIR_ConstrainOperandRC, /*InsnID*//* 170(*/0xAA, 0x01/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 186737 */   GIR_ConstrainOperandRC, /*InsnID*//* 170(*/0xAA, 0x01/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 186743 */   GIR_MakeTempReg, /*TempRegID*//* 168(*/0xA8, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 186747 */   GIR_BuildMI, /*InsnID*//* 169(*/0xA9, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 186752 */   GIR_AddTempRegister, /*InsnID*//* 169(*/0xA9, 0x01/*)*/, /*TempRegID*//* 168(*/0xA8, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186759 */   GIR_AddSimpleTempRegister, /*InsnID*//* 169(*/0xA9, 0x01/*)*/, /*TempRegID*//* 169(*/0xA9, 0x01/*)*/,
     /* 186764 */   GIR_AddImm8, /*InsnID*//* 169(*/0xA9, 0x01/*)*/, /*Imm*/32,
     /* 186768 */   GIR_AddImm8, /*InsnID*//* 169(*/0xA9, 0x01/*)*/, /*Imm*/31,
     /* 186772 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 169(*/0xA9, 0x01/*)*/,
     /* 186775 */   GIR_MakeTempReg, /*TempRegID*//* 167(*/0xA7, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 186779 */   GIR_BuildMI, /*InsnID*//* 168(*/0xA8, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 186784 */   GIR_AddTempRegister, /*InsnID*//* 168(*/0xA8, 0x01/*)*/, /*TempRegID*//* 167(*/0xA7, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186791 */   GIR_AddSimpleTempRegister, /*InsnID*//* 168(*/0xA8, 0x01/*)*/, /*TempRegID*//* 168(*/0xA8, 0x01/*)*/,
     /* 186796 */   GIR_AddImm, /*InsnID*//* 168(*/0xA8, 0x01/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 186807 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 168(*/0xA8, 0x01/*)*/,
     /* 186810 */   GIR_MakeTempReg, /*TempRegID*//* 166(*/0xA6, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 186814 */   GIR_BuildMI, /*InsnID*//* 167(*/0xA7, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 186819 */   GIR_AddTempRegister, /*InsnID*//* 167(*/0xA7, 0x01/*)*/, /*TempRegID*//* 166(*/0xA6, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186826 */   GIR_AddSimpleTempRegister, /*InsnID*//* 167(*/0xA7, 0x01/*)*/, /*TempRegID*//* 167(*/0xA7, 0x01/*)*/,
     /* 186831 */   GIR_AddImm, /*InsnID*//* 167(*/0xA7, 0x01/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 186842 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 167(*/0xA7, 0x01/*)*/,
     /* 186845 */   GIR_MakeTempReg, /*TempRegID*//* 165(*/0xA5, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 186849 */   GIR_BuildMI, /*InsnID*//* 166(*/0xA6, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 186854 */   GIR_AddTempRegister, /*InsnID*//* 166(*/0xA6, 0x01/*)*/, /*TempRegID*//* 165(*/0xA5, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186861 */   GIR_AddImm, /*InsnID*//* 166(*/0xA6, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 186872 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 166(*/0xA6, 0x01/*)*/,
     /* 186875 */   GIR_MakeTempReg, /*TempRegID*//* 164(*/0xA4, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 186879 */   GIR_BuildMI, /*InsnID*//* 165(*/0xA5, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 186884 */   GIR_AddTempRegister, /*InsnID*//* 165(*/0xA5, 0x01/*)*/, /*TempRegID*//* 164(*/0xA4, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186891 */   GIR_AddSimpleTempRegister, /*InsnID*//* 165(*/0xA5, 0x01/*)*/, /*TempRegID*//* 165(*/0xA5, 0x01/*)*/,
     /* 186896 */   GIR_AddImm, /*InsnID*//* 165(*/0xA5, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 186907 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 165(*/0xA5, 0x01/*)*/,
     /* 186910 */   GIR_MakeTempReg, /*TempRegID*//* 163(*/0xA3, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 186914 */   GIR_BuildMI, /*InsnID*//* 164(*/0xA4, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 186919 */   GIR_AddTempRegister, /*InsnID*//* 164(*/0xA4, 0x01/*)*/, /*TempRegID*//* 163(*/0xA3, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186926 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 164(*/0xA4, 0x01/*)*/,
     /* 186929 */   GIR_MakeTempReg, /*TempRegID*//* 162(*/0xA2, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 186933 */   GIR_BuildMI, /*InsnID*//* 163(*/0xA3, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 186938 */   GIR_AddTempRegister, /*InsnID*//* 163(*/0xA3, 0x01/*)*/, /*TempRegID*//* 162(*/0xA2, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186945 */   GIR_AddSimpleTempRegister, /*InsnID*//* 163(*/0xA3, 0x01/*)*/, /*TempRegID*//* 163(*/0xA3, 0x01/*)*/,
     /* 186950 */   GIR_AddSimpleTempRegister, /*InsnID*//* 163(*/0xA3, 0x01/*)*/, /*TempRegID*//* 164(*/0xA4, 0x01/*)*/,
     /* 186955 */   GIR_AddImm8, /*InsnID*//* 163(*/0xA3, 0x01/*)*/, /*Imm*/1,
     /* 186959 */   GIR_ConstrainOperandRC, /*InsnID*//* 163(*/0xA3, 0x01/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 186965 */   GIR_ConstrainOperandRC, /*InsnID*//* 163(*/0xA3, 0x01/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 186971 */   GIR_ConstrainOperandRC, /*InsnID*//* 163(*/0xA3, 0x01/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 186977 */   GIR_MakeTempReg, /*TempRegID*//* 161(*/0xA1, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 186981 */   GIR_BuildMI, /*InsnID*//* 162(*/0xA2, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 186986 */   GIR_AddTempRegister, /*InsnID*//* 162(*/0xA2, 0x01/*)*/, /*TempRegID*//* 161(*/0xA1, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186993 */   GIR_AddSimpleTempRegister, /*InsnID*//* 162(*/0xA2, 0x01/*)*/, /*TempRegID*//* 162(*/0xA2, 0x01/*)*/,
     /* 186998 */   GIR_AddImm8, /*InsnID*//* 162(*/0xA2, 0x01/*)*/, /*Imm*/32,
     /* 187002 */   GIR_AddImm8, /*InsnID*//* 162(*/0xA2, 0x01/*)*/, /*Imm*/31,
     /* 187006 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 162(*/0xA2, 0x01/*)*/,
     /* 187009 */   GIR_MakeTempReg, /*TempRegID*//* 160(*/0xA0, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187013 */   GIR_BuildMI, /*InsnID*//* 161(*/0xA1, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 187018 */   GIR_AddTempRegister, /*InsnID*//* 161(*/0xA1, 0x01/*)*/, /*TempRegID*//* 160(*/0xA0, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187025 */   GIR_AddSimpleTempRegister, /*InsnID*//* 161(*/0xA1, 0x01/*)*/, /*TempRegID*//* 161(*/0xA1, 0x01/*)*/,
     /* 187030 */   GIR_AddImm, /*InsnID*//* 161(*/0xA1, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 187041 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 161(*/0xA1, 0x01/*)*/,
     /* 187044 */   GIR_MakeTempReg, /*TempRegID*//* 159(*/0x9F, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187048 */   GIR_BuildMI, /*InsnID*//* 160(*/0xA0, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 187053 */   GIR_AddTempRegister, /*InsnID*//* 160(*/0xA0, 0x01/*)*/, /*TempRegID*//* 159(*/0x9F, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187060 */   GIR_AddSimpleTempRegister, /*InsnID*//* 160(*/0xA0, 0x01/*)*/, /*TempRegID*//* 160(*/0xA0, 0x01/*)*/,
     /* 187065 */   GIR_AddImm, /*InsnID*//* 160(*/0xA0, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 187076 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 160(*/0xA0, 0x01/*)*/,
     /* 187079 */   GIR_MakeTempReg, /*TempRegID*//* 158(*/0x9E, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187083 */   GIR_BuildMI, /*InsnID*//* 159(*/0x9F, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 187088 */   GIR_AddTempRegister, /*InsnID*//* 159(*/0x9F, 0x01/*)*/, /*TempRegID*//* 158(*/0x9E, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187095 */   GIR_Copy, /*NewInsnID*//* 159(*/0x9F, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 187100 */   GIR_AddImm8, /*InsnID*//* 159(*/0x9F, 0x01/*)*/, /*Imm*/1,
     /* 187104 */   GIR_AddImm8, /*InsnID*//* 159(*/0x9F, 0x01/*)*/, /*Imm*/62,
     /* 187108 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 159(*/0x9F, 0x01/*)*/,
     /* 187111 */   GIR_MakeTempReg, /*TempRegID*//* 157(*/0x9D, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187115 */   GIR_BuildMI, /*InsnID*//* 158(*/0x9E, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 187120 */   GIR_AddTempRegister, /*InsnID*//* 158(*/0x9E, 0x01/*)*/, /*TempRegID*//* 157(*/0x9D, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187127 */   GIR_AddSimpleTempRegister, /*InsnID*//* 158(*/0x9E, 0x01/*)*/, /*TempRegID*//* 158(*/0x9E, 0x01/*)*/,
     /* 187132 */   GIR_AddSimpleTempRegister, /*InsnID*//* 158(*/0x9E, 0x01/*)*/, /*TempRegID*//* 159(*/0x9F, 0x01/*)*/,
     /* 187137 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 158(*/0x9E, 0x01/*)*/,
     /* 187140 */   GIR_MakeTempReg, /*TempRegID*//* 156(*/0x9C, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 187144 */   GIR_BuildMI, /*InsnID*//* 157(*/0x9D, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 187149 */   GIR_AddTempRegister, /*InsnID*//* 157(*/0x9D, 0x01/*)*/, /*TempRegID*//* 156(*/0x9C, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187156 */   GIR_AddImm, /*InsnID*//* 157(*/0x9D, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 187167 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 157(*/0x9D, 0x01/*)*/,
     /* 187170 */   GIR_MakeTempReg, /*TempRegID*//* 155(*/0x9B, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 187174 */   GIR_BuildMI, /*InsnID*//* 156(*/0x9C, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 187179 */   GIR_AddTempRegister, /*InsnID*//* 156(*/0x9C, 0x01/*)*/, /*TempRegID*//* 155(*/0x9B, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187186 */   GIR_AddSimpleTempRegister, /*InsnID*//* 156(*/0x9C, 0x01/*)*/, /*TempRegID*//* 156(*/0x9C, 0x01/*)*/,
     /* 187191 */   GIR_AddImm, /*InsnID*//* 156(*/0x9C, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 187202 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 156(*/0x9C, 0x01/*)*/,
     /* 187205 */   GIR_MakeTempReg, /*TempRegID*//* 154(*/0x9A, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187209 */   GIR_BuildMI, /*InsnID*//* 155(*/0x9B, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 187214 */   GIR_AddTempRegister, /*InsnID*//* 155(*/0x9B, 0x01/*)*/, /*TempRegID*//* 154(*/0x9A, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187221 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 155(*/0x9B, 0x01/*)*/,
     /* 187224 */   GIR_MakeTempReg, /*TempRegID*//* 153(*/0x99, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187228 */   GIR_BuildMI, /*InsnID*//* 154(*/0x9A, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 187233 */   GIR_AddTempRegister, /*InsnID*//* 154(*/0x9A, 0x01/*)*/, /*TempRegID*//* 153(*/0x99, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187240 */   GIR_AddSimpleTempRegister, /*InsnID*//* 154(*/0x9A, 0x01/*)*/, /*TempRegID*//* 154(*/0x9A, 0x01/*)*/,
     /* 187245 */   GIR_AddSimpleTempRegister, /*InsnID*//* 154(*/0x9A, 0x01/*)*/, /*TempRegID*//* 155(*/0x9B, 0x01/*)*/,
     /* 187250 */   GIR_AddImm8, /*InsnID*//* 154(*/0x9A, 0x01/*)*/, /*Imm*/1,
     /* 187254 */   GIR_ConstrainOperandRC, /*InsnID*//* 154(*/0x9A, 0x01/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 187260 */   GIR_ConstrainOperandRC, /*InsnID*//* 154(*/0x9A, 0x01/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 187266 */   GIR_ConstrainOperandRC, /*InsnID*//* 154(*/0x9A, 0x01/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 187272 */   GIR_MakeTempReg, /*TempRegID*//* 152(*/0x98, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187276 */   GIR_BuildMI, /*InsnID*//* 153(*/0x99, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 187281 */   GIR_AddTempRegister, /*InsnID*//* 153(*/0x99, 0x01/*)*/, /*TempRegID*//* 152(*/0x98, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187288 */   GIR_AddSimpleTempRegister, /*InsnID*//* 153(*/0x99, 0x01/*)*/, /*TempRegID*//* 153(*/0x99, 0x01/*)*/,
     /* 187293 */   GIR_AddImm8, /*InsnID*//* 153(*/0x99, 0x01/*)*/, /*Imm*/32,
     /* 187297 */   GIR_AddImm8, /*InsnID*//* 153(*/0x99, 0x01/*)*/, /*Imm*/31,
     /* 187301 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 153(*/0x99, 0x01/*)*/,
     /* 187304 */   GIR_MakeTempReg, /*TempRegID*//* 151(*/0x97, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187308 */   GIR_BuildMI, /*InsnID*//* 152(*/0x98, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 187313 */   GIR_AddTempRegister, /*InsnID*//* 152(*/0x98, 0x01/*)*/, /*TempRegID*//* 151(*/0x97, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187320 */   GIR_AddSimpleTempRegister, /*InsnID*//* 152(*/0x98, 0x01/*)*/, /*TempRegID*//* 152(*/0x98, 0x01/*)*/,
     /* 187325 */   GIR_AddImm, /*InsnID*//* 152(*/0x98, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 187336 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 152(*/0x98, 0x01/*)*/,
     /* 187339 */   GIR_MakeTempReg, /*TempRegID*//* 150(*/0x96, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187343 */   GIR_BuildMI, /*InsnID*//* 151(*/0x97, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 187348 */   GIR_AddTempRegister, /*InsnID*//* 151(*/0x97, 0x01/*)*/, /*TempRegID*//* 150(*/0x96, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187355 */   GIR_AddSimpleTempRegister, /*InsnID*//* 151(*/0x97, 0x01/*)*/, /*TempRegID*//* 151(*/0x97, 0x01/*)*/,
     /* 187360 */   GIR_AddImm, /*InsnID*//* 151(*/0x97, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 187371 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 151(*/0x97, 0x01/*)*/,
     /* 187374 */   GIR_MakeTempReg, /*TempRegID*//* 149(*/0x95, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187378 */   GIR_BuildMI, /*InsnID*//* 150(*/0x96, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 187383 */   GIR_AddTempRegister, /*InsnID*//* 150(*/0x96, 0x01/*)*/, /*TempRegID*//* 149(*/0x95, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187390 */   GIR_Copy, /*NewInsnID*//* 150(*/0x96, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 187395 */   GIR_AddImm8, /*InsnID*//* 150(*/0x96, 0x01/*)*/, /*Imm*/63,
     /* 187399 */   GIR_AddImm8, /*InsnID*//* 150(*/0x96, 0x01/*)*/, /*Imm*/1,
     /* 187403 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 150(*/0x96, 0x01/*)*/,
     /* 187406 */   GIR_MakeTempReg, /*TempRegID*//* 148(*/0x94, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187410 */   GIR_BuildMI, /*InsnID*//* 149(*/0x95, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 187415 */   GIR_AddTempRegister, /*InsnID*//* 149(*/0x95, 0x01/*)*/, /*TempRegID*//* 148(*/0x94, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187422 */   GIR_AddSimpleTempRegister, /*InsnID*//* 149(*/0x95, 0x01/*)*/, /*TempRegID*//* 149(*/0x95, 0x01/*)*/,
     /* 187427 */   GIR_AddSimpleTempRegister, /*InsnID*//* 149(*/0x95, 0x01/*)*/, /*TempRegID*//* 150(*/0x96, 0x01/*)*/,
     /* 187432 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 149(*/0x95, 0x01/*)*/,
     /* 187435 */   GIR_MakeTempReg, /*TempRegID*//* 147(*/0x93, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187439 */   GIR_BuildMI, /*InsnID*//* 148(*/0x94, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 187444 */   GIR_AddTempRegister, /*InsnID*//* 148(*/0x94, 0x01/*)*/, /*TempRegID*//* 147(*/0x93, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187451 */   GIR_AddSimpleTempRegister, /*InsnID*//* 148(*/0x94, 0x01/*)*/, /*TempRegID*//* 148(*/0x94, 0x01/*)*/,
     /* 187456 */   GIR_AddSimpleTempRegister, /*InsnID*//* 148(*/0x94, 0x01/*)*/, /*TempRegID*//* 157(*/0x9D, 0x01/*)*/,
     /* 187461 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 148(*/0x94, 0x01/*)*/,
     /* 187464 */   GIR_MakeTempReg, /*TempRegID*//* 146(*/0x92, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187468 */   GIR_BuildMI, /*InsnID*//* 147(*/0x93, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 187473 */   GIR_AddTempRegister, /*InsnID*//* 147(*/0x93, 0x01/*)*/, /*TempRegID*//* 146(*/0x92, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187480 */   GIR_AddSimpleTempRegister, /*InsnID*//* 147(*/0x93, 0x01/*)*/, /*TempRegID*//* 147(*/0x93, 0x01/*)*/,
     /* 187485 */   GIR_AddImm8, /*InsnID*//* 147(*/0x93, 0x01/*)*/, /*Imm*/62,
     /* 187489 */   GIR_AddImm8, /*InsnID*//* 147(*/0x93, 0x01/*)*/, /*Imm*/2,
     /* 187493 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 147(*/0x93, 0x01/*)*/,
     /* 187496 */   GIR_MakeTempReg, /*TempRegID*//* 145(*/0x91, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187500 */   GIR_BuildMI, /*InsnID*//* 146(*/0x92, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 187505 */   GIR_AddTempRegister, /*InsnID*//* 146(*/0x92, 0x01/*)*/, /*TempRegID*//* 145(*/0x91, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187512 */   GIR_AddSimpleTempRegister, /*InsnID*//* 146(*/0x92, 0x01/*)*/, /*TempRegID*//* 146(*/0x92, 0x01/*)*/,
     /* 187517 */   GIR_AddSimpleTempRegister, /*InsnID*//* 146(*/0x92, 0x01/*)*/, /*TempRegID*//* 166(*/0xA6, 0x01/*)*/,
     /* 187522 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 146(*/0x92, 0x01/*)*/,
     /* 187525 */   GIR_MakeTempReg, /*TempRegID*//* 144(*/0x90, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187529 */   GIR_BuildMI, /*InsnID*//* 145(*/0x91, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 187534 */   GIR_AddTempRegister, /*InsnID*//* 145(*/0x91, 0x01/*)*/, /*TempRegID*//* 144(*/0x90, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187541 */   GIR_AddSimpleTempRegister, /*InsnID*//* 145(*/0x91, 0x01/*)*/, /*TempRegID*//* 145(*/0x91, 0x01/*)*/,
     /* 187546 */   GIR_AddSimpleTempRegister, /*InsnID*//* 145(*/0x91, 0x01/*)*/, /*TempRegID*//* 173(*/0xAD, 0x01/*)*/,
     /* 187551 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 145(*/0x91, 0x01/*)*/,
     /* 187554 */   GIR_MakeTempReg, /*TempRegID*//* 143(*/0x8F, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187558 */   GIR_BuildMI, /*InsnID*//* 144(*/0x90, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 187563 */   GIR_AddTempRegister, /*InsnID*//* 144(*/0x90, 0x01/*)*/, /*TempRegID*//* 143(*/0x8F, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187570 */   GIR_AddSimpleTempRegister, /*InsnID*//* 144(*/0x90, 0x01/*)*/, /*TempRegID*//* 144(*/0x90, 0x01/*)*/,
     /* 187575 */   GIR_AddImm8, /*InsnID*//* 144(*/0x90, 0x01/*)*/, /*Imm*/60,
     /* 187579 */   GIR_AddImm8, /*InsnID*//* 144(*/0x90, 0x01/*)*/, /*Imm*/4,
     /* 187583 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 144(*/0x90, 0x01/*)*/,
     /* 187586 */   GIR_MakeTempReg, /*TempRegID*//* 142(*/0x8E, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187590 */   GIR_BuildMI, /*InsnID*//* 143(*/0x8F, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 187595 */   GIR_AddTempRegister, /*InsnID*//* 143(*/0x8F, 0x01/*)*/, /*TempRegID*//* 142(*/0x8E, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187602 */   GIR_AddSimpleTempRegister, /*InsnID*//* 143(*/0x8F, 0x01/*)*/, /*TempRegID*//* 143(*/0x8F, 0x01/*)*/,
     /* 187607 */   GIR_AddSimpleTempRegister, /*InsnID*//* 143(*/0x8F, 0x01/*)*/, /*TempRegID*//* 201(*/0xC9, 0x01/*)*/,
     /* 187612 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 143(*/0x8F, 0x01/*)*/,
     /* 187615 */   GIR_MakeTempReg, /*TempRegID*//* 141(*/0x8D, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187619 */   GIR_BuildMI, /*InsnID*//* 142(*/0x8E, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 187624 */   GIR_AddTempRegister, /*InsnID*//* 142(*/0x8E, 0x01/*)*/, /*TempRegID*//* 141(*/0x8D, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187631 */   GIR_AddSimpleTempRegister, /*InsnID*//* 142(*/0x8E, 0x01/*)*/, /*TempRegID*//* 142(*/0x8E, 0x01/*)*/,
     /* 187636 */   GIR_AddSimpleTempRegister, /*InsnID*//* 142(*/0x8E, 0x01/*)*/, /*TempRegID*//* 208(*/0xD0, 0x01/*)*/,
     /* 187641 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 142(*/0x8E, 0x01/*)*/,
     /* 187644 */   GIR_MakeTempReg, /*TempRegID*//* 407(*/0x97, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 187648 */   GIR_BuildMI, /*InsnID*//* 408(*/0x98, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 187653 */   GIR_AddTempRegister, /*InsnID*//* 408(*/0x98, 0x03/*)*/, /*TempRegID*//* 407(*/0x97, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187660 */   GIR_AddImm, /*InsnID*//* 408(*/0x98, 0x03/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 187671 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 408(*/0x98, 0x03/*)*/,
     /* 187674 */   GIR_MakeTempReg, /*TempRegID*//* 406(*/0x96, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 187678 */   GIR_BuildMI, /*InsnID*//* 407(*/0x97, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 187683 */   GIR_AddTempRegister, /*InsnID*//* 407(*/0x97, 0x03/*)*/, /*TempRegID*//* 406(*/0x96, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187690 */   GIR_AddSimpleTempRegister, /*InsnID*//* 407(*/0x97, 0x03/*)*/, /*TempRegID*//* 407(*/0x97, 0x03/*)*/,
     /* 187695 */   GIR_AddImm, /*InsnID*//* 407(*/0x97, 0x03/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 187706 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 407(*/0x97, 0x03/*)*/,
     /* 187709 */   GIR_MakeTempReg, /*TempRegID*//* 405(*/0x95, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 187713 */   GIR_BuildMI, /*InsnID*//* 406(*/0x96, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 187718 */   GIR_AddTempRegister, /*InsnID*//* 406(*/0x96, 0x03/*)*/, /*TempRegID*//* 405(*/0x95, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187725 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 406(*/0x96, 0x03/*)*/,
     /* 187728 */   GIR_MakeTempReg, /*TempRegID*//* 404(*/0x94, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 187732 */   GIR_BuildMI, /*InsnID*//* 405(*/0x95, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 187737 */   GIR_AddTempRegister, /*InsnID*//* 405(*/0x95, 0x03/*)*/, /*TempRegID*//* 404(*/0x94, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187744 */   GIR_AddSimpleTempRegister, /*InsnID*//* 405(*/0x95, 0x03/*)*/, /*TempRegID*//* 405(*/0x95, 0x03/*)*/,
     /* 187749 */   GIR_AddSimpleTempRegister, /*InsnID*//* 405(*/0x95, 0x03/*)*/, /*TempRegID*//* 406(*/0x96, 0x03/*)*/,
     /* 187754 */   GIR_AddImm8, /*InsnID*//* 405(*/0x95, 0x03/*)*/, /*Imm*/1,
     /* 187758 */   GIR_ConstrainOperandRC, /*InsnID*//* 405(*/0x95, 0x03/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 187764 */   GIR_ConstrainOperandRC, /*InsnID*//* 405(*/0x95, 0x03/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 187770 */   GIR_ConstrainOperandRC, /*InsnID*//* 405(*/0x95, 0x03/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 187776 */   GIR_MakeTempReg, /*TempRegID*//* 403(*/0x93, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 187780 */   GIR_BuildMI, /*InsnID*//* 404(*/0x94, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 187785 */   GIR_AddTempRegister, /*InsnID*//* 404(*/0x94, 0x03/*)*/, /*TempRegID*//* 403(*/0x93, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187792 */   GIR_AddSimpleTempRegister, /*InsnID*//* 404(*/0x94, 0x03/*)*/, /*TempRegID*//* 404(*/0x94, 0x03/*)*/,
     /* 187797 */   GIR_AddImm8, /*InsnID*//* 404(*/0x94, 0x03/*)*/, /*Imm*/32,
     /* 187801 */   GIR_AddImm8, /*InsnID*//* 404(*/0x94, 0x03/*)*/, /*Imm*/31,
     /* 187805 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 404(*/0x94, 0x03/*)*/,
     /* 187808 */   GIR_MakeTempReg, /*TempRegID*//* 402(*/0x92, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 187812 */   GIR_BuildMI, /*InsnID*//* 403(*/0x93, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 187817 */   GIR_AddTempRegister, /*InsnID*//* 403(*/0x93, 0x03/*)*/, /*TempRegID*//* 402(*/0x92, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187824 */   GIR_AddSimpleTempRegister, /*InsnID*//* 403(*/0x93, 0x03/*)*/, /*TempRegID*//* 403(*/0x93, 0x03/*)*/,
     /* 187829 */   GIR_AddImm, /*InsnID*//* 403(*/0x93, 0x03/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 187840 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 403(*/0x93, 0x03/*)*/,
     /* 187843 */   GIR_MakeTempReg, /*TempRegID*//* 401(*/0x91, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 187847 */   GIR_BuildMI, /*InsnID*//* 402(*/0x92, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 187852 */   GIR_AddTempRegister, /*InsnID*//* 402(*/0x92, 0x03/*)*/, /*TempRegID*//* 401(*/0x91, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187859 */   GIR_AddSimpleTempRegister, /*InsnID*//* 402(*/0x92, 0x03/*)*/, /*TempRegID*//* 402(*/0x92, 0x03/*)*/,
     /* 187864 */   GIR_AddImm, /*InsnID*//* 402(*/0x92, 0x03/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 187875 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 402(*/0x92, 0x03/*)*/,
     /* 187878 */   GIR_MakeTempReg, /*TempRegID*//* 400(*/0x90, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 187882 */   GIR_BuildMI, /*InsnID*//* 401(*/0x91, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 187887 */   GIR_AddTempRegister, /*InsnID*//* 401(*/0x91, 0x03/*)*/, /*TempRegID*//* 400(*/0x90, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187894 */   GIR_AddImm, /*InsnID*//* 401(*/0x91, 0x03/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 187905 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 401(*/0x91, 0x03/*)*/,
     /* 187908 */   GIR_MakeTempReg, /*TempRegID*//* 399(*/0x8F, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 187912 */   GIR_BuildMI, /*InsnID*//* 400(*/0x90, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 187917 */   GIR_AddTempRegister, /*InsnID*//* 400(*/0x90, 0x03/*)*/, /*TempRegID*//* 399(*/0x8F, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187924 */   GIR_AddSimpleTempRegister, /*InsnID*//* 400(*/0x90, 0x03/*)*/, /*TempRegID*//* 400(*/0x90, 0x03/*)*/,
     /* 187929 */   GIR_AddImm, /*InsnID*//* 400(*/0x90, 0x03/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 187940 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 400(*/0x90, 0x03/*)*/,
     /* 187943 */   GIR_MakeTempReg, /*TempRegID*//* 398(*/0x8E, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 187947 */   GIR_BuildMI, /*InsnID*//* 399(*/0x8F, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 187952 */   GIR_AddTempRegister, /*InsnID*//* 399(*/0x8F, 0x03/*)*/, /*TempRegID*//* 398(*/0x8E, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187959 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 399(*/0x8F, 0x03/*)*/,
     /* 187962 */   GIR_MakeTempReg, /*TempRegID*//* 397(*/0x8D, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 187966 */   GIR_BuildMI, /*InsnID*//* 398(*/0x8E, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 187971 */   GIR_AddTempRegister, /*InsnID*//* 398(*/0x8E, 0x03/*)*/, /*TempRegID*//* 397(*/0x8D, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187978 */   GIR_AddSimpleTempRegister, /*InsnID*//* 398(*/0x8E, 0x03/*)*/, /*TempRegID*//* 398(*/0x8E, 0x03/*)*/,
     /* 187983 */   GIR_AddSimpleTempRegister, /*InsnID*//* 398(*/0x8E, 0x03/*)*/, /*TempRegID*//* 399(*/0x8F, 0x03/*)*/,
     /* 187988 */   GIR_AddImm8, /*InsnID*//* 398(*/0x8E, 0x03/*)*/, /*Imm*/1,
     /* 187992 */   GIR_ConstrainOperandRC, /*InsnID*//* 398(*/0x8E, 0x03/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 187998 */   GIR_ConstrainOperandRC, /*InsnID*//* 398(*/0x8E, 0x03/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 188004 */   GIR_ConstrainOperandRC, /*InsnID*//* 398(*/0x8E, 0x03/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 188010 */   GIR_MakeTempReg, /*TempRegID*//* 396(*/0x8C, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 188014 */   GIR_BuildMI, /*InsnID*//* 397(*/0x8D, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 188019 */   GIR_AddTempRegister, /*InsnID*//* 397(*/0x8D, 0x03/*)*/, /*TempRegID*//* 396(*/0x8C, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188026 */   GIR_AddSimpleTempRegister, /*InsnID*//* 397(*/0x8D, 0x03/*)*/, /*TempRegID*//* 397(*/0x8D, 0x03/*)*/,
     /* 188031 */   GIR_AddImm8, /*InsnID*//* 397(*/0x8D, 0x03/*)*/, /*Imm*/32,
     /* 188035 */   GIR_AddImm8, /*InsnID*//* 397(*/0x8D, 0x03/*)*/, /*Imm*/31,
     /* 188039 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 397(*/0x8D, 0x03/*)*/,
     /* 188042 */   GIR_MakeTempReg, /*TempRegID*//* 395(*/0x8B, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 188046 */   GIR_BuildMI, /*InsnID*//* 396(*/0x8C, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 188051 */   GIR_AddTempRegister, /*InsnID*//* 396(*/0x8C, 0x03/*)*/, /*TempRegID*//* 395(*/0x8B, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188058 */   GIR_AddSimpleTempRegister, /*InsnID*//* 396(*/0x8C, 0x03/*)*/, /*TempRegID*//* 396(*/0x8C, 0x03/*)*/,
     /* 188063 */   GIR_AddImm, /*InsnID*//* 396(*/0x8C, 0x03/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 188074 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 396(*/0x8C, 0x03/*)*/,
     /* 188077 */   GIR_MakeTempReg, /*TempRegID*//* 394(*/0x8A, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 188081 */   GIR_BuildMI, /*InsnID*//* 395(*/0x8B, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 188086 */   GIR_AddTempRegister, /*InsnID*//* 395(*/0x8B, 0x03/*)*/, /*TempRegID*//* 394(*/0x8A, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188093 */   GIR_AddSimpleTempRegister, /*InsnID*//* 395(*/0x8B, 0x03/*)*/, /*TempRegID*//* 395(*/0x8B, 0x03/*)*/,
     /* 188098 */   GIR_AddImm, /*InsnID*//* 395(*/0x8B, 0x03/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 188109 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 395(*/0x8B, 0x03/*)*/,
     /* 188112 */   GIR_MakeTempReg, /*TempRegID*//* 393(*/0x89, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 188116 */   GIR_BuildMI, /*InsnID*//* 394(*/0x8A, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 188121 */   GIR_AddTempRegister, /*InsnID*//* 394(*/0x8A, 0x03/*)*/, /*TempRegID*//* 393(*/0x89, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188128 */   GIR_AddImm, /*InsnID*//* 394(*/0x8A, 0x03/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 188139 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 394(*/0x8A, 0x03/*)*/,
     /* 188142 */   GIR_MakeTempReg, /*TempRegID*//* 392(*/0x88, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 188146 */   GIR_BuildMI, /*InsnID*//* 393(*/0x89, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 188151 */   GIR_AddTempRegister, /*InsnID*//* 393(*/0x89, 0x03/*)*/, /*TempRegID*//* 392(*/0x88, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188158 */   GIR_AddSimpleTempRegister, /*InsnID*//* 393(*/0x89, 0x03/*)*/, /*TempRegID*//* 393(*/0x89, 0x03/*)*/,
     /* 188163 */   GIR_AddImm, /*InsnID*//* 393(*/0x89, 0x03/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 188174 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 393(*/0x89, 0x03/*)*/,
     /* 188177 */   GIR_MakeTempReg, /*TempRegID*//* 391(*/0x87, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 188181 */   GIR_BuildMI, /*InsnID*//* 392(*/0x88, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 188186 */   GIR_AddTempRegister, /*InsnID*//* 392(*/0x88, 0x03/*)*/, /*TempRegID*//* 391(*/0x87, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188193 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 392(*/0x88, 0x03/*)*/,
     /* 188196 */   GIR_MakeTempReg, /*TempRegID*//* 390(*/0x86, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 188200 */   GIR_BuildMI, /*InsnID*//* 391(*/0x87, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 188205 */   GIR_AddTempRegister, /*InsnID*//* 391(*/0x87, 0x03/*)*/, /*TempRegID*//* 390(*/0x86, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188212 */   GIR_AddSimpleTempRegister, /*InsnID*//* 391(*/0x87, 0x03/*)*/, /*TempRegID*//* 391(*/0x87, 0x03/*)*/,
     /* 188217 */   GIR_AddSimpleTempRegister, /*InsnID*//* 391(*/0x87, 0x03/*)*/, /*TempRegID*//* 392(*/0x88, 0x03/*)*/,
     /* 188222 */   GIR_AddImm8, /*InsnID*//* 391(*/0x87, 0x03/*)*/, /*Imm*/1,
     /* 188226 */   GIR_ConstrainOperandRC, /*InsnID*//* 391(*/0x87, 0x03/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 188232 */   GIR_ConstrainOperandRC, /*InsnID*//* 391(*/0x87, 0x03/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 188238 */   GIR_ConstrainOperandRC, /*InsnID*//* 391(*/0x87, 0x03/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 188244 */   GIR_MakeTempReg, /*TempRegID*//* 389(*/0x85, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 188248 */   GIR_BuildMI, /*InsnID*//* 390(*/0x86, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 188253 */   GIR_AddTempRegister, /*InsnID*//* 390(*/0x86, 0x03/*)*/, /*TempRegID*//* 389(*/0x85, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188260 */   GIR_AddSimpleTempRegister, /*InsnID*//* 390(*/0x86, 0x03/*)*/, /*TempRegID*//* 390(*/0x86, 0x03/*)*/,
     /* 188265 */   GIR_AddImm8, /*InsnID*//* 390(*/0x86, 0x03/*)*/, /*Imm*/32,
     /* 188269 */   GIR_AddImm8, /*InsnID*//* 390(*/0x86, 0x03/*)*/, /*Imm*/31,
     /* 188273 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 390(*/0x86, 0x03/*)*/,
     /* 188276 */   GIR_MakeTempReg, /*TempRegID*//* 388(*/0x84, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 188280 */   GIR_BuildMI, /*InsnID*//* 389(*/0x85, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 188285 */   GIR_AddTempRegister, /*InsnID*//* 389(*/0x85, 0x03/*)*/, /*TempRegID*//* 388(*/0x84, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188292 */   GIR_AddSimpleTempRegister, /*InsnID*//* 389(*/0x85, 0x03/*)*/, /*TempRegID*//* 389(*/0x85, 0x03/*)*/,
     /* 188297 */   GIR_AddImm, /*InsnID*//* 389(*/0x85, 0x03/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 188308 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 389(*/0x85, 0x03/*)*/,
     /* 188311 */   GIR_MakeTempReg, /*TempRegID*//* 387(*/0x83, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 188315 */   GIR_BuildMI, /*InsnID*//* 388(*/0x84, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 188320 */   GIR_AddTempRegister, /*InsnID*//* 388(*/0x84, 0x03/*)*/, /*TempRegID*//* 387(*/0x83, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188327 */   GIR_AddSimpleTempRegister, /*InsnID*//* 388(*/0x84, 0x03/*)*/, /*TempRegID*//* 388(*/0x84, 0x03/*)*/,
     /* 188332 */   GIR_AddImm, /*InsnID*//* 388(*/0x84, 0x03/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 188343 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 388(*/0x84, 0x03/*)*/,
     /* 188346 */   GIR_MakeTempReg, /*TempRegID*//* 386(*/0x82, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 188350 */   GIR_BuildMI, /*InsnID*//* 387(*/0x83, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 188355 */   GIR_AddTempRegister, /*InsnID*//* 387(*/0x83, 0x03/*)*/, /*TempRegID*//* 386(*/0x82, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188362 */   GIR_Copy, /*NewInsnID*//* 387(*/0x83, 0x03/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 188367 */   GIR_AddImm8, /*InsnID*//* 387(*/0x83, 0x03/*)*/, /*Imm*/1,
     /* 188371 */   GIR_AddImm8, /*InsnID*//* 387(*/0x83, 0x03/*)*/, /*Imm*/62,
     /* 188375 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 387(*/0x83, 0x03/*)*/,
     /* 188378 */   GIR_MakeTempReg, /*TempRegID*//* 385(*/0x81, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 188382 */   GIR_BuildMI, /*InsnID*//* 386(*/0x82, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 188387 */   GIR_AddTempRegister, /*InsnID*//* 386(*/0x82, 0x03/*)*/, /*TempRegID*//* 385(*/0x81, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188394 */   GIR_AddSimpleTempRegister, /*InsnID*//* 386(*/0x82, 0x03/*)*/, /*TempRegID*//* 386(*/0x82, 0x03/*)*/,
     /* 188399 */   GIR_AddSimpleTempRegister, /*InsnID*//* 386(*/0x82, 0x03/*)*/, /*TempRegID*//* 387(*/0x83, 0x03/*)*/,
     /* 188404 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 386(*/0x82, 0x03/*)*/,
     /* 188407 */   GIR_MakeTempReg, /*TempRegID*//* 384(*/0x80, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 188411 */   GIR_BuildMI, /*InsnID*//* 385(*/0x81, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 188416 */   GIR_AddTempRegister, /*InsnID*//* 385(*/0x81, 0x03/*)*/, /*TempRegID*//* 384(*/0x80, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188423 */   GIR_AddImm, /*InsnID*//* 385(*/0x81, 0x03/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 188434 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 385(*/0x81, 0x03/*)*/,
     /* 188437 */   GIR_MakeTempReg, /*TempRegID*//* 383(*/0xFF, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 188441 */   GIR_BuildMI, /*InsnID*//* 384(*/0x80, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 188446 */   GIR_AddTempRegister, /*InsnID*//* 384(*/0x80, 0x03/*)*/, /*TempRegID*//* 383(*/0xFF, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188453 */   GIR_AddSimpleTempRegister, /*InsnID*//* 384(*/0x80, 0x03/*)*/, /*TempRegID*//* 384(*/0x80, 0x03/*)*/,
     /* 188458 */   GIR_AddImm, /*InsnID*//* 384(*/0x80, 0x03/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 188469 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 384(*/0x80, 0x03/*)*/,
     /* 188472 */   GIR_MakeTempReg, /*TempRegID*//* 382(*/0xFE, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 188476 */   GIR_BuildMI, /*InsnID*//* 383(*/0xFF, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 188481 */   GIR_AddTempRegister, /*InsnID*//* 383(*/0xFF, 0x02/*)*/, /*TempRegID*//* 382(*/0xFE, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188488 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 383(*/0xFF, 0x02/*)*/,
     /* 188491 */   GIR_MakeTempReg, /*TempRegID*//* 381(*/0xFD, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 188495 */   GIR_BuildMI, /*InsnID*//* 382(*/0xFE, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 188500 */   GIR_AddTempRegister, /*InsnID*//* 382(*/0xFE, 0x02/*)*/, /*TempRegID*//* 381(*/0xFD, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188507 */   GIR_AddSimpleTempRegister, /*InsnID*//* 382(*/0xFE, 0x02/*)*/, /*TempRegID*//* 382(*/0xFE, 0x02/*)*/,
     /* 188512 */   GIR_AddSimpleTempRegister, /*InsnID*//* 382(*/0xFE, 0x02/*)*/, /*TempRegID*//* 383(*/0xFF, 0x02/*)*/,
     /* 188517 */   GIR_AddImm8, /*InsnID*//* 382(*/0xFE, 0x02/*)*/, /*Imm*/1,
     /* 188521 */   GIR_ConstrainOperandRC, /*InsnID*//* 382(*/0xFE, 0x02/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 188527 */   GIR_ConstrainOperandRC, /*InsnID*//* 382(*/0xFE, 0x02/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 188533 */   GIR_ConstrainOperandRC, /*InsnID*//* 382(*/0xFE, 0x02/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 188539 */   GIR_MakeTempReg, /*TempRegID*//* 380(*/0xFC, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 188543 */   GIR_BuildMI, /*InsnID*//* 381(*/0xFD, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 188548 */   GIR_AddTempRegister, /*InsnID*//* 381(*/0xFD, 0x02/*)*/, /*TempRegID*//* 380(*/0xFC, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188555 */   GIR_AddSimpleTempRegister, /*InsnID*//* 381(*/0xFD, 0x02/*)*/, /*TempRegID*//* 381(*/0xFD, 0x02/*)*/,
     /* 188560 */   GIR_AddImm8, /*InsnID*//* 381(*/0xFD, 0x02/*)*/, /*Imm*/32,
     /* 188564 */   GIR_AddImm8, /*InsnID*//* 381(*/0xFD, 0x02/*)*/, /*Imm*/31,
     /* 188568 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 381(*/0xFD, 0x02/*)*/,
     /* 188571 */   GIR_MakeTempReg, /*TempRegID*//* 379(*/0xFB, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 188575 */   GIR_BuildMI, /*InsnID*//* 380(*/0xFC, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 188580 */   GIR_AddTempRegister, /*InsnID*//* 380(*/0xFC, 0x02/*)*/, /*TempRegID*//* 379(*/0xFB, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188587 */   GIR_AddSimpleTempRegister, /*InsnID*//* 380(*/0xFC, 0x02/*)*/, /*TempRegID*//* 380(*/0xFC, 0x02/*)*/,
     /* 188592 */   GIR_AddImm, /*InsnID*//* 380(*/0xFC, 0x02/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 188603 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 380(*/0xFC, 0x02/*)*/,
     /* 188606 */   GIR_MakeTempReg, /*TempRegID*//* 378(*/0xFA, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 188610 */   GIR_BuildMI, /*InsnID*//* 379(*/0xFB, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 188615 */   GIR_AddTempRegister, /*InsnID*//* 379(*/0xFB, 0x02/*)*/, /*TempRegID*//* 378(*/0xFA, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188622 */   GIR_AddSimpleTempRegister, /*InsnID*//* 379(*/0xFB, 0x02/*)*/, /*TempRegID*//* 379(*/0xFB, 0x02/*)*/,
     /* 188627 */   GIR_AddImm, /*InsnID*//* 379(*/0xFB, 0x02/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 188638 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 379(*/0xFB, 0x02/*)*/,
     /* 188641 */   GIR_MakeTempReg, /*TempRegID*//* 377(*/0xF9, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 188645 */   GIR_BuildMI, /*InsnID*//* 378(*/0xFA, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 188650 */   GIR_AddTempRegister, /*InsnID*//* 378(*/0xFA, 0x02/*)*/, /*TempRegID*//* 377(*/0xF9, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188657 */   GIR_Copy, /*NewInsnID*//* 378(*/0xFA, 0x02/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 188662 */   GIR_AddImm8, /*InsnID*//* 378(*/0xFA, 0x02/*)*/, /*Imm*/63,
     /* 188666 */   GIR_AddImm8, /*InsnID*//* 378(*/0xFA, 0x02/*)*/, /*Imm*/1,
     /* 188670 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 378(*/0xFA, 0x02/*)*/,
     /* 188673 */   GIR_MakeTempReg, /*TempRegID*//* 376(*/0xF8, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 188677 */   GIR_BuildMI, /*InsnID*//* 377(*/0xF9, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 188682 */   GIR_AddTempRegister, /*InsnID*//* 377(*/0xF9, 0x02/*)*/, /*TempRegID*//* 376(*/0xF8, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188689 */   GIR_AddSimpleTempRegister, /*InsnID*//* 377(*/0xF9, 0x02/*)*/, /*TempRegID*//* 377(*/0xF9, 0x02/*)*/,
     /* 188694 */   GIR_AddSimpleTempRegister, /*InsnID*//* 377(*/0xF9, 0x02/*)*/, /*TempRegID*//* 378(*/0xFA, 0x02/*)*/,
     /* 188699 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 377(*/0xF9, 0x02/*)*/,
     /* 188702 */   GIR_MakeTempReg, /*TempRegID*//* 375(*/0xF7, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 188706 */   GIR_BuildMI, /*InsnID*//* 376(*/0xF8, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 188711 */   GIR_AddTempRegister, /*InsnID*//* 376(*/0xF8, 0x02/*)*/, /*TempRegID*//* 375(*/0xF7, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188718 */   GIR_AddSimpleTempRegister, /*InsnID*//* 376(*/0xF8, 0x02/*)*/, /*TempRegID*//* 376(*/0xF8, 0x02/*)*/,
     /* 188723 */   GIR_AddSimpleTempRegister, /*InsnID*//* 376(*/0xF8, 0x02/*)*/, /*TempRegID*//* 385(*/0x81, 0x03/*)*/,
     /* 188728 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 376(*/0xF8, 0x02/*)*/,
     /* 188731 */   GIR_MakeTempReg, /*TempRegID*//* 374(*/0xF6, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 188735 */   GIR_BuildMI, /*InsnID*//* 375(*/0xF7, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 188740 */   GIR_AddTempRegister, /*InsnID*//* 375(*/0xF7, 0x02/*)*/, /*TempRegID*//* 374(*/0xF6, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188747 */   GIR_AddSimpleTempRegister, /*InsnID*//* 375(*/0xF7, 0x02/*)*/, /*TempRegID*//* 375(*/0xF7, 0x02/*)*/,
     /* 188752 */   GIR_AddImm8, /*InsnID*//* 375(*/0xF7, 0x02/*)*/, /*Imm*/2,
     /* 188756 */   GIR_AddImm8, /*InsnID*//* 375(*/0xF7, 0x02/*)*/, /*Imm*/61,
     /* 188760 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 375(*/0xF7, 0x02/*)*/,
     /* 188763 */   GIR_MakeTempReg, /*TempRegID*//* 373(*/0xF5, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 188767 */   GIR_BuildMI, /*InsnID*//* 374(*/0xF6, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 188772 */   GIR_AddTempRegister, /*InsnID*//* 374(*/0xF6, 0x02/*)*/, /*TempRegID*//* 373(*/0xF5, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188779 */   GIR_AddSimpleTempRegister, /*InsnID*//* 374(*/0xF6, 0x02/*)*/, /*TempRegID*//* 374(*/0xF6, 0x02/*)*/,
     /* 188784 */   GIR_AddSimpleTempRegister, /*InsnID*//* 374(*/0xF6, 0x02/*)*/, /*TempRegID*//* 394(*/0x8A, 0x03/*)*/,
     /* 188789 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 374(*/0xF6, 0x02/*)*/,
     /* 188792 */   GIR_MakeTempReg, /*TempRegID*//* 372(*/0xF4, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 188796 */   GIR_BuildMI, /*InsnID*//* 373(*/0xF5, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 188801 */   GIR_AddTempRegister, /*InsnID*//* 373(*/0xF5, 0x02/*)*/, /*TempRegID*//* 372(*/0xF4, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188808 */   GIR_AddImm, /*InsnID*//* 373(*/0xF5, 0x02/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 188819 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 373(*/0xF5, 0x02/*)*/,
     /* 188822 */   GIR_MakeTempReg, /*TempRegID*//* 371(*/0xF3, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 188826 */   GIR_BuildMI, /*InsnID*//* 372(*/0xF4, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 188831 */   GIR_AddTempRegister, /*InsnID*//* 372(*/0xF4, 0x02/*)*/, /*TempRegID*//* 371(*/0xF3, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188838 */   GIR_AddSimpleTempRegister, /*InsnID*//* 372(*/0xF4, 0x02/*)*/, /*TempRegID*//* 372(*/0xF4, 0x02/*)*/,
     /* 188843 */   GIR_AddImm, /*InsnID*//* 372(*/0xF4, 0x02/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 188854 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 372(*/0xF4, 0x02/*)*/,
     /* 188857 */   GIR_MakeTempReg, /*TempRegID*//* 370(*/0xF2, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 188861 */   GIR_BuildMI, /*InsnID*//* 371(*/0xF3, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 188866 */   GIR_AddTempRegister, /*InsnID*//* 371(*/0xF3, 0x02/*)*/, /*TempRegID*//* 370(*/0xF2, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188873 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 371(*/0xF3, 0x02/*)*/,
     /* 188876 */   GIR_MakeTempReg, /*TempRegID*//* 369(*/0xF1, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 188880 */   GIR_BuildMI, /*InsnID*//* 370(*/0xF2, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 188885 */   GIR_AddTempRegister, /*InsnID*//* 370(*/0xF2, 0x02/*)*/, /*TempRegID*//* 369(*/0xF1, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188892 */   GIR_AddSimpleTempRegister, /*InsnID*//* 370(*/0xF2, 0x02/*)*/, /*TempRegID*//* 370(*/0xF2, 0x02/*)*/,
     /* 188897 */   GIR_AddSimpleTempRegister, /*InsnID*//* 370(*/0xF2, 0x02/*)*/, /*TempRegID*//* 371(*/0xF3, 0x02/*)*/,
     /* 188902 */   GIR_AddImm8, /*InsnID*//* 370(*/0xF2, 0x02/*)*/, /*Imm*/1,
     /* 188906 */   GIR_ConstrainOperandRC, /*InsnID*//* 370(*/0xF2, 0x02/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 188912 */   GIR_ConstrainOperandRC, /*InsnID*//* 370(*/0xF2, 0x02/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 188918 */   GIR_ConstrainOperandRC, /*InsnID*//* 370(*/0xF2, 0x02/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 188924 */   GIR_MakeTempReg, /*TempRegID*//* 368(*/0xF0, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 188928 */   GIR_BuildMI, /*InsnID*//* 369(*/0xF1, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 188933 */   GIR_AddTempRegister, /*InsnID*//* 369(*/0xF1, 0x02/*)*/, /*TempRegID*//* 368(*/0xF0, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188940 */   GIR_AddSimpleTempRegister, /*InsnID*//* 369(*/0xF1, 0x02/*)*/, /*TempRegID*//* 369(*/0xF1, 0x02/*)*/,
     /* 188945 */   GIR_AddImm8, /*InsnID*//* 369(*/0xF1, 0x02/*)*/, /*Imm*/32,
     /* 188949 */   GIR_AddImm8, /*InsnID*//* 369(*/0xF1, 0x02/*)*/, /*Imm*/31,
     /* 188953 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 369(*/0xF1, 0x02/*)*/,
     /* 188956 */   GIR_MakeTempReg, /*TempRegID*//* 367(*/0xEF, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 188960 */   GIR_BuildMI, /*InsnID*//* 368(*/0xF0, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 188965 */   GIR_AddTempRegister, /*InsnID*//* 368(*/0xF0, 0x02/*)*/, /*TempRegID*//* 367(*/0xEF, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188972 */   GIR_AddSimpleTempRegister, /*InsnID*//* 368(*/0xF0, 0x02/*)*/, /*TempRegID*//* 368(*/0xF0, 0x02/*)*/,
     /* 188977 */   GIR_AddImm, /*InsnID*//* 368(*/0xF0, 0x02/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 188988 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 368(*/0xF0, 0x02/*)*/,
     /* 188991 */   GIR_MakeTempReg, /*TempRegID*//* 366(*/0xEE, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 188995 */   GIR_BuildMI, /*InsnID*//* 367(*/0xEF, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 189000 */   GIR_AddTempRegister, /*InsnID*//* 367(*/0xEF, 0x02/*)*/, /*TempRegID*//* 366(*/0xEE, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189007 */   GIR_AddSimpleTempRegister, /*InsnID*//* 367(*/0xEF, 0x02/*)*/, /*TempRegID*//* 367(*/0xEF, 0x02/*)*/,
     /* 189012 */   GIR_AddImm, /*InsnID*//* 367(*/0xEF, 0x02/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 189023 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 367(*/0xEF, 0x02/*)*/,
     /* 189026 */   GIR_MakeTempReg, /*TempRegID*//* 365(*/0xED, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 189030 */   GIR_BuildMI, /*InsnID*//* 366(*/0xEE, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 189035 */   GIR_AddTempRegister, /*InsnID*//* 366(*/0xEE, 0x02/*)*/, /*TempRegID*//* 365(*/0xED, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189042 */   GIR_AddImm, /*InsnID*//* 366(*/0xEE, 0x02/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 189053 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 366(*/0xEE, 0x02/*)*/,
     /* 189056 */   GIR_MakeTempReg, /*TempRegID*//* 364(*/0xEC, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 189060 */   GIR_BuildMI, /*InsnID*//* 365(*/0xED, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 189065 */   GIR_AddTempRegister, /*InsnID*//* 365(*/0xED, 0x02/*)*/, /*TempRegID*//* 364(*/0xEC, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189072 */   GIR_AddSimpleTempRegister, /*InsnID*//* 365(*/0xED, 0x02/*)*/, /*TempRegID*//* 365(*/0xED, 0x02/*)*/,
     /* 189077 */   GIR_AddImm, /*InsnID*//* 365(*/0xED, 0x02/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 189088 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 365(*/0xED, 0x02/*)*/,
     /* 189091 */   GIR_MakeTempReg, /*TempRegID*//* 363(*/0xEB, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 189095 */   GIR_BuildMI, /*InsnID*//* 364(*/0xEC, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 189100 */   GIR_AddTempRegister, /*InsnID*//* 364(*/0xEC, 0x02/*)*/, /*TempRegID*//* 363(*/0xEB, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189107 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 364(*/0xEC, 0x02/*)*/,
     /* 189110 */   GIR_MakeTempReg, /*TempRegID*//* 362(*/0xEA, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 189114 */   GIR_BuildMI, /*InsnID*//* 363(*/0xEB, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 189119 */   GIR_AddTempRegister, /*InsnID*//* 363(*/0xEB, 0x02/*)*/, /*TempRegID*//* 362(*/0xEA, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189126 */   GIR_AddSimpleTempRegister, /*InsnID*//* 363(*/0xEB, 0x02/*)*/, /*TempRegID*//* 363(*/0xEB, 0x02/*)*/,
     /* 189131 */   GIR_AddSimpleTempRegister, /*InsnID*//* 363(*/0xEB, 0x02/*)*/, /*TempRegID*//* 364(*/0xEC, 0x02/*)*/,
     /* 189136 */   GIR_AddImm8, /*InsnID*//* 363(*/0xEB, 0x02/*)*/, /*Imm*/1,
     /* 189140 */   GIR_ConstrainOperandRC, /*InsnID*//* 363(*/0xEB, 0x02/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 189146 */   GIR_ConstrainOperandRC, /*InsnID*//* 363(*/0xEB, 0x02/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 189152 */   GIR_ConstrainOperandRC, /*InsnID*//* 363(*/0xEB, 0x02/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 189158 */   GIR_MakeTempReg, /*TempRegID*//* 361(*/0xE9, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 189162 */   GIR_BuildMI, /*InsnID*//* 362(*/0xEA, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 189167 */   GIR_AddTempRegister, /*InsnID*//* 362(*/0xEA, 0x02/*)*/, /*TempRegID*//* 361(*/0xE9, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189174 */   GIR_AddSimpleTempRegister, /*InsnID*//* 362(*/0xEA, 0x02/*)*/, /*TempRegID*//* 362(*/0xEA, 0x02/*)*/,
     /* 189179 */   GIR_AddImm8, /*InsnID*//* 362(*/0xEA, 0x02/*)*/, /*Imm*/32,
     /* 189183 */   GIR_AddImm8, /*InsnID*//* 362(*/0xEA, 0x02/*)*/, /*Imm*/31,
     /* 189187 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 362(*/0xEA, 0x02/*)*/,
     /* 189190 */   GIR_MakeTempReg, /*TempRegID*//* 360(*/0xE8, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 189194 */   GIR_BuildMI, /*InsnID*//* 361(*/0xE9, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 189199 */   GIR_AddTempRegister, /*InsnID*//* 361(*/0xE9, 0x02/*)*/, /*TempRegID*//* 360(*/0xE8, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189206 */   GIR_AddSimpleTempRegister, /*InsnID*//* 361(*/0xE9, 0x02/*)*/, /*TempRegID*//* 361(*/0xE9, 0x02/*)*/,
     /* 189211 */   GIR_AddImm, /*InsnID*//* 361(*/0xE9, 0x02/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 189222 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 361(*/0xE9, 0x02/*)*/,
     /* 189225 */   GIR_MakeTempReg, /*TempRegID*//* 359(*/0xE7, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 189229 */   GIR_BuildMI, /*InsnID*//* 360(*/0xE8, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 189234 */   GIR_AddTempRegister, /*InsnID*//* 360(*/0xE8, 0x02/*)*/, /*TempRegID*//* 359(*/0xE7, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189241 */   GIR_AddSimpleTempRegister, /*InsnID*//* 360(*/0xE8, 0x02/*)*/, /*TempRegID*//* 360(*/0xE8, 0x02/*)*/,
     /* 189246 */   GIR_AddImm, /*InsnID*//* 360(*/0xE8, 0x02/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 189257 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 360(*/0xE8, 0x02/*)*/,
     /* 189260 */   GIR_MakeTempReg, /*TempRegID*//* 358(*/0xE6, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 189264 */   GIR_BuildMI, /*InsnID*//* 359(*/0xE7, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 189269 */   GIR_AddTempRegister, /*InsnID*//* 359(*/0xE7, 0x02/*)*/, /*TempRegID*//* 358(*/0xE6, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189276 */   GIR_Copy, /*NewInsnID*//* 359(*/0xE7, 0x02/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 189281 */   GIR_AddImm8, /*InsnID*//* 359(*/0xE7, 0x02/*)*/, /*Imm*/1,
     /* 189285 */   GIR_AddImm8, /*InsnID*//* 359(*/0xE7, 0x02/*)*/, /*Imm*/62,
     /* 189289 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 359(*/0xE7, 0x02/*)*/,
     /* 189292 */   GIR_MakeTempReg, /*TempRegID*//* 357(*/0xE5, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 189296 */   GIR_BuildMI, /*InsnID*//* 358(*/0xE6, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 189301 */   GIR_AddTempRegister, /*InsnID*//* 358(*/0xE6, 0x02/*)*/, /*TempRegID*//* 357(*/0xE5, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189308 */   GIR_AddSimpleTempRegister, /*InsnID*//* 358(*/0xE6, 0x02/*)*/, /*TempRegID*//* 358(*/0xE6, 0x02/*)*/,
     /* 189313 */   GIR_AddSimpleTempRegister, /*InsnID*//* 358(*/0xE6, 0x02/*)*/, /*TempRegID*//* 359(*/0xE7, 0x02/*)*/,
     /* 189318 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 358(*/0xE6, 0x02/*)*/,
     /* 189321 */   GIR_MakeTempReg, /*TempRegID*//* 356(*/0xE4, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 189325 */   GIR_BuildMI, /*InsnID*//* 357(*/0xE5, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 189330 */   GIR_AddTempRegister, /*InsnID*//* 357(*/0xE5, 0x02/*)*/, /*TempRegID*//* 356(*/0xE4, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189337 */   GIR_AddImm, /*InsnID*//* 357(*/0xE5, 0x02/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 189348 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 357(*/0xE5, 0x02/*)*/,
     /* 189351 */   GIR_MakeTempReg, /*TempRegID*//* 355(*/0xE3, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 189355 */   GIR_BuildMI, /*InsnID*//* 356(*/0xE4, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 189360 */   GIR_AddTempRegister, /*InsnID*//* 356(*/0xE4, 0x02/*)*/, /*TempRegID*//* 355(*/0xE3, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189367 */   GIR_AddSimpleTempRegister, /*InsnID*//* 356(*/0xE4, 0x02/*)*/, /*TempRegID*//* 356(*/0xE4, 0x02/*)*/,
     /* 189372 */   GIR_AddImm, /*InsnID*//* 356(*/0xE4, 0x02/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 189383 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 356(*/0xE4, 0x02/*)*/,
     /* 189386 */   GIR_MakeTempReg, /*TempRegID*//* 354(*/0xE2, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 189390 */   GIR_BuildMI, /*InsnID*//* 355(*/0xE3, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 189395 */   GIR_AddTempRegister, /*InsnID*//* 355(*/0xE3, 0x02/*)*/, /*TempRegID*//* 354(*/0xE2, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189402 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 355(*/0xE3, 0x02/*)*/,
     /* 189405 */   GIR_MakeTempReg, /*TempRegID*//* 353(*/0xE1, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 189409 */   GIR_BuildMI, /*InsnID*//* 354(*/0xE2, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 189414 */   GIR_AddTempRegister, /*InsnID*//* 354(*/0xE2, 0x02/*)*/, /*TempRegID*//* 353(*/0xE1, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189421 */   GIR_AddSimpleTempRegister, /*InsnID*//* 354(*/0xE2, 0x02/*)*/, /*TempRegID*//* 354(*/0xE2, 0x02/*)*/,
     /* 189426 */   GIR_AddSimpleTempRegister, /*InsnID*//* 354(*/0xE2, 0x02/*)*/, /*TempRegID*//* 355(*/0xE3, 0x02/*)*/,
     /* 189431 */   GIR_AddImm8, /*InsnID*//* 354(*/0xE2, 0x02/*)*/, /*Imm*/1,
     /* 189435 */   GIR_ConstrainOperandRC, /*InsnID*//* 354(*/0xE2, 0x02/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 189441 */   GIR_ConstrainOperandRC, /*InsnID*//* 354(*/0xE2, 0x02/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 189447 */   GIR_ConstrainOperandRC, /*InsnID*//* 354(*/0xE2, 0x02/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 189453 */   GIR_MakeTempReg, /*TempRegID*//* 352(*/0xE0, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 189457 */   GIR_BuildMI, /*InsnID*//* 353(*/0xE1, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 189462 */   GIR_AddTempRegister, /*InsnID*//* 353(*/0xE1, 0x02/*)*/, /*TempRegID*//* 352(*/0xE0, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189469 */   GIR_AddSimpleTempRegister, /*InsnID*//* 353(*/0xE1, 0x02/*)*/, /*TempRegID*//* 353(*/0xE1, 0x02/*)*/,
     /* 189474 */   GIR_AddImm8, /*InsnID*//* 353(*/0xE1, 0x02/*)*/, /*Imm*/32,
     /* 189478 */   GIR_AddImm8, /*InsnID*//* 353(*/0xE1, 0x02/*)*/, /*Imm*/31,
     /* 189482 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 353(*/0xE1, 0x02/*)*/,
     /* 189485 */   GIR_MakeTempReg, /*TempRegID*//* 351(*/0xDF, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 189489 */   GIR_BuildMI, /*InsnID*//* 352(*/0xE0, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 189494 */   GIR_AddTempRegister, /*InsnID*//* 352(*/0xE0, 0x02/*)*/, /*TempRegID*//* 351(*/0xDF, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189501 */   GIR_AddSimpleTempRegister, /*InsnID*//* 352(*/0xE0, 0x02/*)*/, /*TempRegID*//* 352(*/0xE0, 0x02/*)*/,
     /* 189506 */   GIR_AddImm, /*InsnID*//* 352(*/0xE0, 0x02/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 189517 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 352(*/0xE0, 0x02/*)*/,
     /* 189520 */   GIR_MakeTempReg, /*TempRegID*//* 350(*/0xDE, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 189524 */   GIR_BuildMI, /*InsnID*//* 351(*/0xDF, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 189529 */   GIR_AddTempRegister, /*InsnID*//* 351(*/0xDF, 0x02/*)*/, /*TempRegID*//* 350(*/0xDE, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189536 */   GIR_AddSimpleTempRegister, /*InsnID*//* 351(*/0xDF, 0x02/*)*/, /*TempRegID*//* 351(*/0xDF, 0x02/*)*/,
     /* 189541 */   GIR_AddImm, /*InsnID*//* 351(*/0xDF, 0x02/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 189552 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 351(*/0xDF, 0x02/*)*/,
     /* 189555 */   GIR_MakeTempReg, /*TempRegID*//* 349(*/0xDD, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 189559 */   GIR_BuildMI, /*InsnID*//* 350(*/0xDE, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 189564 */   GIR_AddTempRegister, /*InsnID*//* 350(*/0xDE, 0x02/*)*/, /*TempRegID*//* 349(*/0xDD, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189571 */   GIR_Copy, /*NewInsnID*//* 350(*/0xDE, 0x02/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 189576 */   GIR_AddImm8, /*InsnID*//* 350(*/0xDE, 0x02/*)*/, /*Imm*/63,
     /* 189580 */   GIR_AddImm8, /*InsnID*//* 350(*/0xDE, 0x02/*)*/, /*Imm*/1,
     /* 189584 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 350(*/0xDE, 0x02/*)*/,
     /* 189587 */   GIR_MakeTempReg, /*TempRegID*//* 348(*/0xDC, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 189591 */   GIR_BuildMI, /*InsnID*//* 349(*/0xDD, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 189596 */   GIR_AddTempRegister, /*InsnID*//* 349(*/0xDD, 0x02/*)*/, /*TempRegID*//* 348(*/0xDC, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189603 */   GIR_AddSimpleTempRegister, /*InsnID*//* 349(*/0xDD, 0x02/*)*/, /*TempRegID*//* 349(*/0xDD, 0x02/*)*/,
     /* 189608 */   GIR_AddSimpleTempRegister, /*InsnID*//* 349(*/0xDD, 0x02/*)*/, /*TempRegID*//* 350(*/0xDE, 0x02/*)*/,
     /* 189613 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 349(*/0xDD, 0x02/*)*/,
     /* 189616 */   GIR_MakeTempReg, /*TempRegID*//* 347(*/0xDB, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 189620 */   GIR_BuildMI, /*InsnID*//* 348(*/0xDC, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 189625 */   GIR_AddTempRegister, /*InsnID*//* 348(*/0xDC, 0x02/*)*/, /*TempRegID*//* 347(*/0xDB, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189632 */   GIR_AddSimpleTempRegister, /*InsnID*//* 348(*/0xDC, 0x02/*)*/, /*TempRegID*//* 348(*/0xDC, 0x02/*)*/,
     /* 189637 */   GIR_AddSimpleTempRegister, /*InsnID*//* 348(*/0xDC, 0x02/*)*/, /*TempRegID*//* 357(*/0xE5, 0x02/*)*/,
     /* 189642 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 348(*/0xDC, 0x02/*)*/,
     /* 189645 */   GIR_MakeTempReg, /*TempRegID*//* 346(*/0xDA, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 189649 */   GIR_BuildMI, /*InsnID*//* 347(*/0xDB, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 189654 */   GIR_AddTempRegister, /*InsnID*//* 347(*/0xDB, 0x02/*)*/, /*TempRegID*//* 346(*/0xDA, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189661 */   GIR_AddSimpleTempRegister, /*InsnID*//* 347(*/0xDB, 0x02/*)*/, /*TempRegID*//* 347(*/0xDB, 0x02/*)*/,
     /* 189666 */   GIR_AddImm8, /*InsnID*//* 347(*/0xDB, 0x02/*)*/, /*Imm*/62,
     /* 189670 */   GIR_AddImm8, /*InsnID*//* 347(*/0xDB, 0x02/*)*/, /*Imm*/2,
     /* 189674 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 347(*/0xDB, 0x02/*)*/,
     /* 189677 */   GIR_MakeTempReg, /*TempRegID*//* 345(*/0xD9, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 189681 */   GIR_BuildMI, /*InsnID*//* 346(*/0xDA, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 189686 */   GIR_AddTempRegister, /*InsnID*//* 346(*/0xDA, 0x02/*)*/, /*TempRegID*//* 345(*/0xD9, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189693 */   GIR_AddSimpleTempRegister, /*InsnID*//* 346(*/0xDA, 0x02/*)*/, /*TempRegID*//* 346(*/0xDA, 0x02/*)*/,
     /* 189698 */   GIR_AddSimpleTempRegister, /*InsnID*//* 346(*/0xDA, 0x02/*)*/, /*TempRegID*//* 366(*/0xEE, 0x02/*)*/,
     /* 189703 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 346(*/0xDA, 0x02/*)*/,
     /* 189706 */   GIR_MakeTempReg, /*TempRegID*//* 344(*/0xD8, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 189710 */   GIR_BuildMI, /*InsnID*//* 345(*/0xD9, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 189715 */   GIR_AddTempRegister, /*InsnID*//* 345(*/0xD9, 0x02/*)*/, /*TempRegID*//* 344(*/0xD8, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189722 */   GIR_AddSimpleTempRegister, /*InsnID*//* 345(*/0xD9, 0x02/*)*/, /*TempRegID*//* 345(*/0xD9, 0x02/*)*/,
     /* 189727 */   GIR_AddSimpleTempRegister, /*InsnID*//* 345(*/0xD9, 0x02/*)*/, /*TempRegID*//* 373(*/0xF5, 0x02/*)*/,
     /* 189732 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 345(*/0xD9, 0x02/*)*/,
     /* 189735 */   GIR_MakeTempReg, /*TempRegID*//* 343(*/0xD7, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 189739 */   GIR_BuildMI, /*InsnID*//* 344(*/0xD8, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 189744 */   GIR_AddTempRegister, /*InsnID*//* 344(*/0xD8, 0x02/*)*/, /*TempRegID*//* 343(*/0xD7, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189751 */   GIR_AddSimpleTempRegister, /*InsnID*//* 344(*/0xD8, 0x02/*)*/, /*TempRegID*//* 344(*/0xD8, 0x02/*)*/,
     /* 189756 */   GIR_AddImm8, /*InsnID*//* 344(*/0xD8, 0x02/*)*/, /*Imm*/4,
     /* 189760 */   GIR_AddImm8, /*InsnID*//* 344(*/0xD8, 0x02/*)*/, /*Imm*/59,
     /* 189764 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 344(*/0xD8, 0x02/*)*/,
     /* 189767 */   GIR_MakeTempReg, /*TempRegID*//* 342(*/0xD6, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 189771 */   GIR_BuildMI, /*InsnID*//* 343(*/0xD7, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 189776 */   GIR_AddTempRegister, /*InsnID*//* 343(*/0xD7, 0x02/*)*/, /*TempRegID*//* 342(*/0xD6, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189783 */   GIR_AddSimpleTempRegister, /*InsnID*//* 343(*/0xD7, 0x02/*)*/, /*TempRegID*//* 343(*/0xD7, 0x02/*)*/,
     /* 189788 */   GIR_AddSimpleTempRegister, /*InsnID*//* 343(*/0xD7, 0x02/*)*/, /*TempRegID*//* 401(*/0x91, 0x03/*)*/,
     /* 189793 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 343(*/0xD7, 0x02/*)*/,
     /* 189796 */   GIR_MakeTempReg, /*TempRegID*//* 341(*/0xD5, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 189800 */   GIR_BuildMI, /*InsnID*//* 342(*/0xD6, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 189805 */   GIR_AddTempRegister, /*InsnID*//* 342(*/0xD6, 0x02/*)*/, /*TempRegID*//* 341(*/0xD5, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189812 */   GIR_AddImm, /*InsnID*//* 342(*/0xD6, 0x02/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 189823 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 342(*/0xD6, 0x02/*)*/,
     /* 189826 */   GIR_MakeTempReg, /*TempRegID*//* 340(*/0xD4, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 189830 */   GIR_BuildMI, /*InsnID*//* 341(*/0xD5, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 189835 */   GIR_AddTempRegister, /*InsnID*//* 341(*/0xD5, 0x02/*)*/, /*TempRegID*//* 340(*/0xD4, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189842 */   GIR_AddSimpleTempRegister, /*InsnID*//* 341(*/0xD5, 0x02/*)*/, /*TempRegID*//* 341(*/0xD5, 0x02/*)*/,
     /* 189847 */   GIR_AddImm, /*InsnID*//* 341(*/0xD5, 0x02/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 189858 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 341(*/0xD5, 0x02/*)*/,
     /* 189861 */   GIR_MakeTempReg, /*TempRegID*//* 339(*/0xD3, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 189865 */   GIR_BuildMI, /*InsnID*//* 340(*/0xD4, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 189870 */   GIR_AddTempRegister, /*InsnID*//* 340(*/0xD4, 0x02/*)*/, /*TempRegID*//* 339(*/0xD3, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189877 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 340(*/0xD4, 0x02/*)*/,
     /* 189880 */   GIR_MakeTempReg, /*TempRegID*//* 338(*/0xD2, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 189884 */   GIR_BuildMI, /*InsnID*//* 339(*/0xD3, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 189889 */   GIR_AddTempRegister, /*InsnID*//* 339(*/0xD3, 0x02/*)*/, /*TempRegID*//* 338(*/0xD2, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189896 */   GIR_AddSimpleTempRegister, /*InsnID*//* 339(*/0xD3, 0x02/*)*/, /*TempRegID*//* 339(*/0xD3, 0x02/*)*/,
     /* 189901 */   GIR_AddSimpleTempRegister, /*InsnID*//* 339(*/0xD3, 0x02/*)*/, /*TempRegID*//* 340(*/0xD4, 0x02/*)*/,
     /* 189906 */   GIR_AddImm8, /*InsnID*//* 339(*/0xD3, 0x02/*)*/, /*Imm*/1,
     /* 189910 */   GIR_ConstrainOperandRC, /*InsnID*//* 339(*/0xD3, 0x02/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 189916 */   GIR_ConstrainOperandRC, /*InsnID*//* 339(*/0xD3, 0x02/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 189922 */   GIR_ConstrainOperandRC, /*InsnID*//* 339(*/0xD3, 0x02/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 189928 */   GIR_MakeTempReg, /*TempRegID*//* 337(*/0xD1, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 189932 */   GIR_BuildMI, /*InsnID*//* 338(*/0xD2, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 189937 */   GIR_AddTempRegister, /*InsnID*//* 338(*/0xD2, 0x02/*)*/, /*TempRegID*//* 337(*/0xD1, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189944 */   GIR_AddSimpleTempRegister, /*InsnID*//* 338(*/0xD2, 0x02/*)*/, /*TempRegID*//* 338(*/0xD2, 0x02/*)*/,
     /* 189949 */   GIR_AddImm8, /*InsnID*//* 338(*/0xD2, 0x02/*)*/, /*Imm*/32,
     /* 189953 */   GIR_AddImm8, /*InsnID*//* 338(*/0xD2, 0x02/*)*/, /*Imm*/31,
     /* 189957 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 338(*/0xD2, 0x02/*)*/,
     /* 189960 */   GIR_MakeTempReg, /*TempRegID*//* 336(*/0xD0, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 189964 */   GIR_BuildMI, /*InsnID*//* 337(*/0xD1, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 189969 */   GIR_AddTempRegister, /*InsnID*//* 337(*/0xD1, 0x02/*)*/, /*TempRegID*//* 336(*/0xD0, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189976 */   GIR_AddSimpleTempRegister, /*InsnID*//* 337(*/0xD1, 0x02/*)*/, /*TempRegID*//* 337(*/0xD1, 0x02/*)*/,
     /* 189981 */   GIR_AddImm, /*InsnID*//* 337(*/0xD1, 0x02/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 189992 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 337(*/0xD1, 0x02/*)*/,
     /* 189995 */   GIR_MakeTempReg, /*TempRegID*//* 335(*/0xCF, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 189999 */   GIR_BuildMI, /*InsnID*//* 336(*/0xD0, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 190004 */   GIR_AddTempRegister, /*InsnID*//* 336(*/0xD0, 0x02/*)*/, /*TempRegID*//* 335(*/0xCF, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190011 */   GIR_AddSimpleTempRegister, /*InsnID*//* 336(*/0xD0, 0x02/*)*/, /*TempRegID*//* 336(*/0xD0, 0x02/*)*/,
     /* 190016 */   GIR_AddImm, /*InsnID*//* 336(*/0xD0, 0x02/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 190027 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 336(*/0xD0, 0x02/*)*/,
     /* 190030 */   GIR_MakeTempReg, /*TempRegID*//* 334(*/0xCE, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 190034 */   GIR_BuildMI, /*InsnID*//* 335(*/0xCF, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 190039 */   GIR_AddTempRegister, /*InsnID*//* 335(*/0xCF, 0x02/*)*/, /*TempRegID*//* 334(*/0xCE, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190046 */   GIR_AddImm, /*InsnID*//* 335(*/0xCF, 0x02/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 190057 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 335(*/0xCF, 0x02/*)*/,
     /* 190060 */   GIR_MakeTempReg, /*TempRegID*//* 333(*/0xCD, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 190064 */   GIR_BuildMI, /*InsnID*//* 334(*/0xCE, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 190069 */   GIR_AddTempRegister, /*InsnID*//* 334(*/0xCE, 0x02/*)*/, /*TempRegID*//* 333(*/0xCD, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190076 */   GIR_AddSimpleTempRegister, /*InsnID*//* 334(*/0xCE, 0x02/*)*/, /*TempRegID*//* 334(*/0xCE, 0x02/*)*/,
     /* 190081 */   GIR_AddImm, /*InsnID*//* 334(*/0xCE, 0x02/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 190092 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 334(*/0xCE, 0x02/*)*/,
     /* 190095 */   GIR_MakeTempReg, /*TempRegID*//* 332(*/0xCC, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 190099 */   GIR_BuildMI, /*InsnID*//* 333(*/0xCD, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 190104 */   GIR_AddTempRegister, /*InsnID*//* 333(*/0xCD, 0x02/*)*/, /*TempRegID*//* 332(*/0xCC, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190111 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 333(*/0xCD, 0x02/*)*/,
     /* 190114 */   GIR_MakeTempReg, /*TempRegID*//* 331(*/0xCB, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 190118 */   GIR_BuildMI, /*InsnID*//* 332(*/0xCC, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 190123 */   GIR_AddTempRegister, /*InsnID*//* 332(*/0xCC, 0x02/*)*/, /*TempRegID*//* 331(*/0xCB, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190130 */   GIR_AddSimpleTempRegister, /*InsnID*//* 332(*/0xCC, 0x02/*)*/, /*TempRegID*//* 332(*/0xCC, 0x02/*)*/,
     /* 190135 */   GIR_AddSimpleTempRegister, /*InsnID*//* 332(*/0xCC, 0x02/*)*/, /*TempRegID*//* 333(*/0xCD, 0x02/*)*/,
     /* 190140 */   GIR_AddImm8, /*InsnID*//* 332(*/0xCC, 0x02/*)*/, /*Imm*/1,
     /* 190144 */   GIR_ConstrainOperandRC, /*InsnID*//* 332(*/0xCC, 0x02/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 190150 */   GIR_ConstrainOperandRC, /*InsnID*//* 332(*/0xCC, 0x02/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 190156 */   GIR_ConstrainOperandRC, /*InsnID*//* 332(*/0xCC, 0x02/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 190162 */   GIR_MakeTempReg, /*TempRegID*//* 330(*/0xCA, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 190166 */   GIR_BuildMI, /*InsnID*//* 331(*/0xCB, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 190171 */   GIR_AddTempRegister, /*InsnID*//* 331(*/0xCB, 0x02/*)*/, /*TempRegID*//* 330(*/0xCA, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190178 */   GIR_AddSimpleTempRegister, /*InsnID*//* 331(*/0xCB, 0x02/*)*/, /*TempRegID*//* 331(*/0xCB, 0x02/*)*/,
     /* 190183 */   GIR_AddImm8, /*InsnID*//* 331(*/0xCB, 0x02/*)*/, /*Imm*/32,
     /* 190187 */   GIR_AddImm8, /*InsnID*//* 331(*/0xCB, 0x02/*)*/, /*Imm*/31,
     /* 190191 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 331(*/0xCB, 0x02/*)*/,
     /* 190194 */   GIR_MakeTempReg, /*TempRegID*//* 329(*/0xC9, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 190198 */   GIR_BuildMI, /*InsnID*//* 330(*/0xCA, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 190203 */   GIR_AddTempRegister, /*InsnID*//* 330(*/0xCA, 0x02/*)*/, /*TempRegID*//* 329(*/0xC9, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190210 */   GIR_AddSimpleTempRegister, /*InsnID*//* 330(*/0xCA, 0x02/*)*/, /*TempRegID*//* 330(*/0xCA, 0x02/*)*/,
     /* 190215 */   GIR_AddImm, /*InsnID*//* 330(*/0xCA, 0x02/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 190226 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 330(*/0xCA, 0x02/*)*/,
     /* 190229 */   GIR_MakeTempReg, /*TempRegID*//* 328(*/0xC8, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 190233 */   GIR_BuildMI, /*InsnID*//* 329(*/0xC9, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 190238 */   GIR_AddTempRegister, /*InsnID*//* 329(*/0xC9, 0x02/*)*/, /*TempRegID*//* 328(*/0xC8, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190245 */   GIR_AddSimpleTempRegister, /*InsnID*//* 329(*/0xC9, 0x02/*)*/, /*TempRegID*//* 329(*/0xC9, 0x02/*)*/,
     /* 190250 */   GIR_AddImm, /*InsnID*//* 329(*/0xC9, 0x02/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 190261 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 329(*/0xC9, 0x02/*)*/,
     /* 190264 */   GIR_MakeTempReg, /*TempRegID*//* 327(*/0xC7, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 190268 */   GIR_BuildMI, /*InsnID*//* 328(*/0xC8, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 190273 */   GIR_AddTempRegister, /*InsnID*//* 328(*/0xC8, 0x02/*)*/, /*TempRegID*//* 327(*/0xC7, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190280 */   GIR_AddImm, /*InsnID*//* 328(*/0xC8, 0x02/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 190291 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 328(*/0xC8, 0x02/*)*/,
     /* 190294 */   GIR_MakeTempReg, /*TempRegID*//* 326(*/0xC6, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 190298 */   GIR_BuildMI, /*InsnID*//* 327(*/0xC7, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 190303 */   GIR_AddTempRegister, /*InsnID*//* 327(*/0xC7, 0x02/*)*/, /*TempRegID*//* 326(*/0xC6, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190310 */   GIR_AddSimpleTempRegister, /*InsnID*//* 327(*/0xC7, 0x02/*)*/, /*TempRegID*//* 327(*/0xC7, 0x02/*)*/,
     /* 190315 */   GIR_AddImm, /*InsnID*//* 327(*/0xC7, 0x02/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 190326 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 327(*/0xC7, 0x02/*)*/,
     /* 190329 */   GIR_MakeTempReg, /*TempRegID*//* 325(*/0xC5, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 190333 */   GIR_BuildMI, /*InsnID*//* 326(*/0xC6, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 190338 */   GIR_AddTempRegister, /*InsnID*//* 326(*/0xC6, 0x02/*)*/, /*TempRegID*//* 325(*/0xC5, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190345 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 326(*/0xC6, 0x02/*)*/,
     /* 190348 */   GIR_MakeTempReg, /*TempRegID*//* 324(*/0xC4, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 190352 */   GIR_BuildMI, /*InsnID*//* 325(*/0xC5, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 190357 */   GIR_AddTempRegister, /*InsnID*//* 325(*/0xC5, 0x02/*)*/, /*TempRegID*//* 324(*/0xC4, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190364 */   GIR_AddSimpleTempRegister, /*InsnID*//* 325(*/0xC5, 0x02/*)*/, /*TempRegID*//* 325(*/0xC5, 0x02/*)*/,
     /* 190369 */   GIR_AddSimpleTempRegister, /*InsnID*//* 325(*/0xC5, 0x02/*)*/, /*TempRegID*//* 326(*/0xC6, 0x02/*)*/,
     /* 190374 */   GIR_AddImm8, /*InsnID*//* 325(*/0xC5, 0x02/*)*/, /*Imm*/1,
     /* 190378 */   GIR_ConstrainOperandRC, /*InsnID*//* 325(*/0xC5, 0x02/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 190384 */   GIR_ConstrainOperandRC, /*InsnID*//* 325(*/0xC5, 0x02/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 190390 */   GIR_ConstrainOperandRC, /*InsnID*//* 325(*/0xC5, 0x02/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 190396 */   GIR_MakeTempReg, /*TempRegID*//* 323(*/0xC3, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 190400 */   GIR_BuildMI, /*InsnID*//* 324(*/0xC4, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 190405 */   GIR_AddTempRegister, /*InsnID*//* 324(*/0xC4, 0x02/*)*/, /*TempRegID*//* 323(*/0xC3, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190412 */   GIR_AddSimpleTempRegister, /*InsnID*//* 324(*/0xC4, 0x02/*)*/, /*TempRegID*//* 324(*/0xC4, 0x02/*)*/,
     /* 190417 */   GIR_AddImm8, /*InsnID*//* 324(*/0xC4, 0x02/*)*/, /*Imm*/32,
     /* 190421 */   GIR_AddImm8, /*InsnID*//* 324(*/0xC4, 0x02/*)*/, /*Imm*/31,
     /* 190425 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 324(*/0xC4, 0x02/*)*/,
     /* 190428 */   GIR_MakeTempReg, /*TempRegID*//* 322(*/0xC2, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 190432 */   GIR_BuildMI, /*InsnID*//* 323(*/0xC3, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 190437 */   GIR_AddTempRegister, /*InsnID*//* 323(*/0xC3, 0x02/*)*/, /*TempRegID*//* 322(*/0xC2, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190444 */   GIR_AddSimpleTempRegister, /*InsnID*//* 323(*/0xC3, 0x02/*)*/, /*TempRegID*//* 323(*/0xC3, 0x02/*)*/,
     /* 190449 */   GIR_AddImm, /*InsnID*//* 323(*/0xC3, 0x02/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 190460 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 323(*/0xC3, 0x02/*)*/,
     /* 190463 */   GIR_MakeTempReg, /*TempRegID*//* 321(*/0xC1, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 190467 */   GIR_BuildMI, /*InsnID*//* 322(*/0xC2, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 190472 */   GIR_AddTempRegister, /*InsnID*//* 322(*/0xC2, 0x02/*)*/, /*TempRegID*//* 321(*/0xC1, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190479 */   GIR_AddSimpleTempRegister, /*InsnID*//* 322(*/0xC2, 0x02/*)*/, /*TempRegID*//* 322(*/0xC2, 0x02/*)*/,
     /* 190484 */   GIR_AddImm, /*InsnID*//* 322(*/0xC2, 0x02/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 190495 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 322(*/0xC2, 0x02/*)*/,
     /* 190498 */   GIR_MakeTempReg, /*TempRegID*//* 320(*/0xC0, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 190502 */   GIR_BuildMI, /*InsnID*//* 321(*/0xC1, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 190507 */   GIR_AddTempRegister, /*InsnID*//* 321(*/0xC1, 0x02/*)*/, /*TempRegID*//* 320(*/0xC0, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190514 */   GIR_Copy, /*NewInsnID*//* 321(*/0xC1, 0x02/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 190519 */   GIR_AddImm8, /*InsnID*//* 321(*/0xC1, 0x02/*)*/, /*Imm*/1,
     /* 190523 */   GIR_AddImm8, /*InsnID*//* 321(*/0xC1, 0x02/*)*/, /*Imm*/62,
     /* 190527 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 321(*/0xC1, 0x02/*)*/,
     /* 190530 */   GIR_MakeTempReg, /*TempRegID*//* 319(*/0xBF, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 190534 */   GIR_BuildMI, /*InsnID*//* 320(*/0xC0, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 190539 */   GIR_AddTempRegister, /*InsnID*//* 320(*/0xC0, 0x02/*)*/, /*TempRegID*//* 319(*/0xBF, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190546 */   GIR_AddSimpleTempRegister, /*InsnID*//* 320(*/0xC0, 0x02/*)*/, /*TempRegID*//* 320(*/0xC0, 0x02/*)*/,
     /* 190551 */   GIR_AddSimpleTempRegister, /*InsnID*//* 320(*/0xC0, 0x02/*)*/, /*TempRegID*//* 321(*/0xC1, 0x02/*)*/,
     /* 190556 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 320(*/0xC0, 0x02/*)*/,
     /* 190559 */   GIR_MakeTempReg, /*TempRegID*//* 318(*/0xBE, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 190563 */   GIR_BuildMI, /*InsnID*//* 319(*/0xBF, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 190568 */   GIR_AddTempRegister, /*InsnID*//* 319(*/0xBF, 0x02/*)*/, /*TempRegID*//* 318(*/0xBE, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190575 */   GIR_AddImm, /*InsnID*//* 319(*/0xBF, 0x02/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 190586 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 319(*/0xBF, 0x02/*)*/,
     /* 190589 */   GIR_MakeTempReg, /*TempRegID*//* 317(*/0xBD, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 190593 */   GIR_BuildMI, /*InsnID*//* 318(*/0xBE, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 190598 */   GIR_AddTempRegister, /*InsnID*//* 318(*/0xBE, 0x02/*)*/, /*TempRegID*//* 317(*/0xBD, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190605 */   GIR_AddSimpleTempRegister, /*InsnID*//* 318(*/0xBE, 0x02/*)*/, /*TempRegID*//* 318(*/0xBE, 0x02/*)*/,
     /* 190610 */   GIR_AddImm, /*InsnID*//* 318(*/0xBE, 0x02/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 190621 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 318(*/0xBE, 0x02/*)*/,
     /* 190624 */   GIR_MakeTempReg, /*TempRegID*//* 316(*/0xBC, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 190628 */   GIR_BuildMI, /*InsnID*//* 317(*/0xBD, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 190633 */   GIR_AddTempRegister, /*InsnID*//* 317(*/0xBD, 0x02/*)*/, /*TempRegID*//* 316(*/0xBC, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190640 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 317(*/0xBD, 0x02/*)*/,
     /* 190643 */   GIR_MakeTempReg, /*TempRegID*//* 315(*/0xBB, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 190647 */   GIR_BuildMI, /*InsnID*//* 316(*/0xBC, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 190652 */   GIR_AddTempRegister, /*InsnID*//* 316(*/0xBC, 0x02/*)*/, /*TempRegID*//* 315(*/0xBB, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190659 */   GIR_AddSimpleTempRegister, /*InsnID*//* 316(*/0xBC, 0x02/*)*/, /*TempRegID*//* 316(*/0xBC, 0x02/*)*/,
     /* 190664 */   GIR_AddSimpleTempRegister, /*InsnID*//* 316(*/0xBC, 0x02/*)*/, /*TempRegID*//* 317(*/0xBD, 0x02/*)*/,
     /* 190669 */   GIR_AddImm8, /*InsnID*//* 316(*/0xBC, 0x02/*)*/, /*Imm*/1,
     /* 190673 */   GIR_ConstrainOperandRC, /*InsnID*//* 316(*/0xBC, 0x02/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 190679 */   GIR_ConstrainOperandRC, /*InsnID*//* 316(*/0xBC, 0x02/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 190685 */   GIR_ConstrainOperandRC, /*InsnID*//* 316(*/0xBC, 0x02/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 190691 */   GIR_MakeTempReg, /*TempRegID*//* 314(*/0xBA, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 190695 */   GIR_BuildMI, /*InsnID*//* 315(*/0xBB, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 190700 */   GIR_AddTempRegister, /*InsnID*//* 315(*/0xBB, 0x02/*)*/, /*TempRegID*//* 314(*/0xBA, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190707 */   GIR_AddSimpleTempRegister, /*InsnID*//* 315(*/0xBB, 0x02/*)*/, /*TempRegID*//* 315(*/0xBB, 0x02/*)*/,
     /* 190712 */   GIR_AddImm8, /*InsnID*//* 315(*/0xBB, 0x02/*)*/, /*Imm*/32,
     /* 190716 */   GIR_AddImm8, /*InsnID*//* 315(*/0xBB, 0x02/*)*/, /*Imm*/31,
     /* 190720 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 315(*/0xBB, 0x02/*)*/,
     /* 190723 */   GIR_MakeTempReg, /*TempRegID*//* 313(*/0xB9, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 190727 */   GIR_BuildMI, /*InsnID*//* 314(*/0xBA, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 190732 */   GIR_AddTempRegister, /*InsnID*//* 314(*/0xBA, 0x02/*)*/, /*TempRegID*//* 313(*/0xB9, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190739 */   GIR_AddSimpleTempRegister, /*InsnID*//* 314(*/0xBA, 0x02/*)*/, /*TempRegID*//* 314(*/0xBA, 0x02/*)*/,
     /* 190744 */   GIR_AddImm, /*InsnID*//* 314(*/0xBA, 0x02/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 190755 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 314(*/0xBA, 0x02/*)*/,
     /* 190758 */   GIR_MakeTempReg, /*TempRegID*//* 312(*/0xB8, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 190762 */   GIR_BuildMI, /*InsnID*//* 313(*/0xB9, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 190767 */   GIR_AddTempRegister, /*InsnID*//* 313(*/0xB9, 0x02/*)*/, /*TempRegID*//* 312(*/0xB8, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190774 */   GIR_AddSimpleTempRegister, /*InsnID*//* 313(*/0xB9, 0x02/*)*/, /*TempRegID*//* 313(*/0xB9, 0x02/*)*/,
     /* 190779 */   GIR_AddImm, /*InsnID*//* 313(*/0xB9, 0x02/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 190790 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 313(*/0xB9, 0x02/*)*/,
     /* 190793 */   GIR_MakeTempReg, /*TempRegID*//* 311(*/0xB7, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 190797 */   GIR_BuildMI, /*InsnID*//* 312(*/0xB8, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 190802 */   GIR_AddTempRegister, /*InsnID*//* 312(*/0xB8, 0x02/*)*/, /*TempRegID*//* 311(*/0xB7, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190809 */   GIR_Copy, /*NewInsnID*//* 312(*/0xB8, 0x02/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 190814 */   GIR_AddImm8, /*InsnID*//* 312(*/0xB8, 0x02/*)*/, /*Imm*/63,
     /* 190818 */   GIR_AddImm8, /*InsnID*//* 312(*/0xB8, 0x02/*)*/, /*Imm*/1,
     /* 190822 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 312(*/0xB8, 0x02/*)*/,
     /* 190825 */   GIR_MakeTempReg, /*TempRegID*//* 310(*/0xB6, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 190829 */   GIR_BuildMI, /*InsnID*//* 311(*/0xB7, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 190834 */   GIR_AddTempRegister, /*InsnID*//* 311(*/0xB7, 0x02/*)*/, /*TempRegID*//* 310(*/0xB6, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190841 */   GIR_AddSimpleTempRegister, /*InsnID*//* 311(*/0xB7, 0x02/*)*/, /*TempRegID*//* 311(*/0xB7, 0x02/*)*/,
     /* 190846 */   GIR_AddSimpleTempRegister, /*InsnID*//* 311(*/0xB7, 0x02/*)*/, /*TempRegID*//* 312(*/0xB8, 0x02/*)*/,
     /* 190851 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 311(*/0xB7, 0x02/*)*/,
     /* 190854 */   GIR_MakeTempReg, /*TempRegID*//* 309(*/0xB5, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 190858 */   GIR_BuildMI, /*InsnID*//* 310(*/0xB6, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 190863 */   GIR_AddTempRegister, /*InsnID*//* 310(*/0xB6, 0x02/*)*/, /*TempRegID*//* 309(*/0xB5, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190870 */   GIR_AddSimpleTempRegister, /*InsnID*//* 310(*/0xB6, 0x02/*)*/, /*TempRegID*//* 310(*/0xB6, 0x02/*)*/,
     /* 190875 */   GIR_AddSimpleTempRegister, /*InsnID*//* 310(*/0xB6, 0x02/*)*/, /*TempRegID*//* 319(*/0xBF, 0x02/*)*/,
     /* 190880 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 310(*/0xB6, 0x02/*)*/,
     /* 190883 */   GIR_MakeTempReg, /*TempRegID*//* 308(*/0xB4, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 190887 */   GIR_BuildMI, /*InsnID*//* 309(*/0xB5, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 190892 */   GIR_AddTempRegister, /*InsnID*//* 309(*/0xB5, 0x02/*)*/, /*TempRegID*//* 308(*/0xB4, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190899 */   GIR_AddSimpleTempRegister, /*InsnID*//* 309(*/0xB5, 0x02/*)*/, /*TempRegID*//* 309(*/0xB5, 0x02/*)*/,
     /* 190904 */   GIR_AddImm8, /*InsnID*//* 309(*/0xB5, 0x02/*)*/, /*Imm*/2,
     /* 190908 */   GIR_AddImm8, /*InsnID*//* 309(*/0xB5, 0x02/*)*/, /*Imm*/61,
     /* 190912 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 309(*/0xB5, 0x02/*)*/,
     /* 190915 */   GIR_MakeTempReg, /*TempRegID*//* 307(*/0xB3, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 190919 */   GIR_BuildMI, /*InsnID*//* 308(*/0xB4, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 190924 */   GIR_AddTempRegister, /*InsnID*//* 308(*/0xB4, 0x02/*)*/, /*TempRegID*//* 307(*/0xB3, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190931 */   GIR_AddSimpleTempRegister, /*InsnID*//* 308(*/0xB4, 0x02/*)*/, /*TempRegID*//* 308(*/0xB4, 0x02/*)*/,
     /* 190936 */   GIR_AddSimpleTempRegister, /*InsnID*//* 308(*/0xB4, 0x02/*)*/, /*TempRegID*//* 328(*/0xC8, 0x02/*)*/,
     /* 190941 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 308(*/0xB4, 0x02/*)*/,
     /* 190944 */   GIR_MakeTempReg, /*TempRegID*//* 306(*/0xB2, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 190948 */   GIR_BuildMI, /*InsnID*//* 307(*/0xB3, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 190953 */   GIR_AddTempRegister, /*InsnID*//* 307(*/0xB3, 0x02/*)*/, /*TempRegID*//* 306(*/0xB2, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190960 */   GIR_AddImm, /*InsnID*//* 307(*/0xB3, 0x02/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 190971 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 307(*/0xB3, 0x02/*)*/,
     /* 190974 */   GIR_MakeTempReg, /*TempRegID*//* 305(*/0xB1, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 190978 */   GIR_BuildMI, /*InsnID*//* 306(*/0xB2, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 190983 */   GIR_AddTempRegister, /*InsnID*//* 306(*/0xB2, 0x02/*)*/, /*TempRegID*//* 305(*/0xB1, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190990 */   GIR_AddSimpleTempRegister, /*InsnID*//* 306(*/0xB2, 0x02/*)*/, /*TempRegID*//* 306(*/0xB2, 0x02/*)*/,
     /* 190995 */   GIR_AddImm, /*InsnID*//* 306(*/0xB2, 0x02/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 191006 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 306(*/0xB2, 0x02/*)*/,
     /* 191009 */   GIR_MakeTempReg, /*TempRegID*//* 304(*/0xB0, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191013 */   GIR_BuildMI, /*InsnID*//* 305(*/0xB1, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 191018 */   GIR_AddTempRegister, /*InsnID*//* 305(*/0xB1, 0x02/*)*/, /*TempRegID*//* 304(*/0xB0, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191025 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 305(*/0xB1, 0x02/*)*/,
     /* 191028 */   GIR_MakeTempReg, /*TempRegID*//* 303(*/0xAF, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191032 */   GIR_BuildMI, /*InsnID*//* 304(*/0xB0, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 191037 */   GIR_AddTempRegister, /*InsnID*//* 304(*/0xB0, 0x02/*)*/, /*TempRegID*//* 303(*/0xAF, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191044 */   GIR_AddSimpleTempRegister, /*InsnID*//* 304(*/0xB0, 0x02/*)*/, /*TempRegID*//* 304(*/0xB0, 0x02/*)*/,
     /* 191049 */   GIR_AddSimpleTempRegister, /*InsnID*//* 304(*/0xB0, 0x02/*)*/, /*TempRegID*//* 305(*/0xB1, 0x02/*)*/,
     /* 191054 */   GIR_AddImm8, /*InsnID*//* 304(*/0xB0, 0x02/*)*/, /*Imm*/1,
     /* 191058 */   GIR_ConstrainOperandRC, /*InsnID*//* 304(*/0xB0, 0x02/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 191064 */   GIR_ConstrainOperandRC, /*InsnID*//* 304(*/0xB0, 0x02/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 191070 */   GIR_ConstrainOperandRC, /*InsnID*//* 304(*/0xB0, 0x02/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 191076 */   GIR_MakeTempReg, /*TempRegID*//* 302(*/0xAE, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191080 */   GIR_BuildMI, /*InsnID*//* 303(*/0xAF, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 191085 */   GIR_AddTempRegister, /*InsnID*//* 303(*/0xAF, 0x02/*)*/, /*TempRegID*//* 302(*/0xAE, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191092 */   GIR_AddSimpleTempRegister, /*InsnID*//* 303(*/0xAF, 0x02/*)*/, /*TempRegID*//* 303(*/0xAF, 0x02/*)*/,
     /* 191097 */   GIR_AddImm8, /*InsnID*//* 303(*/0xAF, 0x02/*)*/, /*Imm*/32,
     /* 191101 */   GIR_AddImm8, /*InsnID*//* 303(*/0xAF, 0x02/*)*/, /*Imm*/31,
     /* 191105 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 303(*/0xAF, 0x02/*)*/,
     /* 191108 */   GIR_MakeTempReg, /*TempRegID*//* 301(*/0xAD, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191112 */   GIR_BuildMI, /*InsnID*//* 302(*/0xAE, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 191117 */   GIR_AddTempRegister, /*InsnID*//* 302(*/0xAE, 0x02/*)*/, /*TempRegID*//* 301(*/0xAD, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191124 */   GIR_AddSimpleTempRegister, /*InsnID*//* 302(*/0xAE, 0x02/*)*/, /*TempRegID*//* 302(*/0xAE, 0x02/*)*/,
     /* 191129 */   GIR_AddImm, /*InsnID*//* 302(*/0xAE, 0x02/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 191140 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 302(*/0xAE, 0x02/*)*/,
     /* 191143 */   GIR_MakeTempReg, /*TempRegID*//* 300(*/0xAC, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191147 */   GIR_BuildMI, /*InsnID*//* 301(*/0xAD, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 191152 */   GIR_AddTempRegister, /*InsnID*//* 301(*/0xAD, 0x02/*)*/, /*TempRegID*//* 300(*/0xAC, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191159 */   GIR_AddSimpleTempRegister, /*InsnID*//* 301(*/0xAD, 0x02/*)*/, /*TempRegID*//* 301(*/0xAD, 0x02/*)*/,
     /* 191164 */   GIR_AddImm, /*InsnID*//* 301(*/0xAD, 0x02/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 191175 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 301(*/0xAD, 0x02/*)*/,
     /* 191178 */   GIR_MakeTempReg, /*TempRegID*//* 299(*/0xAB, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 191182 */   GIR_BuildMI, /*InsnID*//* 300(*/0xAC, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 191187 */   GIR_AddTempRegister, /*InsnID*//* 300(*/0xAC, 0x02/*)*/, /*TempRegID*//* 299(*/0xAB, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191194 */   GIR_AddImm, /*InsnID*//* 300(*/0xAC, 0x02/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 191205 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 300(*/0xAC, 0x02/*)*/,
     /* 191208 */   GIR_MakeTempReg, /*TempRegID*//* 298(*/0xAA, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 191212 */   GIR_BuildMI, /*InsnID*//* 299(*/0xAB, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 191217 */   GIR_AddTempRegister, /*InsnID*//* 299(*/0xAB, 0x02/*)*/, /*TempRegID*//* 298(*/0xAA, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191224 */   GIR_AddSimpleTempRegister, /*InsnID*//* 299(*/0xAB, 0x02/*)*/, /*TempRegID*//* 299(*/0xAB, 0x02/*)*/,
     /* 191229 */   GIR_AddImm, /*InsnID*//* 299(*/0xAB, 0x02/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 191240 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 299(*/0xAB, 0x02/*)*/,
     /* 191243 */   GIR_MakeTempReg, /*TempRegID*//* 297(*/0xA9, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191247 */   GIR_BuildMI, /*InsnID*//* 298(*/0xAA, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 191252 */   GIR_AddTempRegister, /*InsnID*//* 298(*/0xAA, 0x02/*)*/, /*TempRegID*//* 297(*/0xA9, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191259 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 298(*/0xAA, 0x02/*)*/,
     /* 191262 */   GIR_MakeTempReg, /*TempRegID*//* 296(*/0xA8, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191266 */   GIR_BuildMI, /*InsnID*//* 297(*/0xA9, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 191271 */   GIR_AddTempRegister, /*InsnID*//* 297(*/0xA9, 0x02/*)*/, /*TempRegID*//* 296(*/0xA8, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191278 */   GIR_AddSimpleTempRegister, /*InsnID*//* 297(*/0xA9, 0x02/*)*/, /*TempRegID*//* 297(*/0xA9, 0x02/*)*/,
     /* 191283 */   GIR_AddSimpleTempRegister, /*InsnID*//* 297(*/0xA9, 0x02/*)*/, /*TempRegID*//* 298(*/0xAA, 0x02/*)*/,
     /* 191288 */   GIR_AddImm8, /*InsnID*//* 297(*/0xA9, 0x02/*)*/, /*Imm*/1,
     /* 191292 */   GIR_ConstrainOperandRC, /*InsnID*//* 297(*/0xA9, 0x02/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 191298 */   GIR_ConstrainOperandRC, /*InsnID*//* 297(*/0xA9, 0x02/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 191304 */   GIR_ConstrainOperandRC, /*InsnID*//* 297(*/0xA9, 0x02/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 191310 */   GIR_MakeTempReg, /*TempRegID*//* 295(*/0xA7, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191314 */   GIR_BuildMI, /*InsnID*//* 296(*/0xA8, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 191319 */   GIR_AddTempRegister, /*InsnID*//* 296(*/0xA8, 0x02/*)*/, /*TempRegID*//* 295(*/0xA7, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191326 */   GIR_AddSimpleTempRegister, /*InsnID*//* 296(*/0xA8, 0x02/*)*/, /*TempRegID*//* 296(*/0xA8, 0x02/*)*/,
     /* 191331 */   GIR_AddImm8, /*InsnID*//* 296(*/0xA8, 0x02/*)*/, /*Imm*/32,
     /* 191335 */   GIR_AddImm8, /*InsnID*//* 296(*/0xA8, 0x02/*)*/, /*Imm*/31,
     /* 191339 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 296(*/0xA8, 0x02/*)*/,
     /* 191342 */   GIR_MakeTempReg, /*TempRegID*//* 294(*/0xA6, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191346 */   GIR_BuildMI, /*InsnID*//* 295(*/0xA7, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 191351 */   GIR_AddTempRegister, /*InsnID*//* 295(*/0xA7, 0x02/*)*/, /*TempRegID*//* 294(*/0xA6, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191358 */   GIR_AddSimpleTempRegister, /*InsnID*//* 295(*/0xA7, 0x02/*)*/, /*TempRegID*//* 295(*/0xA7, 0x02/*)*/,
     /* 191363 */   GIR_AddImm, /*InsnID*//* 295(*/0xA7, 0x02/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 191374 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 295(*/0xA7, 0x02/*)*/,
     /* 191377 */   GIR_MakeTempReg, /*TempRegID*//* 293(*/0xA5, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191381 */   GIR_BuildMI, /*InsnID*//* 294(*/0xA6, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 191386 */   GIR_AddTempRegister, /*InsnID*//* 294(*/0xA6, 0x02/*)*/, /*TempRegID*//* 293(*/0xA5, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191393 */   GIR_AddSimpleTempRegister, /*InsnID*//* 294(*/0xA6, 0x02/*)*/, /*TempRegID*//* 294(*/0xA6, 0x02/*)*/,
     /* 191398 */   GIR_AddImm, /*InsnID*//* 294(*/0xA6, 0x02/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 191409 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 294(*/0xA6, 0x02/*)*/,
     /* 191412 */   GIR_MakeTempReg, /*TempRegID*//* 292(*/0xA4, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191416 */   GIR_BuildMI, /*InsnID*//* 293(*/0xA5, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 191421 */   GIR_AddTempRegister, /*InsnID*//* 293(*/0xA5, 0x02/*)*/, /*TempRegID*//* 292(*/0xA4, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191428 */   GIR_Copy, /*NewInsnID*//* 293(*/0xA5, 0x02/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 191433 */   GIR_AddImm8, /*InsnID*//* 293(*/0xA5, 0x02/*)*/, /*Imm*/1,
     /* 191437 */   GIR_AddImm8, /*InsnID*//* 293(*/0xA5, 0x02/*)*/, /*Imm*/62,
     /* 191441 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 293(*/0xA5, 0x02/*)*/,
     /* 191444 */   GIR_MakeTempReg, /*TempRegID*//* 291(*/0xA3, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191448 */   GIR_BuildMI, /*InsnID*//* 292(*/0xA4, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 191453 */   GIR_AddTempRegister, /*InsnID*//* 292(*/0xA4, 0x02/*)*/, /*TempRegID*//* 291(*/0xA3, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191460 */   GIR_AddSimpleTempRegister, /*InsnID*//* 292(*/0xA4, 0x02/*)*/, /*TempRegID*//* 292(*/0xA4, 0x02/*)*/,
     /* 191465 */   GIR_AddSimpleTempRegister, /*InsnID*//* 292(*/0xA4, 0x02/*)*/, /*TempRegID*//* 293(*/0xA5, 0x02/*)*/,
     /* 191470 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 292(*/0xA4, 0x02/*)*/,
     /* 191473 */   GIR_MakeTempReg, /*TempRegID*//* 290(*/0xA2, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 191477 */   GIR_BuildMI, /*InsnID*//* 291(*/0xA3, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 191482 */   GIR_AddTempRegister, /*InsnID*//* 291(*/0xA3, 0x02/*)*/, /*TempRegID*//* 290(*/0xA2, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191489 */   GIR_AddImm, /*InsnID*//* 291(*/0xA3, 0x02/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 191500 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 291(*/0xA3, 0x02/*)*/,
     /* 191503 */   GIR_MakeTempReg, /*TempRegID*//* 289(*/0xA1, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 191507 */   GIR_BuildMI, /*InsnID*//* 290(*/0xA2, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 191512 */   GIR_AddTempRegister, /*InsnID*//* 290(*/0xA2, 0x02/*)*/, /*TempRegID*//* 289(*/0xA1, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191519 */   GIR_AddSimpleTempRegister, /*InsnID*//* 290(*/0xA2, 0x02/*)*/, /*TempRegID*//* 290(*/0xA2, 0x02/*)*/,
     /* 191524 */   GIR_AddImm, /*InsnID*//* 290(*/0xA2, 0x02/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 191535 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 290(*/0xA2, 0x02/*)*/,
     /* 191538 */   GIR_MakeTempReg, /*TempRegID*//* 288(*/0xA0, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191542 */   GIR_BuildMI, /*InsnID*//* 289(*/0xA1, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 191547 */   GIR_AddTempRegister, /*InsnID*//* 289(*/0xA1, 0x02/*)*/, /*TempRegID*//* 288(*/0xA0, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191554 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 289(*/0xA1, 0x02/*)*/,
     /* 191557 */   GIR_MakeTempReg, /*TempRegID*//* 287(*/0x9F, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191561 */   GIR_BuildMI, /*InsnID*//* 288(*/0xA0, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 191566 */   GIR_AddTempRegister, /*InsnID*//* 288(*/0xA0, 0x02/*)*/, /*TempRegID*//* 287(*/0x9F, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191573 */   GIR_AddSimpleTempRegister, /*InsnID*//* 288(*/0xA0, 0x02/*)*/, /*TempRegID*//* 288(*/0xA0, 0x02/*)*/,
     /* 191578 */   GIR_AddSimpleTempRegister, /*InsnID*//* 288(*/0xA0, 0x02/*)*/, /*TempRegID*//* 289(*/0xA1, 0x02/*)*/,
     /* 191583 */   GIR_AddImm8, /*InsnID*//* 288(*/0xA0, 0x02/*)*/, /*Imm*/1,
     /* 191587 */   GIR_ConstrainOperandRC, /*InsnID*//* 288(*/0xA0, 0x02/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 191593 */   GIR_ConstrainOperandRC, /*InsnID*//* 288(*/0xA0, 0x02/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 191599 */   GIR_ConstrainOperandRC, /*InsnID*//* 288(*/0xA0, 0x02/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 191605 */   GIR_MakeTempReg, /*TempRegID*//* 286(*/0x9E, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191609 */   GIR_BuildMI, /*InsnID*//* 287(*/0x9F, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 191614 */   GIR_AddTempRegister, /*InsnID*//* 287(*/0x9F, 0x02/*)*/, /*TempRegID*//* 286(*/0x9E, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191621 */   GIR_AddSimpleTempRegister, /*InsnID*//* 287(*/0x9F, 0x02/*)*/, /*TempRegID*//* 287(*/0x9F, 0x02/*)*/,
     /* 191626 */   GIR_AddImm8, /*InsnID*//* 287(*/0x9F, 0x02/*)*/, /*Imm*/32,
     /* 191630 */   GIR_AddImm8, /*InsnID*//* 287(*/0x9F, 0x02/*)*/, /*Imm*/31,
     /* 191634 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 287(*/0x9F, 0x02/*)*/,
     /* 191637 */   GIR_MakeTempReg, /*TempRegID*//* 285(*/0x9D, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191641 */   GIR_BuildMI, /*InsnID*//* 286(*/0x9E, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 191646 */   GIR_AddTempRegister, /*InsnID*//* 286(*/0x9E, 0x02/*)*/, /*TempRegID*//* 285(*/0x9D, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191653 */   GIR_AddSimpleTempRegister, /*InsnID*//* 286(*/0x9E, 0x02/*)*/, /*TempRegID*//* 286(*/0x9E, 0x02/*)*/,
     /* 191658 */   GIR_AddImm, /*InsnID*//* 286(*/0x9E, 0x02/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 191669 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 286(*/0x9E, 0x02/*)*/,
     /* 191672 */   GIR_MakeTempReg, /*TempRegID*//* 284(*/0x9C, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191676 */   GIR_BuildMI, /*InsnID*//* 285(*/0x9D, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 191681 */   GIR_AddTempRegister, /*InsnID*//* 285(*/0x9D, 0x02/*)*/, /*TempRegID*//* 284(*/0x9C, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191688 */   GIR_AddSimpleTempRegister, /*InsnID*//* 285(*/0x9D, 0x02/*)*/, /*TempRegID*//* 285(*/0x9D, 0x02/*)*/,
     /* 191693 */   GIR_AddImm, /*InsnID*//* 285(*/0x9D, 0x02/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 191704 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 285(*/0x9D, 0x02/*)*/,
     /* 191707 */   GIR_MakeTempReg, /*TempRegID*//* 283(*/0x9B, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191711 */   GIR_BuildMI, /*InsnID*//* 284(*/0x9C, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 191716 */   GIR_AddTempRegister, /*InsnID*//* 284(*/0x9C, 0x02/*)*/, /*TempRegID*//* 283(*/0x9B, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191723 */   GIR_Copy, /*NewInsnID*//* 284(*/0x9C, 0x02/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 191728 */   GIR_AddImm8, /*InsnID*//* 284(*/0x9C, 0x02/*)*/, /*Imm*/63,
     /* 191732 */   GIR_AddImm8, /*InsnID*//* 284(*/0x9C, 0x02/*)*/, /*Imm*/1,
     /* 191736 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 284(*/0x9C, 0x02/*)*/,
     /* 191739 */   GIR_MakeTempReg, /*TempRegID*//* 282(*/0x9A, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191743 */   GIR_BuildMI, /*InsnID*//* 283(*/0x9B, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 191748 */   GIR_AddTempRegister, /*InsnID*//* 283(*/0x9B, 0x02/*)*/, /*TempRegID*//* 282(*/0x9A, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191755 */   GIR_AddSimpleTempRegister, /*InsnID*//* 283(*/0x9B, 0x02/*)*/, /*TempRegID*//* 283(*/0x9B, 0x02/*)*/,
     /* 191760 */   GIR_AddSimpleTempRegister, /*InsnID*//* 283(*/0x9B, 0x02/*)*/, /*TempRegID*//* 284(*/0x9C, 0x02/*)*/,
     /* 191765 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 283(*/0x9B, 0x02/*)*/,
     /* 191768 */   GIR_MakeTempReg, /*TempRegID*//* 281(*/0x99, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191772 */   GIR_BuildMI, /*InsnID*//* 282(*/0x9A, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 191777 */   GIR_AddTempRegister, /*InsnID*//* 282(*/0x9A, 0x02/*)*/, /*TempRegID*//* 281(*/0x99, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191784 */   GIR_AddSimpleTempRegister, /*InsnID*//* 282(*/0x9A, 0x02/*)*/, /*TempRegID*//* 282(*/0x9A, 0x02/*)*/,
     /* 191789 */   GIR_AddSimpleTempRegister, /*InsnID*//* 282(*/0x9A, 0x02/*)*/, /*TempRegID*//* 291(*/0xA3, 0x02/*)*/,
     /* 191794 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 282(*/0x9A, 0x02/*)*/,
     /* 191797 */   GIR_MakeTempReg, /*TempRegID*//* 280(*/0x98, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191801 */   GIR_BuildMI, /*InsnID*//* 281(*/0x99, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 191806 */   GIR_AddTempRegister, /*InsnID*//* 281(*/0x99, 0x02/*)*/, /*TempRegID*//* 280(*/0x98, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191813 */   GIR_AddSimpleTempRegister, /*InsnID*//* 281(*/0x99, 0x02/*)*/, /*TempRegID*//* 281(*/0x99, 0x02/*)*/,
     /* 191818 */   GIR_AddImm8, /*InsnID*//* 281(*/0x99, 0x02/*)*/, /*Imm*/62,
     /* 191822 */   GIR_AddImm8, /*InsnID*//* 281(*/0x99, 0x02/*)*/, /*Imm*/2,
     /* 191826 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 281(*/0x99, 0x02/*)*/,
     /* 191829 */   GIR_MakeTempReg, /*TempRegID*//* 279(*/0x97, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191833 */   GIR_BuildMI, /*InsnID*//* 280(*/0x98, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 191838 */   GIR_AddTempRegister, /*InsnID*//* 280(*/0x98, 0x02/*)*/, /*TempRegID*//* 279(*/0x97, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191845 */   GIR_AddSimpleTempRegister, /*InsnID*//* 280(*/0x98, 0x02/*)*/, /*TempRegID*//* 280(*/0x98, 0x02/*)*/,
     /* 191850 */   GIR_AddSimpleTempRegister, /*InsnID*//* 280(*/0x98, 0x02/*)*/, /*TempRegID*//* 300(*/0xAC, 0x02/*)*/,
     /* 191855 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 280(*/0x98, 0x02/*)*/,
     /* 191858 */   GIR_MakeTempReg, /*TempRegID*//* 278(*/0x96, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191862 */   GIR_BuildMI, /*InsnID*//* 279(*/0x97, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 191867 */   GIR_AddTempRegister, /*InsnID*//* 279(*/0x97, 0x02/*)*/, /*TempRegID*//* 278(*/0x96, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191874 */   GIR_AddSimpleTempRegister, /*InsnID*//* 279(*/0x97, 0x02/*)*/, /*TempRegID*//* 279(*/0x97, 0x02/*)*/,
     /* 191879 */   GIR_AddSimpleTempRegister, /*InsnID*//* 279(*/0x97, 0x02/*)*/, /*TempRegID*//* 307(*/0xB3, 0x02/*)*/,
     /* 191884 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 279(*/0x97, 0x02/*)*/,
     /* 191887 */   GIR_MakeTempReg, /*TempRegID*//* 277(*/0x95, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191891 */   GIR_BuildMI, /*InsnID*//* 278(*/0x96, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 191896 */   GIR_AddTempRegister, /*InsnID*//* 278(*/0x96, 0x02/*)*/, /*TempRegID*//* 277(*/0x95, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191903 */   GIR_AddSimpleTempRegister, /*InsnID*//* 278(*/0x96, 0x02/*)*/, /*TempRegID*//* 278(*/0x96, 0x02/*)*/,
     /* 191908 */   GIR_AddImm8, /*InsnID*//* 278(*/0x96, 0x02/*)*/, /*Imm*/60,
     /* 191912 */   GIR_AddImm8, /*InsnID*//* 278(*/0x96, 0x02/*)*/, /*Imm*/4,
     /* 191916 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 278(*/0x96, 0x02/*)*/,
     /* 191919 */   GIR_MakeTempReg, /*TempRegID*//* 276(*/0x94, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191923 */   GIR_BuildMI, /*InsnID*//* 277(*/0x95, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 191928 */   GIR_AddTempRegister, /*InsnID*//* 277(*/0x95, 0x02/*)*/, /*TempRegID*//* 276(*/0x94, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191935 */   GIR_AddSimpleTempRegister, /*InsnID*//* 277(*/0x95, 0x02/*)*/, /*TempRegID*//* 277(*/0x95, 0x02/*)*/,
     /* 191940 */   GIR_AddSimpleTempRegister, /*InsnID*//* 277(*/0x95, 0x02/*)*/, /*TempRegID*//* 335(*/0xCF, 0x02/*)*/,
     /* 191945 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 277(*/0x95, 0x02/*)*/,
     /* 191948 */   GIR_MakeTempReg, /*TempRegID*//* 275(*/0x93, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191952 */   GIR_BuildMI, /*InsnID*//* 276(*/0x94, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 191957 */   GIR_AddTempRegister, /*InsnID*//* 276(*/0x94, 0x02/*)*/, /*TempRegID*//* 275(*/0x93, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191964 */   GIR_AddSimpleTempRegister, /*InsnID*//* 276(*/0x94, 0x02/*)*/, /*TempRegID*//* 276(*/0x94, 0x02/*)*/,
     /* 191969 */   GIR_AddSimpleTempRegister, /*InsnID*//* 276(*/0x94, 0x02/*)*/, /*TempRegID*//* 342(*/0xD6, 0x02/*)*/,
     /* 191974 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 276(*/0x94, 0x02/*)*/,
     /* 191977 */   GIR_MakeTempReg, /*TempRegID*//* 547(*/0xA3, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 191981 */   GIR_BuildMI, /*InsnID*//* 548(*/0xA4, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 191986 */   GIR_AddTempRegister, /*InsnID*//* 548(*/0xA4, 0x04/*)*/, /*TempRegID*//* 547(*/0xA3, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191993 */   GIR_AddImm, /*InsnID*//* 548(*/0xA4, 0x04/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 192004 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 548(*/0xA4, 0x04/*)*/,
     /* 192007 */   GIR_MakeTempReg, /*TempRegID*//* 546(*/0xA2, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 192011 */   GIR_BuildMI, /*InsnID*//* 547(*/0xA3, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 192016 */   GIR_AddTempRegister, /*InsnID*//* 547(*/0xA3, 0x04/*)*/, /*TempRegID*//* 546(*/0xA2, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192023 */   GIR_AddSimpleTempRegister, /*InsnID*//* 547(*/0xA3, 0x04/*)*/, /*TempRegID*//* 547(*/0xA3, 0x04/*)*/,
     /* 192028 */   GIR_AddImm, /*InsnID*//* 547(*/0xA3, 0x04/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 192039 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 547(*/0xA3, 0x04/*)*/,
     /* 192042 */   GIR_MakeTempReg, /*TempRegID*//* 545(*/0xA1, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 192046 */   GIR_BuildMI, /*InsnID*//* 546(*/0xA2, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 192051 */   GIR_AddTempRegister, /*InsnID*//* 546(*/0xA2, 0x04/*)*/, /*TempRegID*//* 545(*/0xA1, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192058 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 546(*/0xA2, 0x04/*)*/,
     /* 192061 */   GIR_MakeTempReg, /*TempRegID*//* 544(*/0xA0, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 192065 */   GIR_BuildMI, /*InsnID*//* 545(*/0xA1, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 192070 */   GIR_AddTempRegister, /*InsnID*//* 545(*/0xA1, 0x04/*)*/, /*TempRegID*//* 544(*/0xA0, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192077 */   GIR_AddSimpleTempRegister, /*InsnID*//* 545(*/0xA1, 0x04/*)*/, /*TempRegID*//* 545(*/0xA1, 0x04/*)*/,
     /* 192082 */   GIR_AddSimpleTempRegister, /*InsnID*//* 545(*/0xA1, 0x04/*)*/, /*TempRegID*//* 546(*/0xA2, 0x04/*)*/,
     /* 192087 */   GIR_AddImm8, /*InsnID*//* 545(*/0xA1, 0x04/*)*/, /*Imm*/1,
     /* 192091 */   GIR_ConstrainOperandRC, /*InsnID*//* 545(*/0xA1, 0x04/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 192097 */   GIR_ConstrainOperandRC, /*InsnID*//* 545(*/0xA1, 0x04/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 192103 */   GIR_ConstrainOperandRC, /*InsnID*//* 545(*/0xA1, 0x04/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 192109 */   GIR_MakeTempReg, /*TempRegID*//* 543(*/0x9F, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 192113 */   GIR_BuildMI, /*InsnID*//* 544(*/0xA0, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 192118 */   GIR_AddTempRegister, /*InsnID*//* 544(*/0xA0, 0x04/*)*/, /*TempRegID*//* 543(*/0x9F, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192125 */   GIR_AddSimpleTempRegister, /*InsnID*//* 544(*/0xA0, 0x04/*)*/, /*TempRegID*//* 544(*/0xA0, 0x04/*)*/,
     /* 192130 */   GIR_AddImm8, /*InsnID*//* 544(*/0xA0, 0x04/*)*/, /*Imm*/32,
     /* 192134 */   GIR_AddImm8, /*InsnID*//* 544(*/0xA0, 0x04/*)*/, /*Imm*/31,
     /* 192138 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 544(*/0xA0, 0x04/*)*/,
     /* 192141 */   GIR_MakeTempReg, /*TempRegID*//* 542(*/0x9E, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 192145 */   GIR_BuildMI, /*InsnID*//* 543(*/0x9F, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 192150 */   GIR_AddTempRegister, /*InsnID*//* 543(*/0x9F, 0x04/*)*/, /*TempRegID*//* 542(*/0x9E, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192157 */   GIR_AddSimpleTempRegister, /*InsnID*//* 543(*/0x9F, 0x04/*)*/, /*TempRegID*//* 543(*/0x9F, 0x04/*)*/,
     /* 192162 */   GIR_AddImm, /*InsnID*//* 543(*/0x9F, 0x04/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 192173 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 543(*/0x9F, 0x04/*)*/,
     /* 192176 */   GIR_MakeTempReg, /*TempRegID*//* 541(*/0x9D, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 192180 */   GIR_BuildMI, /*InsnID*//* 542(*/0x9E, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 192185 */   GIR_AddTempRegister, /*InsnID*//* 542(*/0x9E, 0x04/*)*/, /*TempRegID*//* 541(*/0x9D, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192192 */   GIR_AddSimpleTempRegister, /*InsnID*//* 542(*/0x9E, 0x04/*)*/, /*TempRegID*//* 542(*/0x9E, 0x04/*)*/,
     /* 192197 */   GIR_AddImm, /*InsnID*//* 542(*/0x9E, 0x04/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 192208 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 542(*/0x9E, 0x04/*)*/,
     /* 192211 */   GIR_MakeTempReg, /*TempRegID*//* 540(*/0x9C, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 192215 */   GIR_BuildMI, /*InsnID*//* 541(*/0x9D, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 192220 */   GIR_AddTempRegister, /*InsnID*//* 541(*/0x9D, 0x04/*)*/, /*TempRegID*//* 540(*/0x9C, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192227 */   GIR_AddImm, /*InsnID*//* 541(*/0x9D, 0x04/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 192238 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 541(*/0x9D, 0x04/*)*/,
     /* 192241 */   GIR_MakeTempReg, /*TempRegID*//* 539(*/0x9B, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 192245 */   GIR_BuildMI, /*InsnID*//* 540(*/0x9C, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 192250 */   GIR_AddTempRegister, /*InsnID*//* 540(*/0x9C, 0x04/*)*/, /*TempRegID*//* 539(*/0x9B, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192257 */   GIR_AddSimpleTempRegister, /*InsnID*//* 540(*/0x9C, 0x04/*)*/, /*TempRegID*//* 540(*/0x9C, 0x04/*)*/,
     /* 192262 */   GIR_AddImm, /*InsnID*//* 540(*/0x9C, 0x04/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 192273 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 540(*/0x9C, 0x04/*)*/,
     /* 192276 */   GIR_MakeTempReg, /*TempRegID*//* 538(*/0x9A, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 192280 */   GIR_BuildMI, /*InsnID*//* 539(*/0x9B, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 192285 */   GIR_AddTempRegister, /*InsnID*//* 539(*/0x9B, 0x04/*)*/, /*TempRegID*//* 538(*/0x9A, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192292 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 539(*/0x9B, 0x04/*)*/,
     /* 192295 */   GIR_MakeTempReg, /*TempRegID*//* 537(*/0x99, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 192299 */   GIR_BuildMI, /*InsnID*//* 538(*/0x9A, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 192304 */   GIR_AddTempRegister, /*InsnID*//* 538(*/0x9A, 0x04/*)*/, /*TempRegID*//* 537(*/0x99, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192311 */   GIR_AddSimpleTempRegister, /*InsnID*//* 538(*/0x9A, 0x04/*)*/, /*TempRegID*//* 538(*/0x9A, 0x04/*)*/,
     /* 192316 */   GIR_AddSimpleTempRegister, /*InsnID*//* 538(*/0x9A, 0x04/*)*/, /*TempRegID*//* 539(*/0x9B, 0x04/*)*/,
     /* 192321 */   GIR_AddImm8, /*InsnID*//* 538(*/0x9A, 0x04/*)*/, /*Imm*/1,
     /* 192325 */   GIR_ConstrainOperandRC, /*InsnID*//* 538(*/0x9A, 0x04/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 192331 */   GIR_ConstrainOperandRC, /*InsnID*//* 538(*/0x9A, 0x04/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 192337 */   GIR_ConstrainOperandRC, /*InsnID*//* 538(*/0x9A, 0x04/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 192343 */   GIR_MakeTempReg, /*TempRegID*//* 536(*/0x98, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 192347 */   GIR_BuildMI, /*InsnID*//* 537(*/0x99, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 192352 */   GIR_AddTempRegister, /*InsnID*//* 537(*/0x99, 0x04/*)*/, /*TempRegID*//* 536(*/0x98, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192359 */   GIR_AddSimpleTempRegister, /*InsnID*//* 537(*/0x99, 0x04/*)*/, /*TempRegID*//* 537(*/0x99, 0x04/*)*/,
     /* 192364 */   GIR_AddImm8, /*InsnID*//* 537(*/0x99, 0x04/*)*/, /*Imm*/32,
     /* 192368 */   GIR_AddImm8, /*InsnID*//* 537(*/0x99, 0x04/*)*/, /*Imm*/31,
     /* 192372 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 537(*/0x99, 0x04/*)*/,
     /* 192375 */   GIR_MakeTempReg, /*TempRegID*//* 535(*/0x97, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 192379 */   GIR_BuildMI, /*InsnID*//* 536(*/0x98, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 192384 */   GIR_AddTempRegister, /*InsnID*//* 536(*/0x98, 0x04/*)*/, /*TempRegID*//* 535(*/0x97, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192391 */   GIR_AddSimpleTempRegister, /*InsnID*//* 536(*/0x98, 0x04/*)*/, /*TempRegID*//* 536(*/0x98, 0x04/*)*/,
     /* 192396 */   GIR_AddImm, /*InsnID*//* 536(*/0x98, 0x04/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 192407 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 536(*/0x98, 0x04/*)*/,
     /* 192410 */   GIR_MakeTempReg, /*TempRegID*//* 534(*/0x96, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 192414 */   GIR_BuildMI, /*InsnID*//* 535(*/0x97, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 192419 */   GIR_AddTempRegister, /*InsnID*//* 535(*/0x97, 0x04/*)*/, /*TempRegID*//* 534(*/0x96, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192426 */   GIR_AddSimpleTempRegister, /*InsnID*//* 535(*/0x97, 0x04/*)*/, /*TempRegID*//* 535(*/0x97, 0x04/*)*/,
     /* 192431 */   GIR_AddImm, /*InsnID*//* 535(*/0x97, 0x04/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 192442 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 535(*/0x97, 0x04/*)*/,
     /* 192445 */   GIR_MakeTempReg, /*TempRegID*//* 533(*/0x95, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 192449 */   GIR_BuildMI, /*InsnID*//* 534(*/0x96, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 192454 */   GIR_AddTempRegister, /*InsnID*//* 534(*/0x96, 0x04/*)*/, /*TempRegID*//* 533(*/0x95, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192461 */   GIR_AddImm, /*InsnID*//* 534(*/0x96, 0x04/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 192472 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 534(*/0x96, 0x04/*)*/,
     /* 192475 */   GIR_MakeTempReg, /*TempRegID*//* 532(*/0x94, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 192479 */   GIR_BuildMI, /*InsnID*//* 533(*/0x95, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 192484 */   GIR_AddTempRegister, /*InsnID*//* 533(*/0x95, 0x04/*)*/, /*TempRegID*//* 532(*/0x94, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192491 */   GIR_AddSimpleTempRegister, /*InsnID*//* 533(*/0x95, 0x04/*)*/, /*TempRegID*//* 533(*/0x95, 0x04/*)*/,
     /* 192496 */   GIR_AddImm, /*InsnID*//* 533(*/0x95, 0x04/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 192507 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 533(*/0x95, 0x04/*)*/,
     /* 192510 */   GIR_MakeTempReg, /*TempRegID*//* 531(*/0x93, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 192514 */   GIR_BuildMI, /*InsnID*//* 532(*/0x94, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 192519 */   GIR_AddTempRegister, /*InsnID*//* 532(*/0x94, 0x04/*)*/, /*TempRegID*//* 531(*/0x93, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192526 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 532(*/0x94, 0x04/*)*/,
     /* 192529 */   GIR_MakeTempReg, /*TempRegID*//* 530(*/0x92, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 192533 */   GIR_BuildMI, /*InsnID*//* 531(*/0x93, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 192538 */   GIR_AddTempRegister, /*InsnID*//* 531(*/0x93, 0x04/*)*/, /*TempRegID*//* 530(*/0x92, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192545 */   GIR_AddSimpleTempRegister, /*InsnID*//* 531(*/0x93, 0x04/*)*/, /*TempRegID*//* 531(*/0x93, 0x04/*)*/,
     /* 192550 */   GIR_AddSimpleTempRegister, /*InsnID*//* 531(*/0x93, 0x04/*)*/, /*TempRegID*//* 532(*/0x94, 0x04/*)*/,
     /* 192555 */   GIR_AddImm8, /*InsnID*//* 531(*/0x93, 0x04/*)*/, /*Imm*/1,
     /* 192559 */   GIR_ConstrainOperandRC, /*InsnID*//* 531(*/0x93, 0x04/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 192565 */   GIR_ConstrainOperandRC, /*InsnID*//* 531(*/0x93, 0x04/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 192571 */   GIR_ConstrainOperandRC, /*InsnID*//* 531(*/0x93, 0x04/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 192577 */   GIR_MakeTempReg, /*TempRegID*//* 529(*/0x91, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 192581 */   GIR_BuildMI, /*InsnID*//* 530(*/0x92, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 192586 */   GIR_AddTempRegister, /*InsnID*//* 530(*/0x92, 0x04/*)*/, /*TempRegID*//* 529(*/0x91, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192593 */   GIR_AddSimpleTempRegister, /*InsnID*//* 530(*/0x92, 0x04/*)*/, /*TempRegID*//* 530(*/0x92, 0x04/*)*/,
     /* 192598 */   GIR_AddImm8, /*InsnID*//* 530(*/0x92, 0x04/*)*/, /*Imm*/32,
     /* 192602 */   GIR_AddImm8, /*InsnID*//* 530(*/0x92, 0x04/*)*/, /*Imm*/31,
     /* 192606 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 530(*/0x92, 0x04/*)*/,
     /* 192609 */   GIR_MakeTempReg, /*TempRegID*//* 528(*/0x90, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 192613 */   GIR_BuildMI, /*InsnID*//* 529(*/0x91, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 192618 */   GIR_AddTempRegister, /*InsnID*//* 529(*/0x91, 0x04/*)*/, /*TempRegID*//* 528(*/0x90, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192625 */   GIR_AddSimpleTempRegister, /*InsnID*//* 529(*/0x91, 0x04/*)*/, /*TempRegID*//* 529(*/0x91, 0x04/*)*/,
     /* 192630 */   GIR_AddImm, /*InsnID*//* 529(*/0x91, 0x04/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 192641 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 529(*/0x91, 0x04/*)*/,
     /* 192644 */   GIR_MakeTempReg, /*TempRegID*//* 527(*/0x8F, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 192648 */   GIR_BuildMI, /*InsnID*//* 528(*/0x90, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 192653 */   GIR_AddTempRegister, /*InsnID*//* 528(*/0x90, 0x04/*)*/, /*TempRegID*//* 527(*/0x8F, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192660 */   GIR_AddSimpleTempRegister, /*InsnID*//* 528(*/0x90, 0x04/*)*/, /*TempRegID*//* 528(*/0x90, 0x04/*)*/,
     /* 192665 */   GIR_AddImm, /*InsnID*//* 528(*/0x90, 0x04/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 192676 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 528(*/0x90, 0x04/*)*/,
     /* 192679 */   GIR_MakeTempReg, /*TempRegID*//* 526(*/0x8E, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 192683 */   GIR_BuildMI, /*InsnID*//* 527(*/0x8F, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 192688 */   GIR_AddTempRegister, /*InsnID*//* 527(*/0x8F, 0x04/*)*/, /*TempRegID*//* 526(*/0x8E, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192695 */   GIR_Copy, /*NewInsnID*//* 527(*/0x8F, 0x04/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 192700 */   GIR_AddImm8, /*InsnID*//* 527(*/0x8F, 0x04/*)*/, /*Imm*/1,
     /* 192704 */   GIR_AddImm8, /*InsnID*//* 527(*/0x8F, 0x04/*)*/, /*Imm*/62,
     /* 192708 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 527(*/0x8F, 0x04/*)*/,
     /* 192711 */   GIR_MakeTempReg, /*TempRegID*//* 525(*/0x8D, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 192715 */   GIR_BuildMI, /*InsnID*//* 526(*/0x8E, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 192720 */   GIR_AddTempRegister, /*InsnID*//* 526(*/0x8E, 0x04/*)*/, /*TempRegID*//* 525(*/0x8D, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192727 */   GIR_AddSimpleTempRegister, /*InsnID*//* 526(*/0x8E, 0x04/*)*/, /*TempRegID*//* 526(*/0x8E, 0x04/*)*/,
     /* 192732 */   GIR_AddSimpleTempRegister, /*InsnID*//* 526(*/0x8E, 0x04/*)*/, /*TempRegID*//* 527(*/0x8F, 0x04/*)*/,
     /* 192737 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 526(*/0x8E, 0x04/*)*/,
     /* 192740 */   GIR_MakeTempReg, /*TempRegID*//* 524(*/0x8C, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 192744 */   GIR_BuildMI, /*InsnID*//* 525(*/0x8D, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 192749 */   GIR_AddTempRegister, /*InsnID*//* 525(*/0x8D, 0x04/*)*/, /*TempRegID*//* 524(*/0x8C, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192756 */   GIR_AddImm, /*InsnID*//* 525(*/0x8D, 0x04/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 192767 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 525(*/0x8D, 0x04/*)*/,
     /* 192770 */   GIR_MakeTempReg, /*TempRegID*//* 523(*/0x8B, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 192774 */   GIR_BuildMI, /*InsnID*//* 524(*/0x8C, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 192779 */   GIR_AddTempRegister, /*InsnID*//* 524(*/0x8C, 0x04/*)*/, /*TempRegID*//* 523(*/0x8B, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192786 */   GIR_AddSimpleTempRegister, /*InsnID*//* 524(*/0x8C, 0x04/*)*/, /*TempRegID*//* 524(*/0x8C, 0x04/*)*/,
     /* 192791 */   GIR_AddImm, /*InsnID*//* 524(*/0x8C, 0x04/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 192802 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 524(*/0x8C, 0x04/*)*/,
     /* 192805 */   GIR_MakeTempReg, /*TempRegID*//* 522(*/0x8A, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 192809 */   GIR_BuildMI, /*InsnID*//* 523(*/0x8B, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 192814 */   GIR_AddTempRegister, /*InsnID*//* 523(*/0x8B, 0x04/*)*/, /*TempRegID*//* 522(*/0x8A, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192821 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 523(*/0x8B, 0x04/*)*/,
     /* 192824 */   GIR_MakeTempReg, /*TempRegID*//* 521(*/0x89, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 192828 */   GIR_BuildMI, /*InsnID*//* 522(*/0x8A, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 192833 */   GIR_AddTempRegister, /*InsnID*//* 522(*/0x8A, 0x04/*)*/, /*TempRegID*//* 521(*/0x89, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192840 */   GIR_AddSimpleTempRegister, /*InsnID*//* 522(*/0x8A, 0x04/*)*/, /*TempRegID*//* 522(*/0x8A, 0x04/*)*/,
     /* 192845 */   GIR_AddSimpleTempRegister, /*InsnID*//* 522(*/0x8A, 0x04/*)*/, /*TempRegID*//* 523(*/0x8B, 0x04/*)*/,
     /* 192850 */   GIR_AddImm8, /*InsnID*//* 522(*/0x8A, 0x04/*)*/, /*Imm*/1,
     /* 192854 */   GIR_ConstrainOperandRC, /*InsnID*//* 522(*/0x8A, 0x04/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 192860 */   GIR_ConstrainOperandRC, /*InsnID*//* 522(*/0x8A, 0x04/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 192866 */   GIR_ConstrainOperandRC, /*InsnID*//* 522(*/0x8A, 0x04/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 192872 */   GIR_MakeTempReg, /*TempRegID*//* 520(*/0x88, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 192876 */   GIR_BuildMI, /*InsnID*//* 521(*/0x89, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 192881 */   GIR_AddTempRegister, /*InsnID*//* 521(*/0x89, 0x04/*)*/, /*TempRegID*//* 520(*/0x88, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192888 */   GIR_AddSimpleTempRegister, /*InsnID*//* 521(*/0x89, 0x04/*)*/, /*TempRegID*//* 521(*/0x89, 0x04/*)*/,
     /* 192893 */   GIR_AddImm8, /*InsnID*//* 521(*/0x89, 0x04/*)*/, /*Imm*/32,
     /* 192897 */   GIR_AddImm8, /*InsnID*//* 521(*/0x89, 0x04/*)*/, /*Imm*/31,
     /* 192901 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 521(*/0x89, 0x04/*)*/,
     /* 192904 */   GIR_MakeTempReg, /*TempRegID*//* 519(*/0x87, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 192908 */   GIR_BuildMI, /*InsnID*//* 520(*/0x88, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 192913 */   GIR_AddTempRegister, /*InsnID*//* 520(*/0x88, 0x04/*)*/, /*TempRegID*//* 519(*/0x87, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192920 */   GIR_AddSimpleTempRegister, /*InsnID*//* 520(*/0x88, 0x04/*)*/, /*TempRegID*//* 520(*/0x88, 0x04/*)*/,
     /* 192925 */   GIR_AddImm, /*InsnID*//* 520(*/0x88, 0x04/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 192936 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 520(*/0x88, 0x04/*)*/,
     /* 192939 */   GIR_MakeTempReg, /*TempRegID*//* 518(*/0x86, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 192943 */   GIR_BuildMI, /*InsnID*//* 519(*/0x87, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 192948 */   GIR_AddTempRegister, /*InsnID*//* 519(*/0x87, 0x04/*)*/, /*TempRegID*//* 518(*/0x86, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192955 */   GIR_AddSimpleTempRegister, /*InsnID*//* 519(*/0x87, 0x04/*)*/, /*TempRegID*//* 519(*/0x87, 0x04/*)*/,
     /* 192960 */   GIR_AddImm, /*InsnID*//* 519(*/0x87, 0x04/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 192971 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 519(*/0x87, 0x04/*)*/,
     /* 192974 */   GIR_MakeTempReg, /*TempRegID*//* 517(*/0x85, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 192978 */   GIR_BuildMI, /*InsnID*//* 518(*/0x86, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 192983 */   GIR_AddTempRegister, /*InsnID*//* 518(*/0x86, 0x04/*)*/, /*TempRegID*//* 517(*/0x85, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192990 */   GIR_Copy, /*NewInsnID*//* 518(*/0x86, 0x04/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 192995 */   GIR_AddImm8, /*InsnID*//* 518(*/0x86, 0x04/*)*/, /*Imm*/63,
     /* 192999 */   GIR_AddImm8, /*InsnID*//* 518(*/0x86, 0x04/*)*/, /*Imm*/1,
     /* 193003 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 518(*/0x86, 0x04/*)*/,
     /* 193006 */   GIR_MakeTempReg, /*TempRegID*//* 516(*/0x84, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 193010 */   GIR_BuildMI, /*InsnID*//* 517(*/0x85, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 193015 */   GIR_AddTempRegister, /*InsnID*//* 517(*/0x85, 0x04/*)*/, /*TempRegID*//* 516(*/0x84, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193022 */   GIR_AddSimpleTempRegister, /*InsnID*//* 517(*/0x85, 0x04/*)*/, /*TempRegID*//* 517(*/0x85, 0x04/*)*/,
     /* 193027 */   GIR_AddSimpleTempRegister, /*InsnID*//* 517(*/0x85, 0x04/*)*/, /*TempRegID*//* 518(*/0x86, 0x04/*)*/,
     /* 193032 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 517(*/0x85, 0x04/*)*/,
     /* 193035 */   GIR_MakeTempReg, /*TempRegID*//* 515(*/0x83, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 193039 */   GIR_BuildMI, /*InsnID*//* 516(*/0x84, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 193044 */   GIR_AddTempRegister, /*InsnID*//* 516(*/0x84, 0x04/*)*/, /*TempRegID*//* 515(*/0x83, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193051 */   GIR_AddSimpleTempRegister, /*InsnID*//* 516(*/0x84, 0x04/*)*/, /*TempRegID*//* 516(*/0x84, 0x04/*)*/,
     /* 193056 */   GIR_AddSimpleTempRegister, /*InsnID*//* 516(*/0x84, 0x04/*)*/, /*TempRegID*//* 525(*/0x8D, 0x04/*)*/,
     /* 193061 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 516(*/0x84, 0x04/*)*/,
     /* 193064 */   GIR_MakeTempReg, /*TempRegID*//* 514(*/0x82, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 193068 */   GIR_BuildMI, /*InsnID*//* 515(*/0x83, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 193073 */   GIR_AddTempRegister, /*InsnID*//* 515(*/0x83, 0x04/*)*/, /*TempRegID*//* 514(*/0x82, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193080 */   GIR_AddSimpleTempRegister, /*InsnID*//* 515(*/0x83, 0x04/*)*/, /*TempRegID*//* 515(*/0x83, 0x04/*)*/,
     /* 193085 */   GIR_AddImm8, /*InsnID*//* 515(*/0x83, 0x04/*)*/, /*Imm*/2,
     /* 193089 */   GIR_AddImm8, /*InsnID*//* 515(*/0x83, 0x04/*)*/, /*Imm*/61,
     /* 193093 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 515(*/0x83, 0x04/*)*/,
     /* 193096 */   GIR_MakeTempReg, /*TempRegID*//* 513(*/0x81, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 193100 */   GIR_BuildMI, /*InsnID*//* 514(*/0x82, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 193105 */   GIR_AddTempRegister, /*InsnID*//* 514(*/0x82, 0x04/*)*/, /*TempRegID*//* 513(*/0x81, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193112 */   GIR_AddSimpleTempRegister, /*InsnID*//* 514(*/0x82, 0x04/*)*/, /*TempRegID*//* 514(*/0x82, 0x04/*)*/,
     /* 193117 */   GIR_AddSimpleTempRegister, /*InsnID*//* 514(*/0x82, 0x04/*)*/, /*TempRegID*//* 534(*/0x96, 0x04/*)*/,
     /* 193122 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 514(*/0x82, 0x04/*)*/,
     /* 193125 */   GIR_MakeTempReg, /*TempRegID*//* 512(*/0x80, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 193129 */   GIR_BuildMI, /*InsnID*//* 513(*/0x81, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 193134 */   GIR_AddTempRegister, /*InsnID*//* 513(*/0x81, 0x04/*)*/, /*TempRegID*//* 512(*/0x80, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193141 */   GIR_AddImm, /*InsnID*//* 513(*/0x81, 0x04/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 193152 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 513(*/0x81, 0x04/*)*/,
     /* 193155 */   GIR_MakeTempReg, /*TempRegID*//* 511(*/0xFF, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 193159 */   GIR_BuildMI, /*InsnID*//* 512(*/0x80, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 193164 */   GIR_AddTempRegister, /*InsnID*//* 512(*/0x80, 0x04/*)*/, /*TempRegID*//* 511(*/0xFF, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193171 */   GIR_AddSimpleTempRegister, /*InsnID*//* 512(*/0x80, 0x04/*)*/, /*TempRegID*//* 512(*/0x80, 0x04/*)*/,
     /* 193176 */   GIR_AddImm, /*InsnID*//* 512(*/0x80, 0x04/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 193187 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 512(*/0x80, 0x04/*)*/,
     /* 193190 */   GIR_MakeTempReg, /*TempRegID*//* 510(*/0xFE, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 193194 */   GIR_BuildMI, /*InsnID*//* 511(*/0xFF, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 193199 */   GIR_AddTempRegister, /*InsnID*//* 511(*/0xFF, 0x03/*)*/, /*TempRegID*//* 510(*/0xFE, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193206 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 511(*/0xFF, 0x03/*)*/,
     /* 193209 */   GIR_MakeTempReg, /*TempRegID*//* 509(*/0xFD, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 193213 */   GIR_BuildMI, /*InsnID*//* 510(*/0xFE, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 193218 */   GIR_AddTempRegister, /*InsnID*//* 510(*/0xFE, 0x03/*)*/, /*TempRegID*//* 509(*/0xFD, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193225 */   GIR_AddSimpleTempRegister, /*InsnID*//* 510(*/0xFE, 0x03/*)*/, /*TempRegID*//* 510(*/0xFE, 0x03/*)*/,
     /* 193230 */   GIR_AddSimpleTempRegister, /*InsnID*//* 510(*/0xFE, 0x03/*)*/, /*TempRegID*//* 511(*/0xFF, 0x03/*)*/,
     /* 193235 */   GIR_AddImm8, /*InsnID*//* 510(*/0xFE, 0x03/*)*/, /*Imm*/1,
     /* 193239 */   GIR_ConstrainOperandRC, /*InsnID*//* 510(*/0xFE, 0x03/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 193245 */   GIR_ConstrainOperandRC, /*InsnID*//* 510(*/0xFE, 0x03/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 193251 */   GIR_ConstrainOperandRC, /*InsnID*//* 510(*/0xFE, 0x03/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 193257 */   GIR_MakeTempReg, /*TempRegID*//* 508(*/0xFC, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 193261 */   GIR_BuildMI, /*InsnID*//* 509(*/0xFD, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 193266 */   GIR_AddTempRegister, /*InsnID*//* 509(*/0xFD, 0x03/*)*/, /*TempRegID*//* 508(*/0xFC, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193273 */   GIR_AddSimpleTempRegister, /*InsnID*//* 509(*/0xFD, 0x03/*)*/, /*TempRegID*//* 509(*/0xFD, 0x03/*)*/,
     /* 193278 */   GIR_AddImm8, /*InsnID*//* 509(*/0xFD, 0x03/*)*/, /*Imm*/32,
     /* 193282 */   GIR_AddImm8, /*InsnID*//* 509(*/0xFD, 0x03/*)*/, /*Imm*/31,
     /* 193286 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 509(*/0xFD, 0x03/*)*/,
     /* 193289 */   GIR_MakeTempReg, /*TempRegID*//* 507(*/0xFB, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 193293 */   GIR_BuildMI, /*InsnID*//* 508(*/0xFC, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 193298 */   GIR_AddTempRegister, /*InsnID*//* 508(*/0xFC, 0x03/*)*/, /*TempRegID*//* 507(*/0xFB, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193305 */   GIR_AddSimpleTempRegister, /*InsnID*//* 508(*/0xFC, 0x03/*)*/, /*TempRegID*//* 508(*/0xFC, 0x03/*)*/,
     /* 193310 */   GIR_AddImm, /*InsnID*//* 508(*/0xFC, 0x03/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 193321 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 508(*/0xFC, 0x03/*)*/,
     /* 193324 */   GIR_MakeTempReg, /*TempRegID*//* 506(*/0xFA, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 193328 */   GIR_BuildMI, /*InsnID*//* 507(*/0xFB, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 193333 */   GIR_AddTempRegister, /*InsnID*//* 507(*/0xFB, 0x03/*)*/, /*TempRegID*//* 506(*/0xFA, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193340 */   GIR_AddSimpleTempRegister, /*InsnID*//* 507(*/0xFB, 0x03/*)*/, /*TempRegID*//* 507(*/0xFB, 0x03/*)*/,
     /* 193345 */   GIR_AddImm, /*InsnID*//* 507(*/0xFB, 0x03/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 193356 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 507(*/0xFB, 0x03/*)*/,
     /* 193359 */   GIR_MakeTempReg, /*TempRegID*//* 505(*/0xF9, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 193363 */   GIR_BuildMI, /*InsnID*//* 506(*/0xFA, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 193368 */   GIR_AddTempRegister, /*InsnID*//* 506(*/0xFA, 0x03/*)*/, /*TempRegID*//* 505(*/0xF9, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193375 */   GIR_AddImm, /*InsnID*//* 506(*/0xFA, 0x03/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 193386 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 506(*/0xFA, 0x03/*)*/,
     /* 193389 */   GIR_MakeTempReg, /*TempRegID*//* 504(*/0xF8, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 193393 */   GIR_BuildMI, /*InsnID*//* 505(*/0xF9, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 193398 */   GIR_AddTempRegister, /*InsnID*//* 505(*/0xF9, 0x03/*)*/, /*TempRegID*//* 504(*/0xF8, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193405 */   GIR_AddSimpleTempRegister, /*InsnID*//* 505(*/0xF9, 0x03/*)*/, /*TempRegID*//* 505(*/0xF9, 0x03/*)*/,
     /* 193410 */   GIR_AddImm, /*InsnID*//* 505(*/0xF9, 0x03/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 193421 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 505(*/0xF9, 0x03/*)*/,
     /* 193424 */   GIR_MakeTempReg, /*TempRegID*//* 503(*/0xF7, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 193428 */   GIR_BuildMI, /*InsnID*//* 504(*/0xF8, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 193433 */   GIR_AddTempRegister, /*InsnID*//* 504(*/0xF8, 0x03/*)*/, /*TempRegID*//* 503(*/0xF7, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193440 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 504(*/0xF8, 0x03/*)*/,
     /* 193443 */   GIR_MakeTempReg, /*TempRegID*//* 502(*/0xF6, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 193447 */   GIR_BuildMI, /*InsnID*//* 503(*/0xF7, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 193452 */   GIR_AddTempRegister, /*InsnID*//* 503(*/0xF7, 0x03/*)*/, /*TempRegID*//* 502(*/0xF6, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193459 */   GIR_AddSimpleTempRegister, /*InsnID*//* 503(*/0xF7, 0x03/*)*/, /*TempRegID*//* 503(*/0xF7, 0x03/*)*/,
     /* 193464 */   GIR_AddSimpleTempRegister, /*InsnID*//* 503(*/0xF7, 0x03/*)*/, /*TempRegID*//* 504(*/0xF8, 0x03/*)*/,
     /* 193469 */   GIR_AddImm8, /*InsnID*//* 503(*/0xF7, 0x03/*)*/, /*Imm*/1,
     /* 193473 */   GIR_ConstrainOperandRC, /*InsnID*//* 503(*/0xF7, 0x03/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 193479 */   GIR_ConstrainOperandRC, /*InsnID*//* 503(*/0xF7, 0x03/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 193485 */   GIR_ConstrainOperandRC, /*InsnID*//* 503(*/0xF7, 0x03/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 193491 */   GIR_MakeTempReg, /*TempRegID*//* 501(*/0xF5, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 193495 */   GIR_BuildMI, /*InsnID*//* 502(*/0xF6, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 193500 */   GIR_AddTempRegister, /*InsnID*//* 502(*/0xF6, 0x03/*)*/, /*TempRegID*//* 501(*/0xF5, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193507 */   GIR_AddSimpleTempRegister, /*InsnID*//* 502(*/0xF6, 0x03/*)*/, /*TempRegID*//* 502(*/0xF6, 0x03/*)*/,
     /* 193512 */   GIR_AddImm8, /*InsnID*//* 502(*/0xF6, 0x03/*)*/, /*Imm*/32,
     /* 193516 */   GIR_AddImm8, /*InsnID*//* 502(*/0xF6, 0x03/*)*/, /*Imm*/31,
     /* 193520 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 502(*/0xF6, 0x03/*)*/,
     /* 193523 */   GIR_MakeTempReg, /*TempRegID*//* 500(*/0xF4, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 193527 */   GIR_BuildMI, /*InsnID*//* 501(*/0xF5, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 193532 */   GIR_AddTempRegister, /*InsnID*//* 501(*/0xF5, 0x03/*)*/, /*TempRegID*//* 500(*/0xF4, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193539 */   GIR_AddSimpleTempRegister, /*InsnID*//* 501(*/0xF5, 0x03/*)*/, /*TempRegID*//* 501(*/0xF5, 0x03/*)*/,
     /* 193544 */   GIR_AddImm, /*InsnID*//* 501(*/0xF5, 0x03/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 193555 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 501(*/0xF5, 0x03/*)*/,
     /* 193558 */   GIR_MakeTempReg, /*TempRegID*//* 499(*/0xF3, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 193562 */   GIR_BuildMI, /*InsnID*//* 500(*/0xF4, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 193567 */   GIR_AddTempRegister, /*InsnID*//* 500(*/0xF4, 0x03/*)*/, /*TempRegID*//* 499(*/0xF3, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193574 */   GIR_AddSimpleTempRegister, /*InsnID*//* 500(*/0xF4, 0x03/*)*/, /*TempRegID*//* 500(*/0xF4, 0x03/*)*/,
     /* 193579 */   GIR_AddImm, /*InsnID*//* 500(*/0xF4, 0x03/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 193590 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 500(*/0xF4, 0x03/*)*/,
     /* 193593 */   GIR_MakeTempReg, /*TempRegID*//* 498(*/0xF2, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 193597 */   GIR_BuildMI, /*InsnID*//* 499(*/0xF3, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 193602 */   GIR_AddTempRegister, /*InsnID*//* 499(*/0xF3, 0x03/*)*/, /*TempRegID*//* 498(*/0xF2, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193609 */   GIR_Copy, /*NewInsnID*//* 499(*/0xF3, 0x03/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 193614 */   GIR_AddImm8, /*InsnID*//* 499(*/0xF3, 0x03/*)*/, /*Imm*/1,
     /* 193618 */   GIR_AddImm8, /*InsnID*//* 499(*/0xF3, 0x03/*)*/, /*Imm*/62,
     /* 193622 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 499(*/0xF3, 0x03/*)*/,
     /* 193625 */   GIR_MakeTempReg, /*TempRegID*//* 497(*/0xF1, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 193629 */   GIR_BuildMI, /*InsnID*//* 498(*/0xF2, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 193634 */   GIR_AddTempRegister, /*InsnID*//* 498(*/0xF2, 0x03/*)*/, /*TempRegID*//* 497(*/0xF1, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193641 */   GIR_AddSimpleTempRegister, /*InsnID*//* 498(*/0xF2, 0x03/*)*/, /*TempRegID*//* 498(*/0xF2, 0x03/*)*/,
     /* 193646 */   GIR_AddSimpleTempRegister, /*InsnID*//* 498(*/0xF2, 0x03/*)*/, /*TempRegID*//* 499(*/0xF3, 0x03/*)*/,
     /* 193651 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 498(*/0xF2, 0x03/*)*/,
     /* 193654 */   GIR_MakeTempReg, /*TempRegID*//* 496(*/0xF0, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 193658 */   GIR_BuildMI, /*InsnID*//* 497(*/0xF1, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 193663 */   GIR_AddTempRegister, /*InsnID*//* 497(*/0xF1, 0x03/*)*/, /*TempRegID*//* 496(*/0xF0, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193670 */   GIR_AddImm, /*InsnID*//* 497(*/0xF1, 0x03/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 193681 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 497(*/0xF1, 0x03/*)*/,
     /* 193684 */   GIR_MakeTempReg, /*TempRegID*//* 495(*/0xEF, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 193688 */   GIR_BuildMI, /*InsnID*//* 496(*/0xF0, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 193693 */   GIR_AddTempRegister, /*InsnID*//* 496(*/0xF0, 0x03/*)*/, /*TempRegID*//* 495(*/0xEF, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193700 */   GIR_AddSimpleTempRegister, /*InsnID*//* 496(*/0xF0, 0x03/*)*/, /*TempRegID*//* 496(*/0xF0, 0x03/*)*/,
     /* 193705 */   GIR_AddImm, /*InsnID*//* 496(*/0xF0, 0x03/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 193716 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 496(*/0xF0, 0x03/*)*/,
     /* 193719 */   GIR_MakeTempReg, /*TempRegID*//* 494(*/0xEE, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 193723 */   GIR_BuildMI, /*InsnID*//* 495(*/0xEF, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 193728 */   GIR_AddTempRegister, /*InsnID*//* 495(*/0xEF, 0x03/*)*/, /*TempRegID*//* 494(*/0xEE, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193735 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 495(*/0xEF, 0x03/*)*/,
     /* 193738 */   GIR_MakeTempReg, /*TempRegID*//* 493(*/0xED, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 193742 */   GIR_BuildMI, /*InsnID*//* 494(*/0xEE, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 193747 */   GIR_AddTempRegister, /*InsnID*//* 494(*/0xEE, 0x03/*)*/, /*TempRegID*//* 493(*/0xED, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193754 */   GIR_AddSimpleTempRegister, /*InsnID*//* 494(*/0xEE, 0x03/*)*/, /*TempRegID*//* 494(*/0xEE, 0x03/*)*/,
     /* 193759 */   GIR_AddSimpleTempRegister, /*InsnID*//* 494(*/0xEE, 0x03/*)*/, /*TempRegID*//* 495(*/0xEF, 0x03/*)*/,
     /* 193764 */   GIR_AddImm8, /*InsnID*//* 494(*/0xEE, 0x03/*)*/, /*Imm*/1,
     /* 193768 */   GIR_ConstrainOperandRC, /*InsnID*//* 494(*/0xEE, 0x03/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 193774 */   GIR_ConstrainOperandRC, /*InsnID*//* 494(*/0xEE, 0x03/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 193780 */   GIR_ConstrainOperandRC, /*InsnID*//* 494(*/0xEE, 0x03/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 193786 */   GIR_MakeTempReg, /*TempRegID*//* 492(*/0xEC, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 193790 */   GIR_BuildMI, /*InsnID*//* 493(*/0xED, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 193795 */   GIR_AddTempRegister, /*InsnID*//* 493(*/0xED, 0x03/*)*/, /*TempRegID*//* 492(*/0xEC, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193802 */   GIR_AddSimpleTempRegister, /*InsnID*//* 493(*/0xED, 0x03/*)*/, /*TempRegID*//* 493(*/0xED, 0x03/*)*/,
     /* 193807 */   GIR_AddImm8, /*InsnID*//* 493(*/0xED, 0x03/*)*/, /*Imm*/32,
     /* 193811 */   GIR_AddImm8, /*InsnID*//* 493(*/0xED, 0x03/*)*/, /*Imm*/31,
     /* 193815 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 493(*/0xED, 0x03/*)*/,
     /* 193818 */   GIR_MakeTempReg, /*TempRegID*//* 491(*/0xEB, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 193822 */   GIR_BuildMI, /*InsnID*//* 492(*/0xEC, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 193827 */   GIR_AddTempRegister, /*InsnID*//* 492(*/0xEC, 0x03/*)*/, /*TempRegID*//* 491(*/0xEB, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193834 */   GIR_AddSimpleTempRegister, /*InsnID*//* 492(*/0xEC, 0x03/*)*/, /*TempRegID*//* 492(*/0xEC, 0x03/*)*/,
     /* 193839 */   GIR_AddImm, /*InsnID*//* 492(*/0xEC, 0x03/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 193850 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 492(*/0xEC, 0x03/*)*/,
     /* 193853 */   GIR_MakeTempReg, /*TempRegID*//* 490(*/0xEA, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 193857 */   GIR_BuildMI, /*InsnID*//* 491(*/0xEB, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 193862 */   GIR_AddTempRegister, /*InsnID*//* 491(*/0xEB, 0x03/*)*/, /*TempRegID*//* 490(*/0xEA, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193869 */   GIR_AddSimpleTempRegister, /*InsnID*//* 491(*/0xEB, 0x03/*)*/, /*TempRegID*//* 491(*/0xEB, 0x03/*)*/,
     /* 193874 */   GIR_AddImm, /*InsnID*//* 491(*/0xEB, 0x03/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 193885 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 491(*/0xEB, 0x03/*)*/,
     /* 193888 */   GIR_MakeTempReg, /*TempRegID*//* 489(*/0xE9, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 193892 */   GIR_BuildMI, /*InsnID*//* 490(*/0xEA, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 193897 */   GIR_AddTempRegister, /*InsnID*//* 490(*/0xEA, 0x03/*)*/, /*TempRegID*//* 489(*/0xE9, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193904 */   GIR_Copy, /*NewInsnID*//* 490(*/0xEA, 0x03/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 193909 */   GIR_AddImm8, /*InsnID*//* 490(*/0xEA, 0x03/*)*/, /*Imm*/63,
     /* 193913 */   GIR_AddImm8, /*InsnID*//* 490(*/0xEA, 0x03/*)*/, /*Imm*/1,
     /* 193917 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 490(*/0xEA, 0x03/*)*/,
     /* 193920 */   GIR_MakeTempReg, /*TempRegID*//* 488(*/0xE8, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 193924 */   GIR_BuildMI, /*InsnID*//* 489(*/0xE9, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 193929 */   GIR_AddTempRegister, /*InsnID*//* 489(*/0xE9, 0x03/*)*/, /*TempRegID*//* 488(*/0xE8, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193936 */   GIR_AddSimpleTempRegister, /*InsnID*//* 489(*/0xE9, 0x03/*)*/, /*TempRegID*//* 489(*/0xE9, 0x03/*)*/,
     /* 193941 */   GIR_AddSimpleTempRegister, /*InsnID*//* 489(*/0xE9, 0x03/*)*/, /*TempRegID*//* 490(*/0xEA, 0x03/*)*/,
     /* 193946 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 489(*/0xE9, 0x03/*)*/,
     /* 193949 */   GIR_MakeTempReg, /*TempRegID*//* 487(*/0xE7, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 193953 */   GIR_BuildMI, /*InsnID*//* 488(*/0xE8, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 193958 */   GIR_AddTempRegister, /*InsnID*//* 488(*/0xE8, 0x03/*)*/, /*TempRegID*//* 487(*/0xE7, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193965 */   GIR_AddSimpleTempRegister, /*InsnID*//* 488(*/0xE8, 0x03/*)*/, /*TempRegID*//* 488(*/0xE8, 0x03/*)*/,
     /* 193970 */   GIR_AddSimpleTempRegister, /*InsnID*//* 488(*/0xE8, 0x03/*)*/, /*TempRegID*//* 497(*/0xF1, 0x03/*)*/,
     /* 193975 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 488(*/0xE8, 0x03/*)*/,
     /* 193978 */   GIR_MakeTempReg, /*TempRegID*//* 486(*/0xE6, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 193982 */   GIR_BuildMI, /*InsnID*//* 487(*/0xE7, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 193987 */   GIR_AddTempRegister, /*InsnID*//* 487(*/0xE7, 0x03/*)*/, /*TempRegID*//* 486(*/0xE6, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193994 */   GIR_AddSimpleTempRegister, /*InsnID*//* 487(*/0xE7, 0x03/*)*/, /*TempRegID*//* 487(*/0xE7, 0x03/*)*/,
     /* 193999 */   GIR_AddImm8, /*InsnID*//* 487(*/0xE7, 0x03/*)*/, /*Imm*/62,
     /* 194003 */   GIR_AddImm8, /*InsnID*//* 487(*/0xE7, 0x03/*)*/, /*Imm*/2,
     /* 194007 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 487(*/0xE7, 0x03/*)*/,
     /* 194010 */   GIR_MakeTempReg, /*TempRegID*//* 485(*/0xE5, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 194014 */   GIR_BuildMI, /*InsnID*//* 486(*/0xE6, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 194019 */   GIR_AddTempRegister, /*InsnID*//* 486(*/0xE6, 0x03/*)*/, /*TempRegID*//* 485(*/0xE5, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194026 */   GIR_AddSimpleTempRegister, /*InsnID*//* 486(*/0xE6, 0x03/*)*/, /*TempRegID*//* 486(*/0xE6, 0x03/*)*/,
     /* 194031 */   GIR_AddSimpleTempRegister, /*InsnID*//* 486(*/0xE6, 0x03/*)*/, /*TempRegID*//* 506(*/0xFA, 0x03/*)*/,
     /* 194036 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 486(*/0xE6, 0x03/*)*/,
     /* 194039 */   GIR_MakeTempReg, /*TempRegID*//* 484(*/0xE4, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 194043 */   GIR_BuildMI, /*InsnID*//* 485(*/0xE5, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 194048 */   GIR_AddTempRegister, /*InsnID*//* 485(*/0xE5, 0x03/*)*/, /*TempRegID*//* 484(*/0xE4, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194055 */   GIR_AddSimpleTempRegister, /*InsnID*//* 485(*/0xE5, 0x03/*)*/, /*TempRegID*//* 485(*/0xE5, 0x03/*)*/,
     /* 194060 */   GIR_AddSimpleTempRegister, /*InsnID*//* 485(*/0xE5, 0x03/*)*/, /*TempRegID*//* 513(*/0x81, 0x04/*)*/,
     /* 194065 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 485(*/0xE5, 0x03/*)*/,
     /* 194068 */   GIR_MakeTempReg, /*TempRegID*//* 483(*/0xE3, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 194072 */   GIR_BuildMI, /*InsnID*//* 484(*/0xE4, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 194077 */   GIR_AddTempRegister, /*InsnID*//* 484(*/0xE4, 0x03/*)*/, /*TempRegID*//* 483(*/0xE3, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194084 */   GIR_AddSimpleTempRegister, /*InsnID*//* 484(*/0xE4, 0x03/*)*/, /*TempRegID*//* 484(*/0xE4, 0x03/*)*/,
     /* 194089 */   GIR_AddImm8, /*InsnID*//* 484(*/0xE4, 0x03/*)*/, /*Imm*/4,
     /* 194093 */   GIR_AddImm8, /*InsnID*//* 484(*/0xE4, 0x03/*)*/, /*Imm*/59,
     /* 194097 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 484(*/0xE4, 0x03/*)*/,
     /* 194100 */   GIR_MakeTempReg, /*TempRegID*//* 482(*/0xE2, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 194104 */   GIR_BuildMI, /*InsnID*//* 483(*/0xE3, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 194109 */   GIR_AddTempRegister, /*InsnID*//* 483(*/0xE3, 0x03/*)*/, /*TempRegID*//* 482(*/0xE2, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194116 */   GIR_AddSimpleTempRegister, /*InsnID*//* 483(*/0xE3, 0x03/*)*/, /*TempRegID*//* 483(*/0xE3, 0x03/*)*/,
     /* 194121 */   GIR_AddSimpleTempRegister, /*InsnID*//* 483(*/0xE3, 0x03/*)*/, /*TempRegID*//* 541(*/0x9D, 0x04/*)*/,
     /* 194126 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 483(*/0xE3, 0x03/*)*/,
     /* 194129 */   GIR_MakeTempReg, /*TempRegID*//* 481(*/0xE1, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 194133 */   GIR_BuildMI, /*InsnID*//* 482(*/0xE2, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 194138 */   GIR_AddTempRegister, /*InsnID*//* 482(*/0xE2, 0x03/*)*/, /*TempRegID*//* 481(*/0xE1, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194145 */   GIR_AddImm, /*InsnID*//* 482(*/0xE2, 0x03/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 194156 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 482(*/0xE2, 0x03/*)*/,
     /* 194159 */   GIR_MakeTempReg, /*TempRegID*//* 480(*/0xE0, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 194163 */   GIR_BuildMI, /*InsnID*//* 481(*/0xE1, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 194168 */   GIR_AddTempRegister, /*InsnID*//* 481(*/0xE1, 0x03/*)*/, /*TempRegID*//* 480(*/0xE0, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194175 */   GIR_AddSimpleTempRegister, /*InsnID*//* 481(*/0xE1, 0x03/*)*/, /*TempRegID*//* 481(*/0xE1, 0x03/*)*/,
     /* 194180 */   GIR_AddImm, /*InsnID*//* 481(*/0xE1, 0x03/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 194191 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 481(*/0xE1, 0x03/*)*/,
     /* 194194 */   GIR_MakeTempReg, /*TempRegID*//* 479(*/0xDF, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 194198 */   GIR_BuildMI, /*InsnID*//* 480(*/0xE0, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 194203 */   GIR_AddTempRegister, /*InsnID*//* 480(*/0xE0, 0x03/*)*/, /*TempRegID*//* 479(*/0xDF, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194210 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 480(*/0xE0, 0x03/*)*/,
     /* 194213 */   GIR_MakeTempReg, /*TempRegID*//* 478(*/0xDE, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 194217 */   GIR_BuildMI, /*InsnID*//* 479(*/0xDF, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 194222 */   GIR_AddTempRegister, /*InsnID*//* 479(*/0xDF, 0x03/*)*/, /*TempRegID*//* 478(*/0xDE, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194229 */   GIR_AddSimpleTempRegister, /*InsnID*//* 479(*/0xDF, 0x03/*)*/, /*TempRegID*//* 479(*/0xDF, 0x03/*)*/,
     /* 194234 */   GIR_AddSimpleTempRegister, /*InsnID*//* 479(*/0xDF, 0x03/*)*/, /*TempRegID*//* 480(*/0xE0, 0x03/*)*/,
     /* 194239 */   GIR_AddImm8, /*InsnID*//* 479(*/0xDF, 0x03/*)*/, /*Imm*/1,
     /* 194243 */   GIR_ConstrainOperandRC, /*InsnID*//* 479(*/0xDF, 0x03/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 194249 */   GIR_ConstrainOperandRC, /*InsnID*//* 479(*/0xDF, 0x03/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 194255 */   GIR_ConstrainOperandRC, /*InsnID*//* 479(*/0xDF, 0x03/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 194261 */   GIR_MakeTempReg, /*TempRegID*//* 477(*/0xDD, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 194265 */   GIR_BuildMI, /*InsnID*//* 478(*/0xDE, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 194270 */   GIR_AddTempRegister, /*InsnID*//* 478(*/0xDE, 0x03/*)*/, /*TempRegID*//* 477(*/0xDD, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194277 */   GIR_AddSimpleTempRegister, /*InsnID*//* 478(*/0xDE, 0x03/*)*/, /*TempRegID*//* 478(*/0xDE, 0x03/*)*/,
     /* 194282 */   GIR_AddImm8, /*InsnID*//* 478(*/0xDE, 0x03/*)*/, /*Imm*/32,
     /* 194286 */   GIR_AddImm8, /*InsnID*//* 478(*/0xDE, 0x03/*)*/, /*Imm*/31,
     /* 194290 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 478(*/0xDE, 0x03/*)*/,
     /* 194293 */   GIR_MakeTempReg, /*TempRegID*//* 476(*/0xDC, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 194297 */   GIR_BuildMI, /*InsnID*//* 477(*/0xDD, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 194302 */   GIR_AddTempRegister, /*InsnID*//* 477(*/0xDD, 0x03/*)*/, /*TempRegID*//* 476(*/0xDC, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194309 */   GIR_AddSimpleTempRegister, /*InsnID*//* 477(*/0xDD, 0x03/*)*/, /*TempRegID*//* 477(*/0xDD, 0x03/*)*/,
     /* 194314 */   GIR_AddImm, /*InsnID*//* 477(*/0xDD, 0x03/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 194325 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 477(*/0xDD, 0x03/*)*/,
     /* 194328 */   GIR_MakeTempReg, /*TempRegID*//* 475(*/0xDB, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 194332 */   GIR_BuildMI, /*InsnID*//* 476(*/0xDC, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 194337 */   GIR_AddTempRegister, /*InsnID*//* 476(*/0xDC, 0x03/*)*/, /*TempRegID*//* 475(*/0xDB, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194344 */   GIR_AddSimpleTempRegister, /*InsnID*//* 476(*/0xDC, 0x03/*)*/, /*TempRegID*//* 476(*/0xDC, 0x03/*)*/,
     /* 194349 */   GIR_AddImm, /*InsnID*//* 476(*/0xDC, 0x03/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 194360 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 476(*/0xDC, 0x03/*)*/,
     /* 194363 */   GIR_MakeTempReg, /*TempRegID*//* 474(*/0xDA, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 194367 */   GIR_BuildMI, /*InsnID*//* 475(*/0xDB, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 194372 */   GIR_AddTempRegister, /*InsnID*//* 475(*/0xDB, 0x03/*)*/, /*TempRegID*//* 474(*/0xDA, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194379 */   GIR_AddImm, /*InsnID*//* 475(*/0xDB, 0x03/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 194390 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 475(*/0xDB, 0x03/*)*/,
     /* 194393 */   GIR_MakeTempReg, /*TempRegID*//* 473(*/0xD9, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 194397 */   GIR_BuildMI, /*InsnID*//* 474(*/0xDA, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 194402 */   GIR_AddTempRegister, /*InsnID*//* 474(*/0xDA, 0x03/*)*/, /*TempRegID*//* 473(*/0xD9, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194409 */   GIR_AddSimpleTempRegister, /*InsnID*//* 474(*/0xDA, 0x03/*)*/, /*TempRegID*//* 474(*/0xDA, 0x03/*)*/,
     /* 194414 */   GIR_AddImm, /*InsnID*//* 474(*/0xDA, 0x03/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 194425 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 474(*/0xDA, 0x03/*)*/,
     /* 194428 */   GIR_MakeTempReg, /*TempRegID*//* 472(*/0xD8, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 194432 */   GIR_BuildMI, /*InsnID*//* 473(*/0xD9, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 194437 */   GIR_AddTempRegister, /*InsnID*//* 473(*/0xD9, 0x03/*)*/, /*TempRegID*//* 472(*/0xD8, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194444 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 473(*/0xD9, 0x03/*)*/,
     /* 194447 */   GIR_MakeTempReg, /*TempRegID*//* 471(*/0xD7, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 194451 */   GIR_BuildMI, /*InsnID*//* 472(*/0xD8, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 194456 */   GIR_AddTempRegister, /*InsnID*//* 472(*/0xD8, 0x03/*)*/, /*TempRegID*//* 471(*/0xD7, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194463 */   GIR_AddSimpleTempRegister, /*InsnID*//* 472(*/0xD8, 0x03/*)*/, /*TempRegID*//* 472(*/0xD8, 0x03/*)*/,
     /* 194468 */   GIR_AddSimpleTempRegister, /*InsnID*//* 472(*/0xD8, 0x03/*)*/, /*TempRegID*//* 473(*/0xD9, 0x03/*)*/,
     /* 194473 */   GIR_AddImm8, /*InsnID*//* 472(*/0xD8, 0x03/*)*/, /*Imm*/1,
     /* 194477 */   GIR_ConstrainOperandRC, /*InsnID*//* 472(*/0xD8, 0x03/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 194483 */   GIR_ConstrainOperandRC, /*InsnID*//* 472(*/0xD8, 0x03/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 194489 */   GIR_ConstrainOperandRC, /*InsnID*//* 472(*/0xD8, 0x03/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 194495 */   GIR_MakeTempReg, /*TempRegID*//* 470(*/0xD6, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 194499 */   GIR_BuildMI, /*InsnID*//* 471(*/0xD7, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 194504 */   GIR_AddTempRegister, /*InsnID*//* 471(*/0xD7, 0x03/*)*/, /*TempRegID*//* 470(*/0xD6, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194511 */   GIR_AddSimpleTempRegister, /*InsnID*//* 471(*/0xD7, 0x03/*)*/, /*TempRegID*//* 471(*/0xD7, 0x03/*)*/,
     /* 194516 */   GIR_AddImm8, /*InsnID*//* 471(*/0xD7, 0x03/*)*/, /*Imm*/32,
     /* 194520 */   GIR_AddImm8, /*InsnID*//* 471(*/0xD7, 0x03/*)*/, /*Imm*/31,
     /* 194524 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 471(*/0xD7, 0x03/*)*/,
     /* 194527 */   GIR_MakeTempReg, /*TempRegID*//* 469(*/0xD5, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 194531 */   GIR_BuildMI, /*InsnID*//* 470(*/0xD6, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 194536 */   GIR_AddTempRegister, /*InsnID*//* 470(*/0xD6, 0x03/*)*/, /*TempRegID*//* 469(*/0xD5, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194543 */   GIR_AddSimpleTempRegister, /*InsnID*//* 470(*/0xD6, 0x03/*)*/, /*TempRegID*//* 470(*/0xD6, 0x03/*)*/,
     /* 194548 */   GIR_AddImm, /*InsnID*//* 470(*/0xD6, 0x03/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 194559 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 470(*/0xD6, 0x03/*)*/,
     /* 194562 */   GIR_MakeTempReg, /*TempRegID*//* 468(*/0xD4, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 194566 */   GIR_BuildMI, /*InsnID*//* 469(*/0xD5, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 194571 */   GIR_AddTempRegister, /*InsnID*//* 469(*/0xD5, 0x03/*)*/, /*TempRegID*//* 468(*/0xD4, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194578 */   GIR_AddSimpleTempRegister, /*InsnID*//* 469(*/0xD5, 0x03/*)*/, /*TempRegID*//* 469(*/0xD5, 0x03/*)*/,
     /* 194583 */   GIR_AddImm, /*InsnID*//* 469(*/0xD5, 0x03/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 194594 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 469(*/0xD5, 0x03/*)*/,
     /* 194597 */   GIR_MakeTempReg, /*TempRegID*//* 467(*/0xD3, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 194601 */   GIR_BuildMI, /*InsnID*//* 468(*/0xD4, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 194606 */   GIR_AddTempRegister, /*InsnID*//* 468(*/0xD4, 0x03/*)*/, /*TempRegID*//* 467(*/0xD3, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194613 */   GIR_AddImm, /*InsnID*//* 468(*/0xD4, 0x03/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 194624 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 468(*/0xD4, 0x03/*)*/,
     /* 194627 */   GIR_MakeTempReg, /*TempRegID*//* 466(*/0xD2, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 194631 */   GIR_BuildMI, /*InsnID*//* 467(*/0xD3, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 194636 */   GIR_AddTempRegister, /*InsnID*//* 467(*/0xD3, 0x03/*)*/, /*TempRegID*//* 466(*/0xD2, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194643 */   GIR_AddSimpleTempRegister, /*InsnID*//* 467(*/0xD3, 0x03/*)*/, /*TempRegID*//* 467(*/0xD3, 0x03/*)*/,
     /* 194648 */   GIR_AddImm, /*InsnID*//* 467(*/0xD3, 0x03/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 194659 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 467(*/0xD3, 0x03/*)*/,
     /* 194662 */   GIR_MakeTempReg, /*TempRegID*//* 465(*/0xD1, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 194666 */   GIR_BuildMI, /*InsnID*//* 466(*/0xD2, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 194671 */   GIR_AddTempRegister, /*InsnID*//* 466(*/0xD2, 0x03/*)*/, /*TempRegID*//* 465(*/0xD1, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194678 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 466(*/0xD2, 0x03/*)*/,
     /* 194681 */   GIR_MakeTempReg, /*TempRegID*//* 464(*/0xD0, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 194685 */   GIR_BuildMI, /*InsnID*//* 465(*/0xD1, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 194690 */   GIR_AddTempRegister, /*InsnID*//* 465(*/0xD1, 0x03/*)*/, /*TempRegID*//* 464(*/0xD0, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194697 */   GIR_AddSimpleTempRegister, /*InsnID*//* 465(*/0xD1, 0x03/*)*/, /*TempRegID*//* 465(*/0xD1, 0x03/*)*/,
     /* 194702 */   GIR_AddSimpleTempRegister, /*InsnID*//* 465(*/0xD1, 0x03/*)*/, /*TempRegID*//* 466(*/0xD2, 0x03/*)*/,
     /* 194707 */   GIR_AddImm8, /*InsnID*//* 465(*/0xD1, 0x03/*)*/, /*Imm*/1,
     /* 194711 */   GIR_ConstrainOperandRC, /*InsnID*//* 465(*/0xD1, 0x03/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 194717 */   GIR_ConstrainOperandRC, /*InsnID*//* 465(*/0xD1, 0x03/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 194723 */   GIR_ConstrainOperandRC, /*InsnID*//* 465(*/0xD1, 0x03/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 194729 */   GIR_MakeTempReg, /*TempRegID*//* 463(*/0xCF, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 194733 */   GIR_BuildMI, /*InsnID*//* 464(*/0xD0, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 194738 */   GIR_AddTempRegister, /*InsnID*//* 464(*/0xD0, 0x03/*)*/, /*TempRegID*//* 463(*/0xCF, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194745 */   GIR_AddSimpleTempRegister, /*InsnID*//* 464(*/0xD0, 0x03/*)*/, /*TempRegID*//* 464(*/0xD0, 0x03/*)*/,
     /* 194750 */   GIR_AddImm8, /*InsnID*//* 464(*/0xD0, 0x03/*)*/, /*Imm*/32,
     /* 194754 */   GIR_AddImm8, /*InsnID*//* 464(*/0xD0, 0x03/*)*/, /*Imm*/31,
     /* 194758 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 464(*/0xD0, 0x03/*)*/,
     /* 194761 */   GIR_MakeTempReg, /*TempRegID*//* 462(*/0xCE, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 194765 */   GIR_BuildMI, /*InsnID*//* 463(*/0xCF, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 194770 */   GIR_AddTempRegister, /*InsnID*//* 463(*/0xCF, 0x03/*)*/, /*TempRegID*//* 462(*/0xCE, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194777 */   GIR_AddSimpleTempRegister, /*InsnID*//* 463(*/0xCF, 0x03/*)*/, /*TempRegID*//* 463(*/0xCF, 0x03/*)*/,
     /* 194782 */   GIR_AddImm, /*InsnID*//* 463(*/0xCF, 0x03/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 194793 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 463(*/0xCF, 0x03/*)*/,
     /* 194796 */   GIR_MakeTempReg, /*TempRegID*//* 461(*/0xCD, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 194800 */   GIR_BuildMI, /*InsnID*//* 462(*/0xCE, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 194805 */   GIR_AddTempRegister, /*InsnID*//* 462(*/0xCE, 0x03/*)*/, /*TempRegID*//* 461(*/0xCD, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194812 */   GIR_AddSimpleTempRegister, /*InsnID*//* 462(*/0xCE, 0x03/*)*/, /*TempRegID*//* 462(*/0xCE, 0x03/*)*/,
     /* 194817 */   GIR_AddImm, /*InsnID*//* 462(*/0xCE, 0x03/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 194828 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 462(*/0xCE, 0x03/*)*/,
     /* 194831 */   GIR_MakeTempReg, /*TempRegID*//* 460(*/0xCC, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 194835 */   GIR_BuildMI, /*InsnID*//* 461(*/0xCD, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 194840 */   GIR_AddTempRegister, /*InsnID*//* 461(*/0xCD, 0x03/*)*/, /*TempRegID*//* 460(*/0xCC, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194847 */   GIR_Copy, /*NewInsnID*//* 461(*/0xCD, 0x03/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 194852 */   GIR_AddImm8, /*InsnID*//* 461(*/0xCD, 0x03/*)*/, /*Imm*/1,
     /* 194856 */   GIR_AddImm8, /*InsnID*//* 461(*/0xCD, 0x03/*)*/, /*Imm*/62,
     /* 194860 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 461(*/0xCD, 0x03/*)*/,
     /* 194863 */   GIR_MakeTempReg, /*TempRegID*//* 459(*/0xCB, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 194867 */   GIR_BuildMI, /*InsnID*//* 460(*/0xCC, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 194872 */   GIR_AddTempRegister, /*InsnID*//* 460(*/0xCC, 0x03/*)*/, /*TempRegID*//* 459(*/0xCB, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194879 */   GIR_AddSimpleTempRegister, /*InsnID*//* 460(*/0xCC, 0x03/*)*/, /*TempRegID*//* 460(*/0xCC, 0x03/*)*/,
     /* 194884 */   GIR_AddSimpleTempRegister, /*InsnID*//* 460(*/0xCC, 0x03/*)*/, /*TempRegID*//* 461(*/0xCD, 0x03/*)*/,
     /* 194889 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 460(*/0xCC, 0x03/*)*/,
     /* 194892 */   GIR_MakeTempReg, /*TempRegID*//* 458(*/0xCA, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 194896 */   GIR_BuildMI, /*InsnID*//* 459(*/0xCB, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 194901 */   GIR_AddTempRegister, /*InsnID*//* 459(*/0xCB, 0x03/*)*/, /*TempRegID*//* 458(*/0xCA, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194908 */   GIR_AddImm, /*InsnID*//* 459(*/0xCB, 0x03/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 194919 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 459(*/0xCB, 0x03/*)*/,
     /* 194922 */   GIR_MakeTempReg, /*TempRegID*//* 457(*/0xC9, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 194926 */   GIR_BuildMI, /*InsnID*//* 458(*/0xCA, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 194931 */   GIR_AddTempRegister, /*InsnID*//* 458(*/0xCA, 0x03/*)*/, /*TempRegID*//* 457(*/0xC9, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194938 */   GIR_AddSimpleTempRegister, /*InsnID*//* 458(*/0xCA, 0x03/*)*/, /*TempRegID*//* 458(*/0xCA, 0x03/*)*/,
     /* 194943 */   GIR_AddImm, /*InsnID*//* 458(*/0xCA, 0x03/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 194954 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 458(*/0xCA, 0x03/*)*/,
     /* 194957 */   GIR_MakeTempReg, /*TempRegID*//* 456(*/0xC8, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 194961 */   GIR_BuildMI, /*InsnID*//* 457(*/0xC9, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 194966 */   GIR_AddTempRegister, /*InsnID*//* 457(*/0xC9, 0x03/*)*/, /*TempRegID*//* 456(*/0xC8, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194973 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 457(*/0xC9, 0x03/*)*/,
     /* 194976 */   GIR_MakeTempReg, /*TempRegID*//* 455(*/0xC7, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 194980 */   GIR_BuildMI, /*InsnID*//* 456(*/0xC8, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 194985 */   GIR_AddTempRegister, /*InsnID*//* 456(*/0xC8, 0x03/*)*/, /*TempRegID*//* 455(*/0xC7, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194992 */   GIR_AddSimpleTempRegister, /*InsnID*//* 456(*/0xC8, 0x03/*)*/, /*TempRegID*//* 456(*/0xC8, 0x03/*)*/,
     /* 194997 */   GIR_AddSimpleTempRegister, /*InsnID*//* 456(*/0xC8, 0x03/*)*/, /*TempRegID*//* 457(*/0xC9, 0x03/*)*/,
     /* 195002 */   GIR_AddImm8, /*InsnID*//* 456(*/0xC8, 0x03/*)*/, /*Imm*/1,
     /* 195006 */   GIR_ConstrainOperandRC, /*InsnID*//* 456(*/0xC8, 0x03/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 195012 */   GIR_ConstrainOperandRC, /*InsnID*//* 456(*/0xC8, 0x03/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 195018 */   GIR_ConstrainOperandRC, /*InsnID*//* 456(*/0xC8, 0x03/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 195024 */   GIR_MakeTempReg, /*TempRegID*//* 454(*/0xC6, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 195028 */   GIR_BuildMI, /*InsnID*//* 455(*/0xC7, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 195033 */   GIR_AddTempRegister, /*InsnID*//* 455(*/0xC7, 0x03/*)*/, /*TempRegID*//* 454(*/0xC6, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195040 */   GIR_AddSimpleTempRegister, /*InsnID*//* 455(*/0xC7, 0x03/*)*/, /*TempRegID*//* 455(*/0xC7, 0x03/*)*/,
     /* 195045 */   GIR_AddImm8, /*InsnID*//* 455(*/0xC7, 0x03/*)*/, /*Imm*/32,
     /* 195049 */   GIR_AddImm8, /*InsnID*//* 455(*/0xC7, 0x03/*)*/, /*Imm*/31,
     /* 195053 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 455(*/0xC7, 0x03/*)*/,
     /* 195056 */   GIR_MakeTempReg, /*TempRegID*//* 453(*/0xC5, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 195060 */   GIR_BuildMI, /*InsnID*//* 454(*/0xC6, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 195065 */   GIR_AddTempRegister, /*InsnID*//* 454(*/0xC6, 0x03/*)*/, /*TempRegID*//* 453(*/0xC5, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195072 */   GIR_AddSimpleTempRegister, /*InsnID*//* 454(*/0xC6, 0x03/*)*/, /*TempRegID*//* 454(*/0xC6, 0x03/*)*/,
     /* 195077 */   GIR_AddImm, /*InsnID*//* 454(*/0xC6, 0x03/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 195088 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 454(*/0xC6, 0x03/*)*/,
     /* 195091 */   GIR_MakeTempReg, /*TempRegID*//* 452(*/0xC4, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 195095 */   GIR_BuildMI, /*InsnID*//* 453(*/0xC5, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 195100 */   GIR_AddTempRegister, /*InsnID*//* 453(*/0xC5, 0x03/*)*/, /*TempRegID*//* 452(*/0xC4, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195107 */   GIR_AddSimpleTempRegister, /*InsnID*//* 453(*/0xC5, 0x03/*)*/, /*TempRegID*//* 453(*/0xC5, 0x03/*)*/,
     /* 195112 */   GIR_AddImm, /*InsnID*//* 453(*/0xC5, 0x03/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 195123 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 453(*/0xC5, 0x03/*)*/,
     /* 195126 */   GIR_MakeTempReg, /*TempRegID*//* 451(*/0xC3, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 195130 */   GIR_BuildMI, /*InsnID*//* 452(*/0xC4, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 195135 */   GIR_AddTempRegister, /*InsnID*//* 452(*/0xC4, 0x03/*)*/, /*TempRegID*//* 451(*/0xC3, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195142 */   GIR_Copy, /*NewInsnID*//* 452(*/0xC4, 0x03/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 195147 */   GIR_AddImm8, /*InsnID*//* 452(*/0xC4, 0x03/*)*/, /*Imm*/63,
     /* 195151 */   GIR_AddImm8, /*InsnID*//* 452(*/0xC4, 0x03/*)*/, /*Imm*/1,
     /* 195155 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 452(*/0xC4, 0x03/*)*/,
     /* 195158 */   GIR_MakeTempReg, /*TempRegID*//* 450(*/0xC2, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 195162 */   GIR_BuildMI, /*InsnID*//* 451(*/0xC3, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 195167 */   GIR_AddTempRegister, /*InsnID*//* 451(*/0xC3, 0x03/*)*/, /*TempRegID*//* 450(*/0xC2, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195174 */   GIR_AddSimpleTempRegister, /*InsnID*//* 451(*/0xC3, 0x03/*)*/, /*TempRegID*//* 451(*/0xC3, 0x03/*)*/,
     /* 195179 */   GIR_AddSimpleTempRegister, /*InsnID*//* 451(*/0xC3, 0x03/*)*/, /*TempRegID*//* 452(*/0xC4, 0x03/*)*/,
     /* 195184 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 451(*/0xC3, 0x03/*)*/,
     /* 195187 */   GIR_MakeTempReg, /*TempRegID*//* 449(*/0xC1, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 195191 */   GIR_BuildMI, /*InsnID*//* 450(*/0xC2, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 195196 */   GIR_AddTempRegister, /*InsnID*//* 450(*/0xC2, 0x03/*)*/, /*TempRegID*//* 449(*/0xC1, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195203 */   GIR_AddSimpleTempRegister, /*InsnID*//* 450(*/0xC2, 0x03/*)*/, /*TempRegID*//* 450(*/0xC2, 0x03/*)*/,
     /* 195208 */   GIR_AddSimpleTempRegister, /*InsnID*//* 450(*/0xC2, 0x03/*)*/, /*TempRegID*//* 459(*/0xCB, 0x03/*)*/,
     /* 195213 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 450(*/0xC2, 0x03/*)*/,
     /* 195216 */   GIR_MakeTempReg, /*TempRegID*//* 448(*/0xC0, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 195220 */   GIR_BuildMI, /*InsnID*//* 449(*/0xC1, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 195225 */   GIR_AddTempRegister, /*InsnID*//* 449(*/0xC1, 0x03/*)*/, /*TempRegID*//* 448(*/0xC0, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195232 */   GIR_AddSimpleTempRegister, /*InsnID*//* 449(*/0xC1, 0x03/*)*/, /*TempRegID*//* 449(*/0xC1, 0x03/*)*/,
     /* 195237 */   GIR_AddImm8, /*InsnID*//* 449(*/0xC1, 0x03/*)*/, /*Imm*/2,
     /* 195241 */   GIR_AddImm8, /*InsnID*//* 449(*/0xC1, 0x03/*)*/, /*Imm*/61,
     /* 195245 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 449(*/0xC1, 0x03/*)*/,
     /* 195248 */   GIR_MakeTempReg, /*TempRegID*//* 447(*/0xBF, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 195252 */   GIR_BuildMI, /*InsnID*//* 448(*/0xC0, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 195257 */   GIR_AddTempRegister, /*InsnID*//* 448(*/0xC0, 0x03/*)*/, /*TempRegID*//* 447(*/0xBF, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195264 */   GIR_AddSimpleTempRegister, /*InsnID*//* 448(*/0xC0, 0x03/*)*/, /*TempRegID*//* 448(*/0xC0, 0x03/*)*/,
     /* 195269 */   GIR_AddSimpleTempRegister, /*InsnID*//* 448(*/0xC0, 0x03/*)*/, /*TempRegID*//* 468(*/0xD4, 0x03/*)*/,
     /* 195274 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 448(*/0xC0, 0x03/*)*/,
     /* 195277 */   GIR_MakeTempReg, /*TempRegID*//* 446(*/0xBE, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 195281 */   GIR_BuildMI, /*InsnID*//* 447(*/0xBF, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 195286 */   GIR_AddTempRegister, /*InsnID*//* 447(*/0xBF, 0x03/*)*/, /*TempRegID*//* 446(*/0xBE, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195293 */   GIR_AddImm, /*InsnID*//* 447(*/0xBF, 0x03/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 195304 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 447(*/0xBF, 0x03/*)*/,
     /* 195307 */   GIR_MakeTempReg, /*TempRegID*//* 445(*/0xBD, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 195311 */   GIR_BuildMI, /*InsnID*//* 446(*/0xBE, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 195316 */   GIR_AddTempRegister, /*InsnID*//* 446(*/0xBE, 0x03/*)*/, /*TempRegID*//* 445(*/0xBD, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195323 */   GIR_AddSimpleTempRegister, /*InsnID*//* 446(*/0xBE, 0x03/*)*/, /*TempRegID*//* 446(*/0xBE, 0x03/*)*/,
     /* 195328 */   GIR_AddImm, /*InsnID*//* 446(*/0xBE, 0x03/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 195339 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 446(*/0xBE, 0x03/*)*/,
     /* 195342 */   GIR_MakeTempReg, /*TempRegID*//* 444(*/0xBC, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 195346 */   GIR_BuildMI, /*InsnID*//* 445(*/0xBD, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 195351 */   GIR_AddTempRegister, /*InsnID*//* 445(*/0xBD, 0x03/*)*/, /*TempRegID*//* 444(*/0xBC, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195358 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 445(*/0xBD, 0x03/*)*/,
     /* 195361 */   GIR_MakeTempReg, /*TempRegID*//* 443(*/0xBB, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 195365 */   GIR_BuildMI, /*InsnID*//* 444(*/0xBC, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 195370 */   GIR_AddTempRegister, /*InsnID*//* 444(*/0xBC, 0x03/*)*/, /*TempRegID*//* 443(*/0xBB, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195377 */   GIR_AddSimpleTempRegister, /*InsnID*//* 444(*/0xBC, 0x03/*)*/, /*TempRegID*//* 444(*/0xBC, 0x03/*)*/,
     /* 195382 */   GIR_AddSimpleTempRegister, /*InsnID*//* 444(*/0xBC, 0x03/*)*/, /*TempRegID*//* 445(*/0xBD, 0x03/*)*/,
     /* 195387 */   GIR_AddImm8, /*InsnID*//* 444(*/0xBC, 0x03/*)*/, /*Imm*/1,
     /* 195391 */   GIR_ConstrainOperandRC, /*InsnID*//* 444(*/0xBC, 0x03/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 195397 */   GIR_ConstrainOperandRC, /*InsnID*//* 444(*/0xBC, 0x03/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 195403 */   GIR_ConstrainOperandRC, /*InsnID*//* 444(*/0xBC, 0x03/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 195409 */   GIR_MakeTempReg, /*TempRegID*//* 442(*/0xBA, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 195413 */   GIR_BuildMI, /*InsnID*//* 443(*/0xBB, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 195418 */   GIR_AddTempRegister, /*InsnID*//* 443(*/0xBB, 0x03/*)*/, /*TempRegID*//* 442(*/0xBA, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195425 */   GIR_AddSimpleTempRegister, /*InsnID*//* 443(*/0xBB, 0x03/*)*/, /*TempRegID*//* 443(*/0xBB, 0x03/*)*/,
     /* 195430 */   GIR_AddImm8, /*InsnID*//* 443(*/0xBB, 0x03/*)*/, /*Imm*/32,
     /* 195434 */   GIR_AddImm8, /*InsnID*//* 443(*/0xBB, 0x03/*)*/, /*Imm*/31,
     /* 195438 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 443(*/0xBB, 0x03/*)*/,
     /* 195441 */   GIR_MakeTempReg, /*TempRegID*//* 441(*/0xB9, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 195445 */   GIR_BuildMI, /*InsnID*//* 442(*/0xBA, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 195450 */   GIR_AddTempRegister, /*InsnID*//* 442(*/0xBA, 0x03/*)*/, /*TempRegID*//* 441(*/0xB9, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195457 */   GIR_AddSimpleTempRegister, /*InsnID*//* 442(*/0xBA, 0x03/*)*/, /*TempRegID*//* 442(*/0xBA, 0x03/*)*/,
     /* 195462 */   GIR_AddImm, /*InsnID*//* 442(*/0xBA, 0x03/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 195473 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 442(*/0xBA, 0x03/*)*/,
     /* 195476 */   GIR_MakeTempReg, /*TempRegID*//* 440(*/0xB8, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 195480 */   GIR_BuildMI, /*InsnID*//* 441(*/0xB9, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 195485 */   GIR_AddTempRegister, /*InsnID*//* 441(*/0xB9, 0x03/*)*/, /*TempRegID*//* 440(*/0xB8, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195492 */   GIR_AddSimpleTempRegister, /*InsnID*//* 441(*/0xB9, 0x03/*)*/, /*TempRegID*//* 441(*/0xB9, 0x03/*)*/,
     /* 195497 */   GIR_AddImm, /*InsnID*//* 441(*/0xB9, 0x03/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 195508 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 441(*/0xB9, 0x03/*)*/,
     /* 195511 */   GIR_MakeTempReg, /*TempRegID*//* 439(*/0xB7, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 195515 */   GIR_BuildMI, /*InsnID*//* 440(*/0xB8, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 195520 */   GIR_AddTempRegister, /*InsnID*//* 440(*/0xB8, 0x03/*)*/, /*TempRegID*//* 439(*/0xB7, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195527 */   GIR_AddImm, /*InsnID*//* 440(*/0xB8, 0x03/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 195538 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 440(*/0xB8, 0x03/*)*/,
     /* 195541 */   GIR_MakeTempReg, /*TempRegID*//* 438(*/0xB6, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 195545 */   GIR_BuildMI, /*InsnID*//* 439(*/0xB7, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 195550 */   GIR_AddTempRegister, /*InsnID*//* 439(*/0xB7, 0x03/*)*/, /*TempRegID*//* 438(*/0xB6, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195557 */   GIR_AddSimpleTempRegister, /*InsnID*//* 439(*/0xB7, 0x03/*)*/, /*TempRegID*//* 439(*/0xB7, 0x03/*)*/,
     /* 195562 */   GIR_AddImm, /*InsnID*//* 439(*/0xB7, 0x03/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 195573 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 439(*/0xB7, 0x03/*)*/,
     /* 195576 */   GIR_MakeTempReg, /*TempRegID*//* 437(*/0xB5, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 195580 */   GIR_BuildMI, /*InsnID*//* 438(*/0xB6, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 195585 */   GIR_AddTempRegister, /*InsnID*//* 438(*/0xB6, 0x03/*)*/, /*TempRegID*//* 437(*/0xB5, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195592 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 438(*/0xB6, 0x03/*)*/,
     /* 195595 */   GIR_MakeTempReg, /*TempRegID*//* 436(*/0xB4, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 195599 */   GIR_BuildMI, /*InsnID*//* 437(*/0xB5, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 195604 */   GIR_AddTempRegister, /*InsnID*//* 437(*/0xB5, 0x03/*)*/, /*TempRegID*//* 436(*/0xB4, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195611 */   GIR_AddSimpleTempRegister, /*InsnID*//* 437(*/0xB5, 0x03/*)*/, /*TempRegID*//* 437(*/0xB5, 0x03/*)*/,
     /* 195616 */   GIR_AddSimpleTempRegister, /*InsnID*//* 437(*/0xB5, 0x03/*)*/, /*TempRegID*//* 438(*/0xB6, 0x03/*)*/,
     /* 195621 */   GIR_AddImm8, /*InsnID*//* 437(*/0xB5, 0x03/*)*/, /*Imm*/1,
     /* 195625 */   GIR_ConstrainOperandRC, /*InsnID*//* 437(*/0xB5, 0x03/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 195631 */   GIR_ConstrainOperandRC, /*InsnID*//* 437(*/0xB5, 0x03/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 195637 */   GIR_ConstrainOperandRC, /*InsnID*//* 437(*/0xB5, 0x03/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 195643 */   GIR_MakeTempReg, /*TempRegID*//* 435(*/0xB3, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 195647 */   GIR_BuildMI, /*InsnID*//* 436(*/0xB4, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 195652 */   GIR_AddTempRegister, /*InsnID*//* 436(*/0xB4, 0x03/*)*/, /*TempRegID*//* 435(*/0xB3, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195659 */   GIR_AddSimpleTempRegister, /*InsnID*//* 436(*/0xB4, 0x03/*)*/, /*TempRegID*//* 436(*/0xB4, 0x03/*)*/,
     /* 195664 */   GIR_AddImm8, /*InsnID*//* 436(*/0xB4, 0x03/*)*/, /*Imm*/32,
     /* 195668 */   GIR_AddImm8, /*InsnID*//* 436(*/0xB4, 0x03/*)*/, /*Imm*/31,
     /* 195672 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 436(*/0xB4, 0x03/*)*/,
     /* 195675 */   GIR_MakeTempReg, /*TempRegID*//* 434(*/0xB2, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 195679 */   GIR_BuildMI, /*InsnID*//* 435(*/0xB3, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 195684 */   GIR_AddTempRegister, /*InsnID*//* 435(*/0xB3, 0x03/*)*/, /*TempRegID*//* 434(*/0xB2, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195691 */   GIR_AddSimpleTempRegister, /*InsnID*//* 435(*/0xB3, 0x03/*)*/, /*TempRegID*//* 435(*/0xB3, 0x03/*)*/,
     /* 195696 */   GIR_AddImm, /*InsnID*//* 435(*/0xB3, 0x03/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 195707 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 435(*/0xB3, 0x03/*)*/,
     /* 195710 */   GIR_MakeTempReg, /*TempRegID*//* 433(*/0xB1, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 195714 */   GIR_BuildMI, /*InsnID*//* 434(*/0xB2, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 195719 */   GIR_AddTempRegister, /*InsnID*//* 434(*/0xB2, 0x03/*)*/, /*TempRegID*//* 433(*/0xB1, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195726 */   GIR_AddSimpleTempRegister, /*InsnID*//* 434(*/0xB2, 0x03/*)*/, /*TempRegID*//* 434(*/0xB2, 0x03/*)*/,
     /* 195731 */   GIR_AddImm, /*InsnID*//* 434(*/0xB2, 0x03/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 195742 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 434(*/0xB2, 0x03/*)*/,
     /* 195745 */   GIR_MakeTempReg, /*TempRegID*//* 432(*/0xB0, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 195749 */   GIR_BuildMI, /*InsnID*//* 433(*/0xB1, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 195754 */   GIR_AddTempRegister, /*InsnID*//* 433(*/0xB1, 0x03/*)*/, /*TempRegID*//* 432(*/0xB0, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195761 */   GIR_Copy, /*NewInsnID*//* 433(*/0xB1, 0x03/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 195766 */   GIR_AddImm8, /*InsnID*//* 433(*/0xB1, 0x03/*)*/, /*Imm*/1,
     /* 195770 */   GIR_AddImm8, /*InsnID*//* 433(*/0xB1, 0x03/*)*/, /*Imm*/62,
     /* 195774 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 433(*/0xB1, 0x03/*)*/,
     /* 195777 */   GIR_MakeTempReg, /*TempRegID*//* 431(*/0xAF, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 195781 */   GIR_BuildMI, /*InsnID*//* 432(*/0xB0, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 195786 */   GIR_AddTempRegister, /*InsnID*//* 432(*/0xB0, 0x03/*)*/, /*TempRegID*//* 431(*/0xAF, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195793 */   GIR_AddSimpleTempRegister, /*InsnID*//* 432(*/0xB0, 0x03/*)*/, /*TempRegID*//* 432(*/0xB0, 0x03/*)*/,
     /* 195798 */   GIR_AddSimpleTempRegister, /*InsnID*//* 432(*/0xB0, 0x03/*)*/, /*TempRegID*//* 433(*/0xB1, 0x03/*)*/,
     /* 195803 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 432(*/0xB0, 0x03/*)*/,
     /* 195806 */   GIR_MakeTempReg, /*TempRegID*//* 430(*/0xAE, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 195810 */   GIR_BuildMI, /*InsnID*//* 431(*/0xAF, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 195815 */   GIR_AddTempRegister, /*InsnID*//* 431(*/0xAF, 0x03/*)*/, /*TempRegID*//* 430(*/0xAE, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195822 */   GIR_AddImm, /*InsnID*//* 431(*/0xAF, 0x03/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 195833 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 431(*/0xAF, 0x03/*)*/,
     /* 195836 */   GIR_MakeTempReg, /*TempRegID*//* 429(*/0xAD, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 195840 */   GIR_BuildMI, /*InsnID*//* 430(*/0xAE, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 195845 */   GIR_AddTempRegister, /*InsnID*//* 430(*/0xAE, 0x03/*)*/, /*TempRegID*//* 429(*/0xAD, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195852 */   GIR_AddSimpleTempRegister, /*InsnID*//* 430(*/0xAE, 0x03/*)*/, /*TempRegID*//* 430(*/0xAE, 0x03/*)*/,
     /* 195857 */   GIR_AddImm, /*InsnID*//* 430(*/0xAE, 0x03/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 195868 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 430(*/0xAE, 0x03/*)*/,
     /* 195871 */   GIR_MakeTempReg, /*TempRegID*//* 428(*/0xAC, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 195875 */   GIR_BuildMI, /*InsnID*//* 429(*/0xAD, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 195880 */   GIR_AddTempRegister, /*InsnID*//* 429(*/0xAD, 0x03/*)*/, /*TempRegID*//* 428(*/0xAC, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195887 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 429(*/0xAD, 0x03/*)*/,
     /* 195890 */   GIR_MakeTempReg, /*TempRegID*//* 427(*/0xAB, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 195894 */   GIR_BuildMI, /*InsnID*//* 428(*/0xAC, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 195899 */   GIR_AddTempRegister, /*InsnID*//* 428(*/0xAC, 0x03/*)*/, /*TempRegID*//* 427(*/0xAB, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195906 */   GIR_AddSimpleTempRegister, /*InsnID*//* 428(*/0xAC, 0x03/*)*/, /*TempRegID*//* 428(*/0xAC, 0x03/*)*/,
     /* 195911 */   GIR_AddSimpleTempRegister, /*InsnID*//* 428(*/0xAC, 0x03/*)*/, /*TempRegID*//* 429(*/0xAD, 0x03/*)*/,
     /* 195916 */   GIR_AddImm8, /*InsnID*//* 428(*/0xAC, 0x03/*)*/, /*Imm*/1,
     /* 195920 */   GIR_ConstrainOperandRC, /*InsnID*//* 428(*/0xAC, 0x03/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 195926 */   GIR_ConstrainOperandRC, /*InsnID*//* 428(*/0xAC, 0x03/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 195932 */   GIR_ConstrainOperandRC, /*InsnID*//* 428(*/0xAC, 0x03/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 195938 */   GIR_MakeTempReg, /*TempRegID*//* 426(*/0xAA, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 195942 */   GIR_BuildMI, /*InsnID*//* 427(*/0xAB, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 195947 */   GIR_AddTempRegister, /*InsnID*//* 427(*/0xAB, 0x03/*)*/, /*TempRegID*//* 426(*/0xAA, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195954 */   GIR_AddSimpleTempRegister, /*InsnID*//* 427(*/0xAB, 0x03/*)*/, /*TempRegID*//* 427(*/0xAB, 0x03/*)*/,
     /* 195959 */   GIR_AddImm8, /*InsnID*//* 427(*/0xAB, 0x03/*)*/, /*Imm*/32,
     /* 195963 */   GIR_AddImm8, /*InsnID*//* 427(*/0xAB, 0x03/*)*/, /*Imm*/31,
     /* 195967 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 427(*/0xAB, 0x03/*)*/,
     /* 195970 */   GIR_MakeTempReg, /*TempRegID*//* 425(*/0xA9, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 195974 */   GIR_BuildMI, /*InsnID*//* 426(*/0xAA, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 195979 */   GIR_AddTempRegister, /*InsnID*//* 426(*/0xAA, 0x03/*)*/, /*TempRegID*//* 425(*/0xA9, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195986 */   GIR_AddSimpleTempRegister, /*InsnID*//* 426(*/0xAA, 0x03/*)*/, /*TempRegID*//* 426(*/0xAA, 0x03/*)*/,
     /* 195991 */   GIR_AddImm, /*InsnID*//* 426(*/0xAA, 0x03/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 196002 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 426(*/0xAA, 0x03/*)*/,
     /* 196005 */   GIR_MakeTempReg, /*TempRegID*//* 424(*/0xA8, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196009 */   GIR_BuildMI, /*InsnID*//* 425(*/0xA9, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 196014 */   GIR_AddTempRegister, /*InsnID*//* 425(*/0xA9, 0x03/*)*/, /*TempRegID*//* 424(*/0xA8, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196021 */   GIR_AddSimpleTempRegister, /*InsnID*//* 425(*/0xA9, 0x03/*)*/, /*TempRegID*//* 425(*/0xA9, 0x03/*)*/,
     /* 196026 */   GIR_AddImm, /*InsnID*//* 425(*/0xA9, 0x03/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 196037 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 425(*/0xA9, 0x03/*)*/,
     /* 196040 */   GIR_MakeTempReg, /*TempRegID*//* 423(*/0xA7, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196044 */   GIR_BuildMI, /*InsnID*//* 424(*/0xA8, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 196049 */   GIR_AddTempRegister, /*InsnID*//* 424(*/0xA8, 0x03/*)*/, /*TempRegID*//* 423(*/0xA7, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196056 */   GIR_Copy, /*NewInsnID*//* 424(*/0xA8, 0x03/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 196061 */   GIR_AddImm8, /*InsnID*//* 424(*/0xA8, 0x03/*)*/, /*Imm*/63,
     /* 196065 */   GIR_AddImm8, /*InsnID*//* 424(*/0xA8, 0x03/*)*/, /*Imm*/1,
     /* 196069 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 424(*/0xA8, 0x03/*)*/,
     /* 196072 */   GIR_MakeTempReg, /*TempRegID*//* 422(*/0xA6, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196076 */   GIR_BuildMI, /*InsnID*//* 423(*/0xA7, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 196081 */   GIR_AddTempRegister, /*InsnID*//* 423(*/0xA7, 0x03/*)*/, /*TempRegID*//* 422(*/0xA6, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196088 */   GIR_AddSimpleTempRegister, /*InsnID*//* 423(*/0xA7, 0x03/*)*/, /*TempRegID*//* 423(*/0xA7, 0x03/*)*/,
     /* 196093 */   GIR_AddSimpleTempRegister, /*InsnID*//* 423(*/0xA7, 0x03/*)*/, /*TempRegID*//* 424(*/0xA8, 0x03/*)*/,
     /* 196098 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 423(*/0xA7, 0x03/*)*/,
     /* 196101 */   GIR_MakeTempReg, /*TempRegID*//* 421(*/0xA5, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196105 */   GIR_BuildMI, /*InsnID*//* 422(*/0xA6, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 196110 */   GIR_AddTempRegister, /*InsnID*//* 422(*/0xA6, 0x03/*)*/, /*TempRegID*//* 421(*/0xA5, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196117 */   GIR_AddSimpleTempRegister, /*InsnID*//* 422(*/0xA6, 0x03/*)*/, /*TempRegID*//* 422(*/0xA6, 0x03/*)*/,
     /* 196122 */   GIR_AddSimpleTempRegister, /*InsnID*//* 422(*/0xA6, 0x03/*)*/, /*TempRegID*//* 431(*/0xAF, 0x03/*)*/,
     /* 196127 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 422(*/0xA6, 0x03/*)*/,
     /* 196130 */   GIR_MakeTempReg, /*TempRegID*//* 420(*/0xA4, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196134 */   GIR_BuildMI, /*InsnID*//* 421(*/0xA5, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 196139 */   GIR_AddTempRegister, /*InsnID*//* 421(*/0xA5, 0x03/*)*/, /*TempRegID*//* 420(*/0xA4, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196146 */   GIR_AddSimpleTempRegister, /*InsnID*//* 421(*/0xA5, 0x03/*)*/, /*TempRegID*//* 421(*/0xA5, 0x03/*)*/,
     /* 196151 */   GIR_AddImm8, /*InsnID*//* 421(*/0xA5, 0x03/*)*/, /*Imm*/62,
     /* 196155 */   GIR_AddImm8, /*InsnID*//* 421(*/0xA5, 0x03/*)*/, /*Imm*/2,
     /* 196159 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 421(*/0xA5, 0x03/*)*/,
     /* 196162 */   GIR_MakeTempReg, /*TempRegID*//* 419(*/0xA3, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196166 */   GIR_BuildMI, /*InsnID*//* 420(*/0xA4, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 196171 */   GIR_AddTempRegister, /*InsnID*//* 420(*/0xA4, 0x03/*)*/, /*TempRegID*//* 419(*/0xA3, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196178 */   GIR_AddSimpleTempRegister, /*InsnID*//* 420(*/0xA4, 0x03/*)*/, /*TempRegID*//* 420(*/0xA4, 0x03/*)*/,
     /* 196183 */   GIR_AddSimpleTempRegister, /*InsnID*//* 420(*/0xA4, 0x03/*)*/, /*TempRegID*//* 440(*/0xB8, 0x03/*)*/,
     /* 196188 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 420(*/0xA4, 0x03/*)*/,
     /* 196191 */   GIR_MakeTempReg, /*TempRegID*//* 418(*/0xA2, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196195 */   GIR_BuildMI, /*InsnID*//* 419(*/0xA3, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 196200 */   GIR_AddTempRegister, /*InsnID*//* 419(*/0xA3, 0x03/*)*/, /*TempRegID*//* 418(*/0xA2, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196207 */   GIR_AddSimpleTempRegister, /*InsnID*//* 419(*/0xA3, 0x03/*)*/, /*TempRegID*//* 419(*/0xA3, 0x03/*)*/,
     /* 196212 */   GIR_AddSimpleTempRegister, /*InsnID*//* 419(*/0xA3, 0x03/*)*/, /*TempRegID*//* 447(*/0xBF, 0x03/*)*/,
     /* 196217 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 419(*/0xA3, 0x03/*)*/,
     /* 196220 */   GIR_MakeTempReg, /*TempRegID*//* 417(*/0xA1, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196224 */   GIR_BuildMI, /*InsnID*//* 418(*/0xA2, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 196229 */   GIR_AddTempRegister, /*InsnID*//* 418(*/0xA2, 0x03/*)*/, /*TempRegID*//* 417(*/0xA1, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196236 */   GIR_AddSimpleTempRegister, /*InsnID*//* 418(*/0xA2, 0x03/*)*/, /*TempRegID*//* 418(*/0xA2, 0x03/*)*/,
     /* 196241 */   GIR_AddImm8, /*InsnID*//* 418(*/0xA2, 0x03/*)*/, /*Imm*/60,
     /* 196245 */   GIR_AddImm8, /*InsnID*//* 418(*/0xA2, 0x03/*)*/, /*Imm*/4,
     /* 196249 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 418(*/0xA2, 0x03/*)*/,
     /* 196252 */   GIR_MakeTempReg, /*TempRegID*//* 416(*/0xA0, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196256 */   GIR_BuildMI, /*InsnID*//* 417(*/0xA1, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 196261 */   GIR_AddTempRegister, /*InsnID*//* 417(*/0xA1, 0x03/*)*/, /*TempRegID*//* 416(*/0xA0, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196268 */   GIR_AddSimpleTempRegister, /*InsnID*//* 417(*/0xA1, 0x03/*)*/, /*TempRegID*//* 417(*/0xA1, 0x03/*)*/,
     /* 196273 */   GIR_AddSimpleTempRegister, /*InsnID*//* 417(*/0xA1, 0x03/*)*/, /*TempRegID*//* 475(*/0xDB, 0x03/*)*/,
     /* 196278 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 417(*/0xA1, 0x03/*)*/,
     /* 196281 */   GIR_MakeTempReg, /*TempRegID*//* 415(*/0x9F, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196285 */   GIR_BuildMI, /*InsnID*//* 416(*/0xA0, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 196290 */   GIR_AddTempRegister, /*InsnID*//* 416(*/0xA0, 0x03/*)*/, /*TempRegID*//* 415(*/0x9F, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196297 */   GIR_AddSimpleTempRegister, /*InsnID*//* 416(*/0xA0, 0x03/*)*/, /*TempRegID*//* 416(*/0xA0, 0x03/*)*/,
     /* 196302 */   GIR_AddSimpleTempRegister, /*InsnID*//* 416(*/0xA0, 0x03/*)*/, /*TempRegID*//* 482(*/0xE2, 0x03/*)*/,
     /* 196307 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 416(*/0xA0, 0x03/*)*/,
     /* 196310 */   GIR_MakeTempReg, /*TempRegID*//* 414(*/0x9E, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196314 */   GIR_BuildMI, /*InsnID*//* 415(*/0x9F, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 196319 */   GIR_AddTempRegister, /*InsnID*//* 415(*/0x9F, 0x03/*)*/, /*TempRegID*//* 414(*/0x9E, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196326 */   GIR_AddSimpleTempRegister, /*InsnID*//* 415(*/0x9F, 0x03/*)*/, /*TempRegID*//* 415(*/0x9F, 0x03/*)*/,
     /* 196331 */   GIR_AddImm8, /*InsnID*//* 415(*/0x9F, 0x03/*)*/, /*Imm*/32,
     /* 196335 */   GIR_AddImm8, /*InsnID*//* 415(*/0x9F, 0x03/*)*/, /*Imm*/32,
     /* 196339 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 415(*/0x9F, 0x03/*)*/,
     /* 196342 */   GIR_MakeTempReg, /*TempRegID*//* 682(*/0xAA, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 196346 */   GIR_BuildMI, /*InsnID*//* 683(*/0xAB, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 196351 */   GIR_AddTempRegister, /*InsnID*//* 683(*/0xAB, 0x05/*)*/, /*TempRegID*//* 682(*/0xAA, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196358 */   GIR_AddImm, /*InsnID*//* 683(*/0xAB, 0x05/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 196369 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 683(*/0xAB, 0x05/*)*/,
     /* 196372 */   GIR_MakeTempReg, /*TempRegID*//* 681(*/0xA9, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 196376 */   GIR_BuildMI, /*InsnID*//* 682(*/0xAA, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 196381 */   GIR_AddTempRegister, /*InsnID*//* 682(*/0xAA, 0x05/*)*/, /*TempRegID*//* 681(*/0xA9, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196388 */   GIR_AddSimpleTempRegister, /*InsnID*//* 682(*/0xAA, 0x05/*)*/, /*TempRegID*//* 682(*/0xAA, 0x05/*)*/,
     /* 196393 */   GIR_AddImm, /*InsnID*//* 682(*/0xAA, 0x05/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 196404 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 682(*/0xAA, 0x05/*)*/,
     /* 196407 */   GIR_MakeTempReg, /*TempRegID*//* 680(*/0xA8, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 196411 */   GIR_BuildMI, /*InsnID*//* 681(*/0xA9, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 196416 */   GIR_AddTempRegister, /*InsnID*//* 681(*/0xA9, 0x05/*)*/, /*TempRegID*//* 680(*/0xA8, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196423 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 681(*/0xA9, 0x05/*)*/,
     /* 196426 */   GIR_MakeTempReg, /*TempRegID*//* 679(*/0xA7, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 196430 */   GIR_BuildMI, /*InsnID*//* 680(*/0xA8, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 196435 */   GIR_AddTempRegister, /*InsnID*//* 680(*/0xA8, 0x05/*)*/, /*TempRegID*//* 679(*/0xA7, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196442 */   GIR_AddSimpleTempRegister, /*InsnID*//* 680(*/0xA8, 0x05/*)*/, /*TempRegID*//* 680(*/0xA8, 0x05/*)*/,
     /* 196447 */   GIR_AddSimpleTempRegister, /*InsnID*//* 680(*/0xA8, 0x05/*)*/, /*TempRegID*//* 681(*/0xA9, 0x05/*)*/,
     /* 196452 */   GIR_AddImm8, /*InsnID*//* 680(*/0xA8, 0x05/*)*/, /*Imm*/1,
     /* 196456 */   GIR_ConstrainOperandRC, /*InsnID*//* 680(*/0xA8, 0x05/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 196462 */   GIR_ConstrainOperandRC, /*InsnID*//* 680(*/0xA8, 0x05/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 196468 */   GIR_ConstrainOperandRC, /*InsnID*//* 680(*/0xA8, 0x05/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 196474 */   GIR_MakeTempReg, /*TempRegID*//* 678(*/0xA6, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 196478 */   GIR_BuildMI, /*InsnID*//* 679(*/0xA7, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 196483 */   GIR_AddTempRegister, /*InsnID*//* 679(*/0xA7, 0x05/*)*/, /*TempRegID*//* 678(*/0xA6, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196490 */   GIR_AddSimpleTempRegister, /*InsnID*//* 679(*/0xA7, 0x05/*)*/, /*TempRegID*//* 679(*/0xA7, 0x05/*)*/,
     /* 196495 */   GIR_AddImm8, /*InsnID*//* 679(*/0xA7, 0x05/*)*/, /*Imm*/32,
     /* 196499 */   GIR_AddImm8, /*InsnID*//* 679(*/0xA7, 0x05/*)*/, /*Imm*/31,
     /* 196503 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 679(*/0xA7, 0x05/*)*/,
     /* 196506 */   GIR_MakeTempReg, /*TempRegID*//* 677(*/0xA5, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 196510 */   GIR_BuildMI, /*InsnID*//* 678(*/0xA6, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 196515 */   GIR_AddTempRegister, /*InsnID*//* 678(*/0xA6, 0x05/*)*/, /*TempRegID*//* 677(*/0xA5, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196522 */   GIR_AddSimpleTempRegister, /*InsnID*//* 678(*/0xA6, 0x05/*)*/, /*TempRegID*//* 678(*/0xA6, 0x05/*)*/,
     /* 196527 */   GIR_AddImm, /*InsnID*//* 678(*/0xA6, 0x05/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 196538 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 678(*/0xA6, 0x05/*)*/,
     /* 196541 */   GIR_MakeTempReg, /*TempRegID*//* 676(*/0xA4, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 196545 */   GIR_BuildMI, /*InsnID*//* 677(*/0xA5, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 196550 */   GIR_AddTempRegister, /*InsnID*//* 677(*/0xA5, 0x05/*)*/, /*TempRegID*//* 676(*/0xA4, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196557 */   GIR_AddSimpleTempRegister, /*InsnID*//* 677(*/0xA5, 0x05/*)*/, /*TempRegID*//* 677(*/0xA5, 0x05/*)*/,
     /* 196562 */   GIR_AddImm, /*InsnID*//* 677(*/0xA5, 0x05/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 196573 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 677(*/0xA5, 0x05/*)*/,
     /* 196576 */   GIR_MakeTempReg, /*TempRegID*//* 675(*/0xA3, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 196580 */   GIR_BuildMI, /*InsnID*//* 676(*/0xA4, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 196585 */   GIR_AddTempRegister, /*InsnID*//* 676(*/0xA4, 0x05/*)*/, /*TempRegID*//* 675(*/0xA3, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196592 */   GIR_AddImm, /*InsnID*//* 676(*/0xA4, 0x05/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 196603 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 676(*/0xA4, 0x05/*)*/,
     /* 196606 */   GIR_MakeTempReg, /*TempRegID*//* 674(*/0xA2, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 196610 */   GIR_BuildMI, /*InsnID*//* 675(*/0xA3, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 196615 */   GIR_AddTempRegister, /*InsnID*//* 675(*/0xA3, 0x05/*)*/, /*TempRegID*//* 674(*/0xA2, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196622 */   GIR_AddSimpleTempRegister, /*InsnID*//* 675(*/0xA3, 0x05/*)*/, /*TempRegID*//* 675(*/0xA3, 0x05/*)*/,
     /* 196627 */   GIR_AddImm, /*InsnID*//* 675(*/0xA3, 0x05/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 196638 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 675(*/0xA3, 0x05/*)*/,
     /* 196641 */   GIR_MakeTempReg, /*TempRegID*//* 673(*/0xA1, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 196645 */   GIR_BuildMI, /*InsnID*//* 674(*/0xA2, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 196650 */   GIR_AddTempRegister, /*InsnID*//* 674(*/0xA2, 0x05/*)*/, /*TempRegID*//* 673(*/0xA1, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196657 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 674(*/0xA2, 0x05/*)*/,
     /* 196660 */   GIR_MakeTempReg, /*TempRegID*//* 672(*/0xA0, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 196664 */   GIR_BuildMI, /*InsnID*//* 673(*/0xA1, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 196669 */   GIR_AddTempRegister, /*InsnID*//* 673(*/0xA1, 0x05/*)*/, /*TempRegID*//* 672(*/0xA0, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196676 */   GIR_AddSimpleTempRegister, /*InsnID*//* 673(*/0xA1, 0x05/*)*/, /*TempRegID*//* 673(*/0xA1, 0x05/*)*/,
     /* 196681 */   GIR_AddSimpleTempRegister, /*InsnID*//* 673(*/0xA1, 0x05/*)*/, /*TempRegID*//* 674(*/0xA2, 0x05/*)*/,
     /* 196686 */   GIR_AddImm8, /*InsnID*//* 673(*/0xA1, 0x05/*)*/, /*Imm*/1,
     /* 196690 */   GIR_ConstrainOperandRC, /*InsnID*//* 673(*/0xA1, 0x05/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 196696 */   GIR_ConstrainOperandRC, /*InsnID*//* 673(*/0xA1, 0x05/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 196702 */   GIR_ConstrainOperandRC, /*InsnID*//* 673(*/0xA1, 0x05/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 196708 */   GIR_MakeTempReg, /*TempRegID*//* 671(*/0x9F, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 196712 */   GIR_BuildMI, /*InsnID*//* 672(*/0xA0, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 196717 */   GIR_AddTempRegister, /*InsnID*//* 672(*/0xA0, 0x05/*)*/, /*TempRegID*//* 671(*/0x9F, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196724 */   GIR_AddSimpleTempRegister, /*InsnID*//* 672(*/0xA0, 0x05/*)*/, /*TempRegID*//* 672(*/0xA0, 0x05/*)*/,
     /* 196729 */   GIR_AddImm8, /*InsnID*//* 672(*/0xA0, 0x05/*)*/, /*Imm*/32,
     /* 196733 */   GIR_AddImm8, /*InsnID*//* 672(*/0xA0, 0x05/*)*/, /*Imm*/31,
     /* 196737 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 672(*/0xA0, 0x05/*)*/,
     /* 196740 */   GIR_MakeTempReg, /*TempRegID*//* 670(*/0x9E, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 196744 */   GIR_BuildMI, /*InsnID*//* 671(*/0x9F, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 196749 */   GIR_AddTempRegister, /*InsnID*//* 671(*/0x9F, 0x05/*)*/, /*TempRegID*//* 670(*/0x9E, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196756 */   GIR_AddSimpleTempRegister, /*InsnID*//* 671(*/0x9F, 0x05/*)*/, /*TempRegID*//* 671(*/0x9F, 0x05/*)*/,
     /* 196761 */   GIR_AddImm, /*InsnID*//* 671(*/0x9F, 0x05/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 196772 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 671(*/0x9F, 0x05/*)*/,
     /* 196775 */   GIR_MakeTempReg, /*TempRegID*//* 669(*/0x9D, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 196779 */   GIR_BuildMI, /*InsnID*//* 670(*/0x9E, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 196784 */   GIR_AddTempRegister, /*InsnID*//* 670(*/0x9E, 0x05/*)*/, /*TempRegID*//* 669(*/0x9D, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196791 */   GIR_AddSimpleTempRegister, /*InsnID*//* 670(*/0x9E, 0x05/*)*/, /*TempRegID*//* 670(*/0x9E, 0x05/*)*/,
     /* 196796 */   GIR_AddImm, /*InsnID*//* 670(*/0x9E, 0x05/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 196807 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 670(*/0x9E, 0x05/*)*/,
     /* 196810 */   GIR_MakeTempReg, /*TempRegID*//* 668(*/0x9C, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 196814 */   GIR_BuildMI, /*InsnID*//* 669(*/0x9D, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 196819 */   GIR_AddTempRegister, /*InsnID*//* 669(*/0x9D, 0x05/*)*/, /*TempRegID*//* 668(*/0x9C, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196826 */   GIR_AddImm, /*InsnID*//* 669(*/0x9D, 0x05/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 196837 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 669(*/0x9D, 0x05/*)*/,
     /* 196840 */   GIR_MakeTempReg, /*TempRegID*//* 667(*/0x9B, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 196844 */   GIR_BuildMI, /*InsnID*//* 668(*/0x9C, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 196849 */   GIR_AddTempRegister, /*InsnID*//* 668(*/0x9C, 0x05/*)*/, /*TempRegID*//* 667(*/0x9B, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196856 */   GIR_AddSimpleTempRegister, /*InsnID*//* 668(*/0x9C, 0x05/*)*/, /*TempRegID*//* 668(*/0x9C, 0x05/*)*/,
     /* 196861 */   GIR_AddImm, /*InsnID*//* 668(*/0x9C, 0x05/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 196872 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 668(*/0x9C, 0x05/*)*/,
     /* 196875 */   GIR_MakeTempReg, /*TempRegID*//* 666(*/0x9A, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 196879 */   GIR_BuildMI, /*InsnID*//* 667(*/0x9B, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 196884 */   GIR_AddTempRegister, /*InsnID*//* 667(*/0x9B, 0x05/*)*/, /*TempRegID*//* 666(*/0x9A, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196891 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 667(*/0x9B, 0x05/*)*/,
     /* 196894 */   GIR_MakeTempReg, /*TempRegID*//* 665(*/0x99, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 196898 */   GIR_BuildMI, /*InsnID*//* 666(*/0x9A, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 196903 */   GIR_AddTempRegister, /*InsnID*//* 666(*/0x9A, 0x05/*)*/, /*TempRegID*//* 665(*/0x99, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196910 */   GIR_AddSimpleTempRegister, /*InsnID*//* 666(*/0x9A, 0x05/*)*/, /*TempRegID*//* 666(*/0x9A, 0x05/*)*/,
     /* 196915 */   GIR_AddSimpleTempRegister, /*InsnID*//* 666(*/0x9A, 0x05/*)*/, /*TempRegID*//* 667(*/0x9B, 0x05/*)*/,
     /* 196920 */   GIR_AddImm8, /*InsnID*//* 666(*/0x9A, 0x05/*)*/, /*Imm*/1,
     /* 196924 */   GIR_ConstrainOperandRC, /*InsnID*//* 666(*/0x9A, 0x05/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 196930 */   GIR_ConstrainOperandRC, /*InsnID*//* 666(*/0x9A, 0x05/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 196936 */   GIR_ConstrainOperandRC, /*InsnID*//* 666(*/0x9A, 0x05/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 196942 */   GIR_MakeTempReg, /*TempRegID*//* 664(*/0x98, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 196946 */   GIR_BuildMI, /*InsnID*//* 665(*/0x99, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 196951 */   GIR_AddTempRegister, /*InsnID*//* 665(*/0x99, 0x05/*)*/, /*TempRegID*//* 664(*/0x98, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196958 */   GIR_AddSimpleTempRegister, /*InsnID*//* 665(*/0x99, 0x05/*)*/, /*TempRegID*//* 665(*/0x99, 0x05/*)*/,
     /* 196963 */   GIR_AddImm8, /*InsnID*//* 665(*/0x99, 0x05/*)*/, /*Imm*/32,
     /* 196967 */   GIR_AddImm8, /*InsnID*//* 665(*/0x99, 0x05/*)*/, /*Imm*/31,
     /* 196971 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 665(*/0x99, 0x05/*)*/,
     /* 196974 */   GIR_MakeTempReg, /*TempRegID*//* 663(*/0x97, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 196978 */   GIR_BuildMI, /*InsnID*//* 664(*/0x98, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 196983 */   GIR_AddTempRegister, /*InsnID*//* 664(*/0x98, 0x05/*)*/, /*TempRegID*//* 663(*/0x97, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196990 */   GIR_AddSimpleTempRegister, /*InsnID*//* 664(*/0x98, 0x05/*)*/, /*TempRegID*//* 664(*/0x98, 0x05/*)*/,
     /* 196995 */   GIR_AddImm, /*InsnID*//* 664(*/0x98, 0x05/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 197006 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 664(*/0x98, 0x05/*)*/,
     /* 197009 */   GIR_MakeTempReg, /*TempRegID*//* 662(*/0x96, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 197013 */   GIR_BuildMI, /*InsnID*//* 663(*/0x97, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 197018 */   GIR_AddTempRegister, /*InsnID*//* 663(*/0x97, 0x05/*)*/, /*TempRegID*//* 662(*/0x96, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197025 */   GIR_AddSimpleTempRegister, /*InsnID*//* 663(*/0x97, 0x05/*)*/, /*TempRegID*//* 663(*/0x97, 0x05/*)*/,
     /* 197030 */   GIR_AddImm, /*InsnID*//* 663(*/0x97, 0x05/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 197041 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 663(*/0x97, 0x05/*)*/,
     /* 197044 */   GIR_MakeTempReg, /*TempRegID*//* 661(*/0x95, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 197048 */   GIR_BuildMI, /*InsnID*//* 662(*/0x96, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 197053 */   GIR_AddTempRegister, /*InsnID*//* 662(*/0x96, 0x05/*)*/, /*TempRegID*//* 661(*/0x95, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197060 */   GIR_Copy, /*NewInsnID*//* 662(*/0x96, 0x05/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 197065 */   GIR_AddImm8, /*InsnID*//* 662(*/0x96, 0x05/*)*/, /*Imm*/1,
     /* 197069 */   GIR_AddImm8, /*InsnID*//* 662(*/0x96, 0x05/*)*/, /*Imm*/62,
     /* 197073 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 662(*/0x96, 0x05/*)*/,
     /* 197076 */   GIR_MakeTempReg, /*TempRegID*//* 660(*/0x94, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 197080 */   GIR_BuildMI, /*InsnID*//* 661(*/0x95, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 197085 */   GIR_AddTempRegister, /*InsnID*//* 661(*/0x95, 0x05/*)*/, /*TempRegID*//* 660(*/0x94, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197092 */   GIR_AddSimpleTempRegister, /*InsnID*//* 661(*/0x95, 0x05/*)*/, /*TempRegID*//* 661(*/0x95, 0x05/*)*/,
     /* 197097 */   GIR_AddSimpleTempRegister, /*InsnID*//* 661(*/0x95, 0x05/*)*/, /*TempRegID*//* 662(*/0x96, 0x05/*)*/,
     /* 197102 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 661(*/0x95, 0x05/*)*/,
     /* 197105 */   GIR_MakeTempReg, /*TempRegID*//* 659(*/0x93, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 197109 */   GIR_BuildMI, /*InsnID*//* 660(*/0x94, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 197114 */   GIR_AddTempRegister, /*InsnID*//* 660(*/0x94, 0x05/*)*/, /*TempRegID*//* 659(*/0x93, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197121 */   GIR_AddImm, /*InsnID*//* 660(*/0x94, 0x05/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 197132 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 660(*/0x94, 0x05/*)*/,
     /* 197135 */   GIR_MakeTempReg, /*TempRegID*//* 658(*/0x92, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 197139 */   GIR_BuildMI, /*InsnID*//* 659(*/0x93, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 197144 */   GIR_AddTempRegister, /*InsnID*//* 659(*/0x93, 0x05/*)*/, /*TempRegID*//* 658(*/0x92, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197151 */   GIR_AddSimpleTempRegister, /*InsnID*//* 659(*/0x93, 0x05/*)*/, /*TempRegID*//* 659(*/0x93, 0x05/*)*/,
     /* 197156 */   GIR_AddImm, /*InsnID*//* 659(*/0x93, 0x05/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 197167 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 659(*/0x93, 0x05/*)*/,
     /* 197170 */   GIR_MakeTempReg, /*TempRegID*//* 657(*/0x91, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 197174 */   GIR_BuildMI, /*InsnID*//* 658(*/0x92, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 197179 */   GIR_AddTempRegister, /*InsnID*//* 658(*/0x92, 0x05/*)*/, /*TempRegID*//* 657(*/0x91, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197186 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 658(*/0x92, 0x05/*)*/,
     /* 197189 */   GIR_MakeTempReg, /*TempRegID*//* 656(*/0x90, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 197193 */   GIR_BuildMI, /*InsnID*//* 657(*/0x91, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 197198 */   GIR_AddTempRegister, /*InsnID*//* 657(*/0x91, 0x05/*)*/, /*TempRegID*//* 656(*/0x90, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197205 */   GIR_AddSimpleTempRegister, /*InsnID*//* 657(*/0x91, 0x05/*)*/, /*TempRegID*//* 657(*/0x91, 0x05/*)*/,
     /* 197210 */   GIR_AddSimpleTempRegister, /*InsnID*//* 657(*/0x91, 0x05/*)*/, /*TempRegID*//* 658(*/0x92, 0x05/*)*/,
     /* 197215 */   GIR_AddImm8, /*InsnID*//* 657(*/0x91, 0x05/*)*/, /*Imm*/1,
     /* 197219 */   GIR_ConstrainOperandRC, /*InsnID*//* 657(*/0x91, 0x05/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 197225 */   GIR_ConstrainOperandRC, /*InsnID*//* 657(*/0x91, 0x05/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 197231 */   GIR_ConstrainOperandRC, /*InsnID*//* 657(*/0x91, 0x05/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 197237 */   GIR_MakeTempReg, /*TempRegID*//* 655(*/0x8F, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 197241 */   GIR_BuildMI, /*InsnID*//* 656(*/0x90, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 197246 */   GIR_AddTempRegister, /*InsnID*//* 656(*/0x90, 0x05/*)*/, /*TempRegID*//* 655(*/0x8F, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197253 */   GIR_AddSimpleTempRegister, /*InsnID*//* 656(*/0x90, 0x05/*)*/, /*TempRegID*//* 656(*/0x90, 0x05/*)*/,
     /* 197258 */   GIR_AddImm8, /*InsnID*//* 656(*/0x90, 0x05/*)*/, /*Imm*/32,
     /* 197262 */   GIR_AddImm8, /*InsnID*//* 656(*/0x90, 0x05/*)*/, /*Imm*/31,
     /* 197266 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 656(*/0x90, 0x05/*)*/,
     /* 197269 */   GIR_MakeTempReg, /*TempRegID*//* 654(*/0x8E, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 197273 */   GIR_BuildMI, /*InsnID*//* 655(*/0x8F, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 197278 */   GIR_AddTempRegister, /*InsnID*//* 655(*/0x8F, 0x05/*)*/, /*TempRegID*//* 654(*/0x8E, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197285 */   GIR_AddSimpleTempRegister, /*InsnID*//* 655(*/0x8F, 0x05/*)*/, /*TempRegID*//* 655(*/0x8F, 0x05/*)*/,
     /* 197290 */   GIR_AddImm, /*InsnID*//* 655(*/0x8F, 0x05/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 197301 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 655(*/0x8F, 0x05/*)*/,
     /* 197304 */   GIR_MakeTempReg, /*TempRegID*//* 653(*/0x8D, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 197308 */   GIR_BuildMI, /*InsnID*//* 654(*/0x8E, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 197313 */   GIR_AddTempRegister, /*InsnID*//* 654(*/0x8E, 0x05/*)*/, /*TempRegID*//* 653(*/0x8D, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197320 */   GIR_AddSimpleTempRegister, /*InsnID*//* 654(*/0x8E, 0x05/*)*/, /*TempRegID*//* 654(*/0x8E, 0x05/*)*/,
     /* 197325 */   GIR_AddImm, /*InsnID*//* 654(*/0x8E, 0x05/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 197336 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 654(*/0x8E, 0x05/*)*/,
     /* 197339 */   GIR_MakeTempReg, /*TempRegID*//* 652(*/0x8C, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 197343 */   GIR_BuildMI, /*InsnID*//* 653(*/0x8D, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 197348 */   GIR_AddTempRegister, /*InsnID*//* 653(*/0x8D, 0x05/*)*/, /*TempRegID*//* 652(*/0x8C, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197355 */   GIR_Copy, /*NewInsnID*//* 653(*/0x8D, 0x05/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 197360 */   GIR_AddImm8, /*InsnID*//* 653(*/0x8D, 0x05/*)*/, /*Imm*/63,
     /* 197364 */   GIR_AddImm8, /*InsnID*//* 653(*/0x8D, 0x05/*)*/, /*Imm*/1,
     /* 197368 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 653(*/0x8D, 0x05/*)*/,
     /* 197371 */   GIR_MakeTempReg, /*TempRegID*//* 651(*/0x8B, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 197375 */   GIR_BuildMI, /*InsnID*//* 652(*/0x8C, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 197380 */   GIR_AddTempRegister, /*InsnID*//* 652(*/0x8C, 0x05/*)*/, /*TempRegID*//* 651(*/0x8B, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197387 */   GIR_AddSimpleTempRegister, /*InsnID*//* 652(*/0x8C, 0x05/*)*/, /*TempRegID*//* 652(*/0x8C, 0x05/*)*/,
     /* 197392 */   GIR_AddSimpleTempRegister, /*InsnID*//* 652(*/0x8C, 0x05/*)*/, /*TempRegID*//* 653(*/0x8D, 0x05/*)*/,
     /* 197397 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 652(*/0x8C, 0x05/*)*/,
     /* 197400 */   GIR_MakeTempReg, /*TempRegID*//* 650(*/0x8A, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 197404 */   GIR_BuildMI, /*InsnID*//* 651(*/0x8B, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 197409 */   GIR_AddTempRegister, /*InsnID*//* 651(*/0x8B, 0x05/*)*/, /*TempRegID*//* 650(*/0x8A, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197416 */   GIR_AddSimpleTempRegister, /*InsnID*//* 651(*/0x8B, 0x05/*)*/, /*TempRegID*//* 651(*/0x8B, 0x05/*)*/,
     /* 197421 */   GIR_AddSimpleTempRegister, /*InsnID*//* 651(*/0x8B, 0x05/*)*/, /*TempRegID*//* 660(*/0x94, 0x05/*)*/,
     /* 197426 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 651(*/0x8B, 0x05/*)*/,
     /* 197429 */   GIR_MakeTempReg, /*TempRegID*//* 649(*/0x89, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 197433 */   GIR_BuildMI, /*InsnID*//* 650(*/0x8A, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 197438 */   GIR_AddTempRegister, /*InsnID*//* 650(*/0x8A, 0x05/*)*/, /*TempRegID*//* 649(*/0x89, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197445 */   GIR_AddSimpleTempRegister, /*InsnID*//* 650(*/0x8A, 0x05/*)*/, /*TempRegID*//* 650(*/0x8A, 0x05/*)*/,
     /* 197450 */   GIR_AddImm8, /*InsnID*//* 650(*/0x8A, 0x05/*)*/, /*Imm*/2,
     /* 197454 */   GIR_AddImm8, /*InsnID*//* 650(*/0x8A, 0x05/*)*/, /*Imm*/61,
     /* 197458 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 650(*/0x8A, 0x05/*)*/,
     /* 197461 */   GIR_MakeTempReg, /*TempRegID*//* 648(*/0x88, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 197465 */   GIR_BuildMI, /*InsnID*//* 649(*/0x89, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 197470 */   GIR_AddTempRegister, /*InsnID*//* 649(*/0x89, 0x05/*)*/, /*TempRegID*//* 648(*/0x88, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197477 */   GIR_AddSimpleTempRegister, /*InsnID*//* 649(*/0x89, 0x05/*)*/, /*TempRegID*//* 649(*/0x89, 0x05/*)*/,
     /* 197482 */   GIR_AddSimpleTempRegister, /*InsnID*//* 649(*/0x89, 0x05/*)*/, /*TempRegID*//* 669(*/0x9D, 0x05/*)*/,
     /* 197487 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 649(*/0x89, 0x05/*)*/,
     /* 197490 */   GIR_MakeTempReg, /*TempRegID*//* 647(*/0x87, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 197494 */   GIR_BuildMI, /*InsnID*//* 648(*/0x88, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 197499 */   GIR_AddTempRegister, /*InsnID*//* 648(*/0x88, 0x05/*)*/, /*TempRegID*//* 647(*/0x87, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197506 */   GIR_AddImm, /*InsnID*//* 648(*/0x88, 0x05/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 197517 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 648(*/0x88, 0x05/*)*/,
     /* 197520 */   GIR_MakeTempReg, /*TempRegID*//* 646(*/0x86, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 197524 */   GIR_BuildMI, /*InsnID*//* 647(*/0x87, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 197529 */   GIR_AddTempRegister, /*InsnID*//* 647(*/0x87, 0x05/*)*/, /*TempRegID*//* 646(*/0x86, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197536 */   GIR_AddSimpleTempRegister, /*InsnID*//* 647(*/0x87, 0x05/*)*/, /*TempRegID*//* 647(*/0x87, 0x05/*)*/,
     /* 197541 */   GIR_AddImm, /*InsnID*//* 647(*/0x87, 0x05/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 197552 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 647(*/0x87, 0x05/*)*/,
     /* 197555 */   GIR_MakeTempReg, /*TempRegID*//* 645(*/0x85, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 197559 */   GIR_BuildMI, /*InsnID*//* 646(*/0x86, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 197564 */   GIR_AddTempRegister, /*InsnID*//* 646(*/0x86, 0x05/*)*/, /*TempRegID*//* 645(*/0x85, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197571 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 646(*/0x86, 0x05/*)*/,
     /* 197574 */   GIR_MakeTempReg, /*TempRegID*//* 644(*/0x84, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 197578 */   GIR_BuildMI, /*InsnID*//* 645(*/0x85, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 197583 */   GIR_AddTempRegister, /*InsnID*//* 645(*/0x85, 0x05/*)*/, /*TempRegID*//* 644(*/0x84, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197590 */   GIR_AddSimpleTempRegister, /*InsnID*//* 645(*/0x85, 0x05/*)*/, /*TempRegID*//* 645(*/0x85, 0x05/*)*/,
     /* 197595 */   GIR_AddSimpleTempRegister, /*InsnID*//* 645(*/0x85, 0x05/*)*/, /*TempRegID*//* 646(*/0x86, 0x05/*)*/,
     /* 197600 */   GIR_AddImm8, /*InsnID*//* 645(*/0x85, 0x05/*)*/, /*Imm*/1,
     /* 197604 */   GIR_ConstrainOperandRC, /*InsnID*//* 645(*/0x85, 0x05/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 197610 */   GIR_ConstrainOperandRC, /*InsnID*//* 645(*/0x85, 0x05/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 197616 */   GIR_ConstrainOperandRC, /*InsnID*//* 645(*/0x85, 0x05/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 197622 */   GIR_MakeTempReg, /*TempRegID*//* 643(*/0x83, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 197626 */   GIR_BuildMI, /*InsnID*//* 644(*/0x84, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 197631 */   GIR_AddTempRegister, /*InsnID*//* 644(*/0x84, 0x05/*)*/, /*TempRegID*//* 643(*/0x83, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197638 */   GIR_AddSimpleTempRegister, /*InsnID*//* 644(*/0x84, 0x05/*)*/, /*TempRegID*//* 644(*/0x84, 0x05/*)*/,
     /* 197643 */   GIR_AddImm8, /*InsnID*//* 644(*/0x84, 0x05/*)*/, /*Imm*/32,
     /* 197647 */   GIR_AddImm8, /*InsnID*//* 644(*/0x84, 0x05/*)*/, /*Imm*/31,
     /* 197651 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 644(*/0x84, 0x05/*)*/,
     /* 197654 */   GIR_MakeTempReg, /*TempRegID*//* 642(*/0x82, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 197658 */   GIR_BuildMI, /*InsnID*//* 643(*/0x83, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 197663 */   GIR_AddTempRegister, /*InsnID*//* 643(*/0x83, 0x05/*)*/, /*TempRegID*//* 642(*/0x82, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197670 */   GIR_AddSimpleTempRegister, /*InsnID*//* 643(*/0x83, 0x05/*)*/, /*TempRegID*//* 643(*/0x83, 0x05/*)*/,
     /* 197675 */   GIR_AddImm, /*InsnID*//* 643(*/0x83, 0x05/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 197686 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 643(*/0x83, 0x05/*)*/,
     /* 197689 */   GIR_MakeTempReg, /*TempRegID*//* 641(*/0x81, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 197693 */   GIR_BuildMI, /*InsnID*//* 642(*/0x82, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 197698 */   GIR_AddTempRegister, /*InsnID*//* 642(*/0x82, 0x05/*)*/, /*TempRegID*//* 641(*/0x81, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197705 */   GIR_AddSimpleTempRegister, /*InsnID*//* 642(*/0x82, 0x05/*)*/, /*TempRegID*//* 642(*/0x82, 0x05/*)*/,
     /* 197710 */   GIR_AddImm, /*InsnID*//* 642(*/0x82, 0x05/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 197721 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 642(*/0x82, 0x05/*)*/,
     /* 197724 */   GIR_MakeTempReg, /*TempRegID*//* 640(*/0x80, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 197728 */   GIR_BuildMI, /*InsnID*//* 641(*/0x81, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 197733 */   GIR_AddTempRegister, /*InsnID*//* 641(*/0x81, 0x05/*)*/, /*TempRegID*//* 640(*/0x80, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197740 */   GIR_AddImm, /*InsnID*//* 641(*/0x81, 0x05/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 197751 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 641(*/0x81, 0x05/*)*/,
     /* 197754 */   GIR_MakeTempReg, /*TempRegID*//* 639(*/0xFF, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 197758 */   GIR_BuildMI, /*InsnID*//* 640(*/0x80, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 197763 */   GIR_AddTempRegister, /*InsnID*//* 640(*/0x80, 0x05/*)*/, /*TempRegID*//* 639(*/0xFF, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197770 */   GIR_AddSimpleTempRegister, /*InsnID*//* 640(*/0x80, 0x05/*)*/, /*TempRegID*//* 640(*/0x80, 0x05/*)*/,
     /* 197775 */   GIR_AddImm, /*InsnID*//* 640(*/0x80, 0x05/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 197786 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 640(*/0x80, 0x05/*)*/,
     /* 197789 */   GIR_MakeTempReg, /*TempRegID*//* 638(*/0xFE, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 197793 */   GIR_BuildMI, /*InsnID*//* 639(*/0xFF, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 197798 */   GIR_AddTempRegister, /*InsnID*//* 639(*/0xFF, 0x04/*)*/, /*TempRegID*//* 638(*/0xFE, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197805 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 639(*/0xFF, 0x04/*)*/,
     /* 197808 */   GIR_MakeTempReg, /*TempRegID*//* 637(*/0xFD, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 197812 */   GIR_BuildMI, /*InsnID*//* 638(*/0xFE, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 197817 */   GIR_AddTempRegister, /*InsnID*//* 638(*/0xFE, 0x04/*)*/, /*TempRegID*//* 637(*/0xFD, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197824 */   GIR_AddSimpleTempRegister, /*InsnID*//* 638(*/0xFE, 0x04/*)*/, /*TempRegID*//* 638(*/0xFE, 0x04/*)*/,
     /* 197829 */   GIR_AddSimpleTempRegister, /*InsnID*//* 638(*/0xFE, 0x04/*)*/, /*TempRegID*//* 639(*/0xFF, 0x04/*)*/,
     /* 197834 */   GIR_AddImm8, /*InsnID*//* 638(*/0xFE, 0x04/*)*/, /*Imm*/1,
     /* 197838 */   GIR_ConstrainOperandRC, /*InsnID*//* 638(*/0xFE, 0x04/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 197844 */   GIR_ConstrainOperandRC, /*InsnID*//* 638(*/0xFE, 0x04/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 197850 */   GIR_ConstrainOperandRC, /*InsnID*//* 638(*/0xFE, 0x04/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 197856 */   GIR_MakeTempReg, /*TempRegID*//* 636(*/0xFC, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 197860 */   GIR_BuildMI, /*InsnID*//* 637(*/0xFD, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 197865 */   GIR_AddTempRegister, /*InsnID*//* 637(*/0xFD, 0x04/*)*/, /*TempRegID*//* 636(*/0xFC, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197872 */   GIR_AddSimpleTempRegister, /*InsnID*//* 637(*/0xFD, 0x04/*)*/, /*TempRegID*//* 637(*/0xFD, 0x04/*)*/,
     /* 197877 */   GIR_AddImm8, /*InsnID*//* 637(*/0xFD, 0x04/*)*/, /*Imm*/32,
     /* 197881 */   GIR_AddImm8, /*InsnID*//* 637(*/0xFD, 0x04/*)*/, /*Imm*/31,
     /* 197885 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 637(*/0xFD, 0x04/*)*/,
     /* 197888 */   GIR_MakeTempReg, /*TempRegID*//* 635(*/0xFB, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 197892 */   GIR_BuildMI, /*InsnID*//* 636(*/0xFC, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 197897 */   GIR_AddTempRegister, /*InsnID*//* 636(*/0xFC, 0x04/*)*/, /*TempRegID*//* 635(*/0xFB, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197904 */   GIR_AddSimpleTempRegister, /*InsnID*//* 636(*/0xFC, 0x04/*)*/, /*TempRegID*//* 636(*/0xFC, 0x04/*)*/,
     /* 197909 */   GIR_AddImm, /*InsnID*//* 636(*/0xFC, 0x04/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 197920 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 636(*/0xFC, 0x04/*)*/,
     /* 197923 */   GIR_MakeTempReg, /*TempRegID*//* 634(*/0xFA, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 197927 */   GIR_BuildMI, /*InsnID*//* 635(*/0xFB, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 197932 */   GIR_AddTempRegister, /*InsnID*//* 635(*/0xFB, 0x04/*)*/, /*TempRegID*//* 634(*/0xFA, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197939 */   GIR_AddSimpleTempRegister, /*InsnID*//* 635(*/0xFB, 0x04/*)*/, /*TempRegID*//* 635(*/0xFB, 0x04/*)*/,
     /* 197944 */   GIR_AddImm, /*InsnID*//* 635(*/0xFB, 0x04/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 197955 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 635(*/0xFB, 0x04/*)*/,
     /* 197958 */   GIR_MakeTempReg, /*TempRegID*//* 633(*/0xF9, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 197962 */   GIR_BuildMI, /*InsnID*//* 634(*/0xFA, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 197967 */   GIR_AddTempRegister, /*InsnID*//* 634(*/0xFA, 0x04/*)*/, /*TempRegID*//* 633(*/0xF9, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197974 */   GIR_Copy, /*NewInsnID*//* 634(*/0xFA, 0x04/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 197979 */   GIR_AddImm8, /*InsnID*//* 634(*/0xFA, 0x04/*)*/, /*Imm*/1,
     /* 197983 */   GIR_AddImm8, /*InsnID*//* 634(*/0xFA, 0x04/*)*/, /*Imm*/62,
     /* 197987 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 634(*/0xFA, 0x04/*)*/,
     /* 197990 */   GIR_MakeTempReg, /*TempRegID*//* 632(*/0xF8, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 197994 */   GIR_BuildMI, /*InsnID*//* 633(*/0xF9, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 197999 */   GIR_AddTempRegister, /*InsnID*//* 633(*/0xF9, 0x04/*)*/, /*TempRegID*//* 632(*/0xF8, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198006 */   GIR_AddSimpleTempRegister, /*InsnID*//* 633(*/0xF9, 0x04/*)*/, /*TempRegID*//* 633(*/0xF9, 0x04/*)*/,
     /* 198011 */   GIR_AddSimpleTempRegister, /*InsnID*//* 633(*/0xF9, 0x04/*)*/, /*TempRegID*//* 634(*/0xFA, 0x04/*)*/,
     /* 198016 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 633(*/0xF9, 0x04/*)*/,
     /* 198019 */   GIR_MakeTempReg, /*TempRegID*//* 631(*/0xF7, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 198023 */   GIR_BuildMI, /*InsnID*//* 632(*/0xF8, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 198028 */   GIR_AddTempRegister, /*InsnID*//* 632(*/0xF8, 0x04/*)*/, /*TempRegID*//* 631(*/0xF7, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198035 */   GIR_AddImm, /*InsnID*//* 632(*/0xF8, 0x04/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 198046 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 632(*/0xF8, 0x04/*)*/,
     /* 198049 */   GIR_MakeTempReg, /*TempRegID*//* 630(*/0xF6, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 198053 */   GIR_BuildMI, /*InsnID*//* 631(*/0xF7, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 198058 */   GIR_AddTempRegister, /*InsnID*//* 631(*/0xF7, 0x04/*)*/, /*TempRegID*//* 630(*/0xF6, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198065 */   GIR_AddSimpleTempRegister, /*InsnID*//* 631(*/0xF7, 0x04/*)*/, /*TempRegID*//* 631(*/0xF7, 0x04/*)*/,
     /* 198070 */   GIR_AddImm, /*InsnID*//* 631(*/0xF7, 0x04/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 198081 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 631(*/0xF7, 0x04/*)*/,
     /* 198084 */   GIR_MakeTempReg, /*TempRegID*//* 629(*/0xF5, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 198088 */   GIR_BuildMI, /*InsnID*//* 630(*/0xF6, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 198093 */   GIR_AddTempRegister, /*InsnID*//* 630(*/0xF6, 0x04/*)*/, /*TempRegID*//* 629(*/0xF5, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198100 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 630(*/0xF6, 0x04/*)*/,
     /* 198103 */   GIR_MakeTempReg, /*TempRegID*//* 628(*/0xF4, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 198107 */   GIR_BuildMI, /*InsnID*//* 629(*/0xF5, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 198112 */   GIR_AddTempRegister, /*InsnID*//* 629(*/0xF5, 0x04/*)*/, /*TempRegID*//* 628(*/0xF4, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198119 */   GIR_AddSimpleTempRegister, /*InsnID*//* 629(*/0xF5, 0x04/*)*/, /*TempRegID*//* 629(*/0xF5, 0x04/*)*/,
     /* 198124 */   GIR_AddSimpleTempRegister, /*InsnID*//* 629(*/0xF5, 0x04/*)*/, /*TempRegID*//* 630(*/0xF6, 0x04/*)*/,
     /* 198129 */   GIR_AddImm8, /*InsnID*//* 629(*/0xF5, 0x04/*)*/, /*Imm*/1,
     /* 198133 */   GIR_ConstrainOperandRC, /*InsnID*//* 629(*/0xF5, 0x04/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 198139 */   GIR_ConstrainOperandRC, /*InsnID*//* 629(*/0xF5, 0x04/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 198145 */   GIR_ConstrainOperandRC, /*InsnID*//* 629(*/0xF5, 0x04/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 198151 */   GIR_MakeTempReg, /*TempRegID*//* 627(*/0xF3, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 198155 */   GIR_BuildMI, /*InsnID*//* 628(*/0xF4, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 198160 */   GIR_AddTempRegister, /*InsnID*//* 628(*/0xF4, 0x04/*)*/, /*TempRegID*//* 627(*/0xF3, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198167 */   GIR_AddSimpleTempRegister, /*InsnID*//* 628(*/0xF4, 0x04/*)*/, /*TempRegID*//* 628(*/0xF4, 0x04/*)*/,
     /* 198172 */   GIR_AddImm8, /*InsnID*//* 628(*/0xF4, 0x04/*)*/, /*Imm*/32,
     /* 198176 */   GIR_AddImm8, /*InsnID*//* 628(*/0xF4, 0x04/*)*/, /*Imm*/31,
     /* 198180 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 628(*/0xF4, 0x04/*)*/,
     /* 198183 */   GIR_MakeTempReg, /*TempRegID*//* 626(*/0xF2, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 198187 */   GIR_BuildMI, /*InsnID*//* 627(*/0xF3, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 198192 */   GIR_AddTempRegister, /*InsnID*//* 627(*/0xF3, 0x04/*)*/, /*TempRegID*//* 626(*/0xF2, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198199 */   GIR_AddSimpleTempRegister, /*InsnID*//* 627(*/0xF3, 0x04/*)*/, /*TempRegID*//* 627(*/0xF3, 0x04/*)*/,
     /* 198204 */   GIR_AddImm, /*InsnID*//* 627(*/0xF3, 0x04/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 198215 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 627(*/0xF3, 0x04/*)*/,
     /* 198218 */   GIR_MakeTempReg, /*TempRegID*//* 625(*/0xF1, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 198222 */   GIR_BuildMI, /*InsnID*//* 626(*/0xF2, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 198227 */   GIR_AddTempRegister, /*InsnID*//* 626(*/0xF2, 0x04/*)*/, /*TempRegID*//* 625(*/0xF1, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198234 */   GIR_AddSimpleTempRegister, /*InsnID*//* 626(*/0xF2, 0x04/*)*/, /*TempRegID*//* 626(*/0xF2, 0x04/*)*/,
     /* 198239 */   GIR_AddImm, /*InsnID*//* 626(*/0xF2, 0x04/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 198250 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 626(*/0xF2, 0x04/*)*/,
     /* 198253 */   GIR_MakeTempReg, /*TempRegID*//* 624(*/0xF0, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 198257 */   GIR_BuildMI, /*InsnID*//* 625(*/0xF1, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 198262 */   GIR_AddTempRegister, /*InsnID*//* 625(*/0xF1, 0x04/*)*/, /*TempRegID*//* 624(*/0xF0, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198269 */   GIR_Copy, /*NewInsnID*//* 625(*/0xF1, 0x04/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 198274 */   GIR_AddImm8, /*InsnID*//* 625(*/0xF1, 0x04/*)*/, /*Imm*/63,
     /* 198278 */   GIR_AddImm8, /*InsnID*//* 625(*/0xF1, 0x04/*)*/, /*Imm*/1,
     /* 198282 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 625(*/0xF1, 0x04/*)*/,
     /* 198285 */   GIR_MakeTempReg, /*TempRegID*//* 623(*/0xEF, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 198289 */   GIR_BuildMI, /*InsnID*//* 624(*/0xF0, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 198294 */   GIR_AddTempRegister, /*InsnID*//* 624(*/0xF0, 0x04/*)*/, /*TempRegID*//* 623(*/0xEF, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198301 */   GIR_AddSimpleTempRegister, /*InsnID*//* 624(*/0xF0, 0x04/*)*/, /*TempRegID*//* 624(*/0xF0, 0x04/*)*/,
     /* 198306 */   GIR_AddSimpleTempRegister, /*InsnID*//* 624(*/0xF0, 0x04/*)*/, /*TempRegID*//* 625(*/0xF1, 0x04/*)*/,
     /* 198311 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 624(*/0xF0, 0x04/*)*/,
     /* 198314 */   GIR_MakeTempReg, /*TempRegID*//* 622(*/0xEE, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 198318 */   GIR_BuildMI, /*InsnID*//* 623(*/0xEF, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 198323 */   GIR_AddTempRegister, /*InsnID*//* 623(*/0xEF, 0x04/*)*/, /*TempRegID*//* 622(*/0xEE, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198330 */   GIR_AddSimpleTempRegister, /*InsnID*//* 623(*/0xEF, 0x04/*)*/, /*TempRegID*//* 623(*/0xEF, 0x04/*)*/,
     /* 198335 */   GIR_AddSimpleTempRegister, /*InsnID*//* 623(*/0xEF, 0x04/*)*/, /*TempRegID*//* 632(*/0xF8, 0x04/*)*/,
     /* 198340 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 623(*/0xEF, 0x04/*)*/,
     /* 198343 */   GIR_MakeTempReg, /*TempRegID*//* 621(*/0xED, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 198347 */   GIR_BuildMI, /*InsnID*//* 622(*/0xEE, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 198352 */   GIR_AddTempRegister, /*InsnID*//* 622(*/0xEE, 0x04/*)*/, /*TempRegID*//* 621(*/0xED, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198359 */   GIR_AddSimpleTempRegister, /*InsnID*//* 622(*/0xEE, 0x04/*)*/, /*TempRegID*//* 622(*/0xEE, 0x04/*)*/,
     /* 198364 */   GIR_AddImm8, /*InsnID*//* 622(*/0xEE, 0x04/*)*/, /*Imm*/62,
     /* 198368 */   GIR_AddImm8, /*InsnID*//* 622(*/0xEE, 0x04/*)*/, /*Imm*/2,
     /* 198372 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 622(*/0xEE, 0x04/*)*/,
     /* 198375 */   GIR_MakeTempReg, /*TempRegID*//* 620(*/0xEC, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 198379 */   GIR_BuildMI, /*InsnID*//* 621(*/0xED, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 198384 */   GIR_AddTempRegister, /*InsnID*//* 621(*/0xED, 0x04/*)*/, /*TempRegID*//* 620(*/0xEC, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198391 */   GIR_AddSimpleTempRegister, /*InsnID*//* 621(*/0xED, 0x04/*)*/, /*TempRegID*//* 621(*/0xED, 0x04/*)*/,
     /* 198396 */   GIR_AddSimpleTempRegister, /*InsnID*//* 621(*/0xED, 0x04/*)*/, /*TempRegID*//* 641(*/0x81, 0x05/*)*/,
     /* 198401 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 621(*/0xED, 0x04/*)*/,
     /* 198404 */   GIR_MakeTempReg, /*TempRegID*//* 619(*/0xEB, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 198408 */   GIR_BuildMI, /*InsnID*//* 620(*/0xEC, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 198413 */   GIR_AddTempRegister, /*InsnID*//* 620(*/0xEC, 0x04/*)*/, /*TempRegID*//* 619(*/0xEB, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198420 */   GIR_AddSimpleTempRegister, /*InsnID*//* 620(*/0xEC, 0x04/*)*/, /*TempRegID*//* 620(*/0xEC, 0x04/*)*/,
     /* 198425 */   GIR_AddSimpleTempRegister, /*InsnID*//* 620(*/0xEC, 0x04/*)*/, /*TempRegID*//* 648(*/0x88, 0x05/*)*/,
     /* 198430 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 620(*/0xEC, 0x04/*)*/,
     /* 198433 */   GIR_MakeTempReg, /*TempRegID*//* 618(*/0xEA, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 198437 */   GIR_BuildMI, /*InsnID*//* 619(*/0xEB, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 198442 */   GIR_AddTempRegister, /*InsnID*//* 619(*/0xEB, 0x04/*)*/, /*TempRegID*//* 618(*/0xEA, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198449 */   GIR_AddSimpleTempRegister, /*InsnID*//* 619(*/0xEB, 0x04/*)*/, /*TempRegID*//* 619(*/0xEB, 0x04/*)*/,
     /* 198454 */   GIR_AddImm8, /*InsnID*//* 619(*/0xEB, 0x04/*)*/, /*Imm*/4,
     /* 198458 */   GIR_AddImm8, /*InsnID*//* 619(*/0xEB, 0x04/*)*/, /*Imm*/59,
     /* 198462 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 619(*/0xEB, 0x04/*)*/,
     /* 198465 */   GIR_MakeTempReg, /*TempRegID*//* 617(*/0xE9, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 198469 */   GIR_BuildMI, /*InsnID*//* 618(*/0xEA, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 198474 */   GIR_AddTempRegister, /*InsnID*//* 618(*/0xEA, 0x04/*)*/, /*TempRegID*//* 617(*/0xE9, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198481 */   GIR_AddSimpleTempRegister, /*InsnID*//* 618(*/0xEA, 0x04/*)*/, /*TempRegID*//* 618(*/0xEA, 0x04/*)*/,
     /* 198486 */   GIR_AddSimpleTempRegister, /*InsnID*//* 618(*/0xEA, 0x04/*)*/, /*TempRegID*//* 676(*/0xA4, 0x05/*)*/,
     /* 198491 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 618(*/0xEA, 0x04/*)*/,
     /* 198494 */   GIR_MakeTempReg, /*TempRegID*//* 616(*/0xE8, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 198498 */   GIR_BuildMI, /*InsnID*//* 617(*/0xE9, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 198503 */   GIR_AddTempRegister, /*InsnID*//* 617(*/0xE9, 0x04/*)*/, /*TempRegID*//* 616(*/0xE8, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198510 */   GIR_AddImm, /*InsnID*//* 617(*/0xE9, 0x04/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 198521 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 617(*/0xE9, 0x04/*)*/,
     /* 198524 */   GIR_MakeTempReg, /*TempRegID*//* 615(*/0xE7, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 198528 */   GIR_BuildMI, /*InsnID*//* 616(*/0xE8, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 198533 */   GIR_AddTempRegister, /*InsnID*//* 616(*/0xE8, 0x04/*)*/, /*TempRegID*//* 615(*/0xE7, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198540 */   GIR_AddSimpleTempRegister, /*InsnID*//* 616(*/0xE8, 0x04/*)*/, /*TempRegID*//* 616(*/0xE8, 0x04/*)*/,
     /* 198545 */   GIR_AddImm, /*InsnID*//* 616(*/0xE8, 0x04/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 198556 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 616(*/0xE8, 0x04/*)*/,
     /* 198559 */   GIR_MakeTempReg, /*TempRegID*//* 614(*/0xE6, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 198563 */   GIR_BuildMI, /*InsnID*//* 615(*/0xE7, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 198568 */   GIR_AddTempRegister, /*InsnID*//* 615(*/0xE7, 0x04/*)*/, /*TempRegID*//* 614(*/0xE6, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198575 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 615(*/0xE7, 0x04/*)*/,
     /* 198578 */   GIR_MakeTempReg, /*TempRegID*//* 613(*/0xE5, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 198582 */   GIR_BuildMI, /*InsnID*//* 614(*/0xE6, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 198587 */   GIR_AddTempRegister, /*InsnID*//* 614(*/0xE6, 0x04/*)*/, /*TempRegID*//* 613(*/0xE5, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198594 */   GIR_AddSimpleTempRegister, /*InsnID*//* 614(*/0xE6, 0x04/*)*/, /*TempRegID*//* 614(*/0xE6, 0x04/*)*/,
     /* 198599 */   GIR_AddSimpleTempRegister, /*InsnID*//* 614(*/0xE6, 0x04/*)*/, /*TempRegID*//* 615(*/0xE7, 0x04/*)*/,
     /* 198604 */   GIR_AddImm8, /*InsnID*//* 614(*/0xE6, 0x04/*)*/, /*Imm*/1,
     /* 198608 */   GIR_ConstrainOperandRC, /*InsnID*//* 614(*/0xE6, 0x04/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 198614 */   GIR_ConstrainOperandRC, /*InsnID*//* 614(*/0xE6, 0x04/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 198620 */   GIR_ConstrainOperandRC, /*InsnID*//* 614(*/0xE6, 0x04/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 198626 */   GIR_MakeTempReg, /*TempRegID*//* 612(*/0xE4, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 198630 */   GIR_BuildMI, /*InsnID*//* 613(*/0xE5, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 198635 */   GIR_AddTempRegister, /*InsnID*//* 613(*/0xE5, 0x04/*)*/, /*TempRegID*//* 612(*/0xE4, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198642 */   GIR_AddSimpleTempRegister, /*InsnID*//* 613(*/0xE5, 0x04/*)*/, /*TempRegID*//* 613(*/0xE5, 0x04/*)*/,
     /* 198647 */   GIR_AddImm8, /*InsnID*//* 613(*/0xE5, 0x04/*)*/, /*Imm*/32,
     /* 198651 */   GIR_AddImm8, /*InsnID*//* 613(*/0xE5, 0x04/*)*/, /*Imm*/31,
     /* 198655 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 613(*/0xE5, 0x04/*)*/,
     /* 198658 */   GIR_MakeTempReg, /*TempRegID*//* 611(*/0xE3, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 198662 */   GIR_BuildMI, /*InsnID*//* 612(*/0xE4, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 198667 */   GIR_AddTempRegister, /*InsnID*//* 612(*/0xE4, 0x04/*)*/, /*TempRegID*//* 611(*/0xE3, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198674 */   GIR_AddSimpleTempRegister, /*InsnID*//* 612(*/0xE4, 0x04/*)*/, /*TempRegID*//* 612(*/0xE4, 0x04/*)*/,
     /* 198679 */   GIR_AddImm, /*InsnID*//* 612(*/0xE4, 0x04/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 198690 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 612(*/0xE4, 0x04/*)*/,
     /* 198693 */   GIR_MakeTempReg, /*TempRegID*//* 610(*/0xE2, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 198697 */   GIR_BuildMI, /*InsnID*//* 611(*/0xE3, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 198702 */   GIR_AddTempRegister, /*InsnID*//* 611(*/0xE3, 0x04/*)*/, /*TempRegID*//* 610(*/0xE2, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198709 */   GIR_AddSimpleTempRegister, /*InsnID*//* 611(*/0xE3, 0x04/*)*/, /*TempRegID*//* 611(*/0xE3, 0x04/*)*/,
     /* 198714 */   GIR_AddImm, /*InsnID*//* 611(*/0xE3, 0x04/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 198725 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 611(*/0xE3, 0x04/*)*/,
     /* 198728 */   GIR_MakeTempReg, /*TempRegID*//* 609(*/0xE1, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 198732 */   GIR_BuildMI, /*InsnID*//* 610(*/0xE2, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 198737 */   GIR_AddTempRegister, /*InsnID*//* 610(*/0xE2, 0x04/*)*/, /*TempRegID*//* 609(*/0xE1, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198744 */   GIR_AddImm, /*InsnID*//* 610(*/0xE2, 0x04/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 198755 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 610(*/0xE2, 0x04/*)*/,
     /* 198758 */   GIR_MakeTempReg, /*TempRegID*//* 608(*/0xE0, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 198762 */   GIR_BuildMI, /*InsnID*//* 609(*/0xE1, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 198767 */   GIR_AddTempRegister, /*InsnID*//* 609(*/0xE1, 0x04/*)*/, /*TempRegID*//* 608(*/0xE0, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198774 */   GIR_AddSimpleTempRegister, /*InsnID*//* 609(*/0xE1, 0x04/*)*/, /*TempRegID*//* 609(*/0xE1, 0x04/*)*/,
     /* 198779 */   GIR_AddImm, /*InsnID*//* 609(*/0xE1, 0x04/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 198790 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 609(*/0xE1, 0x04/*)*/,
     /* 198793 */   GIR_MakeTempReg, /*TempRegID*//* 607(*/0xDF, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 198797 */   GIR_BuildMI, /*InsnID*//* 608(*/0xE0, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 198802 */   GIR_AddTempRegister, /*InsnID*//* 608(*/0xE0, 0x04/*)*/, /*TempRegID*//* 607(*/0xDF, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198809 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 608(*/0xE0, 0x04/*)*/,
     /* 198812 */   GIR_MakeTempReg, /*TempRegID*//* 606(*/0xDE, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 198816 */   GIR_BuildMI, /*InsnID*//* 607(*/0xDF, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 198821 */   GIR_AddTempRegister, /*InsnID*//* 607(*/0xDF, 0x04/*)*/, /*TempRegID*//* 606(*/0xDE, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198828 */   GIR_AddSimpleTempRegister, /*InsnID*//* 607(*/0xDF, 0x04/*)*/, /*TempRegID*//* 607(*/0xDF, 0x04/*)*/,
     /* 198833 */   GIR_AddSimpleTempRegister, /*InsnID*//* 607(*/0xDF, 0x04/*)*/, /*TempRegID*//* 608(*/0xE0, 0x04/*)*/,
     /* 198838 */   GIR_AddImm8, /*InsnID*//* 607(*/0xDF, 0x04/*)*/, /*Imm*/1,
     /* 198842 */   GIR_ConstrainOperandRC, /*InsnID*//* 607(*/0xDF, 0x04/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 198848 */   GIR_ConstrainOperandRC, /*InsnID*//* 607(*/0xDF, 0x04/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 198854 */   GIR_ConstrainOperandRC, /*InsnID*//* 607(*/0xDF, 0x04/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 198860 */   GIR_MakeTempReg, /*TempRegID*//* 605(*/0xDD, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 198864 */   GIR_BuildMI, /*InsnID*//* 606(*/0xDE, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 198869 */   GIR_AddTempRegister, /*InsnID*//* 606(*/0xDE, 0x04/*)*/, /*TempRegID*//* 605(*/0xDD, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198876 */   GIR_AddSimpleTempRegister, /*InsnID*//* 606(*/0xDE, 0x04/*)*/, /*TempRegID*//* 606(*/0xDE, 0x04/*)*/,
     /* 198881 */   GIR_AddImm8, /*InsnID*//* 606(*/0xDE, 0x04/*)*/, /*Imm*/32,
     /* 198885 */   GIR_AddImm8, /*InsnID*//* 606(*/0xDE, 0x04/*)*/, /*Imm*/31,
     /* 198889 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 606(*/0xDE, 0x04/*)*/,
     /* 198892 */   GIR_MakeTempReg, /*TempRegID*//* 604(*/0xDC, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 198896 */   GIR_BuildMI, /*InsnID*//* 605(*/0xDD, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 198901 */   GIR_AddTempRegister, /*InsnID*//* 605(*/0xDD, 0x04/*)*/, /*TempRegID*//* 604(*/0xDC, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198908 */   GIR_AddSimpleTempRegister, /*InsnID*//* 605(*/0xDD, 0x04/*)*/, /*TempRegID*//* 605(*/0xDD, 0x04/*)*/,
     /* 198913 */   GIR_AddImm, /*InsnID*//* 605(*/0xDD, 0x04/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 198924 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 605(*/0xDD, 0x04/*)*/,
     /* 198927 */   GIR_MakeTempReg, /*TempRegID*//* 603(*/0xDB, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 198931 */   GIR_BuildMI, /*InsnID*//* 604(*/0xDC, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 198936 */   GIR_AddTempRegister, /*InsnID*//* 604(*/0xDC, 0x04/*)*/, /*TempRegID*//* 603(*/0xDB, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198943 */   GIR_AddSimpleTempRegister, /*InsnID*//* 604(*/0xDC, 0x04/*)*/, /*TempRegID*//* 604(*/0xDC, 0x04/*)*/,
     /* 198948 */   GIR_AddImm, /*InsnID*//* 604(*/0xDC, 0x04/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 198959 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 604(*/0xDC, 0x04/*)*/,
     /* 198962 */   GIR_MakeTempReg, /*TempRegID*//* 602(*/0xDA, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 198966 */   GIR_BuildMI, /*InsnID*//* 603(*/0xDB, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 198971 */   GIR_AddTempRegister, /*InsnID*//* 603(*/0xDB, 0x04/*)*/, /*TempRegID*//* 602(*/0xDA, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198978 */   GIR_AddImm, /*InsnID*//* 603(*/0xDB, 0x04/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 198989 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 603(*/0xDB, 0x04/*)*/,
     /* 198992 */   GIR_MakeTempReg, /*TempRegID*//* 601(*/0xD9, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 198996 */   GIR_BuildMI, /*InsnID*//* 602(*/0xDA, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 199001 */   GIR_AddTempRegister, /*InsnID*//* 602(*/0xDA, 0x04/*)*/, /*TempRegID*//* 601(*/0xD9, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199008 */   GIR_AddSimpleTempRegister, /*InsnID*//* 602(*/0xDA, 0x04/*)*/, /*TempRegID*//* 602(*/0xDA, 0x04/*)*/,
     /* 199013 */   GIR_AddImm, /*InsnID*//* 602(*/0xDA, 0x04/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 199024 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 602(*/0xDA, 0x04/*)*/,
     /* 199027 */   GIR_MakeTempReg, /*TempRegID*//* 600(*/0xD8, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 199031 */   GIR_BuildMI, /*InsnID*//* 601(*/0xD9, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 199036 */   GIR_AddTempRegister, /*InsnID*//* 601(*/0xD9, 0x04/*)*/, /*TempRegID*//* 600(*/0xD8, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199043 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 601(*/0xD9, 0x04/*)*/,
     /* 199046 */   GIR_MakeTempReg, /*TempRegID*//* 599(*/0xD7, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 199050 */   GIR_BuildMI, /*InsnID*//* 600(*/0xD8, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 199055 */   GIR_AddTempRegister, /*InsnID*//* 600(*/0xD8, 0x04/*)*/, /*TempRegID*//* 599(*/0xD7, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199062 */   GIR_AddSimpleTempRegister, /*InsnID*//* 600(*/0xD8, 0x04/*)*/, /*TempRegID*//* 600(*/0xD8, 0x04/*)*/,
     /* 199067 */   GIR_AddSimpleTempRegister, /*InsnID*//* 600(*/0xD8, 0x04/*)*/, /*TempRegID*//* 601(*/0xD9, 0x04/*)*/,
     /* 199072 */   GIR_AddImm8, /*InsnID*//* 600(*/0xD8, 0x04/*)*/, /*Imm*/1,
     /* 199076 */   GIR_ConstrainOperandRC, /*InsnID*//* 600(*/0xD8, 0x04/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 199082 */   GIR_ConstrainOperandRC, /*InsnID*//* 600(*/0xD8, 0x04/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 199088 */   GIR_ConstrainOperandRC, /*InsnID*//* 600(*/0xD8, 0x04/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 199094 */   GIR_MakeTempReg, /*TempRegID*//* 598(*/0xD6, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 199098 */   GIR_BuildMI, /*InsnID*//* 599(*/0xD7, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 199103 */   GIR_AddTempRegister, /*InsnID*//* 599(*/0xD7, 0x04/*)*/, /*TempRegID*//* 598(*/0xD6, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199110 */   GIR_AddSimpleTempRegister, /*InsnID*//* 599(*/0xD7, 0x04/*)*/, /*TempRegID*//* 599(*/0xD7, 0x04/*)*/,
     /* 199115 */   GIR_AddImm8, /*InsnID*//* 599(*/0xD7, 0x04/*)*/, /*Imm*/32,
     /* 199119 */   GIR_AddImm8, /*InsnID*//* 599(*/0xD7, 0x04/*)*/, /*Imm*/31,
     /* 199123 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 599(*/0xD7, 0x04/*)*/,
     /* 199126 */   GIR_MakeTempReg, /*TempRegID*//* 597(*/0xD5, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 199130 */   GIR_BuildMI, /*InsnID*//* 598(*/0xD6, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 199135 */   GIR_AddTempRegister, /*InsnID*//* 598(*/0xD6, 0x04/*)*/, /*TempRegID*//* 597(*/0xD5, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199142 */   GIR_AddSimpleTempRegister, /*InsnID*//* 598(*/0xD6, 0x04/*)*/, /*TempRegID*//* 598(*/0xD6, 0x04/*)*/,
     /* 199147 */   GIR_AddImm, /*InsnID*//* 598(*/0xD6, 0x04/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 199158 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 598(*/0xD6, 0x04/*)*/,
     /* 199161 */   GIR_MakeTempReg, /*TempRegID*//* 596(*/0xD4, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 199165 */   GIR_BuildMI, /*InsnID*//* 597(*/0xD5, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 199170 */   GIR_AddTempRegister, /*InsnID*//* 597(*/0xD5, 0x04/*)*/, /*TempRegID*//* 596(*/0xD4, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199177 */   GIR_AddSimpleTempRegister, /*InsnID*//* 597(*/0xD5, 0x04/*)*/, /*TempRegID*//* 597(*/0xD5, 0x04/*)*/,
     /* 199182 */   GIR_AddImm, /*InsnID*//* 597(*/0xD5, 0x04/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 199193 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 597(*/0xD5, 0x04/*)*/,
     /* 199196 */   GIR_MakeTempReg, /*TempRegID*//* 595(*/0xD3, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 199200 */   GIR_BuildMI, /*InsnID*//* 596(*/0xD4, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 199205 */   GIR_AddTempRegister, /*InsnID*//* 596(*/0xD4, 0x04/*)*/, /*TempRegID*//* 595(*/0xD3, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199212 */   GIR_Copy, /*NewInsnID*//* 596(*/0xD4, 0x04/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 199217 */   GIR_AddImm8, /*InsnID*//* 596(*/0xD4, 0x04/*)*/, /*Imm*/1,
     /* 199221 */   GIR_AddImm8, /*InsnID*//* 596(*/0xD4, 0x04/*)*/, /*Imm*/62,
     /* 199225 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 596(*/0xD4, 0x04/*)*/,
     /* 199228 */   GIR_MakeTempReg, /*TempRegID*//* 594(*/0xD2, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 199232 */   GIR_BuildMI, /*InsnID*//* 595(*/0xD3, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 199237 */   GIR_AddTempRegister, /*InsnID*//* 595(*/0xD3, 0x04/*)*/, /*TempRegID*//* 594(*/0xD2, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199244 */   GIR_AddSimpleTempRegister, /*InsnID*//* 595(*/0xD3, 0x04/*)*/, /*TempRegID*//* 595(*/0xD3, 0x04/*)*/,
     /* 199249 */   GIR_AddSimpleTempRegister, /*InsnID*//* 595(*/0xD3, 0x04/*)*/, /*TempRegID*//* 596(*/0xD4, 0x04/*)*/,
     /* 199254 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 595(*/0xD3, 0x04/*)*/,
     /* 199257 */   GIR_MakeTempReg, /*TempRegID*//* 593(*/0xD1, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 199261 */   GIR_BuildMI, /*InsnID*//* 594(*/0xD2, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 199266 */   GIR_AddTempRegister, /*InsnID*//* 594(*/0xD2, 0x04/*)*/, /*TempRegID*//* 593(*/0xD1, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199273 */   GIR_AddImm, /*InsnID*//* 594(*/0xD2, 0x04/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 199284 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 594(*/0xD2, 0x04/*)*/,
     /* 199287 */   GIR_MakeTempReg, /*TempRegID*//* 592(*/0xD0, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 199291 */   GIR_BuildMI, /*InsnID*//* 593(*/0xD1, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 199296 */   GIR_AddTempRegister, /*InsnID*//* 593(*/0xD1, 0x04/*)*/, /*TempRegID*//* 592(*/0xD0, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199303 */   GIR_AddSimpleTempRegister, /*InsnID*//* 593(*/0xD1, 0x04/*)*/, /*TempRegID*//* 593(*/0xD1, 0x04/*)*/,
     /* 199308 */   GIR_AddImm, /*InsnID*//* 593(*/0xD1, 0x04/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 199319 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 593(*/0xD1, 0x04/*)*/,
     /* 199322 */   GIR_MakeTempReg, /*TempRegID*//* 591(*/0xCF, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 199326 */   GIR_BuildMI, /*InsnID*//* 592(*/0xD0, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 199331 */   GIR_AddTempRegister, /*InsnID*//* 592(*/0xD0, 0x04/*)*/, /*TempRegID*//* 591(*/0xCF, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199338 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 592(*/0xD0, 0x04/*)*/,
     /* 199341 */   GIR_MakeTempReg, /*TempRegID*//* 590(*/0xCE, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 199345 */   GIR_BuildMI, /*InsnID*//* 591(*/0xCF, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 199350 */   GIR_AddTempRegister, /*InsnID*//* 591(*/0xCF, 0x04/*)*/, /*TempRegID*//* 590(*/0xCE, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199357 */   GIR_AddSimpleTempRegister, /*InsnID*//* 591(*/0xCF, 0x04/*)*/, /*TempRegID*//* 591(*/0xCF, 0x04/*)*/,
     /* 199362 */   GIR_AddSimpleTempRegister, /*InsnID*//* 591(*/0xCF, 0x04/*)*/, /*TempRegID*//* 592(*/0xD0, 0x04/*)*/,
     /* 199367 */   GIR_AddImm8, /*InsnID*//* 591(*/0xCF, 0x04/*)*/, /*Imm*/1,
     /* 199371 */   GIR_ConstrainOperandRC, /*InsnID*//* 591(*/0xCF, 0x04/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 199377 */   GIR_ConstrainOperandRC, /*InsnID*//* 591(*/0xCF, 0x04/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 199383 */   GIR_ConstrainOperandRC, /*InsnID*//* 591(*/0xCF, 0x04/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 199389 */   GIR_MakeTempReg, /*TempRegID*//* 589(*/0xCD, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 199393 */   GIR_BuildMI, /*InsnID*//* 590(*/0xCE, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 199398 */   GIR_AddTempRegister, /*InsnID*//* 590(*/0xCE, 0x04/*)*/, /*TempRegID*//* 589(*/0xCD, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199405 */   GIR_AddSimpleTempRegister, /*InsnID*//* 590(*/0xCE, 0x04/*)*/, /*TempRegID*//* 590(*/0xCE, 0x04/*)*/,
     /* 199410 */   GIR_AddImm8, /*InsnID*//* 590(*/0xCE, 0x04/*)*/, /*Imm*/32,
     /* 199414 */   GIR_AddImm8, /*InsnID*//* 590(*/0xCE, 0x04/*)*/, /*Imm*/31,
     /* 199418 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 590(*/0xCE, 0x04/*)*/,
     /* 199421 */   GIR_MakeTempReg, /*TempRegID*//* 588(*/0xCC, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 199425 */   GIR_BuildMI, /*InsnID*//* 589(*/0xCD, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 199430 */   GIR_AddTempRegister, /*InsnID*//* 589(*/0xCD, 0x04/*)*/, /*TempRegID*//* 588(*/0xCC, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199437 */   GIR_AddSimpleTempRegister, /*InsnID*//* 589(*/0xCD, 0x04/*)*/, /*TempRegID*//* 589(*/0xCD, 0x04/*)*/,
     /* 199442 */   GIR_AddImm, /*InsnID*//* 589(*/0xCD, 0x04/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 199453 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 589(*/0xCD, 0x04/*)*/,
     /* 199456 */   GIR_MakeTempReg, /*TempRegID*//* 587(*/0xCB, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 199460 */   GIR_BuildMI, /*InsnID*//* 588(*/0xCC, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 199465 */   GIR_AddTempRegister, /*InsnID*//* 588(*/0xCC, 0x04/*)*/, /*TempRegID*//* 587(*/0xCB, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199472 */   GIR_AddSimpleTempRegister, /*InsnID*//* 588(*/0xCC, 0x04/*)*/, /*TempRegID*//* 588(*/0xCC, 0x04/*)*/,
     /* 199477 */   GIR_AddImm, /*InsnID*//* 588(*/0xCC, 0x04/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 199488 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 588(*/0xCC, 0x04/*)*/,
     /* 199491 */   GIR_MakeTempReg, /*TempRegID*//* 586(*/0xCA, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 199495 */   GIR_BuildMI, /*InsnID*//* 587(*/0xCB, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 199500 */   GIR_AddTempRegister, /*InsnID*//* 587(*/0xCB, 0x04/*)*/, /*TempRegID*//* 586(*/0xCA, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199507 */   GIR_Copy, /*NewInsnID*//* 587(*/0xCB, 0x04/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 199512 */   GIR_AddImm8, /*InsnID*//* 587(*/0xCB, 0x04/*)*/, /*Imm*/63,
     /* 199516 */   GIR_AddImm8, /*InsnID*//* 587(*/0xCB, 0x04/*)*/, /*Imm*/1,
     /* 199520 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 587(*/0xCB, 0x04/*)*/,
     /* 199523 */   GIR_MakeTempReg, /*TempRegID*//* 585(*/0xC9, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 199527 */   GIR_BuildMI, /*InsnID*//* 586(*/0xCA, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 199532 */   GIR_AddTempRegister, /*InsnID*//* 586(*/0xCA, 0x04/*)*/, /*TempRegID*//* 585(*/0xC9, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199539 */   GIR_AddSimpleTempRegister, /*InsnID*//* 586(*/0xCA, 0x04/*)*/, /*TempRegID*//* 586(*/0xCA, 0x04/*)*/,
     /* 199544 */   GIR_AddSimpleTempRegister, /*InsnID*//* 586(*/0xCA, 0x04/*)*/, /*TempRegID*//* 587(*/0xCB, 0x04/*)*/,
     /* 199549 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 586(*/0xCA, 0x04/*)*/,
     /* 199552 */   GIR_MakeTempReg, /*TempRegID*//* 584(*/0xC8, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 199556 */   GIR_BuildMI, /*InsnID*//* 585(*/0xC9, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 199561 */   GIR_AddTempRegister, /*InsnID*//* 585(*/0xC9, 0x04/*)*/, /*TempRegID*//* 584(*/0xC8, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199568 */   GIR_AddSimpleTempRegister, /*InsnID*//* 585(*/0xC9, 0x04/*)*/, /*TempRegID*//* 585(*/0xC9, 0x04/*)*/,
     /* 199573 */   GIR_AddSimpleTempRegister, /*InsnID*//* 585(*/0xC9, 0x04/*)*/, /*TempRegID*//* 594(*/0xD2, 0x04/*)*/,
     /* 199578 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 585(*/0xC9, 0x04/*)*/,
     /* 199581 */   GIR_MakeTempReg, /*TempRegID*//* 583(*/0xC7, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 199585 */   GIR_BuildMI, /*InsnID*//* 584(*/0xC8, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 199590 */   GIR_AddTempRegister, /*InsnID*//* 584(*/0xC8, 0x04/*)*/, /*TempRegID*//* 583(*/0xC7, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199597 */   GIR_AddSimpleTempRegister, /*InsnID*//* 584(*/0xC8, 0x04/*)*/, /*TempRegID*//* 584(*/0xC8, 0x04/*)*/,
     /* 199602 */   GIR_AddImm8, /*InsnID*//* 584(*/0xC8, 0x04/*)*/, /*Imm*/2,
     /* 199606 */   GIR_AddImm8, /*InsnID*//* 584(*/0xC8, 0x04/*)*/, /*Imm*/61,
     /* 199610 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 584(*/0xC8, 0x04/*)*/,
     /* 199613 */   GIR_MakeTempReg, /*TempRegID*//* 582(*/0xC6, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 199617 */   GIR_BuildMI, /*InsnID*//* 583(*/0xC7, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 199622 */   GIR_AddTempRegister, /*InsnID*//* 583(*/0xC7, 0x04/*)*/, /*TempRegID*//* 582(*/0xC6, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199629 */   GIR_AddSimpleTempRegister, /*InsnID*//* 583(*/0xC7, 0x04/*)*/, /*TempRegID*//* 583(*/0xC7, 0x04/*)*/,
     /* 199634 */   GIR_AddSimpleTempRegister, /*InsnID*//* 583(*/0xC7, 0x04/*)*/, /*TempRegID*//* 603(*/0xDB, 0x04/*)*/,
     /* 199639 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 583(*/0xC7, 0x04/*)*/,
     /* 199642 */   GIR_MakeTempReg, /*TempRegID*//* 581(*/0xC5, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 199646 */   GIR_BuildMI, /*InsnID*//* 582(*/0xC6, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 199651 */   GIR_AddTempRegister, /*InsnID*//* 582(*/0xC6, 0x04/*)*/, /*TempRegID*//* 581(*/0xC5, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199658 */   GIR_AddImm, /*InsnID*//* 582(*/0xC6, 0x04/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 199669 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 582(*/0xC6, 0x04/*)*/,
     /* 199672 */   GIR_MakeTempReg, /*TempRegID*//* 580(*/0xC4, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 199676 */   GIR_BuildMI, /*InsnID*//* 581(*/0xC5, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 199681 */   GIR_AddTempRegister, /*InsnID*//* 581(*/0xC5, 0x04/*)*/, /*TempRegID*//* 580(*/0xC4, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199688 */   GIR_AddSimpleTempRegister, /*InsnID*//* 581(*/0xC5, 0x04/*)*/, /*TempRegID*//* 581(*/0xC5, 0x04/*)*/,
     /* 199693 */   GIR_AddImm, /*InsnID*//* 581(*/0xC5, 0x04/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 199704 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 581(*/0xC5, 0x04/*)*/,
     /* 199707 */   GIR_MakeTempReg, /*TempRegID*//* 579(*/0xC3, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 199711 */   GIR_BuildMI, /*InsnID*//* 580(*/0xC4, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 199716 */   GIR_AddTempRegister, /*InsnID*//* 580(*/0xC4, 0x04/*)*/, /*TempRegID*//* 579(*/0xC3, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199723 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 580(*/0xC4, 0x04/*)*/,
     /* 199726 */   GIR_MakeTempReg, /*TempRegID*//* 578(*/0xC2, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 199730 */   GIR_BuildMI, /*InsnID*//* 579(*/0xC3, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 199735 */   GIR_AddTempRegister, /*InsnID*//* 579(*/0xC3, 0x04/*)*/, /*TempRegID*//* 578(*/0xC2, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199742 */   GIR_AddSimpleTempRegister, /*InsnID*//* 579(*/0xC3, 0x04/*)*/, /*TempRegID*//* 579(*/0xC3, 0x04/*)*/,
     /* 199747 */   GIR_AddSimpleTempRegister, /*InsnID*//* 579(*/0xC3, 0x04/*)*/, /*TempRegID*//* 580(*/0xC4, 0x04/*)*/,
     /* 199752 */   GIR_AddImm8, /*InsnID*//* 579(*/0xC3, 0x04/*)*/, /*Imm*/1,
     /* 199756 */   GIR_ConstrainOperandRC, /*InsnID*//* 579(*/0xC3, 0x04/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 199762 */   GIR_ConstrainOperandRC, /*InsnID*//* 579(*/0xC3, 0x04/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 199768 */   GIR_ConstrainOperandRC, /*InsnID*//* 579(*/0xC3, 0x04/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 199774 */   GIR_MakeTempReg, /*TempRegID*//* 577(*/0xC1, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 199778 */   GIR_BuildMI, /*InsnID*//* 578(*/0xC2, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 199783 */   GIR_AddTempRegister, /*InsnID*//* 578(*/0xC2, 0x04/*)*/, /*TempRegID*//* 577(*/0xC1, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199790 */   GIR_AddSimpleTempRegister, /*InsnID*//* 578(*/0xC2, 0x04/*)*/, /*TempRegID*//* 578(*/0xC2, 0x04/*)*/,
     /* 199795 */   GIR_AddImm8, /*InsnID*//* 578(*/0xC2, 0x04/*)*/, /*Imm*/32,
     /* 199799 */   GIR_AddImm8, /*InsnID*//* 578(*/0xC2, 0x04/*)*/, /*Imm*/31,
     /* 199803 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 578(*/0xC2, 0x04/*)*/,
     /* 199806 */   GIR_MakeTempReg, /*TempRegID*//* 576(*/0xC0, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 199810 */   GIR_BuildMI, /*InsnID*//* 577(*/0xC1, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 199815 */   GIR_AddTempRegister, /*InsnID*//* 577(*/0xC1, 0x04/*)*/, /*TempRegID*//* 576(*/0xC0, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199822 */   GIR_AddSimpleTempRegister, /*InsnID*//* 577(*/0xC1, 0x04/*)*/, /*TempRegID*//* 577(*/0xC1, 0x04/*)*/,
     /* 199827 */   GIR_AddImm, /*InsnID*//* 577(*/0xC1, 0x04/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 199838 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 577(*/0xC1, 0x04/*)*/,
     /* 199841 */   GIR_MakeTempReg, /*TempRegID*//* 575(*/0xBF, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 199845 */   GIR_BuildMI, /*InsnID*//* 576(*/0xC0, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 199850 */   GIR_AddTempRegister, /*InsnID*//* 576(*/0xC0, 0x04/*)*/, /*TempRegID*//* 575(*/0xBF, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199857 */   GIR_AddSimpleTempRegister, /*InsnID*//* 576(*/0xC0, 0x04/*)*/, /*TempRegID*//* 576(*/0xC0, 0x04/*)*/,
     /* 199862 */   GIR_AddImm, /*InsnID*//* 576(*/0xC0, 0x04/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 199873 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 576(*/0xC0, 0x04/*)*/,
     /* 199876 */   GIR_MakeTempReg, /*TempRegID*//* 574(*/0xBE, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 199880 */   GIR_BuildMI, /*InsnID*//* 575(*/0xBF, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 199885 */   GIR_AddTempRegister, /*InsnID*//* 575(*/0xBF, 0x04/*)*/, /*TempRegID*//* 574(*/0xBE, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199892 */   GIR_AddImm, /*InsnID*//* 575(*/0xBF, 0x04/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 199903 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 575(*/0xBF, 0x04/*)*/,
     /* 199906 */   GIR_MakeTempReg, /*TempRegID*//* 573(*/0xBD, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 199910 */   GIR_BuildMI, /*InsnID*//* 574(*/0xBE, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 199915 */   GIR_AddTempRegister, /*InsnID*//* 574(*/0xBE, 0x04/*)*/, /*TempRegID*//* 573(*/0xBD, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199922 */   GIR_AddSimpleTempRegister, /*InsnID*//* 574(*/0xBE, 0x04/*)*/, /*TempRegID*//* 574(*/0xBE, 0x04/*)*/,
     /* 199927 */   GIR_AddImm, /*InsnID*//* 574(*/0xBE, 0x04/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 199938 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 574(*/0xBE, 0x04/*)*/,
     /* 199941 */   GIR_MakeTempReg, /*TempRegID*//* 572(*/0xBC, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 199945 */   GIR_BuildMI, /*InsnID*//* 573(*/0xBD, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 199950 */   GIR_AddTempRegister, /*InsnID*//* 573(*/0xBD, 0x04/*)*/, /*TempRegID*//* 572(*/0xBC, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199957 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 573(*/0xBD, 0x04/*)*/,
     /* 199960 */   GIR_MakeTempReg, /*TempRegID*//* 571(*/0xBB, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 199964 */   GIR_BuildMI, /*InsnID*//* 572(*/0xBC, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 199969 */   GIR_AddTempRegister, /*InsnID*//* 572(*/0xBC, 0x04/*)*/, /*TempRegID*//* 571(*/0xBB, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199976 */   GIR_AddSimpleTempRegister, /*InsnID*//* 572(*/0xBC, 0x04/*)*/, /*TempRegID*//* 572(*/0xBC, 0x04/*)*/,
     /* 199981 */   GIR_AddSimpleTempRegister, /*InsnID*//* 572(*/0xBC, 0x04/*)*/, /*TempRegID*//* 573(*/0xBD, 0x04/*)*/,
     /* 199986 */   GIR_AddImm8, /*InsnID*//* 572(*/0xBC, 0x04/*)*/, /*Imm*/1,
     /* 199990 */   GIR_ConstrainOperandRC, /*InsnID*//* 572(*/0xBC, 0x04/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 199996 */   GIR_ConstrainOperandRC, /*InsnID*//* 572(*/0xBC, 0x04/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 200002 */   GIR_ConstrainOperandRC, /*InsnID*//* 572(*/0xBC, 0x04/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 200008 */   GIR_MakeTempReg, /*TempRegID*//* 570(*/0xBA, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 200012 */   GIR_BuildMI, /*InsnID*//* 571(*/0xBB, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 200017 */   GIR_AddTempRegister, /*InsnID*//* 571(*/0xBB, 0x04/*)*/, /*TempRegID*//* 570(*/0xBA, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200024 */   GIR_AddSimpleTempRegister, /*InsnID*//* 571(*/0xBB, 0x04/*)*/, /*TempRegID*//* 571(*/0xBB, 0x04/*)*/,
     /* 200029 */   GIR_AddImm8, /*InsnID*//* 571(*/0xBB, 0x04/*)*/, /*Imm*/32,
     /* 200033 */   GIR_AddImm8, /*InsnID*//* 571(*/0xBB, 0x04/*)*/, /*Imm*/31,
     /* 200037 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 571(*/0xBB, 0x04/*)*/,
     /* 200040 */   GIR_MakeTempReg, /*TempRegID*//* 569(*/0xB9, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 200044 */   GIR_BuildMI, /*InsnID*//* 570(*/0xBA, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 200049 */   GIR_AddTempRegister, /*InsnID*//* 570(*/0xBA, 0x04/*)*/, /*TempRegID*//* 569(*/0xB9, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200056 */   GIR_AddSimpleTempRegister, /*InsnID*//* 570(*/0xBA, 0x04/*)*/, /*TempRegID*//* 570(*/0xBA, 0x04/*)*/,
     /* 200061 */   GIR_AddImm, /*InsnID*//* 570(*/0xBA, 0x04/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 200072 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 570(*/0xBA, 0x04/*)*/,
     /* 200075 */   GIR_MakeTempReg, /*TempRegID*//* 568(*/0xB8, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 200079 */   GIR_BuildMI, /*InsnID*//* 569(*/0xB9, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 200084 */   GIR_AddTempRegister, /*InsnID*//* 569(*/0xB9, 0x04/*)*/, /*TempRegID*//* 568(*/0xB8, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200091 */   GIR_AddSimpleTempRegister, /*InsnID*//* 569(*/0xB9, 0x04/*)*/, /*TempRegID*//* 569(*/0xB9, 0x04/*)*/,
     /* 200096 */   GIR_AddImm, /*InsnID*//* 569(*/0xB9, 0x04/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 200107 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 569(*/0xB9, 0x04/*)*/,
     /* 200110 */   GIR_MakeTempReg, /*TempRegID*//* 567(*/0xB7, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 200114 */   GIR_BuildMI, /*InsnID*//* 568(*/0xB8, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 200119 */   GIR_AddTempRegister, /*InsnID*//* 568(*/0xB8, 0x04/*)*/, /*TempRegID*//* 567(*/0xB7, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200126 */   GIR_Copy, /*NewInsnID*//* 568(*/0xB8, 0x04/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 200131 */   GIR_AddImm8, /*InsnID*//* 568(*/0xB8, 0x04/*)*/, /*Imm*/1,
     /* 200135 */   GIR_AddImm8, /*InsnID*//* 568(*/0xB8, 0x04/*)*/, /*Imm*/62,
     /* 200139 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 568(*/0xB8, 0x04/*)*/,
     /* 200142 */   GIR_MakeTempReg, /*TempRegID*//* 566(*/0xB6, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 200146 */   GIR_BuildMI, /*InsnID*//* 567(*/0xB7, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 200151 */   GIR_AddTempRegister, /*InsnID*//* 567(*/0xB7, 0x04/*)*/, /*TempRegID*//* 566(*/0xB6, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200158 */   GIR_AddSimpleTempRegister, /*InsnID*//* 567(*/0xB7, 0x04/*)*/, /*TempRegID*//* 567(*/0xB7, 0x04/*)*/,
     /* 200163 */   GIR_AddSimpleTempRegister, /*InsnID*//* 567(*/0xB7, 0x04/*)*/, /*TempRegID*//* 568(*/0xB8, 0x04/*)*/,
     /* 200168 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 567(*/0xB7, 0x04/*)*/,
     /* 200171 */   GIR_MakeTempReg, /*TempRegID*//* 565(*/0xB5, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 200175 */   GIR_BuildMI, /*InsnID*//* 566(*/0xB6, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 200180 */   GIR_AddTempRegister, /*InsnID*//* 566(*/0xB6, 0x04/*)*/, /*TempRegID*//* 565(*/0xB5, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200187 */   GIR_AddImm, /*InsnID*//* 566(*/0xB6, 0x04/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 200198 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 566(*/0xB6, 0x04/*)*/,
     /* 200201 */   GIR_MakeTempReg, /*TempRegID*//* 564(*/0xB4, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 200205 */   GIR_BuildMI, /*InsnID*//* 565(*/0xB5, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 200210 */   GIR_AddTempRegister, /*InsnID*//* 565(*/0xB5, 0x04/*)*/, /*TempRegID*//* 564(*/0xB4, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200217 */   GIR_AddSimpleTempRegister, /*InsnID*//* 565(*/0xB5, 0x04/*)*/, /*TempRegID*//* 565(*/0xB5, 0x04/*)*/,
     /* 200222 */   GIR_AddImm, /*InsnID*//* 565(*/0xB5, 0x04/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 200233 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 565(*/0xB5, 0x04/*)*/,
     /* 200236 */   GIR_MakeTempReg, /*TempRegID*//* 563(*/0xB3, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 200240 */   GIR_BuildMI, /*InsnID*//* 564(*/0xB4, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 200245 */   GIR_AddTempRegister, /*InsnID*//* 564(*/0xB4, 0x04/*)*/, /*TempRegID*//* 563(*/0xB3, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200252 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 564(*/0xB4, 0x04/*)*/,
     /* 200255 */   GIR_MakeTempReg, /*TempRegID*//* 562(*/0xB2, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 200259 */   GIR_BuildMI, /*InsnID*//* 563(*/0xB3, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 200264 */   GIR_AddTempRegister, /*InsnID*//* 563(*/0xB3, 0x04/*)*/, /*TempRegID*//* 562(*/0xB2, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200271 */   GIR_AddSimpleTempRegister, /*InsnID*//* 563(*/0xB3, 0x04/*)*/, /*TempRegID*//* 563(*/0xB3, 0x04/*)*/,
     /* 200276 */   GIR_AddSimpleTempRegister, /*InsnID*//* 563(*/0xB3, 0x04/*)*/, /*TempRegID*//* 564(*/0xB4, 0x04/*)*/,
     /* 200281 */   GIR_AddImm8, /*InsnID*//* 563(*/0xB3, 0x04/*)*/, /*Imm*/1,
     /* 200285 */   GIR_ConstrainOperandRC, /*InsnID*//* 563(*/0xB3, 0x04/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 200291 */   GIR_ConstrainOperandRC, /*InsnID*//* 563(*/0xB3, 0x04/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 200297 */   GIR_ConstrainOperandRC, /*InsnID*//* 563(*/0xB3, 0x04/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 200303 */   GIR_MakeTempReg, /*TempRegID*//* 561(*/0xB1, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 200307 */   GIR_BuildMI, /*InsnID*//* 562(*/0xB2, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 200312 */   GIR_AddTempRegister, /*InsnID*//* 562(*/0xB2, 0x04/*)*/, /*TempRegID*//* 561(*/0xB1, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200319 */   GIR_AddSimpleTempRegister, /*InsnID*//* 562(*/0xB2, 0x04/*)*/, /*TempRegID*//* 562(*/0xB2, 0x04/*)*/,
     /* 200324 */   GIR_AddImm8, /*InsnID*//* 562(*/0xB2, 0x04/*)*/, /*Imm*/32,
     /* 200328 */   GIR_AddImm8, /*InsnID*//* 562(*/0xB2, 0x04/*)*/, /*Imm*/31,
     /* 200332 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 562(*/0xB2, 0x04/*)*/,
     /* 200335 */   GIR_MakeTempReg, /*TempRegID*//* 560(*/0xB0, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 200339 */   GIR_BuildMI, /*InsnID*//* 561(*/0xB1, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 200344 */   GIR_AddTempRegister, /*InsnID*//* 561(*/0xB1, 0x04/*)*/, /*TempRegID*//* 560(*/0xB0, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200351 */   GIR_AddSimpleTempRegister, /*InsnID*//* 561(*/0xB1, 0x04/*)*/, /*TempRegID*//* 561(*/0xB1, 0x04/*)*/,
     /* 200356 */   GIR_AddImm, /*InsnID*//* 561(*/0xB1, 0x04/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 200367 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 561(*/0xB1, 0x04/*)*/,
     /* 200370 */   GIR_MakeTempReg, /*TempRegID*//* 559(*/0xAF, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 200374 */   GIR_BuildMI, /*InsnID*//* 560(*/0xB0, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 200379 */   GIR_AddTempRegister, /*InsnID*//* 560(*/0xB0, 0x04/*)*/, /*TempRegID*//* 559(*/0xAF, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200386 */   GIR_AddSimpleTempRegister, /*InsnID*//* 560(*/0xB0, 0x04/*)*/, /*TempRegID*//* 560(*/0xB0, 0x04/*)*/,
     /* 200391 */   GIR_AddImm, /*InsnID*//* 560(*/0xB0, 0x04/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 200402 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 560(*/0xB0, 0x04/*)*/,
     /* 200405 */   GIR_MakeTempReg, /*TempRegID*//* 558(*/0xAE, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 200409 */   GIR_BuildMI, /*InsnID*//* 559(*/0xAF, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 200414 */   GIR_AddTempRegister, /*InsnID*//* 559(*/0xAF, 0x04/*)*/, /*TempRegID*//* 558(*/0xAE, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200421 */   GIR_Copy, /*NewInsnID*//* 559(*/0xAF, 0x04/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 200426 */   GIR_AddImm8, /*InsnID*//* 559(*/0xAF, 0x04/*)*/, /*Imm*/63,
     /* 200430 */   GIR_AddImm8, /*InsnID*//* 559(*/0xAF, 0x04/*)*/, /*Imm*/1,
     /* 200434 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 559(*/0xAF, 0x04/*)*/,
     /* 200437 */   GIR_MakeTempReg, /*TempRegID*//* 557(*/0xAD, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 200441 */   GIR_BuildMI, /*InsnID*//* 558(*/0xAE, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 200446 */   GIR_AddTempRegister, /*InsnID*//* 558(*/0xAE, 0x04/*)*/, /*TempRegID*//* 557(*/0xAD, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200453 */   GIR_AddSimpleTempRegister, /*InsnID*//* 558(*/0xAE, 0x04/*)*/, /*TempRegID*//* 558(*/0xAE, 0x04/*)*/,
     /* 200458 */   GIR_AddSimpleTempRegister, /*InsnID*//* 558(*/0xAE, 0x04/*)*/, /*TempRegID*//* 559(*/0xAF, 0x04/*)*/,
     /* 200463 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 558(*/0xAE, 0x04/*)*/,
     /* 200466 */   GIR_MakeTempReg, /*TempRegID*//* 556(*/0xAC, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 200470 */   GIR_BuildMI, /*InsnID*//* 557(*/0xAD, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 200475 */   GIR_AddTempRegister, /*InsnID*//* 557(*/0xAD, 0x04/*)*/, /*TempRegID*//* 556(*/0xAC, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200482 */   GIR_AddSimpleTempRegister, /*InsnID*//* 557(*/0xAD, 0x04/*)*/, /*TempRegID*//* 557(*/0xAD, 0x04/*)*/,
     /* 200487 */   GIR_AddSimpleTempRegister, /*InsnID*//* 557(*/0xAD, 0x04/*)*/, /*TempRegID*//* 566(*/0xB6, 0x04/*)*/,
     /* 200492 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 557(*/0xAD, 0x04/*)*/,
     /* 200495 */   GIR_MakeTempReg, /*TempRegID*//* 555(*/0xAB, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 200499 */   GIR_BuildMI, /*InsnID*//* 556(*/0xAC, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 200504 */   GIR_AddTempRegister, /*InsnID*//* 556(*/0xAC, 0x04/*)*/, /*TempRegID*//* 555(*/0xAB, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200511 */   GIR_AddSimpleTempRegister, /*InsnID*//* 556(*/0xAC, 0x04/*)*/, /*TempRegID*//* 556(*/0xAC, 0x04/*)*/,
     /* 200516 */   GIR_AddImm8, /*InsnID*//* 556(*/0xAC, 0x04/*)*/, /*Imm*/62,
     /* 200520 */   GIR_AddImm8, /*InsnID*//* 556(*/0xAC, 0x04/*)*/, /*Imm*/2,
     /* 200524 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 556(*/0xAC, 0x04/*)*/,
     /* 200527 */   GIR_MakeTempReg, /*TempRegID*//* 554(*/0xAA, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 200531 */   GIR_BuildMI, /*InsnID*//* 555(*/0xAB, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 200536 */   GIR_AddTempRegister, /*InsnID*//* 555(*/0xAB, 0x04/*)*/, /*TempRegID*//* 554(*/0xAA, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200543 */   GIR_AddSimpleTempRegister, /*InsnID*//* 555(*/0xAB, 0x04/*)*/, /*TempRegID*//* 555(*/0xAB, 0x04/*)*/,
     /* 200548 */   GIR_AddSimpleTempRegister, /*InsnID*//* 555(*/0xAB, 0x04/*)*/, /*TempRegID*//* 575(*/0xBF, 0x04/*)*/,
     /* 200553 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 555(*/0xAB, 0x04/*)*/,
     /* 200556 */   GIR_MakeTempReg, /*TempRegID*//* 553(*/0xA9, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 200560 */   GIR_BuildMI, /*InsnID*//* 554(*/0xAA, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 200565 */   GIR_AddTempRegister, /*InsnID*//* 554(*/0xAA, 0x04/*)*/, /*TempRegID*//* 553(*/0xA9, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200572 */   GIR_AddSimpleTempRegister, /*InsnID*//* 554(*/0xAA, 0x04/*)*/, /*TempRegID*//* 554(*/0xAA, 0x04/*)*/,
     /* 200577 */   GIR_AddSimpleTempRegister, /*InsnID*//* 554(*/0xAA, 0x04/*)*/, /*TempRegID*//* 582(*/0xC6, 0x04/*)*/,
     /* 200582 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 554(*/0xAA, 0x04/*)*/,
     /* 200585 */   GIR_MakeTempReg, /*TempRegID*//* 552(*/0xA8, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 200589 */   GIR_BuildMI, /*InsnID*//* 553(*/0xA9, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 200594 */   GIR_AddTempRegister, /*InsnID*//* 553(*/0xA9, 0x04/*)*/, /*TempRegID*//* 552(*/0xA8, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200601 */   GIR_AddSimpleTempRegister, /*InsnID*//* 553(*/0xA9, 0x04/*)*/, /*TempRegID*//* 553(*/0xA9, 0x04/*)*/,
     /* 200606 */   GIR_AddImm8, /*InsnID*//* 553(*/0xA9, 0x04/*)*/, /*Imm*/60,
     /* 200610 */   GIR_AddImm8, /*InsnID*//* 553(*/0xA9, 0x04/*)*/, /*Imm*/4,
     /* 200614 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 553(*/0xA9, 0x04/*)*/,
     /* 200617 */   GIR_MakeTempReg, /*TempRegID*//* 551(*/0xA7, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 200621 */   GIR_BuildMI, /*InsnID*//* 552(*/0xA8, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 200626 */   GIR_AddTempRegister, /*InsnID*//* 552(*/0xA8, 0x04/*)*/, /*TempRegID*//* 551(*/0xA7, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200633 */   GIR_AddSimpleTempRegister, /*InsnID*//* 552(*/0xA8, 0x04/*)*/, /*TempRegID*//* 552(*/0xA8, 0x04/*)*/,
     /* 200638 */   GIR_AddSimpleTempRegister, /*InsnID*//* 552(*/0xA8, 0x04/*)*/, /*TempRegID*//* 610(*/0xE2, 0x04/*)*/,
     /* 200643 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 552(*/0xA8, 0x04/*)*/,
     /* 200646 */   GIR_MakeTempReg, /*TempRegID*//* 550(*/0xA6, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 200650 */   GIR_BuildMI, /*InsnID*//* 551(*/0xA7, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 200655 */   GIR_AddTempRegister, /*InsnID*//* 551(*/0xA7, 0x04/*)*/, /*TempRegID*//* 550(*/0xA6, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200662 */   GIR_AddSimpleTempRegister, /*InsnID*//* 551(*/0xA7, 0x04/*)*/, /*TempRegID*//* 551(*/0xA7, 0x04/*)*/,
     /* 200667 */   GIR_AddSimpleTempRegister, /*InsnID*//* 551(*/0xA7, 0x04/*)*/, /*TempRegID*//* 617(*/0xE9, 0x04/*)*/,
     /* 200672 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 551(*/0xA7, 0x04/*)*/,
     /* 200675 */   GIR_MakeTempReg, /*TempRegID*//* 549(*/0xA5, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 200679 */   GIR_BuildMI, /*InsnID*//* 550(*/0xA6, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 200684 */   GIR_AddTempRegister, /*InsnID*//* 550(*/0xA6, 0x04/*)*/, /*TempRegID*//* 549(*/0xA5, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200691 */   GIR_AddSimpleTempRegister, /*InsnID*//* 550(*/0xA6, 0x04/*)*/, /*TempRegID*//* 550(*/0xA6, 0x04/*)*/,
     /* 200696 */   GIR_AddImm8, /*InsnID*//* 550(*/0xA6, 0x04/*)*/, /*Imm*/32,
     /* 200700 */   GIR_AddImm8, /*InsnID*//* 550(*/0xA6, 0x04/*)*/, /*Imm*/32,
     /* 200704 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 550(*/0xA6, 0x04/*)*/,
     /* 200707 */   GIR_MakeTempReg, /*TempRegID*//* 817(*/0xB1, 0x06/*)*/, /*TypeID*/GILLT_s32,
     /* 200711 */   GIR_BuildMI, /*InsnID*//* 818(*/0xB2, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 200716 */   GIR_AddTempRegister, /*InsnID*//* 818(*/0xB2, 0x06/*)*/, /*TempRegID*//* 817(*/0xB1, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200723 */   GIR_AddImm, /*InsnID*//* 818(*/0xB2, 0x06/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 200734 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 818(*/0xB2, 0x06/*)*/,
     /* 200737 */   GIR_MakeTempReg, /*TempRegID*//* 816(*/0xB0, 0x06/*)*/, /*TypeID*/GILLT_s32,
     /* 200741 */   GIR_BuildMI, /*InsnID*//* 817(*/0xB1, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 200746 */   GIR_AddTempRegister, /*InsnID*//* 817(*/0xB1, 0x06/*)*/, /*TempRegID*//* 816(*/0xB0, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200753 */   GIR_AddSimpleTempRegister, /*InsnID*//* 817(*/0xB1, 0x06/*)*/, /*TempRegID*//* 817(*/0xB1, 0x06/*)*/,
     /* 200758 */   GIR_AddImm, /*InsnID*//* 817(*/0xB1, 0x06/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 200769 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 817(*/0xB1, 0x06/*)*/,
     /* 200772 */   GIR_MakeTempReg, /*TempRegID*//* 815(*/0xAF, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 200776 */   GIR_BuildMI, /*InsnID*//* 816(*/0xB0, 0x06/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 200781 */   GIR_AddTempRegister, /*InsnID*//* 816(*/0xB0, 0x06/*)*/, /*TempRegID*//* 815(*/0xAF, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200788 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 816(*/0xB0, 0x06/*)*/,
     /* 200791 */   GIR_MakeTempReg, /*TempRegID*//* 814(*/0xAE, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 200795 */   GIR_BuildMI, /*InsnID*//* 815(*/0xAF, 0x06/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 200800 */   GIR_AddTempRegister, /*InsnID*//* 815(*/0xAF, 0x06/*)*/, /*TempRegID*//* 814(*/0xAE, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200807 */   GIR_AddSimpleTempRegister, /*InsnID*//* 815(*/0xAF, 0x06/*)*/, /*TempRegID*//* 815(*/0xAF, 0x06/*)*/,
     /* 200812 */   GIR_AddSimpleTempRegister, /*InsnID*//* 815(*/0xAF, 0x06/*)*/, /*TempRegID*//* 816(*/0xB0, 0x06/*)*/,
     /* 200817 */   GIR_AddImm8, /*InsnID*//* 815(*/0xAF, 0x06/*)*/, /*Imm*/1,
     /* 200821 */   GIR_ConstrainOperandRC, /*InsnID*//* 815(*/0xAF, 0x06/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 200827 */   GIR_ConstrainOperandRC, /*InsnID*//* 815(*/0xAF, 0x06/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 200833 */   GIR_ConstrainOperandRC, /*InsnID*//* 815(*/0xAF, 0x06/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 200839 */   GIR_MakeTempReg, /*TempRegID*//* 813(*/0xAD, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 200843 */   GIR_BuildMI, /*InsnID*//* 814(*/0xAE, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 200848 */   GIR_AddTempRegister, /*InsnID*//* 814(*/0xAE, 0x06/*)*/, /*TempRegID*//* 813(*/0xAD, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200855 */   GIR_AddSimpleTempRegister, /*InsnID*//* 814(*/0xAE, 0x06/*)*/, /*TempRegID*//* 814(*/0xAE, 0x06/*)*/,
     /* 200860 */   GIR_AddImm8, /*InsnID*//* 814(*/0xAE, 0x06/*)*/, /*Imm*/32,
     /* 200864 */   GIR_AddImm8, /*InsnID*//* 814(*/0xAE, 0x06/*)*/, /*Imm*/31,
     /* 200868 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 814(*/0xAE, 0x06/*)*/,
     /* 200871 */   GIR_MakeTempReg, /*TempRegID*//* 812(*/0xAC, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 200875 */   GIR_BuildMI, /*InsnID*//* 813(*/0xAD, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 200880 */   GIR_AddTempRegister, /*InsnID*//* 813(*/0xAD, 0x06/*)*/, /*TempRegID*//* 812(*/0xAC, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200887 */   GIR_AddSimpleTempRegister, /*InsnID*//* 813(*/0xAD, 0x06/*)*/, /*TempRegID*//* 813(*/0xAD, 0x06/*)*/,
     /* 200892 */   GIR_AddImm, /*InsnID*//* 813(*/0xAD, 0x06/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 200903 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 813(*/0xAD, 0x06/*)*/,
     /* 200906 */   GIR_MakeTempReg, /*TempRegID*//* 811(*/0xAB, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 200910 */   GIR_BuildMI, /*InsnID*//* 812(*/0xAC, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 200915 */   GIR_AddTempRegister, /*InsnID*//* 812(*/0xAC, 0x06/*)*/, /*TempRegID*//* 811(*/0xAB, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200922 */   GIR_AddSimpleTempRegister, /*InsnID*//* 812(*/0xAC, 0x06/*)*/, /*TempRegID*//* 812(*/0xAC, 0x06/*)*/,
     /* 200927 */   GIR_AddImm, /*InsnID*//* 812(*/0xAC, 0x06/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 200938 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 812(*/0xAC, 0x06/*)*/,
     /* 200941 */   GIR_MakeTempReg, /*TempRegID*//* 810(*/0xAA, 0x06/*)*/, /*TypeID*/GILLT_s32,
     /* 200945 */   GIR_BuildMI, /*InsnID*//* 811(*/0xAB, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 200950 */   GIR_AddTempRegister, /*InsnID*//* 811(*/0xAB, 0x06/*)*/, /*TempRegID*//* 810(*/0xAA, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200957 */   GIR_AddImm, /*InsnID*//* 811(*/0xAB, 0x06/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 200968 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 811(*/0xAB, 0x06/*)*/,
     /* 200971 */   GIR_MakeTempReg, /*TempRegID*//* 809(*/0xA9, 0x06/*)*/, /*TypeID*/GILLT_s32,
     /* 200975 */   GIR_BuildMI, /*InsnID*//* 810(*/0xAA, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 200980 */   GIR_AddTempRegister, /*InsnID*//* 810(*/0xAA, 0x06/*)*/, /*TempRegID*//* 809(*/0xA9, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200987 */   GIR_AddSimpleTempRegister, /*InsnID*//* 810(*/0xAA, 0x06/*)*/, /*TempRegID*//* 810(*/0xAA, 0x06/*)*/,
     /* 200992 */   GIR_AddImm, /*InsnID*//* 810(*/0xAA, 0x06/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 201003 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 810(*/0xAA, 0x06/*)*/,
     /* 201006 */   GIR_MakeTempReg, /*TempRegID*//* 808(*/0xA8, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 201010 */   GIR_BuildMI, /*InsnID*//* 809(*/0xA9, 0x06/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 201015 */   GIR_AddTempRegister, /*InsnID*//* 809(*/0xA9, 0x06/*)*/, /*TempRegID*//* 808(*/0xA8, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201022 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 809(*/0xA9, 0x06/*)*/,
     /* 201025 */   GIR_MakeTempReg, /*TempRegID*//* 807(*/0xA7, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 201029 */   GIR_BuildMI, /*InsnID*//* 808(*/0xA8, 0x06/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 201034 */   GIR_AddTempRegister, /*InsnID*//* 808(*/0xA8, 0x06/*)*/, /*TempRegID*//* 807(*/0xA7, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201041 */   GIR_AddSimpleTempRegister, /*InsnID*//* 808(*/0xA8, 0x06/*)*/, /*TempRegID*//* 808(*/0xA8, 0x06/*)*/,
     /* 201046 */   GIR_AddSimpleTempRegister, /*InsnID*//* 808(*/0xA8, 0x06/*)*/, /*TempRegID*//* 809(*/0xA9, 0x06/*)*/,
     /* 201051 */   GIR_AddImm8, /*InsnID*//* 808(*/0xA8, 0x06/*)*/, /*Imm*/1,
     /* 201055 */   GIR_ConstrainOperandRC, /*InsnID*//* 808(*/0xA8, 0x06/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 201061 */   GIR_ConstrainOperandRC, /*InsnID*//* 808(*/0xA8, 0x06/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 201067 */   GIR_ConstrainOperandRC, /*InsnID*//* 808(*/0xA8, 0x06/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 201073 */   GIR_MakeTempReg, /*TempRegID*//* 806(*/0xA6, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 201077 */   GIR_BuildMI, /*InsnID*//* 807(*/0xA7, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 201082 */   GIR_AddTempRegister, /*InsnID*//* 807(*/0xA7, 0x06/*)*/, /*TempRegID*//* 806(*/0xA6, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201089 */   GIR_AddSimpleTempRegister, /*InsnID*//* 807(*/0xA7, 0x06/*)*/, /*TempRegID*//* 807(*/0xA7, 0x06/*)*/,
     /* 201094 */   GIR_AddImm8, /*InsnID*//* 807(*/0xA7, 0x06/*)*/, /*Imm*/32,
     /* 201098 */   GIR_AddImm8, /*InsnID*//* 807(*/0xA7, 0x06/*)*/, /*Imm*/31,
     /* 201102 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 807(*/0xA7, 0x06/*)*/,
     /* 201105 */   GIR_MakeTempReg, /*TempRegID*//* 805(*/0xA5, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 201109 */   GIR_BuildMI, /*InsnID*//* 806(*/0xA6, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 201114 */   GIR_AddTempRegister, /*InsnID*//* 806(*/0xA6, 0x06/*)*/, /*TempRegID*//* 805(*/0xA5, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201121 */   GIR_AddSimpleTempRegister, /*InsnID*//* 806(*/0xA6, 0x06/*)*/, /*TempRegID*//* 806(*/0xA6, 0x06/*)*/,
     /* 201126 */   GIR_AddImm, /*InsnID*//* 806(*/0xA6, 0x06/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 201137 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 806(*/0xA6, 0x06/*)*/,
     /* 201140 */   GIR_MakeTempReg, /*TempRegID*//* 804(*/0xA4, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 201144 */   GIR_BuildMI, /*InsnID*//* 805(*/0xA5, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 201149 */   GIR_AddTempRegister, /*InsnID*//* 805(*/0xA5, 0x06/*)*/, /*TempRegID*//* 804(*/0xA4, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201156 */   GIR_AddSimpleTempRegister, /*InsnID*//* 805(*/0xA5, 0x06/*)*/, /*TempRegID*//* 805(*/0xA5, 0x06/*)*/,
     /* 201161 */   GIR_AddImm, /*InsnID*//* 805(*/0xA5, 0x06/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 201172 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 805(*/0xA5, 0x06/*)*/,
     /* 201175 */   GIR_MakeTempReg, /*TempRegID*//* 803(*/0xA3, 0x06/*)*/, /*TypeID*/GILLT_s32,
     /* 201179 */   GIR_BuildMI, /*InsnID*//* 804(*/0xA4, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 201184 */   GIR_AddTempRegister, /*InsnID*//* 804(*/0xA4, 0x06/*)*/, /*TempRegID*//* 803(*/0xA3, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201191 */   GIR_AddImm, /*InsnID*//* 804(*/0xA4, 0x06/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 201202 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 804(*/0xA4, 0x06/*)*/,
     /* 201205 */   GIR_MakeTempReg, /*TempRegID*//* 802(*/0xA2, 0x06/*)*/, /*TypeID*/GILLT_s32,
     /* 201209 */   GIR_BuildMI, /*InsnID*//* 803(*/0xA3, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 201214 */   GIR_AddTempRegister, /*InsnID*//* 803(*/0xA3, 0x06/*)*/, /*TempRegID*//* 802(*/0xA2, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201221 */   GIR_AddSimpleTempRegister, /*InsnID*//* 803(*/0xA3, 0x06/*)*/, /*TempRegID*//* 803(*/0xA3, 0x06/*)*/,
     /* 201226 */   GIR_AddImm, /*InsnID*//* 803(*/0xA3, 0x06/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 201237 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 803(*/0xA3, 0x06/*)*/,
     /* 201240 */   GIR_MakeTempReg, /*TempRegID*//* 801(*/0xA1, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 201244 */   GIR_BuildMI, /*InsnID*//* 802(*/0xA2, 0x06/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 201249 */   GIR_AddTempRegister, /*InsnID*//* 802(*/0xA2, 0x06/*)*/, /*TempRegID*//* 801(*/0xA1, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201256 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 802(*/0xA2, 0x06/*)*/,
     /* 201259 */   GIR_MakeTempReg, /*TempRegID*//* 800(*/0xA0, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 201263 */   GIR_BuildMI, /*InsnID*//* 801(*/0xA1, 0x06/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 201268 */   GIR_AddTempRegister, /*InsnID*//* 801(*/0xA1, 0x06/*)*/, /*TempRegID*//* 800(*/0xA0, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201275 */   GIR_AddSimpleTempRegister, /*InsnID*//* 801(*/0xA1, 0x06/*)*/, /*TempRegID*//* 801(*/0xA1, 0x06/*)*/,
     /* 201280 */   GIR_AddSimpleTempRegister, /*InsnID*//* 801(*/0xA1, 0x06/*)*/, /*TempRegID*//* 802(*/0xA2, 0x06/*)*/,
     /* 201285 */   GIR_AddImm8, /*InsnID*//* 801(*/0xA1, 0x06/*)*/, /*Imm*/1,
     /* 201289 */   GIR_ConstrainOperandRC, /*InsnID*//* 801(*/0xA1, 0x06/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 201295 */   GIR_ConstrainOperandRC, /*InsnID*//* 801(*/0xA1, 0x06/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 201301 */   GIR_ConstrainOperandRC, /*InsnID*//* 801(*/0xA1, 0x06/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 201307 */   GIR_MakeTempReg, /*TempRegID*//* 799(*/0x9F, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 201311 */   GIR_BuildMI, /*InsnID*//* 800(*/0xA0, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 201316 */   GIR_AddTempRegister, /*InsnID*//* 800(*/0xA0, 0x06/*)*/, /*TempRegID*//* 799(*/0x9F, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201323 */   GIR_AddSimpleTempRegister, /*InsnID*//* 800(*/0xA0, 0x06/*)*/, /*TempRegID*//* 800(*/0xA0, 0x06/*)*/,
     /* 201328 */   GIR_AddImm8, /*InsnID*//* 800(*/0xA0, 0x06/*)*/, /*Imm*/32,
     /* 201332 */   GIR_AddImm8, /*InsnID*//* 800(*/0xA0, 0x06/*)*/, /*Imm*/31,
     /* 201336 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 800(*/0xA0, 0x06/*)*/,
     /* 201339 */   GIR_MakeTempReg, /*TempRegID*//* 798(*/0x9E, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 201343 */   GIR_BuildMI, /*InsnID*//* 799(*/0x9F, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 201348 */   GIR_AddTempRegister, /*InsnID*//* 799(*/0x9F, 0x06/*)*/, /*TempRegID*//* 798(*/0x9E, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201355 */   GIR_AddSimpleTempRegister, /*InsnID*//* 799(*/0x9F, 0x06/*)*/, /*TempRegID*//* 799(*/0x9F, 0x06/*)*/,
     /* 201360 */   GIR_AddImm, /*InsnID*//* 799(*/0x9F, 0x06/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 201371 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 799(*/0x9F, 0x06/*)*/,
     /* 201374 */   GIR_MakeTempReg, /*TempRegID*//* 797(*/0x9D, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 201378 */   GIR_BuildMI, /*InsnID*//* 798(*/0x9E, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 201383 */   GIR_AddTempRegister, /*InsnID*//* 798(*/0x9E, 0x06/*)*/, /*TempRegID*//* 797(*/0x9D, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201390 */   GIR_AddSimpleTempRegister, /*InsnID*//* 798(*/0x9E, 0x06/*)*/, /*TempRegID*//* 798(*/0x9E, 0x06/*)*/,
     /* 201395 */   GIR_AddImm, /*InsnID*//* 798(*/0x9E, 0x06/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 201406 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 798(*/0x9E, 0x06/*)*/,
     /* 201409 */   GIR_MakeTempReg, /*TempRegID*//* 796(*/0x9C, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 201413 */   GIR_BuildMI, /*InsnID*//* 797(*/0x9D, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 201418 */   GIR_AddTempRegister, /*InsnID*//* 797(*/0x9D, 0x06/*)*/, /*TempRegID*//* 796(*/0x9C, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201425 */   GIR_Copy, /*NewInsnID*//* 797(*/0x9D, 0x06/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 201430 */   GIR_AddImm8, /*InsnID*//* 797(*/0x9D, 0x06/*)*/, /*Imm*/1,
     /* 201434 */   GIR_AddImm8, /*InsnID*//* 797(*/0x9D, 0x06/*)*/, /*Imm*/62,
     /* 201438 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 797(*/0x9D, 0x06/*)*/,
     /* 201441 */   GIR_MakeTempReg, /*TempRegID*//* 795(*/0x9B, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 201445 */   GIR_BuildMI, /*InsnID*//* 796(*/0x9C, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 201450 */   GIR_AddTempRegister, /*InsnID*//* 796(*/0x9C, 0x06/*)*/, /*TempRegID*//* 795(*/0x9B, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201457 */   GIR_AddSimpleTempRegister, /*InsnID*//* 796(*/0x9C, 0x06/*)*/, /*TempRegID*//* 796(*/0x9C, 0x06/*)*/,
     /* 201462 */   GIR_AddSimpleTempRegister, /*InsnID*//* 796(*/0x9C, 0x06/*)*/, /*TempRegID*//* 797(*/0x9D, 0x06/*)*/,
     /* 201467 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 796(*/0x9C, 0x06/*)*/,
     /* 201470 */   GIR_MakeTempReg, /*TempRegID*//* 794(*/0x9A, 0x06/*)*/, /*TypeID*/GILLT_s32,
     /* 201474 */   GIR_BuildMI, /*InsnID*//* 795(*/0x9B, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 201479 */   GIR_AddTempRegister, /*InsnID*//* 795(*/0x9B, 0x06/*)*/, /*TempRegID*//* 794(*/0x9A, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201486 */   GIR_AddImm, /*InsnID*//* 795(*/0x9B, 0x06/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 201497 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 795(*/0x9B, 0x06/*)*/,
     /* 201500 */   GIR_MakeTempReg, /*TempRegID*//* 793(*/0x99, 0x06/*)*/, /*TypeID*/GILLT_s32,
     /* 201504 */   GIR_BuildMI, /*InsnID*//* 794(*/0x9A, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 201509 */   GIR_AddTempRegister, /*InsnID*//* 794(*/0x9A, 0x06/*)*/, /*TempRegID*//* 793(*/0x99, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201516 */   GIR_AddSimpleTempRegister, /*InsnID*//* 794(*/0x9A, 0x06/*)*/, /*TempRegID*//* 794(*/0x9A, 0x06/*)*/,
     /* 201521 */   GIR_AddImm, /*InsnID*//* 794(*/0x9A, 0x06/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 201532 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 794(*/0x9A, 0x06/*)*/,
     /* 201535 */   GIR_MakeTempReg, /*TempRegID*//* 792(*/0x98, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 201539 */   GIR_BuildMI, /*InsnID*//* 793(*/0x99, 0x06/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 201544 */   GIR_AddTempRegister, /*InsnID*//* 793(*/0x99, 0x06/*)*/, /*TempRegID*//* 792(*/0x98, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201551 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 793(*/0x99, 0x06/*)*/,
     /* 201554 */   GIR_MakeTempReg, /*TempRegID*//* 791(*/0x97, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 201558 */   GIR_BuildMI, /*InsnID*//* 792(*/0x98, 0x06/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 201563 */   GIR_AddTempRegister, /*InsnID*//* 792(*/0x98, 0x06/*)*/, /*TempRegID*//* 791(*/0x97, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201570 */   GIR_AddSimpleTempRegister, /*InsnID*//* 792(*/0x98, 0x06/*)*/, /*TempRegID*//* 792(*/0x98, 0x06/*)*/,
     /* 201575 */   GIR_AddSimpleTempRegister, /*InsnID*//* 792(*/0x98, 0x06/*)*/, /*TempRegID*//* 793(*/0x99, 0x06/*)*/,
     /* 201580 */   GIR_AddImm8, /*InsnID*//* 792(*/0x98, 0x06/*)*/, /*Imm*/1,
     /* 201584 */   GIR_ConstrainOperandRC, /*InsnID*//* 792(*/0x98, 0x06/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 201590 */   GIR_ConstrainOperandRC, /*InsnID*//* 792(*/0x98, 0x06/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 201596 */   GIR_ConstrainOperandRC, /*InsnID*//* 792(*/0x98, 0x06/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 201602 */   GIR_MakeTempReg, /*TempRegID*//* 790(*/0x96, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 201606 */   GIR_BuildMI, /*InsnID*//* 791(*/0x97, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 201611 */   GIR_AddTempRegister, /*InsnID*//* 791(*/0x97, 0x06/*)*/, /*TempRegID*//* 790(*/0x96, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201618 */   GIR_AddSimpleTempRegister, /*InsnID*//* 791(*/0x97, 0x06/*)*/, /*TempRegID*//* 791(*/0x97, 0x06/*)*/,
     /* 201623 */   GIR_AddImm8, /*InsnID*//* 791(*/0x97, 0x06/*)*/, /*Imm*/32,
     /* 201627 */   GIR_AddImm8, /*InsnID*//* 791(*/0x97, 0x06/*)*/, /*Imm*/31,
     /* 201631 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 791(*/0x97, 0x06/*)*/,
     /* 201634 */   GIR_MakeTempReg, /*TempRegID*//* 789(*/0x95, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 201638 */   GIR_BuildMI, /*InsnID*//* 790(*/0x96, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 201643 */   GIR_AddTempRegister, /*InsnID*//* 790(*/0x96, 0x06/*)*/, /*TempRegID*//* 789(*/0x95, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201650 */   GIR_AddSimpleTempRegister, /*InsnID*//* 790(*/0x96, 0x06/*)*/, /*TempRegID*//* 790(*/0x96, 0x06/*)*/,
     /* 201655 */   GIR_AddImm, /*InsnID*//* 790(*/0x96, 0x06/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 201666 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 790(*/0x96, 0x06/*)*/,
     /* 201669 */   GIR_MakeTempReg, /*TempRegID*//* 788(*/0x94, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 201673 */   GIR_BuildMI, /*InsnID*//* 789(*/0x95, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 201678 */   GIR_AddTempRegister, /*InsnID*//* 789(*/0x95, 0x06/*)*/, /*TempRegID*//* 788(*/0x94, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201685 */   GIR_AddSimpleTempRegister, /*InsnID*//* 789(*/0x95, 0x06/*)*/, /*TempRegID*//* 789(*/0x95, 0x06/*)*/,
     /* 201690 */   GIR_AddImm, /*InsnID*//* 789(*/0x95, 0x06/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 201701 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 789(*/0x95, 0x06/*)*/,
     /* 201704 */   GIR_MakeTempReg, /*TempRegID*//* 787(*/0x93, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 201708 */   GIR_BuildMI, /*InsnID*//* 788(*/0x94, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 201713 */   GIR_AddTempRegister, /*InsnID*//* 788(*/0x94, 0x06/*)*/, /*TempRegID*//* 787(*/0x93, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201720 */   GIR_Copy, /*NewInsnID*//* 788(*/0x94, 0x06/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 201725 */   GIR_AddImm8, /*InsnID*//* 788(*/0x94, 0x06/*)*/, /*Imm*/63,
     /* 201729 */   GIR_AddImm8, /*InsnID*//* 788(*/0x94, 0x06/*)*/, /*Imm*/1,
     /* 201733 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 788(*/0x94, 0x06/*)*/,
     /* 201736 */   GIR_MakeTempReg, /*TempRegID*//* 786(*/0x92, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 201740 */   GIR_BuildMI, /*InsnID*//* 787(*/0x93, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 201745 */   GIR_AddTempRegister, /*InsnID*//* 787(*/0x93, 0x06/*)*/, /*TempRegID*//* 786(*/0x92, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201752 */   GIR_AddSimpleTempRegister, /*InsnID*//* 787(*/0x93, 0x06/*)*/, /*TempRegID*//* 787(*/0x93, 0x06/*)*/,
     /* 201757 */   GIR_AddSimpleTempRegister, /*InsnID*//* 787(*/0x93, 0x06/*)*/, /*TempRegID*//* 788(*/0x94, 0x06/*)*/,
     /* 201762 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 787(*/0x93, 0x06/*)*/,
     /* 201765 */   GIR_MakeTempReg, /*TempRegID*//* 785(*/0x91, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 201769 */   GIR_BuildMI, /*InsnID*//* 786(*/0x92, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 201774 */   GIR_AddTempRegister, /*InsnID*//* 786(*/0x92, 0x06/*)*/, /*TempRegID*//* 785(*/0x91, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201781 */   GIR_AddSimpleTempRegister, /*InsnID*//* 786(*/0x92, 0x06/*)*/, /*TempRegID*//* 786(*/0x92, 0x06/*)*/,
     /* 201786 */   GIR_AddSimpleTempRegister, /*InsnID*//* 786(*/0x92, 0x06/*)*/, /*TempRegID*//* 795(*/0x9B, 0x06/*)*/,
     /* 201791 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 786(*/0x92, 0x06/*)*/,
     /* 201794 */   GIR_MakeTempReg, /*TempRegID*//* 784(*/0x90, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 201798 */   GIR_BuildMI, /*InsnID*//* 785(*/0x91, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 201803 */   GIR_AddTempRegister, /*InsnID*//* 785(*/0x91, 0x06/*)*/, /*TempRegID*//* 784(*/0x90, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201810 */   GIR_AddSimpleTempRegister, /*InsnID*//* 785(*/0x91, 0x06/*)*/, /*TempRegID*//* 785(*/0x91, 0x06/*)*/,
     /* 201815 */   GIR_AddImm8, /*InsnID*//* 785(*/0x91, 0x06/*)*/, /*Imm*/2,
     /* 201819 */   GIR_AddImm8, /*InsnID*//* 785(*/0x91, 0x06/*)*/, /*Imm*/61,
     /* 201823 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 785(*/0x91, 0x06/*)*/,
     /* 201826 */   GIR_MakeTempReg, /*TempRegID*//* 783(*/0x8F, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 201830 */   GIR_BuildMI, /*InsnID*//* 784(*/0x90, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 201835 */   GIR_AddTempRegister, /*InsnID*//* 784(*/0x90, 0x06/*)*/, /*TempRegID*//* 783(*/0x8F, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201842 */   GIR_AddSimpleTempRegister, /*InsnID*//* 784(*/0x90, 0x06/*)*/, /*TempRegID*//* 784(*/0x90, 0x06/*)*/,
     /* 201847 */   GIR_AddSimpleTempRegister, /*InsnID*//* 784(*/0x90, 0x06/*)*/, /*TempRegID*//* 804(*/0xA4, 0x06/*)*/,
     /* 201852 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 784(*/0x90, 0x06/*)*/,
     /* 201855 */   GIR_MakeTempReg, /*TempRegID*//* 782(*/0x8E, 0x06/*)*/, /*TypeID*/GILLT_s32,
     /* 201859 */   GIR_BuildMI, /*InsnID*//* 783(*/0x8F, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 201864 */   GIR_AddTempRegister, /*InsnID*//* 783(*/0x8F, 0x06/*)*/, /*TempRegID*//* 782(*/0x8E, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201871 */   GIR_AddImm, /*InsnID*//* 783(*/0x8F, 0x06/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 201882 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 783(*/0x8F, 0x06/*)*/,
     /* 201885 */   GIR_MakeTempReg, /*TempRegID*//* 781(*/0x8D, 0x06/*)*/, /*TypeID*/GILLT_s32,
     /* 201889 */   GIR_BuildMI, /*InsnID*//* 782(*/0x8E, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 201894 */   GIR_AddTempRegister, /*InsnID*//* 782(*/0x8E, 0x06/*)*/, /*TempRegID*//* 781(*/0x8D, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201901 */   GIR_AddSimpleTempRegister, /*InsnID*//* 782(*/0x8E, 0x06/*)*/, /*TempRegID*//* 782(*/0x8E, 0x06/*)*/,
     /* 201906 */   GIR_AddImm, /*InsnID*//* 782(*/0x8E, 0x06/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 201917 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 782(*/0x8E, 0x06/*)*/,
     /* 201920 */   GIR_MakeTempReg, /*TempRegID*//* 780(*/0x8C, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 201924 */   GIR_BuildMI, /*InsnID*//* 781(*/0x8D, 0x06/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 201929 */   GIR_AddTempRegister, /*InsnID*//* 781(*/0x8D, 0x06/*)*/, /*TempRegID*//* 780(*/0x8C, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201936 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 781(*/0x8D, 0x06/*)*/,
     /* 201939 */   GIR_MakeTempReg, /*TempRegID*//* 779(*/0x8B, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 201943 */   GIR_BuildMI, /*InsnID*//* 780(*/0x8C, 0x06/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 201948 */   GIR_AddTempRegister, /*InsnID*//* 780(*/0x8C, 0x06/*)*/, /*TempRegID*//* 779(*/0x8B, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201955 */   GIR_AddSimpleTempRegister, /*InsnID*//* 780(*/0x8C, 0x06/*)*/, /*TempRegID*//* 780(*/0x8C, 0x06/*)*/,
     /* 201960 */   GIR_AddSimpleTempRegister, /*InsnID*//* 780(*/0x8C, 0x06/*)*/, /*TempRegID*//* 781(*/0x8D, 0x06/*)*/,
     /* 201965 */   GIR_AddImm8, /*InsnID*//* 780(*/0x8C, 0x06/*)*/, /*Imm*/1,
     /* 201969 */   GIR_ConstrainOperandRC, /*InsnID*//* 780(*/0x8C, 0x06/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 201975 */   GIR_ConstrainOperandRC, /*InsnID*//* 780(*/0x8C, 0x06/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 201981 */   GIR_ConstrainOperandRC, /*InsnID*//* 780(*/0x8C, 0x06/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 201987 */   GIR_MakeTempReg, /*TempRegID*//* 778(*/0x8A, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 201991 */   GIR_BuildMI, /*InsnID*//* 779(*/0x8B, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 201996 */   GIR_AddTempRegister, /*InsnID*//* 779(*/0x8B, 0x06/*)*/, /*TempRegID*//* 778(*/0x8A, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202003 */   GIR_AddSimpleTempRegister, /*InsnID*//* 779(*/0x8B, 0x06/*)*/, /*TempRegID*//* 779(*/0x8B, 0x06/*)*/,
     /* 202008 */   GIR_AddImm8, /*InsnID*//* 779(*/0x8B, 0x06/*)*/, /*Imm*/32,
     /* 202012 */   GIR_AddImm8, /*InsnID*//* 779(*/0x8B, 0x06/*)*/, /*Imm*/31,
     /* 202016 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 779(*/0x8B, 0x06/*)*/,
     /* 202019 */   GIR_MakeTempReg, /*TempRegID*//* 777(*/0x89, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 202023 */   GIR_BuildMI, /*InsnID*//* 778(*/0x8A, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 202028 */   GIR_AddTempRegister, /*InsnID*//* 778(*/0x8A, 0x06/*)*/, /*TempRegID*//* 777(*/0x89, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202035 */   GIR_AddSimpleTempRegister, /*InsnID*//* 778(*/0x8A, 0x06/*)*/, /*TempRegID*//* 778(*/0x8A, 0x06/*)*/,
     /* 202040 */   GIR_AddImm, /*InsnID*//* 778(*/0x8A, 0x06/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 202051 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 778(*/0x8A, 0x06/*)*/,
     /* 202054 */   GIR_MakeTempReg, /*TempRegID*//* 776(*/0x88, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 202058 */   GIR_BuildMI, /*InsnID*//* 777(*/0x89, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 202063 */   GIR_AddTempRegister, /*InsnID*//* 777(*/0x89, 0x06/*)*/, /*TempRegID*//* 776(*/0x88, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202070 */   GIR_AddSimpleTempRegister, /*InsnID*//* 777(*/0x89, 0x06/*)*/, /*TempRegID*//* 777(*/0x89, 0x06/*)*/,
     /* 202075 */   GIR_AddImm, /*InsnID*//* 777(*/0x89, 0x06/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 202086 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 777(*/0x89, 0x06/*)*/,
     /* 202089 */   GIR_MakeTempReg, /*TempRegID*//* 775(*/0x87, 0x06/*)*/, /*TypeID*/GILLT_s32,
     /* 202093 */   GIR_BuildMI, /*InsnID*//* 776(*/0x88, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 202098 */   GIR_AddTempRegister, /*InsnID*//* 776(*/0x88, 0x06/*)*/, /*TempRegID*//* 775(*/0x87, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202105 */   GIR_AddImm, /*InsnID*//* 776(*/0x88, 0x06/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 202116 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 776(*/0x88, 0x06/*)*/,
     /* 202119 */   GIR_MakeTempReg, /*TempRegID*//* 774(*/0x86, 0x06/*)*/, /*TypeID*/GILLT_s32,
     /* 202123 */   GIR_BuildMI, /*InsnID*//* 775(*/0x87, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 202128 */   GIR_AddTempRegister, /*InsnID*//* 775(*/0x87, 0x06/*)*/, /*TempRegID*//* 774(*/0x86, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202135 */   GIR_AddSimpleTempRegister, /*InsnID*//* 775(*/0x87, 0x06/*)*/, /*TempRegID*//* 775(*/0x87, 0x06/*)*/,
     /* 202140 */   GIR_AddImm, /*InsnID*//* 775(*/0x87, 0x06/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 202151 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 775(*/0x87, 0x06/*)*/,
     /* 202154 */   GIR_MakeTempReg, /*TempRegID*//* 773(*/0x85, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 202158 */   GIR_BuildMI, /*InsnID*//* 774(*/0x86, 0x06/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 202163 */   GIR_AddTempRegister, /*InsnID*//* 774(*/0x86, 0x06/*)*/, /*TempRegID*//* 773(*/0x85, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202170 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 774(*/0x86, 0x06/*)*/,
     /* 202173 */   GIR_MakeTempReg, /*TempRegID*//* 772(*/0x84, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 202177 */   GIR_BuildMI, /*InsnID*//* 773(*/0x85, 0x06/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 202182 */   GIR_AddTempRegister, /*InsnID*//* 773(*/0x85, 0x06/*)*/, /*TempRegID*//* 772(*/0x84, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202189 */   GIR_AddSimpleTempRegister, /*InsnID*//* 773(*/0x85, 0x06/*)*/, /*TempRegID*//* 773(*/0x85, 0x06/*)*/,
     /* 202194 */   GIR_AddSimpleTempRegister, /*InsnID*//* 773(*/0x85, 0x06/*)*/, /*TempRegID*//* 774(*/0x86, 0x06/*)*/,
     /* 202199 */   GIR_AddImm8, /*InsnID*//* 773(*/0x85, 0x06/*)*/, /*Imm*/1,
     /* 202203 */   GIR_ConstrainOperandRC, /*InsnID*//* 773(*/0x85, 0x06/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 202209 */   GIR_ConstrainOperandRC, /*InsnID*//* 773(*/0x85, 0x06/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 202215 */   GIR_ConstrainOperandRC, /*InsnID*//* 773(*/0x85, 0x06/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 202221 */   GIR_MakeTempReg, /*TempRegID*//* 771(*/0x83, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 202225 */   GIR_BuildMI, /*InsnID*//* 772(*/0x84, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 202230 */   GIR_AddTempRegister, /*InsnID*//* 772(*/0x84, 0x06/*)*/, /*TempRegID*//* 771(*/0x83, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202237 */   GIR_AddSimpleTempRegister, /*InsnID*//* 772(*/0x84, 0x06/*)*/, /*TempRegID*//* 772(*/0x84, 0x06/*)*/,
     /* 202242 */   GIR_AddImm8, /*InsnID*//* 772(*/0x84, 0x06/*)*/, /*Imm*/32,
     /* 202246 */   GIR_AddImm8, /*InsnID*//* 772(*/0x84, 0x06/*)*/, /*Imm*/31,
     /* 202250 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 772(*/0x84, 0x06/*)*/,
     /* 202253 */   GIR_MakeTempReg, /*TempRegID*//* 770(*/0x82, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 202257 */   GIR_BuildMI, /*InsnID*//* 771(*/0x83, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 202262 */   GIR_AddTempRegister, /*InsnID*//* 771(*/0x83, 0x06/*)*/, /*TempRegID*//* 770(*/0x82, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202269 */   GIR_AddSimpleTempRegister, /*InsnID*//* 771(*/0x83, 0x06/*)*/, /*TempRegID*//* 771(*/0x83, 0x06/*)*/,
     /* 202274 */   GIR_AddImm, /*InsnID*//* 771(*/0x83, 0x06/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 202285 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 771(*/0x83, 0x06/*)*/,
     /* 202288 */   GIR_MakeTempReg, /*TempRegID*//* 769(*/0x81, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 202292 */   GIR_BuildMI, /*InsnID*//* 770(*/0x82, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 202297 */   GIR_AddTempRegister, /*InsnID*//* 770(*/0x82, 0x06/*)*/, /*TempRegID*//* 769(*/0x81, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202304 */   GIR_AddSimpleTempRegister, /*InsnID*//* 770(*/0x82, 0x06/*)*/, /*TempRegID*//* 770(*/0x82, 0x06/*)*/,
     /* 202309 */   GIR_AddImm, /*InsnID*//* 770(*/0x82, 0x06/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 202320 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 770(*/0x82, 0x06/*)*/,
     /* 202323 */   GIR_MakeTempReg, /*TempRegID*//* 768(*/0x80, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 202327 */   GIR_BuildMI, /*InsnID*//* 769(*/0x81, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 202332 */   GIR_AddTempRegister, /*InsnID*//* 769(*/0x81, 0x06/*)*/, /*TempRegID*//* 768(*/0x80, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202339 */   GIR_Copy, /*NewInsnID*//* 769(*/0x81, 0x06/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 202344 */   GIR_AddImm8, /*InsnID*//* 769(*/0x81, 0x06/*)*/, /*Imm*/1,
     /* 202348 */   GIR_AddImm8, /*InsnID*//* 769(*/0x81, 0x06/*)*/, /*Imm*/62,
     /* 202352 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 769(*/0x81, 0x06/*)*/,
     /* 202355 */   GIR_MakeTempReg, /*TempRegID*//* 767(*/0xFF, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 202359 */   GIR_BuildMI, /*InsnID*//* 768(*/0x80, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 202364 */   GIR_AddTempRegister, /*InsnID*//* 768(*/0x80, 0x06/*)*/, /*TempRegID*//* 767(*/0xFF, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202371 */   GIR_AddSimpleTempRegister, /*InsnID*//* 768(*/0x80, 0x06/*)*/, /*TempRegID*//* 768(*/0x80, 0x06/*)*/,
     /* 202376 */   GIR_AddSimpleTempRegister, /*InsnID*//* 768(*/0x80, 0x06/*)*/, /*TempRegID*//* 769(*/0x81, 0x06/*)*/,
     /* 202381 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 768(*/0x80, 0x06/*)*/,
     /* 202384 */   GIR_MakeTempReg, /*TempRegID*//* 766(*/0xFE, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 202388 */   GIR_BuildMI, /*InsnID*//* 767(*/0xFF, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 202393 */   GIR_AddTempRegister, /*InsnID*//* 767(*/0xFF, 0x05/*)*/, /*TempRegID*//* 766(*/0xFE, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202400 */   GIR_AddImm, /*InsnID*//* 767(*/0xFF, 0x05/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 202411 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 767(*/0xFF, 0x05/*)*/,
     /* 202414 */   GIR_MakeTempReg, /*TempRegID*//* 765(*/0xFD, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 202418 */   GIR_BuildMI, /*InsnID*//* 766(*/0xFE, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 202423 */   GIR_AddTempRegister, /*InsnID*//* 766(*/0xFE, 0x05/*)*/, /*TempRegID*//* 765(*/0xFD, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202430 */   GIR_AddSimpleTempRegister, /*InsnID*//* 766(*/0xFE, 0x05/*)*/, /*TempRegID*//* 766(*/0xFE, 0x05/*)*/,
     /* 202435 */   GIR_AddImm, /*InsnID*//* 766(*/0xFE, 0x05/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 202446 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 766(*/0xFE, 0x05/*)*/,
     /* 202449 */   GIR_MakeTempReg, /*TempRegID*//* 764(*/0xFC, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 202453 */   GIR_BuildMI, /*InsnID*//* 765(*/0xFD, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 202458 */   GIR_AddTempRegister, /*InsnID*//* 765(*/0xFD, 0x05/*)*/, /*TempRegID*//* 764(*/0xFC, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202465 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 765(*/0xFD, 0x05/*)*/,
     /* 202468 */   GIR_MakeTempReg, /*TempRegID*//* 763(*/0xFB, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 202472 */   GIR_BuildMI, /*InsnID*//* 764(*/0xFC, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 202477 */   GIR_AddTempRegister, /*InsnID*//* 764(*/0xFC, 0x05/*)*/, /*TempRegID*//* 763(*/0xFB, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202484 */   GIR_AddSimpleTempRegister, /*InsnID*//* 764(*/0xFC, 0x05/*)*/, /*TempRegID*//* 764(*/0xFC, 0x05/*)*/,
     /* 202489 */   GIR_AddSimpleTempRegister, /*InsnID*//* 764(*/0xFC, 0x05/*)*/, /*TempRegID*//* 765(*/0xFD, 0x05/*)*/,
     /* 202494 */   GIR_AddImm8, /*InsnID*//* 764(*/0xFC, 0x05/*)*/, /*Imm*/1,
     /* 202498 */   GIR_ConstrainOperandRC, /*InsnID*//* 764(*/0xFC, 0x05/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 202504 */   GIR_ConstrainOperandRC, /*InsnID*//* 764(*/0xFC, 0x05/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 202510 */   GIR_ConstrainOperandRC, /*InsnID*//* 764(*/0xFC, 0x05/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 202516 */   GIR_MakeTempReg, /*TempRegID*//* 762(*/0xFA, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 202520 */   GIR_BuildMI, /*InsnID*//* 763(*/0xFB, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 202525 */   GIR_AddTempRegister, /*InsnID*//* 763(*/0xFB, 0x05/*)*/, /*TempRegID*//* 762(*/0xFA, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202532 */   GIR_AddSimpleTempRegister, /*InsnID*//* 763(*/0xFB, 0x05/*)*/, /*TempRegID*//* 763(*/0xFB, 0x05/*)*/,
     /* 202537 */   GIR_AddImm8, /*InsnID*//* 763(*/0xFB, 0x05/*)*/, /*Imm*/32,
     /* 202541 */   GIR_AddImm8, /*InsnID*//* 763(*/0xFB, 0x05/*)*/, /*Imm*/31,
     /* 202545 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 763(*/0xFB, 0x05/*)*/,
     /* 202548 */   GIR_MakeTempReg, /*TempRegID*//* 761(*/0xF9, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 202552 */   GIR_BuildMI, /*InsnID*//* 762(*/0xFA, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 202557 */   GIR_AddTempRegister, /*InsnID*//* 762(*/0xFA, 0x05/*)*/, /*TempRegID*//* 761(*/0xF9, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202564 */   GIR_AddSimpleTempRegister, /*InsnID*//* 762(*/0xFA, 0x05/*)*/, /*TempRegID*//* 762(*/0xFA, 0x05/*)*/,
     /* 202569 */   GIR_AddImm, /*InsnID*//* 762(*/0xFA, 0x05/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 202580 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 762(*/0xFA, 0x05/*)*/,
     /* 202583 */   GIR_MakeTempReg, /*TempRegID*//* 760(*/0xF8, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 202587 */   GIR_BuildMI, /*InsnID*//* 761(*/0xF9, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 202592 */   GIR_AddTempRegister, /*InsnID*//* 761(*/0xF9, 0x05/*)*/, /*TempRegID*//* 760(*/0xF8, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202599 */   GIR_AddSimpleTempRegister, /*InsnID*//* 761(*/0xF9, 0x05/*)*/, /*TempRegID*//* 761(*/0xF9, 0x05/*)*/,
     /* 202604 */   GIR_AddImm, /*InsnID*//* 761(*/0xF9, 0x05/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 202615 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 761(*/0xF9, 0x05/*)*/,
     /* 202618 */   GIR_MakeTempReg, /*TempRegID*//* 759(*/0xF7, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 202622 */   GIR_BuildMI, /*InsnID*//* 760(*/0xF8, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 202627 */   GIR_AddTempRegister, /*InsnID*//* 760(*/0xF8, 0x05/*)*/, /*TempRegID*//* 759(*/0xF7, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202634 */   GIR_Copy, /*NewInsnID*//* 760(*/0xF8, 0x05/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 202639 */   GIR_AddImm8, /*InsnID*//* 760(*/0xF8, 0x05/*)*/, /*Imm*/63,
     /* 202643 */   GIR_AddImm8, /*InsnID*//* 760(*/0xF8, 0x05/*)*/, /*Imm*/1,
     /* 202647 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 760(*/0xF8, 0x05/*)*/,
     /* 202650 */   GIR_MakeTempReg, /*TempRegID*//* 758(*/0xF6, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 202654 */   GIR_BuildMI, /*InsnID*//* 759(*/0xF7, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 202659 */   GIR_AddTempRegister, /*InsnID*//* 759(*/0xF7, 0x05/*)*/, /*TempRegID*//* 758(*/0xF6, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202666 */   GIR_AddSimpleTempRegister, /*InsnID*//* 759(*/0xF7, 0x05/*)*/, /*TempRegID*//* 759(*/0xF7, 0x05/*)*/,
     /* 202671 */   GIR_AddSimpleTempRegister, /*InsnID*//* 759(*/0xF7, 0x05/*)*/, /*TempRegID*//* 760(*/0xF8, 0x05/*)*/,
     /* 202676 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 759(*/0xF7, 0x05/*)*/,
     /* 202679 */   GIR_MakeTempReg, /*TempRegID*//* 757(*/0xF5, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 202683 */   GIR_BuildMI, /*InsnID*//* 758(*/0xF6, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 202688 */   GIR_AddTempRegister, /*InsnID*//* 758(*/0xF6, 0x05/*)*/, /*TempRegID*//* 757(*/0xF5, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202695 */   GIR_AddSimpleTempRegister, /*InsnID*//* 758(*/0xF6, 0x05/*)*/, /*TempRegID*//* 758(*/0xF6, 0x05/*)*/,
     /* 202700 */   GIR_AddSimpleTempRegister, /*InsnID*//* 758(*/0xF6, 0x05/*)*/, /*TempRegID*//* 767(*/0xFF, 0x05/*)*/,
     /* 202705 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 758(*/0xF6, 0x05/*)*/,
     /* 202708 */   GIR_MakeTempReg, /*TempRegID*//* 756(*/0xF4, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 202712 */   GIR_BuildMI, /*InsnID*//* 757(*/0xF5, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 202717 */   GIR_AddTempRegister, /*InsnID*//* 757(*/0xF5, 0x05/*)*/, /*TempRegID*//* 756(*/0xF4, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202724 */   GIR_AddSimpleTempRegister, /*InsnID*//* 757(*/0xF5, 0x05/*)*/, /*TempRegID*//* 757(*/0xF5, 0x05/*)*/,
     /* 202729 */   GIR_AddImm8, /*InsnID*//* 757(*/0xF5, 0x05/*)*/, /*Imm*/62,
     /* 202733 */   GIR_AddImm8, /*InsnID*//* 757(*/0xF5, 0x05/*)*/, /*Imm*/2,
     /* 202737 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 757(*/0xF5, 0x05/*)*/,
     /* 202740 */   GIR_MakeTempReg, /*TempRegID*//* 755(*/0xF3, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 202744 */   GIR_BuildMI, /*InsnID*//* 756(*/0xF4, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 202749 */   GIR_AddTempRegister, /*InsnID*//* 756(*/0xF4, 0x05/*)*/, /*TempRegID*//* 755(*/0xF3, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202756 */   GIR_AddSimpleTempRegister, /*InsnID*//* 756(*/0xF4, 0x05/*)*/, /*TempRegID*//* 756(*/0xF4, 0x05/*)*/,
     /* 202761 */   GIR_AddSimpleTempRegister, /*InsnID*//* 756(*/0xF4, 0x05/*)*/, /*TempRegID*//* 776(*/0x88, 0x06/*)*/,
     /* 202766 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 756(*/0xF4, 0x05/*)*/,
     /* 202769 */   GIR_MakeTempReg, /*TempRegID*//* 754(*/0xF2, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 202773 */   GIR_BuildMI, /*InsnID*//* 755(*/0xF3, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 202778 */   GIR_AddTempRegister, /*InsnID*//* 755(*/0xF3, 0x05/*)*/, /*TempRegID*//* 754(*/0xF2, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202785 */   GIR_AddSimpleTempRegister, /*InsnID*//* 755(*/0xF3, 0x05/*)*/, /*TempRegID*//* 755(*/0xF3, 0x05/*)*/,
     /* 202790 */   GIR_AddSimpleTempRegister, /*InsnID*//* 755(*/0xF3, 0x05/*)*/, /*TempRegID*//* 783(*/0x8F, 0x06/*)*/,
     /* 202795 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 755(*/0xF3, 0x05/*)*/,
     /* 202798 */   GIR_MakeTempReg, /*TempRegID*//* 753(*/0xF1, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 202802 */   GIR_BuildMI, /*InsnID*//* 754(*/0xF2, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 202807 */   GIR_AddTempRegister, /*InsnID*//* 754(*/0xF2, 0x05/*)*/, /*TempRegID*//* 753(*/0xF1, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202814 */   GIR_AddSimpleTempRegister, /*InsnID*//* 754(*/0xF2, 0x05/*)*/, /*TempRegID*//* 754(*/0xF2, 0x05/*)*/,
     /* 202819 */   GIR_AddImm8, /*InsnID*//* 754(*/0xF2, 0x05/*)*/, /*Imm*/4,
     /* 202823 */   GIR_AddImm8, /*InsnID*//* 754(*/0xF2, 0x05/*)*/, /*Imm*/59,
     /* 202827 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 754(*/0xF2, 0x05/*)*/,
     /* 202830 */   GIR_MakeTempReg, /*TempRegID*//* 752(*/0xF0, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 202834 */   GIR_BuildMI, /*InsnID*//* 753(*/0xF1, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 202839 */   GIR_AddTempRegister, /*InsnID*//* 753(*/0xF1, 0x05/*)*/, /*TempRegID*//* 752(*/0xF0, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202846 */   GIR_AddSimpleTempRegister, /*InsnID*//* 753(*/0xF1, 0x05/*)*/, /*TempRegID*//* 753(*/0xF1, 0x05/*)*/,
     /* 202851 */   GIR_AddSimpleTempRegister, /*InsnID*//* 753(*/0xF1, 0x05/*)*/, /*TempRegID*//* 811(*/0xAB, 0x06/*)*/,
     /* 202856 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 753(*/0xF1, 0x05/*)*/,
     /* 202859 */   GIR_MakeTempReg, /*TempRegID*//* 751(*/0xEF, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 202863 */   GIR_BuildMI, /*InsnID*//* 752(*/0xF0, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 202868 */   GIR_AddTempRegister, /*InsnID*//* 752(*/0xF0, 0x05/*)*/, /*TempRegID*//* 751(*/0xEF, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202875 */   GIR_AddImm, /*InsnID*//* 752(*/0xF0, 0x05/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 202886 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 752(*/0xF0, 0x05/*)*/,
     /* 202889 */   GIR_MakeTempReg, /*TempRegID*//* 750(*/0xEE, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 202893 */   GIR_BuildMI, /*InsnID*//* 751(*/0xEF, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 202898 */   GIR_AddTempRegister, /*InsnID*//* 751(*/0xEF, 0x05/*)*/, /*TempRegID*//* 750(*/0xEE, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202905 */   GIR_AddSimpleTempRegister, /*InsnID*//* 751(*/0xEF, 0x05/*)*/, /*TempRegID*//* 751(*/0xEF, 0x05/*)*/,
     /* 202910 */   GIR_AddImm, /*InsnID*//* 751(*/0xEF, 0x05/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 202921 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 751(*/0xEF, 0x05/*)*/,
     /* 202924 */   GIR_MakeTempReg, /*TempRegID*//* 749(*/0xED, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 202928 */   GIR_BuildMI, /*InsnID*//* 750(*/0xEE, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 202933 */   GIR_AddTempRegister, /*InsnID*//* 750(*/0xEE, 0x05/*)*/, /*TempRegID*//* 749(*/0xED, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202940 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 750(*/0xEE, 0x05/*)*/,
     /* 202943 */   GIR_MakeTempReg, /*TempRegID*//* 748(*/0xEC, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 202947 */   GIR_BuildMI, /*InsnID*//* 749(*/0xED, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 202952 */   GIR_AddTempRegister, /*InsnID*//* 749(*/0xED, 0x05/*)*/, /*TempRegID*//* 748(*/0xEC, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202959 */   GIR_AddSimpleTempRegister, /*InsnID*//* 749(*/0xED, 0x05/*)*/, /*TempRegID*//* 749(*/0xED, 0x05/*)*/,
     /* 202964 */   GIR_AddSimpleTempRegister, /*InsnID*//* 749(*/0xED, 0x05/*)*/, /*TempRegID*//* 750(*/0xEE, 0x05/*)*/,
     /* 202969 */   GIR_AddImm8, /*InsnID*//* 749(*/0xED, 0x05/*)*/, /*Imm*/1,
     /* 202973 */   GIR_ConstrainOperandRC, /*InsnID*//* 749(*/0xED, 0x05/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 202979 */   GIR_ConstrainOperandRC, /*InsnID*//* 749(*/0xED, 0x05/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 202985 */   GIR_ConstrainOperandRC, /*InsnID*//* 749(*/0xED, 0x05/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 202991 */   GIR_MakeTempReg, /*TempRegID*//* 747(*/0xEB, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 202995 */   GIR_BuildMI, /*InsnID*//* 748(*/0xEC, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 203000 */   GIR_AddTempRegister, /*InsnID*//* 748(*/0xEC, 0x05/*)*/, /*TempRegID*//* 747(*/0xEB, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203007 */   GIR_AddSimpleTempRegister, /*InsnID*//* 748(*/0xEC, 0x05/*)*/, /*TempRegID*//* 748(*/0xEC, 0x05/*)*/,
     /* 203012 */   GIR_AddImm8, /*InsnID*//* 748(*/0xEC, 0x05/*)*/, /*Imm*/32,
     /* 203016 */   GIR_AddImm8, /*InsnID*//* 748(*/0xEC, 0x05/*)*/, /*Imm*/31,
     /* 203020 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 748(*/0xEC, 0x05/*)*/,
     /* 203023 */   GIR_MakeTempReg, /*TempRegID*//* 746(*/0xEA, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 203027 */   GIR_BuildMI, /*InsnID*//* 747(*/0xEB, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 203032 */   GIR_AddTempRegister, /*InsnID*//* 747(*/0xEB, 0x05/*)*/, /*TempRegID*//* 746(*/0xEA, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203039 */   GIR_AddSimpleTempRegister, /*InsnID*//* 747(*/0xEB, 0x05/*)*/, /*TempRegID*//* 747(*/0xEB, 0x05/*)*/,
     /* 203044 */   GIR_AddImm, /*InsnID*//* 747(*/0xEB, 0x05/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 203055 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 747(*/0xEB, 0x05/*)*/,
     /* 203058 */   GIR_MakeTempReg, /*TempRegID*//* 745(*/0xE9, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 203062 */   GIR_BuildMI, /*InsnID*//* 746(*/0xEA, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 203067 */   GIR_AddTempRegister, /*InsnID*//* 746(*/0xEA, 0x05/*)*/, /*TempRegID*//* 745(*/0xE9, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203074 */   GIR_AddSimpleTempRegister, /*InsnID*//* 746(*/0xEA, 0x05/*)*/, /*TempRegID*//* 746(*/0xEA, 0x05/*)*/,
     /* 203079 */   GIR_AddImm, /*InsnID*//* 746(*/0xEA, 0x05/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 203090 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 746(*/0xEA, 0x05/*)*/,
     /* 203093 */   GIR_MakeTempReg, /*TempRegID*//* 744(*/0xE8, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 203097 */   GIR_BuildMI, /*InsnID*//* 745(*/0xE9, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 203102 */   GIR_AddTempRegister, /*InsnID*//* 745(*/0xE9, 0x05/*)*/, /*TempRegID*//* 744(*/0xE8, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203109 */   GIR_AddImm, /*InsnID*//* 745(*/0xE9, 0x05/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 203120 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 745(*/0xE9, 0x05/*)*/,
     /* 203123 */   GIR_MakeTempReg, /*TempRegID*//* 743(*/0xE7, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 203127 */   GIR_BuildMI, /*InsnID*//* 744(*/0xE8, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 203132 */   GIR_AddTempRegister, /*InsnID*//* 744(*/0xE8, 0x05/*)*/, /*TempRegID*//* 743(*/0xE7, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203139 */   GIR_AddSimpleTempRegister, /*InsnID*//* 744(*/0xE8, 0x05/*)*/, /*TempRegID*//* 744(*/0xE8, 0x05/*)*/,
     /* 203144 */   GIR_AddImm, /*InsnID*//* 744(*/0xE8, 0x05/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 203155 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 744(*/0xE8, 0x05/*)*/,
     /* 203158 */   GIR_MakeTempReg, /*TempRegID*//* 742(*/0xE6, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 203162 */   GIR_BuildMI, /*InsnID*//* 743(*/0xE7, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 203167 */   GIR_AddTempRegister, /*InsnID*//* 743(*/0xE7, 0x05/*)*/, /*TempRegID*//* 742(*/0xE6, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203174 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 743(*/0xE7, 0x05/*)*/,
     /* 203177 */   GIR_MakeTempReg, /*TempRegID*//* 741(*/0xE5, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 203181 */   GIR_BuildMI, /*InsnID*//* 742(*/0xE6, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 203186 */   GIR_AddTempRegister, /*InsnID*//* 742(*/0xE6, 0x05/*)*/, /*TempRegID*//* 741(*/0xE5, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203193 */   GIR_AddSimpleTempRegister, /*InsnID*//* 742(*/0xE6, 0x05/*)*/, /*TempRegID*//* 742(*/0xE6, 0x05/*)*/,
     /* 203198 */   GIR_AddSimpleTempRegister, /*InsnID*//* 742(*/0xE6, 0x05/*)*/, /*TempRegID*//* 743(*/0xE7, 0x05/*)*/,
     /* 203203 */   GIR_AddImm8, /*InsnID*//* 742(*/0xE6, 0x05/*)*/, /*Imm*/1,
     /* 203207 */   GIR_ConstrainOperandRC, /*InsnID*//* 742(*/0xE6, 0x05/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 203213 */   GIR_ConstrainOperandRC, /*InsnID*//* 742(*/0xE6, 0x05/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 203219 */   GIR_ConstrainOperandRC, /*InsnID*//* 742(*/0xE6, 0x05/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 203225 */   GIR_MakeTempReg, /*TempRegID*//* 740(*/0xE4, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 203229 */   GIR_BuildMI, /*InsnID*//* 741(*/0xE5, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 203234 */   GIR_AddTempRegister, /*InsnID*//* 741(*/0xE5, 0x05/*)*/, /*TempRegID*//* 740(*/0xE4, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203241 */   GIR_AddSimpleTempRegister, /*InsnID*//* 741(*/0xE5, 0x05/*)*/, /*TempRegID*//* 741(*/0xE5, 0x05/*)*/,
     /* 203246 */   GIR_AddImm8, /*InsnID*//* 741(*/0xE5, 0x05/*)*/, /*Imm*/32,
     /* 203250 */   GIR_AddImm8, /*InsnID*//* 741(*/0xE5, 0x05/*)*/, /*Imm*/31,
     /* 203254 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 741(*/0xE5, 0x05/*)*/,
     /* 203257 */   GIR_MakeTempReg, /*TempRegID*//* 739(*/0xE3, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 203261 */   GIR_BuildMI, /*InsnID*//* 740(*/0xE4, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 203266 */   GIR_AddTempRegister, /*InsnID*//* 740(*/0xE4, 0x05/*)*/, /*TempRegID*//* 739(*/0xE3, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203273 */   GIR_AddSimpleTempRegister, /*InsnID*//* 740(*/0xE4, 0x05/*)*/, /*TempRegID*//* 740(*/0xE4, 0x05/*)*/,
     /* 203278 */   GIR_AddImm, /*InsnID*//* 740(*/0xE4, 0x05/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 203289 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 740(*/0xE4, 0x05/*)*/,
     /* 203292 */   GIR_MakeTempReg, /*TempRegID*//* 738(*/0xE2, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 203296 */   GIR_BuildMI, /*InsnID*//* 739(*/0xE3, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 203301 */   GIR_AddTempRegister, /*InsnID*//* 739(*/0xE3, 0x05/*)*/, /*TempRegID*//* 738(*/0xE2, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203308 */   GIR_AddSimpleTempRegister, /*InsnID*//* 739(*/0xE3, 0x05/*)*/, /*TempRegID*//* 739(*/0xE3, 0x05/*)*/,
     /* 203313 */   GIR_AddImm, /*InsnID*//* 739(*/0xE3, 0x05/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 203324 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 739(*/0xE3, 0x05/*)*/,
     /* 203327 */   GIR_MakeTempReg, /*TempRegID*//* 737(*/0xE1, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 203331 */   GIR_BuildMI, /*InsnID*//* 738(*/0xE2, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 203336 */   GIR_AddTempRegister, /*InsnID*//* 738(*/0xE2, 0x05/*)*/, /*TempRegID*//* 737(*/0xE1, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203343 */   GIR_AddImm, /*InsnID*//* 738(*/0xE2, 0x05/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 203354 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 738(*/0xE2, 0x05/*)*/,
     /* 203357 */   GIR_MakeTempReg, /*TempRegID*//* 736(*/0xE0, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 203361 */   GIR_BuildMI, /*InsnID*//* 737(*/0xE1, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 203366 */   GIR_AddTempRegister, /*InsnID*//* 737(*/0xE1, 0x05/*)*/, /*TempRegID*//* 736(*/0xE0, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203373 */   GIR_AddSimpleTempRegister, /*InsnID*//* 737(*/0xE1, 0x05/*)*/, /*TempRegID*//* 737(*/0xE1, 0x05/*)*/,
     /* 203378 */   GIR_AddImm, /*InsnID*//* 737(*/0xE1, 0x05/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 203389 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 737(*/0xE1, 0x05/*)*/,
     /* 203392 */   GIR_MakeTempReg, /*TempRegID*//* 735(*/0xDF, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 203396 */   GIR_BuildMI, /*InsnID*//* 736(*/0xE0, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 203401 */   GIR_AddTempRegister, /*InsnID*//* 736(*/0xE0, 0x05/*)*/, /*TempRegID*//* 735(*/0xDF, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203408 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 736(*/0xE0, 0x05/*)*/,
     /* 203411 */   GIR_MakeTempReg, /*TempRegID*//* 734(*/0xDE, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 203415 */   GIR_BuildMI, /*InsnID*//* 735(*/0xDF, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 203420 */   GIR_AddTempRegister, /*InsnID*//* 735(*/0xDF, 0x05/*)*/, /*TempRegID*//* 734(*/0xDE, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203427 */   GIR_AddSimpleTempRegister, /*InsnID*//* 735(*/0xDF, 0x05/*)*/, /*TempRegID*//* 735(*/0xDF, 0x05/*)*/,
     /* 203432 */   GIR_AddSimpleTempRegister, /*InsnID*//* 735(*/0xDF, 0x05/*)*/, /*TempRegID*//* 736(*/0xE0, 0x05/*)*/,
     /* 203437 */   GIR_AddImm8, /*InsnID*//* 735(*/0xDF, 0x05/*)*/, /*Imm*/1,
     /* 203441 */   GIR_ConstrainOperandRC, /*InsnID*//* 735(*/0xDF, 0x05/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 203447 */   GIR_ConstrainOperandRC, /*InsnID*//* 735(*/0xDF, 0x05/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 203453 */   GIR_ConstrainOperandRC, /*InsnID*//* 735(*/0xDF, 0x05/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 203459 */   GIR_MakeTempReg, /*TempRegID*//* 733(*/0xDD, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 203463 */   GIR_BuildMI, /*InsnID*//* 734(*/0xDE, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 203468 */   GIR_AddTempRegister, /*InsnID*//* 734(*/0xDE, 0x05/*)*/, /*TempRegID*//* 733(*/0xDD, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203475 */   GIR_AddSimpleTempRegister, /*InsnID*//* 734(*/0xDE, 0x05/*)*/, /*TempRegID*//* 734(*/0xDE, 0x05/*)*/,
     /* 203480 */   GIR_AddImm8, /*InsnID*//* 734(*/0xDE, 0x05/*)*/, /*Imm*/32,
     /* 203484 */   GIR_AddImm8, /*InsnID*//* 734(*/0xDE, 0x05/*)*/, /*Imm*/31,
     /* 203488 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 734(*/0xDE, 0x05/*)*/,
     /* 203491 */   GIR_MakeTempReg, /*TempRegID*//* 732(*/0xDC, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 203495 */   GIR_BuildMI, /*InsnID*//* 733(*/0xDD, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 203500 */   GIR_AddTempRegister, /*InsnID*//* 733(*/0xDD, 0x05/*)*/, /*TempRegID*//* 732(*/0xDC, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203507 */   GIR_AddSimpleTempRegister, /*InsnID*//* 733(*/0xDD, 0x05/*)*/, /*TempRegID*//* 733(*/0xDD, 0x05/*)*/,
     /* 203512 */   GIR_AddImm, /*InsnID*//* 733(*/0xDD, 0x05/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 203523 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 733(*/0xDD, 0x05/*)*/,
     /* 203526 */   GIR_MakeTempReg, /*TempRegID*//* 731(*/0xDB, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 203530 */   GIR_BuildMI, /*InsnID*//* 732(*/0xDC, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 203535 */   GIR_AddTempRegister, /*InsnID*//* 732(*/0xDC, 0x05/*)*/, /*TempRegID*//* 731(*/0xDB, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203542 */   GIR_AddSimpleTempRegister, /*InsnID*//* 732(*/0xDC, 0x05/*)*/, /*TempRegID*//* 732(*/0xDC, 0x05/*)*/,
     /* 203547 */   GIR_AddImm, /*InsnID*//* 732(*/0xDC, 0x05/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 203558 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 732(*/0xDC, 0x05/*)*/,
     /* 203561 */   GIR_MakeTempReg, /*TempRegID*//* 730(*/0xDA, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 203565 */   GIR_BuildMI, /*InsnID*//* 731(*/0xDB, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 203570 */   GIR_AddTempRegister, /*InsnID*//* 731(*/0xDB, 0x05/*)*/, /*TempRegID*//* 730(*/0xDA, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203577 */   GIR_Copy, /*NewInsnID*//* 731(*/0xDB, 0x05/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 203582 */   GIR_AddImm8, /*InsnID*//* 731(*/0xDB, 0x05/*)*/, /*Imm*/1,
     /* 203586 */   GIR_AddImm8, /*InsnID*//* 731(*/0xDB, 0x05/*)*/, /*Imm*/62,
     /* 203590 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 731(*/0xDB, 0x05/*)*/,
     /* 203593 */   GIR_MakeTempReg, /*TempRegID*//* 729(*/0xD9, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 203597 */   GIR_BuildMI, /*InsnID*//* 730(*/0xDA, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 203602 */   GIR_AddTempRegister, /*InsnID*//* 730(*/0xDA, 0x05/*)*/, /*TempRegID*//* 729(*/0xD9, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203609 */   GIR_AddSimpleTempRegister, /*InsnID*//* 730(*/0xDA, 0x05/*)*/, /*TempRegID*//* 730(*/0xDA, 0x05/*)*/,
     /* 203614 */   GIR_AddSimpleTempRegister, /*InsnID*//* 730(*/0xDA, 0x05/*)*/, /*TempRegID*//* 731(*/0xDB, 0x05/*)*/,
     /* 203619 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 730(*/0xDA, 0x05/*)*/,
     /* 203622 */   GIR_MakeTempReg, /*TempRegID*//* 728(*/0xD8, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 203626 */   GIR_BuildMI, /*InsnID*//* 729(*/0xD9, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 203631 */   GIR_AddTempRegister, /*InsnID*//* 729(*/0xD9, 0x05/*)*/, /*TempRegID*//* 728(*/0xD8, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203638 */   GIR_AddImm, /*InsnID*//* 729(*/0xD9, 0x05/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 203649 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 729(*/0xD9, 0x05/*)*/,
     /* 203652 */   GIR_MakeTempReg, /*TempRegID*//* 727(*/0xD7, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 203656 */   GIR_BuildMI, /*InsnID*//* 728(*/0xD8, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 203661 */   GIR_AddTempRegister, /*InsnID*//* 728(*/0xD8, 0x05/*)*/, /*TempRegID*//* 727(*/0xD7, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203668 */   GIR_AddSimpleTempRegister, /*InsnID*//* 728(*/0xD8, 0x05/*)*/, /*TempRegID*//* 728(*/0xD8, 0x05/*)*/,
     /* 203673 */   GIR_AddImm, /*InsnID*//* 728(*/0xD8, 0x05/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 203684 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 728(*/0xD8, 0x05/*)*/,
     /* 203687 */   GIR_MakeTempReg, /*TempRegID*//* 726(*/0xD6, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 203691 */   GIR_BuildMI, /*InsnID*//* 727(*/0xD7, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 203696 */   GIR_AddTempRegister, /*InsnID*//* 727(*/0xD7, 0x05/*)*/, /*TempRegID*//* 726(*/0xD6, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203703 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 727(*/0xD7, 0x05/*)*/,
     /* 203706 */   GIR_MakeTempReg, /*TempRegID*//* 725(*/0xD5, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 203710 */   GIR_BuildMI, /*InsnID*//* 726(*/0xD6, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 203715 */   GIR_AddTempRegister, /*InsnID*//* 726(*/0xD6, 0x05/*)*/, /*TempRegID*//* 725(*/0xD5, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203722 */   GIR_AddSimpleTempRegister, /*InsnID*//* 726(*/0xD6, 0x05/*)*/, /*TempRegID*//* 726(*/0xD6, 0x05/*)*/,
     /* 203727 */   GIR_AddSimpleTempRegister, /*InsnID*//* 726(*/0xD6, 0x05/*)*/, /*TempRegID*//* 727(*/0xD7, 0x05/*)*/,
     /* 203732 */   GIR_AddImm8, /*InsnID*//* 726(*/0xD6, 0x05/*)*/, /*Imm*/1,
     /* 203736 */   GIR_ConstrainOperandRC, /*InsnID*//* 726(*/0xD6, 0x05/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 203742 */   GIR_ConstrainOperandRC, /*InsnID*//* 726(*/0xD6, 0x05/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 203748 */   GIR_ConstrainOperandRC, /*InsnID*//* 726(*/0xD6, 0x05/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 203754 */   GIR_MakeTempReg, /*TempRegID*//* 724(*/0xD4, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 203758 */   GIR_BuildMI, /*InsnID*//* 725(*/0xD5, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 203763 */   GIR_AddTempRegister, /*InsnID*//* 725(*/0xD5, 0x05/*)*/, /*TempRegID*//* 724(*/0xD4, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203770 */   GIR_AddSimpleTempRegister, /*InsnID*//* 725(*/0xD5, 0x05/*)*/, /*TempRegID*//* 725(*/0xD5, 0x05/*)*/,
     /* 203775 */   GIR_AddImm8, /*InsnID*//* 725(*/0xD5, 0x05/*)*/, /*Imm*/32,
     /* 203779 */   GIR_AddImm8, /*InsnID*//* 725(*/0xD5, 0x05/*)*/, /*Imm*/31,
     /* 203783 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 725(*/0xD5, 0x05/*)*/,
     /* 203786 */   GIR_MakeTempReg, /*TempRegID*//* 723(*/0xD3, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 203790 */   GIR_BuildMI, /*InsnID*//* 724(*/0xD4, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 203795 */   GIR_AddTempRegister, /*InsnID*//* 724(*/0xD4, 0x05/*)*/, /*TempRegID*//* 723(*/0xD3, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203802 */   GIR_AddSimpleTempRegister, /*InsnID*//* 724(*/0xD4, 0x05/*)*/, /*TempRegID*//* 724(*/0xD4, 0x05/*)*/,
     /* 203807 */   GIR_AddImm, /*InsnID*//* 724(*/0xD4, 0x05/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 203818 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 724(*/0xD4, 0x05/*)*/,
     /* 203821 */   GIR_MakeTempReg, /*TempRegID*//* 722(*/0xD2, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 203825 */   GIR_BuildMI, /*InsnID*//* 723(*/0xD3, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 203830 */   GIR_AddTempRegister, /*InsnID*//* 723(*/0xD3, 0x05/*)*/, /*TempRegID*//* 722(*/0xD2, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203837 */   GIR_AddSimpleTempRegister, /*InsnID*//* 723(*/0xD3, 0x05/*)*/, /*TempRegID*//* 723(*/0xD3, 0x05/*)*/,
     /* 203842 */   GIR_AddImm, /*InsnID*//* 723(*/0xD3, 0x05/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 203853 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 723(*/0xD3, 0x05/*)*/,
     /* 203856 */   GIR_MakeTempReg, /*TempRegID*//* 721(*/0xD1, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 203860 */   GIR_BuildMI, /*InsnID*//* 722(*/0xD2, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 203865 */   GIR_AddTempRegister, /*InsnID*//* 722(*/0xD2, 0x05/*)*/, /*TempRegID*//* 721(*/0xD1, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203872 */   GIR_Copy, /*NewInsnID*//* 722(*/0xD2, 0x05/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 203877 */   GIR_AddImm8, /*InsnID*//* 722(*/0xD2, 0x05/*)*/, /*Imm*/63,
     /* 203881 */   GIR_AddImm8, /*InsnID*//* 722(*/0xD2, 0x05/*)*/, /*Imm*/1,
     /* 203885 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 722(*/0xD2, 0x05/*)*/,
     /* 203888 */   GIR_MakeTempReg, /*TempRegID*//* 720(*/0xD0, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 203892 */   GIR_BuildMI, /*InsnID*//* 721(*/0xD1, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 203897 */   GIR_AddTempRegister, /*InsnID*//* 721(*/0xD1, 0x05/*)*/, /*TempRegID*//* 720(*/0xD0, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203904 */   GIR_AddSimpleTempRegister, /*InsnID*//* 721(*/0xD1, 0x05/*)*/, /*TempRegID*//* 721(*/0xD1, 0x05/*)*/,
     /* 203909 */   GIR_AddSimpleTempRegister, /*InsnID*//* 721(*/0xD1, 0x05/*)*/, /*TempRegID*//* 722(*/0xD2, 0x05/*)*/,
     /* 203914 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 721(*/0xD1, 0x05/*)*/,
     /* 203917 */   GIR_MakeTempReg, /*TempRegID*//* 719(*/0xCF, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 203921 */   GIR_BuildMI, /*InsnID*//* 720(*/0xD0, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 203926 */   GIR_AddTempRegister, /*InsnID*//* 720(*/0xD0, 0x05/*)*/, /*TempRegID*//* 719(*/0xCF, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203933 */   GIR_AddSimpleTempRegister, /*InsnID*//* 720(*/0xD0, 0x05/*)*/, /*TempRegID*//* 720(*/0xD0, 0x05/*)*/,
     /* 203938 */   GIR_AddSimpleTempRegister, /*InsnID*//* 720(*/0xD0, 0x05/*)*/, /*TempRegID*//* 729(*/0xD9, 0x05/*)*/,
     /* 203943 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 720(*/0xD0, 0x05/*)*/,
     /* 203946 */   GIR_MakeTempReg, /*TempRegID*//* 718(*/0xCE, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 203950 */   GIR_BuildMI, /*InsnID*//* 719(*/0xCF, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 203955 */   GIR_AddTempRegister, /*InsnID*//* 719(*/0xCF, 0x05/*)*/, /*TempRegID*//* 718(*/0xCE, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203962 */   GIR_AddSimpleTempRegister, /*InsnID*//* 719(*/0xCF, 0x05/*)*/, /*TempRegID*//* 719(*/0xCF, 0x05/*)*/,
     /* 203967 */   GIR_AddImm8, /*InsnID*//* 719(*/0xCF, 0x05/*)*/, /*Imm*/2,
     /* 203971 */   GIR_AddImm8, /*InsnID*//* 719(*/0xCF, 0x05/*)*/, /*Imm*/61,
     /* 203975 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 719(*/0xCF, 0x05/*)*/,
     /* 203978 */   GIR_MakeTempReg, /*TempRegID*//* 717(*/0xCD, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 203982 */   GIR_BuildMI, /*InsnID*//* 718(*/0xCE, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 203987 */   GIR_AddTempRegister, /*InsnID*//* 718(*/0xCE, 0x05/*)*/, /*TempRegID*//* 717(*/0xCD, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203994 */   GIR_AddSimpleTempRegister, /*InsnID*//* 718(*/0xCE, 0x05/*)*/, /*TempRegID*//* 718(*/0xCE, 0x05/*)*/,
     /* 203999 */   GIR_AddSimpleTempRegister, /*InsnID*//* 718(*/0xCE, 0x05/*)*/, /*TempRegID*//* 738(*/0xE2, 0x05/*)*/,
     /* 204004 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 718(*/0xCE, 0x05/*)*/,
     /* 204007 */   GIR_MakeTempReg, /*TempRegID*//* 716(*/0xCC, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 204011 */   GIR_BuildMI, /*InsnID*//* 717(*/0xCD, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 204016 */   GIR_AddTempRegister, /*InsnID*//* 717(*/0xCD, 0x05/*)*/, /*TempRegID*//* 716(*/0xCC, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204023 */   GIR_AddImm, /*InsnID*//* 717(*/0xCD, 0x05/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 204034 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 717(*/0xCD, 0x05/*)*/,
     /* 204037 */   GIR_MakeTempReg, /*TempRegID*//* 715(*/0xCB, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 204041 */   GIR_BuildMI, /*InsnID*//* 716(*/0xCC, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 204046 */   GIR_AddTempRegister, /*InsnID*//* 716(*/0xCC, 0x05/*)*/, /*TempRegID*//* 715(*/0xCB, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204053 */   GIR_AddSimpleTempRegister, /*InsnID*//* 716(*/0xCC, 0x05/*)*/, /*TempRegID*//* 716(*/0xCC, 0x05/*)*/,
     /* 204058 */   GIR_AddImm, /*InsnID*//* 716(*/0xCC, 0x05/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 204069 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 716(*/0xCC, 0x05/*)*/,
     /* 204072 */   GIR_MakeTempReg, /*TempRegID*//* 714(*/0xCA, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 204076 */   GIR_BuildMI, /*InsnID*//* 715(*/0xCB, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 204081 */   GIR_AddTempRegister, /*InsnID*//* 715(*/0xCB, 0x05/*)*/, /*TempRegID*//* 714(*/0xCA, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204088 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 715(*/0xCB, 0x05/*)*/,
     /* 204091 */   GIR_MakeTempReg, /*TempRegID*//* 713(*/0xC9, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 204095 */   GIR_BuildMI, /*InsnID*//* 714(*/0xCA, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 204100 */   GIR_AddTempRegister, /*InsnID*//* 714(*/0xCA, 0x05/*)*/, /*TempRegID*//* 713(*/0xC9, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204107 */   GIR_AddSimpleTempRegister, /*InsnID*//* 714(*/0xCA, 0x05/*)*/, /*TempRegID*//* 714(*/0xCA, 0x05/*)*/,
     /* 204112 */   GIR_AddSimpleTempRegister, /*InsnID*//* 714(*/0xCA, 0x05/*)*/, /*TempRegID*//* 715(*/0xCB, 0x05/*)*/,
     /* 204117 */   GIR_AddImm8, /*InsnID*//* 714(*/0xCA, 0x05/*)*/, /*Imm*/1,
     /* 204121 */   GIR_ConstrainOperandRC, /*InsnID*//* 714(*/0xCA, 0x05/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 204127 */   GIR_ConstrainOperandRC, /*InsnID*//* 714(*/0xCA, 0x05/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 204133 */   GIR_ConstrainOperandRC, /*InsnID*//* 714(*/0xCA, 0x05/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 204139 */   GIR_MakeTempReg, /*TempRegID*//* 712(*/0xC8, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 204143 */   GIR_BuildMI, /*InsnID*//* 713(*/0xC9, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 204148 */   GIR_AddTempRegister, /*InsnID*//* 713(*/0xC9, 0x05/*)*/, /*TempRegID*//* 712(*/0xC8, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204155 */   GIR_AddSimpleTempRegister, /*InsnID*//* 713(*/0xC9, 0x05/*)*/, /*TempRegID*//* 713(*/0xC9, 0x05/*)*/,
     /* 204160 */   GIR_AddImm8, /*InsnID*//* 713(*/0xC9, 0x05/*)*/, /*Imm*/32,
     /* 204164 */   GIR_AddImm8, /*InsnID*//* 713(*/0xC9, 0x05/*)*/, /*Imm*/31,
     /* 204168 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 713(*/0xC9, 0x05/*)*/,
     /* 204171 */   GIR_MakeTempReg, /*TempRegID*//* 711(*/0xC7, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 204175 */   GIR_BuildMI, /*InsnID*//* 712(*/0xC8, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 204180 */   GIR_AddTempRegister, /*InsnID*//* 712(*/0xC8, 0x05/*)*/, /*TempRegID*//* 711(*/0xC7, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204187 */   GIR_AddSimpleTempRegister, /*InsnID*//* 712(*/0xC8, 0x05/*)*/, /*TempRegID*//* 712(*/0xC8, 0x05/*)*/,
     /* 204192 */   GIR_AddImm, /*InsnID*//* 712(*/0xC8, 0x05/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 204203 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 712(*/0xC8, 0x05/*)*/,
     /* 204206 */   GIR_MakeTempReg, /*TempRegID*//* 710(*/0xC6, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 204210 */   GIR_BuildMI, /*InsnID*//* 711(*/0xC7, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 204215 */   GIR_AddTempRegister, /*InsnID*//* 711(*/0xC7, 0x05/*)*/, /*TempRegID*//* 710(*/0xC6, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204222 */   GIR_AddSimpleTempRegister, /*InsnID*//* 711(*/0xC7, 0x05/*)*/, /*TempRegID*//* 711(*/0xC7, 0x05/*)*/,
     /* 204227 */   GIR_AddImm, /*InsnID*//* 711(*/0xC7, 0x05/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 204238 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 711(*/0xC7, 0x05/*)*/,
     /* 204241 */   GIR_MakeTempReg, /*TempRegID*//* 709(*/0xC5, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 204245 */   GIR_BuildMI, /*InsnID*//* 710(*/0xC6, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 204250 */   GIR_AddTempRegister, /*InsnID*//* 710(*/0xC6, 0x05/*)*/, /*TempRegID*//* 709(*/0xC5, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204257 */   GIR_AddImm, /*InsnID*//* 710(*/0xC6, 0x05/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 204268 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 710(*/0xC6, 0x05/*)*/,
     /* 204271 */   GIR_MakeTempReg, /*TempRegID*//* 708(*/0xC4, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 204275 */   GIR_BuildMI, /*InsnID*//* 709(*/0xC5, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 204280 */   GIR_AddTempRegister, /*InsnID*//* 709(*/0xC5, 0x05/*)*/, /*TempRegID*//* 708(*/0xC4, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204287 */   GIR_AddSimpleTempRegister, /*InsnID*//* 709(*/0xC5, 0x05/*)*/, /*TempRegID*//* 709(*/0xC5, 0x05/*)*/,
     /* 204292 */   GIR_AddImm, /*InsnID*//* 709(*/0xC5, 0x05/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 204303 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 709(*/0xC5, 0x05/*)*/,
     /* 204306 */   GIR_MakeTempReg, /*TempRegID*//* 707(*/0xC3, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 204310 */   GIR_BuildMI, /*InsnID*//* 708(*/0xC4, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 204315 */   GIR_AddTempRegister, /*InsnID*//* 708(*/0xC4, 0x05/*)*/, /*TempRegID*//* 707(*/0xC3, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204322 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 708(*/0xC4, 0x05/*)*/,
     /* 204325 */   GIR_MakeTempReg, /*TempRegID*//* 706(*/0xC2, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 204329 */   GIR_BuildMI, /*InsnID*//* 707(*/0xC3, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 204334 */   GIR_AddTempRegister, /*InsnID*//* 707(*/0xC3, 0x05/*)*/, /*TempRegID*//* 706(*/0xC2, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204341 */   GIR_AddSimpleTempRegister, /*InsnID*//* 707(*/0xC3, 0x05/*)*/, /*TempRegID*//* 707(*/0xC3, 0x05/*)*/,
     /* 204346 */   GIR_AddSimpleTempRegister, /*InsnID*//* 707(*/0xC3, 0x05/*)*/, /*TempRegID*//* 708(*/0xC4, 0x05/*)*/,
     /* 204351 */   GIR_AddImm8, /*InsnID*//* 707(*/0xC3, 0x05/*)*/, /*Imm*/1,
     /* 204355 */   GIR_ConstrainOperandRC, /*InsnID*//* 707(*/0xC3, 0x05/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 204361 */   GIR_ConstrainOperandRC, /*InsnID*//* 707(*/0xC3, 0x05/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 204367 */   GIR_ConstrainOperandRC, /*InsnID*//* 707(*/0xC3, 0x05/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 204373 */   GIR_MakeTempReg, /*TempRegID*//* 705(*/0xC1, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 204377 */   GIR_BuildMI, /*InsnID*//* 706(*/0xC2, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 204382 */   GIR_AddTempRegister, /*InsnID*//* 706(*/0xC2, 0x05/*)*/, /*TempRegID*//* 705(*/0xC1, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204389 */   GIR_AddSimpleTempRegister, /*InsnID*//* 706(*/0xC2, 0x05/*)*/, /*TempRegID*//* 706(*/0xC2, 0x05/*)*/,
     /* 204394 */   GIR_AddImm8, /*InsnID*//* 706(*/0xC2, 0x05/*)*/, /*Imm*/32,
     /* 204398 */   GIR_AddImm8, /*InsnID*//* 706(*/0xC2, 0x05/*)*/, /*Imm*/31,
     /* 204402 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 706(*/0xC2, 0x05/*)*/,
     /* 204405 */   GIR_MakeTempReg, /*TempRegID*//* 704(*/0xC0, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 204409 */   GIR_BuildMI, /*InsnID*//* 705(*/0xC1, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 204414 */   GIR_AddTempRegister, /*InsnID*//* 705(*/0xC1, 0x05/*)*/, /*TempRegID*//* 704(*/0xC0, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204421 */   GIR_AddSimpleTempRegister, /*InsnID*//* 705(*/0xC1, 0x05/*)*/, /*TempRegID*//* 705(*/0xC1, 0x05/*)*/,
     /* 204426 */   GIR_AddImm, /*InsnID*//* 705(*/0xC1, 0x05/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 204437 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 705(*/0xC1, 0x05/*)*/,
     /* 204440 */   GIR_MakeTempReg, /*TempRegID*//* 703(*/0xBF, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 204444 */   GIR_BuildMI, /*InsnID*//* 704(*/0xC0, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 204449 */   GIR_AddTempRegister, /*InsnID*//* 704(*/0xC0, 0x05/*)*/, /*TempRegID*//* 703(*/0xBF, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204456 */   GIR_AddSimpleTempRegister, /*InsnID*//* 704(*/0xC0, 0x05/*)*/, /*TempRegID*//* 704(*/0xC0, 0x05/*)*/,
     /* 204461 */   GIR_AddImm, /*InsnID*//* 704(*/0xC0, 0x05/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 204472 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 704(*/0xC0, 0x05/*)*/,
     /* 204475 */   GIR_MakeTempReg, /*TempRegID*//* 702(*/0xBE, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 204479 */   GIR_BuildMI, /*InsnID*//* 703(*/0xBF, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 204484 */   GIR_AddTempRegister, /*InsnID*//* 703(*/0xBF, 0x05/*)*/, /*TempRegID*//* 702(*/0xBE, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204491 */   GIR_Copy, /*NewInsnID*//* 703(*/0xBF, 0x05/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 204496 */   GIR_AddImm8, /*InsnID*//* 703(*/0xBF, 0x05/*)*/, /*Imm*/1,
     /* 204500 */   GIR_AddImm8, /*InsnID*//* 703(*/0xBF, 0x05/*)*/, /*Imm*/62,
     /* 204504 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 703(*/0xBF, 0x05/*)*/,
     /* 204507 */   GIR_MakeTempReg, /*TempRegID*//* 701(*/0xBD, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 204511 */   GIR_BuildMI, /*InsnID*//* 702(*/0xBE, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 204516 */   GIR_AddTempRegister, /*InsnID*//* 702(*/0xBE, 0x05/*)*/, /*TempRegID*//* 701(*/0xBD, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204523 */   GIR_AddSimpleTempRegister, /*InsnID*//* 702(*/0xBE, 0x05/*)*/, /*TempRegID*//* 702(*/0xBE, 0x05/*)*/,
     /* 204528 */   GIR_AddSimpleTempRegister, /*InsnID*//* 702(*/0xBE, 0x05/*)*/, /*TempRegID*//* 703(*/0xBF, 0x05/*)*/,
     /* 204533 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 702(*/0xBE, 0x05/*)*/,
     /* 204536 */   GIR_MakeTempReg, /*TempRegID*//* 700(*/0xBC, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 204540 */   GIR_BuildMI, /*InsnID*//* 701(*/0xBD, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 204545 */   GIR_AddTempRegister, /*InsnID*//* 701(*/0xBD, 0x05/*)*/, /*TempRegID*//* 700(*/0xBC, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204552 */   GIR_AddImm, /*InsnID*//* 701(*/0xBD, 0x05/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 204563 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 701(*/0xBD, 0x05/*)*/,
     /* 204566 */   GIR_MakeTempReg, /*TempRegID*//* 699(*/0xBB, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 204570 */   GIR_BuildMI, /*InsnID*//* 700(*/0xBC, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 204575 */   GIR_AddTempRegister, /*InsnID*//* 700(*/0xBC, 0x05/*)*/, /*TempRegID*//* 699(*/0xBB, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204582 */   GIR_AddSimpleTempRegister, /*InsnID*//* 700(*/0xBC, 0x05/*)*/, /*TempRegID*//* 700(*/0xBC, 0x05/*)*/,
     /* 204587 */   GIR_AddImm, /*InsnID*//* 700(*/0xBC, 0x05/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 204598 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 700(*/0xBC, 0x05/*)*/,
     /* 204601 */   GIR_MakeTempReg, /*TempRegID*//* 698(*/0xBA, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 204605 */   GIR_BuildMI, /*InsnID*//* 699(*/0xBB, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 204610 */   GIR_AddTempRegister, /*InsnID*//* 699(*/0xBB, 0x05/*)*/, /*TempRegID*//* 698(*/0xBA, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204617 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 699(*/0xBB, 0x05/*)*/,
     /* 204620 */   GIR_MakeTempReg, /*TempRegID*//* 697(*/0xB9, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 204624 */   GIR_BuildMI, /*InsnID*//* 698(*/0xBA, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 204629 */   GIR_AddTempRegister, /*InsnID*//* 698(*/0xBA, 0x05/*)*/, /*TempRegID*//* 697(*/0xB9, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204636 */   GIR_AddSimpleTempRegister, /*InsnID*//* 698(*/0xBA, 0x05/*)*/, /*TempRegID*//* 698(*/0xBA, 0x05/*)*/,
     /* 204641 */   GIR_AddSimpleTempRegister, /*InsnID*//* 698(*/0xBA, 0x05/*)*/, /*TempRegID*//* 699(*/0xBB, 0x05/*)*/,
     /* 204646 */   GIR_AddImm8, /*InsnID*//* 698(*/0xBA, 0x05/*)*/, /*Imm*/1,
     /* 204650 */   GIR_ConstrainOperandRC, /*InsnID*//* 698(*/0xBA, 0x05/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 204656 */   GIR_ConstrainOperandRC, /*InsnID*//* 698(*/0xBA, 0x05/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 204662 */   GIR_ConstrainOperandRC, /*InsnID*//* 698(*/0xBA, 0x05/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 204668 */   GIR_MakeTempReg, /*TempRegID*//* 696(*/0xB8, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 204672 */   GIR_BuildMI, /*InsnID*//* 697(*/0xB9, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 204677 */   GIR_AddTempRegister, /*InsnID*//* 697(*/0xB9, 0x05/*)*/, /*TempRegID*//* 696(*/0xB8, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204684 */   GIR_AddSimpleTempRegister, /*InsnID*//* 697(*/0xB9, 0x05/*)*/, /*TempRegID*//* 697(*/0xB9, 0x05/*)*/,
     /* 204689 */   GIR_AddImm8, /*InsnID*//* 697(*/0xB9, 0x05/*)*/, /*Imm*/32,
     /* 204693 */   GIR_AddImm8, /*InsnID*//* 697(*/0xB9, 0x05/*)*/, /*Imm*/31,
     /* 204697 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 697(*/0xB9, 0x05/*)*/,
     /* 204700 */   GIR_MakeTempReg, /*TempRegID*//* 695(*/0xB7, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 204704 */   GIR_BuildMI, /*InsnID*//* 696(*/0xB8, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 204709 */   GIR_AddTempRegister, /*InsnID*//* 696(*/0xB8, 0x05/*)*/, /*TempRegID*//* 695(*/0xB7, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204716 */   GIR_AddSimpleTempRegister, /*InsnID*//* 696(*/0xB8, 0x05/*)*/, /*TempRegID*//* 696(*/0xB8, 0x05/*)*/,
     /* 204721 */   GIR_AddImm, /*InsnID*//* 696(*/0xB8, 0x05/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 204732 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 696(*/0xB8, 0x05/*)*/,
     /* 204735 */   GIR_MakeTempReg, /*TempRegID*//* 694(*/0xB6, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 204739 */   GIR_BuildMI, /*InsnID*//* 695(*/0xB7, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 204744 */   GIR_AddTempRegister, /*InsnID*//* 695(*/0xB7, 0x05/*)*/, /*TempRegID*//* 694(*/0xB6, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204751 */   GIR_AddSimpleTempRegister, /*InsnID*//* 695(*/0xB7, 0x05/*)*/, /*TempRegID*//* 695(*/0xB7, 0x05/*)*/,
     /* 204756 */   GIR_AddImm, /*InsnID*//* 695(*/0xB7, 0x05/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 204767 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 695(*/0xB7, 0x05/*)*/,
     /* 204770 */   GIR_MakeTempReg, /*TempRegID*//* 693(*/0xB5, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 204774 */   GIR_BuildMI, /*InsnID*//* 694(*/0xB6, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 204779 */   GIR_AddTempRegister, /*InsnID*//* 694(*/0xB6, 0x05/*)*/, /*TempRegID*//* 693(*/0xB5, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204786 */   GIR_Copy, /*NewInsnID*//* 694(*/0xB6, 0x05/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 204791 */   GIR_AddImm8, /*InsnID*//* 694(*/0xB6, 0x05/*)*/, /*Imm*/63,
     /* 204795 */   GIR_AddImm8, /*InsnID*//* 694(*/0xB6, 0x05/*)*/, /*Imm*/1,
     /* 204799 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 694(*/0xB6, 0x05/*)*/,
     /* 204802 */   GIR_MakeTempReg, /*TempRegID*//* 692(*/0xB4, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 204806 */   GIR_BuildMI, /*InsnID*//* 693(*/0xB5, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 204811 */   GIR_AddTempRegister, /*InsnID*//* 693(*/0xB5, 0x05/*)*/, /*TempRegID*//* 692(*/0xB4, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204818 */   GIR_AddSimpleTempRegister, /*InsnID*//* 693(*/0xB5, 0x05/*)*/, /*TempRegID*//* 693(*/0xB5, 0x05/*)*/,
     /* 204823 */   GIR_AddSimpleTempRegister, /*InsnID*//* 693(*/0xB5, 0x05/*)*/, /*TempRegID*//* 694(*/0xB6, 0x05/*)*/,
     /* 204828 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 693(*/0xB5, 0x05/*)*/,
     /* 204831 */   GIR_MakeTempReg, /*TempRegID*//* 691(*/0xB3, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 204835 */   GIR_BuildMI, /*InsnID*//* 692(*/0xB4, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 204840 */   GIR_AddTempRegister, /*InsnID*//* 692(*/0xB4, 0x05/*)*/, /*TempRegID*//* 691(*/0xB3, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204847 */   GIR_AddSimpleTempRegister, /*InsnID*//* 692(*/0xB4, 0x05/*)*/, /*TempRegID*//* 692(*/0xB4, 0x05/*)*/,
     /* 204852 */   GIR_AddSimpleTempRegister, /*InsnID*//* 692(*/0xB4, 0x05/*)*/, /*TempRegID*//* 701(*/0xBD, 0x05/*)*/,
     /* 204857 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 692(*/0xB4, 0x05/*)*/,
     /* 204860 */   GIR_MakeTempReg, /*TempRegID*//* 690(*/0xB2, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 204864 */   GIR_BuildMI, /*InsnID*//* 691(*/0xB3, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 204869 */   GIR_AddTempRegister, /*InsnID*//* 691(*/0xB3, 0x05/*)*/, /*TempRegID*//* 690(*/0xB2, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204876 */   GIR_AddSimpleTempRegister, /*InsnID*//* 691(*/0xB3, 0x05/*)*/, /*TempRegID*//* 691(*/0xB3, 0x05/*)*/,
     /* 204881 */   GIR_AddImm8, /*InsnID*//* 691(*/0xB3, 0x05/*)*/, /*Imm*/62,
     /* 204885 */   GIR_AddImm8, /*InsnID*//* 691(*/0xB3, 0x05/*)*/, /*Imm*/2,
     /* 204889 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 691(*/0xB3, 0x05/*)*/,
     /* 204892 */   GIR_MakeTempReg, /*TempRegID*//* 689(*/0xB1, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 204896 */   GIR_BuildMI, /*InsnID*//* 690(*/0xB2, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 204901 */   GIR_AddTempRegister, /*InsnID*//* 690(*/0xB2, 0x05/*)*/, /*TempRegID*//* 689(*/0xB1, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204908 */   GIR_AddSimpleTempRegister, /*InsnID*//* 690(*/0xB2, 0x05/*)*/, /*TempRegID*//* 690(*/0xB2, 0x05/*)*/,
     /* 204913 */   GIR_AddSimpleTempRegister, /*InsnID*//* 690(*/0xB2, 0x05/*)*/, /*TempRegID*//* 710(*/0xC6, 0x05/*)*/,
     /* 204918 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 690(*/0xB2, 0x05/*)*/,
     /* 204921 */   GIR_MakeTempReg, /*TempRegID*//* 688(*/0xB0, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 204925 */   GIR_BuildMI, /*InsnID*//* 689(*/0xB1, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 204930 */   GIR_AddTempRegister, /*InsnID*//* 689(*/0xB1, 0x05/*)*/, /*TempRegID*//* 688(*/0xB0, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204937 */   GIR_AddSimpleTempRegister, /*InsnID*//* 689(*/0xB1, 0x05/*)*/, /*TempRegID*//* 689(*/0xB1, 0x05/*)*/,
     /* 204942 */   GIR_AddSimpleTempRegister, /*InsnID*//* 689(*/0xB1, 0x05/*)*/, /*TempRegID*//* 717(*/0xCD, 0x05/*)*/,
     /* 204947 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 689(*/0xB1, 0x05/*)*/,
     /* 204950 */   GIR_MakeTempReg, /*TempRegID*//* 687(*/0xAF, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 204954 */   GIR_BuildMI, /*InsnID*//* 688(*/0xB0, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 204959 */   GIR_AddTempRegister, /*InsnID*//* 688(*/0xB0, 0x05/*)*/, /*TempRegID*//* 687(*/0xAF, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204966 */   GIR_AddSimpleTempRegister, /*InsnID*//* 688(*/0xB0, 0x05/*)*/, /*TempRegID*//* 688(*/0xB0, 0x05/*)*/,
     /* 204971 */   GIR_AddImm8, /*InsnID*//* 688(*/0xB0, 0x05/*)*/, /*Imm*/60,
     /* 204975 */   GIR_AddImm8, /*InsnID*//* 688(*/0xB0, 0x05/*)*/, /*Imm*/4,
     /* 204979 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 688(*/0xB0, 0x05/*)*/,
     /* 204982 */   GIR_MakeTempReg, /*TempRegID*//* 686(*/0xAE, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 204986 */   GIR_BuildMI, /*InsnID*//* 687(*/0xAF, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 204991 */   GIR_AddTempRegister, /*InsnID*//* 687(*/0xAF, 0x05/*)*/, /*TempRegID*//* 686(*/0xAE, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204998 */   GIR_AddSimpleTempRegister, /*InsnID*//* 687(*/0xAF, 0x05/*)*/, /*TempRegID*//* 687(*/0xAF, 0x05/*)*/,
     /* 205003 */   GIR_AddSimpleTempRegister, /*InsnID*//* 687(*/0xAF, 0x05/*)*/, /*TempRegID*//* 745(*/0xE9, 0x05/*)*/,
     /* 205008 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 687(*/0xAF, 0x05/*)*/,
     /* 205011 */   GIR_MakeTempReg, /*TempRegID*//* 685(*/0xAD, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205015 */   GIR_BuildMI, /*InsnID*//* 686(*/0xAE, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 205020 */   GIR_AddTempRegister, /*InsnID*//* 686(*/0xAE, 0x05/*)*/, /*TempRegID*//* 685(*/0xAD, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205027 */   GIR_AddSimpleTempRegister, /*InsnID*//* 686(*/0xAE, 0x05/*)*/, /*TempRegID*//* 686(*/0xAE, 0x05/*)*/,
     /* 205032 */   GIR_AddSimpleTempRegister, /*InsnID*//* 686(*/0xAE, 0x05/*)*/, /*TempRegID*//* 752(*/0xF0, 0x05/*)*/,
     /* 205037 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 686(*/0xAE, 0x05/*)*/,
     /* 205040 */   GIR_MakeTempReg, /*TempRegID*//* 684(*/0xAC, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205044 */   GIR_BuildMI, /*InsnID*//* 685(*/0xAD, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 205049 */   GIR_AddTempRegister, /*InsnID*//* 685(*/0xAD, 0x05/*)*/, /*TempRegID*//* 684(*/0xAC, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205056 */   GIR_AddSimpleTempRegister, /*InsnID*//* 685(*/0xAD, 0x05/*)*/, /*TempRegID*//* 685(*/0xAD, 0x05/*)*/,
     /* 205061 */   GIR_AddImm8, /*InsnID*//* 685(*/0xAD, 0x05/*)*/, /*Imm*/32,
     /* 205065 */   GIR_AddImm8, /*InsnID*//* 685(*/0xAD, 0x05/*)*/, /*Imm*/32,
     /* 205069 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 685(*/0xAD, 0x05/*)*/,
     /* 205072 */   GIR_MakeTempReg, /*TempRegID*//* 683(*/0xAB, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 205076 */   GIR_BuildMI, /*InsnID*//* 684(*/0xAC, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 205081 */   GIR_AddTempRegister, /*InsnID*//* 684(*/0xAC, 0x05/*)*/, /*TempRegID*//* 683(*/0xAB, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205088 */   GIR_AddTempSubRegister, /*InsnID*//* 684(*/0xAC, 0x05/*)*/, /*TempRegID*//* 684(*/0xAC, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 205097 */   GIR_ConstrainOperandRC, /*InsnID*//* 684(*/0xAC, 0x05/*)*/, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 205103 */   GIR_ConstrainOperandRC, /*InsnID*//* 684(*/0xAC, 0x05/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 205109 */   GIR_MakeTempReg, /*TempRegID*//* 548(*/0xA4, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 205113 */   GIR_BuildMI, /*InsnID*//* 549(*/0xA5, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 205118 */   GIR_AddTempRegister, /*InsnID*//* 549(*/0xA5, 0x04/*)*/, /*TempRegID*//* 548(*/0xA4, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205125 */   GIR_AddTempSubRegister, /*InsnID*//* 549(*/0xA5, 0x04/*)*/, /*TempRegID*//* 549(*/0xA5, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 205134 */   GIR_ConstrainOperandRC, /*InsnID*//* 549(*/0xA5, 0x04/*)*/, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 205140 */   GIR_ConstrainOperandRC, /*InsnID*//* 549(*/0xA5, 0x04/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 205146 */   GIR_MakeTempReg, /*TempRegID*//* 413(*/0x9D, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 205150 */   GIR_BuildMI, /*InsnID*//* 414(*/0x9E, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 205155 */   GIR_AddTempRegister, /*InsnID*//* 414(*/0x9E, 0x03/*)*/, /*TempRegID*//* 413(*/0x9D, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205162 */   GIR_AddTempSubRegister, /*InsnID*//* 414(*/0x9E, 0x03/*)*/, /*TempRegID*//* 414(*/0x9E, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 205171 */   GIR_ConstrainOperandRC, /*InsnID*//* 414(*/0x9E, 0x03/*)*/, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 205177 */   GIR_ConstrainOperandRC, /*InsnID*//* 414(*/0x9E, 0x03/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 205183 */   GIR_MakeTempReg, /*TempRegID*//* 412(*/0x9C, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 205187 */   GIR_BuildMI, /*InsnID*//* 413(*/0x9D, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 205192 */   GIR_AddTempRegister, /*InsnID*//* 413(*/0x9D, 0x03/*)*/, /*TempRegID*//* 412(*/0x9C, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205199 */   GIR_AddSimpleTempRegister, /*InsnID*//* 413(*/0x9D, 0x03/*)*/, /*TempRegID*//* 413(*/0x9D, 0x03/*)*/,
     /* 205204 */   GIR_AddImm8, /*InsnID*//* 413(*/0x9D, 0x03/*)*/, /*Imm*/24,
     /* 205208 */   GIR_AddImm8, /*InsnID*//* 413(*/0x9D, 0x03/*)*/, /*Imm*/0,
     /* 205212 */   GIR_AddImm8, /*InsnID*//* 413(*/0x9D, 0x03/*)*/, /*Imm*/31,
     /* 205216 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 413(*/0x9D, 0x03/*)*/,
     /* 205219 */   GIR_MakeTempReg, /*TempRegID*//* 411(*/0x9B, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 205223 */   GIR_BuildMI, /*InsnID*//* 412(*/0x9C, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWIMI),
     /* 205228 */   GIR_AddTempRegister, /*InsnID*//* 412(*/0x9C, 0x03/*)*/, /*TempRegID*//* 411(*/0x9B, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205235 */   GIR_AddSimpleTempRegister, /*InsnID*//* 412(*/0x9C, 0x03/*)*/, /*TempRegID*//* 412(*/0x9C, 0x03/*)*/,
     /* 205240 */   GIR_AddSimpleTempRegister, /*InsnID*//* 412(*/0x9C, 0x03/*)*/, /*TempRegID*//* 548(*/0xA4, 0x04/*)*/,
     /* 205245 */   GIR_AddImm8, /*InsnID*//* 412(*/0x9C, 0x03/*)*/, /*Imm*/8,
     /* 205249 */   GIR_AddImm8, /*InsnID*//* 412(*/0x9C, 0x03/*)*/, /*Imm*/8,
     /* 205253 */   GIR_AddImm8, /*InsnID*//* 412(*/0x9C, 0x03/*)*/, /*Imm*/15,
     /* 205257 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 412(*/0x9C, 0x03/*)*/,
     /* 205260 */   GIR_MakeTempReg, /*TempRegID*//* 410(*/0x9A, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 205264 */   GIR_BuildMI, /*InsnID*//* 411(*/0x9B, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWIMI),
     /* 205269 */   GIR_AddTempRegister, /*InsnID*//* 411(*/0x9B, 0x03/*)*/, /*TempRegID*//* 410(*/0x9A, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205276 */   GIR_AddSimpleTempRegister, /*InsnID*//* 411(*/0x9B, 0x03/*)*/, /*TempRegID*//* 411(*/0x9B, 0x03/*)*/,
     /* 205281 */   GIR_AddSimpleTempRegister, /*InsnID*//* 411(*/0x9B, 0x03/*)*/, /*TempRegID*//* 683(*/0xAB, 0x05/*)*/,
     /* 205286 */   GIR_AddImm8, /*InsnID*//* 411(*/0x9B, 0x03/*)*/, /*Imm*/8,
     /* 205290 */   GIR_AddImm8, /*InsnID*//* 411(*/0x9B, 0x03/*)*/, /*Imm*/24,
     /* 205294 */   GIR_AddImm8, /*InsnID*//* 411(*/0x9B, 0x03/*)*/, /*Imm*/31,
     /* 205298 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 411(*/0x9B, 0x03/*)*/,
     /* 205301 */   GIR_MakeTempReg, /*TempRegID*//* 409(*/0x99, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 205305 */   GIR_BuildMI, /*InsnID*//* 410(*/0x9A, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 205310 */   GIR_AddTempRegister, /*InsnID*//* 410(*/0x9A, 0x03/*)*/, /*TempRegID*//* 409(*/0x99, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205317 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 410(*/0x9A, 0x03/*)*/,
     /* 205320 */   GIR_MakeTempReg, /*TempRegID*//* 408(*/0x98, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 205324 */   GIR_BuildMI, /*InsnID*//* 409(*/0x99, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 205329 */   GIR_AddTempRegister, /*InsnID*//* 409(*/0x99, 0x03/*)*/, /*TempRegID*//* 408(*/0x98, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205336 */   GIR_AddSimpleTempRegister, /*InsnID*//* 409(*/0x99, 0x03/*)*/, /*TempRegID*//* 409(*/0x99, 0x03/*)*/,
     /* 205341 */   GIR_AddSimpleTempRegister, /*InsnID*//* 409(*/0x99, 0x03/*)*/, /*TempRegID*//* 410(*/0x9A, 0x03/*)*/,
     /* 205346 */   GIR_AddImm8, /*InsnID*//* 409(*/0x99, 0x03/*)*/, /*Imm*/1,
     /* 205350 */   GIR_ConstrainOperandRC, /*InsnID*//* 409(*/0x99, 0x03/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 205356 */   GIR_ConstrainOperandRC, /*InsnID*//* 409(*/0x99, 0x03/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 205362 */   GIR_ConstrainOperandRC, /*InsnID*//* 409(*/0x99, 0x03/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 205368 */   GIR_MakeTempReg, /*TempRegID*//* 274(*/0x92, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 205372 */   GIR_BuildMI, /*InsnID*//* 275(*/0x93, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 205377 */   GIR_AddTempRegister, /*InsnID*//* 275(*/0x93, 0x02/*)*/, /*TempRegID*//* 274(*/0x92, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205384 */   GIR_AddTempSubRegister, /*InsnID*//* 275(*/0x93, 0x02/*)*/, /*TempRegID*//* 275(*/0x93, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 205393 */   GIR_ConstrainOperandRC, /*InsnID*//* 275(*/0x93, 0x02/*)*/, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 205399 */   GIR_ConstrainOperandRC, /*InsnID*//* 275(*/0x93, 0x02/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 205405 */   GIR_MakeTempReg, /*TempRegID*//* 140(*/0x8C, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 205409 */   GIR_BuildMI, /*InsnID*//* 141(*/0x8D, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 205414 */   GIR_AddTempRegister, /*InsnID*//* 141(*/0x8D, 0x01/*)*/, /*TempRegID*//* 140(*/0x8C, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205421 */   GIR_AddTempSubRegister, /*InsnID*//* 141(*/0x8D, 0x01/*)*/, /*TempRegID*//* 141(*/0x8D, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 205430 */   GIR_ConstrainOperandRC, /*InsnID*//* 141(*/0x8D, 0x01/*)*/, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 205436 */   GIR_ConstrainOperandRC, /*InsnID*//* 141(*/0x8D, 0x01/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 205442 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s32,
     /* 205445 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 205449 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205454 */   GIR_AddTempSubRegister, /*InsnID*/7, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 205461 */   GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 205466 */   GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 205471 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /* 205474 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 205478 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205483 */   GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 205486 */   GIR_AddImm8, /*InsnID*/6, /*Imm*/24,
     /* 205489 */   GIR_AddImm8, /*InsnID*/6, /*Imm*/0,
     /* 205492 */   GIR_AddImm8, /*InsnID*/6, /*Imm*/31,
     /* 205495 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 205497 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 205500 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(PPC::RLWIMI),
     /* 205504 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205509 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 205512 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*//* 140(*/0x8C, 0x01/*)*/,
     /* 205516 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/8,
     /* 205519 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/8,
     /* 205522 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/15,
     /* 205525 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 205527 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 205530 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::RLWIMI),
     /* 205534 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205539 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 205542 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*//* 274(*/0x92, 0x02/*)*/,
     /* 205546 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/8,
     /* 205549 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/24,
     /* 205552 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/31,
     /* 205555 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 205557 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 205560 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 205564 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205569 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 205571 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 205574 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 205578 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205583 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 205586 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 205589 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 205592 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 205597 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 205602 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 205607 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 205610 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 205614 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205619 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 205622 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/32,
     /* 205625 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 205628 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 205630 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 205633 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 205635 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 205638 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*//* 408(*/0x98, 0x03/*)*/,
     /* 205642 */   GIR_RootConstrainSelectedInstOperands,
     /* 205643 */   // GIR_Coverage, 4847,
     /* 205643 */   GIR_EraseRootFromParent_Done,
     /* 205644 */ // Label 2736: @205644
     /* 205644 */ GIM_Reject,
     /* 205645 */ // Label 2732: @205645
     /* 205645 */ GIM_Reject,
     /* 205646 */ // Label 71: @205646
     /* 205646 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2742*/ GIMT_Encode4(205920),
     /* 205657 */ /*GILLT_s32*//*Label 2737*/ GIMT_Encode4(205677),
     /* 205661 */ /*GILLT_s64*//*Label 2738*/ GIMT_Encode4(205770),
     /* 205665 */ /*GILLT_s128*//*Label 2739*/ GIMT_Encode4(205818),
     /* 205669 */ /*GILLT_v2s64*//*Label 2740*/ GIMT_Encode4(205849),
     /* 205673 */ /*GILLT_v4s32*//*Label 2741*/ GIMT_Encode4(205872),
     /* 205677 */ // Label 2737: @205677
     /* 205677 */ GIM_Try, /*On fail goto*//*Label 2743*/ GIMT_Encode4(205769),
     /* 205682 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 205685 */   GIM_Try, /*On fail goto*//*Label 2744*/ GIMT_Encode4(205749), // Rule ID 1704 //
     /* 205690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 205693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 205697 */     // (fceil:{ *:[f32] } f32:{ *:[f32] }:$S)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (XSRDPIP:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$S, VSFRC:{ *:[i32] })), VSSRC:{ *:[i32] })
     /* 205697 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 205700 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 205704 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205709 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // S
     /* 205713 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 205718 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 205721 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSRDPIP),
     /* 205725 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205730 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 205733 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 205735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 205738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 205740 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 205743 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 205748 */     // GIR_Coverage, 1704,
     /* 205748 */     GIR_EraseRootFromParent_Done,
     /* 205749 */   // Label 2744: @205749
     /* 205749 */   GIM_Try, /*On fail goto*//*Label 2745*/ GIMT_Encode4(205768), // Rule ID 146 //
     /* 205754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 205757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 205761 */     // (fceil:{ *:[f32] } f32:{ *:[f32] }:$RB)  =>  (FRIPS:{ *:[f32] } f32:{ *:[f32] }:$RB)
     /* 205761 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FRIPS),
     /* 205766 */     GIR_RootConstrainSelectedInstOperands,
     /* 205767 */     // GIR_Coverage, 146,
     /* 205767 */     GIR_Done,
     /* 205768 */   // Label 2745: @205768
     /* 205768 */   GIM_Reject,
     /* 205769 */ // Label 2743: @205769
     /* 205769 */ GIM_Reject,
     /* 205770 */ // Label 2738: @205770
     /* 205770 */ GIM_Try, /*On fail goto*//*Label 2746*/ GIMT_Encode4(205817),
     /* 205775 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 205778 */   GIM_Try, /*On fail goto*//*Label 2747*/ GIMT_Encode4(205797), // Rule ID 909 //
     /* 205783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 205786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 205790 */     // (fceil:{ *:[f64] } f64:{ *:[f64] }:$XB)  =>  (XSRDPIP:{ *:[f64] } f64:{ *:[f64] }:$XB)
     /* 205790 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSRDPIP),
     /* 205795 */     GIR_RootConstrainSelectedInstOperands,
     /* 205796 */     // GIR_Coverage, 909,
     /* 205796 */     GIR_Done,
     /* 205797 */   // Label 2747: @205797
     /* 205797 */   GIM_Try, /*On fail goto*//*Label 2748*/ GIMT_Encode4(205816), // Rule ID 144 //
     /* 205802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 205805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 205809 */     // (fceil:{ *:[f64] } f64:{ *:[f64] }:$RB)  =>  (FRIPD:{ *:[f64] } f64:{ *:[f64] }:$RB)
     /* 205809 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FRIPD),
     /* 205814 */     GIR_RootConstrainSelectedInstOperands,
     /* 205815 */     // GIR_Coverage, 144,
     /* 205815 */     GIR_Done,
     /* 205816 */   // Label 2748: @205816
     /* 205816 */   GIM_Reject,
     /* 205817 */ // Label 2746: @205817
     /* 205817 */ GIM_Reject,
     /* 205818 */ // Label 2739: @205818
     /* 205818 */ GIM_Try, /*On fail goto*//*Label 2749*/ GIMT_Encode4(205848), // Rule ID 2159 //
     /* 205823 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 205826 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 205829 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 205833 */   // (fceil:{ *:[f128] } f128:{ *:[f128] }:$vB)  =>  (XSRQPI:{ *:[f128] } 1:{ *:[i32] }, ?:{ *:[f128] }:$vB, 2:{ *:[i32] })
     /* 205833 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSRQPI),
     /* 205836 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VRT]
     /* 205838 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 205841 */   GIR_RootToRootCopy, /*OpIdx*/1, // vB
     /* 205843 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 205846 */   GIR_RootConstrainSelectedInstOperands,
     /* 205847 */   // GIR_Coverage, 2159,
     /* 205847 */   GIR_EraseRootFromParent_Done,
     /* 205848 */ // Label 2749: @205848
     /* 205848 */ GIM_Reject,
     /* 205849 */ // Label 2740: @205849
     /* 205849 */ GIM_Try, /*On fail goto*//*Label 2750*/ GIMT_Encode4(205871), // Rule ID 917 //
     /* 205854 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 205857 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 205860 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 205864 */   // (fceil:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB)  =>  (XVRDPIP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB)
     /* 205864 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVRDPIP),
     /* 205869 */   GIR_RootConstrainSelectedInstOperands,
     /* 205870 */   // GIR_Coverage, 917,
     /* 205870 */   GIR_Done,
     /* 205871 */ // Label 2750: @205871
     /* 205871 */ GIM_Reject,
     /* 205872 */ // Label 2741: @205872
     /* 205872 */ GIM_Try, /*On fail goto*//*Label 2751*/ GIMT_Encode4(205919),
     /* 205877 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 205880 */   GIM_Try, /*On fail goto*//*Label 2752*/ GIMT_Encode4(205899), // Rule ID 925 //
     /* 205885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 205888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 205892 */     // (fceil:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB)  =>  (XVRSPIP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB)
     /* 205892 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVRSPIP),
     /* 205897 */     GIR_RootConstrainSelectedInstOperands,
     /* 205898 */     // GIR_Coverage, 925,
     /* 205898 */     GIR_Done,
     /* 205899 */   // Label 2752: @205899
     /* 205899 */   GIM_Try, /*On fail goto*//*Label 2753*/ GIMT_Encode4(205918), // Rule ID 1414 //
     /* 205904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 205907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 205911 */     // (fceil:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$vA)  =>  (VRFIP:{ *:[v4f32] } ?:{ *:[v4f32] }:$vA)
     /* 205911 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VRFIP),
     /* 205916 */     GIR_RootConstrainSelectedInstOperands,
     /* 205917 */     // GIR_Coverage, 1414,
     /* 205917 */     GIR_Done,
     /* 205918 */   // Label 2753: @205918
     /* 205918 */   GIM_Reject,
     /* 205919 */ // Label 2751: @205919
     /* 205919 */ GIM_Reject,
     /* 205920 */ // Label 2742: @205920
     /* 205920 */ GIM_Reject,
     /* 205921 */ // Label 72: @205921
     /* 205921 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2759*/ GIMT_Encode4(206137),
     /* 205932 */ /*GILLT_s32*//*Label 2754*/ GIMT_Encode4(205952),
     /* 205936 */ /*GILLT_s64*//*Label 2755*/ GIMT_Encode4(206004),
     /* 205940 */ /*GILLT_s128*//*Label 2756*/ GIMT_Encode4(206060),
     /* 205944 */ /*GILLT_v2s64*//*Label 2757*/ GIMT_Encode4(206083),
     /* 205948 */ /*GILLT_v4s32*//*Label 2758*/ GIMT_Encode4(206110),
     /* 205952 */ // Label 2754: @205952
     /* 205952 */ GIM_Try, /*On fail goto*//*Label 2760*/ GIMT_Encode4(206003),
     /* 205957 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 205960 */   GIM_Try, /*On fail goto*//*Label 2761*/ GIMT_Encode4(205979), // Rule ID 960 //
     /* 205965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 205968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 205972 */     // (fsqrt:{ *:[f32] } f32:{ *:[f32] }:$XB)  =>  (XSSQRTSP:{ *:[f32] } f32:{ *:[f32] }:$XB)
     /* 205972 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSSQRTSP),
     /* 205977 */     GIR_RootConstrainSelectedInstOperands,
     /* 205978 */     // GIR_Coverage, 960,
     /* 205978 */     GIR_Done,
     /* 205979 */   // Label 2761: @205979
     /* 205979 */   GIM_Try, /*On fail goto*//*Label 2762*/ GIMT_Encode4(206002), // Rule ID 162 //
     /* 205984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 205987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 205991 */     // (fsqrt:{ *:[f32] } f32:{ *:[f32] }:$RB)  =>  (FSQRTS:{ *:[f32] } f32:{ *:[f32] }:$RB)
     /* 205991 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FSQRTS),
     /* 205996 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 206000 */     GIR_RootConstrainSelectedInstOperands,
     /* 206001 */     // GIR_Coverage, 162,
     /* 206001 */     GIR_Done,
     /* 206002 */   // Label 2762: @206002
     /* 206002 */   GIM_Reject,
     /* 206003 */ // Label 2760: @206003
     /* 206003 */ GIM_Reject,
     /* 206004 */ // Label 2755: @206004
     /* 206004 */ GIM_Try, /*On fail goto*//*Label 2763*/ GIMT_Encode4(206059),
     /* 206009 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 206012 */   GIM_Try, /*On fail goto*//*Label 2764*/ GIMT_Encode4(206035), // Rule ID 809 //
     /* 206017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 206020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 206024 */     // (fsqrt:{ *:[f64] } f64:{ *:[f64] }:$XB)  =>  (XSSQRTDP:{ *:[f64] } f64:{ *:[f64] }:$XB)
     /* 206024 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSSQRTDP),
     /* 206029 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 206033 */     GIR_RootConstrainSelectedInstOperands,
     /* 206034 */     // GIR_Coverage, 809,
     /* 206034 */     GIR_Done,
     /* 206035 */   // Label 2764: @206035
     /* 206035 */   GIM_Try, /*On fail goto*//*Label 2765*/ GIMT_Encode4(206058), // Rule ID 160 //
     /* 206040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 206043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 206047 */     // (fsqrt:{ *:[f64] } f64:{ *:[f64] }:$RB)  =>  (FSQRT:{ *:[f64] } f64:{ *:[f64] }:$RB)
     /* 206047 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FSQRT),
     /* 206052 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 206056 */     GIR_RootConstrainSelectedInstOperands,
     /* 206057 */     // GIR_Coverage, 160,
     /* 206057 */     GIR_Done,
     /* 206058 */   // Label 2765: @206058
     /* 206058 */   GIM_Reject,
     /* 206059 */ // Label 2763: @206059
     /* 206059 */ GIM_Reject,
     /* 206060 */ // Label 2756: @206060
     /* 206060 */ GIM_Try, /*On fail goto*//*Label 2766*/ GIMT_Encode4(206082), // Rule ID 992 //
     /* 206065 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 206068 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 206071 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 206075 */   // (fsqrt:{ *:[f128] } f128:{ *:[f128] }:$RB)  =>  (XSSQRTQP:{ *:[f128] } f128:{ *:[f128] }:$RB)
     /* 206075 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSSQRTQP),
     /* 206080 */   GIR_RootConstrainSelectedInstOperands,
     /* 206081 */   // GIR_Coverage, 992,
     /* 206081 */   GIR_Done,
     /* 206082 */ // Label 2766: @206082
     /* 206082 */ GIM_Reject,
     /* 206083 */ // Label 2757: @206083
     /* 206083 */ GIM_Try, /*On fail goto*//*Label 2767*/ GIMT_Encode4(206109), // Rule ID 820 //
     /* 206088 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 206091 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 206094 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 206098 */   // (fsqrt:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB)  =>  (XVSQRTDP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB)
     /* 206098 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVSQRTDP),
     /* 206103 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 206107 */   GIR_RootConstrainSelectedInstOperands,
     /* 206108 */   // GIR_Coverage, 820,
     /* 206108 */   GIR_Done,
     /* 206109 */ // Label 2767: @206109
     /* 206109 */ GIM_Reject,
     /* 206110 */ // Label 2758: @206110
     /* 206110 */ GIM_Try, /*On fail goto*//*Label 2768*/ GIMT_Encode4(206136), // Rule ID 822 //
     /* 206115 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 206118 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 206121 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 206125 */   // (fsqrt:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB)  =>  (XVSQRTSP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB)
     /* 206125 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVSQRTSP),
     /* 206130 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 206134 */   GIR_RootConstrainSelectedInstOperands,
     /* 206135 */   // GIR_Coverage, 822,
     /* 206135 */   GIR_Done,
     /* 206136 */ // Label 2768: @206136
     /* 206136 */ GIM_Reject,
     /* 206137 */ // Label 2759: @206137
     /* 206137 */ GIM_Reject,
     /* 206138 */ // Label 73: @206138
     /* 206138 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2774*/ GIMT_Encode4(206412),
     /* 206149 */ /*GILLT_s32*//*Label 2769*/ GIMT_Encode4(206169),
     /* 206153 */ /*GILLT_s64*//*Label 2770*/ GIMT_Encode4(206262),
     /* 206157 */ /*GILLT_s128*//*Label 2771*/ GIMT_Encode4(206310),
     /* 206161 */ /*GILLT_v2s64*//*Label 2772*/ GIMT_Encode4(206341),
     /* 206165 */ /*GILLT_v4s32*//*Label 2773*/ GIMT_Encode4(206364),
     /* 206169 */ // Label 2769: @206169
     /* 206169 */ GIM_Try, /*On fail goto*//*Label 2775*/ GIMT_Encode4(206261),
     /* 206174 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 206177 */   GIM_Try, /*On fail goto*//*Label 2776*/ GIMT_Encode4(206241), // Rule ID 1702 //
     /* 206182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 206185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 206189 */     // (ffloor:{ *:[f32] } f32:{ *:[f32] }:$S)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (XSRDPIM:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$S, VSFRC:{ *:[i32] })), VSSRC:{ *:[i32] })
     /* 206189 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 206192 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 206196 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206201 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // S
     /* 206205 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 206210 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 206213 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSRDPIM),
     /* 206217 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206222 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 206225 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 206227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 206230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 206232 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 206235 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 206240 */     // GIR_Coverage, 1702,
     /* 206240 */     GIR_EraseRootFromParent_Done,
     /* 206241 */   // Label 2776: @206241
     /* 206241 */   GIM_Try, /*On fail goto*//*Label 2777*/ GIMT_Encode4(206260), // Rule ID 154 //
     /* 206246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 206249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 206253 */     // (ffloor:{ *:[f32] } f32:{ *:[f32] }:$RB)  =>  (FRIMS:{ *:[f32] } f32:{ *:[f32] }:$RB)
     /* 206253 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FRIMS),
     /* 206258 */     GIR_RootConstrainSelectedInstOperands,
     /* 206259 */     // GIR_Coverage, 154,
     /* 206259 */     GIR_Done,
     /* 206260 */   // Label 2777: @206260
     /* 206260 */   GIM_Reject,
     /* 206261 */ // Label 2775: @206261
     /* 206261 */ GIM_Reject,
     /* 206262 */ // Label 2770: @206262
     /* 206262 */ GIM_Try, /*On fail goto*//*Label 2778*/ GIMT_Encode4(206309),
     /* 206267 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 206270 */   GIM_Try, /*On fail goto*//*Label 2779*/ GIMT_Encode4(206289), // Rule ID 907 //
     /* 206275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 206278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 206282 */     // (ffloor:{ *:[f64] } f64:{ *:[f64] }:$XB)  =>  (XSRDPIM:{ *:[f64] } f64:{ *:[f64] }:$XB)
     /* 206282 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSRDPIM),
     /* 206287 */     GIR_RootConstrainSelectedInstOperands,
     /* 206288 */     // GIR_Coverage, 907,
     /* 206288 */     GIR_Done,
     /* 206289 */   // Label 2779: @206289
     /* 206289 */   GIM_Try, /*On fail goto*//*Label 2780*/ GIMT_Encode4(206308), // Rule ID 152 //
     /* 206294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 206297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 206301 */     // (ffloor:{ *:[f64] } f64:{ *:[f64] }:$RB)  =>  (FRIMD:{ *:[f64] } f64:{ *:[f64] }:$RB)
     /* 206301 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FRIMD),
     /* 206306 */     GIR_RootConstrainSelectedInstOperands,
     /* 206307 */     // GIR_Coverage, 152,
     /* 206307 */     GIR_Done,
     /* 206308 */   // Label 2780: @206308
     /* 206308 */   GIM_Reject,
     /* 206309 */ // Label 2778: @206309
     /* 206309 */ GIM_Reject,
     /* 206310 */ // Label 2771: @206310
     /* 206310 */ GIM_Try, /*On fail goto*//*Label 2781*/ GIMT_Encode4(206340), // Rule ID 2161 //
     /* 206315 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 206318 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 206321 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 206325 */   // (ffloor:{ *:[f128] } f128:{ *:[f128] }:$vB)  =>  (XSRQPI:{ *:[f128] } 1:{ *:[i32] }, ?:{ *:[f128] }:$vB, 3:{ *:[i32] })
     /* 206325 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSRQPI),
     /* 206328 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VRT]
     /* 206330 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 206333 */   GIR_RootToRootCopy, /*OpIdx*/1, // vB
     /* 206335 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 206338 */   GIR_RootConstrainSelectedInstOperands,
     /* 206339 */   // GIR_Coverage, 2161,
     /* 206339 */   GIR_EraseRootFromParent_Done,
     /* 206340 */ // Label 2781: @206340
     /* 206340 */ GIM_Reject,
     /* 206341 */ // Label 2772: @206341
     /* 206341 */ GIM_Try, /*On fail goto*//*Label 2782*/ GIMT_Encode4(206363), // Rule ID 915 //
     /* 206346 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 206349 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 206352 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 206356 */   // (ffloor:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB)  =>  (XVRDPIM:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB)
     /* 206356 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVRDPIM),
     /* 206361 */   GIR_RootConstrainSelectedInstOperands,
     /* 206362 */   // GIR_Coverage, 915,
     /* 206362 */   GIR_Done,
     /* 206363 */ // Label 2782: @206363
     /* 206363 */ GIM_Reject,
     /* 206364 */ // Label 2773: @206364
     /* 206364 */ GIM_Try, /*On fail goto*//*Label 2783*/ GIMT_Encode4(206411),
     /* 206369 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 206372 */   GIM_Try, /*On fail goto*//*Label 2784*/ GIMT_Encode4(206391), // Rule ID 923 //
     /* 206377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 206380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 206384 */     // (ffloor:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB)  =>  (XVRSPIM:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB)
     /* 206384 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVRSPIM),
     /* 206389 */     GIR_RootConstrainSelectedInstOperands,
     /* 206390 */     // GIR_Coverage, 923,
     /* 206390 */     GIR_Done,
     /* 206391 */   // Label 2784: @206391
     /* 206391 */   GIM_Try, /*On fail goto*//*Label 2785*/ GIMT_Encode4(206410), // Rule ID 1413 //
     /* 206396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 206399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 206403 */     // (ffloor:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$vA)  =>  (VRFIM:{ *:[v4f32] } ?:{ *:[v4f32] }:$vA)
     /* 206403 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VRFIM),
     /* 206408 */     GIR_RootConstrainSelectedInstOperands,
     /* 206409 */     // GIR_Coverage, 1413,
     /* 206409 */     GIR_Done,
     /* 206410 */   // Label 2785: @206410
     /* 206410 */   GIM_Reject,
     /* 206411 */ // Label 2783: @206411
     /* 206411 */ GIM_Reject,
     /* 206412 */ // Label 2774: @206412
     /* 206412 */ GIM_Reject,
     /* 206413 */ // Label 74: @206413
     /* 206413 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2791*/ GIMT_Encode4(206624),
     /* 206424 */ /*GILLT_s32*//*Label 2786*/ GIMT_Encode4(206444),
     /* 206428 */ /*GILLT_s64*//*Label 2787*/ GIMT_Encode4(206512),
     /* 206432 */ /*GILLT_s128*//*Label 2788*/ GIMT_Encode4(206539),
     /* 206436 */ /*GILLT_v2s64*//*Label 2789*/ GIMT_Encode4(206570),
     /* 206440 */ /*GILLT_v4s32*//*Label 2790*/ GIMT_Encode4(206597),
     /* 206444 */ // Label 2786: @206444
     /* 206444 */ GIM_Try, /*On fail goto*//*Label 2792*/ GIMT_Encode4(206511), // Rule ID 1708 //
     /* 206449 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 206452 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 206455 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 206459 */   // (frint:{ *:[f32] } f32:{ *:[f32] }:$S)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (XSRDPIC:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$S, VSFRC:{ *:[i32] })), VSSRC:{ *:[i32] })
     /* 206459 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 206462 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 206466 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206471 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // S
     /* 206475 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 206480 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 206483 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSRDPIC),
     /* 206487 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206492 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 206495 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 206497 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 206500 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 206502 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 206505 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 206510 */   // GIR_Coverage, 1708,
     /* 206510 */   GIR_EraseRootFromParent_Done,
     /* 206511 */ // Label 2792: @206511
     /* 206511 */ GIM_Reject,
     /* 206512 */ // Label 2787: @206512
     /* 206512 */ GIM_Try, /*On fail goto*//*Label 2793*/ GIMT_Encode4(206538), // Rule ID 1712 //
     /* 206517 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 206520 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 206523 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 206527 */   // (frint:{ *:[f64] } f64:{ *:[f64] }:$S)  =>  (XSRDPIC:{ *:[f64] } ?:{ *:[f64] }:$S)
     /* 206527 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSRDPIC),
     /* 206532 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 206536 */   GIR_RootConstrainSelectedInstOperands,
     /* 206537 */   // GIR_Coverage, 1712,
     /* 206537 */   GIR_Done,
     /* 206538 */ // Label 2793: @206538
     /* 206538 */ GIM_Reject,
     /* 206539 */ // Label 2788: @206539
     /* 206539 */ GIM_Try, /*On fail goto*//*Label 2794*/ GIMT_Encode4(206569), // Rule ID 2163 //
     /* 206544 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 206547 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 206550 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 206554 */   // (frint:{ *:[f128] } f128:{ *:[f128] }:$vB)  =>  (XSRQPIX:{ *:[f128] } 0:{ *:[i32] }, ?:{ *:[f128] }:$vB, 3:{ *:[i32] })
     /* 206554 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSRQPIX),
     /* 206557 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VRT]
     /* 206559 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 206562 */   GIR_RootToRootCopy, /*OpIdx*/1, // vB
     /* 206564 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 206567 */   GIR_RootConstrainSelectedInstOperands,
     /* 206568 */   // GIR_Coverage, 2163,
     /* 206568 */   GIR_EraseRootFromParent_Done,
     /* 206569 */ // Label 2794: @206569
     /* 206569 */ GIM_Reject,
     /* 206570 */ // Label 2789: @206570
     /* 206570 */ GIM_Try, /*On fail goto*//*Label 2795*/ GIMT_Encode4(206596), // Rule ID 1714 //
     /* 206575 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 206578 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 206581 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 206585 */   // (frint:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$S)  =>  (XVRDPIC:{ *:[v2f64] } ?:{ *:[v2f64] }:$S)
     /* 206585 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVRDPIC),
     /* 206590 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 206594 */   GIR_RootConstrainSelectedInstOperands,
     /* 206595 */   // GIR_Coverage, 1714,
     /* 206595 */   GIR_Done,
     /* 206596 */ // Label 2795: @206596
     /* 206596 */ GIM_Reject,
     /* 206597 */ // Label 2790: @206597
     /* 206597 */ GIM_Try, /*On fail goto*//*Label 2796*/ GIMT_Encode4(206623), // Rule ID 1710 //
     /* 206602 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 206605 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 206608 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 206612 */   // (frint:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$S)  =>  (XVRSPIC:{ *:[v4f32] } ?:{ *:[v4f32] }:$S)
     /* 206612 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVRSPIC),
     /* 206617 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 206621 */   GIR_RootConstrainSelectedInstOperands,
     /* 206622 */   // GIR_Coverage, 1710,
     /* 206622 */   GIR_Done,
     /* 206623 */ // Label 2796: @206623
     /* 206623 */ GIM_Reject,
     /* 206624 */ // Label 2791: @206624
     /* 206624 */ GIM_Reject,
     /* 206625 */ // Label 75: @206625
     /* 206625 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2802*/ GIMT_Encode4(206861),
     /* 206636 */ /*GILLT_s32*//*Label 2797*/ GIMT_Encode4(206656),
     /* 206640 */ /*GILLT_s64*//*Label 2798*/ GIMT_Encode4(206724),
     /* 206644 */ /*GILLT_s128*//*Label 2799*/ GIMT_Encode4(206751),
     /* 206648 */ /*GILLT_v2s64*//*Label 2800*/ GIMT_Encode4(206782),
     /* 206652 */ /*GILLT_v4s32*//*Label 2801*/ GIMT_Encode4(206809),
     /* 206656 */ // Label 2797: @206656
     /* 206656 */ GIM_Try, /*On fail goto*//*Label 2803*/ GIMT_Encode4(206723), // Rule ID 1715 //
     /* 206661 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 206664 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 206667 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 206671 */   // (fnearbyint:{ *:[f32] } f32:{ *:[f32] }:$S)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (XSRDPIC:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$S, VSFRC:{ *:[i32] })), VSSRC:{ *:[i32] })
     /* 206671 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 206674 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 206678 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206683 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // S
     /* 206687 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 206692 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 206695 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSRDPIC),
     /* 206699 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206704 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 206707 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 206709 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 206712 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 206714 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 206717 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 206722 */   // GIR_Coverage, 1715,
     /* 206722 */   GIR_EraseRootFromParent_Done,
     /* 206723 */ // Label 2803: @206723
     /* 206723 */ GIM_Reject,
     /* 206724 */ // Label 2798: @206724
     /* 206724 */ GIM_Try, /*On fail goto*//*Label 2804*/ GIMT_Encode4(206750), // Rule ID 1716 //
     /* 206729 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 206732 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 206735 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 206739 */   // (fnearbyint:{ *:[f64] } f64:{ *:[f64] }:$S)  =>  (XSRDPIC:{ *:[f64] } ?:{ *:[f64] }:$S)
     /* 206739 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSRDPIC),
     /* 206744 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 206748 */   GIR_RootConstrainSelectedInstOperands,
     /* 206749 */   // GIR_Coverage, 1716,
     /* 206749 */   GIR_Done,
     /* 206750 */ // Label 2804: @206750
     /* 206750 */ GIM_Reject,
     /* 206751 */ // Label 2799: @206751
     /* 206751 */ GIM_Try, /*On fail goto*//*Label 2805*/ GIMT_Encode4(206781), // Rule ID 2153 //
     /* 206756 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 206759 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 206762 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 206766 */   // (fnearbyint:{ *:[f128] } f128:{ *:[f128] }:$vB)  =>  (XSRQPI:{ *:[f128] } 0:{ *:[i32] }, ?:{ *:[f128] }:$vB, 3:{ *:[i32] })
     /* 206766 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSRQPI),
     /* 206769 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VRT]
     /* 206771 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 206774 */   GIR_RootToRootCopy, /*OpIdx*/1, // vB
     /* 206776 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 206779 */   GIR_RootConstrainSelectedInstOperands,
     /* 206780 */   // GIR_Coverage, 2153,
     /* 206780 */   GIR_EraseRootFromParent_Done,
     /* 206781 */ // Label 2805: @206781
     /* 206781 */ GIM_Reject,
     /* 206782 */ // Label 2800: @206782
     /* 206782 */ GIM_Try, /*On fail goto*//*Label 2806*/ GIMT_Encode4(206808), // Rule ID 1717 //
     /* 206787 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 206790 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 206793 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 206797 */   // (fnearbyint:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$S)  =>  (XVRDPIC:{ *:[v2f64] } ?:{ *:[v2f64] }:$S)
     /* 206797 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVRDPIC),
     /* 206802 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 206806 */   GIR_RootConstrainSelectedInstOperands,
     /* 206807 */   // GIR_Coverage, 1717,
     /* 206807 */   GIR_Done,
     /* 206808 */ // Label 2806: @206808
     /* 206808 */ GIM_Reject,
     /* 206809 */ // Label 2801: @206809
     /* 206809 */ GIM_Try, /*On fail goto*//*Label 2807*/ GIMT_Encode4(206860),
     /* 206814 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 206817 */   GIM_Try, /*On fail goto*//*Label 2808*/ GIMT_Encode4(206840), // Rule ID 1718 //
     /* 206822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 206825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 206829 */     // (fnearbyint:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$S)  =>  (XVRSPIC:{ *:[v4f32] } ?:{ *:[v4f32] }:$S)
     /* 206829 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVRSPIC),
     /* 206834 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 206838 */     GIR_RootConstrainSelectedInstOperands,
     /* 206839 */     // GIR_Coverage, 1718,
     /* 206839 */     GIR_Done,
     /* 206840 */   // Label 2808: @206840
     /* 206840 */   GIM_Try, /*On fail goto*//*Label 2809*/ GIMT_Encode4(206859), // Rule ID 1416 //
     /* 206845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 206848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 206852 */     // (fnearbyint:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$vA)  =>  (VRFIN:{ *:[v4f32] } ?:{ *:[v4f32] }:$vA)
     /* 206852 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VRFIN),
     /* 206857 */     GIR_RootConstrainSelectedInstOperands,
     /* 206858 */     // GIR_Coverage, 1416,
     /* 206858 */     GIR_Done,
     /* 206859 */   // Label 2809: @206859
     /* 206859 */   GIM_Reject,
     /* 206860 */ // Label 2807: @206860
     /* 206860 */ GIM_Reject,
     /* 206861 */ // Label 2802: @206861
     /* 206861 */ GIM_Reject,
     /* 206862 */ // Label 76: @206862
     /* 206862 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2815*/ GIMT_Encode4(207131),
     /* 206873 */ /*GILLT_s32*//*Label 2810*/ GIMT_Encode4(206893),
     /* 206877 */ /*GILLT_s64*//*Label 2811*/ GIMT_Encode4(206967),
     /* 206881 */ /*GILLT_s128*//*Label 2812*/ GIMT_Encode4(207045),
     /* 206885 */ /*GILLT_v2s64*//*Label 2813*/ GIMT_Encode4(207071),
     /* 206889 */ /*GILLT_v4s32*//*Label 2814*/ GIMT_Encode4(207101),
     /* 206893 */ // Label 2810: @206893
     /* 206893 */ GIM_Try, /*On fail goto*//*Label 2816*/ GIMT_Encode4(206966),
     /* 206898 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 206901 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 206904 */   GIM_Try, /*On fail goto*//*Label 2817*/ GIMT_Encode4(206923), // Rule ID 948 //
     /* 206909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 206912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 206916 */     // (strict_fadd:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)  =>  (XSADDSP:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)
     /* 206916 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSADDSP),
     /* 206921 */     GIR_RootConstrainSelectedInstOperands,
     /* 206922 */     // GIR_Coverage, 948,
     /* 206922 */     GIR_Done,
     /* 206923 */   // Label 2817: @206923
     /* 206923 */   GIM_Try, /*On fail goto*//*Label 2818*/ GIMT_Encode4(206946), // Rule ID 238 //
     /* 206928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 206931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 206935 */     // (strict_fadd:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRB)  =>  (FADDS:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRB)
     /* 206935 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FADDS),
     /* 206940 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 206944 */     GIR_RootConstrainSelectedInstOperands,
     /* 206945 */     // GIR_Coverage, 238,
     /* 206945 */     GIR_Done,
     /* 206946 */   // Label 2818: @206946
     /* 206946 */   GIM_Try, /*On fail goto*//*Label 2819*/ GIMT_Encode4(206965), // Rule ID 578 //
     /* 206951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 206954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 206958 */     // (strict_fadd:{ *:[f32] } f32:{ *:[f32] }:$RA, f32:{ *:[f32] }:$RB)  =>  (EFSADD:{ *:[f32] } f32:{ *:[f32] }:$RA, f32:{ *:[f32] }:$RB)
     /* 206958 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFSADD),
     /* 206963 */     GIR_RootConstrainSelectedInstOperands,
     /* 206964 */     // GIR_Coverage, 578,
     /* 206964 */     GIR_Done,
     /* 206965 */   // Label 2819: @206965
     /* 206965 */   GIM_Reject,
     /* 206966 */ // Label 2816: @206966
     /* 206966 */ GIM_Reject,
     /* 206967 */ // Label 2811: @206967
     /* 206967 */ GIM_Try, /*On fail goto*//*Label 2820*/ GIMT_Encode4(207044),
     /* 206972 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 206975 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 206978 */   GIM_Try, /*On fail goto*//*Label 2821*/ GIMT_Encode4(207001), // Rule ID 765 //
     /* 206983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 206986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 206990 */     // (strict_fadd:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)  =>  (XSADDDP:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)
     /* 206990 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSADDDP),
     /* 206995 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 206999 */     GIR_RootConstrainSelectedInstOperands,
     /* 207000 */     // GIR_Coverage, 765,
     /* 207000 */     GIR_Done,
     /* 207001 */   // Label 2821: @207001
     /* 207001 */   GIM_Try, /*On fail goto*//*Label 2822*/ GIMT_Encode4(207024), // Rule ID 236 //
     /* 207006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 207009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 207013 */     // (strict_fadd:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRB)  =>  (FADD:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRB)
     /* 207013 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FADD),
     /* 207018 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 207022 */     GIR_RootConstrainSelectedInstOperands,
     /* 207023 */     // GIR_Coverage, 236,
     /* 207023 */     GIR_Done,
     /* 207024 */   // Label 2822: @207024
     /* 207024 */   GIM_Try, /*On fail goto*//*Label 2823*/ GIMT_Encode4(207043), // Rule ID 557 //
     /* 207029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 207032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::SPERCRegClassID),
     /* 207036 */     // (strict_fadd:{ *:[f64] } f64:{ *:[f64] }:$RA, f64:{ *:[f64] }:$RB)  =>  (EFDADD:{ *:[f64] } f64:{ *:[f64] }:$RA, f64:{ *:[f64] }:$RB)
     /* 207036 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFDADD),
     /* 207041 */     GIR_RootConstrainSelectedInstOperands,
     /* 207042 */     // GIR_Coverage, 557,
     /* 207042 */     GIR_Done,
     /* 207043 */   // Label 2823: @207043
     /* 207043 */   GIM_Reject,
     /* 207044 */ // Label 2820: @207044
     /* 207044 */ GIM_Reject,
     /* 207045 */ // Label 2812: @207045
     /* 207045 */ GIM_Try, /*On fail goto*//*Label 2824*/ GIMT_Encode4(207070), // Rule ID 983 //
     /* 207050 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 207053 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 207056 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /* 207059 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 207063 */   // (strict_fadd:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)  =>  (XSADDQP:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 207063 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSADDQP),
     /* 207068 */   GIR_RootConstrainSelectedInstOperands,
     /* 207069 */   // GIR_Coverage, 983,
     /* 207069 */   GIR_Done,
     /* 207070 */ // Label 2824: @207070
     /* 207070 */ GIM_Reject,
     /* 207071 */ // Label 2813: @207071
     /* 207071 */ GIM_Try, /*On fail goto*//*Label 2825*/ GIMT_Encode4(207100), // Rule ID 769 //
     /* 207076 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 207079 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 207082 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 207085 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 207089 */   // (strict_fadd:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)  =>  (XVADDDP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /* 207089 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVADDDP),
     /* 207094 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 207098 */   GIR_RootConstrainSelectedInstOperands,
     /* 207099 */   // GIR_Coverage, 769,
     /* 207099 */   GIR_Done,
     /* 207100 */ // Label 2825: @207100
     /* 207100 */ GIM_Reject,
     /* 207101 */ // Label 2814: @207101
     /* 207101 */ GIM_Try, /*On fail goto*//*Label 2826*/ GIMT_Encode4(207130), // Rule ID 771 //
     /* 207106 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 207109 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 207112 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 207115 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 207119 */   // (strict_fadd:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)  =>  (XVADDSP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /* 207119 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVADDSP),
     /* 207124 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 207128 */   GIR_RootConstrainSelectedInstOperands,
     /* 207129 */   // GIR_Coverage, 771,
     /* 207129 */   GIR_Done,
     /* 207130 */ // Label 2826: @207130
     /* 207130 */ GIM_Reject,
     /* 207131 */ // Label 2815: @207131
     /* 207131 */ GIM_Reject,
     /* 207132 */ // Label 77: @207132
     /* 207132 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2832*/ GIMT_Encode4(207401),
     /* 207143 */ /*GILLT_s32*//*Label 2827*/ GIMT_Encode4(207163),
     /* 207147 */ /*GILLT_s64*//*Label 2828*/ GIMT_Encode4(207237),
     /* 207151 */ /*GILLT_s128*//*Label 2829*/ GIMT_Encode4(207315),
     /* 207155 */ /*GILLT_v2s64*//*Label 2830*/ GIMT_Encode4(207341),
     /* 207159 */ /*GILLT_v4s32*//*Label 2831*/ GIMT_Encode4(207371),
     /* 207163 */ // Label 2827: @207163
     /* 207163 */ GIM_Try, /*On fail goto*//*Label 2833*/ GIMT_Encode4(207236),
     /* 207168 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 207171 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 207174 */   GIM_Try, /*On fail goto*//*Label 2834*/ GIMT_Encode4(207193), // Rule ID 952 //
     /* 207179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 207182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 207186 */     // (strict_fsub:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)  =>  (XSSUBSP:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)
     /* 207186 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSSUBSP),
     /* 207191 */     GIR_RootConstrainSelectedInstOperands,
     /* 207192 */     // GIR_Coverage, 952,
     /* 207192 */     GIR_Done,
     /* 207193 */   // Label 2834: @207193
     /* 207193 */   GIM_Try, /*On fail goto*//*Label 2835*/ GIMT_Encode4(207216), // Rule ID 250 //
     /* 207198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 207201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 207205 */     // (strict_fsub:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRB)  =>  (FSUBS:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRB)
     /* 207205 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FSUBS),
     /* 207210 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 207214 */     GIR_RootConstrainSelectedInstOperands,
     /* 207215 */     // GIR_Coverage, 250,
     /* 207215 */     GIR_Done,
     /* 207216 */   // Label 2835: @207216
     /* 207216 */   GIM_Try, /*On fail goto*//*Label 2836*/ GIMT_Encode4(207235), // Rule ID 596 //
     /* 207221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 207224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 207228 */     // (strict_fsub:{ *:[f32] } f32:{ *:[f32] }:$RA, f32:{ *:[f32] }:$RB)  =>  (EFSSUB:{ *:[f32] } f32:{ *:[f32] }:$RA, f32:{ *:[f32] }:$RB)
     /* 207228 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFSSUB),
     /* 207233 */     GIR_RootConstrainSelectedInstOperands,
     /* 207234 */     // GIR_Coverage, 596,
     /* 207234 */     GIR_Done,
     /* 207235 */   // Label 2836: @207235
     /* 207235 */   GIM_Reject,
     /* 207236 */ // Label 2833: @207236
     /* 207236 */ GIM_Reject,
     /* 207237 */ // Label 2828: @207237
     /* 207237 */ GIM_Try, /*On fail goto*//*Label 2837*/ GIMT_Encode4(207314),
     /* 207242 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 207245 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 207248 */   GIM_Try, /*On fail goto*//*Label 2838*/ GIMT_Encode4(207271), // Rule ID 777 //
     /* 207253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 207256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 207260 */     // (strict_fsub:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)  =>  (XSSUBDP:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)
     /* 207260 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSSUBDP),
     /* 207265 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 207269 */     GIR_RootConstrainSelectedInstOperands,
     /* 207270 */     // GIR_Coverage, 777,
     /* 207270 */     GIR_Done,
     /* 207271 */   // Label 2838: @207271
     /* 207271 */   GIM_Try, /*On fail goto*//*Label 2839*/ GIMT_Encode4(207294), // Rule ID 248 //
     /* 207276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 207279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 207283 */     // (strict_fsub:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRB)  =>  (FSUB:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRB)
     /* 207283 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FSUB),
     /* 207288 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 207292 */     GIR_RootConstrainSelectedInstOperands,
     /* 207293 */     // GIR_Coverage, 248,
     /* 207293 */     GIR_Done,
     /* 207294 */   // Label 2839: @207294
     /* 207294 */   GIM_Try, /*On fail goto*//*Label 2840*/ GIMT_Encode4(207313), // Rule ID 575 //
     /* 207299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 207302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::SPERCRegClassID),
     /* 207306 */     // (strict_fsub:{ *:[f64] } f64:{ *:[f64] }:$RA, f64:{ *:[f64] }:$RB)  =>  (EFDSUB:{ *:[f64] } f64:{ *:[f64] }:$RA, f64:{ *:[f64] }:$RB)
     /* 207306 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFDSUB),
     /* 207311 */     GIR_RootConstrainSelectedInstOperands,
     /* 207312 */     // GIR_Coverage, 575,
     /* 207312 */     GIR_Done,
     /* 207313 */   // Label 2840: @207313
     /* 207313 */   GIM_Reject,
     /* 207314 */ // Label 2837: @207314
     /* 207314 */ GIM_Reject,
     /* 207315 */ // Label 2829: @207315
     /* 207315 */ GIM_Try, /*On fail goto*//*Label 2841*/ GIMT_Encode4(207340), // Rule ID 987 //
     /* 207320 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 207323 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 207326 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /* 207329 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 207333 */   // (strict_fsub:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)  =>  (XSSUBQP:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 207333 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSSUBQP),
     /* 207338 */   GIR_RootConstrainSelectedInstOperands,
     /* 207339 */   // GIR_Coverage, 987,
     /* 207339 */   GIR_Done,
     /* 207340 */ // Label 2841: @207340
     /* 207340 */ GIM_Reject,
     /* 207341 */ // Label 2830: @207341
     /* 207341 */ GIM_Try, /*On fail goto*//*Label 2842*/ GIMT_Encode4(207370), // Rule ID 779 //
     /* 207346 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 207349 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 207352 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 207355 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 207359 */   // (strict_fsub:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)  =>  (XVSUBDP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /* 207359 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVSUBDP),
     /* 207364 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 207368 */   GIR_RootConstrainSelectedInstOperands,
     /* 207369 */   // GIR_Coverage, 779,
     /* 207369 */   GIR_Done,
     /* 207370 */ // Label 2842: @207370
     /* 207370 */ GIM_Reject,
     /* 207371 */ // Label 2831: @207371
     /* 207371 */ GIM_Try, /*On fail goto*//*Label 2843*/ GIMT_Encode4(207400), // Rule ID 781 //
     /* 207376 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 207379 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 207382 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 207385 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 207389 */   // (strict_fsub:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)  =>  (XVSUBSP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /* 207389 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVSUBSP),
     /* 207394 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 207398 */   GIR_RootConstrainSelectedInstOperands,
     /* 207399 */   // GIR_Coverage, 781,
     /* 207399 */   GIR_Done,
     /* 207400 */ // Label 2843: @207400
     /* 207400 */ GIM_Reject,
     /* 207401 */ // Label 2832: @207401
     /* 207401 */ GIM_Reject,
     /* 207402 */ // Label 78: @207402
     /* 207402 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2849*/ GIMT_Encode4(207671),
     /* 207413 */ /*GILLT_s32*//*Label 2844*/ GIMT_Encode4(207433),
     /* 207417 */ /*GILLT_s64*//*Label 2845*/ GIMT_Encode4(207507),
     /* 207421 */ /*GILLT_s128*//*Label 2846*/ GIMT_Encode4(207585),
     /* 207425 */ /*GILLT_v2s64*//*Label 2847*/ GIMT_Encode4(207611),
     /* 207429 */ /*GILLT_v4s32*//*Label 2848*/ GIMT_Encode4(207641),
     /* 207433 */ // Label 2844: @207433
     /* 207433 */ GIM_Try, /*On fail goto*//*Label 2850*/ GIMT_Encode4(207506),
     /* 207438 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 207441 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 207444 */   GIM_Try, /*On fail goto*//*Label 2851*/ GIMT_Encode4(207463), // Rule ID 950 //
     /* 207449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 207452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 207456 */     // (strict_fmul:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)  =>  (XSMULSP:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)
     /* 207456 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSMULSP),
     /* 207461 */     GIR_RootConstrainSelectedInstOperands,
     /* 207462 */     // GIR_Coverage, 950,
     /* 207462 */     GIR_Done,
     /* 207463 */   // Label 2851: @207463
     /* 207463 */   GIM_Try, /*On fail goto*//*Label 2852*/ GIMT_Encode4(207486), // Rule ID 246 //
     /* 207468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 207471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 207475 */     // (strict_fmul:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC)  =>  (FMULS:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC)
     /* 207475 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FMULS),
     /* 207480 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 207484 */     GIR_RootConstrainSelectedInstOperands,
     /* 207485 */     // GIR_Coverage, 246,
     /* 207485 */     GIR_Done,
     /* 207486 */   // Label 2852: @207486
     /* 207486 */   GIM_Try, /*On fail goto*//*Label 2853*/ GIMT_Encode4(207505), // Rule ID 592 //
     /* 207491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 207494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 207498 */     // (strict_fmul:{ *:[f32] } f32:{ *:[f32] }:$RA, f32:{ *:[f32] }:$RB)  =>  (EFSMUL:{ *:[f32] } f32:{ *:[f32] }:$RA, f32:{ *:[f32] }:$RB)
     /* 207498 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFSMUL),
     /* 207503 */     GIR_RootConstrainSelectedInstOperands,
     /* 207504 */     // GIR_Coverage, 592,
     /* 207504 */     GIR_Done,
     /* 207505 */   // Label 2853: @207505
     /* 207505 */   GIM_Reject,
     /* 207506 */ // Label 2850: @207506
     /* 207506 */ GIM_Reject,
     /* 207507 */ // Label 2845: @207507
     /* 207507 */ GIM_Try, /*On fail goto*//*Label 2854*/ GIMT_Encode4(207584),
     /* 207512 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 207515 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 207518 */   GIM_Try, /*On fail goto*//*Label 2855*/ GIMT_Encode4(207541), // Rule ID 767 //
     /* 207523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 207526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 207530 */     // (strict_fmul:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)  =>  (XSMULDP:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)
     /* 207530 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSMULDP),
     /* 207535 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 207539 */     GIR_RootConstrainSelectedInstOperands,
     /* 207540 */     // GIR_Coverage, 767,
     /* 207540 */     GIR_Done,
     /* 207541 */   // Label 2855: @207541
     /* 207541 */   GIM_Try, /*On fail goto*//*Label 2856*/ GIMT_Encode4(207564), // Rule ID 244 //
     /* 207546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 207549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 207553 */     // (strict_fmul:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC)  =>  (FMUL:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC)
     /* 207553 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FMUL),
     /* 207558 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 207562 */     GIR_RootConstrainSelectedInstOperands,
     /* 207563 */     // GIR_Coverage, 244,
     /* 207563 */     GIR_Done,
     /* 207564 */   // Label 2856: @207564
     /* 207564 */   GIM_Try, /*On fail goto*//*Label 2857*/ GIMT_Encode4(207583), // Rule ID 571 //
     /* 207569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 207572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::SPERCRegClassID),
     /* 207576 */     // (strict_fmul:{ *:[f64] } f64:{ *:[f64] }:$RA, f64:{ *:[f64] }:$RB)  =>  (EFDMUL:{ *:[f64] } f64:{ *:[f64] }:$RA, f64:{ *:[f64] }:$RB)
     /* 207576 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFDMUL),
     /* 207581 */     GIR_RootConstrainSelectedInstOperands,
     /* 207582 */     // GIR_Coverage, 571,
     /* 207582 */     GIR_Done,
     /* 207583 */   // Label 2857: @207583
     /* 207583 */   GIM_Reject,
     /* 207584 */ // Label 2854: @207584
     /* 207584 */ GIM_Reject,
     /* 207585 */ // Label 2846: @207585
     /* 207585 */ GIM_Try, /*On fail goto*//*Label 2858*/ GIMT_Encode4(207610), // Rule ID 985 //
     /* 207590 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 207593 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 207596 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /* 207599 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 207603 */   // (strict_fmul:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)  =>  (XSMULQP:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 207603 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSMULQP),
     /* 207608 */   GIR_RootConstrainSelectedInstOperands,
     /* 207609 */   // GIR_Coverage, 985,
     /* 207609 */   GIR_Done,
     /* 207610 */ // Label 2858: @207610
     /* 207610 */ GIM_Reject,
     /* 207611 */ // Label 2847: @207611
     /* 207611 */ GIM_Try, /*On fail goto*//*Label 2859*/ GIMT_Encode4(207640), // Rule ID 773 //
     /* 207616 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 207619 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 207622 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 207625 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 207629 */   // (strict_fmul:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)  =>  (XVMULDP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /* 207629 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVMULDP),
     /* 207634 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 207638 */   GIR_RootConstrainSelectedInstOperands,
     /* 207639 */   // GIR_Coverage, 773,
     /* 207639 */   GIR_Done,
     /* 207640 */ // Label 2859: @207640
     /* 207640 */ GIM_Reject,
     /* 207641 */ // Label 2848: @207641
     /* 207641 */ GIM_Try, /*On fail goto*//*Label 2860*/ GIMT_Encode4(207670), // Rule ID 775 //
     /* 207646 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 207649 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 207652 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 207655 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 207659 */   // (strict_fmul:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)  =>  (XVMULSP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /* 207659 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVMULSP),
     /* 207664 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 207668 */   GIR_RootConstrainSelectedInstOperands,
     /* 207669 */   // GIR_Coverage, 775,
     /* 207669 */   GIR_Done,
     /* 207670 */ // Label 2860: @207670
     /* 207670 */ GIM_Reject,
     /* 207671 */ // Label 2849: @207671
     /* 207671 */ GIM_Reject,
     /* 207672 */ // Label 79: @207672
     /* 207672 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2866*/ GIMT_Encode4(207941),
     /* 207683 */ /*GILLT_s32*//*Label 2861*/ GIMT_Encode4(207703),
     /* 207687 */ /*GILLT_s64*//*Label 2862*/ GIMT_Encode4(207777),
     /* 207691 */ /*GILLT_s128*//*Label 2863*/ GIMT_Encode4(207855),
     /* 207695 */ /*GILLT_v2s64*//*Label 2864*/ GIMT_Encode4(207881),
     /* 207699 */ /*GILLT_v4s32*//*Label 2865*/ GIMT_Encode4(207911),
     /* 207703 */ // Label 2861: @207703
     /* 207703 */ GIM_Try, /*On fail goto*//*Label 2867*/ GIMT_Encode4(207776),
     /* 207708 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 207711 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 207714 */   GIM_Try, /*On fail goto*//*Label 2868*/ GIMT_Encode4(207733), // Rule ID 954 //
     /* 207719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 207722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 207726 */     // (strict_fdiv:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)  =>  (XSDIVSP:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)
     /* 207726 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSDIVSP),
     /* 207731 */     GIR_RootConstrainSelectedInstOperands,
     /* 207732 */     // GIR_Coverage, 954,
     /* 207732 */     GIR_Done,
     /* 207733 */   // Label 2868: @207733
     /* 207733 */   GIM_Try, /*On fail goto*//*Label 2869*/ GIMT_Encode4(207756), // Rule ID 242 //
     /* 207738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 207741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 207745 */     // (strict_fdiv:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRB)  =>  (FDIVS:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRB)
     /* 207745 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FDIVS),
     /* 207750 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 207754 */     GIR_RootConstrainSelectedInstOperands,
     /* 207755 */     // GIR_Coverage, 242,
     /* 207755 */     GIR_Done,
     /* 207756 */   // Label 2869: @207756
     /* 207756 */   GIM_Try, /*On fail goto*//*Label 2870*/ GIMT_Encode4(207775), // Rule ID 590 //
     /* 207761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 207764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 207768 */     // (strict_fdiv:{ *:[f32] } f32:{ *:[f32] }:$RA, f32:{ *:[f32] }:$RB)  =>  (EFSDIV:{ *:[f32] } f32:{ *:[f32] }:$RA, f32:{ *:[f32] }:$RB)
     /* 207768 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFSDIV),
     /* 207773 */     GIR_RootConstrainSelectedInstOperands,
     /* 207774 */     // GIR_Coverage, 590,
     /* 207774 */     GIR_Done,
     /* 207775 */   // Label 2870: @207775
     /* 207775 */   GIM_Reject,
     /* 207776 */ // Label 2867: @207776
     /* 207776 */ GIM_Reject,
     /* 207777 */ // Label 2862: @207777
     /* 207777 */ GIM_Try, /*On fail goto*//*Label 2871*/ GIMT_Encode4(207854),
     /* 207782 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 207785 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 207788 */   GIM_Try, /*On fail goto*//*Label 2872*/ GIMT_Encode4(207811), // Rule ID 806 //
     /* 207793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 207796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 207800 */     // (strict_fdiv:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)  =>  (XSDIVDP:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)
     /* 207800 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSDIVDP),
     /* 207805 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 207809 */     GIR_RootConstrainSelectedInstOperands,
     /* 207810 */     // GIR_Coverage, 806,
     /* 207810 */     GIR_Done,
     /* 207811 */   // Label 2872: @207811
     /* 207811 */   GIM_Try, /*On fail goto*//*Label 2873*/ GIMT_Encode4(207834), // Rule ID 240 //
     /* 207816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 207819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 207823 */     // (strict_fdiv:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRB)  =>  (FDIV:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRB)
     /* 207823 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FDIV),
     /* 207828 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 207832 */     GIR_RootConstrainSelectedInstOperands,
     /* 207833 */     // GIR_Coverage, 240,
     /* 207833 */     GIR_Done,
     /* 207834 */   // Label 2873: @207834
     /* 207834 */   GIM_Try, /*On fail goto*//*Label 2874*/ GIMT_Encode4(207853), // Rule ID 569 //
     /* 207839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 207842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::SPERCRegClassID),
     /* 207846 */     // (strict_fdiv:{ *:[f64] } f64:{ *:[f64] }:$RA, f64:{ *:[f64] }:$RB)  =>  (EFDDIV:{ *:[f64] } f64:{ *:[f64] }:$RA, f64:{ *:[f64] }:$RB)
     /* 207846 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFDDIV),
     /* 207851 */     GIR_RootConstrainSelectedInstOperands,
     /* 207852 */     // GIR_Coverage, 569,
     /* 207852 */     GIR_Done,
     /* 207853 */   // Label 2874: @207853
     /* 207853 */   GIM_Reject,
     /* 207854 */ // Label 2871: @207854
     /* 207854 */ GIM_Reject,
     /* 207855 */ // Label 2863: @207855
     /* 207855 */ GIM_Try, /*On fail goto*//*Label 2875*/ GIMT_Encode4(207880), // Rule ID 989 //
     /* 207860 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 207863 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 207866 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /* 207869 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 207873 */   // (strict_fdiv:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)  =>  (XSDIVQP:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 207873 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSDIVQP),
     /* 207878 */   GIR_RootConstrainSelectedInstOperands,
     /* 207879 */   // GIR_Coverage, 989,
     /* 207879 */   GIR_Done,
     /* 207880 */ // Label 2875: @207880
     /* 207880 */ GIM_Reject,
     /* 207881 */ // Label 2864: @207881
     /* 207881 */ GIM_Try, /*On fail goto*//*Label 2876*/ GIMT_Encode4(207910), // Rule ID 815 //
     /* 207886 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 207889 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 207892 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 207895 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 207899 */   // (strict_fdiv:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)  =>  (XVDIVDP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /* 207899 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVDIVDP),
     /* 207904 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 207908 */   GIR_RootConstrainSelectedInstOperands,
     /* 207909 */   // GIR_Coverage, 815,
     /* 207909 */   GIR_Done,
     /* 207910 */ // Label 2876: @207910
     /* 207910 */ GIM_Reject,
     /* 207911 */ // Label 2865: @207911
     /* 207911 */ GIM_Try, /*On fail goto*//*Label 2877*/ GIMT_Encode4(207940), // Rule ID 817 //
     /* 207916 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 207919 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 207922 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 207925 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 207929 */   // (strict_fdiv:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)  =>  (XVDIVSP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /* 207929 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVDIVSP),
     /* 207934 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 207938 */   GIR_RootConstrainSelectedInstOperands,
     /* 207939 */   // GIR_Coverage, 817,
     /* 207939 */   GIR_Done,
     /* 207940 */ // Label 2877: @207940
     /* 207940 */ GIM_Reject,
     /* 207941 */ // Label 2866: @207941
     /* 207941 */ GIM_Reject,
     /* 207942 */ // Label 80: @207942
     /* 207942 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2883*/ GIMT_Encode4(208499),
     /* 207953 */ /*GILLT_s32*//*Label 2878*/ GIMT_Encode4(207973),
     /* 207957 */ /*GILLT_s64*//*Label 2879*/ GIMT_Encode4(208119),
     /* 207961 */ /*GILLT_s128*//*Label 2880*/ GIMT_Encode4(208265),
     /* 207965 */ /*GILLT_v2s64*//*Label 2881*/ GIMT_Encode4(208343),
     /* 207969 */ /*GILLT_v4s32*//*Label 2882*/ GIMT_Encode4(208421),
     /* 207973 */ // Label 2878: @207973
     /* 207973 */ GIM_Try, /*On fail goto*//*Label 2884*/ GIMT_Encode4(208118),
     /* 207978 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 207981 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 207984 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 207987 */   GIM_Try, /*On fail goto*//*Label 2885*/ GIMT_Encode4(208028), // Rule ID 964 //
     /* 207992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 207995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 207999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 208003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 208007 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 208011 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 208013 */     // (strict_fma:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB, (fneg:{ *:[f32] } f32:{ *:[f32] }:$XTi))  =>  (XSMSUBASP:{ *:[f32] } f32:{ *:[f32] }:$XTi, f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)
     /* 208013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMSUBASP),
     /* 208016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 208018 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XTi
     /* 208022 */     GIR_RootToRootCopy, /*OpIdx*/1, // XA
     /* 208024 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /* 208026 */     GIR_RootConstrainSelectedInstOperands,
     /* 208027 */     // GIR_Coverage, 964,
     /* 208027 */     GIR_EraseRootFromParent_Done,
     /* 208028 */   // Label 2885: @208028
     /* 208028 */   GIM_Try, /*On fail goto*//*Label 2886*/ GIMT_Encode4(208053), // Rule ID 962 //
     /* 208033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 208036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 208040 */     // (strict_fma:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB, f32:{ *:[f32] }:$XTi)  =>  (XSMADDASP:{ *:[f32] } f32:{ *:[f32] }:$XTi, f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)
     /* 208040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMADDASP),
     /* 208043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 208045 */     GIR_RootToRootCopy, /*OpIdx*/3, // XTi
     /* 208047 */     GIR_RootToRootCopy, /*OpIdx*/1, // XA
     /* 208049 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /* 208051 */     GIR_RootConstrainSelectedInstOperands,
     /* 208052 */     // GIR_Coverage, 962,
     /* 208052 */     GIR_EraseRootFromParent_Done,
     /* 208053 */   // Label 2886: @208053
     /* 208053 */   GIM_Try, /*On fail goto*//*Label 2887*/ GIMT_Encode4(208094), // Rule ID 224 //
     /* 208058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 208061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 208065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 208069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 208073 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 208077 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 208079 */     // (strict_fma:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC, (fneg:{ *:[f32] } f32:{ *:[f32] }:$FRB))  =>  (FMSUBS:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC, f32:{ *:[f32] }:$FRB)
     /* 208079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FMSUBS),
     /* 208082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /* 208084 */     GIR_RootToRootCopy, /*OpIdx*/1, // FRA
     /* 208086 */     GIR_RootToRootCopy, /*OpIdx*/2, // FRC
     /* 208088 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // FRB
     /* 208092 */     GIR_RootConstrainSelectedInstOperands,
     /* 208093 */     // GIR_Coverage, 224,
     /* 208093 */     GIR_EraseRootFromParent_Done,
     /* 208094 */   // Label 2887: @208094
     /* 208094 */   GIM_Try, /*On fail goto*//*Label 2888*/ GIMT_Encode4(208117), // Rule ID 220 //
     /* 208099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 208102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 208106 */     // (strict_fma:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC, f32:{ *:[f32] }:$FRB)  =>  (FMADDS:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC, f32:{ *:[f32] }:$FRB)
     /* 208106 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FMADDS),
     /* 208111 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 208115 */     GIR_RootConstrainSelectedInstOperands,
     /* 208116 */     // GIR_Coverage, 220,
     /* 208116 */     GIR_Done,
     /* 208117 */   // Label 2888: @208117
     /* 208117 */   GIM_Reject,
     /* 208118 */ // Label 2884: @208118
     /* 208118 */ GIM_Reject,
     /* 208119 */ // Label 2879: @208119
     /* 208119 */ GIM_Try, /*On fail goto*//*Label 2889*/ GIMT_Encode4(208264),
     /* 208124 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 208127 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 208130 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 208133 */   GIM_Try, /*On fail goto*//*Label 2890*/ GIMT_Encode4(208174), // Rule ID 785 //
     /* 208138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 208141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 208145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 208149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 208153 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 208157 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 208159 */     // (strict_fma:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB, (fneg:{ *:[f64] } f64:{ *:[f64] }:$XTi))  =>  (XSMSUBADP:{ *:[f64] } f64:{ *:[f64] }:$XTi, f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)
     /* 208159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMSUBADP),
     /* 208162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 208164 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XTi
     /* 208168 */     GIR_RootToRootCopy, /*OpIdx*/1, // XA
     /* 208170 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /* 208172 */     GIR_RootConstrainSelectedInstOperands,
     /* 208173 */     // GIR_Coverage, 785,
     /* 208173 */     GIR_EraseRootFromParent_Done,
     /* 208174 */   // Label 2890: @208174
     /* 208174 */   GIM_Try, /*On fail goto*//*Label 2891*/ GIMT_Encode4(208199), // Rule ID 783 //
     /* 208179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 208182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 208186 */     // (strict_fma:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB, f64:{ *:[f64] }:$XTi)  =>  (XSMADDADP:{ *:[f64] } f64:{ *:[f64] }:$XTi, f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)
     /* 208186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMADDADP),
     /* 208189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 208191 */     GIR_RootToRootCopy, /*OpIdx*/3, // XTi
     /* 208193 */     GIR_RootToRootCopy, /*OpIdx*/1, // XA
     /* 208195 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /* 208197 */     GIR_RootConstrainSelectedInstOperands,
     /* 208198 */     // GIR_Coverage, 783,
     /* 208198 */     GIR_EraseRootFromParent_Done,
     /* 208199 */   // Label 2891: @208199
     /* 208199 */   GIM_Try, /*On fail goto*//*Label 2892*/ GIMT_Encode4(208240), // Rule ID 222 //
     /* 208204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 208207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 208211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 208215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 208219 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 208223 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 208225 */     // (strict_fma:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC, (fneg:{ *:[f64] } f64:{ *:[f64] }:$FRB))  =>  (FMSUB:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC, f64:{ *:[f64] }:$FRB)
     /* 208225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FMSUB),
     /* 208228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /* 208230 */     GIR_RootToRootCopy, /*OpIdx*/1, // FRA
     /* 208232 */     GIR_RootToRootCopy, /*OpIdx*/2, // FRC
     /* 208234 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // FRB
     /* 208238 */     GIR_RootConstrainSelectedInstOperands,
     /* 208239 */     // GIR_Coverage, 222,
     /* 208239 */     GIR_EraseRootFromParent_Done,
     /* 208240 */   // Label 2892: @208240
     /* 208240 */   GIM_Try, /*On fail goto*//*Label 2893*/ GIMT_Encode4(208263), // Rule ID 218 //
     /* 208245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 208248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 208252 */     // (strict_fma:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC, f64:{ *:[f64] }:$FRB)  =>  (FMADD:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC, f64:{ *:[f64] }:$FRB)
     /* 208252 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FMADD),
     /* 208257 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 208261 */     GIR_RootConstrainSelectedInstOperands,
     /* 208262 */     // GIR_Coverage, 218,
     /* 208262 */     GIR_Done,
     /* 208263 */   // Label 2893: @208263
     /* 208263 */   GIM_Reject,
     /* 208264 */ // Label 2889: @208264
     /* 208264 */ GIM_Reject,
     /* 208265 */ // Label 2880: @208265
     /* 208265 */ GIM_Try, /*On fail goto*//*Label 2894*/ GIMT_Encode4(208342),
     /* 208270 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 208273 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /* 208276 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /* 208279 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 208283 */   GIM_Try, /*On fail goto*//*Label 2895*/ GIMT_Encode4(208320), // Rule ID 995 //
     /* 208288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 208291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 208295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 208299 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s128,
     /* 208303 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 208305 */     // (strict_fma:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB, (fneg:{ *:[f128] } f128:{ *:[f128] }:$RSTi))  =>  (XSMSUBQP:{ *:[f128] } f128:{ *:[f128] }:$RSTi, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 208305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMSUBQP),
     /* 208308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 208310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RSTi
     /* 208314 */     GIR_RootToRootCopy, /*OpIdx*/1, // RA
     /* 208316 */     GIR_RootToRootCopy, /*OpIdx*/2, // RB
     /* 208318 */     GIR_RootConstrainSelectedInstOperands,
     /* 208319 */     // GIR_Coverage, 995,
     /* 208319 */     GIR_EraseRootFromParent_Done,
     /* 208320 */   // Label 2895: @208320
     /* 208320 */   GIM_Try, /*On fail goto*//*Label 2896*/ GIMT_Encode4(208341), // Rule ID 993 //
     /* 208325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 208328 */     // (strict_fma:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB, f128:{ *:[f128] }:$RSTi)  =>  (XSMADDQP:{ *:[f128] } f128:{ *:[f128] }:$RSTi, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 208328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMADDQP),
     /* 208331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 208333 */     GIR_RootToRootCopy, /*OpIdx*/3, // RSTi
     /* 208335 */     GIR_RootToRootCopy, /*OpIdx*/1, // RA
     /* 208337 */     GIR_RootToRootCopy, /*OpIdx*/2, // RB
     /* 208339 */     GIR_RootConstrainSelectedInstOperands,
     /* 208340 */     // GIR_Coverage, 993,
     /* 208340 */     GIR_EraseRootFromParent_Done,
     /* 208341 */   // Label 2896: @208341
     /* 208341 */   GIM_Reject,
     /* 208342 */ // Label 2894: @208342
     /* 208342 */ GIM_Reject,
     /* 208343 */ // Label 2881: @208343
     /* 208343 */ GIM_Try, /*On fail goto*//*Label 2897*/ GIMT_Encode4(208420),
     /* 208348 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 208351 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 208354 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 208357 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 208361 */   GIM_Try, /*On fail goto*//*Label 2898*/ GIMT_Encode4(208398), // Rule ID 795 //
     /* 208366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 208369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 208373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 208377 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 208381 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 208383 */     // (strict_fma:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB, (fneg:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XTi))  =>  (XVMSUBADP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XTi, v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /* 208383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVMSUBADP),
     /* 208386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 208388 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XTi
     /* 208392 */     GIR_RootToRootCopy, /*OpIdx*/1, // XA
     /* 208394 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /* 208396 */     GIR_RootConstrainSelectedInstOperands,
     /* 208397 */     // GIR_Coverage, 795,
     /* 208397 */     GIR_EraseRootFromParent_Done,
     /* 208398 */   // Label 2898: @208398
     /* 208398 */   GIM_Try, /*On fail goto*//*Label 2899*/ GIMT_Encode4(208419), // Rule ID 791 //
     /* 208403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 208406 */     // (strict_fma:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB, v2f64:{ *:[v2f64] }:$XTi)  =>  (XVMADDADP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XTi, v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /* 208406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVMADDADP),
     /* 208409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 208411 */     GIR_RootToRootCopy, /*OpIdx*/3, // XTi
     /* 208413 */     GIR_RootToRootCopy, /*OpIdx*/1, // XA
     /* 208415 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /* 208417 */     GIR_RootConstrainSelectedInstOperands,
     /* 208418 */     // GIR_Coverage, 791,
     /* 208418 */     GIR_EraseRootFromParent_Done,
     /* 208419 */   // Label 2899: @208419
     /* 208419 */   GIM_Reject,
     /* 208420 */ // Label 2897: @208420
     /* 208420 */ GIM_Reject,
     /* 208421 */ // Label 2882: @208421
     /* 208421 */ GIM_Try, /*On fail goto*//*Label 2900*/ GIMT_Encode4(208498),
     /* 208426 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 208429 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 208432 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 208435 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 208439 */   GIM_Try, /*On fail goto*//*Label 2901*/ GIMT_Encode4(208476), // Rule ID 797 //
     /* 208444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 208447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 208451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 208455 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 208459 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 208461 */     // (strict_fma:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB, (fneg:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XTi))  =>  (XVMSUBASP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XTi, v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /* 208461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVMSUBASP),
     /* 208464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 208466 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XTi
     /* 208470 */     GIR_RootToRootCopy, /*OpIdx*/1, // XA
     /* 208472 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /* 208474 */     GIR_RootConstrainSelectedInstOperands,
     /* 208475 */     // GIR_Coverage, 797,
     /* 208475 */     GIR_EraseRootFromParent_Done,
     /* 208476 */   // Label 2901: @208476
     /* 208476 */   GIM_Try, /*On fail goto*//*Label 2902*/ GIMT_Encode4(208497), // Rule ID 793 //
     /* 208481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 208484 */     // (strict_fma:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB, v4f32:{ *:[v4f32] }:$XTi)  =>  (XVMADDASP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XTi, v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /* 208484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVMADDASP),
     /* 208487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 208489 */     GIR_RootToRootCopy, /*OpIdx*/3, // XTi
     /* 208491 */     GIR_RootToRootCopy, /*OpIdx*/1, // XA
     /* 208493 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /* 208495 */     GIR_RootConstrainSelectedInstOperands,
     /* 208496 */     // GIR_Coverage, 793,
     /* 208496 */     GIR_EraseRootFromParent_Done,
     /* 208497 */   // Label 2902: @208497
     /* 208497 */   GIM_Reject,
     /* 208498 */ // Label 2900: @208498
     /* 208498 */ GIM_Reject,
     /* 208499 */ // Label 2883: @208499
     /* 208499 */ GIM_Reject,
     /* 208500 */ // Label 81: @208500
     /* 208500 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2908*/ GIMT_Encode4(208716),
     /* 208511 */ /*GILLT_s32*//*Label 2903*/ GIMT_Encode4(208531),
     /* 208515 */ /*GILLT_s64*//*Label 2904*/ GIMT_Encode4(208583),
     /* 208519 */ /*GILLT_s128*//*Label 2905*/ GIMT_Encode4(208639),
     /* 208523 */ /*GILLT_v2s64*//*Label 2906*/ GIMT_Encode4(208662),
     /* 208527 */ /*GILLT_v4s32*//*Label 2907*/ GIMT_Encode4(208689),
     /* 208531 */ // Label 2903: @208531
     /* 208531 */ GIM_Try, /*On fail goto*//*Label 2909*/ GIMT_Encode4(208582),
     /* 208536 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 208539 */   GIM_Try, /*On fail goto*//*Label 2910*/ GIMT_Encode4(208558), // Rule ID 959 //
     /* 208544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 208547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 208551 */     // (strict_fsqrt:{ *:[f32] } f32:{ *:[f32] }:$XB)  =>  (XSSQRTSP:{ *:[f32] } f32:{ *:[f32] }:$XB)
     /* 208551 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSSQRTSP),
     /* 208556 */     GIR_RootConstrainSelectedInstOperands,
     /* 208557 */     // GIR_Coverage, 959,
     /* 208557 */     GIR_Done,
     /* 208558 */   // Label 2910: @208558
     /* 208558 */   GIM_Try, /*On fail goto*//*Label 2911*/ GIMT_Encode4(208581), // Rule ID 161 //
     /* 208563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 208566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 208570 */     // (strict_fsqrt:{ *:[f32] } f32:{ *:[f32] }:$RB)  =>  (FSQRTS:{ *:[f32] } f32:{ *:[f32] }:$RB)
     /* 208570 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FSQRTS),
     /* 208575 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 208579 */     GIR_RootConstrainSelectedInstOperands,
     /* 208580 */     // GIR_Coverage, 161,
     /* 208580 */     GIR_Done,
     /* 208581 */   // Label 2911: @208581
     /* 208581 */   GIM_Reject,
     /* 208582 */ // Label 2909: @208582
     /* 208582 */ GIM_Reject,
     /* 208583 */ // Label 2904: @208583
     /* 208583 */ GIM_Try, /*On fail goto*//*Label 2912*/ GIMT_Encode4(208638),
     /* 208588 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 208591 */   GIM_Try, /*On fail goto*//*Label 2913*/ GIMT_Encode4(208614), // Rule ID 808 //
     /* 208596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 208599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 208603 */     // (strict_fsqrt:{ *:[f64] } f64:{ *:[f64] }:$XB)  =>  (XSSQRTDP:{ *:[f64] } f64:{ *:[f64] }:$XB)
     /* 208603 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSSQRTDP),
     /* 208608 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 208612 */     GIR_RootConstrainSelectedInstOperands,
     /* 208613 */     // GIR_Coverage, 808,
     /* 208613 */     GIR_Done,
     /* 208614 */   // Label 2913: @208614
     /* 208614 */   GIM_Try, /*On fail goto*//*Label 2914*/ GIMT_Encode4(208637), // Rule ID 159 //
     /* 208619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 208622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 208626 */     // (strict_fsqrt:{ *:[f64] } f64:{ *:[f64] }:$RB)  =>  (FSQRT:{ *:[f64] } f64:{ *:[f64] }:$RB)
     /* 208626 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FSQRT),
     /* 208631 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 208635 */     GIR_RootConstrainSelectedInstOperands,
     /* 208636 */     // GIR_Coverage, 159,
     /* 208636 */     GIR_Done,
     /* 208637 */   // Label 2914: @208637
     /* 208637 */   GIM_Reject,
     /* 208638 */ // Label 2912: @208638
     /* 208638 */ GIM_Reject,
     /* 208639 */ // Label 2905: @208639
     /* 208639 */ GIM_Try, /*On fail goto*//*Label 2915*/ GIMT_Encode4(208661), // Rule ID 991 //
     /* 208644 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 208647 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 208650 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 208654 */   // (strict_fsqrt:{ *:[f128] } f128:{ *:[f128] }:$RB)  =>  (XSSQRTQP:{ *:[f128] } f128:{ *:[f128] }:$RB)
     /* 208654 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSSQRTQP),
     /* 208659 */   GIR_RootConstrainSelectedInstOperands,
     /* 208660 */   // GIR_Coverage, 991,
     /* 208660 */   GIR_Done,
     /* 208661 */ // Label 2915: @208661
     /* 208661 */ GIM_Reject,
     /* 208662 */ // Label 2906: @208662
     /* 208662 */ GIM_Try, /*On fail goto*//*Label 2916*/ GIMT_Encode4(208688), // Rule ID 819 //
     /* 208667 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 208670 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 208673 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 208677 */   // (strict_fsqrt:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB)  =>  (XVSQRTDP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB)
     /* 208677 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVSQRTDP),
     /* 208682 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 208686 */   GIR_RootConstrainSelectedInstOperands,
     /* 208687 */   // GIR_Coverage, 819,
     /* 208687 */   GIR_Done,
     /* 208688 */ // Label 2916: @208688
     /* 208688 */ GIM_Reject,
     /* 208689 */ // Label 2907: @208689
     /* 208689 */ GIM_Try, /*On fail goto*//*Label 2917*/ GIMT_Encode4(208715), // Rule ID 821 //
     /* 208694 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 208697 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 208700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 208704 */   // (strict_fsqrt:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB)  =>  (XVSQRTSP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB)
     /* 208704 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVSQRTSP),
     /* 208709 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 208713 */   GIR_RootConstrainSelectedInstOperands,
     /* 208714 */   // GIR_Coverage, 821,
     /* 208714 */   GIR_Done,
     /* 208715 */ // Label 2917: @208715
     /* 208715 */ GIM_Reject,
     /* 208716 */ // Label 2908: @208716
     /* 208716 */ GIM_Reject,
     /* 208717 */ // Label 82: @208717
     /* 208717 */ GIM_Try, /*On fail goto*//*Label 2918*/ GIMT_Encode4(208729), // Rule ID 72 //
     /* 208722 */   // (trap)  =>  (TRAP)
     /* 208722 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::TRAP),
     /* 208727 */   GIR_RootConstrainSelectedInstOperands,
     /* 208728 */   // GIR_Coverage, 72,
     /* 208728 */   GIR_Done,
     /* 208729 */ // Label 2918: @208729
     /* 208729 */ GIM_Reject,
     /* 208730 */ // Label 83: @208730
     /* 208730 */ GIM_Reject,
     /* 208731 */ }; // Size: 208731 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GLOBALISEL_IMPL

#ifdef GET_GLOBALISEL_PREDICATES_DECL
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const PPCSubtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const PPCSubtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GLOBALISEL_PREDICATES_DECL
#ifdef GET_GLOBALISEL_PREDICATES_INIT
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GLOBALISEL_PREDICATES_INIT
